/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ne=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/base/common/path","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/base/common/extpath","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","child_process","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/base/node/processes","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/decoder","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/browser/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/defaultExtensionsProfileInit","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","string_decoder","util","minimist","assert","path","graceful-fs","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],re=function(X){for(var e=[],R=0,n=X.length;R<n;R++)e[R]=ne[X[R]];return e};define(ne[110],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function R(n,k){if(!n)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=R}),define(ne[51],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function R(A){return A?A.replace(/\$\((.*?)\)/g,(C,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=R;class n{constructor(C,P,I){this.id=C,this.definition=P,this.description=I,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",{fontCharacter:"\\ea71"}),n.closeDirty=new n("close-dirty",{fontCharacter:"\\ea71"}),n.debugBreakpoint=new n("debug-breakpoint",{fontCharacter:"\\ea71"}),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),n.debugHint=new n("debug-hint",{fontCharacter:"\\ea71"}),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circleOutline=new n("circle-outline",{fontCharacter:"\\eabc"}),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLargeOutline=new n("circle-large-outline",{fontCharacter:"\\ebb5"}),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(A,C){const P=["codicon","codicon-"+A];return C&&P.push("codicon-modifier-"+C),P}e.getClassNamesArray=k;var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const C=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function P(b){if(b instanceof n)return["codicon","codicon-"+b.id];const v=C.exec(b.id);if(!v)return P(n.error);const[,y,d]=v,S=["codicon","codicon-"+y];return d&&S.push("codicon-modifier-"+d.substr(1)),S}A.asClassNameArray=P;function I(b){return P(b).join(" ")}A.asClassName=I;function E(b){return"."+P(b).join(".")}A.asCSSSelector=E})(T=e.CSSIcon||(e.CSSIcon={}))}),define(ne[60],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function R(A){return(C,P,I)=>{let E=null,b=null;if(typeof I.value=="function"?(E="value",b=I.value):typeof I.get=="function"&&(E="get",b=I.get),!b)throw new Error("not supported");I[E]=A(b,P)}}e.createDecorator=R;function n(A,C,P){let I=null,E=null;if(typeof P.value=="function"?(I="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(I="get",E=P.get),!E)throw new Error("not supported");const b=`$memoize$${C}`;P[I]=function(...v){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,v)}),this[b]}}e.memoize=n;function k(A,C,P){return R((I,E)=>{const b=`$debounce$${E}`,v=`$debounce$result$${E}`;return function(...y){this[v]||(this[v]=P?P():void 0),clearTimeout(this[b]),C&&(this[v]=C(this[v],...y),y=[this[v]]),this[b]=setTimeout(()=>{I.apply(this,y),this[v]=P?P():void 0},A)}})}e.debounce=k;function T(A,C,P){return R((I,E)=>{const b=`$throttle$timer$${E}`,v=`$throttle$result$${E}`,y=`$throttle$lastRun$${E}`,d=`$throttle$pending$${E}`;return function(...S){if(this[v]||(this[v]=P?P():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),C&&(this[v]=C(this[v],...S)),this[d])return;const w=this[y]+A;w<=Date.now()?(this[y]=Date.now(),I.apply(this,[this[v]]),this[v]=P?P():void 0):(this[d]=!0,this[b]=setTimeout(()=>{this[d]=!1,this[y]=Date.now(),I.apply(this,[this[v]]),this[v]=P?P():void 0},w-Date.now()))}})}e.throttle=T}),define(ne[9],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class R{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?u.isErrorNoTelemetry(s)?new u(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=R,e.errorHandler=new R;function n(h){e.errorHandler.setUnexpectedErrorHandler(h)}e.setUnexpectedErrorHandler=n;function k(h){P(h)||e.errorHandler.onUnexpectedError(h)}e.onUnexpectedError=k;function T(h){P(h)||e.errorHandler.onUnexpectedExternalError(h)}e.onUnexpectedExternalError=T;function A(h){if(h instanceof Error){const{name:s,message:r}=h,t=h.stacktrace||h.stack;return{$isError:!0,name:s,message:r,stack:t,noTelemetry:u.isErrorNoTelemetry(h)}}return h}e.transformErrorForSerialization=A;const C="Canceled";function P(h){return h instanceof I?!0:h instanceof Error&&h.name===C&&h.message===C}e.isCancellationError=P;class I extends Error{constructor(){super(C);this.name=this.message}}e.CancellationError=I;function E(){const h=new Error(C);return h.name=h.message,h}e.canceled=E;function b(h){return h?new Error(`Illegal argument: ${h}`):new Error("Illegal argument")}e.illegalArgument=b;function v(h){return h?new Error(`Illegal state: ${h}`):new Error("Illegal state")}e.illegalState=v;function y(h){return h?new Error(`readonly property '${h} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function d(h){const s=new Error(`${h} has been disposed`);return s.name="DISPOSED",s}e.disposed=d;function S(h){return h?h.message?h.message:h.stack?h.stack.split(`
`)[0]:String(h):"Error"}e.getErrorMessage=S;class w extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=w;class p extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=p;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class u extends Error{constructor(s){super(s);this.name="ErrorNoTelemetry"}static fromError(s){if(s instanceof u)return s;const r=new u;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=u;class f extends Error{constructor(s){super(s||"An unexpected bug occurred.");Object.setPrototypeOf(this,f.prototype);debugger}}e.BugIndicatingError=f}),define(ne[18],re([0,1,9]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(G,te=0){return G[G.length-(1+te)]}e.tail=n;function k(G){if(G.length===0)throw new Error("Invalid tail call");return[G.slice(0,G.length-1),G[G.length-1]]}e.tail2=k;function T(G,te,se=(ce,he)=>ce===he){if(G===te)return!0;if(!G||!te||G.length!==te.length)return!1;for(let ce=0,he=G.length;ce<he;ce++)if(!se(G[ce],te[ce]))return!1;return!0}e.equals=T;function A(G,te){const se=G.length-1;te<se&&(G[te]=G[se]),G.pop()}e.removeFastWithoutKeepingOrder=A;function C(G,te,se){return P(G.length,ce=>se(G[ce],te))}e.binarySearch=C;function P(G,te){let se=0,ce=G-1;for(;se<=ce;){const he=(se+ce)/2|0,ve=te(he);if(ve<0)se=he+1;else if(ve>0)ce=he-1;else return he}return-(se+1)}e.binarySearch2=P;function I(G,te){let se=0,ce=G.length;if(ce===0)return 0;for(;se<ce;){const he=Math.floor((se+ce)/2);te(G[he])?ce=he:se=he+1}return se}e.findFirstInSorted=I;function E(G,te,se){if(G=G|0,G>=te.length)throw new TypeError("invalid index");const ce=te[Math.floor(te.length*Math.random())],he=[],ve=[],pe=[];for(const Ce of te){const be=se(Ce,ce);be<0?he.push(Ce):be>0?ve.push(Ce):pe.push(Ce)}return G<he.length?E(G,he,se):G<he.length+pe.length?pe[0]:E(G-(he.length+pe.length),ve,se)}e.quickSelect=E;function b(G,te){const se=[];let ce;for(const he of G.slice(0).sort(te))!ce||te(ce[0],he)!==0?(ce=[he],se.push(ce)):ce.push(he);return se}e.groupBy=b;function v(G,te,se){const ce=[];function he(Ce,be,Pe){if(be===0&&Pe.length===0)return;const Me=ce[ce.length-1];Me&&Me.start+Me.deleteCount===Ce?(Me.deleteCount+=be,Me.toInsert.push(...Pe)):ce.push({start:Ce,deleteCount:be,toInsert:Pe})}let ve=0,pe=0;for(;;){if(ve===G.length){he(ve,0,te.slice(pe));break}if(pe===te.length){he(ve,G.length-ve,[]);break}const Ce=G[ve],be=te[pe],Pe=se(Ce,be);Pe===0?(ve+=1,pe+=1):Pe<0?(he(ve,1,[]),ve+=1):Pe>0&&(he(ve,0,[be]),pe+=1)}return ce}e.sortedDiff=v;function y(G,te,se){const ce=v(G,te,se),he=[],ve=[];for(const pe of ce)he.push(...G.slice(pe.start,pe.start+pe.deleteCount)),ve.push(...pe.toInsert);return{removed:he,added:ve}}e.delta=y;function d(G,te,se){if(se===0)return[];const ce=G.slice(0,se).sort(te);return w(G,te,ce,se,G.length),ce}e.top=d;function S(G,te,se,ce,he){return se===0?Promise.resolve([]):new Promise((ve,pe)=>{(async()=>{const Ce=G.length,be=G.slice(0,se).sort(te);for(let Pe=se,Me=Math.min(se+ce,Ce);Pe<Ce;Pe=Me,Me=Math.min(Me+ce,Ce)){if(Pe>se&&await new Promise(Ke=>setTimeout(Ke)),he&&he.isCancellationRequested)throw new R.CancellationError;w(G,te,be,Pe,Me)}return be})().then(ve,pe)})}e.topAsync=S;function w(G,te,se,ce,he){for(const ve=se.length;ce<he;ce++){const pe=G[ce];if(te(pe,se[ve-1])<0){se.pop();const Ce=I(se,be=>te(pe,be)<0);se.splice(Ce,0,pe)}}}function p(G){return G.filter(te=>!!te)}e.coalesce=p;function g(G){let te=0;for(let se=0;se<G.length;se++)G[se]&&(G[te]=G[se],te+=1);G.length=te}e.coalesceInPlace=g;function u(G,te,se){G.splice(se,0,G.splice(te,1)[0])}e.move=u;function f(G){return!Array.isArray(G)||G.length===0}e.isFalsyOrEmpty=f;function h(G){return Array.isArray(G)&&G.length>0}e.isNonEmptyArray=h;function s(G,te=se=>se){const se=new Set;return G.filter(ce=>{const he=te(ce);return se.has(he)?!1:(se.add(he),!0)})}e.distinct=s;function r(G){const te=new Set;return se=>{const ce=G(se);return te.has(ce)?!1:(te.add(ce),!0)}}e.uniqueFilter=r;function t(G,te){const se=i(G,te);if(se!==-1)return G[se]}e.findLast=t;function i(G,te){for(let se=G.length-1;se>=0;se--){const ce=G[se];if(te(ce))return se}return-1}e.lastIndex=i;function o(G,te){return G.length>0?G[0]:te}e.firstOrDefault=o;function c(G,te){return G.length>0?G[G.length-1]:te}e.lastOrDefault=c;function a(G,te,se=(ce,he)=>ce===he){let ce=0;for(let he=0,ve=Math.min(G.length,te.length);he<ve&&se(G[he],te[he]);he++)ce++;return ce}e.commonPrefixLength=a;function l(G){return[].concat(...G)}e.flatten=l;function m(G,te){let se=typeof te=="number"?G:0;typeof te=="number"?se=G:(se=0,te=G);const ce=[];if(se<=te)for(let he=se;he<te;he++)ce.push(he);else for(let he=se;he>te;he--)ce.push(he);return ce}e.range=m;function D(G,te,se){return G.reduce((ce,he)=>(ce[te(he)]=se?se(he):he,ce),Object.create(null))}e.index=D;function U(G,te){return G.push(te),()=>O(G,te)}e.insert=U;function O(G,te){const se=G.indexOf(te);if(se>-1)return G.splice(se,1),te}e.remove=O;function F(G,te,se){const ce=G.slice(0,te),he=G.slice(te);return ce.concat(se,he)}e.arrayInsert=F;function L(G,te){let se;if(typeof te=="number"){let ce=te;se=()=>{const he=Math.sin(ce++)*179426549;return he-Math.floor(he)}}else se=Math.random;for(let ce=G.length-1;ce>0;ce-=1){const he=Math.floor(se()*(ce+1)),ve=G[ce];G[ce]=G[he],G[he]=ve}}e.shuffle=L;function N(G,te){const se=G.indexOf(te);se>-1&&(G.splice(se,1),G.unshift(te))}e.pushToStart=N;function W(G,te){const se=G.indexOf(te);se>-1&&(G.splice(se,1),G.push(te))}e.pushToEnd=W;function V(G,te){for(const se of te)G.push(se)}e.pushMany=V;function J(G,te){return Array.isArray(G)?G.map(te):te(G)}e.mapArrayOrNot=J;function $(G){return Array.isArray(G)?G:[G]}e.asArray=$;function Q(G){return G[Math.floor(Math.random()*G.length)]}e.getRandomElement=Q;function H(G,te){for(const se of G){const ce=te(se);if(ce!==void 0)return ce}}e.mapFind=H;function B(G,te,se){const ce=ie(G,te),he=G.length,ve=se.length;G.length=he+ve;for(let pe=he-1;pe>=ce;pe--)G[pe+ve]=G[pe];for(let pe=0;pe<ve;pe++)G[pe+ce]=se[pe]}e.insertInto=B;function Y(G,te,se,ce){const he=ie(G,te),ve=G.splice(he,se);return B(G,he,ce),ve}e.splice=Y;function ie(G,te){return te<0?Math.max(te+G.length,0):Math.min(te,G.length)}var ae;(function(G){function te(he){return he<0}G.isLessThan=te;function se(he){return he>0}G.isGreaterThan=se;function ce(he){return he===0}G.isNeitherLessOrGreaterThan=ce,G.greaterThan=1,G.lessThan=-1,G.neitherLessOrGreaterThan=0})(ae=e.CompareResult||(e.CompareResult={}));function z(G,te){return(se,ce)=>te(G(se),G(ce))}e.compareBy=z;function x(...G){return(te,se)=>{for(const ce of G){const he=ce(te,se);if(!ae.isNeitherLessOrGreaterThan(he))return he}return ae.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const _=(G,te)=>G-te;e.numberComparator=_;function M(G,te){if(G.length===0)return;let se=G[0];for(let ce=1;ce<G.length;ce++){const he=G[ce];te(he,se)>0&&(se=he)}return se}e.findMaxBy=M;function q(G,te){if(G.length===0)return;let se=G[0];for(let ce=1;ce<G.length;ce++){const he=G[ce];te(he,se)>=0&&(se=he)}return se}e.findLastMaxBy=q;function j(G,te){return M(G,(se,ce)=>-te(se,ce))}e.findMinBy=j;class Z{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let se=this.firstIdx;for(;se<this.items.length&&te(this.items[se]);)se++;const ce=se===this.firstIdx?null:this.items.slice(this.firstIdx,se);return this.firstIdx=se,ce}takeFromEndWhile(te){let se=this.lastIdx;for(;se>=0&&te(this.items[se]);)se--;const ce=se===this.lastIdx?null:this.items.slice(se+1,this.lastIdx+1);return this.lastIdx=se,ce}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const se=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,se}}e.ArrayQueue=Z}),define(ne[74],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function R(n){const k=this;let T=!1,A;return function(){return T||(T=!0,A=n.apply(k,arguments)),A}}e.once=R}),define(ne[52],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var R;(function(n){function k(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=k;const T=Object.freeze([]);function A(){return T}n.empty=A;function*C(r){yield r}n.single=C;function P(r){return r||T}n.from=P;function I(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=I;function E(r){return r[Symbol.iterator]().next().value}n.first=E;function b(r,t){for(const i of r)if(t(i))return!0;return!1}n.some=b;function v(r,t){for(const i of r)if(t(i))return i}n.find=v;function*y(r,t){for(const i of r)t(i)&&(yield i)}n.filter=y;function*d(r,t){let i=0;for(const o of r)yield t(o,i++)}n.map=d;function*S(...r){for(const t of r)for(const i of t)yield i}n.concat=S;function*w(r){for(const t of r)for(const i of t)yield i}n.concatNested=w;function p(r,t,i){let o=i;for(const c of r)o=t(o,c);return o}n.reduce=p;function g(r,t){let i=0;for(const o of r)t(o,i++)}n.forEach=g;function*u(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}n.slice=u;function f(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const o=r[Symbol.iterator]();for(let c=0;c<t;c++){const a=o.next();if(a.done)return[i,n.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return o}}]}n.consume=f;function h(r){return f(r)[0]}n.collect=h;function s(r,t,i=(o,c)=>o===c){const o=r[Symbol.iterator](),c=t[Symbol.iterator]();for(;;){const a=o.next(),l=c.next();if(a.done!==l.done)return!1;if(a.done)return!0;if(!i(a.value,l.value))return!1}}n.equals=s})(R=e.Iterable||(e.Iterable={}))}),define(ne[35],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var R;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(R=e.ScanError||(e.ScanError={}));var n;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var T;(function(s){s.DEFAULT={allowTrailingComma:!0}})(T=e.ParseOptions||(e.ParseOptions={}));function A(s,r=!1){let t=0;const i=s.length;let o="",c=0,a=16,l=0;function m(W){let V=0,J=0;for(;V<W;){const $=s.charCodeAt(t);if($>=48&&$<=57)J=J*16+$-48;else if($>=65&&$<=70)J=J*16+$-65+10;else if($>=97&&$<=102)J=J*16+$-97+10;else break;t++,V++}return V<W&&(J=-1),J}function D(W){t=W,o="",c=0,a=16,l=0}function U(){const W=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&I(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&I(s.charCodeAt(t)))for(t++;t<s.length&&I(s.charCodeAt(t));)t++;else return l=3,s.substring(W,t);let V=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&I(s.charCodeAt(t))){for(t++;t<s.length&&I(s.charCodeAt(t));)t++;V=t}else l=3;return s.substring(W,V)}function O(){let W="",V=t;for(;;){if(t>=i){W+=s.substring(V,t),l=2;break}const J=s.charCodeAt(t);if(J===34){W+=s.substring(V,t),t++;break}if(J===92){if(W+=s.substring(V,t),t++,t>=i){l=2;break}switch(s.charCodeAt(t++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const Q=m(4);Q>=0?W+=String.fromCharCode(Q):l=4;break}default:l=5}V=t;continue}if(J>=0&&J<=31)if(P(J)){W+=s.substring(V,t),l=2;break}else l=6;t++}return W}function F(){if(o="",l=0,c=t,t>=i)return c=i,a=17;let W=s.charCodeAt(t);if(C(W)){do t++,o+=String.fromCharCode(W),W=s.charCodeAt(t);while(C(W));return a=15}if(P(W))return t++,o+=String.fromCharCode(W),W===13&&s.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(W){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=O(),a=10;case 47:{const V=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!P(s.charCodeAt(t));)t++;return o=s.substring(V,t),a=12}if(s.charCodeAt(t+1)===42){t+=2;const J=i-1;let $=!1;for(;t<J;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,$=!0;break}t++}return $||(t++,l=1),o=s.substring(V,t),a=13}return o+=String.fromCharCode(W),t++,a=16}case 45:if(o+=String.fromCharCode(W),t++,t===i||!I(s.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=U(),a=11;default:for(;t<i&&L(W);)t++,W=s.charCodeAt(t);if(c!==t){switch(o=s.substring(c,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(W),t++,a=16}}function L(W){if(C(W)||P(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let W;do W=F();while(W>=12&&W<=15);return W}return{setPosition:D,getPosition:()=>t,scan:r?N:F,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>c,getTokenLength:()=>t-c,getTokenError:()=>l}}e.createScanner=A;function C(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function P(s){return s===10||s===13||s===8232||s===8233}function I(s){return s>=48&&s<=57}var E;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(E||(E={}));function b(s,r){const t=[],i=new Object;let o;const c={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function l(m,D,U,O){c.value=m,c.offset=D,c.length=U,c.type=O,c.colonOffset=void 0,o=c}try{u(s,{onObjectBegin:(m,D)=>{if(r<=m)throw i;o=void 0,a=r>m,t.push("")},onObjectProperty:(m,D,U)=>{if(r<D||(l(m,D,U,"property"),t[t.length-1]=m,r<=D+U))throw i},onObjectEnd:(m,D)=>{if(r<=m)throw i;o=void 0,t.pop()},onArrayBegin:(m,D)=>{if(r<=m)throw i;o=void 0,t.push(0)},onArrayEnd:(m,D)=>{if(r<=m)throw i;o=void 0,t.pop()},onLiteralValue:(m,D,U)=>{if(r<D||(l(m,D,U,h(m)),r<=D+U))throw i},onSeparator:(m,D,U)=>{if(r<=D)throw i;if(m===":"&&o&&o.type==="property")o.colonOffset=D,a=!1,o=void 0;else if(m===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(m){if(m!==i)throw m}return{path:t,previousNode:o,isAtPropertyKey:a,matches:m=>{let D=0;for(let U=0;D<m.length&&U<t.length;U++)if(m[D]===t[U]||m[D]==="*")D++;else if(m[D]!=="**")return!1;return D===m.length}}}e.getLocation=b;function v(s,r=[],t=T.DEFAULT){let i=null,o=[];const c=[];function a(m){Array.isArray(o)?o.push(m):i!==null&&(o[i]=m)}return u(s,{onObjectBegin:()=>{const m={};a(m),c.push(o),o=m,i=null},onObjectProperty:m=>{i=m},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const m=[];a(m),c.push(o),o=m,i=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:a,onError:(m,D,U)=>{r.push({error:m,offset:D,length:U})}},t),o[0]}e.parse=v;function y(s,r=[],t=T.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(m){i.type==="property"&&(i.length=m-i.offset,i=i.parent)}function c(m){return i.children.push(m),m}u(s,{onObjectBegin:m=>{i=c({type:"object",offset:m,length:-1,parent:i,children:[]})},onObjectProperty:(m,D,U)=>{i=c({type:"property",offset:D,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:m,offset:D,length:U,parent:i})},onObjectEnd:(m,D)=>{i.length=m+D-i.offset,i=i.parent,o(m+D)},onArrayBegin:(m,D)=>{i=c({type:"array",offset:m,length:-1,parent:i,children:[]})},onArrayEnd:(m,D)=>{i.length=m+D-i.offset,i=i.parent,o(m+D)},onLiteralValue:(m,D,U)=>{c({type:h(m),offset:D,length:U,parent:i,value:m}),o(D+U)},onSeparator:(m,D,U)=>{i.type==="property"&&(m===":"?i.colonOffset=D:m===","&&o(D))},onError:(m,D,U)=>{r.push({error:m,offset:D,length:U})}},t);const l=i.children[0];return l&&delete l.parent,l}e.parseTree=y;function d(s,r){if(!s)return;let t=s;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const c of t.children)if(Array.isArray(c.children)&&c.children[0].value===i){t=c.children[1],o=!0;break}if(!o)return}else{const o=i;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=d;function S(s){if(!s.parent||!s.parent.children)return[];const r=S(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;r.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&r.push(t)}return r}e.getNodePath=S;function w(s){switch(s.type){case"array":return s.children.map(w);case"object":{const r=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(r[t.children[0].value]=w(i))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=w;function p(s,r,t=!1){return r>=s.offset&&r<s.offset+s.length||t&&r===s.offset+s.length}e.contains=p;function g(s,r,t=!1){if(p(s,r,t)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const c=g(i[o],r,t);if(c)return c}return s}}e.findNodeAtOffset=g;function u(s,r,t=T.DEFAULT){const i=A(s,!1);function o(z){return z?()=>z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function c(z){return z?x=>z(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),l=c(r.onObjectProperty),m=o(r.onObjectEnd),D=o(r.onArrayBegin),U=o(r.onArrayEnd),O=c(r.onLiteralValue),F=c(r.onSeparator),L=o(r.onComment),N=c(r.onError),W=t&&t.disallowComments,V=t&&t.allowTrailingComma;function J(){for(;;){const z=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:W||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(z){case 12:case 13:W?$(10):L();break;case 16:$(1);break;case 15:case 14:break;default:return z}}}function $(z,x=[],_=[]){if(N(z),x.length+_.length>0){let M=i.getToken();for(;M!==17;){if(x.indexOf(M)!==-1){J();break}else if(_.indexOf(M)!==-1)break;M=J()}}}function Q(z){const x=i.getTokenValue();return z?O(x):l(x),J(),!0}function H(){switch(i.getToken()){case 11:{let z=0;try{z=JSON.parse(i.getTokenValue()),typeof z!="number"&&($(2),z=0)}catch{$(2)}O(z);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return J(),!0}function B(){return i.getToken()!==10?($(3,[],[2,5]),!1):(Q(!1),i.getToken()===6?(F(":"),J(),ae()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function Y(){a(),J();let z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(z||$(4,[],[]),F(","),J(),i.getToken()===2&&V)break}else z&&$(6,[],[]);B()||$(4,[],[2,5]),z=!0}return m(),i.getToken()!==2?$(7,[2],[]):J(),!0}function ie(){D(),J();let z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(z||$(4,[],[]),F(","),J(),i.getToken()===4&&V)break}else z&&$(6,[],[]);ae()||$(4,[],[4,5]),z=!0}return U(),i.getToken()!==4?$(8,[4],[]):J(),!0}function ae(){switch(i.getToken()){case 3:return ie();case 1:return Y();case 10:return Q(!0);default:return H()}}return J(),i.getToken()===17?t.allowEmptyContent?!0:($(4,[],[]),!1):ae()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=u;function f(s,r){const t=A(s),i=[];let o,c=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:c!==a&&i.push(s.substring(c,a)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),c=t.getPosition();break}while(o!==17);return i.join("")}e.stripComments=f;function h(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=h}),define(ne[53],re([0,1,35]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(I,E,b){let v,y,d,S,w;if(E){for(S=E.offset,w=S+E.length,d=S;d>0&&!P(I,d-1);)d--;let a=w;for(;a<I.length&&!P(I,a);)a++;y=I.substring(d,a),v=A(y,b)}else y=I,v=0,d=0,S=0,w=I.length;const p=C(b,I);let g=!1,u=0,f;b.insertSpaces?f=T(" ",b.tabSize||4):f="	";const h=(0,R.createScanner)(y,!1);let s=!1;function r(){return p+T(f,v+u)}function t(){let a=h.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=h.scan();return s=a===16||h.getTokenError()!==0,a}const i=[];function o(a,l,m){!s&&l<w&&m>S&&I.substring(l,m)!==a&&i.push({offset:l,length:m-l,content:a})}let c=t();if(c!==17){const a=h.getTokenOffset()+d,l=T(f,v);o(l,d,a)}for(;c!==17;){let a=h.getTokenOffset()+h.getTokenLength()+d,l=t(),m="";for(;!g&&(l===12||l===13);){const U=h.getTokenOffset()+d;o(" ",a,U),a=h.getTokenOffset()+h.getTokenLength()+d,m=l===12?r():"",l=t()}if(l===2)c!==1&&(u--,m=r());else if(l===4)c!==3&&(u--,m=r());else{switch(c){case 3:case 1:u++,m=r();break;case 5:case 12:m=r();break;case 13:g?m=r():m=" ";break;case 6:m=" ";break;case 10:if(l===6){m="";break}case 7:case 8:case 9:case 11:case 2:case 4:l===12||l===13?m=" ":l!==5&&l!==17&&(s=!0);break;case 16:s=!0;break}g&&(l===12||l===13)&&(m=r())}const D=h.getTokenOffset()+d;o(m,a,D),c=l}return i}e.format=n;function k(I,E){const b=JSON.stringify(I,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?b.replace(/\r\n|\r|\n/g,E.eol):b}e.toFormattedString=k;function T(I,E){let b="";for(let v=0;v<E;v++)b+=I;return b}function A(I,E){let b=0,v=0;const y=E.tabSize||4;for(;b<I.length;){const d=I.charAt(b);if(d===" ")v++;else if(d==="	")v+=y;else break;b++}return Math.floor(v/y)}function C(I,E){for(let b=0;b<E.length;b++){const v=E.charAt(b);if(v==="\r")return b+1<E.length&&E.charAt(b+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=C;function P(I,E){return`\r
`.indexOf(I.charAt(E))!==-1}e.isEOL=P}),define(ne[75],re([0,1,35,53]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(I,E,b){return T(I,E,void 0,b)}e.removeProperty=k;function T(I,E,b,v,y){const d=E.slice(),S=[],w=(0,R.parseTree)(I,S);let p,g;for(;d.length>0&&(g=d.pop(),p=(0,R.findNodeAtLocation)(w,d),p===void 0&&b!==void 0);)typeof g=="string"?b={[g]:b}:b=[b];if(p)if(p.type==="object"&&typeof g=="string"&&Array.isArray(p.children)){const u=(0,R.findNodeAtLocation)(p,[g]);if(u!==void 0)if(b===void 0){if(!u.parent)throw new Error("Malformed AST");const f=p.children.indexOf(u.parent);let h,s=u.parent.offset+u.parent.length;if(f>0){const r=p.children[f-1];h=r.offset+r.length}else h=p.offset+1,p.children.length>1&&(s=p.children[1].offset);return A(I,{offset:h,length:s-h,content:""},v)}else return A(I,{offset:u.offset,length:u.length,content:JSON.stringify(b)},v);else{if(b===void 0)return[];const f=`${JSON.stringify(g)}: ${JSON.stringify(b)}`,h=y?y(p.children.map(r=>r.children[0].value)):p.children.length;let s;if(h>0){const r=p.children[h-1];s={offset:r.offset+r.length,length:0,content:","+f}}else p.children.length===0?s={offset:p.offset+1,length:0,content:f}:s={offset:p.offset+1,length:0,content:f+","};return A(I,s,v)}}else if(p.type==="array"&&typeof g=="number"&&Array.isArray(p.children))if(b!==void 0){const u=`${JSON.stringify(b)}`;let f;if(p.children.length===0||g===0)f={offset:p.offset+1,length:0,content:p.children.length===0?u:u+","};else{const h=g===-1||g>p.children.length?p.children.length:g,s=p.children[h-1];f={offset:s.offset+s.length,length:0,content:","+u}}return A(I,f,v)}else{const u=g,f=p.children[u];let h;if(p.children.length===1)h={offset:p.offset+1,length:p.length-2,content:""};else if(p.children.length-1===u){const s=p.children[u-1],r=s.offset+s.length,t=p.offset+p.length;h={offset:r,length:t-2-r,content:""}}else h={offset:f.offset,length:p.children[u+1].offset-f.offset,content:""};return A(I,h,v)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${p.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return A(I,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(b)},v)}}e.setProperty=T;function A(I,E,b){let v=C(I,E),y=E.offset,d=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;y>0&&!(0,n.isEOL)(v,y-1);)y--;for(;d<v.length&&!(0,n.isEOL)(v,d);)d++}const S=(0,n.format)(v,{offset:y,length:d-y},b);for(let p=S.length-1;p>=0;p--){const g=S[p];v=C(v,g),y=Math.min(y,g.offset),d=Math.max(d,g.offset+g.length),d+=g.content.length-g.length}const w=I.length-(v.length-d)-y;return[{offset:y,length:w,content:v.substring(y,d)}]}e.withFormatting=A;function C(I,E){return I.substring(0,E.offset)+E.content+I.substring(E.offset+E.length)}e.applyEdit=C;function P(I,E){const b=E.slice(0).sort((y,d)=>{const S=y.offset-d.offset;return S===0?y.length-d.length:S});let v=I.length;for(let y=b.length-1;y>=0;y--){const d=b[y];if(d.offset+d.length<=v)I=C(I,d);else throw new Error("Overlapping edit");v=d.offset}return I}e.applyEdits=P}),define(ne[111],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class R{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new R(()=>k(this.getValue()))}}e.Lazy=R}),define(ne[2],re([0,1,74,52]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let T=null;function A(o){T=o}if(e.setDisposableTracker=A,k){const o="__is_disposable_tracked__";A(new class{trackDisposable(c){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(a)},3e3)}setParent(c,a){if(c&&c!==g.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==g.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function C(o){return T?.trackDisposable(o),o}function P(o){T?.markAsDisposed(o)}function I(o,c){T?.setParent(o,c)}function E(o,c){if(!!T)for(const a of o)T.setParent(a,c)}function b(o){return T?.markAsSingleton(o),o}e.markAsSingleton=b;class v extends Error{constructor(c){super(`Encountered errors while disposing of store. Errors: [${c.join(", ")}]`);this.errors=c}}e.MultiDisposeError=v;function y(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=y;function d(o){if(n.Iterable.is(o)){const c=[];for(const a of o)if(a)try{a.dispose()}catch(l){c.push(l)}if(c.length===1)throw c[0];if(c.length>1)throw new v(c);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=d;function S(...o){const c=w(()=>d(o));return E(o,c),c}e.combinedDisposable=S;function w(o){const c=C({dispose:(0,R.once)(()=>{P(c),o()})});return c}e.toDisposable=w;class p{constructor(){this._toDispose=new Set,this._isDisposed=!1,C(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{d(this._toDispose.values())}finally{this._toDispose.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return I(c,this),this._isDisposed?p.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(c),c}}e.DisposableStore=p,p.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new p,C(this),I(this._store,this)}dispose(){P(this),this._store.dispose()}_register(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(c)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,C(this)}get value(){return this._isDisposed?void 0:this._value}set value(c){this._isDisposed||c===this._value||(this._value?.dispose(),c&&I(c,this),this._value=c)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const c=this._value;return this._value=void 0,c&&I(c,null),c}}e.MutableDisposable=u;class f{constructor(c){this._disposable=c,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=f;class h{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,C(this)}set(c){let a=c;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,P(this))},this}}e.SafeDisposable=h;class s{constructor(){this.references=new Map}acquire(c,...a){let l=this.references.get(c);l||(l={counter:0,object:this.createReferencedObject(c,...a)},this.references.set(c,l));const{object:m}=l,D=(0,R.once)(()=>{--l.counter==0&&(this.destroyReferencedObject(c,l.object),this.references.delete(c))});return l.counter++,{object:m,dispose:D}}}e.ReferenceCollection=s;class r{constructor(c){this.referenceCollection=c}async acquire(c,...a){const l=this.referenceCollection.acquire(c,...a);try{return{object:await l.object,dispose:()=>l.dispose()}}catch(m){throw l.dispose(),m}}}e.AsyncReferenceCollection=r;class t{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=t;function i(o){const c=new p;try{o(c)}finally{c.dispose()}}e.disposeOnReturn=i}),define(ne[112],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class R{constructor(T){this.element=T,this.next=R.Undefined,this.prev=R.Undefined}}R.Undefined=new R(void 0);class n{constructor(){this._first=R.Undefined,this._last=R.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===R.Undefined}clear(){let T=this._first;for(;T!==R.Undefined;){const A=T.next;T.prev=R.Undefined,T.next=R.Undefined,T=A}this._first=R.Undefined,this._last=R.Undefined,this._size=0}unshift(T){return this._insert(T,!1)}push(T){return this._insert(T,!0)}_insert(T,A){const C=new R(T);if(this._first===R.Undefined)this._first=C,this._last=C;else if(A){const I=this._last;this._last=C,C.prev=I,I.next=C}else{const I=this._first;this._first=C,C.next=I,I.prev=C}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(C))}}shift(){if(this._first!==R.Undefined){const T=this._first.element;return this._remove(this._first),T}}pop(){if(this._last!==R.Undefined){const T=this._last.element;return this._remove(this._last),T}}_remove(T){if(T.prev!==R.Undefined&&T.next!==R.Undefined){const A=T.prev;A.next=T.next,T.next.prev=A}else T.prev===R.Undefined&&T.next===R.Undefined?(this._first=R.Undefined,this._last=R.Undefined):T.next===R.Undefined?(this._last=this._last.prev,this._last.next=R.Undefined):T.prev===R.Undefined&&(this._first=this._first.next,this._first.prev=R.Undefined);this._size-=1}*[Symbol.iterator](){let T=this._first;for(;T!==R.Undefined;)yield T.element,T=T.next}}e.LinkedList=n}),function(){function X(k){const T=[];typeof k=="number"&&T.push("code/timeOrigin",k);function A(P){T.push(P,Date.now())}function C(){const P=[];for(let I=0;I<T.length;I+=2)P.push({name:T[I],startTime:T[I+1]});return P}return{mark:A,getMarks:C}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(k+A.startTime)});return T}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function R(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return R(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=R(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=R(n))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var R=e();for(var n in R)(typeof exports=="object"?exports:X)[n]=R[n]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function R(n){if(e[n])return e[n].exports;var k=e[n]={i:n,l:!1,exports:{}};return X[n].call(k.exports,k,k.exports,R),k.l=!0,k.exports}return R.m=X,R.c=e,R.d=function(n,k,T){R.o(n,k)||Object.defineProperty(n,k,{enumerable:!0,get:T})},R.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},R.t=function(n,k){if(1&k&&(n=R(n)),8&k||4&k&&typeof n=="object"&&n&&n.__esModule)return n;var T=Object.create(null);if(R.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:n}),2&k&&typeof n!="string")for(var A in n)R.d(T,A,function(C){return n[C]}.bind(null,A));return T},R.n=function(n){var k=n&&n.__esModule?function(){return n.default}:function(){return n};return R.d(k,"a",k),k},R.o=function(n,k){return Object.prototype.hasOwnProperty.call(n,k)},R.p="",R(R.s=0)}([function(X,e,R){(function(n){var k;e=X.exports=_,k=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var oe=Array.prototype.slice.call(arguments,0);oe.unshift("SEMVER"),console.log.apply(console,oe)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,C=e.re=[],P=e.src=[],I=0,E=I++;P[E]="0|[1-9]\\d*";var b=I++;P[b]="[0-9]+";var v=I++;P[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=I++;P[y]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var d=I++;P[d]="("+P[b]+")\\.("+P[b]+")\\.("+P[b]+")";var S=I++;P[S]="(?:"+P[E]+"|"+P[v]+")";var w=I++;P[w]="(?:"+P[b]+"|"+P[v]+")";var p=I++;P[p]="(?:-("+P[S]+"(?:\\."+P[S]+")*))";var g=I++;P[g]="(?:-?("+P[w]+"(?:\\."+P[w]+")*))";var u=I++;P[u]="[0-9A-Za-z-]+";var f=I++;P[f]="(?:\\+("+P[u]+"(?:\\."+P[u]+")*))";var h=I++,s="v?"+P[y]+P[p]+"?"+P[f]+"?";P[h]="^"+s+"$";var r="[v=\\s]*"+P[d]+P[g]+"?"+P[f]+"?",t=I++;P[t]="^"+r+"$";var i=I++;P[i]="((?:<|>)?=?)";var o=I++;P[o]=P[b]+"|x|X|\\*";var c=I++;P[c]=P[E]+"|x|X|\\*";var a=I++;P[a]="[v=\\s]*("+P[c]+")(?:\\.("+P[c]+")(?:\\.("+P[c]+")(?:"+P[p]+")?"+P[f]+"?)?)?";var l=I++;P[l]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[g]+")?"+P[f]+"?)?)?";var m=I++;P[m]="^"+P[i]+"\\s*"+P[a]+"$";var D=I++;P[D]="^"+P[i]+"\\s*"+P[l]+"$";var U=I++;P[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=I++;P[O]="(?:~>?)";var F=I++;P[F]="(\\s*)"+P[O]+"\\s+",C[F]=new RegExp(P[F],"g");var L=I++;P[L]="^"+P[O]+P[a]+"$";var N=I++;P[N]="^"+P[O]+P[l]+"$";var W=I++;P[W]="(?:\\^)";var V=I++;P[V]="(\\s*)"+P[W]+"\\s+",C[V]=new RegExp(P[V],"g");var J=I++;P[J]="^"+P[W]+P[a]+"$";var $=I++;P[$]="^"+P[W]+P[l]+"$";var Q=I++;P[Q]="^"+P[i]+"\\s*("+r+")$|^$";var H=I++;P[H]="^"+P[i]+"\\s*("+s+")$|^$";var B=I++;P[B]="(\\s*)"+P[i]+"\\s*("+r+"|"+P[a]+")",C[B]=new RegExp(P[B],"g");var Y=I++;P[Y]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=I++;P[ie]="^\\s*("+P[l]+")\\s+-\\s+("+P[l]+")\\s*$";var ae=I++;P[ae]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,P[z]),C[z]||(C[z]=new RegExp(P[z]));function x(oe,ue){if(oe instanceof _)return oe;if(typeof oe!="string"||oe.length>T||!(ue?C[t]:C[h]).test(oe))return null;try{return new _(oe,ue)}catch{return null}}function _(oe,ue){if(oe instanceof _){if(oe.loose===ue)return oe;oe=oe.version}else if(typeof oe!="string")throw new TypeError("Invalid Version: "+oe);if(oe.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof _))return new _(oe,ue);k("SemVer",oe,ue),this.loose=ue;var de=oe.trim().match(ue?C[t]:C[h]);if(!de)throw new TypeError("Invalid Version: "+oe);if(this.raw=oe,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var Ie=+Ee;if(Ie>=0&&Ie<A)return Ie}return Ee}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=x,e.valid=function(oe,ue){var de=x(oe,ue);return de?de.version:null},e.clean=function(oe,ue){var de=x(oe.trim().replace(/^[=v]+/,""),ue);return de?de.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(oe){return k("SemVer.compare",this.version,this.loose,oe),oe instanceof _||(oe=new _(oe,this.loose)),this.compareMain(oe)||this.comparePre(oe)},_.prototype.compareMain=function(oe){return oe instanceof _||(oe=new _(oe,this.loose)),q(this.major,oe.major)||q(this.minor,oe.minor)||q(this.patch,oe.patch)},_.prototype.comparePre=function(oe){if(oe instanceof _||(oe=new _(oe,this.loose)),this.prerelease.length&&!oe.prerelease.length)return-1;if(!this.prerelease.length&&oe.prerelease.length)return 1;if(!this.prerelease.length&&!oe.prerelease.length)return 0;var ue=0;do{var de=this.prerelease[ue],Ee=oe.prerelease[ue];if(k("prerelease compare",ue,de,Ee),de===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(de===void 0)return-1;if(de!==Ee)return q(de,Ee)}while(++ue)},_.prototype.inc=function(oe,ue){switch(oe){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ue);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ue);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ue),this.inc("pre",ue);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ue),this.inc("pre",ue);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ue&&(this.prerelease[0]===ue?isNaN(this.prerelease[1])&&(this.prerelease=[ue,0]):this.prerelease=[ue,0]);break;default:throw new Error("invalid increment argument: "+oe)}return this.format(),this.raw=this.version,this},e.inc=function(oe,ue,de,Ee){typeof de=="string"&&(Ee=de,de=void 0);try{return new _(oe,de).inc(ue,Ee).version}catch{return null}},e.diff=function(oe,ue){if(te(oe,ue))return null;var de=x(oe),Ee=x(ue);if(de.prerelease.length||Ee.prerelease.length){for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==Ee[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in de)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&de[Ie]!==Ee[Ie])return Ie},e.compareIdentifiers=q;var M=/^[0-9]+$/;function q(oe,ue){var de=M.test(oe),Ee=M.test(ue);return de&&Ee&&(oe=+oe,ue=+ue),de&&!Ee?-1:Ee&&!de?1:oe<ue?-1:oe>ue?1:0}function j(oe,ue,de){return new _(oe,de).compare(new _(ue,de))}function Z(oe,ue,de){return j(oe,ue,de)>0}function G(oe,ue,de){return j(oe,ue,de)<0}function te(oe,ue,de){return j(oe,ue,de)===0}function se(oe,ue,de){return j(oe,ue,de)!==0}function ce(oe,ue,de){return j(oe,ue,de)>=0}function he(oe,ue,de){return j(oe,ue,de)<=0}function ve(oe,ue,de,Ee){var Ie;switch(ue){case"===":typeof oe=="object"&&(oe=oe.version),typeof de=="object"&&(de=de.version),Ie=oe===de;break;case"!==":typeof oe=="object"&&(oe=oe.version),typeof de=="object"&&(de=de.version),Ie=oe!==de;break;case"":case"=":case"==":Ie=te(oe,de,Ee);break;case"!=":Ie=se(oe,de,Ee);break;case">":Ie=Z(oe,de,Ee);break;case">=":Ie=ce(oe,de,Ee);break;case"<":Ie=G(oe,de,Ee);break;case"<=":Ie=he(oe,de,Ee);break;default:throw new TypeError("Invalid operator: "+ue)}return Ie}function pe(oe,ue){if(oe instanceof pe){if(oe.loose===ue)return oe;oe=oe.value}if(!(this instanceof pe))return new pe(oe,ue);k("comparator",oe,ue),this.loose=ue,this.parse(oe),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(oe,ue){return q(ue,oe)},e.major=function(oe,ue){return new _(oe,ue).major},e.minor=function(oe,ue){return new _(oe,ue).minor},e.patch=function(oe,ue){return new _(oe,ue).patch},e.compare=j,e.compareLoose=function(oe,ue){return j(oe,ue,!0)},e.rcompare=function(oe,ue,de){return j(ue,oe,de)},e.sort=function(oe,ue){return oe.sort(function(de,Ee){return e.compare(de,Ee,ue)})},e.rsort=function(oe,ue){return oe.sort(function(de,Ee){return e.rcompare(de,Ee,ue)})},e.gt=Z,e.lt=G,e.eq=te,e.neq=se,e.gte=ce,e.lte=he,e.cmp=ve,e.Comparator=pe;var Ce={};function be(oe,ue){if(oe instanceof be)return oe.loose===ue?oe:new be(oe.raw,ue);if(oe instanceof pe)return new be(oe.value,ue);if(!(this instanceof be))return new be(oe,ue);if(this.loose=ue,this.raw=oe,this.set=oe.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+oe);this.format()}function Pe(oe){return!oe||oe.toLowerCase()==="x"||oe==="*"}function Me(oe,ue,de,Ee,Ie,Ue,Re,$e,Ae,Te,Ne,ee,le){return((ue=Pe(de)?"":Pe(Ee)?">="+de+".0.0":Pe(Ie)?">="+de+"."+Ee+".0":">="+ue)+" "+($e=Pe(Ae)?"":Pe(Te)?"<"+(+Ae+1)+".0.0":Pe(Ne)?"<"+Ae+"."+(+Te+1)+".0":ee?"<="+Ae+"."+Te+"."+Ne+"-"+ee:"<="+$e)).trim()}function Ke(oe,ue){for(var de=0;de<oe.length;de++)if(!oe[de].test(ue))return!1;if(ue.prerelease.length){for(de=0;de<oe.length;de++)if(k(oe[de].semver),oe[de].semver!==Ce&&oe[de].semver.prerelease.length>0){var Ee=oe[de].semver;if(Ee.major===ue.major&&Ee.minor===ue.minor&&Ee.patch===ue.patch)return!0}return!1}return!0}function He(oe,ue,de){try{ue=new be(ue,de)}catch{return!1}return ue.test(oe)}function We(oe,ue,de,Ee){var Ie,Ue,Re,$e,Ae;switch(oe=new _(oe,Ee),ue=new be(ue,Ee),de){case">":Ie=Z,Ue=he,Re=G,$e=">",Ae=">=";break;case"<":Ie=G,Ue=ce,Re=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(He(oe,ue,Ee))return!1;for(var Te=0;Te<ue.set.length;++Te){var Ne=ue.set[Te],ee=null,le=null;if(Ne.forEach(function(fe){fe.semver===Ce&&(fe=new pe(">=0.0.0")),ee=ee||fe,le=le||fe,Ie(fe.semver,ee.semver,Ee)?ee=fe:Re(fe.semver,le.semver,Ee)&&(le=fe)}),ee.operator===$e||ee.operator===Ae||(!le.operator||le.operator===$e)&&Ue(oe,le.semver)||le.operator===Ae&&Re(oe,le.semver))return!1}return!0}pe.prototype.parse=function(oe){var ue=this.loose?C[Q]:C[H],de=oe.match(ue);if(!de)throw new TypeError("Invalid comparator: "+oe);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new _(de[2],this.loose):this.semver=Ce},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(oe){return k("Comparator.test",oe,this.loose),this.semver===Ce||(typeof oe=="string"&&(oe=new _(oe,this.loose)),ve(oe,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(oe,ue){if(!(oe instanceof pe))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new be(oe.value,ue),He(this.value,de,ue);if(oe.operator==="")return de=new be(this.value,ue),He(oe.semver,de,ue);var Ee=!(this.operator!==">="&&this.operator!==">"||oe.operator!==">="&&oe.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||oe.operator!=="<="&&oe.operator!=="<"),Ue=this.semver.version===oe.semver.version,Re=!(this.operator!==">="&&this.operator!=="<="||oe.operator!==">="&&oe.operator!=="<="),$e=ve(this.semver,"<",oe.semver,ue)&&(this.operator===">="||this.operator===">")&&(oe.operator==="<="||oe.operator==="<"),Ae=ve(this.semver,">",oe.semver,ue)&&(this.operator==="<="||this.operator==="<")&&(oe.operator===">="||oe.operator===">");return Ee||Ie||Ue&&Re||$e||Ae},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(oe){return oe.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(oe){var ue=this.loose;oe=oe.trim(),k("range",oe,ue);var de=ue?C[ie]:C[Y];oe=oe.replace(de,Me),k("hyphen replace",oe),oe=oe.replace(C[B],"$1$2$3"),k("comparator trim",oe,C[B]),oe=(oe=(oe=oe.replace(C[F],"$1~")).replace(C[V],"$1^")).split(/\s+/).join(" ");var Ee=ue?C[Q]:C[H],Ie=oe.split(" ").map(function(Ue){return function(Re,$e){return k("comp",Re),Re=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(ee,le){k("caret",ee,le);var fe=le?C[$]:C[J];return ee.replace(fe,function(Se,me,we,De,ke){var Le;return k("caret",ee,Se,me,we,De,ke),Pe(me)?Le="":Pe(we)?Le=">="+me+".0.0 <"+(+me+1)+".0.0":Pe(De)?Le=me==="0"?">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0":">="+me+"."+we+".0 <"+(+me+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=me==="0"?we==="0"?">="+me+"."+we+"."+De+ke+" <"+me+"."+we+"."+(+De+1):">="+me+"."+we+"."+De+ke+" <"+me+"."+(+we+1)+".0":">="+me+"."+we+"."+De+ke+" <"+(+me+1)+".0.0"):(k("no pr"),Le=me==="0"?we==="0"?">="+me+"."+we+"."+De+" <"+me+"."+we+"."+(+De+1):">="+me+"."+we+"."+De+" <"+me+"."+(+we+1)+".0":">="+me+"."+we+"."+De+" <"+(+me+1)+".0.0"),k("caret return",Le),Le})}(Ne,Te)}).join(" ")}(Re,$e),k("caret",Re),Re=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(ee,le){var fe=le?C[N]:C[L];return ee.replace(fe,function(Se,me,we,De,ke){var Le;return k("tilde",ee,Se,me,we,De,ke),Pe(me)?Le="":Pe(we)?Le=">="+me+".0.0 <"+(+me+1)+".0.0":Pe(De)?Le=">="+me+"."+we+".0 <"+me+"."+(+we+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+me+"."+we+"."+De+ke+" <"+me+"."+(+we+1)+".0"):Le=">="+me+"."+we+"."+De+" <"+me+"."+(+we+1)+".0",k("tilde return",Le),Le})}(Ne,Te)}).join(" ")}(Re,$e),k("tildes",Re),Re=function(Ae,Te){return k("replaceXRanges",Ae,Te),Ae.split(/\s+/).map(function(Ne){return function(ee,le){ee=ee.trim();var fe=le?C[D]:C[m];return ee.replace(fe,function(Se,me,we,De,ke,Le){k("xRange",ee,Se,me,we,De,ke,Le);var _e=Pe(we),Fe=_e||Pe(De),ze=Fe||Pe(ke);return me==="="&&ze&&(me=""),_e?Se=me===">"||me==="<"?"<0.0.0":"*":me&&ze?(Fe&&(De=0),ze&&(ke=0),me===">"?(me=">=",Fe?(we=+we+1,De=0,ke=0):ze&&(De=+De+1,ke=0)):me==="<="&&(me="<",Fe?we=+we+1:De=+De+1),Se=me+we+"."+De+"."+ke):Fe?Se=">="+we+".0.0 <"+(+we+1)+".0.0":ze&&(Se=">="+we+"."+De+".0 <"+we+"."+(+De+1)+".0"),k("xRange return",Se),Se})}(Ne,Te)}).join(" ")}(Re,$e),k("xrange",Re),Re=function(Ae,Te){return k("replaceStars",Ae,Te),Ae.trim().replace(C[ae],"")}(Re,$e),k("stars",Re),Re}(Ue,ue)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Ue){return!!Ue.match(Ee)})),Ie=Ie.map(function(Ue){return new pe(Ue,ue)})},be.prototype.intersects=function(oe,ue){if(!(oe instanceof be))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ee){return oe.set.some(function(Ie){return Ie.every(function(Ue){return Ee.intersects(Ue,ue)})})})})},e.toComparators=function(oe,ue){return new be(oe,ue).set.map(function(de){return de.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},be.prototype.test=function(oe){if(!oe)return!1;typeof oe=="string"&&(oe=new _(oe,this.loose));for(var ue=0;ue<this.set.length;ue++)if(Ke(this.set[ue],oe))return!0;return!1},e.satisfies=He,e.maxSatisfying=function(oe,ue,de){var Ee=null,Ie=null;try{var Ue=new be(ue,de)}catch{return null}return oe.forEach(function(Re){Ue.test(Re)&&(Ee&&Ie.compare(Re)!==-1||(Ie=new _(Ee=Re,de)))}),Ee},e.minSatisfying=function(oe,ue,de){var Ee=null,Ie=null;try{var Ue=new be(ue,de)}catch{return null}return oe.forEach(function(Re){Ue.test(Re)&&(Ee&&Ie.compare(Re)!==1||(Ie=new _(Ee=Re,de)))}),Ee},e.validRange=function(oe,ue){try{return new be(oe,ue).range||"*"}catch{return null}},e.ltr=function(oe,ue,de){return We(oe,ue,"<",de)},e.gtr=function(oe,ue,de){return We(oe,ue,">",de)},e.outside=We,e.prerelease=function(oe,ue){var de=x(oe,ue);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(oe,ue,de){return oe=new be(oe,de),ue=new be(ue,de),oe.intersects(ue)},e.coerce=function(oe){if(oe instanceof _)return oe;if(typeof oe!="string")return null;var ue=oe.match(C[U]);return ue==null?null:x((ue[1]||"0")+"."+(ue[2]||"0")+"."+(ue[3]||"0"))}}).call(this,R(1))},function(X,e){var R,n,k=X.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function C(w){if(R===setTimeout)return setTimeout(w,0);if((R===T||!R)&&setTimeout)return R=setTimeout,setTimeout(w,0);try{return R(w,0)}catch{try{return R.call(null,w,0)}catch{return R.call(this,w,0)}}}(function(){try{R=typeof setTimeout=="function"?setTimeout:T}catch{R=T}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var P,I=[],E=!1,b=-1;function v(){E&&P&&(E=!1,P.length?I=P.concat(I):b=-1,I.length&&y())}function y(){if(!E){var w=C(v);E=!0;for(var p=I.length;p;){for(P=I,I=[];++b<p;)P&&P[b].run();b=-1,p=I.length}P=null,E=!1,function(g){if(n===clearTimeout)return clearTimeout(g);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(g);try{n(g)}catch{try{return n.call(null,g)}catch{return n.call(this,g)}}}(w)}}function d(w,p){this.fun=w,this.array=p}function S(){}k.nextTick=function(w){var p=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)p[g-1]=arguments[g];I.push(new d(w,p)),I.length!==1||E||C(y)},d.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(w){return[]},k.binding=function(w){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(w){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(ne[113],re([0,1]),function(X,e){"use strict";var R;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(C,P,I){this.level=C,this.key=P,this.value=I,this.forward=[]}}const k=void 0;class T{constructor(C,P=2**16){this.comparator=C,this[R]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new n(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,k,k)}has(C){return Boolean(T._search(this,C,this.comparator))}get(C){return T._search(this,C,this.comparator)?.value}set(C,P){return T._insert(this,C,P,this.comparator)&&(this._size+=1),this}delete(C){const P=T._delete(this,C,this.comparator);return P&&(this._size-=1),P}forEach(C,P){let I=this._header.forward[0];for(;I;)C.call(P,I.value,I.key,this),I=I.forward[0]}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let C=this._header.forward[0];for(;C;)yield[C.key,C.value],C=C.forward[0]}*keys(){let C=this._header.forward[0];for(;C;)yield C.key,C=C.forward[0]}*values(){let C=this._header.forward[0];for(;C;)yield C.value,C=C.forward[0]}toString(){let C="[SkipList]:",P=this._header.forward[0];for(;P;)C+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return C}static _search(C,P,I){let E=C._header;for(let b=C._level-1;b>=0;b--)for(;E.forward[b]&&I(E.forward[b].key,P)<0;)E=E.forward[b];if(E=E.forward[0],E&&I(E.key,P)===0)return E}static _insert(C,P,I,E){const b=[];let v=C._header;for(let y=C._level-1;y>=0;y--){for(;v.forward[y]&&E(v.forward[y].key,P)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],v&&E(v.key,P)===0)return v.value=I,!1;{const y=T._randomLevel(C);if(y>C._level){for(let d=C._level;d<y;d++)b[d]=C._header;C._level=y}v=new n(y,P,I);for(let d=0;d<y;d++)v.forward[d]=b[d].forward[d],b[d].forward[d]=v;return!0}}static _randomLevel(C,P=.5){let I=1;for(;Math.random()<P&&I<C._maxLevel;)I+=1;return I}static _delete(C,P,I){const E=[];let b=C._header;for(let v=C._level-1;v>=0;v--){for(;b.forward[v]&&I(b.forward[v].key,P)<0;)b=b.forward[v];E[v]=b}if(b=b.forward[0],!b||I(b.key,P)!==0)return!1;for(let v=0;v<C._level&&E[v].forward[v]===b;v++)E[v].forward[v]=b.forward[v];for(;C._level>0&&C._header.forward[C._level-1]===k;)C._level-=1;return!0}}e.SkipList=T}),define(ne[41],re([0,1,9,2]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(f){const h=f;return h?typeof h.read=="function":!1}e.isReadable=k;function T(f){const h=f;return h?[h.on,h.pause,h.resume,h.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=T;function A(f){const h=f;return h?T(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}e.isReadableBufferedStream=A;function C(f,h){return new P(f,h)}e.newWriteableStream=C;class P{constructor(h,s){this.reducer=h,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(h){if(!this.state.destroyed){if(this.state.flowing)this.emitData(h);else if(this.buffer.data.push(h),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(h){this.state.destroyed||(this.state.flowing?this.emitError(h):this.buffer.error.push(h))}end(h){this.state.destroyed||(typeof h!="undefined"&&this.write(h),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(h){this.listeners.data.slice(0).forEach(s=>s(h))}emitError(h){this.listeners.error.length===0?(0,R.onUnexpectedError)(h):this.listeners.error.slice(0).forEach(s=>s(h))}emitEnd(){this.listeners.end.slice(0).forEach(h=>h())}on(h,s){if(!this.state.destroyed)switch(h){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(h,s){if(this.state.destroyed)return;let r;switch(h){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(s);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const h=this.reducer(this.buffer.data);this.emitData(h),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const h of this.buffer.error)this.emitError(h);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(f,h){const s=[];let r;for(;(r=f.read())!==null;)s.push(r);return h(s)}e.consumeReadable=I;function E(f,h,s){const r=[];let t;for(;(t=f.read())!==null&&r.length<s;)r.push(t);return t===null&&r.length>0?h(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t!="undefined"){const i=t;return t=void 0,i}return f.read()}}}e.peekReadable=E;function b(f,h){return new Promise((s,r)=>{const t=[];v(f,{onData:i=>{h&&t.push(i)},onError:i=>{h?r(i):s(void 0)},onEnd:()=>{s(h?h(t):void 0)}})})}e.consumeStream=b;function v(f,h){let s=!1;return f.on("error",r=>{s||h.onError(r)}),f.on("end",()=>{s||h.onEnd()}),f.on("data",r=>{s||h.onData(r)}),(0,n.toDisposable)(()=>s=!0)}e.listenStream=v;function y(f,h){return new Promise((s,r)=>{const t=new n.DisposableStore,i=[],o=l=>{if(i.push(l),i.length>h)return t.dispose(),f.pause(),s({stream:f,buffer:i,ended:!1})},c=l=>r(l),a=()=>s({stream:f,buffer:i,ended:!0});t.add((0,n.toDisposable)(()=>f.removeListener("error",c))),f.on("error",c),t.add((0,n.toDisposable)(()=>f.removeListener("end",a))),f.on("end",a),t.add((0,n.toDisposable)(()=>f.removeListener("data",o))),f.on("data",o)})}e.peekStream=y;function d(f,h){const s=C(h);return s.end(f),s}e.toStream=d;function S(){const f=C(()=>{throw new Error("not supported")});return f.end(),f}e.emptyStream=S;function w(f){let h=!1;return{read:()=>h?null:(h=!0,f)}}e.toReadable=w;function p(f,h,s){const r=C(s);return v(f,{onData:t=>r.write(h.data(t)),onError:t=>r.error(h.error?h.error(t):t),onEnd:()=>r.end()}),r}e.transform=p;function g(f,h,s){let r=!1;return{read:()=>{const t=h.read();return r?t:(r=!0,t!==null?s([f,t]):f)}}}e.prefixedReadable=g;function u(f,h,s){let r=!1;const t=C(s);return v(h,{onData:i=>r?t.write(i):(r=!0,t.write(s([f,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(f)),t.end()}}),t}e.prefixedStream=u}),define(ne[16],re([0,1,41]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let k,T;class A{constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}static alloc(l){return n?new A(Buffer.allocUnsafe(l)):new A(new Uint8Array(l))}static wrap(l){return n&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new A(l)}static fromString(l,m){return!(m?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(l)):(k||(k=new TextEncoder),new A(k.encode(l)))}static fromByteArray(l){const m=A.alloc(l.length);for(let D=0,U=l.length;D<U;D++)m.buffer[D]=l[D];return m}static concat(l,m){if(typeof m=="undefined"){m=0;for(let O=0,F=l.length;O<F;O++)m+=l[O].byteLength}const D=A.alloc(m);let U=0;for(let O=0,F=l.length;O<F;O++){const L=l[O];D.set(L,U),U+=L.byteLength}return D}clone(){const l=A.alloc(this.byteLength);return l.set(this),l}toString(){return n?this.buffer.toString():(T||(T=new TextDecoder),T.decode(this.buffer))}slice(l,m){return new A(this.buffer.subarray(l,m))}set(l,m){if(l instanceof A)this.buffer.set(l.buffer,m);else if(l instanceof Uint8Array)this.buffer.set(l,m);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),m);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return I(this.buffer,l)}writeUInt32BE(l,m){E(this.buffer,l,m)}readUInt32LE(l){return b(this.buffer,l)}writeUInt32LE(l,m){v(this.buffer,l,m)}readUInt8(l){return y(this.buffer,l)}writeUInt8(l,m){d(this.buffer,l,m)}}e.VSBuffer=A;function C(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0}e.readUInt16LE=C;function P(a,l,m){a[m+0]=l&255,l=l>>>8,a[m+1]=l&255}e.writeUInt16LE=P;function I(a,l){return a[l]*2**24+a[l+1]*2**16+a[l+2]*2**8+a[l+3]}e.readUInt32BE=I;function E(a,l,m){a[m+3]=l,l=l>>>8,a[m+2]=l,l=l>>>8,a[m+1]=l,l=l>>>8,a[m]=l}e.writeUInt32BE=E;function b(a,l){return a[l+0]<<0>>>0|a[l+1]<<8>>>0|a[l+2]<<16>>>0|a[l+3]<<24>>>0}e.readUInt32LE=b;function v(a,l,m){a[m+0]=l&255,l=l>>>8,a[m+1]=l&255,l=l>>>8,a[m+2]=l&255,l=l>>>8,a[m+3]=l&255}e.writeUInt32LE=v;function y(a,l){return a[l]}e.readUInt8=y;function d(a,l,m){a[m]=l}e.writeUInt8=d;function S(a){return R.consumeReadable(a,l=>A.concat(l))}e.readableToBuffer=S;function w(a){return R.toReadable(a)}e.bufferToReadable=w;function p(a){return R.consumeStream(a,l=>A.concat(l))}e.streamToBuffer=p;async function g(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await p(a.stream)])}e.bufferedStreamToBuffer=g;function u(a){return R.toStream(a,l=>A.concat(l))}e.bufferToStream=u;function f(a){return R.transform(a,{data:l=>typeof l=="string"?A.fromString(l):A.wrap(l)},l=>A.concat(l))}e.streamToBufferReadableStream=f;function h(a){return R.newWriteableStream(l=>A.concat(l),a)}e.newWriteableBufferStream=h;function s(a,l){return R.prefixedReadable(a,l,m=>A.concat(m))}e.prefixedBufferReadable=s;function r(a,l){return R.prefixedStream(a,l,m=>A.concat(m))}e.prefixedBufferStream=r;function t(a){let l=0,m=0,D=0;const U=new Uint8Array(Math.floor(a.length/4*3)),O=L=>{switch(m){case 3:U[D++]=l|L,m=0;break;case 2:U[D++]=l|L>>>2,l=L<<6,m=3;break;case 1:U[D++]=l|L>>>4,l=L<<4,m=2;break;default:l=L<<2,m=1}};for(let L=0;L<a.length;L++){const N=a.charCodeAt(L);if(N>=65&&N<=90)O(N-65);else if(N>=97&&N<=122)O(N-97+26);else if(N>=48&&N<=57)O(N-48+52);else if(N===43||N===45)O(62);else if(N===47||N===95)O(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[L]}`)}}const F=D;for(;m>0;)O(0);return A.wrap(U).slice(0,F)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function c({buffer:a},l=!0,m=!1){const D=m?o:i;let U="";const O=a.byteLength%3;let F=0;for(;F<a.byteLength-O;F+=3){const L=a[F+0],N=a[F+1],W=a[F+2];U+=D[L>>>2],U+=D[(L<<4|N>>>4)&63],U+=D[(N<<2|W>>>6)&63],U+=D[W&63]}if(O===1){const L=a[F+0];U+=D[L>>>2],U+=D[L<<4&63],l&&(U+="==")}else if(O===2){const L=a[F+0],N=a[F+1];U+=D[L>>>2],U+=D[(L<<4|N>>>4)&63],U+=D[N<<2&63],l&&(U+="=")}return U}e.encodeBase64=c}),define(ne[15],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function R(c){return typeof c=="string"}e.isString=R;function n(c){return Array.isArray(c)&&c.every(a=>R(a))}e.isStringArray=n;function k(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.isObject=k;function T(c){const a=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof a}e.isTypedArray=T;function A(c){return typeof c=="number"&&!isNaN(c)}e.isNumber=A;function C(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.isIterable=C;function P(c){return c===!0||c===!1}e.isBoolean=P;function I(c){return typeof c=="undefined"}e.isUndefined=I;function E(c){return!b(c)}e.isDefined=E;function b(c){return I(c)||c===null}e.isUndefinedOrNull=b;function v(c,a){if(!c)throw new Error(a?`Unexpected type, expected '${a}'`:"Unexpected type")}e.assertType=v;function y(c){if(b(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.assertIsDefined=y;function d(...c){const a=[];for(let l=0;l<c.length;l++){const m=c[l];if(b(m))throw new Error(`Assertion Failed: argument at index ${l} is undefined or null`);a.push(m)}return a}e.assertAllDefined=d;const S=Object.prototype.hasOwnProperty;function w(c){if(!k(c))return!1;for(const a in c)if(S.call(c,a))return!1;return!0}e.isEmptyObject=w;function p(c){return typeof c=="function"}e.isFunction=p;function g(...c){return c.length>0&&c.every(p)}e.areFunctions=g;function u(c,a){const l=Math.min(c.length,a.length);for(let m=0;m<l;m++)f(c[m],a[m])}e.validateConstraints=u;function f(c,a){if(R(a)){if(typeof c!==a)throw new Error(`argument does not match constraint: typeof ${a}`)}else if(p(a)){try{if(c instanceof a)return}catch{}if(!b(c)&&c.constructor===a||a.length===1&&a.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=f;function h(c){let a=[],l=Object.getPrototypeOf(c);for(;Object.prototype!==l;)a=a.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return a}e.getAllPropertyNames=h;function s(c){const a=[];for(const l of h(c))typeof c[l]=="function"&&a.push(l);return a}e.getAllMethodNames=s;function r(c,a){const l=D=>function(){const U=Array.prototype.slice.call(arguments,0);return a(D,U)},m={};for(const D of c)m[D]=l(D);return m}e.createProxyObject=r;function t(c){return c===null?void 0:c}e.withNullAsUndefined=t;function i(c){return typeof c=="undefined"?null:c}e.withUndefinedAsNull=i;function o(c,a="Unreachable"){throw new Error(a)}e.assertNever=o}),define(ne[30],re([0,1,15]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const S=Array.isArray(d)?[]:{};return Object.keys(d).forEach(w=>{d[w]&&typeof d[w]=="object"?S[w]=n(d[w]):S[w]=d[w]}),S}e.deepClone=n;function k(d){if(!d||typeof d!="object")return d;const S=[d];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const p in w)if(T.call(w,p)){const g=w[p];typeof g=="object"&&!Object.isFrozen(g)&&!(0,R.isTypedArray)(g)&&S.push(g)}}return d}e.deepFreeze=k;const T=Object.prototype.hasOwnProperty;function A(d,S){return C(d,S,new Set)}e.cloneAndChange=A;function C(d,S,w){if((0,R.isUndefinedOrNull)(d))return d;const p=S(d);if(typeof p!="undefined")return p;if(Array.isArray(d)){const g=[];for(const u of d)g.push(C(u,S,w));return g}if((0,R.isObject)(d)){if(w.has(d))throw new Error("Cannot clone recursive data-structure");w.add(d);const g={};for(const u in d)T.call(d,u)&&(g[u]=C(d[u],S,w));return w.delete(d),g}return d}function P(d,S,w=!0){return(0,R.isObject)(d)?((0,R.isObject)(S)&&Object.keys(S).forEach(p=>{p in d?w&&((0,R.isObject)(d[p])&&(0,R.isObject)(S[p])?P(d[p],S[p],w):d[p]=S[p]):d[p]=S[p]}),d):S}e.mixin=P;function I(d,S){if(d===S)return!0;if(d==null||S===null||S===void 0||typeof d!=typeof S||typeof d!="object"||Array.isArray(d)!==Array.isArray(S))return!1;let w,p;if(Array.isArray(d)){if(d.length!==S.length)return!1;for(w=0;w<d.length;w++)if(!I(d[w],S[w]))return!1}else{const g=[];for(p in d)g.push(p);g.sort();const u=[];for(p in S)u.push(p);if(u.sort(),!I(g,u))return!1;for(w=0;w<g.length;w++)if(!I(d[g[w]],S[g[w]]))return!1}return!0}e.equals=I;function E(d){const S=new Set;return JSON.stringify(d,(w,p)=>{if((0,R.isObject)(p)||Array.isArray(p)){if(S.has(p))return"[Circular]";S.add(p)}return p})}e.safeStringify=E;function b(d,S){const w=Object.create(null);return!d||!S||Object.keys(S).forEach(g=>{const u=d[g],f=S[g];I(u,f)||(w[g]=f)}),w}e.distinct=b;function v(d,S){const w=S.toLowerCase(),p=Object.keys(d).find(g=>g.toLowerCase()===w);return p?d[p]:d[S]}e.getCaseInsensitive=v;function y(d,S){const w=Object.create(null);for(const[p,g]of Object.entries(d))S(p,g)&&(w[p]=g);return w}e.filter=y}),define(ne[31],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const R=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(k){return R.test(k)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(C){for(let P=0;P<C.length;P++)C[P]=Math.floor(Math.random()*256);return C};const T=new Uint8Array(16),A=[];for(let C=0;C<256;C++)A.push(C.toString(16).padStart(2,"0"));return function(){k(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let P=0,I="";return I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+="-",I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I+=A[T[P++]],I}}()}),define(ne[114],re([0,1,269]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class n{constructor(T="utf8"){this.stringDecoder=new R.StringDecoder(T),this.remaining=null}write(T){const A=[],C=this.remaining?this.remaining+this.stringDecoder.write(T):this.stringDecoder.write(T);if(C.length<1)return A;let P=0,I,E=P;for(;E<C.length;)if(I=C.charCodeAt(E),I===13||I===10){if(A.push(C.substring(P,E)),E++,E<C.length){const b=I;I=C.charCodeAt(E),(b===13&&I===10||b===10&&I===13)&&E++}P=E}else E++;return this.remaining=P<C.length?C.substr(P):null,A}end(){return this.remaining}}e.LineDecoder=n}),define(ne[115],re([0,1,37]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const C=A.replace(/\-/g,":").toLowerCase();return!n.has(C)}function T(){const A=(0,R.networkInterfaces)();for(const C in A){const P=A[C];if(P){for(const{mac:I}of P)if(k(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=T}),define(ne[116],re([0,1,76]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(C,P,I,E=1){let b=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!b)return b=!0,v(0)},I);k(C,P,E,d=>{if(!b)return b=!0,clearTimeout(y),v(d)})})}e.findFreePort=n;function k(C,P,I,E){if(P===0)return E(0);const b=new R.Socket;b.once("connect",()=>(A(b),k(C+I,P-1,I,E))),b.once("data",()=>{}),b.once("error",v=>(A(b),v.code!=="ECONNREFUSED"?k(C+I,P-1,I,E):E(C))),b.connect(C,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function T(C,P,I){let E=!1,b,v=1;const y=R.createServer({pauseOnConnect:!0});function d(S,w){E||(E=!0,y.removeAllListeners(),y.close(),b&&clearTimeout(b),w(S))}return new Promise(S=>{b=setTimeout(()=>{d(0,S)},I),y.on("listening",()=>{d(C,S)}),y.on("error",w=>{w&&(w.code==="EADDRINUSE"||w.code==="EACCES")&&v<P?(C++,v++,y.listen(C,"127.0.0.1")):d(0,S)}),y.on("close",()=>{d(0,S)}),y.listen(C,"127.0.0.1")})}e.findFreePortFaster=T;function A(C){try{C.removeAllListeners("connect"),C.removeAllListeners("error"),C.end(),C.destroy(),C.unref()}catch(P){console.error(P)}}}),define(ne[117],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const R="Offline";function n(T){return T instanceof k?!0:T instanceof Error&&T.name===R&&T.message===R}e.isOfflineError=n;class k extends Error{constructor(){super(R);this.name=this.message}}e.OfflineError=k}),define(ne[118],re([0,1,16,9,117]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function T(P,I){if(!navigator.onLine)throw new k.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((b,v)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(E,P),E.responseType="arraybuffer",E.onerror=y=>v(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=y=>{b({res:{statusCode:E.status,headers:C(E)},stream:(0,R.bufferToStream)(R.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=y=>v(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),I.onCancellationRequested(()=>{E.abort(),v((0,n.canceled)())})})}e.request=T;function A(P,I){if(I.headers){e:for(const E in I.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,I.headers[E])}}}function C(P){const I=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const b=E.indexOf(":");I[E.substr(0,b).trim().toLowerCase()]=E.substr(b+1).trim()}return I}}),define(ne[119],re([10,11]),function(X,e){return X.create("vs/base/common/date",e)}),define(ne[61],re([0,1,119]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,k=n*60,T=k*24,A=T*7,C=T*30,P=T*365;function I(b,v,y){typeof b!="number"&&(b=b.getTime());const d=Math.round((new Date().getTime()-b)/1e3);if(d<-30)return(0,R.localize)(0,null,I(new Date().getTime()+d*1e3,!1));if(d<30)return(0,R.localize)(1,null);let S;return d<n?(S=d,v?S===1?y?(0,R.localize)(2,null,S):(0,R.localize)(3,null,S):y?(0,R.localize)(4,null,S):(0,R.localize)(5,null,S):S===1?y?(0,R.localize)(6,null,S):(0,R.localize)(7,null,S):y?(0,R.localize)(8,null,S):(0,R.localize)(9,null,S)):d<k?(S=Math.floor(d/n),v?S===1?y?(0,R.localize)(10,null,S):(0,R.localize)(11,null,S):y?(0,R.localize)(12,null,S):(0,R.localize)(13,null,S):S===1?y?(0,R.localize)(14,null,S):(0,R.localize)(15,null,S):y?(0,R.localize)(16,null,S):(0,R.localize)(17,null,S)):d<T?(S=Math.floor(d/k),v?S===1?y?(0,R.localize)(18,null,S):(0,R.localize)(19,null,S):y?(0,R.localize)(20,null,S):(0,R.localize)(21,null,S):S===1?y?(0,R.localize)(22,null,S):(0,R.localize)(23,null,S):y?(0,R.localize)(24,null,S):(0,R.localize)(25,null,S)):d<A?(S=Math.floor(d/T),v?S===1?(0,R.localize)(26,null,S):(0,R.localize)(27,null,S):S===1?(0,R.localize)(28,null,S):(0,R.localize)(29,null,S)):d<C?(S=Math.floor(d/A),v?S===1?y?(0,R.localize)(30,null,S):(0,R.localize)(31,null,S):y?(0,R.localize)(32,null,S):(0,R.localize)(33,null,S):S===1?y?(0,R.localize)(34,null,S):(0,R.localize)(35,null,S):y?(0,R.localize)(36,null,S):(0,R.localize)(37,null,S)):d<P?(S=Math.floor(d/C),v?S===1?y?(0,R.localize)(38,null,S):(0,R.localize)(39,null,S):y?(0,R.localize)(40,null,S):(0,R.localize)(41,null,S):S===1?y?(0,R.localize)(42,null,S):(0,R.localize)(43,null,S):y?(0,R.localize)(44,null,S):(0,R.localize)(45,null,S)):(S=Math.floor(d/P),v?S===1?y?(0,R.localize)(46,null,S):(0,R.localize)(47,null,S):y?(0,R.localize)(48,null,S):(0,R.localize)(49,null,S):S===1?y?(0,R.localize)(50,null,S):(0,R.localize)(51,null,S):y?(0,R.localize)(52,null,S):(0,R.localize)(53,null,S))}e.fromNow=I;function E(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(ne[120],re([10,11]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(ne[38],re([0,1,18,15,120]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function T(b,v){return v&&(b.stack||b.stacktrace)?k.localize(0,null,C(b),A(b.stack)||A(b.stacktrace)):C(b)}function A(b){return Array.isArray(b)?b.join(`
`):b}function C(b){return typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?k.localize(1,null,b.message):b.message||k.localize(2,null)}function P(b=null,v=!1){if(!b)return k.localize(3,null);if(Array.isArray(b)){const y=R.coalesce(b),d=P(y[0],v);return y.length>1?k.localize(4,null,d,y.length):d}if(n.isString(b))return b;if(b.detail){const y=b.detail;if(y.error)return T(y.error,v);if(y.exception)return T(y.exception,v)}return b.stack?T(b,v):b.message?b.message:k.localize(5,null)}e.toErrorMessage=P;function I(b){const v=b;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=I;function E(b,v){let y;return typeof b=="string"?y=new Error(b):y=b,y.actions=v,y}e.createErrorWithActions=E}),define(ne[121],re([10,11]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(ne[122],re([0,1,121]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(k){switch(k){case 1:return(0,R.localize)(0,null);case 2:return(0,R.localize)(1,null);case 3:return(0,R.localize)(2,null);case 4:return(0,R.localize)(3,null);case 5:return(0,R.localize)(4,null);case 6:return(0,R.localize)(5,null);case 7:return(0,R.localize)(6,null);case 8:return(0,R.localize)(7,null);case 9:return(0,R.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(ne[123],re([10,11]),function(X,e){return X.create("vs/base/common/platform",e)}),define(ne[4],re([0,1,123]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let k=!1,T=!1,A=!1,C=!1,P=!1,I=!1,E=!1,b=!1,v=!1,y,d=n,S,w;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let p;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?p=e.globals.vscode.process:typeof process!="undefined"&&(p=process);const g=typeof p?.versions?.electron=="string",u=g&&p?.type==="renderer";if(typeof navigator=="object"&&!u)w=navigator.userAgent,k=w.indexOf("Windows")>=0,T=w.indexOf("Macintosh")>=0,b=(w.indexOf("Macintosh")>=0||w.indexOf("iPad")>=0||w.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=w.indexOf("Linux")>=0,I=!0,y=R.getConfiguredDefaultLocale(R.localize(0,null))||n,d=y;else if(typeof p=="object"){k=p.platform==="win32",T=p.platform==="darwin",A=p.platform==="linux",C=A&&!!p.env.SNAP&&!!p.env.SNAP_REVISION,E=g,v=!!p.env.CI||!!p.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=n,d=n;const a=p.env.VSCODE_NLS_CONFIG;if(a)try{const l=JSON.parse(a),m=l.availableLanguages["*"];y=l.locale,d=m||n,S=l._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var f;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function h(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=h;let s=0;T?s=1:k?s=3:A&&(s=2),e.isWindows=k,e.isMacintosh=T,e.isLinux=A,e.isLinuxSnap=C,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isCI=v,e.platform=s,e.userAgent=w,e.language=d;var r;(function(a){function l(){return e.language}a.value=l;function m(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=m;function D(){return e.language==="en"}a.isDefault=D})(r=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",m=>{if(m.data&&m.data.vscodeScheduleAsyncWork)for(let D=0,U=a.length;D<U;D++){const O=a[D];if(O.id===m.data.vscodeScheduleAsyncWork){a.splice(D,1),O.callback();return}}});let l=0;return m=>{const D=++l;a.push({id:D,callback:m}),e.globals.postMessage({vscodeScheduleAsyncWork:D},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=T||b?2:k?1:3;let i=!0,o=!1;function c(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ne[36],re([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof R.globals.vscode!="undefined"&&typeof R.globals.vscode.process!="undefined"){const k=R.globals.vscode.process;n={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return R.isWindows?"win32":R.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(ne[12],re([0,1,36]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,k=97,T=90,A=122,C=46,P=47,I=92,E=58,b=63;class v extends Error{constructor(f,h,s){let r;typeof h=="string"&&h.indexOf("not ")===0?(r="must not be",h=h.replace(/^not /,"")):r="must be";const t=f.indexOf(".")!==-1?"property":"argument";let i=`The "${f}" ${t} ${r} of type ${h}`;i+=`. Received type ${typeof s}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function y(u,f){if(typeof u!="string")throw new v(f,"string",u)}function d(u){return u===P||u===I}function S(u){return u===P}function w(u){return u>=n&&u<=T||u>=k&&u<=A}function p(u,f,h,s){let r="",t=0,i=-1,o=0,c=0;for(let a=0;a<=u.length;++a){if(a<u.length)c=u.charCodeAt(a);else{if(s(c))break;c=P}if(s(c)){if(!(i===a-1||o===1))if(o===2){if(r.length<2||t!==2||r.charCodeAt(r.length-1)!==C||r.charCodeAt(r.length-2)!==C){if(r.length>2){const l=r.lastIndexOf(h);l===-1?(r="",t=0):(r=r.slice(0,l),t=r.length-1-r.lastIndexOf(h)),i=a,o=0;continue}else if(r.length!==0){r="",t=0,i=a,o=0;continue}}f&&(r+=r.length>0?`${h}..`:"..",t=2)}else r.length>0?r+=`${h}${u.slice(i+1,a)}`:r=u.slice(i+1,a),t=a-i-1;i=a,o=0}else c===C&&o!==-1?++o:o=-1}return r}function g(u,f){if(f===null||typeof f!="object")throw new v("pathObject","Object",f);const h=f.dir||f.root,s=f.base||`${f.name||""}${f.ext||""}`;return h?h===f.root?`${h}${s}`:`${h}${u}${s}`:s}e.win32={resolve(...u){let f="",h="",s=!1;for(let r=u.length-1;r>=-1;r--){let t;if(r>=0){if(t=u[r],y(t,"path"),t.length===0)continue}else f.length===0?t=R.cwd():(t=R.env[`=${f}`]||R.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==f.toLowerCase()&&t.charCodeAt(2)===I)&&(t=`${f}\\`));const i=t.length;let o=0,c="",a=!1;const l=t.charCodeAt(0);if(i===1)d(l)&&(o=1,a=!0);else if(d(l))if(a=!0,d(t.charCodeAt(1))){let m=2,D=m;for(;m<i&&!d(t.charCodeAt(m));)m++;if(m<i&&m!==D){const U=t.slice(D,m);for(D=m;m<i&&d(t.charCodeAt(m));)m++;if(m<i&&m!==D){for(D=m;m<i&&!d(t.charCodeAt(m));)m++;(m===i||m!==D)&&(c=`\\\\${U}\\${t.slice(D,m)}`,o=m)}}}else o=1;else w(l)&&t.charCodeAt(1)===E&&(c=t.slice(0,2),o=2,i>2&&d(t.charCodeAt(2))&&(a=!0,o=3));if(c.length>0)if(f.length>0){if(c.toLowerCase()!==f.toLowerCase())continue}else f=c;if(s){if(f.length>0)break}else if(h=`${t.slice(o)}\\${h}`,s=a,a&&f.length>0)break}return h=p(h,!s,"\\",d),s?`${f}\\${h}`:`${f}${h}`||"."},normalize(u){y(u,"path");const f=u.length;if(f===0)return".";let h=0,s,r=!1;const t=u.charCodeAt(0);if(f===1)return S(t)?"\\":u;if(d(t))if(r=!0,d(u.charCodeAt(1))){let o=2,c=o;for(;o<f&&!d(u.charCodeAt(o));)o++;if(o<f&&o!==c){const a=u.slice(c,o);for(c=o;o<f&&d(u.charCodeAt(o));)o++;if(o<f&&o!==c){for(c=o;o<f&&!d(u.charCodeAt(o));)o++;if(o===f)return`\\\\${a}\\${u.slice(c)}\\`;o!==c&&(s=`\\\\${a}\\${u.slice(c,o)}`,h=o)}}}else h=1;else w(t)&&u.charCodeAt(1)===E&&(s=u.slice(0,2),h=2,f>2&&d(u.charCodeAt(2))&&(r=!0,h=3));let i=h<f?p(u.slice(h),!r,"\\",d):"";return i.length===0&&!r&&(i="."),i.length>0&&d(u.charCodeAt(f-1))&&(i+="\\"),s===void 0?r?`\\${i}`:i:r?`${s}\\${i}`:`${s}${i}`},isAbsolute(u){y(u,"path");const f=u.length;if(f===0)return!1;const h=u.charCodeAt(0);return d(h)||f>2&&w(h)&&u.charCodeAt(1)===E&&d(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let f,h;for(let t=0;t<u.length;++t){const i=u[t];y(i,"path"),i.length>0&&(f===void 0?f=h=i:f+=`\\${i}`)}if(f===void 0)return".";let s=!0,r=0;if(typeof h=="string"&&d(h.charCodeAt(0))){++r;const t=h.length;t>1&&d(h.charCodeAt(1))&&(++r,t>2&&(d(h.charCodeAt(2))?++r:s=!1))}if(s){for(;r<f.length&&d(f.charCodeAt(r));)r++;r>=2&&(f=`\\${f.slice(r)}`)}return e.win32.normalize(f)},relative(u,f){if(y(u,"from"),y(f,"to"),u===f)return"";const h=e.win32.resolve(u),s=e.win32.resolve(f);if(h===s||(u=h.toLowerCase(),f=s.toLowerCase(),u===f))return"";let r=0;for(;r<u.length&&u.charCodeAt(r)===I;)r++;let t=u.length;for(;t-1>r&&u.charCodeAt(t-1)===I;)t--;const i=t-r;let o=0;for(;o<f.length&&f.charCodeAt(o)===I;)o++;let c=f.length;for(;c-1>o&&f.charCodeAt(c-1)===I;)c--;const a=c-o,l=i<a?i:a;let m=-1,D=0;for(;D<l;D++){const O=u.charCodeAt(r+D);if(O!==f.charCodeAt(o+D))break;O===I&&(m=D)}if(D!==l){if(m===-1)return s}else{if(a>l){if(f.charCodeAt(o+D)===I)return s.slice(o+D+1);if(D===2)return s.slice(o+D)}i>l&&(u.charCodeAt(r+D)===I?m=D:D===2&&(m=3)),m===-1&&(m=0)}let U="";for(D=r+m+1;D<=t;++D)(D===t||u.charCodeAt(D)===I)&&(U+=U.length===0?"..":"\\..");return o+=m,U.length>0?`${U}${s.slice(o,c)}`:(s.charCodeAt(o)===I&&++o,s.slice(o,c))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const f=e.win32.resolve(u);if(f.length<=2)return u;if(f.charCodeAt(0)===I){if(f.charCodeAt(1)===I){const h=f.charCodeAt(2);if(h!==b&&h!==C)return`\\\\?\\UNC\\${f.slice(2)}`}}else if(w(f.charCodeAt(0))&&f.charCodeAt(1)===E&&f.charCodeAt(2)===I)return`\\\\?\\${f}`;return u},dirname(u){y(u,"path");const f=u.length;if(f===0)return".";let h=-1,s=0;const r=u.charCodeAt(0);if(f===1)return d(r)?u:".";if(d(r)){if(h=s=1,d(u.charCodeAt(1))){let o=2,c=o;for(;o<f&&!d(u.charCodeAt(o));)o++;if(o<f&&o!==c){for(c=o;o<f&&d(u.charCodeAt(o));)o++;if(o<f&&o!==c){for(c=o;o<f&&!d(u.charCodeAt(o));)o++;if(o===f)return u;o!==c&&(h=s=o+1)}}}}else w(r)&&u.charCodeAt(1)===E&&(h=f>2&&d(u.charCodeAt(2))?3:2,s=h);let t=-1,i=!0;for(let o=f-1;o>=s;--o)if(d(u.charCodeAt(o))){if(!i){t=o;break}}else i=!1;if(t===-1){if(h===-1)return".";t=h}return u.slice(0,t)},basename(u,f){f!==void 0&&y(f,"ext"),y(u,"path");let h=0,s=-1,r=!0,t;if(u.length>=2&&w(u.charCodeAt(0))&&u.charCodeAt(1)===E&&(h=2),f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let i=f.length-1,o=-1;for(t=u.length-1;t>=h;--t){const c=u.charCodeAt(t);if(d(c)){if(!r){h=t+1;break}}else o===-1&&(r=!1,o=t+1),i>=0&&(c===f.charCodeAt(i)?--i==-1&&(s=t):(i=-1,s=o))}return h===s?s=o:s===-1&&(s=u.length),u.slice(h,s)}for(t=u.length-1;t>=h;--t)if(d(u.charCodeAt(t))){if(!r){h=t+1;break}}else s===-1&&(r=!1,s=t+1);return s===-1?"":u.slice(h,s)},extname(u){y(u,"path");let f=0,h=-1,s=0,r=-1,t=!0,i=0;u.length>=2&&u.charCodeAt(1)===E&&w(u.charCodeAt(0))&&(f=s=2);for(let o=u.length-1;o>=f;--o){const c=u.charCodeAt(o);if(d(c)){if(!t){s=o+1;break}continue}r===-1&&(t=!1,r=o+1),c===C?h===-1?h=o:i!==1&&(i=1):h!==-1&&(i=-1)}return h===-1||r===-1||i===0||i===1&&h===r-1&&h===s+1?"":u.slice(h,r)},format:g.bind(null,"\\"),parse(u){y(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const h=u.length;let s=0,r=u.charCodeAt(0);if(h===1)return d(r)?(f.root=f.dir=u,f):(f.base=f.name=u,f);if(d(r)){if(s=1,d(u.charCodeAt(1))){let m=2,D=m;for(;m<h&&!d(u.charCodeAt(m));)m++;if(m<h&&m!==D){for(D=m;m<h&&d(u.charCodeAt(m));)m++;if(m<h&&m!==D){for(D=m;m<h&&!d(u.charCodeAt(m));)m++;m===h?s=m:m!==D&&(s=m+1)}}}}else if(w(r)&&u.charCodeAt(1)===E){if(h<=2)return f.root=f.dir=u,f;if(s=2,d(u.charCodeAt(2))){if(h===3)return f.root=f.dir=u,f;s=3}}s>0&&(f.root=u.slice(0,s));let t=-1,i=s,o=-1,c=!0,a=u.length-1,l=0;for(;a>=s;--a){if(r=u.charCodeAt(a),d(r)){if(!c){i=a+1;break}continue}o===-1&&(c=!1,o=a+1),r===C?t===-1?t=a:l!==1&&(l=1):t!==-1&&(l=-1)}return o!==-1&&(t===-1||l===0||l===1&&t===o-1&&t===i+1?f.base=f.name=u.slice(i,o):(f.name=u.slice(i,t),f.base=u.slice(i,o),f.ext=u.slice(t,o))),i>0&&i!==s?f.dir=u.slice(0,i-1):f.dir=f.root,f},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let f="",h=!1;for(let s=u.length-1;s>=-1&&!h;s--){const r=s>=0?u[s]:R.cwd();y(r,"path"),r.length!==0&&(f=`${r}/${f}`,h=r.charCodeAt(0)===P)}return f=p(f,!h,"/",S),h?`/${f}`:f.length>0?f:"."},normalize(u){if(y(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===P,h=u.charCodeAt(u.length-1)===P;return u=p(u,!f,"/",S),u.length===0?f?"/":h?"./":".":(h&&(u+="/"),f?`/${u}`:u)},isAbsolute(u){return y(u,"path"),u.length>0&&u.charCodeAt(0)===P},join(...u){if(u.length===0)return".";let f;for(let h=0;h<u.length;++h){const s=u[h];y(s,"path"),s.length>0&&(f===void 0?f=s:f+=`/${s}`)}return f===void 0?".":e.posix.normalize(f)},relative(u,f){if(y(u,"from"),y(f,"to"),u===f||(u=e.posix.resolve(u),f=e.posix.resolve(f),u===f))return"";const h=1,s=u.length,r=s-h,t=1,i=f.length-t,o=r<i?r:i;let c=-1,a=0;for(;a<o;a++){const m=u.charCodeAt(h+a);if(m!==f.charCodeAt(t+a))break;m===P&&(c=a)}if(a===o)if(i>o){if(f.charCodeAt(t+a)===P)return f.slice(t+a+1);if(a===0)return f.slice(t+a)}else r>o&&(u.charCodeAt(h+a)===P?c=a:a===0&&(c=0));let l="";for(a=h+c+1;a<=s;++a)(a===s||u.charCodeAt(a)===P)&&(l+=l.length===0?"..":"/..");return`${l}${f.slice(t+c)}`},toNamespacedPath(u){return u},dirname(u){if(y(u,"path"),u.length===0)return".";const f=u.charCodeAt(0)===P;let h=-1,s=!0;for(let r=u.length-1;r>=1;--r)if(u.charCodeAt(r)===P){if(!s){h=r;break}}else s=!1;return h===-1?f?"/":".":f&&h===1?"//":u.slice(0,h)},basename(u,f){f!==void 0&&y(f,"ext"),y(u,"path");let h=0,s=-1,r=!0,t;if(f!==void 0&&f.length>0&&f.length<=u.length){if(f===u)return"";let i=f.length-1,o=-1;for(t=u.length-1;t>=0;--t){const c=u.charCodeAt(t);if(c===P){if(!r){h=t+1;break}}else o===-1&&(r=!1,o=t+1),i>=0&&(c===f.charCodeAt(i)?--i==-1&&(s=t):(i=-1,s=o))}return h===s?s=o:s===-1&&(s=u.length),u.slice(h,s)}for(t=u.length-1;t>=0;--t)if(u.charCodeAt(t)===P){if(!r){h=t+1;break}}else s===-1&&(r=!1,s=t+1);return s===-1?"":u.slice(h,s)},extname(u){y(u,"path");let f=-1,h=0,s=-1,r=!0,t=0;for(let i=u.length-1;i>=0;--i){const o=u.charCodeAt(i);if(o===P){if(!r){h=i+1;break}continue}s===-1&&(r=!1,s=i+1),o===C?f===-1?f=i:t!==1&&(t=1):f!==-1&&(t=-1)}return f===-1||s===-1||t===0||t===1&&f===s-1&&f===h+1?"":u.slice(f,s)},format:g.bind(null,"/"),parse(u){y(u,"path");const f={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return f;const h=u.charCodeAt(0)===P;let s;h?(f.root="/",s=1):s=0;let r=-1,t=0,i=-1,o=!0,c=u.length-1,a=0;for(;c>=s;--c){const l=u.charCodeAt(c);if(l===P){if(!o){t=c+1;break}continue}i===-1&&(o=!1,i=c+1),l===C?r===-1?r=c:a!==1&&(a=1):r!==-1&&(a=-1)}if(i!==-1){const l=t===0&&h?1:t;r===-1||a===0||a===1&&r===i-1&&r===t+1?f.base=f.name=u.slice(l,i):(f.name=u.slice(l,r),f.base=u.slice(l,i),f.ext=u.slice(r,i))}return t>0?f.dir=u.slice(0,t-1):h&&(f.dir="/"),f},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=R.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=R.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=R.platform==="win32"?e.win32.join:e.posix.join,e.resolve=R.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=R.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=R.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=R.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=R.platform==="win32"?e.win32.extname:e.posix.extname,e.format=R.platform==="win32"?e.win32.format:e.posix.format,e.parse=R.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=R.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=R.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=R.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(ne[124],re([0,1,12]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(E){const b=(0,R.extname)(E),v=n[b.toLowerCase()];return v!==void 0?v:A(E)}e.getMediaOrTextMime=T;function A(E){const b=(0,R.extname)(E);return k[b.toLowerCase()]}e.getMediaMime=A;function C(E){for(const b in k)if(k[b]===E)return b}e.getExtensionForMimeType=C;const P=/^(.+)\/(.+?)(;.+)?$/;function I(E,b){const v=P.exec(E);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:b?void 0:E}e.normalizeMimeType=I}),define(ne[77],re([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(C){C[C.stdout=0]="stdout",C[C.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var k;(function(C){C[C.Success=0]="Success",C[C.Unknown=1]="Unknown",C[C.AccessDenied=2]="AccessDenied",C[C.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function T(C,...P){const I=P.reduce((v,y)=>(v[y]=!0,v),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(C).filter(v=>!I[v]).forEach(v=>{for(let y=0;y<E.length;y++)if(v.search(E[y])!==-1){delete C[v];break}})}e.sanitizeProcessEnvironment=T;function A(C){!C||(delete C.DEBUG,R.isMacintosh&&delete C.DYLD_LIBRARY_PATH,R.isLinux&&delete C.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(ne[125],re([0,1,4]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=R.globals.performance&&typeof R.globals.performance.now=="function";class k{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?R.globals.performance.now():Date.now()}}e.StopWatch=k}),define(ne[3],re([0,1,9,74,2,112,125]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const C=!1,P=!1;var I;(function(c){c.None=()=>k.Disposable.None;function a(M){if(P){const{onListenerDidAdd:q}=M,j=d.create();let Z=0;M.onListenerDidAdd=()=>{++Z==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),q?.()}}}function l(M){return(q,j=null,Z)=>{let G=!1,te;return te=M(se=>{if(!G)return te?te.dispose():G=!0,q.call(j,se)},null,Z),G&&te.dispose(),te}}c.once=l;function m(M,q,j){return N((Z,G=null,te)=>M(se=>Z.call(G,q(se)),null,te),j)}c.map=m;function D(M,q,j){return N((Z,G=null,te)=>M(se=>{q(se),Z.call(G,se)},null,te),j)}c.forEach=D;function U(M,q,j){return N((Z,G=null,te)=>M(se=>q(se)&&Z.call(G,se),null,te),j)}c.filter=U;function O(M){return M}c.signal=O;function F(...M){return(q,j=null,Z)=>(0,k.combinedDisposable)(...M.map(G=>G(te=>q.call(j,te),null,Z)))}c.any=F;function L(M,q,j,Z){let G=j;return m(M,te=>(G=q(G,te),G),Z)}c.reduce=L;function N(M,q){let j;const Z={onFirstListenerAdd(){j=M(G.fire,G)},onLastListenerRemove(){j?.dispose()}};q||a(Z);const G=new w(Z);return q?.add(G),G.event}function W(M,q,j=100,Z=!1,G,te){let se,ce,he,ve=0;const pe={leakWarningThreshold:G,onFirstListenerAdd(){se=M(be=>{ve++,ce=q(ce,be),Z&&!he&&(Ce.fire(ce),ce=void 0),clearTimeout(he),he=setTimeout(()=>{const Pe=ce;ce=void 0,he=void 0,(!Z||ve>1)&&Ce.fire(Pe),ve=0},j)})},onLastListenerRemove(){se.dispose()}};te||a(pe);const Ce=new w(pe);return te?.add(Ce),Ce.event}c.debounce=W;function V(M,q=(Z,G)=>Z===G,j){let Z=!0,G;return U(M,te=>{const se=Z||!q(te,G);return Z=!1,G=te,se},j)}c.latch=V;function J(M,q,j){return[c.filter(M,q,j),c.filter(M,Z=>!q(Z),j)]}c.split=J;function $(M,q=!1,j=[]){let Z=j.slice(),G=M(ce=>{Z?Z.push(ce):se.fire(ce)});const te=()=>{Z?.forEach(ce=>se.fire(ce)),Z=null},se=new w({onFirstListenerAdd(){G||(G=M(ce=>se.fire(ce)))},onFirstListenerDidAdd(){Z&&(q?setTimeout(te):te())},onLastListenerRemove(){G&&G.dispose(),G=null}});return se.event}c.buffer=$;class Q{constructor(q){this.event=q,this.disposables=new k.DisposableStore}map(q){return new Q(m(this.event,q,this.disposables))}forEach(q){return new Q(D(this.event,q,this.disposables))}filter(q){return new Q(U(this.event,q,this.disposables))}reduce(q,j){return new Q(L(this.event,q,j,this.disposables))}latch(){return new Q(V(this.event,void 0,this.disposables))}debounce(q,j=100,Z=!1,G){return new Q(W(this.event,q,j,Z,G,this.disposables))}on(q,j,Z){return this.event(q,j,Z)}once(q,j,Z){return l(this.event)(q,j,Z)}dispose(){this.disposables.dispose()}}function H(M){return new Q(M)}c.chain=H;function B(M,q,j=Z=>Z){const Z=(...ce)=>se.fire(j(...ce)),G=()=>M.on(q,Z),te=()=>M.removeListener(q,Z),se=new w({onFirstListenerAdd:G,onLastListenerRemove:te});return se.event}c.fromNodeEventEmitter=B;function Y(M,q,j=Z=>Z){const Z=(...ce)=>se.fire(j(...ce)),G=()=>M.addEventListener(q,Z),te=()=>M.removeEventListener(q,Z),se=new w({onFirstListenerAdd:G,onLastListenerRemove:te});return se.event}c.fromDOMEventEmitter=Y;function ie(M){return new Promise(q=>l(M)(q))}c.toPromise=ie;function ae(M,q){return q(void 0),M(j=>q(j))}c.runAndSubscribe=ae;function z(M,q){let j=null;function Z(te){j?.dispose(),j=new k.DisposableStore,q(te,j)}Z(void 0);const G=M(te=>Z(te));return(0,k.toDisposable)(()=>{G.dispose(),j?.dispose()})}c.runAndSubscribeWithStore=z;class x{constructor(q,j){this.obs=q,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{q.addObserver(this)},onLastListenerRemove:()=>{q.removeObserver(this)}};j||a(Z),this.emitter=new w(Z),j&&j.add(this.emitter)}beginUpdate(q){this._counter++}handleChange(q,j){this._hasChanged=!0}endUpdate(q){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function _(M,q){return new x(M,q).emitter.event}c.fromObservable=_})(I=e.Event||(e.Event={}));class E{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${E._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let b=-1;function v(c){const a=b;return b=c,{dispose(){b=a}}}e.setGlobalLeakWarningThreshold=v;class y{constructor(a,l=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=l,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,l){let m=b;if(typeof this.customThreshold=="number"&&(m=this.customThreshold),m<=0||l<m)return;this._stacks||(this._stacks=new Map);const D=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,D+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=m*.5;let U,O=0;for(const[F,L]of this._stacks)(!U||O<L)&&(U=F,O=L);console.warn(`[${this.name}] potential listener LEAK detected, having ${l} listeners already. MOST frequent listener (${O}):`),console.warn(U)}return()=>{const U=this._stacks.get(a.value)||0;this._stacks.set(a.value,U-1)}}}class d{constructor(a){this.value=a}static create(){return new d(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(a,l,m){this.callback=a,this.callbackThis=l,this.stack=m,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class w{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=b>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(C){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const l of a)l.subscription.isset()&&(l.subscription.unset(),l.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,l,m)=>{this._listeners||(this._listeners=new T.LinkedList);const D=this._listeners.isEmpty();D&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let U,O;this._leakageMon&&this._listeners.size>=30&&(O=d.create(),U=this._leakageMon.check(O,this._listeners.size+1)),C&&(O=O??d.create());const F=new S(a,l,O),L=this._listeners.push(F);D&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,l);const N=F.subscription.set(()=>{U?.(),this._disposed||(L(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return m instanceof k.DisposableStore?m.add(N):Array.isArray(m)&&m.push(N),N}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const l of this._listeners)this._deliveryQueue.push(this,l,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=w;class p{constructor(){this._queue=new T.LinkedList}get size(){return this._queue.size}push(a,l,m){this._queue.push(new u(a,l,m))}clear(a){const l=new T.LinkedList;for(const m of this._queue)m.emitter!==a&&l.push(m);this._queue=l}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(l){(0,R.onUnexpectedError)(l)}}}}e.EventDeliveryQueue=p;class g extends p{clear(a){this._queue.clear()}}class u{constructor(a,l,m){this.emitter=a,this.listener=l,this.event=m}}class f extends w{async fireAsync(a,l,m){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new T.LinkedList);for(const D of this._listeners)this._asyncDeliveryQueue.push([D,a]);for(;this._asyncDeliveryQueue.size>0&&!l.isCancellationRequested;){const[D,U]=this._asyncDeliveryQueue.shift(),O=[],F={...U,token:l,waitUntil:L=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");m&&(L=m(L,D.callback)),O.push(L)}};try{D.invoke(F)}catch(L){(0,R.onUnexpectedError)(L);continue}Object.freeze(O),await Promise.allSettled(O).then(L=>{for(const N of L)N.status==="rejected"&&(0,R.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=f;class h extends w{constructor(a){super(a);this._isPaused=0,this._eventQueue=new T.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=h;class s extends h{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=s;class r extends w{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(l=>super.fire(l)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new w({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const l={event:a,listener:null};this.events.push(l),this.hasListeners&&this.hook(l);const m=()=>{this.hasListeners&&this.unhook(l);const D=this.events.indexOf(l);this.events.splice(D,1)};return(0,k.toDisposable)((0,n.once)(m))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(l=>this.emitter.fire(l))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(a){return(l,m,D)=>a(U=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>l.call(m,U)):l.call(m,U)},void 0,D)}bufferEvents(a){const l=[];this.buffers.push(l);const m=a();return this.buffers.pop(),l.forEach(D=>D()),m}}e.EventBufferer=i;class o{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new w({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(ne[21],re([0,1,3]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(C,P){const I=setTimeout(C.bind(P),0);return{dispose(){clearTimeout(I)}}});var k;(function(C){function P(I){return I===C.None||I===C.Cancelled||I instanceof T?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}C.isCancellationToken=P,C.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:R.Event.None}),C.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k=e.CancellationToken||(e.CancellationToken={}));class T{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new R.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new T),this._token}cancel(){this._token?this._token instanceof T&&this._token.cancel():this._token=k.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof T&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(ne[126],re([0,1,21]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(C){this.task=C,this.result=null}get(){if(this.result)return this.result;const C=new R.CancellationTokenSource,P=this.task(C.token);return this.result={promise:P,dispose:()=>{this.result=null,C.cancel(),C.dispose()}},this.result}}e.Cache=n;class k{constructor(C){this.fn=C,this.lastCache=void 0,this.lastArgKey=void 0}get(C){const P=JSON.stringify(C);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(C)),this.lastCache}}e.LRUCachedFunction=k;class T{constructor(C){this.fn=C,this._map=new Map}get cachedValues(){return this._map}get(C){if(this._map.has(C))return this._map.get(C);const P=this.fn(C);return this._map.set(C,P),P}}e.CachedFunction=T}),define(ne[78],re([0,1,3,2]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:R.Event.None,value:A});e.staticObservableValue=k;class T extends n.Disposable{constructor(C){super();this._value=C,this.changeEmitter=this._register(new R.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(C){C!==this._value&&(this._value=C,this.changeEmitter.fire(C))}}e.MutableObservableValue=T}),define(ne[26],re([0,1,126,111]),function(X,e,R,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function T(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=T;const A=/{(\d+)}/g;function C(ee,...le){return le.length===0?ee:ee.replace(A,function(fe,Se){const me=parseInt(Se,10);return isNaN(me)||me<0||me>=le.length?fe:le[me]})}e.format=C;const P=/{([^}]+)}/g;function I(ee,le){return ee.replace(P,(fe,Se)=>le[Se]??fe)}e.format2=I;function E(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=E;function b(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function v(ee,le){let fe=0;const Se=le.charCodeAt(0);for(let me=ee.length-1;me>=0;me--)ee.charCodeAt(me)===Se&&fe++;return fe}e.count=v;function y(ee,le,fe="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${fe}`}e.truncate=y;function d(ee,le=" "){const fe=S(ee,le);return w(fe,le)}e.trim=d;function S(ee,le){if(!ee||!le)return ee;const fe=le.length;if(fe===0||ee.length===0)return ee;let Se=0;for(;ee.indexOf(le,Se)===Se;)Se=Se+fe;return ee.substring(Se)}e.ltrim=S;function w(ee,le){if(!ee||!le)return ee;const fe=le.length,Se=ee.length;if(fe===0||Se===0)return ee;let me=Se,we=-1;for(;we=ee.lastIndexOf(le,me-1),!(we===-1||we+fe!==me);){if(we===0)return"";me=we}return ee.substring(0,me)}e.rtrim=w;function p(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=p;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function u(ee,le,fe={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=b(ee)),fe.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let Se="";return fe.global&&(Se+="g"),fe.matchCase||(Se+="i"),fe.multiline&&(Se+="m"),fe.unicode&&(Se+="u"),new RegExp(ee,Se)}e.createRegExp=u;function f(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=f;function h(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=h;function s(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=s;function r(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ee){for(let le=0,fe=ee.length;le<fe;le++){const Se=ee.charCodeAt(le);if(Se!==32&&Se!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function i(ee,le=0,fe=ee.length){for(let Se=le;Se<fe;Se++){const me=ee.charCodeAt(Se);if(me!==32&&me!==9)return ee.substring(le,Se)}return ee.substring(le,fe)}e.getLeadingWhitespace=i;function o(ee,le=ee.length-1){for(let fe=le;fe>=0;fe--){const Se=ee.charCodeAt(fe);if(Se!==32&&Se!==9)return fe}return-1}e.lastNonWhitespaceIndex=o;function c(ee,le,fe){const Se=[];let me=0;for(const we of ee.matchAll(le)){if(Se.push(ee.slice(me,we.index)),we.index===void 0)throw new Error("match.index should be defined");me=we.index+we[0].length,Se.push(fe(we[0],...we.slice(1),we.index,ee,we.groups))}return Se.push(ee.slice(me)),Promise.all(Se).then(we=>we.join(""))}e.replaceAsync=c;function a(ee,le){return ee<le?-1:ee>le?1:0}e.compare=a;function l(ee,le,fe=0,Se=ee.length,me=0,we=le.length){for(;fe<Se&&me<we;fe++,me++){const Le=ee.charCodeAt(fe),_e=le.charCodeAt(me);if(Le<_e)return-1;if(Le>_e)return 1}const De=Se-fe,ke=we-me;return De<ke?-1:De>ke?1:0}e.compareSubstring=l;function m(ee,le){return D(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=m;function D(ee,le,fe=0,Se=ee.length,me=0,we=le.length){for(;fe<Se&&me<we;fe++,me++){let Le=ee.charCodeAt(fe),_e=le.charCodeAt(me);if(Le===_e)continue;if(Le>=128||_e>=128)return l(ee.toLowerCase(),le.toLowerCase(),fe,Se,me,we);O(Le)&&(Le-=32),O(_e)&&(_e-=32);const Fe=Le-_e;if(Fe!==0)return Fe}const De=Se-fe,ke=we-me;return De<ke?-1:De>ke?1:0}e.compareSubstringIgnoreCase=D;function U(ee){return ee>=48&&ee<=57}e.isAsciiDigit=U;function O(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=O;function F(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=F;function L(ee,le){return ee.length===le.length&&D(ee,le)===0}e.equalsIgnoreCase=L;function N(ee,le){const fe=le.length;return le.length>ee.length?!1:D(ee,le,0,fe)===0}e.startsWithIgnoreCase=N;function W(ee,le){const fe=Math.min(ee.length,le.length);let Se;for(Se=0;Se<fe;Se++)if(ee.charCodeAt(Se)!==le.charCodeAt(Se))return Se;return fe}e.commonPrefixLength=W;function V(ee,le){const fe=Math.min(ee.length,le.length);let Se;const me=ee.length-1,we=le.length-1;for(Se=0;Se<fe;Se++)if(ee.charCodeAt(me-Se)!==le.charCodeAt(we-Se))return Se;return fe}e.commonSuffixLength=V;function J(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=J;function $(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=$;function Q(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=Q;function H(ee,le,fe){const Se=ee.charCodeAt(fe);if(J(Se)&&fe+1<le){const me=ee.charCodeAt(fe+1);if($(me))return Q(Se,me)}return Se}e.getNextCodePoint=H;function B(ee,le){const fe=ee.charCodeAt(le-1);if($(fe)&&le>1){const Se=ee.charCodeAt(le-2);if(J(Se))return Q(Se,fe)}return fe}class Y{constructor(le,fe=0){this._str=le,this._len=le.length,this._offset=fe}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=B(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=H(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=Y;class ie{constructor(le,fe=0){this._iterator=new Y(le,fe)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=Ee.getInstance(),fe=this._iterator,Se=fe.offset;let me=le.getGraphemeBreakType(fe.nextCodePoint());for(;!fe.eol();){const we=fe.offset,De=le.getGraphemeBreakType(fe.nextCodePoint());if(ue(me,De)){fe.setOffset(we);break}me=De}return fe.offset-Se}prevGraphemeLength(){const le=Ee.getInstance(),fe=this._iterator,Se=fe.offset;let me=le.getGraphemeBreakType(fe.prevCodePoint());for(;fe.offset>0;){const we=fe.offset,De=le.getGraphemeBreakType(fe.prevCodePoint());if(ue(De,me)){fe.setOffset(we);break}me=De}return Se-fe.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function ae(ee,le){return new ie(ee,le).nextGraphemeLength()}e.nextCharLength=ae;function z(ee,le){return new ie(ee,le).prevGraphemeLength()}e.prevCharLength=z;function x(ee,le){le>0&&$(ee.charCodeAt(le))&&le--;const fe=le+ae(ee,le);return[fe-z(ee,fe),fe]}e.getCharContainingOffset=x;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function M(ee){return _.test(ee)}e.containsRTL=M;const q=/^[\t\n\r\x20-\x7E]*$/;function j(ee){return q.test(ee)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=Z;function G(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=G;function te(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=te;function se(ee,le){if(ee.length<le)return ee;const fe=/\b/g;let Se=0;for(;fe.test(ee)&&!(ee.length-fe.lastIndex<le);)Se=fe.lastIndex,fe.lastIndex+=1;return ee.substring(Se).replace(/^\s/,"")}e.lcut=se;const ce=/\x1B\x5B[12]?K/g,he=/\x1b\[\d+m/g,ve=/\x1b\[0?m/g;function pe(ee){return ee&&(ee=ee.replace(ce,""),ee=ee.replace(he,""),ee=ee.replace(ve,"")),ee}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ce(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ce;function be(ee){return Ce(ee)?ee.substr(1):ee}e.stripUTF8BOM=be;function Pe(ee,le){if(!ee||!le||ee.length<le.length)return!1;const fe=le.length,Se=ee.toLowerCase();let me=0,we=-1;for(;me<fe;){const De=Se.indexOf(le[me],we+1);if(De<0)return!1;we=De,me++}return!0}e.fuzzyContains=Pe;function Me(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=Me;function Ke(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=Ke;function He(ee,le=1){if(le===0)return"";let fe=-1;do fe=ee.indexOf(`
`,fe+1),le--;while(le>0&&fe>=0);return fe===-1?ee:(ee[fe-1]==="\r"&&fe--,ee.substr(0,fe))}e.getNLines=He;function We(ee){const le=90-65+1;return ee=ee%(2*le),ee<le?String.fromCharCode(97+ee):String.fromCharCode(65+ee-le)}e.singleLetterHash=We;function oe(ee){return Ee.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=oe;function ue(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var de;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(de=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Ee{constructor(){this._data=Ie()}static getInstance(){return Ee._INSTANCE||(Ee._INSTANCE=new Ee),Ee._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const fe=this._data,Se=fe.length/3;let me=1;for(;me<=Se;)if(le<fe[3*me])me=2*me;else if(le>fe[3*me+1])me=2*me+1;else return fe[3*me+2];return 0}}Ee._INSTANCE=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ue(ee,le){if(ee===0)return 0;const fe=Re(ee,le);if(fe!==void 0)return fe;const Se=new Y(le,ee);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Ue;function Re(ee,le){const fe=new Y(le,ee);let Se=fe.prevCodePoint();for(;$e(Se)||Se===65039||Se===8419;){if(fe.offset===0)return;Se=fe.prevCodePoint()}if(!te(Se))return;let me=fe.offset;return me>0&&fe.prevCodePoint()===8205&&(me=fe.offset),me}function $e(ee){return 127995<=ee&&ee<=127999}var Ae;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class Te{constructor(le){this.confusableDictionary=le}static getInstance(le){return Te.cache.get(Array.from(le))}static getLocales(){return Te._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,k=Te,Te.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new R.LRUCachedFunction(ee=>{function le(_e){const Fe=new Map;for(let ze=0;ze<_e.length;ze+=2)Fe.set(_e[ze],_e[ze+1]);return Fe}function fe(_e,Fe){const ze=new Map(_e);for(const[Qe,it]of Fe)ze.set(Qe,it);return ze}function Se(_e,Fe){if(!_e)return Fe;const ze=new Map;for(const[Qe,it]of _e)Fe.has(Qe)&&ze.set(Qe,it);return ze}const me=k.ambiguousCharacterData.getValue();let we=ee.filter(_e=>!_e.startsWith("_")&&_e in me);we.length===0&&(we=["_default"]);let De;for(const _e of we){const Fe=le(me[_e]);De=Se(De,Fe)}const ke=le(me._common),Le=fe(ke,De);return new Te(Le)}),Te._locales=new n.Lazy(()=>Object.keys(Te.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(le){return Ne.getData().has(le)}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne,Ne._data=void 0}),define(ne[42],re([0,1,12,4,26,15]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function C(o){return o.replace(/[\\/]/g,R.posix.sep)}e.toSlashes=C;function P(o){return o.indexOf("/")===-1&&(o=C(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function I(o,c=R.posix.sep){if(!o)return"";const a=o.length,l=o.charCodeAt(0);if(A(l)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let D=3;const U=D;for(;D<a&&!A(o.charCodeAt(D));D++);if(U!==D&&!A(o.charCodeAt(D+1))){for(D+=1;D<a;D++)if(A(o.charCodeAt(D)))return o.slice(0,D+1).replace(/[\\/]/g,c)}}return c}else if(p(l)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let m=o.indexOf("://");if(m!==-1){for(m+=3;m<a;m++)if(A(o.charCodeAt(m)))return o.slice(0,m+1)}return""}e.getRoot=I;function E(o){if(!n.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let a=2;const l=a;for(;a<o.length&&(c=o.charCodeAt(a),c!==92);a++);return!(l===a||(c=o.charCodeAt(a+1),isNaN(c)||c===92))}e.isUNC=E;const b=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function d(o,c=n.isWindows){const a=c?b:v;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||c&&y.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=d;function S(o,c,a){const l=o===c;return!a||l?l:!o||!c?!1:(0,k.equalsIgnoreCase)(o,c)}e.isEqual=S;function w(o,c,a,l=R.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let D=c.length;return c.charAt(c.length-1)===l&&D--,o.charAt(D)===l}return c.charAt(c.length-1)!==l&&(c+=l),o.indexOf(c)===0}e.isEqualOrParent=w;function p(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=p;function g(o,c){return n.isWindows&&o.endsWith(":")&&(o+=R.sep),(0,R.isAbsolute)(o)||(o=(0,R.join)(c,o)),o=(0,R.normalize)(o),n.isWindows?(o=(0,k.rtrim)(o,R.sep),o.endsWith(":")&&(o+=R.sep)):(o=(0,k.rtrim)(o,R.sep),o||(o=R.sep)),o}e.sanitizeFilePath=g;function u(o){const c=(0,R.normalize)(o);return n.isWindows?o.length>3?!1:f(c)&&(o.length===2||c.charCodeAt(2)===92):c===R.posix.sep}e.isRootOrDriveLetter=u;function f(o,c=n.isWindows){return c?p(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=f;function h(o){return f(o)?o[0]:void 0}e.getDriveLetter=h;function s(o,c,a){return c.length>o.length?-1:o===c?0:(a&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=s;function r(o){const c=o.split(":");let a,l,m;for(const D of c){const U=Number(D);(0,T.isNumber)(U)?l===void 0?l=U:m===void 0&&(m=U):a=a?[a,D].join(":"):D}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:l!==void 0?l:void 0,column:m!==void 0?m:l!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,c,a=8){let l="";for(let D=0;D<a;D++)l+=t.charAt(Math.floor(Math.random()*t.length));let m;return c?m=`${c}-${l}`:m=l,o?(0,R.join)(o,m):m}e.randomPath=i}),define(ne[62],re([0,1,26]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(p){return k(p,0)}e.hash=n;function k(p,g){switch(typeof p){case"object":return p===null?T(349,g):Array.isArray(p)?P(p,g):I(p,g);case"string":return C(p,g);case"boolean":return A(p,g);case"number":return T(p,g);case"undefined":return T(937,g);default:return T(617,g)}}e.doHash=k;function T(p,g){return(g<<5)-g+p|0}e.numberHash=T;function A(p,g){return T(p?433:863,g)}function C(p,g){g=T(149417,g);for(let u=0,f=p.length;u<f;u++)g=T(p.charCodeAt(u),g);return g}e.stringHash=C;function P(p,g){return g=T(104579,g),p.reduce((u,f)=>k(f,u),g)}function I(p,g){return g=T(181387,g),Object.keys(p).sort().reduce((u,f)=>(u=C(f,u),k(p[f],u)),g)}class E{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=k(g,this._value),this._value}}e.Hasher=E;var b;(function(p){p[p.BLOCK_SIZE=64]="BLOCK_SIZE",p[p.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function v(p,g,u=32){const f=u-g,h=~((1<<f)-1);return(p<<g|(h&p)>>>f)>>>0}function y(p,g=0,u=p.byteLength,f=0){for(let h=0;h<u;h++)p[g+h]=f}function d(p,g,u="0"){for(;p.length<g;)p=u+p;return p}function S(p,g=32){return p instanceof ArrayBuffer?Array.from(new Uint8Array(p)).map(u=>u.toString(16).padStart(2,"0")).join(""):d((p>>>0).toString(16),g/4)}e.toHexString=S;class w{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const u=g.length;if(u===0)return;const f=this._buff;let h=this._buffLen,s=this._leftoverHighSurrogate,r,t;for(s!==0?(r=s,t=-1,s=0):(r=g.charCodeAt(0),t=0);;){let i=r;if(R.isHighSurrogate(r))if(t+1<u){const o=g.charCodeAt(t+1);R.isLowSurrogate(o)?(t++,i=R.computeCodePoint(r,o)):i=65533}else{s=r;break}else R.isLowSurrogate(r)&&(i=65533);if(h=this._push(f,h,i),t++,t<u)r=g.charCodeAt(t);else break}this._buffLen=h,this._leftoverHighSurrogate=s}_push(g,u,f){return f<128?g[u++]=f:f<2048?(g[u++]=192|(f&1984)>>>6,g[u++]=128|(f&63)>>>0):f<65536?(g[u++]=224|(f&61440)>>>12,g[u++]=128|(f&4032)>>>6,g[u++]=128|(f&63)>>>0):(g[u++]=240|(f&1835008)>>>18,g[u++]=128|(f&258048)>>>12,g[u++]=128|(f&4032)>>>6,g[u++]=128|(f&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=w._bigBlock32,u=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,u.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,v(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let f=this._h0,h=this._h1,s=this._h2,r=this._h3,t=this._h4,i,o,c;for(let a=0;a<80;a++)a<20?(i=h&s|~h&r,o=1518500249):a<40?(i=h^s^r,o=1859775393):a<60?(i=h&s|h&r|s&r,o=2400959708):(i=h^s^r,o=3395469782),c=v(f,5)+i+t+o+g.getUint32(a*4,!1)&4294967295,t=r,r=s,s=v(h,30),h=f,f=c;this._h0=this._h0+f&4294967295,this._h1=this._h1+h&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=w,w._bigBlock32=new DataView(new ArrayBuffer(320))}),define(ne[34],re([0,1,18,26]),function(X,e,R,n){"use strict";var k,T,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function C(t,i,o){let c=t.get(i);return c===void 0&&(c=o,t.set(i,c)),c}e.getOrSet=C;function P(t){const i=[];return t.forEach((o,c)=>{i.push(`${c} => ${o}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=P;function I(t){const i=[];return t.forEach(o=>{i.push(o)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=I;class E{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),c=this._value.charCodeAt(this._pos);return o-c}value(){return this._value[this._pos]}}e.StringIterator=E;class b{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=b;class v{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const c=this._value.charCodeAt(o);if(!(c===47||this._splitOnBackslash&&c===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class d{constructor(i,o){this._ignorePathCasing=i,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=d;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(w||(w={}));class p{constructor(i){this._iter=i}static forUris(i=()=>!1,o=()=>!1){return new p(new d(i,o))}static forPaths(i=!1){return new p(new v(void 0,!i))}static forStrings(){return new p(new E)}static forConfigKeys(){return new p(new b)}clear(){this._root=void 0}fill(i,o){if(o){const c=o.slice(0);(0,R.shuffle)(c);for(const a of c)this.set(a,i)}else{const c=i.slice(0);(0,R.shuffle)(c);for(const a of c)this.set(a[0],a[1])}}set(i,o){const c=this._iter.reset(i);let a;this._root||(this._root=new S,this._root.segment=c.value());const l=[];for(a=this._root;;){const D=c.cmp(a.segment);if(D>0)a.left||(a.left=new S,a.left.segment=c.value()),l.push([-1,a]),a=a.left;else if(D<0)a.right||(a.right=new S,a.right.segment=c.value()),l.push([1,a]),a=a.right;else if(c.hasNext())c.next(),a.mid||(a.mid=new S,a.mid.segment=c.value()),l.push([0,a]),a=a.mid;else break}const m=a.value;a.value=o,a.key=i;for(let D=l.length-1;D>=0;D--){const U=l[D][1];U.updateHeight();const O=U.balanceFactor();if(O<-1||O>1){const F=l[D][0],L=l[D+1][0];if(F===1&&L===1)l[D][1]=U.rotateLeft();else if(F===-1&&L===-1)l[D][1]=U.rotateRight();else if(F===1&&L===-1)U.right=l[D+1][1]=l[D+1][1].rotateRight(),l[D][1]=U.rotateLeft();else if(F===-1&&L===1)U.left=l[D+1][1]=l[D+1][1].rotateLeft(),l[D][1]=U.rotateRight();else throw new Error;if(D>0)switch(l[D-1][0]){case-1:l[D-1][1].left=l[D][1];break;case 1:l[D-1][1].right=l[D][1];break;case 0:l[D-1][1].mid=l[D][1];break}else this._root=l[0][1]}}return m}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let c=this._root;for(;c;){const a=o.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else break}return c}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const c=this._iter.reset(i),a=[];let l=this._root;for(;l;){const m=c.cmp(l.segment);if(m>0)a.push([-1,l]),l=l.left;else if(m<0)a.push([1,l]),l=l.right;else if(c.hasNext())c.next(),a.push([0,l]),l=l.mid;else break}if(!!l){if(o?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const m=this._min(l.right),{key:D,value:U,segment:O}=m;this._delete(m.key,!1),l.key=D,l.value=U,l.segment=O}else{const m=l.left??l.right;if(a.length>0){const[D,U]=a[a.length-1];switch(D){case-1:U.left=m;break;case 0:U.mid=m;break;case 1:U.right=m;break}}else this._root=m}for(let m=a.length-1;m>=0;m--){const D=a[m][1];D.updateHeight();const U=D.balanceFactor();if(U>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),a[m][1]=D.rotateLeft()):U<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),a[m][1]=D.rotateRight()),m>0)switch(a[m-1][0]){case-1:a[m-1][1].left=a[m][1];break;case 1:a[m-1][1].right=a[m][1];break;case 0:a[m-1][1].mid=a[m][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let c=this._root,a;for(;c;){const l=o.cmp(c.segment);if(l>0)c=c.left;else if(l<0)c=c.right;else if(o.hasNext())o.next(),a=c.value||a,c=c.mid;else break}return c&&c.value||a}findSuperstr(i){const o=this._iter.reset(i);let c=this._root;for(;c;){const a=o.cmp(c.segment);if(a>0)c=c.left;else if(a<0)c=c.right;else if(o.hasNext())o.next(),c=c.mid;else return c.mid?this._entries(c.mid):void 0}}forEach(i){for(const[o,c]of this)i(c,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const o=[];return this._dfsEntries(i,o),o[Symbol.iterator]()}_dfsEntries(i,o){!i||(i.left&&this._dfsEntries(i.left,o),i.value&&o.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,o),i.right&&this._dfsEntries(i.right,o))}_isBalanced(){const i=o=>{if(!o)return!0;const c=o.balanceFactor();return c<-1||c>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=p;class g{constructor(i,o){this.uri=i,this.value=o}}class u{constructor(i,o){this[k]="ResourceMap",i instanceof u?(this.map=new Map(i.map),this.toKey=o??u.defaultToKey):(this.map=new Map,this.toKey=i??u.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new g(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(const[c,a]of this.map)i(a.value,a.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=u,u.defaultToKey=t=>t.toString();class f{constructor(i,o){this[T]="ResourceSet",!i||typeof i=="function"?this._map=new u(i):(this._map=new u(o),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,o){this._map.forEach((c,a)=>i.call(o,a,a,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=f;var h;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(h=e.Touch||(e.Touch={}));class s{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const c=this._map.get(i);if(!!c)return o!==0&&this.touch(c,o),c.value}set(i,o,c=0){let a=this._map.get(i);if(a)a.value=o,c!==0&&this.touch(a,c);else{switch(a={key:i,value:o,next:void 0,previous:void 0},c){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const c=this._state;let a=this._head;for(;a;){if(o?i.bind(o)(a.value,a.key,this):i(a.value,a.key,this),this._state!==c)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,o=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:c.key,done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return a}values(){const i=this,o=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:c.value,done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return a}entries(){const i=this,o=this._state;let c=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(c){const l={value:[c.key,c.value],done:!1};return c=c.next,l}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,c=this.size;for(;o&&c>i;)this._map.delete(o.key),o=o.next,c--;this._head=o,this._size=c,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,c=i.previous;if(!o||!c)throw new Error("Invalid list");o.previous=c,c.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const c=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(c.previous=a,a.next=c),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const c=i.next,a=i.previous;i===this._head?(c.previous=void 0,this._head=c):(c.previous=a,a.next=c),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,c)=>{i.push([c,o])}),i}fromJSON(i){this.clear();for(const[o,c]of i)this.set(o,c)}}e.LinkedMap=s;class r extends s{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(ne[79],re([0,1,34]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new R.LRUCache(1e4);function k(I){return P(I,"NFC",n)}e.normalizeNFC=k;const T=new R.LRUCache(1e4);function A(I){return P(I,"NFD",T)}e.normalizeNFD=A;const C=/[^\u0000-\u0080]/;function P(I,E,b){if(!I)return I;const v=b.get(I);if(v)return v;let y;return C.test(I)?y=I.normalize(E):y=I,b.set(I,y),y}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(E){return A(E).replace(I,"")}}()}),define(ne[80],re([0,1,26]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(n||(n={})),function(k){const T="error",A="warning",C="warn",P="info",I="ignore";function E(v){return v?R.equalsIgnoreCase(T,v)?k.Error:R.equalsIgnoreCase(A,v)||R.equalsIgnoreCase(C,v)?k.Warning:R.equalsIgnoreCase(P,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=E;function b(v){switch(v){case k.Error:return T;case k.Warning:return A;case k.Info:return P;default:return I}}k.toString=b}(n||(n={})),e.default=n}),define(ne[7],re([0,1,12,4]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,T=/^\//,A=/^\/\//;function C(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!k.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!T.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,i){return!t&&!i?"file":t}function I(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==b&&(i=b+i):i=b;break}return i}const E="",b="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(i,o,c,a,l,m=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=P(i,m),this.authority=o||E,this.path=I(this.scheme,c||E),this.query=a||E,this.fragment=l||E,C(this,m))}static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return u(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:c,path:a,query:l,fragment:m}=i;return o===void 0?o=this.scheme:o===null&&(o=E),c===void 0?c=this.authority:c===null&&(c=E),a===void 0?a=this.path:a===null&&(a=E),l===void 0?l=this.query:l===null&&(l=E),m===void 0?m=this.fragment:m===null&&(m=E),o===this.scheme&&c===this.authority&&a===this.path&&l===this.query&&m===this.fragment?this:new S(o,c,a,l,m)}static parse(i,o=!1){const c=v.exec(i);return c?new S(c[2]||E,r(c[4]||E),r(c[5]||E),r(c[7]||E),r(c[9]||E),o):new S(E,E,E,E,E)}static file(i){let o=E;if(n.isWindows&&(i=i.replace(/\\/g,b)),i[0]===b&&i[1]===b){const c=i.indexOf(b,2);c===-1?(o=i.substring(2),i=b):(o=i.substring(2,c),i=i.substring(c)||b)}return new S("file",o,i,E,E)}static from(i){const o=new S(i.scheme,i.authority,i.path,i.query,i.fragment);return C(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let c;return n.isWindows&&i.scheme==="file"?c=y.file(R.win32.join(u(i,!0),...o)).path:c=R.posix.join(i.path,...o),i.with({path:c})}toString(i=!1){return f(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const o=new S(i);return o._formatted=i.external,o._fsPath=i._sep===d?i.fsPath:null,o}}else return i}}e.URI=y;const d=n.isWindows?1:void 0;class S extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(i=!1){return i?f(this,!0):(this._formatted||(this._formatted=f(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=d),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const w={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function p(t,i){let o,c=-1;for(let a=0;a<t.length;a++){const l=t.charCodeAt(a);if(l>=97&&l<=122||l>=65&&l<=90||l>=48&&l<=57||l===45||l===46||l===95||l===126||i&&l===47)c!==-1&&(o+=encodeURIComponent(t.substring(c,a)),c=-1),o!==void 0&&(o+=t.charAt(a));else{o===void 0&&(o=t.substr(0,a));const m=w[l];m!==void 0?(c!==-1&&(o+=encodeURIComponent(t.substring(c,a)),c=-1),o+=m):c===-1&&(c=a)}}return c!==-1&&(o+=encodeURIComponent(t.substring(c))),o!==void 0?o:t}function g(t){let i;for(let o=0;o<t.length;o++){const c=t.charCodeAt(o);c===35||c===63?(i===void 0&&(i=t.substr(0,o)),i+=w[c]):i!==void 0&&(i+=t[o])}return i!==void 0?i:t}function u(t,i){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=u;function f(t,i){const o=i?g:p;let c="",{scheme:a,authority:l,path:m,query:D,fragment:U}=t;if(a&&(c+=a,c+=":"),(l||a==="file")&&(c+=b,c+=b),l){let O=l.indexOf("@");if(O!==-1){const F=l.substr(0,O);l=l.substr(O+1),O=F.indexOf(":"),O===-1?c+=o(F,!1):(c+=o(F.substr(0,O),!1),c+=":",c+=o(F.substr(O+1),!1)),c+="@"}l=l.toLowerCase(),O=l.indexOf(":"),O===-1?c+=o(l,!1):(c+=o(l.substr(0,O),!1),c+=l.substr(O))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const O=m.charCodeAt(1);O>=65&&O<=90&&(m=`/${String.fromCharCode(O+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const O=m.charCodeAt(0);O>=65&&O<=90&&(m=`${String.fromCharCode(O+32)}:${m.substr(2)}`)}c+=o(m,!0)}return D&&(c+="?",c+=o(D,!1)),U&&(c+="#",c+=i?U:p(U,!1)),c}function h(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+h(t.substr(3)):t}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(s)?t.replace(s,i=>h(i)):t}}),define(ne[127],re([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(I){const E=I;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=n;function k(I){const E=[];let b;try{const v=JSON.parse(I.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),b=y.__$stack),E.push(...v)}catch{E.push("Unable to log remote console arguments",I.arguments)}return{args:E,stack:b}}e.parse=k;function T(I){if(typeof I!="string")return T(k(I).stack);const E=I;if(E){const b=A(E),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(v&&v.length===4)return{uri:R.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=T;function A(I){if(!I)return I;const E=I.indexOf(`
`);return E===-1?I:I.substring(0,E)}function C(I,E){const{args:b,stack:v}=k(I),y=typeof b[0]=="string"&&b.length===1;let d=A(v);d&&(d=`(${d.trim()})`);let S=[];if(typeof b[0]=="string"?d&&y?S=[`%c[${E}] %c${b[0]} %c${d}`,P("blue"),P(""),P("grey")]:S=[`%c[${E}] %c${b[0]}`,P("blue"),P(""),...b.slice(1)]:S=[`%c[${E}]%`,P("blue"),...b],d&&!y&&S.push(d),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,S)}e.log=C;function P(I){return`color: ${I}`}}),define(ne[63],re([0,1,16,26,7]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function T(I){return JSON.stringify(I,C)}e.stringify=T;function A(I){let E=JSON.parse(I);return E=P(E),E}e.parse=A;function C(I,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,n.regExpFlags)(E)}:E}function P(I,E=0){if(!I||E>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return k.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof R.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let b=0;b<I.length;++b)I[b]=P(I[b],E+1);else for(const b in I)Object.hasOwnProperty.call(I,b)&&(I[b]=P(I[b],E+1))}return I}e.revive=P}),define(ne[20],re([0,1,4,7]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(C){C.inMemory="inmemory",C.vscode="vscode",C.internal="private",C.walkThrough="walkThrough",C.walkThroughSnippet="walkThroughSnippet",C.http="http",C.https="https",C.file="file",C.mailto="mailto",C.untitled="untitled",C.data="data",C.command="command",C.vscodeRemote="vscode-remote",C.vscodeRemoteResource="vscode-remote-resource",C.vscodeUserData="vscode-userdata",C.vscodeCustomEditor="vscode-custom-editor",C.vscodeNotebook="vscode-notebook",C.vscodeNotebookCell="vscode-notebook-cell",C.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",C.vscodeNotebookCellOutput="vscode-notebook-cell-output",C.vscodeInteractive="vscode-interactive",C.vscodeInteractiveInput="vscode-interactive-input",C.vscodeSettings="vscode-settings",C.vscodeWorkspaceTrust="vscode-workspace-trust",C.vscodeTerminal="vscode-terminal",C.webviewPanel="webview-panel",C.vscodeWebview="vscode-webview",C.extension="extension",C.vscodeFileResource="vscode-file",C.tmp="tmp",C.vsls="vsls",C.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${k.vscodeRemoteResource}`}set(P,I,E){this._hosts[P]=I,this._ports[P]=E}setConnectionToken(P,I){this._connectionTokens[P]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const I=P.authority;let E=this._hosts[I];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const b=this._ports[I],v=this._connectionTokens[I];let y=`path=${encodeURIComponent(P.path)}`;return typeof v=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),n.URI.from({scheme:R.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${E}:${b}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new T;class A{asBrowserUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===k.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?E.with({scheme:k.vscodeFileResource,authority:E.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeFileResource?E.with({scheme:k.file,authority:E.authority!==A.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(P,I){return n.URI.isUri(P)?P:n.URI.parse(I.toUrl(P))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(ne[17],re([0,1,42,20,12,4,26,7]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(y){return(0,C.uriToFsPath)(y,!0)}e.originalFSPath=P;class I{constructor(d){this._ignorePathCasing=d}compare(d,S,w=!1){return d===S?0:(0,A.compare)(this.getComparisonKey(d,w),this.getComparisonKey(S,w))}isEqual(d,S,w=!1){return d===S?!0:!d||!S?!1:this.getComparisonKey(d,w)===this.getComparisonKey(S,w)}getComparisonKey(d,S=!1){return d.with({path:this._ignorePathCasing(d)?d.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(d){return this._ignorePathCasing(d)}isEqualOrParent(d,S,w=!1){if(d.scheme===S.scheme){if(d.scheme===n.Schemas.file)return R.isEqualOrParent(P(d),P(S),this._ignorePathCasing(d))&&d.query===S.query&&(w||d.fragment===S.fragment);if((0,e.isEqualAuthority)(d.authority,S.authority))return R.isEqualOrParent(d.path,S.path,this._ignorePathCasing(d),"/")&&d.query===S.query&&(w||d.fragment===S.fragment)}return!1}joinPath(d,...S){return C.URI.joinPath(d,...S)}basenameOrAuthority(d){return(0,e.basename)(d)||d.authority}basename(d){return k.posix.basename(d.path)}extname(d){return k.posix.extname(d.path)}dirname(d){if(d.path.length===0)return d;let S;return d.scheme===n.Schemas.file?S=C.URI.file(k.dirname(P(d))).path:(S=k.posix.dirname(d.path),d.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${d.toString})) resulted in a relative path`),S="/")),d.with({path:S})}normalizePath(d){if(!d.path.length)return d;let S;return d.scheme===n.Schemas.file?S=C.URI.file(k.normalize(P(d))).path:S=k.posix.normalize(d.path),d.with({path:S})}relativePath(d,S){if(d.scheme!==S.scheme||!(0,e.isEqualAuthority)(d.authority,S.authority))return;if(d.scheme===n.Schemas.file){const g=k.relative(P(d),P(S));return T.isWindows?R.toSlashes(g):g}let w=d.path||"/";const p=S.path||"/";if(this._ignorePathCasing(d)){let g=0;for(const u=Math.min(w.length,p.length);g<u&&!(w.charCodeAt(g)!==p.charCodeAt(g)&&w.charAt(g).toLowerCase()!==p.charAt(g).toLowerCase());g++);w=p.substr(0,g)+w.substr(g)}return k.posix.relative(w,p)}resolvePath(d,S){if(d.scheme===n.Schemas.file){const w=C.URI.file(k.resolve(P(d),S));return d.with({authority:w.authority,path:w.path})}return S=R.toPosixPath(S),d.with({path:k.posix.resolve(d.path,S)})}isAbsolutePath(d){return!!d.path&&d.path[0]==="/"}isEqualAuthority(d,S){return d===S||d!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(d,S)}hasTrailingPathSeparator(d,S=k.sep){if(d.scheme===n.Schemas.file){const w=P(d);return w.length>R.getRoot(w).length&&w[w.length-1]===S}else{const w=d.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(d.fsPath)}}removeTrailingPathSeparator(d,S=k.sep){return(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path.substr(0,d.path.length-1)}):d}addTrailingPathSeparator(d,S=k.sep){let w=!1;if(d.scheme===n.Schemas.file){const p=P(d);w=p!==void 0&&p.length===R.getRoot(p).length&&p[p.length-1]===S}else{S="/";const p=d.path;w=p.length===1&&p.charCodeAt(p.length-1)===47}return!w&&!(0,e.hasTrailingPathSeparator)(d,S)?d.with({path:d.path+"/"}):d}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(y=>y.scheme===n.Schemas.file?!T.isLinux:!0),e.extUriIgnorePathCase=new I(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(y,d){const S=[];for(let w=0;w<y.length;w++){const p=d(y[w]);y.some((g,u)=>u===w?!1:(0,e.isEqualOrParent)(p,d(g)))||S.push(y[w])}return S}e.distinctParents=E;var b;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function d(S){const w=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(u=>{const[f,h]=u.split(":");f&&h&&w.set(f,h)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&w.set(y.META_DATA_MIME,g),w}y.parseMetaData=d})(b=e.DataUri||(e.DataUri={}));function v(y,d,S){if(d){let w=y.path;return w&&w[0]!==k.posix.sep&&(w=k.posix.sep+w),y.with({scheme:S,authority:d,path:w})}return y.with({scheme:S})}e.toLocalResource=v}),define(ne[6],re([0,1,21,9,3,2,17,4]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(x){return!!x&&typeof x.then=="function"}e.isThenable=P;function I(x){const _=new R.CancellationTokenSource,M=x(_.token),q=new Promise((j,Z)=>{const G=_.token.onCancellationRequested(()=>{G.dispose(),_.dispose(),Z(new n.CancellationError)});Promise.resolve(M).then(te=>{G.dispose(),_.dispose(),j(te)},te=>{G.dispose(),_.dispose(),Z(te)})});return new class{cancel(){_.cancel()}then(j,Z){return q.then(j,Z)}catch(j){return this.then(void 0,j)}finally(j){return q.finally(j)}}}e.createCancelablePromise=I;function E(x,_,M){return new Promise((q,j)=>{const Z=_.onCancellationRequested(()=>{Z.dispose(),q(M)});x.then(q,j).finally(()=>Z.dispose())})}e.raceCancellation=E;function b(x,_){return new Promise((M,q)=>{const j=_.onCancellationRequested(()=>{j.dispose(),q(new n.CancellationError)});x.then(M,q).finally(()=>j.dispose())})}e.raceCancellationError=b;async function v(x){let _=-1;const M=x.map((j,Z)=>j.then(G=>(_=Z,G))),q=await Promise.race(M);return x.forEach((j,Z)=>{Z!==_&&j.cancel()}),q}e.raceCancellablePromises=v;function y(x,_,M){let q;const j=setTimeout(()=>{q?.(void 0),M?.()},_);return Promise.race([x.finally(()=>clearTimeout(j)),new Promise(Z=>q=Z)])}e.raceTimeout=y;function d(x){return new Promise((_,M)=>{const q=x();P(q)?q.then(_,M):_(q)})}e.asPromise=d;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const M=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(M,M).then(q)})}return new Promise((M,q)=>{this.queuedPromise.then(M,q)})}return this.activePromise=_(),new Promise((M,q)=>{this.activePromise.then(j=>{this.activePromise=null,M(j)},j=>{this.activePromise=null,q(j)})})}}e.Throttler=S;class w{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=w;class p{constructor(){this.promiseMap=new Map}queue(_,M){const j=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(M).finally(()=>{this.promiseMap.get(_)===j&&this.promiseMap.delete(_)});return this.promiseMap.set(_,j),j}}e.SequencerByKey=p;const g=(x,_)=>{let M=!0;const q=setTimeout(()=>{M=!1,_()},x);return{isTriggered:()=>M,dispose:()=>{clearTimeout(q),M=!1}}},u=x=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,x())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class f{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,M=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Z)=>{this.doResolve=j,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=M===e.MicrotaskDelay?u(q):g(M,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=f;class h{constructor(_){this.delayer=new f(_),this.throttler=new S}trigger(_,M){return this.delayer.trigger(()=>this.throttler.queue(_),M)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=h;class s{constructor(){this._isOpen=!1,this._promise=new Promise((_,M)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function t(x,_){return _?new Promise((M,q)=>{const j=setTimeout(()=>{Z.dispose(),M()},x),Z=_.onCancellationRequested(()=>{clearTimeout(j),Z.dispose(),q(new n.CancellationError)})}):I(M=>t(x,M))}e.timeout=t;function i(x,_=0){const M=setTimeout(x,_);return(0,T.toDisposable)(()=>clearTimeout(M))}e.disposableTimeout=i;function o(x){const _=[];let M=0;const q=x.length;function j(){return M<q?x[M++]():null}function Z(G){G!=null&&_.push(G);const te=j();return te?te.then(Z):Promise.resolve(_)}return Promise.resolve(null).then(Z)}e.sequence=o;function c(x,_=q=>!!q,M=null){let q=0;const j=x.length,Z=()=>{if(q>=j)return Promise.resolve(M);const G=x[q++];return Promise.resolve(G()).then(se=>_(se)?Promise.resolve(se):Z())};return Z()}e.first=c;function a(x,_=q=>!!q,M=null){if(x.length===0)return Promise.resolve(M);let q=x.length;const j=()=>{q=-1;for(const Z of x)Z.cancel?.()};return new Promise((Z,G)=>{for(const te of x)te.then(se=>{--q>=0&&_(se)?(j(),Z(se)):q===0&&Z(M)}).catch(se=>{--q>=0&&(j(),G(se))})})}e.firstParallel=a;class l{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((M,q)=>{this.outstandingPromises.push({factory:_,c:M,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const M=_.factory();M.then(_.c,_.e),M.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=l;class m extends l{constructor(){super(1)}}e.Queue=m;class D{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new H;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,M=A.extUri){const q=M.getComparisonKey(_);let j=this.queues.get(q);return j||(j=new m,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(q),this.onDidQueueDrain()}),this.queues.set(q,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=D;class U{constructor(_,M){this._token=-1,typeof _=="function"&&typeof M=="number"&&this.setIfNotSet(_,M)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,M){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},M)}setIfNotSet(_,M){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},M))}}e.TimeoutTimer=U;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,M){this.cancel(),this._token=setInterval(()=>{_()},M)}}e.IntervalTimer=O;class F{constructor(_,M){this.timeoutToken=-1,this.runner=_,this.timeout=M,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class L{constructor(_,M){M%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${M}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=M,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=L;class N extends F{constructor(_,M){super(_,M);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class W extends T.Disposable{constructor(_,M){super();this.options=_,this.handler=M,this.pendingWork=[],this.throttler=this._register(new T.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,C.setTimeout0)(()=>{if(_)return;const M=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,M-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(x,_)=>{const M=requestIdleCallback(x,typeof _=="number"?{timeout:_}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(M))}}}}();class V{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(M){this._error=M}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function J(x,_,M){let q;for(let j=0;j<M;j++)try{return await x()}catch(Z){q=Z,await t(_)}throw q}e.retry=J;class ${hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(_,M,q){return this._pending={taskId:_,cancel:()=>q?.(),promise:M},M.then(()=>this.donePending(_),()=>this.donePending(_)),M}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let M,q;const j=new Promise((Z,G)=>{M=Z,q=G});this._next={run:_,promise:j,promiseResolve:M,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=$;class Q{constructor(_,M=()=>Date.now()){this.interval=_,this.nowFn=M,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,M)=>{this.completeCallback=_,this.errorCallback=M})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(M=>{this.completeCallback(_),this.resolved=!0,M()})}error(_){return new Promise(M=>{this.errorCallback(_),this.rejected=!0,M()})}cancel(){new Promise(_=>{this.errorCallback(new n.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=H;var B;(function(x){async function _(q){let j;const Z=await Promise.all(q.map(G=>G.then(te=>te,te=>{j||(j=te)})));if(typeof j!="undefined")throw j;return Z}x.settled=_;function M(q){return new Promise(async(j,Z)=>{try{await q(j,Z)}catch(G){Z(G)}})}x.withAsyncBody=M})(B=e.Promises||(e.Promises={}));var Y;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(Y||(Y={}));class ie{constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const M={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(_(M)),this.resolve()}catch(q){this.reject(q)}finally{M.emitOne=void 0,M.emitMany=void 0,M.reject=void 0}})}static fromArray(_){return new ie(M=>{M.emitMany(_)})}static fromPromise(_){return new ie(async M=>{M.emitMany(await _)})}static fromPromises(_){return new ie(async M=>{await Promise.all(_.map(async q=>M.emitOne(await q)))})}static merge(_){return new ie(async M=>{await Promise.all(_.map(async q=>{for await(const j of q)M.emitOne(j)}))})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,M){return new ie(async q=>{for await(const j of _)q.emitOne(M(j))})}map(_){return ie.map(this,_)}static filter(_,M){return new ie(async q=>{for await(const j of _)M(j)&&q.emitOne(j)})}filter(_){return ie.filter(this,_)}static coalesce(_){return ie.filter(_,M=>!!M)}coalesce(){return ie.coalesce(this)}static async toPromise(_){const M=[];for await(const q of _)M.push(q);return M}toPromise(){return ie.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class ae extends ie{constructor(_,M){super(M);this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ae;function z(x){const _=new R.CancellationTokenSource,M=x(_.token);return new ae(_,async q=>{const j=_.token.onCancellationRequested(()=>{j.dispose(),_.dispose(),q.reject(new n.CancellationError)});try{for await(const Z of M){if(_.token.isCancellationRequested)return;q.emitOne(Z)}j.dispose(),_.dispose()}catch(Z){j.dispose(),_.dispose(),q.reject(Z)}})}e.createCancelableAsyncIterable=z}),define(ne[81],re([0,1,18,6,42,34,12,4,26]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",b="[^/\\\\]",v=/\//g;function y(H,B){switch(H){case 0:return"";case 1:return`${b}*?`;default:return`(?:${E}|${b}+${E}${B?`|${E}${b}+`:""})*?`}}function d(H,B){if(!H)return[];const Y=[];let ie=!1,ae=!1,z="";for(const x of H){switch(x){case B:if(!ie&&!ae){Y.push(z),z="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}z+=x}return z&&Y.push(z),Y}e.splitGlobAware=d;function S(H){if(!H)return"";let B="";const Y=d(H,e.GLOB_SPLIT);if(Y.every(ie=>ie===e.GLOBSTAR))B=".*";else{let ie=!1;Y.forEach((ae,z)=>{if(ae===e.GLOBSTAR){if(ie)return;B+=y(2,z===Y.length-1)}else{let x=!1,_="",M=!1,q="";for(const j of ae){if(j!=="}"&&x){_+=j;continue}if(M&&(j!=="]"||!q)){let Z;j==="-"?Z=j:(j==="^"||j==="!")&&!q?Z="^":j===e.GLOB_SPLIT?Z="":Z=(0,P.escapeRegExpCharacters)(j),q+=Z;continue}switch(j){case"{":x=!0;continue;case"[":M=!0;continue;case"}":{B+=`(?:${d(_,",").map(te=>S(te)).join("|")})`,x=!1,_="";break}case"]":{B+="["+q+"]",M=!1,q="";break}case"?":B+=b;continue;case"*":B+=y(1);continue;default:B+=(0,P.escapeRegExpCharacters)(j)}}z<Y.length-1&&(Y[z+1]!==e.GLOBSTAR||z+2<Y.length)&&(B+=E)}ie=ae===e.GLOBSTAR})}return B}const w=/^\*\*\/\*\.[\w\.-]+$/,p=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,u=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,f=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new T.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i(H,B){if(!H)return t;let Y;typeof H!="string"?Y=H.pattern:Y=H,Y=Y.trim();const ie=`${Y}_${!!B.trimForExclusions}`;let ae=s.get(ie);if(ae)return o(ae,H);let z;return w.test(Y)?ae=a(Y.substr(4),Y):(z=p.exec(c(Y,B)))?ae=l(z[1],Y):(B.trimForExclusions?u:g).test(Y)?ae=m(Y,B):(z=f.exec(c(Y,B)))?ae=D(z[1].substr(1),Y,!0):(z=h.exec(c(Y,B)))?ae=D(z[1],Y,!1):ae=U(Y),s.set(ie,ae),o(ae,H)}function o(H,B){if(typeof B=="string")return H;const Y=function(ie,ae){return(0,k.isEqualOrParent)(ie,B.base,!C.isLinux)?H(ie.substr(B.base.length+1),ae):null};return Y.allBasenames=H.allBasenames,Y.allPaths=H.allPaths,Y.basenames=H.basenames,Y.patterns=H.patterns,Y}function c(H,B){return B.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function a(H,B){return function(Y,ie){return typeof Y=="string"&&Y.endsWith(H)?B:null}}function l(H,B){const Y=`/${H}`,ie=`\\${H}`,ae=function(x,_){return typeof x!="string"?null:_?_===H?B:null:x===H||x.endsWith(Y)||x.endsWith(ie)?B:null},z=[H];return ae.basenames=z,ae.patterns=[B],ae.allBasenames=z,ae}function m(H,B){const Y=$(H.slice(1,-1).split(",").map(_=>i(_,B)).filter(_=>_!==t),H),ie=Y.length;if(!ie)return t;if(ie===1)return Y[0];const ae=function(_,M){for(let q=0,j=Y.length;q<j;q++)if(Y[q](_,M))return H;return null},z=Y.find(_=>!!_.allBasenames);z&&(ae.allBasenames=z.allBasenames);const x=Y.reduce((_,M)=>M.allPaths?_.concat(M.allPaths):_,[]);return x.length&&(ae.allPaths=x),ae}function D(H,B,Y){const ie=A.sep===A.posix.sep,ae=ie?H:H.replace(v,A.sep),z=A.sep+ae,x=A.posix.sep+H;let _;return Y?_=function(M,q){return typeof M=="string"&&(M===ae||M.endsWith(z)||!ie&&(M===H||M.endsWith(x)))?B:null}:_=function(M,q){return typeof M=="string"&&(M===ae||!ie&&M===H)?B:null},_.allPaths=[(Y?"*/":"./")+H],_}function U(H){try{const B=new RegExp(`^${S(H)}$`);return function(Y){return B.lastIndex=0,typeof Y=="string"&&B.test(Y)?H:null}}catch{return t}}function O(H,B,Y){return!H||typeof B!="string"?!1:F(H)(B,void 0,Y)}e.match=O;function F(H,B={}){if(!H)return r;if(typeof H=="string"||L(H)){const Y=i(H,B);if(Y===t)return r;const ie=function(ae,z){return!!Y(ae,z)};return Y.allBasenames&&(ie.allBasenames=Y.allBasenames),Y.allPaths&&(ie.allPaths=Y.allPaths),ie}return V(H,B)}e.parse=F;function L(H){const B=H;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=L;function N(H){return H.allBasenames||[]}e.getBasenameTerms=N;function W(H){return H.allPaths||[]}e.getPathTerms=W;function V(H,B){const Y=$(Object.getOwnPropertyNames(H).map(_=>J(_,H[_],B)).filter(_=>_!==t)),ie=Y.length;if(!ie)return t;if(!Y.some(_=>!!_.requiresSiblings)){if(ie===1)return Y[0];const _=function(j,Z){let G;for(let te=0,se=Y.length;te<se;te++){const ce=Y[te](j,Z);if(typeof ce=="string")return ce;(0,n.isThenable)(ce)&&(G||(G=[]),G.push(ce))}return G?(async()=>{for(const te of G){const se=await te;if(typeof se=="string")return se}return null})():null},M=Y.find(j=>!!j.allBasenames);M&&(_.allBasenames=M.allBasenames);const q=Y.reduce((j,Z)=>Z.allPaths?j.concat(Z.allPaths):j,[]);return q.length&&(_.allPaths=q),_}const ae=function(_,M,q){let j,Z;for(let G=0,te=Y.length;G<te;G++){const se=Y[G];se.requiresSiblings&&q&&(M||(M=(0,A.basename)(_)),j||(j=M.substr(0,M.length-(0,A.extname)(_).length)));const ce=se(_,M,j,q);if(typeof ce=="string")return ce;(0,n.isThenable)(ce)&&(Z||(Z=[]),Z.push(ce))}return Z?(async()=>{for(const G of Z){const te=await G;if(typeof te=="string")return te}return null})():null},z=Y.find(_=>!!_.allBasenames);z&&(ae.allBasenames=z.allBasenames);const x=Y.reduce((_,M)=>M.allPaths?_.concat(M.allPaths):_,[]);return x.length&&(ae.allPaths=x),ae}function J(H,B,Y){if(B===!1)return t;const ie=i(H,Y);if(ie===t)return t;if(typeof B=="boolean")return ie;if(B){const ae=B.when;if(typeof ae=="string"){const z=(x,_,M,q)=>{if(!q||!ie(x,_))return null;const j=ae.replace("$(basename)",M),Z=q(j);return(0,n.isThenable)(Z)?Z.then(G=>G?H:null):Z?H:null};return z.requiresSiblings=!0,z}}return ie}function $(H,B){const Y=H.filter(_=>!!_.basenames);if(Y.length<2)return H;const ie=Y.reduce((_,M)=>{const q=M.basenames;return q?_.concat(q):_},[]);let ae;if(B){ae=[];for(let _=0,M=ie.length;_<M;_++)ae.push(B)}else ae=Y.reduce((_,M)=>{const q=M.patterns;return q?_.concat(q):_},[]);const z=function(_,M){if(typeof _!="string")return null;if(!M){let j;for(j=_.length;j>0;j--){const Z=_.charCodeAt(j-1);if(Z===47||Z===92)break}M=_.substr(j)}const q=ie.indexOf(M);return q!==-1?ae[q]:null};z.basenames=ie,z.patterns=ae,z.allBasenames=ie;const x=H.filter(_=>!_.basenames);return x.push(z),x}function Q(H,B){return(0,R.equals)(H,B,(Y,ie)=>typeof Y=="string"&&typeof ie=="string"?Y===ie:typeof Y!="string"&&typeof ie!="string"?Y.base===ie.base&&Y.pattern===ie.pattern:!1)}e.patternsEquals=Q}),define(ne[128],re([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(E){return E.toJSON()}class k{constructor(b){this._uriTransformer=b}transformIncoming(b){const v=this._uriTransformer.transformIncoming(b);return v===b?b:n(R.URI.from(v))}transformOutgoing(b){const v=this._uriTransformer.transformOutgoing(b);return v===b?b:n(R.URI.from(v))}transformOutgoingURI(b){const v=this._uriTransformer.transformOutgoing(b);return v===b?b:R.URI.from(v)}transformOutgoingScheme(b){return this._uriTransformer.transformOutgoingScheme(b)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function T(E,b,v){if(!E||v>200)return null;if(typeof E=="object"){if(E instanceof R.URI)return b.transformOutgoing(E);for(const y in E)if(Object.hasOwnProperty.call(E,y)){const d=T(E[y],b,v+1);d!==null&&(E[y]=d)}}return null}function A(E,b){const v=T(E,b,0);return v===null?E:v}e.transformOutgoingURIs=A;function C(E,b,v,y){if(!E||y>200)return null;if(typeof E=="object"){if(E.$mid===1)return v?R.URI.revive(b.transformIncoming(E)):b.transformIncoming(E);for(const d in E)if(Object.hasOwnProperty.call(E,d)){const S=C(E[d],b,v,y+1);S!==null&&(E[d]=S)}}return null}function P(E,b){const v=C(E,b,!1,0);return v===null?E:v}e.transformIncomingURIs=P;function I(E,b){const v=C(E,b,!0,0);return v===null?E:v}e.transformAndReviveIncomingURIs=I}),define(ne[129],re([0,1,37,9,34,31,115]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,b=0;const v=(0,R.networkInterfaces)();for(const y in v){const d=v[y];if(d)for(const{mac:S,internal:w}of d)w||(b+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(E+=1))}this._value=b>0?E/b:0}return this._value}};let C;async function P(){return C||(C=(async()=>await I()||T.generateUuid())()),C}e.getMachineId=P;async function I(){try{const E=await new Promise((v,y)=>{X(["crypto"],v,y)}),b=(0,A.getMac)();return E.createHash("sha256").update(b,"utf8").digest("hex")}catch(E){n.onUnexpectedError(E);return}}}),define(ne[27],re([0,1,54,37,270,6,42,79,12,4,17,7]),function(X,e,R,n,k,T,A,C,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function y(V,J=v.UNLINK){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return J===v.UNLINK?S(V):d(V)}async function d(V){try{const J=(0,A.randomPath)((0,n.tmpdir)());try{await R.promises.rename(V,J)}catch{return S(V)}S(J).catch($=>{})}catch(J){if(J.code!=="ENOENT")throw J}}async function S(V){return(0,k.promisify)(R.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function w(V){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");R.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function p(V,J){return f(await(J?g(V):(0,k.promisify)(R.readdir)(V)))}async function g(V){try{return await(0,k.promisify)(R.readdir)(V,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const J=[],$=await p(V);for(const Q of $){let H=!1,B=!1,Y=!1;try{const ie=await e.Promises.lstat((0,P.join)(V,Q));H=ie.isFile(),B=ie.isDirectory(),Y=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}J.push({name:Q,isFile:()=>H,isDirectory:()=>B,isSymbolicLink:()=>Y})}return J}function u(V){return f(R.readdirSync(V))}e.readdirSync=u;function f(V){return V.map(J=>typeof J=="string"?I.isMacintosh?(0,C.normalizeNFC)(J):J:(J.name=I.isMacintosh?(0,C.normalizeNFC)(J.name):J.name,J))}async function h(V){const J=await p(V),$=[];for(const Q of J)await r.existsDirectory((0,P.join)(V,Q))&&$.push(Q);return $}function s(V,J=1e3){return new Promise($=>{let Q=!1;const H=setInterval(()=>{Q||(Q=!0,R.access(V,B=>{Q=!1,B&&(clearInterval(H),$(void 0))}))},J)})}e.whenDeleted=s;var r;(function(V){async function J(H){let B;try{if(B=await e.Promises.lstat(H),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Y){if(Y.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(I.isWindows&&Y.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ie}throw Y}}V.stat=J;async function $(H){try{const{stat:B,symbolicLink:Y}=await V.stat(H);return B.isFile()&&Y?.dangling!==!0}catch{}return!1}V.existsFile=$;async function Q(H){try{const{stat:B,symbolicLink:Y}=await V.stat(H);return B.isDirectory()&&Y?.dangling!==!0}catch{}return!1}V.existsDirectory=Q})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new T.ResourceQueue;function i(V,J,$){return t.queueFor(b.URI.file(V),E.extUriBiasedIgnorePathCase).queue(()=>{const Q=m($);return new Promise((H,B)=>a(V,J,Q,Y=>Y?B(Y):H()))})}let o=!0;function c(V){o=V}e.configureFlushOnWrite=c;function a(V,J,$,Q){if(!o)return R.writeFile(V,J,{mode:$.mode,flag:$.flag},Q);R.open(V,$.flag,$.mode,(H,B)=>{if(H)return Q(H);R.writeFile(B,J,Y=>{if(Y)return R.close(B,()=>Q(Y));R.fdatasync(B,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),c(!1)),R.close(B,ae=>Q(ae))))})})}function l(V,J,$){const Q=m($);if(!o)return R.writeFileSync(V,J,{mode:Q.mode,flag:Q.flag});const H=R.openSync(V,Q.flag,Q.mode);try{R.writeFileSync(H,J);try{R.fdatasyncSync(H)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),c(!1)}}finally{R.closeSync(H)}}e.writeFileSync=l;function m(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function D(V,J){if(V!==J)try{await e.Promises.rename(V,J)}catch($){if(V.toLowerCase()!==J.toLowerCase()&&$.code==="EXDEV"||V.endsWith("."))await U(V,J,{preserveSymlinks:!1}),await y(V,v.MOVE);else throw $}}async function U(V,J,$){return F(V,J,{root:{source:V,target:J},options:$,handledSourcePaths:new Set})}const O=511;async function F(V,J,$){if($.handledSourcePaths.has(V))return;$.handledSourcePaths.add(V);const{stat:Q,symbolicLink:H}=await r.stat(V);if(H){if($.options.preserveSymlinks)try{return await W(V,J,$)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(H.dangling)return}return Q.isDirectory()?L(V,J,Q.mode&O,$):N(V,J,Q.mode&O)}async function L(V,J,$,Q){await e.Promises.mkdir(J,{recursive:!0,mode:$});const H=await p(V);for(const B of H)await F((0,P.join)(V,B),(0,P.join)(J,B),Q)}async function N(V,J,$){await e.Promises.copyFile(V,J),await e.Promises.chmod(J,$)}async function W(V,J,$){let Q=await e.Promises.readlink(V);(0,A.isEqualOrParent)(Q,$.root.source,!I.isLinux)&&(Q=(0,P.join)($.root.target,Q.substr($.root.source.length+1))),await e.Promises.symlink(Q,J)}e.Promises=new class{get access(){return(0,k.promisify)(R.access)}get stat(){return(0,k.promisify)(R.stat)}get lstat(){return(0,k.promisify)(R.lstat)}get utimes(){return(0,k.promisify)(R.utimes)}get read(){return(V,J,$,Q,H)=>new Promise((B,Y)=>{R.read(V,J,$,Q,H,(ie,ae,z)=>ie?Y(ie):B({bytesRead:ae,buffer:z}))})}get readFile(){return(0,k.promisify)(R.readFile)}get write(){return(V,J,$,Q,H)=>new Promise((B,Y)=>{R.write(V,J,$,Q,H,(ie,ae,z)=>ie?Y(ie):B({bytesWritten:ae,buffer:z}))})}get appendFile(){return(0,k.promisify)(R.appendFile)}get fdatasync(){return(0,k.promisify)(R.fdatasync)}get truncate(){return(0,k.promisify)(R.truncate)}get rename(){return(0,k.promisify)(R.rename)}get copyFile(){return(0,k.promisify)(R.copyFile)}get open(){return(0,k.promisify)(R.open)}get close(){return(0,k.promisify)(R.close)}get symlink(){return(0,k.promisify)(R.symlink)}get readlink(){return(0,k.promisify)(R.readlink)}get chmod(){return(0,k.promisify)(R.chmod)}get mkdir(){return(0,k.promisify)(R.mkdir)}get unlink(){return(0,k.promisify)(R.unlink)}get rmdir(){return(0,k.promisify)(R.rmdir)}get realpath(){return(0,k.promisify)(R.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return p}get readDirsInDir(){return h}get writeFile(){return i}get rm(){return y}get move(){return D}get copy(){return U}}}),define(ne[130],re([0,1,54,12,4,26,27]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function C(v){if(k.isLinux)return v;const y=(0,n.dirname)(v);if(v===y)return v;const d=((0,n.basename)(v)||v).toLowerCase();try{const w=(0,A.readdirSync)(y).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=C(y);if(p)return(0,n.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const g=C(y);if(g)return(0,n.join)(g,w[p])}}}catch{}return null}e.realcaseSync=C;async function P(v){if(k.isLinux)return v;const y=(0,n.dirname)(v);if(v===y)return v;const d=((0,n.basename)(v)||v).toLowerCase();try{const w=(await A.Promises.readdir(y)).filter(p=>p.toLowerCase()===d);if(w.length===1){const p=await P(y);if(p)return(0,n.join)(p,w[0])}else if(w.length>1){const p=w.indexOf(d);if(p>=0){const g=await P(y);if(g)return(0,n.join)(g,w[p])}}}catch{}return null}e.realcase=P;async function I(v){try{return await A.Promises.realpath(v)}catch{const d=b(v);return await A.Promises.access(d,R.constants.R_OK),d}}e.realpath=I;function E(v){try{return R.realpathSync(v)}catch{const d=b(v);return R.accessSync(d,R.constants.R_OK),d}}e.realpathSync=E;function b(v){return(0,T.rtrim)((0,n.normalize)(v),n.sep)}}),define(ne[82],re([0,1,37,12,27]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const T=/^\d+$/,A=/^Microsoft.PowerShell_.*/,C=/^Microsoft.PowerShellPreview_.*/;var P;(function(f){f[f.x64=0]="x64",f[f.x86=1]="x86",f[f.ARM=2]="ARM"})(P||(P={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class b{constructor(h,s,r){this.exePath=h,this.displayName=s,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:f=!1}={}){return f?I===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:f=!1,findPreview:h=!1}={}){const s=v({useAlternateBitness:f});if(!s)return null;const r=n.join(s,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const a of await k.Promises.readdir(r)){let l=-1;if(h){const D=a.indexOf("-");if(D<0)continue;const U=a.substring(0,D);if(!T.test(U)||a.substring(D+1)!=="preview")continue;l=parseInt(U,10)}else{if(!T.test(a))continue;l=parseInt(a,10)}if(l<=t)continue;const m=n.join(r,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(m)||(i=m,t=l)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",c=h?" Preview":"";return new b(i,`PowerShell${c}${o}`,!0)}async function d({findPreview:f}={}){if(!process.env.LOCALAPPDATA)return null;const h=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(h))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=f?{pwshMsixDirRegex:C,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(h))if(s.test(t)){const i=n.join(h,t,"pwsh.exe");return new b(i,r)}return null}function S(){const f=n.join(R.homedir(),".dotnet","tools","pwsh.exe");return new b(f,".NET Core PowerShell Global Tool")}function w(){const f=n.join(process.env.windir,I===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(f,"Windows PowerShell",!0)}async function*p(){let f=await y();f&&(yield f),f=await y({useAlternateBitness:!0}),f&&(yield f),f=await d(),f&&(yield f),f=S(),f&&(yield f),f=await y({findPreview:!0}),f&&(yield f),f=await d({findPreview:!0}),f&&(yield f),f=await y({useAlternateBitness:!0,findPreview:!0}),f&&(yield f),f=w(),f&&(yield f)}async function*g(){for await(const f of p())await f.exists()&&(yield f)}e.enumeratePowerShellInstallations=g;async function u(){for await(const f of g())return f;return null}e.getFirstAvailablePowerShellInstallation=u}),define(ne[131],re([0,1,48,20]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((C,P)=>{let I;const E=new Map;function b(y,d,S,w,p){const g=E.get(d);if(y===A||g){const u={name:v(S),cmd:S,pid:y,ppid:d,load:w,mem:p};E.set(y,u),y===A&&(I=u),g&&(g.children||(g.children=[]),g.children.push(u),g.children.length>1&&(g.children=g.children.sort((f,h)=>f.pid-h.pid)))}}function v(y){const d=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,w=/--vscode-window-kind=process-explorer/,p=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,u=/--crashes-directory/,f=/\\pipe\\winpty-control/,h=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(u.exec(y))return"electron-crash-reporter";if(f.exec(y))return"winpty-process";if(h.exec(y))return"console-window-host (Windows internal process)";let r=s.exec(y);if(r&&r.length===2){if(r[1]==="renderer")return d.exec(y)?"shared-process":S.exec(y)?"issue-reporter":w.exec(y)?"process-explorer":"window";if(r[1]==="utility"){if(p.exec(y))return"utility-network-service";if(g.exec(y))return"extension-host"}return r[1]}const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(y),r&&(i+=r+" ");while(r);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=d=>d.indexOf("\\\\?\\")===0||d.indexOf("\\??\\")===0?d.substr(4):d.indexOf('"\\\\?\\')===0||d.indexOf('"\\??\\')===0?'"'+d.substr(5):d;new Promise((d,S)=>{X(["windows-process-tree"],d,S)}).then(d=>{d.getProcessList(A,S=>{if(!S){P(new Error(`Root process ${A} not found`));return}d.getProcessCpuUsage(S,w=>{const p=new Map;w.forEach(g=>{const u=y(g.commandLine||"");p.set(g.pid,{name:v(u),cmd:u,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),I=p.get(A),I?(p.forEach(g=>{const u=p.get(g.ppid);u&&(u.children||(u.children=[]),u.children.push(g))}),p.forEach(g=>{g.children&&(g.children=g.children.sort((u,f)=>u.pid-f.pid))}),C(I)):P(new Error(`Root process ${A} not found`))})},d.ProcessDataFlag.CommandLine|d.ProcessDataFlag.Memory)})}else{let y=function(){let d=[I];const S=[];for(;d.length;){const p=d.shift();p&&(S.push(p.pid),p.children&&(d=d.concat(p.children)))}let w=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);w+=" "+S.join(" "),(0,R.exec)(w,{},(p,g,u)=>{if(p||u)P(p||new Error(u.toString()));else{const f=g.toString().split(`
`);for(let h=0;h<S.length;h++){const s=E.get(S[h]);s.load=parseFloat(f[h])}if(!I){P(new Error(`Root process ${A} not found`));return}C(I)}})};(0,R.exec)("which ps",{},(d,S,w)=>{if(d||w)if(process.platform!=="linux")P(d||new Error(w.toString()));else{const p=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,R.exec)(p,{},(g,u,f)=>{g||f?P(g||new Error(f.toString())):(T(u,b),y())})}else{const p=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,R.exec)(`${p} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,f,h)=>{u||h&&!h.includes("screen size is bogus")?P(u||new Error(h.toString())):(T(f,b),process.platform==="linux"?y():I?C(I):P(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function T(A,C){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=A.toString().split(`
`);for(const E of I){const b=P.exec(E.trim());b&&b.length===6&&C(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}});var ge=this&&this.__decorate||function(X,e,R,n){var k=arguments.length,T=k<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,R):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(X,e,R,n);else for(var C=X.length-1;C>=0;C--)(A=X[C])&&(T=(k<3?A(T):k>3?A(e,R,T):A(e,R))||T);return k>3&&T&&Object.defineProperty(e,R,T),T};define(ne[39],re([0,1,18,6,16,21,60,9,3,2,63,26,15]),function(X,e,R,n,k,T,A,C,P,I,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function d(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function w(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var p;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(p||(p={}));class g{constructor(B){this.buffer=B,this.pos=0}read(B){const Y=this.buffer.slice(this.pos,this.pos+B);return this.pos+=Y.byteLength,Y}}class u{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var f;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(f||(f={}));function h(H){const B=k.VSBuffer.alloc(4);return B.writeUInt32BE(H,0),B}function s(H){return H.read(4).readUInt32BE(0)}function r(H){const B=k.VSBuffer.alloc(1);return B.writeUInt8(H,0),B}const t={Undefined:r(f.Undefined),String:r(f.String),Buffer:r(f.Buffer),VSBuffer:r(f.VSBuffer),Array:r(f.Array),Object:r(f.Object)},i=typeof Buffer!="undefined";function o(H,B){if(typeof B=="undefined")H.write(t.Undefined);else if(typeof B=="string"){const Y=k.VSBuffer.fromString(B);H.write(t.String),H.write(h(Y.byteLength)),H.write(Y)}else if(i&&Buffer.isBuffer(B)){const Y=k.VSBuffer.wrap(B);H.write(t.Buffer),H.write(h(Y.byteLength)),H.write(Y)}else if(B instanceof k.VSBuffer)H.write(t.VSBuffer),H.write(h(B.byteLength)),H.write(B);else if(Array.isArray(B)){H.write(t.Array),H.write(h(B.length));for(const Y of B)o(H,Y)}else{const Y=k.VSBuffer.fromString(JSON.stringify(B));H.write(t.Object),H.write(h(Y.byteLength)),H.write(Y)}}function c(H){switch(H.read(1).readUInt8(0)){case f.Undefined:return;case f.String:return H.read(s(H)).toString();case f.Buffer:return H.read(s(H)).buffer;case f.VSBuffer:return H.read(s(H));case f.Array:{const Y=s(H),ie=[];for(let ae=0;ae<Y;ae++)ie.push(c(H));return ie}case f.Object:return JSON.parse(H.read(s(H)).toString())}}class a{constructor(B,Y,ie=null,ae=1e3){this.protocol=B,this.ctx=Y,this.logger=ie,this.timeoutDelay=ae,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(B,Y){this.channels.set(B,Y),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const Y=this.send([B.type]);this.logger?.logOutgoing(Y,0,1,w(B.type));return}case 201:case 202:case 204:case 203:{const Y=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(Y,B.id,1,w(B.type),B.data);return}}}send(B,Y=void 0){const ie=new u;return o(ie,B),o(ie,Y),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const Y=new g(B),ie=c(Y),ae=c(Y),z=ie[0];switch(z){case 100:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(z)}: ${ie[2]}.${ie[3]}`,ae),this.onPromise({type:z,id:ie[1],channelName:ie[2],name:ie[3],arg:ae});case 102:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(z)}: ${ie[2]}.${ie[3]}`,ae),this.onEventListen({type:z,id:ie[1],channelName:ie[2],name:ie[3],arg:ae});case 101:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:ie[1]});case 103:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${d(z)}`),this.disposeActiveRequest({type:z,id:ie[1]})}}onPromise(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const ie=new T.CancellationTokenSource;let ae;try{ae=Y.call(this.ctx,B.name,B.arg,ie.token)}catch(_){ae=Promise.reject(_)}const z=B.id;ae.then(_=>{this.sendResponse({id:z,data:_,type:201}),this.activeRequests.delete(B.id)},_=>{_ instanceof Error?this.sendResponse({id:z,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:z,data:_,type:203}),this.activeRequests.delete(B.id)});const x=(0,I.toDisposable)(()=>ie.cancel());this.activeRequests.set(B.id,x)}onEventListen(B){const Y=this.channels.get(B.channelName);if(!Y){this.collectPendingRequest(B);return}const ie=B.id,z=Y.listen(this.ctx,B.name,B.arg)(x=>this.sendResponse({id:ie,data:x,type:204}));this.activeRequests.set(B.id,z)}disposeActiveRequest(B){const Y=this.activeRequests.get(B.id);Y&&(Y.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let Y=this.pendingRequests.get(B.channelName);Y||(Y=[],this.pendingRequests.set(B.channelName,Y));const ie=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);Y.push({request:B,timeoutTimer:ie})}flushPendingRequests(B){const Y=this.pendingRequests.get(B);if(Y){for(const ie of Y)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var l;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));class m{constructor(B,Y=null){this.protocol=B,this.isDisposed=!1,this.state=p.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=Y}getChannel(B){const Y=this;return{call(ie,ae,z){return Y.isDisposed?Promise.reject(C.canceled()):Y.requestPromise(B,ie,ae,z)},listen(ie,ae){return Y.isDisposed?P.Event.None:Y.requestEvent(B,ie,ae)}}}requestPromise(B,Y,ie,ae=T.CancellationToken.None){const z=this.lastRequestId++,_={id:z,type:100,channelName:B,name:Y,arg:ie};if(ae.isCancellationRequested)return Promise.reject(C.canceled());let M;return new Promise((j,Z)=>{if(ae.isCancellationRequested)return Z(C.canceled());const G=()=>{const he=ve=>{switch(ve.type){case 201:this.handlers.delete(z),j(ve.data);break;case 202:{this.handlers.delete(z);const pe=new Error(ve.data.message);pe.stack=ve.data.stack,pe.name=ve.data.name,Z(pe);break}case 203:this.handlers.delete(z),Z(ve.data);break}};this.handlers.set(z,he),this.sendRequest(_)};let te=null;this.state===p.Idle?G():(te=(0,n.createCancelablePromise)(he=>this.whenInitialized()),te.then(()=>{te=null,G()}));const se=()=>{te?(te.cancel(),te=null):this.sendRequest({id:z,type:101}),Z(C.canceled())},ce=ae.onCancellationRequested(se);M=(0,I.combinedDisposable)((0,I.toDisposable)(se),ce),this.activeRequests.add(M)}).finally(()=>{this.activeRequests.delete(M)})}requestEvent(B,Y,ie){const ae=this.lastRequestId++,x={id:ae,type:102,channelName:B,name:Y,arg:ie};let _=null;const M=new P.Emitter({onFirstListenerAdd:()=>{_=(0,n.createCancelablePromise)(j=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(M),this.sendRequest(x)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(M),this.sendRequest({id:ae,type:103}))}}),q=j=>M.fire(j.data);return this.handlers.set(ae,q),M.event}sendRequest(B){switch(B.type){case 100:case 102:{const Y=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(Y,B.id,0,`${d(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const Y=this.send([B.type,B.id]);this.logger?.logOutgoing(Y,B.id,0,d(B.type));return}}}send(B,Y=void 0){const ie=new u;return o(ie,B),o(ie,Y),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const Y=new g(B),ie=c(Y),ae=c(Y),z=ie[0];switch(z){case 200:return this.logger?.logIncoming(B.byteLength,0,0,w(z)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,ie[1],0,w(z),ae),this.onResponse({type:ie[0],id:ie[1],data:ae})}}onResponse(B){if(B.type===200){this.state=p.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===p.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}ge([A.memoize],m.prototype,"onDidInitializePromise",null),e.ChannelClient=m;class D{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:Y,onDidClientDisconnect:ie})=>{P.Event.once(Y.onMessage)(z=>{const x=new g(z),_=c(x),M=new a(Y,_),q=new m(Y);this.channels.forEach((Z,G)=>M.registerChannel(G,Z));const j={channelServer:M,channelClient:q,ctx:_};this._connections.add(j),this._onDidAddConnection.fire(j),ie(()=>{M.dispose(),q.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const B=[];return this._connections.forEach(Y=>B.push(Y)),B}getChannel(B,Y){const ie=this;return{call(ae,z,x){let _;if((0,v.isFunction)(Y)){const q=(0,R.getRandomElement)(ie.connections.filter(Y));_=q?Promise.resolve(q):P.Event.toPromise(P.Event.filter(ie.onDidAddConnection,Y))}else _=Y.routeCall(ie,ae,z);const M=_.then(q=>q.channelClient.getChannel(B));return O(M).call(ae,z,x)},listen(ae,z){if((0,v.isFunction)(Y))return ie.getMulticastEvent(B,Y,ae,z);const x=Y.routeEvent(ie,ae,z).then(_=>_.channelClient.getChannel(B));return O(x).listen(ae,z)}}}getMulticastEvent(B,Y,ie,ae){const z=this;let x=new I.DisposableStore;const _=new P.Emitter({onFirstListenerAdd:()=>{x=new I.DisposableStore;const M=new P.EventMultiplexer,q=new Map,j=G=>{const se=G.channelClient.getChannel(B).listen(ie,ae),ce=M.add(se);q.set(G,ce)},Z=G=>{const te=q.get(G);!te||(te.dispose(),q.delete(G))};z.connections.filter(Y).forEach(j),P.Event.filter(z.onDidAddConnection,Y)(j,void 0,x),z.onDidRemoveConnection(Z,void 0,x),M.event(_.fire,_,x),x.add(M)},onLastListenerRemove:()=>{x.dispose()}});return _.event}registerChannel(B,Y){this.channels.set(B,Y),this._connections.forEach(ie=>{ie.channelServer.registerChannel(B,Y)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=D;class U{constructor(B,Y,ie=null){const ae=new u;o(ae,Y),B.send(ae.buffer),this.channelClient=new m(B,ie),this.channelServer=new a(B,Y,ie)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,Y){this.channelServer.registerChannel(B,Y)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=U;function O(H){return{call(B,Y,ie){return H.then(ae=>ae.call(B,Y,ie))},listen(B,Y){const ie=new P.Relay;return H.then(ae=>ie.input=ae.listen(B,Y)),ie.event}}}e.getDelayedChannel=O;function F(H){let B=!1;return{call(Y,ie,ae){return B?H.call(Y,ie,ae):(0,n.timeout)(0).then(()=>B=!0).then(()=>H.call(Y,ie,ae))},listen(Y,ie){if(B)return H.listen(Y,ie);const ae=new P.Relay;return(0,n.timeout)(0).then(()=>B=!0).then(()=>ae.input=H.listen(Y,ie)),ae.event}}}e.getNextTickChannel=F;class L{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const Y of B.connections)if(await Promise.resolve(this.fn(Y.ctx)))return Promise.resolve(Y);return await P.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=L;var N;(function(H){function B(z,x){const _=z,M=x&&x.disableMarshalling,q=new Map;for(const j in _)ie(j)&&q.set(j,P.Event.buffer(_[j],!0));return new class{listen(j,Z,G){const te=q.get(Z);if(te)return te;if(ae(Z)){const se=_[Z];if(typeof se=="function")return se.call(_,G)}throw new Error(`Event not found: ${Z}`)}call(j,Z,G){const te=_[Z];if(typeof te=="function"){if(!M&&Array.isArray(G))for(let se=0;se<G.length;se++)G[se]=(0,E.revive)(G[se]);return te.apply(_,G)}throw new Error(`Method not found: ${Z}`)}}}H.fromService=B;function Y(z,x){const _=x&&x.disableMarshalling;return new Proxy({},{get(M,q){if(typeof q=="string")return x?.properties?.has(q)?x.properties.get(q):ae(q)?function(j){return z.listen(q,j)}:ie(q)?z.listen(q):async function(...j){let Z;x&&!(0,v.isUndefinedOrNull)(x.context)?Z=[x.context,...j]:Z=j;const G=await z.call(q,Z);return _?G:(0,E.revive)(G)};throw new Error(`Property not found: ${String(q)}`)}})}H.toService=Y;function ie(z){return z[0]==="o"&&z[1]==="n"&&b.isUpperAsciiLetter(z.charCodeAt(2))}function ae(z){return/^onDynamic/.test(z)&&b.isUpperAsciiLetter(z.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const B=H.toString();if(B!=="[object Object]")return B}return H}function J(H){return Array.isArray(H)?H.map(V):V(H)}function $(H,B,Y,ie,ae,z,x){x=J(x);const _=W[ae],M=_[ie%_.length];let q=[`%c[${H}]%c[${String(B).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${M}`];/\($/.test(z)?(q=q.concat(x),q.push(")")):q.push(x),console.log.apply(console,q)}e.logWithColors=$;class Q{constructor(B,Y){this._outgoingPrefix=B,this._incomingPrefix=Y,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,Y,ie,ae,z){this._totalOutgoing+=B,$(this._outgoingPrefix,this._totalOutgoing,B,Y,ie,ae,z)}logIncoming(B,Y,ie,ae,z){this._totalIncoming+=B,$(this._incomingPrefix,this._totalIncoming,B,Y,ie,ae,z)}}e.IPCLogger=Q}),define(ne[132],re([0,1,16,3,39]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class T{constructor(P){this.port=P,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",I=>R.VSBuffer.wrap(I.data)),P.start()}send(P){this.port.postMessage(P.buffer)}disconnect(){this.port.close()}}e.Protocol=T;class A extends k.IPCClient{constructor(P,I){const E=new T(P);super(E,I);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=A}),define(ne[83],re([0,1,16,3,2,39]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var C;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let c=0;function a(m,D){if(!o.has(m)){const U=String(++c);o.set(m,U)}return o.get(m)}function l(m,D,U,O){if(!i.enableDiagnostics)return;const F=a(m,D);if(O instanceof R.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const L=R.VSBuffer.alloc(O.byteLength);L.set(O),i.records.push({timestamp:Date.now(),id:F,label:D,type:U,buff:L})}else i.records.push({timestamp:Date.now(),id:F,label:D,type:U,data:O})}i.traceSocketEvent=l})(C=e.SocketDiagnostics||(e.SocketDiagnostics={}));var P;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function E(){return I||(I=R.VSBuffer.alloc(0)),I}class b{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,c){if(o===0)return E();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const D=this._chunks[0];return c&&(this._chunks.shift(),this._totalLength-=o),D}if(this._chunks[0].byteLength>o){const D=this._chunks[0].slice(0,o);return c&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),D}const a=R.VSBuffer.alloc(o);let l=0,m=0;for(;o>0;){const D=this._chunks[m];if(D.byteLength>o){const U=D.slice(0,o);a.set(U,l),l+=o,c&&(this._chunks[m]=D.slice(o),this._totalLength-=o),o-=o}else a.set(D,l),l+=D.byteLength,c?(this._chunks.shift(),this._totalLength-=D.byteLength):m++,o-=D.byteLength}return a}}e.ChunkStream=b;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(v||(v={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(o,c,a,l){this.type=o,this.id=c,this.ack=a,this.data=l,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends k.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new b,this._register(this._socket.onData(c=>this.acceptChunk(c))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const c=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=c.readUInt32BE(9),this._state.messageType=c.readUInt8(0),this._state.id=c.readUInt32BE(1),this._state.ack=c.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,l=this._state.id,m=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",c),this._onMessage.fire(new S(a,l,m,c)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class p{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const c=R.VSBuffer.alloc(13);c.writeUInt8(o.type,0),c.writeUInt32BE(o.id,1),c.writeUInt32BE(o.ack,5),c.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(c,o.data)}_bufferAdd(o,c){const a=this._totalLength===0;return this._data.push(o,c),this._totalLength+=o.byteLength+c.byteLength,a}_bufferTake(){const o=R.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,c){this._bufferAdd(o,c)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends k.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new p(this._socket)),this._socketReader=this._register(new w(this._socket)),this._register(this._socketReader.onMessage(c=>{c.type===1&&this._onMessage.fire(c.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new S(1,0,0,o))}}e.Protocol=g;class u extends T.IPCClient{constructor(o,c,a=null){super(o,c,a);this.protocol=o}static fromSocket(o,c){return new u(new g(o),c)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=u;class f{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=f;class h{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const o=[];let c=0,a=this._first;for(;a;)o[c++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const c=new h(o);if(!this._first){this._first=c,this._last=c;return}this._last.next=c,this._last=c}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let c=0;c<r._HISTORY_LENGTH;c++)this.lastRuns[c]=o-1e3*c;setInterval(()=>{for(let c=r._HISTORY_LENGTH;c>=1;c--)this.lastRuns[c]=this.lastRuns[c-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),c=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let l=0;l<r._HISTORY_LENGTH;l++)o-this.lastRuns[l]<=c&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class t{constructor(o,c=null,a=r.getInstance()){this._onControlMessage=new f,this.onControlMessage=this._onControlMessage.event,this._onMessage=new f,this.onMessage=this._onMessage.event,this._onDidDispose=new f,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new f,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new f,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(l=>this._receiveMessage(l))),this._socketDisposables.push(this._socket.onClose(l=>this._onSocketClose.fire(l))),c&&this._socketReader.acceptChunk(c)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new S(5,0,0,E());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new S(7,0,0,E());this._socketWriter.write(o)}sendResume(){const o=new S(8,0,0,E());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,c){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new p(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new w(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(c)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o);const c=this._outgoingUnackMsg.toArray();for(let a=0,l=c.length;a<l;a++)this._socketWriter.write(c[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const c=this._outgoingUnackMsg.peek();if(c&&c.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const c=Date.now();c-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=c,this._socketWriter.write(new S(6,0,0,E())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const c=this._outgoingUnackMsg.toArray();for(let a=0,l=c.length;a<l;a++)this._socketWriter.write(c[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const c=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new S(1,c,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const c=new S(2,0,0,o);this._socketWriter.write(c)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),c=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,l=Date.now()-this._lastSocketTimeoutTime;if(c>=2e4&&a>=2e4&&l>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const m=Math.max(2e4-c,2e4-a,2e4-l,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},m)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(ne[133],re([0,1,84,3,39,132]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const P=n.Event.fromNodeEventEmitter(R.ipcRenderer,"vscode:createMessageChannel",(I,E)=>E);return n.Event.map(P,I=>{const{port1:E,port2:b}=new MessageChannel,y={protocol:new T.Protocol(E),onDidClientDisconnect:n.Event.fromDOMEventEmitter(E,"close")};return R.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[b]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(ne[134],re([0,1,16,9,3,2,12,4,31,39,83]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function b(){return{crypto:X.__$__nodeRequire("crypto"),zlib:X.__$__nodeRequire("zlib"),net:X.__$__nodeRequire("net"),os:X.__$__nodeRequire("os")}}class v{constructor(a,l=""){this.debugLabel=l,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=m=>{if(this.traceSocketEvent("error",{code:m?.code,message:m?.message}),m){if(m.code==="EPIPE")return;(0,n.onUnexpectedError)(m)}},this.socket.on("error",this._errorListener)}traceSocketEvent(a,l){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,l)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(a){const l=m=>{this.traceSocketEvent("read",m),a(R.VSBuffer.wrap(m))};return this.socket.on("data",l),{dispose:()=>this.socket.off("data",l)}}onClose(a){const l=m=>{this.traceSocketEvent("close",{hadError:m}),a({type:0,hadError:m,error:void 0})};return this.socket.on("close",l),{dispose:()=>this.socket.off("close",l)}}onEnd(a){const l=()=>{this.traceSocketEvent("nodeEndReceived"),a()};return this.socket.on("end",l),{dispose:()=>this.socket.off("end",l)}}write(a){if(!this.socket.destroyed)try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,l=>{if(l){if(l.code==="EPIPE")return;(0,n.onUnexpectedError)(l)}})}catch(l){if(l.code==="EPIPE")return;(0,n.onUnexpectedError)(l)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,l)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const m=()=>{this.socket.off("close",m),this.socket.off("end",m),this.socket.off("error",m),this.socket.off("timeout",m),this.socket.off("drain",m),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",m),this.socket.on("end",m),this.socket.on("error",m),this.socket.on("timeout",m),this.socket.on("drain",m)})}}e.NodeSocket=v;var y;(function(c){c[c.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var d;(function(c){c[c.PeekHeader=1]="PeekHeader",c[c.ReadHeader=2]="ReadHeader",c[c.ReadBody=3]="ReadBody",c[c.Fin=4]="Fin"})(d||(d={}));class S extends T.Disposable{constructor(a,l,m,D){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:l,inflateBytesLength:m?.byteLength||0,recordInflateBytes:D}),this._flowManager=this._register(new w(this,l,m,D,this._onData,(U,O)=>this._write(U,O))),this._register(this._flowManager.onError(U=>{console.error(U),(0,n.onUnexpectedError)(U),this._onClose.fire({type:0,hadError:!0,error:U})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(U=>this._acceptChunk(U))),this._register(this.socket.onClose(U=>this._onClose.fire(U)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,l){this.socket.traceSocketEvent(a,l)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,l){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let m=2;a.byteLength<126?m+=0:a.byteLength<2**16?m+=2:m+=8;const D=R.VSBuffer.alloc(m);if(l?D.writeUInt8(194,0):D.writeUInt8(130,0),a.byteLength<126)D.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){D.writeUInt8(126,1);let U=1;D.writeUInt8(a.byteLength>>>8&255,++U),D.writeUInt8(a.byteLength>>>0&255,++U)}else{D.writeUInt8(127,1);let U=1;D.writeUInt8(0,++U),D.writeUInt8(0,++U),D.writeUInt8(0,++U),D.writeUInt8(0,++U),D.writeUInt8(a.byteLength>>>24&255,++U),D.writeUInt8(a.byteLength>>>16&255,++U),D.writeUInt8(a.byteLength>>>8&255,++U),D.writeUInt8(a.byteLength>>>0&255,++U)}this.socket.write(R.VSBuffer.concat([D,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const l=this._incomingData.peek(this._state.readLen),m=l.readUInt8(0),D=(m&128)>>>7,U=(m&64)>>>6,O=l.readUInt8(1),F=(O&128)>>>7,L=O&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(L===126?2:0)+(L===127?8:0),this._state.fin=D,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(U)),this._state.firstFrameOfMessage=Boolean(D),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const l=this._incomingData.read(this._state.readLen),m=l.readUInt8(1),D=(m&128)>>>7;let U=m&127,O=1;U===126?U=l.readUInt8(++O)*2**8+l.readUInt8(++O):U===127&&(U=l.readUInt8(++O)*0+l.readUInt8(++O)*0+l.readUInt8(++O)*0+l.readUInt8(++O)*0+l.readUInt8(++O)*2**24+l.readUInt8(++O)*2**16+l.readUInt8(++O)*2**8+l.readUInt8(++O));let F=0;D&&(F=l.readUInt8(++O)*2**24+l.readUInt8(++O)*2**16+l.readUInt8(++O)*2**8+l.readUInt8(++O)),this._state.state=3,this._state.readLen=U,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const l=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",l),u(l,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",l),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(l,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class w extends T.Disposable{constructor(a,l,m,D,U,O){super();this._tracer=a,this._onData=U,this._writeFn=O,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,l?(this._zlibInflateStream=this._register(new p(this._tracer,D,m,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:R.VSBuffer.alloc(0)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const l=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(l,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,l){return new Promise((m,D)=>{a.write(l),a.flush(U=>m(U))})}acceptFrame(a,l,m){this._readQueue.push({data:a,isCompressed:l,isLastFrameOfMessage:m}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const l=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(l)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,l,m){return new Promise((D,U)=>{a.write(l),m&&a.write(R.VSBuffer.fromByteArray([0,0,255,255])),a.flush(O=>D(O))})}}class p extends T.Disposable{constructor(a,l,m,D){super();this._tracer=a,this._recordInflateBytes=l,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=b().zlib.createInflateRaw(D),this._zlibInflate.on("error",U=>{this._tracer.traceSocketEvent("zlibInflateError",{message:U?.message,code:U?.code}),this._onError.fire(U)}),this._zlibInflate.on("data",U=>{this._tracer.traceSocketEvent("zlibInflateData",U),this._pendingInflateData.push(R.VSBuffer.wrap(U))}),m&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",m.buffer),this._zlibInflate.write(m.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?R.VSBuffer.concat(this._recordedInflateBytes):R.VSBuffer.alloc(0)}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const l=R.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(l)})}}class g extends T.Disposable{constructor(a,l){super();this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=b().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",m=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:m?.message,code:m?.code}),this._onError.fire(m)}),this._zlibDeflate.on("data",m=>{this._tracer.traceSocketEvent("zlibDeflateData",m),this._pendingDeflateData.push(R.VSBuffer.wrap(m))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let l=R.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,l=l.slice(0,l.byteLength-4),a(l)})}}function u(c,a){if(a===0)return;const l=c.byteLength>>>2;for(let L=0;L<l;L++){const N=c.readUInt32BE(L*4);c.writeUInt32BE(N^a,L*4)}const m=l*4,D=c.byteLength-m,U=a>>>24&255,O=a>>>16&255,F=a>>>8&255;D>=1&&c.writeUInt8(c.readUInt8(m)^U,m),D>=2&&c.writeUInt8(c.readUInt8(m+1)^O,m+1),D>=3&&c.writeUInt8(c.readUInt8(m+2)^F,m+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const f={[2]:107,[1]:103};function h(){const c=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${c}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${c}.sock`):a=(0,A.join)(b().os.tmpdir(),`vscode-ipc-${c}.sock`),r(a),a}e.createRandomIPCHandle=h;function s(c,a,l){const m=b().crypto.createHash("md5").update(c).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${m}-${l}-${a}-sock`;let D;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?D=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${m.substr(0,8)}-${l}-${a}.sock`):D=(0,A.join)(c,`${l}-${a}.sock`),r(D),D}e.createStaticIPCHandle=s;function r(c){const a=f[C.platform];typeof a=="number"&&c.length>=a&&console.warn(`WARNING: IPC handle "${c}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends I.IPCServer{constructor(a){super(t.toClientConnectionEvent(a));this.server=a}static toClientConnectionEvent(a){const l=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(l,m=>({protocol:new E.Protocol(new v(m,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(m,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function i(c){return new Promise((a,l)=>{const m=b().net.createServer();m.on("error",l),m.listen(c,()=>{m.removeListener("error",l),a(new t(m))})})}e.serve=i;function o(c,a){return new Promise((l,m)=>{const D=b().net.createConnection(c,()=>{D.removeListener("error",m),l(E.Client.fromSocket(new v(D,`ipc-client${a}`),a))});D.once("error",m)})}e.connect=o}),define(ne[85],re([0,1,6,3,2,15]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function C(b){const v=b;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=C;var P;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class I extends k.Disposable{constructor(v,y=Object.create(null)){super();this.database=v,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new R.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((y,d)=>this.accept(d,y)),v.deleted?.forEach(y=>this.accept(y,void 0))}accept(v,y){if(this.state===P.Closed)return;let d=!1;(0,T.isUndefinedOrNull)(y)?d=this.cache.delete(v):this.cache.get(v)!==y&&(this.cache.set(v,y),d=!0),d&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,y){const d=this.cache.get(v);return(0,T.isUndefinedOrNull)(d)?y:d}getBoolean(v,y){const d=this.get(v);return(0,T.isUndefinedOrNull)(d)?y:d==="true"}getNumber(v,y){const d=this.get(v);return(0,T.isUndefinedOrNull)(d)?y:parseInt(d,10)}async set(v,y){if(this.state===P.Closed)return;if((0,T.isUndefinedOrNull)(y))return this.delete(v);const d=String(y);if(this.cache.get(v)!==d)return this.cache.set(v,d),this.pendingInserts.set(v,d),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===P.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert?.forEach((y,d)=>this.items.set(d,y)),v.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=E}),define(ne[135],re([10,11]),function(X,e){return X.create("vs/base/node/processes",e)}),define(ne[86],re([0,1,48,42,20,30,12,4,36,77,15,114,27,135]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return I.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return I.TerminateResponseCode}});function d(h){switch(h){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function S(h,s){if(C.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const t=R.execFile("taskkill",["/T","/F","/PID",h.pid.toString()],r);return new Promise(i=>{t.once("error",o=>{i({success:!1,error:o})}),t.once("exit",(o,c)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?d(r.status):1})}else if(C.isLinux||C.isMacintosh)try{const r=k.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",X).fsPath;return new Promise(t=>{R.execFile(r,[h.pid.toString()],{encoding:"utf8",shell:!0},(i,o,c)=>{t(i?{success:!1,error:i}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else h.kill("SIGKILL");return Promise.resolve({success:!0})}function w(h=P.env){return h.comspec||"cmd.exe"}e.getWindowsShell=w;class p{constructor(s,r,t,i){if(r!==void 0&&t!==void 0&&i!==void 0)this.cmd=s,this.args=r,this.shell=t,this.options=i;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(P.env).forEach(c=>{o[c]=P.env[c]}),Object.keys(this.options.env).forEach(c=>{o[c]=this.options.env[c]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(A.sep);return r!==-1&&(s=s.substring(r+1)),p.WellKnowCommands[s]?s:"other"}start(s){return C.isWindows&&(this.options&&this.options.cwd&&n.isUNC(this.options.cwd)||!this.options&&n.isUNC(P.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(r=>{let t,i;const o=new Promise((c,a)=>{t=c,i=a});if(r){let c=this.cmd;this.args&&(c=c+" "+this.args.join(" ")),this.childProcess=R.exec(c,this.options,(a,l,m)=>{this.childProcess=null;const D=a;D&&D.killed?i({killed:this.terminateRequested,stdout:l.toString(),stderr:m.toString()}):this.handleExec(t,s,a,l,m)})}else{let c=null;const a=l=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(l,t,s,i);const m={terminated:this.terminateRequested};E.isNumber(l)&&(m.cmdCode=l),t(m)};if(this.shell&&C.isWindows){const l=T.deepClone(this.options);l.windowsVerbatimArguments=!0,l.detached=!1;let m=!1,D=!1;const U=[];let O=this.ensureQuotes(this.cmd);U.push(O.value),m=O.quoted,this.args&&this.args.forEach(L=>{O=this.ensureQuotes(L),U.push(O.value),D=D&&O.quoted});const F=["/s","/c"];m?D?F.push('"'+U.join(" ")+'"'):U.length>1?F.push('"'+U[0]+'" '+U.slice(1).join(" ")):F.push('"'+U[0]+'"'):F.push(U.join(" ")),c=R.spawn(w(),F,l)}else this.cmd&&(c=R.spawn(this.cmd,this.args,this.options));c&&(this.childProcess=c,this.childProcessPromise=Promise.resolve(c),this.pidResolve&&(this.pidResolve(E.isNumber(c.pid)?c.pid:-1),this.pidResolve=void 0),c.on("error",l=>{this.childProcess=null,i({terminated:this.terminateRequested,error:l})}),c.pid&&(this.childProcess.on("close",a),this.handleSpawn(c,t,s,i,!0)))}return o})}handleClose(s,r,t,i){}ensureQuotes(s){return p.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,S(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!C.isWindows)return s(!1);const r=R.spawn(w(),["/s","/c"]);r.on("error",t=>s(!0)),r.on("exit",t=>s(!1))})}}e.AbstractProcess=p,p.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},p.regexp=/^[^"].* .*[^"]/;class g extends p{constructor(s,r,t,i){super(s,r,t,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,t,i,o){[i,o].forEach((c,a)=>{const l=new b.LineDecoder;l.write(c).forEach(U=>{r({line:U,source:a===0?0:1})});const D=l.end();D&&r({line:D,source:a===0?0:1})}),s({terminated:this.terminateRequested,error:t})}handleSpawn(s,r,t,i,o){const c=new b.LineDecoder,a=new b.LineDecoder;s.stdout.on("data",l=>{c.write(l).forEach(D=>t({line:D,source:0}))}),s.stderr.on("data",l=>{a.write(l).forEach(D=>t({line:D,source:1}))}),this.stdoutLineDecoder=c,this.stderrLineDecoder=a}handleClose(s,r,t,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&t({line:o,source:0});const c=this.stderrLineDecoder?this.stderrLineDecoder.end():null;c&&t({line:c,source:1})}}e.LineProcess=g;function u(h){let s=[],r=!1;const t=function(i){if(r){s.push(i);return}(!h.send(i,c=>{if(c&&console.error(c),r=!1,s.length>0){const a=s.slice(0);s=[],a.forEach(l=>t(l))}})||C.isWindows)&&(r=!0)};return{send:t}}e.createQueuedSender=u;var f;(function(h){async function s(r,t,i){if(A.isAbsolute(r))return r;if(t===void 0&&(t=P.cwd()),A.dirname(r)!=="."||(i===void 0&&E.isString(P.env.PATH)&&(i=P.env.PATH.split(A.delimiter)),i===void 0||i.length===0))return A.join(t,r);async function c(a){if(await v.Promises.exists(a)){let l;try{l=await v.Promises.stat(a)}catch(m){m.message.startsWith("EACCES")&&(l=await v.Promises.lstat(a))}return l?!l.isDirectory():!1}return!1}for(const a of i){let l;if(A.isAbsolute(a)?l=A.join(a,r):l=A.join(t,a,r),await c(l))return l;let m=l+".com";if(await c(m)||(m=l+".exe",await c(m)))return m}return A.join(t,r)}h.findExecutable=s})(f=e.win32||(e.win32={}))}),define(ne[136],re([0,1,37,4,82,86]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,d){return y===1?n.isWindows?b():T.getWindowsShell(d):I(y,d)}e.getSystemShell=A;function C(y,d){return y===1?n.isWindows?v(d):T.getWindowsShell(d):I(y,d)}e.getSystemShellSync=C;let P=null;function I(y,d){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!P){let S;if(n.isWindows)S="/bin/bash";else{if(S=d.SHELL,!S)try{S=(0,R.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}P=S}return P}let E=null;async function b(){return E||(E=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),E}function v(y){if(E)return E;const d=n.isWindows&&parseFloat((0,R.release)())>=10,S=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),w=`${y.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return d?w:T.getWindowsShell(y)}}),define(ne[64],re([0,1,48,6,16,21,127,9,3,2,30,86,77,39]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class d extends y.ChannelServer{constructor(p){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},p);process.once("disconnect",()=>this.dispose())}}e.Server=d;class S{constructor(p,g){this.modulePath=p,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const u=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(u),this.child=null,this._client=null}getChannel(p){const g=this;return{call(u,f,h){return g.requestPromise(p,u,f,h)},listen(u,f){return g.requestEvent(p,u,f)}}}requestPromise(p,g,u,f=T.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(C.canceled());this.disposeDelayer.cancel();const h=this.getCachedChannel(p),s=(0,n.createCancelablePromise)(i=>h.call(g,u,i)),r=f.onCancellationRequested(()=>s.cancel()),t=(0,I.toDisposable)(()=>s.cancel());return this.activeRequests.add(t),s.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(p,g,u){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let f;const h=new P.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(p).listen(g,u)(h.fire,h),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return h.event}get client(){if(!this._client){const p=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,v.removeDangerousEnvVariables)(g.env),this.child=(0,R.fork)(this.modulePath,p,g);const u=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}u.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const h=this.options.useQueue?(0,b.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&h.send(o.buffer.toString("base64")),r=u.event,t={send:s,onMessage:r};this._client=new y.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,c)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,I.dispose)(a)),this.activeRequests.clear(),o!==0&&c!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+c),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:c})})}return this._client}getCachedChannel(p){let g=this.channels.get(p);return g||(g=this.client.getChannel(p),this.channels.set(p,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(ne[137],re([10,11]),function(X,e){return X.create("vs/base/node/zip",e)}),define(ne[138],re([10,11]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ne[139],re([10,11]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(ne[140],re([10,11]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(ne[141],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ne[142],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ne[143],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ne[144],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(ne[145],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ne[146],re([10,11]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ne[147],re([10,11]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(ne[148],re([10,11]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(ne[149],re([10,11]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(ne[150],re([10,11]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(ne[151],re([10,11]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ne[152],re([10,11]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ne[153],re([10,11]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(ne[154],re([10,11]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(ne[155],re([10,11]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(ne[156],re([10,11]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(ne[157],re([10,11]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(ne[158],re([10,11]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ne[159],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(ne[160],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(ne[161],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(ne[162],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(ne[163],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(ne[164],re([10,11]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(ne[165],re([10,11]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(ne[87],re([0,1,61,60,20,12,36,17,7]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(S,w,p){this._args=S,this.paths=w,this.productService=p,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,T.dirname)(k.FileAccess.asFileUri("",X).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,T.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,C.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,C.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,R.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,T.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,T.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,T.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,C.joinPath)(P.URI.file((0,T.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,C.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,C.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,C.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,T.join)(S,"argv.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,T.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,T.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,T.resolve)(S):(0,T.normalize)((0,T.join)(k.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,T.resolve)(S):(0,T.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,T.resolve)(S);const w=A.env.VSCODE_EXTENSIONS;if(w)return w;const p=A.env.VSCODE_PORTABLE;return p?(0,T.join)(p,"extensions"):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(w=>/^[^:/?#]+?:\/\//.test(w)?P.URI.parse(w):P.URI.file((0,T.normalize)(w)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?P.URI.parse(S):P.URI.file((0,T.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,C.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,T.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,T.join)(S,"policy.json")):(0,C.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}ge([n.memoize],I.prototype,"appRoot",null),ge([n.memoize],I.prototype,"userHome",null),ge([n.memoize],I.prototype,"userDataPath",null),ge([n.memoize],I.prototype,"appSettingsHome",null),ge([n.memoize],I.prototype,"tmpDir",null),ge([n.memoize],I.prototype,"cacheHome",null),ge([n.memoize],I.prototype,"stateResource",null),ge([n.memoize],I.prototype,"userRoamingDataHome",null),ge([n.memoize],I.prototype,"userDataSyncHome",null),ge([n.memoize],I.prototype,"userDataSyncLogResource",null),ge([n.memoize],I.prototype,"editSessionsLogResource",null),ge([n.memoize],I.prototype,"sync",null),ge([n.memoize],I.prototype,"machineSettingsResource",null),ge([n.memoize],I.prototype,"workspaceStorageHome",null),ge([n.memoize],I.prototype,"localHistoryHome",null),ge([n.memoize],I.prototype,"keyboardLayoutResource",null),ge([n.memoize],I.prototype,"argvResource",null),ge([n.memoize],I.prototype,"isExtensionDevelopment",null),ge([n.memoize],I.prototype,"untitledWorkspacesHome",null),ge([n.memoize],I.prototype,"installSourcePath",null),ge([n.memoize],I.prototype,"builtinExtensionsPath",null),ge([n.memoize],I.prototype,"extensionsPath",null),ge([n.memoize],I.prototype,"extensionDevelopmentLocationURI",null),ge([n.memoize],I.prototype,"extensionDevelopmentKind",null),ge([n.memoize],I.prototype,"extensionTestsLocationURI",null),ge([n.memoize],I.prototype,"debugExtensionHost",null),ge([n.memoize],I.prototype,"serviceMachineIdResource",null),ge([n.memoize],I.prototype,"telemetryLogResource",null),ge([n.memoize],I.prototype,"disableWorkspaceTrust",null),ge([n.memoize],I.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=I;function E(d,S){return y(d["inspect-extensions"],d["inspect-brk-extensions"],5870,S,d.debugId,d.extensionEnvironment)}e.parseExtensionHostPort=E;function b(d,S){return y(d["inspect-search"],d["inspect-brk-search"],5876,S,d.extensionEnvironment)}e.parseSearchPort=b;function v(d,S){return y(d["inspect-ptyhost"],d["inspect-brk-ptyhost"],5877,S,d.extensionEnvironment)}e.parsePtyHostPort=v;function y(d,S,w,p,g,u){const h=Number(S||d)||(p?null:w),s=h?Boolean(!!S):!1;let r;if(u)try{r=JSON.parse(u)}catch{}return{port:h,break:s,debugId:g,env:r}}}),define(ne[166],re([0,1,271,4,139]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const T={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(12,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(13,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},category:{type:"string",cat:"e",description:(0,k.localize)(16,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(17,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(19,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(21,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(22,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(24,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(25,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(27,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(28,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(32,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function C(d,S,w=A){const p={},g=["_"],u=[];for(const r in S){const t=S[r];t.alias&&(p[r]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(r),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(u.push(r),t.deprecates&&u.push(...t.deprecates))}const f=R(d,{string:g,boolean:u,alias:p}),h={},s=f;h._=f._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in S){const t=S[r];t.alias&&delete s[t.alias];let i=s[r];if(t.deprecates)for(const o of t.deprecates)s.hasOwnProperty(o)&&(i||(i=s[o],i&&w.onDeprecatedOption(o,t.deprecationMessage||(0,k.localize)(34,null,r))),delete s[o]);if(typeof i!="undefined"){if(t.type==="string[]"){if(Array.isArray(i)||(i=[i]),!t.allowEmptyValue){const o=i.filter(c=>c.length>0);o.length!==i.length&&(w.onEmptyValue(r),i=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(i)?(i=i.pop(),w.onMultipleValues(r,i)):!i&&!t.allowEmptyValue&&(w.onEmptyValue(r),i=void 0));h[r]=i,t.deprecationMessage&&w.onDeprecatedOption(r,t.deprecationMessage)}delete s[r]}for(const r in s)w.onUnknownOption(r);return h}e.parseArgs=C;function P(d,S){let w="";return S.args&&(Array.isArray(S.args)?w=` <${S.args.join("> <")}>`:w=` <${S.args}>`),S.alias?`-${S.alias} --${d}${w}`:`--${d}${w}`}function I(d,S){let w=0;const p=[];for(const h in d){const s=d[h],r=P(h,s);w=Math.max(w,r.length),p.push([r,s.description])}const g=w+2+1;if(S-g<25)return p.reduce((h,s)=>h.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const u=S-g-1,f=[];for(const h of p){const s=h[0],r=b(h[1],u),t=E(g-s.length-2);f.push("  "+s+t+r[0]);for(let i=1;i<r.length;i++)f.push(E(g)+r[i])}return f}e.formatOptions=I;function E(d){return" ".repeat(d)}function b(d,S){const w=[];for(;d.length;){const p=d.length<S?d.length:d.lastIndexOf(" ",S),g=d.slice(0,p).trim();d=d.slice(p),w.push(g)}return w}function v(d,S,w,p,g){const u=process.stdout.isTTY&&process.stdout.columns||80,f=g?.noInputFiles!==!0?`[${(0,k.localize)(35,null)}...]`:"",h=[`${d} ${w}`];h.push(""),h.push(`${(0,k.localize)(36,null)}: ${S} [${(0,k.localize)(37,null)}]${f}`),h.push(""),g?.noPipe!==!0&&(n.isWindows?h.push((0,k.localize)(38,null,S)):h.push((0,k.localize)(39,null,S)),h.push(""));const s={};for(const r in p){const t=p[r];if(t.description&&t.cat){let i=s[t.cat];i||(s[t.cat]=i={}),i[r]=t}}for(const r in s){const t=r,i=s[t];i&&(h.push(T[t]),h.push(...I(i,u)),h.push(""))}return h.join(`
`)}e.buildHelpMessage=v;function y(d,S){return`${d||(0,k.localize)(40,null)}
${S||(0,k.localize)(41,null)}
${process.arch}`}e.buildVersionMessage=y}),define(ne[167],re([0,1,272,140,166]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const T=2048;function A(v,y){const d={onUnknownOption:w=>{console.warn((0,n.localize)(0,null,w))},onMultipleValues:(w,p)=>{console.warn((0,n.localize)(1,null,w,p))},onEmptyValue:w=>{console.warn((0,n.localize)(2,null,w))},onDeprecatedOption:(w,p)=>{console.warn((0,n.localize)(3,null,w,p))}},S=(0,k.parseArgs)(v,k.OPTIONS,y?d:void 0);return S.goto&&S._.forEach(w=>R(/^(\w:)?[^:]+(:\d*){0,2}$/.test(w),(0,n.localize)(4,null))),S["max-memory"]&&R(parseInt(S["max-memory"])>=T,`The max-memory argument cannot be specified lower than ${T} MB.`),S}function C(v){const y=v.findIndex(d=>!/^-/.test(d));if(y>-1)return[...v.slice(0,y),...v.slice(y+1)]}function P(v){let[,...y]=v;process.env.VSCODE_DEV&&(y=C(y)||[]);const d=!b(process.env);return A(y,d)}e.parseMainProcessArgv=P;function I(v){const[,,...y]=v;return A(y,!0)}e.parseCLIProcessArgv=I;function E(v,...y){const d=v.indexOf("--");return d===-1?v.push(...y):v.splice(d,0,...y),v}e.addArg=E;function b(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=b}),function(){"use strict";function X(e,R,n,k){function T(C){const P=A(C),I=[P];return e.isAbsolute(P)||I.unshift(k),e.resolve(...I)}function A(C){const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,n);const E=C["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(b,"AppData","Roaming")}break;case"darwin":I=e.join(R.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(R.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,n)}return{getUserDataPath:T}}if(typeof define=="function")define(ne[168],re([0,273,37,20,17,36]),function(e,R,n,k,T,A){const C=T.dirname(k.FileAccess.asFileUri("",e)),P=e.__$__nodeRequire(T.joinPath(C,"package.json").fsPath);return X(R,n,P.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),R=require("path"),n=require("os");module.exports=X(R,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ne[169],re([0,1,37,87,168]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class T extends n.AbstractNativeEnvironmentService{constructor(C,P){super(C,{homeDir:(0,R.homedir)(),tmpDir:(0,R.tmpdir)(),userDataDir:(0,k.getUserDataPath)(C)},P)}}e.NativeEnvironmentService=T}),define(ne[170],re([0,1,7]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,T=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,C=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(w){const p=w.match(A);return p?p[1]:null}function E(w){if(w.indexOf("://")===-1){const p=w.match(n);return p?I(p[2]):null}try{const p=R.URI.parse(w);if(p.authority)return I(p.authority)}catch{}return null}function b(w,p){const g=new Set;let u;for(;u=C.exec(w);){const h=E(u[1]);h&&g.add(h)}const f=new Set(p);return Array.from(g).map(h=>f.has(h)?h:h.replace(P,"a"))}e.getDomainsOfRemotes=b;function v(w){const p=w.match(T);return p?p[2]:null}function y(w,p,g){return w&&p?(g&&p.endsWith(".git")&&(p=p.substr(0,p.length-4)),p.indexOf("/")===0?`${w}${p}`:`${w}/${p}`):null}function d(w,p){if(w.indexOf("://")===-1){const g=w.match(k);if(g)return y(g[2],g[3],p)}try{const g=R.URI.parse(w);if(g.authority)return y(v(g.authority),g.path,p)}catch{}return null}function S(w,p=!1){const g=[];let u;for(;u=C.exec(w);){const f=d(u[1],p);f&&g.push(f)}return g}e.getRemotes=S}),define(ne[171],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class R{constructor(T){this.channel=T}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(T,A,C,P){return this.channel.call("promptImportantExtensionsInstallNotification",[T,A,C,P])}promptWorkspaceRecommendations(T){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=R;class n{constructor(T){this.service=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,C){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(C[0],C[1],C[2],C[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(ne[65],re([0,1,17,80,147,55]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,C=/^-(\d{4})(\d{2})(\d{2})$/;function P(p){return p=p.trim(),p==="*"||A.test(p)}e.isValidVersionStr=P;function I(p){if(!P(p))return null;if(p=p.trim(),p==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=p.match(A);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function E(p){if(!p)return null;const g=p.majorBase,u=p.majorMustEqual,f=p.minorBase;let h=p.minorMustEqual;const s=p.patchBase;let r=p.patchMustEqual;p.hasCaret&&(g===0||(h=!1),r=!1);let t=0;if(p.preRelease){const i=C.exec(p.preRelease);if(i){const[,o,c,a]=i;t=Date.UTC(Number(o),Number(c)-1,Number(a))}}return{majorBase:g,majorMustEqual:u,minorBase:f,minorMustEqual:h,patchBase:s,patchMustEqual:r,isMinimum:p.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function b(p,g,u){let f;typeof p=="string"?f=E(I(p)):f=p;let h;g instanceof Date?h=g.getTime():typeof g=="string"&&(h=new Date(g).getTime());let s;if(typeof u=="string"?s=E(I(u)):s=u,!f||!s)return!1;const r=f.majorBase,t=f.minorBase,i=f.patchBase;let o=s.majorBase,c=s.minorBase,a=s.patchBase;const l=s.notBefore;let m=s.majorMustEqual,D=s.minorMustEqual,U=s.patchMustEqual;return s.isMinimum?r>o?!0:r<o?!1:t>c?!0:t<c||h&&h<l?!1:i>=a:(r===1&&o===0&&(!m||!D||!U)&&(o=1,c=0,a=0,m=!0,D=!1,U=!1),r<o?!1:r>o?!m:t<c?!1:t>c?!D:i<a?!1:i>a?!U:!(h&&h<l))}e.isValidVersion=b;function v(p,g,u,f,h){const s=[];if(typeof f.publisher!="undefined"&&typeof f.publisher!="string")return s.push([n.default.Error,k.localize(0,null)]),s;if(typeof f.name!="string")return s.push([n.default.Error,k.localize(1,null,"name")]),s;if(typeof f.version!="string")return s.push([n.default.Error,k.localize(2,null,"version")]),s;if(!f.engines)return s.push([n.default.Error,k.localize(3,null,"engines")]),s;if(typeof f.engines.vscode!="string")return s.push([n.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof f.extensionDependencies!="undefined"&&!w(f.extensionDependencies))return s.push([n.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof f.activationEvents!="undefined"){if(!w(f.activationEvents))return s.push([n.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof f.main=="undefined"&&typeof f.browser=="undefined")return s.push([n.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof f.extensionKind!="undefined"&&typeof f.main=="undefined"&&s.push([n.default.Warning,k.localize(8,null,"extensionKind")]),typeof f.main!="undefined"){if(typeof f.main!="string")return s.push([n.default.Error,k.localize(9,null,"main")]),s;{const i=(0,R.joinPath)(u,f.main);(0,R.isEqualOrParent)(i,u)||s.push([n.default.Warning,k.localize(10,null,i.path,u.path)])}if(typeof f.activationEvents=="undefined")return s.push([n.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof f.browser!="undefined"){if(typeof f.browser!="string")return s.push([n.default.Error,k.localize(12,null,"browser")]),s;{const i=(0,R.joinPath)(u,f.browser);(0,R.isEqualOrParent)(i,u)||s.push([n.default.Warning,k.localize(13,null,i.path,u.path)])}if(typeof f.activationEvents=="undefined")return s.push([n.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!T.valid(f.version))return s.push([n.default.Error,k.localize(15,null)]),s;const r=[];if(!y(p,g,f,h,r))for(const i of r)s.push([n.default.Error,i]);return s}e.validateExtensionManifest=v;function y(p,g,u,f,h){return f||typeof u.main=="undefined"&&typeof u.browser=="undefined"?!0:S(p,g,u.engines.vscode,h)}e.isValidExtensionVersion=y;function d(p,g,u){return p==="*"||S(g,u,p)}e.isEngineValid=d;function S(p,g,u,f=[]){const h=E(I(u));if(!h)return f.push(k.localize(16,null,u)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return f.push(k.localize(17,null,u)),!1}else if(!h.majorMustEqual)return f.push(k.localize(18,null,u)),!1;return b(p,g,h)?!0:(f.push(k.localize(19,null,p,u)),!1)}function w(p){if(!Array.isArray(p))return!1;for(let g=0,u=p.length;g<u;g++)if(typeof p[g]!="string")return!1;return!0}}),define(ne[49],re([0,1,16,31]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(T,A,C){let P=C&&C.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await A.readFile(T.serviceMachineIdResource)).value.toString();P=(0,n.isUUID)(E)?E:null}catch{P=null}if(!P){P=(0,n.generateUuid)();try{await A.writeFile(T.serviceMachineIdResource,R.VSBuffer.fromString(P))}catch{}}return C?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=k}),define(ne[56],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class R{constructor(k,T=[],A=!1){this.ctor=k,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=R}),define(ne[88],re([0,1,56]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function k(A,C,P){C instanceof R.SyncDescriptor||(C=new R.SyncDescriptor(C,[],P)),n.push([A,C])}e.registerSingleton=k;function T(){return n}e.getSingletonServiceDescriptors=T}),define(ne[172],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class R{constructor(T){this.incoming=new Map,this.outgoing=new Map,this.data=T}}e.Node=R;class n{constructor(T){this._hashFn=T,this._nodes=new Map}roots(){const T=[];for(const A of this._nodes.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const C=this.lookupOrInsertNode(T),P=this.lookupOrInsertNode(A);C.outgoing.set(this._hashFn(A),P),P.incoming.set(this._hashFn(T),C)}removeNode(T){const A=this._hashFn(T);this._nodes.delete(A);for(const C of this._nodes.values())C.outgoing.delete(A),C.incoming.delete(A)}lookupOrInsertNode(T){const A=this._hashFn(T);let C=this._nodes.get(A);return C||(C=new R(T),this._nodes.set(A,C)),C}lookup(T){return this._nodes.get(this._hashFn(T))}isEmpty(){return this._nodes.size===0}toString(){const T=[];for(const[A,C]of this._nodes)T.push(`${A}, (incoming)[${[...C.incoming.keys()].join(", ")}], (outgoing)[${[...C.outgoing.keys()].join(",")}]`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this._nodes){const C=new Set([T]),P=this._findCycle(A,C);if(P)return P}}_findCycle(T,A){for(const[C,P]of T.outgoing){if(A.has(C))return[...A,C].join(" -> ");A.add(C);const I=this._findCycle(P,A);if(I)return I;A.delete(C)}}}e.Graph=n}),define(ne[5],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var R;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function C(P){return P[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=C})(R=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function n(A,C,P){C[R.DI_TARGET]===C?C[R.DI_DEPENDENCIES].push({id:A,index:P}):(C[R.DI_DEPENDENCIES]=[{id:A,index:P}],C[R.DI_TARGET]=C)}function k(A){if(R.serviceIds.has(A))return R.serviceIds.get(A);const C=function(P,I,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(C,P,E)};return C.toString=()=>A,R.serviceIds.set(A,C),C}e.createDecorator=k;function T(A){return A}e.refineServiceDecorator=T}),define(ne[173],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,R.createDecorator)("checksumService")}),define(ne[19],re([0,1,15,7,5]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function T(p){return p&&typeof p=="object"&&(!p.overrideIdentifier||typeof p.overrideIdentifier=="string")&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationOverrides=T;function A(p){return p&&typeof p=="object"&&(!p.overrideIdentifiers||Array.isArray(p.overrideIdentifiers))&&!p.overrideIdentifier&&(!p.resource||p.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var C;(function(p){p[p.APPLICATION=1]="APPLICATION",p[p.USER=2]="USER",p[p.USER_LOCAL=3]="USER_LOCAL",p[p.USER_REMOTE=4]="USER_REMOTE",p[p.WORKSPACE=5]="WORKSPACE",p[p.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",p[p.DEFAULT=7]="DEFAULT",p[p.MEMORY=8]="MEMORY"})(C=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(p){switch(p){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function I(p,g){const u=Object.create(null);for(const f in p)E(u,f,p[f],g);return u}e.toValuesTree=I;function E(p,g,u,f){const h=g.split("."),s=h.pop();let r=p;for(let t=0;t<h.length;t++){const i=h[t];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":break;default:f(`Ignoring ${g} as ${h.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=u}catch{f(`Ignoring ${g} as ${h.join(".")} is ${JSON.stringify(r)}`)}else f(`Ignoring ${g} as ${h.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=E;function b(p,g){const u=g.split(".");v(p,u)}e.removeFromValueTree=b;function v(p,g){const u=g.shift();if(g.length===0){delete p[u];return}if(Object.keys(p).indexOf(u)!==-1){const f=p[u];typeof f=="object"&&!Array.isArray(f)&&(v(f,g),Object.keys(f).length===0&&delete p[u])}}function y(p,g,u){function f(r,t){let i=r;for(const o of t){if(typeof i!="object"||i===null)return;i=i[o]}return i}const h=g.split("."),s=f(p,h);return typeof s=="undefined"?u:s}e.getConfigurationValue=y;function d(p,g,u){Object.keys(g).forEach(f=>{f!=="__proto__"&&(f in p?R.isObject(p[f])&&R.isObject(g[f])?d(p[f],g[f],u):u&&(p[f]=g[f]):p[f]=g[f])})}e.merge=d;function S(p,g,u){const f=p.inspect(g),h=p.inspect(u);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:f.defaultValue}e.getMigratedSettingValue=S;function w(p){return p.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(ne[174],re([0,1,4,26,5]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const T=new Map;T.set("false",!1),T.set("true",!0),T.set("isMac",R.isMacintosh),T.set("isLinux",R.isLinux),T.set("isWindows",R.isWindows),T.set("isWeb",R.isWeb),T.set("isMacNative",R.isMacintosh&&!R.isWeb),T.set("isEdge",R.isEdge),T.set("isFirefox",R.isFirefox),T.set("isChrome",R.isChrome),T.set("isSafari",R.isSafari);const A=Object.prototype.hasOwnProperty;var C;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(C=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return b.INSTANCE}static true(){return v.INSTANCE}static has(L){return y.create(L)}static equals(L,N){return d.create(L,N)}static notEquals(L,N){return p.create(L,N)}static regex(L,N){return t.create(L,N)}static in(L,N){return S.create(L,N)}static notIn(L,N){return w.create(L,N)}static not(L){return g.create(L)}static and(...L){return c.create(L,null)}static or(...L){return a.create(L,null,!0)}static greater(L,N){return f.create(L,N)}static greaterEquals(L,N){return h.create(L,N)}static smaller(L,N){return s.create(L,N)}static smallerEquals(L,N){return r.create(L,N)}static deserialize(L,N=!1){if(!!L)return this._deserializeOrExpression(L,N)}static _deserializeOrExpression(L,N){const W=L.split("||");return a.create(W.map(V=>this._deserializeAndExpression(V,N)),null,!0)}static _deserializeAndExpression(L,N){const W=L.split("&&");return c.create(W.map(V=>this._deserializeOne(V,N)),null)}static _deserializeOne(L,N){if(L=L.trim(),L.indexOf("!=")>=0){const W=L.split("!=");return p.create(W[0].trim(),this._deserializeValue(W[1],N))}if(L.indexOf("==")>=0){const W=L.split("==");return d.create(W[0].trim(),this._deserializeValue(W[1],N))}if(L.indexOf("=~")>=0){const W=L.split("=~");return t.create(W[0].trim(),this._deserializeRegexValue(W[1],N))}if(L.indexOf(" not in ")>=0){const W=L.split(" not in ");return w.create(W[0].trim(),W[1].trim())}if(L.indexOf(" in ")>=0){const W=L.split(" in ");return S.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(L)){const W=L.split(">=");return h.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(L)){const W=L.split(">");return f.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(L)){const W=L.split("<=");return r.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(L)){const W=L.split("<");return s.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(L)?g.create(L.substr(1).trim()):y.create(L)}static _deserializeValue(L,N){if(L=L.trim(),L==="true")return!0;if(L==="false")return!1;const W=/^'([^']*)'$/.exec(L);return W?W[1].trim():L}static _deserializeRegexValue(L,N){if((0,n.isFalsyOrWhitespace)(L)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const W=L.indexOf("/"),V=L.lastIndexOf("/");if(W===V||W<0){if(N)throw new Error(`bad regexp-value '${L}', missing /-enclosure`);return console.warn(`bad regexp-value '${L}', missing /-enclosure`),null}const J=L.slice(W+1,V),$=L[V+1]==="i"?"i":"";try{return new RegExp(J,$)}catch(Q){if(N)throw new Error(`bad regexp-value '${L}', parse error: ${Q}`);return console.warn(`bad regexp-value '${L}', parse error: ${Q}`),null}}}e.ContextKeyExpr=P;function I(F,L){const N=F?F.substituteConstants():void 0,W=L?L.substituteConstants():void 0;return!N&&!W?!0:!N||!W?!1:N.equals(W)}e.expressionsAreEqualWithConstantSubstitution=I;function E(F,L){return F.cmp(L)}class b{constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class v{constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class y{constructor(L,N){this.key=L,this.negated=N,this.type=2}static create(L,N=null){const W=T.get(L);return typeof W=="boolean"?W?v.INSTANCE:b.INSTANCE:new y(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:m(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?v.INSTANCE:b.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class d{constructor(L,N,W){this.key=L,this.value=N,this.negated=W,this.type=4}static create(L,N,W=null){if(typeof N=="boolean")return N?y.create(L,W):g.create(L,W);const V=T.get(L);return typeof V=="boolean"?N===(V?"true":"false")?v.INSTANCE:b.INSTANCE:new d(L,N,W)}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?v.INSTANCE:b.INSTANCE}return this}evaluate(L){return L.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(L){return L.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=p.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=d;class S{constructor(L,N){this.key=L,this.valueKey=N,this.type=10,this.negated=null}static create(L,N){return new S(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.valueKey,L.key,L.valueKey)}equals(L){return L.type===this.type?this.key===L.key&&this.valueKey===L.valueKey:!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.valueKey),W=L.getValue(this.key);return Array.isArray(N)?N.includes(W):typeof W=="string"&&typeof N=="object"&&N!==null?A.call(N,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(L){return L.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=w.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class w{constructor(L,N){this.key=L,this.valueKey=N,this.type=11,this._negated=S.create(L,N)}static create(L,N){return new w(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:this._negated.cmp(L._negated)}equals(L){return L.type===this.type?this._negated.equals(L._negated):!1}substituteConstants(){return this}evaluate(L){return!this._negated.evaluate(L)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(L){return L.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=w;class p{constructor(L,N,W){this.key=L,this.value=N,this.negated=W,this.type=5}static create(L,N,W=null){if(typeof N=="boolean")return N?g.create(L,W):y.create(L,W);const V=T.get(L);return typeof V=="boolean"?N===(V?"true":"false")?b.INSTANCE:v.INSTANCE:new p(L,N,W)}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){const L=T.get(this.key);if(typeof L=="boolean"){const N=L?"true":"false";return this.value===N?b.INSTANCE:v.INSTANCE}return this}evaluate(L){return L.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(L){return L.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=p;class g{constructor(L,N){this.key=L,this.negated=N,this.type=3}static create(L,N=null){const W=T.get(L);return typeof W=="boolean"?W?b.INSTANCE:v.INSTANCE:new g(L,N)}cmp(L){return L.type!==this.type?this.type-L.type:m(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=T.get(this.key);return typeof L=="boolean"?L?b.INSTANCE:v.INSTANCE:this}evaluate(L){return!L.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(L){return L.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function u(F,L){if(typeof F=="string"){const N=parseFloat(F);isNaN(N)||(F=N)}return typeof F=="string"||typeof F=="number"?L(F):b.INSTANCE}class f{constructor(L,N,W){this.key=L,this.value=N,this.negated=W,this.type=12}static create(L,N,W=null){return u(N,V=>new f(L,V,W))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=f;class h{constructor(L,N,W){this.key=L,this.value=N,this.negated=W,this.type=13}static create(L,N,W=null){return u(N,V=>new h(L,V,W))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(L){return L.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=h;class s{constructor(L,N,W){this.key=L,this.value=N,this.negated=W,this.type=14}static create(L,N,W=null){return u(N,V=>new s(L,V,W))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=h.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class r{constructor(L,N,W){this.key=L,this.value=N,this.negated=W,this.type=15}static create(L,N,W=null){return u(N,V=>new r(L,V,W))}cmp(L){return L.type!==this.type?this.type-L.type:D(this.key,this.value,L.key,L.value)}equals(L){return L.type===this.type?this.key===L.key&&this.value===L.value:!1}substituteConstants(){return this}evaluate(L){return typeof this.value=="string"?!1:parseFloat(L.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(L){return L.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(L,N){this.key=L,this.regexp=N,this.type=7,this.negated=null}static create(L,N){return new t(L,N)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.key<L.key)return-1;if(this.key>L.key)return 1;const N=this.regexp?this.regexp.source:"",W=L.regexp?L.regexp.source:"";return N<W?-1:N>W?1:0}equals(L){if(L.type===this.type){const N=this.regexp?this.regexp.source:"",W=L.regexp?L.regexp.source:"";return this.key===L.key&&N===W}return!1}substituteConstants(){return this}evaluate(L){const N=L.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const L=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${L}`}keys(){return[this.key]}map(L){return L.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class i{constructor(L){this._actual=L,this.type=8}static create(L){return new i(L)}cmp(L){return L.type!==this.type?this.type-L.type:this._actual.cmp(L._actual)}equals(L){return L.type===this.type?this._actual.equals(L._actual):!1}substituteConstants(){return this}evaluate(L){return!this._actual.evaluate(L)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(L){return new i(this._actual.map(L))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function o(F){let L=null;for(let N=0,W=F.length;N<W;N++){const V=F[N].substituteConstants();if(F[N]!==V&&L===null){L=[];for(let J=0;J<N;J++)L[J]=F[J]}L!==null&&(L[N]=V)}return L===null?F:L}class c{constructor(L,N){this.expr=L,this.negated=N,this.type=6}static create(L,N){return c._normalizeArr(L,N)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const V=E(this.expr[N],L.expr[N]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:c.create(L,this.negated)}evaluate(L){for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].evaluate(L))return!1;return!0}static _normalizeArr(L,N){const W=[];let V=!1;for(const J of L)if(!!J){if(J.type===1){V=!0;continue}if(J.type===0)return b.INSTANCE;if(J.type===6){W.push(...J.expr);continue}W.push(J)}if(W.length===0&&V)return v.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(E);for(let J=1;J<W.length;J++)W[J-1].equals(W[J])&&(W.splice(J,1),J--);if(W.length===1)return W[0];for(;W.length>1;){const J=W[W.length-1];if(J.type!==9)break;W.pop();const $=W.pop(),Q=W.length===0,H=a.create(J.expr.map(B=>c.create([B,$],null)),null,Q);H&&(W.push(H),W.sort(E))}return W.length===1?W[0]:new c(W,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new c(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());this.negated=a.create(L,this,!0)}return this.negated}}class a{constructor(L,N){this.expr=L,this.negated=N,this.type=9}static create(L,N,W){return a._normalizeArr(L,N,W)}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const V=E(this.expr[N],L.expr[N]);if(V!==0)return V}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(L.expr[N]))return!1;return!0}return!1}substituteConstants(){const L=o(this.expr);return L===this.expr?this:a.create(L,this.negated,!1)}evaluate(L){for(let N=0,W=this.expr.length;N<W;N++)if(this.expr[N].evaluate(L))return!0;return!1}static _normalizeArr(L,N,W){let V=[],J=!1;if(L){for(let $=0,Q=L.length;$<Q;$++){const H=L[$];if(!!H){if(H.type===0){J=!0;continue}if(H.type===1)return v.INSTANCE;if(H.type===9){V=V.concat(H.expr);continue}V.push(H)}}if(V.length===0&&J)return b.INSTANCE;V.sort(E)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(W){for(let $=0;$<V.length;$++)for(let Q=$+1;Q<V.length;Q++)U(V[$],V[Q])&&(V.splice(Q,1),Q--);if(V.length===1)return V[0]}return new a(V,N)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const N of this.expr)L.push(...N.keys());return L}map(L){return new a(this.expr.map(N=>N.map(L)),null)}negate(){if(!this.negated){const L=[];for(const N of this.expr)L.push(N.negate());for(;L.length>1;){const N=L.shift(),W=L.shift(),V=[];for(const $ of O(N))for(const Q of O(W))V.push(c.create([$,Q],null));const J=L.length===0;L.unshift(a.create(V,null,J))}this.negated=L[0]}return this.negated}}class l extends y{constructor(L,N,W){super(L,null);this._defaultValue=N,typeof W=="object"?l._info.push({...W,key:L}):W!==!0&&l._info.push({key:L,description:W,type:N!=null?typeof N:void 0})}static all(){return l._info.values()}bindTo(L){return L.createKey(this.key,this._defaultValue)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return d.create(this.key,L)}notEqualsTo(L){return p.create(this.key,L)}}e.RawContextKey=l,l._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function m(F,L){return F<L?-1:F>L?1:0}function D(F,L,N,W){return F<N?-1:F>N?1:L<W?-1:L>W?1:0}function U(F,L){if(L.type===6&&F.type!==9&&F.type!==6){for(const V of L.expr)if(F.equals(V))return!0}const N=F.negate(),W=O(N).concat(O(L));W.sort(E);for(let V=0;V<W.length;V++){const $=W[V].negate();for(let Q=V+1;Q<W.length;Q++){const H=W[Q];if($.equals(H))return!0}}return!1}e.implies=U;function O(F){return F.type===9?F.expr:[F]}}),define(ne[89],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,R.createDecorator)(e.ID);function n(T){return!!T.hostName&&!!T.errorMessage}e.isRemoteDiagnosticError=n;class k{async getPerformanceInfo(A,C){return{}}async getSystemInfo(A,C){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,C){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(ne[90],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,R.createDecorator)("downloadService")}),define(ne[14],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,R.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,R.refineServiceDecorator)(e.IEnvironmentService)}),define(ne[28],re([0,1,142,5]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function T(p){switch(p){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=T;function A(p,g){switch(p){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function C(p,g){return g==="web"&&!p.includes("web")}e.isNotWebExtensionInWebTargetPlatform=C;function P(p,g,u){return C(g,u)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===u?!0:I(u).includes(p)}e.isTargetPlatformCompatible=P;function I(p){switch(p){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function E(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.isIExtensionIdentifier=E;var b;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(b=e.SortBy||(e.SortBy={}));var v;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var y;(function(p){p.Install="install",p.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var d;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(d=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var S;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatiblePreRelease="IncompatiblePreRelease",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.Extract="Extract",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class w extends Error{constructor(g,u){super(g);this.code=u,this.name=u}}e.ExtensionManagementError=w,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,n.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,R.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,R.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,n.createDecorator)("IDefaultExtensionsProfileInitService")}),define(ne[175],re([0,1,3,2,63,30,7,128,28]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(w,p){return A.URI.revive(p?p.transformIncoming(w):w)}function E(w,p){return p?p.transformOutgoingURI(w):w}function b(w,p){p=p||C.DefaultURITransformer;const g=w.manifest;return{...(0,C.transformAndReviveIncomingURIs)({...w,manifest:void 0},p),manifest:g}}function v(w,p){return p?(0,T.cloneAndChange)(w,g=>g instanceof A.URI?p.transformOutgoingURI(g):void 0):w}class y{constructor(p,g){this.service=p,this.getUriTransformer=g,this.onInstallExtension=R.Event.buffer(p.onInstallExtension,!0),this.onDidInstallExtensions=R.Event.buffer(p.onDidInstallExtensions,!0),this.onUninstallExtension=R.Event.buffer(p.onUninstallExtension,!0),this.onDidUninstallExtension=R.Event.buffer(p.onDidUninstallExtension,!0)}listen(p,g){const u=this.getUriTransformer(p);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return R.Event.map(this.onDidInstallExtensions,f=>f.map(h=>({...h,local:h.local?v(h.local,u):h.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(p,g,u){const f=this.getUriTransformer(p);switch(g){case"zip":return this.service.zip(b(u[0],f)).then(h=>E(h,f));case"unzip":return this.service.unzip(I(u[0],f));case"install":return this.service.install(I(u[0],f),(0,k.revive)(u[1]));case"getManifest":return this.service.getManifest(I(u[0],f));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(u[0]);case"installFromGallery":return this.service.installFromGallery(u[0],(0,k.revive)(u[1]));case"uninstall":return this.service.uninstall(b(u[0],f),(0,k.revive)(u[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(b(u[0],f));case"getInstalled":return this.service.getInstalled(u[0],A.URI.revive(u[1])).then(h=>h.map(s=>v(s,f)));case"getMetadata":return this.service.getMetadata(b(u[0],f));case"updateMetadata":return this.service.updateMetadata(b(u[0],f),u[1]).then(h=>v(h,f));case"updateExtensionScope":return this.service.updateExtensionScope(b(u[0],f),u[1]).then(h=>v(h,f));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class d extends n.Disposable{constructor(p){super();this.channel=p,this._onInstallExtension=this._register(new R.Emitter),this._onDidInstallExtensions=this._register(new R.Emitter),this._onUninstallExtension=this._register(new R.Emitter),this._onDidUninstallExtension=this._register(new R.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(u=>({...u,local:u.local?b(u.local,null):u.local,source:this.isUriComponents(u.source)?A.URI.revive(u.source):u.source,profileLocation:A.URI.revive(u.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:A.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(p){return p?typeof p.path=="string"&&typeof p.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(p){const g=await this.getTargetPlatform();return p.allTargetPlatforms.some(u=>(0,P.isTargetPlatformCompatible)(u,p.allTargetPlatforms,g))}zip(p){return Promise.resolve(this.channel.call("zip",[p]).then(g=>A.URI.revive(g)))}unzip(p){return Promise.resolve(this.channel.call("unzip",[p]))}install(p,g){return Promise.resolve(this.channel.call("install",[p,g])).then(u=>b(u,null))}getManifest(p){return Promise.resolve(this.channel.call("getManifest",[p]))}installFromGallery(p,g){return Promise.resolve(this.channel.call("installFromGallery",[p,g])).then(u=>b(u,null))}uninstall(p,g){return Promise.resolve(this.channel.call("uninstall",[p,g]))}reinstallFromGallery(p){return Promise.resolve(this.channel.call("reinstallFromGallery",[p]))}getInstalled(p=null,g){return Promise.resolve(this.channel.call("getInstalled",[p,g])).then(u=>u.map(f=>b(f,null)))}getMetadata(p){return Promise.resolve(this.channel.call("getMetadata",[p]))}updateMetadata(p,g){return Promise.resolve(this.channel.call("updateMetadata",[p,g])).then(u=>b(u,null))}updateExtensionScope(p,g){return Promise.resolve(this.channel.call("updateExtensionScope",[p,g])).then(u=>b(u,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=d;class S{constructor(p){this.service=p}listen(p,g){throw new Error("Invalid listen")}call(p,g,u){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(u[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(ne[91],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var T;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(T=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,R.createDecorator)("IExtensionRecommendationNotificationService")}),define(ne[13],re([0,1,34,12,26,15,7,149,5]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function I($){return $.create===!0}e.isFileOpenForWriteOptions=I;var E;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var b;(function($){$[$.Readonly=1]="Readonly"})(b=e.FilePermission||(e.FilePermission={}));var v;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y($){return!!($.capabilities&2)}e.hasReadWriteCapability=y;function d($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=d;function S($){return!!($.capabilities&32768)}e.hasFileCloneCapability=S;function w($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=w;function p($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=p;function g($){return y($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var u;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(u=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class f extends Error{constructor(Q,H){super(Q);this.code=H}}e.FileSystemProviderError=f;function h($,Q){const H=new f($.toString(),Q);return r(H,Q),H}e.createFileSystemProviderError=h;function s($){return $||h((0,C.localize)(0,null),u.Unknown)}e.ensureFileSystemProviderError=s;function r($,Q){return $.name=Q?`${Q} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=r;function t($){if(!$)return u.Unknown;if($ instanceof f)return $.code;const Q=/^(.+) \(FileSystemError\)$/.exec($.name);if(!Q)return u.Unknown;switch(Q[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.toFileSystemProviderErrorCode=t;function i($){if($ instanceof D)return $.fileOperationResult;switch(t($)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var o;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class c{constructor(Q,H,B){this.resource=Q,this.operation=H,this.target=B}isOperation(Q){return this.operation===Q}}e.FileOperationEvent=c;var a;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class l{constructor(Q,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=Q;const B=new Map;for(const Y of Q){const ie=B.get(Y.type);switch(ie?ie.push([Y.resource,Y]):B.set(Y.type,[[Y.resource,Y]]),Y.type){case 1:this.rawAdded.push(Y.resource);break;case 0:this.rawUpdated.push(Y.resource);break;case 2:this.rawDeleted.push(Y.resource);break}}for(const[Y,ie]of B)switch(Y){case 1:this.added=R.TernarySearchTree.forUris(()=>H),this.added.fill(ie);break;case 0:this.updated=R.TernarySearchTree.forUris(()=>H),this.updated.fill(ie);break;case 2:this.deleted=R.TernarySearchTree.forUris(()=>H),this.deleted.fill(ie);break}}contains(Q,...H){return this.doContains(Q,{includeChildren:!1},...H)}affects(Q,...H){return this.doContains(Q,{includeChildren:!0},...H)}doContains(Q,H,...B){if(!Q)return!1;const Y=B.length>0;return!!((!Y||B.includes(1))&&(this.added?.get(Q)||H.includeChildren&&this.added?.findSuperstr(Q))||(!Y||B.includes(0))&&(this.updated?.get(Q)||H.includeChildren&&this.updated?.findSuperstr(Q))||(!Y||B.includes(2))&&(this.deleted?.findSubstr(Q)||H.includeChildren&&this.deleted?.findSuperstr(Q)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=l;function m($,Q,H){return!$||!Q||$===Q||Q.length>$.length?!1:(Q.charAt(Q.length-1)!==n.sep&&(Q+=n.sep),H?(0,k.startsWithIgnoreCase)($,Q):$.indexOf(Q)===0)}e.isParent=m;class D extends Error{constructor(Q,H,B){super(Q);this.fileOperationResult=H,this.options=B}}e.FileOperationError=D;class U extends D{constructor(Q,H,B){super(Q,2,B);this.stat=H}}e.NotModifiedSinceFileOperationError=U;var O;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function L($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=L;async function N($,Q){if(!Q.hasProvider(A.URI.from({scheme:$.scheme})))return new Promise(H=>{const B=Q.onDidChangeFileSystemProviderRegistrations(Y=>{Y.scheme===$.scheme&&Y.added&&(B.dispose(),H())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(Q){return(0,T.isNumber)(Q)||(Q=0),Q<W.KB?(0,C.localize)(1,null,Q.toFixed(0)):Q<W.MB?(0,C.localize)(2,null,(Q/W.KB).toFixed(2)):Q<W.GB?(0,C.localize)(3,null,(Q/W.MB).toFixed(2)):Q<W.TB?(0,C.localize)(4,null,(Q/W.GB).toFixed(2)):(0,C.localize)(5,null,(Q/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var V;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function J($){return{maxFileSize:$===0?300*W.MB:16*W.GB,maxHeapSize:$===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=J});var K=this&&this.__param||function(X,e){return function(R,n){e(R,n,X)}};define(ne[176],re([0,1,177,41,13]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let T=class{constructor(C){this.fileService=C}async checksum(C){const P=(await this.fileService.readFileStream(C)).value;return new Promise((I,E)=>{const b=(0,R.createHash)("md5");(0,n.listenStream)(P,{onData:v=>b.update(v.buffer),onError:v=>E(v),onEnd:()=>I(b.digest("base64").replace(/=+$/,""))})})}};T=ge([K(0,k.IFileService)],T),e.ChecksumService=T}),define(ne[178],re([0,1,16,38,9,3,2,41,7,31,13]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends A.Disposable{constructor(y,d){super();this.channel=y,this.extraCapabilities=d,this.onDidChangeCapabilities=T.Event.None,this._onDidChange=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,d){const{buffer:S}=await this.channel.call("readFile",[y,d]);return S}readFileStream(y,d,S){const w=(0,C.newWriteableStream)(g=>R.VSBuffer.concat(g.map(u=>R.VSBuffer.wrap(u))).buffer),p=this.channel.listen("readFileStream",[y,d])(g=>{if(g instanceof R.VSBuffer)w.write(g.buffer);else{if(g==="end")w.end();else{let u=g;u instanceof Error||(u=(0,E.createFileSystemProviderError)((0,n.toErrorMessage)(u),E.FileSystemProviderErrorCode.Unknown)),w.error(u),w.end()}p.dispose()}});return S.onCancellationRequested(()=>{w.error((0,k.canceled)()),w.end(),p.dispose()}),w}writeFile(y,d,S){return this.channel.call("writeFile",[y,R.VSBuffer.wrap(d),S])}open(y,d){return this.channel.call("open",[y,d])}close(y){return this.channel.call("close",[y])}async read(y,d,S,w,p){const[g,u]=await this.channel.call("read",[y,d,p]);return S.set(g.buffer.slice(0,u),w),u}write(y,d,S,w,p){return this.channel.call("write",[y,d,R.VSBuffer.wrap(S),w,p])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,d){return this.channel.call("delete",[y,d])}rename(y,d,S){return this.channel.call("rename",[y,d,S])}copy(y,d,S){return this.channel.call("copy",[y,d,S])}cloneFile(y,d){return this.channel.call("cloneFile",[y,d])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const d=y;this._onDidChange.fire(d.map(S=>({resource:P.URI.revive(S.resource),type:S.type})))}else{const d=y;this._onDidWatchError.fire(d)}}))}watch(y,d){const S=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,S,y,d]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=b}),define(ne[92],re([0,1,16,9,150,13]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(E,b,v,y,d,S){let w;try{await C(E,b,v,y,d,S)}catch(p){w=p}finally{w&&d.errorTransformer&&(w=d.errorTransformer(w)),typeof w!="undefined"&&v.error(w),v.end()}}e.readFileIntoStream=A;async function C(E,b,v,y,d,S){P(S);const w=await E.open(b,{create:!1});try{P(S);let p=0,g=0,u=d&&typeof d.length=="number"?d.length:void 0,f=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),h=d&&typeof d.position=="number"?d.position:0,s=0;do g=await E.read(w,h,f.buffer,s,f.byteLength-s),h+=g,s+=g,p+=g,typeof u=="number"&&(u-=g),s===f.byteLength&&(await v.write(y(f)),f=R.VSBuffer.alloc(Math.min(d.bufferSize,typeof u=="number"?u:d.bufferSize)),s=0);while(g>0&&(typeof u!="number"||u>0)&&P(S)&&I(p,d));if(s>0){let r=s;typeof u=="number"&&(r=Math.min(s,u)),v.write(y(f.slice(0,r)))}}catch(p){throw(0,T.ensureFileSystemProviderError)(p)}finally{await E.close(w)}}function P(E){if(E.isCancellationRequested)throw(0,n.canceled)();return!0}function I(E,b){if(b?.limits){if(typeof b.limits.memory=="number"&&E>b.limits.memory)throw(0,T.createFileSystemProviderError)((0,k.localize)(0,null),T.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof b.limits.size=="number"&&E>b.limits.size)throw(0,T.createFileSystemProviderError)((0,k.localize)(1,null),T.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(ne[57],re([0,1,81,2,12,4,7,13]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(p){return p.recursive===!0}e.isRecursiveWatchRequest=P;class I extends n.Disposable{constructor(g,u,f,h){super();this.onFileChanges=g,this.onLogMessage=u,this.verboseLogging=f,this.options=h,this.watcherDisposables=this._register(new n.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new n.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(u=>this.onFileChanges(u))),g.add(this.watcher.onDidLogMessage(u=>this.onLogMessage(u))),g.add(this.watcher.onDidError(u=>this.onError(u)))}onError(g){this.options.restartOnError?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I,I.MAX_RESTARTS=5;class E extends I{constructor(g,u,f){super(g,u,f,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class b extends I{constructor(g,u,f){super(g,u,f,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function v(p){return p.map(g=>({type:g.type,resource:A.URI.file(g.path)}))}e.toFileChanges=v;function y(p){const g=new w;for(const u of p)g.processEvent(u);return g.coalesce()}e.coalesceEvents=y;function d(p,g){return typeof g=="string"&&!g.startsWith(R.GLOBSTAR)&&!(0,k.isAbsolute)(g)?{base:p,pattern:g}:g}e.normalizeWatcherPattern=d;function S(p,g){const u=[];for(const f of g)u.push((0,R.parse)(d(p,f)));return u}e.parseWatcherPatterns=S;class w{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return T.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const u=this.mapPathToChange.get(this.toKey(g));let f=!1;if(u){const h=u.type,s=g.type;u.path!==g.path&&(g.type===2||g.type===1)?f=!0:h===1&&s===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(u)):h===2&&s===1?u.type=0:h===1&&s===0||(u.type=s)}else f=!0;f&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],u=[];return Array.from(this.coalesced).filter(f=>f.type!==2?(g.push(f),!1):!0).sort((f,h)=>f.path.length-h.path.length).filter(f=>u.some(h=>(0,C.isParent)(f.path,h,!T.isLinux))?!1:(u.push(f.path),!0)).concat(g)}}}),define(ne[179],re([0,1,54,6,21,42,2,79,12,4,130,27,57]),function(X,e,R,n,k,T,A,C,P,I,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(w,p,g,u){super();this.request=w,this.onDidFilesChange=p,this.onLogMessage=g,this.verboseLogging=u,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},f=>this.onDidFilesChange(f)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const w=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const p=await b.Promises.stat(w);this._register(await this.doWatch(w,p.isDirectory()))}catch(w){w.code!=="ENOENT"?this.error(w):this.trace(w)}}async normalizePath(w){let p=w.path;try{p=await b.Promises.realpath(w.path),w.path===p&&(p=await(0,E.realcase)(w.path)??w.path),w.path!==p&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${w.path}, real: ${p})`)}catch{}return p}async doWatch(w,p){if(I.isMacintosh&&(0,T.isEqualOrParent)(w,"/Volumes/",!0))return this.error(`Refusing to watch ${w} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const g=new k.CancellationTokenSource(this.cts.token),u=new A.DisposableStore;try{const f=(0,P.basename)(w),h=(0,R.watch)(w);u.add((0,A.toDisposable)(()=>{h.removeAllListeners(),h.close()})),this.trace(`Started watching: '${w}'`);const s=new Set;if(p)try{for(const t of await b.Promises.readdir(w))s.add(t)}catch(t){this.error(t)}const r=new Map;u.add((0,A.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),h.on("error",(t,i)=>{this.error(`Failed to watch ${w} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),h.on("change",(t,i)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let o="";if(i&&(o=i.toString(),I.isMacintosh&&(o=(0,C.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(p)if(t==="rename"){r.get(o)?.dispose();const c=setTimeout(async()=>{if(r.delete(o),o===f&&!await b.Promises.exists(w)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(w,o));if(g.token.isCancellationRequested)return;let l;a?s.has(o)?l=0:(l=1,s.add(o)):(s.delete(o),l=2),this.onFileChange({path:(0,P.join)(this.request.path,o),type:l})},y.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,A.toDisposable)(()=>clearTimeout(c)))}else{let c;s.has(o)?c=0:(c=1,s.add(o)),this.onFileChange({path:(0,P.join)(this.request.path,o),type:c})}else if(t==="rename"||o!==f){const c=setTimeout(async()=>{const a=await b.Promises.exists(w);g.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),u.add(await this.doWatch(w,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);u.clear(),u.add((0,A.toDisposable)(()=>clearTimeout(c)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(f){await b.Promises.exists(w)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${w} for changes using fs.watch() (${f.toString()})`)}return(0,A.toDisposable)(()=>{g.dispose(!0),u.dispose()})}async onFileChange(w,p=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${w.type===1?"[ADDED]":w.type===2?"[DELETED]":"[CHANGED]"} ${w.path}`),!p&&this.excludes.some(g=>g(w.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${w.path}`):!p&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(w.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${w.path}`):this.fileChangesBuffer.push(w);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const u=(0,v.coalesceEvents)(g);if(u.length>0){if(this.verboseLogging)for(const h of u)this.trace(`>> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.path}`);this.throttledFileChangesWorker.work(u)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${u.length}, most recent change: ${u[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(w){if(I.isLinux)return b.Promises.exists(w);try{const p=(0,P.basename)(w);return(await b.Promises.readdir((0,P.dirname)(w))).some(u=>u===p)}catch(p){return this.trace(p),!1}}setVerboseLogging(w){this.verboseLogging=w}error(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${w}`})}warn(w){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${w}`})}trace(w){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${w}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function d(S,w,p,g,u=512){const f=await b.Promises.open(S,"r"),h=Buffer.allocUnsafe(u),s=new k.CancellationTokenSource(g);let r,t=!1;const i={path:S,excludes:[],recursive:!1},o=new y(i,c=>{(async()=>{for(const{type:a}of c)if(a===0){if(t)return;t=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:l}=await b.Promises.read(f,h,0,u,null);if(!l||s.token.isCancellationRequested)break;w(h.slice(0,l))}}catch(l){r=new Error(l),s.dispose(!0)}finally{t=!1}}})()});return await o.ready,p(),new Promise((c,a)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await b.Promises.close(f)}catch(l){r=new Error(l)}r?a(r):c()})})}e.watchFileContents=d}),define(ne[180],re([0,1,3,81,2,4,179]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class C extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new R.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=R.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(I){const E=this.normalizeRequests(I),b=E.filter(y=>{const d=this.watchers.get(y.path);return d?!(0,n.patternsEquals)(d.request.excludes,y.excludes)||!(0,n.patternsEquals)(d.request.includes,y.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:y})=>!E.find(d=>d.path===y.path&&(0,n.patternsEquals)(d.excludes,y.excludes)&&(0,n.patternsEquals)(d.includes,y.includes))).map(({request:y})=>y.path);b.length&&this.trace(`Request to start watching: ${b.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.stopWatching(y);for(const y of b)this.startWatching(y)}startWatching(I){const E=new A.NodeJSFileWatcherLibrary(I,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),b={request:I,instance:E};this.watchers.set(I.path,b)}async stop(){for(const[I]of this.watchers)this.stopWatching(I);this.watchers.clear()}stopWatching(I){const E=this.watchers.get(I);E&&(this.watchers.delete(I),E.instance.dispose())}normalizeRequests(I){const E=new Map;for(const b of I){const v=T.isLinux?b.path:b.path.toLowerCase();E.set(v,b)}return Array.from(E.values())}async setVerboseLogging(I){this.verboseLogging=I;for(const[,E]of this.watchers)E.instance.setVerboseLogging(I)}trace(I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I)})}toMessage(I,E){return E?`[File Watcher (node.js)] ${I} (path: ${E.request.path})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=C}),define(ne[181],re([0,1,57,180]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends R.AbstractNonRecursiveWatcherClient{constructor(A,C,P){super(A,C,P);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(ne[182],re([0,1,20,39,64,57]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends T.AbstractUniversalWatcherClient{constructor(P,I,E){super(P,I,E);this.init()}createWatcher(P){const I=P.add(new k.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(I.onDidProcessExit(({code:E,signal:b})=>this.onError(`terminated by itself with code ${E}, signal: ${b}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(I.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(ne[93],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class R{constructor(...k){this._entries=new Map;for(const[T,A]of k)this.set(T,A)}set(k,T){const A=this._entries.get(k);return this._entries.set(k,T),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=R}),define(ne[183],re([0,1,6,9,56,172,5,93]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class I extends Error{constructor(d){super("cyclic dependency between services");this.message=d.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${d.toString()}`}}class E{constructor(d=new C.ServiceCollection,S=!1,w){this._activeInstantiations=new Set,this._services=d,this._strict=S,this._parent=w,this._services.set(A.IInstantiationService,this)}createChild(d){return new E(d,this._strict,this)}invokeFunction(d,...S){const w=v.traceInvocation(d);let p=!1;try{return d({get:u=>{if(p)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const f=this._getOrCreateServiceInstance(u,w);if(!f)throw new Error(`[invokeFunction] unknown service '${u}'`);return f}},...S)}finally{p=!0,w.stop()}}createInstance(d,...S){let w,p;return d instanceof k.SyncDescriptor?(w=v.traceCreation(d.ctor),p=this._createInstance(d.ctor,d.staticArguments.concat(S),w)):(w=v.traceCreation(d),p=this._createInstance(d,S,w)),w.stop(),p}_createInstance(d,S=[],w){const p=A._util.getServiceDependencies(d).sort((f,h)=>f.index-h.index),g=[];for(const f of p){const h=this._getOrCreateServiceInstance(f.id,w);h||this._throwIfStrict(`[createInstance] ${d.name} depends on UNKNOWN service ${f.id}.`,!1),g.push(h)}const u=p.length>0?p[0].index:S.length;if(S.length!==u){console.trace(`[createInstance] First service dependency of ${d.name} at position ${u+1} conflicts with ${S.length} static arguments`);const f=u-S.length;f>0?S=S.concat(new Array(f)):S=S.slice(0,u)}return new d(...[...S,...g])}_setServiceInstance(d,S){if(this._services.get(d)instanceof k.SyncDescriptor)this._services.set(d,S);else if(this._parent)this._parent._setServiceInstance(d,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(d){const S=this._services.get(d);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(d):S}_getOrCreateServiceInstance(d,S){const w=this._getServiceInstanceOrDescriptor(d);return w instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(d,w,S.branch(d,!0)):(S.branch(d,!1),w)}_safeCreateAndCacheServiceInstance(d,S,w){if(this._activeInstantiations.has(d))throw new Error(`illegal state - RECURSIVELY instantiating service '${d}'`);this._activeInstantiations.add(d);try{return this._createAndCacheServiceInstance(d,S,w)}finally{this._activeInstantiations.delete(d)}}_createAndCacheServiceInstance(d,S,w){const p=new T.Graph(f=>f.id.toString());let g=0;const u=[{id:d,desc:S,_trace:w}];for(;u.length;){const f=u.pop();if(p.lookupOrInsertNode(f),g++>1e3)throw new I(p);for(const h of A._util.getServiceDependencies(f.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(h.id);if(s||this._throwIfStrict(`[createInstance] ${d} depends on ${h.id} which is NOT registered.`,!0),s instanceof k.SyncDescriptor){const r={id:h.id,desc:s,_trace:f._trace.branch(h.id,!0)};p.insertEdge(f,r),u.push(r)}}}for(;;){const f=p.roots();if(f.length===0){if(!p.isEmpty())throw new I(p);break}for(const{data:h}of f){if(this._getServiceInstanceOrDescriptor(h.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this._setServiceInstance(h.id,r)}p.removeNode(h)}}return this._getServiceInstanceOrDescriptor(d)}_createServiceInstanceWithOwner(d,S,w=[],p,g){if(this._services.get(d)instanceof k.SyncDescriptor)return this._createServiceInstance(S,w,p,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(d,S,w,p,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(d,S=[],w,p){if(w){const g=new R.IdleValue(()=>this._createInstance(d,S,p));return new Proxy(Object.create(null),{get(u,f){if(f in u)return u[f];const h=g.value;let s=h[f];return typeof s!="function"||(s=s.bind(h),u[f]=s),s},set(u,f,h){return g.value[f]=h,!0}})}else return this._createInstance(d,S,p)}_throwIfStrict(d,S){if(S&&console.warn(d),this._strict)throw new Error(d)}}e.InstantiationService=E;var b;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(b||(b={}));class v{constructor(d,S){this.type=d,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(d){return P?new v(1,d.name||d.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(d){return P?new v(0,d.name):v._None}branch(d,S){const w=new v(2,d.toString());return this._dep.push([d,S,w]),w}stop(){const d=Date.now()-this._start;v._totals+=d;let S=!1;function w(g,u){const f=[],h=new Array(g+1).join("	");for(const[s,r,t]of u._dep)if(r&&t){S=!0,f.push(`${h}CREATES -> ${s}`);const i=w(g+1,t);i&&f.push(i)}else f.push(`${h}uses -> ${s}`);return f.join(`
`)}const p=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${d.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(d>2||S)&&console.log(p.join(`
`))}}e.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(ne[184],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class R{constructor(k,T){this.server=k,this.router=T}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,T){this.server.registerChannel(k,T)}}e.MessagePortMainProcessService=R}),define(ne[94],re([0,1,39,56,88,5]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,d,S){const w=S.getChannel(y);return C(d)?new d.channelClientCtor(w):R.ProxyChannel.toService(w,d?.proxyOptions)}}function C(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,T.createDecorator)("mainProcessService");let P=class extends A{constructor(y,d,S){super(y,d,S)}};P=ge([K(2,e.IMainProcessService)],P);function I(v,y,d){(0,k.registerSingleton)(v,new n.SyncDescriptor(P,[y,d],d?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,T.createDecorator)("sharedProcessService");let E=class extends A{constructor(y,d,S){super(y,d,S)}};E=ge([K(2,e.ISharedProcessService)],E);function b(v,y,d){(0,k.registerSingleton)(v,new n.SyncDescriptor(E,[y,d],d?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=b}),define(ne[66],re([0,1,21,2,4,152,28,5]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,C.createDecorator)("languagePackService");let P=class extends n.Disposable{constructor(E){super();this.extensionGalleryService=E}async getAvailableLanguages(){const E=new R.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let b;try{b=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const y=b.firstPage.filter(d=>d.properties.localizedLanguages?.length&&d.tags.some(S=>S.startsWith("lp-"))).map(d=>{const S=d.properties.localizedLanguages?.[0],w=this.getLocale(d);return{...this.createQuickPickItem(w,S,d),extensionId:d.identifier.id,galleryExtension:d}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(E){return E.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(E,b,v){const y=b??E;let d;if(y!==E&&(d=`(${E})`),E.toLowerCase()===k.language.toLowerCase()&&(d??(d=""),d+=(0,T.localize)(0,null)),v?.installCount){d??(d="");const S=v.installCount;let w;S>1e6?w=`${Math.floor(S/1e5)/10}M`:S>1e3?w=`${Math.floor(S/1e3)}K`:w=String(S),d+=` $(cloud-download) ${w}`}return{id:E,label:y,description:d}}};P=ge([K(0,A.IExtensionGalleryService)],P),e.LanguagePackBaseService=P}),define(ne[185],re([0,1,2,66]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends R.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=ge([K(0,n.ILanguagePackService)],k),e.LocalizationsUpdater=k}),define(ne[8],re([0,1,38,3,2,4,5]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function C(){return new Date().toISOString()}var P;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(P=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=P.Info;function I(r,t,i){switch(t){case P.Trace:r.trace(i);break;case P.Debug:r.debug(i);break;case P.Info:r.info(i);break;case P.Warning:r.warn(i);break;case P.Error:r.error(i);break;case P.Critical:r.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function E(r){let t="";for(let i=0;i<r.length;i++){let o=r[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(i>0?" ":"")+o}return t}e.format=E;class b extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=b;class v extends b{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(P.Trace)&&this.log(P.Trace,E([t,...i]))}debug(t,...i){this.checkLogLevel(P.Debug)&&this.log(P.Debug,E([t,...i]))}info(t,...i){this.checkLogLevel(P.Info)&&this.log(P.Info,E([t,...i]))}warn(t,...i){this.checkLogLevel(P.Warning)&&this.log(P.Warning,E([t,...i]))}error(t,...i){if(this.checkLogLevel(P.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(P.Error,E(o))}else this.log(P.Error,E([t,...i]))}critical(t,...i){this.checkLogLevel(P.Critical)&&this.log(P.Critical,E([t,...i]))}flush(){}}e.AbstractMessageLogger=v;class y extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!T.isWindows}trace(t,...i){this.getLevel()<=P.Trace&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}debug(t,...i){this.getLevel()<=P.Debug&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}info(t,...i){this.getLevel()<=P.Info&&(this.useColors?console.log(`[90m[main ${C()}][0m`,t,...i):console.log(`[main ${C()}]`,t,...i))}warn(t,...i){this.getLevel()<=P.Warning&&(this.useColors?console.warn(`[93m[main ${C()}][0m`,t,...i):console.warn(`[main ${C()}]`,t,...i))}error(t,...i){this.getLevel()<=P.Error&&(this.useColors?console.error(`[91m[main ${C()}][0m`,t,...i):console.error(`[main ${C()}]`,t,...i))}critical(t,...i){this.getLevel()<=P.Critical&&(this.useColors?console.error(`[90m[main ${C()}][0m`,t,...i):console.error(`[main ${C()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class d extends b{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=P.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=P.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=P.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=P.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=P.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=P.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=d;class S extends b{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=P.Trace&&this.adapter.log(P.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=P.Debug&&this.adapter.log(P.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=P.Info&&this.adapter.log(P.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=P.Warning&&this.adapter.log(P.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=P.Error&&this.adapter.log(P.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=P.Critical&&this.adapter.log(P.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,R.toErrorMessage)(t,this.getLevel()<=P.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class w extends b{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const o of this.logServices)o.trace(t,...i)}debug(t,...i){for(const o of this.logServices)o.debug(t,...i)}info(t,...i){for(const o of this.logServices)o.info(t,...i)}warn(t,...i){for(const o of this.logServices)o.warn(t,...i)}error(t,...i){for(const o of this.logServices)o.error(t,...i)}critical(t,...i){for(const o of this.logServices)o.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=w;class p extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=p;class g extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(c=>c.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,i){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,i?.always?P.Trace:this.logLevel,i),this.loggers.set(t.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class u{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(t){}getLevel(){return P.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=u;function f(r){if(r.verbose)return P.Trace;if(typeof r.logLevel=="string"){const t=h(r.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=f;function h(r){switch(r){case"trace":return P.Trace;case"debug":return P.Debug;case"info":return P.Info;case"warn":return P.Warning;case"error":return P.Error;case"critical":return P.Critical;case"off":return P.Off}}e.parseLogLevel=h;function s(r){switch(r){case P.Trace:return"trace";case P.Debug:return"debug";case P.Info:return"info";case P.Warning:return"warn";case P.Error:return"error";case P.Critical:return"critical";case P.Off:return"off"}}e.LogLevelToString=s}),define(ne[186],re([0,1,6,9,2,12,27,14,8]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends k.Disposable{constructor(b,v){super();this.environmentService=b,this.logService=v,this._register(new R.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,T.basename)(this.environmentService.logsPath),v=(0,T.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(v)).filter(p=>/^\d{8}T\d{6}$/.test(p)).sort().filter(p=>p!==b),w=S.slice(0,Math.max(0,S.length-9));w.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${w.join(", ")}'`),await Promise.all(w.map(p=>A.Promises.rm((0,T.join)(v,p)))))}catch(b){(0,n.onUnexpectedError)(b)}}};I=ge([K(0,C.IEnvironmentService),K(1,P.ILogService)],I),e.LogsDataCleaner=I}),define(ne[187],re([0,1,6,9,2,12,27,14,8]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class ft extends k.Disposable{constructor(b,v,y){super();this.backupWorkspacesPath=b,this.environmentService=v,this.logService=y,this._register(new R.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const b=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(b).emptyWorkspaceInfos.map(S=>S.backupFolder),d=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(d.map(async S=>{S.length===ft.NON_EMPTY_WORKSPACE_ID_LENGTH||S===ft.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,T.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(b){(0,n.onUnexpectedError)(b)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",I=ge([K(1,C.INativeEnvironmentService),K(2,P.ILogService)],I),e.StorageDataCleaner=I}),define(ne[188],re([0,1,18,6,9,3,2,12,57,8]),function(X,e,R,n,k,T,A,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends A.Disposable{constructor(v,y){super();this.logService=v,this.options=y,this._onDidChangeFile=this._register(new T.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new T.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(v,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,y):this.watchNonRecursive(v,y)}watchUniversal(v,y){const d={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,R.insert)(this.universalPathsToWatch,d);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,P.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&v.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,y){const d={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,R.insert)(this.nonRecursivePathsToWatch,d);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,P.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,C.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(ne[189],re([0,1,18,6,16,21,3,62,52,2,34,20,190,17,41,148,13,92,8]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let u=class extends I.Disposable{constructor(h){super();this.logService=h,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(h,s){if(this.provider.has(h))throw new Error(`A filesystem provider for the scheme '${h}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${h}`);const r=new I.DisposableStore;return this.provider.set(h,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:h,provider:s}),r.add(s.onDidChangeFile(t=>this._onDidFilesChange.fire(new w.FileChangesEvent(t,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:h}))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:h,provider:s}),this.provider.delete(h),(0,I.dispose)(r)})}getProvider(h){return this.provider.get(h)}async activateProvider(h){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:h,join(r){s.push(r)}}),!this.provider.has(h)&&await n.Promises.settled(s)}async canHandleResource(h){return await this.activateProvider(h.scheme),this.hasProvider(h)}hasProvider(h){return this.provider.has(h.scheme)}hasCapability(h,s){const r=this.provider.get(h.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return P.Iterable.map(this.provider,([h,s])=>({scheme:h,capabilities:s.capabilities}))}async withProvider(h){if(!(0,y.isAbsolutePath)(h))throw new w.FileOperationError((0,S.localize)(0,null,this.resourceForError(h)),8);await this.activateProvider(h.scheme);const s=this.provider.get(h.scheme);if(!s){const r=new Error;throw r.name="ENOPRO",r.message=(0,S.localize)(1,null,h.toString()),r}return s}async withReadProvider(h){const s=await this.withProvider(h);if((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s)||(0,w.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(h){const s=await this.withProvider(h);if((0,w.hasOpenReadWriteCloseCapability)(s)||(0,w.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${h.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(h,s){try{return await this.doResolveFile(h,s)}catch(r){throw(0,w.toFileSystemProviderErrorCode)(r)===w.FileSystemProviderErrorCode.FileNotFound?new w.FileOperationError((0,S.localize)(2,null,this.resourceForError(h)),1):(0,w.ensureFileSystemProviderError)(r)}}async doResolveFile(h,s){const r=await this.withProvider(h),t=this.isPathCaseSensitive(r),i=s?.resolveTo,o=s?.resolveSingleChildDescendants,c=s?.resolveMetadata,a=await r.stat(h);let l;return this.toFileStat(r,h,a,void 0,!!c,(m,D)=>(l||(l=E.TernarySearchTree.forUris(()=>!t),l.set(h,!0),i&&l.fill(!0,i)),l.get(m.resource)||l.findSuperstr(m.resource.with({query:null,fragment:null}))?!0:m.isDirectory&&o?D===1:!1))}async toFileStat(h,s,r,t,i,o){const{providerExtUri:c}=this.getExtUri(h),a={resource:s,name:c.basename(s),isFile:(r.type&w.FileType.File)!=0,isDirectory:(r.type&w.FileType.Directory)!=0,isSymbolicLink:(r.type&w.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&w.FilePermission.Readonly)||Boolean(h.capabilities&2048),etag:(0,w.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const l=await h.readdir(s),m=await n.Promises.settled(l.map(async([D,U])=>{try{const O=c.joinPath(s,D),F=i?await h.stat(O):{type:U};return await this.toFileStat(h,O,F,l.length,i,o)}catch(O){return this.logService.trace(O),null}}));a.children=(0,R.coalesce)(m)}catch(l){this.logService.trace(l),a.children=[]}return a}return a}async resolveAll(h){return n.Promises.settled(h.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(h){const s=await this.withProvider(h),r=await s.stat(h);return this.toFileStat(s,h,r,void 0,!0,()=>!1)}async exists(h){const s=await this.withProvider(h);try{return!!await s.stat(h)}catch{return!1}}async canCreateFile(h,s){try{await this.doValidateCreateFile(h,s)}catch(r){return r}return!0}async doValidateCreateFile(h,s){if(!s?.overwrite&&await this.exists(h))throw new w.FileOperationError((0,S.localize)(3,null,this.resourceForError(h)),3,s)}async createFile(h,s=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(h,r);const t=await this.writeFile(h,s);return this._onDidRunOperation.fire(new w.FileOperationEvent(h,0,t)),t}async writeFile(h,s,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),{providerExtUri:i}=this.getExtUri(t);try{await this.validateWriteFile(t,h,r)||await this.mkdirp(t,i.dirname(h));let c;if((0,w.hasReadWriteCapability)(t)&&!(s instanceof k.VSBuffer))if((0,d.isReadableStream)(s)){const a=await(0,d.peekStream)(s,3);a.ended?c=k.VSBuffer.concat(a.buffer):c=a}else c=(0,d.peekReadable)(s,a=>k.VSBuffer.concat(a),3);else c=s;!(0,w.hasOpenReadWriteCloseCapability)(t)||(0,w.hasReadWriteCapability)(t)&&c instanceof k.VSBuffer?await this.doWriteUnbuffered(t,h,r,c):await this.doWriteBuffered(t,h,r,c instanceof k.VSBuffer?(0,k.bufferToReadable)(c):c),this._onDidRunOperation.fire(new w.FileOperationEvent(h,4))}catch(o){throw new w.FileOperationError((0,S.localize)(4,null,this.resourceForError(h),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),r)}return this.resolve(h,{resolveMetadata:!0})}async validateWriteFile(h,s,r){if(!!r?.unlock&&!(h.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(s)));let i;try{i=await h.stat(s)}catch{return}if((i.type&w.FileType.Directory)!=0)throw new w.FileOperationError((0,S.localize)(6,null,this.resourceForError(s)),0,r);if(this.throwIfFileIsReadonly(s,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==w.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,w.etag)({mtime:r.mtime,size:i.size}))throw new w.FileOperationError((0,S.localize)(7,null),3,r);return i}async readFile(h,s,r){const t=await this.withReadProvider(h);return s?.atomic?this.doReadFileAtomic(t,h,s,r):this.doReadFile(t,h,s,r)}async doReadFileAtomic(h,s,r,t){return new Promise((i,o)=>{this.writeQueue.queueFor(s,this.getExtUri(h).providerExtUri).queue(async()=>{try{const c=await this.doReadFile(h,s,r,t);i(c)}catch(c){o(c)}})})}async doReadFile(h,s,r,t){const i=await this.doReadFileStream(h,s,{...r,preferUnbuffered:!0},t);return{...i,value:await(0,k.streamToBuffer)(i.value)}}async readFileStream(h,s,r){const t=await this.withReadProvider(h);return this.doReadFileStream(t,h,s,r)}async doReadFileStream(h,s,r,t){const i=new T.CancellationTokenSource(t),o=this.validateReadFile(s,r).then(a=>a,a=>{throw i.cancel(),a});let c;try{return typeof r?.etag=="string"&&r.etag!==w.ETAG_DISABLED&&await o,r?.atomic&&(0,w.hasFileAtomicReadCapability)(h)||!((0,w.hasOpenReadWriteCloseCapability)(h)||(0,w.hasFileReadStreamCapability)(h))||(0,w.hasReadWriteCapability)(h)&&r?.preferUnbuffered?c=this.readFileUnbuffered(h,s,r):(0,w.hasFileReadStreamCapability)(h)?c=this.readFileStreamed(h,s,i.token,r):c=this.readFileBuffered(h,s,i.token,r),{...await o,value:c}}catch(a){c&&await(0,d.consumeStream)(c);const l=(0,S.localize)(8,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(a).toString());throw a instanceof w.NotModifiedSinceFileOperationError?new w.NotModifiedSinceFileOperationError(l,a.stat,r):new w.FileOperationError(l,(0,w.toFileOperationResult)(a),r)}}readFileStreamed(h,s,r,t=Object.create(null)){const i=h.readFileStream(s,t,r);return(0,d.transform)(i,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new w.FileOperationError((0,S.localize)(9,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}readFileBuffered(h,s,r,t=Object.create(null)){const i=(0,k.newWriteableBufferStream)();return(0,p.readFileIntoStream)(h,s,i,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new w.FileOperationError((0,S.localize)(10,null,this.resourceForError(s),(0,w.ensureFileSystemProviderError)(o).toString()),(0,w.toFileOperationResult)(o),t)},r),i}readFileUnbuffered(h,s,r){const t=(0,d.newWriteableStream)(i=>k.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,w.hasFileAtomicReadCapability)(h)?i=await h.readFile(s,{atomic:!0}):i=await h.readFile(s),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(s,i.byteLength,r),t.end(k.VSBuffer.wrap(i))}catch(i){t.error(i),t.end()}})(),t}async validateReadFile(h,s){const r=await this.resolve(h,{resolveMetadata:!0});if(r.isDirectory)throw new w.FileOperationError((0,S.localize)(11,null,this.resourceForError(h)),0,s);if(typeof s?.etag=="string"&&s.etag!==w.ETAG_DISABLED&&s.etag===r.etag)throw new w.NotModifiedSinceFileOperationError((0,S.localize)(12,null),r,s);return this.validateReadFileLimits(h,r.size,s),r}validateReadFileLimits(h,s,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&s>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&s>r.limits.size&&(t=7),typeof t=="number")throw new w.FileOperationError((0,S.localize)(13,null,this.resourceForError(h)),t)}}async canMove(h,s,r){return this.doCanMoveCopy(h,s,"move",r)}async canCopy(h,s,r){return this.doCanMoveCopy(h,s,"copy",r)}async doCanMoveCopy(h,s,r,t){if(h.toString()!==s.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h):await this.withReadProvider(h),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,h,o,s,r,t)}catch(i){return i}return!0}async move(h,s,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(h),h),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(t,h,i,s,"move",!!r),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(h,o==="move"?2:3,c)),c}async copy(h,s,r){const t=await this.withReadProvider(h),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(t,h,i,s,"copy",!!r),c=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(h,o==="copy"?3:2,c)),c}async doMoveCopy(h,s,r,t,i,o){if(s.toString()===t.toString())return i;const{exists:c,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(h,s,r,t,i,o);if(c&&!a&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),i==="copy"){if(h===r&&(0,w.hasFileFolderCopyCapability)(h))await h.copy(s,t,{overwrite:o});else{const l=await this.resolve(s);l.isDirectory?await this.doCopyFolder(h,l,r,t):await this.doCopyFile(h,s,r,t)}return i}else return h===r?(await h.rename(s,t,{overwrite:o}),i):(await this.doMoveCopy(h,s,r,t,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(h,s,r,t){if((0,w.hasOpenReadWriteCloseCapability)(h)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(h,s,r,t);if((0,w.hasOpenReadWriteCloseCapability)(h)&&(0,w.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(h,s,r,t);if((0,w.hasReadWriteCapability)(h)&&(0,w.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(h,s,r,t);if((0,w.hasReadWriteCapability)(h)&&(0,w.hasReadWriteCapability)(r))return this.doPipeUnbuffered(h,s,r,t)}async doCopyFolder(h,s,r,t){await r.mkdir(t),Array.isArray(s.children)&&await n.Promises.settled(s.children.map(async i=>{const o=this.getExtUri(r).providerExtUri.joinPath(t,i.name);return i.isDirectory?this.doCopyFolder(h,await this.resolve(i.resource),r,o):this.doCopyFile(h,i.resource,r,o)}))}async doValidateMoveCopy(h,s,r,t,i,o){let c=!1;if(h===r){const{providerExtUri:l,isPathCaseSensitive:m}=this.getExtUri(h);if(m||(c=l.isEqual(s,t)),c&&i==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(s),this.resourceForError(t)));if(!c&&l.isEqualOrParent(t,s))throw new Error((0,S.localize)(15,null,this.resourceForError(s),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!c){if(!o)throw new w.FileOperationError((0,S.localize)(16,null,this.resourceForError(s),this.resourceForError(t)),4);if(h===r){const{providerExtUri:l}=this.getExtUri(h);if(l.isEqualOrParent(s,t))throw new Error((0,S.localize)(17,null,this.resourceForError(s),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:c}}getExtUri(h){const s=this.isPathCaseSensitive(h);return{providerExtUri:s?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(h){return!!(h.capabilities&1024)}async createFolder(h){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);await this.mkdirp(s,h);const r=await this.resolve(h,{resolveMetadata:!0});return this._onDidRunOperation.fire(new w.FileOperationEvent(h,0,r)),r}async mkdirp(h,s){const r=[],{providerExtUri:t}=this.getExtUri(h);for(;!t.isEqual(s,t.dirname(s));)try{if(((await h.stat(s)).type&w.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,w.toFileSystemProviderErrorCode)(i)!==w.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(t.basename(s)),s=t.dirname(s)}for(let i=r.length-1;i>=0;i--){s=t.joinPath(s,r[i]);try{await h.mkdir(s)}catch(o){if((0,w.toFileSystemProviderErrorCode)(o)!==w.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(h,s){try{await this.doValidateDelete(h,s)}catch(r){return r}return!0}async doValidateDelete(h,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(h),h);if(!!s?.useTrash&&!(r.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(h)));let i;try{i=await r.stat(h)}catch{}if(i)this.throwIfFileIsReadonly(h,i);else throw new w.FileOperationError((0,S.localize)(20,null,this.resourceForError(h)),1);if(!!!s?.recursive){const c=await this.resolve(h);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(h)))}return r}async del(h,s){const r=await this.doValidateDelete(h,s),t=!!s?.useTrash,i=!!s?.recursive;await r.delete(h,{recursive:i,useTrash:t}),this._onDidRunOperation.fire(new w.FileOperationEvent(h,1))}async cloneFile(h,s){const r=await this.withProvider(h),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(r===t&&this.getExtUri(r).providerExtUri.isEqual(h,s))return;if(r===t&&(0,w.hasFileCloneCapability)(r))return r.cloneFile(h,s);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s));const i=this.writeQueue.queueFor(h,this.getExtUri(r).providerExtUri);return r===t&&(0,w.hasFileFolderCopyCapability)(r)?i.queue(()=>r.copy(h,s,{overwrite:!0})):i.queue(()=>this.doCopyFile(r,h,t,s))}watch(h,s={recursive:!1,excludes:[]}){const r=new I.DisposableStore;let t=!1,i=()=>{t=!0};return r.add((0,I.toDisposable)(()=>i())),(async()=>{try{const o=await this.doWatch(h,s);t?(0,I.dispose)(o):i=()=>(0,I.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(h,s){const r=await this.withProvider(h),t=(0,C.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(h),s]);let i=this.activeWatchers.get(t);return i||(i={count:0,disposable:r.watch(h,s)},this.activeWatchers.set(t,i)),i.count+=1,(0,I.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,I.dispose)(i.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,h]of this.activeWatchers)(0,I.dispose)(h.disposable);this.activeWatchers.clear()}async doWriteBuffered(h,s,r,t){return this.writeQueue.queueFor(s,this.getExtUri(h).providerExtUri).queue(async()=>{const i=await h.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,d.isReadableStream)(t)||(0,d.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(h,i,t):await this.doWriteReadableBufferedQueued(h,i,t)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await h.close(i)}})}async doWriteStreamBufferedQueued(h,s,r){let t=0,i;if((0,d.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(h,s,o,o.byteLength,t,0),t+=o.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((o,c)=>{(0,d.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(h,s,a,a.byteLength,t,0)}catch(l){return c(l)}t+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>c(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(h,s,r){let t=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(h,s,i,i.byteLength,t,0),t+=i.byteLength}async doWriteBuffer(h,s,r,t,i,o){let c=0;for(;c<t;)c+=await h.write(s,i+c,r.buffer,o+c,t-c)}async doWriteUnbuffered(h,s,r,t){return this.writeQueue.queueFor(s,this.getExtUri(h).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(h,s,r,t))}async doWriteUnbufferedQueued(h,s,r,t){let i;t instanceof k.VSBuffer?i=t:(0,d.isReadableStream)(t)?i=await(0,k.streamToBuffer)(t):(0,d.isReadableBufferedStream)(t)?i=await(0,k.bufferedStreamToBuffer)(t):i=(0,k.readableToBuffer)(t),await h.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(h,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(h,s,r,t))}async doPipeBufferedQueued(h,s,r,t){let i,o;try{i=await h.open(s,{create:!1}),o=await r.open(t,{create:!0,unlock:!1});const c=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,l=0,m=0;do m=await h.read(i,a,c.buffer,l,c.byteLength-l),await this.doWriteBuffer(r,o,c,m,a,l),a+=m,l+=m,l===c.byteLength&&(l=0);while(m>0)}catch(c){throw(0,w.ensureFileSystemProviderError)(c)}finally{await n.Promises.settled([typeof i=="number"?h.close(i):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(h,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(h,s,r,t))}async doPipeUnbufferedQueued(h,s,r,t){return r.writeFile(t,await h.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(h,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(h,s,r,t))}async doPipeUnbufferedToBufferedQueued(h,s,r,t){const i=await r.open(t,{create:!0,unlock:!1});try{const o=await h.readFile(s);await this.doWriteBuffer(r,i,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,w.ensureFileSystemProviderError)(o)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(h,s,r,t){const i=await(0,k.streamToBuffer)(this.readFileBuffered(h,s,T.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,i)}throwIfFileSystemIsReadonly(h,s){if(h.capabilities&2048)throw new w.FileOperationError((0,S.localize)(22,null,this.resourceForError(s)),6);return h}throwIfFileIsReadonly(h,s){if((s.permissions??0)&w.FilePermission.Readonly)throw new w.FileOperationError((0,S.localize)(23,null,this.resourceForError(h)),6)}resourceForError(h){return h.scheme===b.Schemas.file?h.fsPath:h.toString(!0)}};u=ge([K(0,g.ILogService)],u),e.FileService=u}),define(ne[191],re([0,1,54,274,6,34,16,3,42,2,12,4,17,41,27,151,13,92,188,38,182,181]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(R)}catch(r){console.error(`Error enabling graceful-fs: ${(0,u.toErrorMessage)(r)}`)}})();class s extends g.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i);this.onDidChangeCapabilities=C.Event.None,this.resourceLocks=new T.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,b.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:o}=await d.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(t){try{const i=await d.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async c=>{try{let a;c.isSymbolicLink()?a=(await this.stat((0,v.joinPath)(t,c.name))).type:a=this.toType(c),o.push([c.name,a])}catch(a){this.logService.trace(a)}})),o}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let o;return i?.dangling?o=w.FileType.Unknown:t.isFile()?o=w.FileType.File:t.isDirectory()?o=w.FileType.Directory:o=w.FileType.Unknown,i&&(o|=w.FileType.SymbolicLink),o}async createResourceLock(t){const i=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const c=new k.Barrier;return this.resourceLocks.set(t,c),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,I.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===c&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),c.open()})}async readFile(t,i){let o;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const c=this.toFilePath(t);return await d.Promises.readFile(c)}catch(c){throw this.toFileSystemProviderError(c)}finally{o?.dispose()}}readFileStream(t,i,o){const c=(0,y.newWriteableStream)(a=>A.VSBuffer.concat(a.map(l=>A.VSBuffer.wrap(l))).buffer);return(0,p.readFileIntoStream)(this,t,c,a=>a.buffer,{...i,bufferSize:256*1024},o),c}async writeFile(t,i,o){let c;try{const a=this.toFilePath(t);if(!o.create||!o.overwrite){if(await d.Promises.exists(a)){if(!o.overwrite)throw(0,w.createFileSystemProviderError)((0,S.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,w.createFileSystemProviderError)((0,S.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(c,0,i,0,i.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof c=="number"&&await this.close(c)}}static configureFlushOnWrite(t){s.canFlush=t}async open(t,i){const o=this.toFilePath(t);let c;(0,w.isFileOpenForWriteOptions)(i)&&(c=await this.createResourceLock(t));let a;try{if((0,w.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:m}=await d.SymlinkSupport.stat(o);m.mode&128||await d.Promises.chmod(o,m.mode|128)}catch(m){this.logService.trace(m)}let l;if((0,w.isFileOpenForWriteOptions)(i)){if(b.isWindows)try{await d.Promises.truncate(o,0),l="r+"}catch(m){m.code!=="ENOENT"&&this.logService.trace(m)}l||(l="w")}else l="r";a=await d.Promises.open(o,l)}catch(l){throw c?.dispose(),(0,w.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,l):this.toFileSystemProviderError(l)}if(this.mapHandleToPos.set(a,0),(0,w.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,t),c){const l=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,c),l&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),l.dispose())}return a}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&s.canFlush)try{await d.Promises.fdatasync(t)}catch(o){s.configureFlushOnWrite(!1),this.logService.error(o)}return await d.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,o,c,a){const l=this.normalizePos(t,i);let m=null;try{m=(await d.Promises.read(t,o,c,a,l)).bytesRead}catch(D){throw this.toFileSystemProviderError(D)}finally{this.updatePos(t,l,m)}return m}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,o){const c=this.mapHandleToPos.get(t);typeof c=="number"&&(typeof i=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,c+o):this.mapHandleToPos.delete(t)))}async write(t,i,o,c,a){return(0,k.retry)(()=>this.doWrite(t,i,o,c,a),100,3)}async doWrite(t,i,o,c,a){const l=this.normalizePos(t,i);let m=null;try{m=(await d.Promises.write(t,o,c,a,l)).bytesWritten}catch(D){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),D)}finally{this.updatePos(t,l,m)}return m}async mkdir(t){try{await d.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const o=this.toFilePath(t);i.recursive?await d.Promises.rm(o,d.RimRafMode.MOVE):await d.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,i,o){const c=this.toFilePath(t),a=this.toFilePath(i);if(c!==a)try{await this.validateTargetDeleted(t,i,"move",o.overwrite),await d.Promises.move(c,a)}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(2,null,(0,E.basename)(c),(0,E.basename)((0,E.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async copy(t,i,o){const c=this.toFilePath(t),a=this.toFilePath(i);if(c!==a)try{await this.validateTargetDeleted(t,i,"copy",o.overwrite),await d.Promises.copy(c,a,{preserveSymlinks:!0})}catch(l){throw(l.code==="EINVAL"||l.code==="EBUSY"||l.code==="ENAMETOOLONG")&&(l=new Error((0,S.localize)(3,null,(0,E.basename)(c),(0,E.basename)((0,E.dirname)(a)),l.toString()))),this.toFileSystemProviderError(l)}}async validateTargetDeleted(t,i,o,c){const a=this.toFilePath(t),l=this.toFilePath(i);let m=!1;if(!!(this.capabilities&1024)||(m=(0,P.isEqual)(a,l,!0)),m&&o==="copy")throw(0,w.createFileSystemProviderError)((0,S.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(!m&&await d.Promises.exists(l)){if(!c)throw(0,w.createFileSystemProviderError)((0,S.localize)(5,null),w.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,o){const c=this.toFilePath(t),a=this.toFilePath(i),l=!!(this.capabilities&1024);if((0,P.isEqual)(c,a,!l))return;const m=new I.DisposableStore;try{const[D,U]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);m.add(D),m.add(U),o&&await d.Promises.mkdir((0,E.dirname)(a),{recursive:!0}),await d.Promises.copyFile(c,a)}catch(D){if(D.code==="ENOENT"&&!o)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(D)}finally{m.dispose()}}createUniversalWatcher(t,i,o){return new f.UniversalWatcherClient(c=>t(c),c=>i(c),o)}createNonRecursiveWatcher(t,i,o){return new h.NodeJSWatcherClient(c=>t(c),c=>i(c),o)}toFileSystemProviderError(t){if(t instanceof w.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=w.FileSystemProviderErrorCode.NoPermissions;break;default:i=w.FileSystemProviderErrorCode.Unknown}return(0,w.createFileSystemProviderError)(t,i)}async toFileSystemProviderWriteError(t,i){let o=this.toFileSystemProviderError(i);if(t&&o.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:c}=await d.SymlinkSupport.stat(this.toFilePath(t));c.mode&128||(o=(0,w.createFileSystemProviderError)(i,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(c){this.logService.trace(c)}return o}}e.DiskFileSystemProvider=s,s.canFlush=!0}),define(ne[95],re([0,1,3,7,8]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class T{constructor(v){this.service=v,this.onDidChangeLogLevel=R.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(v,y,d){switch(y){case"setLevel":return this.service.setLevel(d)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=T;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,y){return v.call("setLevel",y)}}e.LogLevelChannelClient=A;class C{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,y){throw new Error(`Event not found: ${y}`)}async call(v,y,d){switch(y){case"createLogger":this.createLogger(n.URI.revive(d[0]),d[1]);return;case"log":return this.log(n.URI.revive(d[0]),d[1]);case"consoleLog":return this.consoleLog(d[0],d[1])}throw new Error(`Call not found: ${y}`)}createLogger(v,y){this.loggers.set(v.toString(),this.loggerService.createLogger(v,y))}consoleLog(v,y){let d=console.log;switch(v){case k.LogLevel.Error:d=console.error;break;case k.LogLevel.Warning:d=console.warn;break;case k.LogLevel.Info:d=console.info;break}d.call(console,...y)}log(v,y){const d=this.loggers.get(v.toString());if(!d)throw new Error("Create the logger before logging");for(const[S,w]of y)(0,k.log)(d,S,w)}}e.LoggerChannel=C;class P extends k.AbstractLoggerService{constructor(v,y,d){super(v,y);this.channel=d}createConsoleMainLogger(){return new k.AdapterLogger({log:(v,y)=>{this.channel.call("consoleLog",[v,y])}})}doCreateLogger(v,y,d){return new I(this.channel,v,y,d)}}e.LoggerChannelClient=P;class I extends k.AbstractMessageLogger{constructor(v,y,d,S){super(S?.always);this.channel=v,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(d),this.channel.call("createLogger",[y,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,y){const d=[[v,y]];this.isLoggerCreated?this.doLog(d):this.buffer.push(...d)}doLog(v){this.channel.call("log",[this.file,v])}}class E extends k.LogService{constructor(v,y){super(y);this.parent=v,this._register(v.onDidChangeLogLevel(d=>y.setLevel(d)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=E}),define(ne[67],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,R.createDecorator)("nativeHostService")}),define(ne[58],re([0,1,3,52,2,5]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,T.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(I){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...I,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(I),n.Iterable.reduce(this.policies.entries(),(b,[v,y])=>({...b,[v]:y}),{})}getPolicyValue(I){return this.policies.get(I)}serialize(){return n.Iterable.reduce(Object.entries(this.policyDefinitions),(I,[E,b])=>({...I,[E]:{definition:b,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=A;class C{constructor(){this.onDidChange=R.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=C}),define(ne[192],re([0,1,3,2,58]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class T{constructor(P){this.service=P,this.disposables=new n.DisposableStore}listen(P,I){switch(I){case"onDidChange":return R.Event.map(this.service.onDidChange,E=>E.reduce((b,v)=>({...b,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${I}`)}call(P,I,E){switch(I){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${I}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=T;class A extends k.AbstractPolicyService{constructor(P,I){super();this.channel=I;for(const E in P){const{definition:b,value:v}=P[E];this.policyDefinitions[E]=b,v!==void 0&&this.policies.set(E,v)}this.channel.listen("onDidChange")(E=>{for(const b in E){const v=E[b];v===null?this.policies.delete(b):this.policies.set(b,v)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(P){const I=await this.channel.call("registerPolicyDefinitions",P);for(const E in I)this.policies.set(E,I[E])}}e.PolicyChannelClient=A}),define(ne[96],re([0,1,20,4,36,17]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const C=n.globals.vscode.context.configuration();if(C)A=C.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const C=(0,T.dirname)(R.FileAccess.asFileUri("",X));A=X.__$__nodeRequire((0,T.joinPath)(C,"product.json").fsPath);const P=X.__$__nodeRequire((0,T.joinPath)(C,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:P.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(ne[24],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,R.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(ne[193],re([0,1,6,9,2,12,27,8,24]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends k.Disposable{constructor(b,v,y){super();this.productService=v,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpCodeCaches(b)},30*1e3)).schedule()}async cleanUpCodeCaches(b){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),y=(0,T.dirname)(b),d=(0,T.basename)(b),S=await A.Promises.readdir(y);await Promise.all(S.map(async w=>{if(w===d)return;const p=(0,T.join)(y,w),g=await A.Promises.stat(p);if(g.isDirectory()&&v-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),A.Promises.rm(p)}))}catch(v){(0,n.onUnexpectedError)(v)}}};I=ge([K(1,P.IProductService),K(2,C.ILogService)],I),e.CodeCacheCleaner=I}),define(ne[194],re([0,1,6,9,2,12,27,14,8,24]),function(X,e,R,n,k,T,A,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let E=class extends k.Disposable{constructor(v,y,d){super();this.environmentService=v,this.logService=y,this.productService=d,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new R.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,T.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(y)){const u=y[g];v[`${u.hash}.${g}`]=!0}const d=(0,T.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(d))return;const w=await A.Promises.readdir(d);for(const g of w){if(v[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,T.join)(d,g))}const p=Date.now();for(const g of Object.keys(v)){const u=(0,T.join)(d,g),f=await A.Promises.readdir(u);for(const h of f){if(h==="tcf.json")continue;const s=(0,T.join)(u,h),r=await A.Promises.stat(s);r.isDirectory()&&p-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,T.join)(g,h)}`),await A.Promises.rm(s))}}}catch(v){(0,n.onUnexpectedError)(v)}}};E=ge([K(0,C.INativeEnvironmentService),K(1,P.ILogService),K(2,I.IProductService)],E),e.LanguagePackCachedDataCleaner=E}),define(ne[195],re([0,1,12,5]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var k;(function(T){function A(C,P="noAbsolutePaths"){for(const I of C.nodes)I.callFrame&&I.callFrame.url&&((0,R.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(I.callFrame.url))&&(I.callFrame.url=(0,R.join)(P,(0,R.basename)(I.callFrame.url)));return C}T.rewriteAbsolutePaths=A})(k=e.Utils||(e.Utils={}))}),define(ne[196],re([0,1,31]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(T){const C=await(await new Promise((I,E)=>{X(["v8-inspect-profiler"],I,E)})).startProfiling({port:T.port,checkForPaused:!0}),P=(0,R.generateUuid)();return this._sessions.set(P,C),P}async stopProfiling(T){const A=this._sessions.get(T);if(!A)throw new Error(`UNKNOWN session '${T}'`);const C=await A.stop();return this._sessions.delete(T),C.profile}}e.InspectProfilingService=n}),define(ne[40],re([0,1,110,15]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,C){R.ok(n.isString(A)),R.ok(n.isObject(C)),R.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,C)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(ne[97],re([0,1,3,40]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(C){return C.length>0&&C.charAt(C.length-1)==="#"?C.substring(0,C.length-1):C}class T{constructor(){this._onDidChangeSchema=new R.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,I){this.schemasById[k(P)]=I,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new T;n.Registry.add(e.Extensions.JSONContribution,A)}),define(ne[43],re([0,1,18,3,15,138,19,97,40]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=P.Registry.as(C.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const t=this.doRegisterConfigurations(s,r);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:s,remove:r}){const t=[];t.push(...this.doDeregisterConfigurations(r)),t.push(...this.doRegisterConfigurations(s,!1)),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,R.distinct)(t)})}registerDefaultConfigurations(s){const r=[],t=[];for(const{overrides:i,source:o}of s)for(const c in i)if(r.push(c),e.OVERRIDE_PROPERTY_REGEX.test(c)){const a=this.configurationDefaultsOverrides.get(c),l=a?.valuesSources??new Map;if(o)for(const O of Object.keys(i[c]))l.set(O,o);const m={...a?.value||{},...i[c]};this.configurationDefaultsOverrides.set(c,{source:o,value:m,valuesSources:l});const D=(0,A.getLanguageTagSettingPlainKey)(c),U={type:"object",default:m,description:T.localize(1,null,D),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(c)),this.configurationProperties[c]=U,this.defaultLanguageConfigurationOverridesNode.properties[c]=U}else{this.configurationDefaultsOverrides.set(c,{value:i[c],source:o});const a=this.configurationProperties[c];a&&(this.updatePropertyDefaultValue(c,a),this.updateSchema(c,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:t,source:i}of s)for(const o in t){const c=this.configurationDefaultsOverrides.get(o),a=k.isString(i)?i:i?.id,l=k.isString(c?.source)?c?.source:c?.source?.id;if(a===l)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const m=this.configurationProperties[o];m&&(this.updatePropertyDefaultValue(o,m),this.updateSchema(o,m))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const t=[];return s.forEach(i=>{t.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),t}doDeregisterConfigurations(s){const r=[],t=i=>{if(i.properties)for(const o in i.properties){r.push(o);const c=this.configurationProperties[o];c?.policy?.name&&this.policyConfigurations.delete(c.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>t(o))};for(const i of s){t(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(s,r=!0,t,i,o=3){o=k.isUndefinedOrNull(s.scope)?o:s.scope;const c=[],a=s.properties;if(a)for(const m in a){const D=a[m];if(r&&u(m,D)){delete a[m];continue}if(D.source=t,D.defaultDefaultValue=a[m].default,this.updatePropertyDefaultValue(m,D),e.OVERRIDE_PROPERTY_REGEX.test(m)?D.scope=void 0:(D.scope=k.isUndefinedOrNull(D.scope)?o:D.scope,D.restricted=k.isUndefinedOrNull(D.restricted)?!!i?.includes(m):D.restricted),a[m].hasOwnProperty("included")&&!a[m].included){this.excludedConfigurationProperties[m]=a[m],delete a[m];continue}else this.configurationProperties[m]=a[m],a[m].policy?.name&&this.policyConfigurations.set(a[m].policy.name,m);!a[m].deprecationMessage&&a[m].markdownDeprecationMessage&&(a[m].deprecationMessage=a[m].markdownDeprecationMessage),c.push(m)}const l=s.allOf;if(l)for(const m of l)c.push(...this.validateAndRegisterProperties(m,r,t,i,o));return c}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const r=t=>{const i=t.properties;if(i)for(const c in i)this.updateSchema(c,i[c]);t.allOf?.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,t={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){const t=this.configurationDefaultsOverrides.get(s);let i=t?.value,o=t?.source;k.isUndefined(i)&&(i=r.defaultDefaultValue,o=void 0),k.isUndefined(i)&&(i=p(r.type)),r.default=i,r.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",d=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(h){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(h)){let r=d.exec(h);for(;r?.length;){const t=r[1].trim();t&&s.push(t),r=d.exec(h)}}return(0,R.distinct)(s)}e.overrideIdentifiersFromKey=S;function w(h){return h.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=w;function p(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=p;const g=new v;P.Registry.add(e.Extensions.Configuration,g);function u(h,s){return h.trim()?e.OVERRIDE_PROPERTY_REGEX.test(h)?T.localize(7,null,h):g.getConfigurationProperties()[h]!==void 0?T.localize(8,null,h):s.policy?.name&&g.getPolicyConfigurations().get(s.policy?.name)!==void 0?T.localize(9,null,h,s.policy?.name,g.getPolicyConfigurations().get(s.policy?.name)):null:T.localize(6,null)}e.validateProperty=u;function f(){const h=[],s=g.getConfigurationProperties();for(const r of Object.keys(s))h.push([r,s[r].scope]);return h.push(["launch",4]),h.push(["task",4]),h}e.getScopes=f}),define(ne[68],re([0,1,18,3,35,2,34,30,15,7,19,43,40]),function(X,e,R,n,k,T,A,C,P,I,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},t=[],i=[]){this._contents=r,this._keys=t,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,E.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,t){const i=this.getContentsForOverrideIdentifer(t);return i?r?(0,E.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const i of this.overrides)i.identifiers.includes(r)&&t.push(...i.keys);return R.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return R.distinct(r)}override(r){let t=this.overrideConfigurations.get(r);return t||(t=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,t)),t}merge(...r){const t=C.deepClone(this.contents),i=C.deepClone(this.overrides),o=[...this.keys];for(const c of r)if(!c.isEmpty()){this.mergeContents(t,c.contents);for(const a of c.overrides){const[l]=i.filter(m=>R.equals(m.identifiers,a.identifiers));l?(this.mergeContents(l.contents,a.contents),l.keys.push(...a.keys),l.keys=R.distinct(l.keys)):i.push(C.deepClone(a))}for(const a of c.keys)o.indexOf(a)===-1&&o.push(a)}return new y(t,o,i)}freeze(){return this.frozen=!0,this}clone(){return new y(C.deepClone(this.contents),[...this.keys],C.deepClone(this.overrides))}createOverrideConfigurationModel(r){const t=this.getContentsForOverrideIdentifer(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const i={};for(const o of R.distinct([...Object.keys(this.contents),...Object.keys(t)])){let c=this.contents[o];const a=t[o];a&&(typeof c=="object"&&typeof a=="object"?(c=C.deepClone(c),this.mergeContents(c,a)):c=a),i[o]=c}return new y(i,this.keys,this.overrides)}mergeContents(r,t){for(const i of Object.keys(t)){if(i in r&&P.isObject(r[i])&&P.isObject(t[i])){this.mergeContents(r[i],t[i]);continue}r[i]=C.deepClone(t[i])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?C.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let t=null,i=null;const o=c=>{c&&(i?this.mergeContents(i,c):i=C.deepClone(c))};for(const c of this.overrides)R.equals(c.identifiers,[r])?t=c.contents:c.identifiers.includes(r)&&o(c.contents);return o(t),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.addKey(r),(0,E.addToValueTree)(this.contents,r,t,i=>{throw new Error(i)})}removeValue(r){this.removeKey(r)&&(0,E.removeFromValueTree)(this.contents,r)}addKey(r){let t=this.keys.length;for(let i=0;i<t;i++)r.indexOf(this.keys[i])===0&&(t=i);this.keys.splice(t,1,r)}removeKey(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class d{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,t){if(!P.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,t)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,t){this._raw=r;const{contents:i,keys:o,overrides:c,restricted:a}=this.doParseRaw(r,t);this._configurationModel=new y(i,o,c),this._restrictedConfigurations=a||[]}doParseContent(r){let t={},i=null,o=[];const c=[],a=[];function l(D){Array.isArray(o)?o.push(D):i!==null&&(o[i]=D)}const m={onObjectBegin:()=>{const D={};l(D),c.push(o),o=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const D=[];l(D),c.push(o),o=D,i=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:l,onError:(D,U,O)=>{a.push({error:D,offset:U,length:O})}};if(r)try{k.visit(r,m),t=o[0]||{}}catch(D){console.error(`Error while parsing settings file ${this._name}: ${D}`),this._parseErrors=[D]}return t}doParseRaw(r,t){const i=v.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,i,!0,t);r=o.raw;const c=(0,E.toValuesTree)(r,m=>console.error(`Conflict in settings file ${this._name}: ${m}`)),a=Object.keys(r),l=this.toOverrides(r,m=>console.error(`Conflict in settings file ${this._name}: ${m}`));return{contents:c,keys:a,overrides:l,restricted:o.restricted}}filter(r,t,i,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const c={},a=[];for(const l in r)if(b.OVERRIDE_PROPERTY_REGEX.test(l)&&i){const m=this.filter(r[l],t,!1,o);c[l]=m.raw,a.push(...m.restricted)}else{const m=t[l],D=m?typeof m.scope!="undefined"?m.scope:3:void 0;m?.restricted&&a.push(l),(D===void 0||o.scopes===void 0||o.scopes.includes(D))&&(o.skipRestricted&&m?.restricted||(c[l]=r[l]))}return{raw:c,restricted:a}}toOverrides(r,t){const i=[];for(const o of Object.keys(r))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const a in r[o])c[a]=r[o][a];i.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,E.toValuesTree)(c,t)})}return i}}e.ConfigurationModelParser=d;class S extends T.Disposable{constructor(r,t,i,o){super();this.userSettingsResource=r,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,c=>c.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&i.isEqual(c.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(r,t,i,o,c=new y,a=new y,l=new A.ResourceMap,m=new y,D=new A.ResourceMap,U=!0){this._defaultConfiguration=r,this._policyConfiguration=t,this._applicationConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=c,this._workspaceConfiguration=a,this._folderConfigurations=l,this._memoryConfiguration=m,this._memoryConfigurationByResource=D,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,t,i){return this.getConsolidatedConfigurationModel(r,t,i).getValue(r)}updateValue(r,t,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new y,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(r):o.setValue(r,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,t,i){const o=this.getConsolidatedConfigurationModel(r,t,i),c=this.getFolderConfigurationModelForResource(t.resource,i),a=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,l=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),m=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),D=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),U=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),F=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),L=i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,N=c?t.overrideIdentifier?c.freeze().override(t.overrideIdentifier).getValue(r):c.freeze().getValue(r):void 0,W=t.overrideIdentifier?a.override(t.overrideIdentifier).getValue(r):a.getValue(r),V=o.getValue(r),J=R.distinct(o.overrides.map($=>$.identifiers).flat()).filter($=>o.getOverrideValue(r,$)!==void 0);return{defaultValue:l,policyValue:m,applicationValue:D,userValue:U,userLocalValue:O,userRemoteValue:F,workspaceValue:L,workspaceFolderValue:N,memoryValue:W,value:V,default:l!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,policy:m!==void 0?{value:m}:void 0,application:D!==void 0?{value:D,override:t.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspace:L!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:c?.freeze().getValue(r),override:t.overrideIdentifier?c?.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:a.getValue(r),override:t.overrideIdentifier?a.getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:J.length?J:void 0}}keys(r){const t=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,t){this._folderConfigurations.set(r,t),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const i=[];if(!t){const{added:o,updated:c,removed:a}=f(this._defaultConfiguration,r);t=[...o,...c,...a]}for(const o of t)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(c),l=r.getKeysForOverrideIdentifier(c),m=[...l.filter(D=>a.indexOf(D)===-1),...a.filter(D=>l.indexOf(D)===-1),...a.filter(D=>!C.equals(this._defaultConfiguration.override(c).getValue(D),r.override(c).getValue(D)))];i.push([c,m])}return this.updateDefaultConfiguration(r),{keys:t,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:i,removed:o}=f(this._policyConfiguration,r),c=[...t,...i,...o];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:i,removed:o,overrides:c}=f(this.applicationConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:i,removed:o,overrides:c}=f(this.localUserConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:i,removed:o,overrides:c}=f(this.remoteUserConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:i,removed:o,overrides:c}=f(this.workspaceConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:c}}compareAndUpdateFolderConfiguration(r,t){const i=this.folderConfigurations.get(r),{added:o,updated:c,removed:a,overrides:l}=f(i,t),m=[...o,...c,...a];return(m.length||!i)&&this.updateFolderConfiguration(r,t),{keys:m,overrides:l}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:o,removed:c,overrides:a}=f(t,void 0);return{keys:[...i,...o,...c],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&r){const o=t.getFolder(r);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const c=this._memoryConfigurationByResource.get(r);c&&(i=i.merge(c))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let t=this._foldersConsolidatedConfigurations.get(r);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(t=i.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(r,t)):t=i}return t}getFolderConfigurationModelForResource(r,t){if(t&&r){const i=t.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,t)=>{const{contents:i,overrides:o,keys:c}=this._folderConfigurations.get(t);return r.push([t,{contents:i,overrides:o,keys:c}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(i=>r.add(i))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o))),[...t.values()]}static parse(r){const t=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),c=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),l=r.folders.reduce((m,D)=>(m.set(I.URI.revive(D[0]),this.parseConfigurationModel(D[1])),m),new A.ResourceMap);return new w(t,i,o,c,new y,a,l,new y,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=w;function p(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,t=new Map;for(const o of s)o.keys.forEach(c=>r.add(c)),o.overrides.forEach(([c,a])=>{const l=(0,A.getOrSet)(t,c,new Set);a.forEach(m=>l.add(m))});const i=[];return t.forEach((o,c)=>i.push([c,[...o.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=p;class g{constructor(r,t,i,o){this.change=r,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const c=new Set;r.keys.forEach(l=>c.add(l)),r.overrides.forEach(([,l])=>l.forEach(m=>c.add(m))),this.affectedKeys=[...c.values()];const a=new y;this.affectedKeys.forEach(l=>a.setValue(l,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(t){const i=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,t,this.currentWorkspace);return!C.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(r,t){let i=(0,E.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(r=r[o],!r)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=g;class u extends g{constructor(r,t,i,o){super({keys:r.allKeys(),overrides:[]},void 0,r,t);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=u;function f(s,r){const{added:t,removed:i,updated:o}=h(r,s),c=[],a=s?.getAllOverrideIdentifiers()||[],l=r?.getAllOverrideIdentifiers()||[];if(r){const m=l.filter(D=>!a.includes(D));for(const D of m)c.push([D,r.getKeysForOverrideIdentifier(D)])}if(s){const m=a.filter(D=>!l.includes(D));for(const D of m)c.push([D,s.getKeysForOverrideIdentifier(D)])}if(r&&s){for(const m of a)if(l.includes(m)){const D=h({contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)},{contents:r.getOverrideValue(void 0,m)||{},keys:r.getKeysForOverrideIdentifier(m)});c.push([m,[...D.added,...D.removed,...D.updated]])}}return{added:t,removed:i,updated:o,overrides:c}}function h(s,r){const t=s?r?s.keys.filter(c=>r.keys.indexOf(c)===-1):[...s.keys]:[],i=r?s?r.keys.filter(c=>s.keys.indexOf(c)===-1):[...r.keys]:[],o=[];if(s&&r){for(const c of r.keys)if(s.keys.indexOf(c)!==-1){const a=(0,E.getConfigurationValue)(r.contents,c),l=(0,E.getConfigurationValue)(s.contents,c);C.equals(a,l)||o.push(c)}}return{added:t,removed:i,updated:o}}}),define(ne[197],re([0,1,18,3,2,30,15,19,68,43,8,58,40]),function(X,e,R,n,k,T,A,C,P,I,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new d(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(v.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:u})=>this.onDidUpdateConfiguration(g,u))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,u){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class d extends P.ConfigurationModel{constructor(g={}){const u=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),f=Object.keys(u),h=Object.create(null),s=[];for(const r in u){const t=g[r],i=t!==void 0?t:u[r].default;(0,C.addToValueTree)(h,r,i,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(h))I.OVERRIDE_PROPERTY_REGEX.test(r)&&s.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(h[r]),contents:(0,C.toValuesTree)(h[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(h,f,s)}}e.DefaultConfigurationModel=d;class S{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let w=class extends k.Disposable{constructor(g,u,f){super();this.defaultConfiguration=g,this.policyService=u,this.logService=f,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const u={},f=[],h=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const s of g){const r=h[s];if(!r){f.push(s);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}f.push(s),u[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(u)||await this.policyService.registerPolicyDefinitions(u),f}onDidChangePolicies(g){const u=v.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),f=(0,R.coalesce)(g.map(h=>u.get(h)));this.update(f,!0)}update(g,u){const f=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),h=[],s=this._configurationModel.isEmpty();for(const r of g){const t=f[r]?.policy?.name;if(t){const i=this.policyService.getPolicyValue(t);(s?i!==void 0:!(0,T.equals)(this._configurationModel.getValue(r),i))&&h.push([r,i])}else this._configurationModel.getValue(r)!==void 0&&h.push([r,void 0])}if(h.length){const r=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of r.keys)this._configurationModel.setValue(t,r.getValue(t));for(const[t,i]of h)i===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,i);u&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};w=ge([K(1,b.IPolicyService),K(2,E.ILogService)],w),e.PolicyConfiguration=w}),define(ne[198],re([0,1,6,3,2,17,19,68,197,58]),function(X,e,R,n,k,T,A,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends k.Disposable{constructor(v,y,d,S){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=d instanceof I.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,d,S)),this.userConfiguration=this._register(new C.UserSettings(this.settingsResource,void 0,T.extUriBiasedIgnorePathCase,y)),this.configuration=new C.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new C.ConfigurationModel,new C.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new R.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:w,properties:p})=>this.onDidDefaultConfigurationChange(w,p))),this._register(this.policyConfiguration.onDidChangeConfiguration(w=>this.onDidPolicyConfigurationChange(w))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,y,d]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new C.Configuration(v,y,new C.ConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(v,y){const d=typeof v=="string"?v:void 0,S=(0,A.isConfigurationOverrides)(v)?v:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(d,S,void 0)}updateValue(v,y,d,S){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const y=this.configuration.toData(),d=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(d,y,2)}onDidDefaultConfigurationChange(v,y){const d=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(v,y);this.trigger(S,d,7)}onDidPolicyConfigurationChange(v){const y=this.configuration.toData(),d=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(d,y,7)}trigger(v,y,d){const S=new C.ConfigurationChangeEvent(v,{data:y},this.configuration);S.source=d,S.sourceConfig=this.getTargetConfiguration(d),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(ne[199],re([0,1,9,5]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class T extends R.ErrorNoTelemetry{constructor(C,P=k.Unknown,I){super(C);this._message=C,this._code=P,this._detail=I,this.isHandled=P===k.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,T.prototype)}static isTemporarilyNotAvailable(C){return C instanceof T&&C._code===k.TemporarilyNotAvailable}static isNoResolverFound(C){return C instanceof T&&C._code===k.NoResolverFound}static isHandled(C){return C instanceof T&&C.isHandled}}e.RemoteAuthorityResolverError=T}),define(ne[98],re([0,1,20]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(I){return I.scheme===R.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=n;function k(I){if(!I)return;const E=I.indexOf("+");return E<0?I:I.substr(0,E)}e.getRemoteName=k;function T(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=T;function A(I){const{host:E,port:b}=P(I);if(typeof b=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:b}}e.parseAuthorityWithPort=A;function C(I,E){let{host:b,port:v}=P(I);return typeof v=="undefined"&&(v=E),{host:b,port:v}}e.parseAuthorityWithOptionalPort=C;function P(I){const E=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const b=I.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const v=I.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:I,port:void 0}}}),define(ne[44],re([0,1,26,5,98]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function T(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=T;function A(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var C;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(C=e.ExtensionType||(e.ExtensionType={}));var P;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,w){if(typeof S=="undefined"||S===null)return typeof w=="undefined"||w===null;if(typeof w=="undefined"||w===null)return!1;if(typeof S=="string"||typeof w=="string"){const p=typeof S=="string"?S:S.value,g=typeof w=="string"?w:w.value;return R.equalsIgnoreCase(p,g)}return S._lower===w._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=I;function E(d){return b(d)}e.isApplicationScopedExtension=E;function b(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=b;function v(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function y(d,S){if(S){const w=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return d.activationEvents?.indexOf(w)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(ne[32],re([0,1,26,28,44,4,7,9,36]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,R.compareIgnoreCase)(r.id,t.id)===0}e.areSameExtensions=I;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class b{constructor(t,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=t.id}static create(t){const i=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new b(t.identifier,i,o)}static parse(t){const i=E.exec(t);return i&&i[1]&&i[2]?new b({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof b?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=b;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const t=v.exec(r);return t&&t[1]?[S(t[1]),t[2]]:[S(r),void 0]}e.getIdAndVersion=y;function d(r,t){return`${r}.${t}`}e.getExtensionId=d;function S(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function w(r,t){return S(d(r,t))}e.getGalleryExtensionId=w;function p(r,t){const i=[],o=c=>{for(const a of i)if(a.some(l=>I(t(l),t(c))))return a;return null};for(const c of r){const a=o(c);a?a.push(c):i.push([c])}return i}e.groupByExtension=p;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function u(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=u,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function f(r,t){const i=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&i.every(a=>!I(a.identifier,{id:c}))){const a=r.filter(l=>I(l.identifier,{id:c}));a.length===1&&(i.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=f;async function h(r,t){if(!T.isLinux)return!1;let i;try{i=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){t.debug("Error while getting the os-release file.",(0,C.getErrorMessage)(c))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=h;async function s(r,t){const i=await h(r,t),o=(0,n.getTargetPlatform)(i?"alpine":T.platform,P.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(ne[45],re([0,1,6,16,2,34,7,32,13,5,8]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let b=class extends k.Disposable{constructor(y,d){super();this.fileService=y,this.logService=d,this.resourcesAccessQueueMap=new T.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,d){return this.withProfileExtensions(d,S=>(S=S.filter(w=>y.some(([p])=>!(0,C.areSameExtensions)(w.identifier,p.identifier))),S.push(...y.map(([w,p])=>({identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:p}))),S))}removeExtensionFromProfile(y,d){return this.withProfileExtensions(d,S=>S.filter(w=>!(0,C.areSameExtensions)(w.identifier,y)))}async withProfileExtensions(y,d){return this.getResourceAccessQueue(y).queue(async()=>{let S=[];try{const w=await this.fileService.readFile(y),p=JSON.parse(w.value.toString());for(const g of p){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}S.push({identifier:g.identifier,location:A.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(w){w.fileOperationResult!==1&&this.logService.error(w)}if(d){S=d(S);const w=S.map(p=>({identifier:p.identifier,version:p.version,location:p.location.toJSON(),metadata:p.metadata}));await this.fileService.writeFile(y,n.VSBuffer.fromString(JSON.stringify(w)))}return S})}getResourceAccessQueue(y){let d=this.resourcesAccessQueueMap.get(y);return d||(d=new R.Queue,this.resourcesAccessQueueMap.set(y,d)),d}};b=ge([K(0,P.IFileService),K(1,E.ILogService)],b),e.ExtensionsProfileScannerService=b}),define(ne[200],re([0,1,21,32]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(T,A,C,P,I){try{const E=await T.getExtensionsControlManifest();if(!E.deprecated)return;const b=await T.getInstalled(1);for(const[v,y]of Object.entries(E.deprecated)){if(!y?.extension)continue;const{id:d,autoMigrate:S,preRelease:w}=y.extension;if(!S)continue;const p=b.find(u=>(0,n.areSameExtensions)(u.identifier,{id:v}));if(!p)continue;const g=(await A.getExtensions([{id:d,preRelease:w}],{targetPlatform:await T.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0];if(!g){I.info(`Skipping migrating '${p.identifier.id}' extension because, the comaptible target '${d}' extension is not found`);continue}try{I.info(`Migrating '${p.identifier.id}' extension to '${d}' extension...`);const u=!P.getDisabledExtensions().some(h=>(0,n.areSameExtensions)(h,p.identifier));await T.uninstall(p),I.info(`Uninstalled the unsupported extension '${p.identifier.id}'`);let f=b.find(h=>(0,n.areSameExtensions)(h.identifier,{id:d}));(!f||!f.isPreReleaseVersion&&u)&&(f=await T.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:p.isMachineScoped,operation:4}),I.info(`Installed the pre-release extension '${f.identifier.id}'`),u||(await P.disableExtension(f.identifier),I.info(`Disabled the pre-release extension '${f.identifier.id}' because the unsupported extension '${p.identifier.id}' is disabled`)),S.storage&&(C.addToMigrationList((0,n.getExtensionId)(p.manifest.publisher,p.manifest.name),(0,n.getExtensionId)(f.manifest.publisher,f.manifest.name)),I.info("Added pre-release extension to the storage migration list"))),I.info(`Migrated '${p.identifier.id}' extension to '${d}' extension.`)}catch(u){I.error(u)}}}catch(E){I.error(E)}}e.migrateUnsupportedExtensions=k}),define(ne[201],re([0,1,6,9,2,4,17,55,7,31,27,14,28,32,13,8]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let w=class extends k.Disposable{constructor(g,u,f,h){super();this.fileService=u,this.extensionGalleryService=f,this.logService=h,this.extensionsDownloadDir=P.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,u){await this.cleanUpPromise;const f=this.getName(g),h=(0,A.joinPath)(this.extensionsDownloadDir,f);if(!await this.fileService.exists(h)){const s=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(g,s,u);try{await this.rename(s,h,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return h}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,u,f){try{await E.Promises.rename(g.fsPath,u.fsPath)}catch(h){if(T.isWindows&&h&&h.code==="EPERM"&&Date.now()<f)return this.logService.info(`Failed renaming ${g} to ${u} with 'EPERM' error. Trying again...`),this.rename(g,u,f);throw h}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const u=[],f=[];for(const r of g.children){const t=y.ExtensionKey.parse(r.name);t&&f.push([t,r])}const h=(0,y.groupByExtension)(f,([r])=>r),s=[];for(const r of h)r.sort((t,i)=>C.rcompare(t[0].version,i[0].version)),u.push(...r.slice(1).map(t=>t[1].resource)),s.push(r[0][1]);s.sort((r,t)=>r.mtime-t.mtime),u.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await R.Promises.settled(u.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?y.ExtensionKey.create(g).toString().toLowerCase():(0,I.generateUuid)()}};w=ge([K(0,b.INativeEnvironmentService),K(1,d.IFileService),K(2,v.IExtensionGalleryService),K(3,S.ILogService)],w),e.ExtensionsDownloader=w}),define(ne[202],re([0,1,2,12,27,44]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends R.Disposable{constructor(P,I){super();this.environmentService=P,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,T.MANIFEST_CACHE_FOLDER,T.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(I.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(P){P.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(P){P.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(ne[203],re([0,1,177,18,6,2,20,12,27,14,28,32,8,66]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let d=class extends y.LanguagePackBaseService{constructor(g,u,f,h){super(f);this.extensionManagementService=g,this.logService=h,this.cache=this._register(new S(u,h)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),u=Object.keys(g).map(f=>{const h=g[f];return{...this.createQuickPickItem(f,h.label),extensionId:h.extensions[0].extensionIdentifier.id}});return u.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),u.sort((f,h)=>f.label.localeCompare(h.label)),u}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const u=await this.cache.getLanguagePacks();Object.keys(u).some(f=>u[f]&&u[f].extensions.some(h=>(0,b.areSameExtensions)(h.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,u]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(u);return!(0,n.equals)(Object.keys(g),Object.keys(f))}};d=ge([K(0,E.IExtensionManagementService),K(1,I.INativeEnvironmentService),K(2,E.IExtensionGalleryService),K(3,v.ILogService)],d),e.NativeLanguagePackService=d;let S=class extends T.Disposable{constructor(g,u){super();this.logService=u,this.languagePacks={},this.languagePacksFilePath=(0,C.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(u=>{Object.keys(u).forEach(f=>delete u[f]),this.createLanguagePacksFromExtensions(u,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...u){for(const f of u)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,f);Object.keys(g).forEach(f=>this.updateHash(g[f]))}createLanguagePacksFromExtension(g,u){const f=u.identifier,h=u.manifest.contributes&&u.manifest.contributes.localizations?u.manifest.contributes.localizations:[];for(const s of h)if(u.location.scheme===A.Schemas.file&&w(s)){let r=g[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},g[s.languageId]=r);const t=r.extensions.filter(i=>(0,b.areSameExtensions)(i.extensionIdentifier,f))[0];t?t.version=u.manifest.version:r.extensions.push({extensionIdentifier:f,version:u.manifest.version});for(const i of s.translations)r.translations[i.id]=(0,C.join)(u.location.fsPath,i.path)}}updateHash(g){if(g){const u=(0,R.createHash)("md5");for(const f of g.extensions)u.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);g.hash=u.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let u=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(u=g(f),f)).then(f=>{for(const s of Object.keys(f))f[s]||delete f[s];this.languagePacks=f,this.initializedCache=!0;const h=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",h),P.Promises.writeFile(this.languagePacksFilePath,h)}).then(()=>u,f=>this.logService.error(f))})}};S=ge([K(0,I.INativeEnvironmentService),K(1,v.ILogService)],S);function w(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const g of p.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}}),define(ne[204],re([0,1,6,16,21,9,3,2,31,83,199,98]),function(X,e,R,n,k,T,A,C,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var y;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function d(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(z){const x=new k.CancellationTokenSource;return setTimeout(()=>x.cancel(),z),x.token}function w(z,x){if(z.isCancellationRequested||x.isCancellationRequested)return k.CancellationToken.Cancelled;const _=new k.CancellationTokenSource;return z.onCancellationRequested(()=>_.cancel()),x.onCancellationRequested(()=>_.cancel()),_.token}class p{constructor(x){this._state="pending",this._disposables=new C.DisposableStore,this.promise=new Promise((_,M)=>{this._resolvePromise=_,this._rejectPromise=M}),x.isCancellationRequested?this._timeout():this._disposables.add(x.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(x){this._state==="pending"?this._disposables.add(x):x.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(x))}reject(x){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(x))}}function g(z,x){const _=new p(x);return _.registerDisposable(z.onControlMessage(M=>{const q=JSON.parse(M.toString()),j=H(q);j?_.reject(j):_.resolve(q)})),_.promise}function u(z,x,_,M,q,j,Z,G){const te=new p(G);return x.connect(_,M,q,j,Z,(se,ce)=>{te.didTimeout?(se&&z.error(se),ce?.dispose()):se||!ce?te.reject(se):te.resolve(ce)}),te.promise}function f(z,x){const _=new p(x);return z.then(M=>{_.didTimeout||_.resolve(M)},M=>{_.didTimeout||_.reject(M)}),_.promise}async function h(z,x,_,M){const q=ie(z,x);z.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let j;try{j=await u(z.logService,z.socketFactory,z.host,z.port,(0,b.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${d(x)}-${z.reconnectionToken}`,M)}catch(ce){throw z.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ce),ce}z.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Z,G;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(j,null),Z=z.reconnectionProtocol,G=!1):(Z=new I.PersistentProtocol(j,null),G=!0),z.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const te=await f(z.signService.createNewMessage((0,P.generateUuid)()),M),se={type:"auth",auth:z.connectionToken||"00000000000000000000",data:te.data};Z.sendControl(n.VSBuffer.fromString(JSON.stringify(se)));try{const ce=await g(Z,w(M,S(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ce=new Error("Unexpected handshake message");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}if(z.logService.trace(`${q} 4/6. received SignRequest control message.`),!await f(z.signService.validate(te,ce.signedData),M)){const Ce=new Error("Refused to connect to unsupported server");throw Ce.code="VSCODE_CONNECTION_ERROR",Ce}const ve=await f(z.signService.sign(ce.data),M),pe={type:"connectionType",commit:z.commit,signedData:ve,desiredConnectionType:x};return _&&(pe.args=_),z.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:Z,ownsProtocol:G}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(z.logService.error(`${q} the handshake timed out. Error:`),z.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${q} received error control message when negotiating connection. Error:`),z.logService.error(ce)),G&&Q(Z),ce}}async function s(z,x,_,M){const q=Date.now(),j=ie(z,x),{protocol:Z,ownsProtocol:G}=await h(z,x,_,M),te=new p(M);return te.registerDisposable(Z.onControlMessage(se=>{const ce=JSON.parse(se.toString()),he=H(ce);he?(z.logService.error(`${j} received error control message when negotiating connection. Error:`),z.logService.error(he),G&&Q(Z),te.reject(he)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ae(q)}!`),te.resolve({protocol:Z,firstMessage:ce}))})),te.promise}async function r(z,x){const{protocol:_}=await s(z,1,void 0,x);return{protocol:_}}async function t(z,x,_){const{protocol:M,firstMessage:q}=await s(z,2,x,_),j=q&&q.debugPort;return{protocol:M,debugPort:j}}async function i(z,x,_){const M=Date.now(),q=ie(z,3),{protocol:j}=await h(z,3,x,_);return z.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ae(M)}!`),j}async function o(z,x,_){const{host:M,port:q,connectionToken:j}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:M,port:q,connectionToken:j,reconnectionToken:x,reconnectionProtocol:_,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function c(z,x,_){return l(z,async M=>{const{protocol:q}=await r(M,k.CancellationToken.None);return new J(z,x,_,M.reconnectionToken,q)})}e.connectRemoteAgentManagement=c;async function a(z,x){return l(z,async _=>{const{protocol:M,debugPort:q}=await t(_,x,k.CancellationToken.None);return new $(z,x,_.reconnectionToken,M,q)})}e.connectRemoteAgentExtensionHost=a;async function l(z,x){const _=5;for(let M=1;;M++)try{const q=(0,P.generateUuid)(),j=await o(z,q,null);return await x(j)}catch(q){if(M<_)z.logService.error(`[remote-connection][attempt ${M}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(q);else throw z.logService.error(`[remote-connection][attempt ${M}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(q),V.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(q)),q}}async function m(z,x,_){const M=await o(z,(0,P.generateUuid)(),null);return await i(M,{host:x,port:_},k.CancellationToken.None)}e.connectRemoteAgentTunnel=m;function D(z){return(0,R.createCancelablePromise)(x=>new Promise((_,M)=>{const q=setTimeout(_,z*1e3);x.onCancellationRequested(()=>{clearTimeout(q),_()})}))}var U;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(U=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(x,_){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=O;class F{constructor(x,_,M,q){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.durationSeconds=M,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class L{constructor(x,_,M){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=M,this.type=2}}e.ReconnectionRunningEvent=L;class N{constructor(x,_,M){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=M,this.type=4}}e.ConnectionGainEvent=N;class W{constructor(x,_,M,q){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=M,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=W;class V extends C.Disposable{constructor(x,_,M,q,j){super();this._connectionType=x,this._options=_,this.reconnectionToken=M,this.protocol=q,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(q.onSocketClose(Z=>{const G=Y(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${G} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${G} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${G} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(()=>{const Z=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Z} received socket timeout event.`),this._beginReconnecting()})),V._instances.push(this),this._register((0,C.toDisposable)(()=>{const Z=V._instances.indexOf(this);Z>=0&&V._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(x,_,M){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=x,this._permanentFailureAttempt=_,this._permanentFailureHandled=M,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(x=>x._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(x=>x._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||V._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const x=Y(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let M=-1;do{M++;const q=M<_.length?_[M]:_[_.length-1];try{if(q>0){const Z=D(q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Z)),this._options.logService.info(`${x} waiting for ${q} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new L(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1)),this._options.logService.info(`${x} resolving connection...`);const j=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${x} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,S(v)),this._options.logService.info(`${x} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),M+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(M>360){this._options.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,T.isCancellationError)(j)){this._options.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,E.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),M+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(x,_,M){this._reconnectionFailureIsFatal?V.triggerPermanentFailure(x,_,M):this._gotoPermanentFailure(x,_,M)}_gotoPermanentFailure(x,_,M){this._onDidStateChange.fire(new W(this.reconnectionToken,x,_,M)),Q(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=V,V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class J extends V{constructor(x,_,M,q,j){super(1,x,q,j,!0);this.client=this._register(new I.Client(j,{remoteAuthority:_,clientId:M},x.ipcLogger))}async _reconnect(x,_){await r(x,_)}}e.ManagementPersistentConnection=J;class $ extends V{constructor(x,_,M,q,j){super(2,x,M,q,!1);this._startArguments=_,this.debugPort=j}async _reconnect(x,_){await t(x,this._startArguments,_)}}e.ExtensionHostPersistentConnection=$;function Q(z){try{z.acceptDisconnect();const x=z.getSocket();z.dispose(),x.dispose()}catch(x){(0,T.onUnexpectedError)(x)}}function H(z){if(z&&z.type==="error"){const x=new Error(`Connection error: ${z.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function B(z,x){for(;z.length<x;)z+=" ";return z}function Y(z,x,_){return`[remote-connection][${B(d(z),13)}][${x.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function ie(z,x){return`${Y(x,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function ae(z){return`${Date.now()-z} ms`}}),define(ne[205],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,R.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(ne[206],re([0,1,76,134]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,T,A,C,P,I){const E=v=>I(v,void 0),b=R.createConnection({host:k,port:T},()=>{b.removeListener("error",E);const v=Buffer.alloc(16);for(let w=0;w<16;w++)v[w]=Math.round(Math.random()*256);const y=v.toString("base64"),d=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${T}${A}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];b.write(d.join(`\r
`)+`\r
\r
`);const S=w=>{w.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",S),I(void 0,new n.NodeSocket(b,P)))};b.on("data",S)});b.setNoDelay(!0),b.once("error",E)}}}),define(ne[207],re([0,1,118,19,8]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let T=class{constructor(C,P){this.configurationService=C,this.logService=P}async request(C,P){this.logService.trace("RequestService#request (browser) - begin",C.url),C.proxyAuthorization||(C.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const I=await(0,R.request)(C,P);return this.logService.trace("RequestService#request (browser) - success",C.url),I}catch(I){throw this.logService.error("RequestService#request (browser) - error",C.url,I),I}}async resolveProxy(C){}};T=ge([K(0,n.IConfigurationService),K(1,k.ILogService)],T),e.RequestService=T}),define(ne[46],re([0,1,16,153,43,5,40]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,T.createDecorator)("requestService");function C(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=C;function P(S){return S.res.statusCode===204}async function I(S){return P(S)?null:(await(0,R.streamToBuffer)(S.stream)).toString()}e.asText=I;async function E(S){if(!C(S))throw new Error("Server returned "+S.res.statusCode);return I(S)}e.asTextOrError=E;async function b(S){if(!C(S))throw new Error("Server returned "+S.res.statusCode);if(P(S))return null;const p=(await(0,R.streamToBuffer)(S.stream)).toString();try{return JSON.parse(p)}catch(g){throw g.message+=`:
`+p,g}}e.asJson=b;function v(S){d(S)}e.updateProxyConfigurationsScope=v;let y;function d(S){const w=A.Registry.as(k.Extensions.Configuration),p=y;y={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},w.updateConfigurations({add:[y],remove:p?[p]:[]})}d(2)}),define(ne[208],re([0,1,21,20,13,46]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(P,I){this.requestService=P,this.fileService=I}async download(P,I,E=R.CancellationToken.None){if(P.scheme===n.Schemas.file||P.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(P,I);return}const b={type:"GET",url:P.toString(!0)},v=await this.requestService.request(b,E);if(v.res.statusCode===200)await this.fileService.writeFile(I,v.stream);else{const y=await(0,T.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${y}`)}}};A=ge([K(0,T.IRequestService),K(1,k.IFileService)],A),e.DownloadService=A}),define(ne[209],re([0,1,18,21,2,17,170,13,8,24,46]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=class extends k.Disposable{constructor(y,d,S,w){super();this.fileService=y,this.productService=d,this.requestService=S,this.logService=w,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,p])=>this.allConfigBasedTips.set(p.configPath,p))}getConfigBasedTips(y){return this.getValidConfigBasedTips(y)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(y){const d=[];for(const[S,w]of this.allConfigBasedTips)if(!(w.configScheme&&w.configScheme!==y.scheme))try{const p=await this.fileService.readFile((0,T.joinPath)(y,S)),g=new Map;Object.entries(w.recommendations).forEach(([f,h])=>{if((0,R.isNonEmptyArray)(h.remotes))for(const s of h.remotes)g.set(s,{extensionId:f,extensionName:h.name,configName:w.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled});else d.push({extensionId:f,extensionName:h.name,configName:w.configName,important:!!h.important,isExtensionPack:!!h.isExtensionPack,whenNotInstalled:h.whenNotInstalled})});const u=(0,A.getDomainsOfRemotes)(p.value.toString(),[...g.keys()]);for(const f of u){const h=g.get(f);h&&d.push(h)}}catch{}return d}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const y=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(y.res.statusCode!==200)return[];const d=await(0,E.asJson)(y);return d?d.workspaceRecommendations||[]:[]}catch(y){return this.logService.error(y),[]}}};b=ge([K(0,C.IFileService),K(1,I.IProductService),K(2,E.IRequestService),K(3,P.ILogService)],b),e.ExtensionTipsService=b}),define(ne[210],re([0,1,16,21]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(C){this.service=C}listen(C,P){throw new Error("Invalid listen")}call(C,P,I,E=n.CancellationToken.None){switch(P){case"request":return this.service.request(I[0],E).then(async({res:b,stream:v})=>{const y=await(0,R.streamToBuffer)(v);return[{statusCode:b.statusCode,headers:b.headers},y]});case"resolveProxy":return this.service.resolveProxy(I[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class T{constructor(C){this.channel=C}async request(C,P){const[I,E]=await this.channel.call("request",[C],P);return{res:I,stream:(0,R.bufferToStream)(E)}}async resolveProxy(C){return this.channel.call("resolveProxy",[C])}}e.RequestChannelClient=T}),define(ne[211],re([0,1,207,210]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(A,C,P){this.configurationService=C,this.logService=P,this.browserRequestService=new R.RequestService(C,P),this.mainRequestService=new n.RequestChannelClient(A.getChannel("request"))}request(A,C){return this.getRequestService().request(A,C)}async resolveProxy(A){return this.getRequestService().resolveProxy(A)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=k}),define(ne[99],re([0,1,62,5]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(T){return(0,R.hash)({moduleId:T.process.moduleId,windowId:T.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(ne[212],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var R;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(R=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(ne[213],re([0,1,84,6,21,3,2,20,31,8,99,212]),function(X,e,R,n,k,T,A,C,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const w=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${w})`);const p=(0,E.hash)(S);this.processeDisposables.has(p)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${w})`),this.doDisposeWorker(S));const g=new k.CancellationTokenSource;let u,f,h;this.processeDisposables.set(p,i=>{g.dispose(!0),u?.terminate(S,k.CancellationToken.None),f?.close(),h?.close(),this.processeDisposables.delete(p);const o=this.processResolvers.get(p);o&&(this.processResolvers.delete(p),o({reason:i}))}),u=await this.getOrCreateWebWorker(S);const s=new Promise(i=>{this.processResolvers.set(p,i)});if(g.token.isCancellationRequested)return s;const{port1:r,port2:t}=new MessageChannel;return f=r,h=t,await u.spawn(S,h,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${w})`),R.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[f])),s}getOrCreateWebWorker(S){let w=this.workers.get(S.process.moduleId);if(!w){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const p=new y(S.process.type,this.logService);w=p.init(),p.onDidProcessSelfTerminate(({configuration:g,reason:u})=>{this.doDisposeWorker(g,u)}),this.workers.set(S.process.moduleId,w)}return w}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,w){const p=this.processeDisposables.get((0,E.hash)(S));p&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),p(w))}};v=ge([K(0,I.ILogService)],v),e.SharedProcessWorkerService=v;class y extends A.Disposable{constructor(S,w){super();this.type=S,this.logService=w,this._onDidProcessSelfTerminate=this._register(new T.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new n.DeferredPromise,w=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return w.onerror=p=>{this.logService.error(`SharedProcess: worker error (${this.type})`,p.message)},w.onmessageerror=p=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,p)},w.onmessage=p=>{const{id:g,message:u,configuration:f,nonce:h}=p.data;switch(g){case b.SharedProcessWorkerMessages.Ready:S.complete(w);break;case b.SharedProcessWorkerMessages.Ack:if(h){const s=this.mapMessageNonceToPendingMessageResolve.get(h);s&&(this.mapMessageNonceToPendingMessageResolve.delete(h),s())}break;case b.SharedProcessWorkerMessages.SelfTerminated:f&&u&&this._onDidProcessSelfTerminate.fire({configuration:f,reason:JSON.parse(u)});break;case b.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,u);break;case b.SharedProcessWorkerMessages.Info:u&&this.logService.info(u);break;case b.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,u);break;case b.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,u);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,p)}},w.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,w,p){const g=await this.workerReady;if(!w.isCancellationRequested)return new Promise(u=>{const f=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(f,u);const h={...S,nonce:f};p?g.postMessage(h,[p]):g.postMessage(h),w.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(f)&&u()})})}spawn(S,w,p){const g={id:b.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:C.FileAccess.asFileUri("bootstrap-fork",X).fsPath}};return this.send(g,p,w)}terminate(S,w){const p={id:b.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(p,w)}}}),define(ne[214],re([0,1,60,20,169]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class T extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}ge([R.memoize],T.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=T}),define(ne[215],re([0,1,48,12,154,21,38,9,4,31,136,167,6]),function(X,e,R,n,k,T,A,C,P,I,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let d;async function S(p,g,u){return g["force-disable-user-env"]?(p.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(p.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(u)&&!g["force-user-env"]?(p.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(u)?p.trace("resolveShellEnv(): running (--force-user-env)"):p.trace("resolveShellEnv(): running (macOS/Linux)"),d||(d=v.Promises.withAsyncBody(async(f,h)=>{const s=new T.CancellationTokenSource,r=setTimeout(()=>{s.dispose(!0),h(new Error((0,k.localize)(0,null)))},y);try{f(await w(p,s.token))}catch(t){!(0,C.isCancellationError)(t)&&!s.token.isCancellationRequested?h(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(t)))):f({})}finally{clearTimeout(r),s.dispose()}})),d)}e.getResolvedShellEnv=S;async function w(p,g){const u=process.env.ELECTRON_RUN_AS_NODE;p.trace("getUnixShellEnvironment#runAsNode",u);const f=process.env.ELECTRON_NO_ATTACH_CONSOLE;p.trace("getUnixShellEnvironment#noAttach",f);const h=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(h+"(.*)"+h),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};p.trace("getUnixShellEnvironment#env",r);const t=await(0,E.getSystemShell)(P.OS,r);return p.trace("getUnixShellEnvironment#shell",t),new Promise((i,o)=>{if(g.isCancellationRequested)return o((0,C.canceled)());const c=(0,n.basename)(t);let a,l;const m=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(c)?(a=`& '${process.execPath}' ${m} -p '''${h}'' + JSON.stringify(process.env) + ''${h}'''`,l=["-Login","-Command"]):(a=`'${process.execPath}' ${m} -p '"${h}" + JSON.stringify(process.env) + "${h}"'`,c==="tcsh"?l=["-ic"]:l=["-ilc"]),p.trace("getUnixShellEnvironment#spawn",JSON.stringify(l),a);const D=(0,R.spawn)(t,[...l,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(D.kill(),o((0,C.canceled)()))),D.on("error",F=>{p.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),o(F)});const U=[];D.stdout.on("data",F=>U.push(F));const O=[];D.stderr.on("data",F=>O.push(F)),D.on("close",(F,L)=>{const N=Buffer.concat(U).toString("utf8");p.trace("getUnixShellEnvironment#raw",N);const W=Buffer.concat(O).toString("utf8");if(W.trim()&&p.trace("getUnixShellEnvironment#stderr",W),F||L)return o(new Error((0,k.localize)(2,null,F,L)));const V=s.exec(N),J=V?V[1]:"{}";try{const $=JSON.parse(J);u?$.ELECTRON_RUN_AS_NODE=u:delete $.ELECTRON_RUN_AS_NODE,f?$.ELECTRON_NO_ATTACH_CONSOLE=f:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,p.trace("getUnixShellEnvironment#result",$),i($)}catch($){p.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)($)),o($)}})})}}),define(ne[100],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,R.createDecorator)(e.SIGN_SERVICE_ID)}),define(ne[216],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class R{constructor(){this.validators=new Map}vsda(){return new Promise((k,T)=>X(["vsda"],k,T))}async createNewMessage(k){try{const T=await this.vsda(),A=new T.validator;if(A){const C=String(R._nextId++);return this.validators.set(C,A),{id:C,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,T){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(T)==="ok"}catch{return!1}}async sign(k){try{const T=await this.vsda(),A=new T.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=R,R._nextId=1}),define(ne[217],re([0,1,3,2]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class k extends n.Disposable{constructor(E,b,v){super();this.channel=E,this.profile=b,this.workspace=v}async getItems(){const E={profile:this.profile,workspace:this.workspace},b=await this.channel.call("getItems",E);return new Map(b)}updateItems(E){const b={profile:this.profile,workspace:this.workspace};return E.insert&&(b.insert=Array.from(E.insert.entries())),E.delete&&(b.delete=Array.from(E.delete.values())),this.channel.call("updateItems",b)}}class T extends k{constructor(E,b){super(E,b,void 0);this._onDidChangeItemsExternal=this._register(new R.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(E=>this.onDidChangeStorage(E)))}onDidChangeStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class A extends T{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class C extends T{constructor(E,b){super(E,b)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=C;class P extends k{constructor(E,b){super(E,void 0,b);this.onDidChangeItemsExternal=R.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P}),define(ne[101],re([0,1,4,36,7,31]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(I){if(R.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function C(I,E,b,v,y,d,S,w,p,g){const u=Object.create(null);u["common.machineId"]=S,u.sessionID=(0,T.generateUuid)()+Date.now(),u.commitHash=y,u.version=d,u["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,R.PlatformToString)(R.platform),u["common.nodePlatform"]=n.platform,u["common.nodeArch"]=v,u["common.product"]=g||"desktop",w&&(u["common.msftInternal"]=w);let f=0;const h=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),R.isLinuxSnap&&(u["common.snap"]="true");const s=A(b);s&&(u["common.platformDetail"]=s);try{const r=await I.readFile(k.URI.file(p));u["common.source"]=r.value.toString().slice(0,30)}catch{}return u}e.resolveCommonProperties=C;function P(I){const E=n.env.USERDNSDOMAIN;if(!E)return!1;const b=E.toLowerCase();return I.some(v=>b===v)}e.verifyMicrosoftInternalDomain=P}),define(ne[22],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,R.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,R.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ne[218],re([0,1,37,52,6,35,20,12,4,7,129,27,131,89,13,24,22]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const p=new Map;async function g(r,t){const i=`${r}::${t.join(":")}`,o=p.get(i);if(o)return o;const c=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,l=new Map,m=2e4;function D(O,F,L,N){const W=F.substring(O.length+1);return k.Promises.withAsyncBody(async V=>{let J;try{J=await b.Promises.readdir(F,{withFileTypes:!0})}catch{V();return}if(N.count>=m){N.count+=J.length,N.maxReached=!0,V();return}let $=J.length;if($===0){V();return}let Q=J;N.count+J.length>m&&(N.maxReached=!0,$=m-N.count,Q=J.slice(0,$)),N.count+=J.length;for(const H of Q)if(H.isDirectory()){if(L.includes(H.name)||await D(O,(0,C.join)(F,H.name),L,N),--$==0){V();return}}else{const B=H.name.lastIndexOf(".");if(B>=0){const Y=H.name.substring(B+1);Y&&a.set(Y,(a.get(Y)??0)+1)}for(const Y of c)Y.relativePathPattern?.test(W)!==!1&&Y.filePattern.test(H.name)&&l.set(Y.tag,(l.get(Y.tag)??0)+1);if(--$==0){V();return}}})}const U=k.Promises.withAsyncBody(async O=>{const F={count:0,maxReached:!1};await D(r,r,t,F);const L=await h(r);O({configFiles:u(l),fileTypes:u(a),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:L})});return p.set(i,U),U}e.collectWorkspaceStats=g;function u(r){return[...n.Iterable.map(r.entries(),([t,i])=>({name:t,count:i}))].sort((t,i)=>i.count-t.count)}function f(){const r={os:`${R.type()} ${R.arch()} ${R.release()}`,memory:`${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=R.cpus();return t&&t.length>0&&(r.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),r}e.getMachineInfo=f;async function h(r){try{const t=new Map,i=(0,C.join)(r,".vscode","launch.json"),o=await b.Promises.readFile(i),c=[],a=(0,T.parse)(o.toString(),c);if(c.length)return console.log(`Unable to parse ${i}`),[];if((0,T.getNodeType)(a)==="object"&&a.configurations)for(const l of a.configurations){const m=l.type;m&&(t.has(m)?t.set(m,t.get(m)+1):t.set(m,1))}return u(t)}catch{return[]}}e.collectLaunchConfigs=h;let s=class{constructor(t,i){this.telemetryService=t,this.productService=i}formatMachineInfo(t){const i=[];return i.push(`OS Version:       ${t.os}`),i.push(`CPUs:             ${t.cpus}`),i.push(`Memory (System):  ${t.memory}`),i.push(`VM:               ${t.vmHint}`),i.join(`
`)}formatEnvironment(t){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${R.type()} ${R.arch()} ${R.release()}`);const o=R.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(R.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(R.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${R.loadavg().map(c=>Math.round(c)).join(", ")}`),i.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${t.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(t,i){return Promise.all([(0,v.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[c,a]=o,l=this.formatProcessList(t,c);return i.forEach(m=>{if((0,y.isRemoteDiagnosticError)(m))l+=`
${m.errorMessage}`,a+=`
${m.errorMessage}`;else if(l+=`

Remote: ${m.hostName}`,m.processes&&(l+=`
${this.formatProcessList(t,m.processes)}`),m.workspaceMetadata){a+=`
|  Remote: ${m.hostName}`;for(const D of Object.keys(m.workspaceMetadata)){const U=m.workspaceMetadata[D];let O=`${U.fileCount} files`;U.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${D}): ${O}`,a+=this.formatWorkspaceStats(U)}}}),{processInfo:l,workspaceInfo:a}})}async getSystemInfo(t,i){const{memory:o,vmHint:c,os:a,cpus:l}=f(),m={os:a,memory:o,cpus:l,vmHint:c,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(m.load=`${R.loadavg().map(D=>Math.round(D)).join(", ")}`),P.isLinux&&(m.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(m)}async getDiagnostics(t,i){const o=[];return(0,v.listProcesses)(t.mainPID).then(async c=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,c)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),i.forEach(a=>{if((0,y.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const l of Object.keys(a.workspaceMetadata)){const m=a.workspaceMetadata[l];let D=`${m.fileCount} files`;m.maxFilesReached&&(D=`more than ${D}`),o.push(`Folder (${l}): ${D}`),o.push(this.formatWorkspaceStats(m))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const i=[],o=60;let c=0;const a=(U,O)=>{const F=` ${U}(${O})`;c+F.length>o?(i.push(l),l="|                 ",c=l.length):c+=F.length,l+=F};let l="|      File types:";const m=10,D=t.fileTypes.length>m?m:t.fileTypes.length;for(let U=0;U<D;U++){const O=t.fileTypes[U];a(O.name,O.count)}if(i.push(l),t.configFiles.length>=0&&(l="|      Conf files:",c=0,t.configFiles.forEach(U=>{a(U.name,U.count)}),i.push(l)),t.launchConfigFiles.length>0){let U="|      Launch Configs:";t.launchConfigFiles.forEach(O=>{U+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(U)}return i.join(`
`)}expandGPUFeatures(t){const i=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const i=[],o=[];return t.windows.forEach(c=>{c.folderURIs.length===0||!!c.remoteAuthority||(i.push(`|  Window (${c.title})`),c.folderURIs.forEach(a=>{const l=I.URI.revive(a);if(l.scheme===A.Schemas.file){const m=l.fsPath;o.push(g(m,["node_modules",".git"]).then(D=>{let U=`${D.fileCount} files`;D.maxFilesReached&&(U=`more than ${U}`),i.push(`|    Folder (${(0,C.basename)(m)}): ${U}`),i.push(this.formatWorkspaceStats(D))}).catch(D=>{i.push(`|      Error: Unable to collect workspace stats for folder ${m} (${D.toString()})`)}))}else i.push(`|    Folder (${l.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(c=>i.join(`
`)).catch(c=>`Unable to collect workspace stats: ${c}`)}formatProcessList(t,i){const o=new Map;t.windows.forEach(a=>o.set(a.pid,a.title));const c=[];return c.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(t.mainPID,o,c,i,0),c.join(`
`)}formatProcessItem(t,i,o,c,a){const l=a===0;let m;l?m=c.pid===t?`${this.productService.applicationName} main`:"remote agent":(m=`${"  ".repeat(a)} ${c.name}`,c.name==="window"&&(m=`${m} (${i.get(c.pid)})`));const D=process.platform==="win32"?c.mem:R.totalmem()*(c.mem/100);o.push(`${c.load.toFixed(0).padStart(5," ")}	${(D/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${c.pid.toFixed(0).padStart(6," ")}	${m}`),Array.isArray(c.children)&&c.children.forEach(U=>this.formatProcessItem(t,i,o,U,a+1))}async getWorkspaceFileExtensions(t){const i=new Set;for(const{uri:o}of t.folders){const c=I.URI.revive(o);if(c.scheme!==A.Schemas.file)continue;const a=c.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(m=>i.add(m.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(t){for(const{uri:i}of t.folders){const o=I.URI.revive(i);if(o.scheme!==A.Schemas.file)continue;const c=o.fsPath;try{const a=await g(c,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),a.launchConfigFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})}),a.configFiles.forEach(l=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:l.name,count:l.count})})}catch{}}}};s=ge([K(0,w.ITelemetryService),K(1,S.IProductService)],s),e.DiagnosticsService=s}),define(ne[102],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class R{constructor(T){this.appenders=T}listen(T,A){throw new Error(`Event not found: ${A}`)}call(T,A,{eventName:C,data:P}){return this.appenders.forEach(I=>I.log(C,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=R;class n{constructor(T){this.channel=T}log(T,A){return this.channel.call("log",{eventName:T,data:A}).then(void 0,C=>`Failed to log telemetry: ${console.warn(C)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(ne[50],re([0,1,30,78,15,19,101,22]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,n.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class I{async publicLog(s,r,t){}async publicLogError(s,r,t){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(h,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&h.publicLog2("updateConfiguration",{configurationSource:(0,T.ConfigurationTargetToString)(r.source),configurationKeys:p(r.sourceConfig)})})}e.configurationTelemetry=E;function b(h,s){return!(s.disableTelemetry||!h.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=b;function v(h){const s=h.getValue(C.TELEMETRY_SETTING_ID),r=h.getValue("telemetry.enableCrashReporter");if(h.getValue(C.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function y(h){const s={},r={},t={};w(h,t);for(let i in t){i=i.length>150?i.substr(i.length-149):i;const o=t[i];typeof o=="number"?r[i]=o:typeof o=="boolean"?r[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),s[i]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(s[i]=o)}return{properties:s,measurements:r}}e.validateTelemetryData=y;const d=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(h){if(!h)return"none";for(const s of d)if(h.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=S;function w(h,s,r=0,t){if(!!h)for(const i of Object.getOwnPropertyNames(h)){const o=h[i],c=t?t+i:i;Array.isArray(o)?s[c]=(0,R.safeStringify)(o):o instanceof Date?s[c]=o.toISOString():(0,k.isObject)(o)?r<2?w(o,s,r+1,c+"."):s[c]=(0,R.safeStringify)(o):s[c]=o}}function p(h){if(!h)return[];const s=[];return g(s,"",h),s}function g(h,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(t=>g(h,s?`${s}.${t}`:t,r[t])):h.push(s)}function u(h,s){const r=h.msftInternalDomains||[],t=s.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(r)||t}e.isInternalTelemetry=u;function f(h){return[h.appRoot,h.extensionsPath,h.userHome.fsPath,h.tmpDir.fsPath,h.userDataPath]}e.getPiiPathsFromEnvironment=f}),define(ne[219],re([0,1,49,50]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(T,A,C,P,I,E,b){const v={"X-Market-Client-Id":`VSCode ${T}`,"User-Agent":`VSCode ${T} (${A.nameShort})`},y=await(0,R.getServiceMachineId)(C,I,E),{sessionId:d}=await b.getTelemetryInfo();return(0,n.supportsTelemetry)(A,C)&&(0,n.getTelemetryLevel)(P)===3&&(v["X-Market-User-Id"]=y,v["VSCode-SessionId"]=d),v}e.resolveMarketplaceHeaders=k}),define(ne[220],re([0,1,9,30,50]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const T="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(P,I,E){const b=await new Promise((w,p)=>{X(["@microsoft/1ds-core-js"],w,p)}),v=await new Promise((w,p)=>{X(["@microsoft/1ds-post-js"],w,p)}),y=new b.AppInsightsCore,d=new v.PostChannel,S={instrumentationKey:P,endpointUrl:T,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[d]]};if(E){S.extensionConfig={};const w={alwaysUseXhrOverride:!0,httpXHROverride:E};S.extensionConfig[d.identifier]=w}return y.initialize(S,[]),y.addTelemetryInitializer(w=>{I&&(w.ext=w.ext??{},w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),y}class C{constructor(I,E,b,v,y){this._isInternalTelemetry=I,this._eventPrefix=E,this._defaultData=b,this._xhrOverride=y,this.endPointUrl=T,this._defaultData||(this._defaultData={}),typeof v=="function"?this._aiCoreOrKey=v():this._aiCoreOrKey=v,this._asyncAiCore=null}_withAIClient(I){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){I(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(E=>{I(E)},E=>{(0,R.onUnexpectedError)(E),console.error(E)})}}log(I,E){if(!this._aiCoreOrKey)return;E=(0,n.mixin)(E,this._defaultData),E=(0,k.validateTelemetryData)(E);const b=this._eventPrefix+"/"+I;try{this._withAIClient(v=>{v.pluginVersionString=E?.properties.version??"Unknown",v.track({name:b,baseData:{name:b,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(I=>{this._withAIClient(E=>{E.unload(!0,()=>{this._aiCoreOrKey=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=C}),define(ne[221],re([0,1,220]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemWebAppender=void 0;class n extends R.AbstractOneDataSystemAppender{constructor(T,A,C,P){super(T,A,C,P);fetch(this.endPointUrl,{method:"POST"}).catch(I=>{this._aiCoreOrKey=void 0})}}e.OneDataSystemWebAppender=n}),define(ne[103],re([0,1,2,14,8,50]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends R.Disposable{constructor(P,I,E=""){super();this.prefix=E;const b=P.getLogger(I.telemetryLogResource);b?this.logger=this._register(b):(this.logger=this._register(P.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,I){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,T.validateTelemetryData)(I))}};A=ge([K(0,k.ILoggerService),K(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(ne[104],re([0,1,2,30,78,4,26,155,19,43,96,24,40,22,50]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(g,u,f){this._configurationService=u,this._productService=f,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new R.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const h of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(h),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,u){this._experimentProperties[g]=u}_updateTelemetryLevel(){let g=(0,d.getTelemetryLevel)(this._configurationService);const u=this._productService.enabledTelemetryLevels;if(u){this._sendErrorTelemetry=this.sendErrorTelemetry?u.error:!1;const f=u.usage?3:u.error?2:0;g=Math.min(g,f)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,u=g.sessionID,f=g["common.machineId"],h=g["common.firstSessionDate"],s=g["common.msftInternal"];return{sessionId:u,machineId:f,firstSessionDate:h,msftInternal:s}}dispose(){this._disposables.dispose()}_log(g,u,f,h){return this.telemetryLevel.value<u?Promise.resolve(void 0):this._commonProperties.then(s=>{f=(0,n.mixin)(f,s),f=(0,n.mixin)(f,this._experimentProperties),f=(0,n.cloneAndChange)(f,r=>{if(typeof r=="string")return this._cleanupInfo(r,h)}),this._appenders.forEach(r=>r.log(g,f))},s=>{console.error(s)})}publicLog(g,u,f){return this._log(g,3,u,f)}publicLog2(g,u,f){return this.publicLog(g,u,f)}publicLogError(g,u){return this._sendErrorTelemetry?this._log(g,2,u,!0):Promise.resolve(void 0)}publicLogError2(g,u){return this.publicLogError(g,u)}_anonymizeFilePaths(g){let u=g;const f=[];for(const t of this._cleanupPatterns)for(;;){const i=t.exec(g);if(!i)break;f.push([i.index,t.lastIndex])}const h=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(u="";;){const t=s.exec(g);if(!t)break;!h.test(t[0])&&f.every(([i,o])=>t.index<i||t.index>=o)&&(u+=g.substring(r,t.index)+"<REDACTED: user-file-path>",r=s.lastIndex)}return r<g.length&&(u+=g.substr(r)),u}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const u=g.toLowerCase(),f=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const h of f)if(h.regex.test(u))return`<REDACTED: ${h.label}>`;return g}_cleanupInfo(g,u){let f=g;u&&(f=this._anonymizeFilePaths(f));for(const h of this._cleanupPatterns)f=f.replace(h,"");return f=this._removePropertiesWithPossibleUserInfo(f),f}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=ge([K(1,P.IConfigurationService),K(2,b.IProductService)],S),e.TelemetryService=S;function w(){const p=(0,C.localize)(0,null,E.default.nameLong),g=E.default.privacyStatementUrl?(0,C.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,C.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=T.isWeb?"":(0,C.localize)(3,null),f=(0,C.localize)(4,null),h=(0,C.localize)(5,null),s=(0,C.localize)(6,null),r=(0,C.localize)(7,null),t=`
|       | ${f} | ${h} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,C.localize)(8,null);return`
${p} ${g} ${u}

&nbsp;

${r}
${t}

&nbsp;

${i}
`}v.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,C.localize)(10,null),(0,C.localize)(11,null),(0,C.localize)(12,null),(0,C.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,C.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,C.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,C.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,C.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ne[222],re([0,1,20,64,19,14,8,24,22,102,103,104]),function(X,e,R,n,k,T,A,C,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(d,S,w,p,g){this.configurationService=d,this.telemetryService=S,this.loggerService=w,this.environmentService=p,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(d){if(!this.customTelemetryServices.has(d.id)){const{machineId:S,sessionId:w}=await this.telemetryService.getTelemetryInfo(),p=Object.create(null);p["common.vscodemachineid"]=S,p["common.vscodesessionid"]=w;const g=[d.id,JSON.stringify(p),d.aiKey],f=new n.Client(R.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),h=[new I.TelemetryAppenderClient(f),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${d.id}] `)];this.customTelemetryServices.set(d.id,new b.TelemetryService({appenders:h,sendErrorTelemetry:d.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(d.id)}async publicLog(d,S,w){await(await this.getCustomTelemetryService(d)).publicLog(S,w)}async publicLogError(d,S,w){await(await this.getCustomTelemetryService(d)).publicLogError(S,w)}};v=ge([K(0,k.IConfigurationService),K(1,P.ITelemetryService),K(2,A.ILoggerService),K(3,T.IEnvironmentService),K(4,C.IProductService)],v),e.CustomEndpointTelemetryService=v}),define(ne[223],re([0,1,6,21,3,2,8]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let C=class extends T.Disposable{constructor(I,E){super();this._logService=E,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((E,b)=>{const v=++this._lastRequestId;this._pendingRequests.set(v,E),this._onCreateRequest.fire({requestId:v,...I});const y=new n.CancellationTokenSource;(0,R.timeout)(this._timeout,y.token).then(()=>b(`Request ${v} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(v,[(0,T.toDisposable)(()=>y.cancel())])})}acceptReply(I,E){const b=this._pendingRequests.get(I);b?(this._pendingRequests.delete(I),(0,T.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),b(E)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};C=ge([K(1,A.ILogService)],C),e.RequestStore=C}),define(ne[105],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(u){u.Shell="terminal.integrated.shell.",u.ShellArgs="terminal.integrated.shellArgs.",u.DefaultProfile="terminal.integrated.defaultProfile.",u.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(u){u.ShellLinux="terminal.integrated.shell.linux",u.ShellMacOs="terminal.integrated.shell.osx",u.ShellWindows="terminal.integrated.shell.windows",u.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",u.AutomationShellLinux="terminal.integrated.automationShell.linux",u.AutomationShellMacOs="terminal.integrated.automationShell.osx",u.AutomationShellWindows="terminal.integrated.automationShell.windows",u.AutomationProfileLinux="terminal.integrated.automationProfile.linux",u.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",u.AutomationProfileWindows="terminal.integrated.automationProfile.windows",u.ShellArgsLinux="terminal.integrated.shellArgs.linux",u.ShellArgsMacOs="terminal.integrated.shellArgs.osx",u.ShellArgsWindows="terminal.integrated.shellArgs.windows",u.ProfilesWindows="terminal.integrated.profiles.windows",u.ProfilesMacOs="terminal.integrated.profiles.osx",u.ProfilesLinux="terminal.integrated.profiles.linux",u.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",u.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",u.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",u.UseWslProfiles="terminal.integrated.useWslProfiles",u.TabsDefaultColor="terminal.integrated.tabs.defaultColor",u.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",u.TabsEnabled="terminal.integrated.tabs.enabled",u.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",u.TabsHideCondition="terminal.integrated.tabs.hideCondition",u.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",u.TabsShowActions="terminal.integrated.tabs.showActions",u.TabsLocation="terminal.integrated.tabs.location",u.TabsFocusMode="terminal.integrated.tabs.focusMode",u.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",u.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",u.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",u.CopyOnSelection="terminal.integrated.copyOnSelection",u.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",u.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",u.FontFamily="terminal.integrated.fontFamily",u.FontSize="terminal.integrated.fontSize",u.LetterSpacing="terminal.integrated.letterSpacing",u.LineHeight="terminal.integrated.lineHeight",u.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",u.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",u.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",u.BellDuration="terminal.integrated.bellDuration",u.FontWeight="terminal.integrated.fontWeight",u.FontWeightBold="terminal.integrated.fontWeightBold",u.CursorBlinking="terminal.integrated.cursorBlinking",u.CursorStyle="terminal.integrated.cursorStyle",u.CursorWidth="terminal.integrated.cursorWidth",u.Scrollback="terminal.integrated.scrollback",u.DetectLocale="terminal.integrated.detectLocale",u.DefaultLocation="terminal.integrated.defaultLocation",u.GpuAcceleration="terminal.integrated.gpuAcceleration",u.TerminalTitleSeparator="terminal.integrated.tabs.separator",u.TerminalTitle="terminal.integrated.tabs.title",u.TerminalDescription="terminal.integrated.tabs.description",u.RightClickBehavior="terminal.integrated.rightClickBehavior",u.Cwd="terminal.integrated.cwd",u.ConfirmOnExit="terminal.integrated.confirmOnExit",u.ConfirmOnKill="terminal.integrated.confirmOnKill",u.EnableBell="terminal.integrated.enableBell",u.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",u.AllowChords="terminal.integrated.allowChords",u.AllowMnemonics="terminal.integrated.allowMnemonics",u.EnvMacOs="terminal.integrated.env.osx",u.EnvLinux="terminal.integrated.env.linux",u.EnvWindows="terminal.integrated.env.windows",u.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",u.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",u.ShowExitAlert="terminal.integrated.showExitAlert",u.SplitCwd="terminal.integrated.splitCwd",u.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",u.WordSeparators="terminal.integrated.wordSeparators",u.EnableFileLinks="terminal.integrated.enableFileLinks",u.UnicodeVersion="terminal.integrated.unicodeVersion",u.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",u.LocalEchoEnabled="terminal.integrated.localEchoEnabled",u.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",u.LocalEchoStyle="terminal.integrated.localEchoStyle",u.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",u.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",u.CustomGlyphs="terminal.integrated.customGlyphs",u.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",u.InheritEnv="terminal.integrated.inheritEnv",u.ShowLinkHover="terminal.integrated.showLinkHover",u.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",u.AutoReplies="terminal.integrated.autoReplies",u.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",u.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",u.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",u.ShellIntegrationDecorationIcon="terminal.integrated.shellIntegration.decorationIcon",u.ShellIntegrationDecorationIconError="terminal.integrated.shellIntegration.decorationIconError",u.ShellIntegrationDecorationIconSuccess="terminal.integrated.shellIntegration.decorationIconSuccess",u.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var T;(function(u){u.FileName="ptyhost"})(T=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(u){u.PowerShell="pwsh",u.Bash="bash",u.Fish="fish",u.Sh="sh",u.Csh="csh",u.Ksh="ksh",u.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var C;(function(u){u.CommandPrompt="cmd",u.PowerShell="pwsh",u.Wsl="wsl",u.GitBash="gitbash"})(C=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(u){u[u.Api=0]="Api",u[u.Process=1]="Process",u[u.Sequence=2]="Sequence",u[u.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(u){u.LocalPty="localPty",u.PtyHost="ptyHost",u.Log="log",u.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,R.createDecorator)("ptyService");var E;(function(u){u.Cwd="cwd",u.InitialCwd="initialCwd",u.FixedDimensions="fixedDimensions",u.Title="title",u.ShellType="shellType",u.HasChildProcesses="hasChildProcesses",u.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",u.OverrideDimensions="overrideDimensions",u.FailedShellIntegrationActivation="failedShellIntegrationActivation",u.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var b;(function(u){u[u.BeatInterval=5e3]="BeatInterval",u[u.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",u[u.SecondWaitMultiplier=1]="SecondWaitMultiplier",u[u.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(u){u[u.Panel=1]="Panel",u[u.Editor=2]="Editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(u){u.TerminalView="view",u.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var d;(function(u){u[u.GraceTime=6e4]="GraceTime",u[u.ShortGraceTime=6e3]="ShortGraceTime"})(d=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(u){u[u.HighWatermarkChars=1e5]="HighWatermarkChars",u[u.LowWatermarkChars=5e3]="LowWatermarkChars",u[u.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var w;(function(u){u.GitBash="Git Bash",u.Pwsh="PowerShell"})(w=e.ProfileSource||(e.ProfileSource={}));var p;(function(u){u[u.Off=0]="Off",u[u.FinalTerm=1]="FinalTerm",u[u.VSCode=2]="VSCode"})(p=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(u){u[u.Unknown=0]="Unknown",u[u.Shutdown=1]="Shutdown",u[u.Process=2]="Process",u[u.User=3]="User",u[u.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(ne[224],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,R.createDecorator)("localPtyService")}),define(ne[225],re([0,1,37,20,30,12,4,36,26,15,27]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function b(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(R.release());let h=0;return f&&f.length===4&&(h=parseInt(f[3])),h}e.getWindowsBuildNumber=b;async function v(f,h,s,r=C.env,t=E.Promises.exists){if(T.isAbsolute(f))return await t(f)?f:void 0;if(h===void 0&&(h=C.cwd()),T.dirname(f)!=="."){const a=T.join(h,f);return await t(a)?a:void 0}const o=(0,k.getCaseInsensitive)(r,"PATH");if(s===void 0&&(0,I.isString)(o)&&(s=o.split(T.delimiter)),s===void 0||s.length===0){const a=T.join(h,f);return await t(a)?a:void 0}for(const a of s){let l;if(T.isAbsolute(a)?l=T.join(a,f):l=T.join(h,a,f),await t(l))return l;if(A.isWindows){let m=l+".com";if(await t(m)||(m=l+".exe",await t(m)))return m}}const c=T.join(h,f);return await t(c)?c:void 0}e.findExecutable=v;function y(f,h,s){if(!h.enabled||!f.executable||f.isFeatureTerminal||f.hideFromUser||f.ignoreShellIntegration)return;const r=f.args,t=C.platform==="win32"?T.basename(f.executable).toLowerCase():T.basename(f.executable),i=T.dirname(n.FileAccess.asFileUri("",X).fsPath);let o;const c={VSCODE_INJECTION:"1"};if(A.isWindows){if(t==="pwsh.exe")return!r||g(r)?o=e.shellIntegrationArgs.get(d.WindowsPwsh):p(r)&&(o=e.shellIntegrationArgs.get(d.WindowsPwshLogin)),o?(o&&(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,"")),{newArgs:o,envMixin:c}):void 0;s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args);return}switch(t){case"bash":return!r||r.length===0?o=e.shellIntegrationArgs.get(d.Bash):u(r)&&(c.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(d.Bash)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i),{newArgs:o,envMixin:c}):void 0;case"pwsh":return!r||g(r)?o=e.shellIntegrationArgs.get(d.Pwsh):p(r)&&(o=e.shellIntegrationArgs.get(d.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,""),{newArgs:o,envMixin:c}):void 0;case"zsh":{if(!r||r.length===0?o=e.shellIntegrationArgs.get(d.Zsh):u(r)?o=e.shellIntegrationArgs.get(d.ZshLogin):(r===e.shellIntegrationArgs.get(d.Zsh)||r===e.shellIntegrationArgs.get(d.ZshLogin))&&(o=r),!o)return;o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i);const a=T.join(R.tmpdir(),"vscode-zsh");c.ZDOTDIR=a;const l=[];return l.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:T.join(a,".zshrc")}),l.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:T.join(a,".zprofile")}),l.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:T.join(a,".zshenv")}),l.push({source:T.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:T.join(a,".zlogin")}),{newArgs:o,envMixin:c,filesToCopy:l}}}s.warn(`Shell integration cannot be enabled for executable "${f.executable}" and args`,f.args)}e.getShellIntegrationInjection=y;var d;(function(f){f.WindowsPwsh="windows-pwsh",f.WindowsPwshLogin="windows-pwsh-login",f.Pwsh="pwsh",f.PwshLogin="pwsh-login",f.Zsh="zsh",f.ZshLogin="zsh-login",f.Bash="bash"})(d=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(d.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(d.Zsh,["-i"]),e.shellIntegrationArgs.set(d.ZshLogin,["-il"]),e.shellIntegrationArgs.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],w=["-nol","-nologo"];function p(f){return typeof f=="string"?S.includes(f.toLowerCase()):f.length===1&&S.includes(f[0].toLowerCase())||f.length===2&&(S.includes(f[0].toLowerCase())||S.includes(f[1].toLowerCase()))&&(w.includes(f[0].toLowerCase())||w.includes(f[1].toLowerCase()))}function g(f){return typeof f=="string"?w.includes(f.toLowerCase()):f.length===0||f?.length===1&&w.includes(f[0].toLowerCase())}function u(f){return f==="string"&&S.includes(f.toLowerCase())||typeof f!="string"&&f.length===1&&S.includes(f[0].toLowerCase())}}),define(ne[226],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var R;(function(T){T.DARK="dark",T.LIGHT="light",T.HIGH_CONTRAST_DARK="hcDark",T.HIGH_CONTRAST_LIGHT="hcLight"})(R=e.ColorScheme||(e.ColorScheme={}));function n(T){return T===R.HIGH_CONTRAST_DARK||T===R.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function k(T){return T===R.DARK||T===R.HIGH_CONTRAST_DARK}e.isDark=k}),define(ne[106],re([0,1,51,3,2,5,40,226]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,T.createDecorator)("themeService");var P;(function(w){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}w.isThemeColor=p})(P=e.ThemeColor||(e.ThemeColor={}));function I(w){return{id:w}}e.themeColorFromId=I;var E;(function(w){function p(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||P.isThemeColor(i.color))}w.isThemeIcon=p;const g=new RegExp(`^\\$\\((${R.CSSIcon.iconNameExpression}(?:${R.CSSIcon.iconModifierExpression})?)\\)$`);function u(i){const o=g.exec(i);if(!o)return;const[,c]=o;return{id:c}}w.fromString=u;function f(i){return{id:i}}w.fromId=f;function h(i,o){let c=i.id;const a=c.lastIndexOf("~");return a!==-1&&(c=c.substring(0,a)),o&&(c=`${c}~${o}`),{id:c}}w.modify=h;function s(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}w.getModifier=s;function r(i,o){return i.id===o.id&&i.color?.id===o.color?.id}w.isEqual=r;function t(i,o){return{id:i.id,color:o?I(o):void 0}}w.asThemeIcon=t,w.asClassNameArray=R.CSSIcon.asClassNameArray,w.asClassName=R.CSSIcon.asClassName,w.asCSSSelector=R.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=R.Codicon.file,e.FolderThemeIcon=R.Codicon.folder;function b(w){switch(w){case C.ColorScheme.DARK:return"vs-dark";case C.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case C.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=b,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(p){return this.themingParticipants.push(p),this.onThemingParticipantAddedEmitter.fire(p),(0,k.toDisposable)(()=>{const g=this.themingParticipants.indexOf(p);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new v;A.Registry.add(e.Extensions.ThemingContribution,y);function d(w){return y.onColorThemeChange(w)}e.registerThemingParticipant=d;class S extends k.Disposable{constructor(p){super();this.themeService=p,this.theme=p.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(p){this.theme=p,this.updateStyles()}updateStyles(){}getColor(p,g){let u=this.theme.getColor(p);return u&&g&&(u=g(u,this.theme)),u?u.toString():null}}e.Themable=S}),define(ne[227],re([0,1,51,7,157,106]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(v,y){const d=[{name:null,description:(0,k.localize)(0,null)}];return d.push(...v.map(S=>({name:S.profileName,description:C(S)}))),y&&d.push(...y.map(S=>({name:S.title,description:P(S)}))),{values:d.map(S=>S.name),markdownDescriptions:d.map(S=>S.description)}}e.createProfileSchemaEnums=A;function C(v){let y=`$(${T.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:R.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?y+=`
- args: "${v.args}"`:y+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(y+=`
- overrideName: ${v.overrideName}`),v.color&&(y+=`
- color: ${v.color}`),v.env&&(y+=`
- env: ${JSON.stringify(v.env)}`),y}function P(v){return`$(${T.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:R.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function I(v,y){if(!v&&!y)return!0;if(typeof v=="string"&&typeof y=="string")return v===y;if(Array.isArray(v)&&Array.isArray(y)){if(v.length!==y.length)return!1;for(let d=0;d<v.length;d++)if(v[d]!==y[d])return!1;return!0}return!1}e.terminalProfileArgsMatch=I;function E(v,y){if(!v&&!y)return!0;if(!v||!y)return!1;if(T.ThemeIcon.isThemeIcon(v)&&T.ThemeIcon.isThemeIcon(y))return v.id===y.id&&v.color===y.color;if(typeof v=="object"&&v&&"light"in v&&"dark"in v&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const d=v,S=y;if((n.URI.isUri(d.light)||b(d.light))&&(n.URI.isUri(d.dark)||b(d.dark))&&(n.URI.isUri(S.light)||b(S.light))&&(n.URI.isUri(S.dark)||b(S.dark)))return d.light.path===S.light.path&&d.dark.path===S.dark.path}if(n.URI.isUri(v)&&n.URI.isUri(y)||b(v)||b(y)){const d=v,S=y;return d.path===S.path&&d.scheme===S.scheme}return!1}e.terminalIconsEqual=E;function b(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=b}),define(ne[228],re([0,1,51,156,43,40,227]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(R.Codicon.getAll(),f=>f.id),markdownEnumDescriptions:Array.from(R.Codicon.getAll(),f=>`$(${f.id})`)};const C={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...C}},I={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...C}},E=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),d=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),w={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...C}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...C}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...C}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...C}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function p(){T.Registry.as(k.Extensions.Configuration).registerConfiguration(w),u()}e.registerTerminalPlatformConfiguration=p;let g;function u(f,h){const s=T.Registry.as(k.Extensions.Configuration);let r;f&&(r=(0,A.createProfileSchemaEnums)(f?.profiles,h));const t=g;g={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:f?.os===3?r?.values:void 0,markdownEnumDescriptions:f?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:f?.os===2?r?.values:void 0,markdownEnumDescriptions:f?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:f?.os===1?r?.values:void 0,markdownEnumDescriptions:f?.os===1?r?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=u}),define(ne[229],re([0,1,48,51,12,4,27,82,225,106]),function(X,e,R,n,k,T,A,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,b=!0;function v(r,t,i,o,c=process.env,a,l,m,D){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},T.isWindows?y(i,a,c,l,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),D,m):f(a,l,i,r&&typeof r=="object"?{...r}:o.getValue(T.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(T.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),D,m,c)}e.detectAvailableProfiles=v;async function y(r,t,i,o,c,a,l,m,D){const U=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${U?"Sysnative":"System32"}`;let F=!1;(0,P.getWindowsBuildNumber)()>=16299&&(F=!0),await w(m);const L=new Map;r&&(L.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),L.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),L.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),L.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),h(a,L);const N=await d(L.entries(),l,t,i,o,D);if(r||!r&&c)try{const W=await g(`${O}\\${F?"wsl":"bash"}.exe`,l);for(const V of W)(!a||!(V.profileName in a))&&N.push(V)}catch{b&&(o?.info("WSL is not installed, so could not detect WSL profiles"),b=!1)}return N}async function d(r,t,i,o=process.env,c,a){const l=[];for(const[m,D]of r){if(D===null)continue;let U,O,F;if("source"in D){const W=E?.get(D.source);if(!W)continue;U=W.paths,O=D.args||W.args,D.icon?F=S(D.icon):W.icon&&(F=W.icon)}else U=Array.isArray(D.path)?D.path:[D.path],O=T.isWindows||Array.isArray(D.args)?D.args:void 0,F=S(D.icon);const L=await a?.(U)||U.slice(),N=await s(m,t,L,i,o,O,D.env,D.overrideName,D.isAutoDetected,c);N?(N.isAutoDetected=D.isAutoDetected,N.icon=F,N.color=D.color,l.push(N)):c?.debug("Terminal profile not validated",m,U)}return c?.debug("Validated terminal profiles",l),l}function S(r){return typeof r=="string"?{id:r}:r}async function w(r){E&&!r||(E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),E.set("PowerShell",{profileName:"PowerShell",paths:r||await p(),icon:I.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function p(){const r=[];for await(const t of(0,C.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function g(r,t){const i=[],o=await new Promise((l,m)=>{R.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(D,U)=>{if(D)return m("Problem occurred when getting wsl distros");l(U)})});if(!o)return[];const c=new RegExp(/[\r?\n]/),a=o.split(c).filter(l=>l.trim().length>0&&l!=="");for(const l of a){if(l===""||l.startsWith("docker-desktop"))continue;const m=`${l} (WSL)`,D={profileName:m,path:r,args:["-d",`${l}`],isDefault:m===t,icon:u(l),isAutoDetected:!1};i.push(D)}return i}function u(r){return r.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):r.includes("Debian")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function f(r,t,i,o,c,a,l,m){const D=new Map;if(i){const U=(await r.readFile("/etc/shells")).toString(),O=a||U.split(`
`).filter(L=>L.trim().indexOf("#")!==0&&L.trim().length>0),F=new Map;for(const L of O){let N=(0,k.basename)(L),W=F.get(N)||0;W++,W>1&&(N=`${N} (${W})`),F.set(N,W),D.set(N,{path:L,isAutoDetected:!0})}}return h(o,D),await d(D.entries(),c,r,m,t,l)}function h(r,t){if(!!r)for(const[i,o]of Object.entries(r))o===null||!("path"in o)&&!("source"in o)?t.delete(i):(o.icon=o.icon||t.get(i)?.icon,t.set(i,o))}async function s(r,t,i,o,c,a,l,m,D,U){if(i.length===0)return Promise.resolve(void 0);const O=i.shift();if(O==="")return s(r,t,i,o,c,a,l,m,D);const F={profileName:r,path:O,args:a,env:l,overrideName:m,isAutoDetected:D,isDefault:r===t};if((0,k.basename)(O)===O){const N=c.PATH?c.PATH.split(k.delimiter):void 0,W=await(0,P.findExecutable)(O,void 0,N,void 0,o.existsFile);return W?(F.path=W,F.isFromPath=!0,F):s(r,t,i,o,c,a)}return await o.existsFile((0,k.normalize)(O))?F:s(r,t,i,o,c,a,l,m,D)}}),define(ne[230],re([0,1,3,2,20,4,39,64,19,14,87,215,8,95,223,105,228,229]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(h){h[h.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let u=0,f=class extends n.Disposable{constructor(s,r,t,i){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=t,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new R.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new R.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new R.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new R.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new R.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new R.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new R.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new R.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new R.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new R.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new R.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new R.Emitter),this.onProcessExit=this._onProcessExit.event,(0,w.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new d.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(T.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:u,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,E.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const t=new C.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,s);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=t.getChannel(S.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const c=A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(c.onProcessData(a=>this._onProcessData.fire(a))),this._register(c.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(c.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(c.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(c.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(c.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(c.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,c]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,t,i,o,c,a,l,m,D,U){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(s,r,t,i,o,c,a,l,m,D,U);return clearTimeout(O),u=Math.max(u,F),F}updateTitle(s,r,t){return this._proxy.updateTitle(s,r,t)}updateIcon(s,r,t){return this._proxy.updateIcon(s,r,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,t){return this._proxy.resize(s,r,t)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}installAutoReply(s,r){return this._proxy.installAutoReply(s,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(s){return this._proxy.uninstallAutoReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,t,i=!1){const o=await this._shellEnv;return(0,p.detectAvailableProfiles)(r,t,i,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}getRevivedPtyNewId(s){return this._proxy.getRevivedPtyNewId(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s,r){return this._proxy.reviveTerminalProcesses(s,r)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,t){return this._proxy.updateProperty(s,r,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};f=ge([K(1,P.IConfigurationService),K(2,I.IEnvironmentService),K(3,v.ILogService)],f),e.PtyHostService=f}),define(ne[69],re([0,1,3,4,5,8]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var C;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(C=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!w)return{address:w[1],port:+w[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=b;function v(S,w){return w?w!==1&&S<1024:!n.isWindows&&S<1024}e.isPortPrivileged=v;class y{constructor(w,p,g){this.remoteAddress=w,this.localAddress=p,this._dispose=g,this._onDispose=new R.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let d=class{constructor(w){this.logService=w,this._onTunnelOpened=new R.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new R.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new R.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(w){return this._tunnelProvider=w,w?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this._canElevate=w.elevation,this._privacyOptions=w.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const w=[],p=Array.from(this._tunnels.values());for(const g of p){const u=Array.from(g.values());for(const f of u){const h=await f.value;h&&w.push(h)}}return w}async dispose(){for(const w of this._tunnels.values()){for(const{value:p}of w.values())await p.then(g=>g?.dispose());w.clear()}this._tunnels.clear()}openTunnel(w,p,g,u,f=!1,h,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${p}:${g} on local port ${u}.`),!w)return;if(p||(p="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(w,p,g,u,f,h,s);return r?r.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(p,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(t);return(t.tunnelRemoteHost!==p||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const p=this._tunnels.get(w.tunnelRemoteHost);if(p){const g=p.get(w.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(w.tunnelRemoteHost,w.tunnelRemotePort,g))}}}}async tryDisposeTunnel(w,p,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${p}.`);const u=g.value.then(async f=>{f&&(await f.dispose(!0),this._onTunnelClosed.fire({host:f.tunnelRemoteHost,port:f.tunnelRemotePort}))});return this._tunnels.has(w)&&this._tunnels.get(w).delete(p),u}}async closeTunnel(w,p){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${p} `);const g=this._tunnels.get(w);if(g&&g.has(p)){const u=g.get(p);u.refcount=0,await this.tryDisposeTunnel(w,p,u)}}addTunnelToMap(w,p,g){this._tunnels.has(w)||this._tunnels.set(w,new Map),this._tunnels.get(w).set(p,{refcount:1,value:g})}async removeEmptyTunnelFromMap(w,p){const g=this._tunnels.get(w);g&&(await g.get(p)||g.delete(p),g.size===0&&this._tunnels.delete(w))}getTunnelFromMap(w,p){const g=[w];E(w)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):b(w)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const u=g.map(f=>this._tunnels.get(f));for(const f of u){const h=f?.get(p);if(h)return h}}canTunnel(w){return!!I(w)}createWithProvider(w,p,g,u,f,h,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${p}:${g} on local port ${u}.`);const r=g;this._factoryInProgress.add(r);const i={elevationRequired:f?v(u===void 0?g:u):!1},o={remoteAddress:{host:p,port:g},localAddressPort:u,privacy:h,public:h?h!==C.Private:void 0,protocol:s},c=w.forwardPort(o,i);return c?(this.addTunnelToMap(p,g,c),c.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),c}};d=ge([K(0,T.ILogService)],d),e.AbstractTunnelService=d}),define(ne[231],re([0,1,8,69,2,9,6]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class C extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(E){this._address=E,this._addressPromise&&(this._addressPromise.complete(E),this._addressPromise=null)}setTunnel(E){this._register(E)}}let P=class Ct extends k.Disposable{constructor(E,b){super();this._tunnelService=E,this._logService=b,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(E,b,v,y,d,S){const w=new C,p=await Promise.resolve(this._tunnelService.openTunnel(E,w,v,y,d,S));if(!p)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${y} (remote).`),w.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(b))throw this._disposedTunnels.delete(b),w.dispose(),await p.dispose(),(0,T.canceled)();return w.setTunnel(p),this._tunnels.set(b,w),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${p.localAddress} (local) to ${v}:${y} (remote).`),{tunnelLocalPort:p.tunnelLocalPort,localAddress:p.localAddress}}async setAddress(E,b){const v=this._tunnels.get(E);!v||v.setAddress(b)}async destroyTunnel(E){const b=this._tunnels.get(E);if(b){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this._tunnels.delete(E),await b.dispose();return}this._disposedTunnels.add(E)}};P._lastId=0,P=ge([K(0,n.ISharedTunnelsService),K(1,R.ILogService)],P),e.SharedProcessTunnelService=P}),define(ne[232],re([0,1,76,116,206,6,2,19,8,24,204,69,100]),function(X,e,R,n,k,T,A,C,P,I,E,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(g,u,f,h,s){let r;for(let t=3;t&&(r?.dispose(),r=await new d(g,u,f,h,s).waitForReady(),!(s&&n.BROWSER_RESTRICTED_PORTS[s]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));t--);return r}class d extends A.Disposable{constructor(u,f,h,s,r){super();this.defaultTunnelHost=f,this.suggestedLocalPort=r,this.privacy=b.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=u,this._server=R.createServer(),this._barrier=new T.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=h}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(f=>{f()})}async waitForReady(){let u=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),f=null;return this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address(),f||(u=0,this._server.listen(u,this.defaultTunnelHost),await this._barrier.wait(),f=this._server.address()),this.tunnelLocalPort=f.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${f.port}`,this}async _onConnection(u){u.pause();const f=(0,b.isLocalhost)(this.tunnelRemoteHost)||(0,b.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,h=await(0,E.connectRemoteAgentTunnel)(this._options,f,this.tunnelRemotePort),s=h.getSocket().socket,r=h.readEntireBuffer();h.dispose(),r.byteLength>0&&u.write(r.buffer),u.on("end",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),s.end()}),u.on("close",()=>s.end()),u.on("error",()=>{u.localAddress&&this._socketsDispose.delete(u.localAddress),s.destroy()}),s.on("end",()=>u.end()),s.on("close",()=>u.end()),s.on("error",()=>{u.destroy()}),u.pipe(s),s.pipe(u),u.localAddress&&this._socketsDispose.set(u.localAddress,()=>{u.end(),s.end()})}}let S=class extends b.AbstractTunnelService{constructor(u,f,h,s,r){super(f);this.socketFactory=u,this.signService=h,this.productService=s,this.configurationService=r}get defaultTunnelHost(){const u=this.configurationService.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(u,f,h,s,r,t,i){const o=this.getTunnelFromMap(f,h);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,f,h,s,r,t,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${f}:${h} on local port ${s}.`);const c={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:u,signService:this.signService,logService:this.logService,ipcLogger:null},a=y(c,this.defaultTunnelHost,f,h,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(f,h,a),a}}};S=ge([K(1,P.ILogService),K(2,v.ISignService),K(3,I.IProductService),K(4,C.IConfigurationService)],S),e.BaseTunnelService=S;let w=class extends S{constructor(u,f,h,s){super(k.nodeSocketFactory,u,f,h,s)}};w=ge([K(0,P.ILogService),K(1,v.ISignService),K(2,I.IProductService),K(3,C.IConfigurationService)],w),e.TunnelService=w;let p=class extends A.Disposable{constructor(u,f,h,s){super();this.logService=u,this.productService=f,this.signService=h,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(u,f,h,s,r,t,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${h}:${s} on local port ${r}.`),!this._tunnelServices.has(u)){const c=new w(this.logService,this.signService,this.productService,this.configurationService);this._register(c),this._tunnelServices.set(u,c),c.onTunnelClosed(async()=>{(await c.tunnels).length===0&&(c.dispose(),this._tunnelServices.delete(u))})}return this._tunnelServices.get(u).openTunnel(f,h,s,r,t,i,o)}};p=ge([K(0,P.ILogService),K(1,I.IProductService),K(2,v.ISignService),K(3,C.IConfigurationService)],p),e.SharedTunnelsService=p}),define(ne[33],re([0,1,5]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,R.createDecorator)("IUriIdentityService")}),define(ne[233],re([0,1,3,2,7,14,32,13,8,33]),function(X,e,R,n,k,T,A,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let E=class extends n.Disposable{constructor(v,y,d,S,w){super();this.extensionsManagementService=v,this.logService=S,this.uriIdentityService=w,this._onDidChangeExtensionsByAnotherSource=this._register(new R.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(u=>u.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(g=>this.onInstallExtension(g))),this._register(v.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(v.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const p=k.URI.file(d.extensionsPath);this._register(y.watch(p)),this._register(R.Event.filter(y.onDidFilesChange,g=>g.rawChanges.some(u=>this.doesChangeAffects(u,p)))(()=>this.onDidChange()))}doesChangeAffects(v,y){return v.type!==1&&v.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v.resource),y)?!1:this.uriIdentityService.extUri.isEqual(v.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(v.resource).startsWith(".")}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const y of v)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(),y=v.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(w=>(0,A.areSameExtensions)(w,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),d=this.installedExtensions.filter(S=>this.installingExtensions.some(w=>(0,A.areSameExtensions)(w,S))?!1:v.every(w=>!(0,A.areSameExtensions)(w.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=v.map(S=>S.identifier),(y.length||d.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:d})}}};E=ge([K(1,C.IFileService),K(2,T.INativeEnvironmentService),K(3,P.ILogService),K(4,I.IUriIdentityService)],E),e.ExtensionsWatcher=E}),define(ne[234],re([0,1,33,88,13,17,113,3,2]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(v){this.uri=v,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let E=class{constructor(v){this._fileService=v,this._dispooables=new P.DisposableStore,this._limit=2**16;const y=new Map,d=S=>{let w=y.get(S.scheme);return w===void 0&&(w=v.hasProvider(S)&&!this._fileService.hasCapability(S,1024),y.set(S.scheme,w)),w};this._dispooables.add(C.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new T.ExtUri(d),this._canonicalUris=new A.SkipList((S,w)=>this.extUri.compare(S,w,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,T.normalizePath)(v));const y=this._canonicalUris.get(v);return y?y.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new I(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((d,S)=>d[1].touch<S[1].touch?1:d[1].touch>S[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let d=0;d<y;d++)this._canonicalUris.set(v[d][0],v[d][1].touch())}};E=ge([K(0,k.IFileService)],E),e.UriIdentityService=E,(0,n.registerSingleton)(R.IUriIdentityService,E,!0)}),define(ne[235],re([0,1,3,2,13,41,34,16]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{constructor(E,b,v,y){super();this.fileSystemScheme=E,this.fileSystemProvider=b,this.userDataScheme=v,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(d=>this.handleFileChanges(d)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,b){this.watchResources.set(E,E);const v=this.fileSystemProvider.watch(this.toFileSystemResource(E),b);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),v.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,b,v){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(b),v)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,b,v){const y=(0,T.newWriteableStream)(d=>C.VSBuffer.concat(d.map(S=>C.VSBuffer.wrap(S))).buffer);return(async()=>{try{const d=await this.readFile(E);y.end(d)}catch(d){y.error(d),y.end()}})(),y}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,b,v){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),b,v)}delete(E,b){return this.fileSystemProvider.delete(this.toFileSystemResource(E),b)}copy(E,b,v){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(E),this.toFileSystemResource(b),v);throw new Error("copy not supported")}handleFileChanges(E){const b=[];for(const v of E){if(v.resource.scheme!==this.fileSystemScheme)continue;const y=this.toUserDataResource(v.resource);this.watchResources.findSubstr(y)&&b.push({resource:y,type:v.type})}b.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(b))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(ne[59],re([0,1,75]),function(X,e,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,C,P,I){const E=(0,R.setProperty)(A,C,P,I)[0];return E&&(A=A.substring(0,E.offset)+E.content+A.substring(E.offset+E.length)),A}e.edit=n;function k(A,C,P){let I=P;for(;I>=0;){if(A.charAt(I)===C.charAt(C.length-1)&&C.length===1)return I+1;if(I--,C.length===2&&I>=0&&A.charAt(I)===C.charAt(0))return I+2}return 0}e.getLineStartOffset=k;function T(A,C,P){let I=P;for(;I>=0;)if(A.charAt(I)===C.charAt(C.length-1)&&C.length===1||(I++,C.length===2&&I>=0&&A.charAt(I)===C.charAt(1)))return I;return A.length-1}e.getLineEndOffset=T}),define(ne[236],re([0,1,30,55,15]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function T(v,y,d,S,w){const p=[],g=[],u=[];if(!y){const O=v.filter(({identifier:F})=>w.every(L=>L.toLowerCase()!==F.id.toLowerCase()));return{local:{added:p,removed:g,updated:u},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}v=v.map(E),y=y.map(E),d=d?d.map(E):null;const f=new Map,h=O=>{O.uuid&&f.set(O.id.toLowerCase(),O.uuid)};v.forEach(({identifier:O})=>h(O)),y.forEach(({identifier:O})=>h(O)),d?.forEach(({identifier:O})=>h(O));const s=O=>{const F=O.identifier.uuid||f.get(O.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${O.identifier.id.toLowerCase()}`},r=(O,F)=>(O.set(s(F),F),O),t=v.reduce(r,new Map),i=y.reduce(r,new Map),o=y.reduce((O,F)=>{const L=s(F);F=(0,R.deepClone)(F);const N=t.get(L);return N&&(N.installed&&(F.installed=!0),F.version||(F.version=N.version)),r(O,F)},new Map),c=d?d.reduce(r,new Map):null,a=S.reduce(r,new Map),l=w.reduce((O,F)=>{const L=f.get(F.toLowerCase());return O.add(L?`uuid:${L}`:`id:${F.toLowerCase()}`)},new Set),m=A(t,i,l);if(m.added.size>0||m.removed.size>0||m.updated.size>0){const O=A(c,t,l),F=A(c,i,l),L=(N,W)=>{const V=t.get(N);if(V){const J=i.get(N),$=W?J:V;return{...$,version:J.version&&(!V.installed||n.gt(J.version,V.version))?J.version:V.version,state:C(V,J,c?.get(N)),preRelease:(0,k.isUndefined)($.preRelease)?V.preRelease:V.installed?$.preRelease:J.preRelease}}};for(const N of F.removed.values()){const W=t.get(N);W&&g.push(W.identifier)}for(const N of F.added.values())if(O.added.has(N)){if(m.updated.has(N)){const W=L(N,!0);W&&(u.push(b(W,N)),o.set(N,W))}}else{const W=i.get(N);W.installed&&p.push(b(W,N))}for(const N of F.updated.values()){const W=L(N,!0);W&&(u.push(b(W,N)),o.set(N,W))}for(const N of O.added.values())F.added.has(N)||o.set(N,t.get(N));for(const N of O.updated.values())if(!F.removed.has(N)&&!F.updated.has(N)){const W=L(N,!1);W&&(o.get(N)?.installed&&(W.installed=!0),o.set(N,W))}for(const N of O.removed.values())!a.has(N)&&!F.updated.has(N)&&c?.get(N)?.installed&&o.delete(N)}const D=[],U=A(i,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(U.added.size>0||U.updated.size>0||U.removed.size>0)&&o.forEach((O,F)=>D.push(b(O,F))),{local:{added:p,removed:g,updated:u},remote:D.length?{added:[...U.added].map(O=>o.get(O)),updated:[...U.updated].map(O=>o.get(O)),removed:[...U.removed].map(O=>i.get(O)),all:D}:null}}e.merge=T;function A(v,y,d,{checkInstalledProperty:S,checkVersionProperty:w}={checkInstalledProperty:!1,checkVersionProperty:!1}){const p=v?[...v.keys()].filter(s=>!d.has(s)):[],g=[...y.keys()].filter(s=>!d.has(s)),u=g.filter(s=>p.indexOf(s)===-1).reduce((s,r)=>(s.add(r),s),new Set),f=p.filter(s=>g.indexOf(s)===-1).reduce((s,r)=>(s.add(r),s),new Set),h=new Set;for(const s of p){if(f.has(s))continue;const r=v.get(s),t=y.get(s);(!t||r.disabled!==t.disabled||r.installed&&t.installed&&r.preRelease!==t.preRelease||!I(r.state,t.state)||w&&r.version!==t.version||S&&r.installed!==t.installed)&&h.add(s)}return{added:u,removed:f,updated:h}}function C(v,y,d){const S=v.state,w=y.state,p=d?.state;if(!y.version||S&&n.gt(v.version,y.version))return S;if(w&&n.gt(y.version,v.version)||!S)return w;if(!w)return S;const g=(0,R.deepClone)(S),u=p?P(p,w):{added:Object.keys(w).reduce((h,s)=>(h.add(s),h),new Set),removed:new Set,updated:new Set},f=p?P(p,S):{added:Object.keys(S).reduce((h,s)=>(h.add(s),h),new Set),removed:new Set,updated:new Set};for(const h of[...u.added.values(),...u.updated.values()])g[h]=w[h];for(const h of u.removed.values())f.updated.has(h)||delete g[h];return g}function P(v,y){const d=Object.keys(v),S=Object.keys(y),w=S.filter(u=>d.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),p=d.filter(u=>S.indexOf(u)===-1).reduce((u,f)=>(u.add(f),u),new Set),g=new Set;for(const u of d){if(p.has(u))continue;const f=v[u],h=y[u];(0,R.equals)(f,h)||g.add(u)}return{added:w,removed:p,updated:g}}function I(v={},y={}){const{added:d,removed:S,updated:w}=P(v,y);return d.size===0&&S.size===0&&w.size===0}function E(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function b(v,y){const d={identifier:{id:v.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!v.preRelease};return v.version&&(d.version=v.version),v.disabled&&(d.disabled=!0),v.installed&&(d.installed=!0),v.state&&(d.state=v.state),d}}),define(ne[107],re([0,1,18,19,5]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let T=class{constructor(C){this.configurationService=C}hasToNeverSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(C.toLowerCase())}hasToAlwaysSyncExtension(C){return this.getConfiguredIgnoredExtensions().includes(`-${C.toLowerCase()}`)}updateIgnoredExtensions(C,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==C&&E!==`-${C}`),P&&I.push(C.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}updateSynchronizedExtensions(C,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==C&&E!==`-${C}`),P&&I.push(`-${C.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}getIgnoredExtensions(C){const P=C.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),E=[],b=[];if(Array.isArray(I))for(const v of I)v.startsWith("-")?b.push(v.substring(1)):E.push(v);return(0,R.distinct)([...P,...E].filter(v=>b.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let C=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return C!==void 0||(C=this.configurationService.inspect("sync.ignoredExtensions").userValue,C!==void 0)?C:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};T=ge([K(0,n.IConfigurationService)],T),e.IgnoredExtensionsManagementService=T}),define(ne[237],re([0,1,18,35,30,174,59]),function(X,e,R,n,k,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function C(f){return(0,n.parse)(f)||[]}e.parseKeybindings=C;async function P(f,h,s,r,t){const i=C(f),o=C(h),c=s?C(s):null,a=[...i,...o,...c||[]].map(J=>J.key),l=await t.resolveUserBindings(a),m=E(i,o,c,l);if(!m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:f,hasChanges:!1,hasConflicts:!1};if(!m.hasLocalForwarded&&m.hasRemoteForwarded)return{mergeContent:h,hasChanges:!0,hasConflicts:!1};if(m.hasLocalForwarded&&!m.hasRemoteForwarded)return{mergeContent:f,hasChanges:!0,hasConflicts:!1};const D=v(i),U=v(o),O=c?v(c):null,F=d(D,U,l),L=O?d(O,D,l):{added:[...D.keys()].reduce((J,$)=>(J.add($),J),new Set),removed:new Set,updated:new Set},N=O?d(O,U,l):{added:[...U.keys()].reduce((J,$)=>(J.add($),J),new Set),removed:new Set,updated:new Set},W=I(F,L,N);let V=f;for(const J of W.removed.values())W.conflicts.has(J)||(V=g(V,J,r));for(const J of W.added.values()){if(W.conflicts.has(J))continue;const $=U.get(J);if($.some(Q=>Q.command!==`-${J}`&&m.conflicts.has(l[Q.key]))){W.conflicts.add(J);continue}V=p(V,$,r)}for(const J of W.updated.values()){if(W.conflicts.has(J))continue;const $=U.get(J);if($.some(Q=>Q.command!==`-${J}`&&m.conflicts.has(l[Q.key]))){W.conflicts.add(J);continue}V=u(V,J,$,r)}return{mergeContent:V,hasChanges:!0,hasConflicts:W.conflicts.size>0}}e.merge=P;function I(f,h,s){const r=new Set,t=new Set,i=new Set,o=new Set;for(const c of h.removed.values())s.updated.has(c)&&o.add(c);for(const c of s.removed.values())o.has(c)||(h.updated.has(c)?o.add(c):t.add(c));for(const c of h.added.values())o.has(c)||s.added.has(c)&&f.updated.has(c)&&o.add(c);for(const c of s.added.values())o.has(c)||(h.added.has(c)?f.updated.has(c)&&o.add(c):r.add(c));for(const c of h.updated.values())o.has(c)||s.updated.has(c)&&f.updated.has(c)&&o.add(c);for(const c of s.updated.values())o.has(c)||(h.updated.has(c)?f.updated.has(c)&&o.add(c):i.add(c));return{added:r,removed:t,updated:i,conflicts:o}}function E(f,h,s,r){const t=new Set,i=b(f,r),o=b(h,r),c=s?b(s,r):null,a=y(i,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const l=c?y(c,i):{added:[...i.keys()].reduce((L,N)=>(L.add(N),L),new Set),removed:new Set,updated:new Set};if(l.added.size===0&&l.removed.size===0&&l.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const m=c?y(c,o):{added:[...o.keys()].reduce((L,N)=>(L.add(N),L),new Set),removed:new Set,updated:new Set};if(m.added.size===0&&m.removed.size===0&&m.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:D,removed:U,updated:O,conflicts:F}=I(a,l,m);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:D,removed:U,updated:O,conflicts:F}}function b(f,h){const s=new Map;for(const r of f){const t=h[r.key];let i=s.get(t);i||(i=[],s.set(t,i)),i.push(r)}return s}function v(f){const h=new Map;for(const s of f){const r=s.command[0]==="-"?s.command.substring(1):s.command;let t=h.get(r);t||(t=[],h.set(r,t)),t.push(s)}return h}function y(f,h){const s=[...f.keys()],r=[...h.keys()],t=r.filter(c=>s.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),i=s.filter(c=>r.indexOf(c)===-1).reduce((c,a)=>(c.add(a),c),new Set),o=new Set;for(const c of s){if(i.has(c))continue;const a=f.get(c).map(m=>({...m,key:c})),l=h.get(c).map(m=>({...m,key:c}));(0,R.equals)(a,l,(m,D)=>w(m,D))||o.add(c)}return{added:t,removed:i,updated:o}}function d(f,h,s){const r=[...f.keys()],t=[...h.keys()],i=t.filter(a=>r.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),o=r.filter(a=>t.indexOf(a)===-1).reduce((a,l)=>(a.add(l),a),new Set),c=new Set;for(const a of r){if(o.has(a))continue;const l=f.get(a).map(D=>({...D,key:s[D.key]})),m=h.get(a).map(D=>({...D,key:s[D.key]}));S(l,m)||c.add(a)}return{added:i,removed:o,updated:c}}function S(f,h){return!(!(0,R.equals)(f.filter(({command:s})=>s[0]!=="-"),h.filter(({command:s})=>s[0]!=="-"),(s,r)=>w(s,r))||!(0,R.equals)(f.filter(({command:s})=>s[0]==="-"),h.filter(({command:s})=>s[0]==="-"),(s,r)=>w(s,r)))}function w(f,h){if(f.command!==h.command||f.key!==h.key)return!1;const s=T.ContextKeyExpr.deserialize(f.when),r=T.ContextKeyExpr.deserialize(h.when);return!(s&&!r||!s&&r||s&&r&&!s.equals(r)||!k.equals(f.args,h.args))}function p(f,h,s){for(const r of h)f=A.edit(f,[-1],r,s);return f}function g(f,h,s){const r=C(f);for(let t=r.length-1;t>=0;t--)(r[t].command===h||r[t].command===`-${h}`)&&(f=A.edit(f,[t],void 0,s));return f}function u(f,h,s,r){const t=C(f),i=t.findIndex(o=>o.command===h||o.command===`-${h}`);for(let o=t.length-1;o>=0;o--)(t[o].command===h||t[o].command===`-${h}`)&&(f=A.edit(f,[o],void 0,r));for(let o=s.length-1;o>=0;o--)f=A.edit(f,[i],s[o],r);return f}}),define(ne[238],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function R(T,A,C){const P={},I={},E=new Set;if(!A)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:T,updated:{},removed:[]},conflicts:[]};const b=n(T,A);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=n(C,T),y=n(C,A),d={},S={},w=new Set,p=new Set;for(const g of v.removed.values())y.updated.has(g)?P[g]=A[g]:w.add(g);for(const g of y.removed.values())p.has(g)||(v.updated.has(g)?p.add(g):E.add(g));for(const g of v.updated.values())p.has(g)||(y.updated.has(g)?b.updated.has(g)&&p.add(g):S[g]=T[g]);for(const g of y.updated.values())p.has(g)||(v.updated.has(g)?b.updated.has(g)&&p.add(g):T[g]!==void 0&&(I[g]=A[g]));for(const g of v.added.values())p.has(g)||(y.added.has(g)?b.updated.has(g)&&p.add(g):d[g]=T[g]);for(const g of y.added.values())p.has(g)||(v.added.has(g)?b.updated.has(g)&&p.add(g):P[g]=A[g]);return{local:{added:P,removed:[...E.values()],updated:I},remote:{added:d,removed:[...w.values()],updated:S},conflicts:[...p.values()]}}e.merge=R;function n(T,A){const C=T?Object.keys(T):[],P=A?Object.keys(A):[],I=P.filter(v=>C.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),E=C.filter(v=>P.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),b=new Set;for(const v of C){if(E.has(v))continue;const y=T[v],d=A[v];y!==d&&b.add(v)}return{added:I,removed:E,updated:b}}function k(T,A){const{added:C,removed:P,updated:I}=n(T,A);return C.size===0&&P.size===0&&I.size===0}e.areSame=k}),define(ne[25],re([0,1,18,17,15,163,43,28,5,97,40]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function b(){const c=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(c).filter(a=>!!c[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=b;function v(){const c=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(c).filter(D=>!!c[D].ignoreSync),l=Object.keys(c).filter(D=>c[D].scope===2||c[D].scope===6),m=b();return(0,R.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...l,...m])}e.getDefaultIgnoredSettings=v,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const c="vscode://schemas/ignoredSettings",a=E.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,T.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,T.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,T.localize)(2,null),items:[{type:"string",pattern:C.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,T.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,T.localize)(4,null),default:[],scope:1,$ref:c,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const l=E.Registry.as(I.Extensions.JSONContribution),m=()=>{const D=b(),U=v().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(N=>U.indexOf(N)===-1),F=U.filter(N=>D.indexOf(N)===-1),L={items:{type:"string",enum:[...O,...F.map(N=>`-${N}`)]}};l.registerSchema(c,L)};return a.onDidUpdateConfiguration(()=>m())}e.registerConfiguration=y;function d(c){return c&&(0,k.isObject)(c)&&(0,k.isString)(c.id)&&Array.isArray(c.scopes)}e.isAuthenticationProvider=d;var S;(function(c){c.Settings="settings",c.Keybindings="keybindings",c.Snippets="snippets",c.Tasks="tasks",c.Extensions="extensions",c.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function w(c,a,l){return l.joinPath(a.userDataSyncHome,c,`lastSync${c}.json`)}e.getLastSyncResourceUri=w,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function p(c){const a={};return a[e.HEADER_EXECUTION_ID]=c,a}e.createSyncHeaders=p;var g;(function(c){c.Unauthorized="Unauthorized",c.Conflict="Conflict",c.Gone="Gone",c.PreconditionFailed="PreconditionFailed",c.TooLarge="TooLarge",c.UpgradeRequired="UpgradeRequired",c.PreconditionRequired="PreconditionRequired",c.TooManyRequests="RemoteTooManyRequests",c.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",c.RequestFailed="RequestFailed",c.RequestCanceled="RequestCanceled",c.RequestTimeout="RequestTimeout",c.RequestProtocolNotSupported="RequestProtocolNotSupported",c.RequestPathNotEscaped="RequestPathNotEscaped",c.RequestHeadersNotObject="RequestHeadersNotObject",c.NoRef="NoRef",c.EmptyResponse="EmptyResponse",c.TurnedOff="TurnedOff",c.SessionExpired="SessionExpired",c.ServiceChanged="ServiceChanged",c.DefaultServiceChanged="DefaultServiceChanged",c.LocalTooManyRequests="LocalTooManyRequests",c.LocalPreconditionFailed="LocalPreconditionFailed",c.LocalInvalidContent="LocalInvalidContent",c.LocalError="LocalError",c.IncompatibleLocalContent="IncompatibleLocalContent",c.IncompatibleRemoteContent="IncompatibleRemoteContent",c.UnresolvedConflicts="UnresolvedConflicts",c.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class u extends Error{constructor(a,l,m,D){super(a);this.code=l,this.resource=m,this.operationId=D,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=u;class f extends u{constructor(a,l,m,D,U){super(a,m,void 0,U);this.url=l,this.serverCode=D}}e.UserDataSyncStoreError=f;class h extends u{constructor(a,l){super(a,l)}}e.UserDataAutoSyncError=h,function(c){function a(l){if(l instanceof c)return l;const m=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(l.name);if(m&&m[1]){const D=m[2]==="unknown"?void 0:m[2],U=m[3]==="unknown"?void 0:m[3];return new c(l.message,m[1],D,U)}return new c(l.message,"Unknown")}c.toUserDataSyncError=a}(u=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(c){c.Uninitialized="uninitialized",c.Idle="idle",c.Syncing="syncing",c.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var r;(function(c){c[c.None=0]="None",c[c.Added=1]="Added",c[c.Modified=2]="Modified",c[c.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(c){c.Preview="preview",c.Conflict="conflict",c.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(c){return`sync.enable.${c}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(c,a){if(c.scheme!==e.USER_DATA_SYNC_SCHEME)return c=c.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(l=>(0,n.isEqualOrParent)(c,(0,n.joinPath)(a.userDataSyncHome,l,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(ne[239],re([0,1,30,25]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(C,P,I,E,b){if(!P)return{remote:Object.keys(C).length>0?C:null,local:{added:{},removed:[],updated:{}}};const v=T(C,P);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=I?T(I,P):{added:Object.keys(P).reduce((g,u)=>(g.add(u),g),new Set),removed:new Set,updated:new Set},d=I?T(I,C):{added:Object.keys(C).reduce((g,u)=>(g.add(u),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},w=R.deepClone(P),p=!I;for(const g of d.added.values())g!==n.SYNC_SERVICE_URL_TYPE&&p&&y.added.has(g)||(w[g]=C[g]);for(const g of d.updated.values())w[g]=C[g];for(const g of d.removed.values())E.unregistered.includes(g)||delete w[g];for(const g of y.added.values()){const u=P[g];if(E.machine.includes(g)){b.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(I&&d.added.has(g))continue;const f=C[g];f&&f.value===u.value||g===n.SYNC_SERVICE_URL_TYPE&&p&&d.added.has(g)||(f?S.updated[g]=u:S.added[g]=u)}for(const g of y.updated.values()){const u=P[g];if(E.machine.includes(g)){b.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(d.updated.has(g)||d.removed.has(g))continue;const f=C[g];f&&f.value===u.value||(S.updated[g]=u)}for(const g of y.removed.values()){if(E.machine.includes(g)){b.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}d.updated.has(g)||d.removed.has(g)||S.removed.push(g)}return{local:S,remote:A(w,P)?null:w}}e.merge=k;function T(C,P){const I=Object.keys(C),E=Object.keys(P),b=E.filter(d=>I.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),v=I.filter(d=>E.indexOf(d)===-1).reduce((d,S)=>(d.add(S),d),new Set),y=new Set;for(const d of I){if(v.has(d))continue;const S=C[d],w=P[d];R.equals(S,w)||y.add(d)}return{added:b,removed:v,updated:y}}function A(C,P){const{added:I,removed:E,updated:b}=T(C,P);return I.size===0&&E.size===0&&b.size===0}}),define(ne[240],re([0,1,18,35,75,53,30,59,25]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function I(a,l,m){let D=[];m?D=b(m):D=E(l);const U=[],O=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(D))for(const F of D)F.startsWith("-")?O.push(F.substring(1)):U.push(F);return(0,R.distinct)([...a,...U].filter(F=>O.indexOf(F)===-1))}e.getIgnoredSettings=I;function E(a){let l=a.inspect("settingsSync.ignoredSettings").userValue;return l!==void 0||(l=a.inspect("sync.ignoredSettings").userValue,l!==void 0)?l:a.getValue("settingsSync.ignoredSettings")||[]}function b(a){const l=(0,n.parse)(a);return l?l["settingsSync.ignoredSettings"]||l["sync.ignoredSettings"]||[]:[]}function v(a,l){const m=(0,n.parse)(a)||{};let D="{}";for(const U of Object.keys(m)){const O=(0,k.setProperty)(D,[U],m[U],l);D=(0,k.applyEdits)(D,O)}return D}e.removeComments=v;function y(a,l,m,D){if(m.length){const U=c(l),O=(0,n.parse)(l)||{},F=(0,n.parse)(a);if(!F)return a;const L=[];for(const N of m){const W=O[N],V=F[N];W===void 0?a=C.edit(a,[N],void 0,D):V!==void 0?a=C.edit(a,[N],W,D):L.push(s(N,U))}L.sort((N,W)=>N.startOffset-W.startOffset),L.forEach(N=>a=g(N.setting.key,l,a,D))}return a}e.updateIgnoredSettings=y;function d(a,l,m,D,U,O){const F=y(a,l,D,O),L=m!==F,N=m!==l;if(!L&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(L&&!N)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(N&&!L)return{conflictsSettings:[],localContent:y(l,a,D,O),remoteContent:null,hasConflicts:!1};if(m===null&&w(a)){const j=S(a,l,D)?null:y(l,a,D,O);return{conflictsSettings:[],localContent:j,remoteContent:null,hasConflicts:!1}}let W=a,V=l;const J=(0,n.parse)(a),$=(0,n.parse)(l),Q=m?(0,n.parse)(m):null,H=D.reduce((j,Z)=>(j.add(Z),j),new Set),B=p(J,$,H),Y=p(Q,J,H),ie=p(Q,$,H),ae=new Map,z=new Set,x=j=>{z.add(j);const Z=U.filter(({key:G})=>G===j)[0];Z?(W=C.edit(W,[j],Z.value,O),V=C.edit(V,[j],Z.value,O)):ae.set(j,{key:j,localValue:J[j],remoteValue:$[j]})};for(const j of Y.removed.values())ie.updated.has(j)?x(j):V=C.edit(V,[j],void 0,O);for(const j of ie.removed.values())z.has(j)||(Y.updated.has(j)?x(j):W=C.edit(W,[j],void 0,O));for(const j of Y.updated.values())z.has(j)||(ie.updated.has(j)?B.updated.has(j)&&x(j):V=C.edit(V,[j],J[j],O));for(const j of ie.updated.values())z.has(j)||(Y.updated.has(j)?B.updated.has(j)&&x(j):W=C.edit(W,[j],$[j],O));for(const j of Y.added.values())z.has(j)||(ie.added.has(j)?B.updated.has(j)&&x(j):V=g(j,W,V,O));for(const j of ie.added.values())z.has(j)||(Y.added.has(j)?B.updated.has(j)&&x(j):W=g(j,V,W,O));const _=ae.size>0||!S(W,V,D),M=_||!S(W,a,[]),q=_||!S(V,l,[]);return{localContent:M?W:null,remoteContent:q?V:null,conflictsSettings:[...ae.values()],hasConflicts:_}}e.merge=d;function S(a,l,m){if(a===l)return!0;const D=(0,n.parse)(a),U=(0,n.parse)(l),O=m.reduce((N,W)=>(N.add(W),N),new Set),F=c(a).filter(N=>!(N.setting&&O.has(N.setting.key))),L=c(l).filter(N=>!(N.setting&&O.has(N.setting.key)));if(F.length!==L.length)return!1;for(let N=0;N<F.length;N++){const W=F[N],V=L[N];if(W.setting&&V.setting){if(W.setting.key!==V.setting.key||!A.equals(D[W.setting.key],U[W.setting.key]))return!1}else if(!W.setting&&!V.setting){if(W.value!==V.value)return!1}else return!1}return!0}e.areSame=S;function w(a){return a?c(a).length===0:!0}e.isEmpty=w;function p(a,l,m){const D=a?Object.keys(a).filter(N=>!m.has(N)):[],U=Object.keys(l).filter(N=>!m.has(N)),O=U.filter(N=>D.indexOf(N)===-1).reduce((N,W)=>(N.add(W),N),new Set),F=D.filter(N=>U.indexOf(N)===-1).reduce((N,W)=>(N.add(W),N),new Set),L=new Set;if(a)for(const N of D){if(F.has(N))continue;const W=a[N],V=l[N];A.equals(W,V)||L.add(N)}return{added:O,removed:F,updated:L}}function g(a,l,m,D){const U=(0,n.parse)(l),O=c(l),F=c(m),L=u(a,O,F);return f(m,a,U[a],L,F,D)}e.addSetting=g;function u(a,l,m){const D=l.findIndex(O=>O.setting?.key===a),U=l[D-1];if(U){if(U.setting){const F=s(U.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!0}}else{const F=r(D,l);if(F){const L=s(F.setting.key,m);if(L){const N=t(m.indexOf(L),m),W=i(l,F,l[D]);if(N){const V=i(m,L,N),J=o(W,V);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.indexOf(N),insertAfter:!1}}else{const V=i(m,L,m[m.length-1]),J=o(W,V);return J?{index:m.indexOf(J),insertAfter:!0}:{index:m.length-1,insertAfter:!0}}}}}const O=l[D+1];if(O)if(O.setting){const F=s(O.setting.key,m);if(F)return{index:m.indexOf(F),insertAfter:!1}}else{const F=t(D,l);if(F){const L=s(F.setting.key,m);if(L){const N=r(m.indexOf(L),m),W=i(l,l[D],F);if(N){const V=i(m,N,L),J=o(W.reverse(),V.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:m.indexOf(N),insertAfter:!0}}else{const V=i(m,m[0],L),J=o(W.reverse(),V.reverse());return J?{index:m.indexOf(J),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:m.length-1,insertAfter:!0}}function f(a,l,m,D,U,O){let F;return D.index===-1?F=(0,k.setProperty)(a,[l],m,O):F=h(a,l,m,D,U,O).map(L=>(0,k.withFormatting)(a,L,O)[0]),(0,k.applyEdits)(a,F)}function h(a,l,m,D,U,O){const F=`${JSON.stringify(l)}: ${JSON.stringify(m)}`,L=(0,T.getEOL)(O,a),N=U[D.index];if(D.insertAfter){const W=[];if(N.setting)W.push({offset:N.endOffset,length:0,content:","+F});else{const V=t(D.index,U),J=r(D.index,U),$=J?.setting?.commaOffset;J&&$===void 0&&W.push({offset:J.endOffset,length:0,content:","});const Q=$!==void 0&&$>N.endOffset;W.push({offset:Q?$+1:N.endOffset,length:0,content:V?L+F+",":L+F})}return W}else{if(N.setting)return[{offset:N.startOffset,length:0,content:F+","}];const W=(U[D.index-1]&&!U[D.index-1].setting?L:"")+F+(t(D.index,U)?",":"")+L;return[{offset:N.startOffset,length:0,content:W}]}}function s(a,l){return l.filter(m=>m.setting?.key===a)[0]}function r(a,l){for(let m=a-1;m>=0;m--)if(l[m].setting)return l[m]}function t(a,l){for(let m=a+1;m<l.length;m++)if(l[m].setting)return l[m]}function i(a,l,m){const D=a.indexOf(l),U=a.indexOf(m);return a.filter((O,F)=>D<F&&F<U)}function o(a,l){if(a.length&&l.length){let m=0;for(;m<l.length&&m<a.length;m++)if(a[m].value!==l[m].value)return l[m-1];return l[m-1]}}function c(a){const l=[];let m=-1,D,U;const O={onObjectBegin:F=>{m++},onObjectProperty:(F,L,N)=>{m===0&&(D=L,U=F)},onObjectEnd:(F,L)=>{m--,m===0&&l.push({startOffset:D,endOffset:F+L,value:a.substring(D,F+L),setting:{key:U,commaOffset:void 0}})},onArrayBegin:(F,L)=>{m++},onArrayEnd:(F,L)=>{m--,m===0&&l.push({startOffset:D,endOffset:F+L,value:a.substring(D,F+L),setting:{key:U,commaOffset:void 0}})},onLiteralValue:(F,L,N)=>{m===0&&l.push({startOffset:D,endOffset:L+N,value:a.substring(D,L+N),setting:{key:U,commaOffset:void 0}})},onSeparator:(F,L,N)=>{if(m===0&&F===","){let W=l.length-1;for(;W>=0&&!l[W].setting;W--);const V=l[W];V&&l.splice(W,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:L}})}},onComment:(F,L)=>{m===0&&l.push({startOffset:F,endOffset:F+L,value:a.substring(F,F+L)})}};return(0,n.visit)(a,O),l}}),define(ne[70],re([0,1,3,2,5,25]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(P,I){super();this.userDataSyncStoreService=P,this.logService=I,this._onDidChangeAccount=this._register(new R.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new R.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};A=ge([K(0,T.IUserDataSyncStoreService),K(1,T.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(ne[241],re([0,1,6,16,61,2,17,19,14,13,25]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let b=class extends T.Disposable{constructor(y,d,S,w){super();this.environmentService=y,this.fileService=d,this.configurationService=S,this.logService=w,E.ALL_SYNC_RESOURCES.forEach(p=>this.cleanUpBackup(p))}async getAllRefs(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),S=await this.fileService.resolve(d);return S.children?S.children.filter(p=>p.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(p.name)).sort().reverse().map(p=>({ref:p.name,created:this.getCreationTime(p)})):[]}async resolveContent(y,d){if(!d){const S=await this.getAllRefs(y);S.length&&(d=S[S.length-1].ref)}if(d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,d);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(y,d){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),w=(0,A.joinPath)(S,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(w,n.VSBuffer.fromString(d))}catch(p){this.logService.error(p)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const d=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(d))return}catch{return}const S=await this.fileService.resolve(d);if(S.children){const w=S.children.filter(f=>f.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(f.name)).sort(),p=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=w.filter(f=>Date.now()-this.getCreationTime(f)>p);const u=w.length-g.length;u<10&&(g=g.slice(10-u)),await R.Promises.settled(g.map(async f=>{this.logService.info("Deleting from backup",f.resource.path),await this.fileService.del(f.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};b=ge([K(0,P.IEnvironmentService),K(1,I.IFileService),K(2,C.IConfigurationService),K(3,E.IUserDataSyncLogService)],b),e.UserDataSyncBackupStoreService=b}),define(ne[242],re([0,1,2,7]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(v){this.service=v}listen(v,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"triggerSync":return this.service.triggerSync(d[0],d[1],d[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(d[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class T{constructor(v){this.service=v}listen(v,y){throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(d[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(d[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=T;class A{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=A;class C{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(v,y,d){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(d[0],d[1]);case"setEnablements":return this.service.setEnablements(d)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=C;class P{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(d)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class I{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(v,y,d){switch(y){case"switch":return this.service.switch(d[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class E extends R.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:n.URI.revive(v.url),type:v.type,defaultUrl:n.URI.revive(v.defaultUrl),insidersUrl:n.URI.revive(v.insidersUrl),stableUrl:n.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=E}),define(ne[243],re([0,1,14,8]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends n.AbstractLogger{constructor(A,C){super();this.logger=this._register(A.createLogger(C.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...C){this.logger.trace(A,...C)}debug(A,...C){this.logger.debug(A,...C)}info(A,...C){this.logger.info(A,...C)}warn(A,...C){this.logger.warn(A,...C)}error(A,...C){this.logger.error(A,...C)}critical(A,...C){this.logger.critical(A,...C)}flush(){this.logger.flush()}};k=ge([K(0,n.ILoggerService),K(1,R.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(ne[244],re([0,1,3,2,7,25]),function(X,e,R,n,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class A{constructor(E,b){this.service=E,this.logService=b,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new R.Emitter}listen(E,b){switch(b){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${b}`)}async call(E,b,v){try{return await this._call(E,b,v)}catch(y){throw this.logService.error(y),y}}async _call(E,b,v){switch(b){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(v[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(v[0],k.URI.revive(v[1]),v[2],v[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(v[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0]);case"getAssociatedResources":return this.service.getAssociatedResources(v[0],{created:v[1].created,uri:k.URI.revive(v[1].uri)});case"getMachineId":return this.service.getMachineId(v[0],{created:v[1].created,uri:k.URI.revive(v[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(b.startsWith("manualSync/")){const y=b.substring("manualSync/".length),d=v[0],S=this.getManualSyncTask(d);switch(v=v.slice(1),y){case"preview":return S.preview();case"accept":return S.accept(k.URI.revive(v[0]),v[1]);case"merge":return S.merge(k.URI.revive(v[0]));case"discard":return S.discard(k.URI.revive(v[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(E){const b=this.manualSyncTasks.get(this.createKey(E));if(!b)throw new Error(`Manual sync taks not found: ${E}`);return b.manualSyncTask}async createManualSyncTask(){const E=new n.DisposableStore,b=E.add(await this.service.createManualSyncTask());return E.add(b.onSynchronizeResources(v=>this.onManualSynchronizeResources.fire({manualSyncTaskId:b.id,data:v}))),this.manualSyncTasks.set(this.createKey(b.id),{manualSyncTask:b,disposables:E}),{id:b.id,manifest:b.manifest,status:b.status}}disposeManualSyncTask(E){E.dispose();const b=this.createKey(E.id);this.manualSyncTasks.get(b)?.disposables.dispose(),this.manualSyncTasks.delete(b)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=A;class C extends n.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new R.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new R.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new R.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new R.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(b,v,y){return E.call(b,v,y).then(null,d=>{throw T.UserDataSyncError.toUserDataSyncError(d)})},listen(b,v){return E.listen(b,v)}},this.channel.call("_getInitialData").then(([b,v,y])=>{this.updateStatus(b),this.updateConflicts(v),y&&this.updateLastSyncTime(y),this._register(this.channel.listen("onDidChangeStatus")(d=>this.updateStatus(d))),this._register(this.channel.listen("onDidChangeLastSyncTime")(d=>this.updateLastSyncTime(d)))}),this._register(this.channel.listen("onDidChangeConflicts")(b=>this.updateConflicts(b))),this._register(this.channel.listen("onSyncErrors")(b=>this._onSyncErrors.fire(b.map(([v,y])=>[v,T.UserDataSyncError.toUserDataSyncError(y)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:b,status:v}=await this.channel.call("createManualSyncTask"),y=this,d=new P(E,b,v,{async call(S,w,p){return y.channel.call(`manualSync/${S}`,[E,...Array.isArray(w)?w:[w]],p)},listen(S,w){return R.Event.map(R.Event.filter(y.channel.listen(`manualSync/${S}`,w),p=>!d.isDiposed()&&p.manualSyncTaskId===E),p=>p.data)}});return d}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,b,v,y){return this.channel.call("accept",[E,b,v,y])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:v,uri:y})=>({created:v,uri:k.URI.revive(y)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:v,uri:y})=>({created:v,uri:k.URI.revive(y)}))}async getAssociatedResources(E,b){return(await this.channel.call("getAssociatedResources",[E,b])).map(({resource:y,comparableResource:d})=>({resource:k.URI.revive(y),comparableResource:k.URI.revive(d)}))}async getMachineId(E,b){return this.channel.call("getMachineId",[E,b])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([b,v])=>[b,v.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=C;class P extends n.Disposable{constructor(E,b,v,y){super();this.id=E,this.manifest=b,this._disposed=!1,this._status=v;const d=this;this.channel={async call(S,w,p){try{const g=await y.call(S,w,p);return d.isDiposed()||(d._status=await y.call("_getStatus")),g}catch(g){throw T.UserDataSyncError.toUserDataSyncError(g)}},listen(S,w){return y.listen(S,w)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,b){const v=await this.channel.call("accept",[E,b]);return this.deserializePreviews(v)}async merge(E){const b=await this.channel.call("merge",[E]);return this.deserializePreviews(b)}async discard(E){const b=await this.channel.call("discard",[E]);return this.deserializePreviews(b)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([b,v])=>[b,{isLastSyncFromCurrentMachine:v.isLastSyncFromCurrentMachine,resourcePreviews:v.resourcePreviews.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource),acceptedResource:k.URI.revive(y.acceptedResource)}))}])}}}),define(ne[245],re([0,1,6,3,2]),function(X,e,R,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class T extends k.Disposable{constructor({onDidOpenWindow:C,onDidFocusWindow:P,getActiveWindowId:I}){super();this.disposables=this._register(new k.DisposableStore),n.Event.latch(n.Event.any(C,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,R.createCancelablePromise)(()=>I()),(async()=>{try{const b=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:b}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(C){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=C}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=T}),define(ne[246],re([0,1,165,12,34,17,7,5,20]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,C.createDecorator)("contextService");function I(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=I;function E(t){if(t.configuration)return{id:t.id,configPath:t.configuration};if(t.folders.length===1)return{id:t.id,uri:t.folders[0].uri}}e.toWorkspaceIdentifier=E;function b(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=b;function v(t){const i=t;if(i?.uri)return{id:i.id,uri:A.URI.revive(i.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=v;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function d(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=d;function S(t){const i=t;return!!(i&&typeof i=="object"&&A.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=S;class w{constructor(i,o,c,a,l){this._id=i,this._transient=c,this._configuration=a,this._ignorePathCasing=l,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=w;class p{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,T.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function g(t){return new p({uri:t,index:0,name:(0,T.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const u=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,R.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function f(t,i){return T.extUriBiasedIgnorePathCase.isEqualOrParent(t,i.untitledWorkspacesHome)}e.isUntitledWorkspace=f;function h(t){let i;return A.URI.isUri(t)?i=t:i=t.configuration,i?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=h;function s(t,i){return!f(t,i)&&!h(t)}e.isSavedWorkspace=s;function r(t){return(typeof t=="string"?(0,n.extname)(t):(0,T.extname)(t))===u}e.hasWorkspaceFileExtension=r}),define(ne[29],re([0,1,62,3,2,17,15,7,158,14,13,5,8,246,34,33,6,31]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function g(s){const r=s;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&C.URI.isUri(r.location)&&C.URI.isUri(r.globalStorageHome)&&C.URI.isUri(r.settingsResource)&&C.URI.isUri(r.keybindingsResource)&&C.URI.isUri(r.tasksResource)&&C.URI.isUri(r.snippetsHome)&&((0,A.isUndefined)(r.extensionsResource)||C.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=g,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,b.createDecorator)("IUserDataProfilesService");function u(s,r){return{id:s.id,isDefault:s.isDefault,name:s.name,location:C.URI.revive(s.location).with({scheme:r}),globalStorageHome:C.URI.revive(s.globalStorageHome).with({scheme:r}),settingsResource:C.URI.revive(s.settingsResource).with({scheme:r}),keybindingsResource:C.URI.revive(s.keybindingsResource).with({scheme:r}),tasksResource:C.URI.revive(s.tasksResource).with({scheme:r}),snippetsHome:C.URI.revive(s.snippetsHome).with({scheme:r}),extensionsResource:C.URI.revive(s.extensionsResource)?.with({scheme:r})}}e.reviveProfile=u,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function f(s,r,t){return{id:(0,R.hash)(r.path).toString(16),name:s,location:r,isDefault:!1,globalStorageHome:(0,T.joinPath)(r,"globalStorage"),settingsResource:(0,T.joinPath)(r,"settings.json"),keybindingsResource:(0,T.joinPath)(r,"keybindings.json"),tasksResource:(0,T.joinPath)(r,"tasks.json"),snippetsHome:(0,T.joinPath)(r,"snippets"),extensionsResource:(0,T.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:t}}e.toUserDataProfile=f;let h=class extends k.Disposable{constructor(r,t,i,o){super();this.environmentService=r,this.fileService=t,this.uriIdentityService=i,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new n.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new n.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new n.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new n.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profilesHome=(0,T.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(c=>f(c.name,c.location,c.useDefaultFlags)):[];let t;const i=new d.ResourceMap,o=f((0,P.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0?o.extensionsResource:void 0}),r.length){const c=this.getStoredProfileAssociations();if(c.workspaces)for(const[a,l]of Object.entries(c.workspaces)){const m=C.URI.parse(a),D=C.URI.parse(l),U=r.find(O=>this.uriIdentityService.extUri.isEqual(O.location,D));U&&i.set(m,U)}if(c.emptyWindow){const a=C.URI.parse(c.emptyWindow);t=r.find(l=>this.uriIdentityService.extUri.isEqual(l.location,a))}}this._profilesObject={profiles:r,workspaces:i,emptyWindow:t}}return this._profilesObject}getProfile(r,t){if(!this.enabled)return this.defaultProfile;const i=this.getWorkspace(r);let o=C.URI.isUri(i)?this.profilesObject.workspaces.get(i):this.profilesObject.emptyWindow;return o||(o=t,this.profiles.length>1&&this.updateWorkspaceAssociation(r,o)),o}getWorkspace(r){return(0,y.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,y.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}async createProfile(r,t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(a=>a.name===r))throw new Error(`Profile with name ${r} already exists`);const o=f(r,(0,T.joinPath)(this.profilesHome,(0,R.hash)((0,p.generateUuid)()).toString(16)),t);await this.fileService.createFolder(o.location);const c=[];return this._onWillCreateProfile.fire({profile:o,join(a){c.push(a)}}),await w.Promises.settled(c),this.updateProfiles([o],[],[]),i&&await this.setProfileForWorkspace(o,i),o}async updateProfile(r,t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(c=>c.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);return o=f(t,o.location,i),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(r,t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const i=this.profiles.find(o=>o.id===r.id);if(!i)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,i)}async unsetWorkspace(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const t=this.profiles.find(o=>o.id===r.id);if(!t)throw new Error(`Profile '${r.name}' does not exist`);const i=[];this._onWillRemoveProfile.fire({profile:t,join(o){i.push(o)}}),await w.Promises.settled(i),t.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])t.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[t],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(t.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(r,t,i){const o=[];for(let c of[...this.profilesObject.profiles,...r])c.isDefault||t.some(a=>c.id===a.id)||(c=i.find(a=>c.id===a.id)??c,o.push({location:c.location,name:c.name,useDefaultFlags:c.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(r,t,i)}triggerProfilesChanges(r,t,i){this._onDidChangeProfiles.fire({added:r,removed:t,updated:i,all:this.profiles})}updateWorkspaceAssociation(r,t){const i=this.getWorkspace(r);C.URI.isUri(i)?(this.profilesObject.workspaces.delete(i),t&&this.profilesObject.workspaces.set(i,t)):this.profilesObject.emptyWindow=t,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[i,o]of this.profilesObject.workspaces.entries())r[i.toString()]=o.location.toString();const t=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:t}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};h.PROFILES_KEY="userDataProfiles",h.PROFILE_ASSOCIATIONS_KEY="profileAssociations",h=ge([K(0,I.IEnvironmentService),K(1,E.IFileService),K(2,S.IUriIdentityService),K(3,v.ILogService)],h),e.UserDataProfilesService=h}),define(ne[247],re([0,1,18,6,21,9,3,2,4,7,141,28,32,44,8,24,22,29]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends C.Disposable{constructor(t,i,o,c,a){super();this.galleryService=t,this.telemetryService=i,this.logService=o,this.productService=c,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,C.toDisposable)(()=>{this.installingExtensions.forEach(l=>l.cancel()),this.uninstallingExtensions.forEach(l=>l.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const i=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,b.isTargetPlatformCompatible)(o,t.allTargetPlatforms,i))}async installFromGallery(t,i={}){try{if(!this.galleryService.isEnabled())throw new b.ExtensionManagementError(E.localize(0,null),b.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,i)}catch(o){throw h(this.telemetryService,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),f(o)}}async uninstall(t,i={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,i)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const i=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:i,compatible:!0},k.CancellationToken.None);if(!o)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,i,o){const c=U=>`${v.ExtensionKey.create(U).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!I.URI.isUri(i)){const U=this.installingExtensions.get(c(i));if(U){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:O}=await U.waitUntilTaskIsFinished();return O}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],l=[],m=this.createInstallExtensionTask(t,i,o);I.URI.isUri(i)||this.installingExtensions.set(c(i),m),this._onInstallExtension.fire({identifier:m.identifier,source:i,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",m.identifier.id),a.push({task:m,manifest:t});let D=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",m.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(m.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:F,manifest:L}of O){D=D||!!L.extensionDependencies?.some(W=>(0,v.areSameExtensions)({id:W},m.identifier));const N=c(F);if(this.installingExtensions.has(N))this.logService.info("Extension is already requested to install",F.identifier.id);else{const W=this.createInstallExtensionTask(L,F,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(N,W),this._onInstallExtension.fire({identifier:W.identifier,source:F,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",W.identifier.id),a.push({task:W,manifest:L})}}}catch(O){if(I.URI.isUri(m.source))(0,R.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",m.identifier.id,O.message),(0,R.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",m.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",m.identifier.id),O}const U=a.reduce((O,{task:F,manifest:L})=>(O.set(F.identifier.id.toLowerCase(),{task:F,manifest:L}),O),new Map);for(;U.size;){let O;const F=[...U.values()].filter(({manifest:L})=>!L.extensionDependencies?.some(N=>U.has(N.toLowerCase())));F.length?O=U.size===1?F:F.filter(({task:L})=>!(L===m&&!D)):(this.logService.info("Found extensions with circular dependencies",F.map(({task:L})=>L.identifier.id)),O=[...U.values()]),await this.joinAllSettled(O.map(async({task:L})=>{const N=new Date().getTime();try{const{local:W}=await L.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall(W,L.source,o,k.CancellationToken.None))),!I.URI.isUri(L.source)){const V=L.operation===3,J=V?void 0:(new Date().getTime()-L.source.lastUpdated)/1e3;if(h(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(L.source),duration:new Date().getTime()-N,durationSinceUpdate:J}),P.isWeb&&L.operation!==3)try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}l.push({local:W,identifier:L.identifier,operation:L.operation,source:L.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw I.URI.isUri(L.source)||h(this.telemetryService,L.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(L.source),duration:new Date().getTime()-N,error:W}),this.logService.error("Error while installing the extension:",L.identifier.id),W}finally{U.delete(L.identifier.id.toLowerCase())}}))}return l.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(l),l.filter(({identifier:O})=>(0,v.areSameExtensions)(O,m.identifier))[0].local}catch(U){if(a.forEach(({task:O})=>O.cancel()),l.length)try{const O=await Promise.allSettled(l.map(({local:F})=>this.createUninstallExtensionTask(F,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let F=0;F<O.length;F++){const L=O[F],{identifier:N}=l[F];L.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,T.getErrorMessage)(L.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,T.getErrorMessage)(O),l.map(({identifier:F})=>F.id))}throw this._onDidInstallExtensions.fire(a.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source,context:o.context,profileLocation:o.profileLocation}))),U}finally{for(const{task:U}of a)if(!I.URI.isUri(U.source)){const O=c(U.source);this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(t){const i=[],o=[],c=await Promise.allSettled(t);for(const a of c)a.status==="fulfilled"?i.push(a.value):o.push(a.reason);if(o.length)throw u(o);return i}async getAllDepsAndPackExtensionsToInstall(t,i,o,c,a){if(!this.galleryService.isEnabled())return[];let l=await this.getInstalled(void 0,a);const m=[t,...l.map(O=>O.identifier)],D=[],U=async(O,F)=>{const L=F.extensionDependencies||[],N=[...L];if(F.extensionPack){const W=o?l.find(V=>(0,v.areSameExtensions)(V.identifier,O)):void 0;for(const V of F.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(J=>(0,v.areSameExtensions)({id:J},{id:V}))||N.every(J=>!(0,v.areSameExtensions)({id:J},{id:V}))&&N.push(V)}if(N.length){const W=[...m,...D.map(J=>J.gallery.identifier)],V=N.filter(J=>W.every($=>!(0,v.areSameExtensions)($,{id:J})));if(V.length){const J=await this.galleryService.getExtensions(V.map($=>({id:$,preRelease:c})),k.CancellationToken.None);for(const $ of J){if(W.find(B=>(0,v.areSameExtensions)(B,$.identifier)))continue;const Q=L.some(B=>(0,v.areSameExtensions)({id:B},$.identifier));let H;try{H=await this.checkAndGetCompatibleVersion($,!1,c)}catch(B){if(B instanceof b.ExtensionManagementError&&B.code===b.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Q){this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id);continue}else throw B}D.push({gallery:H.extension,manifest:H.manifest}),await U(H.extension.identifier,H.manifest)}}}};return await U(t,i),l=await this.getInstalled(void 0,a),D.filter(O=>!l.some(F=>(0,v.areSameExtensions)(F.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(t,i,o){if((await this.getExtensionsControlManifest()).malicious.some(m=>(0,v.areSameExtensions)(t.identifier,m)))throw new b.ExtensionManagementError(E.localize(3,null,t.identifier.id),b.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const m=await this.getTargetPlatform();throw new b.ExtensionManagementError(E.localize(4,null,t.identifier.id,this.productService.nameLong,(0,b.TargetPlatformToString)(m)),b.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,i,o);if(a){if(o&&!i&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new b.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new b.ExtensionManagementError(E.localize(6,null,t.identifier.id),b.ExtensionManagementErrorCode.ReleaseVersionNotFound):new b.ExtensionManagementError(E.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),b.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const l=await this.galleryService.getManifest(a,k.CancellationToken.None);if(l===null)throw new b.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,b.ExtensionManagementErrorCode.Invalid);if(l.version!==a.version)throw new b.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,b.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:l}}async getCompatibleVersion(t,i,o){const c=await this.getTargetPlatform();let a=null;return!i&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,o,c)&&(a=t),a||(i?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:c,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,o,c)),a}async uninstallExtension(t,i){const o=U=>`${U.id.toLowerCase()}${i.versionOnly?`-${t.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,c=this.uninstallingExtensions.get(o(t.identifier));if(c)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),c.waitUntilTaskIsFinished();const a=(U,O)=>{const F=this.createUninstallExtensionTask(U,O);return this.uninstallingExtensions.set(o(F.extension.identifier),F),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${U.identifier.id}@${U.manifest.version}`),this._onUninstallExtension.fire({identifier:U.identifier,profileLocation:i.profileLocation,applicationScoped:U.isApplicationScoped}),F},l=(U,O)=>{O?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${U.identifier.id}@${U.manifest.version}`,i.profileLocation.toString(),O.message):this.logService.error("Failed to uninstall extension:",`${U.identifier.id}@${U.manifest.version}`,O.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${U.identifier.id}@${U.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${U.identifier.id}@${U.manifest.version}`),h(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(U),error:O}),this._onDidUninstallExtension.fire({identifier:U.identifier,version:U.manifest.version,error:O?.code,profileLocation:i.profileLocation,applicationScoped:U.isApplicationScoped})},m=[],D=[];try{m.push(a(t,i));const U=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const O=this.getAllPackExtensionsToUninstall(t,U);for(const F of O)this.uninstallingExtensions.has(o(F.identifier))?this.logService.info("Extensions is already requested to uninstall",F.identifier.id):m.push(a(F,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(m.map(O=>O.extension),U,t),await this.joinAllSettled(m.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(O.extension,i,k.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}l(O.extension)}catch(F){const L=F instanceof b.ExtensionManagementError?F:new b.ExtensionManagementError((0,T.getErrorMessage)(F),b.ExtensionManagementErrorCode.Internal);throw l(O.extension,L),L}finally{D.push(O)}}))}catch(U){const O=U instanceof b.ExtensionManagementError?U:new b.ExtensionManagementError((0,T.getErrorMessage)(U),b.ExtensionManagementErrorCode.Internal);for(const F of m){try{F.cancel()}catch{}D.includes(F)||l(F.extension,O)}throw O}finally{for(const U of m)this.uninstallingExtensions.delete(o(U.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",U.extension.identifier.id)}}checkForDependents(t,i,o){for(const c of t){const a=this.getDependents(c,i);if(a.length){const l=a.filter(m=>!t.some(D=>(0,v.areSameExtensions)(D.identifier,m.identifier)));if(l.length)throw new Error(this.getDependentsErrorMessage(c,l,o))}}}getDependentsErrorMessage(t,i,o){return o===t?i.length===1?E.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(9,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(10,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(t,i,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const c=t.manifest.extensionPack?t.manifest.extensionPack:[];if(c.length){const a=i.filter(m=>!m.isBuiltin&&c.some(D=>(0,v.areSameExtensions)({id:D},m.identifier))),l=[];for(const m of a)l.push(...this.getAllPackExtensionsToUninstall(m,i,o));return[...a,...l]}return[]}getDependents(t,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,v.areSameExtensions)({id:c},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,i,o){return o.profileLocation&&(0,y.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,i,o)}createUninstallExtensionTask(t,i){return i.profileLocation&&t.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,i)}};g=ge([K(0,b.IExtensionGalleryService),K(1,w.ITelemetryService),K(2,d.ILogService),K(3,S.IProductService),K(4,p.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function u(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((i,o)=>new Error(`${i.message}${i.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=u;function f(r){if(r instanceof b.ExtensionManagementError)return r;const t=new b.ExtensionManagementError(r.message,b.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function h(r,t,{extensionData:i,duration:o,error:c,durationSinceUpdate:a}){const l=c?c instanceof b.ExtensionManagementError?c.code:b.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(t,{...i,success:!c,duration:o,errorcode:l,durationSinceUpdate:a})}e.reportTelemetry=h;class s{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>new Promise((i,o)=>{const c=t.onCancellationRequested(()=>{c.dispose(),o(new T.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(ne[71],re([0,1,18,6,30,16,9,35,122,2,20,12,4,17,55,80,15,7,143,14,32,44,65,13,5,8,24,3,63,45,29,33]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h,s,r,t,i,o,c,a,l,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var U;(function(J){function $(Q,H){if(Q===H)return!0;const B=Object.keys(Q),Y=new Set;for(const ie of Object.keys(H))Y.add(ie);if(B.length!==Y.size)return!1;for(const ie of B){if(Q[ie]!==H[ie])return!1;Y.delete(ie)}return Y.size===0}J.equals=$})(U=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let O=class extends I.Disposable{constructor($,Q,H,B,Y,ie,ae,z,x,_,M){super();this.systemExtensionsLocation=$,this.userExtensionsLocation=Q,this.extensionsControlLocation=H,this.cacheLocation=B,this.userDataProfilesService=Y,this.extensionsProfileScannerService=ie,this.fileService=ae,this.logService=z,this.environmentService=x,this.productService=_,this.instantiationService=M,this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(N,(0,y.joinPath)(this.cacheLocation,h.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(N,(0,y.joinPath)(this.cacheLocation,h.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(L,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,f.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,Q){const[H,B]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(Q)]),Y=await this.scanExtensionsUnderDevelopment($,[...H,...B]);return this.dedupExtensions(H,B,Y,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const Q=[];Q.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),Q.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[H,B]=await Promise.all(Q);return this.applyScanOptions([...H,...B],0,$,!1)}async scanUserExtensions($){this.logService.trace("Started scanning user extensions");const Q=await this.createExtensionScannerInput($.profileLocation??this.userExtensionsLocation,!!$.profileLocation,1,!$.includeUninstalled,$.language);let B=await($.useCache&&!Q.devMode&&Q.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(Q);return B=await this.applyScanOptions(B,1,$,!0),this.logService.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment($,Q){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const H=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const Y=await this.createExtensionScannerInput(B,!1,1,!0,$.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(Y)).map(ae=>(ae.type=Q.find(z=>(0,f.areSameExtensions)(z.identifier,ae.identifier))?.type??ae.type,this.extensionsScanner.validate(ae,Y)))}))).flat();return this.applyScanOptions(H,"development",$,!0)}return[]}async scanExistingExtension($,Q,H){const B=await this.createExtensionScannerInput($,!1,Q,!0,H.language),Y=await this.extensionsScanner.scanExtension(B);return!Y||!H.includeInvalid&&!Y.isValid?null:Y}async scanOneOrMultipleExtensions($,Q,H){const B=await this.createExtensionScannerInput($,!1,Q,!0,H.language),Y=await this.extensionsScanner.scanOneOrMultipleExtensions(B);return this.applyScanOptions(Y,Q,H,!0)}async scanMetadata($){const Q=(0,y.joinPath)($,"package.json"),H=(await this.fileService.readFile(Q)).value.toString();return JSON.parse(H).__metadata}async updateMetadata($,Q){const H=(0,y.joinPath)($,"package.json"),B=(await this.fileService.readFile(H)).value.toString(),Y=JSON.parse(B);Q.isMachineScoped=Q.isMachineScoped||void 0,Q.isBuiltin=Q.isBuiltin||void 0,Q.installedTimestamp=Q.installedTimestamp||void 0,Y.__metadata={...Y.__metadata,...Q},await this.fileService.writeFile((0,y.joinPath)($,"package.json"),T.VSBuffer.fromString(JSON.stringify(Y,null,"	")))}async applyScanOptions($,Q,H,B){return H.includeAllVersions||($=this.dedupExtensions(Q===0?$:void 0,Q===1?$:void 0,Q==="development"?$:void 0,await this.getTargetPlatform(),B)),H.includeInvalid||($=$.filter(Y=>Y.isValid)),$.sort((Y,ie)=>{const ae=b.basename(Y.location.fsPath),z=b.basename(ie.location.fsPath);return ae<z?-1:ae>z?1:0})}dedupExtensions($,Q,H,B,Y){const ie=(z,x,_)=>{if(z.isValid&&!x.isValid)return!1;if(z.isValid===x.isValid){if(Y&&d.gt(z.manifest.version,x.manifest.version))return this.logService.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(d.eq(z.manifest.version,x.manifest.version)){if(z.type===0)return this.logService.debug(`Skipping extension ${x.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===B)return this.logService.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return _?this.logService.warn(`Overwriting user extension ${z.location.path} with ${x.location.path}.`):this.logService.debug(`Overwriting user extension ${z.location.path} with ${x.location.path}.`),!0},ae=new Map;return $?.forEach(z=>{const x=h.ExtensionIdentifier.toKey(z.identifier.id),_=ae.get(x);(!_||ie(_,z,!1))&&ae.set(x,z)}),Q?.forEach(z=>{const x=h.ExtensionIdentifier.toKey(z.identifier.id),_=ae.get(x);if(!_&&$&&z.type===0){this.logService.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!_||ie(_,z,!1))&&ae.set(x,z)}),H?.forEach(z=>{const x=h.ExtensionIdentifier.toKey(z.identifier.id),_=ae.get(x);(!_||ie(_,z,!0))&&ae.set(x,z),ae.set(x,z)}),[...ae.values()]}async scanDefaultSystemExtensions($,Q){this.logService.trace("Started scanning system extensions");const H=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,Q),Y=await($&&!H.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(H);return this.logService.trace("Scanned system extensions:",Y.length),Y}async scanDevSystemExtensions($,Q){const H=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!H?.length)return[];this.logService.trace("Started scanning dev system extensions");const B=Q?await this.getBuiltInExtensionControl():{},Y=[],ie=p.URI.file(b.normalize(b.join(E.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions")));for(const z of H){const x=B[z.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":Y.push((0,y.joinPath)(ie,z.name));break;default:Y.push(p.URI.file(x));break}}const ae=await Promise.all(Y.map(async z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(z,!1,0,!0,$))));return this.logService.trace("Scanned dev system extensions:",ae.length),(0,R.coalesce)(ae)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,Q,H,B,Y,ie=!0){const ae=await this.getTranslations(Y??v.language),z=await this.getMtime($),x=Q?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,_=x?await this.getMtime(x):void 0;return new F($,z,x,_,Q,H,B,ie,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,Y,ae)}async getMtime($){try{const Q=await this.fileService.stat($);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};O=ge([K(4,m.IUserDataProfilesService),K(5,l.IExtensionsProfileScannerService),K(6,r.IFileService),K(7,i.ILogService),K(8,u.IEnvironmentService),K(9,o.IProductService),K(10,t.IInstantiationService)],O),e.AbstractExtensionsScannerService=O;class F{constructor($,Q,H,B,Y,ie,ae,z,x,_,M,q,j,Z){this.location=$,this.mtime=Q,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=B,this.profile=Y,this.type=ie,this.excludeObsolete=ae,this.validate=z,this.productVersion=x,this.productDate=_,this.productCommit=M,this.devMode=q,this.language=j,this.translations=Z}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,Q){return(0,y.isEqual)($.location,Q.location)&&$.mtime===Q.mtime&&(0,y.isEqual)($.applicationExtensionslocation,Q.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&$.profile===Q.profile&&$.type===Q.type&&$.excludeObsolete===Q.excludeObsolete&&$.validate===Q.validate&&$.productVersion===Q.productVersion&&$.productDate===Q.productDate&&$.productCommit===Q.productCommit&&$.devMode===Q.devMode&&$.language===Q.language&&U.equals($.translations,Q.translations)}}let L=class extends I.Disposable{constructor($,Q,H,B,Y){super();this.obsoleteFile=$,this.extensionsProfileScannerService=Q,this.uriIdentityService=H,this.fileService=B,this.logService=Y}async scanExtensions($){const Q=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let H={};if($.excludeObsolete&&$.type===1)try{const B=(await this.fileService.readFile(this.obsoleteFile)).value.toString();H=JSON.parse(B)}catch{}return(0,w.isEmptyObject)(H)?Q:Q.filter(B=>!H[f.ExtensionKey.create(B).toString()])}async scanExtensionsFromLocation($){const Q=await this.fileService.resolve($.location);if(!Q.children?.length)return[];const H=await Promise.all(Q.children.map(async B=>{if(!B.isDirectory||$.type===1&&(0,y.basename)(B.resource).indexOf(".")===0)return null;const Y=new F(B.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(Y)}));return(0,R.coalesce)(H).sort((B,Y)=>B.location.path<Y.location.path?-1:1)}async scanExtensionsFromProfile($){let Q=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){Q=Q.filter(B=>!B.metadata?.isApplicationScoped);const H=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,B=>!!B.metadata?.isApplicationScoped,$);Q.push(...H)}return Q}async scanExtensionsFromProfileResource($,Q,H){const B=await this.extensionsProfileScannerService.scanProfileExtensions($);if(!B.length)return[];const Y=await Promise.all(B.map(async ie=>{if(Q(ie)){const ae=new F(ie.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ae,ie.metadata)}return null}));return(0,R.coalesce)(Y)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,y.joinPath)($.location,"package.json"))){const Q=await this.scanExtension($);return Q?[Q]:[]}else return await this.scanExtensions($)}catch(Q){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,A.getErrorMessage)(Q)),[]}}async scanExtension($,Q){try{let H=await this.scanExtensionManifest($.location);if(H){H.publisher||(H.publisher=h.UNDEFINED_PUBLISHER),Q=Q??H.__metadata,delete H.__metadata;const B=(0,f.getGalleryExtensionId)(H.publisher,H.name),Y=Q?.id?{id:B,uuid:Q.id}:{id:B},ie=Q?.isSystem?0:$.type,ae=ie===0||!!Q?.isBuiltin;H=await this.translateManifest($.location,H,F.createNlsConfiguration($));const z={type:ie,identifier:Y,manifest:H,location:$.location,isBuiltin:ae,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return $.validate?this.validate(z,$):z}}catch(H){$.type!==0&&this.logService.error(H)}return null}validate($,Q){let H=!0;const B=(0,s.validateExtensionManifest)(Q.productVersion,Q.productDate,Q.location,$.manifest,$.isBuiltin);for(const[Y,ie]of B)Y===S.default.Error&&(H=!1,this.logService.error(this.formatMessage(Q.location,ie)));return $.isValid=H,$.validations=B,$}async scanExtensionManifest($){const Q=(0,y.joinPath)($,"package.json");let H;try{H=(await this.fileService.readFile(Q)).value.toString()}catch(Y){return(0,r.toFileOperationResult)(Y)!==1&&this.logService.error(this.formatMessage($,(0,g.localize)(0,null,Q.path,Y.message))),null}let B;try{B=JSON.parse(H)}catch{const ie=[];(0,C.parse)(H,ie);for(const ae of ie)this.logService.error(this.formatMessage($,(0,g.localize)(1,null,Q.path,ae.offset,ae.length,(0,P.getParseErrorMessage)(ae.error))));return null}return(0,C.getNodeType)(B)!=="object"?(this.logService.error(this.formatMessage($,(0,g.localize)(2,null,Q.path))),null):B}async translateManifest($,Q,H){const B=await this.getLocalizedMessages($,Q,H);if(B)try{const Y=[],ie=await this.resolveOriginalMessageBundle(B.default,Y);if(Y.length>0)return Y.forEach(z=>{this.logService.error(this.formatMessage($,(0,g.localize)(3,null,B.default?.path,(0,P.getParseErrorMessage)(z.error))))}),Q;if((0,C.getNodeType)(B)!=="object")return this.logService.error(this.formatMessage($,(0,g.localize)(4,null,B.default?.path))),Q;const ae=B.values||Object.create(null);this.replaceNLStrings(H.pseudo,Q,ae,ie,$)}catch{}return Q}async getLocalizedMessages($,Q,H){const B=(0,y.joinPath)($,"package.nls.json"),Y=(x,_)=>{_.forEach(M=>{this.logService.error(this.formatMessage($,(0,g.localize)(5,null,x?.path,(0,P.getParseErrorMessage)(M.error))))})},ie=x=>{this.logService.error(this.formatMessage($,(0,g.localize)(6,null,x?.path)))},ae=`${Q.publisher}.${Q.name}`,z=H.translations[ae];if(z)try{const x=p.URI.file(z),_=(await this.fileService.readFile(x)).value.toString(),M=[],q=(0,C.parse)(_,M);return M.length>0?(Y(x,M),{values:void 0,default:B}):(0,C.getNodeType)(q)!=="object"?(ie(x),{values:void 0,default:B}):{values:q.contents?q.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.fileService.exists(B))return;let _;try{_=await this.findMessageBundles($,H)}catch{return}if(!_.localized)return{values:void 0,default:_.original};try{const M=(await this.fileService.readFile(_.localized)).value.toString(),q=[],j=(0,C.parse)(M,q);return q.length>0?(Y(_.localized,q),{values:void 0,default:_.original}):(0,C.getNodeType)(j)!=="object"?(ie(_.localized),{values:void 0,default:_.original}):{values:j,default:_.original}}catch{return{values:void 0,default:_.original}}}}async resolveOriginalMessageBundle($,Q){if($)try{const H=(await this.fileService.readFile($)).value.toString();return(0,C.parse)(H,Q)}catch{return null}else return null}findMessageBundles($,Q){return new Promise((H,B)=>{const Y=ie=>{const ae=(0,y.joinPath)($,`package.nls.${ie}.json`);this.fileService.exists(ae).then(z=>{z&&H({localized:ae,original:(0,y.joinPath)($,"package.nls.json")});const x=ie.lastIndexOf("-");x===-1?H({localized:(0,y.joinPath)($,"package.nls.json"),original:null}):(ie=ie.substring(0,x),Y(ie))})};if(Q.devMode||Q.pseudo||!Q.language)return H({localized:(0,y.joinPath)($,"package.nls.json"),original:null});Y(Q.language)})}replaceNLStrings($,Q,H,B,Y){const ie=(ae,z,x)=>{const _=ae[z];if((0,w.isString)(_)){const M=_,q=M.length;if(q>1&&M[0]==="%"&&M[q-1]==="%"){const j=M.substr(1,q-2);let Z=H[j];Z===void 0&&B&&(Z=B[j]);let G=typeof Z=="string"?Z:Z.message;if(G!==void 0)if($&&(G="\uFF3B"+G.replace(/[aouei]/g,"$&$&")+"\uFF3D"),x&&B&&(z==="title"||z==="category")){const te=B[j],se={value:G,original:typeof te=="string"?te:te?.message};ae[z]=se}else ae[z]=G;else this.logService.warn(this.formatMessage(Y,(0,g.localize)(7,null,j)))}}else if((0,w.isObject)(_))for(const M in _)_.hasOwnProperty(M)&&(M==="commands"?ie(_,M,!0):ie(_,M,x));else if(Array.isArray(_))for(let M=0;M<_.length;M++)ie(_,M,x)};for(const ae in Q)Q.hasOwnProperty(ae)&&ie(Q,ae)}formatMessage($,Q){return`[${$.path}]: ${Q}`}};L=ge([K(1,l.IExtensionsProfileScannerService),K(2,D.IUriIdentityService),K(3,r.IFileService),K(4,i.ILogService)],L);let N=class extends L{constructor($,Q,H,B,Y,ie){super(Q,H,B,Y,ie);this.cacheFile=$,this.cacheValidatorThrottler=this._register(new n.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new c.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const Q=await this.readExtensionCache();if(this.input=$,Q&&Q.input&&F.equals(Q.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),Q.result.map(B=>(B.location=p.URI.revive(B.location),B));const H=await super.scanExtensions($);return await this.writeExtensionCache({input:$,result:H}),H}async readExtensionCache(){try{const $=await this.fileService.readFile(this.cacheFile),Q=JSON.parse($.value.toString());return{result:Q.result,input:(0,a.revive)(Q.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)($))}return null}async writeExtensionCache($){try{await this.fileService.writeFile(this.cacheFile,T.VSBuffer.fromString(JSON.stringify($)))}catch(Q){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(Q))}}async validateCache(){if(!this.input)return;const $=await this.readExtensionCache();if(!$)return;const Q=$.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(H,Q))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(B){this.logService.error(B)}}};N=ge([K(2,l.IExtensionsProfileScannerService),K(3,D.IUriIdentityService),K(4,r.IFileService),K(5,i.ILogService)],N);function W(J,$){const Q=(0,f.getExtensionId)(J.manifest.publisher,J.manifest.name);return{id:Q,identifier:new h.ExtensionIdentifier(Q),isBuiltin:J.type===0,isUserBuiltin:J.type===1&&J.isBuiltin,isUnderDevelopment:$,extensionLocation:J.location,uuid:J.identifier.uuid,targetPlatform:J.targetPlatform,...J.manifest}}e.toExtensionDescription=W;class V extends O{constructor($,Q,H,B,Y,ie,ae,z,x,_,M){super($,Q,(0,y.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(B,h.MANIFEST_CACHE_FOLDER),Y,ie,ae,z,x,_,M);this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const q=await this.fileService.readFile(p.URI.file(v.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=V}),define(ne[248],re([0,1,2,17,28,45,13,29]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitService=void 0;let P=class extends R.Disposable{constructor(E,b,v,y){super();this.userDataProfilesService=E,this.fileService=b,this.extensionManagementService=v,this.extensionsProfileScannerService=y}async initialize(){const E=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(E)}catch{}const b=await this.extensionManagementService.getInstalled(1),v=await Promise.all(b.map(async y=>[y,await this.extensionManagementService.getMetadata(y)]));await this.extensionsProfileScannerService.addExtensionsToProfile(v,E)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,n.joinPath)(this.userDataProfilesService.defaultProfile.location,C.EXTENSIONS_RESOURCE_NAME)}};P=ge([K(0,C.IUserDataProfilesService),K(1,A.IFileService),K(2,k.IExtensionManagementService),K(3,T.IExtensionsProfileScannerService)],P),e.DefaultExtensionsProfileInitService=P}),define(ne[249],re([0,1,48,6,38,3,2,20,12,27,8,29]),function(X,e,R,n,k,T,A,C,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends A.Disposable{constructor(d,S){super();this.userDataProfilesService=d,this.logService=S,this.processesLimiter=new n.Limiter(5)}async postUninstall(d){const S=this.parseScript(d,"uninstall");return S&&(this.logService.info(d.identifier.id,d.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,d).then(()=>this.logService.info(d.identifier.id,d.manifest.version,"Finished running post uninstall script"),w=>this.logService.error(d.identifier.id,d.manifest.version,`Failed to run post uninstall script: ${w}`)))),I.Promises.rm(this.getExtensionStoragePath(d)).then(void 0,w=>this.logService.error("Error while removing extension storage path",w))}parseScript(d,S){const w=`vscode:${S}`;if(d.location.scheme===C.Schemas.file&&d.manifest&&d.manifest.scripts&&typeof d.manifest.scripts[w]=="string"){const p=d.manifest.scripts[w].split(" ");return p.length<2||p[0]!=="node"||!p[1]?(this.logService.warn(d.identifier.id,d.manifest.version,`${w} should be a node script`),null):{script:(0,P.join)(d.location.fsPath,p[1]),args:p.slice(2)||[]}}return null}runLifecycleHook(d,S,w,p,g){return new Promise((u,f)=>{const h=this.start(d,S,w,g);let s;const r=t=>{s&&(clearTimeout(s),s=null),t?f(t):u(void 0)};h.on("error",t=>{r((0,k.toErrorMessage)(t)||"Unknown")}),h.on("exit",(t,i)=>{r(t?`post-${S} process exited with code ${t}`:void 0)}),p&&(s=setTimeout(()=>{s=null,h.kill(),f("timed out")},5e3))})}start(d,S,w,p){const g={silent:!0,execArgv:void 0},u=(0,R.fork)(d,[`--type=extension-post-${S}`,...w],g);u.stdout.setEncoding("utf8"),u.stderr.setEncoding("utf8");const f=T.Event.fromNodeEventEmitter(u.stdout,"data"),h=T.Event.fromNodeEventEmitter(u.stderr,"data");f(t=>this.logService.info(p.identifier.id,p.manifest.version,`post-${S}`,t)),h(t=>this.logService.error(p.identifier.id,p.manifest.version,`post-${S}`,t));const s=T.Event.any(T.Event.map(f,t=>({data:`%c${t}`,format:[""]})),T.Event.map(h,t=>({data:`%c${t}`,format:["color: red"]})));return T.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(p.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),u}getExtensionStoragePath(d){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,d.identifier.id.toLowerCase())}};v=ge([K(0,b.IUserDataProfilesService),K(1,E.ILogService)],v),e.ExtensionsLifecycle=v}),define(ne[250],re([0,1,7,14,45,71,13,5,8,24,29]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let b=class extends T.NativeExtensionsScannerService{constructor(y,d,S,w,p,g,u){super(R.URI.file(p.builtinExtensionsPath),R.URI.file(p.extensionsPath),p.userHome,R.URI.file(p.userDataPath),y,d,S,w,p,g,u)}};b=ge([K(0,E.IUserDataProfilesService),K(1,k.IExtensionsProfileScannerService),K(2,A.IFileService),K(3,P.ILogService),K(4,n.INativeEnvironmentService),K(5,I.IProductService),K(6,C.IInstantiationService)],b),e.ExtensionsScannerService=b}),define(ne[23],re([0,1,6,3,2,190,15,85,5,29]),function(X,e,R,n,k,T,A,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var b;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(b=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class d extends k.Disposable{constructor(u={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=u,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new R.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,R.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,T.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(u,f){if(f===E){switch(u){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:u})}else this._onDidChangeValue.fire({scope:u,key:f,target:this.getKeyTargets(u)[f]})}emitWillSaveState(u){this._onWillSaveState.fire({reason:u})}get(u,f,h){return this.getStorage(f)?.get(u,h)}getBoolean(u,f,h){return this.getStorage(f)?.getBoolean(u,h)}getNumber(u,f,h){return this.getStorage(f)?.getNumber(u,h)}store(u,f,h,s){if((0,A.isUndefinedOrNull)(f)){this.remove(u,h);return}this.withPausedEmitters(()=>{this.updateKeyTarget(u,h,s),this.getStorage(h)?.set(u,f)})}remove(u,f){this.withPausedEmitters(()=>{this.updateKeyTarget(u,f,void 0),this.getStorage(f)?.delete(u)})}withPausedEmitters(u){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{u()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(u,f){const h=[],s=this.getKeyTargets(u);for(const r of Object.keys(s))s[r]===f&&h.push(r);return h}updateKeyTarget(u,f,h){const s=this.getKeyTargets(f);typeof h=="number"?s[u]!==h&&(s[u]=h,this.getStorage(f)?.set(E,JSON.stringify(s))):typeof s[u]=="number"&&(delete s[u],this.getStorage(f)?.set(E,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(u){switch(u){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(u){const f=this.get(E,u);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}isNew(u){return this.getBoolean(e.IS_NEW_KEY,u)===!0}async flush(u=b.NONE){this._onWillSaveState.fire({reason:u});const f=this.getStorage(-1),h=this.getStorage(0),s=this.getStorage(1);switch(u){case b.NONE:await R.Promises.settled([f?.whenFlushed()??Promise.resolve(),h?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case b.SHUTDOWN:await R.Promises.settled([f?.flush(0)??Promise.resolve(),h?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const u=this.getStorage(-1)?.items??new Map,f=this.getStorage(0)?.items??new Map,h=this.getStorage(1)?.items??new Map;return p(u,f,h,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(u,f){return this.emitWillSaveState(b.NONE),(0,I.isUserDataProfile)(u)?this.switchToProfile(u,f):this.switchToWorkspace(u,f)}canSwitchProfile(u,f){return!(u.id===f.id||S(f)&&S(u))}switchData(u,f,h,s){this.withPausedEmitters(()=>{if(s)for(const[r,t]of u)f.set(r,t);else{const r=new Set;for(const[t,i]of u)r.add(t),f.get(t)!==i&&this.emitDidChangeValue(h,t);for(const[t]of f.items)r.has(t)||this.emitDidChangeValue(h,t)}})}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class w extends d{constructor(){super();this.applicationStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.profileStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new C.Storage(new C.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(u=>this.emitDidChangeValue(1,u))),this._register(this.profileStorage.onDidChangeStorage(u=>this.emitDidChangeValue(0,u))),this._register(this.applicationStorage.onDidChangeStorage(u=>this.emitDidChangeValue(-1,u)))}getStorage(u){switch(u){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(u){switch(u){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=w;async function p(g,u,f,h,s,r){const t=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,o=new Map;g.forEach((O,F)=>{i.set(F,O),o.set(F,t(O))});const c=new Map,a=new Map;u.forEach((O,F)=>{c.set(F,O),a.set(F,t(O))});const l=new Map,m=new Map;f.forEach((O,F)=>{l.set(F,O),m.set(F,t(O))}),console.group(h!==s?`Storage: Application (path: ${h})`:`Storage: Application & Profile (path: ${h}, default profile)`);const D=[];if(i.forEach((O,F)=>{D.push({key:F,value:O})}),console.table(D),console.groupEnd(),console.log(o),h!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const O=[];c.forEach((F,L)=>{O.push({key:L,value:F})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const U=[];l.forEach((O,F)=>{U.push({key:F,value:O})}),console.table(U),console.groupEnd(),console.log(m)}e.logStorage=p}),define(ne[251],re([0,1,3,2,15,28,32,23]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends n.Disposable{constructor(b,v){super();this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(b)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(v.onDidInstallExtensions(y=>y.forEach(({local:d,operation:S})=>{d&&S===4&&this._removeFromDisabledExtensions(d.identifier)})))}async enableExtension(b,v){return this._removeFromDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:v}),!0):!1}async disableExtension(b,v){return this._addToDisabledExtensions(b)?(this._onDidChangeEnablement.fire({extensions:[b],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(b){const v=this.getDisabledExtensions();return v.every(y=>!(0,A.areSameExtensions)(y,b))?(v.push(b),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(b){const v=this.getDisabledExtensions();for(let y=0;y<v.length;y++){const d=v[y];if((0,A.areSameExtensions)(d,b))return v.splice(y,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(b){this._setExtensions(T.DISABLED_EXTENSIONS_STORAGE_PATH,b)}_getExtensions(b){return this.storageManger.get(b,0)}_setExtensions(b,v){this.storageManger.set(b,v,0)}};P=ge([K(0,C.IStorageService),K(1,T.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class I extends n.Disposable{constructor(b){super();this.storageService=b,this.storage=Object.create(null),this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this._register(b.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(b,v){let y;return v===0?((0,k.isUndefinedOrNull)(this.storage[b])&&(this.storage[b]=this._get(b,v)),y=this.storage[b]):y=this._get(b,v),JSON.parse(y)}set(b,v,y){const d=JSON.stringify(v.map(({id:w,uuid:p})=>({id:w,uuid:p})));this._get(b,y)!==d&&(y===0&&(v.length?this.storage[b]=d:delete this.storage[b]),this._set(b,v.length?d:void 0,y))}onDidStorageChange(b){if(b.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[b.key])&&this._get(b.key,b.scope)!==this.storage[b.key]){const y=this.get(b.key,b.scope);delete this.storage[b.key];const d=this.get(b.key,b.scope),S=y.filter(p=>!d.some(g=>(0,A.areSameExtensions)(p,g))),w=d.filter(p=>!y.some(g=>(0,A.areSameExtensions)(g,p)));(S.length||w.length)&&this._onDidChange.fire([...S,...w])}}_get(b,v){return this.storageService.get(b,v,"[]")}_set(b,v,y){v?this.storageService.store(b,v,y,1):this.storageService.remove(b,y)}}e.StorageManager=I}),define(ne[252],re([0,1,18,21,9,4,36,15,7,19,14,28,32,65,13,8,24,46,219,23,22]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const h=T.isWeb?"web":(0,b.getTargetPlatform)(T.platform,A.arch);var s;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(..._){return String(_.reduce((M,q)=>M|q,0))}var t;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class l{constructor(M=a){this.state=M}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(M,q=this.state.pageSize){return new l({...this.state,pageNumber:M,pageSize:q})}withFilter(M,...q){const j=[...this.state.criteria,...q.length?q.map(Z=>({filterType:M,value:Z})):[{filterType:M}]];return new l({...this.state,criteria:j})}withSortBy(M){return new l({...this.state,sortBy:M})}withSortOrder(M){return new l({...this.state,sortOrder:M})}withFlags(...M){return new l({...this.state,flags:M.reduce((q,j)=>q|j,0)})}withAssetTypes(...M){return new l({...this.state,assetTypes:M})}withSource(M){return new l({...this.state,source:M})}get raw(){const{criteria:M,pageNumber:q,pageSize:j,sortBy:Z,sortOrder:G,flags:te,assetTypes:se}=this.state;return{filters:[{criteria:M,pageNumber:q,pageSize:j,sortBy:Z,sortOrder:G}],assetTypes:se,flags:te}}get searchText(){const M=this.state.criteria.filter(q=>q.filterType===t.SearchText)[0];return M&&M.value?M.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(M=>String(M.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function m(_,M){const q=(_||[]).filter(j=>j.statisticName===M)[0];return q?q.value:0}function D(_){const M="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(j=>j.assetType.indexOf(M)===0).reduce((j,Z)=>{const G=F(_,Z.assetType);return G&&j.push([Z.assetType.substring(M.length),G]),j},[])}function U(_){if(_.properties){const M=_.properties.filter(Z=>Z.key===i.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=M.filter(Z=>q.test(Z.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return F(_,i.Repository)}function O(_){return{uri:`${_.fallbackAssetUri}/${i.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${i.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function F(_,M){return _.files.filter(j=>j.assetType===M)[0]?{uri:`${_.assetUri}/${M}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${M}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function L(_,M){const q=_.properties?_.properties.filter(Z=>Z.key===M):[],j=q.length>0&&q[0].value;return j?j.split(",").map(Z=>(0,v.adoptToGalleryExtensionId)(Z)):[]}function N(_){const M=_.properties?_.properties.filter(q=>q.key===o.Engine):[];return M.length>0&&M[0].value||""}function W(_){const M=_.properties?_.properties.filter(q=>q.key===o.PreRelease):[];return M.length>0&&M[0].value==="true"}function V(_){const M=_.properties?_.properties.filter(j=>j.key===o.LocalizedLanguages):[],q=M.length>0&&M[0].value||"";return q?q.split(","):[]}function J(_){return _.properties?.find(M=>M.key===o.SponsorLink)?.value}function $(_){return _.indexOf("preview")!==-1}function Q(_){return _.targetPlatform?(0,b.toTargetPlatform)(_.targetPlatform):"undefined"}function H(_){const M=(0,R.distinct)(_.versions.map(Q)),q=!!_.tags?.includes(b.WEB_EXTENSION_TAG),j=M.indexOf("web");return q?j===-1&&M.push("web"):j!==-1&&M.splice(j,1),M}function B(_,M){const q=(0,b.getFallbackTargetPlarforms)(M);for(let j=0;j<_.length;j++){const Z=_[j];if(Z.version===_[j-1]?.version){let G=j;const te=Q(Z);if(te===M)for(;G>0&&_[G-1].version===Z.version;)G--;else if(q.includes(te))for(;G>0&&_[G-1].version===Z.version&&Q(_[G-1])!==M;)G--;G!==j&&(_.splice(j,1),_.splice(G,0,Z))}}return _}e.sortExtensionVersions=B;function Y(_,M,q){_.telemetryData={index:M,querySource:q}}function ie(_,M,q){const j=_.versions[0],Z={manifest:F(M,i.Manifest),readme:F(M,i.Details),changelog:F(M,i.Changelog),license:F(M,i.License),repository:U(M),download:O(M),icon:F(M,i.Icon),coreTranslations:D(M)};return{identifier:{id:(0,v.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:M.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:J(j),description:_.shortDescription||"",installCount:m(_.statistics,"install"),rating:m(_.statistics,"averagerating"),ratingCount:m(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:q,assets:Z,properties:{dependencies:L(M,o.Dependency),extensionPack:L(M,o.ExtensionPack),engine:N(M),localizedLanguages:V(M),targetPlatform:Q(M),isPreReleaseVersion:W(M)},hasPreReleaseVersion:W(j),hasReleaseVersion:!0,preview:$(_.flags)}}let ae=class{constructor(M,q,j,Z,G,te,se,ce){this.requestService=q,this.logService=j,this.environmentService=Z,this.telemetryService=G,this.fileService=te,this.productService=se,this.configurationService=ce;const he=se.extensionsGallery;this.extensionsGalleryUrl=he&&he.serviceUrl,this.extensionsControlUrl=he&&he.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(se.version,se,this.environmentService,this.configurationService,this.fileService,M,this.telemetryService)}api(M=""){return`${this.extensionsGalleryUrl}${M}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(M,q,j){const Z=n.CancellationToken.isCancellationToken(q)?{}:q,G=n.CancellationToken.isCancellationToken(q)?q:j,te=[],se=[],ce=[],he=[];let ve=!0;for(const be of M){be.uuid?se.push(be.uuid):te.push(be.id);const Pe=!!(be.version||be.preRelease);ce.push({id:be.id,uuid:be.uuid,includePreRelease:Pe}),be.version&&he.push({id:be.id,uuid:be.uuid,version:be.version}),ve=ve&&!!be.hasPreRelease&&!Pe}if(!se.length&&!te.length)return[];let pe=new l().withPage(1,M.length);se.length&&(pe=pe.withFilter(t.ExtensionId,...se)),te.length&&(pe=pe.withFilter(t.ExtensionName,...te)),(Z.queryAllVersions||ve)&&(pe=pe.withFlags(pe.flags,s.IncludeVersions)),Z.source&&(pe=pe.withSource(Z.source));const{extensions:Ce}=await this.queryGalleryExtensions(pe,{targetPlatform:Z.targetPlatform??h,includePreRelease:ce,versions:he,compatible:!!Z.compatible},G);return Z.source&&Ce.forEach((be,Pe)=>Y(be,Pe,Z.source)),Ce}async getCompatibleExtension(M,q,j){if((0,b.isNotWebExtensionInWebTargetPlatform)(M.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(M,q,j))return M;const Z=new l().withFlags(s.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,M.identifier.uuid),{extensions:G}=await this.queryGalleryExtensions(Z,{targetPlatform:j,compatible:!0,includePreRelease:q},n.CancellationToken.None);return G[0]||null}async isExtensionCompatible(M,q,j){if(!(0,b.isTargetPlatformCompatible)(M.properties.targetPlatform,M.allTargetPlatforms,j)||!q&&M.properties.isPreReleaseVersion)return!1;let Z=M.properties.engine;if(!Z){const G=await this.getManifest(M,n.CancellationToken.None);if(!G)throw new Error("Manifest was not found");Z=G.engines.vscode}return(0,y.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(M,q,j,Z,G){if(!(0,b.isTargetPlatformCompatible)(Q(M),Z,G)||q!=="any"&&W(M)!==(q==="prerelease"))return!1;if(j)try{const te=await this.getEngine(M);if(!(0,y.isEngineValid)(te,this.productService.version,this.productService.date))return!1}catch(te){return this.logService.error(`Error while getting the engine for the version ${M.version}.`,(0,k.getErrorMessage)(te)),!1}return!0}async query(M,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=M.text||"";const Z=M.pageSize??50;let G=new l().withPage(1,Z);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(G=G.withFilter(t.Category,Ce||pe),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ve,pe,Ce)=>(G=G.withFilter(t.Tag,Ce||pe),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(G=G.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),G=G.withFilter(t.SearchText,j)),G=G.withSortBy(0)):M.ids?G=G.withFilter(t.ExtensionId,...M.ids):M.names?G=G.withFilter(t.ExtensionName,...M.names):G=G.withSortBy(4),typeof M.sortBy=="number"&&(G=G.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(G=G.withSortOrder(M.sortOrder)),M.source&&(G=G.withSource(M.source));const te=async(ve,pe)=>{const{extensions:Ce,total:be}=await this.queryGalleryExtensions(ve,{targetPlatform:h,compatible:!1,includePreRelease:!!M.includePreRelease},pe);return Ce.forEach((Pe,Me)=>Y(Pe,(ve.pageNumber-1)*ve.pageSize+Me,M.source)),{extensions:Ce,total:be}},{extensions:se,total:ce}=await te(G,q),he=async(ve,pe)=>{if(pe.isCancellationRequested)throw new k.CancellationError;const{extensions:Ce}=await te(G.withPage(ve+1),pe);return Ce};return{firstPage:se,total:ce,pageSize:G.pageSize,getPage:he}}async queryGalleryExtensions(M,q,j){const Z=M.flags;!!(M.flags&s.IncludeLatestVersionOnly)&&!!(M.flags&s.IncludeVersions)&&(M=M.withFlags(M.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(M.flags&s.IncludeLatestVersionOnly)&&!(M.flags&s.IncludeVersions)&&(M=M.withFlags(M.flags,s.IncludeLatestVersionOnly)),q.versions?.length&&(M=M.withFlags(M.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),M=M.withFlags(M.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:G,total:te}=await this.queryRawGalleryExtensions(M,j);if(!(M.flags&s.IncludeLatestVersionOnly)){const ve=[];for(const pe of G){const Ce=await this.toGalleryExtensionWithCriteria(pe,q);Ce&&ve.push(Ce)}return{extensions:ve,total:te}}const ce=[],he=new Map;for(let ve=0;ve<G.length;ve++){const pe=G[ve],Ce={id:(0,v.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},be=(0,C.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Me=>(0,v.areSameExtensions)(Me,Ce))?.includePreRelease;if(q.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(H(pe),q.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(pe,q);!Pe||Pe.properties.isPreReleaseVersion&&(!be||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==q.targetPlatform&&Pe.hasPreReleaseVersion?he.set(pe.extensionId,ve):ce.push([ve,Pe])}if(he.size){const ve=new Date().getTime(),pe=new l().withFlags(Z&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,he.size).withFilter(t.ExtensionId,...he.keys()),{extensions:Ce}=await this.queryGalleryExtensions(pe,q,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ve,count:he.size});for(const be of Ce){const Pe=he.get(be.identifier.uuid);ce.push([Pe,be])}}return{extensions:ce.sort((ve,pe)=>ve[0]-pe[0]).map(([,ve])=>ve),total:te}}async toGalleryExtensionWithCriteria(M,q){const j={id:(0,v.getGalleryExtensionId)(M.publisher.publisherName,M.extensionName),uuid:M.extensionId},Z=q.versions?.find(ce=>(0,v.areSameExtensions)(ce,j))?.version,G=(0,C.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ce=>(0,v.areSameExtensions)(ce,j))?.includePreRelease,te=H(M),se=B(M.versions,q.targetPlatform);if(q.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(te,q.targetPlatform))return null;for(let ce=0;ce<se.length;ce++){const he=se[ce];if(!(Z&&he.version!==Z)){if(await this.isValidVersion(he,G?"any":"release",q.compatible,te,q.targetPlatform))return ie(M,he,te);if(Z&&he.version===Z)return null}}return Z||q.compatible?null:ie(M,M.versions[0],te)}async queryRawGalleryExtensions(M,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");M=M.withFlags(M.flags,s.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(s.Unpublished));const j=await this.commonHeadersPromise,Z=JSON.stringify(M.raw),G={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},te=new Date().getTime();let se,ce,he=0;try{if(se=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:G},q),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:he};const ve=await(0,p.asJson)(se);if(ve){const pe=ve.results[0],Ce=pe.extensions,be=pe.resultMetadata&&pe.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return he=be&&be.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:he}}return{galleryExtensions:[],total:he}}catch(ve){throw ce=ve,ve}finally{this.telemetryService.publicLog2("galleryService:query",{...M.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-te,success:!!se&&(0,p.isSuccess)(se),responseBodySize:se?.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:ce?(0,k.isCancellationError)(ce)?"canceled":(0,k.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(he)})}}async reportStatistic(M,q,j,Z){if(!this.isEnabled())return;const G=T.isWeb?this.api(`/itemName/${M}.${q}/version/${j}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${M}/extensions/${q}/${j}/stats?statType=${Z}`),te=T.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.commonHeadersPromise,Accept:te};try{await this.requestService.request({type:"POST",url:G,headers:ce},n.CancellationToken.None)}catch{}}async download(M,q,j){this.logService.trace("ExtensionGalleryService#download",M.identifier.id);const Z=(0,v.getGalleryExtensionTelemetryData)(M),G=new Date().getTime(),te=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:ve}),se=j===2?"install":j===3?"update":"",ce=se?{uri:`${M.assets.download.uri}${P.URI.parse(M.assets.download.uri).query?"&":"?"}${se}=true`,fallbackUri:`${M.assets.download.fallbackUri}${P.URI.parse(M.assets.download.fallbackUri).query?"&":"?"}${se}=true`}:M.assets.download,he=await this.getAsset(ce);await this.fileService.writeFile(q,he.stream),te(new Date().getTime()-G)}async getReadme(M,q){if(M.assets.readme){const j=await this.getAsset(M.assets.readme,{},q);return await(0,p.asTextOrError)(j)||""}return""}async getManifest(M,q){if(M.assets.manifest){const j=await this.getAsset(M.assets.manifest,{},q),Z=await(0,p.asTextOrError)(j);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(M,q){const j=F(M,i.Manifest);if(!j)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},G=await this.getAsset(j,{headers:Z});return await(0,p.asJson)(G)}async getCoreTranslation(M,q){const j=M.assets.coreTranslations.filter(Z=>Z[0]===q.toUpperCase())[0];if(j){const Z=await this.getAsset(j[1]),G=await(0,p.asTextOrError)(Z);return G?JSON.parse(G):null}return null}async getChangelog(M,q){if(M.assets.changelog){const j=await this.getAsset(M.assets.changelog,{},q);return await(0,p.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(M,q,j){let Z=new l().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);M.identifier.uuid?Z=Z.withFilter(t.ExtensionId,M.identifier.uuid):Z=Z.withFilter(t.ExtensionName,M.identifier.id);const{galleryExtensions:G}=await this.queryRawGalleryExtensions(Z,n.CancellationToken.None);if(!G.length)return[];const te=H(G[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(te,j))return[];const se=[];await Promise.all(G[0].versions.map(async ve=>{try{await this.isValidVersion(ve,q?"any":"release",!0,te,j)&&se.push(ve)}catch{}}));const ce=[],he=new Set;for(const ve of B(se,j))he.has(ve.version)||(he.add(ve.version),ce.push({version:ve.version,date:ve.lastUpdated,isPreReleaseVersion:W(ve)}));return ce}async getAsset(M,q={},j=n.CancellationToken.None){const Z=await this.commonHeadersPromise,G={type:"GET"},te={...Z,...q.headers||{}};q={...q,...G,headers:te};const se=M.uri,ce=M.fallbackUri,he={...q,url:se};try{const ve=await this.requestService.request(he,j);if(ve.res.statusCode===200)return ve;const pe=await(0,p.asTextOrError)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${pe}`)}catch(ve){if((0,k.isCancellationError)(ve))throw ve;const pe=(0,k.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:se,message:pe});const Ce={...q,url:ce};return this.requestService.request(Ce,j)}}async getEngine(M){let q=N(M);if(!q){const j=await this.getManifestFromRawExtensionVersion(M,n.CancellationToken.None);if(!j)throw new Error("Manifest was not found");q=j.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const M=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(M.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,p.asJson)(M),j=[],Z={};if(q){for(const G of q.malicious)j.push({id:G});if(q.migrateToPreRelease)for(const[G,te]of Object.entries(q.migrateToPreRelease))(!te.engine||(0,y.isEngineValid)(te.engine,this.productService.version,this.productService.date))&&(Z[G.toLowerCase()]={disallowInstall:!0,extension:{id:te.id,displayName:te.displayName,autoMigrate:{storage:!!te.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[G,te]of Object.entries(q.deprecated))te&&(Z[G.toLowerCase()]=(0,C.isBoolean)(te)?{}:te)}return{malicious:j,deprecated:Z}}};ae=ge([K(1,p.IRequestService),K(2,S.ILogService),K(3,E.IEnvironmentService),K(4,f.ITelemetryService),K(5,d.IFileService),K(6,w.IProductService),K(7,I.IConfigurationService)],ae);let z=class extends ae{constructor(M,q,j,Z,G,te,se,ce){super(M,q,j,Z,G,te,se,ce)}};z=ge([K(0,u.IStorageService),K(1,p.IRequestService),K(2,S.ILogService),K(3,E.IEnvironmentService),K(4,f.ITelemetryService),K(5,d.IFileService),K(6,w.IProductService),K(7,I.IConfigurationService)],z),e.ExtensionGalleryService=z;let x=class extends ae{constructor(M,q,j,Z,G,te,se){super(void 0,M,q,j,Z,G,te,se)}};x=ge([K(0,p.IRequestService),K(1,S.ILogService),K(2,E.IEnvironmentService),K(3,f.ITelemetryService),K(4,d.IFileService),K(5,w.IProductService),K(6,I.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(ne[72],re([0,1,5,3,2,23,32,24,18,8,15]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,R.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=class Je extends k.Disposable{constructor(d,S,w){super();this.storageService=d,this.productService=S,this.logService=w,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(d),this._register(this.storageService.onDidChangeValue(p=>this.onDidChangeStorageValue(p)))}static toKey(d){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(d.id)}@${d.version}`}static fromKey(d){const S=b.exec(d);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(d,S){const w=await d.getInstalled(),p=[];for(const[g,u]of Je.readAllExtensionsWithKeysForSync(S)){const f=w.find(h=>(0,A.areSameExtensions)(h.identifier,{id:g}))?.manifest.version;for(const h of u)f!==h&&p.push(Je.toKey({id:g,version:h}))}for(const g of p)S.remove(g,0)}static readAllExtensionsWithKeysForSync(d){const S=new Map,w=d.keys(0,1);for(const p of w){const g=Je.fromKey(p);if(g){let u=S.get(g.id.toLowerCase());u||S.set(g.id.toLowerCase(),u=[]),u.push(g.version)}}return S}onDidChangeStorageValue(d){if(d.scope!==0)return;if(this.extensionsWithKeysForSync.has(d.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Je.fromKey(d.key);if(S){if(this.storageService.get(d.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let w=this.extensionsWithKeysForSync.get(S.id.toLowerCase());w||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),w=[]),w.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(d){if((0,E.isString)(d))return d;const S=d.manifest?d.manifest.publisher:d.publisher,w=d.manifest?d.manifest.name:d.name;return(0,A.getExtensionId)(S,w)}getExtensionState(d,S){const w=this.getExtensionId(d),p=this.storageService.get(w,S?0:1);if(p)try{return JSON.parse(p)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${w}, global: ${S}): ${g}`)}}setExtensionState(d,S,w){const p=this.getExtensionId(d);S===void 0?this.storageService.remove(p,w?0:1):this.storageService.store(p,JSON.stringify(S),w?0:1,1)}setKeysForSync(d,S){this.storageService.store(Je.toKey(d),JSON.stringify(S),0,1)}getKeysForSync(d){const S=this.productService.extensionSyncedKeys?.[d.id.toLowerCase()],w=this.storageService.get(Je.toKey(d),0),p=w?JSON.parse(w):void 0;return p&&S?(0,P.distinct)([...p,...S]):p||S}addToMigrationList(d,S){if(d!==S){const w=this.migrationList.filter(p=>!p.includes(d)&&!p.includes(S));w.push([d,S]),this.migrationList=w}}getSourceExtensionToMigrate(d){const S=this.migrationList.find(([,w])=>d===w);return S?S[0]:void 0}get migrationList(){const d=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(d);if(Array.isArray(S))return S}catch{}return[]}set migrationList(d){d.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(d),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};v=ge([K(0,T.IStorageService),K(1,C.IProductService),K(2,I.ILogService)],v),e.ExtensionStorageService=v}),define(ne[253],re([0,1,18,6,3,12,4,36,7,144,14,28,32,209,91,13,8,67,24,46,23,22]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const s="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let t=class extends y.ExtensionTipsService{constructor(o,c,a,l,m,D,U,O,F,L){super(U,O,F,L);this.environmentService=o,this.telemetryService=c,this.extensionManagementService=a,this.storageService=l,this.nativeHostService=m,this.extensionRecommendationNotificationService=D,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&Object.entries(O.exeBasedExtensionTips).forEach(([N,W])=>{const V=[],J=[],$=[];Object.entries(W.recommendations).forEach(([Q,H])=>{H.important?W.important?V.push({extensionId:Q,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):J.push({extensionId:Q,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):$.push({extensionId:Q,extensionName:H.name,isExtensionPack:!!H.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:V}),J.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:J}),$.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:$})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...c]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),c=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(c,a)}groupImportantTipsByExe(o,c){const a=new Map;o.forEach(O=>a.set(O.extensionId.toLowerCase(),O));const{installed:l,uninstalled:m}=this.groupByInstalled([...a.keys()],c);for(const O of l){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:F.exeName})}for(const O of m){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:F.exeName})}const D=this.getPromptedExecutableTips(),U=new Map;for(const O of m){const F=a.get(O);if(F&&(!D[F.exeName]||!D[F.exeName].includes(F.extensionId))){let L=U.get(F.exeName);L||(L=[],U.set(F.exeName,L)),L.push(F)}}return U}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,c]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(c).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(c[0].exeName,c);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const l=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(l(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const l=this._register((0,n.disposableTimeout)(()=>{l.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),c=Date.now()-o,a=7*24*60*60*1e3;if(c<a){const D=this._register((0,n.disposableTimeout)(()=>{D.dispose(),this.promptMediumImportanceExeBasedTip()},a-c));return}const[l,m]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(m).then(D=>{switch(D){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(l),this.addToRecommendedExecutables(m[0].exeName,m);const U=this._register((0,n.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(l),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const U=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(U(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const U=this._register((0,n.disposableTimeout)(()=>{U.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(o){const c=await this.extensionManagementService.getInstalled(1),a=o.filter(m=>!m.whenNotInstalled||m.whenNotInstalled.every(D=>c.every(U=>!(0,v.areSameExtensions)(U.identifier,{id:D})))).map(({extensionId:m})=>m.toLowerCase()),l=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,l,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(r,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(r,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(s,-1,"{}"))}addToRecommendedExecutables(o,c){const a=this.getPromptedExecutableTips();a[o]=c.map(({extensionId:l})=>l.toLowerCase()),this.storageService.store(s,JSON.stringify(a),-1,0)}groupByInstalled(o,c){const a=[],l=[],m=c.reduce((D,U)=>(D.add(U.identifier.id.toLowerCase()),D),new Set);return o.forEach(D=>{m.has(D.toLowerCase())?a.push(D):l.push(D)}),{installed:a,uninstalled:l}}async getValidExecutableBasedExtensionTips(o){const c=[],a=new Map;for(const l of o.keys()){const m=o.get(l);if(!m||!(0,R.isNonEmptyArray)(m.recommendations))continue;const D=[];A.isWindows?m.windowsPath&&D.push(m.windowsPath.replace("%USERPROFILE%",C.env.USERPROFILE).replace("%ProgramFiles(x86)%",C.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",C.env.ProgramFiles).replace("%APPDATA%",C.env.APPDATA).replace("%WINDIR%",C.env.WINDIR)):(D.push((0,T.join)("/usr/local/bin",l)),D.push((0,T.join)("/usr/bin",l)),D.push((0,T.join)(this.environmentService.userHome.fsPath,l)));for(const U of D){let O=a.get(U);if(O===void 0&&(O=await this.fileService.exists(P.URI.file(U)),a.set(U,O)),O)for(const{extensionId:F,extensionName:L,isExtensionPack:N,whenNotInstalled:W}of m.recommendations)c.push({extensionId:F,extensionName:L,isExtensionPack:N,exeName:l,exeFriendlyName:m.exeFriendlyName,windowsPath:m.windowsPath,whenNotInstalled:W})}}return c}};t=ge([K(0,E.INativeEnvironmentService),K(1,h.ITelemetryService),K(2,b.IExtensionManagementService),K(3,f.IStorageService),K(4,p.INativeHostService),K(5,d.IExtensionRecommendationNotificationService),K(6,S.IFileService),K(7,g.IProductService),K(8,u.IRequestService),K(9,w.ILogService)],t),e.ExtensionTipsService=t}),define(ne[254],re([0,1,6,2,17,85,23,217]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class P extends A.AbstractStorageService{constructor(E,b,v,y){super();this.initialWorkspace=E,this.initialProfiles=b,this.mainProcessService=v,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new n.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new n.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const E=this._register(new C.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),b=this._register(new T.Storage(E));return this._register(b.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),b}createProfileStorage(E){this.profileStorageDisposables.clear(),this.profileStorageProfile=E;let b;if((0,A.isProfileUsingDefaultStorage)(E))b=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new C.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));b=this.profileStorageDisposables.add(new T.Storage(v))}return this.profileStorageDisposables.add(b.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),b}createWorkspaceStorage(E){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=E?.id;let b;if(E){const v=this.workspaceStorageDisposables.add(new C.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));b=this.workspaceStorageDisposables.add(new T.Storage(v)),this.workspaceStorageDisposables.add(b.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return b}async doInitialize(){await R.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await R.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(E,b){if(!this.canSwitchProfile(this.profileStorageProfile,E))return;const v=this.profileStorage,y=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(E),await this.profileStorage.init(),this.switchData(y,this.profileStorage,0,b)}async switchToWorkspace(E,b){const v=this.workspaceStorage,y=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(E),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1,b)}}e.NativeStorageService=P}),define(ne[255],re([0,1,3,2,17,14,94,29]),function(X,e,R,n,k,T,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends n.Disposable{constructor(E,b,v){super();this._profiles=[],this._onDidChangeProfiles=this._register(new R.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=b.getChannel("userDataProfiles"),this.profilesHome=(0,k.joinPath)(v.userRoamingDataHome,"profiles"),this._profiles=E.map(y=>(0,C.reviveProfile)(y,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(y=>{const d=y.added.map(p=>(0,C.reviveProfile)(p,this.profilesHome.scheme)),S=y.removed.map(p=>(0,C.reviveProfile)(p,this.profilesHome.scheme)),w=y.updated.map(p=>(0,C.reviveProfile)(p,this.profilesHome.scheme));this._profiles=y.all.map(p=>(0,C.reviveProfile)(p,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:d,removed:S,updated:w,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createProfile(E,b,v){const y=await this.channel.call("createProfile",[E,b,v]);return(0,C.reviveProfile)(y,this.profilesHome.scheme)}async setProfileForWorkspace(E,b){await this.channel.call("setProfileForWorkspace",[E,b])}removeProfile(E){return this.channel.call("removeProfile",[E])}async updateProfile(E,b,v){const y=await this.channel.call("updateProfile",[E,b,v]);return(0,C.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}getProfile(E,b){throw new Error("Not implemented")}};P=ge([K(1,A.IMainProcessService),K(2,T.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(ne[47],re([0,1,18,6,16,21,3,35,2,26,15,7,159,19,14,13,8,49,23,22,33,25,29]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=r;let t=class extends P.Disposable{constructor(l,m,D,U,O,F,L,N,W,V,J){super();this.resource=l,this.fileService=m,this.environmentService=D,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=F,this.userDataSyncEnablementService=L,this.telemetryService=N,this.logService=W,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=J.extUri,this.syncFolder=this.extUri.joinPath(D.userDataSyncHome,l),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,h.PREVIEW_DIR_NAME),this.lastSyncResource=(0,h.getLastSyncResourceUri)(l,D,this.extUri),this.currentMachineIdPromise=(0,p.getServiceMachineId)(D,m,U)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const l=await this.syncPreviewPromise;this.syncPreviewPromise=null;const m=await this.performSync(l.remoteUserData,l.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(m)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const l=await this.getLastSyncUserData();(l?await this.hasRemoteChanged(l):!0)&&this._onDidChangeLocal.fire()}}setStatus(l){this._status!==l&&(this._status=l,this._onDidChangStatus.fire(l))}async sync(l,m={}){await this._sync(l,!0,this.getUserDataSyncConfiguration(),m)}async preview(l,m,D={}){return this._sync(l,!1,m,D)}async apply(l,m={}){try{this.syncHeaders={...m};const D=await this.doApply(l);return this.setStatus(D),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(l,m,D,U){try{if(this.syncHeaders={...U},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const F=await this.getLastSyncUserData(),L=await this.getLatestRemoteUserData(l,F);return O=await this.performSync(L,F,m,D),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(l){const m=await this.resolveContent(l);if(!m)return!1;const D=this.parseSyncData(m);if(!D)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const U=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,U),F=await this.isRemoteDataFromCurrentMachine(O),L=await this.generateSyncPreview({ref:O.ref,syncData:D},U,F,this.getUserDataSyncConfiguration(),T.CancellationToken.None),N=[];for(const W of L){const V=await this.getAcceptResult(W,W.remoteResource,void 0,T.CancellationToken.None),{remoteChange:J}=await this.getAcceptResult(W,W.previewResource,W.remoteContent,T.CancellationToken.None);N.push([W,{...V,remoteChange:J!==0?J:2}])}await this.applyResult(O,U,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(l){const m=await this.currentMachineIdPromise;return!!l.syncData?.machineId&&l.syncData.machineId===m}async getLatestRemoteUserData(l,m){if(m){const D=l&&l.latest?l.latest[this.resource]:void 0;if(m.ref===D||D===void 0&&m.syncData===null)return m}return this.getRemoteUserData(m)}async performSync(l,m,D,U){if(l.syncData&&l.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new h.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,l.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(l,m,D,U)}catch(O){if(O instanceof h.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(l,m,D,U);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),l=await this.getRemoteUserData(null),m=await this.getLastSyncUserData(),this.performSync(l,m,D,U)}throw O}}async doSync(l,m,D,U){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(F=>this.doGenerateSyncResourcePreview(l,m,D,U,F)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":D?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(l){return await this.updateSyncResourcePreview(l,async m=>{const D=await this.getMergeResult(m,T.CancellationToken.None);await this.fileService.writeFile(m.previewResource,k.VSBuffer.fromString(D?.content||""));const U=D&&!D.hasConflicts?await this.getAcceptResult(m,m.previewResource,void 0,T.CancellationToken.None):void 0;return m.acceptResult=U,m.mergeState=D.hasConflicts?"conflict":U?"accepted":"preview",m.localChange=U?U.localChange:D.localChange,m.remoteChange=U?U.remoteChange:D.remoteChange,m}),this.syncPreviewPromise}async accept(l,m){return await this.updateSyncResourcePreview(l,async D=>{const U=await this.getAcceptResult(D,l,m,T.CancellationToken.None);return D.acceptResult=U,D.mergeState="accepted",D.localChange=U.localChange,D.remoteChange=U.remoteChange,D}),this.syncPreviewPromise}async discard(l){return await this.updateSyncResourcePreview(l,async m=>{const D=await this.getMergeResult(m,T.CancellationToken.None);return await this.fileService.writeFile(m.previewResource,k.VSBuffer.fromString(D.content||"")),m.acceptResult=void 0,m.mergeState="preview",m.localChange=D.localChange,m.remoteChange=D.remoteChange,m}),this.syncPreviewPromise}async updateSyncResourcePreview(l,m){if(!this.syncPreviewPromise)return;let D=await this.syncPreviewPromise;const U=D.resourcePreviews.findIndex(({localResource:O,remoteResource:F,previewResource:L})=>this.extUri.isEqual(O,l)||this.extUri.isEqual(F,l)||this.extUri.isEqual(L,l));U!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async O=>{const F=[...D.resourcePreviews];return F[U]=await m(F[U]),{...D,resourcePreviews:F}}),D=await this.syncPreviewPromise,this.updateConflicts(D.resourcePreviews),D.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(l){if(!this.syncPreviewPromise)return"idle";const m=await this.syncPreviewPromise;return m.resourcePreviews.some(({mergeState:D})=>D==="conflict")?"hasConflicts":m.resourcePreviews.some(({mergeState:D})=>D!=="accepted")?"syncing":(await this.applyResult(m.remoteUserData,m.lastSyncUserData,m.resourcePreviews.map(D=>[D,D.acceptResult]),l),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(l){const m=l.filter(({mergeState:D})=>D==="conflict");(0,R.equals)(this._conflicts,m,(D,U)=>this.extUri.isEqual(D.previewResource,U.previewResource))||(this._conflicts=m,this._onDidChangeConflicts.fire(m))}async hasPreviouslySynced(){const l=await this.getLastSyncUserData();return!!l&&l.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:m,ref:D})=>({created:m,uri:this.toRemoteBackupResource(D)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:m,ref:D})=>({created:m,uri:this.toLocalBackupResource(D)}))}toRemoteBackupResource(l){return b.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${l}`})}toLocalBackupResource(l){return b.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${l}`})}async getMachineId({uri:l}){const m=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(m))){const{content:D}=await this.getUserData(m);if(D)return this.parseSyncData(D)?.machineId}}async resolveContent(l){const m=this.extUri.basename(l);if(this.extUri.isEqual(l,this.toRemoteBackupResource(m))){const{content:D}=await this.getUserData(m);return D}return this.extUri.isEqual(l,this.toLocalBackupResource(m))?this.userDataSyncBackupStoreService.resolveContent(this.resource,m):null}async resolvePreviewContent(l){const m=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(m)for(const D of m.resourcePreviews){if(this.extUri.isEqual(D.acceptedResource,l))return D.acceptResult?D.acceptResult.content:null;if(this.extUri.isEqual(D.remoteResource,l))return D.remoteContent;if(this.extUri.isEqual(D.localResource,l))return D.localContent;if(this.extUri.isEqual(D.baseResource,l))return D.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(l,m,D,U,O){const F=await this.isRemoteDataFromCurrentMachine(l),L=await this.generateSyncPreview(l,m,F,U,O),N=[];for(const W of L){const V=W.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)N.push({...W,acceptedResource:V,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const J=D?await this.getMergeResult(W,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(W.previewResource,k.VSBuffer.fromString(J?.content||""));const $=J&&!J.hasConflicts?await this.getAcceptResult(W,W.previewResource,void 0,O):void 0;N.push({...W,acceptResult:$,mergeState:J?.hasConflicts?"conflict":$?"accepted":"preview",localChange:$?$.localChange:J?J.localChange:W.localChange,remoteChange:$?$.remoteChange:J?J.remoteChange:W.remoteChange})}}return{remoteUserData:l,lastSyncUserData:m,resourcePreviews:N,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){try{const l=await this.fileService.readFile(this.lastSyncResource),m=JSON.parse(l.value.toString()),D=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=m.version&&D&&m.version!==D,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${m.version} is not compatible with current sync state version ${D}.`),await this.resetLocal(),null;const U=m;if(U.content===null)return{ref:m.ref,syncData:null};const O=JSON.parse(U.content);if(r(O))return{...m,syncData:O,content:void 0}}catch(l){l instanceof S.FileOperationError&&l.fileOperationResult===1||this.logService.error(l)}return null}async updateLastSyncUserData(l,m={}){if(m.ref||m.content||m.version)throw new Error("Cannot have core properties as additional");const D=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),U={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,version:D,...m};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(U)))}async getRemoteUserData(l){const{ref:m,content:D}=await this.getUserData(l);let U=null;return D!==null&&(U=this.parseSyncData(D)),{ref:m,syncData:U}}parseSyncData(l){try{const m=JSON.parse(l);if(r(m))return m}catch(m){this.logService.error(m)}throw new h.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(l){if((0,E.isString)(l)){const m=await this.userDataSyncStoreService.resolveContent(this.resource,l);return{ref:l,content:m}}else{const m=l?{ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,m,this.syncHeaders)}}async updateRemoteUserData(l,m){const D=await this.currentMachineIdPromise,U={version:this.version,machineId:D,content:l};return m=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(U),m,this.syncHeaders),{ref:m,syncData:U}}async backupLocal(l){const m={version:this.version,content:l};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(m))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=ge([K(1,S.IFileService),K(2,d.IEnvironmentService),K(3,g.IStorageService),K(4,h.IUserDataSyncStoreService),K(5,h.IUserDataSyncBackupStoreService),K(6,h.IUserDataSyncEnablementService),K(7,u.ITelemetryService),K(8,h.IUserDataSyncLogService),K(9,y.IConfigurationService),K(10,f.IUriIdentityService)],t),e.AbstractSynchroniser=t;let i=class extends t{constructor(l,m,D,U,O,F,L,N,W,V,J,$){super(m,D,U,O,F,L,N,W,V,J,$);this.file=l,this._register(this.fileService.watch(this.extUri.dirname(l))),this._register(this.fileService.onDidFilesChange(Q=>this.onFileChanges(Q)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(l,m,D){try{m?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(l),D?void 0:m):await this.fileService.createFile(this.file,k.VSBuffer.fromString(l),{overwrite:D})}catch(U){throw U instanceof S.FileOperationError&&U.fileOperationResult===1||U instanceof S.FileOperationError&&U.fileOperationResult===3?new h.UserDataSyncError(U.message,"LocalPreconditionFailed"):U}}onFileChanges(l){!l.contains(this.file)||this.triggerLocalChange()}};i=ge([K(2,S.IFileService),K(3,d.IEnvironmentService),K(4,g.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,u.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,y.IConfigurationService),K(11,f.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let o=class extends i{constructor(l,m,D,U,O,F,L,N,W,V,J,$,Q){super(l,m,D,U,O,F,L,N,W,V,$,Q);this.userDataSyncUtilService=J,this._formattingOptions=void 0}hasErrors(l,m){const D=[],U=(0,C.parse)(l,D,{allowEmptyContent:!0,allowTrailingComma:!0});return D.length>0||!(0,E.isUndefined)(U)&&m!==Array.isArray(U)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=ge([K(2,S.IFileService),K(3,d.IEnvironmentService),K(4,g.IStorageService),K(5,h.IUserDataSyncStoreService),K(6,h.IUserDataSyncBackupStoreService),K(7,h.IUserDataSyncEnablementService),K(8,u.ITelemetryService),K(9,h.IUserDataSyncLogService),K(10,h.IUserDataSyncUtilService),K(11,y.IConfigurationService),K(12,f.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let c=class{constructor(l,m,D,U,O,F){this.resource=l,this.userDataProfilesService=m,this.environmentService=D,this.logService=U,this.fileService=O,this.extUri=F.extUri,this.lastSyncResource=(0,h.getLastSyncResourceUri)(this.resource,D,this.extUri)}async initialize({ref:l,content:m}){if(!m){this.logService.info("Remote content does not exist.",this.resource);return}const D=this.parseSyncData(m);if(!!D)try{await this.doInitialize({ref:l,syncData:D})}catch(U){this.logService.error(U)}}parseSyncData(l){try{const m=JSON.parse(l);if(r(m))return m}catch(m){this.logService.error(m)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(l,m={}){const D={ref:l.ref,content:l.syncData?JSON.stringify(l.syncData):null,...m};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(D)))}};c=ge([K(1,s.IUserDataProfilesService),K(2,d.IEnvironmentService),K(3,w.ILogService),K(4,S.IFileService),K(5,f.IUriIdentityService)],c),e.AbstractInitializer=c}),define(ne[256],re([0,1,6,21,9,3,53,26,7,19,14,28,32,72,13,8,23,22,33,29,47,236,107,25]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(c,a){const l=JSON.parse(c.content);if(c.version===1||c.version===2){const m=(await a.getInstalled(0)).filter(D=>D.isBuiltin);for(const D of l)c.version===1&&(D.enabled===!1&&(D.disabled=!0),delete D.enabled),c.version===2&&m.every(U=>!(0,v.areSameExtensions)(U.identifier,D.identifier))&&(D.installed=!0)}return l}let i=class gt extends f.AbstractSynchroniser{constructor(a,l,m,D,U,O,F,L,N,W,V,J,$,Q,H){super("extensions",l,a,m,D,U,J,$,N,V,H);this.extensionManagementService=O,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=L,this.extensionGalleryService=W,this.extensionStorageService=Q,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(T.Event.any(T.Event.filter(this.extensionManagementService.onDidInstallExtensions,B=>B.some(({local:Y})=>!!Y)),T.Event.filter(this.extensionManagementService.onDidUninstallExtension,B=>!B.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(a,l){const m=a.syncData?await t(a.syncData,this.extensionManagementService):null,D=l?.skippedExtensions||[],U=l?.syncData?await t(l.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(void 0),F=this.getLocalExtensions(O),L=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);m?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:N,remote:W}=(0,h.merge)(F,m,U,D,L),V={local:N,remote:W,content:this.getPreviewContent(F,N.added,N.updated,N.removed),localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:W!==null?2:0},J=this.stringify(F,!1);return[{skippedExtensions:D,baseResource:this.baseResource,baseContent:U?this.stringify(U,!1):J,localResource:this.localResource,localContent:J,localExtensions:F,remoteResource:this.remoteResource,remoteContent:m?this.stringify(m,!1):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(a){const l=a.syncData?await t(a.syncData,this.extensionManagementService):null,m=await this.extensionManagementService.getInstalled(void 0),D=this.getLocalExtensions(m),U=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),{remote:O}=(0,h.merge)(D,l,l,a.skippedExtensions||[],U);return O!==null}getPreviewContent(a,l,m,D){const U=[...l,...m],O=new Set,F=L=>{O.add(L.id.toLowerCase()),L.uuid&&O.add(L.uuid)};U.forEach(({identifier:L})=>F(L)),D.forEach(F);for(const L of a)O.has(L.identifier.id.toLowerCase())||L.identifier.uuid&&O.has(L.identifier.uuid)||U.push(L);return this.stringify(U,!1)}async getMergeResult(a,l){return{...a.previewResult,hasConflicts:!1}}async getAcceptResult(a,l,m,D){if(this.extUri.isEqual(l,this.localResource))return this.acceptLocal(a);if(this.extUri.isEqual(l,this.remoteResource))return this.acceptRemote(a);if(this.extUri.isEqual(l,this.previewResource))return a.previewResult;throw new Error(`Invalid Resource: ${l.toString()}`)}async acceptLocal(a){const l=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),D=(0,h.merge)(a.localExtensions,null,null,a.skippedExtensions,m),{local:U,remote:O}=D;return{content:a.localContent,local:U,remote:O,localChange:U.added.length>0||U.removed.length>0||U.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(a){const l=await this.extensionManagementService.getInstalled(),m=this.ignoredExtensionsManagementService.getIgnoredExtensions(l),D=a.remoteContent?JSON.parse(a.remoteContent):null;if(D!==null){const U=(0,h.merge)(a.localExtensions,D,a.localExtensions,[],m),{local:O,remote:F}=U;return{content:a.remoteContent,local:O,remote:F,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:a.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(a,l,m,D){let{skippedExtensions:U,localExtensions:O}=m[0][0];const{local:F,remote:L,localChange:N,remoteChange:W}=m[0][1];if(N===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),N!==0&&(await this.backupLocal(JSON.stringify(O)),U=await this.updateLocalExtensions(F.added,F.removed,F.updated,U)),L){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(L.all);a=await this.updateRemoteUserData(V,D?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${L.added.length?` Added: ${JSON.stringify(L.added.map(J=>J.identifier.id))}.`:""}${L.updated.length?` Updated: ${JSON.stringify(L.updated.map(J=>J.identifier.id))}.`:""}${L.removed.length?` Removed: ${JSON.stringify(L.removed.map(J=>J.identifier.id))}.`:""}`)}l?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(a,{skippedExtensions:U}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${U.length?` Skipped: ${JSON.stringify(U.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:a}){return[{resource:this.extUri.joinPath(a,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(a){if(this.extUri.isEqual(a,gt.EXTENSIONS_DATA_URI)){const m=await this.extensionManagementService.getInstalled(),D=this.ignoredExtensionsManagementService.getIgnoredExtensions(m),U=this.getLocalExtensions(m).filter(O=>!D.some(F=>(0,v.areSameExtensions)({id:F},O.identifier)));return this.stringify(U,!0)}if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.baseResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a)){const m=await this.resolvePreviewContent(a);return m&&this.stringify(JSON.parse(m),!0)}let l=await super.resolveContent(a);if(l)return l;if(l=await super.resolveContent(this.extUri.dirname(a)),l){const m=this.parseSyncData(l);if(m)switch(this.extUri.basename(a)){case"extensions.json":return this.stringify(this.parseExtensions(m),!0)}}return null}stringify(a,l){return a.sort((m,D)=>!m.identifier.uuid&&D.identifier.uuid?-1:m.identifier.uuid&&!D.identifier.uuid?1:(0,C.compare)(m.identifier.id,D.identifier.id)),l?(0,A.toFormattedString)(a,{}):JSON.stringify(a)}async hasLocalData(){try{const a=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(a).some(m=>m.installed||m.disabled))return!0}catch{}return!1}async updateLocalExtensions(a,l,m,D){const U=[],O=[],F=await this.extensionManagementService.getInstalled();if(l.length){const N=F.filter(({identifier:W,isBuiltin:V})=>!V&&l.some(J=>(0,v.areSameExtensions)(W,J)));await R.Promises.settled(N.map(async W=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,W.identifier.id),U.push(W.identifier)}))}(a.length||m.length)&&await R.Promises.settled([...a,...m].map(async N=>{const W=F.find(J=>(0,v.areSameExtensions)(J.identifier,N.identifier));if(W&&W.isBuiltin){N.state&&W.manifest.version===N.version&&this.updateExtensionState(N.state,W,W.manifest.version),this.extensionEnablementService.getDisabledExtensions().some($=>(0,v.areSameExtensions)($,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id))),U.push(N.identifier);return}const V=(await this.extensionGalleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],n.CancellationToken.None))[0];if(N.state&&(W?W.manifest.version===N.version:!!V)&&this.updateExtensionState(N.state,W||V,W?.manifest.version),V)try{this.extensionEnablementService.getDisabledExtensions().some($=>(0,v.areSameExtensions)($,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id,V.version))),(!W||W.preRelease!==N.preRelease)&&(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,N.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:N.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,N.identifier.id,V.version),U.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),O.push(N)))}catch(J){O.push(N),J instanceof b.ExtensionManagementError&&[b.ExtensionManagementErrorCode.Incompatible,b.ExtensionManagementErrorCode.IncompatiblePreRelease,b.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(J.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,V.displayName||V.identifier.id):(this.logService.error(J),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id))}else O.push(N),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}));const L=[];for(const N of D)U.some(W=>(0,v.areSameExtensions)(W,N.identifier))||L.push(N);for(const N of O)L.some(W=>(0,v.areSameExtensions)(W.identifier,N.identifier))||L.push(N);return L}updateExtensionState(a,l,m){const D=this.extensionStorageService.getExtensionState(l,!0)||{},U=m?this.extensionStorageService.getKeysForSync({id:l.identifier.id,version:m}):void 0;U?U.forEach(O=>{D[O]=a[O]}):Object.keys(a).forEach(O=>D[O]=a[O]),this.extensionStorageService.setExtensionState(l,D,!0)}parseExtensions(a){return JSON.parse(a.content)}getLocalExtensions(a){const l=this.extensionEnablementService.getDisabledExtensions();return a.map(m=>{const{identifier:D,isBuiltin:U,manifest:O,preRelease:F}=m,L={identifier:D,preRelease:F,version:O.version};l.some(N=>(0,v.areSameExtensions)(N,D))&&(L.disabled=!0),U||(L.installed=!0);try{const N=this.extensionStorageService.getKeysForSync({id:D.id,version:O.version});if(N){const W=this.extensionStorageService.getExtensionState(m,!0)||{};L.state=Object.keys(W).reduce((V,J)=>(N.includes(J)&&(V[J]=W[J]),V),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(N))}return L})}};i.EXTENSIONS_DATA_URI=P.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=ge([K(0,E.IEnvironmentService),K(1,d.IFileService),K(2,w.IStorageService),K(3,r.IUserDataSyncStoreService),K(4,r.IUserDataSyncBackupStoreService),K(5,b.IExtensionManagementService),K(6,b.IGlobalExtensionEnablementService),K(7,s.IIgnoredExtensionsManagementService),K(8,r.IUserDataSyncLogService),K(9,b.IExtensionGalleryService),K(10,I.IConfigurationService),K(11,r.IUserDataSyncEnablementService),K(12,p.ITelemetryService),K(13,y.IExtensionStorageService),K(14,g.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let o=class extends f.AbstractInitializer{constructor(a,l,m,D,U,O,F){super("extensions",D,U,O,m,F);this.extensionManagementService=a,this.ignoredExtensionsManagementService=l}async parseExtensions(a){return a.syncData?await t(a.syncData,this.extensionManagementService):null}generatePreview(a,l){const m=[],D=[],U=[];for(const O of a){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const F=l.find(L=>(0,v.areSameExtensions)(L.identifier,O.identifier));F?(m.push(F),O.disabled&&U.push(O.identifier)):O.installed&&(D.push({...O.identifier,preRelease:!!O.preRelease}),O.disabled&&U.push(O.identifier))}return{installedExtensions:m,newExtensions:D,disabledExtensions:U,remoteExtensions:a}}};o=ge([K(0,b.IExtensionManagementService),K(1,s.IIgnoredExtensionsManagementService),K(2,d.IFileService),K(3,u.IUserDataProfilesService),K(4,E.IEnvironmentService),K(5,S.ILogService),K(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(ne[257],re([0,1,16,9,3,35,53,4,7,31,19,14,13,8,49,23,22,33,47,59,239,25,29]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",t=["locale"];function i(m,D){const U=m.storage?Object.keys(m.storage).sort():[],O={};return U.forEach(F=>O[F]=m.storage[F]),m.storage=O,D?(0,A.toFormattedString)(m,{}):JSON.stringify(m)}const o=1;let c=class mt extends g.AbstractSynchroniser{constructor(D,U,O,F,L,N,W,V,J,$){super("globalState",D,L,J,U,O,N,W,F,V,$);this.storageService=J,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(D.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(D.onDidFilesChange,Q=>Q.contains(this.environmentService.argvResource)),k.Event.filter(J.onDidChangeValue,Q=>Q.scope===0&&Q.target!==void 0?Q.target===0:J.keys(0,0).includes(Q.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(D,U,O){const F=D.syncData?JSON.parse(D.syncData.content):null;U=U===null&&O?D:U;const L=U&&U.syncData?JSON.parse(U.syncData.content):null,N=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=this.getStorageKeys(L),{local:V,remote:J}=(0,f.merge)(N.storage,F?F.storage:null,L?L.storage:null,W,this.logService),$={content:null,local:V,remote:J,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:J!==null?2:0},Q=i(N,!1);return[{baseResource:this.baseResource,baseContent:L?i(L,!1):Q,localResource:this.localResource,localContent:Q,localUserData:N,remoteResource:this.remoteResource,remoteContent:F?i(F,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:W}]}async hasRemoteChanged(D){const U=D.syncData?JSON.parse(D.syncData.content):null;if(U===null)return!0;const O=await this.getLocalGlobalState(),F=this.getStorageKeys(U),{remote:L}=(0,f.merge)(O.storage,U.storage,U.storage,F,this.logService);return L!==null}async getMergeResult(D,U){return{...D.previewResult,hasConflicts:!1}}async getAcceptResult(D,U,O,F){if(this.extUri.isEqual(U,this.localResource))return this.acceptLocal(D);if(this.extUri.isEqual(U,this.remoteResource))return this.acceptRemote(D);if(this.extUri.isEqual(U,this.previewResource))return D.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async acceptLocal(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:D.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(D){if(D.remoteContent!==null){const U=JSON.parse(D.remoteContent),{local:O,remote:F}=(0,f.merge)(D.localUserData.storage,U.storage,null,D.storageKeys,this.logService);return{content:D.remoteContent,local:O,remote:F,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(D,U,O,F){const{localUserData:L}=O[0][0],{local:N,remote:W,localChange:V,remoteChange:J}=O[0][1];if(V===0&&J===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(L)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),J!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const $=JSON.stringify({storage:W});D=await this.updateRemoteUserData($,F?null:D.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}U?.ref!==D.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(D),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:D}){return[{resource:this.extUri.joinPath(D,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(D){if(this.extUri.isEqual(D,mt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return i(O,!0)}if(this.extUri.isEqual(this.remoteResource,D)||this.extUri.isEqual(this.baseResource,D)||this.extUri.isEqual(this.localResource,D)||this.extUri.isEqual(this.acceptedResource,D)){const O=await this.resolvePreviewContent(D);return O&&i(JSON.parse(O),!0)}let U=await super.resolveContent(D);if(U)return U;if(U=await super.resolveContent(this.extUri.dirname(D)),U){const O=this.parseSyncData(U);if(O)switch(this.extUri.basename(D)){case"globalState.json":return i(JSON.parse(O.content),!0)}}return null}async hasLocalData(){try{const{storage:D}=await this.getLocalGlobalState();if(Object.keys(D).length>1||D[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const D={},U=await this.getLocalArgvContent(),O=(0,T.parse)(U);for(const F of t)O[F]!==void 0&&(D[`${r}${F}`]={version:1,value:O[F]});for(const F of this.storageService.keys(0,0)){const L=this.storageService.get(F,0);L&&(D[F]={version:1,value:L})}return{storage:D}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const D=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),D.value.toString()}catch(D){this.logService.debug((0,n.getErrorMessage)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:U,updated:O}){const F={},L={},N=(V,J)=>{for(const $ of V){if($.startsWith(r)){F[$.substring(r.length)]=J?J[$].value:void 0;continue}if(J){const Q=J[$];Q.value!==String(this.storageService.get($,0))&&(L[$]=Q.value)}else this.storageService.get($,0)!==void 0&&(L[$]=void 0)}};if(N(Object.keys(D),D),N(Object.keys(O),O),N(U),Object.keys(F).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(F),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(L).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(L))this.storageService.store(V,L[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(L))}}async updateArgv(D){const U=await this.getLocalArgvContent();let O=U;for(const F of Object.keys(D))O=(0,u.edit)(O,[F],D[F],{});U!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(D){const U=this.storageService.keys(0,0),O=this.storageService.keys(0,1),F=[...U,...O],L=D?.storage?Object.keys(D.storage).filter(N=>!N.startsWith(r)&&!F.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!C.isWeb){const N=[...h.ALL_SYNC_RESOURCES.map(W=>(0,h.getEnablementKey)(W)),h.SYNC_SERVICE_URL_TYPE];L.push(...N),O.push(...N)}return{user:U,machine:O,unregistered:L}}};c.GLOBAL_STATE_DATA_URI=P.URI.from({scheme:h.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),c=ge([K(0,v.IFileService),K(1,h.IUserDataSyncStoreService),K(2,h.IUserDataSyncBackupStoreService),K(3,h.IUserDataSyncLogService),K(4,b.IEnvironmentService),K(5,h.IUserDataSyncEnablementService),K(6,w.ITelemetryService),K(7,E.IConfigurationService),K(8,S.IStorageService),K(9,p.IUriIdentityService)],c),e.GlobalStateSynchroniser=c;let a=class extends g.AbstractInitializer{constructor(D,U,O,F,L,N){super("globalState",O,F,L,U,N);this.storageService=D}async doInitialize(D){const U=D.syncData?JSON.parse(D.syncData.content):null;if(!U){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},F={};for(const L of Object.keys(U.storage))L.startsWith(r)?O[L.substring(r.length)]=U.storage[L].value:this.storageService.get(L,0)===void 0&&(F[L]=U.storage[L].value);if(Object.keys(O).length){let L="{}";try{L=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const N of Object.keys(O))L=(0,u.edit)(L,[N],O[N],{});await this.fileService.writeFile(this.environmentService.argvResource,R.VSBuffer.fromString(L))}if(Object.keys(F).length)for(const L of Object.keys(F))this.storageService.store(L,F[L],0,0)}};a=ge([K(0,S.IStorageService),K(1,v.IFileService),K(2,s.IUserDataProfilesService),K(3,b.IEnvironmentService),K(4,h.IUserDataSyncLogService),K(5,p.IUriIdentityService)],a),e.GlobalStateInitializer=a;let l=class{constructor(D,U,O,F,L){this.userDataSyncStoreClient=D,this.storageService=U,this.environmentService=O,this.fileService=F,this.logService=L}getSyncStoreType(D){return this.parseGlobalState(D)?.storage[h.SYNC_SERVICE_URL_TYPE]?.value}async sync(D){const U=(0,h.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(D,U)}catch(O){if(O instanceof h.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(D,U)}throw O}}async doSync(D,U){const O=await this.userDataSyncStoreClient.read("globalState",null,U),F=this.parseGlobalState(O)||{storage:{}};F.storage[h.SYNC_SERVICE_URL_TYPE]={value:D,version:o};const L=await(0,d.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:o,machineId:L,content:i(F,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(N),O.ref,U)}parseGlobalState({content:D}){if(!D)return null;const U=JSON.parse(D);if((0,g.isSyncData)(U))return U?JSON.parse(U.content):null;throw new Error("Invalid remote data")}};l=ge([K(1,S.IStorageService),K(2,b.IEnvironmentService),K(3,v.IFileService),K(4,y.ILogService)],l),e.UserDataSyncStoreTypeSynchronizer=l}),define(ne[258],re([0,1,18,16,3,35,4,15,160,19,14,13,23,22,33,29,47,237,25]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function u(s,r,t){try{const i=JSON.parse(s);if(!r)return(0,C.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,C.isUndefined)(i.mac)?null:i.mac;case 3:return(0,C.isUndefined)(i.linux)?null:i.linux;case 1:return(0,C.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=u;let f=class extends w.AbstractJsonFileSynchroniser{constructor(r,t,i,o,c,a,l,m,D,U,O,F){super(l.defaultProfile.keybindingsResource,"keybindings",a,m,D,r,t,c,O,i,U,o,F);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(o.onDidChangeConfiguration,L=>L.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i,o){const c=r.syncData?u(r.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?r:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,l=await this.getLocalFileContent(),m=await this.getFormattingOptions();let D=null,U=!1,O=!1,F=!1;if(c){let W=l?l.value.toString():"[]";if(W=W||"[]",this.hasErrors(W,!0))throw new g.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==W||a!==c){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const V=await(0,p.merge)(W,c,a,m,this.userDataSyncUtilService);V.hasChanges&&(D=V.mergeContent,F=V.hasConflicts,U=F||V.mergeContent!==W,O=F||V.mergeContent!==c)}}else l&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),D=l.value.toString(),O=!0);const L={content:D,localChange:U?l?2:1:0,remoteChange:O?2:0,hasConflicts:F},N=l?l.value.toString():null;return[{fileContent:l,baseResource:this.baseResource,baseContent:a!==null?a:N,localResource:this.localResource,localContent:N,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:c,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getKeybindingsContentFromLastSyncUserData(r);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString():"",c=await this.getFormattingOptions(),a=await(0,p.merge)(o||"[]",t,t,c,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,o){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,o){const{fileContent:c}=i[0][0];let{content:a,localChange:l,remoteChange:m}=i[0][1];if(l===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new g.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),c&&await this.backupLocal(this.toSyncContent(c.value.toString())),await this.updateLocalFileContent(a||"[]",c,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),m!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const D=this.toSyncContent(a||"[]",r.syncData?.content);r=await this.updateRemoteUserData(D,o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,T.parse)(r.value.toString());if((0,R.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return u(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:u(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};f=ge([K(0,g.IUserDataSyncStoreService),K(1,g.IUserDataSyncBackupStoreService),K(2,g.IUserDataSyncLogService),K(3,I.IConfigurationService),K(4,g.IUserDataSyncEnablementService),K(5,b.IFileService),K(6,S.IUserDataProfilesService),K(7,E.IEnvironmentService),K(8,v.IStorageService),K(9,g.IUserDataSyncUtilService),K(10,y.ITelemetryService),K(11,d.IUriIdentityService)],f),e.KeybindingsSynchroniser=f;let h=class extends w.AbstractInitializer{constructor(r,t,i,o,c){super("keybindings",t,i,o,r,c)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,n.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,T.parse)(r.value.toString());return!(0,R.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return u(r,!0,this.logService)}catch(t){return this.logService.error(t),null}}};h=ge([K(0,b.IFileService),K(1,S.IUserDataProfilesService),K(2,E.IEnvironmentService),K(3,g.IUserDataSyncLogService),K(4,d.IUriIdentityService)],h),e.KeybindingsInitializer=h}),define(ne[259],re([0,1,16,3,161,19,68,14,28,13,23,22,33,29,47,59,240,25]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function u(s){const r=JSON.parse(s);return g(r)?r:{settings:s}}e.parseSettingsSyncContent=u;let f=class extends d.AbstractJsonFileSynchroniser{constructor(r,t,i,o,c,a,l,m,D,U,O,F,L){super(t.defaultProfile.settingsResource,"settings",r,i,o,c,a,U,O,l,m,D,L);this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,t),o=this.getSettingsSyncContent(i),c=new A.ConfigurationModelParser(p.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&c.parse(o.settings),c.configurationModel.getValue(p.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,t,i){const o=await this.getLocalFileContent(),c=await this.getFormattingOptions(),a=this.getSettingsSyncContent(r);t=t===null&&i?r:t;const l=t?this.getSettingsSyncContent(t):null,m=await this.getIgnoredSettings();let D=null,U=!1,O=!1,F=!1;if(a){let W=o?o.value.toString().trim():"{}";W=W||"{}",this.validateContent(W),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,w.merge)(W,a.settings,l?l.settings:null,m,[],c);D=V.localContent||V.remoteContent,U=V.localContent!==null,O=V.remoteContent!==null,F=V.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),D=o.value.toString().trim()||"{}",this.validateContent(D),O=!0);const L={content:D,localChange:U?2:0,remoteChange:O?2:0,hasConflicts:F},N=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:l?l.settings:N,localResource:this.localResource,localContent:N,localChange:L.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:L.remoteChange,previewResource:this.previewResource,previewResult:L,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getSettingsSyncContent(r);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString().trim():"",c=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,w.merge)(o||"{}",t.settings,t.settings,c,[],a).remoteContent!==null}async getMergeResult(r,t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,w.updateIgnoredSettings)(r.previewResult.content,"{}",o,i):null}}async getAcceptResult(r,t,i,o){const c=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?(0,w.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,c):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,w.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,w.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",a,c):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,o){const{fileContent:c}=i[0][0];let{content:a,localChange:l,remoteChange:m}=i[0][1];if(l===0&&m===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),l!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),c&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(c.value.toString()))),await this.updateLocalFileContent(a,c,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),m!==0){const D=await this.getFormattingOptions(),U=this.getSettingsSyncContent(r),O=await this.getIgnoredSettings(a);a=(0,w.updateIgnoredSettings)(a,U?U.settings:"{}",O,D),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=await this.getFormattingOptions(),i=(0,S.edit)(r.value.toString(),[p.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,w.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(r)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(r){let t=await super.resolvePreviewContent(r);if(t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,w.updateIgnoredSettings)(t,"{}",o,i)}return t}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return u(r)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:c})=>!!c)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,w.getIgnoredSettings)(t,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new p.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};f=ge([K(0,I.IFileService),K(1,y.IUserDataProfilesService),K(2,C.IEnvironmentService),K(3,E.IStorageService),K(4,p.IUserDataSyncStoreService),K(5,p.IUserDataSyncBackupStoreService),K(6,p.IUserDataSyncLogService),K(7,p.IUserDataSyncUtilService),K(8,T.IConfigurationService),K(9,p.IUserDataSyncEnablementService),K(10,b.ITelemetryService),K(11,P.IExtensionManagementService),K(12,v.IUriIdentityService)],f),e.SettingsSynchroniser=f;let h=class extends d.AbstractInitializer{constructor(r,t,i,o,c){super("settings",t,i,o,r,c)}async doInitialize(r){const t=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,R.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,w.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return u(r)}catch(t){this.logService.error(t)}return null}};h=ge([K(0,I.IFileService),K(1,y.IUserDataProfilesService),K(2,C.IEnvironmentService),K(3,p.IUserDataSyncLogService),K(4,v.IUriIdentityService)],h),e.SettingsInitializer=h}),define(ne[260],re([0,1,16,3,30,19,14,13,23,22,33,29,47,238,25]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends v.AbstractSynchroniser{constructor(g,u,f,h,s,r,t,i,o,c,a){super("snippets",u,g,h,s,r,o,c,t,i,a);this.version=1,this.snippetsFolder=f.defaultProfile.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,l=>l.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,u,f){const h=await this.getSnippetsFileContents(),s=this.toSnippetsContents(h),r=g.syncData?this.parseSnippets(g.syncData):null;u=u===null&&f?g:u;const t=u&&u.syncData?this.parseSnippets(u.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,y.merge)(s,r,t);return this.getResourcePreviews(i,h,r||{},t||{})}async hasRemoteChanged(g){const u=g.syncData?this.parseSnippets(g.syncData):null;if(u===null)return!0;const f=await this.getSnippetsFileContents(),h=this.toSnippetsContents(f),s=(0,y.merge)(h,u,u);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async getMergeResult(g,u){return g.previewResult}async getAcceptResult(g,u,f,h){if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(u,this.syncPreviewFolder))return f===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:f,localChange:f===null?g.fileContent!==null?3:0:2,remoteChange:f===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async applyResult(g,u,f,h){const s=f.map(([r,t])=>({...r,acceptResult:t}));s.every(({localChange:r,remoteChange:t})=>r===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,h)),s.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(s,g,h)),u?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,u,f,h){const s=new Map;for(const r of Object.keys(g.local.added)){const t={content:g.local.added[r],hasConflicts:!1,localChange:1,remoteChange:0};s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.local.updated)){const t={content:g.local.updated[r],hasConflicts:!1,localChange:2,remoteChange:0},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.added)){const t={content:g.remote.added[r],hasConflicts:!1,localChange:0,remoteChange:1},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.updated)){const t={content:g.remote.updated[r],hasConflicts:!1,localChange:0,remoteChange:2},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.conflicts){const t={content:u[r]?u[r].value.toString():null,hasConflicts:!0,localChange:u[r]?2:1,remoteChange:f[r]?2:1},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(u))if(!s.has(r)){const t={content:u[r]?u[r].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=u[r]?u[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:h[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:u[r]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:f[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...s.values()]}async getAssociatedResources({uri:g}){const u=await super.resolveContent(g);if(u){const f=this.parseSyncData(u);if(f){const h=this.parseSnippets(f),s=[];for(const r of Object.keys(h)){const t=this.extUri.joinPath(g,r),i=this.extUri.joinPath(this.snippetsFolder,r),o=await this.fileService.exists(i);s.push({resource:t,comparableResource:o?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:d.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let u=await super.resolveContent(g);if(u)return u;if(u=await super.resolveContent(this.extUri.dirname(g)),u){const f=this.parseSyncData(u);if(f)return this.parseSnippets(f)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const u={};for(const f of g)f.fileContent&&(u[this.extUri.basename(f.localResource)]=f.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(u)))}async updateLocalSnippets(g,u){for(const{fileContent:f,acceptResult:h,localResource:s,remoteResource:r,localChange:t}of g)if(t!==0){const i=r?this.extUri.basename(r):this.extUri.basename(s),o=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,R.VSBuffer.fromString(h.content),{overwrite:u}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,R.VSBuffer.fromString(h.content),u?void 0:f),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,u,f){const h=u.syncData?this.parseSnippets(u.syncData):{},s=(0,k.deepClone)(h);for(const{acceptResult:r,localResource:t,remoteResource:i,remoteChange:o}of g)if(o!==0){const c=t?this.extUri.basename(t):this.extUri.basename(i);o===3?delete s[c]:s[c]=r.content}return(0,y.areSame)(h,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),u=await this.updateRemoteUserData(JSON.stringify(s),f?null:u.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),u}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const u={};for(const f of Object.keys(g))u[f]=g[f].value.toString();return u}async getSnippetsFileContents(){const g={};let u;try{u=await this.fileService.resolve(this.snippetsFolder)}catch(f){if(f instanceof C.FileOperationError&&f.fileOperationResult===1)return g;throw f}for(const f of u.children||[]){const h=f.resource,s=this.extUri.extname(h);if(s===".json"||s===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,h),t=await this.fileService.readFile(h);g[r]=t}}return g}};S=ge([K(0,A.IEnvironmentService),K(1,C.IFileService),K(2,b.IUserDataProfilesService),K(3,P.IStorageService),K(4,d.IUserDataSyncStoreService),K(5,d.IUserDataSyncBackupStoreService),K(6,d.IUserDataSyncLogService),K(7,T.IConfigurationService),K(8,d.IUserDataSyncEnablementService),K(9,I.ITelemetryService),K(10,E.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let w=class extends v.AbstractInitializer{constructor(g,u,f,h,s){super("snippets",u,f,h,g,s)}async doInitialize(g){const u=g.syncData?JSON.parse(g.syncData.content):null;if(!u){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const h of Object.keys(u)){const s=u[h];if(s){const r=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,h);await this.fileService.createFile(r,R.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};w=ge([K(0,C.IFileService),K(1,b.IUserDataProfilesService),K(2,A.IEnvironmentService),K(3,d.IUserDataSyncLogService),K(4,E.IUriIdentityService)],w),e.SnippetsInitializer=w}),define(ne[261],re([0,1,16,19,14,13,23,22,33,29,47,25]),function(X,e,R,n,k,T,A,C,P,I,E,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(w,p){try{return JSON.parse(w).tasks}catch(g){return p.error(g),null}}e.getTasksContentFromSyncContent=v;let y=class extends E.AbstractFileSynchroniser{constructor(p,g,u,f,h,s,r,t,i,o,c){super(c.defaultProfile.tasksResource,"tasks",s,r,t,p,g,h,i,u,f,o);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(p,g,u,f){const h=p.syncData?v(p.syncData.content,this.logService):null;g=g===null&&u?p:g;const s=g?.syncData?v(g.syncData.content,this.logService):null,r=await this.getLocalFileContent();let t=null,i=!1,o=!1,c=!1;if(h){const m=r?r.value.toString():null;if(!s||s!==m||s!==h){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const D=S(m,h,s);t=D.content,c=D.hasConflicts,i=D.hasLocalChanged,o=D.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),o=!0);const a={content:t,localChange:i?r?2:1:0,remoteChange:o?2:0,hasConflicts:c},l=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:s!==null?s:l,localResource:this.localResource,localContent:l,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:h,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(p){const g=p?.syncData?v(p.syncData.content,this.logService):null;if(g===null)return!0;const u=await this.getLocalFileContent(),f=u?u.value.toString():null,h=S(f,g,g);return h.hasLocalChanged||h.hasRemoteChanged}async getMergeResult(p,g){return p.previewResult}async getAcceptResult(p,g,u,f){if(this.extUri.isEqual(g,this.localResource))return{content:p.fileContent?p.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:p.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return u===void 0?{content:p.previewResult.content,localChange:p.previewResult.localChange,remoteChange:p.previewResult.remoteChange}:{content:u,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(p,g,u,f){const{fileContent:h}=u[0][0],{content:s,localChange:r,remoteChange:t}=u[0][1];if(r===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),h&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(h.value.toString()))),await this.updateLocalFileContent(s||"{}",h,f),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(s||"{}"));p=await this.updateRemoteUserData(i,f?null:p.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==p.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(p),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:p}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(p,"tasks.json"),comparableResource:g}]}async resolveContent(p){if(this.extUri.isEqual(this.remoteResource,p)||this.extUri.isEqual(this.baseResource,p)||this.extUri.isEqual(this.localResource,p)||this.extUri.isEqual(this.acceptedResource,p))return this.resolvePreviewContent(p);let g=await super.resolveContent(p);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(p)),g){const u=this.parseSyncData(g);if(u)switch(this.extUri.basename(p)){case"tasks.json":return v(u.content,this.logService)}}return null}toTasksSyncContent(p){return{tasks:p}}};y=ge([K(0,b.IUserDataSyncStoreService),K(1,b.IUserDataSyncBackupStoreService),K(2,b.IUserDataSyncLogService),K(3,n.IConfigurationService),K(4,b.IUserDataSyncEnablementService),K(5,T.IFileService),K(6,k.IEnvironmentService),K(7,A.IStorageService),K(8,C.ITelemetryService),K(9,P.IUriIdentityService),K(10,I.IUserDataProfilesService)],y),e.TasksSynchroniser=y;let d=class extends E.AbstractInitializer{constructor(p,g,u,f,h){super("tasks",g,u,f,p,h);this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(p){const g=p.syncData?v(p.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,R.VSBuffer.fromString(g)),await this.updateLastSyncUserData(p)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};d=ge([K(0,T.IFileService),K(1,I.IUserDataProfilesService),K(2,k.IEnvironmentService),K(3,b.IUserDataSyncLogService),K(4,P.IUriIdentityService)],d),e.TasksInitializer=d;function S(w,p,g){if(w===null&&p===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===p)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const u=g!==w,f=g!==p;return!u&&!f?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:u&&!f?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:f&&!u?{content:p,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(ne[262],re([0,1,3,2,4,14,23,22,25]),function(X,e,R,n,k,T,A,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const I="sync.enable";let E=class extends n.Disposable{constructor(v,y,d,S){super();this.storageService=v,this.telemetryService=y,this.environmentService=d,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new R.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new R.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(w=>this.onDidStorageChange(w)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(I,{enabled:v}),this.storageService.store(I,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,P.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,y){if(this.isResourceEnabled(v)!==y){const d=(0,P.getEnablementKey)(v);this.storeResourceEnablement(d,y)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,y){this.storageService.store(v,y,-1,k.isWeb?0:1)}onDidStorageChange(v){if(v.scope!==-1)return;if(I===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=P.ALL_SYNC_RESOURCES.filter(d=>(0,P.getEnablementKey)(d)===v.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};E=ge([K(0,A.IStorageService),K(1,C.ITelemetryService),K(2,T.IEnvironmentService),K(3,P.IUserDataSyncStoreManagementService)],E),e.UserDataSyncEnablementService=E}),define(ne[73],re([0,1,3,2,4,26,164,14,13,5,24,49,23,25]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const d="sync.currentMachineName",S="Safari",w="Chrome",p="Edge",g="Firefox",u="Android";function f(r){switch(r){case S:case w:case p:case g:case u:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=f;function h(){return k.isSafari?S:k.isChrome?w:k.isEdge?p:k.isFirefox?g:k.isAndroid?u:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let s=class tt extends n.Disposable{constructor(t,i,o,c,a,l){super();this.storageService=o,this.userDataSyncStoreService=c,this.logService=a,this.productService=l,this._onDidChange=this._register(new R.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,b.getServiceMachineId)(t,i,o)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(c=>({...c,isCurrent:c.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:c})=>c===i)||(o.machines.push({id:i,name:this.computeCurrentMachineName(o.machines),platform:h()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t),c=o.machines.filter(({id:a})=>a!==i);c.length!==o.machines.length&&(o.machines=c,await this.writeMachinesData(o))}async renameMachine(t,i,o){const c=await this.readMachinesData(o),a=c.machines.find(({id:l})=>l===t);if(a){a.name=i,await this.writeMachinesData(c);const l=await this.currentMachineIdPromise;t===l&&this.storageService.store(d,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[o,c]of t){const a=i.machines.find(l=>l.id===o);a&&(a.disabled=c?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(d,-1);if(i)return i;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${h()} (${this.productService.nameShort})`,c=new RegExp(`${(0,T.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const l of t){const m=c.exec(l.name),D=m?parseInt(m[1]):0;a=D>a?D:a}return`${o} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==tt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),o=await this.userDataSyncStoreService.write(tt.RESOURCE,i,this.userData?.ref||null);this.userData={ref:o,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[tt.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:tt.VERSION,machines:[]}}};s.VERSION=1,s.RESOURCE="machines",s=ge([K(0,C.IEnvironmentService),K(1,P.IFileService),K(2,v.IStorageService),K(3,y.IUserDataSyncStoreService),K(4,y.IUserDataSyncLogService),K(5,E.IProductService)],s),e.UserDataSyncMachinesService=s}),define(ne[263],re([0,1,6,61,38,9,3,2,4,17,7,162,24,23,22,25,70,73]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",u="sync.sessionId",f="sync.storeUrl",h="sync.productQuality";let s=class extends C.Disposable{constructor(i,o,c,a,l,m,D,U,O,F){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=c,this.userDataSyncEnablementService=a,this.userDataSyncService=l,this.logService=m,this.userDataSyncAccountService=D,this.telemetryService=U,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new C.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new R.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(D.onDidChangeAccount(()=>this.updateAutoSync())),this._register(c.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(l.onDidChangeLocal(L=>this.triggerSync([L],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,L])=>L)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const i=this.storageService.get(f,-1);return i?E.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(f,i.toString(),-1,1):this.storageService.remove(f,-1)}get productQuality(){return this.storageService.get(h,-1)}set productQuality(i){i?this.storageService.store(h,i,-1,1):this.storageService.remove(h,-1)}updateAutoSync(){const{enabled:i,message:o}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(c=>this.onDidFinishSync(c))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,o,c){try{this.userDataSyncAccountService.account&&!c&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(u,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const o=S.UserDataSyncError.toUserDataSyncError(i);o instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,R.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(i,o,c){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",c)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};s=ge([K(0,v.IProductService),K(1,S.IUserDataSyncStoreManagementService),K(2,S.IUserDataSyncStoreService),K(3,S.IUserDataSyncEnablementService),K(4,S.IUserDataSyncService),K(5,S.IUserDataSyncLogService),K(6,w.IUserDataSyncAccountService),K(7,d.ITelemetryService),K(8,p.IUserDataSyncMachinesService),K(9,y.IStorageService)],s),e.UserDataAutoSyncService=s;class r extends C.Disposable{constructor(i,o,c,a,l,m,D,U){super();this.lastSyncUrl=i,this.interval=o,this.userDataSyncStoreManagementService=c,this.userDataSyncStoreService=a,this.userDataSyncService=l,this.userDataSyncMachinesService=m,this.logService=D,this.storageService=U,this.intervalHandler=this._register(new C.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,C.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,R.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(i,o){const c=(0,R.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(l){if((0,T.isCancellationError)(l))return}return this.doSync(i,o,a)});return this.syncPromise=c,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!i&&(!(0,I.isEqual)(o.defaultUrl,i.defaultUrl)||!(0,I.isEqual)(o.insidersUrl,i.insidersUrl)||!(0,I.isEqual)(o.stableUrl,i.stableUrl))}async doSync(i,o,c){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),c.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const l=this.storageService.get(u,-1);if(l&&this.manifest&&l!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const m=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(c.isCancellationRequested)return;const D=m.find(U=>U.isCurrent);if(D?.disabled)throw new S.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(U){throw new S.UserDataAutoSyncError((0,k.toErrorMessage)(U),U instanceof S.UserDataSyncError?U.code:"Unknown")}if(this.manifest&&this.manifest.session!==l&&this.storageService.store(u,this.manifest.session,-1,1),c.isCancellationRequested)return;D||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(l){this.logService.error(l),a=l}this._onDidFinishSync.fire(a)}register(i){return super._register(i)}}r.INTERVAL_SYNCING="Interval"}),define(ne[264],re([0,1,18,6,38,3,2,17,15,31,19,28,5,23,22,256,257,258,259,260,261,25]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let r=class extends A.Disposable{constructor(a,l,m,D,U,O,F,L){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=l,this.instantiationService=m,this.configurationService=D,this.logService=U,this.telemetryService=O,this.storageService=F,this.userDataSyncEnablementService=L,this._status="uninitialized",this._onDidChangeStatus=this._register(new T.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new T.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new T.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new T.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new T.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new T.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new T.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(s,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,l){this.checkEnablement();const m=(0,I.generateUuid)();try{const L=(0,h.createSyncHeaders)(m);l&&(L["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,L)}catch(L){const N=h.UserDataSyncError.toUserDataSyncError(L);throw this.reportUserDataSyncError(N,m),N}const D=!1,U=this,O=this.getEnabledSynchronizers();let F;return{manifest:a,async run(){if(D)throw new Error("Can run a task only once");return F=(0,n.createCancelablePromise)(L=>U.sync(O,a,m,L)),F.finally(()=>F=void 0)},async stop(){if(F?.cancel(),U.status!=="idle")return U.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new h.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,I.generateUuid)(),l=(0,h.createSyncHeaders)(a);let m;try{m=await this.userDataSyncStoreService.manifest(null,l)}catch(O){const F=h.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(F,a),F}await this.resetLocal();const D=this.getEnabledSynchronizers(),U=async()=>{await this.stop(D),await this.resetLocal()};return new t(a,m,l,D,U,this.configurationService,this.logService)}async sync(a,l,m,D){if(D.isCancellationRequested||!a.length)return;const U=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,h.createSyncHeaders)(m);for(const F of a){if(D.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(F.resource))return;try{await F.sync(l,O)}catch(L){let N=!1;if(L instanceof h.UserDataSyncError)switch(L.code){case"TooLarge":L=new h.UserDataSyncError(L.message,L.code,F.resource),N=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":N=!0;break}const W=h.UserDataSyncError.toUserDataSyncError(L);if(this.reportUserDataSyncError(W,m),N)throw W;this.logService.error(L),this.logService.error(`${F.resource}: ${(0,k.toErrorMessage)(L)}`),this._syncErrors.push([F.resource,W])}}this.logService.info(`Sync done. Took ${new Date().getTime()-U}ms`),this.updateLastSyncTime()}catch(O){const F=h.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(F,m),F}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const l of a)try{l.status!=="idle"&&await l.stop()}catch(m){this.logService.error(m)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async l=>{if(await l.replace(a))return!0})}async accept(a,l,m,D){this.checkEnablement(),await this.performSynchronizerAction(async U=>{if(U.resource===a)return await U.accept(l,m),D&&await U.apply(!1,(0,h.createSyncHeaders)((0,I.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async l=>{const m=await l.resolveContent(a);if(m)return m})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async m=>{if(m.resource===a)return m.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async m=>{if(m.resource===a)return m.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,l){return await this.performSynchronizerAction(async D=>{if(D.resource===a)return D.getAssociatedResources(l)})||[]}async getMachineId(a,l){return await this.performSynchronizerAction(async D=>{if(D.resource===a)return await D.getMachineId(l)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async l=>{if(l.resource!=="globalState"&&await l.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async l=>{if(await l.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(s,-1),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(l){this.logService.error(`${a.resource}: ${(0,k.toErrorMessage)(l)}`),this.logService.error(l)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const l=new A.DisposableStore;try{const m=this.synchronizers.value||l.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),D=[...m.enabled,...m.disabled.map(U=>l.add(m.createSynchronizer(U)))];for(const U of D){const O=await a(U);if(!(0,P.isUndefined)(O))return O}return null}finally{l.dispose()}}setStatus(a){const l=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),l==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const l=this.computeStatus(a);this.setStatus(l)}updateConflicts(a){const l=this.computeConflicts(a);(0,R.equals)(this._conflicts,l,([m,D],[U,O])=>m===m&&(0,R.equals)(D,O,(F,L)=>(0,C.isEqual)(F.previewResource,L.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(l))}computeConflicts(a){return a.filter(l=>l.status==="hasConflicts").map(l=>[l.resource,l.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(l=>l.status==="hasConflicts")?"hasConflicts":a.some(l=>l.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,l){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof h.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof h.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:l,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=ge([K(0,h.IUserDataSyncStoreService),K(1,h.IUserDataSyncStoreManagementService),K(2,v.IInstantiationService),K(3,E.IConfigurationService),K(4,h.IUserDataSyncLogService),K(5,d.ITelemetryService),K(6,y.IStorageService),K(7,h.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class t extends A.Disposable{constructor(a,l,m,D,U,O,F){super();this.id=a,this.manifest=l,this.syncHeaders=m,this.synchronisers=D,this.onStop=U,this.configurationService=O,this.logService=F,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new T.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,l){try{return await this.performAction(a,m=>m.accept(a,l))}catch(m){throw this.logService.error(m),m}}async merge(a){try{return a?await this.performAction(a,l=>l.merge(a)):await this.mergeAll()}catch(l){throw this.logService.error(l),l}}async discard(a){try{return await this.performAction(a,l=>l.discard(a))}catch(l){throw this.logService.error(l),l}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,l]of this.previews)for(const m of l.resourcePreviews)m.mergeState==="conflict"&&a.push(m.previewResource);for(const l of a)await this.discard(l);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[l,m]of this.previews){this.synchronizingResources.push([l,m.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const D=this.synchronisers.find(O=>O.resource===l);for(const O of m.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await D.merge(O.previewResource);const U=await D.apply(!1,this.syncHeaders);U&&a.push(this.toSyncResourcePreview(D.resource,U)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(D=>D.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(D=>D.resource===a);for(const D of l.resourcePreviews)await m.accept(D.remoteResource);await m.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(D=>D[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,l]of this.previews){this.synchronizingResources.push([a,l.resourcePreviews.map(D=>D.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const m=this.synchronisers.find(D=>D.resource===a);for(const D of l.resourcePreviews)await m.accept(D.localResource);await m.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(D=>D[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,l){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const m=this.previews.findIndex(([,V])=>V.resourcePreviews.some(({localResource:J,previewResource:$,remoteResource:Q})=>(0,C.isEqual)(a,J)||(0,C.isEqual)(a,$)||(0,C.isEqual)(a,Q)));if(m===-1)return this.previews;const[D,U]=this.previews[m],O=U.resourcePreviews.find(({localResource:V,remoteResource:J,previewResource:$})=>(0,C.isEqual)(V,a)||(0,C.isEqual)(J,a)||(0,C.isEqual)($,a));if(!O)return this.previews;let F=this.synchronizingResources.find(V=>V[0]===D);F||(F=[D,[]],this.synchronizingResources.push(F)),F[1].some(V=>(0,C.isEqual)(V,O.localResource))||(F[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const L=this.synchronisers.find(V=>V.resource===this.previews[m][0]),N=await l(L);N?this.previews.splice(m,1,this.toSyncResourcePreview(L.resource,N)):this.previews.splice(m,1);const W=this.synchronizingResources.findIndex(V=>V[0]===D);return this.synchronizingResources[W][1].splice(F[1].findIndex(V=>(0,C.isEqual)(V,O.localResource)),1),F[1].length||(this.synchronizingResources.splice(W,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[l,m]of this.previews){this.synchronizingResources.push([l,m.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const D=this.synchronisers.find(O=>O.resource===l);let U=m;for(const O of m.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(U=await D.merge(O.previewResource));U&&a.push(this.toSyncResourcePreview(D.resource,U)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===l),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const l=[],m=await this.getUserDataSyncConfiguration();for(const D of this.synchronisers){if(a.isCancellationRequested)return[];const U=await D.preview(this.manifest,m,this.syncHeaders);U&&l.push(this.toSyncResourcePreview(D.resource,U))}return l}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE),l=this.synchronisers.find(m=>m instanceof g.SettingsSynchroniser);if(l){const m=await l.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...m}}return a}toSyncResourcePreview(a,l){return[a,{isLastSyncFromCurrentMachine:l.isLastSyncFromCurrentMachine,resourcePreviews:l.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends A.Disposable{constructor(a,l,m,D,U,O,F){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=l,this.onDidChangeLocal=m,this.userDataSyncEnablementService=D,this.instantiationService=U,this.extensionGalleryService=O,this.logService=F,this._enabled=[],this._register(D.onDidChangeResourceEnablement(([L,N])=>this.onDidChangeResourceEnablement(L,N))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,L])=>L.dispose())));for(const L of h.ALL_SYNC_RESOURCES)D.isResourceEnabled(L)&&this.registerSynchronizer(L)}get enabled(){return this._enabled.sort((a,l)=>a[1]-l[1]).map(([a])=>a)}get disabled(){return h.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,l){l?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([U])=>U.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const l=new A.DisposableStore,m=l.add(this.createSynchronizer(a));l.add(m.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),l.add(m.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),l.add(m.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const D=this.getOrder(a);this._enabled.push([m,D,l])}deRegisterSynchronizer(a){const l=this._enabled.findIndex(([m])=>m.resource===a);if(l!==-1){const m=this._enabled.splice(l,1);for(const[D,,U]of m){if(D.status!=="idle"){const O=D.conflicts.length>0;D.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}U.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(g.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(p.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(u.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(f.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(w.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};i=ge([K(3,h.IUserDataSyncEnablementService),K(4,v.IInstantiationService),K(5,b.IExtensionGalleryService),K(6,h.IUserDataSyncLogService)],i);function o(c){return{baseResource:c.baseResource,localResource:c.localResource,previewResource:c.previewResource,remoteResource:c.remoteResource,acceptedResource:c.acceptedResource,localChange:c.localChange,remoteChange:c.remoteChange,mergeState:c.mergeState}}}),define(ne[265],re([0,1,6,21,9,3,2,124,4,17,15,7,31,19,14,13,24,46,49,23,25]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const h="sync.previous.store",s="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",i=100,o=1e3*60*5;let c=class extends A.Disposable{constructor(O,F,L){super();this.productService=O,this.configurationService=F,this.storageService=L,this._onDidChangeUserDataSyncStore=this._register(new T.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(T.Event.filter(L.onDidChangeValue,N=>N.key===f.SYNC_SERVICE_URL_TYPE&&N.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(f.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(O){this.storageService.store(f.SYNC_SERVICE_URL_TYPE,O,-1,P.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[f.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(f.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=P.isWeb&&O?.web?{...O,...O.web}:O;const L={...O||{},...F||{}};if(L&&(0,E.isString)(L.url)&&(0,E.isObject)(L.authenticationProviders)&&Object.keys(L.authenticationProviders).every(N=>Array.isArray(L.authenticationProviders[N].scopes))){const N=L,W=!!N.canSwitch&&!F?.url,V=N.url===N.insidersUrl?"insiders":"stable",J=(W?this.userDataSyncStoreType:void 0)||V,$=F?.url||(J==="insiders"?N.insidersUrl:J==="stable"?N.stableUrl:N.url);return{url:b.URI.parse($),type:J,defaultType:V,defaultUrl:b.URI.parse(N.url),stableUrl:b.URI.parse(N.stableUrl),insidersUrl:b.URI.parse(N.insidersUrl),canSwitch:W,authenticationProviders:Object.keys(N.authenticationProviders).reduce((Q,H)=>(Q.push({id:H,scopes:N.authenticationProviders[H].scopes}),Q),[])}}}};c=ge([K(0,w.IProductService),K(1,y.IConfigurationService),K(2,u.IStorageService)],c),e.AbstractUserDataSyncStoreManagementService=c;let a=class extends c{constructor(O,F,L){super(O,F,L);const N=this.storageService.get(h,-1);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const W=this.productService[f.CONFIGURATION_SYNC_STORE_KEY];W?this.storageService.store(h,JSON.stringify(W),-1,1):this.storageService.remove(h,-1)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=ge([K(0,w.IProductService),K(1,y.IConfigurationService),K(2,u.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let l=class extends A.Disposable{constructor(O,F,L,N,W,V,J){super();this.requestService=L,this.logService=N,this.storageService=J,this._onTokenFailed=this._register(new T.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new T.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new T.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,g.getServiceMachineId)(W,V,J).then($=>{const Q={"X-Client-Name":`${F.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(Q["X-Client-Commit"]=F.commit),Q}),this.session=new D(i,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,I.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(s,-1);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,R.createCancelablePromise)(F=>(0,R.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(s,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O),L={},N=await this.request(F.toString(),{type:"GET",headers:L},[],n.CancellationToken.None);return(await(0,p.asJson)(N)||[]).map(({url:V,created:J})=>({ref:(0,I.relativePath)(F,F.with({path:V})),created:J*1e3}))}async resolveContent(O,F,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString();L={...L},L["Cache-Control"]="no-cache";const W=await this.request(N,{type:"GET",headers:L},[],n.CancellationToken.None);return await(0,p.asTextOrError)(W)}async delete(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=F!==null?(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString():(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),N={};await this.request(L,{type:"DELETE",headers:N},[],n.CancellationToken.None)}async read(O,F,L={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();L={...L},L["Cache-Control"]="no-cache",F&&(L["If-None-Match"]=F.ref);const W=await this.request(N,{type:"GET",headers:L},[304],n.CancellationToken.None);let V=null;if(W.res.statusCode===304&&(V=F),V===null){const J=W.res.headers.etag;if(!J)throw new f.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",W.res.statusCode,W.res.headers[f.HEADER_OPERATION_ID]);const $=await(0,p.asTextOrError)(W);if(!$&&W.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",N,"EmptyResponse",W.res.statusCode,W.res.headers[f.HEADER_OPERATION_ID]);V={ref:J,content:$}}return V}async write(O,F,L,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();N={...N},N["Content-Type"]=C.Mimes.text,L&&(N["If-Match"]=L);const V=await this.request(W,{type:"POST",data:F,headers:N},[],n.CancellationToken.None),J=V.res.headers.etag;if(!J)throw new f.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",V.res.statusCode,V.res.headers[f.HEADER_OPERATION_ID]);return J}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const L=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const N=await this.request(L,{type:"GET",headers:F},[304],n.CancellationToken.None);let W=null;if(N.res.statusCode===304&&(W=O),!W){const J=N.res.headers.etag;if(!J)throw new f.UserDataSyncStoreError("Server did not return the ref",L,"NoRef",N.res.statusCode,N.res.headers[f.HEADER_OPERATION_ID]);const $=await(0,p.asTextOrError)(N);if(!$&&N.res.statusCode===304)throw new f.UserDataSyncStoreError("Empty response",L,"EmptyResponse",N.res.statusCode,N.res.headers[f.HEADER_OPERATION_ID]);$&&(W={...JSON.parse($),ref:J})}const V=this.storageService.get(r,-1);return V&&W&&V!==W.session&&this.clearSession(),W===null&&V&&this.clearSession(),W&&this.storageService.store(r,W.session,-1,1),W}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":C.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,-1),this.storageService.remove(t,-1)}async request(O,F,L,N){if(!this.authToken)throw new f.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new f.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const W=await this.commonHeadersPromise;F.headers={...F.headers||{},...W,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let V;try{V=await this.session.request(O,F,N)}catch(H){if(!(H instanceof f.UserDataSyncStoreError)){let B="RequestFailed";const Y=(0,k.getErrorMessage)(H).toLowerCase();Y.includes("xhr timeout")?B="RequestTimeout":Y.includes("protocol")&&Y.includes("not supported")?B="RequestProtocolNotSupported":Y.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":Y.includes("headers must be an object")?B="RequestHeadersNotObject":(0,k.isCancellationError)(H)&&(B="RequestCanceled"),H=new f.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,B,void 0,void 0)}throw this.logService.info("Request failed",O),H}const J=V.res.headers[f.HEADER_OPERATION_ID],$={url:O,status:V.res.statusCode,"execution-id":F.headers[f.HEADER_EXECUTION_ID],"operation-id":J},Q=(0,p.isSuccess)(V)||V.res.statusCode&&L.indexOf(V.res.statusCode)!==-1;if(Q?this.logService.trace("Request succeeded",$):this.logService.info("Request failed",$),V.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new f.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",V.res.statusCode,J);if(this._onTokenSucceed.fire(),V.res.statusCode===409)throw new f.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",V.res.statusCode,J);if(V.res.statusCode===410)throw new f.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",V.res.statusCode,J);if(V.res.statusCode===412)throw new f.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",V.res.statusCode,J);if(V.res.statusCode===413)throw new f.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",V.res.statusCode,J);if(V.res.statusCode===426)throw new f.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",V.res.statusCode,J);if(V.res.statusCode===429){const H=V.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new f.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",V.res.statusCode,J)):new f.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",V.res.statusCode,J)}if(!Q)throw new f.UserDataSyncStoreError("Server returned "+V.res.statusCode,O,"Unknown",V.res.statusCode,J);return V}addSessionHeaders(O){let F=this.storageService.get(t,-1);F===void 0&&(F=(0,v.generateUuid)(),this.storageService.store(t,F,-1,1)),O["X-Machine-Session-Id"]=F;const L=this.storageService.get(r,-1);L!==void 0&&(O["X-User-Session-Id"]=L)}};l=ge([K(1,w.IProductService),K(2,p.IRequestService),K(3,f.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,S.IFileService),K(6,u.IStorageService)],l),e.UserDataSyncStoreClient=l;let m=class extends l{constructor(O,F,L,N,W,V,J){super(O.userDataSyncStore?.url,F,L,N,W,V,J);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};m=ge([K(0,f.IUserDataSyncStoreManagementService),K(1,w.IProductService),K(2,p.IRequestService),K(3,f.IUserDataSyncLogService),K(4,d.IEnvironmentService),K(5,S.IFileService),K(6,u.IStorageService)],m),e.UserDataSyncStoreService=m;class D{constructor(O,F,L,N){this.limit=O,this.interval=F,this.requestService=L,this.logService=N,this.requests=[],this.startTime=void 0}request(O,F,L){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new f.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,L)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=D}),define(ne[266],re([0,1,3,67,24,23,22,263,25,70,73]),function(X,e,R,n,k,T,A,C,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=class extends C.UserDataAutoSyncService{constructor(y,d,S,w,p,g,u,f,h,s,r){super(y,d,S,w,p,u,f,h,s,r);this._register(R.Event.debounce(R.Event.any(R.Event.map(g.onDidFocusWindow,()=>"windowFocus"),R.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};b=ge([K(0,k.IProductService),K(1,P.IUserDataSyncStoreManagementService),K(2,P.IUserDataSyncStoreService),K(3,P.IUserDataSyncEnablementService),K(4,P.IUserDataSyncService),K(5,n.INativeHostService),K(6,P.IUserDataSyncLogService),K(7,I.IUserDataSyncAccountService),K(8,A.ITelemetryService),K(9,E.IUserDataSyncMachinesService),K(10,T.IStorageService)],b),e.UserDataAutoSyncService=b}),define(ne[108],re([0,1,54,6,12,15,27,137,275,276]),function(X,e,R,n,k,T,A,C,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class E extends Error{constructor(s,r){let t=r.message;switch(s){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=s,this.cause=r}}e.ExtractError=E;function b(h){const s=h.externalFileAttributes>>16||33188;return[448,56,7].map(r=>s&r).reduce((r,t)=>r+t,s&61440)}function v(h){if(h instanceof E)return h;let s;return/end of central directory record signature not found/.test(h.message)&&(s="CorruptZip"),new E(s,h)}function y(h,s,r,t,i,o){const c=k.dirname(s),a=k.join(t,c);if(!a.startsWith(t))return Promise.reject(new Error(C.localize(0,null,s)));const l=k.join(t,s);let m;return o.onCancellationRequested(()=>{m?.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((D,U)=>{if(!o.isCancellationRequested)try{m=(0,R.createWriteStream)(l,{mode:r}),m.once("close",()=>D()),m.once("error",U),h.once("error",U),h.pipe(m)}catch(O){U(O)}}))}function d(h,s,r,t){let i=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{i.cancel(),h.close()}),new Promise((c,a)=>{const l=new n.Sequencer,m=D=>{D.isCancellationRequested||(o++,h.readEntry())};h.once("error",a),h.once("close",()=>i.then(()=>{t.isCancellationRequested||h.entryCount===o?c():a(new E("Incomplete",new Error(C.localize(1,null,o,h.entryCount))))},a)),h.readEntry(),h.on("entry",D=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(D.fileName)){m(t);return}const U=D.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(U)){const L=k.join(s,U);i=(0,n.createCancelablePromise)(N=>A.Promises.mkdir(L,{recursive:!0}).then(()=>m(N)).then(void 0,a));return}const O=w(h,D),F=b(D);i=(0,n.createCancelablePromise)(L=>l.queue(()=>O.then(N=>y(N,U,F,s,r,L).then(()=>m(L)))).then(null,a))})})}function S(h,s=!1){return new Promise((r,t)=>{(0,P.open)(h,s?{lazyEntries:!0}:void 0,(i,o)=>{i?t(v(i)):r((0,T.assertIsDefined)(o))})})}function w(h,s){return new Promise((r,t)=>{h.openReadStream(s,(i,o)=>{i?t(v(i)):r((0,T.assertIsDefined)(o))})})}function p(h,s){return new Promise((r,t)=>{const i=new I.ZipFile;s.forEach(c=>{c.contents?i.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&i.addFile(c.localPath,c.path)}),i.end();const o=(0,R.createWriteStream)(h);i.outputStream.pipe(o),i.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(h))})}e.zip=p;function g(h,s,r={},t){const i=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=S(h,!0);return r.overwrite&&(o=o.then(c=>A.Promises.rm(s).then(()=>c))),o.then(c=>d(c,s,{sourcePathRegex:i},t))}e.extract=g;function u(h,s){return S(h).then(r=>new Promise((t,i)=>{r.on("entry",o=>{o.fileName===s&&w(r,o).then(c=>t(c),c=>i(c))}),r.once("close",()=>i(new Error(C.localize(2,null,s))))}))}function f(h,s){return u(h,s).then(r=>new Promise((t,i)=>{const o=[];r.once("error",i),r.on("data",c=>o.push(c)),r.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=f}),define(ne[267],re([0,1,108,146]),function(X,e,R,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(T){return(0,R.buffer)(T,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=k}),define(ne[109],re([0,1,6,38,9,2,20,12,4,17,55,15,7,31,27,108,145,90,14,247,28,32,45,71,201,249,267,202,233,44,65,13,5,8,24,22,33,29]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h,s,r,t,i,o,c,a,l,m,D,U,O,F,L,N,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,U.refineServiceDecorator)(f.IServerExtensionManagementService);let V=class extends u.AbstractExtensionManagementService{constructor(z,x,_,M,q,j,Z,G,te,se,ce,he){super(z,x,_,se,he);this.extensionsScannerService=q,this.extensionsProfileScannerService=j,this.downloadService=Z,this.fileService=te,this.installGalleryExtensionsTasks=new Map;const ve=this._register(G.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(G.createInstance(J,Ce=>ve.postUninstall(Ce))),this.manifestCache=this._register(new c.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(G.createInstance(t.ExtensionsDownloader));const pe=this._register(new a.ExtensionsWatcher(this,te,M,_,ce));this._register(pe.onDidChangeExtensionsByAnotherSource(({added:Ce,removed:be})=>{Ce.length&&this._onDidInstallExtensions.fire(Ce.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),be.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,h.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const x=await this.collectFiles(z),_=await(0,S.zip)((0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,x);return v.URI.file(_)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:x,cleanup:_}=await this.downloadVsix(z),M=C.resolve(x.fsPath);try{return await(0,o.getManifest)(M)}finally{await _()}}getInstalled(z,x){return this.extensionsScanner.scanExtensions(z??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(z,x={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:_,cleanup:M}=await this.downloadVsix(z);try{const q=await(0,o.getManifest)(C.resolve(_.fsPath));if(q.engines&&q.engines.vscode&&!(0,m.isEngineValid)(q.engines.vscode,this.productService.version,this.productService.date))throw new Error(w.localize(0,null,(0,h.getGalleryExtensionId)(q.publisher,q.name),this.productService.version));return await this.installExtension(q,_,x)}finally{await M()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,x){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const _={...x};return x.isPreReleaseVersion&&(_.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,_),this.manifestCache.invalidate(),z}async updateExtensionScope(z,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:x}),this.manifestCache.invalidate(),z}removeUninstalledExtensions(z){return this.extensionsScanner.cleanUp(z)}async downloadVsix(z){if(z.scheme===A.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const x=(0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)());return await this.downloadService.download(z,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(M){this.logService.error(M)}}}}doCreateInstallExtensionTask(z,x,_){let M;if(v.URI.isUri(x))M=new H(z,x,_,this.galleryService,this.extensionsScanner,this.logService);else{const q=h.ExtensionKey.create(x).toString();M=this.installGalleryExtensionsTasks.get(q),M||(this.installGalleryExtensionsTasks.set(q,M=new Q(z,x,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),M.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(q)))}return _.profileLocation?new B(M,_.profileLocation,this.extensionsProfileScannerService):M}doCreateUninstallExtensionTask(z,x){return x.profileLocation?new ie(z,x.profileLocation,this.extensionsProfileScannerService):new Y(z,x,this.extensionsScanner)}async collectFiles(z){const x=async M=>{let q=await d.Promises.readdir(M);q=q.map(G=>C.join(M,G));const j=await Promise.all(q.map(G=>d.Promises.stat(G)));let Z=Promise.resolve([]);return j.forEach((G,te)=>{const se=q[te];G.isFile()&&(Z=Z.then(ce=>[...ce,se])),G.isDirectory()&&(Z=Z.then(ce=>x(se).then(he=>[...ce,...he])))}),Z};return(await x(z.location.fsPath)).map(M=>({path:`extension/${C.relative(z.location.fsPath,M)}`,localPath:M}))}};V=ge([K(0,f.IExtensionGalleryService),K(1,L.ITelemetryService),K(2,O.ILogService),K(3,g.INativeEnvironmentService),K(4,r.IExtensionsScannerService),K(5,s.IExtensionsProfileScannerService),K(6,p.IDownloadService),K(7,U.IInstantiationService),K(8,D.IFileService),K(9,F.IProductService),K(10,N.IUriIdentityService),K(11,W.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let J=class extends T.Disposable{constructor(z,x,_,M){super();this.beforeRemovingExtension=z,this.fileService=x,this.extensionsScannerService=_,this.logService=M,this.uninstalledPath=(0,I.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new R.Queue}async cleanUp(z){await this.removeUninstalledExtensions(),z&&await this.removeOutdatedExtensions()}async scanExtensions(z,x){const _={includeInvalid:!0,profileLocation:x};let M=[];return z===null||z===0?M.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_)):z===1&&M.push(...await this.extensionsScannerService.scanUserExtensions(_)),M=z!==null?M.filter(q=>q.type===z):M,Promise.all(M.map(q=>this.toLocalExtension(q)))}async scanUserExtensions(z){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(x.map(_=>this.toLocalExtension(_)))}async extractUserExtension(z,x,_,M){const q=z.toString(),j=C.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),Z=C.join(this.extensionsScannerService.userExtensionsLocation.fsPath,q);try{await d.Promises.rm(Z)}catch{throw new f.ExtensionManagementError(w.localize(1,null,Z,z.id),f.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,x,j,M),_={..._,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(v.URI.file(j),_);try{await this.rename(z,j,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(G){try{await d.Promises.rm(j)}catch{}if(G.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(G)}. Deleted from extracted location`,j),G}return this.scanLocalExtension(v.URI.file(Z),1)}async updateMetadata(z,x){return await this.extensionsScannerService.updateMetadata(z.location,x),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const x=z.map(_=>h.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{x.forEach(M=>_[M.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(M=>delete M[z.toString()]);const _=(await this.scanUserExtensions(!0)).find(M=>h.ExtensionKey.create(M).equals(z))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(z,x){this.logService.trace(`Deleting ${x} extension from disk`,z.identifier.id,z.location.fsPath),await d.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[h.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await d.Promises.readFile(this.uninstalledPath,"utf8")}catch(M){if(M.code!=="ENOENT")throw M}let _={};if(x)try{_=JSON.parse(x)}catch{}return z&&(z(_),Object.keys(_).length?await d.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await d.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(z,x,_,M){this.logService.trace(`Started extracting the extension from ${x} to ${_}`);try{await d.Promises.rm(_)}catch(q){throw new f.ExtensionManagementError(this.joinErrors(q).message,f.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(x,_,{sourcePath:"extension",overwrite:!0},M),this.logService.info(`Extracted extension to ${_}:`,z.id)}catch(q){try{await d.Promises.rm(_)}catch{}let j=f.ExtensionManagementErrorCode.Extract;throw q instanceof S.ExtractError&&(q.type==="CorruptZip"?j=f.ExtensionManagementErrorCode.CorruptZip:q.type==="Incomplete"&&(j=f.ExtensionManagementErrorCode.IncompleteZip)),new f.ExtensionManagementError(q.message,j)}}async rename(z,x,_,M){try{await d.Promises.rename(x,_)}catch(q){if(P.isWindows&&q&&q.code==="EPERM"&&Date.now()<M)return this.logService.info(`Failed renaming ${x} to ${_} with 'EPERM' error. Trying again...`,z.id),this.rename(z,x,_,M);throw new f.ExtensionManagementError(q.message||w.localize(2,null,x,_),q.code||f.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,x){const _=await this.extensionsScannerService.scanExistingExtension(z,x,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(w.localize(3,null,z.path))}async toLocalExtension(z){const x=await this.fileService.resolve(z.location);let _,M;return x.children&&(_=x.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,M=x.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:_,changelogUrl:M,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const j of x)z[h.ExtensionKey.create(j).toString()]||_.add(j.identifier.id.toLowerCase());const M=(0,h.groupByExtension)(x,j=>j.identifier);await R.Promises.settled(M.map(async j=>{const Z=j.sort((G,te)=>E.rcompare(G.manifest.version,te.manifest.version))[0];_.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const q=x.filter(j=>z[h.ExtensionKey.create(j).toString()]);await R.Promises.settled(q.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],M=await this.extensionsScannerService.getTargetPlatform(),q=(0,h.groupByExtension)(x,j=>j.identifier);for(const j of q)if(j.length>1&&_.push(...j.sort((Z,G)=>{const te=E.rcompare(Z.manifest.version,G.manifest.version);return te!==0?te:Z.targetPlatform===M?-1:1}).slice(1)),j[0].type===0){const Z=z.find(G=>(0,h.areSameExtensions)(G.identifier,j[0].identifier));(!Z||E.gte(Z.manifest.version,j[0].manifest.version))&&_.push(j[0])}await R.Promises.settled(_.map(j=>this.removeExtension(j,"outdated")))}joinErrors(z){const x=Array.isArray(z)?z:[z];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((_,M)=>new Error(`${_.message}${_.message?",":""}${M instanceof Error?M.message:M}`),new Error(""))}};J=ge([K(1,D.IFileService),K(2,r.IExtensionsScannerService),K(3,O.ILogService)],J);class $ extends u.AbstractExtensionTask{constructor(z,x,_,M,q){super();this.identifier=z,this.source=x,this.options=_,this.extensionsScanner=M,this.logService=q,this._operation=2}get operation(){return(0,b.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(z,x){try{const _=await this.unsetUninstalledAndGetLocal(z.key);if(_)return z.metadata?this.extensionsScanner.updateMetadata(_,z.metadata):_}catch{throw P.isMacintosh?new f.ExtensionManagementError(w.localize(4,null),f.ExtensionManagementErrorCode.Internal):new f.ExtensionManagementError(w.localize(5,null),f.ExtensionManagementErrorCode.Internal)}return this.extract(z,x)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const _=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),_}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:x,metadata:_},M){const q=await this.extensionsScanner.extractUserExtension(x,z,_,M);return this.logService.info("Extracting completed.",x.id),q}}class Q extends ${constructor(z,x,_,M,q,j){super(x.identifier,x,_,q,j);this.manifest=z,this.gallery=x,this.extensionsDownloader=M}async doRun(z){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,h.areSameExtensions)(j.identifier,this.gallery.identifier));_&&(this._operation=3);const M={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,l.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,b.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,M),metadata:M};const q=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:q,key:h.ExtensionKey.create(this.gallery),metadata:M},z);return _&&!this.options.profileLocation&&(_.targetPlatform!==j.targetPlatform||E.neq(_.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:j,metadata:M}}catch(j){throw await this.deleteDownloadedVSIX(q),j}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(v.URI.file(z))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,k.getErrorMessage)(x))}}async downloadExtension(z,x){let _;try{this.logService.trace("Started downloading extension:",z.identifier.id),_=(await this.extensionsDownloader.downloadExtension(z,x)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,_)}catch(M){throw new f.ExtensionManagementError((0,u.joinErrors)(M).message,f.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(_),_}catch(M){throw await this.deleteDownloadedVSIX(_),new f.ExtensionManagementError((0,u.joinErrors)(M).message,f.ExtensionManagementErrorCode.Invalid)}}}class H extends ${constructor(z,x,_,M,q,j){super({id:(0,h.getGalleryExtensionId)(z.publisher,z.name)},x,_,q,j);this.manifest=z,this.location=x,this.galleryService=M}async doRun(z){const x=new h.ExtensionKey(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,h.areSameExtensions)(this.identifier,Z.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(q.isApplicationScoped=(0,l.isApplicationScopedExtension)(this.manifest),q.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=3,x.equals(new h.ExtensionKey(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch{throw new Error(w.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&E.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const Z=await this.unsetUninstalledAndGetLocal(x);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(w.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:C.resolve(this.location.fsPath),key:x,metadata:q},z),metadata:q}}async getMetadata(z,x,_){try{let[M]=await this.galleryService.getExtensions([{id:z,version:x}],_);if(M||([M]=await this.galleryService.getExtensions([{id:z}],_)),M)return{id:M.identifier.uuid,publisherDisplayName:M.publisherDisplayName,publisherId:M.publisherId,isPreReleaseVersion:M.properties.isPreReleaseVersion,preRelease:M.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B{constructor(z,x,_){this.task=z,this.profileLocation=x,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class Y extends u.AbstractExtensionTask{constructor(z,x,_){super();this.extension=z,this.options=x,this.extensionsScanner=_}async doRun(z){const x=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=h.ExtensionKey.create(this.extension);x.push(..._.filter(q=>M.equals(h.ExtensionKey.create(q))))}else x.push(..._.filter(M=>(0,h.areSameExtensions)(M.identifier,this.extension.identifier)));if(!x.length)throw new Error(w.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const M of x)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(q){throw new Error(w.localize(9,null,(0,n.toErrorMessage)(q)))}}}class ie extends u.AbstractExtensionTask{constructor(z,x,_){super();this.extension=z,this.profileLocation=x,this.extensionsProfileScannerService=_}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(ne[268],re([0,1,2,28,32,45,72,200,109,44,5,8,23,33,29]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let w=class extends R.Disposable{constructor(u,f,h,s,r,t,i,o){super();this.userDataProfilesService=f,u.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,C.migrateUnsupportedExtensions)(u,h,s,r,o),A.ExtensionStorageService.removeOutdatedExtensionVersions(u,i),this._register(t.createInstance(p))}};w=ge([K(0,P.INativeServerExtensionManagementService),K(1,d.IUserDataProfilesService),K(2,n.IExtensionGalleryService),K(3,A.IExtensionStorageService),K(4,n.IGlobalExtensionEnablementService),K(5,E.IInstantiationService),K(6,v.IStorageService),K(7,b.ILogService)],w),e.ExtensionsCleaner=w;let p=class extends R.Disposable{constructor(u,f,h,s,r){super();this.extensionManagementService=u,this.userDataProfilesService=f,this.extensionsProfileScannerService=h,this.uriIdentityService=s,this.logService=r,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new R.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:u,removed:f,all:h}){try{await Promise.all(f.map(s=>s.extensionsResource?this.removeExtensionsFromProfile(s.extensionsResource):Promise.resolve()))}catch(s){this.logService.error(s)}if(h.length===1){this.profileModeDisposables.clear();const s=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{s.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{u.length&&(await Promise.all(u.map(s=>s.extensionsResource?this.populateExtensionsFromProfile(s.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new R.DisposableStore,this.profileModeDisposables.value.add((0,R.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(s=>this.onDidChangeProfiles(s))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(s=>this.onDidInstallExtensions(s))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(s=>this.onDidUninstallExtension(s))),await this.uninstallExtensionsNotInProfiles()))}catch(s){this.logService.error(s)}}async uninstallExtensionsNotInProfiles(){const f=(await this.extensionManagementService.getAllUserInstalled()).filter(h=>!this.profileExtensionsLocations.has(this.getKey(h.identifier,h.manifest.version)));f.length&&await Promise.all(f.map(h=>this.extensionManagementService.uninstall(h,S)))}async onDidInstallExtensions(u){for(const{local:f,profileLocation:h}of u)!f||!h||this.addExtensionWithKey(this.getKey(f.identifier,f.manifest.version),h)}async onDidUninstallExtension(u){!u.profileLocation||!u.version||this.removeExtensionWithKey(this.getKey(u.identifier,u.version),u.profileLocation)&&await this.uninstallExtensions([{identifier:u.identifier,version:u.version}])}async populateExtensionsFromProfile(u){const f=await this.extensionsProfileScannerService.scanProfileExtensions(u);for(const h of f)this.addExtensionWithKey(this.getKey(h.identifier,h.version),u)}async removeExtensionsFromProfile(u){const f=[];for(const h of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(h,u))continue;const s=this.fromKey(h);s&&f.push(s)}f.length&&await this.uninstallExtensions(f)}addExtensionWithKey(u,f){let h=this.profileExtensionsLocations.get(u);h||(h=[],this.profileExtensionsLocations.set(u,h)),h.push(f)}removeExtensionWithKey(u,f){const h=this.profileExtensionsLocations.get(u);if(h){const s=h.findIndex(r=>this.uriIdentityService.extUri.isEqual(r,f));s>-1&&h.splice(s,1)}return h?.length?!1:(this.profileExtensionsLocations.delete(u),!0)}async uninstallExtensions(u){const h=(await this.extensionManagementService.getAllUserInstalled()).filter(s=>u.some(r=>this.getKey(s.identifier,s.manifest.version)===this.getKey(r.identifier,r.version)));h.length&&await Promise.all(h.map(s=>this.extensionManagementService.uninstall(s,S)))}getKey(u,f){return`${I.ExtensionIdentifier.toKey(u.id)}@${f}`}fromKey(u){const[f,h]=(0,k.getIdAndVersion)(u);return h?{identifier:{id:f},version:h}:void 0}};p=ge([K(0,P.INativeServerExtensionManagementService),K(1,d.IUserDataProfilesService),K(2,T.IExtensionsProfileScannerService),K(3,y.IUriIdentityService),K(4,b.ILogService)],p)}),define(ne[277],re([0,1,84,37,38,9,2,20,17,7,39,133,193,268,194,185,186,187,173,176,19,198,89,218,90,208,14,214,251,252,28,175,253,109,91,171,13,189,191,56,5,183,93,184,94,66,203,8,95,67,96,24,46,23,254,101,22,102,103,104,50,222,105,224,230,72,107,25,70,241,242,243,73,262,264,244,265,266,245,100,216,69,232,205,231,99,213,33,234,4,235,178,196,195,71,250,29,45,192,58,255,221,248,211]),function(X,e,R,n,k,T,A,C,P,I,E,b,v,y,d,S,w,p,g,u,f,h,s,r,t,i,o,c,a,l,m,D,U,O,F,L,N,W,V,J,$,Q,H,B,Y,ie,ae,z,x,_,M,q,j,Z,G,te,se,ce,he,ve,pe,Ce,be,Pe,Me,Ke,He,We,oe,ue,de,Ee,Ie,Ue,Re,$e,Ae,Te,Ne,ee,le,fe,Se,me,we,De,ke,Le,_e,Fe,ze,Qe,it,vt,Pt,It,Dt,pt,Rt,St,kt,Lt,Tt,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class _t extends A.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new b.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),R.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",qe=(xe,Xe)=>this.onDisposeWorker(Xe);R.ipcRenderer.on(Oe,qe),this._register((0,A.toDisposable)(()=>R.ipcRenderer.removeListener(Oe,qe)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,We.registerConfiguration)(),ye.invokeFunction(Oe=>{const qe=Oe.get(z.ILogService);qe.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(qe)}),this._register((0,A.combinedDisposable)(ye.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(d.LanguagePackCachedDataCleaner),ye.createInstance(p.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(w.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(y.ExtensionsCleaner)))}async initServices(){const ye=new H.ServiceCollection,Oe={_serviceBrand:void 0,...M.default};ye.set(q.IProductService,Oe);const qe=new E.StaticRouter(Ge=>Ge==="main"),xe=new B.MessagePortMainProcessService(this.server,qe);ye.set(Y.IMainProcessService,xe);const Xe=this.configuration.policiesData?new Rt.PolicyChannelClient(this.configuration.policiesData,xe.getChannel("policy")):new St.NullPolicyService;ye.set(St.IPolicyService,Xe);const je=new c.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(o.INativeEnvironmentService,je);const st=new x.LogLevelChannelClient(this.server.getChannel("logLevel",qe)),Ze=new x.LoggerChannelClient(this.configuration.logLevel,st.onDidChangeLogLevel,xe.getChannel("logger"));ye.set(z.ILoggerService,Ze);const ct=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,P.joinPath)(I.URI.file(je.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),Be=this._register(new x.FollowerLogService(st,ct));ye.set(z.ILogService,Be),this.sharedProcessWorkerService=new ke.SharedProcessWorkerService(Be),ye.set(De.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ye=this._register(new W.FileService(Be));ye.set(N.IFileService,Ye);const lt=this._register(new V.DiskFileSystemProvider(Be));Ye.registerProvider(C.Schemas.file,lt);const ut=this._register(new ze.FileUserDataProvider(C.Schemas.file,this._register(new Qe.DiskFileSystemProviderClient(xe.getChannel(Qe.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Fe.isLinux})),C.Schemas.vscodeUserData,Be));Ye.registerProvider(C.Schemas.vscodeUserData,ut);const et=this._register(new kt.UserDataProfilesNativeService(this.configuration.profiles,xe,je));ye.set(Dt.IUserDataProfilesService,et);const Ve=this._register(new h.ConfigurationService(et.defaultProfile.settingsResource,Ye,Xe,Be));ye.set(f.IConfigurationService,Ve);const nt=new G.NativeStorageService(void 0,{defaultProfile:et.defaultProfile,currentProfile:et.defaultProfile},xe,je);ye.set(Z.IStorageService,nt),this._register((0,A.toDisposable)(()=>nt.flush())),await Promise.all([Ve.initialize(),nt.initialize()]),ye.set(Le.IUriIdentityService,new _e.UriIdentityService(Ye)),ye.set(j.IRequestService,new At.SharedProcessRequestService(xe,Ve,Be)),ye.set(g.IChecksumService,new J.SyncDescriptor(u.ChecksumService)),ye.set(vt.IV8InspectProfilingService,new J.SyncDescriptor(it.InspectProfilingService));const ot=E.ProxyChannel.toService(xe.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(_.INativeHostService,ot),ye.set(t.IDownloadService,new J.SyncDescriptor(i.DownloadService));const ht=this._register(new Ne.ActiveWindowManager(ot)),Ut=new E.StaticRouter(Ge=>ht.getActiveClientId().then(dt=>Ge===dt));ye.set(F.IExtensionRecommendationNotificationService,new L.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ut)));let at;const rt=[],wt=(0,pe.isInternalTelemetry)(Oe,Ve);if((0,pe.supportsTelemetry)(Oe,je)){const Ge=new he.TelemetryLogAppender(Ze,je);rt.push(Ge);const{installSourcePath:dt}=je;if(Oe.aiConfig?.ariaKey){const bt=new Lt.OneDataSystemWebAppender(wt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>bt.flush())),rt.push(bt)}at=new ve.TelemetryService({appenders:rt,commonProperties:(0,te.resolveCommonProperties)(Ye,(0,n.release)(),(0,n.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,wt,dt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(je)},Ve,Oe)}else{at=pe.NullTelemetryService;const Ge=pe.NullAppender;rt.push(Ge)}this.server.registerChannel("telemetryAppender",new ce.TelemetryAppenderChannel(rt)),ye.set(se.ITelemetryService,at);const Mt=new Ce.CustomEndpointTelemetryService(Ve,at,Ze,je,Oe);ye.set(se.ICustomEndpointTelemetryService,Mt),ye.set(pt.IExtensionsProfileScannerService,new J.SyncDescriptor(pt.ExtensionsProfileScannerService)),ye.set(Pt.IExtensionsScannerService,new J.SyncDescriptor(It.ExtensionsScannerService)),ye.set(O.INativeServerExtensionManagementService,new J.SyncDescriptor(O.ExtensionManagementService)),ye.set(m.IDefaultExtensionsProfileInitService,new J.SyncDescriptor(Tt.DefaultExtensionsProfileInitService)),ye.set(m.IExtensionGalleryService,new J.SyncDescriptor(l.ExtensionGalleryService)),ye.set(m.IExtensionTipsService,new J.SyncDescriptor(U.ExtensionTipsService)),ye.set(ie.ILanguagePackService,new J.SyncDescriptor(ae.NativeLanguagePackService)),ye.set(s.IDiagnosticsService,new J.SyncDescriptor(r.DiagnosticsService)),ye.set(oe.IUserDataSyncAccountService,new J.SyncDescriptor(oe.UserDataSyncAccountService)),ye.set(We.IUserDataSyncLogService,new J.SyncDescriptor(Ee.UserDataSyncLogService)),ye.set(We.IUserDataSyncUtilService,new de.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),ye.set(m.IGlobalExtensionEnablementService,new J.SyncDescriptor(a.GlobalExtensionEnablementService)),ye.set(He.IIgnoredExtensionsManagementService,new J.SyncDescriptor(He.IgnoredExtensionsManagementService)),ye.set(Ke.IExtensionStorageService,new J.SyncDescriptor(Ke.ExtensionStorageService)),ye.set(We.IUserDataSyncStoreManagementService,new J.SyncDescriptor(Ae.UserDataSyncStoreManagementService)),ye.set(We.IUserDataSyncStoreService,new J.SyncDescriptor(Ae.UserDataSyncStoreService)),ye.set(Ie.IUserDataSyncMachinesService,new J.SyncDescriptor(Ie.UserDataSyncMachinesService)),ye.set(We.IUserDataSyncBackupStoreService,new J.SyncDescriptor(ue.UserDataSyncBackupStoreService)),ye.set(We.IUserDataSyncEnablementService,new J.SyncDescriptor(Ue.UserDataSyncEnablementService)),ye.set(We.IUserDataSyncService,new J.SyncDescriptor(Re.UserDataSyncService));const Et=new Me.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ve.getValue("terminal.integrated.persistentSessionScrollback")??100},Ve,je,Be);return Et.initialize(),ye.set(Pe.ILocalPtyService,this._register(Et)),ye.set(ee.ISignService,new J.SyncDescriptor(le.SignService)),ye.set(fe.ISharedTunnelsService,new J.SyncDescriptor(Se.SharedTunnelsService)),ye.set(me.ISharedProcessTunnelService,new J.SyncDescriptor(we.SharedProcessTunnelService)),new Q.InstantiationService(ye)}initChannels(ye){const Oe=new D.ExtensionManagementChannel(ye.get(m.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const qe=E.ProxyChannel.fromService(ye.get(ie.ILanguagePackService));this.server.registerChannel("languagePacks",qe);const xe=E.ProxyChannel.fromService(ye.get(s.IDiagnosticsService));this.server.registerChannel("diagnostics",xe);const Xe=new D.ExtensionTipsChannel(ye.get(m.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Xe);const je=E.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",je);const st=E.ProxyChannel.fromService(ye.get(vt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",st);const Ze=new de.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const ct=E.ProxyChannel.fromService(ye.get(se.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ct);const Be=new de.UserDataSyncAccountServiceChannel(ye.get(oe.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",Be);const Ye=new de.UserDataSyncStoreManagementServiceChannel(ye.get(We.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ye);const lt=new $e.UserDataSyncChannel(ye.get(We.IUserDataSyncService),ye.get(z.ILogService));this.server.registerChannel("userDataSync",lt);const ut=this._register(ye.get($.IInstantiationService).createInstance(Te.UserDataAutoSyncService)),et=new de.UserDataAutoSyncChannel(ut);this.server.registerChannel("userDataAutoSync",et);const Ve=ye.get(Pe.ILocalPtyService),nt=E.ProxyChannel.fromService(Ve);this.server.registerChannel(be.TerminalIpcChannels.LocalPty,nt);const ot=E.ProxyChannel.fromService(ye.get(me.ISharedProcessTunnelService));this.server.registerChannel(me.ipcSharedProcessTunnelChannelName,ot);const ht=E.ProxyChannel.fromService(ye.get(De.ISharedProcessWorkerService));this.server.registerChannel(De.ipcSharedProcessWorkerChannelName,ht),this.server.registerChannel("IDefaultExtensionsProfileInitService",E.ProxyChannel.fromService(ye.get(m.IDefaultExtensionsProfileInitService)))}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,T.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,T.setUnexpectedErrorHandler)(Oe=>{const qe=(0,k.toErrorMessage)(Oe,!0);!qe||ye.error(`[uncaught exception in sharedProcess]: ${qe}`)})}}async function Ot(yt){const ye=new _t(yt);R.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),R.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ot})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8179d832082f44ee45c4f9e01e229d22c008a2a6/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
