/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var X=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/network","vs/base/common/types","electron","vs/platform/files/common/files","vs/base/common/resources","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/platform/product/common/productService","vs/base/common/cancellation","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/platform/workspace/common/workspace","vs/base/common/arrays","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","fs","os","vs/base/common/extpath","vs/base/common/strings","vs/platform/windows/electron-main/windows","vs/base/common/map","vs/base/common/labels","vs/platform/telemetry/common/telemetry","vs/base/common/process","vs/platform/policy/common/policy","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/errorMessage","child_process","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/platform/update/common/update","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/functional","vs/base/common/json","vs/base/common/objects","vs/base/common/decorators","vs/platform/product/common/product","vs/platform/request/common/request","vs/platform/dialogs/electron-main/dialogMainService","vs/base/common/iterator","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/platform/protocol/electron-main/protocol","vs/platform/configuration/common/configurationRegistry","vs/platform/theme/electron-main/themeMainService","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/hash","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/workspaces/electron-main/workspacesHistoryMainService","crypto","net","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/normalization","vs/base/node/id","vs/base/parts/ipc/node/ipc.net","vs/base/node/processes","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/common/workspaces","vs/base/node/ports","vs/base/common/observableValue","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/shell/node/shellEnv","vs/platform/telemetry/common/commonProperties","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/storage/common/storage","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/codicons","vs/base/common/color","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/crypto","vs/base/node/decoder","string_decoder","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/encryption/node/encryptionMainService","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/credentials/common/credentialsMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/state/electron-main/stateMainService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/tunnel/node/tunnelService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/backup/electron-main/backupMainService","vs/platform/storage/electron-main/storageIpc","vs/platform/protocol/electron-main/protocolMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/node/userDataProfile","vs/platform/extensionManagement/electron-main/defaultExtensionsProfileInit","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","vs/platform/policy/node/nativePolicyService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","minimist","assert","path","graceful-fs","vscode-policy-watcher","zlib","vs/code/electron-main/main"],J=function(B){for(var e=[],E=0,t=B.length;E<t;E++)e[E]=X[B[E]];return e};define(X[116],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(t,D){if(!t)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=E}),define(X[117],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function E(M){return M?M.replace(/\$\((.*?)\)/g,(b,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=E;class t{constructor(b,d,w){this.id=b,this.definition=d,this.description=w,t._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return t._allCodicons}}e.Codicon=t,t._allCodicons=[],t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",t.add.definition),t.gistNew=new t("gist-new",t.add.definition),t.repoCreate=new t("repo-create",t.add.definition),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolCustomColor=new t("symbol-customcolor",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.circleSmallFilled=new t("circle-small-filled",{fontCharacter:"\\eb8a"}),t.debugStackframeDot=new t("debug-stackframe-dot",t.circleSmallFilled.definition),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.runErrors=new t("run-errors",{fontCharacter:"\\ebde"}),t.folderLibrary=new t("folder-library",{fontCharacter:"\\ebdf"}),t.debugContinueSmall=new t("debug-continue-small",{fontCharacter:"\\ebe0"}),t.beakerStop=new t("beaker-stop",{fontCharacter:"\\ebe1"}),t.graphLine=new t("graph-line",{fontCharacter:"\\ebe2"}),t.graphScatter=new t("graph-scatter",{fontCharacter:"\\ebe3"}),t.pieChart=new t("pie-chart",{fontCharacter:"\\ebe4"}),t.bracket=new t("bracket",t.json.definition),t.bracketDot=new t("bracket-dot",{fontCharacter:"\\ebe5"}),t.bracketError=new t("bracket-error",{fontCharacter:"\\ebe6"}),t.lockSmall=new t("lock-small",{fontCharacter:"\\ebe7"}),t.azureDevops=new t("azure-devops",{fontCharacter:"\\ebe8"}),t.verifiedFilled=new t("verified-filled",{fontCharacter:"\\ebe9"}),t.newLine=new t("newline",{fontCharacter:"\\ebea"}),t.layout=new t("layout",{fontCharacter:"\\ebeb"}),t.layoutActivitybarLeft=new t("layout-activitybar-left",{fontCharacter:"\\ebec"}),t.layoutActivitybarRight=new t("layout-activitybar-right",{fontCharacter:"\\ebed"}),t.layoutPanelLeft=new t("layout-panel-left",{fontCharacter:"\\ebee"}),t.layoutPanelCenter=new t("layout-panel-center",{fontCharacter:"\\ebef"}),t.layoutPanelJustify=new t("layout-panel-justify",{fontCharacter:"\\ebf0"}),t.layoutPanelRight=new t("layout-panel-right",{fontCharacter:"\\ebf1"}),t.layoutPanel=new t("layout-panel",{fontCharacter:"\\ebf2"}),t.layoutSidebarLeft=new t("layout-sidebar-left",{fontCharacter:"\\ebf3"}),t.layoutSidebarRight=new t("layout-sidebar-right",{fontCharacter:"\\ebf4"}),t.layoutStatusbar=new t("layout-statusbar",{fontCharacter:"\\ebf5"}),t.layoutMenubar=new t("layout-menubar",{fontCharacter:"\\ebf6"}),t.layoutCentered=new t("layout-centered",{fontCharacter:"\\ebf7"}),t.layoutSidebarRightOff=new t("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),t.layoutPanelOff=new t("layout-panel-off",{fontCharacter:"\\ec01"}),t.layoutSidebarLeftOff=new t("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),t.target=new t("target",{fontCharacter:"\\ebf8"}),t.indent=new t("indent",{fontCharacter:"\\ebf9"}),t.recordSmall=new t("record-small",{fontCharacter:"\\ebfa"}),t.errorSmall=new t("error-small",{fontCharacter:"\\ebfb"}),t.arrowCircleDown=new t("arrow-circle-down",{fontCharacter:"\\ebfc"}),t.arrowCircleLeft=new t("arrow-circle-left",{fontCharacter:"\\ebfd"}),t.arrowCircleRight=new t("arrow-circle-right",{fontCharacter:"\\ebfe"}),t.arrowCircleUp=new t("arrow-circle-up",{fontCharacter:"\\ebff"}),t.heartFilled=new t("heart-filled",{fontCharacter:"\\ec04"}),t.map=new t("map",{fontCharacter:"\\ec05"}),t.mapFilled=new t("map-filled",{fontCharacter:"\\ec06"}),t.circleSmall=new t("circle-small",{fontCharacter:"\\ec07"}),t.bellSlash=new t("bell-slash",{fontCharacter:"\\ec08"}),t.bellSlashDot=new t("bell-slash-dot",{fontCharacter:"\\ec09"}),t.commentUnresolved=new t("comment-unresolved",{fontCharacter:"\\ec0a"}),t.gitPullRequestGoToChanges=new t("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),t.gitPullRequestNewChanges=new t("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),t.dialogError=new t("dialog-error",t.error.definition),t.dialogWarning=new t("dialog-warning",t.warning.definition),t.dialogInfo=new t("dialog-info",t.info.definition),t.dialogClose=new t("dialog-close",t.close.definition),t.treeItemExpanded=new t("tree-item-expanded",t.chevronDown.definition),t.treeFilterOnTypeOn=new t("tree-filter-on-type-on",t.listFilter.definition),t.treeFilterOnTypeOff=new t("tree-filter-on-type-off",t.listSelection.definition),t.treeFilterClear=new t("tree-filter-clear",t.close.definition),t.treeItemLoading=new t("tree-item-loading",t.loading.definition),t.menuSelection=new t("menu-selection",t.check.definition),t.menuSubmenu=new t("menu-submenu",t.chevronRight.definition),t.menuBarMore=new t("menubar-more",t.more.definition),t.scrollbarButtonLeft=new t("scrollbar-button-left",t.triangleLeft.definition),t.scrollbarButtonRight=new t("scrollbar-button-right",t.triangleRight.definition),t.scrollbarButtonUp=new t("scrollbar-button-up",t.triangleUp.definition),t.scrollbarButtonDown=new t("scrollbar-button-down",t.triangleDown.definition),t.toolBarMore=new t("toolbar-more",t.more.definition),t.quickInputBack=new t("quick-input-back",t.arrowLeft.definition);function D(M,b){const d=["codicon","codicon-"+M];return b&&d.push("codicon-modifier-"+b),d}e.getClassNamesArray=D;var R;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function d(P){if(P instanceof t)return["codicon","codicon-"+P.id];const S=b.exec(P.id);if(!S)return d(t.error);const[,f,u]=S,p=["codicon","codicon-"+f];return u&&p.push("codicon-modifier-"+u.substr(1)),p}M.asClassNameArray=d;function w(P){return d(P).join(" ")}M.asClassName=w;function C(P){return"."+d(P).join(".")}M.asCSSSelector=C})(R=e.CSSIcon||(e.CSSIcon={}))}),define(X[118],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(b,d){const w=Math.pow(10,d);return Math.round(b*w)/w}class t{constructor(d,w,C,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,w))|0,this.b=Math.min(255,Math.max(0,C))|0,this.a=E(Math.max(Math.min(1,P),0),3)}static equals(d,w){return d.r===w.r&&d.g===w.g&&d.b===w.b&&d.a===w.a}}e.RGBA=t;class D{constructor(d,w,C,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,w),0),3),this.l=E(Math.max(Math.min(1,C),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(d,w){return d.h===w.h&&d.s===w.s&&d.l===w.l&&d.a===w.a}static fromRGBA(d){const w=d.r/255,C=d.g/255,P=d.b/255,S=d.a,f=Math.max(w,C,P),u=Math.min(w,C,P);let p=0,m=0;const y=(u+f)/2,I=f-u;if(I>0){switch(m=Math.min(y<=.5?I/(2*y):I/(2-2*y),1),f){case w:p=(C-P)/I+(C<P?6:0);break;case C:p=(P-w)/I+2;break;case P:p=(w-C)/I+4;break}p*=60,p=Math.round(p)}return new D(p,m,y,S)}static _hue2rgb(d,w,C){return C<0&&(C+=1),C>1&&(C-=1),C<1/6?d+(w-d)*6*C:C<1/2?w:C<2/3?d+(w-d)*(2/3-C)*6:d}static toRGBA(d){const w=d.h/360,{s:C,l:P,a:S}=d;let f,u,p;if(C===0)f=u=p=P;else{const m=P<.5?P*(1+C):P+C-P*C,y=2*P-m;f=D._hue2rgb(y,m,w+1/3),u=D._hue2rgb(y,m,w),p=D._hue2rgb(y,m,w-1/3)}return new t(Math.round(f*255),Math.round(u*255),Math.round(p*255),S)}}e.HSLA=D;class R{constructor(d,w,C,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=E(Math.max(Math.min(1,w),0),3),this.v=E(Math.max(Math.min(1,C),0),3),this.a=E(Math.max(Math.min(1,P),0),3)}static equals(d,w){return d.h===w.h&&d.s===w.s&&d.v===w.v&&d.a===w.a}static fromRGBA(d){const w=d.r/255,C=d.g/255,P=d.b/255,S=Math.max(w,C,P),f=Math.min(w,C,P),u=S-f,p=S===0?0:u/S;let m;return u===0?m=0:S===w?m=((C-P)/u%6+6)%6:S===C?m=(P-w)/u+2:m=(w-C)/u+4,new R(Math.round(m*60),p,S,d.a)}static toRGBA(d){const{h:w,s:C,v:P,a:S}=d,f=P*C,u=f*(1-Math.abs(w/60%2-1)),p=P-f;let[m,y,I]=[0,0,0];return w<60?(m=f,y=u):w<120?(m=u,y=f):w<180?(y=f,I=u):w<240?(y=u,I=f):w<300?(m=u,I=f):w<=360&&(m=f,I=u),m=Math.round((m+p)*255),y=Math.round((y+p)*255),I=Math.round((I+p)*255),new t(m,y,I,S)}}e.HSVA=R;class M{constructor(d){if(d)if(d instanceof t)this.rgba=d;else if(d instanceof D)this._hsla=d,this.rgba=D.toRGBA(d);else if(d instanceof R)this._hsva=d,this.rgba=R.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(d){return M.Format.CSS.parseHex(d)||M.red}get hsla(){return this._hsla?this._hsla:D.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:R.fromRGBA(this.rgba)}equals(d){return!!d&&t.equals(this.rgba,d.rgba)&&D.equals(this.hsla,d.hsla)&&R.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=M._relativeLuminanceForComponent(this.rgba.r),w=M._relativeLuminanceForComponent(this.rgba.g),C=M._relativeLuminanceForComponent(this.rgba.b),P=.2126*d+.7152*w+.0722*C;return E(P,4)}static _relativeLuminanceForComponent(d){const w=d/255;return w<=.03928?w/12.92:Math.pow((w+.055)/1.055,2.4)}getContrastRatio(d){const w=this.getRelativeLuminance(),C=d.getRelativeLuminance();return w>C?(w+.05)/(C+.05):(C+.05)/(w+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const w=this.getRelativeLuminance(),C=d.getRelativeLuminance();return w>C}isDarkerThan(d){const w=this.getRelativeLuminance(),C=d.getRelativeLuminance();return w<C}lighten(d){return new M(new D(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new M(new D(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:w,g:C,b:P,a:S}=this.rgba;return new M(new t(w,C,P,S*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new M(new t(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const w=d.rgba,C=this.rgba.a,P=w.a,S=C+P*(1-C);if(S<1e-6)return M.transparent;const f=this.rgba.r*C/S+w.r*P*(1-C)/S,u=this.rgba.g*C/S+w.g*P*(1-C)/S,p=this.rgba.b*C/S+w.b*P*(1-C)/S;return new M(new t(f,u,p,S))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:w,g:C,b:P,a:S}=this.rgba;return new M(new t(d.rgba.r-S*(d.rgba.r-w),d.rgba.g-S*(d.rgba.g-C),d.rgba.b-S*(d.rgba.b-P),1))}flatten(...d){const w=d.reduceRight((C,P)=>M._flatten(P,C));return M._flatten(this,w)}static _flatten(d,w){const C=1-d.rgba.a;return new M(new t(C*w.rgba.r+d.rgba.a*d.rgba.r,C*w.rgba.g+d.rgba.a*d.rgba.g,C*w.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this._toString||(this._toString=M.Format.CSS.format(this)),this._toString}static getLighterColor(d,w,C){if(d.isLighterThan(w))return d;C=C||.5;const P=d.getRelativeLuminance(),S=w.getRelativeLuminance();return C=C*(S-P)/S,d.lighten(C)}static getDarkerColor(d,w,C){if(d.isDarkerThan(w))return d;C=C||.5;const P=d.getRelativeLuminance(),S=w.getRelativeLuminance();return C=C*(P-S)/P,d.darken(C)}}e.Color=M,M.white=new M(new t(255,255,255,1)),M.black=new M(new t(0,0,0,1)),M.red=new M(new t(255,0,0,1)),M.blue=new M(new t(0,0,255,1)),M.green=new M(new t(0,255,0,1)),M.cyan=new M(new t(0,255,255,1)),M.lightgrey=new M(new t(211,211,211,1)),M.transparent=new M(new t(0,0,0,0)),function(b){let d;(function(w){let C;(function(P){function S(s){return s.rgba.a===1?`rgb(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b})`:b.Format.CSS.formatRGBA(s)}P.formatRGB=S;function f(s){return`rgba(${s.rgba.r}, ${s.rgba.g}, ${s.rgba.b}, ${+s.rgba.a.toFixed(2)})`}P.formatRGBA=f;function u(s){return s.hsla.a===1?`hsl(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(s)}P.formatHSL=u;function p(s){return`hsla(${s.hsla.h}, ${(s.hsla.s*100).toFixed(2)}%, ${(s.hsla.l*100).toFixed(2)}%, ${s.hsla.a.toFixed(2)})`}P.formatHSLA=p;function m(s){const r=s.toString(16);return r.length!==2?"0"+r:r}function y(s){return`#${m(s.rgba.r)}${m(s.rgba.g)}${m(s.rgba.b)}`}P.formatHex=y;function I(s,r=!1){return r&&s.rgba.a===1?b.Format.CSS.formatHex(s):`#${m(s.rgba.r)}${m(s.rgba.g)}${m(s.rgba.b)}${m(Math.round(s.rgba.a*255))}`}P.formatHexA=I;function g(s){return s.isOpaque()?b.Format.CSS.formatHex(s):b.Format.CSS.formatRGBA(s)}P.format=g;function h(s){const r=s.length;if(r===0||s.charCodeAt(0)!==35)return null;if(r===7){const n=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),i=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),o=16*l(s.charCodeAt(5))+l(s.charCodeAt(6));return new b(new t(n,i,o,1))}if(r===9){const n=16*l(s.charCodeAt(1))+l(s.charCodeAt(2)),i=16*l(s.charCodeAt(3))+l(s.charCodeAt(4)),o=16*l(s.charCodeAt(5))+l(s.charCodeAt(6)),a=16*l(s.charCodeAt(7))+l(s.charCodeAt(8));return new b(new t(n,i,o,a/255))}if(r===4){const n=l(s.charCodeAt(1)),i=l(s.charCodeAt(2)),o=l(s.charCodeAt(3));return new b(new t(16*n+n,16*i+i,16*o+o))}if(r===5){const n=l(s.charCodeAt(1)),i=l(s.charCodeAt(2)),o=l(s.charCodeAt(3)),a=l(s.charCodeAt(4));return new b(new t(16*n+n,16*i+i,16*o+o,(16*a+a)/255))}return null}P.parseHex=h;function l(s){switch(s){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(C=w.CSS||(w.CSS={}))})(d=b.Format||(b.Format={}))}(M=e.Color||(e.Color={}))}),define(X[51],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function E(M){return(b,d,w)=>{let C=null,P=null;if(typeof w.value=="function"?(C="value",P=w.value):typeof w.get=="function"&&(C="get",P=w.get),!P)throw new Error("not supported");w[C]=M(P,d)}}e.createDecorator=E;function t(M,b,d){let w=null,C=null;if(typeof d.value=="function"?(w="value",C=d.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(w="get",C=d.get),!C)throw new Error("not supported");const P=`$memoize$${b}`;d[w]=function(...S){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,S)}),this[P]}}e.memoize=t;function D(M,b,d){return E((w,C)=>{const P=`$debounce$${C}`,S=`$debounce$result$${C}`;return function(...f){this[S]||(this[S]=d?d():void 0),clearTimeout(this[P]),b&&(this[S]=b(this[S],...f),f=[this[S]]),this[P]=setTimeout(()=>{w.apply(this,f),this[S]=d?d():void 0},M)}})}e.debounce=D;function R(M,b,d){return E((w,C)=>{const P=`$throttle$timer$${C}`,S=`$throttle$result$${C}`,f=`$throttle$lastRun$${C}`,u=`$throttle$pending$${C}`;return function(...p){if(this[S]||(this[S]=d?d():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),b&&(this[S]=b(this[S],...p)),this[u])return;const m=this[f]+M;m<=Date.now()?(this[f]=Date.now(),w.apply(this,[this[S]]),this[S]=d?d():void 0):(this[u]=!0,this[P]=setTimeout(()=>{this[u]=!1,this[f]=Date.now(),w.apply(this,[this[S]]),this[S]=d?d():void 0},m-Date.now()))}})}e.throttle=R}),define(X[19],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?g.isErrorNoTelemetry(s)?new g(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=E,e.errorHandler=new E;function t(l){e.errorHandler.setUnexpectedErrorHandler(l)}e.setUnexpectedErrorHandler=t;function D(l){d(l)||e.errorHandler.onUnexpectedError(l)}e.onUnexpectedError=D;function R(l){d(l)||e.errorHandler.onUnexpectedExternalError(l)}e.onUnexpectedExternalError=R;function M(l){if(l instanceof Error){const{name:s,message:r}=l,n=l.stacktrace||l.stack;return{$isError:!0,name:s,message:r,stack:n,noTelemetry:g.isErrorNoTelemetry(l)}}return l}e.transformErrorForSerialization=M;const b="Canceled";function d(l){return l instanceof w?!0:l instanceof Error&&l.name===b&&l.message===b}e.isCancellationError=d;class w extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=w;function C(){const l=new Error(b);return l.name=l.message,l}e.canceled=C;function P(l){return l?new Error(`Illegal argument: ${l}`):new Error("Illegal argument")}e.illegalArgument=P;function S(l){return l?new Error(`Illegal state: ${l}`):new Error("Illegal state")}e.illegalState=S;function f(l){return l?new Error(`readonly property '${l} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=f;function u(l){const s=new Error(`${l} has been disposed`);return s.name="DISPOSED",s}e.disposed=u;function p(l){return l?l.message?l.message:l.stack?l.stack.split(`
`)[0]:String(l):"Error"}e.getErrorMessage=p;class m extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=m;class y extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=y;class I extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=I;class g extends Error{constructor(s){super(s);this.name="ErrorNoTelemetry"}static fromError(s){if(s instanceof g)return s;const r=new g;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=g;class h extends Error{constructor(s){super(s||"An unexpected bug occurred.");Object.setPrototypeOf(this,h.prototype);debugger}}e.BugIndicatingError=h}),define(X[25],J([0,1,19]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function t(_,K=0){return _[_.length-(1+K)]}e.tail=t;function D(_){if(_.length===0)throw new Error("Invalid tail call");return[_.slice(0,_.length-1),_[_.length-1]]}e.tail2=D;function R(_,K,Z=(ne,le)=>ne===le){if(_===K)return!0;if(!_||!K||_.length!==K.length)return!1;for(let ne=0,le=_.length;ne<le;ne++)if(!Z(_[ne],K[ne]))return!1;return!0}e.equals=R;function M(_,K){const Z=_.length-1;K<Z&&(_[K]=_[Z]),_.pop()}e.removeFastWithoutKeepingOrder=M;function b(_,K,Z){return d(_.length,ne=>Z(_[ne],K))}e.binarySearch=b;function d(_,K){let Z=0,ne=_-1;for(;Z<=ne;){const le=(Z+ne)/2|0,ge=K(le);if(ge<0)Z=le+1;else if(ge>0)ne=le-1;else return le}return-(Z+1)}e.binarySearch2=d;function w(_,K){let Z=0,ne=_.length;if(ne===0)return 0;for(;Z<ne;){const le=Math.floor((Z+ne)/2);K(_[le])?ne=le:Z=le+1}return Z}e.findFirstInSorted=w;function C(_,K,Z){if(_=_|0,_>=K.length)throw new TypeError("invalid index");const ne=K[Math.floor(K.length*Math.random())],le=[],ge=[],Ee=[];for(const Re of K){const Pe=Z(Re,ne);Pe<0?le.push(Re):Pe>0?ge.push(Re):Ee.push(Re)}return _<le.length?C(_,le,Z):_<le.length+Ee.length?Ee[0]:C(_-(le.length+Ee.length),ge,Z)}e.quickSelect=C;function P(_,K){const Z=[];let ne;for(const le of _.slice(0).sort(K))!ne||K(ne[0],le)!==0?(ne=[le],Z.push(ne)):ne.push(le);return Z}e.groupBy=P;function S(_,K,Z){const ne=[];function le(Re,Pe,ke){if(Pe===0&&ke.length===0)return;const Ne=ne[ne.length-1];Ne&&Ne.start+Ne.deleteCount===Re?(Ne.deleteCount+=Pe,Ne.toInsert.push(...ke)):ne.push({start:Re,deleteCount:Pe,toInsert:ke})}let ge=0,Ee=0;for(;;){if(ge===_.length){le(ge,0,K.slice(Ee));break}if(Ee===K.length){le(ge,_.length-ge,[]);break}const Re=_[ge],Pe=K[Ee],ke=Z(Re,Pe);ke===0?(ge+=1,Ee+=1):ke<0?(le(ge,1,[]),ge+=1):ke>0&&(le(ge,0,[Pe]),Ee+=1)}return ne}e.sortedDiff=S;function f(_,K,Z){const ne=S(_,K,Z),le=[],ge=[];for(const Ee of ne)le.push(..._.slice(Ee.start,Ee.start+Ee.deleteCount)),ge.push(...Ee.toInsert);return{removed:le,added:ge}}e.delta=f;function u(_,K,Z){if(Z===0)return[];const ne=_.slice(0,Z).sort(K);return m(_,K,ne,Z,_.length),ne}e.top=u;function p(_,K,Z,ne,le){return Z===0?Promise.resolve([]):new Promise((ge,Ee)=>{(async()=>{const Re=_.length,Pe=_.slice(0,Z).sort(K);for(let ke=Z,Ne=Math.min(Z+ne,Re);ke<Re;ke=Ne,Ne=Math.min(Ne+ne,Re)){if(ke>Z&&await new Promise(ue=>setTimeout(ue)),le&&le.isCancellationRequested)throw new E.CancellationError;m(_,K,Pe,ke,Ne)}return Pe})().then(ge,Ee)})}e.topAsync=p;function m(_,K,Z,ne,le){for(const ge=Z.length;ne<le;ne++){const Ee=_[ne];if(K(Ee,Z[ge-1])<0){Z.pop();const Re=w(Z,Pe=>K(Ee,Pe)<0);Z.splice(Re,0,Ee)}}}function y(_){return _.filter(K=>!!K)}e.coalesce=y;function I(_){let K=0;for(let Z=0;Z<_.length;Z++)_[Z]&&(_[K]=_[Z],K+=1);_.length=K}e.coalesceInPlace=I;function g(_,K,Z){_.splice(Z,0,_.splice(K,1)[0])}e.move=g;function h(_){return!Array.isArray(_)||_.length===0}e.isFalsyOrEmpty=h;function l(_){return Array.isArray(_)&&_.length>0}e.isNonEmptyArray=l;function s(_,K=Z=>Z){const Z=new Set;return _.filter(ne=>{const le=K(ne);return Z.has(le)?!1:(Z.add(le),!0)})}e.distinct=s;function r(_){const K=new Set;return Z=>{const ne=_(Z);return K.has(ne)?!1:(K.add(ne),!0)}}e.uniqueFilter=r;function n(_,K){const Z=i(_,K);if(Z!==-1)return _[Z]}e.findLast=n;function i(_,K){for(let Z=_.length-1;Z>=0;Z--){const ne=_[Z];if(K(ne))return Z}return-1}e.lastIndex=i;function o(_,K){return _.length>0?_[0]:K}e.firstOrDefault=o;function a(_,K){return _.length>0?_[_.length-1]:K}e.lastOrDefault=a;function c(_,K,Z=(ne,le)=>ne===le){let ne=0;for(let le=0,ge=Math.min(_.length,K.length);le<ge&&Z(_[le],K[le]);le++)ne++;return ne}e.commonPrefixLength=c;function v(_){return[].concat(..._)}e.flatten=v;function k(_,K){let Z=typeof K=="number"?_:0;typeof K=="number"?Z=_:(Z=0,K=_);const ne=[];if(Z<=K)for(let le=Z;le<K;le++)ne.push(le);else for(let le=Z;le>K;le--)ne.push(le);return ne}e.range=k;function L(_,K,Z){return _.reduce((ne,le)=>(ne[K(le)]=Z?Z(le):le,ne),Object.create(null))}e.index=L;function O(_,K){return _.push(K),()=>F(_,K)}e.insert=O;function F(_,K){const Z=_.indexOf(K);if(Z>-1)return _.splice(Z,1),K}e.remove=F;function j(_,K,Z){const ne=_.slice(0,K),le=_.slice(K);return ne.concat(Z,le)}e.arrayInsert=j;function ee(_,K){let Z;if(typeof K=="number"){let ne=K;Z=()=>{const le=Math.sin(ne++)*179426549;return le-Math.floor(le)}}else Z=Math.random;for(let ne=_.length-1;ne>0;ne-=1){const le=Math.floor(Z()*(ne+1)),ge=_[ne];_[ne]=_[le],_[le]=ge}}e.shuffle=ee;function se(_,K){const Z=_.indexOf(K);Z>-1&&(_.splice(Z,1),_.unshift(K))}e.pushToStart=se;function ae(_,K){const Z=_.indexOf(K);Z>-1&&(_.splice(Z,1),_.push(K))}e.pushToEnd=ae;function ie(_,K){for(const Z of K)_.push(Z)}e.pushMany=ie;function ce(_,K){return Array.isArray(_)?_.map(K):K(_)}e.mapArrayOrNot=ce;function H(_){return Array.isArray(_)?_:[_]}e.asArray=H;function re(_){return _[Math.floor(Math.random()*_.length)]}e.getRandomElement=re;function q(_,K){for(const Z of _){const ne=K(Z);if(ne!==void 0)return ne}}e.mapFind=q;function T(_,K,Z){const ne=V(_,K),le=_.length,ge=Z.length;_.length=le+ge;for(let Ee=le-1;Ee>=ne;Ee--)_[Ee+ge]=_[Ee];for(let Ee=0;Ee<ge;Ee++)_[Ee+ne]=Z[Ee]}e.insertInto=T;function N(_,K,Z,ne){const le=V(_,K),ge=_.splice(le,Z);return T(_,le,ne),ge}e.splice=N;function V(_,K){return K<0?Math.max(K+_.length,0):Math.min(K,_.length)}var te;(function(_){function K(le){return le<0}_.isLessThan=K;function Z(le){return le>0}_.isGreaterThan=Z;function ne(le){return le===0}_.isNeitherLessOrGreaterThan=ne,_.greaterThan=1,_.lessThan=-1,_.neitherLessOrGreaterThan=0})(te=e.CompareResult||(e.CompareResult={}));function $(_,K){return(Z,ne)=>K(_(Z),_(ne))}e.compareBy=$;function Q(..._){return(K,Z)=>{for(const ne of _){const le=ne(K,Z);if(!te.isNeitherLessOrGreaterThan(le))return le}return te.neitherLessOrGreaterThan}}e.tieBreakComparators=Q;const A=(_,K)=>_-K;e.numberComparator=A;function W(_,K){if(_.length===0)return;let Z=_[0];for(let ne=1;ne<_.length;ne++){const le=_[ne];K(le,Z)>0&&(Z=le)}return Z}e.findMaxBy=W;function U(_,K){if(_.length===0)return;let Z=_[0];for(let ne=1;ne<_.length;ne++){const le=_[ne];K(le,Z)>=0&&(Z=le)}return Z}e.findLastMaxBy=U;function z(_,K){return W(_,(Z,ne)=>-K(Z,ne))}e.findMinBy=z;class Y{constructor(K){this.items=K,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(K){let Z=this.firstIdx;for(;Z<this.items.length&&K(this.items[Z]);)Z++;const ne=Z===this.firstIdx?null:this.items.slice(this.firstIdx,Z);return this.firstIdx=Z,ne}takeFromEndWhile(K){let Z=this.lastIdx;for(;Z>=0&&K(this.items[Z]);)Z--;const ne=Z===this.lastIdx?null:this.items.slice(Z+1,this.lastIdx+1);return this.lastIdx=Z,ne}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const K=this.items[this.firstIdx];return this.firstIdx++,K}removeLast(){const K=this.items[this.lastIdx];return this.lastIdx--,K}takeCount(K){const Z=this.items.slice(this.firstIdx,this.firstIdx+K);return this.firstIdx+=K,Z}}e.ArrayQueue=Y}),define(X[48],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(t){const D=this;let R=!1,M;return function(){return R||(R=!0,M=t.apply(D,arguments)),M}}e.once=E}),define(X[55],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(t){function D(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}t.is=D;const R=Object.freeze([]);function M(){return R}t.empty=M;function*b(r){yield r}t.single=b;function d(r){return r||R}t.from=d;function w(r){return!r||r[Symbol.iterator]().next().done===!0}t.isEmpty=w;function C(r){return r[Symbol.iterator]().next().value}t.first=C;function P(r,n){for(const i of r)if(n(i))return!0;return!1}t.some=P;function S(r,n){for(const i of r)if(n(i))return i}t.find=S;function*f(r,n){for(const i of r)n(i)&&(yield i)}t.filter=f;function*u(r,n){let i=0;for(const o of r)yield n(o,i++)}t.map=u;function*p(...r){for(const n of r)for(const i of n)yield i}t.concat=p;function*m(r){for(const n of r)for(const i of n)yield i}t.concatNested=m;function y(r,n,i){let o=i;for(const a of r)o=n(o,a);return o}t.reduce=y;function I(r,n){let i=0;for(const o of r)n(o,i++)}t.forEach=I;function*g(r,n,i=r.length){for(n<0&&(n+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);n<i;n++)yield r[n]}t.slice=g;function h(r,n=Number.POSITIVE_INFINITY){const i=[];if(n===0)return[i,r];const o=r[Symbol.iterator]();for(let a=0;a<n;a++){const c=o.next();if(c.done)return[i,t.empty()];i.push(c.value)}return[i,{[Symbol.iterator](){return o}}]}t.consume=h;function l(r){return h(r)[0]}t.collect=l;function s(r,n,i=(o,a)=>o===a){const o=r[Symbol.iterator](),a=n[Symbol.iterator]();for(;;){const c=o.next(),v=a.next();if(c.done!==v.done)return!1;if(c.done)return!0;if(!i(c.value,v.value))return!1}}t.equals=s})(E=e.Iterable||(e.Iterable={}))}),define(X[49],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var t;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(t=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(s){s.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function M(s,r=!1){let n=0;const i=s.length;let o="",a=0,c=16,v=0;function k(ae){let ie=0,ce=0;for(;ie<ae;){const H=s.charCodeAt(n);if(H>=48&&H<=57)ce=ce*16+H-48;else if(H>=65&&H<=70)ce=ce*16+H-65+10;else if(H>=97&&H<=102)ce=ce*16+H-97+10;else break;n++,ie++}return ie<ae&&(ce=-1),ce}function L(ae){n=ae,o="",a=0,c=16,v=0}function O(){const ae=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&w(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&w(s.charCodeAt(n)))for(n++;n<s.length&&w(s.charCodeAt(n));)n++;else return v=3,s.substring(ae,n);let ie=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&w(s.charCodeAt(n))){for(n++;n<s.length&&w(s.charCodeAt(n));)n++;ie=n}else v=3;return s.substring(ae,ie)}function F(){let ae="",ie=n;for(;;){if(n>=i){ae+=s.substring(ie,n),v=2;break}const ce=s.charCodeAt(n);if(ce===34){ae+=s.substring(ie,n),n++;break}if(ce===92){if(ae+=s.substring(ie,n),n++,n>=i){v=2;break}switch(s.charCodeAt(n++)){case 34:ae+='"';break;case 92:ae+="\\";break;case 47:ae+="/";break;case 98:ae+="\b";break;case 102:ae+="\f";break;case 110:ae+=`
`;break;case 114:ae+="\r";break;case 116:ae+="	";break;case 117:{const re=k(4);re>=0?ae+=String.fromCharCode(re):v=4;break}default:v=5}ie=n;continue}if(ce>=0&&ce<=31)if(d(ce)){ae+=s.substring(ie,n),v=2;break}else v=6;n++}return ae}function j(){if(o="",v=0,a=n,n>=i)return a=i,c=17;let ae=s.charCodeAt(n);if(b(ae)){do n++,o+=String.fromCharCode(ae),ae=s.charCodeAt(n);while(b(ae));return c=15}if(d(ae))return n++,o+=String.fromCharCode(ae),ae===13&&s.charCodeAt(n)===10&&(n++,o+=`
`),c=14;switch(ae){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,o=F(),c=10;case 47:{const ie=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!d(s.charCodeAt(n));)n++;return o=s.substring(ie,n),c=12}if(s.charCodeAt(n+1)===42){n+=2;const ce=i-1;let H=!1;for(;n<ce;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,H=!0;break}n++}return H||(n++,v=1),o=s.substring(ie,n),c=13}return o+=String.fromCharCode(ae),n++,c=16}case 45:if(o+=String.fromCharCode(ae),n++,n===i||!w(s.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),c=11;default:for(;n<i&&ee(ae);)n++,ae=s.charCodeAt(n);if(a!==n){switch(o=s.substring(a,n),o){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return o+=String.fromCharCode(ae),n++,c=16}}function ee(ae){if(b(ae)||d(ae))return!1;switch(ae){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function se(){let ae;do ae=j();while(ae>=12&&ae<=15);return ae}return{setPosition:L,getPosition:()=>n,scan:r?se:j,getToken:()=>c,getTokenValue:()=>o,getTokenOffset:()=>a,getTokenLength:()=>n-a,getTokenError:()=>v}}e.createScanner=M;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function d(s){return s===10||s===13||s===8232||s===8233}function w(s){return s>=48&&s<=57}var C;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(C||(C={}));function P(s,r){const n=[],i=new Object;let o;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function v(k,L,O,F){a.value=k,a.offset=L,a.length=O,a.type=F,a.colonOffset=void 0,o=a}try{g(s,{onObjectBegin:(k,L)=>{if(r<=k)throw i;o=void 0,c=r>k,n.push("")},onObjectProperty:(k,L,O)=>{if(r<L||(v(k,L,O,"property"),n[n.length-1]=k,r<=L+O))throw i},onObjectEnd:(k,L)=>{if(r<=k)throw i;o=void 0,n.pop()},onArrayBegin:(k,L)=>{if(r<=k)throw i;o=void 0,n.push(0)},onArrayEnd:(k,L)=>{if(r<=k)throw i;o=void 0,n.pop()},onLiteralValue:(k,L,O)=>{if(r<L||(v(k,L,O,l(k)),r<=L+O))throw i},onSeparator:(k,L,O)=>{if(r<=L)throw i;if(k===":"&&o&&o.type==="property")o.colonOffset=L,c=!1,o=void 0;else if(k===","){const F=n[n.length-1];typeof F=="number"?n[n.length-1]=F+1:(c=!0,n[n.length-1]=""),o=void 0}}})}catch(k){if(k!==i)throw k}return{path:n,previousNode:o,isAtPropertyKey:c,matches:k=>{let L=0;for(let O=0;L<k.length&&O<n.length;O++)if(k[L]===n[O]||k[L]==="*")L++;else if(k[L]!=="**")return!1;return L===k.length}}}e.getLocation=P;function S(s,r=[],n=R.DEFAULT){let i=null,o=[];const a=[];function c(k){Array.isArray(o)?o.push(k):i!==null&&(o[i]=k)}return g(s,{onObjectBegin:()=>{const k={};c(k),a.push(o),o=k,i=null},onObjectProperty:k=>{i=k},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const k=[];c(k),a.push(o),o=k,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:c,onError:(k,L,O)=>{r.push({error:k,offset:L,length:O})}},n),o[0]}e.parse=S;function f(s,r=[],n=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(k){i.type==="property"&&(i.length=k-i.offset,i=i.parent)}function a(k){return i.children.push(k),k}g(s,{onObjectBegin:k=>{i=a({type:"object",offset:k,length:-1,parent:i,children:[]})},onObjectProperty:(k,L,O)=>{i=a({type:"property",offset:L,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:k,offset:L,length:O,parent:i})},onObjectEnd:(k,L)=>{i.length=k+L-i.offset,i=i.parent,o(k+L)},onArrayBegin:(k,L)=>{i=a({type:"array",offset:k,length:-1,parent:i,children:[]})},onArrayEnd:(k,L)=>{i.length=k+L-i.offset,i=i.parent,o(k+L)},onLiteralValue:(k,L,O)=>{a({type:l(k),offset:L,length:O,parent:i,value:k}),o(L+O)},onSeparator:(k,L,O)=>{i.type==="property"&&(k===":"?i.colonOffset=L:k===","&&o(L))},onError:(k,L,O)=>{r.push({error:k,offset:L,length:O})}},n);const v=i.children[0];return v&&delete v.parent,v}e.parseTree=f;function u(s,r){if(!s)return;let n=s;for(const i of r)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let o=!1;for(const a of n.children)if(Array.isArray(a.children)&&a.children[0].value===i){n=a.children[1],o=!0;break}if(!o)return}else{const o=i;if(n.type!=="array"||o<0||!Array.isArray(n.children)||o>=n.children.length)return;n=n.children[o]}return n}e.findNodeAtLocation=u;function p(s){if(!s.parent||!s.parent.children)return[];const r=p(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;r.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&r.push(n)}return r}e.getNodePath=p;function m(s){switch(s.type){case"array":return s.children.map(m);case"object":{const r=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(r[n.children[0].value]=m(i))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=m;function y(s,r,n=!1){return r>=s.offset&&r<s.offset+s.length||n&&r===s.offset+s.length}e.contains=y;function I(s,r,n=!1){if(y(s,r,n)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const a=I(i[o],r,n);if(a)return a}return s}}e.findNodeAtOffset=I;function g(s,r,n=R.DEFAULT){const i=M(s,!1);function o($){return $?()=>$(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a($){return $?Q=>$(Q,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=o(r.onObjectBegin),v=a(r.onObjectProperty),k=o(r.onObjectEnd),L=o(r.onArrayBegin),O=o(r.onArrayEnd),F=a(r.onLiteralValue),j=a(r.onSeparator),ee=o(r.onComment),se=a(r.onError),ae=n&&n.disallowComments,ie=n&&n.allowTrailingComma;function ce(){for(;;){const $=i.scan();switch(i.getTokenError()){case 4:H(14);break;case 5:H(15);break;case 3:H(13);break;case 1:ae||H(11);break;case 2:H(12);break;case 6:H(16);break}switch($){case 12:case 13:ae?H(10):ee();break;case 16:H(1);break;case 15:case 14:break;default:return $}}}function H($,Q=[],A=[]){if(se($),Q.length+A.length>0){let W=i.getToken();for(;W!==17;){if(Q.indexOf(W)!==-1){ce();break}else if(A.indexOf(W)!==-1)break;W=ce()}}}function re($){const Q=i.getTokenValue();return $?F(Q):v(Q),ce(),!0}function q(){switch(i.getToken()){case 11:{let $=0;try{$=JSON.parse(i.getTokenValue()),typeof $!="number"&&(H(2),$=0)}catch{H(2)}F($);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return ce(),!0}function T(){return i.getToken()!==10?(H(3,[],[2,5]),!1):(re(!1),i.getToken()===6?(j(":"),ce(),te()||H(4,[],[2,5])):H(5,[],[2,5]),!0)}function N(){c(),ce();let $=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if($||H(4,[],[]),j(","),ce(),i.getToken()===2&&ie)break}else $&&H(6,[],[]);T()||H(4,[],[2,5]),$=!0}return k(),i.getToken()!==2?H(7,[2],[]):ce(),!0}function V(){L(),ce();let $=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if($||H(4,[],[]),j(","),ce(),i.getToken()===4&&ie)break}else $&&H(6,[],[]);te()||H(4,[],[4,5]),$=!0}return O(),i.getToken()!==4?H(8,[4],[]):ce(),!0}function te(){switch(i.getToken()){case 3:return V();case 1:return N();case 10:return re(!0);default:return q()}}return ce(),i.getToken()===17?n.allowEmptyContent?!0:(H(4,[],[]),!1):te()?(i.getToken()!==17&&H(9,[],[]),!0):(H(4,[],[]),!1)}e.visit=g;function h(s,r){const n=M(s),i=[];let o,a=0,c;do switch(c=n.getPosition(),o=n.scan(),o){case 12:case 13:case 17:a!==c&&i.push(s.substring(a,c)),r!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,r)),a=n.getPosition();break}while(o!==17);return i.join("")}e.stripComments=h;function l(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=l}),define(X[119],J([0,1,49]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function t(w,C,P){let S,f,u,p,m;if(C){for(p=C.offset,m=p+C.length,u=p;u>0&&!d(w,u-1);)u--;let c=m;for(;c<w.length&&!d(w,c);)c++;f=w.substring(u,c),S=M(f,P)}else f=w,S=0,u=0,p=0,m=w.length;const y=b(P,w);let I=!1,g=0,h;P.insertSpaces?h=R(" ",P.tabSize||4):h="	";const l=(0,E.createScanner)(f,!1);let s=!1;function r(){return y+R(h,S+g)}function n(){let c=l.scan();for(I=!1;c===15||c===14;)I=I||c===14,c=l.scan();return s=c===16||l.getTokenError()!==0,c}const i=[];function o(c,v,k){!s&&v<m&&k>p&&w.substring(v,k)!==c&&i.push({offset:v,length:k-v,content:c})}let a=n();if(a!==17){const c=l.getTokenOffset()+u,v=R(h,S);o(v,u,c)}for(;a!==17;){let c=l.getTokenOffset()+l.getTokenLength()+u,v=n(),k="";for(;!I&&(v===12||v===13);){const O=l.getTokenOffset()+u;o(" ",c,O),c=l.getTokenOffset()+l.getTokenLength()+u,k=v===12?r():"",v=n()}if(v===2)a!==1&&(g--,k=r());else if(v===4)a!==3&&(g--,k=r());else{switch(a){case 3:case 1:g++,k=r();break;case 5:case 12:k=r();break;case 13:I?k=r():k=" ";break;case 6:k=" ";break;case 10:if(v===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?k=" ":v!==5&&v!==17&&(s=!0);break;case 16:s=!0;break}I&&(v===12||v===13)&&(k=r())}const L=l.getTokenOffset()+u;o(k,c,L),a=v}return i}e.format=t;function D(w,C){const P=JSON.stringify(w,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?P.replace(/\r\n|\r|\n/g,C.eol):P}e.toFormattedString=D;function R(w,C){let P="";for(let S=0;S<C;S++)P+=w;return P}function M(w,C){let P=0,S=0;const f=C.tabSize||4;for(;P<w.length;){const u=w.charAt(P);if(u===" ")S++;else if(u==="	")S+=f;else break;P++}return Math.floor(S/f)}function b(w,C){for(let P=0;P<C.length;P++){const S=C.charAt(P);if(S==="\r")return P+1<C.length&&C.charAt(P+1)===`
`?`\r
`:"\r";if(S===`
`)return`
`}return w&&w.eol||`
`}e.getEOL=b;function d(w,C){return`\r
`.indexOf(w.charAt(C))!==-1}e.isEOL=d}),define(X[120],J([0,1,49,119]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(w,C,P){return R(w,C,void 0,P)}e.removeProperty=D;function R(w,C,P,S,f){const u=C.slice(),p=[],m=(0,E.parseTree)(w,p);let y,I;for(;u.length>0&&(I=u.pop(),y=(0,E.findNodeAtLocation)(m,u),y===void 0&&P!==void 0);)typeof I=="string"?P={[I]:P}:P=[P];if(y)if(y.type==="object"&&typeof I=="string"&&Array.isArray(y.children)){const g=(0,E.findNodeAtLocation)(y,[I]);if(g!==void 0)if(P===void 0){if(!g.parent)throw new Error("Malformed AST");const h=y.children.indexOf(g.parent);let l,s=g.parent.offset+g.parent.length;if(h>0){const r=y.children[h-1];l=r.offset+r.length}else l=y.offset+1,y.children.length>1&&(s=y.children[1].offset);return M(w,{offset:l,length:s-l,content:""},S)}else return M(w,{offset:g.offset,length:g.length,content:JSON.stringify(P)},S);else{if(P===void 0)return[];const h=`${JSON.stringify(I)}: ${JSON.stringify(P)}`,l=f?f(y.children.map(r=>r.children[0].value)):y.children.length;let s;if(l>0){const r=y.children[l-1];s={offset:r.offset+r.length,length:0,content:","+h}}else y.children.length===0?s={offset:y.offset+1,length:0,content:h}:s={offset:y.offset+1,length:0,content:h+","};return M(w,s,S)}}else if(y.type==="array"&&typeof I=="number"&&Array.isArray(y.children))if(P!==void 0){const g=`${JSON.stringify(P)}`;let h;if(y.children.length===0||I===0)h={offset:y.offset+1,length:0,content:y.children.length===0?g:g+","};else{const l=I===-1||I>y.children.length?y.children.length:I,s=y.children[l-1];h={offset:s.offset+s.length,length:0,content:","+g}}return M(w,h,S)}else{const g=I,h=y.children[g];let l;if(y.children.length===1)l={offset:y.offset+1,length:y.length-2,content:""};else if(y.children.length-1===g){const s=y.children[g-1],r=s.offset+s.length,n=y.offset+y.length;l={offset:r,length:n-2-r,content:""}}else l={offset:h.offset,length:y.children[g+1].offset-h.offset,content:""};return M(w,l,S)}else throw new Error(`Can not add ${typeof I!="number"?"index":"property"} to parent of type ${y.type}`);else{if(P===void 0)throw new Error("Can not delete in empty document");return M(w,{offset:m?m.offset:0,length:m?m.length:0,content:JSON.stringify(P)},S)}}e.setProperty=R;function M(w,C,P){let S=b(w,C),f=C.offset,u=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;f>0&&!(0,t.isEOL)(S,f-1);)f--;for(;u<S.length&&!(0,t.isEOL)(S,u);)u++}const p=(0,t.format)(S,{offset:f,length:u-f},P);for(let y=p.length-1;y>=0;y--){const I=p[y];S=b(S,I),f=Math.min(f,I.offset),u=Math.max(u,I.offset+I.length),u+=I.content.length-I.length}const m=w.length-(S.length-u)-f;return[{offset:f,length:m,content:S.substring(f,u)}]}e.withFormatting=M;function b(w,C){return w.substring(0,C.offset)+C.content+w.substring(C.offset+C.length)}e.applyEdit=b;function d(w,C){const P=C.slice(0).sort((f,u)=>{const p=f.offset-u.offset;return p===0?f.length-u.length:p});let S=w.length;for(let f=P.length-1;f>=0;f--){const u=P[f];if(u.offset+u.length<=S)w=b(w,u);else throw new Error("Overlapping edit");S=u.offset}return w}e.applyEdits=d}),define(X[121],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(D){this.executor=D,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(D){this._error=D}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(D){return new E(()=>D(this.getValue()))}}e.Lazy=E}),define(X[2],J([0,1,48,55]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let R=null;function M(o){R=o}if(e.setDisposableTracker=M,D){const o="__is_disposable_tracked__";M(new class{trackDisposable(a){const c=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[o]||console.log(c)},3e3)}setParent(a,c){if(a&&a!==I.None)try{a[o]=!0}catch{}}markAsDisposed(a){if(a&&a!==I.None)try{a[o]=!0}catch{}}markAsSingleton(a){}})}function b(o){return R?.trackDisposable(o),o}function d(o){R?.markAsDisposed(o)}function w(o,a){R?.setParent(o,a)}function C(o,a){if(!!R)for(const c of o)R.setParent(c,a)}function P(o){return R?.markAsSingleton(o),o}e.markAsSingleton=P;class S extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=S;function f(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=f;function u(o){if(t.Iterable.is(o)){const a=[];for(const c of o)if(c)try{c.dispose()}catch(v){a.push(v)}if(a.length===1)throw a[0];if(a.length>1)throw new S(a);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=u;function p(...o){const a=m(()=>u(o));return C(o,a),a}e.combinedDisposable=p;function m(o){const a=b({dispose:(0,E.once)(()=>{d(a),o()})});return a}e.toDisposable=m;class y{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{u(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return w(a,this),this._isDisposed?y.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=y,y.DISABLE_DISPOSED_WARNING=!1;class I{constructor(){this._store=new y,b(this),w(this._store,this)}dispose(){d(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=I,I.None=Object.freeze({dispose(){}});class g{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&w(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&w(a,null),a}}e.MutableDisposable=g;class h{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=h;class l{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(a){let c=a;return this.unset=()=>c=void 0,this.isset=()=>c!==void 0,this.dispose=()=>{c&&(c(),c=void 0,d(this))},this}}e.SafeDisposable=l;class s{constructor(){this.references=new Map}acquire(a,...c){let v=this.references.get(a);v||(v={counter:0,object:this.createReferencedObject(a,...c)},this.references.set(a,v));const{object:k}=v,L=(0,E.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(a,v.object),this.references.delete(a))});return v.counter++,{object:k,dispose:L}}}e.ReferenceCollection=s;class r{constructor(a){this.referenceCollection=a}async acquire(a,...c){const v=this.referenceCollection.acquire(a,...c);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(k){throw v.dispose(),k}}}e.AsyncReferenceCollection=r;class n{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=n;function i(o){const a=new y;try{o(a)}finally{a.dispose()}}e.disposeOnReturn=i}),define(X[122],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(R){this.element=R,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class t{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let R=this._first;for(;R!==E.Undefined;){const M=R.next;R.prev=E.Undefined,R.next=E.Undefined,R=M}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(R){return this._insert(R,!1)}push(R){return this._insert(R,!0)}_insert(R,M){const b=new E(R);if(this._first===E.Undefined)this._first=b,this._last=b;else if(M){const w=this._last;this._last=b,b.prev=w,w.next=b}else{const w=this._first;this._first=b,b.next=w,w.prev=b}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(b))}}shift(){if(this._first!==E.Undefined){const R=this._first.element;return this._remove(this._first),R}}pop(){if(this._last!==E.Undefined){const R=this._last.element;return this._remove(this._last),R}}_remove(R){if(R.prev!==E.Undefined&&R.next!==E.Undefined){const M=R.prev;M.next=R.next,R.next.prev=M}else R.prev===E.Undefined&&R.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):R.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):R.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let R=this._first;for(;R!==E.Undefined;)yield R.element,R=R.next}}e.LinkedList=t}),function(){function B(D){const R=[];typeof D=="number"&&R.push("code/timeOrigin",D);function M(d){R.push(d,Date.now())}function b(){const d=[];for(let w=0;w<R.length;w+=2)d.push({name:R[w],startTime:R[w+1]});return d}return{mark:M,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?B():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const M of performance.getEntriesByType("mark"))R.push({name:M.name,startTime:Math.round(D+M.startTime)});return R}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return B(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),B()}function E(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var t;typeof global=="object"?t=global:typeof self=="object"?t=self:t={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(t)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(t):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),t.perf=E(t))}(),define(X[123],J([0,1]),function(B,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class t{constructor(b,d,w){this.level=b,this.key=d,this.value=w,this.forward=[]}}const D=void 0;class R{constructor(b,d=2**16){this.comparator=b,this[E]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(d)|0),this._header=new t(this._maxLevel,D,D)}get size(){return this._size}clear(){this._header=new t(this._maxLevel,D,D)}has(b){return Boolean(R._search(this,b,this.comparator))}get(b){return R._search(this,b,this.comparator)?.value}set(b,d){return R._insert(this,b,d,this.comparator)&&(this._size+=1),this}delete(b){const d=R._delete(this,b,this.comparator);return d&&(this._size-=1),d}forEach(b,d){let w=this._header.forward[0];for(;w;)b.call(d,w.value,w.key,this),w=w.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",d=this._header.forward[0];for(;d;)b+=`node(${d.key}, ${d.value}, lvl:${d.level})`,d=d.forward[0];return b}static _search(b,d,w){let C=b._header;for(let P=b._level-1;P>=0;P--)for(;C.forward[P]&&w(C.forward[P].key,d)<0;)C=C.forward[P];if(C=C.forward[0],C&&w(C.key,d)===0)return C}static _insert(b,d,w,C){const P=[];let S=b._header;for(let f=b._level-1;f>=0;f--){for(;S.forward[f]&&C(S.forward[f].key,d)<0;)S=S.forward[f];P[f]=S}if(S=S.forward[0],S&&C(S.key,d)===0)return S.value=w,!1;{const f=R._randomLevel(b);if(f>b._level){for(let u=b._level;u<f;u++)P[u]=b._header;b._level=f}S=new t(f,d,w);for(let u=0;u<f;u++)S.forward[u]=P[u].forward[u],P[u].forward[u]=S;return!0}}static _randomLevel(b,d=.5){let w=1;for(;Math.random()<d&&w<b._maxLevel;)w+=1;return w}static _delete(b,d,w){const C=[];let P=b._header;for(let S=b._level-1;S>=0;S--){for(;P.forward[S]&&w(P.forward[S].key,d)<0;)P=P.forward[S];C[S]=P}if(P=P.forward[0],!P||w(P.key,d)!==0)return!1;for(let S=0;S<b._level&&C[S].forward[S]===P;S++)C[S].forward[S]=P.forward[S];for(;b._level>0&&b._header.forward[b._level-1]===D;)b._level-=1;return!0}}e.SkipList=R}),define(X[56],J([0,1,19,2]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function D(h){const l=h;return l?typeof l.read=="function":!1}e.isReadable=D;function R(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=R;function M(h){const l=h;return l?R(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=M;function b(h,l){return new d(h,l)}e.newWriteableStream=b;class d{constructor(l,s){this.reducer=l,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(s=>s(l))}emitError(l){this.listeners.error.length===0?(0,E.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(s=>s(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,s){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(l,s){if(this.state.destroyed)return;let r;switch(l){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const n=r.indexOf(s);n>=0&&r.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function w(h,l){const s=[];let r;for(;(r=h.read())!==null;)s.push(r);return l(s)}e.consumeReadable=w;function C(h,l,s){const r=[];let n;for(;(n=h.read())!==null&&r.length<s;)r.push(n);return n===null&&r.length>0?l(r):{read:()=>{if(r.length>0)return r.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return h.read()}}}e.peekReadable=C;function P(h,l){return new Promise((s,r)=>{const n=[];S(h,{onData:i=>{l&&n.push(i)},onError:i=>{l?r(i):s(void 0)},onEnd:()=>{s(l?l(n):void 0)}})})}e.consumeStream=P;function S(h,l){let s=!1;return h.on("error",r=>{s||l.onError(r)}),h.on("end",()=>{s||l.onEnd()}),h.on("data",r=>{s||l.onData(r)}),(0,t.toDisposable)(()=>s=!0)}e.listenStream=S;function f(h,l){return new Promise((s,r)=>{const n=new t.DisposableStore,i=[],o=v=>{if(i.push(v),i.length>l)return n.dispose(),h.pause(),s({stream:h,buffer:i,ended:!1})},a=v=>r(v),c=()=>s({stream:h,buffer:i,ended:!0});n.add((0,t.toDisposable)(()=>h.removeListener("error",a))),h.on("error",a),n.add((0,t.toDisposable)(()=>h.removeListener("end",c))),h.on("end",c),n.add((0,t.toDisposable)(()=>h.removeListener("data",o))),h.on("data",o)})}e.peekStream=f;function u(h,l){const s=b(l);return s.end(h),s}e.toStream=u;function p(){const h=b(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=p;function m(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=m;function y(h,l,s){const r=b(s);return S(h,{onData:n=>r.write(l.data(n)),onError:n=>r.error(l.error?l.error(n):n),onEnd:()=>r.end()}),r}e.transform=y;function I(h,l,s){let r=!1;return{read:()=>{const n=l.read();return r?n:(r=!0,n!==null?s([h,n]):h)}}}e.prefixedReadable=I;function g(h,l,s){let r=!1;const n=b(s);return S(l,{onData:i=>r?n.write(i):(r=!0,n.write(s([h,i]))),onError:i=>n.error(i),onEnd:()=>{r||(r=!0,n.write(h)),n.end()}}),n}e.prefixedStream=g}),define(X[17],J([0,1,56]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const t=typeof Buffer!="undefined";let D,R;class M{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return t?new M(Buffer.allocUnsafe(v)):new M(new Uint8Array(v))}static wrap(v){return t&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new M(v)}static fromString(v,k){return!(k?.dontUseNodeBuffer||!1)&&t?new M(Buffer.from(v)):(D||(D=new TextEncoder),new M(D.encode(v)))}static fromByteArray(v){const k=M.alloc(v.length);for(let L=0,O=v.length;L<O;L++)k.buffer[L]=v[L];return k}static concat(v,k){if(typeof k=="undefined"){k=0;for(let F=0,j=v.length;F<j;F++)k+=v[F].byteLength}const L=M.alloc(k);let O=0;for(let F=0,j=v.length;F<j;F++){const ee=v[F];L.set(ee,O),O+=ee.byteLength}return L}clone(){const v=M.alloc(this.byteLength);return v.set(this),v}toString(){return t?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(v,k){return new M(this.buffer.subarray(v,k))}set(v,k){if(v instanceof M)this.buffer.set(v.buffer,k);else if(v instanceof Uint8Array)this.buffer.set(v,k);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),k);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return w(this.buffer,v)}writeUInt32BE(v,k){C(this.buffer,v,k)}readUInt32LE(v){return P(this.buffer,v)}writeUInt32LE(v,k){S(this.buffer,v,k)}readUInt8(v){return f(this.buffer,v)}writeUInt8(v,k){u(this.buffer,v,k)}}e.VSBuffer=M;function b(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0}e.readUInt16LE=b;function d(c,v,k){c[k+0]=v&255,v=v>>>8,c[k+1]=v&255}e.writeUInt16LE=d;function w(c,v){return c[v]*2**24+c[v+1]*2**16+c[v+2]*2**8+c[v+3]}e.readUInt32BE=w;function C(c,v,k){c[k+3]=v,v=v>>>8,c[k+2]=v,v=v>>>8,c[k+1]=v,v=v>>>8,c[k]=v}e.writeUInt32BE=C;function P(c,v){return c[v+0]<<0>>>0|c[v+1]<<8>>>0|c[v+2]<<16>>>0|c[v+3]<<24>>>0}e.readUInt32LE=P;function S(c,v,k){c[k+0]=v&255,v=v>>>8,c[k+1]=v&255,v=v>>>8,c[k+2]=v&255,v=v>>>8,c[k+3]=v&255}e.writeUInt32LE=S;function f(c,v){return c[v]}e.readUInt8=f;function u(c,v,k){c[k]=v}e.writeUInt8=u;function p(c){return E.consumeReadable(c,v=>M.concat(v))}e.readableToBuffer=p;function m(c){return E.toReadable(c)}e.bufferToReadable=m;function y(c){return E.consumeStream(c,v=>M.concat(v))}e.streamToBuffer=y;async function I(c){return c.ended?M.concat(c.buffer):M.concat([...c.buffer,await y(c.stream)])}e.bufferedStreamToBuffer=I;function g(c){return E.toStream(c,v=>M.concat(v))}e.bufferToStream=g;function h(c){return E.transform(c,{data:v=>typeof v=="string"?M.fromString(v):M.wrap(v)},v=>M.concat(v))}e.streamToBufferReadableStream=h;function l(c){return E.newWriteableStream(v=>M.concat(v),c)}e.newWriteableBufferStream=l;function s(c,v){return E.prefixedReadable(c,v,k=>M.concat(k))}e.prefixedBufferReadable=s;function r(c,v){return E.prefixedStream(c,v,k=>M.concat(k))}e.prefixedBufferStream=r;function n(c){let v=0,k=0,L=0;const O=new Uint8Array(Math.floor(c.length/4*3)),F=ee=>{switch(k){case 3:O[L++]=v|ee,k=0;break;case 2:O[L++]=v|ee>>>2,v=ee<<6,k=3;break;case 1:O[L++]=v|ee>>>4,v=ee<<4,k=2;break;default:v=ee<<2,k=1}};for(let ee=0;ee<c.length;ee++){const se=c.charCodeAt(ee);if(se>=65&&se<=90)F(se-65);else if(se>=97&&se<=122)F(se-97+26);else if(se>=48&&se<=57)F(se-48+52);else if(se===43||se===45)F(62);else if(se===47||se===95)F(63);else{if(se===61)break;throw new SyntaxError(`Unexpected base64 character ${c[ee]}`)}}const j=L;for(;k>0;)F(0);return M.wrap(O).slice(0,j)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:c},v=!0,k=!1){const L=k?o:i;let O="";const F=c.byteLength%3;let j=0;for(;j<c.byteLength-F;j+=3){const ee=c[j+0],se=c[j+1],ae=c[j+2];O+=L[ee>>>2],O+=L[(ee<<4|se>>>4)&63],O+=L[(se<<2|ae>>>6)&63],O+=L[ae&63]}if(F===1){const ee=c[j+0];O+=L[ee>>>2],O+=L[ee<<4&63],v&&(O+="==")}else if(F===2){const ee=c[j+0],se=c[j+1];O+=L[ee>>>2],O+=L[(ee<<4|se>>>4)&63],O+=L[se<<2&63],v&&(O+="=")}return O}e.encodeBase64=a}),define(X[13],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(a){return typeof a=="string"}e.isString=E;function t(a){return Array.isArray(a)&&a.every(c=>E(c))}e.isStringArray=t;function D(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=D;function R(a){const c=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof c}e.isTypedArray=R;function M(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=M;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=b;function d(a){return a===!0||a===!1}e.isBoolean=d;function w(a){return typeof a=="undefined"}e.isUndefined=w;function C(a){return!P(a)}e.isDefined=C;function P(a){return w(a)||a===null}e.isUndefinedOrNull=P;function S(a,c){if(!a)throw new Error(c?`Unexpected type, expected '${c}'`:"Unexpected type")}e.assertType=S;function f(a){if(P(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function u(...a){const c=[];for(let v=0;v<a.length;v++){const k=a[v];if(P(k))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);c.push(k)}return c}e.assertAllDefined=u;const p=Object.prototype.hasOwnProperty;function m(a){if(!D(a))return!1;for(const c in a)if(p.call(a,c))return!1;return!0}e.isEmptyObject=m;function y(a){return typeof a=="function"}e.isFunction=y;function I(...a){return a.length>0&&a.every(y)}e.areFunctions=I;function g(a,c){const v=Math.min(a.length,c.length);for(let k=0;k<v;k++)h(a[k],c[k])}e.validateConstraints=g;function h(a,c){if(E(c)){if(typeof a!==c)throw new Error(`argument does not match constraint: typeof ${c}`)}else if(y(c)){try{if(a instanceof c)return}catch{}if(!P(a)&&a.constructor===c||c.length===1&&c.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=h;function l(a){let c=[],v=Object.getPrototypeOf(a);for(;Object.prototype!==v;)c=c.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return c}e.getAllPropertyNames=l;function s(a){const c=[];for(const v of l(a))typeof a[v]=="function"&&c.push(v);return c}e.getAllMethodNames=s;function r(a,c){const v=L=>function(){const O=Array.prototype.slice.call(arguments,0);return c(L,O)},k={};for(const L of a)k[L]=v(L);return k}e.createProxyObject=r;function n(a){return a===null?void 0:a}e.withNullAsUndefined=n;function i(a){return typeof a=="undefined"?null:a}e.withUndefinedAsNull=i;function o(a,c="Unreachable"){throw new Error(c)}e.assertNever=o}),define(X[50],J([0,1,13]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function t(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const p=Array.isArray(u)?[]:{};return Object.keys(u).forEach(m=>{u[m]&&typeof u[m]=="object"?p[m]=t(u[m]):p[m]=u[m]}),p}e.deepClone=t;function D(u){if(!u||typeof u!="object")return u;const p=[u];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const y in m)if(R.call(m,y)){const I=m[y];typeof I=="object"&&!Object.isFrozen(I)&&!(0,E.isTypedArray)(I)&&p.push(I)}}return u}e.deepFreeze=D;const R=Object.prototype.hasOwnProperty;function M(u,p){return b(u,p,new Set)}e.cloneAndChange=M;function b(u,p,m){if((0,E.isUndefinedOrNull)(u))return u;const y=p(u);if(typeof y!="undefined")return y;if(Array.isArray(u)){const I=[];for(const g of u)I.push(b(g,p,m));return I}if((0,E.isObject)(u)){if(m.has(u))throw new Error("Cannot clone recursive data-structure");m.add(u);const I={};for(const g in u)R.call(u,g)&&(I[g]=b(u[g],p,m));return m.delete(u),I}return u}function d(u,p,m=!0){return(0,E.isObject)(u)?((0,E.isObject)(p)&&Object.keys(p).forEach(y=>{y in u?m&&((0,E.isObject)(u[y])&&(0,E.isObject)(p[y])?d(u[y],p[y],m):u[y]=p[y]):u[y]=p[y]}),u):p}e.mixin=d;function w(u,p){if(u===p)return!0;if(u==null||p===null||p===void 0||typeof u!=typeof p||typeof u!="object"||Array.isArray(u)!==Array.isArray(p))return!1;let m,y;if(Array.isArray(u)){if(u.length!==p.length)return!1;for(m=0;m<u.length;m++)if(!w(u[m],p[m]))return!1}else{const I=[];for(y in u)I.push(y);I.sort();const g=[];for(y in p)g.push(y);if(g.sort(),!w(I,g))return!1;for(m=0;m<I.length;m++)if(!w(u[I[m]],p[I[m]]))return!1}return!0}e.equals=w;function C(u){const p=new Set;return JSON.stringify(u,(m,y)=>{if((0,E.isObject)(y)||Array.isArray(y)){if(p.has(y))return"[Circular]";p.add(y)}return y})}e.safeStringify=C;function P(u,p){const m=Object.create(null);return!u||!p||Object.keys(p).forEach(I=>{const g=u[I],h=p[I];w(g,h)||(m[I]=h)}),m}e.distinct=P;function S(u,p){const m=p.toLowerCase(),y=Object.keys(u).find(I=>I.toLowerCase()===m);return y?u[y]:u[p]}e.getCaseInsensitive=S;function f(u,p){const m=Object.create(null);for(const[y,I]of Object.entries(u))p(y,I)&&(m[y]=I);return m}e.filter=f}),define(X[27],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function t(D){return E.test(D)}e.isUUID=t,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(b){for(let d=0;d<b.length;d++)b[d]=Math.floor(Math.random()*256);return b};const R=new Uint8Array(16),M=[];for(let b=0;b<256;b++)M.push(b.toString(16).padStart(2,"0"));return function(){D(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let d=0,w="";return w+=M[R[d++]],w+=M[R[d++]],w+=M[R[d++]],w+=M[R[d++]],w+="-",w+=M[R[d++]],w+=M[R[d++]],w+="-",w+=M[R[d++]],w+=M[R[d++]],w+="-",w+=M[R[d++]],w+=M[R[d++]],w+="-",w+=M[R[d++]],w+=M[R[d++]],w+=M[R[d++]],w+=M[R[d++]],w+=M[R[d++]],w+=M[R[d++]],w}}()}),define(X[124],J([0,1,75,28,48]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function R(M,b){if(await new Promise((C,P)=>{const S=t.createReadStream(M),f=E.createHash("sha1");S.pipe(f);const u=(0,D.once)((p,m)=>{S.removeAllListeners(),f.removeAllListeners(),p?P(p):C(m)});S.once("error",u),S.once("end",u),f.once("error",u),f.once("data",p=>u(void 0,p.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=R}),define(X[125],J([0,1,126]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class t{constructor(R="utf8"){this.stringDecoder=new E.StringDecoder(R),this.remaining=null}write(R){const M=[],b=this.remaining?this.remaining+this.stringDecoder.write(R):this.stringDecoder.write(R);if(b.length<1)return M;let d=0,w,C=d;for(;C<b.length;)if(w=b.charCodeAt(C),w===13||w===10){if(M.push(b.substring(d,C)),C++,C<b.length){const P=w;w=b.charCodeAt(C),(P===13&&w===10||P===10&&w===13)&&C++}d=C}else C++;return this.remaining=d<b.length?b.substr(d):null,M}end(){return this.remaining}}e.LineDecoder=t}),define(X[127],J([0,1,29]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const t=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(M){const b=M.replace(/\-/g,":").toLowerCase();return!t.has(b)}function R(){const M=(0,E.networkInterfaces)();for(const b in M){const d=M[b];if(d){for(const{mac:w}of d)if(D(w))return w}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=R}),define(X[90],J([0,1,76]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function t(b,d,w,C=1){let P=!1;return new Promise(S=>{const f=setTimeout(()=>{if(!P)return P=!0,S(0)},w);D(b,d,C,u=>{if(!P)return P=!0,clearTimeout(f),S(u)})})}e.findFreePort=t;function D(b,d,w,C){if(d===0)return C(0);const P=new E.Socket;P.once("connect",()=>(M(P),D(b+w,d-1,w,C))),P.once("data",()=>{}),P.once("error",S=>(M(P),S.code!=="ECONNREFUSED"?D(b+w,d-1,w,C):C(b))),P.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(b,d,w){let C=!1,P,S=1;const f=E.createServer({pauseOnConnect:!0});function u(p,m){C||(C=!0,f.removeAllListeners(),f.close(),P&&clearTimeout(P),m(p))}return new Promise(p=>{P=setTimeout(()=>{u(0,p)},w),f.on("listening",()=>{u(b,p)}),f.on("error",m=>{m&&(m.code==="EADDRINUSE"||m.code==="EACCES")&&S<d?(b++,S++,f.listen(b,"127.0.0.1")):u(0,p)}),f.on("close",()=>{u(0,p)}),f.listen(b,"127.0.0.1")})}e.findFreePortFaster=R;function M(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(d){console.error(d)}}}),define(X[128],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(X[129],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(D,R){this.sender=D,this.onMessage=R}send(D){try{this.sender.send("vscode:message",D.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=E}),define(X[38],J([0,1,14,19]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class D{constructor(){this.mapListenerToWrapper=new WeakMap}on(M,b){const d=(w,...C)=>{this.validateEvent(M,w)&&b(w,...C)};return this.mapListenerToWrapper.set(b,d),E.ipcMain.on(M,d),this}once(M,b){return E.ipcMain.once(M,(d,...w)=>{this.validateEvent(M,d)&&b(d,...w)}),this}handle(M,b){return E.ipcMain.handle(M,(d,...w)=>this.validateEvent(M,d)?b(d,...w):Promise.reject(`Invalid channel '${M}' or sender for ipcMain.handle() usage.`)),this}removeHandler(M){return E.ipcMain.removeHandler(M),this}removeListener(M,b){const d=this.mapListenerToWrapper.get(b);return d&&(E.ipcMain.removeListener(M,d),this.mapListenerToWrapper.delete(b)),this}validateEvent(M,b){if(!M||!M.startsWith("vscode:"))return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because the channel is unknown.`),!1;const d=b.senderFrame,w=d.url;if(!w)return!0;let C="unknown";try{C=new URL(w).host}catch{return(0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a malformed URL '${w}'.`),!1}return C!=="vscode-app"?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because of a bad origin of '${C}'.`),!1):d.parent!==null?((0,t.onUnexpectedError)(`Refused to handle ipcMain event for channel '${M}' because sender of origin '${C}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new D}),define(X[130],J([0,1,14,38,13,128]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){t.validatedIpcMain.on(R.CONTEXT_MENU_CHANNEL,(d,w,C,P,S)=>{const f=b(d,P,C);f.popup({window:(0,D.withNullAsUndefined)(E.BrowserWindow.fromWebContents(d.sender)),x:S?S.x:void 0,y:S?S.y:void 0,positioningItem:S?S.positioningItem:void 0,callback:()=>{f&&d.sender.send(R.CONTEXT_MENU_CLOSE_CHANNEL,w)}})})}e.registerContextMenuListener=M;function b(d,w,C){const P=new E.Menu;return C.forEach(S=>{let f;S.type==="separator"?f=new E.MenuItem({type:S.type}):Array.isArray(S.submenu)?f=new E.MenuItem({submenu:b(d,w,S.submenu),label:S.label}):f=new E.MenuItem({label:S.label,type:S.type,accelerator:S.accelerator,checked:S.checked,enabled:S.enabled,visible:S.visible,click:(u,p,m)=>d.sender.send(w,S.id,m)}),P.append(f)}),P}}),define(X[131],J([11,10]),function(B,e){return B.create("vs/base/common/date",e)}),define(X[132],J([0,1,131]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const t=60,D=t*60,R=D*24,M=R*7,b=R*30,d=R*365;function w(P,S,f){typeof P!="number"&&(P=P.getTime());const u=Math.round((new Date().getTime()-P)/1e3);if(u<-30)return(0,E.localize)(0,null,w(new Date().getTime()+u*1e3,!1));if(u<30)return(0,E.localize)(1,null);let p;return u<t?(p=u,S?p===1?f?(0,E.localize)(2,null,p):(0,E.localize)(3,null,p):f?(0,E.localize)(4,null,p):(0,E.localize)(5,null,p):p===1?f?(0,E.localize)(6,null,p):(0,E.localize)(7,null,p):f?(0,E.localize)(8,null,p):(0,E.localize)(9,null,p)):u<D?(p=Math.floor(u/t),S?p===1?f?(0,E.localize)(10,null,p):(0,E.localize)(11,null,p):f?(0,E.localize)(12,null,p):(0,E.localize)(13,null,p):p===1?f?(0,E.localize)(14,null,p):(0,E.localize)(15,null,p):f?(0,E.localize)(16,null,p):(0,E.localize)(17,null,p)):u<R?(p=Math.floor(u/D),S?p===1?f?(0,E.localize)(18,null,p):(0,E.localize)(19,null,p):f?(0,E.localize)(20,null,p):(0,E.localize)(21,null,p):p===1?f?(0,E.localize)(22,null,p):(0,E.localize)(23,null,p):f?(0,E.localize)(24,null,p):(0,E.localize)(25,null,p)):u<M?(p=Math.floor(u/R),S?p===1?(0,E.localize)(26,null,p):(0,E.localize)(27,null,p):p===1?(0,E.localize)(28,null,p):(0,E.localize)(29,null,p)):u<b?(p=Math.floor(u/M),S?p===1?f?(0,E.localize)(30,null,p):(0,E.localize)(31,null,p):f?(0,E.localize)(32,null,p):(0,E.localize)(33,null,p):p===1?f?(0,E.localize)(34,null,p):(0,E.localize)(35,null,p):f?(0,E.localize)(36,null,p):(0,E.localize)(37,null,p)):u<d?(p=Math.floor(u/b),S?p===1?f?(0,E.localize)(38,null,p):(0,E.localize)(39,null,p):f?(0,E.localize)(40,null,p):(0,E.localize)(41,null,p):p===1?f?(0,E.localize)(42,null,p):(0,E.localize)(43,null,p):f?(0,E.localize)(44,null,p):(0,E.localize)(45,null,p)):(p=Math.floor(u/d),S?p===1?f?(0,E.localize)(46,null,p):(0,E.localize)(47,null,p):f?(0,E.localize)(48,null,p):(0,E.localize)(49,null,p):p===1?f?(0,E.localize)(50,null,p):(0,E.localize)(51,null,p):f?(0,E.localize)(52,null,p):(0,E.localize)(53,null,p))}e.fromNow=w;function C(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=C}),define(X[133],J([11,10]),function(B,e){return B.create("vs/base/common/errorMessage",e)}),define(X[41],J([0,1,25,13,133]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,S){return S&&(P.stack||P.stacktrace)?D.localize(0,null,b(P),M(P.stack)||M(P.stacktrace)):b(P)}function M(P){return Array.isArray(P)?P.join(`
`):P}function b(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?D.localize(1,null,P.message):P.message||D.localize(2,null)}function d(P=null,S=!1){if(!P)return D.localize(3,null);if(Array.isArray(P)){const f=E.coalesce(P),u=d(f[0],S);return f.length>1?D.localize(4,null,u,f.length):u}if(t.isString(P))return P;if(P.detail){const f=P.detail;if(f.error)return R(f.error,S);if(f.exception)return R(f.exception,S)}return P.stack?R(P,S):P.message?P.message:D.localize(5,null)}e.toErrorMessage=d;function w(P){const S=P;return S instanceof Error&&Array.isArray(S.actions)}e.isErrorWithActions=w;function C(P,S){let f;return typeof P=="string"?f=new Error(P):f=P,f.actions=S,f}e.createErrorWithActions=C}),define(X[134],J([11,10]),function(B,e){return B.create("vs/base/common/platform",e)}),define(X[4],J([0,1,134]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const t="en";let D=!1,R=!1,M=!1,b=!1,d=!1,w=!1,C=!1,P=!1,S=!1,f,u=t,p,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let y;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?y=e.globals.vscode.process:typeof process!="undefined"&&(y=process);const I=typeof y?.versions?.electron=="string",g=I&&y?.type==="renderer";if(typeof navigator=="object"&&!g)m=navigator.userAgent,D=m.indexOf("Windows")>=0,R=m.indexOf("Macintosh")>=0,P=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,w=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||t,u=f;else if(typeof y=="object"){D=y.platform==="win32",R=y.platform==="darwin",M=y.platform==="linux",b=M&&!!y.env.SNAP&&!!y.env.SNAP_REVISION,C=I,S=!!y.env.CI||!!y.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=t,u=t;const c=y.env.VSCODE_NLS_CONFIG;if(c)try{const v=JSON.parse(c),k=v.availableLanguages["*"];f=v.locale,u=k||t,p=v._translationsConfigFile}catch{}d=!0}else console.error("Unable to resolve platform.");var h;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(h=e.Platform||(e.Platform={}));function l(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=l;let s=0;R?s=1:D?s=3:M&&(s=2),e.isWindows=D,e.isMacintosh=R,e.isLinux=M,e.isLinuxSnap=b,e.isNative=d,e.isElectron=C,e.isWeb=w,e.isWebWorker=w&&typeof e.globals.importScripts=="function",e.isIOS=P,e.isCI=S,e.platform=s,e.userAgent=m,e.language=u;var r;(function(c){function v(){return e.language}c.value=v;function k(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}c.isDefaultVariant=k;function L(){return e.language==="en"}c.isDefault=L})(r=e.Language||(e.Language={})),e.locale=f,e.translationsConfigFile=p,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const c=[];e.globals.addEventListener("message",k=>{if(k.data&&k.data.vscodeScheduleAsyncWork)for(let L=0,O=c.length;L<O;L++){const F=c[L];if(F.id===k.data.vscodeScheduleAsyncWork){c.splice(L,1),F.callback();return}}});let v=0;return k=>{const L=++v;c.push({id:L,callback:k}),e.globals.postMessage({vscodeScheduleAsyncWork:L},"*")}}return c=>setTimeout(c)})();var n;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(n=e.OperatingSystem||(e.OperatingSystem={})),e.OS=R||P?2:D?1:3;let i=!0,o=!1;function a(){if(!o){o=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,i=new Uint16Array(c.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=a,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(X[36],J([0,1,4]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let t;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const D=E.globals.vscode.process;t={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()}}}else typeof process!="undefined"?t={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:t={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=t.cwd,e.env=t.env,e.platform=t.platform,e.arch=t.arch}),define(X[9],J([0,1,36]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const t=65,D=97,R=90,M=122,b=46,d=47,w=92,C=58,P=63;class S extends Error{constructor(h,l,s){let r;typeof l=="string"&&l.indexOf("not ")===0?(r="must not be",l=l.replace(/^not /,"")):r="must be";const n=h.indexOf(".")!==-1?"property":"argument";let i=`The "${h}" ${n} ${r} of type ${l}`;i+=`. Received type ${typeof s}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function f(g,h){if(typeof g!="string")throw new S(h,"string",g)}function u(g){return g===d||g===w}function p(g){return g===d}function m(g){return g>=t&&g<=R||g>=D&&g<=M}function y(g,h,l,s){let r="",n=0,i=-1,o=0,a=0;for(let c=0;c<=g.length;++c){if(c<g.length)a=g.charCodeAt(c);else{if(s(a))break;a=d}if(s(a)){if(!(i===c-1||o===1))if(o===2){if(r.length<2||n!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const v=r.lastIndexOf(l);v===-1?(r="",n=0):(r=r.slice(0,v),n=r.length-1-r.lastIndexOf(l)),i=c,o=0;continue}else if(r.length!==0){r="",n=0,i=c,o=0;continue}}h&&(r+=r.length>0?`${l}..`:"..",n=2)}else r.length>0?r+=`${l}${g.slice(i+1,c)}`:r=g.slice(i+1,c),n=c-i-1;i=c,o=0}else a===b&&o!==-1?++o:o=-1}return r}function I(g,h){if(h===null||typeof h!="object")throw new S("pathObject","Object",h);const l=h.dir||h.root,s=h.base||`${h.name||""}${h.ext||""}`;return l?l===h.root?`${l}${s}`:`${l}${g}${s}`:s}e.win32={resolve(...g){let h="",l="",s=!1;for(let r=g.length-1;r>=-1;r--){let n;if(r>=0){if(n=g[r],f(n,"path"),n.length===0)continue}else h.length===0?n=E.cwd():(n=E.env[`=${h}`]||E.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==h.toLowerCase()&&n.charCodeAt(2)===w)&&(n=`${h}\\`));const i=n.length;let o=0,a="",c=!1;const v=n.charCodeAt(0);if(i===1)u(v)&&(o=1,c=!0);else if(u(v))if(c=!0,u(n.charCodeAt(1))){let k=2,L=k;for(;k<i&&!u(n.charCodeAt(k));)k++;if(k<i&&k!==L){const O=n.slice(L,k);for(L=k;k<i&&u(n.charCodeAt(k));)k++;if(k<i&&k!==L){for(L=k;k<i&&!u(n.charCodeAt(k));)k++;(k===i||k!==L)&&(a=`\\\\${O}\\${n.slice(L,k)}`,o=k)}}}else o=1;else m(v)&&n.charCodeAt(1)===C&&(a=n.slice(0,2),o=2,i>2&&u(n.charCodeAt(2))&&(c=!0,o=3));if(a.length>0)if(h.length>0){if(a.toLowerCase()!==h.toLowerCase())continue}else h=a;if(s){if(h.length>0)break}else if(l=`${n.slice(o)}\\${l}`,s=c,c&&h.length>0)break}return l=y(l,!s,"\\",u),s?`${h}\\${l}`:`${h}${l}`||"."},normalize(g){f(g,"path");const h=g.length;if(h===0)return".";let l=0,s,r=!1;const n=g.charCodeAt(0);if(h===1)return p(n)?"\\":g;if(u(n))if(r=!0,u(g.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(g.charCodeAt(o));)o++;if(o<h&&o!==a){const c=g.slice(a,o);for(a=o;o<h&&u(g.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(g.charCodeAt(o));)o++;if(o===h)return`\\\\${c}\\${g.slice(a)}\\`;o!==a&&(s=`\\\\${c}\\${g.slice(a,o)}`,l=o)}}}else l=1;else m(n)&&g.charCodeAt(1)===C&&(s=g.slice(0,2),l=2,h>2&&u(g.charCodeAt(2))&&(r=!0,l=3));let i=l<h?y(g.slice(l),!r,"\\",u):"";return i.length===0&&!r&&(i="."),i.length>0&&u(g.charCodeAt(h-1))&&(i+="\\"),s===void 0?r?`\\${i}`:i:r?`${s}\\${i}`:`${s}${i}`},isAbsolute(g){f(g,"path");const h=g.length;if(h===0)return!1;const l=g.charCodeAt(0);return u(l)||h>2&&m(l)&&g.charCodeAt(1)===C&&u(g.charCodeAt(2))},join(...g){if(g.length===0)return".";let h,l;for(let n=0;n<g.length;++n){const i=g[n];f(i,"path"),i.length>0&&(h===void 0?h=l=i:h+=`\\${i}`)}if(h===void 0)return".";let s=!0,r=0;if(typeof l=="string"&&u(l.charCodeAt(0))){++r;const n=l.length;n>1&&u(l.charCodeAt(1))&&(++r,n>2&&(u(l.charCodeAt(2))?++r:s=!1))}if(s){for(;r<h.length&&u(h.charCodeAt(r));)r++;r>=2&&(h=`\\${h.slice(r)}`)}return e.win32.normalize(h)},relative(g,h){if(f(g,"from"),f(h,"to"),g===h)return"";const l=e.win32.resolve(g),s=e.win32.resolve(h);if(l===s||(g=l.toLowerCase(),h=s.toLowerCase(),g===h))return"";let r=0;for(;r<g.length&&g.charCodeAt(r)===w;)r++;let n=g.length;for(;n-1>r&&g.charCodeAt(n-1)===w;)n--;const i=n-r;let o=0;for(;o<h.length&&h.charCodeAt(o)===w;)o++;let a=h.length;for(;a-1>o&&h.charCodeAt(a-1)===w;)a--;const c=a-o,v=i<c?i:c;let k=-1,L=0;for(;L<v;L++){const F=g.charCodeAt(r+L);if(F!==h.charCodeAt(o+L))break;F===w&&(k=L)}if(L!==v){if(k===-1)return s}else{if(c>v){if(h.charCodeAt(o+L)===w)return s.slice(o+L+1);if(L===2)return s.slice(o+L)}i>v&&(g.charCodeAt(r+L)===w?k=L:L===2&&(k=3)),k===-1&&(k=0)}let O="";for(L=r+k+1;L<=n;++L)(L===n||g.charCodeAt(L)===w)&&(O+=O.length===0?"..":"\\..");return o+=k,O.length>0?`${O}${s.slice(o,a)}`:(s.charCodeAt(o)===w&&++o,s.slice(o,a))},toNamespacedPath(g){if(typeof g!="string")return g;if(g.length===0)return"";const h=e.win32.resolve(g);if(h.length<=2)return g;if(h.charCodeAt(0)===w){if(h.charCodeAt(1)===w){const l=h.charCodeAt(2);if(l!==P&&l!==b)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(m(h.charCodeAt(0))&&h.charCodeAt(1)===C&&h.charCodeAt(2)===w)return`\\\\?\\${h}`;return g},dirname(g){f(g,"path");const h=g.length;if(h===0)return".";let l=-1,s=0;const r=g.charCodeAt(0);if(h===1)return u(r)?g:".";if(u(r)){if(l=s=1,u(g.charCodeAt(1))){let o=2,a=o;for(;o<h&&!u(g.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&u(g.charCodeAt(o));)o++;if(o<h&&o!==a){for(a=o;o<h&&!u(g.charCodeAt(o));)o++;if(o===h)return g;o!==a&&(l=s=o+1)}}}}else m(r)&&g.charCodeAt(1)===C&&(l=h>2&&u(g.charCodeAt(2))?3:2,s=l);let n=-1,i=!0;for(let o=h-1;o>=s;--o)if(u(g.charCodeAt(o))){if(!i){n=o;break}}else i=!1;if(n===-1){if(l===-1)return".";n=l}return g.slice(0,n)},basename(g,h){h!==void 0&&f(h,"ext"),f(g,"path");let l=0,s=-1,r=!0,n;if(g.length>=2&&m(g.charCodeAt(0))&&g.charCodeAt(1)===C&&(l=2),h!==void 0&&h.length>0&&h.length<=g.length){if(h===g)return"";let i=h.length-1,o=-1;for(n=g.length-1;n>=l;--n){const a=g.charCodeAt(n);if(u(a)){if(!r){l=n+1;break}}else o===-1&&(r=!1,o=n+1),i>=0&&(a===h.charCodeAt(i)?--i==-1&&(s=n):(i=-1,s=o))}return l===s?s=o:s===-1&&(s=g.length),g.slice(l,s)}for(n=g.length-1;n>=l;--n)if(u(g.charCodeAt(n))){if(!r){l=n+1;break}}else s===-1&&(r=!1,s=n+1);return s===-1?"":g.slice(l,s)},extname(g){f(g,"path");let h=0,l=-1,s=0,r=-1,n=!0,i=0;g.length>=2&&g.charCodeAt(1)===C&&m(g.charCodeAt(0))&&(h=s=2);for(let o=g.length-1;o>=h;--o){const a=g.charCodeAt(o);if(u(a)){if(!n){s=o+1;break}continue}r===-1&&(n=!1,r=o+1),a===b?l===-1?l=o:i!==1&&(i=1):l!==-1&&(i=-1)}return l===-1||r===-1||i===0||i===1&&l===r-1&&l===s+1?"":g.slice(l,r)},format:I.bind(null,"\\"),parse(g){f(g,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return h;const l=g.length;let s=0,r=g.charCodeAt(0);if(l===1)return u(r)?(h.root=h.dir=g,h):(h.base=h.name=g,h);if(u(r)){if(s=1,u(g.charCodeAt(1))){let k=2,L=k;for(;k<l&&!u(g.charCodeAt(k));)k++;if(k<l&&k!==L){for(L=k;k<l&&u(g.charCodeAt(k));)k++;if(k<l&&k!==L){for(L=k;k<l&&!u(g.charCodeAt(k));)k++;k===l?s=k:k!==L&&(s=k+1)}}}}else if(m(r)&&g.charCodeAt(1)===C){if(l<=2)return h.root=h.dir=g,h;if(s=2,u(g.charCodeAt(2))){if(l===3)return h.root=h.dir=g,h;s=3}}s>0&&(h.root=g.slice(0,s));let n=-1,i=s,o=-1,a=!0,c=g.length-1,v=0;for(;c>=s;--c){if(r=g.charCodeAt(c),u(r)){if(!a){i=c+1;break}continue}o===-1&&(a=!1,o=c+1),r===b?n===-1?n=c:v!==1&&(v=1):n!==-1&&(v=-1)}return o!==-1&&(n===-1||v===0||v===1&&n===o-1&&n===i+1?h.base=h.name=g.slice(i,o):(h.name=g.slice(i,n),h.base=g.slice(i,o),h.ext=g.slice(n,o))),i>0&&i!==s?h.dir=g.slice(0,i-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...g){let h="",l=!1;for(let s=g.length-1;s>=-1&&!l;s--){const r=s>=0?g[s]:E.cwd();f(r,"path"),r.length!==0&&(h=`${r}/${h}`,l=r.charCodeAt(0)===d)}return h=y(h,!l,"/",p),l?`/${h}`:h.length>0?h:"."},normalize(g){if(f(g,"path"),g.length===0)return".";const h=g.charCodeAt(0)===d,l=g.charCodeAt(g.length-1)===d;return g=y(g,!h,"/",p),g.length===0?h?"/":l?"./":".":(l&&(g+="/"),h?`/${g}`:g)},isAbsolute(g){return f(g,"path"),g.length>0&&g.charCodeAt(0)===d},join(...g){if(g.length===0)return".";let h;for(let l=0;l<g.length;++l){const s=g[l];f(s,"path"),s.length>0&&(h===void 0?h=s:h+=`/${s}`)}return h===void 0?".":e.posix.normalize(h)},relative(g,h){if(f(g,"from"),f(h,"to"),g===h||(g=e.posix.resolve(g),h=e.posix.resolve(h),g===h))return"";const l=1,s=g.length,r=s-l,n=1,i=h.length-n,o=r<i?r:i;let a=-1,c=0;for(;c<o;c++){const k=g.charCodeAt(l+c);if(k!==h.charCodeAt(n+c))break;k===d&&(a=c)}if(c===o)if(i>o){if(h.charCodeAt(n+c)===d)return h.slice(n+c+1);if(c===0)return h.slice(n+c)}else r>o&&(g.charCodeAt(l+c)===d?a=c:c===0&&(a=0));let v="";for(c=l+a+1;c<=s;++c)(c===s||g.charCodeAt(c)===d)&&(v+=v.length===0?"..":"/..");return`${v}${h.slice(n+a)}`},toNamespacedPath(g){return g},dirname(g){if(f(g,"path"),g.length===0)return".";const h=g.charCodeAt(0)===d;let l=-1,s=!0;for(let r=g.length-1;r>=1;--r)if(g.charCodeAt(r)===d){if(!s){l=r;break}}else s=!1;return l===-1?h?"/":".":h&&l===1?"//":g.slice(0,l)},basename(g,h){h!==void 0&&f(h,"ext"),f(g,"path");let l=0,s=-1,r=!0,n;if(h!==void 0&&h.length>0&&h.length<=g.length){if(h===g)return"";let i=h.length-1,o=-1;for(n=g.length-1;n>=0;--n){const a=g.charCodeAt(n);if(a===d){if(!r){l=n+1;break}}else o===-1&&(r=!1,o=n+1),i>=0&&(a===h.charCodeAt(i)?--i==-1&&(s=n):(i=-1,s=o))}return l===s?s=o:s===-1&&(s=g.length),g.slice(l,s)}for(n=g.length-1;n>=0;--n)if(g.charCodeAt(n)===d){if(!r){l=n+1;break}}else s===-1&&(r=!1,s=n+1);return s===-1?"":g.slice(l,s)},extname(g){f(g,"path");let h=-1,l=0,s=-1,r=!0,n=0;for(let i=g.length-1;i>=0;--i){const o=g.charCodeAt(i);if(o===d){if(!r){l=i+1;break}continue}s===-1&&(r=!1,s=i+1),o===b?h===-1?h=i:n!==1&&(n=1):h!==-1&&(n=-1)}return h===-1||s===-1||n===0||n===1&&h===s-1&&h===l+1?"":g.slice(h,s)},format:I.bind(null,"/"),parse(g){f(g,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(g.length===0)return h;const l=g.charCodeAt(0)===d;let s;l?(h.root="/",s=1):s=0;let r=-1,n=0,i=-1,o=!0,a=g.length-1,c=0;for(;a>=s;--a){const v=g.charCodeAt(a);if(v===d){if(!o){n=a+1;break}continue}i===-1&&(o=!1,i=a+1),v===b?r===-1?r=a:c!==1&&(c=1):r!==-1&&(c=-1)}if(i!==-1){const v=n===0&&l?1:n;r===-1||c===0||c===1&&r===i-1&&r===n+1?h.base=h.name=g.slice(v,i):(h.name=g.slice(v,r),h.base=g.slice(v,i),h.ext=g.slice(r,i))}return n>0?h.dir=g.slice(0,n-1):l&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(X[77],J([0,1,4]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var t;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(t=e.Source||(e.Source={}));var D;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(D=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(b,...d){const w=d.reduce((S,f)=>(S[f]=!0,S),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(S=>!w[S]).forEach(S=>{for(let f=0;f<C.length;f++)if(S.search(C[f])!==-1){delete b[S];break}})}e.sanitizeProcessEnvironment=R;function M(b){!b||(delete b.DEBUG,E.isMacintosh&&delete b.DYLD_LIBRARY_PATH,E.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=M}),define(X[78],J([0,1,4]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const t=E.globals.performance&&typeof E.globals.performance.now=="function";class D{constructor(M){this._highResolution=t&&M,this._startTime=this._now(),this._stopTime=-1}static create(M=!0){return new D(M)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=D}),define(X[3],J([0,1,19,48,2,122,78]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const b=!1,d=!1;var w;(function(a){a.None=()=>D.Disposable.None;function c(W){if(d){const{onListenerDidAdd:U}=W,z=u.create();let Y=0;W.onListenerDidAdd=()=>{++Y==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),z.print()),U?.()}}}function v(W){return(U,z=null,Y)=>{let _=!1,K;return K=W(Z=>{if(!_)return K?K.dispose():_=!0,U.call(z,Z)},null,Y),_&&K.dispose(),K}}a.once=v;function k(W,U,z){return se((Y,_=null,K)=>W(Z=>Y.call(_,U(Z)),null,K),z)}a.map=k;function L(W,U,z){return se((Y,_=null,K)=>W(Z=>{U(Z),Y.call(_,Z)},null,K),z)}a.forEach=L;function O(W,U,z){return se((Y,_=null,K)=>W(Z=>U(Z)&&Y.call(_,Z),null,K),z)}a.filter=O;function F(W){return W}a.signal=F;function j(...W){return(U,z=null,Y)=>(0,D.combinedDisposable)(...W.map(_=>_(K=>U.call(z,K),null,Y)))}a.any=j;function ee(W,U,z,Y){let _=z;return k(W,K=>(_=U(_,K),_),Y)}a.reduce=ee;function se(W,U){let z;const Y={onFirstListenerAdd(){z=W(_.fire,_)},onLastListenerRemove(){z?.dispose()}};U||c(Y);const _=new m(Y);return U?.add(_),_.event}function ae(W,U,z=100,Y=!1,_,K){let Z,ne,le,ge=0;const Ee={leakWarningThreshold:_,onFirstListenerAdd(){Z=W(Pe=>{ge++,ne=U(ne,Pe),Y&&!le&&(Re.fire(ne),ne=void 0),clearTimeout(le),le=setTimeout(()=>{const ke=ne;ne=void 0,le=void 0,(!Y||ge>1)&&Re.fire(ke),ge=0},z)})},onLastListenerRemove(){Z.dispose()}};K||c(Ee);const Re=new m(Ee);return K?.add(Re),Re.event}a.debounce=ae;function ie(W,U=(Y,_)=>Y===_,z){let Y=!0,_;return O(W,K=>{const Z=Y||!U(K,_);return Y=!1,_=K,Z},z)}a.latch=ie;function ce(W,U,z){return[a.filter(W,U,z),a.filter(W,Y=>!U(Y),z)]}a.split=ce;function H(W,U=!1,z=[]){let Y=z.slice(),_=W(ne=>{Y?Y.push(ne):Z.fire(ne)});const K=()=>{Y?.forEach(ne=>Z.fire(ne)),Y=null},Z=new m({onFirstListenerAdd(){_||(_=W(ne=>Z.fire(ne)))},onFirstListenerDidAdd(){Y&&(U?setTimeout(K):K())},onLastListenerRemove(){_&&_.dispose(),_=null}});return Z.event}a.buffer=H;class re{constructor(U){this.event=U,this.disposables=new D.DisposableStore}map(U){return new re(k(this.event,U,this.disposables))}forEach(U){return new re(L(this.event,U,this.disposables))}filter(U){return new re(O(this.event,U,this.disposables))}reduce(U,z){return new re(ee(this.event,U,z,this.disposables))}latch(){return new re(ie(this.event,void 0,this.disposables))}debounce(U,z=100,Y=!1,_){return new re(ae(this.event,U,z,Y,_,this.disposables))}on(U,z,Y){return this.event(U,z,Y)}once(U,z,Y){return v(this.event)(U,z,Y)}dispose(){this.disposables.dispose()}}function q(W){return new re(W)}a.chain=q;function T(W,U,z=Y=>Y){const Y=(...ne)=>Z.fire(z(...ne)),_=()=>W.on(U,Y),K=()=>W.removeListener(U,Y),Z=new m({onFirstListenerAdd:_,onLastListenerRemove:K});return Z.event}a.fromNodeEventEmitter=T;function N(W,U,z=Y=>Y){const Y=(...ne)=>Z.fire(z(...ne)),_=()=>W.addEventListener(U,Y),K=()=>W.removeEventListener(U,Y),Z=new m({onFirstListenerAdd:_,onLastListenerRemove:K});return Z.event}a.fromDOMEventEmitter=N;function V(W){return new Promise(U=>v(W)(U))}a.toPromise=V;function te(W,U){return U(void 0),W(z=>U(z))}a.runAndSubscribe=te;function $(W,U){let z=null;function Y(K){z?.dispose(),z=new D.DisposableStore,U(K,z)}Y(void 0);const _=W(K=>Y(K));return(0,D.toDisposable)(()=>{_.dispose(),z?.dispose()})}a.runAndSubscribeWithStore=$;class Q{constructor(U,z){this.obs=U,this._counter=0,this._hasChanged=!1;const Y={onFirstListenerAdd:()=>{U.addObserver(this)},onLastListenerRemove:()=>{U.removeObserver(this)}};z||c(Y),this.emitter=new m(Y),z&&z.add(this.emitter)}beginUpdate(U){this._counter++}handleChange(U,z){this._hasChanged=!0}endUpdate(U){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function A(W,U){return new Q(W,U).emitter.event}a.fromObservable=A})(w=e.Event||(e.Event={}));class C{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${C._idPool++}`}start(c){this._stopWatch=new M.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}C._idPool=0;let P=-1;function S(a){const c=P;return P=a,{dispose(){P=c}}}e.setGlobalLeakWarningThreshold=S;class f{constructor(c,v=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c,v){let k=P;if(typeof this.customThreshold=="number"&&(k=this.customThreshold),k<=0||v<k)return;this._stacks||(this._stacks=new Map);const L=this._stacks.get(c.value)||0;if(this._stacks.set(c.value,L+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=k*.5;let O,F=0;for(const[j,ee]of this._stacks)(!O||F<ee)&&(O=j,F=ee);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${F}):`),console.warn(O)}return()=>{const O=this._stacks.get(c.value)||0;this._stacks.set(c.value,O-1)}}}class u{constructor(c){this.value=c}static create(){return new u(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(c,v,k){this.callback=c,this.callbackThis=v,this.stack=k,this.subscription=new D.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class m{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=P>0?new f(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new C(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const c=Array.from(this._listeners);queueMicrotask(()=>{for(const v of c)v.subscription.isset()&&(v.subscription.unset(),v.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(c,v,k)=>{this._listeners||(this._listeners=new R.LinkedList);const L=this._listeners.isEmpty();L&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let O,F;this._leakageMon&&this._listeners.size>=30&&(F=u.create(),O=this._leakageMon.check(F,this._listeners.size+1)),b&&(F=F??u.create());const j=new p(c,v,F),ee=this._listeners.push(j);L&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,v);const se=j.subscription.set(()=>{O?.(),this._disposed||(ee(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return k instanceof D.DisposableStore?k.add(se):Array.isArray(k)&&k.push(se),se}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new I);for(const v of this._listeners)this._deliveryQueue.push(this,v,c);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=m;class y{constructor(){this._queue=new R.LinkedList}get size(){return this._queue.size}push(c,v,k){this._queue.push(new g(c,v,k))}clear(c){const v=new R.LinkedList;for(const k of this._queue)k.emitter!==c&&v.push(k);this._queue=v}deliver(){for(;this._queue.size>0;){const c=this._queue.shift();try{c.listener.invoke(c.event)}catch(v){(0,E.onUnexpectedError)(v)}}}}e.EventDeliveryQueue=y;class I extends y{clear(c){this._queue.clear()}}class g{constructor(c,v,k){this.emitter=c,this.listener=v,this.event=k}}class h extends m{async fireAsync(c,v,k){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new R.LinkedList);for(const L of this._listeners)this._asyncDeliveryQueue.push([L,c]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[L,O]=this._asyncDeliveryQueue.shift(),F=[],j={...O,token:v,waitUntil:ee=>{if(Object.isFrozen(F))throw new Error("waitUntil can NOT be called asynchronous");k&&(ee=k(ee,L.callback)),F.push(ee)}};try{L.invoke(j)}catch(ee){(0,E.onUnexpectedError)(ee);continue}Object.freeze(F),await Promise.allSettled(F).then(ee=>{for(const se of ee)se.status==="rejected"&&(0,E.onUnexpectedError)(se.reason)})}}}}e.AsyncEmitter=h;class l extends m{constructor(c){super(c);this._isPaused=0,this._eventQueue=new R.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=l;class s extends l{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=s;class r extends m{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(v=>super.fire(v)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class n{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new m({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const v={event:c,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const k=()=>{this.hasListeners&&this.unhook(v);const L=this.events.indexOf(v);this.events.splice(L,1)};return(0,D.toDisposable)((0,t.once)(k))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(v=>this.emitter.fire(v))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=n;class i{constructor(){this.buffers=[]}wrapEvent(c){return(v,k,L)=>c(O=>{const F=this.buffers[this.buffers.length-1];F?F.push(()=>v.call(k,O)):v.call(k,O)},void 0,L)}bufferEvents(c){const v=[];this.buffers.push(v);const k=c();return this.buffers.pop(),v.forEach(L=>L()),k}}e.EventBufferer=i;class o{constructor(){this.listening=!1,this.inputEvent=w.None,this.inputEventListener=D.Disposable.None,this.emitter=new m({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(X[21],J([0,1,3]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const t=Object.freeze(function(b,d){const w=setTimeout(b.bind(d),0);return{dispose(){clearTimeout(w)}}});var D;(function(b){function d(w){return w===b.None||w===b.Cancelled||w instanceof R?!0:!w||typeof w!="object"?!1:typeof w.isCancellationRequested=="boolean"&&typeof w.onCancellationRequested=="function"}b.isCancellationToken=d,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:t})})(D=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?t:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class M{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new R),this._token}cancel(){this._token?this._token instanceof R&&this._token.cancel():this._token=D.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof R&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=M}),define(X[135],J([0,1,21]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class t{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new E.CancellationTokenSource,d=this.task(b.token);return this.result={promise:d,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=t;class D{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const d=JSON.stringify(b);return this.lastArgKey!==d&&(this.lastArgKey=d,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=D;class R{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const d=this.fn(b);return this._map.set(b,d),d}}e.CachedFunction=R}),define(X[91],J([0,1,3,2]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const D=M=>({onDidChange:E.Event.None,value:M});e.staticObservableValue=D;class R extends t.Disposable{constructor(b){super();this._value=b,this.changeEmitter=this._register(new E.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}}e.MutableObservableValue=R}),define(X[31],J([0,1,135,121]),function(B,e,E,t){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=R;const M=/{(\d+)}/g;function b(G,...oe){return oe.length===0?G:G.replace(M,function(de,me){const be=parseInt(me,10);return isNaN(be)||be<0||be>=oe.length?de:oe[be]})}e.format=b;const d=/{([^}]+)}/g;function w(G,oe){return G.replace(d,(de,me)=>oe[me]??de)}e.format2=w;function C(G){return G.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}e.escape=C;function P(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function S(G,oe){let de=0;const me=oe.charCodeAt(0);for(let be=G.length-1;be>=0;be--)G.charCodeAt(be)===me&&de++;return de}e.count=S;function f(G,oe,de="\u2026"){return G.length<=oe?G:`${G.substr(0,oe)}${de}`}e.truncate=f;function u(G,oe=" "){const de=p(G,oe);return m(de,oe)}e.trim=u;function p(G,oe){if(!G||!oe)return G;const de=oe.length;if(de===0||G.length===0)return G;let me=0;for(;G.indexOf(oe,me)===me;)me=me+de;return G.substring(me)}e.ltrim=p;function m(G,oe){if(!G||!oe)return G;const de=oe.length,me=G.length;if(de===0||me===0)return G;let be=me,Le=-1;for(;Le=G.lastIndexOf(oe,be-1),!(Le===-1||Le+de!==be);){if(Le===0)return"";be=Le}return G.substring(0,be)}e.rtrim=m;function y(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=y;function I(G){return G.replace(/\*/g,"")}e.stripWildcards=I;function g(G,oe,de={}){if(!G)throw new Error("Cannot create regex from empty string");oe||(G=P(G)),de.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let me="";return de.global&&(me+="g"),de.matchCase||(me+="i"),de.multiline&&(me+="m"),de.unicode&&(me+="u"),new RegExp(G,me)}e.createRegExp=g;function h(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=h;function l(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=l;function s(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=s;function r(G){return G.split(/\r\n|\r|\n/)}e.splitLines=r;function n(G){for(let oe=0,de=G.length;oe<de;oe++){const me=G.charCodeAt(oe);if(me!==32&&me!==9)return oe}return-1}e.firstNonWhitespaceIndex=n;function i(G,oe=0,de=G.length){for(let me=oe;me<de;me++){const be=G.charCodeAt(me);if(be!==32&&be!==9)return G.substring(oe,me)}return G.substring(oe,de)}e.getLeadingWhitespace=i;function o(G,oe=G.length-1){for(let de=oe;de>=0;de--){const me=G.charCodeAt(de);if(me!==32&&me!==9)return de}return-1}e.lastNonWhitespaceIndex=o;function a(G,oe,de){const me=[];let be=0;for(const Le of G.matchAll(oe)){if(me.push(G.slice(be,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");be=Le.index+Le[0].length,me.push(de(Le[0],...Le.slice(1),Le.index,G,Le.groups))}return me.push(G.slice(be)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=a;function c(G,oe){return G<oe?-1:G>oe?1:0}e.compare=c;function v(G,oe,de=0,me=G.length,be=0,Le=oe.length){for(;de<me&&be<Le;de++,be++){const et=G.charCodeAt(de),qe=oe.charCodeAt(be);if(et<qe)return-1;if(et>qe)return 1}const He=me-de,nt=Le-be;return He<nt?-1:He>nt?1:0}e.compareSubstring=v;function k(G,oe){return L(G,oe,0,G.length,0,oe.length)}e.compareIgnoreCase=k;function L(G,oe,de=0,me=G.length,be=0,Le=oe.length){for(;de<me&&be<Le;de++,be++){let et=G.charCodeAt(de),qe=oe.charCodeAt(be);if(et===qe)continue;if(et>=128||qe>=128)return v(G.toLowerCase(),oe.toLowerCase(),de,me,be,Le);F(et)&&(et-=32),F(qe)&&(qe-=32);const Je=et-qe;if(Je!==0)return Je}const He=me-de,nt=Le-be;return He<nt?-1:He>nt?1:0}e.compareSubstringIgnoreCase=L;function O(G){return G>=48&&G<=57}e.isAsciiDigit=O;function F(G){return G>=97&&G<=122}e.isLowerAsciiLetter=F;function j(G){return G>=65&&G<=90}e.isUpperAsciiLetter=j;function ee(G,oe){return G.length===oe.length&&L(G,oe)===0}e.equalsIgnoreCase=ee;function se(G,oe){const de=oe.length;return oe.length>G.length?!1:L(G,oe,0,de)===0}e.startsWithIgnoreCase=se;function ae(G,oe){const de=Math.min(G.length,oe.length);let me;for(me=0;me<de;me++)if(G.charCodeAt(me)!==oe.charCodeAt(me))return me;return de}e.commonPrefixLength=ae;function ie(G,oe){const de=Math.min(G.length,oe.length);let me;const be=G.length-1,Le=oe.length-1;for(me=0;me<de;me++)if(G.charCodeAt(be-me)!==oe.charCodeAt(Le-me))return me;return de}e.commonSuffixLength=ie;function ce(G){return 55296<=G&&G<=56319}e.isHighSurrogate=ce;function H(G){return 56320<=G&&G<=57343}e.isLowSurrogate=H;function re(G,oe){return(G-55296<<10)+(oe-56320)+65536}e.computeCodePoint=re;function q(G,oe,de){const me=G.charCodeAt(de);if(ce(me)&&de+1<oe){const be=G.charCodeAt(de+1);if(H(be))return re(me,be)}return me}e.getNextCodePoint=q;function T(G,oe){const de=G.charCodeAt(oe-1);if(H(de)&&oe>1){const me=G.charCodeAt(oe-2);if(ce(me))return re(me,de)}return de}class N{constructor(oe,de=0){this._str=oe,this._len=oe.length,this._offset=de}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=T(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=q(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}e.CodePointIterator=N;class V{constructor(oe,de=0){this._iterator=new N(oe,de)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Te.getInstance(),de=this._iterator,me=de.offset;let be=oe.getGraphemeBreakType(de.nextCodePoint());for(;!de.eol();){const Le=de.offset,He=oe.getGraphemeBreakType(de.nextCodePoint());if(Me(be,He)){de.setOffset(Le);break}be=He}return de.offset-me}prevGraphemeLength(){const oe=Te.getInstance(),de=this._iterator,me=de.offset;let be=oe.getGraphemeBreakType(de.prevCodePoint());for(;de.offset>0;){const Le=de.offset,He=oe.getGraphemeBreakType(de.prevCodePoint());if(Me(He,be)){de.setOffset(Le);break}be=He}return me-de.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=V;function te(G,oe){return new V(G,oe).nextGraphemeLength()}e.nextCharLength=te;function $(G,oe){return new V(G,oe).prevGraphemeLength()}e.prevCharLength=$;function Q(G,oe){oe>0&&H(G.charCodeAt(oe))&&oe--;const de=oe+te(G,oe);return[de-$(G,de),de]}e.getCharContainingOffset=Q;const A=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(G){return A.test(G)}e.containsRTL=W;const U=/^[\t\n\r\x20-\x7E]*$/;function z(G){return U.test(G)}e.isBasicASCII=z,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=Y;function _(G){return G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=_;function K(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129008||G>=129280&&G<=129535||G>=129648&&G<=129782}e.isEmojiImprecise=K;function Z(G,oe){if(G.length<oe)return G;const de=/\b/g;let me=0;for(;de.test(G)&&!(G.length-de.lastIndex<oe);)me=de.lastIndex,de.lastIndex+=1;return G.substring(me).replace(/^\s/,"")}e.lcut=Z;const ne=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ge=/\x1b\[0?m/g;function Ee(G){return G&&(G=G.replace(ne,""),G=G.replace(le,""),G=G.replace(ge,"")),G}e.removeAnsiEscapeCodes=Ee,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Re(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Re;function Pe(G){return Re(G)?G.substr(1):G}e.stripUTF8BOM=Pe;function ke(G,oe){if(!G||!oe||G.length<oe.length)return!1;const de=oe.length,me=G.toLowerCase();let be=0,Le=-1;for(;be<de;){const He=me.indexOf(oe[be],Le+1);if(He<0)return!1;Le=He,be++}return!0}e.fuzzyContains=ke;function Ne(G,oe=!1){return G?(oe&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ne;function ue(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=ue;function he(G,oe=1){if(oe===0)return"";let de=-1;do de=G.indexOf(`
`,de+1),oe--;while(oe>0&&de>=0);return de===-1?G:(G[de-1]==="\r"&&de--,G.substr(0,de))}e.getNLines=he;function pe(G){const oe=90-65+1;return G=G%(2*oe),G<oe?String.fromCharCode(97+G):String.fromCharCode(65+G-oe)}e.singleLetterHash=pe;function Ie(G){return Te.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=Ie;function Me(G,oe){return G===0?oe!==5&&oe!==7:G===2&&oe===3?!1:G===4||G===2||G===3||oe===4||oe===2||oe===3?!0:!(G===8&&(oe===8||oe===9||oe===11||oe===12)||(G===11||G===9)&&(oe===9||oe===10)||(G===12||G===10)&&oe===10||oe===5||oe===13||oe===7||G===1||G===13&&oe===14||G===6&&oe===6)}var Xe;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Xe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Te{constructor(){this._data=Oe()}static getInstance(){return Te._INSTANCE||(Te._INSTANCE=new Te),Te._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const de=this._data,me=de.length/3;let be=1;for(;be<=me;)if(oe<de[3*be])be=2*be;else if(oe>de[3*be+1])be=2*be+1;else return de[3*be+2];return 0}}Te._INSTANCE=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ae(G,oe){if(G===0)return 0;const de=je(G,oe);if(de!==void 0)return de;const me=new N(oe,G);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=Ae;function je(G,oe){const de=new N(oe,G);let me=de.prevCodePoint();for(;Qe(me)||me===65039||me===8419;){if(de.offset===0)return;me=de.prevCodePoint()}if(!K(me))return;let be=de.offset;return be>0&&de.prevCodePoint()===8205&&(be=de.offset),be}function Qe(G){return 127995<=G&&G<=127999}var Ze;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(Ze||(Ze={})),e.noBreakWhitespace="\xA0";class ze{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return ze.cache.get(Array.from(oe))}static getLocales(){return ze._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=ze,D=ze,ze.ambiguousCharacterData=new t.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),ze.cache=new E.LRUCachedFunction(G=>{function oe(qe){const Je=new Map;for(let xe=0;xe<qe.length;xe+=2)Je.set(qe[xe],qe[xe+1]);return Je}function de(qe,Je){const xe=new Map(qe);for(const[at,ct]of Je)xe.set(at,ct);return xe}function me(qe,Je){if(!qe)return Je;const xe=new Map;for(const[at,ct]of qe)Je.has(at)&&xe.set(at,ct);return xe}const be=D.ambiguousCharacterData.getValue();let Le=G.filter(qe=>!qe.startsWith("_")&&qe in be);Le.length===0&&(Le=["_default"]);let He;for(const qe of Le){const Je=oe(be[qe]);He=me(He,Je)}const nt=oe(be._common),et=de(nt,He);return new ze(et)}),ze._locales=new t.Lazy(()=>Object.keys(ze.ambiguousCharacterData.getValue()).filter(G=>!G.startsWith("_")));class Ve{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ve.getRawData())),this._data}static isInvisibleCharacter(oe){return Ve.getData().has(oe)}static get codePoints(){return Ve.getData()}}e.InvisibleCharacters=Ve,Ve._data=void 0}),define(X[30],J([0,1,9,4,31,13]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function M(o){return o===47||o===92}e.isPathSeparator=M;function b(o){return o.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=b;function d(o){return o.indexOf("/")===-1&&(o=b(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=d;function w(o,a=E.posix.sep){if(!o)return"";const c=o.length,v=o.charCodeAt(0);if(M(v)){if(M(o.charCodeAt(1))&&!M(o.charCodeAt(2))){let L=3;const O=L;for(;L<c&&!M(o.charCodeAt(L));L++);if(O!==L&&!M(o.charCodeAt(L+1))){for(L+=1;L<c;L++)if(M(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,a)}}return a}else if(y(v)&&o.charCodeAt(1)===58)return M(o.charCodeAt(2))?o.slice(0,2)+a:o.slice(0,2);let k=o.indexOf("://");if(k!==-1){for(k+=3;k<c;k++)if(M(o.charCodeAt(k)))return o.slice(0,k+1)}return""}e.getRoot=w;function C(o){if(!t.isWindows||!o||o.length<5)return!1;let a=o.charCodeAt(0);if(a!==92||(a=o.charCodeAt(1),a!==92))return!1;let c=2;const v=c;for(;c<o.length&&(a=o.charCodeAt(c),a!==92);c++);return!(v===c||(a=o.charCodeAt(c+1),isNaN(a)||a===92))}e.isUNC=C;const P=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(o,a=t.isWindows){const c=a?P:S;return!(!o||o.length===0||/^\s+$/.test(o)||(c.lastIndex=0,c.test(o))||a&&f.test(o)||o==="."||o===".."||a&&o[o.length-1]==="."||a&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=u;function p(o,a,c){const v=o===a;return!c||v?v:!o||!a?!1:(0,D.equalsIgnoreCase)(o,a)}e.isEqual=p;function m(o,a,c,v=E.sep){if(o===a)return!0;if(!o||!a||a.length>o.length)return!1;if(c){if(!(0,D.startsWithIgnoreCase)(o,a))return!1;if(a.length===o.length)return!0;let L=a.length;return a.charAt(a.length-1)===v&&L--,o.charAt(L)===v}return a.charAt(a.length-1)!==v&&(a+=v),o.indexOf(a)===0}e.isEqualOrParent=m;function y(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=y;function I(o,a){return t.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(a,o)),o=(0,E.normalize)(o),t.isWindows?(o=(0,D.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,D.rtrim)(o,E.sep),o||(o=E.sep)),o}e.sanitizeFilePath=I;function g(o){const a=(0,E.normalize)(o);return t.isWindows?o.length>3?!1:h(a)&&(o.length===2||a.charCodeAt(2)===92):a===E.posix.sep}e.isRootOrDriveLetter=g;function h(o,a=t.isWindows){return a?y(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=h;function l(o){return h(o)?o[0]:void 0}e.getDriveLetter=l;function s(o,a,c){return a.length>o.length?-1:o===a?0:(c&&(o=o.toLowerCase(),a=a.toLowerCase()),o.indexOf(a))}e.indexOfPath=s;function r(o){const a=o.split(":");let c,v,k;for(const L of a){const O=Number(L);(0,R.isNumber)(O)?v===void 0?v=O:k===void 0&&(k=O):c=c?[c,L].join(":"):L}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:v!==void 0?v:void 0,column:k!==void 0?k:v!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,a,c=8){let v="";for(let L=0;L<c;L++)v+=n.charAt(Math.floor(Math.random()*n.length));let k;return a?k=`${a}-${v}`:k=v,o?(0,E.join)(o,k):k}e.randomPath=i}),define(X[65],J([0,1,31]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function t(y){return D(y,0)}e.hash=t;function D(y,I){switch(typeof y){case"object":return y===null?R(349,I):Array.isArray(y)?d(y,I):w(y,I);case"string":return b(y,I);case"boolean":return M(y,I);case"number":return R(y,I);case"undefined":return R(937,I);default:return R(617,I)}}e.doHash=D;function R(y,I){return(I<<5)-I+y|0}e.numberHash=R;function M(y,I){return R(y?433:863,I)}function b(y,I){I=R(149417,I);for(let g=0,h=y.length;g<h;g++)I=R(y.charCodeAt(g),I);return I}e.stringHash=b;function d(y,I){return I=R(104579,I),y.reduce((g,h)=>D(h,g),I)}function w(y,I){return I=R(181387,I),Object.keys(y).sort().reduce((g,h)=>(g=b(h,g),D(y[h],g)),I)}class C{constructor(){this._value=0}get value(){return this._value}hash(I){return this._value=D(I,this._value),this._value}}e.Hasher=C;var P;(function(y){y[y.BLOCK_SIZE=64]="BLOCK_SIZE",y[y.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function S(y,I,g=32){const h=g-I,l=~((1<<h)-1);return(y<<I|(l&y)>>>h)>>>0}function f(y,I=0,g=y.byteLength,h=0){for(let l=0;l<g;l++)y[I+l]=h}function u(y,I,g="0"){for(;y.length<I;)y=g+y;return y}function p(y,I=32){return y instanceof ArrayBuffer?Array.from(new Uint8Array(y)).map(g=>g.toString(16).padStart(2,"0")).join(""):u((y>>>0).toString(16),I/4)}e.toHexString=p;class m{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(I){const g=I.length;if(g===0)return;const h=this._buff;let l=this._buffLen,s=this._leftoverHighSurrogate,r,n;for(s!==0?(r=s,n=-1,s=0):(r=I.charCodeAt(0),n=0);;){let i=r;if(E.isHighSurrogate(r))if(n+1<g){const o=I.charCodeAt(n+1);E.isLowSurrogate(o)?(n++,i=E.computeCodePoint(r,o)):i=65533}else{s=r;break}else E.isLowSurrogate(r)&&(i=65533);if(l=this._push(h,l,i),n++,n<g)r=I.charCodeAt(n);else break}this._buffLen=l,this._leftoverHighSurrogate=s}_push(I,g,h){return h<128?I[g++]=h:h<2048?(I[g++]=192|(h&1984)>>>6,I[g++]=128|(h&63)>>>0):h<65536?(I[g++]=224|(h&61440)>>>12,I[g++]=128|(h&4032)>>>6,I[g++]=128|(h&63)>>>0):(I[g++]=240|(h&1835008)>>>18,I[g++]=128|(h&258048)>>>12,I[g++]=128|(h&4032)>>>6,I[g++]=128|(h&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,I[0]=I[64+0],I[1]=I[64+1],I[2]=I[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,f(this._buff,this._buffLen),this._buffLen>56&&(this._step(),f(this._buff));const I=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(I/4294967296),!1),this._buffDV.setUint32(60,I%4294967296,!1),this._step()}_step(){const I=m._bigBlock32,g=this._buffDV;for(let c=0;c<64;c+=4)I.setUint32(c,g.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)I.setUint32(c,S(I.getUint32(c-12,!1)^I.getUint32(c-32,!1)^I.getUint32(c-56,!1)^I.getUint32(c-64,!1),1),!1);let h=this._h0,l=this._h1,s=this._h2,r=this._h3,n=this._h4,i,o,a;for(let c=0;c<80;c++)c<20?(i=l&s|~l&r,o=1518500249):c<40?(i=l^s^r,o=1859775393):c<60?(i=l&s|l&r|s&r,o=2400959708):(i=l^s^r,o=3395469782),a=S(h,5)+i+n+o+I.getUint32(c*4,!1)&4294967295,n=r,r=s,s=S(l,30),l=h,h=a;this._h0=this._h0+h&4294967295,this._h1=this._h1+l&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=m,m._bigBlock32=new DataView(new ArrayBuffer(320))}),define(X[33],J([0,1,25,31]),function(B,e,E,t){"use strict";var D,R,M;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(n,i,o){let a=n.get(i);return a===void 0&&(a=o,n.set(i,a)),a}e.getOrSet=b;function d(n){const i=[];return n.forEach((o,a)=>{i.push(`${a} => ${o}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=d;function w(n){const i=[];return n.forEach(o=>{i.push(o)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=w;class C{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),a=this._value.charCodeAt(this._pos);return o-a}value(){return this._value[this._pos]}}e.StringIterator=C;class P{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=P;class S{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const a=this._value.charCodeAt(o);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,t.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,t.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=S;var f;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(f||(f={}));class u{constructor(i,o){this._ignorePathCasing=i,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new S(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,t.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,t.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,t.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,t.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=u;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var m;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(m||(m={}));class y{constructor(i){this._iter=i}static forUris(i=()=>!1,o=()=>!1){return new y(new u(i,o))}static forPaths(i=!1){return new y(new S(void 0,!i))}static forStrings(){return new y(new C)}static forConfigKeys(){return new y(new P)}clear(){this._root=void 0}fill(i,o){if(o){const a=o.slice(0);(0,E.shuffle)(a);for(const c of a)this.set(c,i)}else{const a=i.slice(0);(0,E.shuffle)(a);for(const c of a)this.set(c[0],c[1])}}set(i,o){const a=this._iter.reset(i);let c;this._root||(this._root=new p,this._root.segment=a.value());const v=[];for(c=this._root;;){const L=a.cmp(c.segment);if(L>0)c.left||(c.left=new p,c.left.segment=a.value()),v.push([-1,c]),c=c.left;else if(L<0)c.right||(c.right=new p,c.right.segment=a.value()),v.push([1,c]),c=c.right;else if(a.hasNext())a.next(),c.mid||(c.mid=new p,c.mid.segment=a.value()),v.push([0,c]),c=c.mid;else break}const k=c.value;c.value=o,c.key=i;for(let L=v.length-1;L>=0;L--){const O=v[L][1];O.updateHeight();const F=O.balanceFactor();if(F<-1||F>1){const j=v[L][0],ee=v[L+1][0];if(j===1&&ee===1)v[L][1]=O.rotateLeft();else if(j===-1&&ee===-1)v[L][1]=O.rotateRight();else if(j===1&&ee===-1)O.right=v[L+1][1]=v[L+1][1].rotateRight(),v[L][1]=O.rotateLeft();else if(j===-1&&ee===1)O.left=v[L+1][1]=v[L+1][1].rotateLeft(),v[L][1]=O.rotateRight();else throw new Error;if(L>0)switch(v[L-1][0]){case-1:v[L-1][1].left=v[L][1];break;case 1:v[L-1][1].right=v[L][1];break;case 0:v[L-1][1].mid=v[L][1];break}else this._root=v[0][1]}}return k}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let a=this._root;for(;a;){const c=o.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else break}return a}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const a=this._iter.reset(i),c=[];let v=this._root;for(;v;){const k=a.cmp(v.segment);if(k>0)c.push([-1,v]),v=v.left;else if(k<0)c.push([1,v]),v=v.right;else if(a.hasNext())a.next(),c.push([0,v]),v=v.mid;else break}if(!!v){if(o?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const k=this._min(v.right),{key:L,value:O,segment:F}=k;this._delete(k.key,!1),v.key=L,v.value=O,v.segment=F}else{const k=v.left??v.right;if(c.length>0){const[L,O]=c[c.length-1];switch(L){case-1:O.left=k;break;case 0:O.mid=k;break;case 1:O.right=k;break}}else this._root=k}for(let k=c.length-1;k>=0;k--){const L=c[k][1];L.updateHeight();const O=L.balanceFactor();if(O>1?(L.right.balanceFactor()>=0||(L.right=L.right.rotateRight()),c[k][1]=L.rotateLeft()):O<-1&&(L.left.balanceFactor()<=0||(L.left=L.left.rotateLeft()),c[k][1]=L.rotateRight()),k>0)switch(c[k-1][0]){case-1:c[k-1][1].left=c[k][1];break;case 1:c[k-1][1].right=c[k][1];break;case 0:c[k-1][1].mid=c[k][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let a=this._root,c;for(;a;){const v=o.cmp(a.segment);if(v>0)a=a.left;else if(v<0)a=a.right;else if(o.hasNext())o.next(),c=a.value||c,a=a.mid;else break}return a&&a.value||c}findSuperstr(i){const o=this._iter.reset(i);let a=this._root;for(;a;){const c=o.cmp(a.segment);if(c>0)a=a.left;else if(c<0)a=a.right;else if(o.hasNext())o.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(i){for(const[o,a]of this)i(a,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const o=[];return this._dfsEntries(i,o),o[Symbol.iterator]()}_dfsEntries(i,o){!i||(i.left&&this._dfsEntries(i.left,o),i.value&&o.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,o),i.right&&this._dfsEntries(i.right,o))}_isBalanced(){const i=o=>{if(!o)return!0;const a=o.balanceFactor();return a<-1||a>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=y;class I{constructor(i,o){this.uri=i,this.value=o}}class g{constructor(i,o){this[D]="ResourceMap",i instanceof g?(this.map=new Map(i.map),this.toKey=o??g.defaultToKey):(this.map=new Map,this.toKey=i??g.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new I(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(const[a,c]of this.map)i(c.value,c.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(D=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=g,g.defaultToKey=n=>n.toString();class h{constructor(i,o){this[R]="ResourceSet",!i||typeof i=="function"?this._map=new g(i):(this._map=new g(o),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,o){this._map.forEach((a,c)=>i.call(o,c,c,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=h;var l;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class s{constructor(){this[M]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const a=this._map.get(i);if(!!a)return o!==0&&this.touch(a,o),a.value}set(i,o,a=0){let c=this._map.get(i);if(c)c.value=o,a!==0&&this.touch(c,a);else{switch(c={key:i,value:o,next:void 0,previous:void 0},a){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const a=this._state;let c=this._head;for(;c;){if(o?i.bind(o)(c.value,c.key,this):i(c.value,c.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,o=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.key,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return c}values(){const i=this,o=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.value,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return c}entries(){const i=this,o=this._state;let a=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:[a.key,a.value],done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return c}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,a=this.size;for(;o&&a>i;)this._map.delete(o.key),o=o.next,a--;this._head=o,this._size=a,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,a=i.previous;if(!o||!a)throw new Error("Invalid list");o.previous=a,a.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const a=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(a.previous=c,c.next=a),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const a=i.next,c=i.previous;i===this._head?(a.previous=void 0,this._head=a):(a.previous=c,c.next=a),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,a)=>{i.push([a,o])}),i}fromJSON(i){this.clear();for(const[o,a]of i)this.set(o,a)}}e.LinkedMap=s;class r extends s{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(X[79],J([0,1,33]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const t=new E.LRUCache(1e4);function D(w){return d(w,"NFC",t)}e.normalizeNFC=D;const R=new E.LRUCache(1e4);function M(w){return d(w,"NFD",R)}e.normalizeNFD=M;const b=/[^\u0000-\u0080]/;function d(w,C,P){if(!w)return w;const S=P.get(w);if(S)return S;let f;return b.test(w)?f=w.normalize(C):f=w,P.set(w,f),f}e.removeAccents=function(){const w=/[\u0300-\u036f]/g;return function(C){return M(C).replace(w,"")}}()}),define(X[7],J([0,1,9,4]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,R=/^\//,M=/^\/\//;function b(n,i){if(!n.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!D.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!R.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(M.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(n,i){return!n&&!i?"file":n}function w(n,i){switch(n){case"https":case"http":case"file":i?i[0]!==P&&(i=P+i):i=P;break}return i}const C="",P="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{constructor(i,o,a,c,v,k=!1){typeof i=="object"?(this.scheme=i.scheme||C,this.authority=i.authority||C,this.path=i.path||C,this.query=i.query||C,this.fragment=i.fragment||C):(this.scheme=d(i,k),this.authority=o||C,this.path=w(this.scheme,a||C),this.query=c||C,this.fragment=v||C,b(this,k))}static isUri(i){return i instanceof f?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return g(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:a,path:c,query:v,fragment:k}=i;return o===void 0?o=this.scheme:o===null&&(o=C),a===void 0?a=this.authority:a===null&&(a=C),c===void 0?c=this.path:c===null&&(c=C),v===void 0?v=this.query:v===null&&(v=C),k===void 0?k=this.fragment:k===null&&(k=C),o===this.scheme&&a===this.authority&&c===this.path&&v===this.query&&k===this.fragment?this:new p(o,a,c,v,k)}static parse(i,o=!1){const a=S.exec(i);return a?new p(a[2]||C,r(a[4]||C),r(a[5]||C),r(a[7]||C),r(a[9]||C),o):new p(C,C,C,C,C)}static file(i){let o=C;if(t.isWindows&&(i=i.replace(/\\/g,P)),i[0]===P&&i[1]===P){const a=i.indexOf(P,2);a===-1?(o=i.substring(2),i=P):(o=i.substring(2,a),i=i.substring(a)||P)}return new p("file",o,i,C,C)}static from(i){const o=new p(i.scheme,i.authority,i.path,i.query,i.fragment);return b(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return t.isWindows&&i.scheme==="file"?a=f.file(E.win32.join(g(i,!0),...o)).path:a=E.posix.join(i.path,...o),i.with({path:a})}toString(i=!1){return h(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof f)return i;{const o=new p(i);return o._formatted=i.external,o._fsPath=i._sep===u?i.fsPath:null,o}}else return i}}e.URI=f;const u=t.isWindows?1:void 0;class p extends f{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(i=!1){return i?h(this,!0):(this._formatted||(this._formatted=h(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=u),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const m={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function y(n,i){let o,a=-1;for(let c=0;c<n.length;c++){const v=n.charCodeAt(c);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||i&&v===47)a!==-1&&(o+=encodeURIComponent(n.substring(a,c)),a=-1),o!==void 0&&(o+=n.charAt(c));else{o===void 0&&(o=n.substr(0,c));const k=m[v];k!==void 0?(a!==-1&&(o+=encodeURIComponent(n.substring(a,c)),a=-1),o+=k):a===-1&&(a=c)}}return a!==-1&&(o+=encodeURIComponent(n.substring(a))),o!==void 0?o:n}function I(n){let i;for(let o=0;o<n.length;o++){const a=n.charCodeAt(o);a===35||a===63?(i===void 0&&(i=n.substr(0,o)),i+=m[a]):i!==void 0&&(i+=n[o])}return i!==void 0?i:n}function g(n,i){let o;return n.authority&&n.path.length>1&&n.scheme==="file"?o=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?i?o=n.path.substr(1):o=n.path[1].toLowerCase()+n.path.substr(2):o=n.path,t.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=g;function h(n,i){const o=i?I:y;let a="",{scheme:c,authority:v,path:k,query:L,fragment:O}=n;if(c&&(a+=c,a+=":"),(v||c==="file")&&(a+=P,a+=P),v){let F=v.indexOf("@");if(F!==-1){const j=v.substr(0,F);v=v.substr(F+1),F=j.indexOf(":"),F===-1?a+=o(j,!1):(a+=o(j.substr(0,F),!1),a+=":",a+=o(j.substr(F+1),!1)),a+="@"}v=v.toLowerCase(),F=v.indexOf(":"),F===-1?a+=o(v,!1):(a+=o(v.substr(0,F),!1),a+=v.substr(F))}if(k){if(k.length>=3&&k.charCodeAt(0)===47&&k.charCodeAt(2)===58){const F=k.charCodeAt(1);F>=65&&F<=90&&(k=`/${String.fromCharCode(F+32)}:${k.substr(3)}`)}else if(k.length>=2&&k.charCodeAt(1)===58){const F=k.charCodeAt(0);F>=65&&F<=90&&(k=`${String.fromCharCode(F+32)}:${k.substr(2)}`)}a+=o(k,!0)}return L&&(a+="?",a+=o(L,!1)),O&&(a+="#",a+=i?O:y(O,!1)),a}function l(n){try{return decodeURIComponent(n)}catch{return n.length>3?n.substr(0,3)+l(n.substr(3)):n}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(n){return n.match(s)?n.replace(s,i=>l(i)):n}}),define(X[136],J([0,1,7]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function t(w){const C=w;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.isRemoteConsoleLog=t;function D(w){const C=[];let P;try{const S=JSON.parse(w.arguments),f=S[S.length-1];f&&f.__$stack&&(S.pop(),P=f.__$stack),C.push(...S)}catch{C.push("Unable to log remote console arguments",w.arguments)}return{args:C,stack:P}}e.parse=D;function R(w){if(typeof w!="string")return R(D(w).stack);const C=w;if(C){const P=M(C),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(S&&S.length===4)return{uri:E.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=R;function M(w){if(!w)return w;const C=w.indexOf(`
`);return C===-1?w:w.substring(0,C)}function b(w,C){const{args:P,stack:S}=D(w),f=typeof P[0]=="string"&&P.length===1;let u=M(S);u&&(u=`(${u.trim()})`);let p=[];if(typeof P[0]=="string"?u&&f?p=[`%c[${C}] %c${P[0]} %c${u}`,d("blue"),d(""),d("grey")]:p=[`%c[${C}] %c${P[0]}`,d("blue"),d(""),...P.slice(1)]:p=[`%c[${C}]%`,d("blue"),...P],u&&!f&&p.push(u),typeof console[w.severity]!="function")throw new Error("Unknown console method");console[w.severity].apply(console,p)}e.log=b;function d(w){return`color: ${w}`}}),define(X[66],J([0,1,17,31,7]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(w){return JSON.stringify(w,b)}e.stringify=R;function M(w){let C=JSON.parse(w);return C=d(C),C}e.parse=M;function b(w,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,t.regExpFlags)(C)}:C}function d(w,C=0){if(!w||C>200)return w;if(typeof w=="object"){switch(w.$mid){case 1:return D.URI.revive(w);case 2:return new RegExp(w.source,w.flags);case 14:return new Date(w.source)}if(w instanceof E.VSBuffer||w instanceof Uint8Array)return w;if(Array.isArray(w))for(let P=0;P<w.length;++P)w[P]=d(w[P],C+1);else for(const P in w)Object.hasOwnProperty.call(w,P)&&(w[P]=d(w[P],C+1))}return w}e.revive=d}),define(X[12],J([0,1,4,7]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var D;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(D=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}setServerRootPath(d){this._remoteResourcesPath=`${d}/${D.vscodeRemoteResource}`}set(d,w,C){this._hosts[d]=w,this._ports[d]=C}setConnectionToken(d,w){this._connectionTokens[d]=w}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(d){if(this._delegate)return this._delegate(d);const w=d.authority;let C=this._hosts[w];C&&C.indexOf(":")!==-1&&(C=`[${C}]`);const P=this._ports[w],S=this._connectionTokens[w];let f=`path=${encodeURIComponent(d.path)}`;return typeof S=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(S)}`),t.URI.from({scheme:E.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${C}:${P}`,path:this._remoteResourcesPath,query:f})}}e.RemoteAuthorities=new R;class M{asBrowserUri(d,w){const C=this.toUri(d,w);return C.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(C):C.scheme===D.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${D.vscodeFileResource}://${M.FALLBACK_AUTHORITY}`)?C.with({scheme:D.vscodeFileResource,authority:C.authority||M.FALLBACK_AUTHORITY,query:null,fragment:null}):C}asFileUri(d,w){const C=this.toUri(d,w);return C.scheme===D.vscodeFileResource?C.with({scheme:D.file,authority:C.authority!==M.FALLBACK_AUTHORITY?C.authority:null,query:null,fragment:null}):C}toUri(d,w){return t.URI.isUri(d)?d:t.URI.parse(w.toUrl(d))}}M.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new M}),define(X[16],J([0,1,30,12,9,4,31,7]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(f){return(0,b.uriToFsPath)(f,!0)}e.originalFSPath=d;class w{constructor(u){this._ignorePathCasing=u}compare(u,p,m=!1){return u===p?0:(0,M.compare)(this.getComparisonKey(u,m),this.getComparisonKey(p,m))}isEqual(u,p,m=!1){return u===p?!0:!u||!p?!1:this.getComparisonKey(u,m)===this.getComparisonKey(p,m)}getComparisonKey(u,p=!1){return u.with({path:this._ignorePathCasing(u)?u.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(u){return this._ignorePathCasing(u)}isEqualOrParent(u,p,m=!1){if(u.scheme===p.scheme){if(u.scheme===t.Schemas.file)return E.isEqualOrParent(d(u),d(p),this._ignorePathCasing(u))&&u.query===p.query&&(m||u.fragment===p.fragment);if((0,e.isEqualAuthority)(u.authority,p.authority))return E.isEqualOrParent(u.path,p.path,this._ignorePathCasing(u),"/")&&u.query===p.query&&(m||u.fragment===p.fragment)}return!1}joinPath(u,...p){return b.URI.joinPath(u,...p)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return D.posix.basename(u.path)}extname(u){return D.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let p;return u.scheme===t.Schemas.file?p=b.URI.file(D.dirname(d(u))).path:(p=D.posix.dirname(u.path),u.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),p="/")),u.with({path:p})}normalizePath(u){if(!u.path.length)return u;let p;return u.scheme===t.Schemas.file?p=b.URI.file(D.normalize(d(u))).path:p=D.posix.normalize(u.path),u.with({path:p})}relativePath(u,p){if(u.scheme!==p.scheme||!(0,e.isEqualAuthority)(u.authority,p.authority))return;if(u.scheme===t.Schemas.file){const I=D.relative(d(u),d(p));return R.isWindows?E.toSlashes(I):I}let m=u.path||"/";const y=p.path||"/";if(this._ignorePathCasing(u)){let I=0;for(const g=Math.min(m.length,y.length);I<g&&!(m.charCodeAt(I)!==y.charCodeAt(I)&&m.charAt(I).toLowerCase()!==y.charAt(I).toLowerCase());I++);m=y.substr(0,I)+m.substr(I)}return D.posix.relative(m,y)}resolvePath(u,p){if(u.scheme===t.Schemas.file){const m=b.URI.file(D.resolve(d(u),p));return u.with({authority:m.authority,path:m.path})}return p=E.toPosixPath(p),u.with({path:D.posix.resolve(u.path,p)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,p){return u===p||u!==void 0&&p!==void 0&&(0,M.equalsIgnoreCase)(u,p)}hasTrailingPathSeparator(u,p=D.sep){if(u.scheme===t.Schemas.file){const m=d(u);return m.length>E.getRoot(m).length&&m[m.length-1]===p}else{const m=u.path;return m.length>1&&m.charCodeAt(m.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,p=D.sep){return(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,p=D.sep){let m=!1;if(u.scheme===t.Schemas.file){const y=d(u);m=y!==void 0&&y.length===E.getRoot(y).length&&y[y.length-1]===p}else{p="/";const y=u.path;m=y.length===1&&y.charCodeAt(y.length-1)===47}return!m&&!(0,e.hasTrailingPathSeparator)(u,p)?u.with({path:u.path+"/"}):u}}e.ExtUri=w,e.extUri=new w(()=>!1),e.extUriBiasedIgnorePathCase=new w(f=>f.scheme===t.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new w(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function C(f,u){const p=[];for(let m=0;m<f.length;m++){const y=u(f[m]);f.some((I,g)=>g===m?!1:(0,e.isEqualOrParent)(y,u(I)))||p.push(f[m])}return p}e.distinctParents=C;var P;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function u(p){const m=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(g=>{const[h,l]=g.split(":");h&&l&&m.set(h,l)});const I=p.path.substring(0,p.path.indexOf(";"));return I&&m.set(f.META_DATA_MIME,I),m}f.parseMetaData=u})(P=e.DataUri||(e.DataUri={}));function S(f,u,p){if(u){let m=f.path;return m&&m[0]!==D.posix.sep&&(m=D.posix.sep+m),f.with({scheme:p,authority:u,path:m})}return f.with({scheme:p})}e.toLocalResource=S}),define(X[8],J([0,1,21,19,3,2,16,4]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function d(Q){return!!Q&&typeof Q.then=="function"}e.isThenable=d;function w(Q){const A=new E.CancellationTokenSource,W=Q(A.token),U=new Promise((z,Y)=>{const _=A.token.onCancellationRequested(()=>{_.dispose(),A.dispose(),Y(new t.CancellationError)});Promise.resolve(W).then(K=>{_.dispose(),A.dispose(),z(K)},K=>{_.dispose(),A.dispose(),Y(K)})});return new class{cancel(){A.cancel()}then(z,Y){return U.then(z,Y)}catch(z){return this.then(void 0,z)}finally(z){return U.finally(z)}}}e.createCancelablePromise=w;function C(Q,A,W){return new Promise((U,z)=>{const Y=A.onCancellationRequested(()=>{Y.dispose(),U(W)});Q.then(U,z).finally(()=>Y.dispose())})}e.raceCancellation=C;function P(Q,A){return new Promise((W,U)=>{const z=A.onCancellationRequested(()=>{z.dispose(),U(new t.CancellationError)});Q.then(W,U).finally(()=>z.dispose())})}e.raceCancellationError=P;async function S(Q){let A=-1;const W=Q.map((z,Y)=>z.then(_=>(A=Y,_))),U=await Promise.race(W);return Q.forEach((z,Y)=>{Y!==A&&z.cancel()}),U}e.raceCancellablePromises=S;function f(Q,A,W){let U;const z=setTimeout(()=>{U?.(void 0),W?.()},A);return Promise.race([Q.finally(()=>clearTimeout(z)),new Promise(Y=>U=Y)])}e.raceTimeout=f;function u(Q){return new Promise((A,W)=>{const U=Q();d(U)?U.then(A,W):A(U)})}e.asPromise=u;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(A){if(this.activePromise){if(this.queuedPromiseFactory=A,!this.queuedPromise){const W=()=>{this.queuedPromise=null;const U=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,U};this.queuedPromise=new Promise(U=>{this.activePromise.then(W,W).then(U)})}return new Promise((W,U)=>{this.queuedPromise.then(W,U)})}return this.activePromise=A(),new Promise((W,U)=>{this.activePromise.then(z=>{this.activePromise=null,W(z)},z=>{this.activePromise=null,U(z)})})}}e.Throttler=p;class m{constructor(){this.current=Promise.resolve(null)}queue(A){return this.current=this.current.then(()=>A(),()=>A())}}e.Sequencer=m;class y{constructor(){this.promiseMap=new Map}queue(A,W){const z=(this.promiseMap.get(A)??Promise.resolve()).catch(()=>{}).then(W).finally(()=>{this.promiseMap.get(A)===z&&this.promiseMap.delete(A)});return this.promiseMap.set(A,z),z}}e.SequencerByKey=y;const I=(Q,A)=>{let W=!0;const U=setTimeout(()=>{W=!1,A()},Q);return{isTriggered:()=>W,dispose:()=>{clearTimeout(U),W=!1}}},g=Q=>{let A=!0;return queueMicrotask(()=>{A&&(A=!1,Q())}),{isTriggered:()=>A,dispose:()=>{A=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class h{constructor(A){this.defaultDelay=A,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(A,W=this.defaultDelay){this.task=A,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((z,Y)=>{this.doResolve=z,this.doReject=Y}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const z=this.task;return this.task=null,z()}}));const U=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=W===e.MicrotaskDelay?g(U):I(W,U),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new t.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=h;class l{constructor(A){this.delayer=new h(A),this.throttler=new p}trigger(A,W){return this.delayer.trigger(()=>this.throttler.queue(A),W)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=l;class s{constructor(){this._isOpen=!1,this._promise=new Promise((A,W)=>{this._completePromise=A})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(A){super();this._timeout=setTimeout(()=>this.open(),A)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function n(Q,A){return A?new Promise((W,U)=>{const z=setTimeout(()=>{Y.dispose(),W()},Q),Y=A.onCancellationRequested(()=>{clearTimeout(z),Y.dispose(),U(new t.CancellationError)})}):w(W=>n(Q,W))}e.timeout=n;function i(Q,A=0){const W=setTimeout(Q,A);return(0,R.toDisposable)(()=>clearTimeout(W))}e.disposableTimeout=i;function o(Q){const A=[];let W=0;const U=Q.length;function z(){return W<U?Q[W++]():null}function Y(_){_!=null&&A.push(_);const K=z();return K?K.then(Y):Promise.resolve(A)}return Promise.resolve(null).then(Y)}e.sequence=o;function a(Q,A=U=>!!U,W=null){let U=0;const z=Q.length,Y=()=>{if(U>=z)return Promise.resolve(W);const _=Q[U++];return Promise.resolve(_()).then(Z=>A(Z)?Promise.resolve(Z):Y())};return Y()}e.first=a;function c(Q,A=U=>!!U,W=null){if(Q.length===0)return Promise.resolve(W);let U=Q.length;const z=()=>{U=-1;for(const Y of Q)Y.cancel?.()};return new Promise((Y,_)=>{for(const K of Q)K.then(Z=>{--U>=0&&A(Z)?(z(),Y(Z)):U===0&&Y(W)}).catch(Z=>{--U>=0&&(z(),_(Z))})})}e.firstParallel=c;class v{constructor(A){this._size=0,this.maxDegreeOfParalellism=A,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new D.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(A){return this._size++,new Promise((W,U)=>{this.outstandingPromises.push({factory:A,c:W,e:U}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const A=this.outstandingPromises.shift();this.runningPromises++;const W=A.factory();W.then(A.c,A.e),W.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=v;class k extends v{constructor(){super(1)}}e.Queue=k;class L{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const A=new q;return this.drainers.add(A),A.p}isDrained(){for(const[,A]of this.queues)if(A.size>0)return!1;return!0}queueFor(A,W=M.extUri){const U=W.getComparisonKey(A);let z=this.queues.get(U);return z||(z=new k,D.Event.once(z.onDrained)(()=>{z?.dispose(),this.queues.delete(U),this.onDidQueueDrain()}),this.queues.set(U,z)),z}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const A of this.drainers)A.complete();this.drainers.clear()}dispose(){for(const[,A]of this.queues)A.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=L;class O{constructor(A,W){this._token=-1,typeof A=="function"&&typeof W=="number"&&this.setIfNotSet(A,W)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(A,W){this.cancel(),this._token=setTimeout(()=>{this._token=-1,A()},W)}setIfNotSet(A,W){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,A()},W))}}e.TimeoutTimer=O;class F{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(A,W){this.cancel(),this._token=setInterval(()=>{A()},W)}}e.IntervalTimer=F;class j{constructor(A,W){this.timeoutToken=-1,this.runner=A,this.timeout=W,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(A=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,A)}get delay(){return this.timeout}set delay(A){this.timeout=A}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=j;class ee{constructor(A,W){W%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${W}ms is not a multiple of 1000ms.`),this.runner=A,this.timeout=W,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(A=this.timeout){A%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${A}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(A/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=ee;class se extends j{constructor(A,W){super(A,W);this.units=[]}work(A){this.units.push(A),this.isScheduled()||this.schedule()}doRun(){const A=this.units;this.units=[],this.runner?.(A)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=se;class ae extends R.Disposable{constructor(A,W){super();this.options=A,this.handler=W,this.pendingWork=[],this.throttler=this._register(new R.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(A){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+A.length>this.options.maxBufferedWork)return!1}else if(this.pending+A.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...A),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new j(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=ae,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Q=>{(0,b.setTimeout0)(()=>{if(A)return;const W=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,W-Date.now())}}))});let A=!1;return{dispose(){A||(A=!0)}}}:e.runWhenIdle=(Q,A)=>{const W=requestIdleCallback(Q,typeof A=="number"?{timeout:A}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(W))}}}}();class ie{constructor(A){this._didRun=!1,this._executor=()=>{try{this._value=A()}catch(W){this._error=W}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=ie;async function ce(Q,A,W){let U;for(let z=0;z<W;z++)try{return await Q()}catch(Y){U=Y,await n(A)}throw U}e.retry=ce;class H{hasPending(A){return this._pending?typeof A=="number"?this._pending.taskId===A:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(A,W,U){return this._pending={taskId:A,cancel:()=>U?.(),promise:W},W.then(()=>this.donePending(A),()=>this.donePending(A)),W}donePending(A){this._pending&&A===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const A=this._next;this._next=void 0,A.run().then(A.promiseResolve,A.promiseReject)}}setNext(A){if(this._next)this._next.run=A;else{let W,U;const z=new Promise((Y,_)=>{W=Y,U=_});this._next={run:A,promise:z,promiseResolve:W,promiseReject:U}}return this._next.promise}}e.TaskSequentializer=H;class re{constructor(A,W=()=>Date.now()){this.interval=A,this.nowFn=W,this.lastIncrementTime=0,this.value=0}increment(){const A=this.nowFn();return A-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=A,this.value=0),this.value++,this.value}}e.IntervalCounter=re;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((A,W)=>{this.completeCallback=A,this.errorCallback=W})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(A){return new Promise(W=>{this.completeCallback(A),this.resolved=!0,W()})}error(A){return new Promise(W=>{this.errorCallback(A),this.rejected=!0,W()})}cancel(){new Promise(A=>{this.errorCallback(new t.CancellationError),this.rejected=!0,A()})}}e.DeferredPromise=q;var T;(function(Q){async function A(U){let z;const Y=await Promise.all(U.map(_=>_.then(K=>K,K=>{z||(z=K)})));if(typeof z!="undefined")throw z;return Y}Q.settled=A;function W(U){return new Promise(async(z,Y)=>{try{await U(z,Y)}catch(_){Y(_)}})}Q.withAsyncBody=W})(T=e.Promises||(e.Promises={}));var N;(function(Q){Q[Q.Initial=0]="Initial",Q[Q.DoneOK=1]="DoneOK",Q[Q.DoneError=2]="DoneError"})(N||(N={}));class V{constructor(A){this._state=0,this._results=[],this._error=null,this._onStateChanged=new D.Emitter,queueMicrotask(async()=>{const W={emitOne:U=>this.emitOne(U),emitMany:U=>this.emitMany(U),reject:U=>this.reject(U)};try{await Promise.resolve(A(W)),this.resolve()}catch(U){this.reject(U)}finally{W.emitOne=void 0,W.emitMany=void 0,W.reject=void 0}})}static fromArray(A){return new V(W=>{W.emitMany(A)})}static fromPromise(A){return new V(async W=>{W.emitMany(await A)})}static fromPromises(A){return new V(async W=>{await Promise.all(A.map(async U=>W.emitOne(await U)))})}static merge(A){return new V(async W=>{await Promise.all(A.map(async U=>{for await(const z of U)W.emitOne(z)}))})}[Symbol.asyncIterator](){let A=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(A<this._results.length)return{done:!1,value:this._results[A++]};if(this._state===1)return{done:!0,value:void 0};await D.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(A,W){return new V(async U=>{for await(const z of A)U.emitOne(W(z))})}map(A){return V.map(this,A)}static filter(A,W){return new V(async U=>{for await(const z of A)W(z)&&U.emitOne(z)})}filter(A){return V.filter(this,A)}static coalesce(A){return V.filter(A,W=>!!W)}coalesce(){return V.coalesce(this)}static async toPromise(A){const W=[];for await(const U of A)W.push(U);return W}toPromise(){return V.toPromise(this)}emitOne(A){this._state===0&&(this._results.push(A),this._onStateChanged.fire())}emitMany(A){this._state===0&&(this._results=this._results.concat(A),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(A){this._state===0&&(this._state=2,this._error=A,this._onStateChanged.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class te extends V{constructor(A,W){super(W);this._source=A}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=te;function $(Q){const A=new E.CancellationTokenSource,W=Q(A.token);return new te(A,async U=>{const z=A.token.onCancellationRequested(()=>{z.dispose(),A.dispose(),U.reject(new t.CancellationError)});try{for await(const Y of W){if(A.token.isCancellationRequested)return;U.emitOne(Y)}z.dispose(),A.dispose()}catch(Y){z.dispose(),A.dispose(),U.reject(Y)}})}e.createCancelableAsyncIterable=$}),define(X[92],J([0,1,25,8,30,33,9,4,31]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function w(){return Object.create(null)}e.getEmptyExpression=w,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const C="[/\\\\]",P="[^/\\\\]",S=/\//g;function f(q,T){switch(q){case 0:return"";case 1:return`${P}*?`;default:return`(?:${C}|${P}+${C}${T?`|${C}${P}+`:""})*?`}}function u(q,T){if(!q)return[];const N=[];let V=!1,te=!1,$="";for(const Q of q){switch(Q){case T:if(!V&&!te){N.push($),$="";continue}break;case"{":V=!0;break;case"}":V=!1;break;case"[":te=!0;break;case"]":te=!1;break}$+=Q}return $&&N.push($),N}e.splitGlobAware=u;function p(q){if(!q)return"";let T="";const N=u(q,e.GLOB_SPLIT);if(N.every(V=>V===e.GLOBSTAR))T=".*";else{let V=!1;N.forEach((te,$)=>{if(te===e.GLOBSTAR){if(V)return;T+=f(2,$===N.length-1)}else{let Q=!1,A="",W=!1,U="";for(const z of te){if(z!=="}"&&Q){A+=z;continue}if(W&&(z!=="]"||!U)){let Y;z==="-"?Y=z:(z==="^"||z==="!")&&!U?Y="^":z===e.GLOB_SPLIT?Y="":Y=(0,d.escapeRegExpCharacters)(z),U+=Y;continue}switch(z){case"{":Q=!0;continue;case"[":W=!0;continue;case"}":{T+=`(?:${u(A,",").map(K=>p(K)).join("|")})`,Q=!1,A="";break}case"]":{T+="["+U+"]",W=!1,U="";break}case"?":T+=P;continue;case"*":T+=f(1);continue;default:T+=(0,d.escapeRegExpCharacters)(z)}}$<N.length-1&&(N[$+1]!==e.GLOBSTAR||$+2<N.length)&&(T+=C)}V=te===e.GLOBSTAR})}return T}const m=/^\*\*\/\*\.[\w\.-]+$/,y=/^\*\*\/([\w\.-]+)\/?$/,I=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,g=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,h=/^\*\*((\/[\w\.-]+)+)\/?$/,l=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new R.LRUCache(1e4),r=function(){return!1},n=function(){return null};function i(q,T){if(!q)return n;let N;typeof q!="string"?N=q.pattern:N=q,N=N.trim();const V=`${N}_${!!T.trimForExclusions}`;let te=s.get(V);if(te)return o(te,q);let $;return m.test(N)?te=c(N.substr(4),N):($=y.exec(a(N,T)))?te=v($[1],N):(T.trimForExclusions?g:I).test(N)?te=k(N,T):($=h.exec(a(N,T)))?te=L($[1].substr(1),N,!0):($=l.exec(a(N,T)))?te=L($[1],N,!1):te=O(N),s.set(V,te),o(te,q)}function o(q,T){if(typeof T=="string")return q;const N=function(V,te){return(0,D.isEqualOrParent)(V,T.base,!b.isLinux)?q(V.substr(T.base.length+1),te):null};return N.allBasenames=q.allBasenames,N.allPaths=q.allPaths,N.basenames=q.basenames,N.patterns=q.patterns,N}function a(q,T){return T.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function c(q,T){return function(N,V){return typeof N=="string"&&N.endsWith(q)?T:null}}function v(q,T){const N=`/${q}`,V=`\\${q}`,te=function(Q,A){return typeof Q!="string"?null:A?A===q?T:null:Q===q||Q.endsWith(N)||Q.endsWith(V)?T:null},$=[q];return te.basenames=$,te.patterns=[T],te.allBasenames=$,te}function k(q,T){const N=H(q.slice(1,-1).split(",").map(A=>i(A,T)).filter(A=>A!==n),q),V=N.length;if(!V)return n;if(V===1)return N[0];const te=function(A,W){for(let U=0,z=N.length;U<z;U++)if(N[U](A,W))return q;return null},$=N.find(A=>!!A.allBasenames);$&&(te.allBasenames=$.allBasenames);const Q=N.reduce((A,W)=>W.allPaths?A.concat(W.allPaths):A,[]);return Q.length&&(te.allPaths=Q),te}function L(q,T,N){const V=M.sep===M.posix.sep,te=V?q:q.replace(S,M.sep),$=M.sep+te,Q=M.posix.sep+q;let A;return N?A=function(W,U){return typeof W=="string"&&(W===te||W.endsWith($)||!V&&(W===q||W.endsWith(Q)))?T:null}:A=function(W,U){return typeof W=="string"&&(W===te||!V&&W===q)?T:null},A.allPaths=[(N?"*/":"./")+q],A}function O(q){try{const T=new RegExp(`^${p(q)}$`);return function(N){return T.lastIndex=0,typeof N=="string"&&T.test(N)?q:null}}catch{return n}}function F(q,T,N){return!q||typeof T!="string"?!1:j(q)(T,void 0,N)}e.match=F;function j(q,T={}){if(!q)return r;if(typeof q=="string"||ee(q)){const N=i(q,T);if(N===n)return r;const V=function(te,$){return!!N(te,$)};return N.allBasenames&&(V.allBasenames=N.allBasenames),N.allPaths&&(V.allPaths=N.allPaths),V}return ie(q,T)}e.parse=j;function ee(q){const T=q;return T?typeof T.base=="string"&&typeof T.pattern=="string":!1}e.isRelativePattern=ee;function se(q){return q.allBasenames||[]}e.getBasenameTerms=se;function ae(q){return q.allPaths||[]}e.getPathTerms=ae;function ie(q,T){const N=H(Object.getOwnPropertyNames(q).map(A=>ce(A,q[A],T)).filter(A=>A!==n)),V=N.length;if(!V)return n;if(!N.some(A=>!!A.requiresSiblings)){if(V===1)return N[0];const A=function(z,Y){let _;for(let K=0,Z=N.length;K<Z;K++){const ne=N[K](z,Y);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(_||(_=[]),_.push(ne))}return _?(async()=>{for(const K of _){const Z=await K;if(typeof Z=="string")return Z}return null})():null},W=N.find(z=>!!z.allBasenames);W&&(A.allBasenames=W.allBasenames);const U=N.reduce((z,Y)=>Y.allPaths?z.concat(Y.allPaths):z,[]);return U.length&&(A.allPaths=U),A}const te=function(A,W,U){let z,Y;for(let _=0,K=N.length;_<K;_++){const Z=N[_];Z.requiresSiblings&&U&&(W||(W=(0,M.basename)(A)),z||(z=W.substr(0,W.length-(0,M.extname)(A).length)));const ne=Z(A,W,z,U);if(typeof ne=="string")return ne;(0,t.isThenable)(ne)&&(Y||(Y=[]),Y.push(ne))}return Y?(async()=>{for(const _ of Y){const K=await _;if(typeof K=="string")return K}return null})():null},$=N.find(A=>!!A.allBasenames);$&&(te.allBasenames=$.allBasenames);const Q=N.reduce((A,W)=>W.allPaths?A.concat(W.allPaths):A,[]);return Q.length&&(te.allPaths=Q),te}function ce(q,T,N){if(T===!1)return n;const V=i(q,N);if(V===n)return n;if(typeof T=="boolean")return V;if(T){const te=T.when;if(typeof te=="string"){const $=(Q,A,W,U)=>{if(!U||!V(Q,A))return null;const z=te.replace("$(basename)",W),Y=U(z);return(0,t.isThenable)(Y)?Y.then(_=>_?q:null):Y?q:null};return $.requiresSiblings=!0,$}}return V}function H(q,T){const N=q.filter(A=>!!A.basenames);if(N.length<2)return q;const V=N.reduce((A,W)=>{const U=W.basenames;return U?A.concat(U):A},[]);let te;if(T){te=[];for(let A=0,W=V.length;A<W;A++)te.push(T)}else te=N.reduce((A,W)=>{const U=W.patterns;return U?A.concat(U):A},[]);const $=function(A,W){if(typeof A!="string")return null;if(!W){let z;for(z=A.length;z>0;z--){const Y=A.charCodeAt(z-1);if(Y===47||Y===92)break}W=A.substr(z)}const U=V.indexOf(W);return U!==-1?te[U]:null};$.basenames=V,$.patterns=te,$.allBasenames=V;const Q=q.filter(A=>!A.basenames);return Q.push($),Q}function re(q,T){return(0,E.equals)(q,T,(N,V)=>typeof N=="string"&&typeof V=="string"?N===V:typeof N!="string"&&typeof V!="string"?N.base===V.base&&N.pattern===V.pattern:!1)}e.patternsEquals=re}),define(X[34],J([0,1,25,30,9,4,16,31]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function d(n,i){const{os:o,tildify:a,relative:c}=i;if(c){const L=w(n,c,o);if(typeof L=="string")return L}let v=n.fsPath;if(o===1&&!R.isWindows?v=v.replace(/\//g,"\\"):o!==1&&R.isWindows&&(v=v.replace(/\\/g,"/")),o!==1&&a?.userHome){const L=a.userHome.fsPath;let O;n.scheme!==a.userHome.scheme&&n.path.startsWith(D.posix.sep)?O=a.userHome.with({path:n.path}).fsPath:O=n.fsPath,v=S(O,L,o)}return(o===1?D.win32:D.posix).normalize(C(v,o===1))}e.getPathLabel=d;function w(n,i,o){const a=o===1?D.win32:D.posix,c=o===3?M.extUri:M.extUriIgnorePathCase,v=i.getWorkspace(),k=(0,E.firstOrDefault)(v.folders);if(!k)return;n.scheme!==k.uri.scheme&&n.path.startsWith(D.posix.sep)&&(n=k.uri.with({path:n.path}));const L=i.getWorkspaceFolder(n);if(!L)return;let O;if(c.isEqual(L.uri,n)?O="":O=c.relativePath(L.uri,n)??"",O&&(O=a.normalize(O)),v.folders.length>1&&!i.noPrefix){const F=L.name?L.name:c.basenameOrAuthority(L.uri);O=O?`${F} \u2022 ${O}`:F}return O}function C(n,i=R.isWindows){return(0,t.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=C;let P=Object.create(null);function S(n,i,o=R.OS){if(o===1||!n||!i)return n;let a=P.original===i?P.normalized:void 0;a||(a=i,R.isWindows&&(a=(0,t.toSlashes)(a)),a=`${(0,b.rtrim)(a,D.posix.sep)}${D.posix.sep}`,P={original:i,normalized:a});let c=n;return R.isWindows&&(c=(0,t.toSlashes)(c)),(o===3?c.startsWith(a):(0,b.startsWithIgnoreCase)(c,a))?`~/${c.substr(a.length)}`:n}e.tildify=S;function f(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=f;const u="\u2026",p="\\\\",m="~";function y(n,i=D.sep){const o=new Array(n.length);let a=!1;for(let c=0;c<n.length;c++){const v=n[c];if(v===""){o[c]=`.${i}`;continue}if(!v){o[c]=v;continue}a=!0;let k="",L=v;L.indexOf(p)===0?(k=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length)):L.indexOf(i)===0?(k=L.substr(0,L.indexOf(i)+i.length),L=L.substr(L.indexOf(i)+i.length)):L.indexOf(m)===0&&(k=L.substr(0,L.indexOf(m)+m.length),L=L.substr(L.indexOf(m)+m.length));const O=L.split(i);for(let F=1;a&&F<=O.length;F++)for(let j=O.length-F;a&&j>=0;j--){a=!1;let ee=O.slice(j,j+F).join(i);for(let se=0;!a&&se<n.length;se++)if(se!==c&&n[se]&&n[se].indexOf(ee)>-1){const ae=j+F===O.length,ie=j>0&&n[se].indexOf(i)>-1?i+ee:ee,ce=n[se].endsWith(ie);a=!ae||ce}if(!a){let se="";(O[0].endsWith(":")||k!=="")&&(j===1&&(j=0,F++,ee=O[0]+i+ee),j>0&&(se=O[0]+i),se=k+se),j>0&&(se=se+u+i),se=se+ee,j+F<O.length&&(se=se+i+u),o[c]=se}}a&&(o[c]=v)}return o}e.shorten=y;var I;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(I||(I={}));function g(n,i=Object.create(null)){const o=[];let a=!1,c="";for(const v of n)if(v==="$"||a&&v==="{")c&&o.push({value:c,type:I.TEXT}),c="",a=!0;else if(v==="}"&&a){const k=i[c];if(typeof k=="string")k.length&&o.push({value:k,type:I.VARIABLE});else if(k){const L=o[o.length-1];(!L||L.type!==I.SEPARATOR)&&o.push({value:k.label,type:I.SEPARATOR})}c="",a=!1}else c+=v;return c&&!a&&o.push({value:c,type:I.TEXT}),o.filter((v,k)=>{if(v.type===I.SEPARATOR){const L=o[k-1],O=o[k+1];return[L,O].every(F=>F&&(F.type===I.VARIABLE||F.type===I.TEXT)&&F.value.length>0)}return!0}).map(v=>v.value).join("")}e.template=g;function h(n,i){return R.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):n.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=h;function l(n,i){return R.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):R.isWindows?n.replace(/&&|&/g,o=>o==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=l;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function r(n){const i=n.indexOf("/")!==-1?D.posix:D.win32,o=i.basename(n),a=i.dirname(n);return o.length?{name:o,parentPath:a}:{name:a,parentPath:""}}e.splitName=r}),define(X[137],J([0,1,7]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function t(C){return C.toJSON()}class D{constructor(P){this._uriTransformer=P}transformIncoming(P){const S=this._uriTransformer.transformIncoming(P);return S===P?P:t(E.URI.from(S))}transformOutgoing(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:t(E.URI.from(S))}transformOutgoingURI(P){const S=this._uriTransformer.transformOutgoing(P);return S===P?P:E.URI.from(S)}transformOutgoingScheme(P){return this._uriTransformer.transformOutgoingScheme(P)}}e.URITransformer=D,e.DefaultURITransformer=new class{transformIncoming(C){return C}transformOutgoing(C){return C}transformOutgoingURI(C){return C}transformOutgoingScheme(C){return C}};function R(C,P,S){if(!C||S>200)return null;if(typeof C=="object"){if(C instanceof E.URI)return P.transformOutgoing(C);for(const f in C)if(Object.hasOwnProperty.call(C,f)){const u=R(C[f],P,S+1);u!==null&&(C[f]=u)}}return null}function M(C,P){const S=R(C,P,0);return S===null?C:S}e.transformOutgoingURIs=M;function b(C,P,S,f){if(!C||f>200)return null;if(typeof C=="object"){if(C.$mid===1)return S?E.URI.revive(P.transformIncoming(C)):P.transformIncoming(C);for(const u in C)if(Object.hasOwnProperty.call(C,u)){const p=b(C[u],P,S,f+1);p!==null&&(C[u]=p)}}return null}function d(C,P){const S=b(C,P,!1,0);return S===null?C:S}e.transformIncomingURIs=d;function w(C,P){const S=b(C,P,!0,0);return S===null?C:S}e.transformAndReviveIncomingURIs=w}),define(X[80],J([0,1,29,19,33,27,127]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(C){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(C)}value(){if(this._value===void 0){let C=0,P=0;const S=(0,E.networkInterfaces)();for(const f in S){const u=S[f];if(u)for(const{mac:p,internal:m}of u)m||(P+=1,this._isVirtualMachineMacAddress(p.toUpperCase())&&(C+=1))}this._value=P>0?C/P:0}return this._value}};let b;async function d(){return b||(b=(async()=>await w()||R.generateUuid())()),b}e.getMachineId=d;async function w(){try{const C=await new Promise((S,f)=>{B(["crypto"],S,f)}),P=(0,M.getMac)();return C.createHash("sha256").update(P,"utf8").digest("hex")}catch(C){t.onUnexpectedError(C);return}}}),define(X[23],J([0,1,28,29,138,8,30,79,9,4,16,7]),function(B,e,E,t,D,R,M,b,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var S;(function(ie){ie[ie.UNLINK=0]="UNLINK",ie[ie.MOVE=1]="MOVE"})(S=e.RimRafMode||(e.RimRafMode={}));async function f(ie,ce=S.UNLINK){if((0,M.isRootOrDriveLetter)(ie))throw new Error("rimraf - will refuse to recursively delete root");return ce===S.UNLINK?p(ie):u(ie)}async function u(ie){try{const ce=(0,M.randomPath)((0,t.tmpdir)());try{await E.promises.rename(ie,ce)}catch{return p(ie)}p(ce).catch(H=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function p(ie){return(0,D.promisify)(E.rm)(ie,{recursive:!0,force:!0,maxRetries:3})}function m(ie){if((0,M.isRootOrDriveLetter)(ie))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(ie,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=m;async function y(ie,ce){return h(await(ce?I(ie):(0,D.promisify)(E.readdir)(ie)))}async function I(ie){try{return await(0,D.promisify)(E.readdir)(ie,{withFileTypes:!0})}catch(re){console.warn("[node.js fs] readdir with filetypes failed with error: ",re)}const ce=[],H=await y(ie);for(const re of H){let q=!1,T=!1,N=!1;try{const V=await e.Promises.lstat((0,d.join)(ie,re));q=V.isFile(),T=V.isDirectory(),N=V.isSymbolicLink()}catch(V){console.warn("[node.js fs] unexpected error from lstat after readdir: ",V)}ce.push({name:re,isFile:()=>q,isDirectory:()=>T,isSymbolicLink:()=>N})}return ce}function g(ie){return h(E.readdirSync(ie))}e.readdirSync=g;function h(ie){return ie.map(ce=>typeof ce=="string"?w.isMacintosh?(0,b.normalizeNFC)(ce):ce:(ce.name=w.isMacintosh?(0,b.normalizeNFC)(ce.name):ce.name,ce))}async function l(ie){const ce=await y(ie),H=[];for(const re of ce)await r.existsDirectory((0,d.join)(ie,re))&&H.push(re);return H}function s(ie,ce=1e3){return new Promise(H=>{let re=!1;const q=setInterval(()=>{re||(re=!0,E.access(ie,T=>{re=!1,T&&(clearInterval(q),H(void 0))}))},ce)})}e.whenDeleted=s;var r;(function(ie){async function ce(q){let T;try{if(T=await e.Promises.lstat(q),!T.isSymbolicLink())return{stat:T}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:T?.isSymbolicLink()?{dangling:!1}:void 0}}catch(N){if(N.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};if(w.isWindows&&N.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(V){if(V.code==="ENOENT"&&T)return{stat:T,symbolicLink:{dangling:!0}};throw V}throw N}}ie.stat=ce;async function H(q){try{const{stat:T,symbolicLink:N}=await ie.stat(q);return T.isFile()&&N?.dangling!==!0}catch{}return!1}ie.existsFile=H;async function re(q){try{const{stat:T,symbolicLink:N}=await ie.stat(q);return T.isDirectory()&&N?.dangling!==!0}catch{}return!1}ie.existsDirectory=re})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const n=new R.ResourceQueue;function i(ie,ce,H){return n.queueFor(P.URI.file(ie),C.extUriBiasedIgnorePathCase).queue(()=>{const re=k(H);return new Promise((q,T)=>c(ie,ce,re,N=>N?T(N):q()))})}let o=!0;function a(ie){o=ie}e.configureFlushOnWrite=a;function c(ie,ce,H,re){if(!o)return E.writeFile(ie,ce,{mode:H.mode,flag:H.flag},re);E.open(ie,H.flag,H.mode,(q,T)=>{if(q)return re(q);E.writeFile(T,ce,N=>{if(N)return E.close(T,()=>re(N));E.fdatasync(T,V=>(V&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",V),a(!1)),E.close(T,te=>re(te))))})})}function v(ie,ce,H){const re=k(H);if(!o)return E.writeFileSync(ie,ce,{mode:re.mode,flag:re.flag});const q=E.openSync(ie,re.flag,re.mode);try{E.writeFileSync(q,ce);try{E.fdatasyncSync(q)}catch(T){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",T),a(!1)}}finally{E.closeSync(q)}}e.writeFileSync=v;function k(ie){return ie?{mode:typeof ie.mode=="number"?ie.mode:438,flag:typeof ie.flag=="string"?ie.flag:"w"}:{mode:438,flag:"w"}}async function L(ie,ce){if(ie!==ce)try{await e.Promises.rename(ie,ce)}catch(H){if(ie.toLowerCase()!==ce.toLowerCase()&&H.code==="EXDEV"||ie.endsWith("."))await O(ie,ce,{preserveSymlinks:!1}),await f(ie,S.MOVE);else throw H}}async function O(ie,ce,H){return j(ie,ce,{root:{source:ie,target:ce},options:H,handledSourcePaths:new Set})}const F=511;async function j(ie,ce,H){if(H.handledSourcePaths.has(ie))return;H.handledSourcePaths.add(ie);const{stat:re,symbolicLink:q}=await r.stat(ie);if(q){if(H.options.preserveSymlinks)try{return await ae(ie,ce,H)}catch(T){console.warn("[node.js fs] copy of symlink failed: ",T)}if(q.dangling)return}return re.isDirectory()?ee(ie,ce,re.mode&F,H):se(ie,ce,re.mode&F)}async function ee(ie,ce,H,re){await e.Promises.mkdir(ce,{recursive:!0,mode:H});const q=await y(ie);for(const T of q)await j((0,d.join)(ie,T),(0,d.join)(ce,T),re)}async function se(ie,ce,H){await e.Promises.copyFile(ie,ce),await e.Promises.chmod(ce,H)}async function ae(ie,ce,H){let re=await e.Promises.readlink(ie);(0,M.isEqualOrParent)(re,H.root.source,!w.isLinux)&&(re=(0,d.join)(H.root.target,re.substr(H.root.source.length+1))),await e.Promises.symlink(re,ce)}e.Promises=new class{get access(){return(0,D.promisify)(E.access)}get stat(){return(0,D.promisify)(E.stat)}get lstat(){return(0,D.promisify)(E.lstat)}get utimes(){return(0,D.promisify)(E.utimes)}get read(){return(ie,ce,H,re,q)=>new Promise((T,N)=>{E.read(ie,ce,H,re,q,(V,te,$)=>V?N(V):T({bytesRead:te,buffer:$}))})}get readFile(){return(0,D.promisify)(E.readFile)}get write(){return(ie,ce,H,re,q)=>new Promise((T,N)=>{E.write(ie,ce,H,re,q,(V,te,$)=>V?N(V):T({bytesWritten:te,buffer:$}))})}get appendFile(){return(0,D.promisify)(E.appendFile)}get fdatasync(){return(0,D.promisify)(E.fdatasync)}get truncate(){return(0,D.promisify)(E.truncate)}get rename(){return(0,D.promisify)(E.rename)}get copyFile(){return(0,D.promisify)(E.copyFile)}get open(){return(0,D.promisify)(E.open)}get close(){return(0,D.promisify)(E.close)}get symlink(){return(0,D.promisify)(E.symlink)}get readlink(){return(0,D.promisify)(E.readlink)}get chmod(){return(0,D.promisify)(E.chmod)}get mkdir(){return(0,D.promisify)(E.mkdir)}get unlink(){return(0,D.promisify)(E.unlink)}get rmdir(){return(0,D.promisify)(E.rmdir)}get realpath(){return(0,D.promisify)(E.realpath)}async exists(ie){try{return await e.Promises.access(ie),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return l}get writeFile(){return i}get rm(){return f}get move(){return L}get copy(){return O}}}),define(X[93],J([0,1,28,9,4,31,23]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(S){if(D.isLinux)return S;const f=(0,t.dirname)(S);if(S===f)return S;const u=((0,t.basename)(S)||S).toLowerCase();try{const m=(0,M.readdirSync)(f).filter(y=>y.toLowerCase()===u);if(m.length===1){const y=b(f);if(y)return(0,t.join)(y,m[0])}else if(m.length>1){const y=m.indexOf(u);if(y>=0){const I=b(f);if(I)return(0,t.join)(I,m[y])}}}catch{}return null}e.realcaseSync=b;async function d(S){if(D.isLinux)return S;const f=(0,t.dirname)(S);if(S===f)return S;const u=((0,t.basename)(S)||S).toLowerCase();try{const m=(await M.Promises.readdir(f)).filter(y=>y.toLowerCase()===u);if(m.length===1){const y=await d(f);if(y)return(0,t.join)(y,m[0])}else if(m.length>1){const y=m.indexOf(u);if(y>=0){const I=await d(f);if(I)return(0,t.join)(I,m[y])}}}catch{}return null}e.realcase=d;async function w(S){try{return await M.Promises.realpath(S)}catch{const u=P(S);return await M.Promises.access(u,E.constants.R_OK),u}}e.realpath=w;function C(S){try{return E.realpathSync(S)}catch{const u=P(S);return E.accessSync(u,E.constants.R_OK),u}}e.realpathSync=C;function P(S){return(0,R.rtrim)((0,t.normalize)(S),t.sep)}}),define(X[139],J([0,1,29,9,23]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const R=/^\d+$/,M=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var d;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(d||(d={}));let w;switch(process.arch){case"ia32":case"x32":w=1;break;case"arm":case"arm64":w=2;break;default:w=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class P{constructor(l,s,r){this.exePath=l,this.displayName=s,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:h=!1}={}){return h?w===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:h=!1,findPreview:l=!1}={}){const s=S({useAlternateBitness:h});if(!s)return null;const r=t.join(s,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(r))return null;let n=-1,i=null;for(const c of await D.Promises.readdir(r)){let v=-1;if(l){const L=c.indexOf("-");if(L<0)continue;const O=c.substring(0,L);if(!R.test(O)||c.substring(L+1)!=="preview")continue;v=parseInt(O,10)}else{if(!R.test(c))continue;v=parseInt(c,10)}if(v<=n)continue;const k=t.join(r,c,"pwsh.exe");!await D.SymlinkSupport.existsFile(k)||(i=k,n=v)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",a=l?" Preview":"";return new P(i,`PowerShell${a}${o}`,!0)}async function u({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const l=t.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(l))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=h?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:M,pwshMsixName:"PowerShell (Store)"};for(const n of await D.Promises.readdir(l))if(s.test(n)){const i=t.join(l,n,"pwsh.exe");return new P(i,r)}return null}function p(){const h=t.join(E.homedir(),".dotnet","tools","pwsh.exe");return new P(h,".NET Core PowerShell Global Tool")}function m(){const h=t.join(process.env.windir,w===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(h,"Windows PowerShell",!0)}async function*y(){let h=await f();h&&(yield h),h=await f({useAlternateBitness:!0}),h&&(yield h),h=await u(),h&&(yield h),h=p(),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await u({findPreview:!0}),h&&(yield h),h=await f({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=m(),h&&(yield h)}async function*I(){for await(const h of y())await h.exists()&&(yield h)}e.enumeratePowerShellInstallations=I;async function g(){for await(const h of I())return h;return null}e.getFirstAvailablePowerShellInstallation=g}),define(X[94],J([0,1,42,12]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(M){return new Promise((b,d)=>{let w;const C=new Map;function P(f,u,p,m,y){const I=C.get(u);if(f===M||I){const g={name:S(p),cmd:p,pid:f,ppid:u,load:m,mem:y};C.set(f,g),f===M&&(w=g),I&&(I.children||(I.children=[]),I.children.push(g),I.children.length>1&&(I.children=I.children.sort((h,l)=>h.pid-l.pid)))}}function S(f){const u=/--vscode-window-kind=shared-process/,p=/--vscode-window-kind=issue-reporter/,m=/--vscode-window-kind=process-explorer/,y=/--utility-sub-type=network/,I=/--utility-sub-type=node.mojom.NodeService/,g=/--crashes-directory/,h=/\\pipe\\winpty-control/,l=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(g.exec(f))return"electron-crash-reporter";if(h.exec(f))return"winpty-process";if(l.exec(f))return"console-window-host (Windows internal process)";let r=s.exec(f);if(r&&r.length===2){if(r[1]==="renderer")return u.exec(f)?"shared-process":p.exec(f)?"issue-reporter":m.exec(f)?"process-explorer":"window";if(r[1]==="utility"){if(y.exec(f))return"utility-network-service";if(I.exec(f))return"extension-host"}return r[1]}const n=/[a-zA-Z-]+\.js/g;let i="";do r=n.exec(f),r&&(i+=r+" ");while(r);return i&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron_node ${i}`:f}if(process.platform==="win32"){const f=u=>u.indexOf("\\\\?\\")===0||u.indexOf("\\??\\")===0?u.substr(4):u.indexOf('"\\\\?\\')===0||u.indexOf('"\\??\\')===0?'"'+u.substr(5):u;new Promise((u,p)=>{B(["windows-process-tree"],u,p)}).then(u=>{u.getProcessList(M,p=>{if(!p){d(new Error(`Root process ${M} not found`));return}u.getProcessCpuUsage(p,m=>{const y=new Map;m.forEach(I=>{const g=f(I.commandLine||"");y.set(I.pid,{name:S(g),cmd:g,pid:I.pid,ppid:I.ppid,load:I.cpu||0,mem:I.memory||0})}),w=y.get(M),w?(y.forEach(I=>{const g=y.get(I.ppid);g&&(g.children||(g.children=[]),g.children.push(I))}),y.forEach(I=>{I.children&&(I.children=I.children.sort((g,h)=>g.pid-h.pid))}),b(w)):d(new Error(`Root process ${M} not found`))})},u.ProcessDataFlag.CommandLine|u.ProcessDataFlag.Memory)})}else{let f=function(){let u=[w];const p=[];for(;u.length;){const y=u.shift();y&&(p.push(y.pid),y.children&&(u=u.concat(y.children)))}let m=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",B).fsPath);m+=" "+p.join(" "),(0,E.exec)(m,{},(y,I,g)=>{if(y||g)d(y||new Error(g.toString()));else{const h=I.toString().split(`
`);for(let l=0;l<p.length;l++){const s=C.get(p[l]);s.load=parseFloat(h[l])}if(!w){d(new Error(`Root process ${M} not found`));return}b(w)}})};(0,E.exec)("which ps",{},(u,p,m)=>{if(u||m)if(process.platform!=="linux")d(u||new Error(m.toString()));else{const y=JSON.stringify(t.FileAccess.asFileUri("vs/base/node/ps.sh",B).fsPath);(0,E.exec)(y,{},(I,g,h)=>{I||h?d(I||new Error(h.toString())):(R(g,P),f())})}else{const y=p.toString().trim(),I="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${y} ${I}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(g,h,l)=>{g||l&&!l.includes("screen size is bogus")?d(g||new Error(l.toString())):(R(h,P),process.platform==="linux"?f():w?b(w):d(new Error(`Root process ${M} not found`)))})}})}})}e.listProcesses=D;function R(M,b){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,w=M.toString().split(`
`);for(const C of w){const P=d.exec(C.trim());P&&P.length===6&&b(parseInt(P[1]),parseInt(P[2]),P[5],parseFloat(P[3]),parseFloat(P[4]))}}});var fe=this&&this.__decorate||function(B,e,E,t){var D=arguments.length,R=D<3?e:t===null?t=Object.getOwnPropertyDescriptor(e,E):t,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(B,e,E,t);else for(var b=B.length-1;b>=0;b--)(M=B[b])&&(R=(D<3?M(R):D>3?M(e,E,R):M(e,E))||R);return D>3&&R&&Object.defineProperty(e,E,R),R};define(X[43],J([0,1,25,8,17,21,51,19,3,2,66,31,13]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var f;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(f=e.RequestType||(e.RequestType={}));function u(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p=e.ResponseType||(e.ResponseType={}));function m(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var y;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(y||(y={}));class I{constructor(T){this.buffer=T,this.pos=0}read(T){const N=this.buffer.slice(this.pos,this.pos+T);return this.pos+=N.byteLength,N}}class g{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(T){this.buffers.push(T)}}var h;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object"})(h||(h={}));function l(q){const T=D.VSBuffer.alloc(4);return T.writeUInt32BE(q,0),T}function s(q){return q.read(4).readUInt32BE(0)}function r(q){const T=D.VSBuffer.alloc(1);return T.writeUInt8(q,0),T}const n={Undefined:r(h.Undefined),String:r(h.String),Buffer:r(h.Buffer),VSBuffer:r(h.VSBuffer),Array:r(h.Array),Object:r(h.Object)},i=typeof Buffer!="undefined";function o(q,T){if(typeof T=="undefined")q.write(n.Undefined);else if(typeof T=="string"){const N=D.VSBuffer.fromString(T);q.write(n.String),q.write(l(N.byteLength)),q.write(N)}else if(i&&Buffer.isBuffer(T)){const N=D.VSBuffer.wrap(T);q.write(n.Buffer),q.write(l(N.byteLength)),q.write(N)}else if(T instanceof D.VSBuffer)q.write(n.VSBuffer),q.write(l(T.byteLength)),q.write(T);else if(Array.isArray(T)){q.write(n.Array),q.write(l(T.length));for(const N of T)o(q,N)}else{const N=D.VSBuffer.fromString(JSON.stringify(T));q.write(n.Object),q.write(l(N.byteLength)),q.write(N)}}function a(q){switch(q.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return q.read(s(q)).toString();case h.Buffer:return q.read(s(q)).buffer;case h.VSBuffer:return q.read(s(q));case h.Array:{const N=s(q),V=[];for(let te=0;te<N;te++)V.push(a(q));return V}case h.Object:return JSON.parse(q.read(s(q)).toString())}}class c{constructor(T,N,V=null,te=1e3){this.protocol=T,this.ctx=N,this.logger=V,this.timeoutDelay=te,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(T,N){this.channels.set(T,N),setTimeout(()=>this.flushPendingRequests(T),0)}sendResponse(T){switch(T.type){case 200:{const N=this.send([T.type]);this.logger?.logOutgoing(N,0,1,m(T.type));return}case 201:case 202:case 204:case 203:{const N=this.send([T.type,T.id],T.data);this.logger?.logOutgoing(N,T.id,1,m(T.type),T.data);return}}}send(T,N=void 0){const V=new g;return o(V,T),o(V,N),this.sendBuffer(V.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onRawMessage(T){const N=new I(T),V=a(N),te=a(N),$=V[0];switch($){case 100:return this.logger?.logIncoming(T.byteLength,V[1],1,`${u($)}: ${V[2]}.${V[3]}`,te),this.onPromise({type:$,id:V[1],channelName:V[2],name:V[3],arg:te});case 102:return this.logger?.logIncoming(T.byteLength,V[1],1,`${u($)}: ${V[2]}.${V[3]}`,te),this.onEventListen({type:$,id:V[1],channelName:V[2],name:V[3],arg:te});case 101:return this.logger?.logIncoming(T.byteLength,V[1],1,`${u($)}`),this.disposeActiveRequest({type:$,id:V[1]});case 103:return this.logger?.logIncoming(T.byteLength,V[1],1,`${u($)}`),this.disposeActiveRequest({type:$,id:V[1]})}}onPromise(T){const N=this.channels.get(T.channelName);if(!N){this.collectPendingRequest(T);return}const V=new R.CancellationTokenSource;let te;try{te=N.call(this.ctx,T.name,T.arg,V.token)}catch(A){te=Promise.reject(A)}const $=T.id;te.then(A=>{this.sendResponse({id:$,data:A,type:201}),this.activeRequests.delete(T.id)},A=>{A instanceof Error?this.sendResponse({id:$,data:{message:A.message,name:A.name,stack:A.stack?A.stack.split?A.stack.split(`
`):A.stack:void 0},type:202}):this.sendResponse({id:$,data:A,type:203}),this.activeRequests.delete(T.id)});const Q=(0,w.toDisposable)(()=>V.cancel());this.activeRequests.set(T.id,Q)}onEventListen(T){const N=this.channels.get(T.channelName);if(!N){this.collectPendingRequest(T);return}const V=T.id,$=N.listen(this.ctx,T.name,T.arg)(Q=>this.sendResponse({id:V,data:Q,type:204}));this.activeRequests.set(T.id,$)}disposeActiveRequest(T){const N=this.activeRequests.get(T.id);N&&(N.dispose(),this.activeRequests.delete(T.id))}collectPendingRequest(T){let N=this.pendingRequests.get(T.channelName);N||(N=[],this.pendingRequests.set(T.channelName,N));const V=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.sendResponse({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:T,timeoutTimer:V})}flushPendingRequests(T){const N=this.pendingRequests.get(T);if(N){for(const V of N)switch(clearTimeout(V.timeoutTimer),V.request.type){case 100:this.onPromise(V.request);break;case 102:this.onEventListen(V.request);break}this.pendingRequests.delete(T)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=c;var v;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(v=e.RequestInitiator||(e.RequestInitiator={}));class k{constructor(T,N=null){this.protocol=T,this.isDisposed=!1,this.state=y.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(V=>this.onBuffer(V)),this.logger=N}getChannel(T){const N=this;return{call(V,te,$){return N.isDisposed?Promise.reject(b.canceled()):N.requestPromise(T,V,te,$)},listen(V,te){return N.isDisposed?d.Event.None:N.requestEvent(T,V,te)}}}requestPromise(T,N,V,te=R.CancellationToken.None){const $=this.lastRequestId++,A={id:$,type:100,channelName:T,name:N,arg:V};if(te.isCancellationRequested)return Promise.reject(b.canceled());let W;return new Promise((z,Y)=>{if(te.isCancellationRequested)return Y(b.canceled());const _=()=>{const le=ge=>{switch(ge.type){case 201:this.handlers.delete($),z(ge.data);break;case 202:{this.handlers.delete($);const Ee=new Error(ge.data.message);Ee.stack=ge.data.stack,Ee.name=ge.data.name,Y(Ee);break}case 203:this.handlers.delete($),Y(ge.data);break}};this.handlers.set($,le),this.sendRequest(A)};let K=null;this.state===y.Idle?_():(K=(0,t.createCancelablePromise)(le=>this.whenInitialized()),K.then(()=>{K=null,_()}));const Z=()=>{K?(K.cancel(),K=null):this.sendRequest({id:$,type:101}),Y(b.canceled())},ne=te.onCancellationRequested(Z);W=(0,w.combinedDisposable)((0,w.toDisposable)(Z),ne),this.activeRequests.add(W)}).finally(()=>{this.activeRequests.delete(W)})}requestEvent(T,N,V){const te=this.lastRequestId++,Q={id:te,type:102,channelName:T,name:N,arg:V};let A=null;const W=new d.Emitter({onFirstListenerAdd:()=>{A=(0,t.createCancelablePromise)(z=>this.whenInitialized()),A.then(()=>{A=null,this.activeRequests.add(W),this.sendRequest(Q)})},onLastListenerRemove:()=>{A?(A.cancel(),A=null):(this.activeRequests.delete(W),this.sendRequest({id:te,type:103}))}}),U=z=>W.fire(z.data);return this.handlers.set(te,U),W.event}sendRequest(T){switch(T.type){case 100:case 102:{const N=this.send([T.type,T.id,T.channelName,T.name],T.arg);this.logger?.logOutgoing(N,T.id,0,`${u(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const N=this.send([T.type,T.id]);this.logger?.logOutgoing(N,T.id,0,u(T.type));return}}}send(T,N=void 0){const V=new g;return o(V,T),o(V,N),this.sendBuffer(V.buffer)}sendBuffer(T){try{return this.protocol.send(T),T.byteLength}catch{return 0}}onBuffer(T){const N=new I(T),V=a(N),te=a(N),$=V[0];switch($){case 200:return this.logger?.logIncoming(T.byteLength,0,0,m($)),this.onResponse({type:V[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(T.byteLength,V[1],0,m($),te),this.onResponse({type:V[0],id:V[1],data:te})}}onResponse(T){if(T.type===200){this.state=y.Idle,this._onDidInitialize.fire();return}this.handlers.get(T.id)?.(T)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===y.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,w.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([M.memoize],k.prototype,"onDidInitializePromise",null),e.ChannelClient=k;class L{constructor(T){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,T(({protocol:N,onDidClientDisconnect:V})=>{d.Event.once(N.onMessage)($=>{const Q=new I($),A=a(Q),W=new c(N,A),U=new k(N);this.channels.forEach((Y,_)=>W.registerChannel(_,Y));const z={channelServer:W,channelClient:U,ctx:A};this._connections.add(z),this._onDidAddConnection.fire(z),V(()=>{W.dispose(),U.dispose(),this._connections.delete(z),this._onDidRemoveConnection.fire(z)})})})}get connections(){const T=[];return this._connections.forEach(N=>T.push(N)),T}getChannel(T,N){const V=this;return{call(te,$,Q){let A;if((0,S.isFunction)(N)){const U=(0,E.getRandomElement)(V.connections.filter(N));A=U?Promise.resolve(U):d.Event.toPromise(d.Event.filter(V.onDidAddConnection,N))}else A=N.routeCall(V,te,$);const W=A.then(U=>U.channelClient.getChannel(T));return F(W).call(te,$,Q)},listen(te,$){if((0,S.isFunction)(N))return V.getMulticastEvent(T,N,te,$);const Q=N.routeEvent(V,te,$).then(A=>A.channelClient.getChannel(T));return F(Q).listen(te,$)}}}getMulticastEvent(T,N,V,te){const $=this;let Q=new w.DisposableStore;const A=new d.Emitter({onFirstListenerAdd:()=>{Q=new w.DisposableStore;const W=new d.EventMultiplexer,U=new Map,z=_=>{const Z=_.channelClient.getChannel(T).listen(V,te),ne=W.add(Z);U.set(_,ne)},Y=_=>{const K=U.get(_);!K||(K.dispose(),U.delete(_))};$.connections.filter(N).forEach(z),d.Event.filter($.onDidAddConnection,N)(z,void 0,Q),$.onDidRemoveConnection(Y,void 0,Q),W.event(A.fire,A,Q),Q.add(W)},onLastListenerRemove:()=>{Q.dispose()}});return A.event}registerChannel(T,N){this.channels.set(T,N),this._connections.forEach(V=>{V.channelServer.registerChannel(T,N)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=L;class O{constructor(T,N,V=null){const te=new g;o(te,N),T.send(te.buffer),this.channelClient=new k(T,V),this.channelServer=new c(T,N,V)}getChannel(T){return this.channelClient.getChannel(T)}registerChannel(T,N){this.channelServer.registerChannel(T,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function F(q){return{call(T,N,V){return q.then(te=>te.call(T,N,V))},listen(T,N){const V=new d.Relay;return q.then(te=>V.input=te.listen(T,N)),V.event}}}e.getDelayedChannel=F;function j(q){let T=!1;return{call(N,V,te){return T?q.call(N,V,te):(0,t.timeout)(0).then(()=>T=!0).then(()=>q.call(N,V,te))},listen(N,V){if(T)return q.listen(N,V);const te=new d.Relay;return(0,t.timeout)(0).then(()=>T=!0).then(()=>te.input=q.listen(N,V)),te.event}}}e.getNextTickChannel=j;class ee{constructor(T){this.fn=T}routeCall(T){return this.route(T)}routeEvent(T){return this.route(T)}async route(T){for(const N of T.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await d.Event.toPromise(T.onDidAddConnection),await this.route(T)}}e.StaticRouter=ee;var se;(function(q){function T($,Q){const A=$,W=Q&&Q.disableMarshalling,U=new Map;for(const z in A)V(z)&&U.set(z,d.Event.buffer(A[z],!0));return new class{listen(z,Y,_){const K=U.get(Y);if(K)return K;if(te(Y)){const Z=A[Y];if(typeof Z=="function")return Z.call(A,_)}throw new Error(`Event not found: ${Y}`)}call(z,Y,_){const K=A[Y];if(typeof K=="function"){if(!W&&Array.isArray(_))for(let Z=0;Z<_.length;Z++)_[Z]=(0,C.revive)(_[Z]);return K.apply(A,_)}throw new Error(`Method not found: ${Y}`)}}}q.fromService=T;function N($,Q){const A=Q&&Q.disableMarshalling;return new Proxy({},{get(W,U){if(typeof U=="string")return Q?.properties?.has(U)?Q.properties.get(U):te(U)?function(z){return $.listen(U,z)}:V(U)?$.listen(U):async function(...z){let Y;Q&&!(0,S.isUndefinedOrNull)(Q.context)?Y=[Q.context,...z]:Y=z;const _=await $.call(U,Y);return A?_:(0,C.revive)(_)};throw new Error(`Property not found: ${String(U)}`)}})}q.toService=N;function V($){return $[0]==="o"&&$[1]==="n"&&P.isUpperAsciiLetter($.charCodeAt(2))}function te($){return/^onDynamic/.test($)&&P.isUpperAsciiLetter($.charCodeAt(9))}})(se=e.ProxyChannel||(e.ProxyChannel={}));const ae=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ie(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const T=q.toString();if(T!=="[object Object]")return T}return q}function ce(q){return Array.isArray(q)?q.map(ie):ie(q)}function H(q,T,N,V,te,$,Q){Q=ce(Q);const A=ae[te],W=A[V%A.length];let U=[`%c[${q}]%c[${String(T).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(V).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${W}`];/\($/.test($)?(U=U.concat(Q),U.push(")")):U.push(Q),console.log.apply(console,U)}e.logWithColors=H;class re{constructor(T,N){this._outgoingPrefix=T,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(T,N,V,te,$){this._totalOutgoing+=T,H(this._outgoingPrefix,this._totalOutgoing,T,N,V,te,$)}logIncoming(T,N,V,te,$){this._totalIncoming+=T,H(this._incomingPrefix,this._totalIncoming,T,N,V,te,$)}}e.IPCLogger=re}),define(X[140],J([0,1,17,3,43]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class R{constructor(d){this.port=d,this.onMessage=t.Event.fromDOMEventEmitter(this.port,"message",w=>E.VSBuffer.wrap(w.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=R;class M extends D.IPCClient{constructor(d,w){const C=new R(d);super(C,w);this.protocol=C}dispose(){this.protocol.disconnect()}}e.Client=M}),define(X[95],J([0,1,17,3,2,43]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var M;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(M=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let a=0;function c(k,L){if(!o.has(k)){const O=String(++a);o.set(k,O)}return o.get(k)}function v(k,L,O,F){if(!i.enableDiagnostics)return;const j=c(k,L);if(F instanceof E.VSBuffer||F instanceof Uint8Array||F instanceof ArrayBuffer||ArrayBuffer.isView(F)){const ee=E.VSBuffer.alloc(F.byteLength);ee.set(F),i.records.push({timestamp:Date.now(),id:j,label:L,type:O,buff:ee})}else i.records.push({timestamp:Date.now(),id:j,label:L,type:O,data:F})}i.traceSocketEvent=v})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var d;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let w=null;function C(){return w||(w=E.VSBuffer.alloc(0)),w}class P{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,a){if(o===0)return C();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const L=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=o),L}if(this._chunks[0].byteLength>o){const L=this._chunks[0].slice(0,o);return a&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),L}const c=E.VSBuffer.alloc(o);let v=0,k=0;for(;o>0;){const L=this._chunks[k];if(L.byteLength>o){const O=L.slice(0,o);c.set(O,v),v+=o,a&&(this._chunks[k]=L.slice(o),this._totalLength-=o),o-=o}else c.set(L,v),v+=L.byteLength,a?(this._chunks.shift(),this._totalLength-=L.byteLength):k++,o-=L.byteLength}return c}}e.ChunkStream=P;var S;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(S||(S={}));function f(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var u;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(u=e.ProtocolConstants||(e.ProtocolConstants={}));class p{constructor(o,a,c,v){this.type=o,this.id=a,this.ack=c,this.data=v,this.writtenTime=0}get size(){return this.data.byteLength}}class m extends D.Disposable{constructor(o){super();this._onMessage=this._register(new t.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new P,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:f(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const c=this._state.messageType,v=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",a),this._onMessage.fire(new p(c,v,k,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class y{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=E.VSBuffer.alloc(13);a.writeUInt8(o.type,0),a.writeUInt32BE(o.id,1),a.writeUInt32BE(o.ack,5),a.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:f(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(a,o.data)}_bufferAdd(o,a){const c=this._totalLength===0;return this._data.push(o,a),this._totalLength+=o.byteLength+a.byteLength,c}_bufferTake(){const o=E.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,a){this._bufferAdd(o,a)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class I extends D.Disposable{constructor(o){super();this._onMessage=new t.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new t.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new y(this._socket)),this._socketReader=this._register(new m(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new p(1,0,0,o))}}e.Protocol=I;class g extends R.IPCClient{constructor(o,a,c=null){super(o,a,c);this.protocol=o}static fromSocket(o,a){return new g(new I(o),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=g;class h{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new t.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=h;class l{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){const o=[];let a=0,c=this._first;for(;c;)o[a++]=c.data,c=c.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const a=new l(o);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let a=0;a<r._HISTORY_LENGTH;a++)this.lastRuns[a]=o-1e3*a;setInterval(()=>{for(let a=r._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),a=(1+r._HISTORY_LENGTH)*1e3;let c=0;for(let v=0;v<r._HISTORY_LENGTH;v++)o-this.lastRuns[v]<=a&&c++;return 1-c/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class n{constructor(o,a=null,c=r.getInstance()){this._onControlMessage=new h,this.onControlMessage=this._onControlMessage.event,this._onMessage=new h,this.onMessage=this._onMessage.event,this._onDidDispose=new h,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new h,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new h,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=c,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(v=>this._receiveMessage(v))),this._socketDisposables.push(this._socket.onClose(v=>this._onSocketClose.fire(v))),a&&this._socketReader.acceptChunk(a)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new p(5,0,0,C());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new p(7,0,0,C());this._socketWriter.write(o)}sendResume(){const o=new p(8,0,0,C());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new y(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new m(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(c=>this._receiveMessage(c))),this._socketDisposables.push(this._socket.onClose(c=>this._onSocketClose.fire(c))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,C());this._socketWriter.write(o);const a=this._outgoingUnackMsg.toArray();for(let c=0,v=a.length;c<v;c++)this._socketWriter.write(a[c]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new p(6,0,0,C())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const a=this._outgoingUnackMsg.toArray();for(let c=0,v=a.length;c<v;c++)this._socketWriter.write(a[c]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const c=new p(1,a,this._incomingAckId,o);this._outgoingUnackMsg.push(c),this._isReconnecting||(this._socketWriter.write(c),this._recvAckCheck())}sendControl(o){const a=new p(2,0,0,o);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),a=Date.now()-o.writtenTime,c=Date.now()-this._socketReader.lastReadTime,v=Date.now()-this._lastSocketTimeoutTime;if(a>=2e4&&c>=2e4&&v>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire(void 0);return}const k=Math.max(2e4-a,2e4-c,2e4-v,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},k)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new p(3,0,this._incomingAckId,C());this._socketWriter.write(o)}}e.PersistentProtocol=n}),define(X[141],J([0,1,38,17,3,2,43,129]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(C,P){const S=D.Event.fromNodeEventEmitter(E.validatedIpcMain,P,(u,p)=>({event:u,message:p})),f=D.Event.filter(S,({event:u})=>u.sender.id===C);return D.Event.map(f,({message:u})=>u&&t.VSBuffer.wrap(u))}class w extends M.IPCServer{constructor(){super(w.getOnDidClientConnect())}static getOnDidClientConnect(){const P=D.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:S})=>S);return D.Event.map(P,S=>{const f=S.id;w.Clients.get(f)?.dispose();const p=new D.Emitter;w.Clients.set(f,(0,R.toDisposable)(()=>p.fire()));const m=d(f,"vscode:message"),y=D.Event.any(D.Event.signal(d(f,"vscode:disconnect")),p.event);return{protocol:new b.Protocol(S,m),onDidClientDisconnect:y}})}}e.Server=w,w.Clients=new Map}),define(X[96],J([0,1,38,3,27,140]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class M extends R.Client{constructor(w,C){super({addEventListener:(P,S)=>w.addListener(P,S),removeEventListener:(P,S)=>w.removeListener(P,S),postMessage:P=>w.postMessage(P),start:()=>w.start(),close:()=>w.close()},C)}}e.Client=M;async function b(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const w=(0,D.generateUuid)();d.webContents.send("vscode:createMessageChannel",w);const C=t.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(S,f)=>({nonce:f,port:S.ports[0]})),{port:P}=await t.Event.toPromise(t.Event.once(t.Event.filter(C,S=>S.nonce===w)));return P}e.connect=b}),define(X[81],J([0,1,17,19,3,2,9,4,27,43,95]),function(B,e,E,t,D,R,M,b,d,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:B.__$__nodeRequire("crypto"),zlib:B.__$__nodeRequire("zlib"),net:B.__$__nodeRequire("net"),os:B.__$__nodeRequire("os")}}class S{constructor(c,v=""){this.debugLabel=v,this.socket=c,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=k=>{if(this.traceSocketEvent("error",{code:k?.code,message:k?.message}),k){if(k.code==="EPIPE")return;(0,t.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}traceSocketEvent(c,v){C.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,c,v)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(c){const v=k=>{this.traceSocketEvent("read",k),c(E.VSBuffer.wrap(k))};return this.socket.on("data",v),{dispose:()=>this.socket.off("data",v)}}onClose(c){const v=k=>{this.traceSocketEvent("close",{hadError:k}),c({type:0,hadError:k,error:void 0})};return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(c){const v=()=>{this.traceSocketEvent("nodeEndReceived"),c()};return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(c){if(!this.socket.destroyed)try{this.traceSocketEvent("write",c),this.socket.write(c.buffer,v=>{if(v){if(v.code==="EPIPE")return;(0,t.onUnexpectedError)(v)}})}catch(v){if(v.code==="EPIPE")return;(0,t.onUnexpectedError)(v)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((c,v)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),c();return}const k=()=>{this.socket.off("close",k),this.socket.off("end",k),this.socket.off("error",k),this.socket.off("timeout",k),this.socket.off("drain",k),this.traceSocketEvent("nodeDrainEnd"),c()};this.socket.on("close",k),this.socket.on("end",k),this.socket.on("error",k),this.socket.on("timeout",k),this.socket.on("drain",k)})}}e.NodeSocket=S;var f;(function(a){a[a.MinHeaderByteSize=2]="MinHeaderByteSize"})(f||(f={}));var u;(function(a){a[a.PeekHeader=1]="PeekHeader",a[a.ReadHeader=2]="ReadHeader",a[a.ReadBody=3]="ReadBody",a[a.Fin=4]="Fin"})(u||(u={}));class p extends R.Disposable{constructor(c,v,k,L){super();this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=c,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:v,inflateBytesLength:k?.byteLength||0,recordInflateBytes:L}),this._flowManager=this._register(new m(this,v,k,L,this._onData,(O,F)=>this._write(O,F))),this._register(this._flowManager.onError(O=>{console.error(O),(0,t.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})})),this._incomingData=new C.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(c,v){this.socket.traceSocketEvent(c,v)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(c){return this._onData.event(c)}onClose(c){return this._onClose.event(c)}onEnd(c){return this.socket.onEnd(c)}write(c){this._flowManager.writeMessage(c)}_write(c,v){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",c);let k=2;c.byteLength<126?k+=0:c.byteLength<2**16?k+=2:k+=8;const L=E.VSBuffer.alloc(k);if(v?L.writeUInt8(194,0):L.writeUInt8(130,0),c.byteLength<126)L.writeUInt8(c.byteLength,1);else if(c.byteLength<2**16){L.writeUInt8(126,1);let O=1;L.writeUInt8(c.byteLength>>>8&255,++O),L.writeUInt8(c.byteLength>>>0&255,++O)}else{L.writeUInt8(127,1);let O=1;L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(c.byteLength>>>24&255,++O),L.writeUInt8(c.byteLength>>>16&255,++O),L.writeUInt8(c.byteLength>>>8&255,++O),L.writeUInt8(c.byteLength>>>0&255,++O)}this.socket.write(E.VSBuffer.concat([L,c]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(c){if(c.byteLength!==0){for(this._incomingData.acceptChunk(c);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const v=this._incomingData.peek(this._state.readLen),k=v.readUInt8(0),L=(k&128)>>>7,O=(k&64)>>>6,F=v.readUInt8(1),j=(F&128)>>>7,ee=F&127;this._state.state=2,this._state.readLen=2+(j?4:0)+(ee===126?2:0)+(ee===127?8:0),this._state.fin=L,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(L),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const v=this._incomingData.read(this._state.readLen),k=v.readUInt8(1),L=(k&128)>>>7;let O=k&127,F=1;O===126?O=v.readUInt8(++F)*2**8+v.readUInt8(++F):O===127&&(O=v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*0+v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F));let j=0;L&&(j=v.readUInt8(++F)*2**24+v.readUInt8(++F)*2**16+v.readUInt8(++F)*2**8+v.readUInt8(++F)),this._state.state=3,this._state.readLen=O,this._state.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const v=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",v),g(v,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",v),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(v,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await D.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class m extends R.Disposable{constructor(c,v,k,L,O,F){super();this._tracer=c,this._onData=O,this._writeFn=F,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new D.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,v?(this._zlibInflateStream=this._register(new y(this._tracer,L,k,{windowBits:15})),this._zlibDeflateStream=this._register(new I(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(j=>this._onError.fire(j))),this._register(this._zlibDeflateStream.onError(j=>this._onError.fire(j)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:E.VSBuffer.alloc(0)}writeMessage(c){this._writeQueue.push(c),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const c=this._writeQueue.shift();if(this._zlibDeflateStream){const v=await this._deflateMessage(this._zlibDeflateStream,c);this._writeFn(v,!0)}else this._writeFn(c,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(c,v){return new Promise((k,L)=>{c.write(v),c.flush(O=>k(O))})}acceptFrame(c,v,k){this._readQueue.push({data:c,isCompressed:v,isLastFrameOfMessage:k}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const c=this._readQueue.shift();if(this._zlibInflateStream&&c.isCompressed){const v=await this._inflateFrame(this._zlibInflateStream,c.data,c.isLastFrameOfMessage);this._onData.fire(v)}else this._onData.fire(c.data)}this._isProcessingReadQueue=!1}}_inflateFrame(c,v,k){return new Promise((L,O)=>{c.write(v),k&&c.write(E.VSBuffer.fromByteArray([0,0,255,255])),c.flush(F=>L(F))})}}class y extends R.Disposable{constructor(c,v,k,L){super();this._tracer=c,this._recordInflateBytes=v,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=P().zlib.createInflateRaw(L),this._zlibInflate.on("error",O=>{this._tracer.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this._onError.fire(O)}),this._zlibInflate.on("data",O=>{this._tracer.traceSocketEvent("zlibInflateData",O),this._pendingInflateData.push(E.VSBuffer.wrap(O))}),k&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",k.buffer),this._zlibInflate.write(k.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?E.VSBuffer.concat(this._recordedInflateBytes):E.VSBuffer.alloc(0)}write(c){this._recordInflateBytes&&this._recordedInflateBytes.push(c.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",c),this._zlibInflate.write(c.buffer)}flush(c){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const v=E.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,c(v)})}}class I extends R.Disposable{constructor(c,v){super();this._tracer=c,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=P().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",k=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:k?.message,code:k?.code}),this._onError.fire(k)}),this._zlibDeflate.on("data",k=>{this._tracer.traceSocketEvent("zlibDeflateData",k),this._pendingDeflateData.push(E.VSBuffer.wrap(k))})}write(c){this._tracer.traceSocketEvent("zlibDeflateWrite",c.buffer),this._zlibDeflate.write(c.buffer)}flush(c){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let v=E.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,v=v.slice(0,v.byteLength-4),c(v)})}}function g(a,c){if(c===0)return;const v=a.byteLength>>>2;for(let ee=0;ee<v;ee++){const se=a.readUInt32BE(ee*4);a.writeUInt32BE(se^c,ee*4)}const k=v*4,L=a.byteLength-k,O=c>>>24&255,F=c>>>16&255,j=c>>>8&255;L>=1&&a.writeUInt8(a.readUInt8(k)^O,k),L>=2&&a.writeUInt8(a.readUInt8(k+1)^F,k+1),L>=3&&a.writeUInt8(a.readUInt8(k+2)^j,k+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const h={[2]:107,[1]:103};function l(){const a=(0,d.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${a}-sock`;let c;return e.XDG_RUNTIME_DIR?c=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${a}.sock`):c=(0,M.join)(P().os.tmpdir(),`vscode-ipc-${a}.sock`),r(c),c}e.createRandomIPCHandle=l;function s(a,c,v){const k=P().crypto.createHash("md5").update(a).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${k}-${v}-${c}-sock`;let L;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?L=(0,M.join)(e.XDG_RUNTIME_DIR,`vscode-${k.substr(0,8)}-${v}-${c}.sock`):L=(0,M.join)(a,`${v}-${c}.sock`),r(L),L}e.createStaticIPCHandle=s;function r(a){const c=h[b.platform];typeof c=="number"&&a.length>=c&&console.warn(`WARNING: IPC handle "${a}" is longer than ${c} chars, try a shorter --user-data-dir`)}class n extends w.IPCServer{constructor(c){super(n.toClientConnectionEvent(c));this.server=c}static toClientConnectionEvent(c){const v=D.Event.fromNodeEventEmitter(c,"connection");return D.Event.map(v,k=>({protocol:new C.Protocol(new S(k,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(k,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function i(a){return new Promise((c,v)=>{const k=P().net.createServer();k.on("error",v),k.listen(a,()=>{k.removeListener("error",v),c(new n(k))})})}e.serve=i;function o(a,c){return new Promise((v,k)=>{const L=P().net.createConnection(a,()=>{L.removeListener("error",k),v(C.Client.fromSocket(new S(L,`ipc-client${c}`),c))});L.once("error",k)})}e.connect=o}),define(X[97],J([0,1,8,3,2,13]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var M;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(M=e.StorageHint||(e.StorageHint={}));function b(P){const S=P;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var d;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(d=e.StorageState||(e.StorageState={}));class w extends D.Disposable{constructor(S,f=Object.create(null)){super();this.database=S,this.options=f,this._onDidChangeStorage=this._register(new t.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new E.ThrottledDelayer(w.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((f,u)=>this.accept(u,f)),S.deleted?.forEach(f=>this.accept(f,void 0))}accept(S,f){if(this.state===d.Closed)return;let u=!1;(0,R.isUndefinedOrNull)(f)?u=this.cache.delete(S):this.cache.get(S)!==f&&(this.cache.set(S,f),u=!0),u&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==M.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,f){const u=this.cache.get(S);return(0,R.isUndefinedOrNull)(u)?f:u}getBoolean(S,f){const u=this.get(S);return(0,R.isUndefinedOrNull)(u)?f:u==="true"}getNumber(S,f){const u=this.get(S);return(0,R.isUndefinedOrNull)(u)?f:parseInt(u,10)}async set(S,f){if(this.state===d.Closed)return;if((0,R.isUndefinedOrNull)(f))return this.delete(S);const u=String(f);if(this.cache.get(S)!==u)return this.cache.set(S,u),this.pendingInserts.set(S,u),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async delete(S){if(!(this.state===d.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(S){if(!!this.hasPending)return this.doFlush(S)}async doFlush(S){return this.flushDelayer.trigger(()=>this.flushPending(),S)}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=w,w.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=t.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert?.forEach((f,u)=>this.items.set(u,f)),S.delete?.forEach(f=>this.items.delete(f))}async close(){}}e.InMemoryStorageDatabase=C}),define(X[142],J([0,1,8,3,33,9,23]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{constructor(C,P=Object.create(null)){this.path=C,this.options=P,this.name=(0,R.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return t.Event.None}async getItems(){const C=await this.whenConnected,P=new Map;return(await this.all(C,"SELECT * FROM ItemTable")).forEach(f=>P.set(f.key,f.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${P.size} rows`),P}async updateItems(C){const P=await this.whenConnected;return this.doUpdateItems(P,C)}doUpdateItems(C,P){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${P.insert?(0,D.mapToString)(P.insert):"0"}), delete(${P.delete?(0,D.setToString)(P.delete):"0"})`),this.transaction(C,()=>{const S=P.insert,f=P.delete;if(S&&S.size>0){const u=[];u.push([]);let p=0;S.forEach((m,y)=>{let I=u[p];I.length>b.MAX_HOST_PARAMETERS&&(p++,I=[],u.push(I)),I.push(y,m)}),u.forEach(m=>{this.prepare(C,`INSERT INTO ItemTable VALUES ${new Array(m.length/2).fill("(?,?)").join(",")}`,y=>y.run(m),()=>{const y=[];let I=0;return S.forEach((g,h)=>{y.push(h),I+=g.length}),`Keys: ${y.join(", ")} Length: ${I}`})})}if(f&&f.size){const u=[];u.push([]);let p=0;f.forEach(m=>{let y=u[p];y.length>b.MAX_HOST_PARAMETERS&&(p++,y=[],u.push(y)),y.push(m)}),u.forEach(m=>{this.prepare(C,`DELETE FROM ItemTable WHERE key IN (${new Array(m.length).fill("?").join(",")})`,y=>y.run(m),()=>{const y=[];return f.forEach(I=>{y.push(I)}),`Keys: ${y.join(", ")}`})})}})}async close(C){this.logger.trace(`[storage ${this.name}] close()`);const P=await this.whenConnected;return this.doClose(P,C)}doClose(C,P){return new Promise((S,f)=>{C.db.close(u=>(u&&this.handleSQLiteError(C,`[storage ${this.name}] close(): ${u}`),this.path===b.IN_MEMORY_PATH?S():!C.isErroneous&&!C.isInMemory?this.backup().then(S,p=>(this.logger.error(`[storage ${this.name}] backup(): ${p}`),S())):typeof P=="function"?M.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(p=>{const m=()=>this.doClose(p,void 0);return this.doUpdateItems(p,{insert:P()}).then(()=>m(),y=>(m(),Promise.reject(y)))})).then(S,f):f(u||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const C=this.toBackupPath(this.path);return M.Promises.copy(this.path,C,{preserveSymlinks:!1})}toBackupPath(C){return`${C}.backup`}async checkIntegrity(C){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${C})`);const P=await this.whenConnected,S=await this.get(P,C?"PRAGMA integrity_check":"PRAGMA quick_check"),f=C?S.integrity_check:S.quick_check;return P.isErroneous?`${f} (last error: ${P.lastError})`:P.isInMemory?`${f} (in-memory!)`:f}async connect(C,P=!0){this.logger.trace(`[storage ${this.name}] open(${C}, retryOnBusy: ${P})`);try{return await this.doConnect(C)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&P)return await(0,E.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(C,!1);try{await M.Promises.unlink(C);try{await M.Promises.rename(this.toBackupPath(C),C)}catch{}return await this.doConnect(C)}catch(f){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${f}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(C,P){C.isErroneous=!0,C.lastError=P,this.logger.error(P)}doConnect(C){return new Promise((P,S)=>{new Promise((f,u)=>{B(["@vscode/sqlite3"],f,u)}).then(f=>{const u={db:new(this.logger.isTracing?f.verbose().Database:f.Database)(C,p=>p?u.db&&p.code!=="SQLITE_CANTOPEN"?u.db.close(()=>S(p)):S(p):this.exec(u,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>P(u),m=>u.db.close(()=>S(m)))),isInMemory:C===b.IN_MEMORY_PATH};u.db.on("error",p=>this.handleSQLiteError(u,`[storage ${this.name}] Error (event): ${p}`)),this.logger.isTracing&&u.db.on("trace",p=>this.logger.trace(`[storage ${this.name}] Trace (event): ${p}`))},S)})}exec(C,P){return new Promise((S,f)=>{C.db.exec(P,u=>u?(this.handleSQLiteError(C,`[storage ${this.name}] exec(): ${u}`),f(u)):S())})}get(C,P){return new Promise((S,f)=>{C.db.get(P,(u,p)=>u?(this.handleSQLiteError(C,`[storage ${this.name}] get(): ${u}`),f(u)):S(p))})}all(C,P){return new Promise((S,f)=>{C.db.all(P,(u,p)=>u?(this.handleSQLiteError(C,`[storage ${this.name}] all(): ${u}`),f(u)):S(p))})}transaction(C,P){return new Promise((S,f)=>{C.db.serialize(()=>{C.db.run("BEGIN TRANSACTION"),P(),C.db.run("END TRANSACTION",u=>u?(this.handleSQLiteError(C,`[storage ${this.name}] transaction(): ${u}`),f(u)):S())})})}prepare(C,P,S,f){const u=C.db.prepare(P),p=m=>{this.handleSQLiteError(C,`[storage ${this.name}] prepare(): ${m} (${P}). Details: ${f()}`)};u.on("error",p),S(u),u.finalize(m=>{m&&p(m),u.removeListener("error",p)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class d{constructor(C){C&&typeof C.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=C.logTrace),C&&typeof C.logError=="function"&&(this.logError=C.logError)}get isTracing(){return!!this.logTrace}trace(C){this.logTrace?.(C)}error(C){this.logError?.(C)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(X[143],J([11,10]),function(B,e){return B.create("vs/base/node/processes",e)}),define(X[82],J([0,1,42,30,12,50,9,4,36,77,13,125,23,143]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function u(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function p(l,s){if(b.isWindows)try{const r={stdio:["pipe","pipe","ignore"]};s&&(r.cwd=s);const n=E.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],r);return new Promise(i=>{n.once("error",o=>{i({success:!1,error:o})}),n.once("exit",(o,a)=>{i(o===0?{success:!0}:{success:!1,code:o!==null?o:1})})})}catch(r){return Promise.resolve({success:!1,error:r,code:r.status?u(r.status):1})}else if(b.isLinux||b.isMacintosh)try{const r=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",B).fsPath;return new Promise(n=>{E.execFile(r,[l.pid.toString()],{encoding:"utf8",shell:!0},(i,o,a)=>{n(i?{success:!1,error:i}:{success:!0})})})}catch(r){return Promise.resolve({success:!1,error:r})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function m(l=d.env){return l.comspec||"cmd.exe"}e.getWindowsShell=m;class y{constructor(s,r,n,i){if(r!==void 0&&n!==void 0&&i!==void 0)this.cmd=s,this.args=r,this.shell=n,this.options=i;else{const o=s;this.cmd=o.command,this.shell=o.isShellCommand,this.args=o.args.slice(0),this.options=o.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const o=Object.create(null);Object.keys(d.env).forEach(a=>{o[a]=d.env[a]}),Object.keys(this.options.env).forEach(a=>{o[a]=this.options.env[a]}),this.options.env=o}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const r=s.lastIndexOf(M.sep);return r!==-1&&(s=s.substring(r+1)),y.WellKnowCommands[s]?s:"other"}start(s){return b.isWindows&&(this.options&&this.options.cwd&&t.isUNC(this.options.cwd)||!this.options&&t.isUNC(d.cwd()))?Promise.reject(new Error(f.localize(0,null))):this.useExec().then(r=>{let n,i;const o=new Promise((a,c)=>{n=a,i=c});if(r){let a=this.cmd;this.args&&(a=a+" "+this.args.join(" ")),this.childProcess=E.exec(a,this.options,(c,v,k)=>{this.childProcess=null;const L=c;L&&L.killed?i({killed:this.terminateRequested,stdout:v.toString(),stderr:k.toString()}):this.handleExec(n,s,c,v,k)})}else{let a=null;const c=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,n,s,i);const k={terminated:this.terminateRequested};C.isNumber(v)&&(k.cmdCode=v),n(k)};if(this.shell&&b.isWindows){const v=R.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let k=!1,L=!1;const O=[];let F=this.ensureQuotes(this.cmd);O.push(F.value),k=F.quoted,this.args&&this.args.forEach(ee=>{F=this.ensureQuotes(ee),O.push(F.value),L=L&&F.quoted});const j=["/s","/c"];k?L?j.push('"'+O.join(" ")+'"'):O.length>1?j.push('"'+O[0]+'" '+O.slice(1).join(" ")):j.push('"'+O[0]+'"'):j.push(O.join(" ")),a=E.spawn(m(),j,v)}else this.cmd&&(a=E.spawn(this.cmd,this.args,this.options));a&&(this.childProcess=a,this.childProcessPromise=Promise.resolve(a),this.pidResolve&&(this.pidResolve(C.isNumber(a.pid)?a.pid:-1),this.pidResolve=void 0),a.on("error",v=>{this.childProcess=null,i({terminated:this.terminateRequested,error:v})}),a.pid&&(this.childProcess.on("close",c),this.handleSpawn(a,n,s,i,!0)))}return o})}handleClose(s,r,n,i){}ensureQuotes(s){return y.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,p(s,this.options.cwd).then(r=>(r.success&&(this.childProcess=null),r))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!b.isWindows)return s(!1);const r=E.spawn(m(),["/s","/c"]);r.on("error",n=>s(!0)),r.on("exit",n=>s(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class I extends y{constructor(s,r,n,i){super(s,r,n,i);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,r,n,i,o){[i,o].forEach((a,c)=>{const v=new P.LineDecoder;v.write(a).forEach(O=>{r({line:O,source:c===0?0:1})});const L=v.end();L&&r({line:L,source:c===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,r,n,i,o){const a=new P.LineDecoder,c=new P.LineDecoder;s.stdout.on("data",v=>{a.write(v).forEach(L=>n({line:L,source:0}))}),s.stderr.on("data",v=>{c.write(v).forEach(L=>n({line:L,source:1}))}),this.stdoutLineDecoder=a,this.stderrLineDecoder=c}handleClose(s,r,n,i){const o=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;o&&n({line:o,source:0});const a=this.stderrLineDecoder?this.stderrLineDecoder.end():null;a&&n({line:a,source:1})}}e.LineProcess=I;function g(l){let s=[],r=!1;const n=function(i){if(r){s.push(i);return}(!l.send(i,a=>{if(a&&console.error(a),r=!1,s.length>0){const c=s.slice(0);s=[],c.forEach(v=>n(v))}})||b.isWindows)&&(r=!0)};return{send:n}}e.createQueuedSender=g;var h;(function(l){async function s(r,n,i){if(M.isAbsolute(r))return r;if(n===void 0&&(n=d.cwd()),M.dirname(r)!=="."||(i===void 0&&C.isString(d.env.PATH)&&(i=d.env.PATH.split(M.delimiter)),i===void 0||i.length===0))return M.join(n,r);async function a(c){if(await S.Promises.exists(c)){let v;try{v=await S.Promises.stat(c)}catch(k){k.message.startsWith("EACCES")&&(v=await S.Promises.lstat(c))}return v?!v.isDirectory():!1}return!1}for(const c of i){let v;if(M.isAbsolute(c)?v=M.join(c,r):v=M.join(n,c,r),await a(v))return v;let k=v+".com";if(await a(k)||(k=v+".exe",await a(k)))return k}return M.join(n,r)}l.findExecutable=s})(h=e.win32||(e.win32={}))}),define(X[144],J([0,1,29,4,139,82]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function M(f,u){return f===1?t.isWindows?P():R.getWindowsShell(u):w(f,u)}e.getSystemShell=M;function b(f,u){return f===1?t.isWindows?S(u):R.getWindowsShell(u):w(f,u)}e.getSystemShellSync=b;let d=null;function w(f,u){if(t.isLinux&&f===2||t.isMacintosh&&f===3)return"/bin/bash";if(!d){let p;if(t.isWindows)p="/bin/bash";else{if(p=u.SHELL,!p)try{p=(0,E.userInfo)().shell}catch{}p||(p="sh"),p==="/bin/false"&&(p="/bin/bash")}d=p}return d}let C=null;async function P(){return C||(C=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),C}function S(f){if(C)return C;const u=t.isWindows&&parseFloat((0,E.release)())>=10,p=f.hasOwnProperty("PROCESSOR_ARCHITEW6432"),m=`${f.windir}\\${p?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?m:R.getWindowsShell(f)}}),define(X[145],J([0,1,42,8,17,21,136,19,3,2,50,82,77,43]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class u extends f.ChannelServer{constructor(y){super({send:I=>{try{process.send?.(I.buffer.toString("base64"))}catch{}},onMessage:d.Event.fromNodeEventEmitter(process,"message",I=>D.VSBuffer.wrap(Buffer.from(I,"base64")))},y);process.once("disconnect",()=>this.dispose())}}e.Server=u;class p{constructor(y,I){this.modulePath=y,this.options=I,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=I&&I.timeout?I.timeout:6e4;this.disposeDelayer=new t.Delayer(g),this.child=null,this._client=null}getChannel(y){const I=this;return{call(g,h,l){return I.requestPromise(y,g,h,l)},listen(g,h){return I.requestEvent(y,g,h)}}}requestPromise(y,I,g,h=R.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(y),s=(0,t.createCancelablePromise)(i=>l.call(I,g,i)),r=h.onCancellationRequested(()=>s.cancel()),n=(0,w.toDisposable)(()=>s.cancel());return this.activeRequests.add(n),s.finally(()=>{r.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(y,I,g){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let h;const l=new d.Emitter({onFirstListenerAdd:()=>{h=this.getCachedChannel(y).listen(I,g)(l.fire,l),this.activeRequests.add(h)},onLastListenerRemove:()=>{this.activeRequests.delete(h),h.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const y=this.options&&this.options.args?this.options.args:[],I=Object.create(null);I.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(I.env={...I.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(I.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(I.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(I.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),I.execArgv===void 0&&(I.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,S.removeDangerousEnvVariables)(I.env),this.child=(0,E.fork)(this.modulePath,y,I);const g=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,M.isRemoteConsoleLog)(o)){(0,M.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(D.VSBuffer.wrap(Buffer.from(o,"base64")))});const l=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&l.send(o.buffer.toString("base64")),r=g.event,n={send:s,onMessage:r};this._client=new f.ChannelClient(n);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,a)=>{process.removeListener("exit",i),this.activeRequests.forEach(c=>(0,w.dispose)(c)),this.activeRequests.clear(),o!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+a),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:a})})}return this._client}getCachedChannel(y){let I=this.channels.get(y);return I||(I=this.client.getChannel(y),this.channels.set(y,I)),I}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=p}),define(X[146],J([11,10]),function(B,e){return B.create("vs/code/electron-main/app",e)}),define(X[147],J([11,10]),function(B,e){return B.create("vs/platform/configuration/common/configurationRegistry",e)}),define(X[148],J([11,10]),function(B,e){return B.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(X[149],J([11,10]),function(B,e){return B.create("vs/platform/environment/node/argv",e)}),define(X[150],J([11,10]),function(B,e){return B.create("vs/platform/environment/node/argvHelper",e)}),define(X[151],J([11,10]),function(B,e){return B.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(X[152],J([11,10]),function(B,e){return B.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(X[153],J([11,10]),function(B,e){return B.create("vs/platform/files/common/fileService",e)}),define(X[154],J([11,10]),function(B,e){return B.create("vs/platform/files/common/files",e)}),define(X[155],J([11,10]),function(B,e){return B.create("vs/platform/files/common/io",e)}),define(X[156],J([11,10]),function(B,e){return B.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(X[157],J([11,10]),function(B,e){return B.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(X[158],J([11,10]),function(B,e){return B.create("vs/platform/issue/electron-main/issueMainService",e)}),define(X[159],J([11,10]),function(B,e){return B.create("vs/platform/menubar/electron-main/menubar",e)}),define(X[160],J([11,10]),function(B,e){return B.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(X[161],J([11,10]),function(B,e){return B.create("vs/platform/request/common/request",e)}),define(X[162],J([11,10]),function(B,e){return B.create("vs/platform/shell/node/shellEnv",e)}),define(X[163],J([11,10]),function(B,e){return B.create("vs/platform/telemetry/common/telemetryService",e)}),define(X[164],J([11,10]),function(B,e){return B.create("vs/platform/update/common/update.config.contribution",e)}),define(X[165],J([11,10]),function(B,e){return B.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(X[166],J([11,10]),function(B,e){return B.create("vs/platform/windows/electron-main/windowImpl",e)}),define(X[167],J([11,10]),function(B,e){return B.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(X[168],J([11,10]),function(B,e){return B.create("vs/platform/workspace/common/workspace",e)}),define(X[169],J([11,10]),function(B,e){return B.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(X[170],J([11,10]),function(B,e){return B.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(X[171],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(D){return D&&D.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function t(D){return D&&D.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=t}),define(X[172],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEmptyWindowBackupInfo=void 0;function E(t){return typeof t?.backupFolder=="string"}e.isEmptyWindowBackupInfo=E}),define(X[173],J([0,1,3,2]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(b,d,w){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:w[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:w[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:w[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:w[0],port:w[1],subId:w[2]}))}throw new Error("Method not implemented.")}listen(b,d,w){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class R extends t.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,d,w){this.channel.call("attach",[b,d,w])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,d){this.channel.call("terminate",[b,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,d){return this.channel.call("openExtensionDevelopmentHostWindow",[b,d])}}e.ExtensionHostDebugChannelClient=R}),define(X[174],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;class E{constructor(D){this.machineId=D}encryption(){return new Promise((D,R)=>B(["vscode-encrypt"],D,R))}async encrypt(D){try{return(await this.encryption()).encrypt(this.machineId,D)}catch{return D}}async decrypt(D){try{return(await this.encryption()).decrypt(this.machineId,D)}catch{return D}}}e.EncryptionMainService=E}),define(X[175],J([0,1,132,51,12,9,36,16,7]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class w{constructor(p,m,y){this._args=p,this.paths=m,this.productService=y,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,R.dirname)(D.FileAccess.asFileUri("",B).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,R.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get cacheHome(){return d.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const p=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.join)(this.userDataPath,"logs",p)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,R.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return d.URI.file((0,R.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(d.URI.file((0,R.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const p=M.env.VSCODE_PORTABLE;return p?d.URI.file((0,R.join)(p,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,R.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,R.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const p=this.args["builtin-extensions-dir"];return p?(0,R.resolve)(p):(0,R.normalize)((0,R.join)(D.FileAccess.asFileUri("",B).fsPath,"..","extensions"))}get extensionsDownloadPath(){const p=this.args["extensions-download-dir"];return p?(0,R.resolve)(p):(0,R.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const p=this.args["extensions-dir"];if(p)return(0,R.resolve)(p);const m=M.env.VSCODE_EXTENSIONS;if(m)return m;const y=M.env.VSCODE_PORTABLE;return y?(0,R.join)(y,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const p=this.args.extensionDevelopmentPath;if(Array.isArray(p))return p.map(m=>/^[^:/?#]+?:\/\//.test(m)?d.URI.parse(m):d.URI.file((0,R.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(p=>p==="ui"||p==="workspace"||p==="web"?p:"workspace")}get extensionTestsLocationURI(){const p=this.args.extensionTestsPath;if(p)return/^[^:/?#]+?:\/\//.test(p)?d.URI.parse(p):d.URI.file((0,R.normalize)(p))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const p=this.args["disable-extension"];if(p){if(typeof p=="string")return[p];if(Array.isArray(p)&&p.length>0)return p}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!M.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return d.URI.file((0,R.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const p=M.env.VSCODE_PORTABLE;return p?d.URI.file((0,R.join)(p,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([t.memoize],w.prototype,"appRoot",null),fe([t.memoize],w.prototype,"userHome",null),fe([t.memoize],w.prototype,"userDataPath",null),fe([t.memoize],w.prototype,"appSettingsHome",null),fe([t.memoize],w.prototype,"tmpDir",null),fe([t.memoize],w.prototype,"cacheHome",null),fe([t.memoize],w.prototype,"stateResource",null),fe([t.memoize],w.prototype,"userRoamingDataHome",null),fe([t.memoize],w.prototype,"userDataSyncHome",null),fe([t.memoize],w.prototype,"userDataSyncLogResource",null),fe([t.memoize],w.prototype,"editSessionsLogResource",null),fe([t.memoize],w.prototype,"sync",null),fe([t.memoize],w.prototype,"machineSettingsResource",null),fe([t.memoize],w.prototype,"workspaceStorageHome",null),fe([t.memoize],w.prototype,"localHistoryHome",null),fe([t.memoize],w.prototype,"keyboardLayoutResource",null),fe([t.memoize],w.prototype,"argvResource",null),fe([t.memoize],w.prototype,"isExtensionDevelopment",null),fe([t.memoize],w.prototype,"untitledWorkspacesHome",null),fe([t.memoize],w.prototype,"installSourcePath",null),fe([t.memoize],w.prototype,"builtinExtensionsPath",null),fe([t.memoize],w.prototype,"extensionsPath",null),fe([t.memoize],w.prototype,"extensionDevelopmentLocationURI",null),fe([t.memoize],w.prototype,"extensionDevelopmentKind",null),fe([t.memoize],w.prototype,"extensionTestsLocationURI",null),fe([t.memoize],w.prototype,"debugExtensionHost",null),fe([t.memoize],w.prototype,"serviceMachineIdResource",null),fe([t.memoize],w.prototype,"telemetryLogResource",null),fe([t.memoize],w.prototype,"disableWorkspaceTrust",null),fe([t.memoize],w.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=w;function C(u,p){return f(u["inspect-extensions"],u["inspect-brk-extensions"],5870,p,u.debugId,u.extensionEnvironment)}e.parseExtensionHostPort=C;function P(u,p){return f(u["inspect-search"],u["inspect-brk-search"],5876,p,u.extensionEnvironment)}e.parseSearchPort=P;function S(u,p){return f(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,p,u.extensionEnvironment)}e.parsePtyHostPort=S;function f(u,p,m,y,I,g){const l=Number(p||u)||(y?null:m),s=l?Boolean(!!p):!1;let r;if(g)try{r=JSON.parse(g)}catch{}return{port:l,break:s,debugId:I,env:r}}}),define(X[98],J([0,1,260,4,149]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const R={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,D.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(11,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(12,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,D.localize)(13,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(15,null)},category:{type:"string",cat:"e",description:(0,D.localize)(16,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,D.localize)(17,null)},"pre-release":{type:"boolean",cat:"e",description:(0,D.localize)(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,D.localize)(19,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,D.localize)(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(21,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(22,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(24,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(25,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,D.localize)(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,D.localize)(27,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(28,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,D.localize)(29,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,D.localize)(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(32,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(33,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const M={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(u,p,m=M){const y={},I=["_"],g=[];for(const r in p){const n=p[r];n.alias&&(y[r]=n.alias),n.type==="string"||n.type==="string[]"?(I.push(r),n.deprecates&&I.push(...n.deprecates)):n.type==="boolean"&&(g.push(r),n.deprecates&&g.push(...n.deprecates))}const h=E(u,{string:I,boolean:g,alias:y}),l={},s=h;l._=h._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in p){const n=p[r];n.alias&&delete s[n.alias];let i=s[r];if(n.deprecates)for(const o of n.deprecates)s.hasOwnProperty(o)&&(i||(i=s[o],i&&m.onDeprecatedOption(o,n.deprecationMessage||(0,D.localize)(34,null,r))),delete s[o]);if(typeof i!="undefined"){if(n.type==="string[]"){if(Array.isArray(i)||(i=[i]),!n.allowEmptyValue){const o=i.filter(a=>a.length>0);o.length!==i.length&&(m.onEmptyValue(r),i=o.length>0?o:void 0)}}else n.type==="string"&&(Array.isArray(i)?(i=i.pop(),m.onMultipleValues(r,i)):!i&&!n.allowEmptyValue&&(m.onEmptyValue(r),i=void 0));l[r]=i,n.deprecationMessage&&m.onDeprecatedOption(r,n.deprecationMessage)}delete s[r]}for(const r in s)m.onUnknownOption(r);return l}e.parseArgs=b;function d(u,p){let m="";return p.args&&(Array.isArray(p.args)?m=` <${p.args.join("> <")}>`:m=` <${p.args}>`),p.alias?`-${p.alias} --${u}${m}`:`--${u}${m}`}function w(u,p){let m=0;const y=[];for(const l in u){const s=u[l],r=d(l,s);m=Math.max(m,r.length),y.push([r,s.description])}const I=m+2+1;if(p-I<25)return y.reduce((l,s)=>l.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const g=p-I-1,h=[];for(const l of y){const s=l[0],r=P(l[1],g),n=C(I-s.length-2);h.push("  "+s+n+r[0]);for(let i=1;i<r.length;i++)h.push(C(I)+r[i])}return h}e.formatOptions=w;function C(u){return" ".repeat(u)}function P(u,p){const m=[];for(;u.length;){const y=u.length<p?u.length:u.lastIndexOf(" ",p),I=u.slice(0,y).trim();u=u.slice(y),m.push(I)}return m}function S(u,p,m,y,I){const g=process.stdout.isTTY&&process.stdout.columns||80,h=I?.noInputFiles!==!0?`[${(0,D.localize)(35,null)}...]`:"",l=[`${u} ${m}`];l.push(""),l.push(`${(0,D.localize)(36,null)}: ${p} [${(0,D.localize)(37,null)}]${h}`),l.push(""),I?.noPipe!==!0&&(t.isWindows?l.push((0,D.localize)(38,null,p)):l.push((0,D.localize)(39,null,p)),l.push(""));const s={};for(const r in y){const n=y[r];if(n.description&&n.cat){let i=s[n.cat];i||(s[n.cat]=i={}),i[r]=n}}for(const r in s){const n=r,i=s[n];i&&(l.push(R[n]),l.push(...w(i,g)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=S;function f(u,p){return`${u||(0,D.localize)(40,null)}
${p||(0,D.localize)(41,null)}
${process.arch}`}e.buildVersionMessage=f}),define(X[176],J([0,1,76,173,98]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class R extends t.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,d,w){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(w[0],w[1]):super.call(b,d,w)}async openExtensionDevelopmentHostWindow(b,d){const w=(0,D.parseArgs)(b,D.OPTIONS);w.debugRenderer=d;const C=w.extensionDevelopmentPath;if(!C)return{success:!1};const[P]=this.windowsMainService.openExtensionDevelopmentHostWindow(C,{context:5,cli:w});if(!d)return{success:!0};const S=P.win;if(!S)return{success:!0};const f=S.webContents.debugger;let u=f.isAttached()?1/0:0;const p=(0,E.createServer)(m=>{u++==0&&f.attach();let y=!1;const I=l=>{y||m.write(JSON.stringify(l)+"\0")},g=(l,s,r,n)=>I({method:s,params:r,sessionId:n});S.on("close",()=>{f.removeListener("message",g),m.end(),y=!0}),f.addListener("message",g);let h=Buffer.alloc(0);m.on("data",l=>{h=Buffer.concat([h,l]);for(let s=h.indexOf(0);s!==-1;s=h.indexOf(0)){let r;try{const n=h.slice(0,s).toString("utf8");h=h.slice(s+1),r=JSON.parse(n)}catch(n){console.error("error reading cdp line",n)}f.sendCommand(r.method,r.params,r.sessionId).then(n=>I({id:r.id,sessionId:r.sessionId,result:n})).catch(n=>I({id:r.id,sessionId:r.sessionId,error:{code:0,message:n.message}}))}}),m.on("error",l=>{console.error("error on cdp pipe:",l)}),m.on("close",()=>{y=!0,--u==0&&f.detach()})});return await new Promise(m=>p.listen(0,m)),S.on("close",()=>p.close()),{rendererDebugPort:p.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=R}),define(X[57],J([0,1,261,150,98]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const R=2048;function M(S,f){const u={onUnknownOption:m=>{console.warn((0,t.localize)(0,null,m))},onMultipleValues:(m,y)=>{console.warn((0,t.localize)(1,null,m,y))},onEmptyValue:m=>{console.warn((0,t.localize)(2,null,m))},onDeprecatedOption:(m,y)=>{console.warn((0,t.localize)(3,null,m,y))}},p=(0,D.parseArgs)(S,D.OPTIONS,f?u:void 0);return p.goto&&p._.forEach(m=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(m),(0,t.localize)(4,null))),p["max-memory"]&&E(parseInt(p["max-memory"])>=R,`The max-memory argument cannot be specified lower than ${R} MB.`),p}function b(S){const f=S.findIndex(u=>!/^-/.test(u));if(f>-1)return[...S.slice(0,f),...S.slice(f+1)]}function d(S){let[,...f]=S;process.env.VSCODE_DEV&&(f=b(f)||[]);const u=!P(process.env);return M(f,u)}e.parseMainProcessArgv=d;function w(S){const[,,...f]=S;return M(f,!0)}e.parseCLIProcessArgv=w;function C(S,...f){const u=S.indexOf("--");return u===-1?S.push(...f):S.splice(u,0,...f),S}e.addArg=C;function P(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=P}),function(){"use strict";function B(e,E,t,D){function R(b){const d=M(b),w=[d];return e.isAbsolute(d)||w.unshift(D),e.resolve(...w)}function M(b){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let w=process.env.VSCODE_APPDATA;if(w)return e.join(w,t);const C=b["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(w=process.env.APPDATA,!w){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");w=e.join(P,"AppData","Roaming")}break;case"darwin":w=e.join(E.homedir(),"Library","Application Support");break;case"linux":w=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(w,t)}return{getUserDataPath:R}}if(typeof define=="function")define(X[177],J([0,262,29,12,16,36]),function(e,E,t,D,R,M){const b=R.dirname(D.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(R.joinPath(b,"package.json").fsPath);return B(E,t,d.name,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),E=require("path"),t=require("os");module.exports=B(E,t,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(X[178],J([0,1,29,175,177]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class R extends t.AbstractNativeEnvironmentService{constructor(b,d){super(b,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,D.getUserDataPath)(b)},d)}}e.NativeEnvironmentService=R}),define(X[179],J([0,1,28,29,30]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function R(M){const b=(0,D.randomPath)((0,t.tmpdir)());try{return(0,E.writeFileSync)(b,""),M&&console.log(`Marker file for --wait created: ${b}`),b}catch(d){M&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=R}),define(X[180],J([0,1,17,27]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(R,M,b){let d=b&&b.get("storage.serviceMachineId",-1)||null;if(d)return d;try{const C=(await M.readFile(R.serviceMachineIdResource)).value.toString();d=(0,t.isUUID)(C)?C:null}catch{d=null}if(!d){d=(0,t.generateUuid)();try{await M.writeFile(R.serviceMachineIdResource,E.VSBuffer.fromString(d))}catch{}}return b?.store("storage.serviceMachineId",d,-1,1),d}e.getServiceMachineId=D}),define(X[67],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(D,R=[],M=!1){this.ctor=D,this.staticArguments=R,this.supportsDelayedInstantiation=M}}e.SyncDescriptor=E}),define(X[181],J([0,1,67]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const t=[];function D(M,b,d){b instanceof E.SyncDescriptor||(b=new E.SyncDescriptor(b,[],d)),t.push([M,b])}e.registerSingleton=D;function R(){return t}e.getSingletonServiceDescriptors=R}),define(X[182],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(R){this.incoming=new Map,this.outgoing=new Map,this.data=R}}e.Node=E;class t{constructor(R){this._hashFn=R,this._nodes=new Map}roots(){const R=[];for(const M of this._nodes.values())M.outgoing.size===0&&R.push(M);return R}insertEdge(R,M){const b=this.lookupOrInsertNode(R),d=this.lookupOrInsertNode(M);b.outgoing.set(this._hashFn(M),d),d.incoming.set(this._hashFn(R),b)}removeNode(R){const M=this._hashFn(R);this._nodes.delete(M);for(const b of this._nodes.values())b.outgoing.delete(M),b.incoming.delete(M)}lookupOrInsertNode(R){const M=this._hashFn(R);let b=this._nodes.get(M);return b||(b=new E(R),this._nodes.set(M,b)),b}lookup(R){return this._nodes.get(this._hashFn(R))}isEmpty(){return this._nodes.size===0}toString(){const R=[];for(const[M,b]of this._nodes)R.push(`${M}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return R.join(`
`)}findCycleSlow(){for(const[R,M]of this._nodes){const b=new Set([R]),d=this._findCycle(M,b);if(d)return d}}_findCycle(R,M){for(const[b,d]of R.outgoing){if(M.has(b))return[...M,b].join(" -> ");M.add(b);const w=this._findCycle(d,M);if(w)return w;M.delete(b)}}}e.Graph=t}),define(X[5],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function b(d){return d[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=b})(E=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function t(M,b,d){b[E.DI_TARGET]===b?b[E.DI_DEPENDENCIES].push({id:M,index:d}):(b[E.DI_DEPENDENCIES]=[{id:M,index:d}],b[E.DI_TARGET]=b)}function D(M){if(E.serviceIds.has(M))return E.serviceIds.get(M);const b=function(d,w,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");t(b,d,C)};return b.toString=()=>M,E.serviceIds.set(M,b),b}e.createDecorator=D;function R(M){return M}e.refineServiceDecorator=R}),define(X[58],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(X[18],J([0,1,13,7,5]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,D.createDecorator)("configurationService");function R(y){return y&&typeof y=="object"&&(!y.overrideIdentifier||typeof y.overrideIdentifier=="string")&&(!y.resource||y.resource instanceof t.URI)}e.isConfigurationOverrides=R;function M(y){return y&&typeof y=="object"&&(!y.overrideIdentifiers||Array.isArray(y.overrideIdentifiers))&&!y.overrideIdentifier&&(!y.resource||y.resource instanceof t.URI)}e.isConfigurationUpdateOverrides=M;var b;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.USER=2]="USER",y[y.USER_LOCAL=3]="USER_LOCAL",y[y.USER_REMOTE=4]="USER_REMOTE",y[y.WORKSPACE=5]="WORKSPACE",y[y.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",y[y.DEFAULT=7]="DEFAULT",y[y.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function d(y){switch(y){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=d;function w(y,I){const g=Object.create(null);for(const h in y)C(g,h,y[h],I);return g}e.toValuesTree=w;function C(y,I,g,h){const l=I.split("."),s=l.pop();let r=y;for(let n=0;n<l.length;n++){const i=l[n];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":break;default:h(`Ignoring ${I} as ${l.slice(0,n+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=g}catch{h(`Ignoring ${I} as ${l.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${I} as ${l.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=C;function P(y,I){const g=I.split(".");S(y,g)}e.removeFromValueTree=P;function S(y,I){const g=I.shift();if(I.length===0){delete y[g];return}if(Object.keys(y).indexOf(g)!==-1){const h=y[g];typeof h=="object"&&!Array.isArray(h)&&(S(h,I),Object.keys(h).length===0&&delete y[g])}}function f(y,I,g){function h(r,n){let i=r;for(const o of n){if(typeof i!="object"||i===null)return;i=i[o]}return i}const l=I.split("."),s=h(y,l);return typeof s=="undefined"?g:s}e.getConfigurationValue=f;function u(y,I,g){Object.keys(I).forEach(h=>{h!=="__proto__"&&(h in y?E.isObject(y[h])&&E.isObject(I[h])?u(y[h],I[h],g):g&&(y[h]=I[h]):y[h]=I[h])})}e.merge=u;function p(y,I,g){const h=y.inspect(I),l=y.inspect(g);return typeof h.userValue!="undefined"||typeof h.workspaceValue!="undefined"||typeof h.workspaceFolderValue!="undefined"?h.value:typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:h.defaultValue}e.getMigratedSettingValue=p;function m(y){return y.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=m}),define(X[68],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class t{constructor(){this.secretVault={}}async getPassword(R,M){return this.secretVault[R]?.[M]??null}async setPassword(R,M,b){this.secretVault[R]=this.secretVault[R]??{},this.secretVault[R][M]=b}async deletePassword(R,M){return this.secretVault[R]?.[M]?(delete this.secretVault[R][M],Object.keys(this.secretVault[R]).length===0&&delete this.secretVault[R],!0):!1}async findPassword(R){return JSON.stringify(this.secretVault[R])??null}async findCredentials(R){const M=[];for(const b of Object.keys(this.secretVault[R]||{}))M.push({account:b,password:this.secretVault[R][b]});return M}async clear(){this.secretVault={}}}e.InMemoryCredentialsProvider=t}),define(X[83],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function t(R){return!!R.hostName&&!!R.errorMessage}e.isRemoteDiagnosticError=t;class D{async getPerformanceInfo(M,b){return{}}async getSystemInfo(M,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(M,b){return""}async getWorkspaceFileExtensions(M){return{extensions:[]}}async reportWorkspaceStats(M){}}e.NullDiagnosticsService=D}),define(X[99],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(X[39],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(X[26],J([0,1,51,9,81,39,178,5]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(R.IEnvironmentService);class d extends M.NativeEnvironmentService{get cachedLanguagesPath(){return(0,t.join)(this.userDataPath,"clp")}get backupHome(){return(0,t.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,t.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,t.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}fe([E.memoize],d.prototype,"cachedLanguagesPath",null),fe([E.memoize],d.prototype,"backupHome",null),fe([E.memoize],d.prototype,"backupWorkspacesPath",null),fe([E.memoize],d.prototype,"mainIPCHandle",null),fe([E.memoize],d.prototype,"mainLockfile",null),fe([E.memoize],d.prototype,"disableUpdates",null),fe([E.memoize],d.prototype,"disableKeytar",null),fe([E.memoize],d.prototype,"codeCachePath",null),fe([E.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(X[100],J([0,1,151,5]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function D(y){switch(y){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=D;function R(y){switch(y){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function M(y,I){switch(y){case 3:return I==="x64"?"win32-x64":I==="ia32"?"win32-ia32":I==="arm64"?"win32-arm64":"unknown";case 2:return I==="x64"?"linux-x64":I==="arm64"?"linux-arm64":I==="arm"?"linux-armhf":"unknown";case"alpine":return I==="x64"?"alpine-x64":I==="arm64"?"alpine-arm64":"unknown";case 1:return I==="x64"?"darwin-x64":I==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=M;function b(y,I){return I==="web"&&!y.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function d(y,I,g){return b(I,g)?!1:y==="undefined"||y==="universal"?!0:y==="unknown"?!1:y===g?!0:w(g).includes(y)}e.isTargetPlatformCompatible=d;function w(y){switch(y){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=w;function C(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=C;var P;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=10]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var S;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(S=e.SortOrder||(e.SortOrder={}));var f;(function(y){y.Install="install",y.Uninstall="uninstall"})(f=e.StatisticType||(e.StatisticType={}));var u;(function(y){y[y.None=1]="None",y[y.Install=2]="Install",y[y.Update=3]="Update",y[y.Migrate=4]="Migrate"})(u=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,t.createDecorator)("extensionGalleryService");var p;(function(y){y.Unsupported="Unsupported",y.Deprecated="Deprecated",y.Malicious="Malicious",y.Incompatible="Incompatible",y.IncompatiblePreRelease="IncompatiblePreRelease",y.IncompatibleTargetPlatform="IncompatibleTargetPlatform",y.ReleaseVersionNotFound="ReleaseVersionNotFound",y.Invalid="Invalid",y.Download="Download",y.Extract="Extract",y.Delete="Delete",y.Rename="Rename",y.CorruptZip="CorruptZip",y.IncompleteZip="IncompleteZip",y.Internal="Internal"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class m extends Error{constructor(I,g){super(I);this.code=g,this.name=g}}e.ExtensionManagementError=m,e.IExtensionManagementService=(0,t.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,t.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,t.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,t.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,E.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,t.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,t.createDecorator)("IDefaultExtensionsProfileInitService")}),define(X[183],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(X[184],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(X[101],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(X[185],J([0,1,42,12,9,4,77,23,82,152,101]),function(B,e,E,t,D,R,M,b,d,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=w.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends S{openTerminal(h,l){return this.spawnTerminal(E,h,d.getWindowsShell(),l)}spawnTerminal(h,l,s,r){const n=l.windowsExec||f.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const i=D.basename(n).toLowerCase();if(i==="cmder"||i==="cmder.exe")return h.spawn(n,r?[r]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return n.indexOf(" ")>=0&&o.push('""'),o.push(n),(i==="wt"||i==="wt.exe")&&o.push("-d ."),new Promise((a,c)=>{const v=m(process),k=h.spawn(s,o,{cwd:r,env:v});k.on("error",c),k.on("exit",()=>a())})}runInTerminal(h,l,s,r,n){const i="windowsExec"in n&&n.windowsExec?n.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,a)=>{const c=`"${l} - ${P}"`,v=`""${s.join('" "')}" & pause"`,k=["/c","start",c,"/wait",i,"/c",v],L=Object.assign({},m(process),r);Object.keys(L).filter(j=>L[j]===null).forEach(j=>delete L[j]);const O={cwd:l,env:L,windowsVerbatimArguments:!0};E.spawn(f.CMD,k,O).on("error",j=>{a(y(j))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f._DEFAULT_TERMINAL_WINDOWS){const h=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${h?"Sysnative":"System32"}\\cmd.exe`}return f._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=f,f.CMD="cmd.exe";class u extends S{openTerminal(h,l){return this.spawnTerminal(E,h,l)}runInTerminal(h,l,s,r,n){const i=n.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((o,a)=>{if(i===C.DEFAULT_TERMINAL_OSX||i==="iTerm.app"){const c=i===C.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",k=[t.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`,B).fsPath,"-t",h||P,"-w",l];for(const F of s)k.push("-a"),k.push(F);if(r){const F=Object.assign({},m(process),r);for(const j in F){const ee=F[j];ee===null?(k.push("-u"),k.push(j)):(k.push("-e"),k.push(`${j}=${ee}`))}}let L="";const O=E.spawn(u.OSASCRIPT,k);O.on("error",F=>{a(y(F))}),O.stderr.on("data",F=>{L+=F.toString()}),O.on("exit",F=>{if(F===0)o(void 0);else if(L){const j=L.split(`
`,1);a(new Error(j[0]))}else a(new Error(w.localize(1,null,c,F)))})}else a(new Error(w.localize(2,null,i)))})}spawnTerminal(h,l,s){const r=l.osxExec||C.DEFAULT_TERMINAL_OSX;return new Promise((n,i)=>{const o=["-a",r];s&&o.push(s);const a=m(process),c=h.spawn("/usr/bin/open",o,{cwd:s,env:a});c.on("error",i),c.on("exit",()=>n())})}}e.MacExternalTerminalService=u,u.OSASCRIPT="/usr/bin/osascript";class p extends S{openTerminal(h,l){return this.spawnTerminal(E,h,l)}runInTerminal(h,l,s,r,n){const i=n.linuxExec?Promise.resolve(n.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((o,a)=>{const c=[];i.then(v=>{v.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const k=`${I(s)}; echo; read -p "${p.WAIT_MESSAGE}" -n1;`;c.push(`''${k}''`);const L=Object.assign({},m(process),r);Object.keys(L).filter(ee=>L[ee]===null).forEach(ee=>delete L[ee]);const O={cwd:l,env:L};let F="";const j=E.spawn(v,c,O);j.on("error",ee=>{a(y(ee))}),j.stderr.on("data",ee=>{F+=ee.toString()}),j.on("exit",ee=>{if(ee===0)o(void 0);else if(F){const se=F.split(`
`,1);a(new Error(se[0]))}else a(new Error(w.localize(4,null,v,ee)))})})})}static async getDefaultTerminalLinuxReady(){if(!p._DEFAULT_TERMINAL_LINUX_READY)if(!R.isLinux)p._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const h=await b.Promises.exists("/etc/debian_version");p._DEFAULT_TERMINAL_LINUX_READY=new Promise(l=>{h?l("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?l("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?l("konsole"):process.env.COLORTERM?l(process.env.COLORTERM):process.env.TERM?l(process.env.TERM):l("xterm")})}return p._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(h,l,s){const r=l.linuxExec?Promise.resolve(l.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((n,i)=>{r.then(o=>{const a=m(process),c=h.spawn(o,[],{cwd:s,env:a});c.on("error",i),c.on("exit",()=>n())})})}}e.LinuxExternalTerminalService=p,p.WAIT_MESSAGE=w.localize(3,null);function m(g){const h={...g.env};return(0,M.sanitizeProcessEnvironment)(h),h}function y(g){return"errno"in g&&g.errno==="ENOENT"&&"path"in g&&typeof g.path=="string"?new Error(w.localize(5,null,g.path)):g}function I(g){let h="";for(const l of g)l.indexOf(" ")>=0?h+='"'+l+'"':h+=l,h+=" ";return h}}),define(X[15],J([0,1,33,9,31,13,7,154,5]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function w(H){return H.create===!0}e.isFileOpenForWriteOptions=w;var C;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(C=e.FileType||(e.FileType={}));var P;(function(H){H[H.Readonly=1]="Readonly"})(P=e.FilePermission||(e.FilePermission={}));var S;(function(H){H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=f;function u(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=u;function p(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=p;function m(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=m;function y(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=y;function I(H){return f(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=I;var g;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class h extends Error{constructor(re,q){super(re);this.code=q}}e.FileSystemProviderError=h;function l(H,re){const q=new h(H.toString(),re);return r(q,re),q}e.createFileSystemProviderError=l;function s(H){return H||l((0,b.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=s;function r(H,re){return H.name=re?`${re} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=r;function n(H){if(!H)return g.Unknown;if(H instanceof h)return H.code;const re=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!re)return g.Unknown;switch(re[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=n;function i(H){if(H instanceof L)return H.fileOperationResult;switch(n(H)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var o;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class a{constructor(re,q,T){this.resource=re,this.operation=q,this.target=T}isOperation(re){return this.operation===re}}e.FileOperationEvent=a;var c;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class v{constructor(re,q){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=re;const T=new Map;for(const N of re){const V=T.get(N.type);switch(V?V.push([N.resource,N]):T.set(N.type,[[N.resource,N]]),N.type){case 1:this.rawAdded.push(N.resource);break;case 0:this.rawUpdated.push(N.resource);break;case 2:this.rawDeleted.push(N.resource);break}}for(const[N,V]of T)switch(N){case 1:this.added=E.TernarySearchTree.forUris(()=>q),this.added.fill(V);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>q),this.updated.fill(V);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>q),this.deleted.fill(V);break}}contains(re,...q){return this.doContains(re,{includeChildren:!1},...q)}affects(re,...q){return this.doContains(re,{includeChildren:!0},...q)}doContains(re,q,...T){if(!re)return!1;const N=T.length>0;return!!((!N||T.includes(1))&&(this.added?.get(re)||q.includeChildren&&this.added?.findSuperstr(re))||(!N||T.includes(0))&&(this.updated?.get(re)||q.includeChildren&&this.updated?.findSuperstr(re))||(!N||T.includes(2))&&(this.deleted?.findSubstr(re)||q.includeChildren&&this.deleted?.findSuperstr(re)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=v;function k(H,re,q){return!H||!re||H===re||re.length>H.length?!1:(re.charAt(re.length-1)!==t.sep&&(re+=t.sep),q?(0,D.startsWithIgnoreCase)(H,re):H.indexOf(re)===0)}e.isParent=k;class L extends Error{constructor(re,q,T){super(re);this.fileOperationResult=q,this.options=T}}e.FileOperationError=L;class O extends L{constructor(re,q,T){super(re,2,T);this.stat=q}}e.NotModifiedSinceFileOperationError=O;var F;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(F=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var j;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(j=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function ee(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=ee;async function se(H,re){if(!re.hasProvider(M.URI.from({scheme:H.scheme})))return new Promise(q=>{const T=re.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===H.scheme&&N.added&&(T.dispose(),q())})})}e.whenProviderRegistered=se,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ae{static formatSize(re){return(0,R.isNumber)(re)||(re=0),re<ae.KB?(0,b.localize)(1,null,re.toFixed(0)):re<ae.MB?(0,b.localize)(2,null,(re/ae.KB).toFixed(2)):re<ae.GB?(0,b.localize)(3,null,(re/ae.MB).toFixed(2)):re<ae.TB?(0,b.localize)(4,null,(re/ae.GB).toFixed(2)):(0,b.localize)(5,null,(re/ae.TB).toFixed(2))}}e.ByteSize=ae,ae.KB=1024,ae.MB=ae.KB*ae.KB,ae.GB=ae.MB*ae.KB,ae.TB=ae.GB*ae.KB;var ie;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(ie=e.Arch||(e.Arch={}));function ce(H){return{maxFileSize:H===0?300*ae.MB:16*ae.GB,maxHeapSize:H===0?700*ae.MB:2*700*ae.MB}}e.getPlatformLimits=ce}),define(X[186],J([0,1,17,41,19,3,2,56,7,27,15]),function(B,e,E,t,D,R,M,b,d,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class P extends M.Disposable{constructor(f,u){super();this.channel=f,this.extraCapabilities=u,this.onDidChangeCapabilities=R.Event.None,this._onDidChange=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,w.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(f){return this.channel.call("stat",[f])}readdir(f){return this.channel.call("readdir",[f])}async readFile(f,u){const{buffer:p}=await this.channel.call("readFile",[f,u]);return p}readFileStream(f,u,p){const m=(0,b.newWriteableStream)(I=>E.VSBuffer.concat(I.map(g=>E.VSBuffer.wrap(g))).buffer),y=this.channel.listen("readFileStream",[f,u])(I=>{if(I instanceof E.VSBuffer)m.write(I.buffer);else{if(I==="end")m.end();else{let g=I;g instanceof Error||(g=(0,C.createFileSystemProviderError)((0,t.toErrorMessage)(g),C.FileSystemProviderErrorCode.Unknown)),m.error(g),m.end()}y.dispose()}});return p.onCancellationRequested(()=>{m.error((0,D.canceled)()),m.end(),y.dispose()}),m}writeFile(f,u,p){return this.channel.call("writeFile",[f,E.VSBuffer.wrap(u),p])}open(f,u){return this.channel.call("open",[f,u])}close(f){return this.channel.call("close",[f])}async read(f,u,p,m,y){const[I,g]=await this.channel.call("read",[f,u,y]);return p.set(I.buffer.slice(0,g),m),g}write(f,u,p,m,y){return this.channel.call("write",[f,u,E.VSBuffer.wrap(p),m,y])}mkdir(f){return this.channel.call("mkdir",[f])}delete(f,u){return this.channel.call("delete",[f,u])}rename(f,u,p){return this.channel.call("rename",[f,u,p])}copy(f,u,p){return this.channel.call("copy",[f,u,p])}cloneFile(f,u){return this.channel.call("cloneFile",[f,u])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(f=>{if(Array.isArray(f)){const u=f;this._onDidChange.fire(u.map(p=>({resource:d.URI.revive(p.resource),type:p.type})))}else{const u=f;this._onDidWatchError.fire(u)}}))}watch(f,u){const p=(0,w.generateUuid)();return this.channel.call("watch",[this.sessionId,p,f,u]),(0,M.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,p]))}}e.DiskFileSystemProviderClient=P}),define(X[102],J([0,1,17,19,155,15]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function M(C,P,S,f,u,p){let m;try{await b(C,P,S,f,u,p)}catch(y){m=y}finally{m&&u.errorTransformer&&(m=u.errorTransformer(m)),typeof m!="undefined"&&S.error(m),S.end()}}e.readFileIntoStream=M;async function b(C,P,S,f,u,p){d(p);const m=await C.open(P,{create:!1});try{d(p);let y=0,I=0,g=u&&typeof u.length=="number"?u.length:void 0,h=E.VSBuffer.alloc(Math.min(u.bufferSize,typeof g=="number"?g:u.bufferSize)),l=u&&typeof u.position=="number"?u.position:0,s=0;do I=await C.read(m,l,h.buffer,s,h.byteLength-s),l+=I,s+=I,y+=I,typeof g=="number"&&(g-=I),s===h.byteLength&&(await S.write(f(h)),h=E.VSBuffer.alloc(Math.min(u.bufferSize,typeof g=="number"?g:u.bufferSize)),s=0);while(I>0&&(typeof g!="number"||g>0)&&d(p)&&w(y,u));if(s>0){let r=s;typeof g=="number"&&(r=Math.min(s,g)),S.write(f(h.slice(0,r)))}}catch(y){throw(0,R.ensureFileSystemProviderError)(y)}finally{await C.close(m)}}function d(C){if(C.isCancellationRequested)throw(0,t.canceled)();return!0}function w(C,P){if(P?.limits){if(typeof P.limits.memory=="number"&&C>P.limits.memory)throw(0,R.createFileSystemProviderError)((0,D.localize)(0,null),R.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&C>P.limits.size)throw(0,R.createFileSystemProviderError)((0,D.localize)(1,null),R.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(X[69],J([0,1,92,2,9,4,7,15]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function d(y){return y.recursive===!0}e.isRecursiveWatchRequest=d;class w extends t.Disposable{constructor(I,g,h,l){super();this.onFileChanges=I,this.onLogMessage=g,this.verboseLogging=h,this.options=l,this.watcherDisposables=this._register(new t.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const I=new t.DisposableStore;this.watcherDisposables.value=I,this.watcher=this.createWatcher(I),this.watcher.setVerboseLogging(this.verboseLogging),I.add(this.watcher.onDidChangeFile(g=>this.onFileChanges(g))),I.add(this.watcher.onDidLogMessage(g=>this.onLogMessage(g))),I.add(this.watcher.onDidError(g=>this.onError(g)))}onError(I){this.options.restartOnError?this.restartCounter<w.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${I}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${I}`):this.error(I)}restart(I){this.restartCounter++,this.init(),this.watch(I)}async watch(I){this.requests=I,await this.watcher?.watch(I)}async setVerboseLogging(I){this.verboseLogging=I,await this.watcher?.setVerboseLogging(I)}error(I){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${I}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=w,w.MAX_RESTARTS=5;class C extends w{constructor(I,g,h){super(I,g,h,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=C;class P extends w{constructor(I,g,h){super(I,g,h,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=P;function S(y){return y.map(I=>({type:I.type,resource:M.URI.file(I.path)}))}e.toFileChanges=S;function f(y){const I=new m;for(const g of y)I.processEvent(g);return I.coalesce()}e.coalesceEvents=f;function u(y,I){return typeof I=="string"&&!I.startsWith(E.GLOBSTAR)&&!(0,D.isAbsolute)(I)?{base:y,pattern:I}:I}e.normalizeWatcherPattern=u;function p(y,I){const g=[];for(const h of I)g.push((0,E.parse)(u(y,h)));return g}e.parseWatcherPatterns=p;class m{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(I){return R.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const g=this.mapPathToChange.get(this.toKey(I));let h=!1;if(g){const l=g.type,s=I.type;g.path!==I.path&&(I.type===2||I.type===1)?h=!0:l===1&&s===2?(this.mapPathToChange.delete(this.toKey(I)),this.coalesced.delete(g)):l===2&&s===1?g.type=0:l===1&&s===0||(g.type=s)}else h=!0;h&&(this.coalesced.add(I),this.mapPathToChange.set(this.toKey(I),I))}coalesce(){const I=[],g=[];return Array.from(this.coalesced).filter(h=>h.type!==2?(I.push(h),!1):!0).sort((h,l)=>h.path.length-l.path.length).filter(h=>g.some(l=>(0,b.isParent)(h.path,l,!R.isLinux))?!1:(g.push(h.path),!0)).concat(I)}}}),define(X[187],J([0,1,28,8,21,30,2,79,9,4,93,23,69]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends M.Disposable{constructor(m,y,I,g){super();this.request=m,this.onDidFilesChange=y,this.onLogMessage=I,this.verboseLogging=g,this.throttledFileChangesWorker=new t.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},h=>this.onDidFilesChange(h)),this.fileChangesDelayer=this._register(new t.ThrottledDelayer(f.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,S.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,S.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new D.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const m=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const y=await P.Promises.stat(m);this._register(await this.doWatch(m,y.isDirectory()))}catch(m){m.code!=="ENOENT"?this.error(m):this.trace(m)}}async normalizePath(m){let y=m.path;try{y=await P.Promises.realpath(m.path),m.path===y&&(y=await(0,C.realcase)(m.path)??m.path),m.path!==y&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${m.path}, real: ${y})`)}catch{}return y}async doWatch(m,y){if(w.isMacintosh&&(0,R.isEqualOrParent)(m,"/Volumes/",!0))return this.error(`Refusing to watch ${m} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const I=new D.CancellationTokenSource(this.cts.token),g=new M.DisposableStore;try{const h=(0,d.basename)(m),l=(0,E.watch)(m);g.add((0,M.toDisposable)(()=>{l.removeAllListeners(),l.close()})),this.trace(`Started watching: '${m}'`);const s=new Set;if(y)try{for(const n of await P.Promises.readdir(m))s.add(n)}catch(n){this.error(n)}const r=new Map;g.add((0,M.toDisposable)(()=>{for(const[,n]of r)n.dispose();r.clear()})),l.on("error",(n,i)=>{this.error(`Failed to watch ${m} for changes using fs.watch() (${n}, ${i})`),this.dispose()}),l.on("change",(n,i)=>{if(I.token.isCancellationRequested)return;this.trace(`[raw] ["${n}"] ${i}`);let o="";if(i&&(o=i.toString(),w.isMacintosh&&(o=(0,b.normalizeNFC)(o))),!(!o||n!=="change"&&n!=="rename"))if(y)if(n==="rename"){r.get(o)?.dispose();const a=setTimeout(async()=>{if(r.delete(o),o===h&&!await P.Promises.exists(m)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.existsChildStrictCase((0,d.join)(m,o));if(I.token.isCancellationRequested)return;let v;c?s.has(o)?v=0:(v=1,s.add(o)):(s.delete(o),v=2),this.onFileChange({path:(0,d.join)(this.request.path,o),type:v})},f.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,M.toDisposable)(()=>clearTimeout(a)))}else{let a;s.has(o)?a=0:(a=1,s.add(o)),this.onFileChange({path:(0,d.join)(this.request.path,o),type:a})}else if(n==="rename"||o!==h){const a=setTimeout(async()=>{const c=await P.Promises.exists(m);I.token.isCancellationRequested||(c?(this.onFileChange({path:this.request.path,type:0},!0),g.add(await this.doWatch(m,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},f.FILE_DELETE_HANDLER_DELAY);g.clear(),g.add((0,M.toDisposable)(()=>clearTimeout(a)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(h){await P.Promises.exists(m)&&!I.token.isCancellationRequested&&this.error(`Failed to watch ${m} for changes using fs.watch() (${h.toString()})`)}return(0,M.toDisposable)(()=>{I.dispose(!0),g.dispose()})}async onFileChange(m,y=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${m.type===1?"[ADDED]":m.type===2?"[DELETED]":"[CHANGED]"} ${m.path}`),!y&&this.excludes.some(I=>I(m.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${m.path}`):!y&&this.includes&&this.includes.length>0&&!this.includes.some(I=>I(m.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${m.path}`):this.fileChangesBuffer.push(m);try{await this.fileChangesDelayer.trigger(async()=>{const I=this.fileChangesBuffer;this.fileChangesBuffer=[];const g=(0,S.coalesceEvents)(I);if(g.length>0){if(this.verboseLogging)for(const l of g)this.trace(`>> normalized ${l.type===1?"[ADDED]":l.type===2?"[DELETED]":"[CHANGED]"} ${l.path}`);this.throttledFileChangesWorker.work(g)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(m){if(w.isLinux)return P.Promises.exists(m);try{const y=(0,d.basename)(m);return(await P.Promises.readdir((0,d.dirname)(m))).some(g=>g===y)}catch(y){return this.trace(y),!1}}setVerboseLogging(m){this.verboseLogging=m}error(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${m}`})}warn(m){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${m}`})}trace(m){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${m}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.FILE_DELETE_HANDLER_DELAY=100,f.FILE_CHANGES_HANDLER_DELAY=50;async function u(p,m,y,I,g=512){const h=await P.Promises.open(p,"r"),l=Buffer.allocUnsafe(g),s=new D.CancellationTokenSource(I);let r,n=!1;const i={path:p,excludes:[],recursive:!1},o=new f(i,a=>{(async()=>{for(const{type:c}of a)if(c===0){if(n)return;n=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:v}=await P.Promises.read(h,l,0,g,null);if(!v||s.token.isCancellationRequested)break;m(l.slice(0,v))}}catch(v){r=new Error(v),s.dispose(!0)}finally{n=!1}}})()});return await o.ready,y(),new Promise((a,c)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await P.Promises.close(h)}catch(v){r=new Error(v)}r?c(r):a()})})}e.watchFileContents=u}),define(X[188],J([0,1,3,92,2,4,187]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends D.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new E.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=E.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(w){const C=this.normalizeRequests(w),P=C.filter(f=>{const u=this.watchers.get(f.path);return u?!(0,t.patternsEquals)(u.request.excludes,f.excludes)||!(0,t.patternsEquals)(u.request.includes,f.includes):!0}),S=Array.from(this.watchers.values()).filter(({request:f})=>!C.find(u=>u.path===f.path&&(0,t.patternsEquals)(u.excludes,f.excludes)&&(0,t.patternsEquals)(u.includes,f.includes))).map(({request:f})=>f.path);P.length&&this.trace(`Request to start watching: ${P.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),S.length&&this.trace(`Request to stop watching: ${S.join(",")}`);for(const f of S)this.stopWatching(f);for(const f of P)this.startWatching(f)}startWatching(w){const C=new M.NodeJSFileWatcherLibrary(w,S=>this._onDidChangeFile.fire(S),S=>this._onDidLogMessage.fire(S),this.verboseLogging),P={request:w,instance:C};this.watchers.set(w.path,P)}async stop(){for(const[w]of this.watchers)this.stopWatching(w);this.watchers.clear()}stopWatching(w){const C=this.watchers.get(w);C&&(this.watchers.delete(w),C.instance.dispose())}normalizeRequests(w){const C=new Map;for(const P of w){const S=R.isLinux?P.path:P.path.toLowerCase();C.set(S,P)}return Array.from(C.values())}async setVerboseLogging(w){this.verboseLogging=w;for(const[,C]of this.watchers)C.instance.setVerboseLogging(w)}trace(w){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(w)})}toMessage(w,C){return C?`[File Watcher (node.js)] ${w} (path: ${C.request.path})`:`[File Watcher (node.js)] ${w}`}}e.NodeJSWatcher=b}),define(X[189],J([0,1,69,188]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class D extends E.AbstractNonRecursiveWatcherClient{constructor(M,b,d){super(M,b,d);this.init()}createWatcher(){return new t.NodeJSWatcher}}e.NodeJSWatcherClient=D}),define(X[190],J([0,1,12,43,145,69]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class M extends R.AbstractUniversalWatcherClient{constructor(d,w,C){super(d,w,C);this.init()}createWatcher(d){const w=d.add(new D.Client(E.FileAccess.asFileUri("bootstrap-fork",B).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return d.add(w.onDidProcessExit(({code:C,signal:P})=>this.onError(`terminated by itself with code ${C}, signal: ${P}`))),t.ProxyChannel.toService((0,t.getNextTickChannel)(w.getChannel("watcher")))}}e.UniversalWatcherClient=M}),define(X[84],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...D){this._entries=new Map;for(const[R,M]of D)this.set(R,M)}set(D,R){const M=this._entries.get(D);return this._entries.set(D,R),M}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=E}),define(X[191],J([0,1,8,19,67,182,5,84]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const d=!1;class w extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class C{constructor(u=new b.ServiceCollection,p=!1,m){this._activeInstantiations=new Set,this._services=u,this._strict=p,this._parent=m,this._services.set(M.IInstantiationService,this)}createChild(u){return new C(u,this._strict,this)}invokeFunction(u,...p){const m=S.traceInvocation(u);let y=!1;try{return u({get:g=>{if(y)throw(0,t.illegalState)("service accessor is only valid during the invocation of its target method");const h=this._getOrCreateServiceInstance(g,m);if(!h)throw new Error(`[invokeFunction] unknown service '${g}'`);return h}},...p)}finally{y=!0,m.stop()}}createInstance(u,...p){let m,y;return u instanceof D.SyncDescriptor?(m=S.traceCreation(u.ctor),y=this._createInstance(u.ctor,u.staticArguments.concat(p),m)):(m=S.traceCreation(u),y=this._createInstance(u,p,m)),m.stop(),y}_createInstance(u,p=[],m){const y=M._util.getServiceDependencies(u).sort((h,l)=>h.index-l.index),I=[];for(const h of y){const l=this._getOrCreateServiceInstance(h.id,m);l||this._throwIfStrict(`[createInstance] ${u.name} depends on UNKNOWN service ${h.id}.`,!1),I.push(l)}const g=y.length>0?y[0].index:p.length;if(p.length!==g){console.trace(`[createInstance] First service dependency of ${u.name} at position ${g+1} conflicts with ${p.length} static arguments`);const h=g-p.length;h>0?p=p.concat(new Array(h)):p=p.slice(0,g)}return new u(...[...p,...I])}_setServiceInstance(u,p){if(this._services.get(u)instanceof D.SyncDescriptor)this._services.set(u,p);else if(this._parent)this._parent._setServiceInstance(u,p);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){const p=this._services.get(u);return!p&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):p}_getOrCreateServiceInstance(u,p){const m=this._getServiceInstanceOrDescriptor(u);return m instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,m,p.branch(u,!0)):(p.branch(u,!1),m)}_safeCreateAndCacheServiceInstance(u,p,m){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,p,m)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,p,m){const y=new R.Graph(h=>h.id.toString());let I=0;const g=[{id:u,desc:p,_trace:m}];for(;g.length;){const h=g.pop();if(y.lookupOrInsertNode(h),I++>1e3)throw new w(y);for(const l of M._util.getServiceDependencies(h.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(l.id);if(s||this._throwIfStrict(`[createInstance] ${u} depends on ${l.id} which is NOT registered.`,!0),s instanceof D.SyncDescriptor){const r={id:l.id,desc:s,_trace:h._trace.branch(l.id,!0)};y.insertEdge(h,r),g.push(r)}}}for(;;){const h=y.roots();if(h.length===0){if(!y.isEmpty())throw new w(y);break}for(const{data:l}of h){if(this._getServiceInstanceOrDescriptor(l.id)instanceof D.SyncDescriptor){const r=this._createServiceInstanceWithOwner(l.id,l.desc.ctor,l.desc.staticArguments,l.desc.supportsDelayedInstantiation,l._trace);this._setServiceInstance(l.id,r)}y.removeNode(l)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,p,m=[],y,I){if(this._services.get(u)instanceof D.SyncDescriptor)return this._createServiceInstance(p,m,y,I);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,p,m,y,I);throw new Error(`illegalState - creating UNKNOWN service instance ${p.name}`)}_createServiceInstance(u,p=[],m,y){if(m){const I=new E.IdleValue(()=>this._createInstance(u,p,y));return new Proxy(Object.create(null),{get(g,h){if(h in g)return g[h];const l=I.value;let s=l[h];return typeof s!="function"||(s=s.bind(l),g[h]=s),s},set(g,h,l){return I.value[h]=l,!0}})}else return this._createInstance(u,p,y)}_throwIfStrict(u,p){if(p&&console.warn(u),this._strict)throw new Error(u)}}e.InstantiationService=C;var P;(function(f){f[f.Creation=0]="Creation",f[f.Invocation=1]="Invocation",f[f.Branch=2]="Branch"})(P||(P={}));class S{constructor(u,p){this.type=u,this.name=p,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return d?new S(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(u){return d?new S(0,u.name):S._None}branch(u,p){const m=new S(2,u.toString());return this._dep.push([u,p,m]),m}stop(){const u=Date.now()-this._start;S._totals+=u;let p=!1;function m(I,g){const h=[],l=new Array(I+1).join("	");for(const[s,r,n]of g._dep)if(r&&n){p=!0,h.push(`${l}CREATES -> ${s}`);const i=m(I+1,n);i&&h.push(i)}else h.push(`${l}uses -> ${s}`);return h.join(`
`)}const y=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${m(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(u>2||p)&&console.log(y.join(`
`))}}e.Trace=S,S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(X[6],J([0,1,41,3,2,4,5]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,M.createDecorator)("logService"),e.ILoggerService=(0,M.createDecorator)("loggerService");function b(){return new Date().toISOString()}var d;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;function w(r,n,i){switch(n){case d.Trace:r.trace(i);break;case d.Debug:r.debug(i);break;case d.Info:r.info(i);break;case d.Warning:r.warn(i);break;case d.Error:r.error(i);break;case d.Critical:r.critical(i);break;default:throw new Error("Invalid log level")}}e.log=w;function C(r){let n="";for(let i=0;i<r.length;i++){let o=r[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}n+=(i>0?" ":"")+o}return n}e.format=C;class P extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new t.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=P;class S extends P{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(d.Trace)&&this.log(d.Trace,C([n,...i]))}debug(n,...i){this.checkLogLevel(d.Debug)&&this.log(d.Debug,C([n,...i]))}info(n,...i){this.checkLogLevel(d.Info)&&this.log(d.Info,C([n,...i]))}warn(n,...i){this.checkLogLevel(d.Warning)&&this.log(d.Warning,C([n,...i]))}error(n,...i){if(this.checkLogLevel(d.Error))if(n instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=n.stack,this.log(d.Error,C(o))}else this.log(d.Error,C([n,...i]))}critical(n,...i){this.checkLogLevel(d.Critical)&&this.log(d.Critical,C([n,...i]))}flush(){}}e.AbstractMessageLogger=S;class f extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!R.isWindows}trace(n,...i){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...i):console.log(`[main ${b()}]`,n,...i))}debug(n,...i){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...i):console.log(`[main ${b()}]`,n,...i))}info(n,...i){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...i):console.log(`[main ${b()}]`,n,...i))}warn(n,...i){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,n,...i):console.warn(`[main ${b()}]`,n,...i))}error(n,...i){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,n,...i):console.error(`[main ${b()}]`,n,...i))}critical(n,...i){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,n,...i):console.error(`[main ${b()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=f;class u extends P{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=u;class p extends P{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,E.toErrorMessage)(n,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=p;class m extends P{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const o of this.logServices)o.trace(n,...i)}debug(n,...i){for(const o of this.logServices)o.debug(n,...i)}info(n,...i){for(const o of this.logServices)o.info(n,...i)}warn(n,...i){for(const o of this.logServices)o.warn(n,...i)}error(n,...i){for(const o of this.logServices)o.error(n,...i)}critical(n,...i){for(const o of this.logServices)o.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=m;class y extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=y;class I extends D.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(a=>a.setLevel(o))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let o=this.loggers.get(n.toString());return o||(o=this.doCreateLogger(n,i?.always?d.Trace:this.logLevel,i),this.loggers.set(n.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=I;class g{constructor(){this.onDidChangeLogLevel=new t.Emitter().event}setLevel(n){}getLevel(){return d.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=g;function h(r){if(r.verbose)return d.Trace;if(typeof r.logLevel=="string"){const n=l(r.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=h;function l(r){switch(r){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=l;function s(r){switch(r){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=s});var x=this&&this.__param||function(B,e){return function(E,t){e(E,t,B)}};define(X[192],J([0,1,68,3,2,6,4]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let b=class St extends D.Disposable{constructor(w){super();this.logService=w,this._onDidChangePassword=this._register(new t.Emitter),this.onDidChangePassword=this._onDidChangePassword.event}async getPassword(w,C){let P;try{P=await this.withKeytar()}catch{return null}const S=await P.getPassword(w,C);if(S)try{let{content:f,hasNextChunk:u}=JSON.parse(S);if(!f||!u)return S;let p=1;for(;u;){const m=await P.getPassword(w,`${C}-${p}`),y=JSON.parse(m);f+=y.content,u=y.hasNextChunk,p++}return f}catch{return S}return S}async setPassword(w,C,P){let S;try{S=await this.withKeytar()}catch(p){throw this.surfaceKeytarLoadError?.(p),p}const f=3,u=async(p,m,y)=>{let I=0,g;for(;I<f;)try{await S.setPassword(p,m,y);return}catch(h){g=h,this.logService.warn("Error attempting to set a password: ",h?.message??h),I++,await new Promise(l=>setTimeout(l,200))}throw g};if(M.isWindows&&P.length>St.MAX_PASSWORD_LENGTH){let p=0,m=0,y=!0;for(;y;){const I=P.substring(p,p+St.PASSWORD_CHUNK_SIZE);p+=St.PASSWORD_CHUNK_SIZE,y=P.length-p>0;const g={content:I,hasNextChunk:y};await u(w,m?`${C}-${m}`:C,JSON.stringify(g)),m++}}else await u(w,C,P);this._onDidChangePassword.fire({service:w,account:C})}async deletePassword(w,C){let P;try{P=await this.withKeytar()}catch(u){throw this.surfaceKeytarLoadError?.(u),u}const S=await P.getPassword(w,C);if(!S)return!1;const f=await P.deletePassword(w,C);try{let{content:u,hasNextChunk:p}=JSON.parse(S);if(u&&p){let m=1;for(;p;){const y=`${C}-${m}`,I=await P.getPassword(w,y);await P.deletePassword(w,y),p=JSON.parse(I).hasNextChunk,m++}}}catch{}return f&&this._onDidChangePassword.fire({service:w,account:C}),f}async findPassword(w){let C;try{C=await this.withKeytar()}catch{return null}return C.findPassword(w)}async findCredentials(w){let C;try{C=await this.withKeytar()}catch{return[]}return C.findCredentials(w)}clear(){return this._keytarCache instanceof E.InMemoryCredentialsProvider?this._keytarCache.clear():Promise.resolve()}};b.MAX_PASSWORD_LENGTH=2500,b.PASSWORD_CHUNK_SIZE=b.MAX_PASSWORD_LENGTH-100,b=fe([x(0,R.ILogService)],b),e.BaseCredentialsMainService=b}),define(X[193],J([0,1,25,8,19,3,2,9,69,6]),function(B,e,E,t,D,R,M,b,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class C extends M.Disposable{constructor(S,f){super();this.logService=S,this.options=f,this._onDidChangeFile=this._register(new R.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new R.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new t.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new t.ThrottledDelayer(0))}watch(S,f){return f.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(S,f):this.watchNonRecursive(S,f)}watchUniversal(S,f){const u={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:f.recursive},p=(0,E.insert)(this.universalPathsToWatch,u);return this.refreshUniversalWatchers(),(0,M.toDisposable)(()=>{p(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(f=>this._onDidChangeFile.fire((0,d.toFileChanges)(f)),f=>this.onWatcherLogMessage(f),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)})));const S=this.options?.watcher?.recursive?.usePolling;if(S===!0)for(const f of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(S))for(const f of this.universalPathsToWatch)(0,d.isRecursiveWatchRequest)(f)&&S.includes(f.path)&&(f.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(S,f){const u={path:this.toFilePath(S),excludes:f.excludes,includes:f.includes,recursive:!1},p=(0,E.insert)(this.nonRecursivePathsToWatch,u);return this.refreshNonRecursiveWatchers(),(0,M.toDisposable)(()=>{p(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(S=>(0,D.onUnexpectedError)(S))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(S=>this._onDidChangeFile.fire((0,d.toFileChanges)(S)),S=>this.onWatcherLogMessage(S),this.logService.getLevel()===w.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===w.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(S){S.type==="error"&&this._onDidWatchError.fire(S.message),this.logService[S.type](S.message)}toFilePath(S){return(0,b.normalize)(S.fsPath)}}e.AbstractDiskFileSystemProvider=C}),define(X[194],J([0,1,25,8,17,21,3,65,55,2,33,12,70,16,56,153,15,102,6]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let g=class extends w.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new M.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new M.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new M.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new M.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new M.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new M.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new t.ResourceQueue)}registerProvider(l,s){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,S.mark)(`code/registerFilesystem/${l}`);const r=new w.DisposableStore;return this.provider.set(l,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:s}),r.add(s.onDidChangeFile(n=>this._onDidFilesChange.fire(new m.FileChangesEvent(n,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(n=>this._onDidWatchError.fire(new Error(n)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:l}))),(0,w.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:s}),this.provider.delete(l),(0,w.dispose)(r)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(r){s.push(r)}}),!this.provider.has(l)&&await t.Promises.settled(s)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,s){const r=this.provider.get(l.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return d.Iterable.map(this.provider,([l,s])=>({scheme:l,capabilities:s.capabilities}))}async withProvider(l){if(!(0,f.isAbsolutePath)(l))throw new m.FileOperationError((0,p.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const s=this.provider.get(l.scheme);if(!s){const r=new Error;throw r.name="ENOPRO",r.message=(0,p.localize)(1,null,l.toString()),r}return s}async withReadProvider(l){const s=await this.withProvider(l);if((0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s)||(0,m.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const s=await this.withProvider(l);if((0,m.hasOpenReadWriteCloseCapability)(s)||(0,m.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,s){try{return await this.doResolveFile(l,s)}catch(r){throw(0,m.toFileSystemProviderErrorCode)(r)===m.FileSystemProviderErrorCode.FileNotFound?new m.FileOperationError((0,p.localize)(2,null,this.resourceForError(l)),1):(0,m.ensureFileSystemProviderError)(r)}}async doResolveFile(l,s){const r=await this.withProvider(l),n=this.isPathCaseSensitive(r),i=s?.resolveTo,o=s?.resolveSingleChildDescendants,a=s?.resolveMetadata,c=await r.stat(l);let v;return this.toFileStat(r,l,c,void 0,!!a,(k,L)=>(v||(v=C.TernarySearchTree.forUris(()=>!n),v.set(l,!0),i&&v.fill(!0,i)),v.get(k.resource)||v.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?L===1:!1))}async toFileStat(l,s,r,n,i,o){const{providerExtUri:a}=this.getExtUri(l),c={resource:s,name:a.basename(s),isFile:(r.type&m.FileType.File)!=0,isDirectory:(r.type&m.FileType.Directory)!=0,isSymbolicLink:(r.type&m.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&m.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,m.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(c.isDirectory&&o(c,n)){try{const v=await l.readdir(s),k=await t.Promises.settled(v.map(async([L,O])=>{try{const F=a.joinPath(s,L),j=i?await l.stat(F):{type:O};return await this.toFileStat(l,F,j,v.length,i,o)}catch(F){return this.logService.trace(F),null}}));c.children=(0,E.coalesce)(k)}catch(v){this.logService.trace(v),c.children=[]}return c}return c}async resolveAll(l){return t.Promises.settled(l.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(l){const s=await this.withProvider(l),r=await s.stat(l);return this.toFileStat(s,l,r,void 0,!0,()=>!1)}async exists(l){const s=await this.withProvider(l);try{return!!await s.stat(l)}catch{return!1}}async canCreateFile(l,s){try{await this.doValidateCreateFile(l,s)}catch(r){return r}return!0}async doValidateCreateFile(l,s){if(!s?.overwrite&&await this.exists(l))throw new m.FileOperationError((0,p.localize)(3,null,this.resourceForError(l)),3,s)}async createFile(l,s=D.VSBuffer.fromString(""),r){await this.doValidateCreateFile(l,r);const n=await this.writeFile(l,s);return this._onDidRunOperation.fire(new m.FileOperationEvent(l,0,n)),n}async writeFile(l,s,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:i}=this.getExtUri(n);try{await this.validateWriteFile(n,l,r)||await this.mkdirp(n,i.dirname(l));let a;if((0,m.hasReadWriteCapability)(n)&&!(s instanceof D.VSBuffer))if((0,u.isReadableStream)(s)){const c=await(0,u.peekStream)(s,3);c.ended?a=D.VSBuffer.concat(c.buffer):a=c}else a=(0,u.peekReadable)(s,c=>D.VSBuffer.concat(c),3);else a=s;!(0,m.hasOpenReadWriteCloseCapability)(n)||(0,m.hasReadWriteCapability)(n)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(n,l,r,a):await this.doWriteBuffered(n,l,r,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a),this._onDidRunOperation.fire(new m.FileOperationEvent(l,4))}catch(o){throw new m.FileOperationError((0,p.localize)(4,null,this.resourceForError(l),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),r)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,s,r){if(!!r?.unlock&&!(l.capabilities&8192))throw new Error((0,p.localize)(5,null,this.resourceForError(s)));let i;try{i=await l.stat(s)}catch{return}if((i.type&m.FileType.Directory)!=0)throw new m.FileOperationError((0,p.localize)(6,null,this.resourceForError(s)),0,r);if(this.throwIfFileIsReadonly(s,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==m.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,m.etag)({mtime:r.mtime,size:i.size}))throw new m.FileOperationError((0,p.localize)(7,null),3,r);return i}async readFile(l,s,r){const n=await this.withReadProvider(l);return s?.atomic?this.doReadFileAtomic(n,l,s,r):this.doReadFile(n,l,s,r)}async doReadFileAtomic(l,s,r,n){return new Promise((i,o)=>{this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{try{const a=await this.doReadFile(l,s,r,n);i(a)}catch(a){o(a)}})})}async doReadFile(l,s,r,n){const i=await this.doReadFileStream(l,s,{...r,preferUnbuffered:!0},n);return{...i,value:await(0,D.streamToBuffer)(i.value)}}async readFileStream(l,s,r){const n=await this.withReadProvider(l);return this.doReadFileStream(n,l,s,r)}async doReadFileStream(l,s,r,n){const i=new R.CancellationTokenSource(n),o=this.validateReadFile(s,r).then(c=>c,c=>{throw i.cancel(),c});let a;try{return typeof r?.etag=="string"&&r.etag!==m.ETAG_DISABLED&&await o,r?.atomic&&(0,m.hasFileAtomicReadCapability)(l)||!((0,m.hasOpenReadWriteCloseCapability)(l)||(0,m.hasFileReadStreamCapability)(l))||(0,m.hasReadWriteCapability)(l)&&r?.preferUnbuffered?a=this.readFileUnbuffered(l,s,r):(0,m.hasFileReadStreamCapability)(l)?a=this.readFileStreamed(l,s,i.token,r):a=this.readFileBuffered(l,s,i.token,r),{...await o,value:a}}catch(c){a&&await(0,u.consumeStream)(a);const v=(0,p.localize)(8,null,this.resourceForError(s),(0,m.ensureFileSystemProviderError)(c).toString());throw c instanceof m.NotModifiedSinceFileOperationError?new m.NotModifiedSinceFileOperationError(v,c.stat,r):new m.FileOperationError(v,(0,m.toFileOperationResult)(c),r)}}readFileStreamed(l,s,r,n=Object.create(null)){const i=l.readFileStream(s,n,r);return(0,u.transform)(i,{data:o=>o instanceof D.VSBuffer?o:D.VSBuffer.wrap(o),error:o=>new m.FileOperationError((0,p.localize)(9,null,this.resourceForError(s),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),n)},o=>D.VSBuffer.concat(o))}readFileBuffered(l,s,r,n=Object.create(null)){const i=(0,D.newWriteableBufferStream)();return(0,y.readFileIntoStream)(l,s,i,o=>o,{...n,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new m.FileOperationError((0,p.localize)(10,null,this.resourceForError(s),(0,m.ensureFileSystemProviderError)(o).toString()),(0,m.toFileOperationResult)(o),n)},r),i}readFileUnbuffered(l,s,r){const n=(0,u.newWriteableStream)(i=>D.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,m.hasFileAtomicReadCapability)(l)?i=await l.readFile(s,{atomic:!0}):i=await l.readFile(s),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(s,i.byteLength,r),n.end(D.VSBuffer.wrap(i))}catch(i){n.error(i),n.end()}})(),n}async validateReadFile(l,s){const r=await this.resolve(l,{resolveMetadata:!0});if(r.isDirectory)throw new m.FileOperationError((0,p.localize)(11,null,this.resourceForError(l)),0,s);if(typeof s?.etag=="string"&&s.etag!==m.ETAG_DISABLED&&s.etag===r.etag)throw new m.NotModifiedSinceFileOperationError((0,p.localize)(12,null),r,s);return this.validateReadFileLimits(l,r.size,s),r}validateReadFileLimits(l,s,r){if(r?.limits){let n;if(typeof r.limits.memory=="number"&&s>r.limits.memory&&(n=9),typeof r.limits.size=="number"&&s>r.limits.size&&(n=7),typeof n=="number")throw new m.FileOperationError((0,p.localize)(13,null,this.resourceForError(l)),n)}}async canMove(l,s,r){return this.doCanMoveCopy(l,s,"move",r)}async canCopy(l,s,r){return this.doCanMoveCopy(l,s,"copy",r)}async doCanMoveCopy(l,s,r,n){if(l.toString()!==s.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,l,o,s,r,n)}catch(i){return i}return!0}async move(l,s,r){const n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(n,l,i,s,"move",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,o==="move"?2:3,a)),a}async copy(l,s,r){const n=await this.withReadProvider(l),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(n,l,i,s,"copy",!!r),a=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,o==="copy"?3:2,a)),a}async doMoveCopy(l,s,r,n,i,o){if(s.toString()===n.toString())return i;const{exists:a,isSameResourceWithDifferentPathCase:c}=await this.doValidateMoveCopy(l,s,r,n,i,o);if(a&&!c&&o&&await this.del(n,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(n)),i==="copy"){if(l===r&&(0,m.hasFileFolderCopyCapability)(l))await l.copy(s,n,{overwrite:o});else{const v=await this.resolve(s);v.isDirectory?await this.doCopyFolder(l,v,r,n):await this.doCopyFile(l,s,r,n)}return i}else return l===r?(await l.rename(s,n,{overwrite:o}),i):(await this.doMoveCopy(l,s,r,n,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(l,s,r,n){if((0,m.hasOpenReadWriteCloseCapability)(l)&&(0,m.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(l,s,r,n);if((0,m.hasOpenReadWriteCloseCapability)(l)&&(0,m.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(l,s,r,n);if((0,m.hasReadWriteCapability)(l)&&(0,m.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(l,s,r,n);if((0,m.hasReadWriteCapability)(l)&&(0,m.hasReadWriteCapability)(r))return this.doPipeUnbuffered(l,s,r,n)}async doCopyFolder(l,s,r,n){await r.mkdir(n),Array.isArray(s.children)&&await t.Promises.settled(s.children.map(async i=>{const o=this.getExtUri(r).providerExtUri.joinPath(n,i.name);return i.isDirectory?this.doCopyFolder(l,await this.resolve(i.resource),r,o):this.doCopyFile(l,i.resource,r,o)}))}async doValidateMoveCopy(l,s,r,n,i,o){let a=!1;if(l===r){const{providerExtUri:v,isPathCaseSensitive:k}=this.getExtUri(l);if(k||(a=v.isEqual(s,n)),a&&i==="copy")throw new Error((0,p.localize)(14,null,this.resourceForError(s),this.resourceForError(n)));if(!a&&v.isEqualOrParent(n,s))throw new Error((0,p.localize)(15,null,this.resourceForError(s),this.resourceForError(n)))}const c=await this.exists(n);if(c&&!a){if(!o)throw new m.FileOperationError((0,p.localize)(16,null,this.resourceForError(s),this.resourceForError(n)),4);if(l===r){const{providerExtUri:v}=this.getExtUri(l);if(v.isEqualOrParent(s,n))throw new Error((0,p.localize)(17,null,this.resourceForError(s),this.resourceForError(n)))}}return{exists:c,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const s=this.isPathCaseSensitive(l);return{providerExtUri:s?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(s,l);const r=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new m.FileOperationEvent(l,0,r)),r}async mkdirp(l,s){const r=[],{providerExtUri:n}=this.getExtUri(l);for(;!n.isEqual(s,n.dirname(s));)try{if(((await l.stat(s)).type&m.FileType.Directory)==0)throw new Error((0,p.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,m.toFileSystemProviderErrorCode)(i)!==m.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(n.basename(s)),s=n.dirname(s)}for(let i=r.length-1;i>=0;i--){s=n.joinPath(s,r[i]);try{await l.mkdir(s)}catch(o){if((0,m.toFileSystemProviderErrorCode)(o)!==m.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(l,s){try{await this.doValidateDelete(l,s)}catch(r){return r}return!0}async doValidateDelete(l,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!s?.useTrash&&!(r.capabilities&4096))throw new Error((0,p.localize)(19,null,this.resourceForError(l)));let i;try{i=await r.stat(l)}catch{}if(i)this.throwIfFileIsReadonly(l,i);else throw new m.FileOperationError((0,p.localize)(20,null,this.resourceForError(l)),1);if(!!!s?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,p.localize)(21,null,this.resourceForError(l)))}return r}async del(l,s){const r=await this.doValidateDelete(l,s),n=!!s?.useTrash,i=!!s?.recursive;await r.delete(l,{recursive:i,useTrash:n}),this._onDidRunOperation.fire(new m.FileOperationEvent(l,1))}async cloneFile(l,s){const r=await this.withProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(r===n&&this.getExtUri(r).providerExtUri.isEqual(l,s))return;if(r===n&&(0,m.hasFileCloneCapability)(r))return r.cloneFile(l,s);await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(s));const i=this.writeQueue.queueFor(l,this.getExtUri(r).providerExtUri);return r===n&&(0,m.hasFileFolderCopyCapability)(r)?i.queue(()=>r.copy(l,s,{overwrite:!0})):i.queue(()=>this.doCopyFile(r,l,n,s))}watch(l,s={recursive:!1,excludes:[]}){const r=new w.DisposableStore;let n=!1,i=()=>{n=!0};return r.add((0,w.toDisposable)(()=>i())),(async()=>{try{const o=await this.doWatch(l,s);n?(0,w.dispose)(o):i=()=>(0,w.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(l,s){const r=await this.withProvider(l),n=(0,b.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(l),s]);let i=this.activeWatchers.get(n);return i||(i={count:0,disposable:r.watch(l,s)},this.activeWatchers.set(n,i)),i.count+=1,(0,w.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,w.dispose)(i.disposable),this.activeWatchers.delete(n)))})}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,w.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,s,r,n){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(async()=>{const i=await l.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,u.isReadableStream)(n)||(0,u.isReadableBufferedStream)(n)?await this.doWriteStreamBufferedQueued(l,i,n):await this.doWriteReadableBufferedQueued(l,i,n)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await l.close(i)}})}async doWriteStreamBufferedQueued(l,s,r){let n=0,i;if((0,u.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=D.VSBuffer.concat(r.buffer);await this.doWriteBuffer(l,s,o,o.byteLength,n,0),n+=o.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((o,a)=>{(0,u.listenStream)(i,{onData:async c=>{i.pause();try{await this.doWriteBuffer(l,s,c,c.byteLength,n,0)}catch(v){return a(v)}n+=c.byteLength,setTimeout(()=>i.resume())},onError:c=>a(c),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(l,s,r){let n=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(l,s,i,i.byteLength,n,0),n+=i.byteLength}async doWriteBuffer(l,s,r,n,i,o){let a=0;for(;a<n;)a+=await l.write(s,i+a,r.buffer,o+a,n-a)}async doWriteUnbuffered(l,s,r,n){return this.writeQueue.queueFor(s,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,s,r,n))}async doWriteUnbufferedQueued(l,s,r,n){let i;n instanceof D.VSBuffer?i=n:(0,u.isReadableStream)(n)?i=await(0,D.streamToBuffer)(n):(0,u.isReadableBufferedStream)(n)?i=await(0,D.bufferedStreamToBuffer)(n):i=(0,D.readableToBuffer)(n),await l.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(l,s,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,s,r,n))}async doPipeBufferedQueued(l,s,r,n){let i,o;try{i=await l.open(s,{create:!1}),o=await r.open(n,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let c=0,v=0,k=0;do k=await l.read(i,c,a.buffer,v,a.byteLength-v),await this.doWriteBuffer(r,o,a,k,c,v),c+=k,v+=k,v===a.byteLength&&(v=0);while(k>0)}catch(a){throw(0,m.ensureFileSystemProviderError)(a)}finally{await t.Promises.settled([typeof i=="number"?l.close(i):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(l,s,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,s,r,n))}async doPipeUnbufferedQueued(l,s,r,n){return r.writeFile(n,await l.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,s,r,n){return this.writeQueue.queueFor(n,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,s,r,n))}async doPipeUnbufferedToBufferedQueued(l,s,r,n){const i=await r.open(n,{create:!0,unlock:!1});try{const o=await l.readFile(s);await this.doWriteBuffer(r,i,D.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,m.ensureFileSystemProviderError)(o)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(l,s,r,n){const i=await(0,D.streamToBuffer)(this.readFileBuffered(l,s,R.CancellationToken.None));await this.doWriteUnbuffered(r,n,void 0,i)}throwIfFileSystemIsReadonly(l,s){if(l.capabilities&2048)throw new m.FileOperationError((0,p.localize)(22,null,this.resourceForError(s)),6);return l}throwIfFileIsReadonly(l,s){if((s.permissions??0)&m.FilePermission.Readonly)throw new m.FileOperationError((0,p.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===P.Schemas.file?l.fsPath:l.toString(!0)}};g=fe([x(0,I.ILogService)],g),e.FileService=g}),define(X[85],J([0,1,28,263,8,33,17,3,30,2,9,4,16,56,23,157,15,102,193,41,190,189]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,t.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(r)}`)}})();class s extends I.AbstractDiskFileSystemProvider{constructor(n,i){super(n,i);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new R.ResourceMap(o=>S.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:i,symbolicLink:o}=await u.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(n){try{const i=await u.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async a=>{try{let c;a.isSymbolicLink()?c=(await this.stat((0,S.joinPath)(n,a.name))).type:c=this.toType(a),o.push([a.name,c])}catch(c){this.logService.trace(c)}})),o}catch(i){throw this.toFileSystemProviderError(i)}}toType(n,i){let o;return i?.dangling?o=m.FileType.Unknown:n.isFile()?o=m.FileType.File:n.isDirectory()?o=m.FileType.Directory:o=m.FileType.Unknown,i&&(o|=m.FileType.SymbolicLink),o}async createResourceLock(n){const i=this.toFilePath(n);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.resourceLocks.get(n);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const a=new D.Barrier;return this.resourceLocks.set(n,a),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,w.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(n)===a&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(n,i){let o;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(n)})`),o=await this.createResourceLock(n));const a=this.toFilePath(n);return await u.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}finally{o?.dispose()}}readFileStream(n,i,o){const a=(0,f.newWriteableStream)(c=>M.VSBuffer.concat(c.map(v=>M.VSBuffer.wrap(v))).buffer);return(0,y.readFileIntoStream)(this,n,a,c=>c.buffer,{...i,bufferSize:256*1024},o),a}async writeFile(n,i,o){let a;try{const c=this.toFilePath(n);if(!o.create||!o.overwrite){if(await u.Promises.exists(c)){if(!o.overwrite)throw(0,m.createFileSystemProviderError)((0,p.localize)(0,null),m.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,m.createFileSystemProviderError)((0,p.localize)(1,null),m.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:o.unlock}),await this.write(a,0,i,0,i.byteLength)}catch(c){throw await this.toFileSystemProviderWriteError(n,c)}finally{typeof a=="number"&&await this.close(a)}}static configureFlushOnWrite(n){s.canFlush=n}async open(n,i){const o=this.toFilePath(n);let a;(0,m.isFileOpenForWriteOptions)(i)&&(a=await this.createResourceLock(n));let c;try{if((0,m.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:k}=await u.SymlinkSupport.stat(o);k.mode&128||await u.Promises.chmod(o,k.mode|128)}catch(k){this.logService.trace(k)}let v;if((0,m.isFileOpenForWriteOptions)(i)){if(P.isWindows)try{await u.Promises.truncate(o,0),v="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}v||(v="w")}else v="r";c=await u.Promises.open(o,v)}catch(v){throw a?.dispose(),(0,m.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(n,v):this.toFileSystemProviderError(v)}if(this.mapHandleToPos.set(c,0),(0,m.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(c,n),a){const v=this.mapHandleToLock.get(c);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${o})`),this.mapHandleToLock.set(c,a),v&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${o})`),v.dispose())}return c}async close(n){const i=this.mapHandleToLock.get(n);try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&s.canFlush)try{await u.Promises.fdatasync(n)}catch(o){s.configureFlushOnWrite(!1),this.logService.error(o)}return await u.Promises.close(n)}catch(o){throw this.toFileSystemProviderError(o)}finally{i&&(this.mapHandleToLock.get(n)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.mapHandleToLock.delete(n)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),i.dispose())}}async read(n,i,o,a,c){const v=this.normalizePos(n,i);let k=null;try{k=(await u.Promises.read(n,o,a,c,v)).bytesRead}catch(L){throw this.toFileSystemProviderError(L)}finally{this.updatePos(n,v,k)}return k}normalizePos(n,i){return i===this.mapHandleToPos.get(n)?null:i}updatePos(n,i,o){const a=this.mapHandleToPos.get(n);typeof a=="number"&&(typeof i=="number"||(typeof o=="number"?this.mapHandleToPos.set(n,a+o):this.mapHandleToPos.delete(n)))}async write(n,i,o,a,c){return(0,D.retry)(()=>this.doWrite(n,i,o,a,c),100,3)}async doWrite(n,i,o,a,c){const v=this.normalizePos(n,i);let k=null;try{k=(await u.Promises.write(n,o,a,c,v)).bytesWritten}catch(L){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),L)}finally{this.updatePos(n,v,k)}return k}async mkdir(n){try{await u.Promises.mkdir(this.toFilePath(n))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(n,i){try{const o=this.toFilePath(n);i.recursive?await u.Promises.rm(o,u.RimRafMode.MOVE):await u.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(n,i,o){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(n,i,"move",o.overwrite),await u.Promises.move(a,c)}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(2,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),v.toString()))),this.toFileSystemProviderError(v)}}async copy(n,i,o){const a=this.toFilePath(n),c=this.toFilePath(i);if(a!==c)try{await this.validateTargetDeleted(n,i,"copy",o.overwrite),await u.Promises.copy(a,c,{preserveSymlinks:!0})}catch(v){throw(v.code==="EINVAL"||v.code==="EBUSY"||v.code==="ENAMETOOLONG")&&(v=new Error((0,p.localize)(3,null,(0,C.basename)(a),(0,C.basename)((0,C.dirname)(c)),v.toString()))),this.toFileSystemProviderError(v)}}async validateTargetDeleted(n,i,o,a){const c=this.toFilePath(n),v=this.toFilePath(i);let k=!1;if(!!(this.capabilities&1024)||(k=(0,d.isEqual)(c,v,!0)),k&&o==="copy")throw(0,m.createFileSystemProviderError)((0,p.localize)(4,null),m.FileSystemProviderErrorCode.FileExists);if(!k&&await u.Promises.exists(v)){if(!a)throw(0,m.createFileSystemProviderError)((0,p.localize)(5,null),m.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(n,i){return this.doCloneFile(n,i,!1)}async doCloneFile(n,i,o){const a=this.toFilePath(n),c=this.toFilePath(i),v=!!(this.capabilities&1024);if((0,d.isEqual)(a,c,!v))return;const k=new w.DisposableStore;try{const[L,O]=await Promise.all([this.createResourceLock(n),this.createResourceLock(i)]);k.add(L),k.add(O),o&&await u.Promises.mkdir((0,C.dirname)(c),{recursive:!0}),await u.Promises.copyFile(a,c)}catch(L){if(L.code==="ENOENT"&&!o)return this.doCloneFile(n,i,!0);throw this.toFileSystemProviderError(L)}finally{k.dispose()}}createUniversalWatcher(n,i,o){return new h.UniversalWatcherClient(a=>n(a),a=>i(a),o)}createNonRecursiveWatcher(n,i,o){return new l.NodeJSWatcherClient(a=>n(a),a=>i(a),o)}toFileSystemProviderError(n){if(n instanceof m.FileSystemProviderError)return n;let i;switch(n.code){case"ENOENT":i=m.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=m.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=m.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=m.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=m.FileSystemProviderErrorCode.NoPermissions;break;default:i=m.FileSystemProviderErrorCode.Unknown}return(0,m.createFileSystemProviderError)(n,i)}async toFileSystemProviderWriteError(n,i){let o=this.toFileSystemProviderError(i);if(n&&o.code===m.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await u.SymlinkSupport.stat(this.toFilePath(n));a.mode&128||(o=(0,m.createFileSystemProviderError)(i,m.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.logService.trace(a)}return o}}e.DiskFileSystemProvider=s,s.canFlush=!0}),define(X[195],J([0,1,3,85,2,17,56,21]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class d extends D.Disposable{constructor(P,S){super();this.provider=P,this.logService=S,this.sessionToWatcher=new Map,this.watchRequests=new Map}call(P,S,f){const u=this.getUriTransformer(P);switch(S){case"stat":return this.stat(u,f[0]);case"readdir":return this.readdir(u,f[0]);case"open":return this.open(u,f[0],f[1]);case"close":return this.close(f[0]);case"read":return this.read(f[0],f[1],f[2]);case"readFile":return this.readFile(u,f[0],f[1]);case"write":return this.write(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.writeFile(u,f[0],f[1],f[2]);case"rename":return this.rename(u,f[0],f[1],f[2]);case"copy":return this.copy(u,f[0],f[1],f[2]);case"cloneFile":return this.cloneFile(u,f[0],f[1]);case"mkdir":return this.mkdir(u,f[0]);case"delete":return this.delete(u,f[0],f[1]);case"watch":return this.watch(u,f[0],f[1],f[2],f[3]);case"unwatch":return this.unwatch(f[0],f[1])}throw new Error(`IPC Command ${S} not found`)}listen(P,S,f){const u=this.getUriTransformer(P);switch(S){case"fileChange":return this.onFileChange(u,f[0]);case"readFileStream":return this.onReadFileStream(u,f[0],f[1])}throw new Error(`Unknown event ${S}`)}stat(P,S){const f=this.transformIncoming(P,S,!0);return this.provider.stat(f)}readdir(P,S){const f=this.transformIncoming(P,S);return this.provider.readdir(f)}async readFile(P,S,f){const u=this.transformIncoming(P,S,!0),p=await this.provider.readFile(u,f);return R.VSBuffer.wrap(p)}onReadFileStream(P,S,f){const u=this.transformIncoming(P,S,!0),p=new b.CancellationTokenSource,m=new E.Emitter({onLastListenerRemove:()=>{p.cancel()}}),y=this.provider.readFileStream(u,f,p.token);return(0,M.listenStream)(y,{onData:I=>m.fire(R.VSBuffer.wrap(I)),onError:I=>m.fire(I),onEnd:()=>{m.fire("end"),m.dispose(),p.dispose()}}),m.event}writeFile(P,S,f,u){const p=this.transformIncoming(P,S);return this.provider.writeFile(p,f.buffer,u)}open(P,S,f){const u=this.transformIncoming(P,S,!0);return this.provider.open(u,f)}close(P){return this.provider.close(P)}async read(P,S,f){const u=R.VSBuffer.alloc(f),p=0,m=await this.provider.read(P,S,u.buffer,p,f);return[u,m]}write(P,S,f,u,p){return this.provider.write(P,S,f.buffer,u,p)}mkdir(P,S){const f=this.transformIncoming(P,S);return this.provider.mkdir(f)}delete(P,S,f){const u=this.transformIncoming(P,S);return this.provider.delete(u,f)}rename(P,S,f,u){const p=this.transformIncoming(P,S),m=this.transformIncoming(P,f);return this.provider.rename(p,m,u)}copy(P,S,f,u){const p=this.transformIncoming(P,S),m=this.transformIncoming(P,f);return this.provider.copy(p,m,u)}cloneFile(P,S,f){const u=this.transformIncoming(P,S),p=this.transformIncoming(P,f);return this.provider.cloneFile(u,p)}onFileChange(P,S){const f=new E.Emitter({onFirstListenerAdd:()=>{this.sessionToWatcher.set(S,this.createSessionFileWatcher(P,f))},onLastListenerRemove:()=>{(0,D.dispose)(this.sessionToWatcher.get(S)),this.sessionToWatcher.delete(S)}});return f.event}async watch(P,S,f,u,p){const m=this.sessionToWatcher.get(S);if(m){const y=this.transformIncoming(P,u),I=m.watch(f,y,p);this.watchRequests.set(S+f,I)}}async unwatch(P,S){const f=P+S,u=this.watchRequests.get(f);u&&((0,D.dispose)(u),this.watchRequests.delete(f))}dispose(){super.dispose();for(const[,P]of this.watchRequests)P.dispose();this.watchRequests.clear();for(const[,P]of this.sessionToWatcher)P.dispose();this.sessionToWatcher.clear()}}e.AbstractDiskFileSystemProviderChannel=d;class w extends D.Disposable{constructor(P,S,f,u){super();this.uriTransformer=P,this.logService=f,this.environmentService=u,this.watcherRequests=new Map,this.fileWatcher=this._register(new t.DiskFileSystemProvider(this.logService,{watcher:{recursive:this.getRecursiveWatcherOptions(this.environmentService)}})),this.registerListeners(S)}registerListeners(P){const S=this._register(new E.Emitter);this._register(S.event(f=>{P.fire(f.map(u=>({resource:this.uriTransformer.transformOutgoingURI(u.resource),type:u.type})))})),this._register(this.fileWatcher.onDidChangeFile(f=>S.fire(f))),this._register(this.fileWatcher.onDidWatchError(f=>P.fire(f)))}getRecursiveWatcherOptions(P){}getExtraExcludes(P){}watch(P,S,f){const u=this.getExtraExcludes(this.environmentService);return Array.isArray(u)&&(f.excludes=[...f.excludes,...u]),this.watcherRequests.set(P,this.fileWatcher.watch(S,f)),(0,D.toDisposable)(()=>{(0,D.dispose)(this.watcherRequests.get(P)),this.watcherRequests.delete(P)})}dispose(){super.dispose();for(const[,P]of this.watcherRequests)P.dispose();this.watcherRequests.clear()}}e.AbstractSessionFileWatcher=w}),define(X[196],J([0,1,14,156,4,7,15,9,195,137]),function(B,e,E,t,D,R,M,b,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class C extends d.AbstractDiskFileSystemProviderChannel{constructor(f,u,p){super(f,u);this.environmentService=p}getUriTransformer(f){return w.DefaultURITransformer}transformIncoming(f,u){return R.URI.revive(u)}async delete(f,u,p){if(!p.useTrash)return super.delete(f,u,p);const m=this.transformIncoming(f,u),y=(0,b.normalize)(m.fsPath);try{await E.shell.trashItem(y)}catch{throw(0,M.createFileSystemProviderError)(D.isWindows?(0,t.localize)(0,null,(0,b.basename)(y)):(0,t.localize)(1,null,(0,b.basename)(y)),M.FileSystemProviderErrorCode.Unknown)}}createSessionFileWatcher(f,u){return new P(f,u,this.logService,this.environmentService)}}e.DiskFileSystemProviderChannel=C;class P extends d.AbstractSessionFileWatcher{watch(f,u,p){if(p.recursive)throw(0,M.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",M.FileSystemProviderErrorCode.Unavailable);return super.watch(f,u,p)}}}),define(X[103],J([0,1,6]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function t(R,M){switch(M){case E.LogLevel.Trace:return R.trace;case E.LogLevel.Debug:return R.debug;case E.LogLevel.Info:return R.info;case E.LogLevel.Warning:return R.warn;case E.LogLevel.Error:return R.error;case E.LogLevel.Critical:return R.critical;default:throw new Error("Invalid log level")}}class D extends E.AbstractLogger{constructor(M=E.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(M),this._register(this.onDidChangeLogLevel(b=>{this._logger?.setLevel(b)}))}set logger(M){this._logger=M;for(const{level:b,args:d}of this.buffer)t(M,b).apply(M,d);this.buffer=[]}_log(M,...b){this._logger?t(this._logger,M).apply(this._logger,b):this.getLevel()<=M&&this.buffer.push({level:M,args:b})}trace(M,...b){this._log(E.LogLevel.Trace,M,...b)}debug(M,...b){this._log(E.LogLevel.Debug,M,...b)}info(M,...b){this._log(E.LogLevel.Info,M,...b)}warn(M,...b){this._log(E.LogLevel.Warning,M,...b)}error(M,...b){this._log(E.LogLevel.Error,M,...b)}critical(M,...b){this._log(E.LogLevel.Critical,M,...b)}dispose(){this._logger?.dispose()}flush(){this._logger?.flush()}}e.BufferLogService=D}),define(X[197],J([0,1,8,17,16,15,5,103,6]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const w=5*R.ByteSize.MB;let C=class extends d.AbstractLogger{constructor(f,u,p,m,y){super();this.name=f,this.resource=u,this.donotUseFormatters=m,this.fileService=y,this.backupIndex=1,this.setLevel(p),this.queue=this._register(new E.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,(0,d.format)(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,(0,d.format)(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,(0,d.format)(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,(0,d.format)(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const f=arguments[0];if(f instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=f.stack,this._log(d.LogLevel.Error,(0,d.format)(u))}else this._log(d.LogLevel.Error,(0,d.format)(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,(0,d.format)(arguments))}flush(){}async initialize(){try{await this.fileService.createFile(this.resource)}catch(f){if(f.fileOperationResult!==3)throw f}}_log(f,u){this.queue.queue(async()=>{await this.initializePromise;let p=await this.loadContent();p.length>w&&(await this.fileService.writeFile(this.getBackupResource(),t.VSBuffer.fromString(p)),p=""),this.donotUseFormatters?p+=u:p+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(f)}] ${u}
`,await this.fileService.writeFile(this.resource,t.VSBuffer.fromString(p))})}getCurrentTimestamp(){const f=m=>m<10?`0${m}`:m,u=m=>m<10?`00${m}`:m<100?`0${m}`:m,p=new Date;return`${p.getFullYear()}-${f(p.getMonth()+1)}-${f(p.getDate())} ${f(p.getHours())}:${f(p.getMinutes())}:${f(p.getSeconds())}.${u(p.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch{return""}}stringifyLogLevel(f){switch(f){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}};C=fe([x(4,R.IFileService)],C),e.FileLogger=C;let P=class extends d.AbstractLoggerService{constructor(f,u,p){super(f.getLevel(),f.onDidChangeLogLevel);this.instantiationService=u,this.fileService=p}doCreateLogger(f,u,p){const m=new b.BufferLogService(u);return(0,R.whenProviderRegistered)(f,this.fileService).then(()=>m.logger=this.instantiationService.createInstance(C,p?.name||(0,D.basename)(f),f,m.getLevel(),!!p?.donotUseFormatters)),m}};P=fe([x(0,d.ILogService),x(1,M.IInstantiationService),x(2,R.IFileService)],P),e.FileLoggerService=P}),define(X[198],J([0,1,3,7,6]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class R{constructor(S){this.service=S,this.onDidChangeLogLevel=E.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,f){switch(f){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${f}`)}async call(S,f,u){switch(f){case"setLevel":return this.service.setLevel(u)}throw new Error(`Call not found: ${f}`)}}e.LogLevelChannel=R;class M{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){M.setLevel(this.channel,S)}static setLevel(S,f){return S.call("setLevel",f)}}e.LogLevelChannelClient=M;class b{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,f){throw new Error(`Event not found: ${f}`)}async call(S,f,u){switch(f){case"createLogger":this.createLogger(t.URI.revive(u[0]),u[1]);return;case"log":return this.log(t.URI.revive(u[0]),u[1]);case"consoleLog":return this.consoleLog(u[0],u[1])}throw new Error(`Call not found: ${f}`)}createLogger(S,f){this.loggers.set(S.toString(),this.loggerService.createLogger(S,f))}consoleLog(S,f){let u=console.log;switch(S){case D.LogLevel.Error:u=console.error;break;case D.LogLevel.Warning:u=console.warn;break;case D.LogLevel.Info:u=console.info;break}u.call(console,...f)}log(S,f){const u=this.loggers.get(S.toString());if(!u)throw new Error("Create the logger before logging");for(const[p,m]of f)(0,D.log)(u,p,m)}}e.LoggerChannel=b;class d extends D.AbstractLoggerService{constructor(S,f,u){super(S,f);this.channel=u}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,f)=>{this.channel.call("consoleLog",[S,f])}})}doCreateLogger(S,f,u){return new w(this.channel,S,f,u)}}e.LoggerChannelClient=d;class w extends D.AbstractMessageLogger{constructor(S,f,u,p){super(p?.always);this.channel=S,this.file=f,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(u),this.channel.call("createLogger",[f,p]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,f){const u=[[S,f]];this.isLoggerCreated?this.doLog(u):this.buffer.push(...u)}doLog(S){this.channel.call("log",[this.file,S])}}class C extends D.LogService{constructor(S,f){super(f);this.parent=S,this._register(S.onDidChangeLogLevel(u=>f.setLevel(u)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=C}),define(X[104],J([0,1,15,6]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;async function D(b,d,w,C,P){try{const S=await new Promise((u,p)=>{B(["spdlog"],u,p)});S.setFlushOn(t.LogLevel.Trace);const f=await S.createAsyncRotatingLogger(b,d,w,C);return P&&f.clearFormatters(),f}catch(S){console.error(S)}return null}function R(b,d,w){switch(d){case t.LogLevel.Trace:b.trace(w);break;case t.LogLevel.Debug:b.debug(w);break;case t.LogLevel.Info:b.info(w);break;case t.LogLevel.Warning:b.warn(w);break;case t.LogLevel.Error:b.error(w);break;case t.LogLevel.Critical:b.critical(w);break;default:throw new Error("Invalid log level")}}class M extends t.AbstractMessageLogger{constructor(d,w,C,P,S){super();this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(d,w,C,P),this._register(this.onDidChangeLogLevel(f=>{this._logger?.setLevel(f)}))}async _createSpdLogLogger(d,w,C,P){const S=C?6:1,f=30/S*E.ByteSize.MB,u=await D(d,w,f,S,P);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:p,message:m}of this.buffer)R(this._logger,p,m);this.buffer=[]}}log(d,w){this._logger?R(this._logger,d,w):this.getLevel()<=d&&this.buffer.push({level:d,message:w})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=M}),define(X[199],J([0,1,12,16,27,15,197,6,104]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let w=class extends b.AbstractLoggerService{constructor(P,S){super(P.getLevel(),P.onDidChangeLogLevel);this.fileService=S}doCreateLogger(P,S,f){return P.scheme===E.Schemas.file?new d.SpdLogLogger(f?.name||(0,D.generateUuid)(),P.fsPath,!f?.donotRotate,!!f?.donotUseFormatters,S):new M.FileLogger(f?.name??(0,t.basename)(P),P,S,!!f?.donotUseFormatters,this.fileService)}};w=fe([x(0,b.ILogService),x(1,R.IFileService)],w),e.LoggerService=w}),define(X[200],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(M){return M.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function t(M){return M.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=t;function D(M){return M.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function R(M){return!E(M)&&!t(M)&&!D(M)}e.isMenubarMenuItemAction=R}),define(X[37],J([0,1,3,55,2,5]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,R.createDecorator)("policy");class M extends D.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(w){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...w,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(w),t.Iterable.reduce(this.policies.entries(),(P,[S,f])=>({...P,[S]:f}),{})}getPolicyValue(w){return this.policies.get(w)}serialize(){return t.Iterable.reduce(Object.entries(this.policyDefinitions),(w,[C,P])=>({...w,[C]:{definition:P,value:this.policies.get(C)}}),{})}}e.AbstractPolicyService=M;class b{constructor(){this.onDidChange=E.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(X[201],J([0,1,8,3,55,13,15,6,37]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function w(P,S){const f=[];for(const u of D.Iterable.concat(P.keys(),S.keys()))P.get(u)!==S.get(u)&&f.push(u);return f}let C=class extends d.AbstractPolicyService{constructor(S,f,u){super();this.file=S,this.fileService=f,this.logService=u,this.throttledDelayer=this._register(new E.ThrottledDelayer(500));const p=t.Event.filter(f.onDidFilesChange,m=>m.affects(S));this._register(f.watch(S)),this._register(p(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(S){await this.refresh()}async read(){const S=new Map;try{const f=await this.fileService.readFile(this.file),u=JSON.parse(f.value.toString());if(!(0,R.isObject)(u))throw new Error("Policy file isn't a JSON object");for(const p of Object.keys(u))this.policyDefinitions[p]&&S.set(p,u[p])}catch(f){f.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",f)}return S}async refresh(){const S=await this.read(),f=w(this.policies,S);this.policies=S,f.length>0&&this._onDidChange.fire(f)}};C=fe([x(1,M.IFileService),x(2,b.ILogService)],C),e.FilePolicyService=C}),define(X[202],J([0,1,3,2,37]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class R{constructor(d){this.service=d,this.disposables=new t.DisposableStore}listen(d,w){switch(w){case"onDidChange":return E.Event.map(this.service.onDidChange,C=>C.reduce((P,S)=>({...P,[S]:this.service.getPolicyValue(S)??null}),{}),this.disposables)}throw new Error(`Event not found: ${w}`)}call(d,w,C){switch(w){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(C)}throw new Error(`Call not found: ${w}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=R;class M extends D.AbstractPolicyService{constructor(d,w){super();this.channel=w;for(const C in d){const{definition:P,value:S}=d[C];this.policyDefinitions[C]=P,S!==void 0&&this.policies.set(C,S)}this.channel.listen("onDidChange")(C=>{for(const P in C){const S=C[P];S===null?this.policies.delete(P):this.policies.set(P,S)}this._onDidChange.fire(Object.keys(C))})}async initializePolicies(d){const w=await this.channel.call("registerPolicyDefinitions",d);for(const C in w)this.policies.set(C,w[C])}}e.PolicyChannelClient=M}),define(X[52],J([0,1,12,4,36,16]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let M;if(typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.context!="undefined"){const b=t.globals.vscode.context.configuration();if(b)M=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof B?.__$__nodeRequire=="function"){const b=(0,R.dirname)(E.FileAccess.asFileUri("",B));M=B.__$__nodeRequire((0,R.joinPath)(b,"product.json").fsPath);const d=B.__$__nodeRequire((0,R.joinPath)(b,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(M,{nameShort:`${M.nameShort} Dev`,nameLong:`${M.nameLong} Dev`,dataFolderName:`${M.dataFolderName}-dev`,serverDataFolderName:M.serverDataFolderName?`${M.serverDataFolderName}-dev`:void 0}),Object.assign(M,{version:d.version})}else M={},Object.keys(M).length===0&&Object.assign(M,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=M}),define(X[20],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(X[203],J([0,1,75,6,20]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let R=class{constructor(b,d){this.productService=b,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const w=/^(.*)#([^#]+)$/.exec(d);if(!w)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,C,P]=w;let S=this.trustedExtensionUrlPublicKeys.get(b);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[b],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...S])}const f=Buffer.from(decodeURIComponent(P),"base64");if(f.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const u=f.slice(0,6),p=f.readUIntBE(0,6),m=Date.now()-p;if(m<0||m>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const y=f.slice(6),I=E.createVerify("SHA256");I.write(u),I.write(Buffer.from(C)),I.end();for(let g=0;g<S.length;g++){let h=S[g];if(h!==null){if(typeof h=="string")try{h=E.createPublicKey({key:Buffer.from(h,"base64"),format:"der",type:"spki"}),S[g]=h}catch(l){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${g+1} for ${b}:`,l),S[g]=null;continue}if(I.verify(h,y))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};R=fe([x(0,D.IProductService),x(1,t.ILogService)],R),e.ExtensionUrlTrustService=R}),define(X[59],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(X[44],J([0,1,116,13]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(M,b){E.ok(t.isString(M)),E.ok(t.isObject(b)),E.ok(!this.data.has(M),"There is already an extension with this id"),this.data.set(M,b)}knows(M){return this.data.has(M)}as(M){return this.data.get(M)||null}}e.Registry=new D}),define(X[204],J([0,1,3,44]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class R{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,w){this.schemasById[D(d)]=w,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const M=new R;t.Registry.add(e.Extensions.JSONContribution,M)}),define(X[60],J([0,1,25,3,13,147,18,204,44]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var w;(function(l){l.Multiline="multilineText",l.Singleline="singlelineText"})(w=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var C;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.MACHINE=2]="MACHINE",l[l.WINDOW=3]="WINDOW",l[l.RESOURCE=4]="RESOURCE",l[l.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",l[l.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=d.Registry.as(b.Extensions.JSONContribution);class S{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new t.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new t.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const n=this.doRegisterConfigurations(s,r);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:s,remove:r}){const n=[];n.push(...this.doDeregisterConfigurations(r)),n.push(...this.doRegisterConfigurations(s,!1)),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,E.distinct)(n)})}registerDefaultConfigurations(s){const r=[],n=[];for(const{overrides:i,source:o}of s)for(const a in i)if(r.push(a),e.OVERRIDE_PROPERTY_REGEX.test(a)){const c=this.configurationDefaultsOverrides.get(a),v=c?.valuesSources??new Map;if(o)for(const F of Object.keys(i[a]))v.set(F,o);const k={...c?.value||{},...i[a]};this.configurationDefaultsOverrides.set(a,{source:o,value:k,valuesSources:v});const L=(0,M.getLanguageTagSettingPlainKey)(a),O={type:"object",default:k,description:R.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:D.isString(o)?void 0:o,defaultValueSource:o};n.push(...p(a)),this.configurationProperties[a]=O,this.defaultLanguageConfigurationOverridesNode.properties[a]=O}else{this.configurationDefaultsOverrides.set(a,{value:i[a],source:o});const c=this.configurationProperties[a];c&&(this.updatePropertyDefaultValue(a,c),this.updateSchema(a,c))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:n,source:i}of s)for(const o in n){const a=this.configurationDefaultsOverrides.get(o),c=D.isString(i)?i:i?.id,v=D.isString(a?.source)?a?.source:a?.source?.id;if(c===v)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const k=this.configurationProperties[o];k&&(this.updatePropertyDefaultValue(o,k),this.updateSchema(o,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const n=[];return s.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(s){const r=[],n=i=>{if(i.properties)for(const o in i.properties){r.push(o);const a=this.configurationProperties[o];a?.policy?.name&&this.policyConfigurations.delete(a.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>n(o))};for(const i of s){n(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(s,r=!0,n,i,o=3){o=D.isUndefinedOrNull(s.scope)?o:s.scope;const a=[],c=s.properties;if(c)for(const k in c){const L=c[k];if(r&&g(k,L)){delete c[k];continue}if(L.source=n,L.defaultDefaultValue=c[k].default,this.updatePropertyDefaultValue(k,L),e.OVERRIDE_PROPERTY_REGEX.test(k)?L.scope=void 0:(L.scope=D.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=D.isUndefinedOrNull(L.restricted)?!!i?.includes(k):L.restricted),c[k].hasOwnProperty("included")&&!c[k].included){this.excludedConfigurationProperties[k]=c[k],delete c[k];continue}else this.configurationProperties[k]=c[k],c[k].policy?.name&&this.policyConfigurations.set(c[k].policy.name,k);!c[k].deprecationMessage&&c[k].markdownDeprecationMessage&&(c[k].deprecationMessage=c[k].markdownDeprecationMessage),a.push(k)}const v=s.allOf;if(v)for(const k of v)a.push(...this.validateAndRegisterProperties(k,r,n,i,o));return a}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const r=n=>{const i=n.properties;if(i)for(const a in i)this.updateSchema(a,i[a]);n.allOf?.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,n={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,n),e.allSettings.properties[r]=n,e.applicationSettings.properties[r]=n,e.machineSettings.properties[r]=n,e.machineOverridableSettings.properties[r]=n,e.windowSettings.properties[r]=n,e.resourceSettings.properties[r]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,o=n?.source;D.isUndefined(i)&&(i=r.defaultDefaultValue,o=void 0),D.isUndefined(i)&&(i=y(r.type)),r.default=i,r.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",u=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(l){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(l)){let r=u.exec(l);for(;r?.length;){const n=r[1].trim();n&&s.push(n),r=u.exec(l)}}return(0,E.distinct)(s)}e.overrideIdentifiersFromKey=p;function m(l){return l.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=m;function y(l){switch(Array.isArray(l)?l[0]:l){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=y;const I=new S;d.Registry.add(e.Extensions.Configuration,I);function g(l,s){return l.trim()?e.OVERRIDE_PROPERTY_REGEX.test(l)?R.localize(7,null,l):I.getConfigurationProperties()[l]!==void 0?R.localize(8,null,l):s.policy?.name&&I.getPolicyConfigurations().get(s.policy?.name)!==void 0?R.localize(9,null,l,s.policy?.name,I.getPolicyConfigurations().get(s.policy?.name)):null:R.localize(6,null)}e.validateProperty=g;function h(){const l=[],s=I.getConfigurationProperties();for(const r of Object.keys(s))l.push([r,s[r].scope]);return l.push(["launch",4]),l.push(["task",4]),l}e.getScopes=h}),define(X[105],J([0,1,25,3,49,2,33,50,13,7,18,60,44]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class f{constructor(r={},n=[],i=[]){this._contents=r,this._keys=n,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,C.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,n){const i=this.getContentsForOverrideIdentifer(n);return i?r?(0,C.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const n=[];for(const i of this.overrides)i.identifiers.includes(r)&&n.push(...i.keys);return E.distinct(n)}getAllOverrideIdentifiers(){const r=[];for(const n of this.overrides)r.push(...n.identifiers);return E.distinct(r)}override(r){let n=this.overrideConfigurations.get(r);return n||(n=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,n)),n}merge(...r){const n=b.deepClone(this.contents),i=b.deepClone(this.overrides),o=[...this.keys];for(const a of r)if(!a.isEmpty()){this.mergeContents(n,a.contents);for(const c of a.overrides){const[v]=i.filter(k=>E.equals(k.identifiers,c.identifiers));v?(this.mergeContents(v.contents,c.contents),v.keys.push(...c.keys),v.keys=E.distinct(v.keys)):i.push(b.deepClone(c))}for(const c of a.keys)o.indexOf(c)===-1&&o.push(c)}return new f(n,o,i)}freeze(){return this.frozen=!0,this}clone(){return new f(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(r){const n=this.getContentsForOverrideIdentifer(r);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const o of E.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[o];const c=n[o];c&&(typeof a=="object"&&typeof c=="object"?(a=b.deepClone(a),this.mergeContents(a,c)):a=c),i[o]=a}return new f(i,this.keys,this.overrides)}mergeContents(r,n){for(const i of Object.keys(n)){if(i in r&&d.isObject(r[i])&&d.isObject(n[i])){this.mergeContents(r[i],n[i]);continue}r[i]=b.deepClone(n[i])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let n=null,i=null;const o=a=>{a&&(i?this.mergeContents(i,a):i=b.deepClone(a))};for(const a of this.overrides)E.equals(a.identifiers,[r])?n=a.contents:a.identifiers.includes(r)&&o(a.contents);return o(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,n){this.addKey(r),(0,C.addToValueTree)(this.contents,r,n,i=>{throw new Error(i)})}removeValue(r){this.removeKey(r)&&(0,C.removeFromValueTree)(this.contents,r)}addKey(r){let n=this.keys.length;for(let i=0;i<n;i++)r.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,r)}removeKey(r){const n=this.keys.indexOf(r);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=f;class u{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new f}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,n){if(!d.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,n)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,n){this._raw=r;const{contents:i,keys:o,overrides:a,restricted:c}=this.doParseRaw(r,n);this._configurationModel=new f(i,o,a),this._restrictedConfigurations=c||[]}doParseContent(r){let n={},i=null,o=[];const a=[],c=[];function v(L){Array.isArray(o)?o.push(L):i!==null&&(o[i]=L)}const k={onObjectBegin:()=>{const L={};v(L),a.push(o),o=L,i=null},onObjectProperty:L=>{i=L},onObjectEnd:()=>{o=a.pop()},onArrayBegin:()=>{const L=[];v(L),a.push(o),o=L,i=null},onArrayEnd:()=>{o=a.pop()},onLiteralValue:v,onError:(L,O,F)=>{c.push({error:L,offset:O,length:F})}};if(r)try{D.visit(r,k),n=o[0]||{}}catch(L){console.error(`Error while parsing settings file ${this._name}: ${L}`),this._parseErrors=[L]}return n}doParseRaw(r,n){const i=S.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,i,!0,n);r=o.raw;const a=(0,C.toValuesTree)(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),c=Object.keys(r),v=this.toOverrides(r,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:a,keys:c,overrides:v,restricted:o.restricted}}filter(r,n,i,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const a={},c=[];for(const v in r)if(P.OVERRIDE_PROPERTY_REGEX.test(v)&&i){const k=this.filter(r[v],n,!1,o);a[v]=k.raw,c.push(...k.restricted)}else{const k=n[v],L=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&c.push(v),(L===void 0||o.scopes===void 0||o.scopes.includes(L))&&(o.skipRestricted&&k?.restricted||(a[v]=r[v]))}return{raw:a,restricted:c}}toOverrides(r,n){const i=[];for(const o of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(o)){const a={};for(const c in r[o])a[c]=r[o][c];i.push({identifiers:(0,P.overrideIdentifiersFromKey)(o),keys:Object.keys(a),contents:(0,C.toValuesTree)(a,n)})}return i}}e.ConfigurationModelParser=u;class p extends R.Disposable{constructor(r,n,i,o){super();this.userSettingsResource=r,this.scopes=n,this.fileService=o,this._onDidChange=this._register(new t.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new u(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(t.Event.any(t.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource)),t.Event.filter(this.fileService.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&i.isEqual(a.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new f}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=p;class m{constructor(r,n,i,o,a=new f,c=new f,v=new M.ResourceMap,k=new f,L=new M.ResourceMap,O=!0){this._defaultConfiguration=r,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=a,this._workspaceConfiguration=c,this._folderConfigurations=v,this._memoryConfiguration=k,this._memoryConfigurationByResource=L,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new M.ResourceMap,this._userConfiguration=null}getValue(r,n,i){return this.getConsolidatedConfigurationModel(r,n,i).getValue(r)}updateValue(r,n,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new f,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,n===void 0?o.removeValue(r):o.setValue(r,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,n,i){const o=this.getConsolidatedConfigurationModel(r,n,i),a=this.getFolderConfigurationModelForResource(n.resource,i),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,v=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),k=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),L=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),F=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),j=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),ee=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,se=a?n.overrideIdentifier?a.freeze().override(n.overrideIdentifier).getValue(r):a.freeze().getValue(r):void 0,ae=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(r):c.getValue(r),ie=o.getValue(r),ce=E.distinct(o.overrides.map(H=>H.identifiers).flat()).filter(H=>o.getOverrideValue(r,H)!==void 0);return{defaultValue:v,policyValue:k,applicationValue:L,userValue:O,userLocalValue:F,userRemoteValue:j,workspaceValue:ee,workspaceFolderValue:se,memoryValue:ae,value:ie,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,policy:k!==void 0?{value:k}:void 0,application:L!==void 0?{value:L,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userLocal:F!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,userRemote:j!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspace:ee!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,workspaceFolder:se!==void 0?{value:a?.freeze().getValue(r),override:n.overrideIdentifier?a?.freeze().getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,memory:ae!==void 0?{value:c.getValue(r),override:n.overrideIdentifier?c.getOverrideValue(r,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ce.length?ce:void 0}}keys(r){const n=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,n){this._folderConfigurations.set(r,n),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,n){const i=[];if(!n){const{added:o,updated:a,removed:c}=h(this._defaultConfiguration,r);n=[...o,...a,...c]}for(const o of n)for(const a of(0,P.overrideIdentifiersFromKey)(o)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(a),v=r.getKeysForOverrideIdentifier(a),k=[...v.filter(L=>c.indexOf(L)===-1),...c.filter(L=>v.indexOf(L)===-1),...c.filter(L=>!b.equals(this._defaultConfiguration.override(a).getValue(L),r.override(a).getValue(L)))];i.push([a,k])}return this.updateDefaultConfiguration(r),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:n,updated:i,removed:o}=h(this._policyConfiguration,r),a=[...n,...i,...o];return a.length&&this.updatePolicyConfiguration(r),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:n,updated:i,removed:o,overrides:a}=h(this.applicationConfiguration,r),c=[...n,...i,...o];return c.length&&this.updateApplicationConfiguration(r),{keys:c,overrides:a}}compareAndUpdateLocalUserConfiguration(r){const{added:n,updated:i,removed:o,overrides:a}=h(this.localUserConfiguration,r),c=[...n,...i,...o];return c.length&&this.updateLocalUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateRemoteUserConfiguration(r){const{added:n,updated:i,removed:o,overrides:a}=h(this.remoteUserConfiguration,r),c=[...n,...i,...o];return c.length&&this.updateRemoteUserConfiguration(r),{keys:c,overrides:a}}compareAndUpdateWorkspaceConfiguration(r){const{added:n,updated:i,removed:o,overrides:a}=h(this.workspaceConfiguration,r),c=[...n,...i,...o];return c.length&&this.updateWorkspaceConfiguration(r),{keys:c,overrides:a}}compareAndUpdateFolderConfiguration(r,n){const i=this.folderConfigurations.get(r),{added:o,updated:a,removed:c,overrides:v}=h(i,n),k=[...o,...a,...c];return(k.length||!i)&&this.updateFolderConfiguration(r,n),{keys:k,overrides:v}}compareAndDeleteFolderConfiguration(r){const n=this.folderConfigurations.get(r);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:o,removed:a,overrides:c}=h(n,void 0);return{keys:[...i,...o,...a],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,n,i){let o=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&r){const o=n.getFolder(r);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const a=this._memoryConfigurationByResource.get(r);a&&(i=i.merge(a))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let n=this._foldersConsolidatedConfigurations.get(r);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(n=i.merge(o),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(r,n)):n=i}return n}getFolderConfigurationModelForResource(r,n){if(n&&r){const i=n.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,n)=>{const{contents:i,overrides:o,keys:a}=this._folderConfigurations.get(n);return r.push([n,{contents:i,overrides:o,keys:a}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>r.add(n)),this.userConfiguration.freeze().keys.forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>r.add(i))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>r.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(o=>n.add(o))),[...n.values()]}static parse(r){const n=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),a=this.parseConfigurationModel(r.user),c=this.parseConfigurationModel(r.workspace),v=r.folders.reduce((k,L)=>(k.set(w.URI.revive(L[0]),this.parseConfigurationModel(L[1])),k),new M.ResourceMap);return new m(n,i,o,a,new f,c,v,new f,new M.ResourceMap,!1)}static parseConfigurationModel(r){return new f(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=m;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,n=new Map;for(const o of s)o.keys.forEach(a=>r.add(a)),o.overrides.forEach(([a,c])=>{const v=(0,M.getOrSet)(n,a,new Set);c.forEach(k=>v.add(k))});const i=[];return n.forEach((o,a)=>i.push([a,[...o.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=y;class I{constructor(r,n,i,o){this.change=r,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const a=new Set;r.keys.forEach(v=>a.add(v)),r.overrides.forEach(([,v])=>v.forEach(k=>a.add(k))),this.affectedKeys=[...a.values()];const c=new f;this.affectedKeys.forEach(v=>c.setValue(v,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(r,n,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,n,this.currentWorkspace);return!b.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(r,n){let i=(0,C.toValuesTree)({[n]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(r=r[o],!r)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=I;class g extends I{constructor(r,n,i,o){super({keys:r.allKeys(),overrides:[]},void 0,r,n);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=g;function h(s,r){const{added:n,removed:i,updated:o}=l(r,s),a=[],c=s?.getAllOverrideIdentifiers()||[],v=r?.getAllOverrideIdentifiers()||[];if(r){const k=v.filter(L=>!c.includes(L));for(const L of k)a.push([L,r.getKeysForOverrideIdentifier(L)])}if(s){const k=c.filter(L=>!v.includes(L));for(const L of k)a.push([L,s.getKeysForOverrideIdentifier(L)])}if(r&&s){for(const k of c)if(v.includes(k)){const L=l({contents:s.getOverrideValue(void 0,k)||{},keys:s.getKeysForOverrideIdentifier(k)},{contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)});a.push([k,[...L.added,...L.removed,...L.updated]])}}return{added:n,removed:i,updated:o,overrides:a}}function l(s,r){const n=s?r?s.keys.filter(a=>r.keys.indexOf(a)===-1):[...s.keys]:[],i=r?s?r.keys.filter(a=>s.keys.indexOf(a)===-1):[...r.keys]:[],o=[];if(s&&r){for(const a of r.keys)if(s.keys.indexOf(a)!==-1){const c=(0,C.getConfigurationValue)(r.contents,a),v=(0,C.getConfigurationValue)(s.contents,a);b.equals(c,v)||o.push(a)}}return{added:n,removed:i,updated:o}}}),define(X[205],J([0,1,25,3,2,50,13,18,105,60,6,37,44]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class f extends D.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new u(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(S.Registry.as(w.Extensions.Configuration).onDidUpdateConfiguration(({properties:I,defaultsOverrides:g})=>this.onDidUpdateConfiguration(I,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(I,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:I})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=f;class u extends d.ConfigurationModel{constructor(I={}){const g=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),h=Object.keys(g),l=Object.create(null),s=[];for(const r in g){const n=I[r],i=n!==void 0?n:g[r].default;(0,b.addToValueTree)(l,r,i,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(l))w.OVERRIDE_PROPERTY_REGEX.test(r)&&s.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(l[r]),contents:(0,b.toValuesTree)(l[r],n=>console.error(`Conflict in default settings file: ${n}`))});super(l,h,s)}}e.DefaultConfigurationModel=u;class p{constructor(){this.onDidChangeConfiguration=t.Event.None,this.configurationModel=new d.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=p;let m=class extends D.Disposable{constructor(I,g,h){super();this.defaultConfiguration=I,this.policyService=g,this.logService=h,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new d.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(I=>this.onDidChangePolicies(I))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:I})=>this.update(await this.registerPolicyDefinitions(I),!0))),this._configurationModel}async registerPolicyDefinitions(I){const g={},h=[],l=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties();for(const s of I){const r=l[s];if(!r){h.push(s);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}h.push(s),g[r.policy.name]={type:r.type}}}return(0,M.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),h}onDidChangePolicies(I){const g=S.Registry.as(w.Extensions.Configuration).getPolicyConfigurations(),h=(0,E.coalesce)(I.map(l=>g.get(l)));this.update(h,!0)}update(I,g){const h=S.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),l=[],s=this._configurationModel.isEmpty();for(const r of I){const n=h[r]?.policy?.name;if(n){const i=this.policyService.getPolicyValue(n);(s?i!==void 0:!(0,R.equals)(this._configurationModel.getValue(r),i))&&l.push([r,i])}else this._configurationModel.getValue(r)!==void 0&&l.push([r,void 0])}if(l.length){const r=this._configurationModel;this._configurationModel=new d.ConfigurationModel;for(const n of r.keys)this._configurationModel.setValue(n,r.getValue(n));for(const[n,i]of l)i===void 0?this._configurationModel.removeValue(n):this._configurationModel.setValue(n,i);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};m=fe([x(1,P.IPolicyService),x(2,C.ILogService)],m),e.PolicyConfiguration=m}),define(X[206],J([0,1,8,3,2,16,18,105,205,37]),function(B,e,E,t,D,R,M,b,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class C extends D.Disposable{constructor(S,f,u,p){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new t.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new d.DefaultConfiguration),this.policyConfiguration=u instanceof w.NullPolicyService?new d.NullPolicyConfiguration:this._register(new d.PolicyConfiguration(this.defaultConfiguration,u,p)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,R.extUriBiasedIgnorePathCase,f)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:m,properties:y})=>this.onDidDefaultConfigurationChange(m,y))),this._register(this.policyConfiguration.onDidChangeConfiguration(m=>this.onDidPolicyConfigurationChange(m))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[S,f,u]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(S,f,new b.ConfigurationModel,u)}getConfigurationData(){return this.configuration.toData()}getValue(S,f){const u=typeof S=="string"?S:void 0,p=(0,M.isConfigurationOverrides)(S)?S:(0,M.isConfigurationOverrides)(f)?f:{};return this.configuration.getValue(u,p,void 0)}updateValue(S,f,u,p){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const f=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(u,f,2)}onDidDefaultConfigurationChange(S,f){const u=this.configuration.toData(),p=this.configuration.compareAndUpdateDefaultConfiguration(S,f);this.trigger(p,u,7)}onDidPolicyConfigurationChange(S){const f=this.configuration.toData(),u=this.configuration.compareAndUpdatePolicyConfiguration(S);this.trigger(u,f,7)}trigger(S,f,u){const p=new b.ConfigurationChangeEvent(S,{data:f},this.configuration);p.source=u,p.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(p)}getTargetConfiguration(S){switch(S){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=C}),define(X[207],J([0,1,19,5]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,t.createDecorator)("remoteAuthorityResolverService");var D;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(D=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends E.ErrorNoTelemetry{constructor(b,d=D.Unknown,w){super(b);this._message=b,this._code=d,this._detail=w,this.isHandled=d===D.NotAvailable&&w===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype)}static isTemporarilyNotAvailable(b){return b instanceof R&&b._code===D.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof R&&b._code===D.NoResolverFound}static isHandled(b){return b instanceof R&&b.isHandled}}e.RemoteAuthorityResolverError=R}),define(X[71],J([0,1,12]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function t(w){return w.scheme===E.Schemas.vscodeRemote?w.authority:void 0}e.getRemoteAuthority=t;function D(w){if(!w)return;const C=w.indexOf("+");return C<0?w:w.substr(0,C)}e.getRemoteName=D;function R(w){return`/${w.quality??"oss"}-${w.commit??"dev"}`}e.getRemoteServerRootPath=R;function M(w){const{host:C,port:P}=d(w);if(typeof P=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:P}}e.parseAuthorityWithPort=M;function b(w,C){let{host:P,port:S}=d(w);return typeof S=="undefined"&&(S=C),{host:P,port:S}}e.parseAuthorityWithOptionalPort=b;function d(w){const C=w.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const P=w.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const S=w.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:w,port:void 0}}}),define(X[208],J([0,1,8,17,21,19,3,2,27,95,207,71]),function(B,e,E,t,D,R,M,b,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const S=30*1e3;var f;(function($){$[$.Management=1]="Management",$[$.ExtensionHost=2]="ExtensionHost",$[$.Tunnel=3]="Tunnel"})(f=e.ConnectionType||(e.ConnectionType={}));function u($){switch($){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function p($){const Q=new D.CancellationTokenSource;return setTimeout(()=>Q.cancel(),$),Q.token}function m($,Q){if($.isCancellationRequested||Q.isCancellationRequested)return D.CancellationToken.Cancelled;const A=new D.CancellationTokenSource;return $.onCancellationRequested(()=>A.cancel()),Q.onCancellationRequested(()=>A.cancel()),A.token}class y{constructor(Q){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((A,W)=>{this._resolvePromise=A,this._rejectPromise=W}),Q.isCancellationRequested?this._timeout():this._disposables.add(Q.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(Q){this._state==="pending"?this._disposables.add(Q):Q.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const Q=new Error("Time limit reached");return Q.code="ETIMEDOUT",Q.syscall="connect",Q}resolve(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(Q))}reject(Q){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(Q))}}function I($,Q){const A=new y(Q);return A.registerDisposable($.onControlMessage(W=>{const U=JSON.parse(W.toString()),z=q(U);z?A.reject(z):A.resolve(U)})),A.promise}function g($,Q,A,W,U,z,Y,_){const K=new y(_);return Q.connect(A,W,U,z,Y,(Z,ne)=>{K.didTimeout?(Z&&$.error(Z),ne?.dispose()):Z||!ne?K.reject(Z):K.resolve(ne)}),K.promise}function h($,Q){const A=new y(Q);return $.then(W=>{A.didTimeout||A.resolve(W)},W=>{A.didTimeout||A.reject(W)}),A.promise}async function l($,Q,A,W){const U=V($,Q);$.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let z;try{z=await g($.logService,$.socketFactory,$.host,$.port,(0,P.getRemoteServerRootPath)($),`reconnectionToken=${$.reconnectionToken}&reconnection=${$.reconnectionProtocol?"true":"false"}`,`renderer-${u(Q)}-${$.reconnectionToken}`,W)}catch(ne){throw $.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),$.logService.error(ne),ne}$.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let Y,_;$.reconnectionProtocol?($.reconnectionProtocol.beginAcceptReconnection(z,null),Y=$.reconnectionProtocol,_=!1):(Y=new w.PersistentProtocol(z,null),_=!0),$.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const K=await h($.signService.createNewMessage((0,d.generateUuid)()),W),Z={type:"auth",auth:$.connectionToken||"00000000000000000000",data:K.data};Y.sendControl(t.VSBuffer.fromString(JSON.stringify(Z)));try{const ne=await I(Y,m(W,p(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const Re=new Error("Unexpected handshake message");throw Re.code="VSCODE_CONNECTION_ERROR",Re}if($.logService.trace(`${U} 4/6. received SignRequest control message.`),!await h($.signService.validate(K,ne.signedData),W)){const Re=new Error("Refused to connect to unsupported server");throw Re.code="VSCODE_CONNECTION_ERROR",Re}const ge=await h($.signService.sign(ne.data),W),Ee={type:"connectionType",commit:$.commit,signedData:ge,desiredConnectionType:Q};return A&&(Ee.args=A),$.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),Y.sendControl(t.VSBuffer.fromString(JSON.stringify(Ee))),{protocol:Y,ownsProtocol:_}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&($.logService.error(`${U} the handshake timed out. Error:`),$.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&($.logService.error(`${U} received error control message when negotiating connection. Error:`),$.logService.error(ne)),_&&re(Y),ne}}async function s($,Q,A,W){const U=Date.now(),z=V($,Q),{protocol:Y,ownsProtocol:_}=await l($,Q,A,W),K=new y(W);return K.registerDisposable(Y.onControlMessage(Z=>{const ne=JSON.parse(Z.toString()),le=q(ne);le?($.logService.error(`${z} received error control message when negotiating connection. Error:`),$.logService.error(le),_&&re(Y),K.reject(le)):($.reconnectionProtocol?.endAcceptReconnection(),$.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${te(U)}!`),K.resolve({protocol:Y,firstMessage:ne}))})),K.promise}async function r($,Q){const{protocol:A}=await s($,1,void 0,Q);return{protocol:A}}async function n($,Q,A){const{protocol:W,firstMessage:U}=await s($,2,Q,A),z=U&&U.debugPort;return{protocol:W,debugPort:z}}async function i($,Q,A){const W=Date.now(),U=V($,3),{protocol:z}=await l($,3,Q,A);return $.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${te(W)}!`),z}async function o($,Q,A){const{host:W,port:U,connectionToken:z}=await $.addressProvider.getAddress();return{commit:$.commit,quality:$.quality,host:W,port:U,connectionToken:z,reconnectionToken:Q,reconnectionProtocol:A,socketFactory:$.socketFactory,signService:$.signService,logService:$.logService}}async function a($,Q,A){return v($,async W=>{const{protocol:U}=await r(W,D.CancellationToken.None);return new ce($,Q,A,W.reconnectionToken,U)})}e.connectRemoteAgentManagement=a;async function c($,Q){return v($,async A=>{const{protocol:W,debugPort:U}=await n(A,Q,D.CancellationToken.None);return new H($,Q,A.reconnectionToken,W,U)})}e.connectRemoteAgentExtensionHost=c;async function v($,Q){const A=5;for(let W=1;;W++)try{const U=(0,d.generateUuid)(),z=await o($,U,null);return await Q(z)}catch(U){if(W<A)$.logService.error(`[remote-connection][attempt ${W}] An error occurred in initial connection! Will retry... Error:`),$.logService.error(U);else throw $.logService.error(`[remote-connection][attempt ${W}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),$.logService.error(U),ie.triggerPermanentFailure(0,0,C.RemoteAuthorityResolverError.isHandled(U)),U}}async function k($,Q,A){const W=await o($,(0,d.generateUuid)(),null);return await i(W,{host:Q,port:A},D.CancellationToken.None)}e.connectRemoteAgentTunnel=k;function L($){return(0,E.createCancelablePromise)(Q=>new Promise((A,W)=>{const U=setTimeout(A,$*1e3);Q.onCancellationRequested(()=>{clearTimeout(U),A()})}))}var O;(function($){$[$.ConnectionLost=0]="ConnectionLost",$[$.ReconnectionWait=1]="ReconnectionWait",$[$.ReconnectionRunning=2]="ReconnectionRunning",$[$.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",$[$.ConnectionGain=4]="ConnectionGain"})(O=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class F{constructor(Q,A){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.type=0}}e.ConnectionLostEvent=F;class j{constructor(Q,A,W,U){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.durationSeconds=W,this.cancellableTimer=U,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=j;class ee{constructor(Q,A,W){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.attempt=W,this.type=2}}e.ReconnectionRunningEvent=ee;class se{constructor(Q,A,W){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.attempt=W,this.type=4}}e.ConnectionGainEvent=se;class ae{constructor(Q,A,W,U){this.reconnectionToken=Q,this.millisSinceLastIncomingData=A,this.attempt=W,this.handled=U,this.type=3}}e.ReconnectionPermanentFailureEvent=ae;class ie extends b.Disposable{constructor(Q,A,W,U,z){super();this._connectionType=Q,this._options=A,this.reconnectionToken=W,this.protocol=U,this._reconnectionFailureIsFatal=z,this._onDidStateChange=this._register(new M.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new se(this.reconnectionToken,0,0)),this._register(U.onSocketClose(Y=>{const _=N(this._connectionType,this.reconnectionToken,!0);Y?Y.type===0?(this._options.logService.info(`${_} received socket close event (hadError: ${Y.hadError}).`),Y.error&&this._options.logService.error(Y.error)):(this._options.logService.info(`${_} received socket close event (wasClean: ${Y.wasClean}, code: ${Y.code}, reason: ${Y.reason}).`),Y.event&&this._options.logService.error(Y.event)):this._options.logService.info(`${_} received socket close event.`),this._beginReconnecting()})),this._register(U.onSocketTimeout(()=>{const Y=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Y} received socket timeout event.`),this._beginReconnecting()})),ie._instances.push(this),this._register((0,b.toDisposable)(()=>{const Y=ie._instances.indexOf(this);Y>=0&&ie._instances.splice(Y,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(ie._permanentFailureMillisSinceLastIncomingData,ie._permanentFailureAttempt,ie._permanentFailureHandled)}static triggerPermanentFailure(Q,A,W){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=Q,this._permanentFailureAttempt=A,this._permanentFailureHandled=W,this._instances.forEach(U=>U._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(Q=>Q._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(Q=>Q._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||ie._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const Q=N(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${Q} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const A=[0,5,5,10,10,10,10,10,30];let W=-1;do{W++;const U=W<A.length?A[W]:A[A.length-1];try{if(U>0){const Y=L(U);this._onDidStateChange.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,Y)),this._options.logService.info(`${Q} waiting for ${U} seconds before reconnecting...`);try{await Y}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${Q} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new ee(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1)),this._options.logService.info(`${Q} resolving connection...`);const z=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${Q} connecting to ${z.host}:${z.port}...`),await this._reconnect(z,p(S)),this._options.logService.info(`${Q} reconnected!`),this._onDidStateChange.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),W+1));break}catch(z){if(z.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${Q} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(W>360){this._options.logService.error(`${Q} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}if(C.RemoteAuthorityResolverError.isTemporarilyNotAvailable(z)){this._options.logService.info(`${Q} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((z.code==="ETIMEDOUT"||z.code==="ENETUNREACH"||z.code==="ECONNREFUSED"||z.code==="ECONNRESET")&&z.syscall==="connect"){this._options.logService.info(`${Q} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if((0,R.isCancellationError)(z)){this._options.logService.info(`${Q} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(z);continue}if(z instanceof C.RemoteAuthorityResolverError){this._options.logService.error(`${Q} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,C.RemoteAuthorityResolverError.isHandled(z));break}this._options.logService.error(`${Q} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(z),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),W+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(Q,A,W){this._reconnectionFailureIsFatal?ie.triggerPermanentFailure(Q,A,W):this._gotoPermanentFailure(Q,A,W)}_gotoPermanentFailure(Q,A,W){this._onDidStateChange.fire(new ae(this.reconnectionToken,Q,A,W)),re(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=ie,ie._permanentFailure=!1,ie._permanentFailureMillisSinceLastIncomingData=0,ie._permanentFailureAttempt=0,ie._permanentFailureHandled=!1,ie._instances=[];class ce extends ie{constructor(Q,A,W,U,z){super(1,Q,U,z,!0);this.client=this._register(new w.Client(z,{remoteAuthority:A,clientId:W},Q.ipcLogger))}async _reconnect(Q,A){await r(Q,A)}}e.ManagementPersistentConnection=ce;class H extends ie{constructor(Q,A,W,U,z){super(2,Q,W,U,!1);this._startArguments=A,this.debugPort=z}async _reconnect(Q,A){await n(Q,this._startArguments,A)}}e.ExtensionHostPersistentConnection=H;function re($){try{$.acceptDisconnect();const Q=$.getSocket();$.dispose(),Q.dispose()}catch(Q){(0,R.onUnexpectedError)(Q)}}function q($){if($&&$.type==="error"){const Q=new Error(`Connection error: ${$.reason}`);return Q.code="VSCODE_CONNECTION_ERROR",Q}return null}function T($,Q){for(;$.length<Q;)$+=" ";return $}function N($,Q,A){return`[remote-connection][${T(u($),13)}][${Q.substr(0,5)}\u2026][${A?"reconnect":"initial"}]`}function V($,Q){return`${N(Q,$.reconnectionToken,!!$.reconnectionProtocol)}[${$.host}:${$.port}]`}function te($){return`${Date.now()-$} ms`}}),define(X[209],J([0,1,76,81]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,R,M,b,d,w){const C=S=>w(S,void 0),P=E.createConnection({host:D,port:R},()=>{P.removeListener("error",C);const S=Buffer.alloc(16);for(let m=0;m<16;m++)S[m]=Math.round(Math.random()*256);const f=S.toString("base64"),u=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${R}${M}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];P.write(u.join(`\r
`)+`\r
\r
`);const p=m=>{m.toString().indexOf(`\r
\r
`)>=0&&(P.off("data",p),w(void 0,new t.NodeSocket(P,d)))};P.on("data",p)});P.setNoDelay(!0),P.once("error",C)}}}),define(X[53],J([0,1,17,161,60,5,44]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,R.createDecorator)("requestService");function b(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=b;function d(p){return p.res.statusCode===204}async function w(p){return d(p)?null:(await(0,E.streamToBuffer)(p.stream)).toString()}e.asText=w;async function C(p){if(!b(p))throw new Error("Server returned "+p.res.statusCode);return w(p)}e.asTextOrError=C;async function P(p){if(!b(p))throw new Error("Server returned "+p.res.statusCode);if(d(p))return null;const y=(await(0,E.streamToBuffer)(p.stream)).toString();try{return JSON.parse(y)}catch(I){throw I.message+=`:
`+y,I}}e.asJson=P;function S(p){u(p)}e.updateProxyConfigurationsScope=S;let f;function u(p){const m=M.Registry.as(D.Extensions.Configuration),y=f;f={id:"http",order:15,title:(0,t.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,t.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,t.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,t.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,t.localize)(4,null),(0,t.localize)(5,null),(0,t.localize)(6,null),(0,t.localize)(7,null)],default:"override",description:(0,t.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,t.localize)(9,null),restricted:!0}}},m.updateConfigurations({add:[f],remove:y?[y]:[]})}u(2)}),define(X[210],J([0,1,17,21]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class D{constructor(b){this.service=b}listen(b,d){throw new Error("Invalid listen")}call(b,d,w,C=t.CancellationToken.None){switch(d){case"request":return this.service.request(w[0],C).then(async({res:P,stream:S})=>{const f=await(0,E.streamToBuffer)(S);return[{statusCode:P.statusCode,headers:P.headers},f]});case"resolveProxy":return this.service.resolveProxy(w[0])}throw new Error("Invalid call")}}e.RequestChannel=D;class R{constructor(b){this.channel=b}async request(b,d){const[w,C]=await this.channel.call("request",[b],d);return{res:w,stream:(0,E.bufferToStream)(C)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=R}),define(X[211],J([0,1,212,13]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(M,b){return M.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:M.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function R(M,b,d={}){const w=(0,E.parse)(M),C=d.proxyUrl||D(w,b);if(!C)return null;const P=(0,E.parse)(C);if(!/^https?:$/.test(P.protocol||""))return null;const S={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,t.isBoolean)(d.strictSSL)?d.strictSSL:!0};return w.protocol==="http:"?new(await new Promise((f,u)=>{B(["http-proxy-agent"],f,u)}))(S):new(await new Promise((f,u)=>{B(["https-proxy-agent"],f,u)}))(S)}e.getProxyAgent=R}),define(X[106],J([0,1,42,9,162,21,41,19,4,27,144,57,8]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const f=1e4;let u;async function p(y,I,g){return I["force-disable-user-env"]?(y.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(y.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(g)&&!I["force-user-env"]?(y.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(g)?y.trace("resolveShellEnv(): running (--force-user-env)"):y.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=S.Promises.withAsyncBody(async(h,l)=>{const s=new R.CancellationTokenSource,r=setTimeout(()=>{s.dispose(!0),l(new Error((0,D.localize)(0,null)))},f);try{h(await m(y,s.token))}catch(n){!(0,b.isCancellationError)(n)&&!s.token.isCancellationRequested?l(new Error((0,D.localize)(1,null,(0,M.toErrorMessage)(n)))):h({})}finally{clearTimeout(r),s.dispose()}})),u)}e.getResolvedShellEnv=p;async function m(y,I){const g=process.env.ELECTRON_RUN_AS_NODE;y.trace("getUnixShellEnvironment#runAsNode",g);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;y.trace("getUnixShellEnvironment#noAttach",h);const l=(0,w.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(l+"(.*)"+l),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};y.trace("getUnixShellEnvironment#env",r);const n=await(0,C.getSystemShell)(d.OS,r);return y.trace("getUnixShellEnvironment#shell",n),new Promise((i,o)=>{if(I.isCancellationRequested)return o((0,b.canceled)());const a=(0,t.basename)(n);let c,v;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(a)?(c=`& '${process.execPath}' ${k} -p '''${l}'' + JSON.stringify(process.env) + ''${l}'''`,v=["-Login","-Command"]):(c=`'${process.execPath}' ${k} -p '"${l}" + JSON.stringify(process.env) + "${l}"'`,a==="tcsh"?v=["-ic"]:v=["-ilc"]),y.trace("getUnixShellEnvironment#spawn",JSON.stringify(v),c);const L=(0,E.spawn)(n,[...v,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});I.onCancellationRequested(()=>(L.kill(),o((0,b.canceled)()))),L.on("error",j=>{y.error("getUnixShellEnvironment#errorChildProcess",(0,M.toErrorMessage)(j)),o(j)});const O=[];L.stdout.on("data",j=>O.push(j));const F=[];L.stderr.on("data",j=>F.push(j)),L.on("close",(j,ee)=>{const se=Buffer.concat(O).toString("utf8");y.trace("getUnixShellEnvironment#raw",se);const ae=Buffer.concat(F).toString("utf8");if(ae.trim()&&y.trace("getUnixShellEnvironment#stderr",ae),j||ee)return o(new Error((0,D.localize)(2,null,j,ee)));const ie=s.exec(se),ce=ie?ie[1]:"{}";try{const H=JSON.parse(ce);g?H.ELECTRON_RUN_AS_NODE=g:delete H.ELECTRON_RUN_AS_NODE,h?H.ELECTRON_NO_ATTACH_CONSOLE=h:delete H.ELECTRON_NO_ATTACH_CONSOLE,delete H.XDG_RUNTIME_DIR,y.trace("getUnixShellEnvironment#result",H),i(H)}catch(H){y.error("getUnixShellEnvironment#errorCaught",(0,M.toErrorMessage)(H)),o(H)}})})}}),define(X[86],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(X[213],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.validators=new Map}vsda(){return new Promise((D,R)=>B(["vsda"],D,R))}async createNewMessage(D){try{const R=await this.vsda(),M=new R.validator;if(M){const b=String(E._nextId++);return this.validators.set(b,M),{id:b,data:M.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,R){if(!D.id)return!0;const M=this.validators.get(D.id);if(!M)return!1;this.validators.delete(D.id);try{return M.validate(R)==="ok"}catch{return!1}}async sign(D){try{const R=await this.vsda(),M=new R.signer;if(M)return M.sign(D)}catch{}return D}}e.SignService=E,E._nextId=1}),define(X[45],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,E.createDecorator)("stateMainService")}),define(X[22],J([0,1,14,38,8,3,2,4,36,13,5,6,45]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,C.createDecorator)("lifecycleMainService");var f;(function(m){m[m.QUIT=1]="QUIT",m[m.KILL=2]="KILL"})(f=e.ShutdownReason||(e.ShutdownReason={}));var u;(function(m){m[m.Starting=1]="Starting",m[m.Ready=2]="Ready",m[m.AfterWindowOpen=3]="AfterWindowOpen"})(u=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let p=class yt extends M.Disposable{constructor(y,I){super();this.logService=y,this.stateMainService=I,this._onBeforeShutdown=this._register(new R.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new R.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new R.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new R.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.mapWindowIdToPendingUnload=new Map,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(yt.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(yt.QUIT_AND_RESTART_KEY)}registerListeners(){const y=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),b.isMacintosh&&this.windowCounter===0&&this.fireOnWillShutdown(1))};E.app.addListener("before-quit",y);const I=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!b.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",I),E.app.once("will-quit",g=>{this.logService.trace("Lifecycle#app.on(will-quit)"),g.preventDefault(),this.fireOnWillShutdown(1).finally(()=>{this.resolvePendingQuitPromise(!1),E.app.removeListener("before-quit",y),E.app.removeListener("window-all-closed",I),E.app.quit()})})}fireOnWillShutdown(y){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const I=[];return this._onWillShutdown.fire({reason:y,join(g){I.push(g)}}),this.pendingWillShutdownPromise=(async()=>{try{await D.Promises.settled(I)}catch(g){this.logService.error(g)}try{await this.stateMainService.close()}catch(g){this.logService.error(g)}})(),this.pendingWillShutdownPromise}set phase(y){if(y<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===y)return;this.logService.trace(`lifecycle (main): phase changed (value: ${y})`),this._phase=y;const I=this.phaseWhen.get(this._phase);I&&(I.open(),this.phaseWhen.delete(this._phase))}async when(y){if(y<=this._phase)return;let I=this.phaseWhen.get(y);I||(I=new D.Barrier,this.phaseWhen.set(y,I)),await I.wait()}registerWindow(y){const I=new M.DisposableStore;this.windowCounter++,I.add(y.onWillLoad(h=>this._onWillLoadWindow.fire({window:y,workspace:h.workspace,reason:h.reason})));const g=(0,w.assertIsDefined)(y.win);g.on("close",h=>{const l=y.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${y.id}`),h.preventDefault(),this.unload(y,1).then(s=>{if(s){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(y),y.close()})}),g.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${y.id}`),this.windowCounter--,I.dispose(),this.windowCounter===0&&(!b.isMacintosh||this._quitRequested)&&this.fireOnWillShutdown(1)})}async reload(y,I){await this.unload(y,3)||y.reload(I)}unload(y,I){const g=this.mapWindowIdToPendingUnload.get(y.id);if(g)return g;const h=this.doUnload(y,I).finally(()=>{this.mapWindowIdToPendingUnload.delete(y.id)});return this.mapWindowIdToPendingUnload.set(y.id,h),h}async doUnload(y,I){if(!y.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${y.id}`);const g=this._quitRequested?2:I,h=await this.onBeforeUnloadWindowInRenderer(y,g);return h?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${y.id})`),this.handleWindowUnloadVeto(h)):(await this.onWillUnloadWindowInRenderer(y,g),!1)}handleWindowUnloadVeto(y){return y?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(y){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(y),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(y,I){return new Promise(g=>{const h=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${h}`,s=`vscode:cancel${h}`;t.validatedIpcMain.once(l,()=>{g(!1)}),t.validatedIpcMain.once(s,()=>{g(!0)}),y.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:s,reason:I})})}onWillUnloadWindowInRenderer(y,I){return new Promise(g=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;t.validatedIpcMain.once(l,()=>g()),y.send("vscode:onWillUnload",{replyChannel:l,reason:I})})}quit(y){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${y}`),y&&this.stateMainService.setItem(yt.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(I=>{this.pendingQuitPromiseResolve=I,this.logService.trace("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.pendingQuitPromise)}async relaunch(y){this.logService.trace("Lifecycle#relaunch()");const I=process.argv.slice(1);if(y?.addArgs&&I.push(...y.addArgs),y?.removeArgs)for(const l of y.removeArgs){const s=I.indexOf(l);s>=0&&I.splice(s,1)}const g=()=>{try{if(b.isWindows){const l=(0,d.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:I})};E.app.once("quit",g),await this.quit(!0)&&E.app.removeListener("quit",g)}async kill(y){this.logService.trace("Lifecycle#kill()"),await this.fireOnWillShutdown(2),await Promise.race([(0,D.timeout)(1e3),(async()=>{for(const I of E.BrowserWindow.getAllWindows())if(I&&!I.isDestroyed()){let g;I.webContents&&!I.webContents.isDestroyed()?g=new Promise(h=>I.once("closed",h)):g=Promise.resolve(),I.destroy(),await g}})()]),E.app.exit(y)}};p.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",p=fe([x(0,P.ILogService),x(1,S.IStateMainService)],p),e.LifecycleMainService=p}),define(X[214],J([0,1,4,3,2,5,22]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,R.createDecorator)("keyboardLayoutMainService");let b=class extends D.Disposable{constructor(C){super();this._onDidChangeKeyboardLayout=this._register(new t.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,C.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const C=await new Promise((P,S)=>{B(["native-keymap"],P,S)});this._keyboardLayoutData=d(C),E.isCI||C.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=d(C),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};b=fe([x(0,M.ILifecycleMainService)],b),e.KeyboardLayoutMainService=b;function d(w){const C=w.getKeyMap(),P=w.getCurrentKeyboardLayout();return{keyboardMapping:C,keyboardLayoutInfo:P}}}),define(X[215],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=void 0,e.IStateService=(0,E.createDecorator)("stateService")}),define(X[216],J([0,1,8,17,13,39,15,6]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.FileStorage=void 0;class d{constructor(P,S,f){this.storagePath=P,this.logService=S,this.fileService=f,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new E.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}}getItem(P,S){const f=this.storage[P];return(0,D.isUndefinedOrNull)(f)?S:f}setItem(P,S){this.setItems([{key:P,data:S}])}setItems(P){let S=!1;for(const{key:f,data:u}of P)this.storage[f]!==u&&((0,D.isUndefinedOrNull)(u)?(0,D.isUndefined)(this.storage[f])||(this.storage[f]=void 0,S=!0):(this.storage[f]=u,S=!0));S&&this.save()}removeItem(P){(0,D.isUndefined)(this.storage[P])||(this.storage[P]=void 0,this.save())}async save(P){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),P)}async doSave(){if(!this.initializing)return;await this.initializing;const P=JSON.stringify(this.storage,null,4);if(P!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,t.VSBuffer.fromString(P)),this.lastSavedStorageContents=P}catch(S){this.logService.error(S)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=d;let w=class{constructor(P,S,f){this.fileStorage=new d(P.stateResource,S,f)}async init(){await this.fileStorage.init()}getItem(P,S){return this.fileStorage.getItem(P,S)}};w=fe([x(0,R.IEnvironmentService),x(1,b.ILogService),x(2,M.IFileService)],w),e.StateService=w}),define(X[217],J([0,1,216]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=void 0;class t extends E.StateService{setItem(R,M){this.fileStorage.setItem(R,M)}setItems(R){this.fileStorage.setItems(R)}removeItem(R){this.fileStorage.removeItem(R)}close(){return this.fileStorage.close()}}e.StateMainService=t}),define(X[107],J([0,1,4,36,7,27]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function M(w){if(E.platform===2&&/^penguin(\.|$)/i.test(w))return"chromebook"}async function b(w,C,P,S,f,u,p,m,y,I){const g=Object.create(null);g["common.machineId"]=p,g.sessionID=(0,R.generateUuid)()+Date.now(),g.commitHash=f,g.version=u,g["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,E.PlatformToString)(E.platform),g["common.nodePlatform"]=t.platform,g["common.nodeArch"]=S,g["common.product"]=I||"desktop",m&&(g["common.msftInternal"]=m);let h=0;const l=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-l,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),E.isLinuxSnap&&(g["common.snap"]="true");const s=M(P);s&&(g["common.platformDetail"]=s);try{const r=await w.readFile(D.URI.file(y));g["common.source"]=r.value.toString().slice(0,30)}catch{}return g}e.resolveCommonProperties=b;function d(w){const C=t.env.USERDNSDOMAIN;if(!C)return!1;const P=C.toLowerCase();return w.some(S=>P===S)}e.verifyMicrosoftInternalDomain=d}),define(X[35],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var t;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(t=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(X[218],J([0,1,29,55,8,49,12,9,4,7,80,23,94,83,15,20,35]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const y=new Map;async function I(r,n){const i=`${r}::${n.join(":")}`,o=y.get(i);if(o)return o;const a=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],c=new Map,v=new Map,k=2e4;function L(F,j,ee,se){const ae=j.substring(F.length+1);return D.Promises.withAsyncBody(async ie=>{let ce;try{ce=await P.Promises.readdir(j,{withFileTypes:!0})}catch{ie();return}if(se.count>=k){se.count+=ce.length,se.maxReached=!0,ie();return}let H=ce.length;if(H===0){ie();return}let re=ce;se.count+ce.length>k&&(se.maxReached=!0,H=k-se.count,re=ce.slice(0,H)),se.count+=ce.length;for(const q of re)if(q.isDirectory()){if(ee.includes(q.name)||await L(F,(0,b.join)(j,q.name),ee,se),--H==0){ie();return}}else{const T=q.name.lastIndexOf(".");if(T>=0){const N=q.name.substring(T+1);N&&c.set(N,(c.get(N)??0)+1)}for(const N of a)N.relativePathPattern?.test(ae)!==!1&&N.filePattern.test(q.name)&&v.set(N.tag,(v.get(N.tag)??0)+1);if(--H==0){ie();return}}})}const O=D.Promises.withAsyncBody(async F=>{const j={count:0,maxReached:!1};await L(r,r,n,j);const ee=await l(r);F({configFiles:g(v),fileTypes:g(c),fileCount:j.count,maxFilesReached:j.maxReached,launchConfigFiles:ee})});return y.set(i,O),O}e.collectWorkspaceStats=I;function g(r){return[...t.Iterable.map(r.entries(),([n,i])=>({name:n,count:i}))].sort((n,i)=>i.count-n.count)}function h(){const r={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(C.virtualMachineHint.value()*100)}%`},n=E.cpus();return n&&n.length>0&&(r.cpus=`${n[0].model} (${n.length} x ${n[0].speed})`),r}e.getMachineInfo=h;async function l(r){try{const n=new Map,i=(0,b.join)(r,".vscode","launch.json"),o=await P.Promises.readFile(i),a=[],c=(0,R.parse)(o.toString(),a);if(a.length)return console.log(`Unable to parse ${i}`),[];if((0,R.getNodeType)(c)==="object"&&c.configurations)for(const v of c.configurations){const k=v.type;k&&(n.has(k)?n.set(k,n.get(k)+1):n.set(k,1))}return g(n)}catch{return[]}}e.collectLaunchConfigs=l;let s=class{constructor(n,i){this.telemetryService=n,this.productService=i}formatMachineInfo(n){const i=[];return i.push(`OS Version:       ${n.os}`),i.push(`CPUs:             ${n.cpus}`),i.push(`Memory (System):  ${n.memory}`),i.push(`VM:               ${n.vmHint}`),i.join(`
`)}formatEnvironment(n){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const o=E.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/u.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/u.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||i.push(`Load (avg):       ${E.loadavg().map(a=>Math.round(a)).join(", ")}`),i.push(`VM:               ${Math.round(C.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${n.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${n.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(n.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(n,i){return Promise.all([(0,S.listProcesses)(n.mainPID),this.formatWorkspaceMetadata(n)]).then(async o=>{let[a,c]=o,v=this.formatProcessList(n,a);return i.forEach(k=>{if((0,f.isRemoteDiagnosticError)(k))v+=`
${k.errorMessage}`,c+=`
${k.errorMessage}`;else if(v+=`

Remote: ${k.hostName}`,k.processes&&(v+=`
${this.formatProcessList(n,k.processes)}`),k.workspaceMetadata){c+=`
|  Remote: ${k.hostName}`;for(const L of Object.keys(k.workspaceMetadata)){const O=k.workspaceMetadata[L];let F=`${O.fileCount} files`;O.maxFilesReached&&(F=`more than ${F}`),c+=`|    Folder (${L}): ${F}`,c+=this.formatWorkspaceStats(O)}}}),{processInfo:v,workspaceInfo:c}})}async getSystemInfo(n,i){const{memory:o,vmHint:a,os:c,cpus:v}=h(),k={os:c,memory:o,cpus:v,vmHint:a,processArgs:`${n.mainArguments.join(" ")}`,gpuStatus:n.gpuFeatureStatus,screenReader:`${n.screenReader?"yes":"no"}`,remoteData:i};return d.isWindows||(k.load=`${E.loadavg().map(L=>Math.round(L)).join(", ")}`),d.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(n,i){const o=[];return(0,S.listProcesses)(n.mainPID).then(async a=>(o.push(""),o.push(this.formatEnvironment(n)),o.push(""),o.push(this.formatProcessList(n,a)),n.windows.some(c=>c.folderURIs&&c.folderURIs.length>0&&!c.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(n))),i.forEach(c=>{if((0,f.isRemoteDiagnosticError)(c))o.push(`
${c.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${c.hostName}`),o.push(this.formatMachineInfo(c.machineInfo)),c.processes&&o.push(this.formatProcessList(n,c.processes)),c.workspaceMetadata)for(const v of Object.keys(c.workspaceMetadata)){const k=c.workspaceMetadata[v];let L=`${k.fileCount} files`;k.maxFilesReached&&(L=`more than ${L}`),o.push(`Folder (${v}): ${L}`),o.push(this.formatWorkspaceStats(k))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(n){const i=[],o=60;let a=0;const c=(O,F)=>{const j=` ${O}(${F})`;a+j.length>o?(i.push(v),v="|                 ",a=v.length):a+=j.length,v+=j};let v="|      File types:";const k=10,L=n.fileTypes.length>k?k:n.fileTypes.length;for(let O=0;O<L;O++){const F=n.fileTypes[O];c(F.name,F.count)}if(i.push(v),n.configFiles.length>=0&&(v="|      Conf files:",a=0,n.configFiles.forEach(O=>{c(O.name,O.count)}),i.push(v)),n.launchConfigFiles.length>0){let O="|      Launch Configs:";n.launchConfigFiles.forEach(F=>{O+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),i.push(O)}return i.join(`
`)}expandGPUFeatures(n){const i=Math.max(...Object.keys(n).map(o=>o.length));return Object.keys(n).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${n[o]}`).join(`
                  `)}formatWorkspaceMetadata(n){const i=[],o=[];return n.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(i.push(`|  Window (${a.title})`),a.folderURIs.forEach(c=>{const v=w.URI.revive(c);if(v.scheme===M.Schemas.file){const k=v.fsPath;o.push(I(k,["node_modules",".git"]).then(L=>{let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),i.push(`|    Folder (${(0,b.basename)(k)}): ${O}`),i.push(this.formatWorkspaceStats(L))}).catch(L=>{i.push(`|      Error: Unable to collect workspace stats for folder ${k} (${L.toString()})`)}))}else i.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(a=>i.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(n,i){const o=new Map;n.windows.forEach(c=>o.set(c.pid,c.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(n.mainPID,o,a,i,0),a.join(`
`)}formatProcessItem(n,i,o,a,c){const v=c===0;let k;v?k=a.pid===n?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(c)} ${a.name}`,a.name==="window"&&(k=`${k} (${i.get(a.pid)})`));const L=process.platform==="win32"?a.mem:E.totalmem()*(a.mem/100);o.push(`${a.load.toFixed(0).padStart(5," ")}	${(L/u.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(a.children)&&a.children.forEach(O=>this.formatProcessItem(n,i,o,O,c+1))}async getWorkspaceFileExtensions(n){const i=new Set;for(const{uri:o}of n.folders){const a=w.URI.revive(o);if(a.scheme!==M.Schemas.file)continue;const c=a.fsPath;try{(await I(c,["node_modules",".git"])).fileTypes.forEach(k=>i.add(k.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(n){for(const{uri:i}of n.folders){const o=w.URI.revive(i);if(o.scheme!==M.Schemas.file)continue;const a=o.fsPath;try{const c=await I(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":n.telemetryId,rendererSessionId:n.rendererSessionId}),c.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:n.rendererSessionId,type:v.name,count:v.count})}),c.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:n.rendererSessionId,type:v.name,count:v.count})}),c.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:n.rendererSessionId,type:v.name,count:v.count})})}catch{}}}};s=fe([x(0,m.ITelemetryService),x(1,p.IProductService)],s),e.DiagnosticsService=s}),define(X[219],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(R){this.appenders=R}listen(R,M){throw new Error(`Event not found: ${M}`)}call(R,M,{eventName:b,data:d}){return this.appenders.forEach(w=>w.log(b,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class t{constructor(R){this.channel=R}log(R,M){return this.channel.call("log",{eventName:R,data:M}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=t}),define(X[72],J([0,1,50,91,13,18,107,35]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class d{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,t.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=d,e.NullTelemetryService=new d;class w{async publicLog(s,r,n){}async publicLogError(s,r,n){}}e.NullEndpointTelemetryService=w,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(l,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&l.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(r.source),configurationKeys:y(r.sourceConfig)})})}e.configurationTelemetry=C;function P(l,s){return!(s.disableTelemetry||!l.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=P;function S(l){const s=l.getValue(b.TELEMETRY_SETTING_ID),r=l.getValue("telemetry.enableCrashReporter");if(l.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=S;function f(l){const s={},r={},n={};m(l,n);for(let i in n){i=i.length>150?i.substr(i.length-149):i;const o=n[i];typeof o=="number"?r[i]=o:typeof o=="boolean"?r[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),s[i]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(s[i]=o)}return{properties:s,measurements:r}}e.validateTelemetryData=f;const u=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function p(l){if(!l)return"none";for(const s of u)if(l.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=p;function m(l,s,r=0,n){if(!!l)for(const i of Object.getOwnPropertyNames(l)){const o=l[i],a=n?n+i:i;Array.isArray(o)?s[a]=(0,E.safeStringify)(o):o instanceof Date?s[a]=o.toISOString():(0,D.isObject)(o)?r<2?m(o,s,r+1,a+"."):s[a]=(0,E.safeStringify)(o):s[a]=o}}function y(l){if(!l)return[];const s=[];return I(s,"",l),s}function I(l,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(n=>I(l,s?`${s}.${n}`:n,r[n])):l.push(s)}function g(l,s){const r=l.msftInternalDomains||[],n=s.getValue("telemetry.internalTesting");return(0,M.verifyMicrosoftInternalDomain)(r)||n}e.isInternalTelemetry=g;function h(l){return[l.appRoot,l.extensionsPath,l.userHome.fsPath,l.tmpDir.fsPath,l.userDataPath]}e.getPiiPathsFromEnvironment=h}),define(X[220],J([0,1,180,72]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function D(R,M,b,d,w,C,P){const S={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${M.nameShort})`},f=await(0,E.getServiceMachineId)(b,w,C),{sessionId:u}=await P.getTelemetryInfo();return(0,t.supportsTelemetry)(M,b)&&(0,t.getTelemetryLevel)(d)===3&&(S["X-Market-User-Id"]=f,S["VSCode-SessionId"]=u),S}e.resolveMarketplaceHeaders=D}),define(X[221],J([0,1,2,50,91,4,31,163,18,60,52,20,44,35,72]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=class{constructor(I,g,h){this._configurationService=g,this._productService=h,this._experimentProperties={},this.telemetryLevel=new D.MutableObservableValue(3),this._disposables=new E.DisposableStore,this._cleanupPatterns=[],this._appenders=I.appenders,this._commonProperties=I.commonProperties||Promise.resolve({}),this._piiPaths=I.piiPaths||[],this._sendErrorTelemetry=!!I.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const l of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(l),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(I,g){this._experimentProperties[I]=g}_updateTelemetryLevel(){let I=(0,u.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const h=g.usage?3:g.error?2:0;I=Math.min(I,h)}this.telemetryLevel.value=I}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const I=await this._commonProperties,g=I.sessionID,h=I["common.machineId"],l=I["common.firstSessionDate"],s=I["common.msftInternal"];return{sessionId:g,machineId:h,firstSessionDate:l,msftInternal:s}}dispose(){this._disposables.dispose()}_log(I,g,h,l){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(s=>{h=(0,t.mixin)(h,s),h=(0,t.mixin)(h,this._experimentProperties),h=(0,t.cloneAndChange)(h,r=>{if(typeof r=="string")return this._cleanupInfo(r,l)}),this._appenders.forEach(r=>r.log(I,h))},s=>{console.error(s)})}publicLog(I,g,h){return this._log(I,3,g,h)}publicLog2(I,g,h){return this.publicLog(I,g,h)}publicLogError(I,g){return this._sendErrorTelemetry?this._log(I,2,g,!0):Promise.resolve(void 0)}publicLogError2(I,g){return this.publicLogError(I,g)}_anonymizeFilePaths(I){let g=I;const h=[];for(const n of this._cleanupPatterns)for(;;){const i=n.exec(I);if(!i)break;h.push([i.index,n.lastIndex])}const l=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(g="";;){const n=s.exec(I);if(!n)break;!l.test(n[0])&&h.every(([i,o])=>n.index<i||n.index>=o)&&(g+=I.substring(r,n.index)+"<REDACTED: user-file-path>",r=s.lastIndex)}return r<I.length&&(g+=I.substr(r)),g}_removePropertiesWithPossibleUserInfo(I){if(!I)return I;const g=I.toLowerCase(),h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const l of h)if(l.regex.test(g))return`<REDACTED: ${l.label}>`;return I}_cleanupInfo(I,g){let h=I;g&&(h=this._anonymizeFilePaths(h));for(const l of this._cleanupPatterns)h=h.replace(l,"");return h=this._removePropertiesWithPossibleUserInfo(h),h}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=fe([x(1,d.IConfigurationService),x(2,P.IProductService)],p),e.TelemetryService=p;function m(){const y=(0,b.localize)(0,null,C.default.nameLong),I=C.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=R.isWeb?"":(0,b.localize)(3,null),h=(0,b.localize)(4,null),l=(0,b.localize)(5,null),s=(0,b.localize)(6,null),r=(0,b.localize)(7,null),n=`
|       | ${h} | ${l} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,b.localize)(8,null);return`
${y} ${I} ${g}

&nbsp;

${r}
${n}

&nbsp;

${i}
`}S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[f.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:m(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.Registry.as(w.Extensions.Configuration).registerConfiguration({id:f.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[f.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,b.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,b.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${f.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(X[222],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var E;(function(R){R.DARK="dark",R.LIGHT="light",R.HIGH_CONTRAST_DARK="hcDark",R.HIGH_CONTRAST_LIGHT="hcLight"})(E=e.ColorScheme||(e.ColorScheme={}));function t(R){return R===E.HIGH_CONTRAST_DARK||R===E.HIGH_CONTRAST_LIGHT}e.isHighContrast=t;function D(R){return R===E.DARK||R===E.HIGH_CONTRAST_DARK}e.isDark=D}),define(X[223],J([0,1,117,3,2,5,44,222]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,R.createDecorator)("themeService");var d;(function(m){function y(I){return I&&typeof I=="object"&&typeof I.id=="string"}m.isThemeColor=y})(d=e.ThemeColor||(e.ThemeColor={}));function w(m){return{id:m}}e.themeColorFromId=w;var C;(function(m){function y(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||d.isThemeColor(i.color))}m.isThemeIcon=y;const I=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function g(i){const o=I.exec(i);if(!o)return;const[,a]=o;return{id:a}}m.fromString=g;function h(i){return{id:i}}m.fromId=h;function l(i,o){let a=i.id;const c=a.lastIndexOf("~");return c!==-1&&(a=a.substring(0,c)),o&&(a=`${a}~${o}`),{id:a}}m.modify=l;function s(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}m.getModifier=s;function r(i,o){return i.id===o.id&&i.color?.id===o.color?.id}m.isEqual=r;function n(i,o){return{id:i.id,color:o?w(o):void 0}}m.asThemeIcon=n,m.asClassNameArray=E.CSSIcon.asClassNameArray,m.asClassName=E.CSSIcon.asClassName,m.asCSSSelector=E.CSSIcon.asCSSSelector})(C=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=E.Codicon.file,e.FolderThemeIcon=E.Codicon.folder;function P(m){switch(m){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=P,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new t.Emitter}onColorThemeChange(y){return this.themingParticipants.push(y),this.onThemingParticipantAddedEmitter.fire(y),(0,D.toDisposable)(()=>{const I=this.themingParticipants.indexOf(y);this.themingParticipants.splice(I,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const f=new S;M.Registry.add(e.Extensions.ThemingContribution,f);function u(m){return f.onColorThemeChange(m)}e.registerThemingParticipant=u;class p extends D.Disposable{constructor(y){super();this.themeService=y,this.theme=y.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(I=>this.onThemeChange(I)))}onThemeChange(y){this.theme=y,this.updateStyles()}updateStyles(){}getColor(y,I){let g=this.theme.getColor(y);return g&&I&&(g=I(g,this.theme)),g?g.toString():null}}e.Themable=p}),define(X[61],J([0,1,14,3,2,4,18,5,45]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const w="#FFFFFF",C="#1E1E1E",P="#000000",S="#FFFFFF",f="theme",u="themeBackground",p="windowSplash";e.IThemeMainService=(0,b.createDecorator)("themeMainService");let m=class extends D.Disposable{constructor(I,g){super();this.stateMainService=I,this.configurationService=g,this._onDidChangeColorScheme=this._register(new t.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,E.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.getColorScheme())})}getColorScheme(){if(R.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const I=this.getColorScheme();if(I.highContrast&&this.configurationService.getValue("window.autoDetectHighContrast"))return I.dark?P:S;let g=this.stateMainService.getItem(u,null);if(!g)switch(this.stateMainService.getItem(f,"vs-dark").split(" ")[0]){case"vs":g=w;break;case"hc-black":g=P;break;case"hc-light":g=S;break;default:g=C}return R.isMacintosh&&g.toUpperCase()===C&&(g="#171717"),g}saveWindowSplash(I,g){this.stateMainService.setItems([{key:f,data:g.baseTheme},{key:u,data:g.colorInfo.background},{key:p,data:g}]),typeof I=="number"&&this.updateBackgroundColor(I,g)}updateBackgroundColor(I,g){for(const h of E.BrowserWindow.getAllWindows())if(h.id===I){h.setBackgroundColor(g.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(p)}};m=fe([x(0,d.IStateMainService),x(1,M.IConfigurationService)],m),e.ThemeMainService=m}),define(X[108],J([0,1,3,4,5,6]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,D.createDecorator)("sharedTunnelsService");var M;(function(p){p.Http="http",p.Https="https"})(M=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(p){p.ConstantPrivate="constantPrivate",p.Private="private",p.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(p){p[p.Notify=1]="Notify",p[p.OpenBrowser=2]="OpenBrowser",p[p.OpenPreview=3]="OpenPreview",p[p.Silent=4]="Silent",p[p.Ignore=5]="Ignore",p[p.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function w(p){if(p.scheme!=="http"&&p.scheme!=="https")return;const m=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(p.authority);if(!!m)return{address:m[1],port:+m[2]}}e.extractLocalHostUriMetaDataForPortMapping=w,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function C(p){return e.LOCALHOST_ADDRESSES.indexOf(p)>=0}e.isLocalhost=C,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(p){return e.ALL_INTERFACES_ADDRESSES.indexOf(p)>=0}e.isAllInterfaces=P;function S(p,m){return m?m!==1&&p<1024:!t.isWindows&&p<1024}e.isPortPrivileged=S;class f{constructor(m,y,I){this.remoteAddress=m,this.localAddress=y,this._dispose=I,this._onDispose=new E.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=f;let u=class{constructor(m){this.logService=m,this._onTunnelOpened=new E.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new E.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new E.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(m){return this._tunnelProvider=m,m?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(m){this._canElevate=m.elevation,this._privacyOptions=m.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const m=[],y=Array.from(this._tunnels.values());for(const I of y){const g=Array.from(I.values());for(const h of g){const l=await h.value;l&&m.push(l)}}return m}async dispose(){for(const m of this._tunnels.values()){for(const{value:y}of m.values())await y.then(I=>I?.dispose());m.clear()}this._tunnels.clear()}openTunnel(m,y,I,g,h=!1,l,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${y}:${I} on local port ${g}.`),!m)return;if(y||(y="localhost"),this._tunnelProvider&&this._factoryInProgress.has(I)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(m,y,I,g,h,l,s);return r?r.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(y,I);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==y||n.tunnelRemotePort!==I)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(m){return{tunnelRemotePort:m.tunnelRemotePort,tunnelRemoteHost:m.tunnelRemoteHost,tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress,privacy:m.privacy,protocol:m.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${m.tunnelRemoteHost}:${m.tunnelRemotePort} `);const y=this._tunnels.get(m.tunnelRemoteHost);if(y){const I=y.get(m.tunnelRemotePort);I&&(I.refcount--,await this.tryDisposeTunnel(m.tunnelRemoteHost,m.tunnelRemotePort,I))}}}}async tryDisposeTunnel(m,y,I){if(I.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${m}:${y}.`);const g=I.value.then(async h=>{h&&(await h.dispose(!0),this._onTunnelClosed.fire({host:h.tunnelRemoteHost,port:h.tunnelRemotePort}))});return this._tunnels.has(m)&&this._tunnels.get(m).delete(y),g}}async closeTunnel(m,y){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${m}:${y} `);const I=this._tunnels.get(m);if(I&&I.has(y)){const g=I.get(y);g.refcount=0,await this.tryDisposeTunnel(m,y,g)}}addTunnelToMap(m,y,I){this._tunnels.has(m)||this._tunnels.set(m,new Map),this._tunnels.get(m).set(y,{refcount:1,value:I})}async removeEmptyTunnelFromMap(m,y){const I=this._tunnels.get(m);I&&(await I.get(y)||I.delete(y),I.size===0&&this._tunnels.delete(m))}getTunnelFromMap(m,y){const I=[m];C(m)?(I.push(...e.LOCALHOST_ADDRESSES),I.push(...e.ALL_INTERFACES_ADDRESSES)):P(m)&&I.push(...e.ALL_INTERFACES_ADDRESSES);const g=I.map(h=>this._tunnels.get(h));for(const h of g){const l=h?.get(y);if(l)return l}}canTunnel(m){return!!w(m)}createWithProvider(m,y,I,g,h,l,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${y}:${I} on local port ${g}.`);const r=I;this._factoryInProgress.add(r);const i={elevationRequired:h?S(g===void 0?I:g):!1},o={remoteAddress:{host:y,port:I},localAddressPort:g,privacy:l,public:l?l!==b.Private:void 0,protocol:s},a=m.forwardPort(o,i);return a?(this.addTunnelToMap(y,I,a),a.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),a}};u=fe([x(0,R.ILogService)],u),e.AbstractTunnelService=u}),define(X[224],J([0,1,76,90,209,8,2,18,6,20,208,108,86]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function f(I,g,h,l,s){let r;for(let n=3;n&&(r?.dispose(),r=await new u(I,g,h,l,s).waitForReady(),!(s&&t.BROWSER_RESTRICTED_PORTS[s]||!t.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));n--);return r}class u extends M.Disposable{constructor(g,h,l,s,r){super();this.defaultTunnelHost=h,this.suggestedLocalPort=r,this.privacy=P.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=g,this._server=E.createServer(),this._barrier=new R.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=n=>this._onConnection(n),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(h=>{h()})}async waitForReady(){let g=await(0,t.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),h=null;return this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address(),h||(g=0,this._server.listen(g,this.defaultTunnelHost),await this._barrier.wait(),h=this._server.address()),this.tunnelLocalPort=h.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${h.port}`,this}async _onConnection(g){g.pause();const h=(0,P.isLocalhost)(this.tunnelRemoteHost)||(0,P.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,C.connectRemoteAgentTunnel)(this._options,h,this.tunnelRemotePort),s=l.getSocket().socket,r=l.readEntireBuffer();l.dispose(),r.byteLength>0&&g.write(r.buffer),g.on("end",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),s.end()}),g.on("close",()=>s.end()),g.on("error",()=>{g.localAddress&&this._socketsDispose.delete(g.localAddress),s.destroy()}),s.on("end",()=>g.end()),s.on("close",()=>g.end()),s.on("error",()=>{g.destroy()}),g.pipe(s),s.pipe(g),g.localAddress&&this._socketsDispose.set(g.localAddress,()=>{g.end(),s.end()})}}let p=class extends P.AbstractTunnelService{constructor(g,h,l,s,r){super(h);this.socketFactory=g,this.signService=l,this.productService=s,this.configurationService=r}get defaultTunnelHost(){const g=this.configurationService.getValue("remote.localPortHost");return!g||g==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(g,h,l,s,r,n,i){const o=this.getTunnelFromMap(h,l);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,h,l,s,r,n,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${h}:${l} on local port ${s}.`);const a={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:g,signService:this.signService,logService:this.logService,ipcLogger:null},c=f(a,this.defaultTunnelHost,h,l,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(h,l,c),c}}};p=fe([x(1,d.ILogService),x(2,S.ISignService),x(3,w.IProductService),x(4,b.IConfigurationService)],p),e.BaseTunnelService=p;let m=class extends p{constructor(g,h,l,s){super(D.nodeSocketFactory,g,h,l,s)}};m=fe([x(0,d.ILogService),x(1,S.ISignService),x(2,w.IProductService),x(3,b.IConfigurationService)],m),e.TunnelService=m;let y=class extends M.Disposable{constructor(g,h,l,s){super();this.logService=g,this.productService=h,this.signService=l,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(g,h,l,s,r,n,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${l}:${s} on local port ${r}.`),!this._tunnelServices.has(g)){const a=new m(this.logService,this.signService,this.productService,this.configurationService);this._register(a),this._tunnelServices.set(g,a),a.onTunnelClosed(async()=>{(await a.tunnels).length===0&&(a.dispose(),this._tunnelServices.delete(g))})}return this._tunnelServices.get(g).openTunnel(h,l,s,r,n,i,o)}};y=fe([x(0,d.ILogService),x(1,w.IProductService),x(2,S.ISignService),x(3,b.IConfigurationService)],y),e.SharedTunnelsService=y}),define(X[46],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var t;(function(R){R.Uninitialized="uninitialized",R.Idle="idle",R.CheckingForUpdates="checking for updates",R.AvailableForDownload="available for download",R.Downloading="downloading",R.Downloaded="downloaded",R.Updating="updating",R.Ready="ready"})(t=e.StateType||(e.StateType={}));var D;(function(R){R[R.Setup=0]="Setup",R[R.Archive=1]="Archive",R[R.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(R,M)=>({type:"idle",updateType:R,error:M}),CheckingForUpdates:R=>({type:"checking for updates",explicit:R}),AvailableForDownload:R=>({type:"available for download",update:R}),Downloading:R=>({type:"downloading",update:R}),Downloaded:R=>({type:"downloaded",update:R}),Updating:R=>({type:"updating",update:R}),Ready:R=>({type:"ready",update:R})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(X[225],J([0,1,4,164,60,44]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,t.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,t.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,t.localize)(2,null),(0,t.localize)(3,null),(0,t.localize)(4,null),(0,t.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,t.localize)(6,null),deprecationMessage:(0,t.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,t.localize)(8,null),description:(0,t.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,t.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(X[226],J([0,1,3,46]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(b){this.service=b}listen(b,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(b,d,w){switch(d){case"checkForUpdates":return this.service.checkForUpdates(w);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion();case"_applySpecificUpdate":return this.service._applySpecificUpdate(w)}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=D;class R{constructor(b){this.channel=b,this._onStateChange=new E.Emitter,this.onStateChange=this._onStateChange.event,this._state=t.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}_applySpecificUpdate(b){return this.channel.call("_applySpecificUpdate",b)}}e.UpdateChannelClient=R}),define(X[87],J([0,1,8,21,3,18,26,22,6,20,53,46]),function(B,e,E,t,D,R,M,b,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(u,p,m){return`${m.updateUrl}/api/update/${u}/${p}/${m.commit}`}e.createUpdateURL=S;let f=class{constructor(p,m,y,I,g,h){this.lifecycleMainService=p,this.configurationService=m,this.environmentMainService=y,this.requestService=I,this.logService=g,this.productService=h,this._state=P.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}async initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const p=this.getUpdateMode(),m=this.getProductQuality(p);if(!m){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(m),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(P.State.Idle(this.getUpdateType())),p==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}p==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}getUpdateMode(){return(0,R.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(p){return p==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(p=60*60*1e3){return(0,E.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(p){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){return this.url?await this.getUpdateMode()==="none"?!1:(await this.requestService.request({url:this.url},t.CancellationToken.None)).res.statusCode===204:void 0}async _applySpecificUpdate(p){}getUpdateType(){return 1}doQuitAndInstall(){}};f=fe([x(0,b.ILifecycleMainService),x(1,R.IConfigurationService),x(2,M.IEnvironmentMainService),x(3,C.IRequestService),x(4,d.ILogService),x(5,w.IProductService)],f),e.AbstractUpdateService=f}),define(X[227],J([0,1,14,51,3,2,18,26,22,6,20,53,35,46,87]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let p=class extends u.AbstractUpdateService{constructor(y,I,g,h,l,s,r){super(y,I,h,l,s,r);this.telemetryService=g,this.disposables=new R.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(E.autoUpdater,"error",(y,I)=>I)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(y,I,g)=>({url:I,version:g,productVersion:g}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(y,I,g,h)=>({releaseNotes:I,version:g,productVersion:g,date:h}))}async initialize(){await super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(y){this.logService.error("UpdateService error:",y);const g=(this.state.type==="checking for updates"?this.state.explicit:!0)?y:void 0;this.setState(f.State.Idle(1,g))}buildUpdateFeedUrl(y){let I;this.productService.darwinUniversalAssetId?I=this.productService.darwinUniversalAssetId:I=process.arch==="x64"?"darwin":"darwin-arm64";const g=(0,u.createUpdateURL)(I,y,this.productService);try{E.autoUpdater.setFeedURL({url:g})}catch(h){this.logService.error("Failed to set update feed URL",h);return}return g}doCheckForUpdates(y){this.setState(f.State.CheckingForUpdates(y)),E.autoUpdater.checkForUpdates()}onUpdateAvailable(y){this.state.type==="checking for updates"&&this.setState(f.State.Downloading(y))}onUpdateDownloaded(y){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:y.version}),this.setState(f.State.Ready(y)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(f.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};fe([t.memoize],p.prototype,"onRawError",null),fe([t.memoize],p.prototype,"onRawUpdateNotAvailable",null),fe([t.memoize],p.prototype,"onRawUpdateAvailable",null),fe([t.memoize],p.prototype,"onRawUpdateDownloaded",null),p=fe([x(0,d.ILifecycleMainService),x(1,M.IConfigurationService),x(2,S.ITelemetryService),x(3,b.IEnvironmentMainService),x(4,P.IRequestService),x(5,w.ILogService),x(6,C.IProductService)],p),e.DarwinUpdateService=p}),define(X[228],J([0,1,42,28,8,3,9,26,22,6,35,46]),function(B,e,E,t,D,R,M,b,d,w,C,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(p,m,y){if(this.lifecycleMainService=p,this.logService=y,this._state=P.State.Uninitialized,this._onStateChange=new R.Emitter,this.onStateChange=this._onStateChange.event,m.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(P.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,I=>this.logService.error(I))}get state(){return this._state}setState(p){this.logService.info("update#setState",p.type),this._state=p,this._onStateChange.fire(p)}scheduleCheckForUpdates(p=60*60*1e3){return(0,D.timeout)(p).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(p){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(p)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(p){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(p=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${p}`),!p&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}async _applySpecificUpdate(p){}};S=fe([x(0,d.ILifecycleMainService),x(1,b.IEnvironmentMainService),x(2,w.ILogService)],S);let f=class extends S{constructor(p,m,y,I,g,h){super(y,I,g);this.snap=p,this.snapRevision=m,this.telemetryService=h;const l=(0,t.watch)(M.dirname(this.snap)),s=R.Event.fromNodeEventEmitter(l,"change",(o,a)=>a),r=R.Event.filter(s,o=>o==="current"),i=R.Event.debounce(r,(o,a)=>a,2e3)(()=>this.checkForUpdates(!1));y.onWillShutdown(()=>{i.dispose(),l.close()})}doCheckForUpdates(){this.setState(P.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(p=>{p?this.setState(P.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2)))},p=>{this.logService.error(p),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(P.State.Idle(2,p.message||p))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+M.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const p=await new Promise((y,I)=>(0,t.realpath)(`${M.dirname(this.snap)}/current`,(g,h)=>g?I(g):y(h))),m=M.basename(p);return this.snapRevision!==m}isLatestVersion(){return this.isUpdateAvailable().then(void 0,p=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};f=fe([x(2,d.ILifecycleMainService),x(3,b.IEnvironmentMainService),x(4,w.ILogService),x(5,C.ITelemetryService)],f),e.SnapUpdateService=f}),define(X[62],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(X[229],J([0,1,62,181,15,16,123,3,2]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class w{constructor(S){this.uri=S,this.time=w._clock++}touch(){return this.time=w._clock++,this}}w._clock=0;let C=class{constructor(S){this._fileService=S,this._dispooables=new d.DisposableStore,this._limit=2**16;const f=new Map,u=p=>{let m=f.get(p.scheme);return m===void 0&&(m=S.hasProvider(p)&&!this._fileService.hasCapability(p,1024),f.set(p.scheme,m)),m};this._dispooables.add(b.Event.any(S.onDidChangeFileSystemProviderRegistrations,S.onDidChangeFileSystemProviderCapabilities)(p=>{f.delete(p.scheme)})),this.extUri=new R.ExtUri(u),this._canonicalUris=new M.SkipList((p,m)=>this.extUri.compare(p,m,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(S){this._fileService.hasProvider(S)&&(S=(0,R.normalizePath)(S));const f=this._canonicalUris.get(S);return f?f.touch().uri.with({fragment:S.fragment}):(this._canonicalUris.set(S,new w(S)),this._checkTrim(),S)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const S=[...this._canonicalUris.entries()].sort((u,p)=>u[1].touch<p[1].touch?1:u[1].touch>p[1].touch?-1:0);w._clock=0,this._canonicalUris.clear();const f=this._limit*.5;for(let u=0;u<f;u++)this._canonicalUris.set(S[u][0],S[u][1].touch())}};C=fe([x(0,D.IFileService)],C),e.UriIdentityService=C,(0,t.registerSingleton)(E.IUriIdentityService,C,!0)}),define(X[109],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(X[230],J([0,1,7]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class t{constructor(b){this.handler=b}listen(b,d){throw new Error(`Event not found: ${d}`)}call(b,d,w){switch(d){case"handleURL":return this.handler.handleURL(E.URI.revive(w[0]),w[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=t;class D{constructor(b){this.channel=b}handleURL(b,d){return this.channel.call("handleURL",[b.toJSON(),d])}}e.URLHandlerChannelClient=D;class R{constructor(b){this.next=b}async routeCall(b,d,w,C){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(w){const P=E.URI.revive(w);if(P&&P.query){const S=/\bwindowId=(\d+)/.exec(P.query);if(S){const f=S[1],u=new RegExp(`window:${f}`),p=b.connections.find(m=>u.test(m.ctx));if(p)return p}}}return this.next.routeCall(b,d,w,C)}routeEvent(b,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=R}),define(X[231],J([0,1,8,2,7,20]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class M extends t.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(w,C){const P=[...this.handlers.values()];return(0,E.first)(P.map(S=>()=>S.handleURL(w,C)),void 0,!1).then(S=>S||!1)}registerHandler(w){return this.handlers.add(w),(0,t.toDisposable)(()=>this.handlers.delete(w))}}e.AbstractURLService=M;let b=class extends M{constructor(w){super();this.productService=w}create(w){let{authority:C,path:P,query:S,fragment:f}=w||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return C&&P&&P.indexOf("/")!==0&&(P=`/${P}`),D.URI.from({scheme:this.productService.urlProtocol,authority:C,path:P,query:S,fragment:f})}};b=fe([x(0,R.IProductService)],b),e.NativeURLService=b}),define(X[232],J([0,1,14,8,3,2,4,7]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(C){try{return b.URI.parse(C)}catch{return null}}class w{constructor(P,S,f,u,p){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=R.Disposable.None,this.disposables=new R.DisposableStore,this.uris=P,M.isWindows){const I=u.isBuilt?[]:[`"${u.appRoot}"`];I.push("--open-url","--"),E.app.setAsDefaultProtocolClient(p.urlProtocol,process.execPath,I)}const m=D.Event.map(D.Event.fromNodeEventEmitter(E.app,"open-url",(I,g)=>({event:I,url:g})),({event:I,url:g})=>(I.preventDefault(),g));this.disposables.add(m(I=>{const g=d(I);!g||this.urlService.open(g,{originalUrl:I})})),f.getWindows().filter(I=>I.isReady).length>0?this.flush():D.Event.once(f.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const P=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||P.push(S);P.length!==0&&(this.uris=P,this.flushDisposable=(0,t.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=w}),define(X[233],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(X[234],J([0,1,14,2,12,7]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class M extends t.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);E.protocol.registerFileProtocol(D.Schemas.vscodeWebview,d)}handleWebviewRequest(d,w){try{const C=R.URI.parse(d.url),P=M.validWebviewFilePaths.get(C.path);if(typeof P=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${P}`,f=D.FileAccess.asFileUri(S,B);return w(decodeURIComponent(f.fsPath))}else return w({error:-10})}catch{}return w({error:-2})}}e.WebviewProtocolProvider=M,M.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(X[73],J([0,1,4]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function t(C){return!!C.workspaceUri}e.isWorkspaceToOpen=t;function D(C){return!!C.folderUri}e.isFolderToOpen=D;function R(C){return!!C.fileUri}e.isFileToOpen=R;function M(C){const P=b(C),S=C.getValue("window.menuBarVisibility");return S==="default"||P==="native"&&S==="compact"||E.isMacintosh&&E.isNative?"classic":S}e.getMenuBarVisibility=M;function b(C){if(E.isWeb)return"custom";const P=C.getValue("window");if(P){if(E.isMacintosh&&P.nativeTabs===!0||E.isMacintosh&&P.nativeFullScreen===!1)return"native";const u=C.getValue("workbench.colorCustomizations");if(u?.["window.activeBorder"]||u?.["window.inactiveBorder"])return"custom";const p=P.titleBarStyle;if(p==="native"||p==="custom")return p}return E.isLinux?"native":"custom"}e.getTitleBarStyle=b;function d(C,P){return!E.isWindows||E.isWeb||!P.isBuilt||b(C)==="native"?!1:C.getValue("window.experimental.windowControlsOverlay.enabled")}e.useWindowControlsOverlay=d;function w(C=0){return Math.pow(1.2,C)}e.zoomLevelToZoomFactor=w}),define(X[110],J([0,1]),function(B,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(b){b[b.INITIAL=1]="INITIAL",b[b.LOAD=2]="LOAD",b[b.RELOAD=3]="RELOAD"})(E=e.LoadReason||(e.LoadReason={}));var t;(function(b){b[b.CLOSE=1]="CLOSE",b[b.QUIT=2]="QUIT",b[b.RELOAD=3]="RELOAD",b[b.LOAD=4]="LOAD"})(t=e.UnloadReason||(e.UnloadReason={}));const D=function(b=1){return{width:1024,height:768,mode:b}};e.defaultWindowState=D;var R;(function(b){b[b.Maximized=0]="Maximized",b[b.Normal=1]="Normal",b[b.Minimized=2]="Minimized",b[b.Fullscreen=3]="Fullscreen"})(R=e.WindowMode||(e.WindowMode={}));var M;(function(b){b[b.UNRESPONSIVE=1]="UNRESPONSIVE",b[b.CRASHED=2]="CRASHED",b[b.LOAD=3]="LOAD"})(M=e.WindowError||(e.WindowError={}))}),define(X[32],J([0,1,5]),function(B,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var t;(function(D){D[D.CLI=0]="CLI",D[D.DOCK=1]="DOCK",D[D.MENU=2]="MENU",D[D.DIALOG=3]="DIALOG",D[D.DESKTOP=4]="DESKTOP",D[D.API=5]="API"})(t=e.OpenContext||(e.OpenContext={}))}),define(X[235],J([0,1,14,21,3,65,2,27,68,99,6,20,32]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(p){p[p.Initial=1]="Initial",p[p.StoredCredentialsUsed=2]="StoredCredentialsUsed",p[p.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let u=class extends M.Disposable{constructor(m,y,I,g,h){super();this.logService=m,this.windowsMainService=y,this.credentialsService=I,this.encryptionMainService=g,this.productService=h,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=f.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const m=D.Event.fromNodeEventEmitter(E.app,"login",(y,I,g,h,l)=>({event:y,webContents:I,req:g,authInfo:h,callback:l}));this._register(m(this.onLogin,this))}async onLogin({event:m,authInfo:y,req:I,callback:g}){if(!y.isProxy)return;if(!this.pendingProxyResolve&&this.state===f.LoginDialogShown&&I.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}m.preventDefault();let h;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(y);try{h=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}g(h?.username,h?.password)}async resolveProxyCredentials(m){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const y=await this.doResolveProxyCredentials(m);if(y)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),y;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(m){this.logService.trace("auth#doResolveProxyCredentials - enter",m);const y=String((0,R.hash)({scheme:m.scheme,host:m.host,port:m.port}));let I,g;try{const r=await this.credentialsService.getPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,y);if(r){const n=JSON.parse(await this.encryptionMainService.decrypt(r));I=n.username,g=n.password}}catch(r){this.logService.error(r)}if(this.state!==f.StoredCredentialsUsed&&typeof I=="string"&&typeof g=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=f.StoredCredentialsUsed,{username:I,password:g};const h=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!h){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const l={authInfo:m,username:this.sessionCredentials?.username??I,password:this.sessionCredentials?.password??g,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",t.CancellationToken.None,l),this.state=f.LoginDialogShown;const s=await new Promise(r=>{const n=async(i,o,a)=>{if(o===l.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",n),a){const c={username:a.username,password:a.password};try{if(a.remember){const v=await this.encryptionMainService.encrypt(JSON.stringify(c));await this.credentialsService.setPassword(this.PROXY_CREDENTIALS_SERVICE_KEY,y,v)}else await this.credentialsService.deletePassword(this.PROXY_CREDENTIALS_SERVICE_KEY,y)}catch(v){this.logService.error(v)}r({username:c.username,password:c.password})}else r(void 0)};h.win?.webContents.on("ipc-message",n)});return this.sessionCredentials=s,s}};u=fe([x(0,C.ILogService),x(1,S.IWindowsMainService),x(2,d.ICredentialsMainService),x(3,w.IEncryptionMainService),x(4,P.IProductService)],u),e.ProxyAuthHandler=u}),define(X[236],J([0,1,68,6,39,20,32,192]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let d=class extends b.BaseCredentialsMainService{constructor(C,P,S,f){super(C);this.environmentMainService=P,this.productService=S,this.windowsMainService=f,this.surfaceKeytarLoadError=u=>{this.windowsMainService.sendToFocused("vscode:showCredentialsError",u.message??u)}}async getSecretStoragePrefix(){return Promise.resolve(this.productService.urlProtocol)}async withKeytar(){if(this._keytarCache)return this._keytarCache;if(this.environmentMainService.disableKeytar)return this.logService.info("Keytar is disabled. Using in-memory credential store instead."),this._keytarCache=new E.InMemoryCredentialsProvider,this._keytarCache;const C=await new Promise((P,S)=>{B(["keytar"],P,S)});return await C.findCredentials("test-keytar-loads"),this._keytarCache=C,this._keytarCache}};d=fe([x(0,t.ILogService),x(1,D.INativeEnvironmentService),x(2,R.IProductService),x(3,M.IWindowsMainService)],d),e.CredentialsNativeMainService=d}),define(X[237],J([0,1,19,2,3,6,22,78,42,126,8,12,50,4,36,14,32]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;const y=p.UtilityProcess,I=typeof y!="undefined";let g=class Dt{constructor(r,n,i){this._logService=r,this._windowsMainService=i,this._shutdown=!1,this._extHosts=new Map,n.onWillShutdown(o=>{this._shutdown=!0,o.join(this._waitForAllExit(6e3))})}dispose(){}_getExtHost(r){const n=this._extHosts.get(r);if(!n)throw new Error("Unknown extension host!");return n}onDynamicStdout(r){return this._getExtHost(r).onStdout}onDynamicStderr(r){return this._getExtHost(r).onStderr}onDynamicMessage(r){return this._getExtHost(r).onMessage}onDynamicError(r){return this._getExtHost(r).onError}onDynamicExit(r){return this._getExtHost(r).onExit}async canUseUtilityProcess(){return I}async createExtensionHost(r){if(this._shutdown)throw(0,E.canceled)();const n=String(++Dt._lastId);let i;if(r){if(!I)throw new Error("Cannot use UtilityProcess!");i=new l(n,this._logService,this._windowsMainService)}else i=new h(n,this._logService);return this._extHosts.set(n,i),i.onExit(({pid:o,code:a,signal:c})=>{this._logService.info(`Extension host with pid ${o} exited with code: ${a}, signal: ${c}.`),setTimeout(()=>{i.dispose(),this._extHosts.delete(n)})}),{id:n}}async start(r,n){if(this._shutdown)throw(0,E.canceled)();return this._getExtHost(r).start(n)}async enableInspectPort(r){if(this._shutdown)throw(0,E.canceled)();const n=this._extHosts.get(r);return n?n.enableInspectPort():!1}async kill(r){if(this._shutdown)throw(0,E.canceled)();const n=this._extHosts.get(r);!n||n.kill()}async _killAllNow(){for(const[,r]of this._extHosts)r.kill()}async _waitForAllExit(r){const n=[];for(const[,i]of this._extHosts)n.push(i.waitForExit(r));return C.Promises.settled(n).then(()=>{})}};g._lastId=0,g=fe([x(0,R.ILogService),x(1,M.ILifecycleMainService),x(2,m.IWindowsMainService)],g),e.ExtensionHostStarter=g;let h=class extends t.Disposable{constructor(r,n){super();this.id=r,this._logService=n,this._onStdout=this._register(new D.Emitter),this.onStdout=this._onStdout.event,this._onStderr=this._register(new D.Emitter),this.onStderr=this._onStderr.event,this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._onError=this._register(new D.Emitter),this.onError=this._onError.event,this._onExit=this._register(new D.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){f.isCI&&this._logService.info("Calling fork to start extension host...");const n=b.StopWatch.create(!1);this._process=(0,d.fork)(P.FileAccess.asFileUri("bootstrap-fork",B).fsPath,["--type=extensionHost","--skipWorkspaceStorageLock"],(0,S.mixin)({cwd:(0,u.cwd)()},r));const i=n.elapsed(),o=this._process.pid;this._logService.info(`Starting extension host with pid ${o} (fork() took ${i} ms).`);const a=new w.StringDecoder("utf-8");this._process.stdout?.on("data",v=>{const k=typeof v=="string"?v:a.write(v);this._onStdout.fire(k)});const c=new w.StringDecoder("utf-8");this._process.stderr?.on("data",v=>{const k=typeof v=="string"?v:c.write(v);this._onStderr.fire(k)}),this._process.on("message",v=>{this._onMessage.fire(v)}),this._process.on("error",v=>{this._onError.fire({error:(0,E.transformErrorForSerialization)(v)})}),this._process.on("exit",(v,k)=>{this._hasExited=!0,this._onExit.fire({pid:o,code:v,signal:k})})}enableInspectPort(){return this._process?(this._logService.info(`Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const n=this._process.pid;this._logService.info(`Waiting for extension host with pid ${n} to exit.`),await Promise.race([D.Event.toPromise(this.onExit),(0,C.timeout)(r)]),this._hasExited||(this._logService.info(`Extension host with pid ${n} did not exit within ${r}ms.`),this._process.kill())}};h=fe([x(1,R.ILogService)],h);let l=class extends t.Disposable{constructor(r,n,i){super();this.id=r,this._logService=n,this._windowsMainService=i,this.onStdout=D.Event.None,this.onStderr=D.Event.None,this.onError=D.Event.None,this._onMessage=this._register(new D.Emitter),this.onMessage=this._onMessage.event,this._onExit=this._register(new D.Emitter),this.onExit=this._onExit.event,this._process=null,this._hasExited=!1}start(r){const n=this._windowsMainService.getWindowById(r.responseWindowId);if(!n){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const i=n.win;if(!i||i.isDestroyed()||i.webContents.isDestroyed()){this._logService.info(`UtilityProcess<${this.id}>: Refusing to create new Extension Host UtilityProcess because requesting window cannot be found...`);return}const o=`extensionHost${this.id}`,a=P.FileAccess.asFileUri("bootstrap-fork.js",B).fsPath,c=["--type=extensionHost","--skipWorkspaceStorageLock"],v=r.execArgv||[],k={...r.env};for(const j of Object.keys(k))k[j]=String(k[j]);this._logService.info(`UtilityProcess<${this.id}>: Creating new...`),this._process=new y(a,c,{serviceName:o,env:k,execArgv:v}),this._register(D.Event.fromNodeEventEmitter(this._process,"spawn")(()=>{this._logService.info(`UtilityProcess<${this.id}>: received spawn event.`)})),this._register(D.Event.fromNodeEventEmitter(this._process,"exit")(j=>{j=j||0,this._logService.info(`UtilityProcess<${this.id}>: received exit event with code ${j}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:j,signal:""})}));const L=(j,ee)=>{ee.type==="Utility"&&ee.name===o&&(this._logService.info(`UtilityProcess<${this.id}>: terminated unexpectedly with code ${ee.exitCode}.`),this._hasExited=!0,this._onExit.fire({pid:this._process.pid,code:ee.exitCode,signal:""}))};p.app.on("child-process-gone",L),this._register((0,t.toDisposable)(()=>{p.app.off("child-process-gone",L)}));const{port1:O,port2:F}=new p.MessageChannelMain;this._process.postMessage("port",null,[F]),i.webContents.postMessage(r.responseChannel,r.responseNonce,[O])}enableInspectPort(){return this._process?(this._logService.info(`UtilityProcess<${this.id}>: Enabling inspect port on extension host with pid ${this._process.pid}.`),typeof process._debugProcess=="function"?(process._debugProcess(this._process.pid),!0):f.isWindows?!1:(this._process.kill("SIGUSR1"),!0)):!1}kill(){!this._process||(this._logService.info(`UtilityProcess<${this.id}>: Killing extension host with pid ${this._process.pid}.`),this._process.kill())}async waitForExit(r){if(!this._process)return;const n=this._process.pid;this._logService.info(`UtilityProcess<${this.id}>: Waiting for extension host with pid ${n} to exit.`),await Promise.race([D.Event.toPromise(this.onExit),(0,C.timeout)(r)]),this._hasExited||(this._logService.info(`UtilityProcess<${this.id}>: Extension host with pid ${n} did not exit within ${r}ms, will kill it now.`),this._process.kill())}};l=fe([x(1,R.ILogService),x(2,m.IWindowsMainService)],l)}),define(X[238],J([0,1,14,3,2,234,32]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends D.Disposable{constructor(w){super();this.windowsMainService=w,this._onFoundInFrame=this._register(new t.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new R.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(w,C){let P;if(typeof w.windowId=="number"){const{windowId:S}=w,f=this.windowsMainService.getWindowById(S);if(!f?.win)throw new Error(`Invalid windowId: ${S}`);P=f.win.webContents}else{const{webContentsId:S}=w;if(P=E.webContents.fromId(S),!P)throw new Error(`Invalid webContentsId: ${S}`)}P.isDestroyed()||P.setIgnoreMenuShortcuts(C)}async findInFrame(w,C,P,S){const u=this.getFrameByName(w,C);if(typeof u.findInFrame=="function"){u.findInFrame(P,{findNext:S.findNext,forward:S.forward});const p=(m,y)=>{y.finalUpdate&&(this._onFoundInFrame.fire(y),u.removeListener("found-in-frame",p))};u.on("found-in-frame",p)}}async stopFindInFrame(w,C,P){const f=this.getFrameByName(w,C);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(P.keepSelection?"keepSelection":"clearSelection")}getFrameByName(w,C){const P=this.windowsMainService.getWindowById(w.windowId);if(!P?.win)throw new Error(`Invalid windowId: ${w}`);const S=P.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===C);if(!S)throw new Error(`Unknown frame: ${C}`);return S}};b=fe([x(0,M.IWindowsMainService)],b),e.WebviewMainService=b}),define(X[239],J([0,1,8,3,2]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class R extends D.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:d,getActiveWindowId:w}){super();this.disposables=this._register(new D.DisposableStore),t.Event.latch(t.Event.any(b,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,E.createCancelablePromise)(()=>w()),(async()=>{try{const P=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:P}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=R}),define(X[24],J([0,1,168,9,33,16,7,5,12]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function w(n){const i=n;return typeof i?.id=="string"&&M.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=w;function C(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=C;function P(n){const i=n;return typeof i?.id=="string"&&M.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=P;function S(n){const i=n;if(i?.uri)return{id:i.id,uri:M.URI.revive(i.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:M.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=S;var f;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(f=e.WorkbenchState||(e.WorkbenchState={}));function u(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=u;function p(n){const i=n;return!!(i&&typeof i=="object"&&M.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=p;class m{constructor(i,o,a,c,v){this._id=i,this._transient=a,this._configuration=c,this._ignorePathCasing=v,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=m;class y{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,R.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=y;function I(n){return new y({uri:n,index:0,name:(0,R.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=I,e.WORKSPACE_EXTENSION="code-workspace";const g=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function h(n,i){return R.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=h;function l(n){let i;return M.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===d.Schemas.tmp}e.isTemporaryWorkspace=l;function s(n,i){return!h(n,i)&&!l(n)}e.isSavedWorkspace=s;function r(n){return(typeof n=="string"?(0,t.extname)(n):(0,R.extname)(n))===g}e.hasWorkspaceFileExtension=r}),define(X[240],J([0,1,75,28,30,12,9,4,16,7,23,172,18,26,15,6,171,24]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let I=class{constructor(h,l,s){this.configurationService=l,this.logService=s,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(r,n)=>(0,D.isEqual)(r,n,!b.isLinux)},this.backupHome=h.backupHome,this.workspacesJsonPath=h.backupWorkspacesPath}async initialize(){let h;try{h=JSON.parse(await C.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch{h=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(h.emptyWorkspaceInfos);let l=[];try{Array.isArray(h.rootURIWorkspaces)&&(l=h.rootURIWorkspaces.map(r=>({workspace:{id:r.id,configPath:w.URI.parse(r.configURIPath)},remoteAuthority:r.remoteAuthority})))}catch{}this.workspaces=await this.validateWorkspaces(l);let s=[];try{Array.isArray(h.folderWorkspaceInfos)?s=h.folderWorkspaceInfos.map(r=>({folderUri:w.URI.parse(r.folderUri),remoteAuthority:r.remoteAuthority})):Array.isArray(h.folderURIWorkspaces)&&(s=h.folderURIWorkspaces.map(r=>({folderUri:w.URI.parse(r),remoteAuthority:void 0})))}catch{}this.folders=await this.validateFolders(s),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==u.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===u.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||u.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(h,l){this.workspaces.some(r=>h.workspace.id===r.workspace.id)||(this.workspaces.push(h),this.saveSync());const s=this.getBackupPath(h.workspace.id);return l&&this.moveBackupFolderSync(s,l),s}moveBackupFolderSync(h,l){if(t.existsSync(h)&&this.convertToEmptyWindowBackupSync(h),t.existsSync(l))try{t.renameSync(l,h)}catch(s){this.logService.error(`Backup: Could not move backup folder to new location: ${s.toString()}`)}}unregisterWorkspaceBackupSync(h){const l=h.id,s=this.workspaces.findIndex(r=>r.workspace.id===l);s!==-1&&(this.workspaces.splice(s,1),this.saveSync())}registerFolderBackupSync(h){return this.folders.some(l=>this.backupUriComparer.isEqual(h.folderUri,l.folderUri))||(this.folders.push(h),this.saveSync()),this.getBackupPath(this.getFolderHash(h))}unregisterFolderBackupSync(h){const l=this.folders.findIndex(s=>this.backupUriComparer.isEqual(h,s.folderUri));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(h,l){const s=h||this.getRandomEmptyWindowId();return this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,s))||(this.emptyWindows.push({backupFolder:s,remoteAuthority:l}),this.saveSync()),this.getBackupPath(s)}unregisterEmptyWindowBackupSync(h){const l=this.emptyWindows.findIndex(s=>!!s.backupFolder&&this.backupPathComparer.isEqual(s.backupFolder,h));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(h){return(0,M.join)(this.backupHome,h)}async validateWorkspaces(h){if(!Array.isArray(h))return[];const l=new Set,s=[];for(const r of h){const n=r.workspace;if(!(0,y.isWorkspaceIdentifier)(n))return[];if(!l.has(n.id)){l.add(n.id);const i=this.getBackupPath(n.id);await this.doHasBackups(i)?n.configPath.scheme!==R.Schemas.file||await C.Promises.exists(n.configPath.fsPath)?s.push(r):await this.convertToEmptyWindowBackup(i):await this.deleteStaleBackup(i)}}return s}async validateFolders(h){if(!Array.isArray(h))return[];const l=[],s=new Set;for(const r of h){const n=r.folderUri,i=this.backupUriComparer.getComparisonKey(n);if(!s.has(i)){s.add(i);const o=this.getBackupPath(this.getFolderHash(r));await this.doHasBackups(o)?n.scheme!==R.Schemas.file||await C.Promises.exists(n.fsPath)?l.push(r):await this.convertToEmptyWindowBackup(o):await this.deleteStaleBackup(o)}}return l}async validateEmptyWorkspaces(h){if(!Array.isArray(h))return[];const l=[],s=new Set;for(const r of h){const n=r.backupFolder;if(typeof n!="string")return[];if(!s.has(n)){s.add(n);const i=this.getBackupPath(n);await this.doHasBackups(i)?l.push(r):await this.deleteStaleBackup(i)}}return l}async deleteStaleBackup(h){try{await C.Promises.exists(h)&&await C.Promises.rm(h,C.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{await C.Promises.rename(h,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(h){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(r=>!!r.backupFolder&&this.backupPathComparer.isEqual(r.backupFolder,l));)l=this.getRandomEmptyWindowId();const s=this.getBackupPath(l);try{t.renameSync(h,s)}catch(r){return this.logService.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const h=[];for(const l of this.workspaces)await this.hasBackups(l)&&h.push(l);for(const l of this.folders)await this.hasBackups(l)&&h.push(l);return h}hasBackups(h){let l;return(0,P.isEmptyWindowBackupInfo)(h)?l=h.backupFolder:(0,m.isFolderBackupInfo)(h)?l=this.getBackupPath(this.getFolderHash(h)):l=this.getBackupPath(h.workspace.id),this.doHasBackups(l)}async doHasBackups(h){try{const l=await C.Promises.readdir(h);for(const s of l)try{if((await C.Promises.readdir((0,M.join)(h,s))).length>0)return!0}catch{}}catch{}return!1}saveSync(){try{(0,C.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}async save(){try{await C.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(h){this.logService.error(`Backup: Could not save workspaces.json: ${h.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(h=>({id:h.workspace.id,configURIPath:h.workspace.configPath.toString(),remoteAuthority:h.remoteAuthority})),folderWorkspaceInfos:this.folders.map(h=>({folderUri:h.folderUri.toString(),remoteAuthority:h.remoteAuthority})),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(h){const l=h.folderUri;let s;return l.scheme===R.Schemas.file?s=b.isLinux?l.fsPath:l.fsPath.toLowerCase():s=l.toString().toLowerCase(),(0,E.createHash)("md5").update(s).digest("hex")}};I=fe([x(0,f.IEnvironmentMainService),x(1,S.IConfigurationService),x(2,p.ILogService)],I),e.BackupMainService=I}),define(X[54],J([0,1,14,8,65,34,2,79,4,13,23,148,5,6,24]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,S.createDecorator)("dialogMainService");let p=class{constructor(y){this.logService=y,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new t.Queue}pickFileFolder(y,I){return this.doPick({...y,pickFolders:!0,pickFiles:!0,title:(0,P.localize)(0,null)},I)}pickFolder(y,I){return this.doPick({...y,pickFolders:!0,title:(0,P.localize)(1,null)},I)}pickFile(y,I){return this.doPick({...y,pickFiles:!0,title:(0,P.localize)(2,null)},I)}pickWorkspace(y,I){const g=(0,P.localize)(3,null),h=(0,R.mnemonicButtonLabel)((0,P.localize)(4,null)),l=u.WORKSPACE_FILTER;return this.doPick({...y,pickFiles:!0,title:g,filters:l,buttonLabel:h},I)}async doPick(y,I){const g={title:y.title,buttonLabel:y.buttonLabel,filters:y.filters,defaultPath:y.defaultPath};(typeof y.pickFiles=="boolean"||typeof y.pickFolders=="boolean")&&(g.properties=void 0,y.pickFiles&&y.pickFolders&&(g.properties=["multiSelections","openDirectory","openFile","createDirectory"])),g.properties||(g.properties=["multiSelections",y.pickFolders?"openDirectory":"openFile","createDirectory"]),d.isMacintosh&&g.properties.push("treatPackageAsDirectory");const h=await this.showOpenDialog(g,(0,w.withNullAsUndefined)(I||E.BrowserWindow.getFocusedWindow()));if(h&&h.filePaths&&h.filePaths.length>0)return h.filePaths}getWindowDialogQueue(y){if(y){let I=this.windowDialogQueues.get(y.id);return I||(I=new t.Queue,this.windowDialogQueues.set(y.id,I)),I}else return this.noWindowDialogueQueue}showMessageBox(y,I){return this.getWindowDialogQueue(I).queue(async()=>I?E.dialog.showMessageBox(I,y):E.dialog.showMessageBox(y))}async showSaveDialog(y,I){const g=this.acquireFileDialogLock(y,I);if(!g)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(I).queue(async()=>{let h;return I?h=await E.dialog.showSaveDialog(I,y):h=await E.dialog.showSaveDialog(y),h.filePath=this.normalizePath(h.filePath),h})}finally{(0,M.dispose)(g)}}normalizePath(y){return y&&d.isMacintosh&&(y=(0,b.normalizeNFC)(y)),y}normalizePaths(y){return y.map(I=>this.normalizePath(I))}async showOpenDialog(y,I){y.defaultPath&&(await C.Promises.exists(y.defaultPath)||(y.defaultPath=void 0));const g=this.acquireFileDialogLock(y,I);if(!g)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(I).queue(async()=>{let h;return I?h=await E.dialog.showOpenDialog(I,y):h=await E.dialog.showOpenDialog(y),h.filePaths=this.normalizePaths(h.filePaths),h})}finally{(0,M.dispose)(g)}}acquireFileDialogLock(y,I){if(!I)return M.Disposable.None;this.logService.trace("[DialogMainService]: request to acquire file dialog lock",y);let g=this.windowFileDialogLocks.get(I.id);g||(g=new Set,this.windowFileDialogLocks.set(I.id,g));const h=(0,D.hash)(y);if(!g.has(h))return this.logService.trace("[DialogMainService]: new file dialog lock created",y),g.add(h),(0,M.toDisposable)(()=>{this.logService.trace("[DialogMainService]: file dialog lock disposed",y),g?.delete(h),g?.size===0&&this.windowFileDialogLocks.delete(I.id)})}};p=fe([x(0,f.ILogService)],p),e.DialogMainService=p}),define(X[241],J([0,1,3,2,66,24]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends t.Disposable{constructor(d,w){super();this.logService=d,this.storageMainService=w,this.onDidChangeApplicationStorageEmitter=this._register(new E.Emitter),this.mapProfileToOnDidChangeProfileStorageEmitter=new Map,this.registerStorageChangeListeners(w.applicationStorage,this.onDidChangeApplicationStorageEmitter)}registerStorageChangeListeners(d,w){this._register(E.Event.debounce(d.onDidChangeStorage,(C,P)=>(C?C.push(P):C=[P],C),M.STORAGE_CHANGE_DEBOUNCE_TIME)(C=>{C.length&&w.fire(this.serializeStorageChangeEvents(C,d))}))}serializeStorageChangeEvents(d,w){const C=new Map,P=new Set;return d.forEach(S=>{const f=w.get(S.key);typeof f=="string"?C.set(S.key,f):P.add(S.key)}),{changed:Array.from(C.entries()),deleted:Array.from(P.values())}}listen(d,w,C){switch(w){case"onDidChangeStorage":{const P=C.profile?(0,D.revive)(C.profile):void 0;if(!P)return this.onDidChangeApplicationStorageEmitter.event;let S=this.mapProfileToOnDidChangeProfileStorageEmitter.get(P.id);return S||(S=this._register(new E.Emitter),this.registerStorageChangeListeners(this.storageMainService.profileStorage(P),S),this.mapProfileToOnDidChangeProfileStorageEmitter.set(P.id,S)),S.event}}throw new Error(`Event not found: ${w}`)}async call(d,w,C){const P=C.profile?(0,D.revive)(C.profile):void 0,S=(0,R.reviveIdentifier)(C.workspace),f=await this.withStorageInitialized(P,S);switch(w){case"getItems":return Array.from(f.items.entries());case"updateItems":{const u=C;if(u.insert)for(const[p,m]of u.insert)f.set(p,m);u.delete?.forEach(p=>f.delete(p));break}default:throw new Error(`Call not found: ${w}`)}}async withStorageInitialized(d,w){let C;w?C=this.storageMainService.workspaceStorage(w):d?C=this.storageMainService.profileStorage(d):C=this.storageMainService.applicationStorage;try{await C.init()}catch(P){this.logService.error(`StorageIPC#init: Unable to init ${w?"workspace":d?"profile":"application"} storage due to ${P}`)}return C}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(X[40],J([0,1,65,3,2,16,13,7,165,39,15,5,6,24,33,62,8,27]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function I(s){const r=s;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&b.URI.isUri(r.location)&&b.URI.isUri(r.globalStorageHome)&&b.URI.isUri(r.settingsResource)&&b.URI.isUri(r.keybindingsResource)&&b.URI.isUri(r.tasksResource)&&b.URI.isUri(r.snippetsHome)&&((0,M.isUndefined)(r.extensionsResource)||b.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=I,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function g(s,r){return{id:s.id,isDefault:s.isDefault,name:s.name,location:b.URI.revive(s.location).with({scheme:r}),globalStorageHome:b.URI.revive(s.globalStorageHome).with({scheme:r}),settingsResource:b.URI.revive(s.settingsResource).with({scheme:r}),keybindingsResource:b.URI.revive(s.keybindingsResource).with({scheme:r}),tasksResource:b.URI.revive(s.tasksResource).with({scheme:r}),snippetsHome:b.URI.revive(s.snippetsHome).with({scheme:r}),extensionsResource:b.URI.revive(s.extensionsResource)?.with({scheme:r})}}e.reviveProfile=g,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function h(s,r,n){return{id:(0,E.hash)(r.path).toString(16),name:s,location:r,isDefault:!1,globalStorageHome:(0,R.joinPath)(r,"globalStorage"),settingsResource:(0,R.joinPath)(r,"settings.json"),keybindingsResource:(0,R.joinPath)(r,"keybindings.json"),tasksResource:(0,R.joinPath)(r,"tasks.json"),snippetsHome:(0,R.joinPath)(r,"snippets"),extensionsResource:(0,R.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:n}}e.toUserDataProfile=h;let l=class extends D.Disposable{constructor(r,n,i,o){super();this.environmentService=r,this.fileService=n,this.uriIdentityService=i,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new t.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new t.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new t.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new t.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profilesHome=(0,R.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(a=>h(a.name,a.location,a.useDefaultFlags)):[];let n;const i=new u.ResourceMap,o=h((0,d.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0?o.extensionsResource:void 0}),r.length){const a=this.getStoredProfileAssociations();if(a.workspaces)for(const[c,v]of Object.entries(a.workspaces)){const k=b.URI.parse(c),L=b.URI.parse(v),O=r.find(F=>this.uriIdentityService.extUri.isEqual(F.location,L));O&&i.set(k,O)}if(a.emptyWindow){const c=b.URI.parse(a.emptyWindow);n=r.find(v=>this.uriIdentityService.extUri.isEqual(v.location,c))}}this._profilesObject={profiles:r,workspaces:i,emptyWindow:n}}return this._profilesObject}getProfile(r,n){if(!this.enabled)return this.defaultProfile;const i=this.getWorkspace(r);let o=b.URI.isUri(i)?this.profilesObject.workspaces.get(i):this.profilesObject.emptyWindow;return o||(o=n,this.profiles.length>1&&this.updateWorkspaceAssociation(r,o)),o}getWorkspace(r){return(0,f.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,f.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}async createProfile(r,n,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(c=>c.name===r))throw new Error(`Profile with name ${r} already exists`);const o=h(r,(0,R.joinPath)(this.profilesHome,(0,E.hash)((0,y.generateUuid)()).toString(16)),n);await this.fileService.createFolder(o.location);const a=[];return this._onWillCreateProfile.fire({profile:o,join(c){a.push(c)}}),await m.Promises.settled(a),this.updateProfiles([o],[],[]),i&&await this.setProfileForWorkspace(o,i),o}async updateProfile(r,n,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(a=>a.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);return o=h(n,o.location,i),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(r,n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const i=this.profiles.find(o=>o.id===r.id);if(!i)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(n,i)}async unsetWorkspace(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const n=this.profiles.find(o=>o.id===r.id);if(!n)throw new Error(`Profile '${r.name}' does not exist`);const i=[];this._onWillRemoveProfile.fire({profile:n,join(o){i.push(o)}}),await m.Promises.settled(i),n.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])n.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[n],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(n.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(r,n,i){const o=[];for(let a of[...this.profilesObject.profiles,...r])a.isDefault||n.some(c=>a.id===c.id)||(a=i.find(c=>a.id===c.id)??a,o.push({location:a.location,name:a.name,useDefaultFlags:a.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(r,n,i)}triggerProfilesChanges(r,n,i){this._onDidChangeProfiles.fire({added:r,removed:n,updated:i,all:this.profiles})}updateWorkspaceAssociation(r,n){const i=this.getWorkspace(r);b.URI.isUri(i)?(this.profilesObject.workspaces.delete(i),n&&this.profilesObject.workspaces.set(i,n)):this.profilesObject.emptyWindow=n,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[i,o]of this.profilesObject.workspaces.entries())r[i.toString()]=o.location.toString();const n=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:n}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};l.PROFILES_KEY="userDataProfiles",l.PROFILE_ASSOCIATIONS_KEY="profileAssociations",l=fe([x(0,w.IEnvironmentService),x(1,C.IFileService),x(2,p.IUriIdentityService),x(3,S.ILogService)],l),e.UserDataProfilesService=l}),define(X[242],J([0,1,14,38,2,33,12,9,4,7,27,39,6,40]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let u=class extends D.Disposable{constructor(m,y,I){super();this.logService=I,this.validRoots=R.TernarySearchTree.forPaths(!d.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(m.appRoot),this.addValidFileRoot(m.extensionsPath),this.addValidFileRoot(y.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(m.workspaceStorageHome.fsPath),this.handleProtocols()}handleProtocols(){const{defaultSession:m}=E.session;m.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(y,I)=>this.handleResourceRequest(y,I)),m.protocol.interceptFileProtocol(M.Schemas.file,(y,I)=>this.handleFileRequest(y,I)),this._register((0,D.toDisposable)(()=>{m.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),m.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(m){const y=(0,b.normalize)(m);return this.validRoots.get(y)?D.Disposable.None:(this.validRoots.set(y,!0),(0,D.toDisposable)(()=>this.validRoots.delete(y)))}handleFileRequest(m,y){const I=w.URI.parse(m.url);return this.logService.error(`Refused to load resource ${I.fsPath} from ${M.Schemas.file}: protocol (original URL: ${m.url})`),y({error:-3})}handleResourceRequest(m,y){const I=this.requestToNormalizedFilePath(m);return this.validRoots.findSubstr(I)?y({path:I}):this.validExtensions.has((0,b.extname)(I))?y({path:I}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${I} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${m.url})`),y({error:-3}))}requestToNormalizedFilePath(m){const y=w.URI.parse(m.url),I=M.FileAccess.asFileUri(y);return(0,b.normalize)(I.fsPath)}createIPCObjectUrl(){let m;const y=w.URI.from({scheme:"vscode",path:(0,C.generateUuid)()}),I=y.toString(),g=async()=>m;return t.validatedIpcMain.handle(I,g),this.logService.trace(`IPC Object URL: Registered new channel ${I}.`),{resource:y,update:h=>m=h,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${I}.`),t.validatedIpcMain.removeHandler(I)}}}};u=fe([x(0,P.INativeEnvironmentService),x(1,f.IUserDataProfilesService),x(2,S.ILogService)],u),e.ProtocolMainService=u}),define(X[243],J([0,1,14,38,8,3,2,12,13,96,26,22,6,52,59,61,41,40,37]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let g=class extends M.Disposable{constructor(l,s,r,n,i,o,a,c,v){super();this.machineId=l,this.userEnv=s,this.environmentMainService=r,this.userDataProfilesService=n,this.lifecycleMainService=i,this.logService=o,this.policyService=a,this.themeMainService=c,this.protocolMainService=v,this.firstWindowConnectionBarrier=new D.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new R.Emitter),this.onDidError=R.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(l,s)=>this.onWindowConnection(l,s)),t.validatedIpcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(l,s)=>this.onWorkerConnection(l,s)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(l,s){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const r=await this.connect();if(l.sender.isDestroyed())return r.close();l.sender.postMessage("vscode:createSharedProcessMessageChannelResult",s,[r])}onWorkerConnection(l,s){this.logService.trace("SharedProcess: onWorkerConnection",s);const r=new M.DisposableStore,n=o=>{!this.isAlive()||(this.logService.trace(`SharedProcess: disposing worker (reason: '${o}')`,s),r.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",s))},i=E.BrowserWindow.fromId(s.reply.windowId);if(!i||i.isDestroyed()||i.webContents.isDestroyed()||!s.reply.channel){n("unavailable");return}r.add(R.Event.filter(this.lifecycleMainService.onWillLoadWindow,o=>o.window.win===i)(()=>n("load"))),r.add(R.Event.fromNodeEventEmitter(i,"closed")(()=>n("closed"))),i.webContents.postMessage(s.reply.channel,s.reply.nonce,l.ports)}onWillShutdown(){const l=this.window;!l||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(l.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{l.close()}catch{}this.window=void 0},0))}send(l,...s){if(!this.isAlive()){this.logService.warn(`Sending IPC message to channel '${l}' for shared process window that is destroyed`);return}try{this.window?.webContents.send(l,...s)}catch(r){this.logService.warn(`Error sending IPC message to channel '${l}' of shared process: ${(0,m.toErrorMessage)(r)}`)}}whenReady(){return this._whenReady||(this._whenReady=new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),l()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(l=>t.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),l()}))})()),this._whenIpcReady}createWindow(){const l=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new E.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",B).fsPath,additionalArguments:[`--vscode-window-config=${l.resource.toString()}`,"--vscode-window-kind=shared-process"],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,images:!1,webgl:!1}}),l.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,profiles:this.userDataProfilesService.profiles,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:f.default,policiesData:this.policyService.serialize()}),this.window.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",B).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=l=>{this.logService.trace("SharedProcess#close prevented"),l.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(l,s)=>this._onDidError.fire({type:2,details:s})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(l,s,r)=>this._onDidError.fire({type:3,details:{reason:r,exitCode:s}})))}async connect(){await this.whenIpcReady;const l=(0,d.assertIsDefined)(this.window);return(0,w.connect)(l)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}isAlive(){const l=this.window;return l?!l.isDestroyed()&&!l.webContents.isDestroyed():!1}};g=fe([x(2,C.IEnvironmentMainService),x(3,y.IUserDataProfilesService),x(4,P.ILifecycleMainService),x(5,S.ILogService),x(6,I.IPolicyService),x(7,p.IThemeMainService),x(8,u.IProtocolMainService)],g),e.SharedProcess=g}),define(X[111],J([0,1,8,3,2,70,13,97,5,40]),function(B,e,E,t,D,R,M,b,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";e.IStorageService=(0,d.createDecorator)("storageService");var P;(function(I){I[I.NONE=0]="NONE",I[I.SHUTDOWN=1]="SHUTDOWN"})(P=e.WillSaveStateReason||(e.WillSaveStateReason={}));var S;(function(I){I[I.APPLICATION=-1]="APPLICATION",I[I.PROFILE=0]="PROFILE",I[I.WORKSPACE=1]="WORKSPACE"})(S=e.StorageScope||(e.StorageScope={}));var f;(function(I){I[I.USER=0]="USER",I[I.MACHINE=1]="MACHINE"})(f=e.StorageTarget||(e.StorageTarget={}));class u extends D.Disposable{constructor(g={flushInterval:u.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new t.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new t.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new t.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new E.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,E.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,R.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,h){if(h===C){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:h,target:this.getKeyTargets(g)[h]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,h,l){return this.getStorage(h)?.get(g,l)}getBoolean(g,h,l){return this.getStorage(h)?.getBoolean(g,l)}getNumber(g,h,l){return this.getStorage(h)?.getNumber(g,l)}store(g,h,l,s){if((0,M.isUndefinedOrNull)(h)){this.remove(g,l);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,l,s),this.getStorage(l)?.set(g,h)})}remove(g,h){this.withPausedEmitters(()=>{this.updateKeyTarget(g,h,void 0),this.getStorage(h)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,h){const l=[],s=this.getKeyTargets(g);for(const r of Object.keys(s))s[r]===h&&l.push(r);return l}updateKeyTarget(g,h,l){const s=this.getKeyTargets(h);typeof l=="number"?s[g]!==l&&(s[g]=l,this.getStorage(h)?.set(C,JSON.stringify(s))):typeof s[g]=="number"&&(delete s[g],this.getStorage(h)?.set(C,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const h=this.get(C,g);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(e.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this._onWillSaveState.fire({reason:g});const h=this.getStorage(-1),l=this.getStorage(0),s=this.getStorage(1);switch(g){case P.NONE:await E.Promises.settled([h?.whenFlushed()??Promise.resolve(),l?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await E.Promises.settled([h?.flush(0)??Promise.resolve(),l?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,h=this.getStorage(0)?.items??new Map,l=this.getStorage(1)?.items??new Map;return y(g,h,l,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,h){return this.emitWillSaveState(P.NONE),(0,w.isUserDataProfile)(g)?this.switchToProfile(g,h):this.switchToWorkspace(g,h)}canSwitchProfile(g,h){return!(g.id===h.id||p(h)&&p(g))}switchData(g,h,l,s){this.withPausedEmitters(()=>{if(s)for(const[r,n]of g)h.set(r,n);else{const r=new Set;for(const[n,i]of g)r.add(n),h.get(n)!==i&&this.emitDidChangeValue(l,n);for(const[n]of h.items)r.has(n)||this.emitDidChangeValue(l,n)}})}}e.AbstractStorageService=u,u.DEFAULT_FLUSH_INTERVAL=60*1e3;function p(I){return I.isDefault||!!I.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class m extends u{constructor(){super();this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=m;async function y(I,g,h,l,s,r){const n=F=>{try{return JSON.parse(F)}catch{return F}},i=new Map,o=new Map;I.forEach((F,j)=>{i.set(j,F),o.set(j,n(F))});const a=new Map,c=new Map;g.forEach((F,j)=>{a.set(j,F),c.set(j,n(F))});const v=new Map,k=new Map;h.forEach((F,j)=>{v.set(j,F),k.set(j,n(F))}),console.group(l!==s?`Storage: Application (path: ${l})`:`Storage: Application & Profile (path: ${l}, default profile)`);const L=[];if(i.forEach((F,j)=>{L.push({key:j,value:F})}),console.table(L),console.groupEnd(),console.log(o),l!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const F=[];a.forEach((j,ee)=>{F.push({key:ee,value:j})}),console.table(F),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const O=[];v.forEach((F,j)=>{O.push({key:j,value:F})}),console.table(O),console.groupEnd(),console.log(k)}e.logStorage=y}),define(X[244],J([0,1,25,8,3,2,9,78,7,23,97,142,6,111,35,24]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class m extends R.Disposable{constructor(r,n){super();this.logService=r,this.fileService=n,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new D.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this._storage=new C.Storage(new C.InMemoryStorageDatabase),this.initializePromise=void 0,this.whenInitPromise=new t.DeferredPromise,this.whenInit=this.whenInitPromise.p,this.state=C.StorageState.None}get storage(){return this._storage}init(){return this.initializePromise||(this.initializePromise=(async()=>{if(this.state===C.StorageState.None)try{const r=await this.doCreate();this._storage.dispose(),this._storage=r,this._register(r.onDidChangeStorage(i=>this._onDidChangeStorage.fire({key:i}))),await this.doInit(r);const n=r.getBoolean(f.IS_NEW_KEY);n===void 0?r.set(f.IS_NEW_KEY,!0):n&&r.set(f.IS_NEW_KEY,!1)}catch(r){this.logService.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.state=C.StorageState.Initialized,this.whenInitPromise.complete()}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===S.LogLevel.Trace?r=>this.logService.trace(r):void 0,logError:r=>this.logService.error(r)}}doInit(r){return r.init()}get items(){return this._storage.items}get(r,n){return this._storage.get(r,n)}set(r,n){return this._storage.set(r,n)}delete(r){return this._storage.delete(r)}async close(){const r=new b.StopWatch(!1);await this.doClose(),r.stop(),r.elapsed()>m.LOG_SLOW_CLOSE_THRESHOLD&&await this.logSlowClose(r),this._onDidCloseStorage.fire()}async logSlowClose(r){if(!!this.path)try{const n=(0,E.top)(Array.from(this._storage.items.entries()).map(([o,a])=>({key:o,length:a.length})),(o,a)=>a.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),i=(await this.fileService.stat(d.URI.file(this.path))).size;this.logService.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${i}b, Large Keys: ${n}`)}catch(n){this.logService.error("[storage main] figuring out stats for slow DB on close() resulted in an error",n)}}async doClose(){this.initializePromise&&await this.initializePromise,this.state=C.StorageState.Closed,await this._storage.close()}}m.LOG_SLOW_CLOSE_THRESHOLD=2e3;class y extends m{constructor(r,n,i,o){super(i,o);this.profile=r,this.options=n}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.profile.globalStorageHome.fsPath,y.STORAGE_NAME)}async doCreate(){return new C.Storage(new P.SQLiteStorageDatabase(this.path??P.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.createLoggingOptions()}))}}y.STORAGE_NAME="state.vscdb";class I extends y{constructor(r,n,i,o){super(r,n,i,o)}}e.ProfileStorageMain=I;class g extends y{constructor(r,n,i,o){super(n.defaultProfile,r,i,o)}async doInit(r){await super.doInit(r),this.updateTelemetryState(r)}updateTelemetryState(r){r.get(u.firstSessionDateStorageKey,void 0)===void 0&&r.set(u.firstSessionDateStorageKey,new Date().toUTCString());const i=r.get(u.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();r.set(u.lastSessionDateStorageKey,typeof i=="undefined"?null:i),r.set(u.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=g;class h extends m{constructor(r,n,i,o,a){super(i,a);this.workspace=r,this.options=n,this.environmentService=o}get path(){if(!this.options.useInMemoryStorage)return(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id,h.WORKSPACE_STORAGE_NAME)}async doCreate(){const{storageFilePath:r,wasCreated:n}=await this.prepareWorkspaceStorageFolder();return new C.Storage(new P.SQLiteStorageDatabase(r,{logging:this.createLoggingOptions()}),{hint:n?C.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:P.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const r=(0,M.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),n=(0,M.join)(r,h.WORKSPACE_STORAGE_NAME);return await w.Promises.exists(r)?{storageFilePath:n,wasCreated:!1}:(await w.Promises.mkdir(r,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(r),{storageFilePath:n,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(r){let n;if((0,p.isSingleFolderWorkspaceIdentifier)(this.workspace)?n={folder:this.workspace.uri.toString()}:(0,p.isWorkspaceIdentifier)(this.workspace)&&(n={workspace:this.workspace.configPath.toString()}),n)try{const i=(0,M.join)(r,h.WORKSPACE_META_NAME);await w.Promises.exists(i)||await w.Promises.writeFile(i,JSON.stringify(n,void 0,2))}catch(i){this.logService.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${i}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json";class l extends m{get path(){}async doCreate(){return new C.Storage(new C.InMemoryStorageDatabase)}}e.InMemoryStorageMain=l}),define(X[245],J([0,1,66,39,15,6,215,62,40]),function(B,e,E,t,D,R,M,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=void 0;let w=class It extends d.UserDataProfilesService{constructor(P,S,f,u,p){super(f,u,S,p);this.stateService=P}getStoredProfiles(){return(0,E.revive)(this.stateService.getItem(It.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,E.revive)(this.stateService.getItem(It.PROFILE_ASSOCIATIONS_KEY,{}))}};w=fe([x(0,M.IStateService),x(1,b.IUriIdentityService),x(2,t.IEnvironmentService),x(3,D.IFileService),x(4,R.ILogService)],w),e.UserDataProfilesService=w}),define(X[63],J([0,1,7,39,15,5,6,45,62,40,245]),function(B,e,E,t,D,R,M,b,d,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,R.refineServiceDecorator)(w.IUserDataProfilesService);let P=class bt extends C.UserDataProfilesService{constructor(f,u,p,m,y){super(f,u,p,m,y);this.stateMainService=f}isEnabled(){return this.enabled}saveStoredProfiles(f){this.stateMainService.setItem(bt.PROFILES_KEY,f)}saveStoredProfileAssociations(f){this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,f)}getStoredProfileAssociations(){const f="workspaceAndProfileInfo",u=this.stateMainService.getItem(f,void 0);if(u){this.stateMainService.removeItem(f);const p=u.reduce((m,{workspace:y,profile:I})=>(m[E.URI.revive(y).toString()]=E.URI.revive(I).toString(),m),{});this.stateMainService.setItem(bt.PROFILE_ASSOCIATIONS_KEY,{workspaces:p})}return super.getStoredProfileAssociations()}};P=fe([x(0,b.IStateMainService),x(1,d.IUriIdentityService),x(2,t.IEnvironmentService),x(3,D.IFileService),x(4,M.ILogService)],P),e.UserDataProfilesMainService=P}),define(X[246],J([0,1,2,100,63]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitHandler=void 0;let R=class extends E.Disposable{constructor(b,d){super();this.defaultExtensionsProfileInitService=b,this._register(d.onWillCreateProfile(w=>{d.profiles.length===1&&w.join(this.defaultExtensionsProfileInitService.initialize())})),this._register(d.onDidChangeProfiles(w=>{d.profiles.length===1&&this.defaultExtensionsProfileInitService.uninitialize()}))}};R=fe([x(0,t.IDefaultExtensionsProfileInitService),x(1,D.IUserDataProfilesMainService)],R),e.DefaultExtensionsProfileInitHandler=R}),define(X[88],J([0,1,48,2,39,15,5,22,6,111,244,40,63]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let f=class extends t.Disposable{constructor(m,y,I,g,h){super();this.logService=m,this.environmentService=y,this.userDataProfilesService=I,this.lifecycleMainService=g,this.fileService=h,this.shutdownReason=void 0,this.applicationStorage=this.createApplicationStorage(),this.mapProfileToStorage=new Map,this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.applicationStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(m=>{m.window.profile&&this.profileStorage(m.window.profile).init(),m.workspace&&this.workspaceStorage(m.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(m=>{this.logService.trace("storageMainService#onWillShutdown()"),this.shutdownReason=m.reason,m.join(this.applicationStorage.close());for(const[,y]of this.mapProfileToStorage)m.join(y.close());for(const[,y]of this.mapWorkspaceToStorage)m.join(y.close())})),this._register(this.userDataProfilesService.onWillCreateProfile(m=>{m.join((async()=>{await this.fileService.exists(m.profile.globalStorageHome)||await this.fileService.createFolder(m.profile.globalStorageHome)})())})),this._register(this.userDataProfilesService.onWillRemoveProfile(m=>{const y=this.mapProfileToStorage.get(m.profile.id);y&&m.join(y.close())}))}createApplicationStorage(){this.logService.trace("StorageMainService: creating application storage");const m=new C.ApplicationStorageMain(this.getStorageOptions(),this.userDataProfilesService,this.logService,this.fileService);return(0,E.once)(m.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed application storage")}),m}profileStorage(m){if((0,w.isProfileUsingDefaultStorage)(m))return this.applicationStorage;let y=this.mapProfileToStorage.get(m.id);return y||(this.logService.trace(`StorageMainService: creating profile storage (${m.name})`),y=this.createProfileStorage(m),this.mapProfileToStorage.set(m.id,y),(0,E.once)(y.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed profile storage (${m.name})`),this.mapProfileToStorage.delete(m.id)})),y}createProfileStorage(m){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.ProfileStorageMain(m,this.getStorageOptions(),this.logService,this.fileService)}workspaceStorage(m){let y=this.mapWorkspaceToStorage.get(m.id);return y||(this.logService.trace(`StorageMainService: creating workspace storage (${m.id})`),y=this.createWorkspaceStorage(m),this.mapWorkspaceToStorage.set(m.id,y),(0,E.once)(y.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${m.id})`),this.mapWorkspaceToStorage.delete(m.id)})),y}createWorkspaceStorage(m){return this.shutdownReason===2?new C.InMemoryStorageMain(this.logService,this.fileService):new C.WorkspaceStorageMain(m,this.getStorageOptions(),this.logService,this.environmentService,this.fileService)}};f=fe([x(0,d.ILogService),x(1,D.IEnvironmentService),x(2,S.IUserDataProfilesMainService),x(3,b.ILifecycleMainService),x(4,R.IFileService)],f),e.StorageMainService=f,e.IApplicationStorageMainService=(0,M.createDecorator)("applicationStorageMainService");let u=class extends w.AbstractStorageService{constructor(m,y){super();this.userDataProfilesService=m,this.storageMainService=y,this.whenReady=this.storageMainService.applicationStorage.whenInit}doInitialize(){return this.storageMainService.applicationStorage.whenInit}getStorage(m){if(m===-1)return this.storageMainService.applicationStorage.storage}getLogDetails(m){if(m===-1)return this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath}shouldFlushWhenIdle(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}switchToProfile(){throw new Error("Switching storage profile is unsupported from main process")}switchToWorkspace(){throw new Error("Switching storage workspace is unsupported from main process")}};u=fe([x(0,P.IUserDataProfilesService),x(1,e.IStorageMainService)],u),e.ApplicationStorageMainService=u}),define(X[112],J([0,1,16,7,24]),function(B,e,E,t,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function R(d,w,C){for(const S of d){const f=S.openedWorkspace;if((0,D.isWorkspaceIdentifier)(f)){const u=C(f);if(u){if(u.folders.some(p=>E.extUriBiasedIgnorePathCase.isEqualOrParent(w,p.uri)))return S}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(w,f.configPath))return S}}const P=d.filter(S=>(0,D.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(w,S.openedWorkspace.uri));if(P.length)return P.sort((S,f)=>-(S.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=R;function M(d,w){for(const C of d)if((0,D.isWorkspaceIdentifier)(C.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.configPath,w)||(0,D.isSingleFolderWorkspaceIdentifier)(C.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(C.openedWorkspace.uri,w))return C}e.findWindowOnWorkspaceOrFolder=M;function b(d,w){const C=P=>w.some(S=>E.extUriBiasedIgnorePathCase.isEqual(t.URI.file(S),t.URI.file(P)));for(const P of d)if(P.config?.extensionDevelopmentPath?.some(S=>C(S)))return P}e.findWindowOnExtensionDevelopmentPath=b}),define(X[247],J([0,1,14,2,4,16,7,18,22,6,45,32,110,24]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let u=class kt extends t.Disposable{constructor(h,l,s,r,n){super();this.windowsMainService=h,this.stateMainService=l,this.lifecycleMainService=s,this.logService=r,this.configurationService=n,this._state=p(this.stateMainService.getItem(kt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){E.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(h=>this.onBeforeCloseWindow(h)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(h=>{h.newCount-h.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(h=>this.onBeforeCloseWindow(h))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const h={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!h.lastActiveWindow){let r=this.windowsMainService.getLastActiveWindow();(!r||r.isExtensionDevelopmentHost)&&(r=this.windowsMainService.getWindows().find(n=>!n.isExtensionDevelopmentHost)),r&&(h.lastActiveWindow=this.toWindowState(r))}const l=this.windowsMainService.getWindows().find(r=>r.isExtensionDevelopmentHost&&!r.isExtensionTestHost);l&&(h.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(h.openedWindows=this.windowsMainService.getWindows().filter(r=>!r.isExtensionDevelopmentHost).map(r=>this.toWindowState(r)));const s=y(h);this.stateMainService.setItem(kt.windowsStateStorageKey,s),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",s)}onBeforeCloseWindow(h){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(h);h.isExtensionDevelopmentHost&&!h.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!h.isExtensionDevelopmentHost&&h.openedWorkspace&&this._state.openedWindows.forEach(s=>{const r=(0,f.isWorkspaceIdentifier)(h.openedWorkspace)&&s.workspace?.id===h.openedWorkspace.id,n=(0,f.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)&&s.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(s.folderUri,h.openedWorkspace.uri);(r||n)&&(s.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(h){return{workspace:(0,f.isWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(h.openedWorkspace)?h.openedWorkspace.uri:void 0,backupPath:h.backupPath,remoteAuthority:h.remoteAuthority,uiState:h.serializeWindowState()}}getNewWindowState(h){const l=this.doGetNewWindowState(h),s=this.configurationService.getValue("window");let r;return l.hasDefaultState?r=!!(s?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(s.newWindowDimensions)>=0):(r=!!(this.lifecycleMainService.wasRestarted||s?.restoreFullscreen),r&&D.isMacintosh&&this.windowsMainService.getWindows().some(n=>n.isFullScreen)&&(r=!1)),l.mode===3&&!r&&(l.mode=1),l}doGetNewWindowState(h){const l=this.windowsMainService.getLastActiveWindow();if(!h.extensionTestsPath){if(!!h.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=h.workspace;if((0,f.isWorkspaceIdentifier)(a)){const v=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===a.id).map(k=>k.uiState);if(v.length)return v[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(a)){const v=this.state.openedWindows.filter(k=>k.folderUri&&R.extUriBiasedIgnorePathCase.isEqual(k.folderUri,a.uri)).map(k=>k.uiState);if(v.length)return v[0]}else if(h.backupPath){const v=this.state.openedWindows.filter(k=>k.backupPath===h.backupPath).map(k=>k.uiState);if(v.length)return v[0]}const c=this.lastClosedState||this.state.lastActiveWindow;if(!l&&c)return c.uiState}let s;const r=E.screen.getAllDisplays();if(r.length===1)s=r[0];else{if(D.isMacintosh){const a=E.screen.getCursorScreenPoint();s=E.screen.getDisplayNearestPoint(a)}!s&&l&&(s=E.screen.getDisplayMatching(l.getBounds())),s||(s=E.screen.getPrimaryDisplay()||r[0])}let n=(0,S.defaultWindowState)();n.x=Math.round(s.bounds.x+s.bounds.width/2-n.width/2),n.y=Math.round(s.bounds.y+s.bounds.height/2-n.height/2);const i=this.configurationService.getValue("window");let o=!0;if(i?.newWindowDimensions){if(i.newWindowDimensions==="maximized")n.mode=0,o=!1;else if(i.newWindowDimensions==="fullscreen")n.mode=3,o=!1;else if((i.newWindowDimensions==="inherit"||i.newWindowDimensions==="offset")&&l){const a=l.serializeWindowState();a.mode===3?n.mode=3:n=a,o=n.mode!==3&&i.newWindowDimensions==="offset"}}return o&&(n=this.ensureNoOverlap(n)),n.hasDefaultState=!0,n}ensureNoOverlap(h){if(this.windowsMainService.getWindows().length===0)return h;h.x=typeof h.x=="number"?h.x:0,h.y=typeof h.y=="number"?h.y:0;const l=this.windowsMainService.getWindows().map(s=>s.getBounds());for(;l.some(s=>s.x===h.x||s.y===h.y);)h.x+=30,h.y+=30;return h}};u.windowsStateStorageKey="windowsState",u=fe([x(0,P.IWindowsMainService),x(1,C.IStateMainService),x(2,d.ILifecycleMainService),x(3,w.ILogService),x(4,b.IConfigurationService)],u),e.WindowsStateHandler=u;function p(g){const h={openedWindows:[]},l=g||{openedWindows:[]};return l.lastActiveWindow&&(h.lastActiveWindow=m(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(h.lastPluginDevelopmentHostWindow=m(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(h.openedWindows=l.openedWindows.map(s=>m(s))),h}e.restoreWindowsState=p;function m(g){const h={uiState:g.uiState};return g.backupPath&&(h.backupPath=g.backupPath),g.remoteAuthority&&(h.remoteAuthority=g.remoteAuthority),g.folder&&(h.folderUri=M.URI.parse(g.folder)),g.workspaceIdentifier&&(h.workspace={id:g.workspaceIdentifier.id,configPath:M.URI.parse(g.workspaceIdentifier.configURIPath)}),h}function y(g){return{lastActiveWindow:g.lastActiveWindow&&I(g.lastActiveWindow),lastPluginDevelopmentHostWindow:g.lastPluginDevelopmentHostWindow&&I(g.lastPluginDevelopmentHostWindow),openedWindows:g.openedWindows.map(h=>I(h))}}e.getWindowsStateStoreData=y;function I(g){return{workspaceIdentifier:g.workspace&&{id:g.workspace.id,configURIPath:g.workspace.configPath.toString()},folder:g.folderUri&&g.folderUri.toString(),backupPath:g.backupPath,remoteAuthority:g.remoteAuthority,uiState:g.uiState}}}),define(X[89],J([0,1,30,49,120,34,12,9,4,16,7,5,71,24]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,P.createDecorator)("workspacesService");function u(k){return k.hasOwnProperty("workspace")}e.isRecentWorkspace=u;function p(k){return k.hasOwnProperty("folderUri")}e.isRecentFolder=p;function m(k){return k.hasOwnProperty("fileUri")}e.isRecentFile=m;function y(k){return I(k)||g(k)}e.isStoredWorkspaceFolder=y;function I(k){const L=k;return typeof L?.path=="string"&&(!L.name||typeof L.name=="string")}function g(k){const L=k;return typeof L?.uri=="string"&&(!L.name||typeof L.name=="string")}function h(k,L,O,F,j=!d.isWindows,ee){if(k.scheme!==F.scheme)return{name:O,uri:k.toString(!0)};let se=L?void 0:ee.relativePath(F,k);if(se!==void 0)se.length===0?se=".":d.isWindows&&k.scheme===M.Schemas.file&&!j&&(se=se.replace(/\//g,"\\"));else if(k.scheme===M.Schemas.file)se=k.fsPath,d.isWindows&&(se=(0,R.normalizeDriveLetter)(se),j&&(se=(0,E.toSlashes)(se)));else{if(!ee.isEqualAuthority(k.authority,F.authority))return{name:O,uri:k.toString(!0)};se=k.path}return{name:O,path:se}}e.getStoredWorkspaceFolder=h;function l(k,L,O){const F=[],j=new Set,ee=O.dirname(L);for(const se of k){let ae;if(I(se))se.path&&(ae=O.resolvePath(ee,se.path));else if(g(se))try{ae=C.URI.parse(se.uri),ae.path[0]!=="/"&&(ae=ae.with({path:"/"+ae.path}))}catch(ie){console.warn(ie)}if(ae){const ie=O.getComparisonKey(ae);if(!j.has(ie)){j.add(ie);const ce=se.name||O.basenameOrAuthority(ae);F.push(new f.WorkspaceFolder({uri:ae,name:ce,index:F.length},se))}}}return F}e.toWorkspaceFolders=l;function s(k,L,O,F,j){const ee=r(L,k),se=j.dirname(L),ae=j.dirname(F),ie=[],ce=n(ee.folders);for(const T of ee.folders){const N=I(T)?j.resolvePath(se,T.path):C.URI.parse(T.uri);let V;O?V=!1:V=!I(T)||(0,b.isAbsolute)(T.path),ie.push(h(N,V,T.name,ae,ce,j))}const H={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},re=D.setProperty(k,["folders"],ie,H);let q=D.applyEdits(k,re);return(0,w.isEqualAuthority)(ee.remoteAuthority,(0,S.getRemoteAuthority)(F))&&(q=D.applyEdits(q,D.removeProperty(q,["remoteAuthority"],H))),q}e.rewriteWorkspaceFileForNewLocation=s;function r(k,L){const O=t.parse(L);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(F=>y(F));else throw new Error(`${k} looks like an invalid workspace file.`);return O}function n(k){return d.isWindows?k.some(L=>I(L)&&L.path.indexOf("/")>=0):!0}e.useSlashForPath=n;function i(k){return k.workspace&&typeof k.workspace=="object"&&typeof k.workspace.id=="string"&&typeof k.workspace.configPath=="string"}function o(k){return typeof k.folderUri=="string"}function a(k){return typeof k.fileUri=="string"}function c(k,L){const O={workspaces:[],files:[]};if(k){const F=function(ee,se){for(let ae=0;ae<ee.length;ae++)try{se(ee[ae],ae)}catch(ie){L.warn(`Error restoring recent entry ${JSON.stringify(ee[ae])}: ${ie.toString()}. Skip entry.`)}},j=k;Array.isArray(j.entries)&&F(j.entries,ee=>{const se=ee.label,ae=ee.remoteAuthority;i(ee)?O.workspaces.push({label:se,remoteAuthority:ae,workspace:{id:ee.workspace.id,configPath:C.URI.parse(ee.workspace.configPath)}}):o(ee)?O.workspaces.push({label:se,remoteAuthority:ae,folderUri:C.URI.parse(ee.folderUri)}):a(ee)&&O.files.push({label:se,remoteAuthority:ae,fileUri:C.URI.parse(ee.fileUri)})})}return O}e.restoreRecentlyOpened=c;function v(k){const L={entries:[]};for(const O of k.workspaces)p(O)?L.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):L.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of k.files)L.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return L}e.toStoreData=v}),define(X[113],J([0,1,75,28,12,4,16]),function(B,e,E,t,D,R,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(w){function C(){let P=w.scheme===D.Schemas.file?(0,M.originalFSPath)(w):w.toString();return R.isLinux||(P=P.toLowerCase()),(0,E.createHash)("md5").update(P).digest("hex")}return{id:C(),configPath:w}}e.getWorkspaceIdentifier=b;function d(w,C){function P(){if(w.scheme!==D.Schemas.file)return(0,E.createHash)("md5").update(w.toString()).digest("hex");if(!C)try{C=(0,t.statSync)(w.fsPath)}catch{return}let f;return R.isLinux?f=C.ino:R.isMacintosh?f=C.birthtime.getTime():R.isWindows&&(typeof C.birthtimeMs=="number"?f=Math.floor(C.birthtimeMs):f=C.birthtime.getTime()),(0,E.createHash)("md5").update(w.fsPath).update(f?String(f):"").digest("hex")}const S=P();if(typeof S=="string")return{id:S,uri:w}}e.getSingleFolderWorkspaceIdentifier=d}),define(X[47],J([0,1,14,28,3,49,34,2,12,9,4,16,13,23,170,58,54,26,5,6,20,63,112,24,89,113]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s,r,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,I.createDecorator)("workspacesManagementMainService");let o=class extends b.Disposable{constructor(c,v,k,L,O,F){super();this.environmentMainService=c,this.logService=v,this.userDataProfilesMainService=k,this.backupMainService=L,this.dialogMainService=O,this.productService=F,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(c){return this.doResolveLocalWorkspace(c,v=>(0,t.readFileSync)(v,"utf8"))}resolveLocalWorkspace(c){return this.doResolveLocalWorkspace(c,v=>f.Promises.readFile(v,"utf8"))}doResolveLocalWorkspace(c,v){if(!!this.isWorkspacePath(c)&&c.scheme===d.Schemas.file)try{const k=v(c.fsPath);return k instanceof Promise?k.then(L=>this.doResolveWorkspace(c,L),L=>{}):this.doResolveWorkspace(c,k)}catch{return}}isWorkspacePath(c){return(0,r.isUntitledWorkspace)(c,this.environmentMainService)||(0,r.hasWorkspaceFileExtension)(c)}doResolveWorkspace(c,v){try{const k=this.doParseStoredWorkspace(c,v),L=(0,i.getWorkspaceIdentifier)(c);return{id:L.id,configPath:L.configPath,folders:(0,n.toWorkspaceFolders)(k.folders,L.configPath,P.extUriBiasedIgnorePathCase),remoteAuthority:k.remoteAuthority,transient:k.transient}}catch(k){this.logService.warn(k.toString())}}doParseStoredWorkspace(c,v){const k=(0,R.parse)(v);if(k&&Array.isArray(k.folders))k.folders=k.folders.filter(L=>(0,n.isStoredWorkspaceFolder)(L));else throw new Error(`${c.toString(!0)} looks like an invalid workspace file.`);return k}async createUntitledWorkspace(c,v){const{workspace:k,storedWorkspace:L}=this.newUntitledWorkspace(c,v),O=k.configPath.fsPath;return await f.Promises.mkdir((0,w.dirname)(O),{recursive:!0}),await f.Promises.writeFile(O,JSON.stringify(L,null,"	")),k}createUntitledWorkspaceSync(c,v){const{workspace:k,storedWorkspace:L}=this.newUntitledWorkspace(c,v),O=k.configPath.fsPath;return(0,t.mkdirSync)((0,w.dirname)(O),{recursive:!0}),(0,f.writeFileSync)(O,JSON.stringify(L,null,"	")),k}newUntitledWorkspace(c=[],v){const k=(Date.now()+Math.round(Math.random()*1e3)).toString(),L=(0,P.joinPath)(this.untitledWorkspacesHome,k),O=(0,P.joinPath)(L,r.UNTITLED_WORKSPACE_NAME),F=[];for(const j of c)F.push((0,n.getStoredWorkspaceFolder)(j.uri,!0,j.name,L,!C.isWindows,P.extUriBiasedIgnorePathCase));return{workspace:(0,i.getWorkspaceIdentifier)(O),storedWorkspace:{folders:F,remoteAuthority:v}}}async getWorkspaceIdentifier(c){return(0,i.getWorkspaceIdentifier)(c)}isUntitledWorkspace(c){return(0,r.isUntitledWorkspace)(c.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(c){!this.isUntitledWorkspace(c)||(this.doDeleteUntitledWorkspaceSync(c),this.userDataProfilesMainService.isEnabled()&&this.userDataProfilesMainService.unsetWorkspace(c),this._onDidDeleteUntitledWorkspace.fire(c))}async deleteUntitledWorkspace(c){this.deleteUntitledWorkspaceSync(c)}doDeleteUntitledWorkspaceSync(c){const v=(0,P.originalFSPath)(c.configPath);try{(0,f.rimrafSync)((0,w.dirname)(v));const k=(0,w.join)(this.environmentMainService.workspaceStorageHome.fsPath,c.id);(0,t.existsSync)(k)&&(0,f.writeFileSync)((0,w.join)(k,"obsolete"),"")}catch(k){this.logService.warn(`Unable to delete untitled workspace ${v} (${k}).`)}}getUntitledWorkspacesSync(){const c=[];try{const v=(0,f.readdirSync)(this.untitledWorkspacesHome.fsPath).map(k=>(0,P.joinPath)(this.untitledWorkspacesHome,k,r.UNTITLED_WORKSPACE_NAME));for(const k of v){const L=(0,i.getWorkspaceIdentifier)(k),O=this.resolveLocalWorkspaceSync(k);O?c.push({workspace:L,remoteAuthority:O.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(L)}}catch(v){v.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${v}).`)}return c}async enterWorkspace(c,v,k){if(!c||!c.win||!c.isReady||!await this.isValidTargetWorkspacePath(c,v,k))return;const O=this.doEnterWorkspace(c,(0,i.getWorkspaceIdentifier)(k));if(!!O)return this._onDidEnterWorkspace.fire({window:c,workspace:O.workspace}),O}async isValidTargetWorkspacePath(c,v,k){if(!k)return!0;if((0,r.isWorkspaceIdentifier)(c.openedWorkspace)&&P.extUriBiasedIgnorePathCase.isEqual(c.openedWorkspace.configPath,k))return!1;if((0,s.findWindowOnWorkspaceOrFolder)(v,k)){const L={title:this.productService.nameLong,type:"info",buttons:[(0,M.mnemonicButtonLabel)((0,u.localize)(0,null))],message:(0,u.localize)(1,null,(0,P.basename)(k)),detail:(0,u.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(L,(0,S.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(c,v){if(!c.config)return;c.focus();let k;return c.config.extensionDevelopmentPath||(k=this.backupMainService.registerWorkspaceBackupSync({workspace:v,remoteAuthority:c.remoteAuthority},c.config.backupPath)),(0,r.isWorkspaceIdentifier)(c.openedWorkspace)&&this.isUntitledWorkspace(c.openedWorkspace)&&this.deleteUntitledWorkspaceSync(c.openedWorkspace),c.config.workspace=v,c.config.backupPath=k,{workspace:v,backupPath:k}}};o=fe([x(0,y.IEnvironmentMainService),x(1,g.ILogService),x(2,l.IUserDataProfilesMainService),x(3,p.IBackupMainService),x(4,m.IDialogMainService),x(5,h.IProductService)],o),e.WorkspacesManagementMainService=o}),define(X[114],J([0,1,38,21,5,32,24,47]),function(B,e,E,t,D,R,M,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,D.createDecorator)(e.ID);let d=class{constructor(C,P){this.windowsMainService=C,this.workspacesManagementMainService=P}async getRemoteDiagnostics(C){const P=this.windowsMainService.getWindows();return(await Promise.all(P.map(f=>new Promise(u=>{const p=f.remoteAuthority;if(p){const m=`vscode:getDiagnosticInfoResponse${f.id}`,y={includeProcesses:C.includeProcesses,folders:C.includeWorkspaceMetadata?this.getFolderURIs(f):void 0};f.sendWhenReady("vscode:getDiagnosticInfo",t.CancellationToken.None,{replyChannel:m,args:y}),E.validatedIpcMain.once(m,(I,g)=>{g||u({hostName:p,errorMessage:`Unable to resolve connection to '${p}'.`}),u(g)}),setTimeout(()=>{u({hostName:p,errorMessage:`Connection to '${p}' could not be established`})},5e3)}else u(void 0)})))).filter(f=>!!f)}getFolderURIs(C){const P=[],S=C.openedWorkspace;if((0,M.isSingleFolderWorkspaceIdentifier)(S))P.push(S.uri);else if((0,M.isWorkspaceIdentifier)(S)){const f=this.workspacesManagementMainService.resolveLocalWorkspaceSync(S.configPath);f&&f.folders.forEach(p=>{P.push(p.uri)})}return P}};d=fe([x(0,R.IWindowsMainService),x(1,b.IWorkspacesManagementMainService)],d),e.DiagnosticsMainService=d}),define(X[115],J([0,1,14,25,4,13,7,23,18,57,5,6,109,32,24,47]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,C.createDecorator)(e.ID);let m=class{constructor(I,g,h,l,s){this.logService=I,this.windowsMainService=g,this.urlService=h,this.workspacesManagementMainService=l,this.configurationService=s}async start(I,g){this.logService.trace("Received data from other instance: ",I,g),D.isMacintosh&&E.app.focus({steal:!0});const h=this.parseOpenUrl(I);if(h.length){let l=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(l=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),l.then(()=>{for(const{uri:s,url:r}of h)this.urlService.open(s,{originalUrl:r})})}else return this.startOpenWindow(I,g)}parseOpenUrl(I){return I["open-url"]&&I._urls&&I._urls.length>0?(0,t.coalesce)(I._urls.map(g=>{try{return{uri:M.URI.parse(g),url:g}}catch{return null}})):[]}async startOpenWindow(I,g){const h=(0,w.isLaunchedFromCli)(g)?0:4;let l=[];const s=I.wait&&I.waitMarkerFilePath?M.URI.file(I.waitMarkerFilePath):void 0,r=I.remote||void 0,n={context:h,cli:I,userEnv:g,waitMarkerFileURI:s,remoteAuthority:r};if(I.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(I.extensionDevelopmentPath,n);else if(!I._.length&&!I["folder-uri"]&&!I["file-uri"]){let i=!1;if(I["new-window"]||I["unity-launch"])i=!0;else if(I["reuse-window"])i=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":i=!0;break;case"off":i=!1;break;default:i=!D.isMacintosh}if(i)l=this.windowsMainService.open({...n,forceNewWindow:!0,forceEmpty:!0});else{const o=this.windowsMainService.getLastActiveWindow();o?(this.windowsMainService.openExistingWindow(o,n),l=[o]):l=this.windowsMainService.open({...n,forceEmpty:!0})}}else l=this.windowsMainService.open({...n,forceNewWindow:I["new-window"],preferNewWindow:!I["reuse-window"]&&!I.wait,forceReuseWindow:I["reuse-window"],diffMode:I.diff,mergeMode:I.merge,addMode:I.add,noRecentEntry:!!I["skip-add-to-recently-opened"],gotoLineMode:I.goto});if(s&&l.length===1&&l[0])return Promise.race([l[0].whenClosedOrLoaded,(0,b.whenDeleted)(s.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const I=[];return E.BrowserWindow.getAllWindows().forEach(g=>{const h=this.windowsMainService.getWindowById(g.id);h?I.push(this.codeWindowToInfo(h)):I.push(this.browserWindowToInfo(g))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:I,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}getFolderURIs(I){const g=[],h=I.openedWorkspace;if((0,u.isSingleFolderWorkspaceIdentifier)(h))g.push(h.uri);else if((0,u.isWorkspaceIdentifier)(h)){const l=this.workspacesManagementMainService.resolveLocalWorkspaceSync(h.configPath);l&&l.folders.forEach(r=>{g.push(r.uri)})}return g}codeWindowToInfo(I){const g=this.getFolderURIs(I),h=(0,R.assertIsDefined)(I.win);return this.browserWindowToInfo(h,g,I.remoteAuthority)}browserWindowToInfo(I,g=[],h){return{pid:I.webContents.getOSProcessId(),title:I.getTitle(),folderURIs:g,remoteAuthority:h}}};m=fe([x(0,P.ILogService),x(1,f.IWindowsMainService),x(2,S.IURLService),x(3,p.IWorkspacesManagementMainService),x(4,d.IConfigurationService)],m),e.LaunchMainService=m}),define(X[64],J([0,1,42,14,29,138,51,3,34,2,12,9,4,7,93,80,23,90,160,54,26,5,22,6,20,61,32,24,47,17]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s,r,n,i,o,a,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let k=class extends w.Disposable{constructor(O,F,j,ee,se,ae,ie,ce,H){super();this.sharedProcess=O,this.windowsMainService=F,this.dialogMainService=j,this.lifecycleMainService=ee,this.environmentMainService=se,this.logService=ae,this.productService=ie,this.themeMainService=ce,this.workspacesManagementMainService=H,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,re=>re.id),this.onDidTriggerSystemContextMenu=b.Event.filter(b.Event.map(this.windowsMainService.onDidTriggerSystemContextMenu,({window:re,x:q,y:T})=>({windowId:re.id,x:q,y:T})),({windowId:re})=>!!this.windowsMainService.getWindowById(re)),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-maximize",(re,q)=>q.id),re=>!!this.windowsMainService.getWindowById(re)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-unmaximize",(re,q)=>q.id),re=>!!this.windowsMainService.getWindowById(re)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-blur",(re,q)=>q.id),re=>!!this.windowsMainService.getWindowById(re)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),re=>!!re),re=>re.id),b.Event.filter(b.Event.fromNodeEventEmitter(t.app,"browser-window-focus",(re,q)=>q.id),re=>!!this.windowsMainService.getWindowById(re))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(t.powerMonitor,"resume"),this.onDidChangeColorScheme=this.themeMainService.onDidChangeColorScheme,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(t.screen,"display-metrics-changed",(re,q,T)=>T),re=>!(Array.isArray(re)&&re.length===1&&re[0]==="workArea")),b.Event.fromNodeEventEmitter(t.screen,"display-added"),b.Event.fromNodeEventEmitter(t.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(F=>({id:F.id,workspace:F.openedWorkspace,title:F.win?.getTitle()??"",filename:F.getRepresentedFilename(),dirty:F.isDocumentEdited()}))}async getWindowCount(O){return this.windowsMainService.getWindowCount()}async getActiveWindowId(O){const F=t.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(F)return F.id}openWindow(O,F,j){return Array.isArray(F)?this.doOpenWindow(O,F,j):this.doOpenEmptyWindow(O,F)}async doOpenWindow(O,F,j=Object.create(null)){F.length>0&&this.windowsMainService.open({context:5,contextWindowId:O,urisToOpen:F,cli:this.environmentMainService.args,forceNewWindow:j.forceNewWindow,forceReuseWindow:j.forceReuseWindow,preferNewWindow:j.preferNewWindow,diffMode:j.diffMode,mergeMode:j.mergeMode,addMode:j.addMode,gotoLineMode:j.gotoLineMode,noRecentEntry:j.noRecentEntry,waitMarkerFileURI:j.waitMarkerFileURI,remoteAuthority:j.remoteAuthority||void 0})}async doOpenEmptyWindow(O,F){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:O},F)}async toggleFullScreen(O){this.windowById(O)?.toggleFullScreen()}async handleTitleDoubleClick(O){this.windowById(O)?.handleTitleDoubleClick()}async isMaximized(O){const F=this.windowById(O);return F?.win?F.win.isMaximized():!1}async maximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.maximize()}async unmaximizeWindow(O){const F=this.windowById(O);F?.win&&F.win.unmaximize()}async minimizeWindow(O){const F=this.windowById(O);F?.win&&F.win.minimize()}async updateTitleBarOverlay(O,F){const j=this.windowById(O);j?.win&&j.win.setTitleBarOverlay({color:F.backgroundColor?.trim()===""?void 0:F.backgroundColor,symbolColor:F.foregroundColor?.trim()===""?void 0:F.foregroundColor,height:F.height?F.height-1:void 0})}async focusWindow(O,F){F&&typeof F.windowId=="number"&&(O=F.windowId),this.windowById(O)?.focus({force:F?.force??!1})}async setMinimumSize(O,F,j){const ee=this.windowById(O);if(ee?.win){const[se,ae]=ee.win.getSize(),[ie,ce]=ee.win.getMinimumSize(),[H,re]=[F??ie,j??ce],[q,T]=[Math.max(se,H),Math.max(ae,re)];(ie!==H||ce!==re)&&ee.win.setMinimumSize(H,re),(se!==q||ae!==T)&&ee.win.setSize(q,T)}}async saveWindowSplash(O,F){this.themeMainService.saveWindowSplash(O,F)}async installShellCommand(O){const{source:F,target:j}=await this.getShellCommandLink();try{const{symbolicLink:ee}=await m.SymlinkSupport.stat(F);if(ee&&!ee.dangling){const se=await(0,u.realpath)(F);if(j===se)return}await m.Promises.unlink(F)}catch(ee){if(ee.code!=="ENOENT")throw ee}try{await m.Promises.symlink(j,F)}catch(ee){if(ee.code!=="EACCES"&&ee.code!=="ENOENT")throw ee;const{response:se}=await this.showMessageBox(O,{title:this.productService.nameLong,type:"info",message:(0,I.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,I.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,I.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(se===0)try{const ae=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${j}' '${F}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(ae)}catch{throw new Error((0,I.localize)(3,null,F))}}}async uninstallShellCommand(O){const{source:F}=await this.getShellCommandLink();try{await m.Promises.unlink(F)}catch(j){switch(j.code){case"EACCES":{const{response:ee}=await this.showMessageBox(O,{title:this.productService.nameLong,type:"info",message:(0,I.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,I.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,I.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(ee===0)try{const se=`osascript -e "do shell script \\"rm '${F}'\\" with administrator privileges"`;await(0,R.promisify)(E.exec)(se)}catch{throw new Error((0,I.localize)(7,null,F))}break}case"ENOENT":break;default:throw j}}}async getShellCommandLink(){const O=(0,P.resolve)(this.environmentMainService.appRoot,"bin","code"),F=`/usr/local/bin/${this.productService.applicationName}`;if(!await m.Promises.exists(O))throw new Error((0,I.localize)(8,null,O));return{source:F,target:O}}async showMessageBox(O,F){return this.dialogMainService.showMessageBox(F,this.toBrowserWindow(O))}async showSaveDialog(O,F){return this.dialogMainService.showSaveDialog(F,this.toBrowserWindow(O))}async showOpenDialog(O,F){return this.dialogMainService.showOpenDialog(F,this.toBrowserWindow(O))}toBrowserWindow(O){const F=this.windowById(O);if(F?.win)return F.win}async pickFileFolderAndOpen(O,F){const j=await this.dialogMainService.pickFileFolder(F);j&&this.doOpenPicked(await Promise.all(j.map(async ee=>await m.SymlinkSupport.existsDirectory(ee)?{folderUri:f.URI.file(ee)}:{fileUri:f.URI.file(ee)})),F,O)}async pickFolderAndOpen(O,F){const j=await this.dialogMainService.pickFolder(F);j&&this.doOpenPicked(j.map(ee=>({folderUri:f.URI.file(ee)})),F,O)}async pickFileAndOpen(O,F){const j=await this.dialogMainService.pickFile(F);j&&this.doOpenPicked(j.map(ee=>({fileUri:f.URI.file(ee)})),F,O)}async pickWorkspaceAndOpen(O,F){const j=await this.dialogMainService.pickWorkspace(F);j&&this.doOpenPicked(j.map(ee=>({workspaceUri:f.URI.file(ee)})),F,O)}doOpenPicked(O,F,j){this.windowsMainService.open({context:3,contextWindowId:j,cli:this.environmentMainService.args,urisToOpen:O,forceNewWindow:F.forceNewWindow})}async showItemInFolder(O,F){t.shell.showItemInFolder(F)}async setRepresentedFilename(O,F){this.windowById(O)?.setRepresentedFilename(F)}async setDocumentEdited(O,F){this.windowById(O)?.setDocumentEdited(F)}async openExternal(O,F){return S.isLinuxSnap?this.safeSnapOpenExternal(F):t.shell.openExternal(F),!0}safeSnapOpenExternal(O){const F=process.env.GDK_PIXBUF_MODULE_FILE,j=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,t.shell.openExternal(O),process.env.GDK_PIXBUF_MODULE_FILE=F,process.env.GDK_PIXBUF_MODULEDIR=j}moveItemToTrash(O,F){return t.shell.trashItem(F)}async isAdmin(){let O;return S.isWindows?O=(await new Promise((F,j)=>{B(["native-is-elevated"],F,j)}))():O=process.getuid()===0,O}async writeElevated(O,F,j,ee){const se=await new Promise((ae,ie)=>{B(["@vscode/sudo-prompt"],ae,ie)});return new Promise((ae,ie)=>{const ce=[`"${this.cliPath}"`];ee?.unlock&&ce.push("--file-chmod"),ce.push("--file-write",`"${F.fsPath}"`,`"${j.fsPath}"`);const H={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};se.exec(ce.join(" "),H,(re,q,T)=>{q&&this.logService.trace(`[sudo-prompt] received stdout: ${q}`),T&&this.logService.trace(`[sudo-prompt] received stderr: ${T}`),re?ie(re):ae(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,P.join)((0,P.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,P.join)(this.environmentMainService.appRoot,"bin","code"):(0,P.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return p.virtualMachineHint.value()}async getOSColorScheme(){return this.themeMainService.getColorScheme()}async killProcess(O,F,j){process.kill(F,j)}async readClipboardText(O,F){return t.clipboard.readText(F)}async writeClipboardText(O,F,j){return t.clipboard.writeText(F,j)}async readClipboardFindText(O){return t.clipboard.readFindText()}async writeClipboardFindText(O,F){return t.clipboard.writeFindText(F)}async writeClipboardBuffer(O,F,j,ee){return t.clipboard.writeBuffer(F,Buffer.from(j.buffer),ee)}async readClipboardBuffer(O,F){return v.VSBuffer.wrap(t.clipboard.readBuffer(F))}async hasClipboard(O,F,j){return t.clipboard.has(F,j)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){t.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){t.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){t.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){t.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){t.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(O,F){this.windowById(O)?.updateTouchBar(F)}async notifyReady(O){this.windowById(O)?.setReady()}async relaunch(O,F){return this.lifecycleMainService.relaunch(F)}async reload(O,F){const j=this.windowById(O);if(j){if((0,a.isWorkspaceIdentifier)(j.openedWorkspace)){const ee=j.openedWorkspace.configPath;if(ee.scheme===C.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(ee))?.transient)return this.openWindow(j.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(j,F?.disableExtensions!==void 0?{_:[],"disable-extensions":F.disableExtensions}:void 0)}}async closeWindow(O){this.closeWindowById(O,O)}async closeWindowById(O,F){const j=this.windowById(F);if(j?.win)return j.win.close()}async quit(O){const F=this.windowsMainService.getLastActiveWindow();F?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&F.win?F.win.close():this.lifecycleMainService.quit()}async exit(O,F){await this.lifecycleMainService.kill(F)}async resolveProxy(O,F){const ee=this.windowById(O)?.win?.webContents?.session;if(ee)return ee.resolveProxy(F)}findFreePort(O,F,j,ee,se=1){return(0,y.findFreePort)(F,j,ee,se)}async openDevTools(O,F){const j=this.windowById(O);j?.win&&j.win.webContents.openDevTools(F)}async toggleDevTools(O){const F=this.windowById(O);F?.win&&F.win.webContents.toggleDevTools()}async sendInputEvent(O,F){const j=this.windowById(O);j?.win&&(F.type==="mouseDown"||F.type==="mouseUp")&&j.win.webContents.sendInputEvent(F)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(O,F,j,ee){if(!S.isWindows)return;const se=await new Promise((ae,ie)=>{B(["@vscode/windows-registry"],ae,ie)});try{return se.GetStringRegKey(F,j,ee)}catch{return}}windowById(O){if(typeof O=="number")return this.windowsMainService.getWindowById(O)}};fe([M.memoize],k.prototype,"cliPath",null),k=fe([x(1,o.IWindowsMainService),x(2,g.IDialogMainService),x(3,s.ILifecycleMainService),x(4,h.IEnvironmentMainService),x(5,r.ILogService),x(6,n.IProductService),x(7,i.IThemeMainService),x(8,c.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(X[248],J([0,1,14,38,29,34,2,12,4,94,158,83,114,54,26,5,115,6,64,52,20,59,73]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,p.createDecorator)("issueMainService");let r=class Rt{constructor(i,o,a,c,v,k,L,O,F,j){this.userEnv=i,this.environmentMainService=o,this.launchMainService=a,this.logService=c,this.diagnosticsService=v,this.diagnosticsMainService=k,this.dialogMainService=L,this.nativeHostMainService=O,this.protocolMainService=F,this.productService=j,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){t.validatedIpcMain.on("vscode:issueSystemInfoRequest",async i=>{const[o,a]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),c=await this.diagnosticsService.getSystemInfo(o,a);this.safeSend(i,"vscode:issueSystemInfoResponse",c)}),t.validatedIpcMain.on("vscode:listProcesses",async i=>{const o=[];try{const a=await this.launchMainService.getMainProcessId();o.push({name:(0,C.localize)(0,null),rootProcess:await(0,w.listProcesses)(a)}),(await this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(v=>{(0,P.isRemoteDiagnosticError)(v)?o.push({name:v.hostName,rootProcess:v}):v.processes&&o.push({name:v.hostName,rootProcess:v.processes})})}catch(a){this.logService.error(`Listing processes failed: ${a}`)}this.safeSend(i,"vscode:listProcessesResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterClipboard",async i=>{const o={title:this.productService.nameLong,message:(0,C.localize)(1,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(2,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const a=await this.dialogMainService.showMessageBox(o,this.issueReporterWindow);this.safeSend(i,"vscode:issueReporterClipboardResponse",a.response===0)}}),t.validatedIpcMain.on("vscode:issuePerformanceInfoRequest",async i=>{const o=await this.getPerformanceInfo();this.safeSend(i,"vscode:issuePerformanceInfoResponse",o)}),t.validatedIpcMain.on("vscode:issueReporterConfirmClose",async()=>{const i={title:this.productService.nameLong,message:(0,C.localize)(4,null),type:"warning",buttons:[(0,R.mnemonicButtonLabel)((0,C.localize)(5,null)),(0,R.mnemonicButtonLabel)((0,C.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(i,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),t.validatedIpcMain.on("vscode:workbenchCommand",(i,o)=>{const{id:a,from:c,args:v}=o;let k;switch(c){case"issueReporter":k=this.issueReporterParentWindow;break;case"processExplorer":k=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${c}`)}k?.webContents.send("vscode:runAction",{id:a,from:c,args:v})}),t.validatedIpcMain.on("vscode:openExternal",(i,o)=>{this.nativeHostMainService.openExternal(void 0,o)}),t.validatedIpcMain.on("vscode:closeIssueReporter",i=>{this.issueReporterWindow?.close()}),t.validatedIpcMain.on("vscode:closeProcessExplorer",i=>{this.processExplorerWindow?.close()}),t.validatedIpcMain.on("vscode:windowsInfoRequest",async i=>{const o=await this.launchMainService.getMainProcessInfo();this.safeSend(i,"vscode:windowsInfoResponse",o.windows)})}safeSend(i,o,...a){i.sender.isDestroyed()||i.sender.send(o,...a)}async openReporter(i){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=E.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const o=new M.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(c,a,{backgroundColor:i.styles.backgroundColor,title:(0,C.localize)(7,null),zoomLevel:i.zoomLevel,alwaysOnTop:!1},"issue-reporter"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:i,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,D.type)(),arch:(0,D.arch)(),release:(0,D.release)()},product:g.default}),this.issueReporterWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",B).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,o.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,o.dispose())})}this.issueReporterWindow&&this.focusWindow(this.issueReporterWindow)}async openProcessExplorer(i){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=E.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const o=new M.DisposableStore,a=o.add(this.protocolMainService.createIPCObjectUrl()),c=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(c,a,{backgroundColor:i.styles.backgroundColor,title:(0,C.localize)(8,null),zoomLevel:i.zoomLevel,alwaysOnTop:!0},"process-explorer"),a.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:i,product:g.default}),this.processExplorerWindow.loadURL(b.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",B).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,o.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,o.dispose())})}this.processExplorerWindow&&this.focusWindow(this.processExplorerWindow)}focusWindow(i){i.isMinimized()&&i.restore(),i.focus()}createBrowserWindow(i,o,a,c){const v=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:i.width,height:i.height,minWidth:300,minHeight:200,x:i.x,y:i.y,title:a.title,backgroundColor:a.backgroundColor||Rt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:b.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",B).fsPath,additionalArguments:[`--vscode-window-config=${o.resource.toString()}`,`--vscode-window-kind=${c}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.zoomLevelToZoomFactor)(a.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:a.alwaysOnTop,experimentalDarkMode:!0});return v.setMenuBarVisibility(!1),v}async getSystemStatus(){const[i,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(i,o)}getWindowPosition(i,o,a){let c;const v=E.screen.getAllDisplays();if(v.length===1)c=v[0];else{if(d.isMacintosh){const O=E.screen.getCursorScreenPoint();c=E.screen.getDisplayNearestPoint(O)}!c&&i&&(c=E.screen.getDisplayMatching(i.getBounds())),c||(c=E.screen.getPrimaryDisplay()||v[0])}const k={width:o,height:a},L=c.bounds;return k.x=L.x+L.width/2-k.width/2,k.y=L.y+L.height/2-k.height/2,L.width>0&&L.height>0&&(k.x<L.x&&(k.x=L.x),k.y<L.y&&(k.y=L.y),k.x>L.x+L.width&&(k.x=L.x),k.y>L.y+L.height&&(k.y=L.y),k.width>L.width&&(k.width=L.width),k.height>L.height&&(k.height=L.height)),k}async getPerformanceInfo(){try{const[i,o]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.diagnosticsMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(i,o)}catch(i){throw this.logService.warn("issueService#getPerformanceInfo ",i.message),i}}};r.DEFAULT_BACKGROUND_COLOR="#1E1E1E",r=fe([x(1,u.IEnvironmentMainService),x(2,m.ILaunchMainService),x(3,y.ILogService),x(4,P.IDiagnosticsService),x(5,S.IDiagnosticsMainService),x(6,f.IDialogMainService),x(7,I.INativeHostMainService),x(8,l.IProtocolMainService),x(9,h.IProductService)],r),e.IssueMainService=r}),define(X[249],J([0,1,21,18,26,22,6,64,20,53,35,46,87]),function(B,e,E,t,D,R,M,b,d,w,C,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=class extends S.AbstractUpdateService{constructor(p,m,y,I,g,h,l,s){super(p,m,I,g,h,s);this.telemetryService=y,this.nativeHostMainService=l}buildUpdateFeedUrl(p){return(0,S.createUpdateURL)(`linux-${process.arch}`,p,this.productService)}doCheckForUpdates(p){!this.url||(this.setState(P.State.CheckingForUpdates(p)),this.requestService.request({url:this.url},E.CancellationToken.None).then(w.asJson).then(m=>{!m||!m.url||!m.version||!m.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p}),this.setState(P.State.Idle(1))):this.setState(P.State.AvailableForDownload(m))}).then(void 0,m=>{this.logService.error(m),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!p});const y=p?m.message||m:void 0;this.setState(P.State.Idle(1,y))}))}async doDownloadUpdate(p){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):p.update.url&&this.nativeHostMainService.openExternal(void 0,p.update.url),this.setState(P.State.Idle(1))}};f=fe([x(0,R.ILifecycleMainService),x(1,t.IConfigurationService),x(2,C.ITelemetryService),x(3,D.IEnvironmentMainService),x(4,w.IRequestService),x(5,M.ILogService),x(6,b.INativeHostMainService),x(7,d.IProductService)],f),e.LinuxUpdateService=f}),define(X[250],J([0,1,42,28,29,8,21,51,9,7,124,23,18,26,15,22,6,64,20,53,35,46,87]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function r(a,c=1e3){for(;!a();)await(0,R.timeout)(c)}let n;function i(){return typeof n=="undefined"&&(n=t.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),n}let o=class extends s.AbstractUpdateService{constructor(c,v,k,L,O,F,j,ee,se){super(c,v,L,O,F,se);this.telemetryService=k,this.fileService=j,this.nativeHostMainService=ee}get cachePath(){const c=d.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return P.Promises.mkdir(c,{recursive:!0}).then(()=>c)}async initialize(){if(this.productService.target==="user"&&await this.nativeHostMainService.isAdmin(void 0)){this.logService.info("update#ctor - updates are disabled due to running as Admin in user setup");return}super.initialize()}buildUpdateFeedUrl(c){let v="win32";return process.arch!=="ia32"&&(v+=`-${process.arch}`),i()===1?v+="-archive":this.productService.target==="user"&&(v+="-user"),(0,s.createUpdateURL)(v,c,this.productService)}doCheckForUpdates(c){!this.url||(this.setState(l.State.CheckingForUpdates(c)),this.requestService.request({url:this.url},M.CancellationToken.None).then(g.asJson).then(v=>{const k=i();return!v||!v.url||!v.version||!v.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c}),this.setState(l.State.Idle(k)),Promise.resolve(null)):k===1?(this.setState(l.State.AvailableForDownload(v)),Promise.resolve(null)):(this.setState(l.State.Downloading(v)),this.cleanup(v.version).then(()=>this.getUpdatePackagePath(v.version).then(L=>P.Promises.exists(L).then(O=>{if(O)return Promise.resolve(L);const F=v.url,j=v.hash,ee=`${L}.tmp`;return this.requestService.request({url:F},M.CancellationToken.None).then(se=>this.fileService.writeFile(w.URI.file(ee),se.stream)).then(j?()=>(0,C.checksum)(ee,v.hash):()=>{}).then(()=>P.Promises.rename(ee,L)).then(()=>L)})).then(L=>{const O=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:L},O&&v.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(v)):this.setState(l.State.Ready(v))})))}).then(void 0,v=>{this.logService.error(v),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!c});const k=c?v.message||v:void 0;this.setState(l.State.Idle(i(),k))}))}async doDownloadUpdate(c){c.update.url&&this.nativeHostMainService.openExternal(void 0,c.update.url),this.setState(l.State.Idle(i()))}async getUpdatePackagePath(c){const v=await this.cachePath;return d.join(v,`CodeSetup-${this.productService.quality}-${c}.exe`)}async cleanup(c=null){const v=c?F=>!new RegExp(`${this.productService.quality}-${c}\\.exe$`).test(F):()=>!0,k=await this.cachePath,O=(await P.Promises.readdir(k)).filter(v).map(async F=>{try{await P.Promises.unlink(d.join(k,F))}catch{}});await Promise.all(O)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const c=this.state.update;this.setState(l.State.Updating(c));const v=await this.cachePath;this.availableUpdate.updateFilePath=d.join(v,`CodeSetup-${this.productService.quality}-${c.version}.flag`),await P.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,E.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(l.State.Idle(i()))});const L=`${this.productService.win32MutexName}-ready`,O=await new Promise((F,j)=>{B(["windows-mutex"],F,j)});r(()=>O.isActive(L)).then(()=>this.setState(l.State.Ready(c)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?t.unlinkSync(this.availableUpdate.updateFilePath):(0,E.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return i()}async _applySpecificUpdate(c){if(this.state.type!=="idle")return;const v=this.configurationService.getValue("update.enableWindowsBackgroundUpdates"),k={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!v};this.setState(l.State.Downloading(k)),this.availableUpdate={packagePath:c},v?this.productService.target==="user"?this.doApplyUpdate():this.setState(l.State.Downloaded(k)):this.setState(l.State.Ready(k))}};fe([b.memoize],o.prototype,"cachePath",null),o=fe([x(0,p.ILifecycleMainService),x(1,S.IConfigurationService),x(2,h.ITelemetryService),x(3,f.IEnvironmentMainService),x(4,g.IRequestService),x(5,m.ILogService),x(6,u.IFileService),x(7,y.INativeHostMainService),x(8,I.IProductService)],o),e.Win32UpdateService=o}),define(X[251],J([0,1,14,8,21,41,3,34,2,12,9,70,4,7,166,58,18,54,26,57,15,22,6,20,59,220,88,35,223,61,73,32,24,47,110,118,37,40,66,52]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s,r,n,i,o,a,c,v,k,L,O,F,j,ee,se,ae,ie,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(q){q[q.NONE=0]="NONE",q[q.NAVIGATING=1]="NAVIGATING",q[q.READY=2]="READY"})(H||(H={}));let re=class extends d.Disposable{constructor(T,N,V,te,$,Q,A,W,U,z,Y,_,K,Z,ne,le,ge,Ee){super();this.logService=N,this.environmentMainService=V,this.policyService=te,this.userDataProfilesService=$,this.fileService=Q,this.applicationStorageMainService=A,this.storageMainService=W,this.configurationService=U,this.themeMainService=z,this.workspacesManagementMainService=Y,this.backupMainService=_,this.telemetryService=K,this.dialogMainService=Z,this.lifecycleMainService=ne,this.productService=le,this.protocolMainService=ge,this.windowsMainService=Ee,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidTriggerSystemContextMenu=this._register(new M.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[Re,Pe]=this.restoreWindowState(T.state);this.windowState=Re,this.logService.trace("window#ctor: using window state",Re);const ke=this.windowState.mode===0||this.windowState.mode===3,Ne=this.configurationService.getValue("window");let ue=!1;typeof Ne?.experimental?.useSandbox=="boolean"?ue=Ne.experimental.useSandbox:ue=typeof ce.default.quality=="string"&&ce.default.quality!=="stable";const he={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!ke,title:this.productService.nameLong,webPreferences:{preload:w.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",B).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,k.zoomLevelToZoomFactor)(Ne?.zoomLevel),enableBlinkFeatures:"HighlightAPI",...ue?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};S.isLinux?he.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):S.isWindows&&!this.environmentMainService.isBuilt&&(he.icon=(0,C.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),S.isMacintosh&&!this.useNativeFullScreen()&&(he.fullscreenable=!1),S.isMacintosh&&(he.acceptFirstMouse=!0,Ne?.clickThroughInactive===!1&&(he.acceptFirstMouse=!1));const pe=S.isMacintosh&&Ne?.nativeTabs===!0;pe&&(he.tabbingIdentifier=this.productService.nameShort);const Ie=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(Ie&&(he.titleBarStyle="hidden",S.isMacintosh||(he.frame=!1),(0,k.useWindowControlsOverlay)(this.configurationService,this.environmentMainService))){const Me=this.themeMainService.getWindowSplash()?.colorInfo.titleBarBackground??this.themeMainService.getBackgroundColor(),Xe=ee.Color.fromHex(Me).isDarker()?"#FFFFFF":"#000000";he.titleBarOverlay={height:29,color:Me,symbolColor:Xe}}if((0,P.mark)("code/willCreateCodeBrowserWindow"),this._win=new E.BrowserWindow(he),(0,P.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,S.isMacintosh&&Ie&&this.updateTrafficLightPosition(),S.isMacintosh&&Ie&&this._win.setSheetOffset(22),S.isWindows&&Ie){const Me=278;this._win.hookWindowMessage(Me,()=>{const[Xe,Te]=this._win.getPosition(),Oe=E.screen.getCursorScreenPoint(),Ae=Oe.x-Xe,je=Oe.y-Te;return(()=>!(Ae>30&&je>=0&&je<=Math.max(this._win.getBounds().height*.15,35)))()||(this._win.setEnabled(!1),this._win.setEnabled(!0),this._onDidTriggerSystemContextMenu.fire({x:Ae,y:je})),0})}(S.isMacintosh||S.isWindows)&&Pe&&(!pe||E.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(Me=>typeof Me=="number")&&this._win.setBounds({width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y}),ke&&((0,P.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.show(),(0,P.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),this.onConfigurationUpdated(),this.createTouchBar(),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this._config?.backupPath}get openedWorkspace(){return this._config?.workspace}get profile(){return this.config?this.userDataProfilesService.getProfile(this.config.workspace??"empty-window",(0,ie.revive)(this.config.profiles.current)):void 0}get remoteAuthority(){return this._config?.remoteAuthority}get config(){return this._config}get isExtensionDevelopmentHost(){return!!this._config?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this._config?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this._config?.debugId}setRepresentedFilename(T){S.isMacintosh&&!this.customTrafficLightPosition?this._win.setRepresentedFilename(T):this.representedFilename=T}getRepresentedFilename(){return S.isMacintosh&&!this.customTrafficLightPosition?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(T){S.isMacintosh&&this._win.setDocumentEdited(T),this.documentEdited=T}isDocumentEdited(){return S.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(T){S.isMacintosh&&T?.force&&E.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.logService.trace(`window#load: window reported ready (id: ${this._id})`),this.readyState=2;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(T=>{if(this.isReady)return T(this);this.whenReadyCallbacks.push(T)})}get isReady(){return this.readyState===2}get whenClosedOrLoaded(){return new Promise(T=>{function N(){V.dispose(),te.dispose(),T()}const V=this.onDidClose(()=>N()),te=this.onWillLoad(()=>N())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(N,V)=>this.onWindowError(2,V)),this._win.webContents.on("did-fail-load",(N,V,te)=>this.onWindowError(3,{reason:te,exitCode:V})),this._win.webContents.on("will-prevent-unload",N=>{N.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()}),this._win.webContents.on("did-finish-load",()=>{this.pendingLoadConfig&&(this._config=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",N=>{this._config&&(this._config.maximized=!0),E.app.emit("browser-window-maximize",N,this._win)}),this._win.on("unmaximize",N=>{this._config&&(this._config.maximized=!1),E.app.emit("browser-window-unmaximize",N,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(N=>this.onConfigurationUpdated(N))),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(N=>this.onDidDeleteUntitledWorkspace(N)));const T=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:T},async(N,V)=>{const te=await this.getMarketplaceHeaders();V({cancel:!1,requestHeaders:Object.assign(N.requestHeaders,te)})})}getMarketplaceHeaders(){return this.marketplaceHeadersPromise||(this.marketplaceHeadersPromise=(0,i.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,this.applicationStorageMainService,this.telemetryService)),this.marketplaceHeadersPromise}async onWindowError(T,N){switch(T){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${N?.reason||"<unknown>"}, code: ${N?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:T,reason:N?.reason,code:N?.exitCode}),T){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(this.environmentMainService.args["enable-smoke-test-driver"]){this.destroyWindow(!1,!1);return}if(T===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,u.localize)(0,null)),(0,b.mnemonicButtonLabel)((0,u.localize)(1,null)),(0,b.mnemonicButtonLabel)((0,u.localize)(2,null))],message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null),noLink:!0,defaultId:0,cancelId:1,checkboxLabel:this._config?.workspace?(0,u.localize)(5,null):void 0},this._win);if(V.response!==1){const te=V.response===0;this.destroyWindow(te,V.checkboxChecked)}}else if(T===2){let V;N?V=(0,u.localize)(7,null,N.reason,N.exitCode??"<unknown>"):V=(0,u.localize)(6,null);const te=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,b.mnemonicButtonLabel)((0,u.localize)(8,null)),(0,b.mnemonicButtonLabel)((0,u.localize)(9,null))],message:V,detail:(0,u.localize)(10,null),noLink:!0,defaultId:0,checkboxLabel:this._config?.workspace?(0,u.localize)(11,null):void 0},this._win),$=te.response===0;this.destroyWindow($,te.checkboxChecked)}break}}async destroyWindow(T,N){const V=this._config?.workspace;if(N&&V)try{const te=this.storageMainService.workspaceStorage(V);await te.init(),te.delete("memento/workbench.parts.editor"),await te.close()}catch(te){this.logService.error(te)}if(this._onDidDestroy.fire(),this._win?.destroy(),T&&this._config){let te,$;(0,O.isSingleFolderWorkspaceIdentifier)(V)?te={folderUri:V.uri}:(0,O.isWorkspaceIdentifier)(V)?te={workspaceUri:V.configPath}:$=!0;const[Q]=this.windowsMainService.open({context:5,userEnv:this._config.userEnv,cli:{...this.environmentMainService.args,_:[]},urisToOpen:te?[te]:void 0,forceEmpty:$,forceNewWindow:!0,remoteAuthority:this.remoteAuthority});Q.focus()}}onDidDeleteUntitledWorkspace(T){this._config?.workspace?.id===T.id&&this._config&&(this._config.workspace=void 0)}onConfigurationUpdated(T){const N=this.getMenuBarVisibility();N!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=N,this.setMenuBarVisibility(N)),this.updateTrafficLightPosition(T);let V=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;V?.endsWith("/")&&(V=V.substr(0,V.length-1));const te=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((V||"").indexOf("@")===-1&&(V!==this.currentHttpProxy||te!==this.currentNoProxy)){this.currentHttpProxy=V,this.currentNoProxy=te;const $=V||"",Q=te?`${te},<local>`:"<local>";this.logService.trace(`Setting proxy to '${$}', bypassing '${Q}'`),this._win.webContents.session.setProxy({proxyRules:$,proxyBypassRules:Q,pacScript:""})}}addTabbedWindow(T){S.isMacintosh&&T.win&&this._win.addTabbedWindow(T.win)}load(T,N=Object.create(null)){this.logService.trace(`window#load: attempt to load window (id: ${this._id})`),this.isDocumentEdited()&&(!N.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),N.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(T,N),this.readyState===0?this._config=T:this.pendingLoadConfig=T,this.readyState=1,this._win.loadURL(w.FileAccess.asBrowserUri("vs/code/electron-sandbox/workbench/workbench.html",B).toString(!0));const V=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new t.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:T.workspace,reason:N.isReload?3:V?2:1})}updateConfiguration(T,N){const V=(this._config??this.pendingLoadConfig)?.userEnv;if(V){const te=(0,g.isLaunchedFromCli)(V)&&!(0,g.isLaunchedFromCli)(T.userEnv),$=this.isExtensionDevelopmentHost;(te||$)&&(T.userEnv={...V,...T.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(T.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),N.disableExtensions!==void 0&&(T["disable-extensions"]=N.disableExtensions),T.fullscreen=this.isFullScreen,T.maximized=this._win.isMaximized(),T.partsSplash=this.themeMainService.getWindowSplash(),(0,P.mark)("code/willOpenNewWindow"),T.perfMarks=(0,P.getMarks)(),this.configObjectUrl.update(T)}async reload(T){const N=Object.assign({},this._config);N.workspace=await this.validateWorkspaceBeforeReload(N),delete N.filesToOpenOrCreate,delete N.filesToDiff,delete N.filesToMerge,delete N.filesToWait,this.isExtensionDevelopmentHost&&T&&(N.verbose=T.verbose,N.debugId=T.debugId,N.extensionEnvironment=T.extensionEnvironment,N["inspect-extensions"]=T["inspect-extensions"],N["inspect-brk-extensions"]=T["inspect-brk-extensions"],N["extensions-dir"]=T["extensions-dir"]),N.isInitialStartup=!1,N.policiesData=this.policyService.serialize(),N.editSessionId=this.environmentMainService.editSessionId,N.profiles={all:this.userDataProfilesService.profiles,current:this.profile||this.userDataProfilesService.defaultProfile},this.load(N,{isReload:!0,disableExtensions:T?.["disable-extensions"]})}async validateWorkspaceBeforeReload(T){if((0,O.isWorkspaceIdentifier)(T.workspace)){const N=T.workspace.configPath;if(N.scheme===w.Schemas.file&&!await this.fileService.exists(N))return}else if((0,O.isSingleFolderWorkspaceIdentifier)(T.workspace)){const N=T.workspace.uri;if(N.scheme===w.Schemas.file&&!await this.fileService.exists(N))return}return T.workspace}serializeWindowState(){if(!this._win)return(0,j.defaultWindowState)();if(this.isFullScreen){let V;try{V=E.screen.getDisplayMatching(this.getBounds())}catch{}const te=(0,j.defaultWindowState)();return{mode:3,display:V?V.id:void 0,width:this.windowState.width||te.width,height:this.windowState.height||te.height,x:this.windowState.x||0,y:this.windowState.y||0}}const T=Object.create(null);let N;if(!S.isMacintosh&&this._win.isMaximized()?N=0:N=1,N===0?T.mode=0:T.mode=1,N===1||N===0){let V;N===1?V=this.getBounds():V=this._win.getNormalBounds(),T.x=V.x,T.y=V.y,T.width=V.width,T.height=V.height}return T}restoreWindowState(T){(0,P.mark)("code/willRestoreCodeWindowState");let N=!1;if(T)try{const V=E.screen.getAllDisplays();N=V.length>1,T=this.validateWindowState(T,V)}catch(V){this.logService.warn(`Unexpected error validating window state: ${V}
${V.stack}`)}return(0,P.mark)("code/didRestoreCodeWindowState"),[T||(0,j.defaultWindowState)(),N]}validateWindowState(T,N){if(this.logService.trace(`window#validateWindowState: validating window state on ${N.length} display(s)`,T),typeof T.x!="number"||typeof T.y!="number"||typeof T.width!="number"||typeof T.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(T.width<=0||T.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(N.length===1){const $=this.getWorkingArea(N[0]);if($){let Q=function(){!T||typeof T.x!="number"||typeof T.y!="number"||!$||(T.x<$.x&&(T.x=$.x),T.y<$.y&&(T.y=$.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",$),Q(),T.width>$.width&&(T.width=$.width),T.height>$.height&&(T.height=$.height),T.x>$.x+$.width-128&&(T.x=$.x+$.width-T.width),T.y>$.y+$.height-128&&(T.y=$.y+$.height-T.height),Q()}return T}if(T.display&&T.mode===3){const $=N.find(Q=>Q.id===T.display);if($&&typeof $.bounds?.x=="number"&&typeof $.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const Q=(0,j.defaultWindowState)(3);return Q.x=$.bounds.x,Q.y=$.bounds.y,Q}}let V,te;try{V=E.screen.getDisplayMatching({x:T.x,y:T.y,width:T.width,height:T.height}),te=this.getWorkingArea(V)}catch{}if(V&&te&&T.x+T.width>te.x&&T.y+T.height>te.y&&T.x<te.x+te.width&&T.y<te.y+te.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",te),T}getWorkingArea(T){if(T.workArea.width>0&&T.workArea.height>0)return T.workArea;if(T.bounds.width>0&&T.bounds.height>0)return T.bounds}getBounds(){const[T,N]=this._win.getPosition(),[V,te]=this._win.getSize();return{x:T,y:N,width:V,height:te}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(T){this.useNativeFullScreen()?this.setNativeFullScreen(T):this.setSimpleFullScreen(T),this.sendWhenReady(T?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(T){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(T)}setSimpleFullScreen(T){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(T),this._win.webContents.focus()}useNativeFullScreen(){const T=this.configurationService.getValue("window");return!T||typeof T.nativeFullScreen!="boolean"||T.nativeTabs?!0:T.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let T=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(T)<0&&(T="classic"),T}setMenuBarVisibility(T,N=!0){S.isMacintosh||(T==="toggle"&&N&&this.send("vscode:showInfoMessage",(0,u.localize)(12,null)),T==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(T)}):this.doSetMenuBarVisibility(T))}doSetMenuBarVisibility(T){const N=this.isFullScreen;switch(T){case"classic":this._win.setMenuBarVisibility(!N),this._win.autoHideMenuBar=N;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}updateTrafficLightPosition(T){if(!S.isMacintosh)return;const N="window.commandCenter";if(T&&!T.affectsConfiguration(N)||!((0,k.getTitleBarStyle)(this.configurationService)==="custom"))return;const te=this.configurationService.getValue(N);te?(this.defaultTrafficLightPosition||(this.defaultTrafficLightPosition=this._win.getTrafficLightPosition()),this._win.setTrafficLightPosition({x:7,y:10})):this.defaultTrafficLightPosition&&this._win.setTrafficLightPosition(this.defaultTrafficLightPosition),this.customTrafficLightPosition=te}handleTitleDoubleClick(){if(S.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win?.close()}sendWhenReady(T,N,...V){this.isReady?this.send(T,...V):this.ready().then(()=>{N.isCancellationRequested||this.send(T,...V)})}send(T,...N){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${T}' for window that is destroyed`);return}try{this._win.webContents.send(T,...N)}catch(V){this.logService.warn(`Error sending IPC message to channel '${T}' of window ${this._id}: ${(0,R.toErrorMessage)(V)}`)}}}updateTouchBar(T){!S.isMacintosh||this.touchBarGroups.forEach((N,V)=>{const te=T[V];N.segments=this.createTouchBarGroupSegments(te)})}createTouchBar(){if(!!S.isMacintosh){for(let T=0;T<10;T++){const N=this.createTouchBarGroup();this.touchBarGroups.push(N)}this._win.setTouchBar(new E.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(T=[]){const N=this.createTouchBarGroupSegments(T),V=new E.TouchBar.TouchBarSegmentedControl({segments:N,mode:"buttons",segmentStyle:"automatic",change:te=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:V.segments[te].id,from:"touchbar"})}});return V}createTouchBarGroupSegments(T=[]){return T.map(V=>{let te;V.icon&&!c.ThemeIcon.isThemeIcon(V.icon)&&V.icon?.dark?.scheme===w.Schemas.file&&(te=E.nativeImage.createFromPath(f.URI.revive(V.icon.dark).fsPath),te.isEmpty()&&(te=void 0));let $;return typeof V.title=="string"?$=V.title:$=V.title.value,{id:V.id,label:te?void 0:$,icon:te}})}dispose(){super.dispose(),this._win=null}};re=fe([x(1,s.ILogService),x(2,I.IEnvironmentMainService),x(3,se.IPolicyService),x(4,ae.IUserDataProfilesService),x(5,h.IFileService),x(6,o.IApplicationStorageMainService),x(7,o.IStorageMainService),x(8,m.IConfigurationService),x(9,v.IThemeMainService),x(10,F.IWorkspacesManagementMainService),x(11,p.IBackupMainService),x(12,a.ITelemetryService),x(13,y.IDialogMainService),x(14,l.ILifecycleMainService),x(15,r.IProductService),x(16,n.IProtocolMainService),x(17,L.IWindowsMainService)],re),e.CodeWindow=re}),define(X[74],J([0,1,14,25,8,3,34,2,12,4,16,7,23,169,5,22,6,88,89,24,47]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,u.createDecorator)("workspacesHistoryMainService");let l=class tt extends b.Disposable{constructor(r,n,i,o){super();this.logService=r,this.workspacesManagementMainService=n,this.lifecycleMainService=i,this.applicationStorageMainService=o,this._onDidChangeRecentlyOpened=this._register(new R.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(r=>this.addRecentlyOpened([{workspace:r.workspace,remoteAuthority:r.window.remoteAuthority}])))}async addRecentlyOpened(r){const n=[],i=[];for(const o of r)if((0,I.isRecentWorkspace)(o))!this.workspacesManagementMainService.isUntitledWorkspace(o.workspace)&&this.indexOfWorkspace(n,o.workspace)===-1&&n.push(o);else if((0,I.isRecentFolder)(o))this.indexOfFolder(n,o.folderUri)===-1&&n.push(o);else{const a=this.indexOfFile(i,o.fileUri)>=0,c=o.fileUri.scheme===d.Schemas.file&&tt.COMMON_FILES_FILTER.indexOf((0,C.basename)(o.fileUri))>=0;!a&&!c&&(i.push(o),w.isWindows&&o.fileUri.scheme===d.Schemas.file&&E.app.addRecentDocument(o.fileUri.fsPath))}await this.addEntriesFromStorage(n,i),n.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(n.length=tt.MAX_TOTAL_RECENT_ENTRIES),i.length>tt.MAX_TOTAL_RECENT_ENTRIES&&(i.length=tt.MAX_TOTAL_RECENT_ENTRIES),await this.saveRecentlyOpened({workspaces:n,files:i}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}async removeRecentlyOpened(r){const n=c=>{const v=this.location(c);for(const k of r)if(C.extUriBiasedIgnorePathCase.isEqual(k,v))return!1;return!0},i=await this.getRecentlyOpened(),o=i.workspaces.filter(n),a=i.files.filter(n);(o.length!==i.workspaces.length||a.length!==i.files.length)&&(await this.saveRecentlyOpened({files:a,workspaces:o}),this._onDidChangeRecentlyOpened.fire(),w.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async clearRecentlyOpened(){await this.saveRecentlyOpened({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}async getRecentlyOpened(r){const n=[],i=[];if(r){const a=r.config?.workspace;(0,g.isWorkspaceIdentifier)(a)&&!this.workspacesManagementMainService.isUntitledWorkspace(a)?n.push({workspace:a,remoteAuthority:r.remoteAuthority}):(0,g.isSingleFolderWorkspaceIdentifier)(a)&&n.push({folderUri:a.uri,remoteAuthority:r.remoteAuthority})}const o=r?.config?.filesToOpenOrCreate;if(o)for(const a of o){const c=a.fileUri;c&&this.indexOfFile(i,c)===-1&&i.push({fileUri:c})}return await this.addEntriesFromStorage(n,i),{workspaces:n,files:i}}async addEntriesFromStorage(r,n){const i=await this.getRecentlyOpenedFromStorage();for(const o of i.workspaces){const a=(0,I.isRecentFolder)(o)?this.indexOfFolder(r,o.folderUri):this.indexOfWorkspace(r,o.workspace);a>=0?r[a].label=r[a].label||o.label:r.push(o)}for(const o of i.files){const a=this.indexOfFile(n,o.fileUri);a>=0?n[a].label=n[a].label||o.label:n.push(o)}}async getRecentlyOpenedFromStorage(){await this.applicationStorageMainService.whenReady;let r;const n=this.applicationStorageMainService.get(tt.RECENTLY_OPENED_STORAGE_KEY,-1);if(typeof n=="string")try{r=JSON.parse(n)}catch(i){this.logService.error("Unexpected error parsing opened paths list",i)}return(0,I.restoreRecentlyOpened)(r,this.logService)}async saveRecentlyOpened(r){await this.applicationStorageMainService.whenReady,this.applicationStorageMainService.store(tt.RECENTLY_OPENED_STORAGE_KEY,JSON.stringify((0,I.toStoreData)(r)),-1,1)}location(r){return(0,I.isRecentFolder)(r)?r.folderUri:(0,I.isRecentFile)(r)?r.fileUri:r.workspace.configPath}indexOfWorkspace(r,n){return r.findIndex(i=>(0,I.isRecentWorkspace)(i)&&i.workspace.id===n.id)}indexOfFolder(r,n){return r.findIndex(i=>(0,I.isRecentFolder)(i)&&C.extUriBiasedIgnorePathCase.isEqual(i.folderUri,n))}indexOfFile(r,n){return r.findIndex(i=>C.extUriBiasedIgnorePathCase.isEqual(i.fileUri,n))}async handleWindowsJumpList(){!w.isWindows||(await this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}async updateWindowsJumpList(){if(!w.isWindows)return;const r=[];if(r.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const a of E.app.getJumpListSettings().removedItems){const c=a.args;if(c){const v=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(c);v&&n.push(P.URI.parse(v[2]))}}await this.removeRecentlyOpened(n);let i=!1;const o=(0,t.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,tt.MAX_WINDOWS_JUMP_LIST_ENTRIES).map(a=>{const c=(0,I.isRecentWorkspace)(a)?a.workspace:a.folderUri,{title:v,description:k}=this.getWindowsJumpListLabel(c,a.label);let L;return P.URI.isUri(c)?L=`--folder-uri "${c.toString()}"`:(i=!0,L=`--file-uri "${c.configPath.toString()}"`),{type:"task",title:v.substr(0,255),description:k.substr(0,255),program:process.execPath,args:L,iconPath:"explorer.exe",iconIndex:0}}));o.length>0&&r.push({type:"custom",name:i?(0,f.localize)(2,null):(0,f.localize)(3,null),items:o})}r.push({type:"recent"});try{const n=E.app.setJumpList(r);n&&n!=="ok"&&this.logService.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.logService.warn("updateWindowsJumpList#setJumpList",n)}}getWindowsJumpListLabel(r,n){if(n)return{title:(0,M.splitName)(n).name,description:n};if(P.URI.isUri(r))return{title:(0,C.basename)(r),description:this.renderJumpListPathDescription(r)};if(this.workspacesManagementMainService.isUntitledWorkspace(r))return{title:(0,f.localize)(4,null),description:""};let i=(0,C.basename)(r.configPath);return i.endsWith(g.WORKSPACE_EXTENSION)&&(i=i.substr(0,i.length-g.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,i),description:this.renderJumpListPathDescription(r.configPath)}}renderJumpListPathDescription(r){return r.scheme==="file"?(0,M.normalizeDriveLetter)(r.fsPath):r.toString()}async updateMacOSRecentDocuments(){if(!w.isMacintosh)return;E.app.clearRecentDocuments();const r=await this.getRecentlyOpened(),n=[];let i=0;for(let a=0;a<r.workspaces.length&&i<tt.MAX_MACOS_DOCK_RECENT_WORKSPACES;a++){const c=this.location(r.workspaces[a]);if(c.scheme===d.Schemas.file){const v=(0,C.originalFSPath)(c);await S.Promises.exists(v)&&(n.push(v),i++)}}const o=[];for(let a=0;a<r.files.length&&i<tt.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;a++){const c=this.location(r.files[a]);if(c.scheme===d.Schemas.file){const v=(0,C.originalFSPath)(c);if(tt.COMMON_FILES_FILTER.includes((0,C.basename)(c))||n.includes(v))continue;await S.Promises.exists(v)&&(o.push(v),i++)}}o.reverse().forEach(a=>E.app.addRecentDocument(a)),n.reverse().forEach(a=>E.app.addRecentDocument(a))}};l.MAX_TOTAL_RECENT_ENTRIES=500,l.RECENTLY_OPENED_STORAGE_KEY="history.recentlyOpenedPathsList",l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.MAX_WINDOWS_JUMP_LIST_ENTRIES=7,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l=fe([x(0,m.ILogService),x(1,h.IWorkspacesManagementMainService),x(2,p.ILifecycleMainService),x(3,y.IApplicationStorageMainService)],l),e.WorkspacesHistoryMainService=l}),define(X[252],J([0,1,14,8,21,34,4,7,159,18,26,22,6,200,64,20,45,35,46,73,32,74]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const s="menu";let r=class Mt{constructor(o,a,c,v,k,L,O,F,j,ee,se){this.updateService=o,this.configurationService=a,this.windowsMainService=c,this.environmentMainService=v,this.telemetryService=k,this.workspacesHistoryMainService=L,this.stateMainService=O,this.lifecycleMainService=F,this.logService=j,this.nativeHostMainService=ee,this.productService=se,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new t.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new t.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(M.isMacintosh||(0,g.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const o=this.stateMainService.getItem(Mt.lastKnownMenubarStorageKey);o&&(o.menus&&(this.menubarMenus=o.menus),o.keybindings&&(this.keybindings=o.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(L,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(L,O,F)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(L,O,F)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.files.openFolder"]=(L,O,F)=>this.nativeHostMainService.pickFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(L,O,F)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(F),telemetryExtraData:{from:s}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const o=this.productService.twitterUrl;o&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(o,"openTwitterUrl"));const a=this.productService.requestFeatureUrl;a&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(a,"openUserVoiceUrl"));const c=this.productService.reportIssueUrl;c&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(c,"openReportIssues"));const v=this.productService.licenseUrl;v&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(M.language){const L=v.indexOf("?")>0?"&":"?";this.openUrl(`${v}${L}lang=${M.language}`,"openLicenseUrl")}else this.openUrl(v,"openLicenseUrl")});const k=this.productService.privacyStatementUrl;k&&v&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(k,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(o=>this.onDidChangeWindowsCount(o)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){const o=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get currentEnableNativeTabs(){if(!M.isMacintosh)return!1;const o=this.configurationService.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,a){this.menubarMenus=o.menus,this.keybindings=o.keybindings,this.stateMainService.setItem(Mt.lastKnownMenubarStorageKey,o),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(o){!M.isMacintosh||(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.closedLastWindow=o.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!M.isMacintosh||(this.noActiveWindow=!E.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const o=E.Menu.getApplicationMenu();if(o&&this.oldMenus.push(o),Object.keys(this.menubarMenus).length===0){E.Menu.setApplicationMenu(M.isMacintosh?new E.Menu:null);return}const a=new E.Menu;let c;if(M.isMacintosh){const k=new E.Menu;c=new E.MenuItem({label:this.productService.nameShort,submenu:k}),this.setMacApplicationMenu(k),a.append(c)}if(M.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const k=new E.Menu;k.append(new E.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),E.app.dock.setMenu(k)}if(this.shouldDrawMenu("File")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:k});this.setMenuById(k,"File"),a.append(L)}if(this.shouldDrawMenu("Edit")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:k});this.setMenuById(k,"Edit"),a.append(L)}if(this.shouldDrawMenu("Selection")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:k});this.setMenuById(k,"Selection"),a.append(L)}if(this.shouldDrawMenu("View")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:k});this.setMenuById(k,"View"),a.append(L)}if(this.shouldDrawMenu("Go")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:k});this.setMenuById(k,"Go"),a.append(L)}if(this.shouldDrawMenu("Run")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:k});this.setMenuById(k,"Run"),a.append(L)}if(this.shouldDrawMenu("Terminal")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:k});this.setMenuById(k,"Terminal"),a.append(L)}let v;if(this.shouldDrawMenu("Window")){const k=new E.Menu;v=new E.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:k,role:"window"}),this.setMacWindowMenu(k)}if(v&&a.append(v),this.shouldDrawMenu("Help")){const k=new E.Menu,L=new E.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:k,role:"help"});this.setMenuById(k,"Help"),a.append(L)}a.items&&a.items.length>0?E.Menu.setApplicationMenu(a):E.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(o){const a=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),c=this.getUpdateMenuItems();let v;if(this.shouldDrawMenu("Preferences")){const ae=new E.Menu;this.setMenuById(ae,"Preferences"),v=new E.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:ae})}const k=new E.Menu,L=new E.MenuItem({label:d.localize(12,null),role:"services",submenu:k}),O=new E.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),F=new E.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),j=new E.MenuItem({label:d.localize(15,null),role:"unhide"}),ee=new E.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:async(ae,ie,ce)=>{const H=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!E.BrowserWindow.getFocusedWindow()||H?.isMinimized())&&await this.confirmBeforeQuit(ce)&&this.nativeHostMainService.quit(void 0)}})),se=[a];se.push(...c),v&&se.push(n(),v),se.push(n(),L,n(),O,F,j,n(),ee),se.forEach(ae=>o.append(ae))}async confirmBeforeQuit(o){if(this.windowsMainService.getWindowCount()===0)return!0;const a=this.configurationService.getValue("window.confirmBeforeClose");if(a==="always"||a==="keyboardOnly"&&this.isKeyboardEvent(o)){const c={title:this.productService.nameLong,type:"question",buttons:[(0,R.mnemonicButtonLabel)(d.localize(17,null)),(0,R.mnemonicButtonLabel)(d.localize(18,null))],message:d.localize(19,null),noLink:!0,defaultId:0,cancelId:1},{response:v}=await this.nativeHostMainService.showMessageBox(this.windowsMainService.getFocusedWindow()?.id,c);return v===0}return!0}shouldDrawMenu(o){if(!M.isMacintosh&&(0,g.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(o){case"File":case"Help":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[o];case"Window":if(M.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[o]}}setMenu(o,a){a.forEach(c=>{if((0,f.isMenubarMenuItemSeparator)(c))o.append(n());else if((0,f.isMenubarMenuItemSubmenu)(c)){const v=new E.Menu,k=new E.MenuItem({label:this.mnemonicLabel(c.label),submenu:v});this.setMenu(v,c.submenu.items),o.append(k)}else(0,f.isMenubarMenuItemRecentAction)(c)?o.append(this.createOpenRecentMenuItem(c)):(0,f.isMenubarMenuItemAction)(c)&&(c.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(o),M.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[c.id]?o.append(new E.MenuItem(this.likeAction(c.id,{label:this.mnemonicLabel(c.label),click:this.fallbackMenuHandlers[c.id]}))):o.append(this.createMenuItem(c.label,c.id,!1,c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)):o.append(this.createMenuItem(c.label,c.id,c.enabled!==!1,!!c.checked)))})}setMenuById(o,a){this.menubarMenus&&this.menubarMenus[a]&&this.setMenu(o,this.menubarMenus[a].items)}insertCheckForUpdatesItems(o){const a=this.getUpdateMenuItems();a.length&&(a.forEach(c=>o.append(c)),o.append(n()))}createOpenRecentMenuItem(o){const a=b.URI.revive(o.uri),c=o.id,v=c==="openRecentFile"?{fileUri:a}:c==="openRecentWorkspace"?{workspaceUri:a}:{folderUri:a};return new E.MenuItem(this.likeAction(c,{label:o.label,click:(k,L,O)=>{const F=this.isOptionClick(O);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[v],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:o.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([a])}},!1))}isOptionClick(o){return!!(o&&(!M.isMacintosh&&(o.ctrlKey||o.shiftKey)||M.isMacintosh&&(o.metaKey||o.altKey)))}isKeyboardEvent(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}createRoleMenuItem(o,a,c){const v={label:this.mnemonicLabel(o),role:c,enabled:!0};return new E.MenuItem(this.withKeybinding(a,v))}setMacWindowMenu(o){const a=new E.MenuItem({label:d.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),c=new E.MenuItem({label:d.localize(21,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),v=new E.MenuItem({label:d.localize(22,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),k=this.createMenuItem(d.localize(23,null),"workbench.action.switchWindow"),L=[];this.currentEnableNativeTabs&&(L.push(n()),L.push(this.createMenuItem(d.localize(24,null),"workbench.action.newWindowTab")),L.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),L.push(this.createRoleMenuItem(d.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),L.push(this.createRoleMenuItem(d.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),L.push(this.createRoleMenuItem(d.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[a,c,n(),k,...L,n(),v].forEach(O=>o.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.mnemonicLabel(d.localize(29,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:d.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.mnemonicLabel(d.localize(31,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:d.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.mnemonicLabel(d.localize(33,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new E.MenuItem({label:d.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.mnemonicLabel(d.localize(35,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(o,a,c,v){const k=this.mnemonicLabel(o),L=typeof a=="function"?a:(se,ae,ie)=>{const ce=se?se.userSettingsLabel:null;let H=a;Array.isArray(a)&&(H=this.isOptionClick(ie)?a[1]:a[0]),ce&&ie.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:ce}):this.runActionInRenderer({type:"commandId",commandId:H})},O=typeof c=="boolean"?c:this.windowsMainService.getWindowCount()>0,F=typeof v=="boolean"?v:!1,j={label:k,click:L,enabled:O};F&&(j.type="checkbox",j.checked=F);let ee;return typeof a=="string"?ee=a:Array.isArray(a)&&(ee=a[0]),M.isMacintosh&&(ee==="editor.action.clipboardCutAction"?j.role="cut":ee==="editor.action.clipboardCopyAction"?j.role="copy":ee==="editor.action.clipboardPasteAction"&&(j.role="paste"),ee==="undo"?j.click=this.makeContextAwareClickHandler(L,{inDevTools:se=>se.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):ee==="redo"?j.click=this.makeContextAwareClickHandler(L,{inDevTools:se=>se.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):ee==="editor.action.selectAll"&&(j.click=this.makeContextAwareClickHandler(L,{inDevTools:se=>se.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.withKeybinding(ee,j))}makeContextAwareClickHandler(o,a){return(c,v,k)=>{const L=E.BrowserWindow.getFocusedWindow();if(!L)return a.inNoWindow();if(L.webContents.isDevToolsFocused()&&L.webContents.devToolsWebContents)return a.inDevTools(L.webContents.devToolsWebContents);o(c,v||L,k)}}runActionInRenderer(o){let a=E.BrowserWindow.getFocusedWindow();if(!a){const v=this.windowsMainService.getLastActiveWindow();v?.isMinimized()&&(a=v.win)}const c=a?this.windowsMainService.getWindowById(a.id):void 0;if(c){if(this.logService.trace("menubar#runActionInRenderer",o),M.isMacintosh&&!this.environmentMainService.isBuilt&&!c.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const v={id:o.commandId,from:"menu"};c.sendWhenReady("vscode:runAction",D.CancellationToken.None,v)}else{const v={userSettingsLabel:o.userSettingsLabel};c.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,v)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",o)}withKeybinding(o,a){const c=typeof o=="string"?this.keybindings[o]:void 0;if(c?.label){if(c.isNative!==!1)a.accelerator=c.label,a.userSettingsLabel=c.userSettingsLabel;else if(typeof a.label=="string"){const v=a.label.indexOf("[");v>=0?a.label=`${a.label.substr(0,v)} [${c.label}]`:a.label=`${a.label} [${c.label}]`}}else a.accelerator=void 0;return a}likeAction(o,a,c=!a.accelerator){c&&(a=this.withKeybinding(o,a));const v=a.click;return a.click=(k,L,O)=>{this.reportMenuActionTelemetry(o),v?.(k,L,O)},a}openUrl(o,a){this.nativeHostMainService.openExternal(void 0,o),this.reportMenuActionTelemetry(a)}reportMenuActionTelemetry(o){this.telemetryService.publicLog2("workbenchActionExecuted",{id:o,from:s})}mnemonicLabel(o){return(0,R.mnemonicMenuLabel)(o,!this.currentEnableMenuBarMnemonics)}};r.lastKnownMenubarStorageKey="lastKnownMenubarData",r=fe([x(0,I.IUpdateService),x(1,w.IConfigurationService),x(2,h.IWindowsMainService),x(3,C.IEnvironmentMainService),x(4,y.ITelemetryService),x(5,l.IWorkspacesHistoryMainService),x(6,m.IStateMainService),x(7,P.ILifecycleMainService),x(8,S.ILogService),x(9,u.INativeHostMainService),x(10,p.IProductService)],r),e.Menubar=r;function n(){return new E.MenuItem({type:"separator"})}}),define(X[253],J([0,1,5,22,6,252]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let M=class{constructor(d,w,C){this.instantiationService=d,this.lifecycleMainService=w,this.logService=C,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(R.Menubar)}async updateMenubar(d,w){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(w,d)}};M=fe([x(0,E.IInstantiationService),x(1,t.ILifecycleMainService),x(2,D.ILogService)],M),e.MenubarMainService=M}),define(X[254],J([0,1,14,28,29,25,21,3,30,48,34,2,12,9,70,4,36,16,13,7,167,58,18,54,26,15,5,22,6,52,20,59,71,45,73,251,112,247,24,113,74,47,61,40,37]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s,r,n,i,o,a,c,v,k,L,O,F,j,ee,se,ae,ie,ce,H,re,q,T,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function V(Q){return(0,ie.isWorkspaceIdentifier)(Q?.workspace)}function te(Q){return(0,ie.isSingleFolderWorkspaceIdentifier)(Q?.workspace)}let $=class ut extends P.Disposable{constructor(A,W,U,z,Y,_,K,Z,ne,le,ge,Ee,Re,Pe,ke,Ne,ue,he){super();this.machineId=A,this.initialUserEnv=W,this.logService=U,this.stateMainService=z,this.policyService=Y,this.environmentMainService=_,this.userDataProfilesService=K,this.lifecycleMainService=Z,this.backupMainService=ne,this.configurationService=le,this.workspacesHistoryMainService=ge,this.workspacesManagementMainService=Ee,this.instantiationService=Re,this.dialogMainService=Pe,this.fileService=ke,this.productService=Ne,this.protocolMainService=ue,this.themeMainService=he,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this._onDidTriggerSystemContextMenu=this._register(new b.Emitter),this.onDidTriggerSystemContextMenu=this._onDidTriggerSystemContextMenu.event,this.windowsStateHandler=this._register(new ae.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(A=>this._onDidSignalReadyWindow.fire(A.window))),this._register(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const W=new P.DisposableStore;if(W.add(b.Event.any(A.onDidClose,A.onDidDestroy)(()=>W.dispose())),A.config.extensionDevelopmentPath)for(const U of A.config.extensionDevelopmentPath)W.add(this.protocolMainService.addValidFileRoot(U));A.config.extensionTestsPath&&W.add(this.protocolMainService.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,W){const U=this.environmentMainService.args,z=W?.remoteAuthority||void 0,Y=!0,_=W?.forceReuseWindow,K=!_;return this.open({...A,cli:U,forceEmpty:Y,forceNewWindow:K,forceReuseWindow:_,remoteAuthority:z})}openExistingWindow(A,W){A.focus(),this.handleWaitMarkerFile(W,[A])}open(A){this.logService.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const W=[],U=[],z=[],Y=[],_=[];let K,Z=0;const ne=this.getPathsToOpen(A);this.logService.trace("windowsManager#open pathsToOpen",ne);for(const Pe of ne)te(Pe)?A.addMode?W.push(Pe):U.push(Pe):V(Pe)?z.push(Pe):Pe.fileUri?(K||(K={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),K.filesToOpenOrCreate.push(Pe)):Pe.backupPath?_.push({backupFolder:(0,f.basename)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):Z++;A.diffMode&&K&&K.filesToOpenOrCreate.length>=2&&(K.filesToDiff=K.filesToOpenOrCreate.slice(0,2),K.filesToOpenOrCreate=[]),A.mergeMode&&K&&K.filesToOpenOrCreate.length===4&&(K.filesToMerge=K.filesToOpenOrCreate.slice(0,4),K.filesToOpenOrCreate=[],K.filesToDiff=[]),K&&A.waitMarkerFileURI&&(K.filesToWait={paths:(0,R.coalesce)([...K.filesToDiff,K.filesToMerge[3],...K.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(Y.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),z.push(...Y),_.push(...this.backupMainService.getEmptyWindowBackupPaths())):_.length=0;const{windows:le,filesOpenedInWindow:ge}=this.doOpen(A,z,U,_,Z,K,W);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${U.length}, emptyToRestore: ${_.length}, emptyToOpen: ${Z})`),le.length>1)if(ge)ge.focus();else{const Pe=this.windowsStateHandler.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ke=!0,Ne=!0;if(Pe){const ue=le.filter(he=>this.windowsStateHandler.state.lastActiveWindow&&he.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);ue.length&&(ue[0].focus(),ke=!1,Ne=!1)}if(ke)for(let ue=le.length-1;ue>=0;ue--){const he=le[ue];if(!(he.openedWorkspace&&Y.some(pe=>he.openedWorkspace&&pe.workspace.id===he.openedWorkspace.id)||he.backupPath&&_.some(pe=>he.backupPath&&pe.backupFolder===(0,f.basename)(he.backupPath)))){he.focus(),Ne=!1;break}}Ne&&le[le.length-1].focus()}const Ee=K&&K.filesToDiff.length>0,Re=K&&K.filesToMerge.length>0;if(!le.some(Pe=>Pe.isExtensionDevelopmentHost)&&!Ee&&!Re&&!A.noRecentEntry){const Pe=[];for(const ke of ne)V(ke)&&!ke.transient?Pe.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):te(ke)?Pe.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Pe.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(Pe)}return this.handleWaitMarkerFile(A,le),le}handleWaitMarkerFile(A,W){const U=A.waitMarkerFileURI;A.context===0&&U&&W.length===1&&W[0]&&(async()=>{await W[0].whenClosedOrLoaded;try{await this.fileService.del(U)}catch{}})()}doOpen(A,W,U,z,Y,_,K){const Z=[];let ne;function le(ue,he){Z.push(ue),he&&(ne=ue,_=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:Ee}=this.shouldOpenNewWindow(A);if(!A.initialStartup&&K.length>0){const ue=K[0].remoteAuthority,he=this.getLastActiveWindowForAuthority(ue);he&&le(this.doAddFoldersToExistingWindow(he,K.map(pe=>pe.workspace.uri)))}const Re=U.length+W.length+z.length;if(_&&Re===0){const ue=_.filesToOpenOrCreate[0]||_.filesToDiff[0]||_.filesToMerge[3],he=this.getWindows().filter(Ie=>_&&(0,y.isEqualAuthority)(Ie.remoteAuthority,_.remoteAuthority));let pe;ue?.fileUri&&!Ee&&((A.context===4||A.context===0||A.context===1)&&(pe=(0,se.findWindowOnFile)(he,ue.fileUri,Ie=>Ie.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(Ie.configPath):void 0)),pe||(pe=this.doGetLastActiveWindow(he))),pe?(0,ie.isWorkspaceIdentifier)(pe.openedWorkspace)?W.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):(0,ie.isSingleFolderWorkspaceIdentifier)(pe.openedWorkspace)?U.push({workspace:pe.openedWorkspace,remoteAuthority:pe.remoteAuthority}):le(this.doOpenFilesInExistingWindow(A,pe,_),!0):le(this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:_,forceNewWindow:!0,remoteAuthority:_.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow}),!0)}const Pe=(0,R.distinct)(W,ue=>ue.workspace.id);if(Pe.length>0){const ue=(0,R.coalesce)(Pe.map(he=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.configPath)));if(ue.length>0){const he=ue[0],pe=(0,y.isEqualAuthority)(_?.remoteAuthority,he.remoteAuthority)?_:void 0;le(this.doOpenFilesInExistingWindow(A,he,pe),!!pe),ge=!0}Pe.forEach(he=>{if(ue.some(Me=>Me.openedWorkspace&&Me.openedWorkspace.id===he.workspace.id))return;const pe=he.remoteAuthority,Ie=(0,y.isEqualAuthority)(_?.remoteAuthority,pe)?_:void 0;le(this.doOpenFolderOrWorkspace(A,he,ge,Ie),!!Ie),ge=!0})}const ke=(0,R.distinct)(U,ue=>y.extUriBiasedIgnorePathCase.getComparisonKey(ue.workspace.uri));if(ke.length>0){const ue=(0,R.coalesce)(ke.map(he=>(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),he.workspace.uri)));if(ue.length>0){const he=ue[0],pe=(0,y.isEqualAuthority)(_?.remoteAuthority,he.remoteAuthority)?_:void 0;le(this.doOpenFilesInExistingWindow(A,he,pe),!!pe),ge=!0}ke.forEach(he=>{if(ue.some(Me=>(0,ie.isSingleFolderWorkspaceIdentifier)(Me.openedWorkspace)&&y.extUriBiasedIgnorePathCase.isEqual(Me.openedWorkspace.uri,he.workspace.uri)))return;const pe=he.remoteAuthority,Ie=(0,y.isEqualAuthority)(_?.remoteAuthority,pe)?_:void 0;le(this.doOpenFolderOrWorkspace(A,he,ge,Ie),!!Ie),ge=!0})}const Ne=(0,R.distinct)(z,ue=>ue.backupFolder);if(Ne.length>0&&Ne.forEach(ue=>{const he=ue.remoteAuthority,pe=(0,y.isEqualAuthority)(_?.remoteAuthority,he)?_:void 0;le(this.doOpenEmpty(A,!0,he,pe,ue),!!pe),ge=!0}),Z.length===0||_){_&&!Y&&Y++;const ue=_?_.remoteAuthority:A.remoteAuthority;for(let he=0;he<Y;he++)le(this.doOpenEmpty(A,ge,ue,_),!!_),ge=!0}return{windows:(0,R.distinct)(Z),filesOpenedInWindow:ne}}doOpenFilesInExistingWindow(A,W,U){this.logService.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:U}),W.focus();const z={filesToOpenOrCreate:U?.filesToOpenOrCreate,filesToDiff:U?.filesToDiff,filesToMerge:U?.filesToMerge,filesToWait:U?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return W.sendWhenReady("vscode:openFiles",M.CancellationToken.None,z),W}doAddFoldersToExistingWindow(A,W){this.logService.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:W}),A.focus();const U={foldersToAdd:W};return A.sendWhenReady("vscode:addFolders",M.CancellationToken.None,U),A}doOpenEmpty(A,W,U,z,Y){this.logService.trace("windowsManager#doOpenEmpty",{restore:!!Y,remoteAuthority:U,filesToOpen:z,forceNewWindow:W});let _;return!W&&typeof A.contextWindowId=="number"&&(_=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:U,forceNewWindow:W,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:_,emptyWindowBackupInfo:Y})}doOpenFolderOrWorkspace(A,W,U,z,Y){return this.logService.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:W,filesToOpen:z}),!U&&!Y&&typeof A.contextWindowId=="number"&&(Y=this.getWindowById(A.contextWindowId)),this.openInBrowserWindow({workspace:W.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:W.remoteAuthority,forceNewWindow:U,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:z,windowToUse:Y})}getPathsToOpen(A){let W,U=!1,z=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(W=this.doExtractPathsFromAPI(A),U=!0):A.forceEmpty?W=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(W=this.doExtractPathsFromCLI(A.cli),W.length===0&&W.push(Object.create(null)),U=!0):(W=this.doGetPathsFromLastSession(),W.length===0&&W.push(Object.create(null)),z=!0),!A.addMode&&U){const Y=W.filter(_=>te(_));if(Y.length>1){const _=Y[0].remoteAuthority;if(Y.every(K=>(0,y.isEqualAuthority)(K.remoteAuthority,_))){const K=this.workspacesManagementMainService.createUntitledWorkspaceSync(Y.map(Z=>({uri:Z.workspace.uri})));W.push({workspace:K,remoteAuthority:_}),W=W.filter(Z=>!te(Z))}}}return A.initialStartup&&!z&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&W.unshift(...this.doGetPathsFromLastSession().filter(Y=>V(Y)||te(Y)||Y.backupPath)),W}doExtractPathsFromAPI(A){const W=[],U={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority};for(const z of(0,R.coalesce)(A.urisToOpen||[])){const Y=this.resolveOpenable(z,U);if(Y)Y.label=z.label,W.push(Y);else{const _=this.resourceFromOpenable(z),K={title:this.productService.nameLong,type:"info",buttons:[(0,C.mnemonicButtonLabel)((0,h.localize)(0,null))],defaultId:0,message:_.scheme===S.Schemas.file?(0,h.localize)(1,null):(0,h.localize)(2,null),detail:_.scheme===S.Schemas.file?(0,h.localize)(3,null,(0,C.getPathLabel)(_,{os:p.OS,tildify:this.environmentMainService})):(0,h.localize)(4,null,_.toString(!0)),noLink:!0};this.dialogMainService.showMessageBox(K,(0,I.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}}return W}doExtractPathsFromCLI(A){const W=[],U={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},z=A["folder-uri"];if(z)for(const K of z){const Z=this.cliArgToUri(K);if(Z){const ne=this.resolveOpenable({folderUri:Z},U);ne&&W.push(ne)}}const Y=A["file-uri"];if(Y)for(const K of Y){const Z=this.cliArgToUri(K);if(Z){const ne=this.resolveOpenable((0,ie.hasWorkspaceFileExtension)(K)?{workspaceUri:Z}:{fileUri:Z},U);ne&&W.push(ne)}}const _=A._;for(const K of _){const Z=U.remoteAuthority?this.doResolvePathRemote(K,U):this.doResolveFilePath(K,U);Z&&W.push(Z)}return W}cliArgToUri(A){try{const W=g.URI.parse(A);if(!W.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${A}`);return}return W}catch(W){this.logService.error(`Invalid URI input string: ${A}, ${W.message}`)}}doGetPathsFromLastSession(){const A=this.getRestoreWindowsSetting();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const W=[];A!=="one"&&W.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&W.push(this.windowsStateHandler.state.lastActiveWindow);const U=[];for(const z of W)if(z.workspace){const Y=this.resolveOpenable({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});V(Y)&&U.push(Y)}else if(z.folderUri){const Y=this.resolveOpenable({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});te(Y)&&U.push(Y)}else A!=="folders"&&z.backupPath&&U.push({backupPath:z.backupPath,remoteAuthority:z.remoteAuthority});return U}}}getRestoreWindowsSetting(){let A;return this.lifecycleMainService.wasRestarted?A="all":(A=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}resolveOpenable(A,W=Object.create(null)){const U=this.resourceFromOpenable(A);return U.scheme===S.Schemas.file?((0,j.isFileToOpen)(A)&&(W={...W,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(U.fsPath,W)):this.doResolveRemoteOpenable(A,W)}doResolveRemoteOpenable(A,W){let U=this.resourceFromOpenable(A);const z=(0,O.getRemoteAuthority)(U)||W.remoteAuthority;if(U=(0,y.removeTrailingPathSeparator)((0,y.normalizePath)(U)),(0,j.isFileToOpen)(A)){if(W.gotoLineMode){const{path:Y,line:_,column:K}=(0,d.parseLineAndColumnAware)(U.path);return{fileUri:U.with({path:Y}),options:{selection:_?{startLineNumber:_,startColumn:K||1}:void 0},remoteAuthority:z}}return{fileUri:U,remoteAuthority:z}}else if((0,j.isWorkspaceToOpen)(A))return{workspace:(0,ce.getWorkspaceIdentifier)(U),remoteAuthority:z};return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(U),remoteAuthority:z}}resourceFromOpenable(A){return(0,j.isWorkspaceToOpen)(A)?A.workspaceUri:(0,j.isFolderToOpen)(A)?A.folderUri:A.fileUri}doResolveFilePath(A,W){let U,z;W.gotoLineMode&&({path:A,line:U,column:z}=(0,d.parseLineAndColumnAware)(A)),A=(0,d.sanitizeFilePath)((0,f.normalize)(A),(0,m.cwd)());try{const Y=(0,t.statSync)(A);if(Y.isFile()){if(!W.forceOpenWorkspaceAsFile){const _=this.workspacesManagementMainService.resolveLocalWorkspaceSync(g.URI.file(A));if(_)return _.transient&&W.rejectTransientWorkspaces?void 0:{workspace:{id:_.id,configPath:_.configPath},type:i.FileType.File,exists:!0,remoteAuthority:_.remoteAuthority,transient:_.transient}}return{fileUri:g.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:U?{startLineNumber:U,startColumn:z||1}:void 0}}}else{if(Y.isDirectory())return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(g.URI.file(A),Y),type:i.FileType.Directory,exists:!0};if(!p.isWindows&&A==="/dev/null")return{fileUri:g.URI.file(A),type:i.FileType.File,exists:!0}}}catch{const _=g.URI.file(A);if(this.workspacesHistoryMainService.removeRecentlyOpened([_]),W.ignoreFileNotFound)return{fileUri:_,type:i.FileType.File,exists:!1}}}doResolvePathRemote(A,W){const U=A.charCodeAt(0),z=W.remoteAuthority;let Y,_;W.gotoLineMode&&({path:A,line:Y,column:_}=(0,d.parseLineAndColumnAware)(A)),U!==47&&((0,d.isWindowsDriveLetter)(U)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,d.toSlashes)(A)),A=`/${A}`);const K=g.URI.from({scheme:S.Schemas.vscodeRemote,authority:z,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,ie.hasWorkspaceFileExtension)(A))return W.forceOpenWorkspaceAsFile?{fileUri:K,options:{selection:Y?{startLineNumber:Y,startColumn:_||1}:void 0},remoteAuthority:W.remoteAuthority}:{workspace:(0,ce.getWorkspaceIdentifier)(K),remoteAuthority:z};if(W.gotoLineMode||f.posix.basename(A).indexOf(".")!==-1)return{fileUri:K,options:{selection:Y?{startLineNumber:Y,startColumn:_||1}:void 0},remoteAuthority:z}}return{workspace:(0,ce.getSingleFolderWorkspaceIdentifier)(K),remoteAuthority:z}}shouldOpenNewWindow(A){const W=this.configurationService.getValue("window"),U=W?.openFoldersInNewWindow||"default",z=W?.openFilesInNewWindow||"off";let Y=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(U==="on"||U==="off")&&(Y=U==="on");let _=!1;return A.forceNewWindow||A.forceReuseWindow?_=!!A.forceNewWindow&&!A.forceReuseWindow:(p.isMacintosh?A.context===1&&(_=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(_=!0),!A.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(_=z==="on")),{openFolderInNewWindow:!!Y,openFilesInNewWindow:_}}openExtensionDevelopmentHostWindow(A,W){const U=(0,se.findWindowOnExtensionDevelopmentPath)(this.getWindows(),A);if(U)return this.lifecycleMainService.reload(U,W.cli),U.focus(),[U];let z=W.cli["folder-uri"]||[],Y=W.cli["file-uri"]||[],_=W.cli._;if(!_.length&&!z.length&&!Y.length&&!W.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ge=le&&(le.workspace||le.folderUri);ge&&(g.URI.isUri(ge)?ge.scheme===S.Schemas.file?_=[ge.fsPath]:z=[ge.toString()]:ge.configPath.scheme===S.Schemas.file?_=[(0,y.originalFSPath)(ge.configPath)]:Y=[ge.configPath.toString()])}let K=W.remoteAuthority;for(const le of A)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ge=g.URI.parse(le),Ee=(0,O.getRemoteAuthority)(ge);Ee&&(K?(0,y.isEqualAuthority)(Ee,K)||this.logService.error("more than one extension development path authority"):K=Ee)}_=_.filter(le=>{const ge=g.URI.file(le);return(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:(0,y.isEqualAuthority)((0,O.getRemoteAuthority)(ge),K)}),z=z.filter(le=>{const ge=this.cliArgToUri(le);return ge&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:ge?(0,y.isEqualAuthority)((0,O.getRemoteAuthority)(ge),K):!1}),Y=Y.filter(le=>{const ge=this.cliArgToUri(le);return ge&&!!(0,se.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge)?!1:ge?(0,y.isEqualAuthority)((0,O.getRemoteAuthority)(ge),K):!1}),W.cli._=_,W.cli["folder-uri"]=z,W.cli["file-uri"]=Y;const Z=!_.length&&!z.length&&!Y.length,ne={context:W.context,cli:W.cli,forceNewWindow:!0,forceEmpty:Z,userEnv:W.userEnv,noRecentEntry:!0,waitMarkerFileURI:W.waitMarkerFileURI,remoteAuthority:K};return this.open(ne)}openInBrowserWindow(A){const W=this.configurationService.getValue("window"),U={...this.environmentMainService.args,...A.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,f.join)(this.environmentMainService.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{all:this.userDataProfilesService.profiles,current:this.userDataProfilesService.getProfile(A.workspace??"empty-window",(A.windowToUse??this.getLastActiveWindow())?.profile??this.userDataProfilesService.defaultProfile)},homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.initialUserEnv,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:v.default,isInitialStartup:A.initialStartup,perfMarks:(0,u.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof W?.zoomLevel=="number"?W.zoomLevel:void 0,autoDetectHighContrast:W?.autoDetectHighContrast??!0,autoDetectColorScheme:W?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.themeMainService.getColorScheme(),policiesData:this.policyService.serialize(),editSessionId:this.environmentMainService.editSessionId};let z;if(!A.forceNewWindow&&!A.forceNewTabbedWindow&&(z=A.windowToUse||this.getLastActiveWindow(),z&&z.focus()),z){const Y=z.config;!U.extensionDevelopmentPath&&Y&&!!Y.extensionDevelopmentPath&&(U.extensionDevelopmentPath=Y.extensionDevelopmentPath,U.verbose=Y.verbose,U["inspect-brk-extensions"]=Y["inspect-brk-extensions"],U.debugId=Y.debugId,U.extensionEnvironment=Y.extensionEnvironment,U["inspect-extensions"]=Y["inspect-extensions"],U["extensions-dir"]=Y["extensions-dir"])}else{const Y=this.windowsStateHandler.getNewWindowState(U);(0,u.mark)("code/willCreateCodeWindow");const _=z=this.instantiationService.createInstance(ee.CodeWindow,{state:Y,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,u.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(_),ut.WINDOWS.push(_),this._onDidOpenWindow.fire(_),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,w.once)(_.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(_)),(0,w.once)(_.onDidClose)(()=>this.onWindowClosed(_)),(0,w.once)(_.onDidDestroy)(()=>this._onDidDestroyWindow.fire(_)),_.onDidTriggerSystemContextMenu(({x:Z,y:ne})=>this._onDidTriggerSystemContextMenu.fire({window:_,x:Z,y:ne}));const K=(0,I.assertIsDefined)(_.win?.webContents);K.removeAllListeners("devtools-reload-page"),K.on("devtools-reload-page",()=>this.lifecycleMainService.reload(_)),this.lifecycleMainService.registerWindow(_)}return U.windowId=z.id,z.isReady?this.lifecycleMainService.unload(z,4).then(Y=>{Y||this.doOpenInBrowserWindow(z,U,A)}):this.doOpenInBrowserWindow(z,U,A),z}doOpenInBrowserWindow(A,W,U){if(!W.extensionDevelopmentPath)if((0,ie.isWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:W.workspace,remoteAuthority:W.remoteAuthority});else if((0,ie.isSingleFolderWorkspaceIdentifier)(W.workspace))W.backupPath=this.backupMainService.registerFolderBackupSync({folderUri:W.workspace.uri,remoteAuthority:W.remoteAuthority});else{const z=U.emptyWindowBackupInfo&&U.emptyWindowBackupInfo.backupFolder;W.backupPath=this.backupMainService.registerEmptyWindowBackupSync(z,W.remoteAuthority)}A.load(W)}onWindowClosed(A){const W=ut.WINDOWS.indexOf(A);ut.WINDOWS.splice(W,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const A=E.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(A){return this.doGetLastActiveWindow(this.getWindows().filter(W=>(0,y.isEqualAuthority)(W.remoteAuthority,A)))}doGetLastActiveWindow(A){const W=Math.max.apply(Math,A.map(U=>U.lastFocusTime));return A.find(U=>U.lastFocusTime===W)}sendToFocused(A,...W){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,M.CancellationToken.None,...W)}sendToAll(A,W,U){for(const z of this.getWindows())U&&U.indexOf(z.id)>=0||z.sendWhenReady(A,M.CancellationToken.None,W)}getWindows(){return ut.WINDOWS}getWindowCount(){return ut.WINDOWS.length}getWindowById(A){const W=this.getWindows().filter(U=>U.id===A);return(0,R.firstOrDefault)(W)}getWindowByWebContents(A){const W=E.BrowserWindow.fromWebContents(A);if(!!W)return this.getWindowById(W.id)}};$.WINDOWS=[],$=fe([x(2,c.ILogService),x(3,F.IStateMainService),x(4,N.IPolicyService),x(5,n.IEnvironmentMainService),x(6,T.IUserDataProfilesService),x(7,a.ILifecycleMainService),x(8,l.IBackupMainService),x(9,s.IConfigurationService),x(10,H.IWorkspacesHistoryMainService),x(11,re.IWorkspacesManagementMainService),x(12,o.IInstantiationService),x(13,r.IDialogMainService),x(14,i.IFileService),x(15,k.IProductService),x(16,L.IProtocolMainService),x(17,q.IThemeMainService)],$),e.WindowsMainService=$}),define(X[255],J([0,1,58,32,74,47]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let M=class{constructor(d,w,C,P){this.workspacesManagementMainService=d,this.windowsMainService=w,this.workspacesHistoryMainService=C,this.backupMainService=P,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,w){const C=this.windowsMainService.getWindowById(d);if(C)return this.workspacesManagementMainService.enterWorkspace(C,this.windowsMainService.getWindows(),w)}createUntitledWorkspace(d,w,C){return this.workspacesManagementMainService.createUntitledWorkspace(w,C)}deleteUntitledWorkspace(d,w){return this.workspacesManagementMainService.deleteUntitledWorkspace(w)}getWorkspaceIdentifier(d,w){return this.workspacesManagementMainService.getWorkspaceIdentifier(w)}getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}addRecentlyOpened(d,w){return this.workspacesHistoryMainService.addRecentlyOpened(w)}removeRecentlyOpened(d,w){return this.workspacesHistoryMainService.removeRecentlyOpened(w)}clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};M=fe([x(0,R.IWorkspacesManagementMainService),x(1,t.IWindowsMainService),x(2,D.IWorkspacesHistoryMainService),x(3,E.IBackupMainService)],M),e.WorkspacesMainService=M}),define(X[256],J([0,1,14,38,28,29,17,41,19,30,48,49,34,2,12,9,4,13,7,27,80,130,43,141,96,235,146,58,240,18,68,176,83,114,54,99,174,26,57,106,183,203,184,237,101,185,186,15,196,85,67,5,84,248,214,115,22,6,198,253,64,20,71,243,86,45,241,88,107,35,219,221,72,46,226,227,249,228,250,109,230,231,232,233,238,32,254,239,24,89,74,255,47,236,37,202,63,100,246,210,53]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s,r,n,i,o,a,c,v,k,L,O,F,j,ee,se,ae,ie,ce,H,re,q,T,N,V,te,$,Q,A,W,U,z,Y,_,K,Z,ne,le,ge,Ee,Re,Pe,ke,Ne,ue,he,pe,Ie,Me,Xe,Te,Oe,Ae,je,Qe,Ze,ze,Ve,G,oe,de,me,be,Le,He,nt,et,qe,Je,xe,at,ct,Lt,At,Tt,Wt,Ot,Ft,_t,Ut){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=class extends f.Disposable{constructor(we,Se,ye,ve,De,Fe,We,_e,Ce,Ue){super();this.mainProcessNodeIpcServer=we,this.userEnv=Se,this.mainInstantiationService=ye,this.logService=ve,this.environmentMainService=De,this.lifecycleMainService=Fe,this.configurationService=We,this.stateMainService=_e,this.fileService=Ce,this.productService=Ue,this.configureSession(),this.registerListeners()}configureSession(){const we=Ce=>Ce?.startsWith(`${u.Schemas.vscodeWebview}://`),Se=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Ce,Ue,$e,Ke)=>we(Ke.requestingUrl)?$e(Se.has(Ue)):$e(!1)),E.session.defaultSession.setPermissionCheckHandler((Ce,Ue,$e,Ke)=>we(Ke.requestingUrl)?Se.has(Ue):!1);const ye=new Set([u.Schemas.file,u.Schemas.vscodeFileResource,u.Schemas.vscodeRemoteResource,"devtools"]),ve=Ce=>{for(let Ue=Ce;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${u.Schemas.vscodeWebview}://`))return!0;return!1},De=Ce=>Ce.resourceType==="xhr"||ve(Ce.frame),Fe=Ce=>{const Ue=Ce.frame;if(!Ue||!this.windowsMainService)return!1;const $e=E.BrowserWindow.getAllWindows();for(const Ke of $e)if(Ue.processId===Ke.webContents.mainFrame.processId)return!0;return!1},We=(Ce,Ue)=>{if(Ce.path!=="/index.html")return!0;const $e=Ue.frame;if(!$e||!this.windowsMainService)return!1;for(const Ke of this.windowsMainService.getWindows())if(Ke.win&&$e.processId===Ke.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Ce,Ue)=>{const $e=I.URI.parse(Ce.url);return $e.scheme===u.Schemas.vscodeWebview&&!We($e,Ce)?(this.logService.error("Blocked vscode-webview request",Ce.url),Ue({cancel:!0})):$e.scheme===u.Schemas.vscodeFileResource&&!Fe(Ce)?(this.logService.error("Blocked vscode-file request",Ce.url),Ue({cancel:!0})):$e.path.endsWith(".svg")&&!ye.has($e.scheme)?Ue({cancel:!De(Ce)}):Ue({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Ce,Ue)=>{const $e=Ce.responseHeaders,Ke=$e["content-type"]||$e["Content-Type"];if(Ke&&Array.isArray(Ke)){const rt=I.URI.parse(Ce.url);if(rt.path.endsWith(".svg")&&ye.has(rt.scheme))return $e["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:$e});if(!rt.path.endsWith(u.Schemas.vscodeRemoteResource)&&Ke.some(ht=>ht.toLowerCase().includes("image/svg")))return Ue({cancel:!De(Ce)})}return Ue({cancel:!1})});const _e=E.session.defaultSession;typeof _e.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&_e.setCodeCachePath((0,p.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,d.setUnexpectedErrorHandler)(ye=>this.onUnexpectedError(ye)),process.on("uncaughtException",ye=>(0,d.onUnexpectedError)(ye)),process.on("unhandledRejection",ye=>(0,d.onUnexpectedError)(ye)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,l.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(ye,ve)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",ve)}),E.app.on("activate",(ye,ve)=>{this.logService.trace("app#activate"),ve||this.windowsMainService?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(ye,ve)=>{ve.on("will-navigate",De=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),De.preventDefault()}),ve.setWindowOpenHandler(({url:De})=>(this.nativeHostMainService?.openExternal(void 0,De),{action:"deny"}))});let we=[],Se;E.app.on("open-file",(ye,ve)=>{this.logService.trace("app#open-file: ",ve),ye.preventDefault(),we.push(this.getWindowOpenableFromPathSync(ve)),Se!==void 0&&(clearTimeout(Se),Se=void 0),Se=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:we,gotoLineMode:!1,preferNewWindow:!0}),we=[],Se=void 0},100)}),E.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),t.validatedIpcMain.handle("vscode:fetchShellEnv",ye=>{const ve=this.windowsMainService?.getWindowByWebContents(ye.sender);let De,Fe;return ve?.config?(De=ve.config,Fe={...process.env,...ve.config.userEnv}):(De=this.environmentMainService.args,Fe=process.env),this.resolveShellEnvironment(De,Fe,!1)}),t.validatedIpcMain.handle("vscode:writeNlsFile",(ye,ve,De)=>{const Fe=this.validateNlsPath([ve]);if(!Fe||typeof De!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(Fe,M.VSBuffer.fromString(De))}),t.validatedIpcMain.handle("vscode:readNlsFile",async(ye,...ve)=>{const De=this.validateNlsPath(ve);if(!De)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(De)).value.toString()}),t.validatedIpcMain.on("vscode:toggleDevTools",ye=>ye.sender.toggleDevTools()),t.validatedIpcMain.on("vscode:openDevTools",ye=>ye.sender.openDevTools()),t.validatedIpcMain.on("vscode:reloadWindow",ye=>ye.sender.reload())}validateNlsPath(we){let Se;for(const ye of we)typeof ye=="string"&&(typeof Se!="string"?Se=ye:Se=(0,p.join)(Se,ye));if(!(typeof Se!="string"||!(0,p.isAbsolute)(Se)||!(0,w.isEqualOrParent)(Se,this.environmentMainService.cachedLanguagesPath,!m.isLinux)))return I.URI.file(Se)}onUnexpectedError(we){if(we){const Se={message:`[uncaught exception in main]: ${we.message}`,stack:we.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(Se))}this.logService.error(`[uncaught exception in main]: ${we}`),we.stack&&this.logService.error(we.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const we=this.productService.win32AppUserModelId;m.isWindows&&we&&E.app.setAppUserModelId(we);try{m.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ce){this.logService.error(Ce)}const Se=new r.Server;this.lifecycleMainService.onWillShutdown(Ce=>{Ce.reason===2&&Se.dispose()}),this.logService.trace("Resolving machine identifier...");const ye=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${ye}`);const{sharedProcess:ve,sharedProcessReady:De,sharedProcessClient:Fe}=this.setupSharedProcess(ye),We=await this.initServices(ye,ve,De);this.setUpHandlers(We),We.invokeFunction(Ce=>this.initChannels(Ce,Se,Fe));const _e=We.invokeFunction(Ce=>this.openFirstWindow(Ce,Se));We.invokeFunction(Ce=>this.afterWindowOpen(Ce,ve)),this.environmentMainService.args.trace&&We.invokeFunction(Ce=>this.stopTracingEventually(Ce,_e))}setUpHandlers(we){this._register(we.createInstance(i.ProxyAuthHandler)),this._register(we.createInstance(Ft.DefaultExtensionsProfileInitHandler))}async resolveMachineId(){let we=this.stateMainService.getItem(Me.machineIdKey);return(!we||m.isMacintosh&&we==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(we=await(0,h.getMachineId)(),this.stateMainService.setItem(Me.machineIdKey,we)),we}setupSharedProcess(we){const Se=this._register(this.mainInstantiationService.createInstance(ke.SharedProcess,we,this.userEnv)),ye=(async()=>{this.logService.trace("Main->SharedProcess#connect");const De=await Se.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new n.Client(De,"main")})(),ve=(async()=>(await Se.whenReady(),ye))();return{sharedProcess:Se,sharedProcessReady:ve,sharedProcessClient:ye}}async initServices(we,Se,ye){const ve=new z.ServiceCollection;switch(process.platform){case"win32":ve.set(Ae.IUpdateService,new W.SyncDescriptor(Ve.Win32UpdateService));break;case"linux":m.isLinuxSnap?ve.set(Ae.IUpdateService,new W.SyncDescriptor(ze.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):ve.set(Ae.IUpdateService,new W.SyncDescriptor(Ze.LinuxUpdateService));break;case"darwin":ve.set(Ae.IUpdateService,new W.SyncDescriptor(Qe.DarwinUpdateService));break}ve.set(He.IWindowsMainService,new W.SyncDescriptor(nt.WindowsMainService,[we,this.userEnv])),ve.set(j.IDialogMainService,new W.SyncDescriptor(j.DialogMainService)),ve.set(K.ILaunchMainService,new W.SyncDescriptor(K.LaunchMainService)),ve.set(F.IDiagnosticsMainService,new W.SyncDescriptor(F.DiagnosticsMainService)),ve.set(O.IDiagnosticsService,s.ProxyChannel.toService((0,s.getDelayedChannel)(ye.then(Fe=>Fe.getChannel("diagnostics"))))),ve.set(Y.IIssueMainService,new W.SyncDescriptor(Y.IssueMainService,[this.userEnv])),ve.set(ee.IEncryptionMainService,new W.SyncDescriptor(se.EncryptionMainService,[we])),ve.set(_.IKeyboardLayoutMainService,new W.SyncDescriptor(_.KeyboardLayoutMainService)),ve.set(Ee.INativeHostMainService,new W.SyncDescriptor(Ee.NativeHostMainService,[Se])),ve.set(k.ICredentialsMainService,new W.SyncDescriptor(Lt.CredentialsNativeMainService)),ve.set(be.IWebviewManagerService,new W.SyncDescriptor(Le.WebviewMainService)),ve.set(Je.IWorkspacesService,new W.SyncDescriptor(at.WorkspacesMainService)),ve.set(ct.IWorkspacesManagementMainService,new W.SyncDescriptor(ct.WorkspacesManagementMainService)),ve.set(xe.IWorkspacesHistoryMainService,new W.SyncDescriptor(xe.WorkspacesHistoryMainService)),ve.set(ge.IMenubarMainService,new W.SyncDescriptor(ge.MenubarMainService)),ve.set(H.IExtensionUrlTrustService,new W.SyncDescriptor(re.ExtensionUrlTrustService)),ve.set(q.IExtensionHostStarter,new W.SyncDescriptor(T.ExtensionHostStarter)),ve.set(pe.IStorageMainService,new W.SyncDescriptor(pe.StorageMainService)),ve.set(pe.IApplicationStorageMainService,new W.SyncDescriptor(pe.ApplicationStorageMainService)),m.isWindows?ve.set(N.IExternalTerminalMainService,new W.SyncDescriptor(V.WindowsExternalTerminalService)):m.isMacintosh?ve.set(N.IExternalTerminalMainService,new W.SyncDescriptor(V.MacExternalTerminalService)):m.isLinux&&ve.set(N.IExternalTerminalMainService,new W.SyncDescriptor(V.LinuxExternalTerminalService));const De=new c.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(ve.set(a.IBackupMainService,De),ve.set(G.IURLService,new W.SyncDescriptor(de.NativeURLService)),(0,Oe.supportsTelemetry)(this.productService,this.environmentMainService)){const Fe=(0,Oe.isInternalTelemetry)(this.productService,this.configurationService),We=(0,s.getDelayedChannel)(ye.then(Ke=>Ke.getChannel("telemetryAppender"))),_e=new Xe.TelemetryAppenderClient(We),Ce=(0,Ie.resolveCommonProperties)(this.fileService,(0,R.release)(),(0,R.hostname)(),process.arch,this.productService.commit,this.productService.version,we,Fe,this.environmentMainService.installSourcePath),Ue=(0,Oe.getPiiPathsFromEnvironment)(this.environmentMainService),$e={appenders:[_e],commonProperties:Ce,piiPaths:Ue,sendErrorTelemetry:!0};ve.set(Me.ITelemetryService,new W.SyncDescriptor(Te.TelemetryService,[$e]))}else ve.set(Me.ITelemetryService,Oe.NullTelemetryService);return ve.set(Ot.IDefaultExtensionsProfileInitService,s.ProxyChannel.toService((0,s.getDelayedChannel)(ye.then(Fe=>Fe.getChannel("IDefaultExtensionsProfileInitService"))))),await De.initialize(),this.mainInstantiationService.createChild(ve)}initChannels(we,Se,ye){const ve=s.ProxyChannel.fromService(we.get(K.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",ve);const De=s.ProxyChannel.fromService(we.get(F.IDiagnosticsMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("diagnostics",De);const Fe=new Tt.PolicyChannel(we.get(At.IPolicyService));Se.registerChannel("policy",Fe),ye.then(Ye=>Ye.registerChannel("policy",Fe));const We=this.fileService.getProvider(u.Schemas.file);(0,y.assertType)(We instanceof A.DiskFileSystemProvider);const _e=new Q.DiskFileSystemProviderChannel(We,this.logService,this.environmentMainService);Se.registerChannel(te.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e),ye.then(Ye=>Ye.registerChannel(te.LOCAL_FILE_SYSTEM_CHANNEL_NAME,_e));const Ce=s.ProxyChannel.fromService(we.get(Wt.IUserDataProfilesMainService));Se.registerChannel("userDataProfiles",Ce),ye.then(Ye=>Ye.registerChannel("userDataProfiles",Ce));const Ue=new _t.RequestChannel(we.get(Ut.IRequestService));ye.then(Ye=>Ye.registerChannel("request",Ue));const $e=new je.UpdateChannel(we.get(Ae.IUpdateService));Se.registerChannel("update",$e);const Ke=s.ProxyChannel.fromService(we.get(Y.IIssueMainService));Se.registerChannel("issue",Ke);const rt=s.ProxyChannel.fromService(we.get(ee.IEncryptionMainService));Se.registerChannel("encryption",rt);const ht=s.ProxyChannel.fromService(we.get(k.ICredentialsMainService));Se.registerChannel("credentials",ht);const Ct=s.ProxyChannel.fromService(we.get(Ne.ISignService));Se.registerChannel("sign",Ct);const Ge=s.ProxyChannel.fromService(we.get(_.IKeyboardLayoutMainService));Se.registerChannel("keyboardLayout",Ge),this.nativeHostMainService=we.get(Ee.INativeHostMainService);const dt=s.ProxyChannel.fromService(this.nativeHostMainService);Se.registerChannel("nativeHost",dt),ye.then(Ye=>Ye.registerChannel("nativeHost",dt));const ft=s.ProxyChannel.fromService(we.get(Je.IWorkspacesService));Se.registerChannel("workspaces",ft);const gt=s.ProxyChannel.fromService(we.get(ge.IMenubarMainService));Se.registerChannel("menubar",gt);const wt=s.ProxyChannel.fromService(we.get(G.IURLService));Se.registerChannel("url",wt);const pt=s.ProxyChannel.fromService(we.get(H.IExtensionUrlTrustService));Se.registerChannel("extensionUrlTrust",pt);const mt=s.ProxyChannel.fromService(we.get(be.IWebviewManagerService));Se.registerChannel("webview",mt);const lt=this._register(new he.StorageDatabaseChannel(this.logService,we.get(pe.IStorageMainService)));Se.registerChannel("storage",lt),ye.then(Ye=>Ye.registerChannel("storage",lt));const vt=s.ProxyChannel.fromService(we.get(N.IExternalTerminalMainService));Se.registerChannel("externalTerminal",vt);const Be=new le.LogLevelChannel(we.get(ne.ILogService));Se.registerChannel("logLevel",Be),ye.then(Ye=>Ye.registerChannel("logLevel",Be));const it=new le.LoggerChannel(we.get(ne.ILoggerService));Se.registerChannel("logger",it),ye.then(Ye=>Ye.registerChannel("logger",it));const ot=new L.ElectronExtensionHostDebugBroadcastChannel(we.get(He.IWindowsMainService));Se.registerChannel("extensionhostdebugservice",ot);const st=s.ProxyChannel.fromService(we.get(q.IExtensionHostStarter));Se.registerChannel(q.ipcExtensionHostStarterChannelName,st)}openFirstWindow(we,Se){const ye=this.windowsMainService=we.get(He.IWindowsMainService),ve=we.get(G.IURLService),De=we.get(Ee.INativeHostMainService);this.lifecycleMainService.phase=2;const Fe=[],We=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(Be=>{try{return{uri:I.URI.parse(Be),url:Be}}catch{return}}).filter(Be=>{if(!Be||this.shouldBlockURI(Be.uri))return!1;const it=this.getWindowOpenableFromProtocolLink(Be.uri);return it?(Fe.push(it),!1):!0}),_e=this,Ce=this.environmentMainService,Ue=this.productService,$e=this.logService;ve.registerHandler({async handleURL(Be,it){if($e.trace("app#handleURL: ",Be.toString(!0),it),Be.scheme===Ue.urlProtocol&&Be.path==="workspace"&&(Be=Be.with({authority:"file",path:I.URI.parse(Be.query).path,query:""})),_e.shouldBlockURI(Be))return!0;let ot=!1;const st=new URLSearchParams(Be.query);st.get("windowId")==="_blank"&&(st.delete("windowId"),Be=Be.with({query:st.toString()}),ot=!0),ot||(ot=m.isMacintosh&&ye.getWindowCount()===0),st.get("editSessionId")!==null&&(Ce.editSessionId=st.get("editSessionId")??void 0,st.delete("editSessionId"),Be=Be.with({query:st.toString()}));const Ye=_e.getWindowOpenableFromProtocolLink(Be);if($e.trace("app#handleURL: windowOpenableFromProtocolLink = ",Ye),Ye){const[Pt]=ye.open({context:5,cli:{...Ce.args},urisToOpen:[Ye],forceNewWindow:ot,gotoLineMode:!0});return Pt.focus(),!0}if(ot){const[Pt]=ye.open({context:5,cli:{...Ce.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Pe.getRemoteAuthority)(Be)});return await Pt.ready(),ve.open(Be,it)}return!1}});const Ke=this._register(new et.ActiveWindowManager({onDidOpenWindow:De.onDidOpenWindow,onDidFocusWindow:De.onDidFocusWindow,getActiveWindowId:()=>De.getActiveWindowId(-1)})),rt=new s.StaticRouter(Be=>Ke.getActiveClientId().then(it=>Be===it)),ht=new oe.URLHandlerRouter(rt),Ct=Se.getChannel("urlHandler",ht);ve.registerHandler(new oe.URLHandlerChannelClient(Ct)),this._register(new me.ElectronURLListener(We,ve,ye,this.environmentMainService,this.productService));const Ge=this.environmentMainService.args,dt=global.macOpenFiles,ft=(0,ie.isLaunchedFromCli)(process.env)?0:4,gt=Ge._.length,wt=!!Ge["folder-uri"],pt=!!Ge["file-uri"],mt=Ge["skip-add-to-recently-opened"]===!0,lt=Ge.wait&&Ge.waitMarkerFilePath?I.URI.file(Ge.waitMarkerFilePath):void 0,vt=Ge.remote||void 0;return Fe.length>0?ye.open({context:ft,cli:Ge,urisToOpen:Fe,gotoLineMode:!0,initialStartup:!0}):Ge["new-window"]&&!gt&&!wt&&!pt?ye.open({context:ft,cli:Ge,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:mt,waitMarkerFileURI:lt,initialStartup:!0,remoteAuthority:vt}):dt.length&&!gt&&!wt&&!pt?ye.open({context:1,cli:Ge,urisToOpen:dt.map(Be=>this.getWindowOpenableFromPathSync(Be)),noRecentEntry:mt,waitMarkerFileURI:lt,initialStartup:!0}):ye.open({context:ft,cli:Ge,forceNewWindow:Ge["new-window"]||!gt&&Ge["unity-launch"],diffMode:Ge.diff,mergeMode:Ge.merge,noRecentEntry:mt,waitMarkerFileURI:lt,gotoLineMode:Ge.goto,initialStartup:!0,remoteAuthority:vt})}shouldBlockURI(we){return!!(we.authority===u.Schemas.file&&m.isWindows&&E.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(0,null)),(0,S.mnemonicButtonLabel)((0,o.localize)(1,null))],defaultId:0,cancelId:1,message:(0,o.localize)(2,null,(0,S.getPathLabel)(we,{os:m.OS,tildify:this.environmentMainService}),this.productService.nameShort),detail:(0,o.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(we){if(!!we.path){if(we.authority===u.Schemas.file){const Se=I.URI.file(we.fsPath);return(0,qe.hasWorkspaceFileExtension)(Se)?{workspaceUri:Se}:{fileUri:Se}}else if(we.authority===u.Schemas.vscodeRemote){const Se=we.path.indexOf(p.posix.sep,1);if(Se!==-1){const ye=we.path.substring(1,Se),ve=we.path.substring(Se),De=I.URI.from({scheme:u.Schemas.vscodeRemote,authority:ye,path:ve,query:we.query,fragment:we.fragment});return(0,qe.hasWorkspaceFileExtension)(ve)?{workspaceUri:De}:/:[\d]+$/.test(ve)?{fileUri:De}:{folderUri:De}}}}}getWindowOpenableFromPathSync(we){try{if((0,D.statSync)(we).isDirectory())return{folderUri:I.URI.file(we)};if((0,qe.hasWorkspaceFileExtension)(we))return{workspaceUri:I.URI.file(we)}}catch{}return{fileUri:I.URI.file(we)}}async afterWindowOpen(we,Se){this.lifecycleMainService.phase=3;let ye=!1;(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>ye=!0);const ve=we.get(Me.ITelemetryService);this._register(Se.onDidError(({type:We,details:_e})=>{let Ce;switch(We){case 1:Ce="SharedProcess: detected unresponsive window";break;case 2:Ce=`SharedProcess: crashed (detail: ${_e?.reason??"<unknown>"}, code: ${_e?.exitCode??"<unknown>"})`;break;case 3:Ce=`SharedProcess: failed to load (detail: ${_e?.reason??"<unknown>"}, code: ${_e?.exitCode??"<unknown>"})`;break}(0,d.onUnexpectedError)(new Error(Ce)),ve.publicLog2("sharedprocesserror",{type:We,reason:_e?.reason,code:_e?.exitCode,visible:Se.isVisible(),shuttingdown:ye})}));const De=this.productService.win32MutexName;if(m.isWindows&&De)try{const We=B.__$__nodeRequire("windows-mutex").Mutex,_e=new We(De);(0,C.once)(this.lifecycleMainService.onWillShutdown)(()=>_e.release())}catch(We){this.logService.error(We)}E.protocol.registerHttpProtocol(u.Schemas.vscodeRemoteResource,(We,_e)=>{_e({url:We.url.replace(/^vscode-remote-resource:/,"http:"),method:We.method})});const Fe=we.get(Ae.IUpdateService);(Fe instanceof Ve.Win32UpdateService||Fe instanceof Ze.LinuxUpdateService||Fe instanceof Qe.DarwinUpdateService)&&await Fe.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env,!0);try{const _e=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,P.stripComments)(_e))["enable-crash-reporter"]===void 0){const $e=(0,Oe.getTelemetryLevel)(this.configurationService)>=1,Ke=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${$e},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,g.generateUuid)()}"`,"}"],rt=_e.substring(0,_e.length-2).concat(`,
`,Ke.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(rt))}}catch(We){this.logService.error(We)}}async resolveShellEnvironment(we,Se,ye){try{return await(0,ce.getResolvedShellEnv)(this.logService,we,Se)}catch(ve){const De=(0,b.toErrorMessage)(ve);ye?this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",De):this.logService.error(De)}return{}}stopTracingEventually(we,Se){this.logService.info("Tracing: waiting for windows to get ready...");const ye=we.get(j.IDialogMainService);let ve=!1;const De=async We=>{if(ve)return;ve=!0;const _e=await E.contentTracing.stopRecording(`${(0,w.randomPath)(this.environmentMainService.userHome.fsPath,this.productService.applicationName)}.trace.txt`);We?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${_e}`):ye.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,o.localize)(4,null),detail:(0,o.localize)(5,null,_e),buttons:[(0,S.mnemonicButtonLabel)((0,o.localize)(6,null))],defaultId:0,noLink:!0},(0,y.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))},Fe=setTimeout(()=>De(!0),3e4);Promise.all(Se.map(We=>We.ready())).then(()=>{clearTimeout(Fe),De(!1)})}};Et=fe([x(2,U.IInstantiationService),x(3,ne.ILogService),x(4,ae.IEnvironmentMainService),x(5,Z.ILifecycleMainService),x(6,v.IConfigurationService),x(7,ue.IStateMainService),x(8,$.IFileService),x(9,Re.IProductService)],Et),e.CodeApplication=Et}),define(X[257],J([0,1,37,8,264,2]),function(B,e,E,t,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;class M extends E.AbstractPolicyService{constructor(d){super();this.productName=d,this.throttler=new t.Throttler,this.watcher=this._register(new R.MutableDisposable)}async initializePolicies(d){await this.throttler.queue(()=>new Promise((w,C)=>{try{this.watcher.value=(0,D.createWatcher)(this.productName,d,P=>{for(const S in P){const f=P[S];f===void 0?this.policies.delete(S):this.policies.set(S,f)}this._onDidChange.fire(Object.keys(P)),w()})}catch(P){C(P)}}))}}e.NativePolicyService=M}),define(X[258],J([0,1,212,8,17,19,2,13,18,39,106,6,211,265]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let u=class extends M.Disposable{constructor(m,y,I){super();this.environmentService=y,this.logService=I,this.configure(m.getValue()),this._register(m.onDidChangeConfiguration(()=>this.configure(m.getValue()),this))}configure(m){this.proxyUrl=m.http&&m.http.proxy,this.strictSSL=!!(m.http&&m.http.proxyStrictSSL),this.authorization=m.http&&m.http.proxyAuthorization}async request(m,y){this.logService.trace("RequestService#request (node) - begin",m.url);const{proxyUrl:I,strictSSL:g}=this;let h;try{h=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(r){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",r))}const l={...process.env,...h},s=m.agent?m.agent:await(0,S.getProxyAgent)(m.url||"",l,{proxyUrl:I,strictSSL:g});m.agent=s,m.strictSSL=g,this.authorization&&(m.headers={...m.headers||{},"Proxy-Authorization":this.authorization});try{const r=await this._request(m,y);return this.logService.trace("RequestService#request (node) - success",m.url),r}catch(r){throw this.logService.trace("RequestService#request (node) - error",m.url,r),r}}async getNodeRequest(m){return((0,E.parse)(m.url).protocol==="https:"?await new Promise((g,h)=>{B(["https"],g,h)}):await new Promise((g,h)=>{B(["http"],g,h)})).request}_request(m,y){return t.Promises.withAsyncBody(async(I,g)=>{const h=(0,E.parse)(m.url),l=m.getRawRequest?m.getRawRequest(m):await this.getNodeRequest(m),s={hostname:h.hostname,port:h.port?parseInt(h.port):h.protocol==="https:"?443:80,protocol:h.protocol,path:h.path,method:m.type||"GET",headers:m.headers,agent:m.agent,rejectUnauthorized:(0,b.isBoolean)(m.strictSSL)?m.strictSSL:!0};m.user&&m.password&&(s.auth=m.user+":"+m.password);const r=l(s,n=>{const i=(0,b.isNumber)(m.followRedirects)?m.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&i>0&&n.headers.location)this._request({...m,url:n.headers.location,followRedirects:i-1},y).then(I,g);else{let o=n;n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,f.createGunzip)())),I({res:n,stream:(0,D.streamToBufferReadableStream)(o)})}});r.on("error",g),m.timeout&&r.setTimeout(m.timeout),m.data&&typeof m.data=="string"&&r.write(m.data),r.end(),y.onCancellationRequested(()=>{r.abort(),g(new R.CancellationError)})})}async resolveProxy(m){}};u=fe([x(0,d.IConfigurationService),x(1,w.INativeEnvironmentService),x(2,P.ILogService)],u),e.RequestService=u}),define(X[259],J([0,1,14,258]),function(B,e,E,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(M){return E.net.request}class R extends t.RequestService{request(b,d){return super.request({...b||{},getRawRequest:D},d)}}e.RequestMainService=R}),define(X[266],J([0,1,14,28,7,25,8,41,19,30,48,34,12,9,70,4,36,31,23,43,81,256,10,18,206,218,26,57,179,15,194,85,67,191,84,22,103,6,199,104,52,20,59,242,108,224,53,259,86,213,45,217,72,61,63,37,257,201,2,62,229,40,225]),function(B,e,E,t,D,R,M,b,d,w,C,P,S,f,u,p,m,y,I,g,h,l,s,r,n,i,o,a,c,v,k,L,O,F,j,ee,se,ae,ie,ce,H,re,q,T,N,V,te,$,Q,A,W,U,z,Y,_,K,Z,ne,le,ge,Ee,Re){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Pe{main(){try{this.startup()}catch(ue){console.error(ue.message),E.app.exit(1)}}async startup(){(0,d.setUnexpectedErrorHandler)(Ae=>console.error(Ae));const[ue,he,pe,Ie,Me,Xe,Te,Oe]=this.createServices();try{try{await this.initServices(pe,Oe,Ie,Me)}catch(Ae){throw this.handleStartupDataDirError(pe,Te.nameLong,Ae),Ae}await ue.invokeFunction(async Ae=>{const je=Ae.get(ae.ILogService),Qe=Ae.get(ee.ILifecycleMainService),Ze=Ae.get(v.IFileService),ze=await this.claimInstance(je,pe,Qe,ue,Te,!0);return I.Promises.writeFile(pe.mainLockfile,String(process.pid)).catch(Ve=>{je.warn(`Error writing main lockfile: ${Ve.stack}`)}),Xe.logger=new ce.SpdLogLogger("main",(0,f.join)(pe.logsPath,"main.log"),!0,!1,Xe.getLevel()),(0,C.once)(Qe.onWillShutdown)(Ve=>{Ze.dispose(),Ie.dispose(),Ve.join(I.Promises.unlink(pe.mainLockfile).catch(()=>{}))}),ue.createInstance(l.CodeApplication,ze,he).startup()})}catch(Ae){ue.invokeFunction(this.quit,Ae)}}createServices(){const ue=new j.ServiceCollection,he=new le.DisposableStore;process.once("exit",()=>he.dispose());const pe={_serviceBrand:void 0,...H.default};ue.set(re.IProductService,pe);const Ie=new o.EnvironmentMainService(this.resolveArgs(),pe),Me=this.patchEnvironment(Ie);ue.set(o.IEnvironmentMainService,Ie);const Xe=new se.BufferLogService,Te=he.add(new ae.MultiplexLogService([new ae.ConsoleMainLogger((0,ae.getLogLevel)(Ie)),Xe]));ue.set(ae.ILogService,Te);const Oe=new k.FileService(Te);ue.set(v.IFileService,Oe);const Ae=new L.DiskFileSystemProvider(Te);Oe.registerProvider(S.Schemas.file,Ae);const je=new Ee.UriIdentityService(Oe);ue.set(ge.IUriIdentityService,je),ue.set(ae.ILoggerService,new ie.LoggerService(Te,Oe));const Qe=new U.StateMainService(Ie,Te,Oe);ue.set(W.IStateMainService,Qe);const Ze=new _.UserDataProfilesMainService(Qe,je,Ie,Oe,Te);ue.set(_.IUserDataProfilesMainService,Ze);const ze=p.isWindows&&pe.win32RegValueName?he.add(new Z.NativePolicyService(pe.win32RegValueName)):Ie.policyFile?he.add(new ne.FilePolicyService(Ie.policyFile,Oe,Te)):new K.NullPolicyService;ue.set(K.IPolicyService,ze);const Ve=new n.ConfigurationService(Ze.defaultProfile.settingsResource,Oe,ze,Te);return ue.set(r.IConfigurationService,Ve),ue.set(ee.ILifecycleMainService,new O.SyncDescriptor(ee.LifecycleMainService)),ue.set(te.IRequestService,new O.SyncDescriptor($.RequestMainService)),ue.set(Y.IThemeMainService,new O.SyncDescriptor(Y.ThemeMainService)),ue.set(Q.ISignService,new O.SyncDescriptor(A.SignService)),ue.set(N.ITunnelService,new O.SyncDescriptor(V.TunnelService)),ue.set(q.IProtocolMainService,new O.SyncDescriptor(T.ProtocolMainService)),[new F.InstantiationService(ue,!0),Me,Ie,Ve,Qe,Xe,pe,Ze]}patchEnvironment(ue){const he={VSCODE_IPC_HOOK:ue.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(pe=>{const Ie=process.env[pe];typeof Ie=="string"&&(he[pe]=Ie)}),Object.assign(process.env,he),he}async initServices(ue,he,pe,Ie){await M.Promises.settled([Promise.all([ue.extensionsPath,ue.codeCachePath,ue.logsPath,he.defaultProfile.globalStorageHome.fsPath,ue.workspaceStorageHome.fsPath,ue.localHistoryHome.fsPath,ue.backupHome].map(Me=>Me?I.Promises.mkdir(Me,{recursive:!0}):void 0)),Ie.init(),pe.initialize()]),he.setEnablement(!!pe.getValue(Re.PROFILES_ENABLEMENT_CONFIG))}async claimInstance(ue,he,pe,Ie,Me,Xe){let Te;try{(0,u.mark)("code/willStartMainServer"),Te=await(0,h.serve)(he.mainIPCHandle),(0,u.mark)("code/didStartMainServer"),(0,C.once)(pe.onWillShutdown)(()=>Te.dispose())}catch(Oe){if(Oe.code!=="EADDRINUSE")throw this.handleStartupDataDirError(he,Me.nameLong,Oe),Oe;let Ae;try{Ae=await(0,h.connect)(he.mainIPCHandle,"main")}catch(ze){if(!Xe||p.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.showStartupWarningDialog((0,s.localize)(0,null,Me.nameShort),(0,s.localize)(1,null),Me.nameLong),ze;try{(0,t.unlinkSync)(he.mainIPCHandle)}catch(Ve){throw ue.warn("Could not delete obsolete instance handle",Ve),Ve}return this.claimInstance(ue,he,pe,Ie,Me,!1)}if(he.extensionTestsLocationURI&&!he.debugExtensionHost.break){const ze="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ue.error(ze),Ae.dispose(),new Error(ze)}let je;!he.args.wait&&!he.args.status&&(je=setTimeout(()=>{this.showStartupWarningDialog((0,s.localize)(2,null,Me.nameShort),(0,s.localize)(3,null),Me.nameLong)},1e4));const Qe=g.ProxyChannel.toService(Ae.getChannel("launch"),{disableMarshalling:!0}),Ze=g.ProxyChannel.toService(Ae.getChannel("diagnostics"),{disableMarshalling:!0});if(he.args.status)return Ie.invokeFunction(async()=>{const ze=new i.DiagnosticsService(z.NullTelemetryService,Me),Ve=await Qe.getMainProcessInfo(),G=await Ze.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),oe=await ze.getDiagnostics(Ve,G);throw console.log(oe),new d.ExpectedError});throw p.isWindows&&await this.windowsAllowSetForegroundWindow(Qe,ue),ue.trace("Sending env to running instance..."),await Qe.start(he.args,process.env),Ae.dispose(),je&&clearTimeout(je),new d.ExpectedError("Sent env to running instance. Terminating...")}if(he.args.status)throw ue.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new d.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Te}handleStartupDataDirError(ue,he,pe){if(pe.code==="EACCES"||pe.code==="EPERM"){const Ie=(0,R.coalesce)([ue.userDataPath,ue.extensionsPath,h.XDG_RUNTIME_DIR]).map(Me=>(0,P.getPathLabel)(D.URI.file(Me),{os:p.OS,tildify:ue}));this.showStartupWarningDialog((0,s.localize)(4,null),(0,s.localize)(5,null,(0,b.toErrorMessage)(pe),Ie.join(`
`)),he)}}showStartupWarningDialog(ue,he,pe){E.dialog.showMessageBoxSync({title:pe,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,s.localize)(6,null))],message:ue,detail:he,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ue,he){if(p.isWindows){const pe=await ue.getMainProcessId();he.trace("Sending some foreground love to the running instance:",pe);try{(await new Promise((Ie,Me)=>{B(["windows-foreground-love"],Ie,Me)})).allowSetForegroundWindow(pe)}catch(Ie){he.error(Ie)}}}quit(ue,he){const pe=ue.get(ae.ILogService),Ie=ue.get(ee.ILifecycleMainService);let Me=0;he&&(he.isExpected?he.message&&pe.trace(he.message):(Me=1,he.stack?pe.error(he.stack):pe.error(`Startup error: ${he.toString()}`))),Ie.kill(Me)}resolveArgs(){const ue=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ue.wait&&!ue.waitMarkerFilePath){const he=(0,c.createWaitMarkerFile)(ue.verbose);he&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",he),ue.waitMarkerFilePath=he)}return ue}validatePaths(ue){if(ue["open-url"]&&(ue._urls=ue._,ue._=[]),!ue.remote){const he=this.doValidatePaths(ue._,ue.goto);ue._=he}return ue}doValidatePaths(ue,he){const pe=(0,m.cwd)(),Ie=ue.map(Te=>{let Oe=String(Te),Ae;he&&(Ae=(0,w.parseLineAndColumnAware)(Oe),Oe=Ae.path),Oe&&(Oe=this.preparePath(pe,Oe));const je=(0,w.sanitizeFilePath)(Oe,pe),Qe=(0,f.basename)(je);return Qe&&!(0,w.isValidBasename)(Qe)?null:he&&Ae?(Ae.path=je,this.toPath(Ae)):je}),Me=p.isWindows||p.isMacintosh,Xe=(0,R.distinct)(Ie,Te=>Te&&Me?Te.toLowerCase():Te||"");return(0,R.coalesce)(Xe)}preparePath(ue,he){return p.isWindows&&(he=(0,y.rtrim)(he,'"')),he=(0,y.trim)((0,y.trim)(he," "),"	"),p.isWindows&&(he=(0,f.resolve)(ue,he),he=(0,y.rtrim)(he,".")),he}toPath(ue){const he=[ue.path];return typeof ue.line=="number"&&he.push(String(ue.line)),typeof ue.column=="number"&&he.push(String(ue.column)),he.join(":")}}new Pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8179d832082f44ee45c4f9e01e229d22c008a2a6/core/vs/code/electron-main/main.js.map
