/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/errors","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/assert","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(Q){for(var t=[],D=0,i=Q.length;D<i;D++)t[D]=me[Q[D]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(Q){if(Array.isArray(Q)){for(var t=0,D=Array(Q.length);t<Q.length;t++)D[t]=Q[t];return D}else return Array.from(Q)}var Kt=Object.hasOwnProperty,Lt=Object.setPrototypeOf,qt=Object.isFrozen,xt=Object.getPrototypeOf,jt=Object.getOwnPropertyDescriptor,it=Object.freeze,ot=Object.seal,Gt=Object.create,Nt=typeof Reflect!="undefined"&&Reflect,bt=Nt.apply,Et=Nt.construct;bt||(bt=function(t,D,i){return t.apply(D,i)}),it||(it=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,D){return new(Function.prototype.bind.apply(t,[null].concat($t(D))))});var Yt=nt(Array.prototype.forEach),kt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Xt=nt(String.prototype.indexOf),Zt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Qt(TypeError);function nt(Q){return function(t){for(var D=arguments.length,i=Array(D>1?D-1:0),P=1;P<D;P++)i[P-1]=arguments[P];return bt(Q,t,i)}}function Qt(Q){return function(){for(var t=arguments.length,D=Array(t),i=0;i<t;i++)D[i]=arguments[i];return Et(Q,D)}}function Be(Q,t){Lt&&Lt(Q,null);for(var D=t.length;D--;){var i=t[D];if(typeof i=="string"){var P=ut(i);P!==i&&(qt(t)||(t[D]=P),i=P)}Q[i]=!0}return Q}function ct(Q){var t=Gt(null),D=void 0;for(D in Q)bt(Kt,Q,[D])&&(t[D]=Q[D]);return t}function wt(Q,t){for(;Q!==null;){var D=jt(Q,t);if(D){if(D.get)return nt(D.get);if(typeof D.value=="function")return nt(D.value)}Q=xt(Q)}function i(P){return console.warn("fallback value for",P),null}return i}var Mt=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),_t=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=it(["#text"]),Bt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),At=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),vt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=ot(/<%[\s\S]*|[\s\S]*%>/gm),ni=ot(/^data-[\-\w.\u00B7-\uFFFF]/),si=ot(/^aria-[\-\w]+$/),ri=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=ot(/^(?:\w+script|data):/i),ai=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Q){return typeof Q}:function(Q){return Q&&typeof Symbol=="function"&&Q.constructor===Symbol&&Q!==Symbol.prototype?"symbol":typeof Q};function rt(Q){if(Array.isArray(Q)){for(var t=0,D=Array(Q.length);t<Q.length;t++)D[t]=Q[t];return D}else return Array.from(Q)}var li=function(){return typeof window=="undefined"?null:window},ui=function(t,D){if((typeof t=="undefined"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,P="data-tt-policy-suffix";D.currentScript&&D.currentScript.hasAttribute(P)&&(i=D.currentScript.getAttribute(P));var M="dompurify"+(i?"#"+i:"");try{return t.createPolicy(M,{createHTML:function(b){return b}})}catch{return console.warn("TrustedTypes policy "+M+" could not be created."),null}};function Wt(){var Q=arguments.length>0&&arguments[0]!==void 0?arguments[0]:li(),t=function(le){return Wt(le)};if(t.version="2.3.1",t.removed=[],!Q||!Q.document||Q.document.nodeType!==9)return t.isSupported=!1,t;var D=Q.document,i=Q.document,P=Q.DocumentFragment,M=Q.HTMLTemplateElement,y=Q.Node,b=Q.Element,m=Q.NodeFilter,h=Q.NamedNodeMap,p=h===void 0?Q.NamedNodeMap||Q.MozNamedAttrMap:h,A=Q.Text,l=Q.Comment,r=Q.DOMParser,e=Q.trustedTypes,c=b.prototype,g=wt(c,"cloneNode"),E=wt(c,"nextSibling"),_=wt(c,"childNodes"),u=wt(c,"parentNode");if(typeof M=="function"){var d=i.createElement("template");d.content&&d.content.ownerDocument&&(i=d.content.ownerDocument)}var w=ui(e,D),S=w&&W?w.createHTML(""):"",L=i,C=L.implementation,n=L.createNodeIterator,s=L.createDocumentFragment,a=L.getElementsByTagName,o=D.importNode,v={};try{v=ct(i).documentMode?i.documentMode:{}}catch{}var N={};t.isSupported=typeof u=="function"&&C&&typeof C.createHTMLDocument!="undefined"&&v!==9;var K=ti,ne=ii,re=ni,we=si,ae=oi,ve=ai,fe=ri,ge=null,ye=Be({},[].concat(rt(Mt),rt(_t),rt(Ct),rt(St),rt(Ot))),ee=null,he=Be({},[].concat(rt(Bt),rt(At),rt(Ht),rt(vt))),te=null,Z=null,se=!0,ie=!0,T=!1,$=!1,X=!1,R=!1,f=!1,I=!1,U=!1,q=!0,W=!1,O=!0,H=!0,V=!1,F={},z=null,k=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),B=null,j=Be({},["audio","video","img","source","image","track"]),J=null,ce=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),de="http://www.w3.org/1998/Math/MathML",Ee="http://www.w3.org/2000/svg",_e="http://www.w3.org/1999/xhtml",ke=_e,Ie=!1,De=null,Pe=i.createElement("form"),Me=function(le){De&&De===le||((!le||(typeof le=="undefined"?"undefined":pt(le))!=="object")&&(le={}),le=ct(le),ge="ALLOWED_TAGS"in le?Be({},le.ALLOWED_TAGS):ye,ee="ALLOWED_ATTR"in le?Be({},le.ALLOWED_ATTR):he,J="ADD_URI_SAFE_ATTR"in le?Be(ct(ce),le.ADD_URI_SAFE_ATTR):ce,B="ADD_DATA_URI_TAGS"in le?Be(ct(j),le.ADD_DATA_URI_TAGS):j,z="FORBID_CONTENTS"in le?Be({},le.FORBID_CONTENTS):k,te="FORBID_TAGS"in le?Be({},le.FORBID_TAGS):{},Z="FORBID_ATTR"in le?Be({},le.FORBID_ATTR):{},F="USE_PROFILES"in le?le.USE_PROFILES:!1,se=le.ALLOW_ARIA_ATTR!==!1,ie=le.ALLOW_DATA_ATTR!==!1,T=le.ALLOW_UNKNOWN_PROTOCOLS||!1,$=le.SAFE_FOR_TEMPLATES||!1,X=le.WHOLE_DOCUMENT||!1,I=le.RETURN_DOM||!1,U=le.RETURN_DOM_FRAGMENT||!1,q=le.RETURN_DOM_IMPORT!==!1,W=le.RETURN_TRUSTED_TYPE||!1,f=le.FORCE_BODY||!1,O=le.SANITIZE_DOM!==!1,H=le.KEEP_CONTENT!==!1,V=le.IN_PLACE||!1,fe=le.ALLOWED_URI_REGEXP||fe,ke=le.NAMESPACE||_e,$&&(ie=!1),U&&(I=!0),F&&(ge=Be({},[].concat(rt(Ot))),ee=[],F.html===!0&&(Be(ge,Mt),Be(ee,Bt)),F.svg===!0&&(Be(ge,_t),Be(ee,At),Be(ee,vt)),F.svgFilters===!0&&(Be(ge,Ct),Be(ee,At),Be(ee,vt)),F.mathMl===!0&&(Be(ge,St),Be(ee,Ht),Be(ee,vt))),le.ADD_TAGS&&(ge===ye&&(ge=ct(ge)),Be(ge,le.ADD_TAGS)),le.ADD_ATTR&&(ee===he&&(ee=ct(ee)),Be(ee,le.ADD_ATTR)),le.ADD_URI_SAFE_ATTR&&Be(J,le.ADD_URI_SAFE_ATTR),le.FORBID_CONTENTS&&(z===k&&(z=ct(z)),Be(z,le.FORBID_CONTENTS)),H&&(ge["#text"]=!0),X&&Be(ge,["html","head","body"]),ge.table&&(Be(ge,["tbody"]),delete te.tbody),it&&it(le),De=le)},Ge=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),Ue=Be({},_t);Be(Ue,Ct),Be(Ue,Jt);var Je=Be({},St);Be(Je,ei);var je=function(le){var Se=u(le);(!Se||!Se.tagName)&&(Se={namespaceURI:_e,tagName:"template"});var Ne=ut(le.tagName),$e=ut(Se.tagName);if(le.namespaceURI===Ee)return Se.namespaceURI===_e?Ne==="svg":Se.namespaceURI===de?Ne==="svg"&&($e==="annotation-xml"||Ge[$e]):Boolean(Ue[Ne]);if(le.namespaceURI===de)return Se.namespaceURI===_e?Ne==="math":Se.namespaceURI===Ee?Ne==="math"&&He[$e]:Boolean(Je[Ne]);if(le.namespaceURI===_e){if(Se.namespaceURI===Ee&&!He[$e]||Se.namespaceURI===de&&!Ge[$e])return!1;var Ze=Be({},["title","style","font","a","script"]);return!Je[Ne]&&(Ze[Ne]||!Ue[Ne])}return!1},Oe=function(le){mt(t.removed,{element:le});try{le.parentNode.removeChild(le)}catch{try{le.outerHTML=S}catch{le.remove()}}},x=function(le,Se){try{mt(t.removed,{attribute:Se.getAttributeNode(le),from:Se})}catch{mt(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(le),le==="is"&&!ee[le])if(I||U)try{Oe(Se)}catch{}else try{Se.setAttribute(le,"")}catch{}},oe=function(le){var Se=void 0,Ne=void 0;if(f)le="<remove></remove>"+le;else{var $e=Pt(le,/^[\r\n\t ]+/);Ne=$e&&$e[0]}var Ze=w?w.createHTML(le):le;if(ke===_e)try{Se=new r().parseFromString(Ze,"text/html")}catch{}if(!Se||!Se.documentElement){Se=C.createDocument(ke,"template",null);try{Se.documentElement.innerHTML=Ie?"":Ze}catch{}}var Qe=Se.body||Se.documentElement;return le&&Ne&&Qe.insertBefore(i.createTextNode(Ne),Qe.childNodes[0]||null),ke===_e?a.call(Se,X?"html":"body")[0]:X?Se.documentElement:Qe},be=function(le){return n.call(le.ownerDocument||le,le,m.SHOW_ELEMENT|m.SHOW_COMMENT|m.SHOW_TEXT,null,!1)},Ce=function(le){return le instanceof A||le instanceof l?!1:typeof le.nodeName!="string"||typeof le.textContent!="string"||typeof le.removeChild!="function"||!(le.attributes instanceof p)||typeof le.removeAttribute!="function"||typeof le.setAttribute!="function"||typeof le.namespaceURI!="string"||typeof le.insertBefore!="function"},Fe=function(le){return(typeof y=="undefined"?"undefined":pt(y))==="object"?le instanceof y:le&&(typeof le=="undefined"?"undefined":pt(le))==="object"&&typeof le.nodeType=="number"&&typeof le.nodeName=="string"},Re=function(le,Se,Ne){!N[le]||Yt(N[le],function($e){$e.call(t,Se,Ne,De)})},Ve=function(le){var Se=void 0;if(Re("beforeSanitizeElements",le,null),Ce(le)||Pt(le.nodeName,/[\u0080-\uFFFF]/))return Oe(le),!0;var Ne=ut(le.nodeName);if(Re("uponSanitizeElement",le,{tagName:Ne,allowedTags:ge}),!Fe(le.firstElementChild)&&(!Fe(le.content)||!Fe(le.content.firstElementChild))&&at(/<[/\w]/g,le.innerHTML)&&at(/<[/\w]/g,le.textContent)||Ne==="select"&&at(/<template/i,le.innerHTML))return Oe(le),!0;if(!ge[Ne]||te[Ne]){if(H&&!z[Ne]){var $e=u(le)||le.parentNode,Ze=_(le)||le.childNodes;if(Ze&&$e)for(var Qe=Ze.length,et=Qe-1;et>=0;--et)$e.insertBefore(g(Ze[et],!0),E(le))}return Oe(le),!0}return le instanceof b&&!je(le)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,le.innerHTML)?(Oe(le),!0):($&&le.nodeType===3&&(Se=le.textContent,Se=lt(Se,K," "),Se=lt(Se,ne," "),le.textContent!==Se&&(mt(t.removed,{element:le.cloneNode()}),le.textContent=Se)),Re("afterSanitizeElements",le,null),!1)},tt=function(le,Se,Ne){if(O&&(Se==="id"||Se==="name")&&(Ne in i||Ne in Pe))return!1;if(!(ie&&!Z[Se]&&at(re,Se))){if(!(se&&at(we,Se))){if(!ee[Se]||Z[Se])return!1;if(!J[Se]){if(!at(fe,lt(Ne,ve,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&le!=="script"&&Xt(Ne,"data:")===0&&B[le])){if(!(T&&!at(ae,lt(Ne,ve,"")))){if(Ne)return!1}}}}}}return!0},Xe=function(le){var Se=void 0,Ne=void 0,$e=void 0,Ze=void 0;Re("beforeSanitizeAttributes",le,null);var Qe=le.attributes;if(!!Qe){var et={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ee};for(Ze=Qe.length;Ze--;){Se=Qe[Ze];var st=Se,ht=st.name,Dt=st.namespaceURI;if(Ne=Zt(Se.value),$e=ut(ht),et.attrName=$e,et.attrValue=Ne,et.keepAttr=!0,et.forceKeepAttr=void 0,Re("uponSanitizeAttribute",le,et),Ne=et.attrValue,!et.forceKeepAttr&&(x(ht,le),!!et.keepAttr)){if(at(/\/>/i,Ne)){x(ht,le);continue}$&&(Ne=lt(Ne,K," "),Ne=lt(Ne,ne," "));var Ft=le.nodeName.toLowerCase();if(!!tt(Ft,$e,Ne))try{Dt?le.setAttributeNS(Dt,ht,Ne):le.setAttribute(ht,Ne),kt(t.removed)}catch{}}}Re("afterSanitizeAttributes",le,null)}},qe=function Le(le){var Se=void 0,Ne=be(le);for(Re("beforeSanitizeShadowDOM",le,null);Se=Ne.nextNode();)Re("uponSanitizeShadowNode",Se,null),!Ve(Se)&&(Se.content instanceof P&&Le(Se.content),Xe(Se));Re("afterSanitizeShadowDOM",le,null)};return t.sanitize=function(Le,le){var Se=void 0,Ne=void 0,$e=void 0,Ze=void 0,Qe=void 0;if(Ie=!Le,Ie&&(Le="<!-->"),typeof Le!="string"&&!Fe(Le)){if(typeof Le.toString!="function")throw Rt("toString is not a function");if(Le=Le.toString(),typeof Le!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(Q.toStaticHTML)==="object"||typeof Q.toStaticHTML=="function"){if(typeof Le=="string")return Q.toStaticHTML(Le);if(Fe(Le))return Q.toStaticHTML(Le.outerHTML)}return Le}if(R||Me(le),t.removed=[],typeof Le=="string"&&(V=!1),!V)if(Le instanceof y)Se=oe("<!---->"),Ne=Se.ownerDocument.importNode(Le,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Se=Ne:Se.appendChild(Ne);else{if(!I&&!$&&!X&&Le.indexOf("<")===-1)return w&&W?w.createHTML(Le):Le;if(Se=oe(Le),!Se)return I?null:S}Se&&f&&Oe(Se.firstChild);for(var et=be(V?Le:Se);$e=et.nextNode();)$e.nodeType===3&&$e===Ze||Ve($e)||($e.content instanceof P&&qe($e.content),Xe($e),Ze=$e);if(Ze=null,V)return Le;if(I){if(U)for(Qe=s.call(Se.ownerDocument);Se.firstChild;)Qe.appendChild(Se.firstChild);else Qe=Se;return q&&(Qe=o.call(D,Qe,!0)),Qe}var st=X?Se.outerHTML:Se.innerHTML;return $&&(st=lt(st,K," "),st=lt(st,ne," ")),w&&W?w.createHTML(st):st},t.setConfig=function(Le){Me(Le),R=!0},t.clearConfig=function(){De=null,R=!1},t.isValidAttribute=function(Le,le,Se){De||Me({});var Ne=ut(Le),$e=ut(le);return tt(Ne,$e,Se)},t.addHook=function(Le,le){typeof le=="function"&&(N[Le]=N[Le]||[],mt(N[Le],le))},t.removeHook=function(Le){N[Le]&&kt(N[Le])},t.removeHooks=function(Le){N[Le]&&(N[Le]=[])},t.removeAllHooks=function(){N={}},t}var ci=Wt();define("vs/base/browser/dompurify/dompurify",function(){return ci}),define(me[40],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class D{constructor(y){this.domNode=y,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(y){const b=i(y);this._maxWidth!==b&&(this._maxWidth=b,this.domNode.style.maxWidth=this._maxWidth)}setWidth(y){const b=i(y);this._width!==b&&(this._width=b,this.domNode.style.width=this._width)}setHeight(y){const b=i(y);this._height!==b&&(this._height=b,this.domNode.style.height=this._height)}setTop(y){const b=i(y);this._top!==b&&(this._top=b,this.domNode.style.top=this._top)}setLeft(y){const b=i(y);this._left!==b&&(this._left=b,this.domNode.style.left=this._left)}setBottom(y){const b=i(y);this._bottom!==b&&(this._bottom=b,this.domNode.style.bottom=this._bottom)}setRight(y){const b=i(y);this._right!==b&&(this._right=b,this.domNode.style.right=this._right)}setFontFamily(y){this._fontFamily!==y&&(this._fontFamily=y,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(y){this._fontWeight!==y&&(this._fontWeight=y,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(y){const b=i(y);this._fontSize!==b&&(this._fontSize=b,this.domNode.style.fontSize=this._fontSize)}setFontStyle(y){this._fontStyle!==y&&(this._fontStyle=y,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(y){this._fontFeatureSettings!==y&&(this._fontFeatureSettings=y,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(y){this._textDecoration!==y&&(this._textDecoration=y,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(y){const b=i(y);this._lineHeight!==b&&(this._lineHeight=b,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(y){const b=i(y);this._letterSpacing!==b&&(this._letterSpacing=b,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(y){this._className!==y&&(this._className=y,this.domNode.className=this._className)}toggleClassName(y,b){this.domNode.classList.toggle(y,b),this._className=this.domNode.className}setDisplay(y){this._display!==y&&(this._display=y,this.domNode.style.display=this._display)}setPosition(y){this._position!==y&&(this._position=y,this.domNode.style.position=this._position)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this.domNode.style.visibility=this._visibility)}setColor(y){this._color!==y&&(this._color=y,this.domNode.style.color=this._color)}setBackgroundColor(y){this._backgroundColor!==y&&(this._backgroundColor=y,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(y){this._layerHint!==y&&(this._layerHint=y,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(y){this._boxShadow!==y&&(this._boxShadow=y,this.domNode.style.boxShadow=y)}setContain(y){this._contain!==y&&(this._contain=y,this.domNode.style.contain=this._contain)}setAttribute(y,b){this.domNode.setAttribute(y,b)}removeAttribute(y){this.domNode.removeAttribute(y)}appendChild(y){this.domNode.appendChild(y.domNode)}removeChild(y){this.domNode.removeChild(y.domNode)}}t.FastDomNode=D;function i(M){return typeof M=="number"?`${M}px`:M}function P(M){return new D(M)}t.createFastDomNode=P}),define(me[65],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let D=!1,i=null;function P(y){if(!y.parent||y.parent===y)return null;try{const b=y.location,m=y.parent.location;if(b.origin!=="null"&&m.origin!=="null"&&b.origin!==m.origin)return D=!0,null}catch{return D=!0,null}return y.parent}class M{static getSameOriginWindowChain(){if(!i){i=[];let b=window,m;do m=P(b),m?i.push({window:b,iframeElement:b.frameElement||null}):i.push({window:b,iframeElement:null}),b=m;while(b)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),D}static getPositionOfChildWindowRelativeToAncestorWindow(b,m){if(!m||b===m)return{top:0,left:0};let h=0,p=0;const A=this.getSameOriginWindowChain();for(const l of A){if(h+=l.window.scrollY,p+=l.window.scrollX,l.window===m||!l.iframeElement)break;const r=l.iframeElement.getBoundingClientRect();h+=r.top,p+=r.left}return{top:h,left:p}}}t.IframeUtils=M}),define(me[66],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var D;(function(M){M[M.Copy=0]="Copy",M[M.Move=1]="Move"})(D=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(y,b){super(`ListError [${y}] ${b}`)}}t.ListError=i;class P{constructor(){this.cache=new WeakMap}getHeight(y){return this.cache.get(y)??this.estimateHeight(y)}setDynamicHeight(y,b){b>0&&this.cache.set(y,b)}}t.CachedListVirtualDelegate=P}),define(me[67],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class D{constructor(P){this.spliceables=P}splice(P,M,y){this.spliceables.forEach(b=>b.splice(P,M,y))}}t.CombinedSpliceable=D}),define(me[41],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const D=20;class i{constructor(M,y,b,m,h,p){this._scrollbarSize=Math.round(y),this._oppositeScrollbarSize=Math.round(b),this._arrowSize=Math.round(M),this._visibleSize=m,this._scrollSize=h,this._scrollPosition=p,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(M){const y=Math.round(M);return this._visibleSize!==y?(this._visibleSize=y,this._refreshComputedValues(),!0):!1}setScrollSize(M){const y=Math.round(M);return this._scrollSize!==y?(this._scrollSize=y,this._refreshComputedValues(),!0):!1}setScrollPosition(M){const y=Math.round(M);return this._scrollPosition!==y?(this._scrollPosition=y,this._refreshComputedValues(),!0):!1}setScrollbarSize(M){this._scrollbarSize=Math.round(M)}setOppositeScrollbarSize(M){this._oppositeScrollbarSize=Math.round(M)}static _computeValues(M,y,b,m,h){const p=Math.max(0,b-M),A=Math.max(0,p-2*y),l=m>0&&m>b;if(!l)return{computedAvailableSize:Math.round(p),computedIsNeeded:l,computedSliderSize:Math.round(A),computedSliderRatio:0,computedSliderPosition:0};const r=Math.round(Math.max(D,Math.floor(b*A/m))),e=(A-r)/(m-b),c=h*e;return{computedAvailableSize:Math.round(p),computedIsNeeded:l,computedSliderSize:Math.round(r),computedSliderRatio:e,computedSliderPosition:Math.round(c)}}_refreshComputedValues(){const M=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=M.computedAvailableSize,this._computedIsNeeded=M.computedIsNeeded,this._computedSliderSize=M.computedSliderSize,this._computedSliderRatio=M.computedSliderRatio,this._computedSliderPosition=M.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(M){if(!this._computedIsNeeded)return 0;const y=M-this._arrowSize-this._computedSliderSize/2;return Math.round(y/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(M){if(!this._computedIsNeeded)return 0;const y=M-this._arrowSize;let b=this._scrollPosition;return y<this._computedSliderPosition?b-=this._visibleSize:b+=this._visibleSize,b}getDesiredScrollPositionFromDelta(M){if(!this._computedIsNeeded)return 0;const y=this._computedSliderPosition+M;return Math.round(y/this._computedSliderRatio)}}t.ScrollbarState=i}),define(me[23],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var D;(function(b){b[b.Hidden=0]="Hidden",b[b.Visible=1]="Visible",b[b.Recurse=2]="Recurse"})(D=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(b){b[b.Unknown=0]="Unknown",b[b.Twistie=1]="Twistie",b[b.Element=2]="Element",b[b.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var P;(function(b){b[b.Down=0]="Down",b[b.Up=1]="Up"})(P=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(b=!1){return{accept:!0,bubble:0,autoExpand:b}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(b=!1){return{accept:!0,bubble:0,effect:0,autoExpand:b}}};class M extends Error{constructor(m,h){super(`TreeError [${m}] ${h}`)}}t.TreeError=M;class y{constructor(m){this.fn=m,this._map=new WeakMap}map(m){let h=this._map.get(m);return h||(h=this.fn(m),this._map.set(m,h)),h}}t.WeakMapper=y}),define(me[68],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function D(i,P){if(!i)throw new Error(P?`Assertion failed (${P})`:"Assertion Failed")}t.ok=D}),define(me[11],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function D(y){return y?y.replace(/\$\((.*?)\)/g,(b,m)=>` ${m} `).trim():""}t.getCodiconAriaLabel=D;class i{constructor(b,m,h){this.id=b,this.definition=m,this.description=h,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function P(y,b){const m=["codicon","codicon-"+y];return b&&m.push("codicon-modifier-"+b),m}t.getClassNamesArray=P;var M;(function(y){y.iconNameSegment="[A-Za-z0-9]+",y.iconNameExpression="[A-Za-z0-9-]+",y.iconModifierExpression="~[A-Za-z]+",y.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${y.iconNameExpression})(${y.iconModifierExpression})?$`);function m(A){if(A instanceof i)return["codicon","codicon-"+A.id];const l=b.exec(A.id);if(!l)return m(i.error);const[,r,e]=l,c=["codicon","codicon-"+r];return e&&c.push("codicon-modifier-"+e.substr(1)),c}y.asClassNameArray=m;function h(A){return m(A).join(" ")}y.asClassName=h;function p(A){return"."+m(A).join(".")}y.asCSSSelector=p})(M=t.CSSIcon||(t.CSSIcon={}))}),define(me[69],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function D(y,b){const m=Object.create(null);for(const h of y){const p=b(h);let A=m[p];A||(A=m[p]=[]),A.push(h)}return m}t.groupBy=D;function i(y,b){const m=[],h=[];for(const p of y)b.has(p)||m.push(p);for(const p of b)y.has(p)||h.push(p);return{removed:m,added:h}}t.diffSets=i;function P(y,b){const m=[],h=[];for(const[p,A]of y)b.has(p)||m.push(A);for(const[p,A]of b)y.has(p)||h.push(A);return{removed:m,added:h}}t.diffMaps=P;class M{constructor(){this.map=new Map}add(b,m){let h=this.map.get(b);h||(h=new Set,this.map.set(b,h)),h.add(m)}delete(b,m){const h=this.map.get(b);!h||(h.delete(m),h.size===0&&this.map.delete(b))}forEach(b,m){const h=this.map.get(b);!h||h.forEach(m)}}t.SetMap=M}),define(me[24],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function D(b,m){const h=Math.pow(10,m);return Math.round(b*h)/h}class i{constructor(m,h,p,A=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,m))|0,this.g=Math.min(255,Math.max(0,h))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=D(Math.max(Math.min(1,A),0),3)}static equals(m,h){return m.r===h.r&&m.g===h.g&&m.b===h.b&&m.a===h.a}}t.RGBA=i;class P{constructor(m,h,p,A){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=D(Math.max(Math.min(1,h),0),3),this.l=D(Math.max(Math.min(1,p),0),3),this.a=D(Math.max(Math.min(1,A),0),3)}static equals(m,h){return m.h===h.h&&m.s===h.s&&m.l===h.l&&m.a===h.a}static fromRGBA(m){const h=m.r/255,p=m.g/255,A=m.b/255,l=m.a,r=Math.max(h,p,A),e=Math.min(h,p,A);let c=0,g=0;const E=(e+r)/2,_=r-e;if(_>0){switch(g=Math.min(E<=.5?_/(2*E):_/(2-2*E),1),r){case h:c=(p-A)/_+(p<A?6:0);break;case p:c=(A-h)/_+2;break;case A:c=(h-p)/_+4;break}c*=60,c=Math.round(c)}return new P(c,g,E,l)}static _hue2rgb(m,h,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?m+(h-m)*6*p:p<1/2?h:p<2/3?m+(h-m)*(2/3-p)*6:m}static toRGBA(m){const h=m.h/360,{s:p,l:A,a:l}=m;let r,e,c;if(p===0)r=e=c=A;else{const g=A<.5?A*(1+p):A+p-A*p,E=2*A-g;r=P._hue2rgb(E,g,h+1/3),e=P._hue2rgb(E,g,h),c=P._hue2rgb(E,g,h-1/3)}return new i(Math.round(r*255),Math.round(e*255),Math.round(c*255),l)}}t.HSLA=P;class M{constructor(m,h,p,A){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,m),0)|0,this.s=D(Math.max(Math.min(1,h),0),3),this.v=D(Math.max(Math.min(1,p),0),3),this.a=D(Math.max(Math.min(1,A),0),3)}static equals(m,h){return m.h===h.h&&m.s===h.s&&m.v===h.v&&m.a===h.a}static fromRGBA(m){const h=m.r/255,p=m.g/255,A=m.b/255,l=Math.max(h,p,A),r=Math.min(h,p,A),e=l-r,c=l===0?0:e/l;let g;return e===0?g=0:l===h?g=((p-A)/e%6+6)%6:l===p?g=(A-h)/e+2:g=(h-p)/e+4,new M(Math.round(g*60),c,l,m.a)}static toRGBA(m){const{h,s:p,v:A,a:l}=m,r=A*p,e=r*(1-Math.abs(h/60%2-1)),c=A-r;let[g,E,_]=[0,0,0];return h<60?(g=r,E=e):h<120?(g=e,E=r):h<180?(E=r,_=e):h<240?(E=e,_=r):h<300?(g=e,_=r):h<=360&&(g=r,_=e),g=Math.round((g+c)*255),E=Math.round((E+c)*255),_=Math.round((_+c)*255),new i(g,E,_,l)}}t.HSVA=M;class y{constructor(m){if(m)if(m instanceof i)this.rgba=m;else if(m instanceof P)this._hsla=m,this.rgba=P.toRGBA(m);else if(m instanceof M)this._hsva=m,this.rgba=M.toRGBA(m);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(m){return y.Format.CSS.parseHex(m)||y.red}get hsla(){return this._hsla?this._hsla:P.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:M.fromRGBA(this.rgba)}equals(m){return!!m&&i.equals(this.rgba,m.rgba)&&P.equals(this.hsla,m.hsla)&&M.equals(this.hsva,m.hsva)}getRelativeLuminance(){const m=y._relativeLuminanceForComponent(this.rgba.r),h=y._relativeLuminanceForComponent(this.rgba.g),p=y._relativeLuminanceForComponent(this.rgba.b),A=.2126*m+.7152*h+.0722*p;return D(A,4)}static _relativeLuminanceForComponent(m){const h=m/255;return h<=.03928?h/12.92:Math.pow((h+.055)/1.055,2.4)}getContrastRatio(m){const h=this.getRelativeLuminance(),p=m.getRelativeLuminance();return h>p?(h+.05)/(p+.05):(p+.05)/(h+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(m){const h=this.getRelativeLuminance(),p=m.getRelativeLuminance();return h>p}isDarkerThan(m){const h=this.getRelativeLuminance(),p=m.getRelativeLuminance();return h<p}lighten(m){return new y(new P(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*m,this.hsla.a))}darken(m){return new y(new P(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*m,this.hsla.a))}transparent(m){const{r:h,g:p,b:A,a:l}=this.rgba;return new y(new i(h,p,A,l*m))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new y(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(m){const h=m.rgba,p=this.rgba.a,A=h.a,l=p+A*(1-p);if(l<1e-6)return y.transparent;const r=this.rgba.r*p/l+h.r*A*(1-p)/l,e=this.rgba.g*p/l+h.g*A*(1-p)/l,c=this.rgba.b*p/l+h.b*A*(1-p)/l;return new y(new i(r,e,c,l))}makeOpaque(m){if(this.isOpaque()||m.rgba.a!==1)return this;const{r:h,g:p,b:A,a:l}=this.rgba;return new y(new i(m.rgba.r-l*(m.rgba.r-h),m.rgba.g-l*(m.rgba.g-p),m.rgba.b-l*(m.rgba.b-A),1))}flatten(...m){const h=m.reduceRight((p,A)=>y._flatten(A,p));return y._flatten(this,h)}static _flatten(m,h){const p=1-m.rgba.a;return new y(new i(p*h.rgba.r+m.rgba.a*m.rgba.r,p*h.rgba.g+m.rgba.a*m.rgba.g,p*h.rgba.b+m.rgba.a*m.rgba.b))}toString(){return this._toString||(this._toString=y.Format.CSS.format(this)),this._toString}static getLighterColor(m,h,p){if(m.isLighterThan(h))return m;p=p||.5;const A=m.getRelativeLuminance(),l=h.getRelativeLuminance();return p=p*(l-A)/l,m.lighten(p)}static getDarkerColor(m,h,p){if(m.isDarkerThan(h))return m;p=p||.5;const A=m.getRelativeLuminance(),l=h.getRelativeLuminance();return p=p*(A-l)/A,m.darken(p)}}t.Color=y,y.white=new y(new i(255,255,255,1)),y.black=new y(new i(0,0,0,1)),y.red=new y(new i(255,0,0,1)),y.blue=new y(new i(0,0,255,1)),y.green=new y(new i(0,255,0,1)),y.cyan=new y(new i(0,255,255,1)),y.lightgrey=new y(new i(211,211,211,1)),y.transparent=new y(new i(0,0,0,0)),function(b){let m;(function(h){let p;(function(A){function l(S){return S.rgba.a===1?`rgb(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b})`:b.Format.CSS.formatRGBA(S)}A.formatRGB=l;function r(S){return`rgba(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b}, ${+S.rgba.a.toFixed(2)})`}A.formatRGBA=r;function e(S){return S.hsla.a===1?`hsl(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%)`:b.Format.CSS.formatHSLA(S)}A.formatHSL=e;function c(S){return`hsla(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%, ${S.hsla.a.toFixed(2)})`}A.formatHSLA=c;function g(S){const L=S.toString(16);return L.length!==2?"0"+L:L}function E(S){return`#${g(S.rgba.r)}${g(S.rgba.g)}${g(S.rgba.b)}`}A.formatHex=E;function _(S,L=!1){return L&&S.rgba.a===1?b.Format.CSS.formatHex(S):`#${g(S.rgba.r)}${g(S.rgba.g)}${g(S.rgba.b)}${g(Math.round(S.rgba.a*255))}`}A.formatHexA=_;function u(S){return S.isOpaque()?b.Format.CSS.formatHex(S):b.Format.CSS.formatRGBA(S)}A.format=u;function d(S){const L=S.length;if(L===0||S.charCodeAt(0)!==35)return null;if(L===7){const C=16*w(S.charCodeAt(1))+w(S.charCodeAt(2)),n=16*w(S.charCodeAt(3))+w(S.charCodeAt(4)),s=16*w(S.charCodeAt(5))+w(S.charCodeAt(6));return new b(new i(C,n,s,1))}if(L===9){const C=16*w(S.charCodeAt(1))+w(S.charCodeAt(2)),n=16*w(S.charCodeAt(3))+w(S.charCodeAt(4)),s=16*w(S.charCodeAt(5))+w(S.charCodeAt(6)),a=16*w(S.charCodeAt(7))+w(S.charCodeAt(8));return new b(new i(C,n,s,a/255))}if(L===4){const C=w(S.charCodeAt(1)),n=w(S.charCodeAt(2)),s=w(S.charCodeAt(3));return new b(new i(16*C+C,16*n+n,16*s+s))}if(L===5){const C=w(S.charCodeAt(1)),n=w(S.charCodeAt(2)),s=w(S.charCodeAt(3)),a=w(S.charCodeAt(4));return new b(new i(16*C+C,16*n+n,16*s+s,(16*a+a)/255))}return null}A.parseHex=d;function w(S){switch(S){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=h.CSS||(h.CSS={}))})(m=b.Format||(b.Format={}))}(y=t.Color||(t.Color={}))}),define(me[25],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function D(y){return(b,m,h)=>{let p=null,A=null;if(typeof h.value=="function"?(p="value",A=h.value):typeof h.get=="function"&&(p="get",A=h.get),!A)throw new Error("not supported");h[p]=y(A,m)}}t.createDecorator=D;function i(y,b,m){let h=null,p=null;if(typeof m.value=="function"?(h="value",p=m.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(h="get",p=m.get),!p)throw new Error("not supported");const A=`$memoize$${b}`;m[h]=function(...l){return this.hasOwnProperty(A)||Object.defineProperty(this,A,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,l)}),this[A]}}t.memoize=i;function P(y,b,m){return D((h,p)=>{const A=`$debounce$${p}`,l=`$debounce$result$${p}`;return function(...r){this[l]||(this[l]=m?m():void 0),clearTimeout(this[A]),b&&(this[l]=b(this[l],...r),r=[this[l]]),this[A]=setTimeout(()=>{h.apply(this,r),this[l]=m?m():void 0},y)}})}t.debounce=P;function M(y,b,m){return D((h,p)=>{const A=`$throttle$timer$${p}`,l=`$throttle$result$${p}`,r=`$throttle$lastRun$${p}`,e=`$throttle$pending$${p}`;return function(...c){if(this[l]||(this[l]=m?m():void 0),(this[r]===null||this[r]===void 0)&&(this[r]=-Number.MAX_VALUE),b&&(this[l]=b(this[l],...c)),this[e])return;const g=this[r]+y;g<=Date.now()?(this[r]=Date.now(),h.apply(this,[this[l]]),this[l]=m?m():void 0):(this[e]=!0,this[A]=setTimeout(()=>{this[e]=!1,this[r]=Date.now(),h.apply(this,[this[l]]),this[l]=m?m():void 0},g-Date.now()))}})}t.throttle=M}),define(me[70],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class D{constructor(P,M,y,b){this.originalStart=P,this.originalLength=M,this.modifiedStart=y,this.modifiedLength=b}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=D}),define(me[13],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(S){setTimeout(()=>{throw S.stack?u.isErrorNoTelemetry(S)?new u(S.message+`

`+S.stack):new Error(S.message+`

`+S.stack):S},0)}}addListener(S){return this.listeners.push(S),()=>{this._removeListener(S)}}emit(S){this.listeners.forEach(L=>{L(S)})}_removeListener(S){this.listeners.splice(this.listeners.indexOf(S),1)}setUnexpectedErrorHandler(S){this.unexpectedErrorHandler=S}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(S){this.unexpectedErrorHandler(S),this.emit(S)}onUnexpectedExternalError(S){this.unexpectedErrorHandler(S)}}t.ErrorHandler=D,t.errorHandler=new D;function i(w){t.errorHandler.setUnexpectedErrorHandler(w)}t.setUnexpectedErrorHandler=i;function P(w){m(w)||t.errorHandler.onUnexpectedError(w)}t.onUnexpectedError=P;function M(w){m(w)||t.errorHandler.onUnexpectedExternalError(w)}t.onUnexpectedExternalError=M;function y(w){if(w instanceof Error){const{name:S,message:L}=w,C=w.stacktrace||w.stack;return{$isError:!0,name:S,message:L,stack:C,noTelemetry:u.isErrorNoTelemetry(w)}}return w}t.transformErrorForSerialization=y;const b="Canceled";function m(w){return w instanceof h?!0:w instanceof Error&&w.name===b&&w.message===b}t.isCancellationError=m;class h extends Error{constructor(){super(b);this.name=this.message}}t.CancellationError=h;function p(){const w=new Error(b);return w.name=w.message,w}t.canceled=p;function A(w){return w?new Error(`Illegal argument: ${w}`):new Error("Illegal argument")}t.illegalArgument=A;function l(w){return w?new Error(`Illegal state: ${w}`):new Error("Illegal state")}t.illegalState=l;function r(w){return w?new Error(`readonly property '${w} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=r;function e(w){const S=new Error(`${w} has been disposed`);return S.name="DISPOSED",S}t.disposed=e;function c(w){return w?w.message?w.message:w.stack?w.stack.split(`
`)[0]:String(w):"Error"}t.getErrorMessage=c;class g extends Error{constructor(S){super("NotImplemented");S&&(this.message=S)}}t.NotImplementedError=g;class E extends Error{constructor(S){super("NotSupported");S&&(this.message=S)}}t.NotSupportedError=E;class _ extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=_;class u extends Error{constructor(S){super(S);this.name="ErrorNoTelemetry"}static fromError(S){if(S instanceof u)return S;const L=new u;return L.message=S.message,L.stack=S.stack,L}static isErrorNoTelemetry(S){return S.name==="ErrorNoTelemetry"}}t.ErrorNoTelemetry=u;class d extends Error{constructor(S){super(S||"An unexpected bug occurred.");Object.setPrototypeOf(this,d.prototype);debugger}}t.BugIndicatingError=d}),define(me[14],pe([1,0,13]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(W,O=0){return W[W.length-(1+O)]}t.tail=i;function P(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}t.tail2=P;function M(W,O,H=(V,F)=>V===F){if(W===O)return!0;if(!W||!O||W.length!==O.length)return!1;for(let V=0,F=W.length;V<F;V++)if(!H(W[V],O[V]))return!1;return!0}t.equals=M;function y(W,O){const H=W.length-1;O<H&&(W[O]=W[H]),W.pop()}t.removeFastWithoutKeepingOrder=y;function b(W,O,H){return m(W.length,V=>H(W[V],O))}t.binarySearch=b;function m(W,O){let H=0,V=W-1;for(;H<=V;){const F=(H+V)/2|0,z=O(F);if(z<0)H=F+1;else if(z>0)V=F-1;else return F}return-(H+1)}t.binarySearch2=m;function h(W,O){let H=0,V=W.length;if(V===0)return 0;for(;H<V;){const F=Math.floor((H+V)/2);O(W[F])?V=F:H=F+1}return H}t.findFirstInSorted=h;function p(W,O,H){if(W=W|0,W>=O.length)throw new TypeError("invalid index");const V=O[Math.floor(O.length*Math.random())],F=[],z=[],k=[];for(const B of O){const j=H(B,V);j<0?F.push(B):j>0?z.push(B):k.push(B)}return W<F.length?p(W,F,H):W<F.length+k.length?k[0]:p(W-(F.length+k.length),z,H)}t.quickSelect=p;function A(W,O){const H=[];let V;for(const F of W.slice(0).sort(O))!V||O(V[0],F)!==0?(V=[F],H.push(V)):V.push(F);return H}t.groupBy=A;function l(W,O,H){const V=[];function F(B,j,J){if(j===0&&J.length===0)return;const ce=V[V.length-1];ce&&ce.start+ce.deleteCount===B?(ce.deleteCount+=j,ce.toInsert.push(...J)):V.push({start:B,deleteCount:j,toInsert:J})}let z=0,k=0;for(;;){if(z===W.length){F(z,0,O.slice(k));break}if(k===O.length){F(z,W.length-z,[]);break}const B=W[z],j=O[k],J=H(B,j);J===0?(z+=1,k+=1):J<0?(F(z,1,[]),z+=1):J>0&&(F(z,0,[j]),k+=1)}return V}t.sortedDiff=l;function r(W,O,H){const V=l(W,O,H),F=[],z=[];for(const k of V)F.push(...W.slice(k.start,k.start+k.deleteCount)),z.push(...k.toInsert);return{removed:F,added:z}}t.delta=r;function e(W,O,H){if(H===0)return[];const V=W.slice(0,H).sort(O);return g(W,O,V,H,W.length),V}t.top=e;function c(W,O,H,V,F){return H===0?Promise.resolve([]):new Promise((z,k)=>{(async()=>{const B=W.length,j=W.slice(0,H).sort(O);for(let J=H,ce=Math.min(H+V,B);J<B;J=ce,ce=Math.min(ce+V,B)){if(J>H&&await new Promise(de=>setTimeout(de)),F&&F.isCancellationRequested)throw new D.CancellationError;g(W,O,j,J,ce)}return j})().then(z,k)})}t.topAsync=c;function g(W,O,H,V,F){for(const z=H.length;V<F;V++){const k=W[V];if(O(k,H[z-1])<0){H.pop();const B=h(H,j=>O(k,j)<0);H.splice(B,0,k)}}}function E(W){return W.filter(O=>!!O)}t.coalesce=E;function _(W){let O=0;for(let H=0;H<W.length;H++)W[H]&&(W[O]=W[H],O+=1);W.length=O}t.coalesceInPlace=_;function u(W,O,H){W.splice(H,0,W.splice(O,1)[0])}t.move=u;function d(W){return!Array.isArray(W)||W.length===0}t.isFalsyOrEmpty=d;function w(W){return Array.isArray(W)&&W.length>0}t.isNonEmptyArray=w;function S(W,O=H=>H){const H=new Set;return W.filter(V=>{const F=O(V);return H.has(F)?!1:(H.add(F),!0)})}t.distinct=S;function L(W){const O=new Set;return H=>{const V=W(H);return O.has(V)?!1:(O.add(V),!0)}}t.uniqueFilter=L;function C(W,O){const H=n(W,O);if(H!==-1)return W[H]}t.findLast=C;function n(W,O){for(let H=W.length-1;H>=0;H--){const V=W[H];if(O(V))return H}return-1}t.lastIndex=n;function s(W,O){return W.length>0?W[0]:O}t.firstOrDefault=s;function a(W,O){return W.length>0?W[W.length-1]:O}t.lastOrDefault=a;function o(W,O,H=(V,F)=>V===F){let V=0;for(let F=0,z=Math.min(W.length,O.length);F<z&&H(W[F],O[F]);F++)V++;return V}t.commonPrefixLength=o;function v(W){return[].concat(...W)}t.flatten=v;function N(W,O){let H=typeof O=="number"?W:0;typeof O=="number"?H=W:(H=0,O=W);const V=[];if(H<=O)for(let F=H;F<O;F++)V.push(F);else for(let F=H;F>O;F--)V.push(F);return V}t.range=N;function K(W,O,H){return W.reduce((V,F)=>(V[O(F)]=H?H(F):F,V),Object.create(null))}t.index=K;function ne(W,O){return W.push(O),()=>re(W,O)}t.insert=ne;function re(W,O){const H=W.indexOf(O);if(H>-1)return W.splice(H,1),O}t.remove=re;function we(W,O,H){const V=W.slice(0,O),F=W.slice(O);return V.concat(H,F)}t.arrayInsert=we;function ae(W,O){let H;if(typeof O=="number"){let V=O;H=()=>{const F=Math.sin(V++)*179426549;return F-Math.floor(F)}}else H=Math.random;for(let V=W.length-1;V>0;V-=1){const F=Math.floor(H()*(V+1)),z=W[V];W[V]=W[F],W[F]=z}}t.shuffle=ae;function ve(W,O){const H=W.indexOf(O);H>-1&&(W.splice(H,1),W.unshift(O))}t.pushToStart=ve;function fe(W,O){const H=W.indexOf(O);H>-1&&(W.splice(H,1),W.push(O))}t.pushToEnd=fe;function ge(W,O){for(const H of O)W.push(H)}t.pushMany=ge;function ye(W,O){return Array.isArray(W)?W.map(O):O(W)}t.mapArrayOrNot=ye;function ee(W){return Array.isArray(W)?W:[W]}t.asArray=ee;function he(W){return W[Math.floor(Math.random()*W.length)]}t.getRandomElement=he;function te(W,O){for(const H of W){const V=O(H);if(V!==void 0)return V}}t.mapFind=te;function Z(W,O,H){const V=ie(W,O),F=W.length,z=H.length;W.length=F+z;for(let k=F-1;k>=V;k--)W[k+z]=W[k];for(let k=0;k<z;k++)W[k+V]=H[k]}t.insertInto=Z;function se(W,O,H,V){const F=ie(W,O),z=W.splice(F,H);return Z(W,F,V),z}t.splice=se;function ie(W,O){return O<0?Math.max(O+W.length,0):Math.min(O,W.length)}var T;(function(W){function O(F){return F<0}W.isLessThan=O;function H(F){return F>0}W.isGreaterThan=H;function V(F){return F===0}W.isNeitherLessOrGreaterThan=V,W.greaterThan=1,W.lessThan=-1,W.neitherLessOrGreaterThan=0})(T=t.CompareResult||(t.CompareResult={}));function $(W,O){return(H,V)=>O(W(H),W(V))}t.compareBy=$;function X(...W){return(O,H)=>{for(const V of W){const F=V(O,H);if(!T.isNeitherLessOrGreaterThan(F))return F}return T.neitherLessOrGreaterThan}}t.tieBreakComparators=X;const R=(W,O)=>W-O;t.numberComparator=R;function f(W,O){if(W.length===0)return;let H=W[0];for(let V=1;V<W.length;V++){const F=W[V];O(F,H)>0&&(H=F)}return H}t.findMaxBy=f;function I(W,O){if(W.length===0)return;let H=W[0];for(let V=1;V<W.length;V++){const F=W[V];O(F,H)>=0&&(H=F)}return H}t.findLastMaxBy=I;function U(W,O){return f(W,(H,V)=>-O(H,V))}t.findMinBy=U;class q{constructor(O){this.items=O,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(O){let H=this.firstIdx;for(;H<this.items.length&&O(this.items[H]);)H++;const V=H===this.firstIdx?null:this.items.slice(this.firstIdx,H);return this.firstIdx=H,V}takeFromEndWhile(O){let H=this.lastIdx;for(;H>=0&&O(this.items[H]);)H--;const V=H===this.lastIdx?null:this.items.slice(H+1,this.lastIdx+1);return this.lastIdx=H,V}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const O=this.items[this.firstIdx];return this.firstIdx++,O}removeLast(){const O=this.items[this.lastIdx];return this.lastIdx--,O}takeCount(O){const H=this.items.slice(this.firstIdx,this.firstIdx+O);return this.firstIdx+=O,H}}t.ArrayQueue=q}),define(me[42],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function D(i){const P=this;let M=!1,y;return function(){return M||(M=!0,y=i.apply(P,arguments)),y}}t.once=D}),define(me[71],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class D{constructor(P){this._prefix=P,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=D,t.defaultGenerator=new D("id#")}),define(me[26],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var D;(function(i){function P(L){return L&&typeof L=="object"&&typeof L[Symbol.iterator]=="function"}i.is=P;const M=Object.freeze([]);function y(){return M}i.empty=y;function*b(L){yield L}i.single=b;function m(L){return L||M}i.from=m;function h(L){return!L||L[Symbol.iterator]().next().done===!0}i.isEmpty=h;function p(L){return L[Symbol.iterator]().next().value}i.first=p;function A(L,C){for(const n of L)if(C(n))return!0;return!1}i.some=A;function l(L,C){for(const n of L)if(C(n))return n}i.find=l;function*r(L,C){for(const n of L)C(n)&&(yield n)}i.filter=r;function*e(L,C){let n=0;for(const s of L)yield C(s,n++)}i.map=e;function*c(...L){for(const C of L)for(const n of C)yield n}i.concat=c;function*g(L){for(const C of L)for(const n of C)yield n}i.concatNested=g;function E(L,C,n){let s=n;for(const a of L)s=C(s,a);return s}i.reduce=E;function _(L,C){let n=0;for(const s of L)C(s,n++)}i.forEach=_;function*u(L,C,n=L.length){for(C<0&&(C+=L.length),n<0?n+=L.length:n>L.length&&(n=L.length);C<n;C++)yield L[C]}i.slice=u;function d(L,C=Number.POSITIVE_INFINITY){const n=[];if(C===0)return[n,L];const s=L[Symbol.iterator]();for(let a=0;a<C;a++){const o=s.next();if(o.done)return[n,i.empty()];n.push(o.value)}return[n,{[Symbol.iterator](){return s}}]}i.consume=d;function w(L){return d(L)[0]}i.collect=w;function S(L,C,n=(s,a)=>s===a){const s=L[Symbol.iterator](),a=C[Symbol.iterator]();for(;;){const o=s.next(),v=a.next();if(o.done!==v.done)return!1;if(o.done)return!0;if(!n(o.value,v.value))return!1}}i.equals=S})(D=t.Iterable||(t.Iterable={}))}),define(me[43],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var D;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(D=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class P{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(c,g){this._keyCodeToStr[c]=g,this._strToKeyCode[g.toLowerCase()]=c}keyCodeToStr(c){return this._keyCodeToStr[c]}strToKeyCode(c){return this._strToKeyCode[c.toLowerCase()]||0}}const M=new P,y=new P,b=new P;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const m=[],h=Object.create(null),p=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>p[e]||0,toEnum:e=>h[e]||0,toString:e=>m[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",c=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],g=[],E=[];for(const _ of c){const[u,d,w,S,L,C,n,s,a,o]=_;if(E[w]||(E[w]=!0,m[w]=S,h[S]=w,p[S.toLowerCase()]=w,d&&(t.IMMUTABLE_CODE_TO_KEY_CODE[w]=L,L!==0&&L!==3&&L!==5&&L!==4&&L!==6&&L!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[L]=w))),!g[L]){if(g[L]=!0,!C)throw new Error(`String representation missing for key code ${L} around scan code ${S}`);M.define(L,C),y.define(L,a||C),b.define(L,o||a||C)}n&&(t.EVENT_KEY_CODE_MAP[n]=L),s&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[s]=L)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var A;(function(e){function c(w){return M.keyCodeToStr(w)}e.toString=c;function g(w){return M.strToKeyCode(w)}e.fromString=g;function E(w){return y.keyCodeToStr(w)}e.toUserSettingsUS=E;function _(w){return b.keyCodeToStr(w)}e.toUserSettingsGeneral=_;function u(w){return y.strToKeyCode(w)||b.strToKeyCode(w)}e.fromUserSettings=u;function d(w){if(w>=93&&w<=108)return null;switch(w){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(w)}e.toElectronAccelerator=d})(A=t.KeyCodeUtils||(t.KeyCodeUtils={}));var l;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(l=t.KeyMod||(t.KeyMod={}));function r(e,c){const g=(c&65535)<<16>>>0;return(e|g)>>>0}t.KeyChord=r}),define(me[72],pe([1,0,13]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(A){A[A.CtrlCmd=2048]="CtrlCmd",A[A.Shift=1024]="Shift",A[A.Alt=512]="Alt",A[A.WinCtrl=256]="WinCtrl",A[A.KeyCode=255]="KeyCode"})(i||(i={}));function P(A,l){if(A===0)return null;const r=(A&65535)>>>0,e=(A&4294901760)>>>16;return e!==0?new b([M(r,l),M(e,l)]):new b([M(r,l)])}t.createKeybinding=P;function M(A,l){const r=!!(A&2048),e=!!(A&256),c=l===2?e:r,g=!!(A&1024),E=!!(A&512),_=l===2?r:e,u=A&255;return new y(c,g,E,_,u)}t.createSimpleKeybinding=M;class y{constructor(l,r,e,c,g){this.ctrlKey=l,this.shiftKey=r,this.altKey=e,this.metaKey=c,this.keyCode=g}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",r=this.shiftKey?"1":"0",e=this.altKey?"1":"0",c=this.metaKey?"1":"0";return`${l}${r}${e}${c}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=y;class b{constructor(l){if(l.length===0)throw(0,D.illegalArgument)("parts");this.parts=l}getHashCode(){let l="";for(let r=0,e=this.parts.length;r<e;r++)r!==0&&(l+=";"),l+=this.parts[r].getHashCode();return l}equals(l){if(l===null||this.parts.length!==l.parts.length)return!1;for(let r=0;r<this.parts.length;r++)if(!this.parts[r].equals(l.parts[r]))return!1;return!0}}t.ChordKeybinding=b;class m{constructor(l,r,e,c,g){this.ctrlKey=l,this.shiftKey=r,this.altKey=e,this.metaKey=c,this.scanCode=g}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=m;class h{constructor(l,r,e,c,g,E){this.ctrlKey=l,this.shiftKey=r,this.altKey=e,this.metaKey=c,this.keyLabel=g,this.keyAriaLabel=E}}t.ResolvedKeybindingPart=h;class p{}t.ResolvedKeybinding=p}),define(me[73],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class D{constructor(P){this.executor=P,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(P){this._error=P}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(P){return new D(()=>P(this.getValue()))}}t.Lazy=D}),define(me[2],pe([1,0,42,26]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const P=!1;let M=null;function y(s){M=s}if(t.setDisposableTracker=y,P){const s="__is_disposable_tracked__";y(new class{trackDisposable(a){const o=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[s]||console.log(o)},3e3)}setParent(a,o){if(a&&a!==_.None)try{a[s]=!0}catch{}}markAsDisposed(a){if(a&&a!==_.None)try{a[s]=!0}catch{}}markAsSingleton(a){}})}function b(s){return M?.trackDisposable(s),s}function m(s){M?.markAsDisposed(s)}function h(s,a){M?.setParent(s,a)}function p(s,a){if(!!M)for(const o of s)M.setParent(o,a)}function A(s){return M?.markAsSingleton(s),s}t.markAsSingleton=A;class l extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}t.MultiDisposeError=l;function r(s){return typeof s.dispose=="function"&&s.dispose.length===0}t.isDisposable=r;function e(s){if(i.Iterable.is(s)){const a=[];for(const o of s)if(o)try{o.dispose()}catch(v){a.push(v)}if(a.length===1)throw a[0];if(a.length>1)throw new l(a);return Array.isArray(s)?[]:s}else if(s)return s.dispose(),s}t.dispose=e;function c(...s){const a=g(()=>e(s));return p(s,a),a}t.combinedDisposable=c;function g(s){const a=b({dispose:(0,D.once)(()=>{m(a),s()})});return a}t.toDisposable=g;class E{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(m(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return h(a,this),this._isDisposed?E.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}t.DisposableStore=E,E.DISABLE_DISPOSED_WARNING=!1;class _{constructor(){this._store=new E,b(this),h(this._store,this)}dispose(){m(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}t.Disposable=_,_.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&h(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,m(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&h(a,null),a}}t.MutableDisposable=u;class d{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=d;class w{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(a){let o=a;return this.unset=()=>o=void 0,this.isset=()=>o!==void 0,this.dispose=()=>{o&&(o(),o=void 0,m(this))},this}}t.SafeDisposable=w;class S{constructor(){this.references=new Map}acquire(a,...o){let v=this.references.get(a);v||(v={counter:0,object:this.createReferencedObject(a,...o)},this.references.set(a,v));const{object:N}=v,K=(0,D.once)(()=>{--v.counter==0&&(this.destroyReferencedObject(a,v.object),this.references.delete(a))});return v.counter++,{object:N,dispose:K}}}t.ReferenceCollection=S;class L{constructor(a){this.referenceCollection=a}async acquire(a,...o){const v=this.referenceCollection.acquire(a,...o);try{return{object:await v.object,dispose:()=>v.dispose()}}catch(N){throw v.dispose(),N}}}t.AsyncReferenceCollection=L;class C{constructor(a){this.object=a}dispose(){}}t.ImmortalReference=C;function n(s){const a=new E;try{s(a)}finally{a.dispose()}}t.disposeOnReturn=n}),define(me[74],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class D{constructor(M){this.element=M,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class i{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let M=this._first;for(;M!==D.Undefined;){const y=M.next;M.prev=D.Undefined,M.next=D.Undefined,M=y}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,y){const b=new D(M);if(this._first===D.Undefined)this._first=b,this._last=b;else if(y){const h=this._last;this._last=b,b.prev=h,h.next=b}else{const h=this._first;this._first=b,b.next=h,h.prev=b}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(b))}}shift(){if(this._first!==D.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==D.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==D.Undefined&&M.next!==D.Undefined){const y=M.prev;y.next=M.next,M.next.prev=y}else M.prev===D.Undefined&&M.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):M.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):M.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==D.Undefined;)yield M.element,M=M.next}}t.LinkedList=i}),function(Q,t){typeof exports=="object"&&typeof module!="undefined"?t(exports):typeof define=="function"&&define.amd?define(me[75],pe([0]),t):(Q=typeof globalThis!="undefined"?globalThis:Q||self,t(Q.marked={}))}(this,function(Q){"use strict";function t(O,H){for(var V=0;V<H.length;V++){var F=H[V];F.enumerable=F.enumerable||!1,F.configurable=!0,"value"in F&&(F.writable=!0),Object.defineProperty(O,F.key,F)}}function D(O,H,V){return H&&t(O.prototype,H),V&&t(O,V),Object.defineProperty(O,"prototype",{writable:!1}),O}function i(O,H){if(!!O){if(typeof O=="string")return P(O,H);var V=Object.prototype.toString.call(O).slice(8,-1);if(V==="Object"&&O.constructor&&(V=O.constructor.name),V==="Map"||V==="Set")return Array.from(O);if(V==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(V))return P(O,H)}}function P(O,H){(H==null||H>O.length)&&(H=O.length);for(var V=0,F=new Array(H);V<H;V++)F[V]=O[V];return F}function M(O,H){var V=typeof Symbol!="undefined"&&O[Symbol.iterator]||O["@@iterator"];if(V)return(V=V.call(O)).next.bind(V);if(Array.isArray(O)||(V=i(O))||H&&O&&typeof O.length=="number"){V&&(O=V);var F=0;return function(){return F>=O.length?{done:!0}:{done:!1,value:O[F++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function y(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Q.defaults=y();function b(O){Q.defaults=O}var m=/[&<>"']/,h=/[&<>"']/g,p=/[<>"']|&(?!#?\w+;)/,A=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},r=function(H){return l[H]};function e(O,H){if(H){if(m.test(O))return O.replace(h,r)}else if(p.test(O))return O.replace(A,r);return O}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(O){return O.replace(c,function(H,V){return V=V.toLowerCase(),V==="colon"?":":V.charAt(0)==="#"?V.charAt(1)==="x"?String.fromCharCode(parseInt(V.substring(2),16)):String.fromCharCode(+V.substring(1)):""})}var E=/(^|[^\[])\^/g;function _(O,H){O=typeof O=="string"?O:O.source,H=H||"";var V={replace:function(z,k){return k=k.source||k,k=k.replace(E,"$1"),O=O.replace(z,k),V},getRegex:function(){return new RegExp(O,H)}};return V}var u=/[^\w:]/g,d=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function w(O,H,V){if(O){var F;try{F=decodeURIComponent(g(V)).replace(u,"").toLowerCase()}catch{return null}if(F.indexOf("javascript:")===0||F.indexOf("vbscript:")===0||F.indexOf("data:")===0)return null}H&&!d.test(V)&&(V=s(H,V));try{V=encodeURI(V).replace(/%25/g,"%")}catch{return null}return V}var S={},L=/^[^:]+:\/*[^/]*$/,C=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(O,H){S[" "+O]||(L.test(O)?S[" "+O]=O+"/":S[" "+O]=N(O,"/",!0)),O=S[" "+O];var V=O.indexOf(":")===-1;return H.substring(0,2)==="//"?V?H:O.replace(C,"$1")+H:H.charAt(0)==="/"?V?H:O.replace(n,"$1")+H:O+H}var a={exec:function(){}};function o(O){for(var H=1,V,F;H<arguments.length;H++){V=arguments[H];for(F in V)Object.prototype.hasOwnProperty.call(V,F)&&(O[F]=V[F])}return O}function v(O,H){var V=O.replace(/\|/g,function(k,B,j){for(var J=!1,ce=B;--ce>=0&&j[ce]==="\\";)J=!J;return J?"|":" |"}),F=V.split(/ \|/),z=0;if(F[0].trim()||F.shift(),F.length>0&&!F[F.length-1].trim()&&F.pop(),F.length>H)F.splice(H);else for(;F.length<H;)F.push("");for(;z<F.length;z++)F[z]=F[z].trim().replace(/\\\|/g,"|");return F}function N(O,H,V){var F=O.length;if(F===0)return"";for(var z=0;z<F;){var k=O.charAt(F-z-1);if(k===H&&!V)z++;else if(k!==H&&V)z++;else break}return O.slice(0,F-z)}function K(O,H){if(O.indexOf(H[1])===-1)return-1;for(var V=O.length,F=0,z=0;z<V;z++)if(O[z]==="\\")z++;else if(O[z]===H[0])F++;else if(O[z]===H[1]&&(F--,F<0))return z;return-1}function ne(O){O&&O.sanitize&&!O.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function re(O,H){if(H<1)return"";for(var V="";H>1;)H&1&&(V+=O),H>>=1,O+=O;return V+O}function we(O,H,V,F){var z=H.href,k=H.title?e(H.title):null,B=O[1].replace(/\\([\[\]])/g,"$1");if(O[0].charAt(0)!=="!"){F.state.inLink=!0;var j={type:"link",raw:V,href:z,title:k,text:B,tokens:F.inlineTokens(B,[])};return F.state.inLink=!1,j}return{type:"image",raw:V,href:z,title:k,text:e(B)}}function ae(O,H){var V=O.match(/^(\s+)(?:```)/);if(V===null)return H;var F=V[1];return H.split(`
`).map(function(z){var k=z.match(/^\s+/);if(k===null)return z;var B=k[0];return B.length>=F.length?z.slice(F.length):z}).join(`
`)}var ve=function(){function O(V){this.options=V||Q.defaults}var H=O.prototype;return H.space=function(F){var z=this.rules.block.newline.exec(F);if(z&&z[0].length>0)return{type:"space",raw:z[0]}},H.code=function(F){var z=this.rules.block.code.exec(F);if(z){var k=z[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:z[0],codeBlockStyle:"indented",text:this.options.pedantic?k:N(k,`
`)}}},H.fences=function(F){var z=this.rules.block.fences.exec(F);if(z){var k=z[0],B=ae(k,z[3]||"");return{type:"code",raw:k,lang:z[2]?z[2].trim():z[2],text:B}}},H.heading=function(F){var z=this.rules.block.heading.exec(F);if(z){var k=z[2].trim();if(/#$/.test(k)){var B=N(k,"#");(this.options.pedantic||!B||/ $/.test(B))&&(k=B.trim())}var j={type:"heading",raw:z[0],depth:z[1].length,text:k,tokens:[]};return this.lexer.inline(j.text,j.tokens),j}},H.hr=function(F){var z=this.rules.block.hr.exec(F);if(z)return{type:"hr",raw:z[0]}},H.blockquote=function(F){var z=this.rules.block.blockquote.exec(F);if(z){var k=z[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:z[0],tokens:this.lexer.blockTokens(k,[]),text:k}}},H.list=function(F){var z=this.rules.block.list.exec(F);if(z){var k,B,j,J,ce,de,Ee,_e,ke,Ie,De,Pe,Me=z[1].trim(),Ge=Me.length>1,He={type:"list",raw:"",ordered:Ge,start:Ge?+Me.slice(0,-1):"",loose:!1,items:[]};Me=Ge?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=Ge?Me:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+Me+")((?:[	 ][^\\n]*)?(?:\\n|$))");F&&(Pe=!1,!(!(z=Ue.exec(F))||this.rules.block.hr.test(F)));){if(k=z[0],F=F.substring(k.length),_e=z[2].split(`
`,1)[0],ke=F.split(`
`,1)[0],this.options.pedantic?(J=2,De=_e.trimLeft()):(J=z[2].search(/[^ ]/),J=J>4?1:J,De=_e.slice(J),J+=z[1].length),de=!1,!_e&&/^ *$/.test(ke)&&(k+=ke+`
`,F=F.substring(ke.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),je=new RegExp("^ {0,"+Math.min(3,J-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");F&&(Ie=F.split(`
`,1)[0],_e=Ie,this.options.pedantic&&(_e=_e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Je.test(_e)||je.test(F)));){if(_e.search(/[^ ]/)>=J||!_e.trim())De+=`
`+_e.slice(J);else if(!de)De+=`
`+_e;else break;!de&&!_e.trim()&&(de=!0),k+=Ie+`
`,F=F.substring(Ie.length+1)}He.loose||(Ee?He.loose=!0:/\n *\n *$/.test(k)&&(Ee=!0)),this.options.gfm&&(B=/^\[[ xX]\] /.exec(De),B&&(j=B[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:k,task:!!B,checked:j,loose:!1,text:De}),He.raw+=k}He.items[He.items.length-1].raw=k.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Oe=He.items.length;for(ce=0;ce<Oe;ce++){this.lexer.state.top=!1,He.items[ce].tokens=this.lexer.blockTokens(He.items[ce].text,[]);var x=He.items[ce].tokens.filter(function(be){return be.type==="space"}),oe=x.every(function(be){for(var Ce=be.raw.split(""),Fe=0,Re=M(Ce),Ve;!(Ve=Re()).done;){var tt=Ve.value;if(tt===`
`&&(Fe+=1),Fe>1)return!0}return!1});!He.loose&&x.length&&oe&&(He.loose=!0,He.items[ce].loose=!0)}return He}},H.html=function(F){var z=this.rules.block.html.exec(F);if(z){var k={type:"html",raw:z[0],pre:!this.options.sanitizer&&(z[1]==="pre"||z[1]==="script"||z[1]==="style"),text:z[0]};return this.options.sanitize&&(k.type="paragraph",k.text=this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]),k.tokens=[],this.lexer.inline(k.text,k.tokens)),k}},H.def=function(F){var z=this.rules.block.def.exec(F);if(z){z[3]&&(z[3]=z[3].substring(1,z[3].length-1));var k=z[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:k,raw:z[0],href:z[2],title:z[3]}}},H.table=function(F){var z=this.rules.block.table.exec(F);if(z){var k={type:"table",header:v(z[1]).map(function(Ee){return{text:Ee}}),align:z[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:z[3]&&z[3].trim()?z[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(k.header.length===k.align.length){k.raw=z[0];var B=k.align.length,j,J,ce,de;for(j=0;j<B;j++)/^ *-+: *$/.test(k.align[j])?k.align[j]="right":/^ *:-+: *$/.test(k.align[j])?k.align[j]="center":/^ *:-+ *$/.test(k.align[j])?k.align[j]="left":k.align[j]=null;for(B=k.rows.length,j=0;j<B;j++)k.rows[j]=v(k.rows[j],k.header.length).map(function(Ee){return{text:Ee}});for(B=k.header.length,J=0;J<B;J++)k.header[J].tokens=[],this.lexer.inline(k.header[J].text,k.header[J].tokens);for(B=k.rows.length,J=0;J<B;J++)for(de=k.rows[J],ce=0;ce<de.length;ce++)de[ce].tokens=[],this.lexer.inline(de[ce].text,de[ce].tokens);return k}}},H.lheading=function(F){var z=this.rules.block.lheading.exec(F);if(z){var k={type:"heading",raw:z[0],depth:z[2].charAt(0)==="="?1:2,text:z[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},H.paragraph=function(F){var z=this.rules.block.paragraph.exec(F);if(z){var k={type:"paragraph",raw:z[0],text:z[1].charAt(z[1].length-1)===`
`?z[1].slice(0,-1):z[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},H.text=function(F){var z=this.rules.block.text.exec(F);if(z){var k={type:"text",raw:z[0],text:z[0],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},H.escape=function(F){var z=this.rules.inline.escape.exec(F);if(z)return{type:"escape",raw:z[0],text:e(z[1])}},H.tag=function(F){var z=this.rules.inline.tag.exec(F);if(z)return!this.lexer.state.inLink&&/^<a /i.test(z[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(z[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(z[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(z[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:z[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]}},H.link=function(F){var z=this.rules.inline.link.exec(F);if(z){var k=z[2].trim();if(!this.options.pedantic&&/^</.test(k)){if(!/>$/.test(k))return;var B=N(k.slice(0,-1),"\\");if((k.length-B.length)%2==0)return}else{var j=K(z[2],"()");if(j>-1){var J=z[0].indexOf("!")===0?5:4,ce=J+z[1].length+j;z[2]=z[2].substring(0,j),z[0]=z[0].substring(0,ce).trim(),z[3]=""}}var de=z[2],Ee="";if(this.options.pedantic){var _e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);_e&&(de=_e[1],Ee=_e[3])}else Ee=z[3]?z[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(k)?de=de.slice(1):de=de.slice(1,-1)),we(z,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},z[0],this.lexer)}},H.reflink=function(F,z){var k;if((k=this.rules.inline.reflink.exec(F))||(k=this.rules.inline.nolink.exec(F))){var B=(k[2]||k[1]).replace(/\s+/g," ");if(B=z[B.toLowerCase()],!B||!B.href){var j=k[0].charAt(0);return{type:"text",raw:j,text:j}}return we(k,B,k[0],this.lexer)}},H.emStrong=function(F,z,k){k===void 0&&(k="");var B=this.rules.inline.emStrong.lDelim.exec(F);if(!!B&&!(B[3]&&k.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var j=B[1]||B[2]||"";if(!j||j&&(k===""||this.rules.inline.punctuation.exec(k))){var J=B[0].length-1,ce,de,Ee=J,_e=0,ke=B[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ke.lastIndex=0,z=z.slice(-1*F.length+J);(B=ke.exec(z))!=null;)if(ce=B[1]||B[2]||B[3]||B[4]||B[5]||B[6],!!ce){if(de=ce.length,B[3]||B[4]){Ee+=de;continue}else if((B[5]||B[6])&&J%3&&!((J+de)%3)){_e+=de;continue}if(Ee-=de,!(Ee>0)){if(de=Math.min(de,de+Ee+_e),Math.min(J,de)%2){var Ie=F.slice(1,J+B.index+de);return{type:"em",raw:F.slice(0,J+B.index+de+1),text:Ie,tokens:this.lexer.inlineTokens(Ie,[])}}var De=F.slice(2,J+B.index+de-1);return{type:"strong",raw:F.slice(0,J+B.index+de+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}}}}},H.codespan=function(F){var z=this.rules.inline.code.exec(F);if(z){var k=z[2].replace(/\n/g," "),B=/[^ ]/.test(k),j=/^ /.test(k)&&/ $/.test(k);return B&&j&&(k=k.substring(1,k.length-1)),k=e(k,!0),{type:"codespan",raw:z[0],text:k}}},H.br=function(F){var z=this.rules.inline.br.exec(F);if(z)return{type:"br",raw:z[0]}},H.del=function(F){var z=this.rules.inline.del.exec(F);if(z)return{type:"del",raw:z[0],text:z[2],tokens:this.lexer.inlineTokens(z[2],[])}},H.autolink=function(F,z){var k=this.rules.inline.autolink.exec(F);if(k){var B,j;return k[2]==="@"?(B=e(this.options.mangle?z(k[1]):k[1]),j="mailto:"+B):(B=e(k[1]),j=B),{type:"link",raw:k[0],text:B,href:j,tokens:[{type:"text",raw:B,text:B}]}}},H.url=function(F,z){var k;if(k=this.rules.inline.url.exec(F)){var B,j;if(k[2]==="@")B=e(this.options.mangle?z(k[0]):k[0]),j="mailto:"+B;else{var J;do J=k[0],k[0]=this.rules.inline._backpedal.exec(k[0])[0];while(J!==k[0]);B=e(k[0]),k[1]==="www."?j="http://"+B:j=B}return{type:"link",raw:k[0],text:B,href:j,tokens:[{type:"text",raw:B,text:B}]}}},H.inlineText=function(F,z){var k=this.rules.inline.text.exec(F);if(k){var B;return this.lexer.state.inRawBlock?B=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]:B=e(this.options.smartypants?z(k[0]):k[0]),{type:"text",raw:k[0],text:B}}},O}(),fe={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};fe._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,fe._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,fe.def=_(fe.def).replace("label",fe._label).replace("title",fe._title).getRegex(),fe.bullet=/(?:[*+-]|\d{1,9}[.)])/,fe.listItemStart=_(/^( *)(bull) */).replace("bull",fe.bullet).getRegex(),fe.list=_(fe.list).replace(/bull/g,fe.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+fe.def.source+")").getRegex(),fe._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",fe._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,fe.html=_(fe.html,"i").replace("comment",fe._comment).replace("tag",fe._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),fe.paragraph=_(fe._paragraph).replace("hr",fe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",fe._tag).getRegex(),fe.blockquote=_(fe.blockquote).replace("paragraph",fe.paragraph).getRegex(),fe.normal=o({},fe),fe.gfm=o({},fe.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),fe.gfm.table=_(fe.gfm.table).replace("hr",fe.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",fe._tag).getRegex(),fe.gfm.paragraph=_(fe._paragraph).replace("hr",fe.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",fe.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",fe._tag).getRegex(),fe.pedantic=o({},fe.normal,{html:_(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",fe._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:_(fe.normal._paragraph).replace("hr",fe.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",fe.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ge={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ge._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ge.punctuation=_(ge.punctuation).replace(/punctuation/g,ge._punctuation).getRegex(),ge.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ge.escapedEmSt=/\\\*|\\_/g,ge._comment=_(fe._comment).replace("(?:-->|$)","-->").getRegex(),ge.emStrong.lDelim=_(ge.emStrong.lDelim).replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimAst=_(ge.emStrong.rDelimAst,"g").replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimUnd=_(ge.emStrong.rDelimUnd,"g").replace(/punct/g,ge._punctuation).getRegex(),ge._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ge._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ge._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ge.autolink=_(ge.autolink).replace("scheme",ge._scheme).replace("email",ge._email).getRegex(),ge._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ge.tag=_(ge.tag).replace("comment",ge._comment).replace("attribute",ge._attribute).getRegex(),ge._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ge._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ge._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ge.link=_(ge.link).replace("label",ge._label).replace("href",ge._href).replace("title",ge._title).getRegex(),ge.reflink=_(ge.reflink).replace("label",ge._label).replace("ref",fe._label).getRegex(),ge.nolink=_(ge.nolink).replace("ref",fe._label).getRegex(),ge.reflinkSearch=_(ge.reflinkSearch,"g").replace("reflink",ge.reflink).replace("nolink",ge.nolink).getRegex(),ge.normal=o({},ge),ge.pedantic=o({},ge.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:_(/^!?\[(label)\]\((.*?)\)/).replace("label",ge._label).getRegex(),reflink:_(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ge._label).getRegex()}),ge.gfm=o({},ge.normal,{escape:_(ge.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ge.gfm.url=_(ge.gfm.url,"i").replace("email",ge.gfm._extended_email).getRegex(),ge.breaks=o({},ge.gfm,{br:_(ge.br).replace("{2,}","*").getRegex(),text:_(ge.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ye(O){return O.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(O){var H="",V,F,z=O.length;for(V=0;V<z;V++)F=O.charCodeAt(V),Math.random()>.5&&(F="x"+F.toString(16)),H+="&#"+F+";";return H}var he=function(){function O(V){this.tokens=[],this.tokens.links=Object.create(null),this.options=V||Q.defaults,this.options.tokenizer=this.options.tokenizer||new ve,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var F={block:fe.normal,inline:ge.normal};this.options.pedantic?(F.block=fe.pedantic,F.inline=ge.pedantic):this.options.gfm&&(F.block=fe.gfm,this.options.breaks?F.inline=ge.breaks:F.inline=ge.gfm),this.tokenizer.rules=F}O.lex=function(F,z){var k=new O(z);return k.lex(F)},O.lexInline=function(F,z){var k=new O(z);return k.inlineTokens(F)};var H=O.prototype;return H.lex=function(F){F=F.replace(/\r\n|\r/g,`
`),this.blockTokens(F,this.tokens);for(var z;z=this.inlineQueue.shift();)this.inlineTokens(z.src,z.tokens);return this.tokens},H.blockTokens=function(F,z){var k=this;z===void 0&&(z=[]),this.options.pedantic?F=F.replace(/\t/g,"    ").replace(/^ +$/gm,""):F=F.replace(/^( *)(\t+)/gm,function(Ee,_e,ke){return _e+"    ".repeat(ke.length)});for(var B,j,J,ce;F;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(B=Ee.call({lexer:k},F,z))?(F=F.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.space(F)){F=F.substring(B.raw.length),B.raw.length===1&&z.length>0?z[z.length-1].raw+=`
`:z.push(B);continue}if(B=this.tokenizer.code(F)){F=F.substring(B.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B);continue}if(B=this.tokenizer.fences(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.heading(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.hr(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.blockquote(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.list(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.html(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.def(F)){F=F.substring(B.raw.length),j=z[z.length-1],j&&(j.type==="paragraph"||j.type==="text")?(j.raw+=`
`+B.raw,j.text+=`
`+B.raw,this.inlineQueue[this.inlineQueue.length-1].src=j.text):this.tokens.links[B.tag]||(this.tokens.links[B.tag]={href:B.href,title:B.title});continue}if(B=this.tokenizer.table(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.lheading(F)){F=F.substring(B.raw.length),z.push(B);continue}if(J=F,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,_e=F.slice(1),ke=void 0;k.options.extensions.startBlock.forEach(function(Ie){ke=Ie.call({lexer:this},_e),typeof ke=="number"&&ke>=0&&(Ee=Math.min(Ee,ke))}),Ee<1/0&&Ee>=0&&(J=F.substring(0,Ee+1))}(),this.state.top&&(B=this.tokenizer.paragraph(J))){j=z[z.length-1],ce&&j.type==="paragraph"?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B),ce=J.length!==F.length,F=F.substring(B.raw.length);continue}if(B=this.tokenizer.text(F)){F=F.substring(B.raw.length),j=z[z.length-1],j&&j.type==="text"?(j.raw+=`
`+B.raw,j.text+=`
`+B.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=j.text):z.push(B);continue}if(F){var de="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,z},H.inline=function(F,z){this.inlineQueue.push({src:F,tokens:z})},H.inlineTokens=function(F,z){var k=this;z===void 0&&(z=[]);var B,j,J,ce=F,de,Ee,_e;if(this.tokens.links){var ke=Object.keys(this.tokens.links);if(ke.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(ce))!=null;)ke.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(ce=ce.slice(0,de.index)+"["+re("a",de[0].length-2)+"]"+ce.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(ce))!=null;)ce=ce.slice(0,de.index)+"["+re("a",de[0].length-2)+"]"+ce.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(ce))!=null;)ce=ce.slice(0,de.index)+"++"+ce.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;F;)if(Ee||(_e=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(B=De.call({lexer:k},F,z))?(F=F.substring(B.raw.length),z.push(B),!0):!1}))){if(B=this.tokenizer.escape(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.tag(F)){F=F.substring(B.raw.length),j=z[z.length-1],j&&B.type==="text"&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(B=this.tokenizer.link(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.reflink(F,this.tokens.links)){F=F.substring(B.raw.length),j=z[z.length-1],j&&B.type==="text"&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(B=this.tokenizer.emStrong(F,ce,_e)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.codespan(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.br(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.del(F)){F=F.substring(B.raw.length),z.push(B);continue}if(B=this.tokenizer.autolink(F,ee)){F=F.substring(B.raw.length),z.push(B);continue}if(!this.state.inLink&&(B=this.tokenizer.url(F,ee))){F=F.substring(B.raw.length),z.push(B);continue}if(J=F,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Pe=F.slice(1),Me=void 0;k.options.extensions.startInline.forEach(function(Ge){Me=Ge.call({lexer:this},Pe),typeof Me=="number"&&Me>=0&&(De=Math.min(De,Me))}),De<1/0&&De>=0&&(J=F.substring(0,De+1))}(),B=this.tokenizer.inlineText(J,ye)){F=F.substring(B.raw.length),B.raw.slice(-1)!=="_"&&(_e=B.raw.slice(-1)),Ee=!0,j=z[z.length-1],j&&j.type==="text"?(j.raw+=B.raw,j.text+=B.text):z.push(B);continue}if(F){var Ie="Infinite loop on byte: "+F.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return z},D(O,null,[{key:"rules",get:function(){return{block:fe,inline:ge}}}]),O}(),te=function(){function O(V){this.options=V||Q.defaults}var H=O.prototype;return H.code=function(F,z,k){var B=(z||"").match(/\S*/)[0];if(this.options.highlight){var j=this.options.highlight(F,B);j!=null&&j!==F&&(k=!0,F=j)}return F=F.replace(/\n$/,"")+`
`,B?'<pre><code class="'+this.options.langPrefix+e(B,!0)+'">'+(k?F:e(F,!0))+`</code></pre>
`:"<pre><code>"+(k?F:e(F,!0))+`</code></pre>
`},H.blockquote=function(F){return`<blockquote>
`+F+`</blockquote>
`},H.html=function(F){return F},H.heading=function(F,z,k,B){if(this.options.headerIds){var j=this.options.headerPrefix+B.slug(k);return"<h"+z+' id="'+j+'">'+F+"</h"+z+`>
`}return"<h"+z+">"+F+"</h"+z+`>
`},H.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},H.list=function(F,z,k){var B=z?"ol":"ul",j=z&&k!==1?' start="'+k+'"':"";return"<"+B+j+`>
`+F+"</"+B+`>
`},H.listitem=function(F){return"<li>"+F+`</li>
`},H.checkbox=function(F){return"<input "+(F?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},H.paragraph=function(F){return"<p>"+F+`</p>
`},H.table=function(F,z){return z&&(z="<tbody>"+z+"</tbody>"),`<table>
<thead>
`+F+`</thead>
`+z+`</table>
`},H.tablerow=function(F){return`<tr>
`+F+`</tr>
`},H.tablecell=function(F,z){var k=z.header?"th":"td",B=z.align?"<"+k+' align="'+z.align+'">':"<"+k+">";return B+F+("</"+k+`>
`)},H.strong=function(F){return"<strong>"+F+"</strong>"},H.em=function(F){return"<em>"+F+"</em>"},H.codespan=function(F){return"<code>"+F+"</code>"},H.br=function(){return this.options.xhtml?"<br/>":"<br>"},H.del=function(F){return"<del>"+F+"</del>"},H.link=function(F,z,k){if(F=w(this.options.sanitize,this.options.baseUrl,F),F===null)return k;var B='<a href="'+e(F)+'"';return z&&(B+=' title="'+z+'"'),B+=">"+k+"</a>",B},H.image=function(F,z,k){if(F=w(this.options.sanitize,this.options.baseUrl,F),F===null)return k;var B='<img src="'+F+'" alt="'+k+'"';return z&&(B+=' title="'+z+'"'),B+=this.options.xhtml?"/>":">",B},H.text=function(F){return F},O}(),Z=function(){function O(){}var H=O.prototype;return H.strong=function(F){return F},H.em=function(F){return F},H.codespan=function(F){return F},H.del=function(F){return F},H.html=function(F){return F},H.text=function(F){return F},H.link=function(F,z,k){return""+k},H.image=function(F,z,k){return""+k},H.br=function(){return""},O}(),se=function(){function O(){this.seen={}}var H=O.prototype;return H.serialize=function(F){return F.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},H.getNextSafeSlug=function(F,z){var k=F,B=0;if(this.seen.hasOwnProperty(k)){B=this.seen[F];do B++,k=F+"-"+B;while(this.seen.hasOwnProperty(k))}return z||(this.seen[F]=B,this.seen[k]=0),k},H.slug=function(F,z){z===void 0&&(z={});var k=this.serialize(F);return this.getNextSafeSlug(k,z.dryrun)},O}(),ie=function(){function O(V){this.options=V||Q.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new Z,this.slugger=new se}O.parse=function(F,z){var k=new O(z);return k.parse(F)},O.parseInline=function(F,z){var k=new O(z);return k.parseInline(F)};var H=O.prototype;return H.parse=function(F,z){z===void 0&&(z=!0);var k="",B,j,J,ce,de,Ee,_e,ke,Ie,De,Pe,Me,Ge,He,Ue,Je,je,Oe,x,oe=F.length;for(B=0;B<oe;B++){if(De=F[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(x=this.options.extensions.renderers[De.type].call({parser:this},De),x!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){k+=x||"";continue}switch(De.type){case"space":continue;case"hr":{k+=this.renderer.hr();continue}case"heading":{k+=this.renderer.heading(this.parseInline(De.tokens),De.depth,g(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{k+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(ke="",_e="",ce=De.header.length,j=0;j<ce;j++)_e+=this.renderer.tablecell(this.parseInline(De.header[j].tokens),{header:!0,align:De.align[j]});for(ke+=this.renderer.tablerow(_e),Ie="",ce=De.rows.length,j=0;j<ce;j++){for(Ee=De.rows[j],_e="",de=Ee.length,J=0;J<de;J++)_e+=this.renderer.tablecell(this.parseInline(Ee[J].tokens),{header:!1,align:De.align[J]});Ie+=this.renderer.tablerow(_e)}k+=this.renderer.table(ke,Ie);continue}case"blockquote":{Ie=this.parse(De.tokens),k+=this.renderer.blockquote(Ie);continue}case"list":{for(Pe=De.ordered,Me=De.start,Ge=De.loose,ce=De.items.length,Ie="",j=0;j<ce;j++)Ue=De.items[j],Je=Ue.checked,je=Ue.task,He="",Ue.task&&(Oe=this.renderer.checkbox(Je),Ge?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Oe+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Oe+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(Ue.tokens,Ge),Ie+=this.renderer.listitem(He,je,Je);k+=this.renderer.list(Ie,Pe,Me);continue}case"html":{k+=this.renderer.html(De.text);continue}case"paragraph":{k+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ie=De.tokens?this.parseInline(De.tokens):De.text;B+1<oe&&F[B+1].type==="text";)De=F[++B],Ie+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);k+=z?this.renderer.paragraph(Ie):Ie;continue}default:{var be='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return k},H.parseInline=function(F,z){z=z||this.renderer;var k="",B,j,J,ce=F.length;for(B=0;B<ce;B++){if(j=F[B],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[j.type]&&(J=this.options.extensions.renderers[j.type].call({parser:this},j),J!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(j.type))){k+=J||"";continue}switch(j.type){case"escape":{k+=z.text(j.text);break}case"html":{k+=z.html(j.text);break}case"link":{k+=z.link(j.href,j.title,this.parseInline(j.tokens,z));break}case"image":{k+=z.image(j.href,j.title,j.text);break}case"strong":{k+=z.strong(this.parseInline(j.tokens,z));break}case"em":{k+=z.em(this.parseInline(j.tokens,z));break}case"codespan":{k+=z.codespan(j.text);break}case"br":{k+=z.br();break}case"del":{k+=z.del(this.parseInline(j.tokens,z));break}case"text":{k+=z.text(j.text);break}default:{var de='Token with "'+j.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return k},O}();function T(O,H,V){if(typeof O=="undefined"||O===null)throw new Error("marked(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");if(typeof H=="function"&&(V=H,H=null),H=o({},T.defaults,H||{}),ne(H),V){var F=H.highlight,z;try{z=he.lex(O,H)}catch(J){return V(J)}var k=function(ce){var de;if(!ce)try{H.walkTokens&&T.walkTokens(z,H.walkTokens),de=ie.parse(z,H)}catch(Ee){ce=Ee}return H.highlight=F,ce?V(ce):V(null,de)};if(!F||F.length<3||(delete H.highlight,!z.length))return k();var B=0;T.walkTokens(z,function(J){J.type==="code"&&(B++,setTimeout(function(){F(J.text,J.lang,function(ce,de){if(ce)return k(ce);de!=null&&de!==J.text&&(J.text=de,J.escaped=!0),B--,B===0&&k()})},0))}),B===0&&k();return}try{var j=he.lex(O,H);return H.walkTokens&&T.walkTokens(j,H.walkTokens),ie.parse(j,H)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+e(J.message+"",!0)+"</pre>";throw J}}T.options=T.setOptions=function(O){return o(T.defaults,O),b(T.defaults),T},T.getDefaults=y,T.defaults=Q.defaults,T.use=function(){for(var O=arguments.length,H=new Array(O),V=0;V<O;V++)H[V]=arguments[V];var F=o.apply(void 0,[{}].concat(H)),z=T.defaults.extensions||{renderers:{},childTokens:{}},k;H.forEach(function(B){if(B.extensions&&(k=!0,B.extensions.forEach(function(J){if(!J.name)throw new Error("extension name required");if(J.renderer){var ce=z.renderers?z.renderers[J.name]:null;ce?z.renderers[J.name]=function(){for(var de=arguments.length,Ee=new Array(de),_e=0;_e<de;_e++)Ee[_e]=arguments[_e];var ke=J.renderer.apply(this,Ee);return ke===!1&&(ke=ce.apply(this,Ee)),ke}:z.renderers[J.name]=J.renderer}if(J.tokenizer){if(!J.level||J.level!=="block"&&J.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");z[J.level]?z[J.level].unshift(J.tokenizer):z[J.level]=[J.tokenizer],J.start&&(J.level==="block"?z.startBlock?z.startBlock.push(J.start):z.startBlock=[J.start]:J.level==="inline"&&(z.startInline?z.startInline.push(J.start):z.startInline=[J.start]))}J.childTokens&&(z.childTokens[J.name]=J.childTokens)})),B.renderer&&function(){var J=T.defaults.renderer||new te,ce=function(_e){var ke=J[_e];J[_e]=function(){for(var Ie=arguments.length,De=new Array(Ie),Pe=0;Pe<Ie;Pe++)De[Pe]=arguments[Pe];var Me=B.renderer[_e].apply(J,De);return Me===!1&&(Me=ke.apply(J,De)),Me}};for(var de in B.renderer)ce(de);F.renderer=J}(),B.tokenizer&&function(){var J=T.defaults.tokenizer||new ve,ce=function(_e){var ke=J[_e];J[_e]=function(){for(var Ie=arguments.length,De=new Array(Ie),Pe=0;Pe<Ie;Pe++)De[Pe]=arguments[Pe];var Me=B.tokenizer[_e].apply(J,De);return Me===!1&&(Me=ke.apply(J,De)),Me}};for(var de in B.tokenizer)ce(de);F.tokenizer=J}(),B.walkTokens){var j=T.defaults.walkTokens;F.walkTokens=function(J){B.walkTokens.call(this,J),j&&j.call(this,J)}}k&&(F.extensions=z),T.setOptions(F)})},T.walkTokens=function(O,H){for(var V=function(){var B=z.value;switch(H.call(T,B),B.type){case"table":{for(var j=M(B.header),J;!(J=j()).done;){var ce=J.value;T.walkTokens(ce.tokens,H)}for(var de=M(B.rows),Ee;!(Ee=de()).done;)for(var _e=Ee.value,ke=M(_e),Ie;!(Ie=ke()).done;){var De=Ie.value;T.walkTokens(De.tokens,H)}break}case"list":{T.walkTokens(B.items,H);break}default:T.defaults.extensions&&T.defaults.extensions.childTokens&&T.defaults.extensions.childTokens[B.type]?T.defaults.extensions.childTokens[B.type].forEach(function(Pe){T.walkTokens(B[Pe],H)}):B.tokens&&T.walkTokens(B.tokens,H)}},F=M(O),z;!(z=F()).done;)V()},T.parseInline=function(O,H){if(typeof O=="undefined"||O===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof O!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(O)+", string expected");H=o({},T.defaults,H||{}),ne(H);try{var V=he.lexInline(O,H);return H.walkTokens&&T.walkTokens(V,H.walkTokens),ie.parseInline(V,H)}catch(F){if(F.message+=`
Please report this to https://github.com/markedjs/marked.`,H.silent)return"<p>An error occurred:</p><pre>"+e(F.message+"",!0)+"</pre>";throw F}},T.Parser=ie,T.parser=ie.parse,T.Renderer=te,T.TextRenderer=Z,T.Lexer=he,T.lexer=he.lex,T.Tokenizer=ve,T.Slugger=se,T.parse=T;var $=T.options,X=T.setOptions,R=T.use,f=T.walkTokens,I=T.parseInline,U=T,q=ie.parse,W=he.lex;Q.Lexer=he,Q.Parser=ie,Q.Renderer=te,Q.Slugger=se,Q.TextRenderer=Z,Q.Tokenizer=ve,Q.getDefaults=y,Q.lexer=W,Q.marked=T,Q.options=$,Q.parse=U,Q.parseInline=I,Q.parser=q,Q.setOptions=X,Q.use=R,Q.walkTokens=f,Object.defineProperty(Q,"__esModule",{value:!0})}),define(me[76],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class D{constructor(P,M=0,y=P.length,b=M-1){this.items=P,this.start=M,this.end=y,this.index=b}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=D}),define(me[77],pe([1,0,76]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(y=[],b=10){this._initialize(y),this._limit=b,this._onChange()}getHistory(){return this._elements}add(y){this._history.delete(y),this._history.add(y),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(y){return this._history.has(y)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const y=this._elements;this._navigator=new D.ArrayNavigator(y,0,y.length,y.length)}_reduceToLimit(){const y=this._elements;y.length>this._limit&&this._initialize(y.slice(y.length-this._limit))}_currentPosition(){const y=this._navigator.current();return y?this._elements.indexOf(y):-1}_initialize(y){this._history=new Set;for(const b of y)this._history.add(b)}get _elements(){const y=[];return this._history.forEach(b=>y.push(b)),y}}t.HistoryNavigator=i;class P{constructor(y,b=10){if(this.capacity=b,y.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:y[0],previous:void 0,next:void 0};for(let m=1;m<y.length;m++)this.add(y[m])}add(y){const b={value:y,previous:this.tail,next:void 0};for(this.tail.next=b,this.tail=b,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(y){const b=this.tail.value;return this.tail.value=y,b}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(y){let b=this.head;for(;b;){if(b.value===y)return!0;b=b.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let y=this.head;for(;y;)yield y.value,y=y.next}}t.HistoryNavigator2=P}),define(me[44],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function D(b,m,h){return Math.min(Math.max(b,m),h)}t.clamp=D;function i(b,m){return(m+b%m)%m}t.rot=i;class P{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=P;class M{constructor(){this._n=1,this._val=0}update(m){return this._val=this._val+(m-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=M;class y{constructor(m){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(m),this._values.fill(0,0,m)}update(m){const h=this._values[this._index];return this._values[this._index]=m,this._index=(this._index+1)%this._values.length,this._sum-=h,this._sum+=m,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=y}),define(me[45],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var D;(function(i){function P(m,h){if(m.start>=h.end||h.start>=m.end)return{start:0,end:0};const p=Math.max(m.start,h.start),A=Math.min(m.end,h.end);return A-p<=0?{start:0,end:0}:{start:p,end:A}}i.intersect=P;function M(m){return m.end-m.start<=0}i.isEmpty=M;function y(m,h){return!M(P(m,h))}i.intersects=y;function b(m,h){const p=[],A={start:m.start,end:Math.min(h.start,m.end)},l={start:Math.max(h.end,m.start),end:m.end};return M(A)||p.push(A),M(l)||p.push(l),p}i.relativeComplement=b})(D=t.Range||(t.Range={}))}),define(me[78],pe([1,0,45]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(m,h){const p=[];for(const A of h){if(m.start>=A.range.end)continue;if(m.end<A.range.start)break;const l=D.Range.intersect(m,A.range);D.Range.isEmpty(l)||p.push({range:l,size:A.size})}return p}t.groupIntersect=i;function P({start:m,end:h},p){return{start:m+p,end:h+p}}t.shift=P;function M(m){const h=[];let p=null;for(const A of m){const l=A.range.start,r=A.range.end,e=A.size;if(p&&e===p.size){p.range.end=r;continue}p={range:{start:l,end:r},size:e},h.push(p)}return h}t.consolidate=M;function y(...m){return M(m.reduce((h,p)=>h.concat(p),[]))}class b{constructor(){this.groups=[],this._size=0}splice(h,p,A=[]){const l=A.length-p,r=i({start:0,end:h},this.groups),e=i({start:h+p,end:Number.POSITIVE_INFINITY},this.groups).map(g=>({range:P(g.range,l),size:g.size})),c=A.map((g,E)=>({range:{start:h+E,end:h+E+1},size:g.size}));this.groups=y(r,c,e),this._size=this.groups.reduce((g,E)=>g+E.size*(E.range.end-E.range.start),0)}get count(){const h=this.groups.length;return h?this.groups[h-1].range.end:0}get size(){return this._size}indexAt(h){if(h<0)return-1;let p=0,A=0;for(const l of this.groups){const r=l.range.end-l.range.start,e=A+r*l.size;if(h<e)return p+Math.floor((h-A)/l.size);p+=r,A=e}return p}indexAfter(h){return Math.min(this.indexAt(h)+1,this.count)}positionAt(h){if(h<0)return-1;let p=0,A=0;for(const l of this.groups){const r=l.range.end-l.range.start,e=A+r;if(h<e)return p+(h-A)*l.size;p+=r*l.size,A=e}return-1}}t.RangeMap=b}),define(me[79],pe([1,0,13,2]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function P(d){const w=d;return w?typeof w.read=="function":!1}t.isReadable=P;function M(d){const w=d;return w?[w.on,w.pause,w.resume,w.destroy].every(S=>typeof S=="function"):!1}t.isReadableStream=M;function y(d){const w=d;return w?M(w.stream)&&Array.isArray(w.buffer)&&typeof w.ended=="boolean":!1}t.isReadableBufferedStream=y;function b(d,w){return new m(d,w)}t.newWriteableStream=b;class m{constructor(w,S){this.reducer=w,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(w){if(!this.state.destroyed){if(this.state.flowing)this.emitData(w);else if(this.buffer.data.push(w),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(w){this.state.destroyed||(this.state.flowing?this.emitError(w):this.buffer.error.push(w))}end(w){this.state.destroyed||(typeof w!="undefined"&&this.write(w),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(w){this.listeners.data.slice(0).forEach(S=>S(w))}emitError(w){this.listeners.error.length===0?(0,D.onUnexpectedError)(w):this.listeners.error.slice(0).forEach(S=>S(w))}emitEnd(){this.listeners.end.slice(0).forEach(w=>w())}on(w,S){if(!this.state.destroyed)switch(w){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(w,S){if(this.state.destroyed)return;let L;switch(w){case"data":L=this.listeners.data;break;case"end":L=this.listeners.end;break;case"error":L=this.listeners.error;break}if(L){const C=L.indexOf(S);C>=0&&L.splice(C,1)}}flowData(){if(this.buffer.data.length>0){const w=this.reducer(this.buffer.data);this.emitData(w),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(L=>L())}}flowErrors(){if(this.listeners.error.length>0){for(const w of this.buffer.error)this.emitError(w);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function h(d,w){const S=[];let L;for(;(L=d.read())!==null;)S.push(L);return w(S)}t.consumeReadable=h;function p(d,w,S){const L=[];let C;for(;(C=d.read())!==null&&L.length<S;)L.push(C);return C===null&&L.length>0?w(L):{read:()=>{if(L.length>0)return L.shift();if(typeof C!="undefined"){const n=C;return C=void 0,n}return d.read()}}}t.peekReadable=p;function A(d,w){return new Promise((S,L)=>{const C=[];l(d,{onData:n=>{w&&C.push(n)},onError:n=>{w?L(n):S(void 0)},onEnd:()=>{S(w?w(C):void 0)}})})}t.consumeStream=A;function l(d,w){let S=!1;return d.on("error",L=>{S||w.onError(L)}),d.on("end",()=>{S||w.onEnd()}),d.on("data",L=>{S||w.onData(L)}),(0,i.toDisposable)(()=>S=!0)}t.listenStream=l;function r(d,w){return new Promise((S,L)=>{const C=new i.DisposableStore,n=[],s=v=>{if(n.push(v),n.length>w)return C.dispose(),d.pause(),S({stream:d,buffer:n,ended:!1})},a=v=>L(v),o=()=>S({stream:d,buffer:n,ended:!0});C.add((0,i.toDisposable)(()=>d.removeListener("error",a))),d.on("error",a),C.add((0,i.toDisposable)(()=>d.removeListener("end",o))),d.on("end",o),C.add((0,i.toDisposable)(()=>d.removeListener("data",s))),d.on("data",s)})}t.peekStream=r;function e(d,w){const S=b(w);return S.end(d),S}t.toStream=e;function c(){const d=b(()=>{throw new Error("not supported")});return d.end(),d}t.emptyStream=c;function g(d){let w=!1;return{read:()=>w?null:(w=!0,d)}}t.toReadable=g;function E(d,w,S){const L=b(S);return l(d,{onData:C=>L.write(w.data(C)),onError:C=>L.error(w.error?w.error(C):C),onEnd:()=>L.end()}),L}t.transform=E;function _(d,w,S){let L=!1;return{read:()=>{const C=w.read();return L?C:(L=!0,C!==null?S([d,C]):d)}}}t.prefixedReadable=_;function u(d,w,S){let L=!1;const C=b(S);return l(w,{onData:n=>L?C.write(n):(L=!0,C.write(S([d,n]))),onError:n=>C.error(n),onEnd:()=>{L||(L=!0,C.write(d)),C.end()}}),C}t.prefixedStream=u}),define(me[31],pe([1,0,79]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer!="undefined";let P,M;class y{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return i?new y(Buffer.allocUnsafe(v)):new y(new Uint8Array(v))}static wrap(v){return i&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new y(v)}static fromString(v,N){return!(N?.dontUseNodeBuffer||!1)&&i?new y(Buffer.from(v)):(P||(P=new TextEncoder),new y(P.encode(v)))}static fromByteArray(v){const N=y.alloc(v.length);for(let K=0,ne=v.length;K<ne;K++)N.buffer[K]=v[K];return N}static concat(v,N){if(typeof N=="undefined"){N=0;for(let re=0,we=v.length;re<we;re++)N+=v[re].byteLength}const K=y.alloc(N);let ne=0;for(let re=0,we=v.length;re<we;re++){const ae=v[re];K.set(ae,ne),ne+=ae.byteLength}return K}clone(){const v=y.alloc(this.byteLength);return v.set(this),v}toString(){return i?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(v,N){return new y(this.buffer.subarray(v,N))}set(v,N){if(v instanceof y)this.buffer.set(v.buffer,N);else if(v instanceof Uint8Array)this.buffer.set(v,N);else if(v instanceof ArrayBuffer)this.buffer.set(new Uint8Array(v),N);else if(ArrayBuffer.isView(v))this.buffer.set(new Uint8Array(v.buffer,v.byteOffset,v.byteLength),N);else throw new Error("Unknown argument 'array'")}readUInt32BE(v){return h(this.buffer,v)}writeUInt32BE(v,N){p(this.buffer,v,N)}readUInt32LE(v){return A(this.buffer,v)}writeUInt32LE(v,N){l(this.buffer,v,N)}readUInt8(v){return r(this.buffer,v)}writeUInt8(v,N){e(this.buffer,v,N)}}t.VSBuffer=y;function b(o,v){return o[v+0]<<0>>>0|o[v+1]<<8>>>0}t.readUInt16LE=b;function m(o,v,N){o[N+0]=v&255,v=v>>>8,o[N+1]=v&255}t.writeUInt16LE=m;function h(o,v){return o[v]*2**24+o[v+1]*2**16+o[v+2]*2**8+o[v+3]}t.readUInt32BE=h;function p(o,v,N){o[N+3]=v,v=v>>>8,o[N+2]=v,v=v>>>8,o[N+1]=v,v=v>>>8,o[N]=v}t.writeUInt32BE=p;function A(o,v){return o[v+0]<<0>>>0|o[v+1]<<8>>>0|o[v+2]<<16>>>0|o[v+3]<<24>>>0}t.readUInt32LE=A;function l(o,v,N){o[N+0]=v&255,v=v>>>8,o[N+1]=v&255,v=v>>>8,o[N+2]=v&255,v=v>>>8,o[N+3]=v&255}t.writeUInt32LE=l;function r(o,v){return o[v]}t.readUInt8=r;function e(o,v,N){o[N]=v}t.writeUInt8=e;function c(o){return D.consumeReadable(o,v=>y.concat(v))}t.readableToBuffer=c;function g(o){return D.toReadable(o)}t.bufferToReadable=g;function E(o){return D.consumeStream(o,v=>y.concat(v))}t.streamToBuffer=E;async function _(o){return o.ended?y.concat(o.buffer):y.concat([...o.buffer,await E(o.stream)])}t.bufferedStreamToBuffer=_;function u(o){return D.toStream(o,v=>y.concat(v))}t.bufferToStream=u;function d(o){return D.transform(o,{data:v=>typeof v=="string"?y.fromString(v):y.wrap(v)},v=>y.concat(v))}t.streamToBufferReadableStream=d;function w(o){return D.newWriteableStream(v=>y.concat(v),o)}t.newWriteableBufferStream=w;function S(o,v){return D.prefixedReadable(o,v,N=>y.concat(N))}t.prefixedBufferReadable=S;function L(o,v){return D.prefixedStream(o,v,N=>y.concat(N))}t.prefixedBufferStream=L;function C(o){let v=0,N=0,K=0;const ne=new Uint8Array(Math.floor(o.length/4*3)),re=ae=>{switch(N){case 3:ne[K++]=v|ae,N=0;break;case 2:ne[K++]=v|ae>>>2,v=ae<<6,N=3;break;case 1:ne[K++]=v|ae>>>4,v=ae<<4,N=2;break;default:v=ae<<2,N=1}};for(let ae=0;ae<o.length;ae++){const ve=o.charCodeAt(ae);if(ve>=65&&ve<=90)re(ve-65);else if(ve>=97&&ve<=122)re(ve-97+26);else if(ve>=48&&ve<=57)re(ve-48+52);else if(ve===43||ve===45)re(62);else if(ve===47||ve===95)re(63);else{if(ve===61)break;throw new SyntaxError(`Unexpected base64 character ${o[ae]}`)}}const we=K;for(;N>0;)re(0);return y.wrap(ne).slice(0,we)}t.decodeBase64=C;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:o},v=!0,N=!1){const K=N?s:n;let ne="";const re=o.byteLength%3;let we=0;for(;we<o.byteLength-re;we+=3){const ae=o[we+0],ve=o[we+1],fe=o[we+2];ne+=K[ae>>>2],ne+=K[(ae<<4|ve>>>4)&63],ne+=K[(ve<<2|fe>>>6)&63],ne+=K[fe&63]}if(re===1){const ae=o[we+0];ne+=K[ae>>>2],ne+=K[ae<<4&63],v&&(ne+="==")}else if(re===2){const ae=o[we+0],ve=o[we+1];ne+=K[ae>>>2],ne+=K[(ae<<4|ve>>>4)&63],ne+=K[ve<<2&63],v&&(ne+="=")}return ne}t.encodeBase64=a}),define(me[6],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function D(a){return typeof a=="string"}t.isString=D;function i(a){return Array.isArray(a)&&a.every(o=>D(o))}t.isStringArray=i;function P(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}t.isObject=P;function M(a){const o=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof o}t.isTypedArray=M;function y(a){return typeof a=="number"&&!isNaN(a)}t.isNumber=y;function b(a){return!!a&&typeof a[Symbol.iterator]=="function"}t.isIterable=b;function m(a){return a===!0||a===!1}t.isBoolean=m;function h(a){return typeof a=="undefined"}t.isUndefined=h;function p(a){return!A(a)}t.isDefined=p;function A(a){return h(a)||a===null}t.isUndefinedOrNull=A;function l(a,o){if(!a)throw new Error(o?`Unexpected type, expected '${o}'`:"Unexpected type")}t.assertType=l;function r(a){if(A(a))throw new Error("Assertion Failed: argument is undefined or null");return a}t.assertIsDefined=r;function e(...a){const o=[];for(let v=0;v<a.length;v++){const N=a[v];if(A(N))throw new Error(`Assertion Failed: argument at index ${v} is undefined or null`);o.push(N)}return o}t.assertAllDefined=e;const c=Object.prototype.hasOwnProperty;function g(a){if(!P(a))return!1;for(const o in a)if(c.call(a,o))return!1;return!0}t.isEmptyObject=g;function E(a){return typeof a=="function"}t.isFunction=E;function _(...a){return a.length>0&&a.every(E)}t.areFunctions=_;function u(a,o){const v=Math.min(a.length,o.length);for(let N=0;N<v;N++)d(a[N],o[N])}t.validateConstraints=u;function d(a,o){if(D(o)){if(typeof a!==o)throw new Error(`argument does not match constraint: typeof ${o}`)}else if(E(o)){try{if(a instanceof o)return}catch{}if(!A(a)&&a.constructor===o||o.length===1&&o.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=d;function w(a){let o=[],v=Object.getPrototypeOf(a);for(;Object.prototype!==v;)o=o.concat(Object.getOwnPropertyNames(v)),v=Object.getPrototypeOf(v);return o}t.getAllPropertyNames=w;function S(a){const o=[];for(const v of w(a))typeof a[v]=="function"&&o.push(v);return o}t.getAllMethodNames=S;function L(a,o){const v=K=>function(){const ne=Array.prototype.slice.call(arguments,0);return o(K,ne)},N={};for(const K of a)N[K]=v(K);return N}t.createProxyObject=L;function C(a){return a===null?void 0:a}t.withNullAsUndefined=C;function n(a){return typeof a=="undefined"?null:a}t.withUndefinedAsNull=n;function s(a,o="Unreachable"){throw new Error(o)}t.assertNever=s}),define(me[27],pe([1,0,6]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(e){if(!e||typeof e!="object"||e instanceof RegExp)return e;const c=Array.isArray(e)?[]:{};return Object.keys(e).forEach(g=>{e[g]&&typeof e[g]=="object"?c[g]=i(e[g]):c[g]=e[g]}),c}t.deepClone=i;function P(e){if(!e||typeof e!="object")return e;const c=[e];for(;c.length>0;){const g=c.shift();Object.freeze(g);for(const E in g)if(M.call(g,E)){const _=g[E];typeof _=="object"&&!Object.isFrozen(_)&&!(0,D.isTypedArray)(_)&&c.push(_)}}return e}t.deepFreeze=P;const M=Object.prototype.hasOwnProperty;function y(e,c){return b(e,c,new Set)}t.cloneAndChange=y;function b(e,c,g){if((0,D.isUndefinedOrNull)(e))return e;const E=c(e);if(typeof E!="undefined")return E;if(Array.isArray(e)){const _=[];for(const u of e)_.push(b(u,c,g));return _}if((0,D.isObject)(e)){if(g.has(e))throw new Error("Cannot clone recursive data-structure");g.add(e);const _={};for(const u in e)M.call(e,u)&&(_[u]=b(e[u],c,g));return g.delete(e),_}return e}function m(e,c,g=!0){return(0,D.isObject)(e)?((0,D.isObject)(c)&&Object.keys(c).forEach(E=>{E in e?g&&((0,D.isObject)(e[E])&&(0,D.isObject)(c[E])?m(e[E],c[E],g):e[E]=c[E]):e[E]=c[E]}),e):c}t.mixin=m;function h(e,c){if(e===c)return!0;if(e==null||c===null||c===void 0||typeof e!=typeof c||typeof e!="object"||Array.isArray(e)!==Array.isArray(c))return!1;let g,E;if(Array.isArray(e)){if(e.length!==c.length)return!1;for(g=0;g<e.length;g++)if(!h(e[g],c[g]))return!1}else{const _=[];for(E in e)_.push(E);_.sort();const u=[];for(E in c)u.push(E);if(u.sort(),!h(_,u))return!1;for(g=0;g<_.length;g++)if(!h(e[_[g]],c[_[g]]))return!1}return!0}t.equals=h;function p(e){const c=new Set;return JSON.stringify(e,(g,E)=>{if((0,D.isObject)(E)||Array.isArray(E)){if(c.has(E))return"[Circular]";c.add(E)}return E})}t.safeStringify=p;function A(e,c){const g=Object.create(null);return!e||!c||Object.keys(c).forEach(_=>{const u=e[_],d=c[_];h(u,d)||(g[_]=d)}),g}t.distinct=A;function l(e,c){const g=c.toLowerCase(),E=Object.keys(e).find(_=>_.toLowerCase()===g);return E?e[E]:e[c]}t.getCaseInsensitive=l;function r(e,c){const g=Object.create(null);for(const[E,_]of Object.entries(e))c(E,_)&&(g[E]=_);return g}t.filter=r}),define(me[80],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[81],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class D{constructor(P,M){this.sender=P,this.onMessage=M}send(P){try{this.sender.send("vscode:message",P.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=D}),define(me[46],pe([7]),{}),define(me[82],pe([7]),{}),define(me[83],pe([7]),{}),define(me[84],pe([7]),{}),define(me[85],pe([1,0,11,83,84]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(P){let M=P.definition;for(;M instanceof D.Codicon;)M=M.definition;return`.codicon-${P.id}:before { content: '${M.fontCharacter}'; }`}t.formatRule=i}),define(me[86],pe([7]),{}),define(me[87],pe([7]),{}),define(me[88],pe([7]),{}),define(me[89],pe([7]),{}),define(me[90],pe([7]),{}),define(me[91],pe([7]),{}),define(me[92],pe([7]),{}),define(me[93],pe([7]),{}),define(me[94],pe([7]),{}),define(me[95],pe([12,9]),function(Q,t){return Q.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[96],pe([12,9]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[97],pe([12,9]),function(Q,t){return Q.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[98],pe([12,9]),function(Q,t){return Q.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[99],pe([12,9]),function(Q,t){return Q.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[100],pe([12,9]),function(Q,t){return Q.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[101],pe([12,9]),function(Q,t){return Q.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[102],pe([12,9]),function(Q,t){return Q.create("vs/base/common/actions",t)}),define(me[103],pe([12,9]),function(Q,t){return Q.create("vs/base/common/platform",t)}),define(me[5],pe([1,0,103]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=void 0;const i="en";let P=!1,M=!1,y=!1,b=!1,m=!1,h=!1,p=!1,A=!1,l=!1,r,e=i,c,g;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let E;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?E=t.globals.vscode.process:typeof process!="undefined"&&(E=process);const _=typeof E?.versions?.electron=="string",u=_&&E?.type==="renderer";if(typeof navigator=="object"&&!u)g=navigator.userAgent,P=g.indexOf("Windows")>=0,M=g.indexOf("Macintosh")>=0,A=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,y=g.indexOf("Linux")>=0,h=!0,r=D.getConfiguredDefaultLocale(D.localize(0,null))||i,e=r;else if(typeof E=="object"){P=E.platform==="win32",M=E.platform==="darwin",y=E.platform==="linux",b=y&&!!E.env.SNAP&&!!E.env.SNAP_REVISION,p=_,l=!!E.env.CI||!!E.env.BUILD_ARTIFACTSTAGINGDIRECTORY,r=i,e=i;const o=E.env.VSCODE_NLS_CONFIG;if(o)try{const v=JSON.parse(o),N=v.availableLanguages["*"];r=v.locale,e=N||i,c=v._translationsConfigFile}catch{}m=!0}else console.error("Unable to resolve platform.");var d;(function(o){o[o.Web=0]="Web",o[o.Mac=1]="Mac",o[o.Linux=2]="Linux",o[o.Windows=3]="Windows"})(d=t.Platform||(t.Platform={}));function w(o){switch(o){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=w;let S=0;M?S=1:P?S=3:y&&(S=2),t.isWindows=P,t.isMacintosh=M,t.isLinux=y,t.isLinuxSnap=b,t.isNative=m,t.isElectron=p,t.isWeb=h,t.isWebWorker=h&&typeof t.globals.importScripts=="function",t.isIOS=A,t.isCI=l,t.platform=S,t.userAgent=g,t.language=e;var L;(function(o){function v(){return t.language}o.value=v;function N(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}o.isDefaultVariant=N;function K(){return t.language==="en"}o.isDefault=K})(L=t.Language||(t.Language={})),t.locale=r,t.translationsConfigFile=c,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const o=[];t.globals.addEventListener("message",N=>{if(N.data&&N.data.vscodeScheduleAsyncWork)for(let K=0,ne=o.length;K<ne;K++){const re=o[K];if(re.id===N.data.vscodeScheduleAsyncWork){o.splice(K,1),re.callback();return}}});let v=0;return N=>{const K=++v;o.push({id:K,callback:N}),t.globals.postMessage({vscodeScheduleAsyncWork:K},"*")}}return o=>setTimeout(o)})();var C;(function(o){o[o.Windows=1]="Windows",o[o.Macintosh=2]="Macintosh",o[o.Linux=3]="Linux"})(C=t.OperatingSystem||(t.OperatingSystem={})),t.OS=M||A?2:P?1:3;let n=!0,s=!1;function a(){if(!s){s=!0;const o=new Uint8Array(2);o[0]=1,o[1]=2,n=new Uint16Array(o.buffer)[0]===(2<<8)+1}return n}t.isLittleEndian=a,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[104],pe([1,0,5]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const P=D.globals.vscode.process;i={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],pe([1,0,104]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,P=97,M=90,y=122,b=46,m=47,h=92,p=58,A=63;class l extends Error{constructor(d,w,S){let L;typeof w=="string"&&w.indexOf("not ")===0?(L="must not be",w=w.replace(/^not /,"")):L="must be";const C=d.indexOf(".")!==-1?"property":"argument";let n=`The "${d}" ${C} ${L} of type ${w}`;n+=`. Received type ${typeof S}`;super(n);this.code="ERR_INVALID_ARG_TYPE"}}function r(u,d){if(typeof u!="string")throw new l(d,"string",u)}function e(u){return u===m||u===h}function c(u){return u===m}function g(u){return u>=i&&u<=M||u>=P&&u<=y}function E(u,d,w,S){let L="",C=0,n=-1,s=0,a=0;for(let o=0;o<=u.length;++o){if(o<u.length)a=u.charCodeAt(o);else{if(S(a))break;a=m}if(S(a)){if(!(n===o-1||s===1))if(s===2){if(L.length<2||C!==2||L.charCodeAt(L.length-1)!==b||L.charCodeAt(L.length-2)!==b){if(L.length>2){const v=L.lastIndexOf(w);v===-1?(L="",C=0):(L=L.slice(0,v),C=L.length-1-L.lastIndexOf(w)),n=o,s=0;continue}else if(L.length!==0){L="",C=0,n=o,s=0;continue}}d&&(L+=L.length>0?`${w}..`:"..",C=2)}else L.length>0?L+=`${w}${u.slice(n+1,o)}`:L=u.slice(n+1,o),C=o-n-1;n=o,s=0}else a===b&&s!==-1?++s:s=-1}return L}function _(u,d){if(d===null||typeof d!="object")throw new l("pathObject","Object",d);const w=d.dir||d.root,S=d.base||`${d.name||""}${d.ext||""}`;return w?w===d.root?`${w}${S}`:`${w}${u}${S}`:S}t.win32={resolve(...u){let d="",w="",S=!1;for(let L=u.length-1;L>=-1;L--){let C;if(L>=0){if(C=u[L],r(C,"path"),C.length===0)continue}else d.length===0?C=D.cwd():(C=D.env[`=${d}`]||D.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==d.toLowerCase()&&C.charCodeAt(2)===h)&&(C=`${d}\\`));const n=C.length;let s=0,a="",o=!1;const v=C.charCodeAt(0);if(n===1)e(v)&&(s=1,o=!0);else if(e(v))if(o=!0,e(C.charCodeAt(1))){let N=2,K=N;for(;N<n&&!e(C.charCodeAt(N));)N++;if(N<n&&N!==K){const ne=C.slice(K,N);for(K=N;N<n&&e(C.charCodeAt(N));)N++;if(N<n&&N!==K){for(K=N;N<n&&!e(C.charCodeAt(N));)N++;(N===n||N!==K)&&(a=`\\\\${ne}\\${C.slice(K,N)}`,s=N)}}}else s=1;else g(v)&&C.charCodeAt(1)===p&&(a=C.slice(0,2),s=2,n>2&&e(C.charCodeAt(2))&&(o=!0,s=3));if(a.length>0)if(d.length>0){if(a.toLowerCase()!==d.toLowerCase())continue}else d=a;if(S){if(d.length>0)break}else if(w=`${C.slice(s)}\\${w}`,S=o,o&&d.length>0)break}return w=E(w,!S,"\\",e),S?`${d}\\${w}`:`${d}${w}`||"."},normalize(u){r(u,"path");const d=u.length;if(d===0)return".";let w=0,S,L=!1;const C=u.charCodeAt(0);if(d===1)return c(C)?"\\":u;if(e(C))if(L=!0,e(u.charCodeAt(1))){let s=2,a=s;for(;s<d&&!e(u.charCodeAt(s));)s++;if(s<d&&s!==a){const o=u.slice(a,s);for(a=s;s<d&&e(u.charCodeAt(s));)s++;if(s<d&&s!==a){for(a=s;s<d&&!e(u.charCodeAt(s));)s++;if(s===d)return`\\\\${o}\\${u.slice(a)}\\`;s!==a&&(S=`\\\\${o}\\${u.slice(a,s)}`,w=s)}}}else w=1;else g(C)&&u.charCodeAt(1)===p&&(S=u.slice(0,2),w=2,d>2&&e(u.charCodeAt(2))&&(L=!0,w=3));let n=w<d?E(u.slice(w),!L,"\\",e):"";return n.length===0&&!L&&(n="."),n.length>0&&e(u.charCodeAt(d-1))&&(n+="\\"),S===void 0?L?`\\${n}`:n:L?`${S}\\${n}`:`${S}${n}`},isAbsolute(u){r(u,"path");const d=u.length;if(d===0)return!1;const w=u.charCodeAt(0);return e(w)||d>2&&g(w)&&u.charCodeAt(1)===p&&e(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let d,w;for(let C=0;C<u.length;++C){const n=u[C];r(n,"path"),n.length>0&&(d===void 0?d=w=n:d+=`\\${n}`)}if(d===void 0)return".";let S=!0,L=0;if(typeof w=="string"&&e(w.charCodeAt(0))){++L;const C=w.length;C>1&&e(w.charCodeAt(1))&&(++L,C>2&&(e(w.charCodeAt(2))?++L:S=!1))}if(S){for(;L<d.length&&e(d.charCodeAt(L));)L++;L>=2&&(d=`\\${d.slice(L)}`)}return t.win32.normalize(d)},relative(u,d){if(r(u,"from"),r(d,"to"),u===d)return"";const w=t.win32.resolve(u),S=t.win32.resolve(d);if(w===S||(u=w.toLowerCase(),d=S.toLowerCase(),u===d))return"";let L=0;for(;L<u.length&&u.charCodeAt(L)===h;)L++;let C=u.length;for(;C-1>L&&u.charCodeAt(C-1)===h;)C--;const n=C-L;let s=0;for(;s<d.length&&d.charCodeAt(s)===h;)s++;let a=d.length;for(;a-1>s&&d.charCodeAt(a-1)===h;)a--;const o=a-s,v=n<o?n:o;let N=-1,K=0;for(;K<v;K++){const re=u.charCodeAt(L+K);if(re!==d.charCodeAt(s+K))break;re===h&&(N=K)}if(K!==v){if(N===-1)return S}else{if(o>v){if(d.charCodeAt(s+K)===h)return S.slice(s+K+1);if(K===2)return S.slice(s+K)}n>v&&(u.charCodeAt(L+K)===h?N=K:K===2&&(N=3)),N===-1&&(N=0)}let ne="";for(K=L+N+1;K<=C;++K)(K===C||u.charCodeAt(K)===h)&&(ne+=ne.length===0?"..":"\\..");return s+=N,ne.length>0?`${ne}${S.slice(s,a)}`:(S.charCodeAt(s)===h&&++s,S.slice(s,a))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const d=t.win32.resolve(u);if(d.length<=2)return u;if(d.charCodeAt(0)===h){if(d.charCodeAt(1)===h){const w=d.charCodeAt(2);if(w!==A&&w!==b)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(g(d.charCodeAt(0))&&d.charCodeAt(1)===p&&d.charCodeAt(2)===h)return`\\\\?\\${d}`;return u},dirname(u){r(u,"path");const d=u.length;if(d===0)return".";let w=-1,S=0;const L=u.charCodeAt(0);if(d===1)return e(L)?u:".";if(e(L)){if(w=S=1,e(u.charCodeAt(1))){let s=2,a=s;for(;s<d&&!e(u.charCodeAt(s));)s++;if(s<d&&s!==a){for(a=s;s<d&&e(u.charCodeAt(s));)s++;if(s<d&&s!==a){for(a=s;s<d&&!e(u.charCodeAt(s));)s++;if(s===d)return u;s!==a&&(w=S=s+1)}}}}else g(L)&&u.charCodeAt(1)===p&&(w=d>2&&e(u.charCodeAt(2))?3:2,S=w);let C=-1,n=!0;for(let s=d-1;s>=S;--s)if(e(u.charCodeAt(s))){if(!n){C=s;break}}else n=!1;if(C===-1){if(w===-1)return".";C=w}return u.slice(0,C)},basename(u,d){d!==void 0&&r(d,"ext"),r(u,"path");let w=0,S=-1,L=!0,C;if(u.length>=2&&g(u.charCodeAt(0))&&u.charCodeAt(1)===p&&(w=2),d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,s=-1;for(C=u.length-1;C>=w;--C){const a=u.charCodeAt(C);if(e(a)){if(!L){w=C+1;break}}else s===-1&&(L=!1,s=C+1),n>=0&&(a===d.charCodeAt(n)?--n==-1&&(S=C):(n=-1,S=s))}return w===S?S=s:S===-1&&(S=u.length),u.slice(w,S)}for(C=u.length-1;C>=w;--C)if(e(u.charCodeAt(C))){if(!L){w=C+1;break}}else S===-1&&(L=!1,S=C+1);return S===-1?"":u.slice(w,S)},extname(u){r(u,"path");let d=0,w=-1,S=0,L=-1,C=!0,n=0;u.length>=2&&u.charCodeAt(1)===p&&g(u.charCodeAt(0))&&(d=S=2);for(let s=u.length-1;s>=d;--s){const a=u.charCodeAt(s);if(e(a)){if(!C){S=s+1;break}continue}L===-1&&(C=!1,L=s+1),a===b?w===-1?w=s:n!==1&&(n=1):w!==-1&&(n=-1)}return w===-1||L===-1||n===0||n===1&&w===L-1&&w===S+1?"":u.slice(w,L)},format:_.bind(null,"\\"),parse(u){r(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const w=u.length;let S=0,L=u.charCodeAt(0);if(w===1)return e(L)?(d.root=d.dir=u,d):(d.base=d.name=u,d);if(e(L)){if(S=1,e(u.charCodeAt(1))){let N=2,K=N;for(;N<w&&!e(u.charCodeAt(N));)N++;if(N<w&&N!==K){for(K=N;N<w&&e(u.charCodeAt(N));)N++;if(N<w&&N!==K){for(K=N;N<w&&!e(u.charCodeAt(N));)N++;N===w?S=N:N!==K&&(S=N+1)}}}}else if(g(L)&&u.charCodeAt(1)===p){if(w<=2)return d.root=d.dir=u,d;if(S=2,e(u.charCodeAt(2))){if(w===3)return d.root=d.dir=u,d;S=3}}S>0&&(d.root=u.slice(0,S));let C=-1,n=S,s=-1,a=!0,o=u.length-1,v=0;for(;o>=S;--o){if(L=u.charCodeAt(o),e(L)){if(!a){n=o+1;break}continue}s===-1&&(a=!1,s=o+1),L===b?C===-1?C=o:v!==1&&(v=1):C!==-1&&(v=-1)}return s!==-1&&(C===-1||v===0||v===1&&C===s-1&&C===n+1?d.base=d.name=u.slice(n,s):(d.name=u.slice(n,C),d.base=u.slice(n,s),d.ext=u.slice(C,s))),n>0&&n!==S?d.dir=u.slice(0,n-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...u){let d="",w=!1;for(let S=u.length-1;S>=-1&&!w;S--){const L=S>=0?u[S]:D.cwd();r(L,"path"),L.length!==0&&(d=`${L}/${d}`,w=L.charCodeAt(0)===m)}return d=E(d,!w,"/",c),w?`/${d}`:d.length>0?d:"."},normalize(u){if(r(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===m,w=u.charCodeAt(u.length-1)===m;return u=E(u,!d,"/",c),u.length===0?d?"/":w?"./":".":(w&&(u+="/"),d?`/${u}`:u)},isAbsolute(u){return r(u,"path"),u.length>0&&u.charCodeAt(0)===m},join(...u){if(u.length===0)return".";let d;for(let w=0;w<u.length;++w){const S=u[w];r(S,"path"),S.length>0&&(d===void 0?d=S:d+=`/${S}`)}return d===void 0?".":t.posix.normalize(d)},relative(u,d){if(r(u,"from"),r(d,"to"),u===d||(u=t.posix.resolve(u),d=t.posix.resolve(d),u===d))return"";const w=1,S=u.length,L=S-w,C=1,n=d.length-C,s=L<n?L:n;let a=-1,o=0;for(;o<s;o++){const N=u.charCodeAt(w+o);if(N!==d.charCodeAt(C+o))break;N===m&&(a=o)}if(o===s)if(n>s){if(d.charCodeAt(C+o)===m)return d.slice(C+o+1);if(o===0)return d.slice(C+o)}else L>s&&(u.charCodeAt(w+o)===m?a=o:o===0&&(a=0));let v="";for(o=w+a+1;o<=S;++o)(o===S||u.charCodeAt(o)===m)&&(v+=v.length===0?"..":"/..");return`${v}${d.slice(C+a)}`},toNamespacedPath(u){return u},dirname(u){if(r(u,"path"),u.length===0)return".";const d=u.charCodeAt(0)===m;let w=-1,S=!0;for(let L=u.length-1;L>=1;--L)if(u.charCodeAt(L)===m){if(!S){w=L;break}}else S=!1;return w===-1?d?"/":".":d&&w===1?"//":u.slice(0,w)},basename(u,d){d!==void 0&&r(d,"ext"),r(u,"path");let w=0,S=-1,L=!0,C;if(d!==void 0&&d.length>0&&d.length<=u.length){if(d===u)return"";let n=d.length-1,s=-1;for(C=u.length-1;C>=0;--C){const a=u.charCodeAt(C);if(a===m){if(!L){w=C+1;break}}else s===-1&&(L=!1,s=C+1),n>=0&&(a===d.charCodeAt(n)?--n==-1&&(S=C):(n=-1,S=s))}return w===S?S=s:S===-1&&(S=u.length),u.slice(w,S)}for(C=u.length-1;C>=0;--C)if(u.charCodeAt(C)===m){if(!L){w=C+1;break}}else S===-1&&(L=!1,S=C+1);return S===-1?"":u.slice(w,S)},extname(u){r(u,"path");let d=-1,w=0,S=-1,L=!0,C=0;for(let n=u.length-1;n>=0;--n){const s=u.charCodeAt(n);if(s===m){if(!L){w=n+1;break}continue}S===-1&&(L=!1,S=n+1),s===b?d===-1?d=n:C!==1&&(C=1):d!==-1&&(C=-1)}return d===-1||S===-1||C===0||C===1&&d===S-1&&d===w+1?"":u.slice(d,S)},format:_.bind(null,"/"),parse(u){r(u,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return d;const w=u.charCodeAt(0)===m;let S;w?(d.root="/",S=1):S=0;let L=-1,C=0,n=-1,s=!0,a=u.length-1,o=0;for(;a>=S;--a){const v=u.charCodeAt(a);if(v===m){if(!s){C=a+1;break}continue}n===-1&&(s=!1,n=a+1),v===b?L===-1?L=a:o!==1&&(o=1):L!==-1&&(o=-1)}if(n!==-1){const v=C===0&&w?1:C;L===-1||o===0||o===1&&L===n-1&&L===C+1?d.base=d.name=u.slice(v,n):(d.name=u.slice(v,L),d.base=u.slice(v,n),d.ext=u.slice(L,n))}return C>0?d.dir=u.slice(0,C-1):w&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=D.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=D.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=D.platform==="win32"?t.win32.join:t.posix.join,t.resolve=D.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=D.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=D.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=D.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=D.platform==="win32"?t.win32.extname:t.posix.extname,t.format=D.platform==="win32"?t.win32.format:t.posix.format,t.parse=D.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=D.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=D.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=D.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(me[105],pe([1,0,21]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},P={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function M(p){const A=(0,D.extname)(p),l=i[A.toLowerCase()];return l!==void 0?l:y(p)}t.getMediaOrTextMime=M;function y(p){const A=(0,D.extname)(p);return P[A.toLowerCase()]}t.getMediaMime=y;function b(p){for(const A in P)if(P[A]===p)return A}t.getExtensionForMimeType=b;const m=/^(.+)\/(.+?)(;.+)?$/;function h(p,A){const l=m.exec(p);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:A?void 0:p}t.normalizeMimeType=h}),define(me[106],pe([1,0,5]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=D.globals.performance&&typeof D.globals.performance.now=="function";class P{constructor(y){this._highResolution=i&&y,this._startTime=this._now(),this._stopTime=-1}static create(y=!0){return new P(y)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}t.StopWatch=P}),define(me[3],pe([1,0,13,42,2,74,106]),function(Q,t,D,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;const b=!1,m=!1;var h;(function(a){a.None=()=>P.Disposable.None;function o(f){if(m){const{onListenerDidAdd:I}=f,U=e.create();let q=0;f.onListenerDidAdd=()=>{++q==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),I?.()}}}function v(f){return(I,U=null,q)=>{let W=!1,O;return O=f(H=>{if(!W)return O?O.dispose():W=!0,I.call(U,H)},null,q),W&&O.dispose(),O}}a.once=v;function N(f,I,U){return ve((q,W=null,O)=>f(H=>q.call(W,I(H)),null,O),U)}a.map=N;function K(f,I,U){return ve((q,W=null,O)=>f(H=>{I(H),q.call(W,H)},null,O),U)}a.forEach=K;function ne(f,I,U){return ve((q,W=null,O)=>f(H=>I(H)&&q.call(W,H),null,O),U)}a.filter=ne;function re(f){return f}a.signal=re;function we(...f){return(I,U=null,q)=>(0,P.combinedDisposable)(...f.map(W=>W(O=>I.call(U,O),null,q)))}a.any=we;function ae(f,I,U,q){let W=U;return N(f,O=>(W=I(W,O),W),q)}a.reduce=ae;function ve(f,I){let U;const q={onFirstListenerAdd(){U=f(W.fire,W)},onLastListenerRemove(){U?.dispose()}};I||o(q);const W=new g(q);return I?.add(W),W.event}function fe(f,I,U=100,q=!1,W,O){let H,V,F,z=0;const k={leakWarningThreshold:W,onFirstListenerAdd(){H=f(j=>{z++,V=I(V,j),q&&!F&&(B.fire(V),V=void 0),clearTimeout(F),F=setTimeout(()=>{const J=V;V=void 0,F=void 0,(!q||z>1)&&B.fire(J),z=0},U)})},onLastListenerRemove(){H.dispose()}};O||o(k);const B=new g(k);return O?.add(B),B.event}a.debounce=fe;function ge(f,I=(q,W)=>q===W,U){let q=!0,W;return ne(f,O=>{const H=q||!I(O,W);return q=!1,W=O,H},U)}a.latch=ge;function ye(f,I,U){return[a.filter(f,I,U),a.filter(f,q=>!I(q),U)]}a.split=ye;function ee(f,I=!1,U=[]){let q=U.slice(),W=f(V=>{q?q.push(V):H.fire(V)});const O=()=>{q?.forEach(V=>H.fire(V)),q=null},H=new g({onFirstListenerAdd(){W||(W=f(V=>H.fire(V)))},onFirstListenerDidAdd(){q&&(I?setTimeout(O):O())},onLastListenerRemove(){W&&W.dispose(),W=null}});return H.event}a.buffer=ee;class he{constructor(I){this.event=I,this.disposables=new P.DisposableStore}map(I){return new he(N(this.event,I,this.disposables))}forEach(I){return new he(K(this.event,I,this.disposables))}filter(I){return new he(ne(this.event,I,this.disposables))}reduce(I,U){return new he(ae(this.event,I,U,this.disposables))}latch(){return new he(ge(this.event,void 0,this.disposables))}debounce(I,U=100,q=!1,W){return new he(fe(this.event,I,U,q,W,this.disposables))}on(I,U,q){return this.event(I,U,q)}once(I,U,q){return v(this.event)(I,U,q)}dispose(){this.disposables.dispose()}}function te(f){return new he(f)}a.chain=te;function Z(f,I,U=q=>q){const q=(...V)=>H.fire(U(...V)),W=()=>f.on(I,q),O=()=>f.removeListener(I,q),H=new g({onFirstListenerAdd:W,onLastListenerRemove:O});return H.event}a.fromNodeEventEmitter=Z;function se(f,I,U=q=>q){const q=(...V)=>H.fire(U(...V)),W=()=>f.addEventListener(I,q),O=()=>f.removeEventListener(I,q),H=new g({onFirstListenerAdd:W,onLastListenerRemove:O});return H.event}a.fromDOMEventEmitter=se;function ie(f){return new Promise(I=>v(f)(I))}a.toPromise=ie;function T(f,I){return I(void 0),f(U=>I(U))}a.runAndSubscribe=T;function $(f,I){let U=null;function q(O){U?.dispose(),U=new P.DisposableStore,I(O,U)}q(void 0);const W=f(O=>q(O));return(0,P.toDisposable)(()=>{W.dispose(),U?.dispose()})}a.runAndSubscribeWithStore=$;class X{constructor(I,U){this.obs=I,this._counter=0,this._hasChanged=!1;const q={onFirstListenerAdd:()=>{I.addObserver(this)},onLastListenerRemove:()=>{I.removeObserver(this)}};U||o(q),this.emitter=new g(q),U&&U.add(this.emitter)}beginUpdate(I){this._counter++}handleChange(I,U){this._hasChanged=!0}endUpdate(I){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function R(f,I){return new X(f,I).emitter.event}a.fromObservable=R})(h=t.Event||(t.Event={}));class p{constructor(o){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${o}_${p._idPool++}`}start(o){this._stopWatch=new y.StopWatch(!0),this._listenerCount=o}stop(){if(this._stopWatch){const o=this._stopWatch.elapsed();this._elapsedOverall+=o,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${o.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}p._idPool=0;let A=-1;function l(a){const o=A;return A=a,{dispose(){A=o}}}t.setGlobalLeakWarningThreshold=l;class r{constructor(o,v=Math.random().toString(18).slice(2,5)){this.customThreshold=o,this.name=v,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(o,v){let N=A;if(typeof this.customThreshold=="number"&&(N=this.customThreshold),N<=0||v<N)return;this._stacks||(this._stacks=new Map);const K=this._stacks.get(o.value)||0;if(this._stacks.set(o.value,K+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=N*.5;let ne,re=0;for(const[we,ae]of this._stacks)(!ne||re<ae)&&(ne=we,re=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${v} listeners already. MOST frequent listener (${re}):`),console.warn(ne)}return()=>{const ne=this._stacks.get(o.value)||0;this._stacks.set(o.value,ne-1)}}}class e{constructor(o){this.value=o}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class c{constructor(o,v,N){this.callback=o,this.callbackThis=v,this.stack=N,this.subscription=new P.SafeDisposable}invoke(o){this.callback.call(this.callbackThis,o)}}class g{constructor(o){this._disposed=!1,this._options=o,this._leakageMon=A>0?new r(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new p(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const o=Array.from(this._listeners);queueMicrotask(()=>{for(const v of o)v.subscription.isset()&&(v.subscription.unset(),v.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(o,v,N)=>{this._listeners||(this._listeners=new M.LinkedList);const K=this._listeners.isEmpty();K&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let ne,re;this._leakageMon&&this._listeners.size>=30&&(re=e.create(),ne=this._leakageMon.check(re,this._listeners.size+1)),b&&(re=re??e.create());const we=new c(o,v,re),ae=this._listeners.push(we);K&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,o,v);const ve=we.subscription.set(()=>{ne?.(),this._disposed||(ae(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return N instanceof P.DisposableStore?N.add(ve):Array.isArray(N)&&N.push(ve),ve}),this._event}fire(o){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new _);for(const v of this._listeners)this._deliveryQueue.push(this,v,o);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=g;class E{constructor(){this._queue=new M.LinkedList}get size(){return this._queue.size}push(o,v,N){this._queue.push(new u(o,v,N))}clear(o){const v=new M.LinkedList;for(const N of this._queue)N.emitter!==o&&v.push(N);this._queue=v}deliver(){for(;this._queue.size>0;){const o=this._queue.shift();try{o.listener.invoke(o.event)}catch(v){(0,D.onUnexpectedError)(v)}}}}t.EventDeliveryQueue=E;class _ extends E{clear(o){this._queue.clear()}}class u{constructor(o,v,N){this.emitter=o,this.listener=v,this.event=N}}class d extends g{async fireAsync(o,v,N){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const K of this._listeners)this._asyncDeliveryQueue.push([K,o]);for(;this._asyncDeliveryQueue.size>0&&!v.isCancellationRequested;){const[K,ne]=this._asyncDeliveryQueue.shift(),re=[],we={...ne,token:v,waitUntil:ae=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");N&&(ae=N(ae,K.callback)),re.push(ae)}};try{K.invoke(we)}catch(ae){(0,D.onUnexpectedError)(ae);continue}Object.freeze(re),await Promise.allSettled(re).then(ae=>{for(const ve of ae)ve.status==="rejected"&&(0,D.onUnexpectedError)(ve.reason)})}}}}t.AsyncEmitter=d;class w extends g{constructor(o){super(o);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=o?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const o=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(o))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(o){this._listeners&&(this._isPaused!==0?this._eventQueue.push(o):super.fire(o))}}t.PauseableEmitter=w;class S extends w{constructor(o){super(o);this._delay=o.delay??100}fire(o){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(o)}}t.DebounceEmitter=S;class L extends g{constructor(o){super(o);this._queuedEvents=[],this._mergeFn=o?.merge}fire(o){this._queuedEvents.push(o),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(v=>super.fire(v)),this._queuedEvents=[]})}}t.MicrotaskEmitter=L;class C{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new g({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(o){const v={event:o,listener:null};this.events.push(v),this.hasListeners&&this.hook(v);const N=()=>{this.hasListeners&&this.unhook(v);const K=this.events.indexOf(v);this.events.splice(K,1)};return(0,P.toDisposable)((0,i.once)(N))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(o=>this.hook(o))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(o=>this.unhook(o))}hook(o){o.listener=o.event(v=>this.emitter.fire(v))}unhook(o){o.listener&&o.listener.dispose(),o.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=C;class n{constructor(){this.buffers=[]}wrapEvent(o){return(v,N,K)=>o(ne=>{const re=this.buffers[this.buffers.length-1];re?re.push(()=>v.call(N,ne)):v.call(N,ne)},void 0,K)}bufferEvents(o){const v=[];this.buffers.push(v);const N=o();return this.buffers.pop(),v.forEach(K=>K()),N}}t.EventBufferer=n;class s{constructor(){this.listening=!1,this.inputEvent=h.None,this.inputEventListener=P.Disposable.None,this.emitter=new g({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(o){this.inputEvent=o,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=o(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=s}),define(me[15],pe([1,0,3,2]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class P{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new D.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(u,d){this._zoomLevel!==u&&(this._zoomLevel=u)}getZoomFactor(){return this._zoomFactor}setZoomFactor(u){this._zoomFactor=u}setFullscreen(u){this._fullscreen!==u&&(this._fullscreen=u,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}P.INSTANCE=new P;class M extends i.Disposable{constructor(){super();this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(u){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),u&&this._onDidChange.fire()}}class y extends i.Disposable{constructor(){super();this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const u=this._register(new M);this._register(u.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}get value(){return this._value}_getPixelRatio(){const u=document.createElement("canvas").getContext("2d"),d=window.devicePixelRatio||1,w=u.webkitBackingStorePixelRatio||u.mozBackingStorePixelRatio||u.msBackingStorePixelRatio||u.oBackingStorePixelRatio||u.backingStorePixelRatio||1;return d/w}}class b{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new y)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function m(_,u){typeof _=="string"&&(_=window.matchMedia(_)),_.addEventListener("change",u)}t.addMatchMediaChangeListener=m,t.PixelRatio=new b;function h(_,u){P.INSTANCE.setZoomLevel(_,u)}t.setZoomLevel=h;function p(){return P.INSTANCE.getZoomLevel()}t.getZoomLevel=p;function A(){return P.INSTANCE.getZoomFactor()}t.getZoomFactor=A;function l(_){P.INSTANCE.setZoomFactor(_)}t.setZoomFactor=l;function r(_){P.INSTANCE.setFullscreen(_)}t.setFullscreen=r;function e(){return P.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=P.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.isFirefox=c.indexOf("Firefox")>=0,t.isWebKit=c.indexOf("AppleWebKit")>=0,t.isChrome=c.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&c.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=c.indexOf("Electron/")>=0,t.isAndroid=c.indexOf("Android")>=0;let g=!1;if(window.matchMedia){const _=window.matchMedia("(display-mode: standalone)"),u=window.matchMedia("(display-mode: fullscreen)");g=_.matches,m(_,({matches:d})=>{g&&u.matches||(g=d)})}function E(){return g}t.isStandalone=E}),define(me[107],pe([1,0,15,5]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var P;(function(M){M[M.Always=0]="Always",M[M.FullScreen=1]="FullScreen",M[M.None=2]="None"})(P=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||D.isStandalone()?0:navigator.keyboard||D.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[18],pe([1,0,3]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stop=t.stopEvent=t.DomEmitter=void 0;class i{constructor(b,m,h){const p=A=>this.emitter.fire(A);this.emitter=new D.Emitter({onFirstListenerAdd:()=>b.addEventListener(m,p,h),onLastListenerRemove:()=>b.removeEventListener(m,p,h)})}get event(){return this.emitter.event}dispose(){this.emitter.dispose()}}t.DomEmitter=i;function P(y){return y.preventDefault(),y.stopPropagation(),y}t.stopEvent=P;function M(y){return D.Event.map(y,P)}t.stop=M}),define(me[19],pe([1,0,15,43,72,5]),function(Q,t,D,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function y(e){if(e.charCode){const g=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(g)}const c=e.keyCode;if(c===3)return 7;if(D.isFirefox){if(c===59)return 80;if(c===107)return 81;if(c===109)return 83;if(M.isMacintosh&&c===224)return 57}else if(D.isWebKit){if(c===91)return 57;if(M.isMacintosh&&c===93)return 57;if(!M.isMacintosh&&c===92)return 57}return i.EVENT_KEY_CODE_MAP[c]||0}const b=M.isMacintosh?256:2048,m=512,h=1024,p=M.isMacintosh?2048:256;function A(e){const c=[];return e.ctrlKey&&c.push("ctrl"),e.shiftKey&&c.push("shift"),e.altKey&&c.push("alt"),e.metaKey&&c.push("meta"),`modifiers: [${c.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=A;function l(e){const c=[];return e.ctrlKey&&c.push("ctrl"),e.shiftKey&&c.push("shift"),e.altKey&&c.push("alt"),e.metaKey&&c.push("meta"),`modifiers: [${c.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=l;class r{constructor(c){this._standardKeyboardEventBrand=!0;const g=c;this.browserEvent=g,this.target=g.target,this.ctrlKey=g.ctrlKey,this.shiftKey=g.shiftKey,this.altKey=g.altKey,this.metaKey=g.metaKey,this.keyCode=y(g),this.code=g.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(c){return this._asKeybinding===c}_computeKeybinding(){let c=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(c=this.keyCode);let g=0;return this.ctrlKey&&(g|=b),this.altKey&&(g|=m),this.shiftKey&&(g|=h),this.metaKey&&(g|=p),g|=c,g}_computeRuntimeKeybinding(){let c=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(c=this.keyCode),new P.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,c)}}t.StandardKeyboardEvent=r}),define(me[20],pe([1,0,15,65,5]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class M{constructor(h){this.timestamp=Date.now(),this.browserEvent=h,this.leftButton=h.button===0,this.middleButton=h.button===1,this.rightButton=h.button===2,this.buttons=h.buttons,this.target=h.target,this.detail=h.detail||1,h.type==="dblclick"&&(this.detail=2),this.ctrlKey=h.ctrlKey,this.shiftKey=h.shiftKey,this.altKey=h.altKey,this.metaKey=h.metaKey,typeof h.pageX=="number"?(this.posx=h.pageX,this.posy=h.pageY):(this.posx=h.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=h.clientY+document.body.scrollTop+document.documentElement.scrollTop);const p=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,h.view);this.posx-=p.left,this.posy-=p.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=M;class y extends M{constructor(h){super(h);this.dataTransfer=h.dataTransfer}}t.DragMouseEvent=y;class b{constructor(h,p=0,A=0){if(this.browserEvent=h||null,this.target=h?h.target||h.targetNode||h.srcElement:null,this.deltaY=A,this.deltaX=p,h){const l=h,r=h;if(typeof l.wheelDeltaY!="undefined")this.deltaY=l.wheelDeltaY/120;else if(typeof r.VERTICAL_AXIS!="undefined"&&r.axis===r.VERTICAL_AXIS)this.deltaY=-r.detail/3;else if(h.type==="wheel"){const e=h;e.deltaMode===e.DOM_DELTA_LINE?D.isFirefox&&!P.isMacintosh?this.deltaY=-h.deltaY/3:this.deltaY=-h.deltaY:this.deltaY=-h.deltaY/40}if(typeof l.wheelDeltaX!="undefined")D.isSafari&&P.isWindows?this.deltaX=-(l.wheelDeltaX/120):this.deltaX=l.wheelDeltaX/120;else if(typeof r.HORIZONTAL_AXIS!="undefined"&&r.axis===r.HORIZONTAL_AXIS)this.deltaX=-h.detail/3;else if(h.type==="wheel"){const e=h;e.deltaMode===e.DOM_DELTA_LINE?D.isFirefox&&!P.isMacintosh?this.deltaX=-h.deltaX/3:this.deltaX=-h.deltaX:this.deltaX=-h.deltaX/40}this.deltaY===0&&this.deltaX===0&&h.wheelDelta&&(this.deltaY=h.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=b}),define(me[32],pe([1,0,3,2,102]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class M extends i.Disposable{constructor(l,r="",e="",c=!0,g){super();this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=l,this._label=r,this._cssClass=e,this._enabled=c,this._actionCallback=g}get id(){return this._id}get label(){return this._label}set label(l){this._setLabel(l)}_setLabel(l){this._label!==l&&(this._label=l,this._onDidChange.fire({label:l}))}get tooltip(){return this._tooltip||""}set tooltip(l){this._setTooltip(l)}_setTooltip(l){this._tooltip!==l&&(this._tooltip=l,this._onDidChange.fire({tooltip:l}))}get class(){return this._cssClass}set class(l){this._setClass(l)}_setClass(l){this._cssClass!==l&&(this._cssClass=l,this._onDidChange.fire({class:l}))}get enabled(){return this._enabled}set enabled(l){this._setEnabled(l)}_setEnabled(l){this._enabled!==l&&(this._enabled=l,this._onDidChange.fire({enabled:l}))}get checked(){return this._checked}set checked(l){this._setChecked(l)}_setChecked(l){this._checked!==l&&(this._checked=l,this._onDidChange.fire({checked:l}))}async run(l,r){this._actionCallback&&await this._actionCallback(l)}}t.Action=M;class y extends i.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new D.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new D.Emitter),this.onDidRun=this._onDidRun.event}async run(l,r){if(!l.enabled)return;this._onBeforeRun.fire({action:l});let e;try{await this.runAction(l,r)}catch(c){e=c}this._onDidRun.fire({action:l,error:e})}async runAction(l,r){await l.run(r)}}t.ActionRunner=y;class b extends M{constructor(l){super(b.ID,l,l?"separator text":"separator");this.checked=!1,this.enabled=!1}static join(...l){let r=[];for(const e of l)e.length&&(r.length?r=[...r,new b,...e]:r=e);return r}}t.Separator=b,b.ID="vs.actions.separator";class m{constructor(l,r,e,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=r,this.class=c,this._actions=e}get actions(){return this._actions}dispose(){}async run(){}}t.SubmenuAction=m;class h extends M{constructor(){super(h.ID,P.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=h,h.ID="vs.actions.empty";function p(A){return{id:A.id,label:A.label,class:void 0,enabled:A.enabled??!0,checked:A.checked??!1,run:async()=>A.run(),tooltip:A.label,dispose:()=>{}}}t.toAction=p}),define(me[28],pe([1,0,3]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(b,m){const h=setTimeout(b.bind(m),0);return{dispose(){clearTimeout(h)}}});var P;(function(b){function m(h){return h===b.None||h===b.Cancelled||h instanceof M?!0:!h||typeof h!="object"?!1:typeof h.isCancellationRequested=="boolean"&&typeof h.onCancellationRequested=="function"}b.isCancellationToken=m,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(P=t.CancellationToken||(t.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class y{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=P.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=P.None}}t.CancellationTokenSource=y}),define(me[108],pe([1,0,28]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new D.CancellationTokenSource,m=this.task(b.token);return this.result={promise:m,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}t.Cache=i;class P{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const m=JSON.stringify(b);return this.lastArgKey!==m&&(this.lastArgKey=m,this.lastCache=this.fn(b)),this.lastCache}}t.LRUCachedFunction=P;class M{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const m=this.fn(b);return this._map.set(b,m),m}}t.CachedFunction=M}),define(me[47],pe([1,0,3,2]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var P;(function(r){r[r.Auto=1]="Auto",r[r.Hidden=2]="Hidden",r[r.Visible=3]="Visible"})(P=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class M{constructor(e,c,g,E,_,u,d){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(c=c|0,g=g|0,E=E|0,_=_|0,u=u|0,d=d|0),this.rawScrollLeft=E,this.rawScrollTop=d,c<0&&(c=0),E+c>g&&(E=g-c),E<0&&(E=0),_<0&&(_=0),d+_>u&&(d=u-_),d<0&&(d=0),this.width=c,this.scrollWidth=g,this.scrollLeft=E,this.height=_,this.scrollHeight=u,this.scrollTop=d}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,c){return new M(this._forceIntegerValues,typeof e.width!="undefined"?e.width:this.width,typeof e.scrollWidth!="undefined"?e.scrollWidth:this.scrollWidth,c?this.rawScrollLeft:this.scrollLeft,typeof e.height!="undefined"?e.height:this.height,typeof e.scrollHeight!="undefined"?e.scrollHeight:this.scrollHeight,c?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new M(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft!="undefined"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop!="undefined"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,c){const g=this.width!==e.width,E=this.scrollWidth!==e.scrollWidth,_=this.scrollLeft!==e.scrollLeft,u=this.height!==e.height,d=this.scrollHeight!==e.scrollHeight,w=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:c,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:g,scrollWidthChanged:E,scrollLeftChanged:_,heightChanged:u,scrollHeightChanged:d,scrollTopChanged:w}}}t.ScrollState=M;class y extends i.Disposable{constructor(e){super();this._scrollableBrand=void 0,this._onScroll=this._register(new D.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new M(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,c){const g=this._state.withScrollDimensions(e,c);this._setState(g,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const c=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(c,!1)}setScrollPositionSmooth(e,c){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft=="undefined"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop=="undefined"?this._smoothScrolling.to.scrollTop:e.scrollTop};const g=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===g.scrollLeft&&this._smoothScrolling.to.scrollTop===g.scrollTop)return;let E;c?E=new p(this._smoothScrolling.from,g,this._smoothScrolling.startTime,this._smoothScrolling.duration):E=this._smoothScrolling.combine(this._state,g,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=E}else{const g=this._state.withScrollPosition(e);this._smoothScrolling=p.start(this._state,g,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),c=this._state.withScrollPosition(e);if(this._setState(c,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,c){const g=this._state;g.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(g,c)))}}t.Scrollable=y;class b{constructor(e,c,g){this.scrollLeft=e,this.scrollTop=c,this.isDone=g}}t.SmoothScrollingUpdate=b;function m(r,e){const c=e-r;return function(g){return r+c*l(g)}}function h(r,e,c){return function(g){return g<c?r(g/c):e((g-c)/(1-c))}}class p{constructor(e,c,g,E){this.from=e,this.to=c,this.duration=E,this.startTime=g,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,c,g){if(Math.abs(e-c)>2.5*g){let _,u;return e<c?(_=e+.75*g,u=c-.75*g):(_=e-.75*g,u=c+.75*g),h(m(e,_),m(u,c),.33)}return m(e,c)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const c=(e-this.startTime)/this.duration;if(c<1){const g=this.scrollLeft(c),E=this.scrollTop(c);return new b(g,E,!1)}return new b(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,c,g){return p.start(e,c,g)}static start(e,c,g){g=g+10;const E=Date.now()-10;return new p(e,c,E,g)}}t.SmoothScrollingOperation=p;function A(r){return Math.pow(r,3)}function l(r){return 1-A(1-r)}}),define(me[10],pe([1,0,108,73]),function(Q,t,D,i){"use strict";var P;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function M(x){return!x||typeof x!="string"?!0:x.trim().length===0}t.isFalsyOrWhitespace=M;const y=/{(\d+)}/g;function b(x,...oe){return oe.length===0?x:x.replace(y,function(be,Ce){const Fe=parseInt(Ce,10);return isNaN(Fe)||Fe<0||Fe>=oe.length?be:oe[Fe]})}t.format=b;const m=/{([^}]+)}/g;function h(x,oe){return x.replace(m,(be,Ce)=>oe[Ce]??be)}t.format2=h;function p(x){return x.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=p;function A(x){return x.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=A;function l(x,oe){let be=0;const Ce=oe.charCodeAt(0);for(let Fe=x.length-1;Fe>=0;Fe--)x.charCodeAt(Fe)===Ce&&be++;return be}t.count=l;function r(x,oe,be="\u2026"){return x.length<=oe?x:`${x.substr(0,oe)}${be}`}t.truncate=r;function e(x,oe=" "){const be=c(x,oe);return g(be,oe)}t.trim=e;function c(x,oe){if(!x||!oe)return x;const be=oe.length;if(be===0||x.length===0)return x;let Ce=0;for(;x.indexOf(oe,Ce)===Ce;)Ce=Ce+be;return x.substring(Ce)}t.ltrim=c;function g(x,oe){if(!x||!oe)return x;const be=oe.length,Ce=x.length;if(be===0||Ce===0)return x;let Fe=Ce,Re=-1;for(;Re=x.lastIndexOf(oe,Fe-1),!(Re===-1||Re+be!==Fe);){if(Re===0)return"";Fe=Re}return x.substring(0,Fe)}t.rtrim=g;function E(x){return x.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=E;function _(x){return x.replace(/\*/g,"")}t.stripWildcards=_;function u(x,oe,be={}){if(!x)throw new Error("Cannot create regex from empty string");oe||(x=A(x)),be.wholeWord&&(/\B/.test(x.charAt(0))||(x="\\b"+x),/\B/.test(x.charAt(x.length-1))||(x=x+"\\b"));let Ce="";return be.global&&(Ce+="g"),be.matchCase||(Ce+="i"),be.multiline&&(Ce+="m"),be.unicode&&(Ce+="u"),new RegExp(x,Ce)}t.createRegExp=u;function d(x){return x.source==="^"||x.source==="^$"||x.source==="$"||x.source==="^\\s*$"?!1:!!(x.exec("")&&x.lastIndex===0)}t.regExpLeadsToEndlessLoop=d;function w(x){return!!x.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=w;function S(x){return(x.global?"g":"")+(x.ignoreCase?"i":"")+(x.multiline?"m":"")+(x.unicode?"u":"")}t.regExpFlags=S;function L(x){return x.split(/\r\n|\r|\n/)}t.splitLines=L;function C(x){for(let oe=0,be=x.length;oe<be;oe++){const Ce=x.charCodeAt(oe);if(Ce!==32&&Ce!==9)return oe}return-1}t.firstNonWhitespaceIndex=C;function n(x,oe=0,be=x.length){for(let Ce=oe;Ce<be;Ce++){const Fe=x.charCodeAt(Ce);if(Fe!==32&&Fe!==9)return x.substring(oe,Ce)}return x.substring(oe,be)}t.getLeadingWhitespace=n;function s(x,oe=x.length-1){for(let be=oe;be>=0;be--){const Ce=x.charCodeAt(be);if(Ce!==32&&Ce!==9)return be}return-1}t.lastNonWhitespaceIndex=s;function a(x,oe,be){const Ce=[];let Fe=0;for(const Re of x.matchAll(oe)){if(Ce.push(x.slice(Fe,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Fe=Re.index+Re[0].length,Ce.push(be(Re[0],...Re.slice(1),Re.index,x,Re.groups))}return Ce.push(x.slice(Fe)),Promise.all(Ce).then(Re=>Re.join(""))}t.replaceAsync=a;function o(x,oe){return x<oe?-1:x>oe?1:0}t.compare=o;function v(x,oe,be=0,Ce=x.length,Fe=0,Re=oe.length){for(;be<Ce&&Fe<Re;be++,Fe++){const Xe=x.charCodeAt(be),qe=oe.charCodeAt(Fe);if(Xe<qe)return-1;if(Xe>qe)return 1}const Ve=Ce-be,tt=Re-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstring=v;function N(x,oe){return K(x,oe,0,x.length,0,oe.length)}t.compareIgnoreCase=N;function K(x,oe,be=0,Ce=x.length,Fe=0,Re=oe.length){for(;be<Ce&&Fe<Re;be++,Fe++){let Xe=x.charCodeAt(be),qe=oe.charCodeAt(Fe);if(Xe===qe)continue;if(Xe>=128||qe>=128)return v(x.toLowerCase(),oe.toLowerCase(),be,Ce,Fe,Re);re(Xe)&&(Xe-=32),re(qe)&&(qe-=32);const Le=Xe-qe;if(Le!==0)return Le}const Ve=Ce-be,tt=Re-Fe;return Ve<tt?-1:Ve>tt?1:0}t.compareSubstringIgnoreCase=K;function ne(x){return x>=48&&x<=57}t.isAsciiDigit=ne;function re(x){return x>=97&&x<=122}t.isLowerAsciiLetter=re;function we(x){return x>=65&&x<=90}t.isUpperAsciiLetter=we;function ae(x,oe){return x.length===oe.length&&K(x,oe)===0}t.equalsIgnoreCase=ae;function ve(x,oe){const be=oe.length;return oe.length>x.length?!1:K(x,oe,0,be)===0}t.startsWithIgnoreCase=ve;function fe(x,oe){const be=Math.min(x.length,oe.length);let Ce;for(Ce=0;Ce<be;Ce++)if(x.charCodeAt(Ce)!==oe.charCodeAt(Ce))return Ce;return be}t.commonPrefixLength=fe;function ge(x,oe){const be=Math.min(x.length,oe.length);let Ce;const Fe=x.length-1,Re=oe.length-1;for(Ce=0;Ce<be;Ce++)if(x.charCodeAt(Fe-Ce)!==oe.charCodeAt(Re-Ce))return Ce;return be}t.commonSuffixLength=ge;function ye(x){return 55296<=x&&x<=56319}t.isHighSurrogate=ye;function ee(x){return 56320<=x&&x<=57343}t.isLowSurrogate=ee;function he(x,oe){return(x-55296<<10)+(oe-56320)+65536}t.computeCodePoint=he;function te(x,oe,be){const Ce=x.charCodeAt(be);if(ye(Ce)&&be+1<oe){const Fe=x.charCodeAt(be+1);if(ee(Fe))return he(Ce,Fe)}return Ce}t.getNextCodePoint=te;function Z(x,oe){const be=x.charCodeAt(oe-1);if(ee(be)&&oe>1){const Ce=x.charCodeAt(oe-2);if(ye(Ce))return he(Ce,be)}return be}class se{constructor(oe,be=0){this._str=oe,this._len=oe.length,this._offset=be}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=Z(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=te(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=se;class ie{constructor(oe,be=0){this._iterator=new se(oe,be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ce=be.offset;let Fe=oe.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,Ve=oe.getGraphemeBreakType(be.nextCodePoint());if(Ie(Fe,Ve)){be.setOffset(Re);break}Fe=Ve}return be.offset-Ce}prevGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ce=be.offset;let Fe=oe.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,Ve=oe.getGraphemeBreakType(be.prevCodePoint());if(Ie(Ve,Fe)){be.setOffset(Re);break}Fe=Ve}return Ce-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ie;function T(x,oe){return new ie(x,oe).nextGraphemeLength()}t.nextCharLength=T;function $(x,oe){return new ie(x,oe).prevGraphemeLength()}t.prevCharLength=$;function X(x,oe){oe>0&&ee(x.charCodeAt(oe))&&oe--;const be=oe+T(x,oe);return[be-$(x,be),be]}t.getCharContainingOffset=X;const R=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function f(x){return R.test(x)}t.containsRTL=f;const I=/^[\t\n\r\x20-\x7E]*$/;function U(x){return I.test(x)}t.isBasicASCII=U,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function q(x){return t.UNUSUAL_LINE_TERMINATORS.test(x)}t.containsUnusualLineTerminators=q;function W(x){return x>=11904&&x<=55215||x>=63744&&x<=64255||x>=65281&&x<=65374}t.isFullWidthCharacter=W;function O(x){return x>=127462&&x<=127487||x===8986||x===8987||x===9200||x===9203||x>=9728&&x<=10175||x===11088||x===11093||x>=127744&&x<=128591||x>=128640&&x<=128764||x>=128992&&x<=129008||x>=129280&&x<=129535||x>=129648&&x<=129782}t.isEmojiImprecise=O;function H(x,oe){if(x.length<oe)return x;const be=/\b/g;let Ce=0;for(;be.test(x)&&!(x.length-be.lastIndex<oe);)Ce=be.lastIndex,be.lastIndex+=1;return x.substring(Ce).replace(/^\s/,"")}t.lcut=H;const V=/\x1B\x5B[12]?K/g,F=/\x1b\[\d+m/g,z=/\x1b\[0?m/g;function k(x){return x&&(x=x.replace(V,""),x=x.replace(F,""),x=x.replace(z,"")),x}t.removeAnsiEscapeCodes=k,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function B(x){return!!(x&&x.length>0&&x.charCodeAt(0)===65279)}t.startsWithUTF8BOM=B;function j(x){return B(x)?x.substr(1):x}t.stripUTF8BOM=j;function J(x,oe){if(!x||!oe||x.length<oe.length)return!1;const be=oe.length,Ce=x.toLowerCase();let Fe=0,Re=-1;for(;Fe<be;){const Ve=Ce.indexOf(oe[Fe],Re+1);if(Ve<0)return!1;Re=Ve,Fe++}return!0}t.fuzzyContains=J;function ce(x,oe=!1){return x?(oe&&(x=x.replace(/\\./g,"")),x.toLowerCase()!==x):!1}t.containsUppercaseCharacter=ce;function de(x){return x.charAt(0).toUpperCase()+x.slice(1)}t.uppercaseFirstLetter=de;function Ee(x,oe=1){if(oe===0)return"";let be=-1;do be=x.indexOf(`
`,be+1),oe--;while(oe>0&&be>=0);return be===-1?x:(x[be-1]==="\r"&&be--,x.substr(0,be))}t.getNLines=Ee;function _e(x){const oe=90-65+1;return x=x%(2*oe),x<oe?String.fromCharCode(97+x):String.fromCharCode(65+x-oe)}t.singleLetterHash=_e;function ke(x){return Pe.getInstance().getGraphemeBreakType(x)}t.getGraphemeBreakType=ke;function Ie(x,oe){return x===0?oe!==5&&oe!==7:x===2&&oe===3?!1:x===4||x===2||x===3||oe===4||oe===2||oe===3?!0:!(x===8&&(oe===8||oe===9||oe===11||oe===12)||(x===11||x===9)&&(oe===9||oe===10)||(x===12||x===10)&&oe===10||oe===5||oe===13||oe===7||x===1||x===13&&oe===14||x===6&&oe===6)}var De;(function(x){x[x.Other=0]="Other",x[x.Prepend=1]="Prepend",x[x.CR=2]="CR",x[x.LF=3]="LF",x[x.Control=4]="Control",x[x.Extend=5]="Extend",x[x.Regional_Indicator=6]="Regional_Indicator",x[x.SpacingMark=7]="SpacingMark",x[x.L=8]="L",x[x.V=9]="V",x[x.T=10]="T",x[x.LV=11]="LV",x[x.LVT=12]="LVT",x[x.ZWJ=13]="ZWJ",x[x.Extended_Pictographic=14]="Extended_Pictographic"})(De=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{constructor(){this._data=Me()}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const be=this._data,Ce=be.length/3;let Fe=1;for(;Fe<=Ce;)if(oe<be[3*Fe])Fe=2*Fe;else if(oe>be[3*Fe+1])Fe=2*Fe+1;else return be[3*Fe+2];return 0}}Pe._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(x,oe){if(x===0)return 0;const be=He(x,oe);if(be!==void 0)return be;const Ce=new se(oe,x);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=Ge;function He(x,oe){const be=new se(oe,x);let Ce=be.prevCodePoint();for(;Ue(Ce)||Ce===65039||Ce===8419;){if(be.offset===0)return;Ce=be.prevCodePoint()}if(!O(Ce))return;let Fe=be.offset;return Fe>0&&be.prevCodePoint()===8205&&(Fe=be.offset),Fe}function Ue(x){return 127995<=x&&x<=127999}var Je;(function(x){x[x.zwj=8205]="zwj",x[x.emojiVariantSelector=65039]="emojiVariantSelector",x[x.enclosingKeyCap=8419]="enclosingKeyCap"})(Je||(Je={})),t.noBreakWhitespace="\xA0";class je{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return je.cache.get(Array.from(oe))}static getLocales(){return je._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=je,P=je,je.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new D.LRUCachedFunction(x=>{function oe(qe){const Le=new Map;for(let le=0;le<qe.length;le+=2)Le.set(qe[le],qe[le+1]);return Le}function be(qe,Le){const le=new Map(qe);for(const[Se,Ne]of Le)le.set(Se,Ne);return le}function Ce(qe,Le){if(!qe)return Le;const le=new Map;for(const[Se,Ne]of qe)Le.has(Se)&&le.set(Se,Ne);return le}const Fe=P.ambiguousCharacterData.getValue();let Re=x.filter(qe=>!qe.startsWith("_")&&qe in Fe);Re.length===0&&(Re=["_default"]);let Ve;for(const qe of Re){const Le=oe(Fe[qe]);Ve=Ce(Ve,Le)}const tt=oe(Fe._common),Xe=be(tt,Ve);return new je(Xe)}),je._locales=new i.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(x=>!x.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe,Oe._data=void 0}),define(me[109],pe([1,0,21,5,10,6]),function(Q,t,D,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function y(s){return s===47||s===92}t.isPathSeparator=y;function b(s){return s.replace(/[\\/]/g,D.posix.sep)}t.toSlashes=b;function m(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}t.toPosixPath=m;function h(s,a=D.posix.sep){if(!s)return"";const o=s.length,v=s.charCodeAt(0);if(y(v)){if(y(s.charCodeAt(1))&&!y(s.charCodeAt(2))){let K=3;const ne=K;for(;K<o&&!y(s.charCodeAt(K));K++);if(ne!==K&&!y(s.charCodeAt(K+1))){for(K+=1;K<o;K++)if(y(s.charCodeAt(K)))return s.slice(0,K+1).replace(/[\\/]/g,a)}}return a}else if(E(v)&&s.charCodeAt(1)===58)return y(s.charCodeAt(2))?s.slice(0,2)+a:s.slice(0,2);let N=s.indexOf("://");if(N!==-1){for(N+=3;N<o;N++)if(y(s.charCodeAt(N)))return s.slice(0,N+1)}return""}t.getRoot=h;function p(s){if(!i.isWindows||!s||s.length<5)return!1;let a=s.charCodeAt(0);if(a!==92||(a=s.charCodeAt(1),a!==92))return!1;let o=2;const v=o;for(;o<s.length&&(a=s.charCodeAt(o),a!==92);o++);return!(v===o||(a=s.charCodeAt(o+1),isNaN(a)||a===92))}t.isUNC=p;const A=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,r=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(s,a=i.isWindows){const o=a?A:l;return!(!s||s.length===0||/^\s+$/.test(s)||(o.lastIndex=0,o.test(s))||a&&r.test(s)||s==="."||s===".."||a&&s[s.length-1]==="."||a&&s.length!==s.trim().length||s.length>255)}t.isValidBasename=e;function c(s,a,o){const v=s===a;return!o||v?v:!s||!a?!1:(0,P.equalsIgnoreCase)(s,a)}t.isEqual=c;function g(s,a,o,v=D.sep){if(s===a)return!0;if(!s||!a||a.length>s.length)return!1;if(o){if(!(0,P.startsWithIgnoreCase)(s,a))return!1;if(a.length===s.length)return!0;let K=a.length;return a.charAt(a.length-1)===v&&K--,s.charAt(K)===v}return a.charAt(a.length-1)!==v&&(a+=v),s.indexOf(a)===0}t.isEqualOrParent=g;function E(s){return s>=65&&s<=90||s>=97&&s<=122}t.isWindowsDriveLetter=E;function _(s,a){return i.isWindows&&s.endsWith(":")&&(s+=D.sep),(0,D.isAbsolute)(s)||(s=(0,D.join)(a,s)),s=(0,D.normalize)(s),i.isWindows?(s=(0,P.rtrim)(s,D.sep),s.endsWith(":")&&(s+=D.sep)):(s=(0,P.rtrim)(s,D.sep),s||(s=D.sep)),s}t.sanitizeFilePath=_;function u(s){const a=(0,D.normalize)(s);return i.isWindows?s.length>3?!1:d(a)&&(s.length===2||a.charCodeAt(2)===92):a===D.posix.sep}t.isRootOrDriveLetter=u;function d(s,a=i.isWindows){return a?E(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}t.hasDriveLetter=d;function w(s){return d(s)?s[0]:void 0}t.getDriveLetter=w;function S(s,a,o){return a.length>s.length?-1:s===a?0:(o&&(s=s.toLowerCase(),a=a.toLowerCase()),s.indexOf(a))}t.indexOfPath=S;function L(s){const a=s.split(":");let o,v,N;for(const K of a){const ne=Number(K);(0,M.isNumber)(ne)?v===void 0?v=ne:N===void 0&&(N=ne):o=o?[o,K].join(":"):K}if(!o)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:o,line:v!==void 0?v:void 0,column:N!==void 0?N:v!==void 0?1:void 0}}t.parseLineAndColumnAware=L;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(s,a,o=8){let v="";for(let K=0;K<o;K++)v+=C.charAt(Math.floor(Math.random()*C.length));let N;return a?N=`${a}-${v}`:N=v,s?(0,D.join)(s,N):N}t.randomPath=n}),define(me[110],pe([1,0,10]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(E){return P(E,0)}t.hash=i;function P(E,_){switch(typeof E){case"object":return E===null?M(349,_):Array.isArray(E)?m(E,_):h(E,_);case"string":return b(E,_);case"boolean":return y(E,_);case"number":return M(E,_);case"undefined":return M(937,_);default:return M(617,_)}}t.doHash=P;function M(E,_){return(_<<5)-_+E|0}t.numberHash=M;function y(E,_){return M(E?433:863,_)}function b(E,_){_=M(149417,_);for(let u=0,d=E.length;u<d;u++)_=M(E.charCodeAt(u),_);return _}t.stringHash=b;function m(E,_){return _=M(104579,_),E.reduce((u,d)=>P(d,u),_)}function h(E,_){return _=M(181387,_),Object.keys(E).sort().reduce((u,d)=>(u=b(d,u),P(E[d],u)),_)}class p{constructor(){this._value=0}get value(){return this._value}hash(_){return this._value=P(_,this._value),this._value}}t.Hasher=p;var A;(function(E){E[E.BLOCK_SIZE=64]="BLOCK_SIZE",E[E.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(A||(A={}));function l(E,_,u=32){const d=u-_,w=~((1<<d)-1);return(E<<_|(w&E)>>>d)>>>0}function r(E,_=0,u=E.byteLength,d=0){for(let w=0;w<u;w++)E[_+w]=d}function e(E,_,u="0"){for(;E.length<_;)E=u+E;return E}function c(E,_=32){return E instanceof ArrayBuffer?Array.from(new Uint8Array(E)).map(u=>u.toString(16).padStart(2,"0")).join(""):e((E>>>0).toString(16),_/4)}t.toHexString=c;class g{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(_){const u=_.length;if(u===0)return;const d=this._buff;let w=this._buffLen,S=this._leftoverHighSurrogate,L,C;for(S!==0?(L=S,C=-1,S=0):(L=_.charCodeAt(0),C=0);;){let n=L;if(D.isHighSurrogate(L))if(C+1<u){const s=_.charCodeAt(C+1);D.isLowSurrogate(s)?(C++,n=D.computeCodePoint(L,s)):n=65533}else{S=L;break}else D.isLowSurrogate(L)&&(n=65533);if(w=this._push(d,w,n),C++,C<u)L=_.charCodeAt(C);else break}this._buffLen=w,this._leftoverHighSurrogate=S}_push(_,u,d){return d<128?_[u++]=d:d<2048?(_[u++]=192|(d&1984)>>>6,_[u++]=128|(d&63)>>>0):d<65536?(_[u++]=224|(d&61440)>>>12,_[u++]=128|(d&4032)>>>6,_[u++]=128|(d&63)>>>0):(_[u++]=240|(d&1835008)>>>18,_[u++]=128|(d&258048)>>>12,_[u++]=128|(d&4032)>>>6,_[u++]=128|(d&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,_[0]=_[64+0],_[1]=_[64+1],_[2]=_[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,r(this._buff,this._buffLen),this._buffLen>56&&(this._step(),r(this._buff));const _=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(_/4294967296),!1),this._buffDV.setUint32(60,_%4294967296,!1),this._step()}_step(){const _=g._bigBlock32,u=this._buffDV;for(let o=0;o<64;o+=4)_.setUint32(o,u.getUint32(o,!1),!1);for(let o=64;o<320;o+=4)_.setUint32(o,l(_.getUint32(o-12,!1)^_.getUint32(o-32,!1)^_.getUint32(o-56,!1)^_.getUint32(o-64,!1),1),!1);let d=this._h0,w=this._h1,S=this._h2,L=this._h3,C=this._h4,n,s,a;for(let o=0;o<80;o++)o<20?(n=w&S|~w&L,s=1518500249):o<40?(n=w^S^L,s=1859775393):o<60?(n=w&S|w&L|S&L,s=2400959708):(n=w^S^L,s=3395469782),a=l(d,5)+n+C+s+_.getUint32(o*4,!1)&4294967295,C=L,L=S,S=l(w,30),w=d,d=a;this._h0=this._h0+d&4294967295,this._h1=this._h1+w&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+L&4294967295,this._h4=this._h4+C&4294967295}}t.StringSHA1=g,g._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[111],pe([1,0,70,110]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class P{constructor(l){this.source=l}getElements(){const l=this.source,r=new Int32Array(l.length);for(let e=0,c=l.length;e<c;e++)r[e]=l.charCodeAt(e);return r}}t.StringDiffSequence=P;function M(A,l,r){return new p(new P(A),new P(l)).ComputeDiff(r).changes}t.stringDiff=M;class y{static Assert(l,r){if(!l)throw new Error(r)}}t.Debug=y;class b{static Copy(l,r,e,c,g){for(let E=0;E<g;E++)e[c+E]=l[r+E]}static Copy2(l,r,e,c,g){for(let E=0;E<g;E++)e[c+E]=l[r+E]}}t.MyArray=b;var m;(function(A){A[A.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(m||(m={}));class h{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new D.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(l,r){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,r),this.m_originalCount++}AddModifiedElement(l,r){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,r),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class p{constructor(l,r,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=l,this._modifiedSequence=r;const[c,g,E]=p._getElements(l),[_,u,d]=p._getElements(r);this._hasStrings=E&&d,this._originalStringElements=c,this._originalElementsOrHash=g,this._modifiedStringElements=_,this._modifiedElementsOrHash=u,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(l){return l.length>0&&typeof l[0]=="string"}static _getElements(l){const r=l.getElements();if(p._isStringArray(r)){const e=new Int32Array(r.length);for(let c=0,g=r.length;c<g;c++)e[c]=(0,i.stringHash)(r[c],0);return[r,e,!0]}return r instanceof Int32Array?[[],r,!1]:[[],new Int32Array(r),!1]}ElementsAreEqual(l,r){return this._originalElementsOrHash[l]!==this._modifiedElementsOrHash[r]?!1:this._hasStrings?this._originalStringElements[l]===this._modifiedStringElements[r]:!0}ElementsAreStrictEqual(l,r){if(!this.ElementsAreEqual(l,r))return!1;const e=p._getStrictElement(this._originalSequence,l),c=p._getStrictElement(this._modifiedSequence,r);return e===c}static _getStrictElement(l,r){return typeof l.getStrictElement=="function"?l.getStrictElement(r):null}OriginalElementsAreEqual(l,r){return this._originalElementsOrHash[l]!==this._originalElementsOrHash[r]?!1:this._hasStrings?this._originalStringElements[l]===this._originalStringElements[r]:!0}ModifiedElementsAreEqual(l,r){return this._modifiedElementsOrHash[l]!==this._modifiedElementsOrHash[r]?!1:this._hasStrings?this._modifiedStringElements[l]===this._modifiedStringElements[r]:!0}ComputeDiff(l){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,l)}_ComputeDiff(l,r,e,c,g){const E=[!1];let _=this.ComputeDiffRecursive(l,r,e,c,E);return g&&(_=this.PrettifyChanges(_)),{quitEarly:E[0],changes:_}}ComputeDiffRecursive(l,r,e,c,g){for(g[0]=!1;l<=r&&e<=c&&this.ElementsAreEqual(l,e);)l++,e++;for(;r>=l&&c>=e&&this.ElementsAreEqual(r,c);)r--,c--;if(l>r||e>c){let S;return e<=c?(y.Assert(l===r+1,"originalStart should only be one more than originalEnd"),S=[new D.DiffChange(l,0,e,c-e+1)]):l<=r?(y.Assert(e===c+1,"modifiedStart should only be one more than modifiedEnd"),S=[new D.DiffChange(l,r-l+1,e,0)]):(y.Assert(l===r+1,"originalStart should only be one more than originalEnd"),y.Assert(e===c+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const E=[0],_=[0],u=this.ComputeRecursionPoint(l,r,e,c,E,_,g),d=E[0],w=_[0];if(u!==null)return u;if(!g[0]){const S=this.ComputeDiffRecursive(l,d,e,w,g);let L=[];return g[0]?L=[new D.DiffChange(d+1,r-(d+1)+1,w+1,c-(w+1)+1)]:L=this.ComputeDiffRecursive(d+1,r,w+1,c,g),this.ConcatenateChanges(S,L)}return[new D.DiffChange(l,r-l+1,e,c-e+1)]}WALKTRACE(l,r,e,c,g,E,_,u,d,w,S,L,C,n,s,a,o,v){let N=null,K=null,ne=new h,re=r,we=e,ae=C[0]-a[0]-c,ve=-1073741824,fe=this.m_forwardHistory.length-1;do{const ge=ae+l;ge===re||ge<we&&d[ge-1]<d[ge+1]?(S=d[ge+1],n=S-ae-c,S<ve&&ne.MarkNextChange(),ve=S,ne.AddModifiedElement(S+1,n),ae=ge+1-l):(S=d[ge-1]+1,n=S-ae-c,S<ve&&ne.MarkNextChange(),ve=S-1,ne.AddOriginalElement(S,n+1),ae=ge-1-l),fe>=0&&(d=this.m_forwardHistory[fe],l=d[0],re=1,we=d.length-1)}while(--fe>=-1);if(N=ne.getReverseChanges(),v[0]){let ge=C[0]+1,ye=a[0]+1;if(N!==null&&N.length>0){const ee=N[N.length-1];ge=Math.max(ge,ee.getOriginalEnd()),ye=Math.max(ye,ee.getModifiedEnd())}K=[new D.DiffChange(ge,L-ge+1,ye,s-ye+1)]}else{ne=new h,re=E,we=_,ae=C[0]-a[0]-u,ve=1073741824,fe=o?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ge=ae+g;ge===re||ge<we&&w[ge-1]>=w[ge+1]?(S=w[ge+1]-1,n=S-ae-u,S>ve&&ne.MarkNextChange(),ve=S+1,ne.AddOriginalElement(S+1,n+1),ae=ge+1-g):(S=w[ge-1],n=S-ae-u,S>ve&&ne.MarkNextChange(),ve=S,ne.AddModifiedElement(S+1,n+1),ae=ge-1-g),fe>=0&&(w=this.m_reverseHistory[fe],g=w[0],re=1,we=w.length-1)}while(--fe>=-1);K=ne.getChanges()}return this.ConcatenateChanges(N,K)}ComputeRecursionPoint(l,r,e,c,g,E,_){let u=0,d=0,w=0,S=0,L=0,C=0;l--,e--,g[0]=0,E[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const n=r-l+(c-e),s=n+1,a=new Int32Array(s),o=new Int32Array(s),v=c-e,N=r-l,K=l-e,ne=r-c,we=(N-v)%2==0;a[v]=l,o[N]=r,_[0]=!1;for(let ae=1;ae<=n/2+1;ae++){let ve=0,fe=0;w=this.ClipDiagonalBound(v-ae,ae,v,s),S=this.ClipDiagonalBound(v+ae,ae,v,s);for(let ye=w;ye<=S;ye+=2){ye===w||ye<S&&a[ye-1]<a[ye+1]?u=a[ye+1]:u=a[ye-1]+1,d=u-(ye-v)-K;const ee=u;for(;u<r&&d<c&&this.ElementsAreEqual(u+1,d+1);)u++,d++;if(a[ye]=u,u+d>ve+fe&&(ve=u,fe=d),!we&&Math.abs(ye-N)<=ae-1&&u>=o[ye])return g[0]=u,E[0]=d,ee<=o[ye]&&1447>0&&ae<=1447+1?this.WALKTRACE(v,w,S,K,N,L,C,ne,a,o,u,r,g,d,c,E,we,_):null}const ge=(ve-l+(fe-e)-ae)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ve,ge))return _[0]=!0,g[0]=ve,E[0]=fe,ge>0&&1447>0&&ae<=1447+1?this.WALKTRACE(v,w,S,K,N,L,C,ne,a,o,u,r,g,d,c,E,we,_):(l++,e++,[new D.DiffChange(l,r-l+1,e,c-e+1)]);L=this.ClipDiagonalBound(N-ae,ae,N,s),C=this.ClipDiagonalBound(N+ae,ae,N,s);for(let ye=L;ye<=C;ye+=2){ye===L||ye<C&&o[ye-1]>=o[ye+1]?u=o[ye+1]-1:u=o[ye-1],d=u-(ye-N)-ne;const ee=u;for(;u>l&&d>e&&this.ElementsAreEqual(u,d);)u--,d--;if(o[ye]=u,we&&Math.abs(ye-v)<=ae&&u<=a[ye])return g[0]=u,E[0]=d,ee>=a[ye]&&1447>0&&ae<=1447+1?this.WALKTRACE(v,w,S,K,N,L,C,ne,a,o,u,r,g,d,c,E,we,_):null}if(ae<=1447){let ye=new Int32Array(S-w+2);ye[0]=v-w+1,b.Copy2(a,w,ye,1,S-w+1),this.m_forwardHistory.push(ye),ye=new Int32Array(C-L+2),ye[0]=N-L+1,b.Copy2(o,L,ye,1,C-L+1),this.m_reverseHistory.push(ye)}}return this.WALKTRACE(v,w,S,K,N,L,C,ne,a,o,u,r,g,d,c,E,we,_)}PrettifyChanges(l){for(let r=0;r<l.length;r++){const e=l[r],c=r<l.length-1?l[r+1].originalStart:this._originalElementsOrHash.length,g=r<l.length-1?l[r+1].modifiedStart:this._modifiedElementsOrHash.length,E=e.originalLength>0,_=e.modifiedLength>0;for(;e.originalStart+e.originalLength<c&&e.modifiedStart+e.modifiedLength<g&&(!E||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!_||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const d=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!d)break;e.originalStart++,e.modifiedStart++}const u=[null];if(r<l.length-1&&this.ChangesOverlap(l[r],l[r+1],u)){l[r]=u[0],l.splice(r+1,1),r--;continue}}for(let r=l.length-1;r>=0;r--){const e=l[r];let c=0,g=0;if(r>0){const S=l[r-1];c=S.originalStart+S.originalLength,g=S.modifiedStart+S.modifiedLength}const E=e.originalLength>0,_=e.modifiedLength>0;let u=0,d=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let S=1;;S++){const L=e.originalStart-S,C=e.modifiedStart-S;if(L<c||C<g||E&&!this.OriginalElementsAreEqual(L,L+e.originalLength)||_&&!this.ModifiedElementsAreEqual(C,C+e.modifiedLength))break;const s=(L===c&&C===g?5:0)+this._boundaryScore(L,e.originalLength,C,e.modifiedLength);s>d&&(d=s,u=S)}e.originalStart-=u,e.modifiedStart-=u;const w=[null];if(r>0&&this.ChangesOverlap(l[r-1],l[r],w)){l[r-1]=w[0],l.splice(r,1),r++;continue}}if(this._hasStrings)for(let r=1,e=l.length;r<e;r++){const c=l[r-1],g=l[r],E=g.originalStart-c.originalStart-c.originalLength,_=c.originalStart,u=g.originalStart+g.originalLength,d=u-_,w=c.modifiedStart,S=g.modifiedStart+g.modifiedLength,L=S-w;if(E<5&&d<20&&L<20){const C=this._findBetterContiguousSequence(_,d,w,L,E);if(C){const[n,s]=C;(n!==c.originalStart+c.originalLength||s!==c.modifiedStart+c.modifiedLength)&&(c.originalLength=n-c.originalStart,c.modifiedLength=s-c.modifiedStart,g.originalStart=n+E,g.modifiedStart=s+E,g.originalLength=u-g.originalStart,g.modifiedLength=S-g.modifiedStart)}}}return l}_findBetterContiguousSequence(l,r,e,c,g){if(r<g||c<g)return null;const E=l+r-g+1,_=e+c-g+1;let u=0,d=0,w=0;for(let S=l;S<E;S++)for(let L=e;L<_;L++){const C=this._contiguousSequenceScore(S,L,g);C>0&&C>u&&(u=C,d=S,w=L)}return u>0?[d,w]:null}_contiguousSequenceScore(l,r,e){let c=0;for(let g=0;g<e;g++){if(!this.ElementsAreEqual(l+g,r+g))return 0;c+=this._originalStringElements[l+g].length}return c}_OriginalIsBoundary(l){return l<=0||l>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[l])}_OriginalRegionIsBoundary(l,r){if(this._OriginalIsBoundary(l)||this._OriginalIsBoundary(l-1))return!0;if(r>0){const e=l+r;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(l){return l<=0||l>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[l])}_ModifiedRegionIsBoundary(l,r){if(this._ModifiedIsBoundary(l)||this._ModifiedIsBoundary(l-1))return!0;if(r>0){const e=l+r;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(l,r,e,c){const g=this._OriginalRegionIsBoundary(l,r)?1:0,E=this._ModifiedRegionIsBoundary(e,c)?1:0;return g+E}ConcatenateChanges(l,r){const e=[];if(l.length===0||r.length===0)return r.length>0?r:l;if(this.ChangesOverlap(l[l.length-1],r[0],e)){const c=new Array(l.length+r.length-1);return b.Copy(l,0,c,0,l.length-1),c[l.length-1]=e[0],b.Copy(r,1,c,l.length,r.length-1),c}else{const c=new Array(l.length+r.length);return b.Copy(l,0,c,0,l.length),b.Copy(r,0,c,l.length,r.length),c}}ChangesOverlap(l,r,e){if(y.Assert(l.originalStart<=r.originalStart,"Left change is not less than or equal to right change"),y.Assert(l.modifiedStart<=r.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=r.originalStart||l.modifiedStart+l.modifiedLength>=r.modifiedStart){const c=l.originalStart;let g=l.originalLength;const E=l.modifiedStart;let _=l.modifiedLength;return l.originalStart+l.originalLength>=r.originalStart&&(g=r.originalStart+r.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=r.modifiedStart&&(_=r.modifiedStart+r.modifiedLength-l.modifiedStart),e[0]=new D.DiffChange(c,g,E,_),!0}else return e[0]=null,!1}ClipDiagonalBound(l,r,e,c){if(l>=0&&l<c)return l;const g=e,E=c-e-1,_=r%2==0;if(l<0){const u=g%2==0;return _===u?0:1}else{const u=E%2==0;return _===u?c-1:c-2}}}t.LcsDiff=p}),define(me[48],pe([1,0,14,10]),function(Q,t,D,i){"use strict";var P,M,y;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function b(C,n,s){let a=C.get(n);return a===void 0&&(a=s,C.set(n,a)),a}t.getOrSet=b;function m(C){const n=[];return C.forEach((s,a)=>{n.push(`${a} => ${s}`)}),`Map(${C.size}) {${n.join(", ")}}`}t.mapToString=m;function h(C){const n=[];return C.forEach(s=>{n.push(s)}),`Set(${C.size}) {${n.join(", ")}}`}t.setToString=h;class p{constructor(){this._value="",this._pos=0}reset(n){return this._value=n,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(n){const s=n.charCodeAt(0),a=this._value.charCodeAt(this._pos);return s-a}value(){return this._value[this._pos]}}t.StringIterator=p;class A{constructor(n=!0){this._caseSensitive=n}reset(n){return this._value=n,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let n=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(n)this._from++;else break;else n=!1;return this}cmp(n){return this._caseSensitive?(0,i.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=A;class l{constructor(n=!0,s=!0){this._splitOnBackslash=n,this._caseSensitive=s}reset(n){this._from=0,this._to=0,this._value=n,this._valueLen=n.length;for(let s=n.length-1;s>=0;s--,this._valueLen--){const a=this._value.charCodeAt(s);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let n=!0;for(;this._to<this._valueLen;this._to++){const s=this._value.charCodeAt(this._to);if(s===47||this._splitOnBackslash&&s===92)if(n)this._from++;else break;else n=!1}return this}cmp(n){return this._caseSensitive?(0,i.compareSubstring)(n,this._value,0,n.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(n,this._value,0,n.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=l;var r;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(r||(r={}));class e{constructor(n,s){this._ignorePathCasing=n,this._ignoreQueryAndFragment=s,this._states=[],this._stateIdx=0}reset(n){return this._value=n,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(n)),this._pathIterator.reset(n.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(n)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(n){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(n,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(n,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(n);if(this._states[this._stateIdx]===4)return(0,i.compare)(n,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(n,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=e;class c{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const n=this.right;return this.right=n.left,n.left=this,this.updateHeight(),n.updateHeight(),n}rotateRight(){const n=this.left;return this.left=n.right,n.right=this,this.updateHeight(),n.updateHeight(),n}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var g;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(g||(g={}));class E{constructor(n){this._iter=n}static forUris(n=()=>!1,s=()=>!1){return new E(new e(n,s))}static forPaths(n=!1){return new E(new l(void 0,!n))}static forStrings(){return new E(new p)}static forConfigKeys(){return new E(new A)}clear(){this._root=void 0}fill(n,s){if(s){const a=s.slice(0);(0,D.shuffle)(a);for(const o of a)this.set(o,n)}else{const a=n.slice(0);(0,D.shuffle)(a);for(const o of a)this.set(o[0],o[1])}}set(n,s){const a=this._iter.reset(n);let o;this._root||(this._root=new c,this._root.segment=a.value());const v=[];for(o=this._root;;){const K=a.cmp(o.segment);if(K>0)o.left||(o.left=new c,o.left.segment=a.value()),v.push([-1,o]),o=o.left;else if(K<0)o.right||(o.right=new c,o.right.segment=a.value()),v.push([1,o]),o=o.right;else if(a.hasNext())a.next(),o.mid||(o.mid=new c,o.mid.segment=a.value()),v.push([0,o]),o=o.mid;else break}const N=o.value;o.value=s,o.key=n;for(let K=v.length-1;K>=0;K--){const ne=v[K][1];ne.updateHeight();const re=ne.balanceFactor();if(re<-1||re>1){const we=v[K][0],ae=v[K+1][0];if(we===1&&ae===1)v[K][1]=ne.rotateLeft();else if(we===-1&&ae===-1)v[K][1]=ne.rotateRight();else if(we===1&&ae===-1)ne.right=v[K+1][1]=v[K+1][1].rotateRight(),v[K][1]=ne.rotateLeft();else if(we===-1&&ae===1)ne.left=v[K+1][1]=v[K+1][1].rotateLeft(),v[K][1]=ne.rotateRight();else throw new Error;if(K>0)switch(v[K-1][0]){case-1:v[K-1][1].left=v[K][1];break;case 1:v[K-1][1].right=v[K][1];break;case 0:v[K-1][1].mid=v[K][1];break}else this._root=v[0][1]}}return N}get(n){return this._getNode(n)?.value}_getNode(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else break}return a}has(n){const s=this._getNode(n);return!(s?.value===void 0&&s?.mid===void 0)}delete(n){return this._delete(n,!1)}deleteSuperstr(n){return this._delete(n,!0)}_delete(n,s){const a=this._iter.reset(n),o=[];let v=this._root;for(;v;){const N=a.cmp(v.segment);if(N>0)o.push([-1,v]),v=v.left;else if(N<0)o.push([1,v]),v=v.right;else if(a.hasNext())a.next(),o.push([0,v]),v=v.mid;else break}if(!!v){if(s?(v.left=void 0,v.mid=void 0,v.right=void 0,v.height=1):(v.key=void 0,v.value=void 0),!v.mid&&!v.value)if(v.left&&v.right){const N=this._min(v.right),{key:K,value:ne,segment:re}=N;this._delete(N.key,!1),v.key=K,v.value=ne,v.segment=re}else{const N=v.left??v.right;if(o.length>0){const[K,ne]=o[o.length-1];switch(K){case-1:ne.left=N;break;case 0:ne.mid=N;break;case 1:ne.right=N;break}}else this._root=N}for(let N=o.length-1;N>=0;N--){const K=o[N][1];K.updateHeight();const ne=K.balanceFactor();if(ne>1?(K.right.balanceFactor()>=0||(K.right=K.right.rotateRight()),o[N][1]=K.rotateLeft()):ne<-1&&(K.left.balanceFactor()<=0||(K.left=K.left.rotateLeft()),o[N][1]=K.rotateRight()),N>0)switch(o[N-1][0]){case-1:o[N-1][1].left=o[N][1];break;case 1:o[N-1][1].right=o[N][1];break;case 0:o[N-1][1].mid=o[N][1];break}else this._root=o[0][1]}}}_min(n){for(;n.left;)n=n.left;return n}findSubstr(n){const s=this._iter.reset(n);let a=this._root,o;for(;a;){const v=s.cmp(a.segment);if(v>0)a=a.left;else if(v<0)a=a.right;else if(s.hasNext())s.next(),o=a.value||o,a=a.mid;else break}return a&&a.value||o}findSuperstr(n){const s=this._iter.reset(n);let a=this._root;for(;a;){const o=s.cmp(a.segment);if(o>0)a=a.left;else if(o<0)a=a.right;else if(s.hasNext())s.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(n){for(const[s,a]of this)n(a,s)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(n){const s=[];return this._dfsEntries(n,s),s[Symbol.iterator]()}_dfsEntries(n,s){!n||(n.left&&this._dfsEntries(n.left,s),n.value&&s.push([n.key,n.value]),n.mid&&this._dfsEntries(n.mid,s),n.right&&this._dfsEntries(n.right,s))}_isBalanced(){const n=s=>{if(!s)return!0;const a=s.balanceFactor();return a<-1||a>1?!1:n(s.left)&&n(s.right)};return n(this._root)}}t.TernarySearchTree=E;class _{constructor(n,s){this.uri=n,this.value=s}}class u{constructor(n,s){this[P]="ResourceMap",n instanceof u?(this.map=new Map(n.map),this.toKey=s??u.defaultToKey):(this.map=new Map,this.toKey=n??u.defaultToKey)}set(n,s){return this.map.set(this.toKey(n),new _(n,s)),this}get(n){return this.map.get(this.toKey(n))?.value}has(n){return this.map.has(this.toKey(n))}get size(){return this.map.size}clear(){this.map.clear()}delete(n){return this.map.delete(this.toKey(n))}forEach(n,s){typeof s!="undefined"&&(n=n.bind(s));for(const[a,o]of this.map)n(o.value,o.uri,this)}*values(){for(const n of this.map.values())yield n.value}*keys(){for(const n of this.map.values())yield n.uri}*entries(){for(const n of this.map.values())yield[n.uri,n.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.map)yield[n.uri,n.value]}}t.ResourceMap=u,u.defaultToKey=C=>C.toString();class d{constructor(n,s){this[M]="ResourceSet",!n||typeof n=="function"?this._map=new u(n):(this._map=new u(s),n.forEach(this.add,this))}get size(){return this._map.size}add(n){return this._map.set(n,n),this}clear(){this._map.clear()}delete(n){return this._map.delete(n)}forEach(n,s){this._map.forEach((a,o)=>n.call(s,o,o,this))}has(n){return this._map.has(n)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=d;var w;(function(C){C[C.None=0]="None",C[C.AsOld=1]="AsOld",C[C.AsNew=2]="AsNew"})(w=t.Touch||(t.Touch={}));class S{constructor(){this[y]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(n){return this._map.has(n)}get(n,s=0){const a=this._map.get(n);if(!!a)return s!==0&&this.touch(a,s),a.value}set(n,s,a=0){let o=this._map.get(n);if(o)o.value=s,a!==0&&this.touch(o,a);else{switch(o={key:n,value:s,next:void 0,previous:void 0},a){case 0:this.addItemLast(o);break;case 1:this.addItemFirst(o);break;case 2:this.addItemLast(o);break;default:this.addItemLast(o);break}this._map.set(n,o),this._size++}return this}delete(n){return!!this.remove(n)}remove(n){const s=this._map.get(n);if(!!s)return this._map.delete(n),this.removeItem(s),this._size--,s.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const n=this._head;return this._map.delete(n.key),this.removeItem(n),this._size--,n.value}forEach(n,s){const a=this._state;let o=this._head;for(;o;){if(s?n.bind(s)(o.value,o.key,this):n(o.value,o.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.key,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return o}values(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:a.value,done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return o}entries(){const n=this,s=this._state;let a=this._head;const o={[Symbol.iterator](){return o},next(){if(n._state!==s)throw new Error("LinkedMap got modified during iteration.");if(a){const v={value:[a.key,a.value],done:!1};return a=a.next,v}else return{value:void 0,done:!0}}};return o}[(y=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(n){if(n>=this.size)return;if(n===0){this.clear();return}let s=this._head,a=this.size;for(;s&&a>n;)this._map.delete(s.key),s=s.next,a--;this._head=s,this._size=a,s&&(s.previous=void 0),this._state++}addItemFirst(n){if(!this._head&&!this._tail)this._tail=n;else if(this._head)n.next=this._head,this._head.previous=n;else throw new Error("Invalid list");this._head=n,this._state++}addItemLast(n){if(!this._head&&!this._tail)this._head=n;else if(this._tail)n.previous=this._tail,this._tail.next=n;else throw new Error("Invalid list");this._tail=n,this._state++}removeItem(n){if(n===this._head&&n===this._tail)this._head=void 0,this._tail=void 0;else if(n===this._head){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this._head=n.next}else if(n===this._tail){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this._tail=n.previous}else{const s=n.next,a=n.previous;if(!s||!a)throw new Error("Invalid list");s.previous=a,a.next=s}n.next=void 0,n.previous=void 0,this._state++}touch(n,s){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(s!==1&&s!==2)){if(s===1){if(n===this._head)return;const a=n.next,o=n.previous;n===this._tail?(o.next=void 0,this._tail=o):(a.previous=o,o.next=a),n.previous=void 0,n.next=this._head,this._head.previous=n,this._head=n,this._state++}else if(s===2){if(n===this._tail)return;const a=n.next,o=n.previous;n===this._head?(a.previous=void 0,this._head=a):(a.previous=o,o.next=a),n.next=void 0,n.previous=this._tail,this._tail.next=n,this._tail=n,this._state++}}}toJSON(){const n=[];return this.forEach((s,a)=>{n.push([a,s])}),n}fromJSON(n){this.clear();for(const[s,a]of n)this.set(s,a)}}t.LinkedMap=S;class L extends S{constructor(n,s=1){super();this._limit=n,this._ratio=Math.min(Math.max(0,s),1)}get limit(){return this._limit}set limit(n){this._limit=n,this.checkTrim()}get ratio(){return this._ratio}set ratio(n){this._ratio=Math.min(Math.max(0,n),1),this.checkTrim()}get(n,s=2){return super.get(n,s)}peek(n){return super.get(n,0)}set(n,s){return super.set(n,s,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=L}),define(me[33],pe([1,0,48,10]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function P(...k){return function(B,j){for(let J=0,ce=k.length;J<ce;J++){const de=k[J](B,j);if(de)return de}return null}}t.or=P,t.matchesStrictPrefix=M.bind(void 0,!1),t.matchesPrefix=M.bind(void 0,!0);function M(k,B,j){if(!j||j.length<B.length)return null;let J;return k?J=i.startsWithIgnoreCase(j,B):J=j.indexOf(B)===0,J?B.length>0?[{start:0,end:B.length}]:[]:null}function y(k,B){const j=B.toLowerCase().indexOf(k.toLowerCase());return j===-1?null:[{start:j,end:j+k.length}]}t.matchesContiguousSubString=y;function b(k,B){return m(k.toLowerCase(),B.toLowerCase(),0,0)}t.matchesSubString=b;function m(k,B,j,J){if(j===k.length)return[];if(J===B.length)return null;if(k[j]===B[J]){let ce=null;return(ce=m(k,B,j+1,J+1))?E({start:J,end:J+1},ce):null}return m(k,B,j,J+1)}function h(k){return 97<=k&&k<=122}function p(k){return 65<=k&&k<=90}t.isUpper=p;function A(k){return 48<=k&&k<=57}function l(k){return k===32||k===9||k===10||k===13}const r=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(k=>r.add(k.charCodeAt(0)));function e(k){return l(k)||r.has(k)}function c(k,B){return k===B||e(k)&&e(B)}function g(k){return h(k)||p(k)||A(k)}function E(k,B){return B.length===0?B=[k]:k.end===B[0].start?B[0].start=k.start:B.unshift(k),B}function _(k,B){for(let j=B;j<k.length;j++){const J=k.charCodeAt(j);if(p(J)||A(J)||j>0&&!g(k.charCodeAt(j-1)))return j}return k.length}function u(k,B,j,J){if(j===k.length)return[];if(J===B.length)return null;if(k[j]!==B[J].toLowerCase())return null;{let ce=null,de=J+1;for(ce=u(k,B,j+1,J+1);!ce&&(de=_(B,de))<B.length;)ce=u(k,B,j+1,de),de++;return ce===null?null:E({start:J,end:J+1},ce)}}function d(k){let B=0,j=0,J=0,ce=0,de=0;for(let De=0;De<k.length;De++)de=k.charCodeAt(De),p(de)&&B++,h(de)&&j++,g(de)&&J++,A(de)&&ce++;const Ee=B/k.length,_e=j/k.length,ke=J/k.length,Ie=ce/k.length;return{upperPercent:Ee,lowerPercent:_e,alphaPercent:ke,numericPercent:Ie}}function w(k){const{upperPercent:B,lowerPercent:j}=k;return j===0&&B>.6}function S(k){const{upperPercent:B,lowerPercent:j,alphaPercent:J,numericPercent:ce}=k;return j>.2&&B<.8&&J>.6&&ce<.2}function L(k){let B=0,j=0,J=0,ce=0;for(let de=0;de<k.length;de++)J=k.charCodeAt(de),p(J)&&B++,h(J)&&j++,l(J)&&ce++;return(B===0||j===0)&&ce===0?k.length<=30:B<=5}function C(k,B){if(!B||(B=B.trim(),B.length===0)||!L(k)||B.length>60)return null;const j=d(B);if(!S(j)){if(!w(j))return null;B=B.toLowerCase()}let J=null,ce=0;for(k=k.toLowerCase();ce<B.length&&(J=u(k,B,0,ce))===null;)ce=_(B,ce+1);return J}t.matchesCamelCase=C;function n(k,B,j=!1){if(!B||B.length===0)return null;let J=null,ce=0;for(k=k.toLowerCase(),B=B.toLowerCase();ce<B.length&&(J=s(k,B,0,ce,j))===null;)ce=a(B,ce+1);return J}t.matchesWords=n;function s(k,B,j,J,ce){if(j===k.length)return[];if(J===B.length)return null;if(c(k.charCodeAt(j),B.charCodeAt(J))){let de=null,Ee=J+1;if(de=s(k,B,j+1,J+1,ce),!ce)for(;!de&&(Ee=a(B,Ee))<B.length;)de=s(k,B,j+1,Ee,ce),Ee++;return de?k.charCodeAt(j)!==B.charCodeAt(J)?de:E({start:J,end:J+1},de):null}else return null}function a(k,B){for(let j=B;j<k.length;j++)if(e(k.charCodeAt(j))||j>0&&e(k.charCodeAt(j-1)))return j;return k.length}const o=P(t.matchesPrefix,C,y),v=P(t.matchesPrefix,C,b),N=new D.LRUCache(1e4);function K(k,B,j=!1){if(typeof k!="string"||typeof B!="string")return null;let J=N.get(k);J||(J=new RegExp(i.convertSimple2RegExpPattern(k),"i"),N.set(k,J));const ce=J.exec(B);return ce?[{start:ce.index,end:ce.index+ce[0].length}]:j?v(k,B):o(k,B)}t.matchesFuzzy=K;function ne(k,B){const j=q(k,k.toLowerCase(),0,B,B.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return j?we(j):null}t.matchesFuzzy2=ne;function re(k,B,j,J,ce,de){const Ee=Math.min(13,k.length);for(;j<Ee;j++){const _e=q(k,B,j,J,ce,de,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(_e)return _e}return[0,de]}t.anyScore=re;function we(k){if(typeof k=="undefined")return[];const B=[],j=k[1];for(let J=k.length-1;J>1;J--){const ce=k[J]+j,de=B[B.length-1];de&&de.end===ce?de.end=ce+1:B.push({start:ce,end:ce+1})}return B}t.createMatches=we;const ae=128;function ve(){const k=[],B=[];for(let j=0;j<=ae;j++)B[j]=0;for(let j=0;j<=ae;j++)k.push(B.slice(0));return k}function fe(k){const B=[];for(let j=0;j<=k;j++)B[j]=0;return B}const ge=fe(2*ae),ye=fe(2*ae),ee=ve(),he=ve(),te=ve(),Z=!1;function se(k,B,j,J,ce){function de(_e,ke,Ie=" "){for(;_e.length<ke;)_e=Ie+_e;return _e}let Ee=` |   |${J.split("").map(_e=>de(_e,3)).join("|")}
`;for(let _e=0;_e<=j;_e++)_e===0?Ee+=" |":Ee+=`${B[_e-1]}|`,Ee+=k[_e].slice(0,ce+1).map(ke=>de(ke.toString(),3)).join("|")+`
`;return Ee}function ie(k,B,j,J){k=k.substr(B),j=j.substr(J),console.log(se(he,k,k.length,j,j.length)),console.log(se(te,k,k.length,j,j.length)),console.log(se(ee,k,k.length,j,j.length))}function T(k,B){if(B<0||B>=k.length)return!1;const j=k.codePointAt(B);switch(j){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(j)}}function $(k,B){if(B<0||B>=k.length)return!1;switch(k.charCodeAt(B)){case 32:case 9:return!0;default:return!1}}function X(k,B,j){return B[k]!==j[k]}function R(k,B,j,J,ce,de,Ee=!1){for(;B<j&&ce<de;)k[B]===J[ce]&&(Ee&&(ge[B]=ce),B+=1),ce+=1;return B===j}t.isPatternInWord=R;var f;(function(k){k[k.Diag=1]="Diag",k[k.Left=2]="Left",k[k.LeftLeft=3]="LeftLeft"})(f||(f={}));var I;(function(k){k.Default=[-100,0];function B(j){return!j||j.length===2&&j[0]===-100&&j[1]===0}k.isDefault=B})(I=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(B,j){this.firstMatchCanBeWeak=B,this.boostFullMatch=j}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function q(k,B,j,J,ce,de,Ee=U.default){const _e=k.length>ae?ae:k.length,ke=J.length>ae?ae:J.length;if(j>=_e||de>=ke||_e-j>ke-de||!R(B,j,_e,ce,de,ke,!0))return;W(_e,ke,j,de,B,ce);let Ie=1,De=1,Pe=j,Me=de;const Ge=[!1];for(Ie=1,Pe=j;Pe<_e;Ie++,Pe++){const Oe=ge[Pe],x=ye[Pe],oe=Pe+1<_e?ye[Pe+1]:ke;for(De=Oe-de+1,Me=Oe;Me<oe;De++,Me++){let be=Number.MIN_SAFE_INTEGER,Ce=!1;Me<=x&&(be=O(k,B,Pe,j,J,ce,Me,ke,de,ee[Ie-1][De-1]===0,Ge));let Fe=0;be!==Number.MAX_SAFE_INTEGER&&(Ce=!0,Fe=be+he[Ie-1][De-1]);const Re=Me>Oe,Ve=Re?he[Ie][De-1]+(ee[Ie][De-1]>0?-5:0):0,tt=Me>Oe+1&&ee[Ie][De-1]>0,Xe=tt?he[Ie][De-2]+(ee[Ie][De-2]>0?-5:0):0;if(tt&&(!Re||Xe>=Ve)&&(!Ce||Xe>=Fe))he[Ie][De]=Xe,te[Ie][De]=3,ee[Ie][De]=0;else if(Re&&(!Ce||Ve>=Fe))he[Ie][De]=Ve,te[Ie][De]=2,ee[Ie][De]=0;else if(Ce)he[Ie][De]=Fe,te[Ie][De]=1,ee[Ie][De]=ee[Ie-1][De-1]+1;else throw new Error("not possible")}}if(Z&&ie(k,j,J,de),!Ge[0]&&!Ee.firstMatchCanBeWeak)return;Ie--,De--;const He=[he[Ie][De],de];let Ue=0,Je=0;for(;Ie>=1;){let Oe=De;do{const x=te[Ie][Oe];if(x===3)Oe=Oe-2;else if(x===2)Oe=Oe-1;else break}while(Oe>=1);Ue>1&&B[j+Ie-1]===ce[de+De-1]&&!X(Oe+de-1,J,ce)&&Ue+1>ee[Ie][Oe]&&(Oe=De),Oe===De?Ue++:Ue=1,Je||(Je=Oe),Ie--,De=Oe-1,He.push(De)}ke===_e&&Ee.boostFullMatch&&(He[0]+=2);const je=Je-_e;return He[0]-=je,He}t.fuzzyScore=q;function W(k,B,j,J,ce,de){let Ee=k-1,_e=B-1;for(;Ee>=j&&_e>=J;)ce[Ee]===de[_e]&&(ye[Ee]=_e,Ee--),_e--}function O(k,B,j,J,ce,de,Ee,_e,ke,Ie,De){if(B[j]!==de[Ee])return Number.MIN_SAFE_INTEGER;let Pe=1,Me=!1;return Ee===j-J?Pe=k[j]===ce[Ee]?7:5:X(Ee,ce,de)&&(Ee===0||!X(Ee-1,ce,de))?(Pe=k[j]===ce[Ee]?7:5,Me=!0):T(de,Ee)&&(Ee===0||!T(de,Ee-1))?Pe=5:(T(de,Ee-1)||$(de,Ee-1))&&(Pe=5,Me=!0),Pe>1&&j===J&&(De[0]=!0),Me||(Me=X(Ee,ce,de)||T(de,Ee-1)||$(de,Ee-1)),j===J?Ee>ke&&(Pe-=Me?3:5):Ie?Pe+=Me?2:0:Pe+=Me?0:1,Ee+1===_e&&(Pe-=Me?3:5),Pe}function H(k,B,j,J,ce,de,Ee){return F(k,B,j,J,ce,de,!0,Ee)}t.fuzzyScoreGracefulAggressive=H;function V(k,B,j,J,ce,de,Ee){return F(k,B,j,J,ce,de,!1,Ee)}t.fuzzyScoreGraceful=V;function F(k,B,j,J,ce,de,Ee,_e){let ke=q(k,B,j,J,ce,de,_e);if(ke&&!Ee)return ke;if(k.length>=3){const Ie=Math.min(7,k.length-1);for(let De=j+1;De<Ie;De++){const Pe=z(k,De);if(Pe){const Me=q(Pe,Pe.toLowerCase(),j,J,ce,de,_e);Me&&(Me[0]-=3,(!ke||Me[0]>ke[0])&&(ke=Me))}}}return ke}function z(k,B){if(B+1>=k.length)return;const j=k[B],J=k[B+1];if(j!==J)return k.slice(0,B)+J+j+k.slice(B+2)}}),define(me[34],pe([1,0,11,33,10]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const M=new RegExp(`\\$\\(${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?\\)`,"g"),y=new RegExp(D.CSSIcon.iconNameCharacter),b=new RegExp(`(\\\\)?${M.source}`,"g");function m(g){return g.replace(b,(E,_)=>_?E:`\\${E}`)}t.escapeIcons=m;const h=new RegExp(`\\\\${M.source}`,"g");function p(g){return g.replace(h,E=>`\\${E}`)}t.markdownEscapeEscapedIcons=p;const A=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function l(g){return g.indexOf(t.iconStartMarker)===-1?g:g.replace(A,(E,_,u,d)=>u?E:_||d||"")}t.stripIcons=l;function r(g){const E=g.indexOf(t.iconStartMarker);return E===-1?{text:g}:e(g,E)}t.parseLabelWithIcons=r;function e(g,E){const _=[];let u="";function d(o){if(o){u+=o;for(const v of o)_.push(L)}}let w=-1,S="",L=0,C,n,s=E;const a=g.length;for(d(g.substr(0,E));s<a;)C=g[s],n=g[s+1],C===t.iconStartMarker[0]&&n===t.iconStartMarker[1]?(w=s,d(S),S=t.iconStartMarker,s++):C===")"&&w!==-1?(L+=s-w+1,w=-1,S=""):w!==-1?y.test(C)?S+=C:(d(S),w=-1,S=""):d(C),s++;return d(S),{text:u,iconOffsets:_}}function c(g,E,_=!1){const{text:u,iconOffsets:d}=E;if(!d||d.length===0)return(0,i.matchesFuzzy)(g,u,_);const w=(0,P.ltrim)(u," "),S=u.length-w.length,L=(0,i.matchesFuzzy)(g,w,_);if(L)for(const C of L){const n=d[C.start+S]+S;C.start+=n,C.end+=n}return L}t.matchesFuzzyIconAware=c}),define(me[16],pe([1,0,21,5]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const P=/^\w[\w\d+.-]*$/,M=/^\//,y=/^\/\//;function b(C,n){if(!C.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${C.authority}", path: "${C.path}", query: "${C.query}", fragment: "${C.fragment}"}`);if(C.scheme&&!P.test(C.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(C.path){if(C.authority){if(!M.test(C.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(y.test(C.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(C,n){return!C&&!n?"file":C}function h(C,n){switch(C){case"https":case"http":case"file":n?n[0]!==A&&(n=A+n):n=A;break}return n}const p="",A="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class r{constructor(n,s,a,o,v,N=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=m(n,N),this.authority=s||p,this.path=h(this.scheme,a||p),this.query=o||p,this.fragment=v||p,b(this,N))}static isUri(n){return n instanceof r?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}get fsPath(){return u(this,!1)}with(n){if(!n)return this;let{scheme:s,authority:a,path:o,query:v,fragment:N}=n;return s===void 0?s=this.scheme:s===null&&(s=p),a===void 0?a=this.authority:a===null&&(a=p),o===void 0?o=this.path:o===null&&(o=p),v===void 0?v=this.query:v===null&&(v=p),N===void 0?N=this.fragment:N===null&&(N=p),s===this.scheme&&a===this.authority&&o===this.path&&v===this.query&&N===this.fragment?this:new c(s,a,o,v,N)}static parse(n,s=!1){const a=l.exec(n);return a?new c(a[2]||p,L(a[4]||p),L(a[5]||p),L(a[7]||p),L(a[9]||p),s):new c(p,p,p,p,p)}static file(n){let s=p;if(i.isWindows&&(n=n.replace(/\\/g,A)),n[0]===A&&n[1]===A){const a=n.indexOf(A,2);a===-1?(s=n.substring(2),n=A):(s=n.substring(2,a),n=n.substring(a)||A)}return new c("file",s,n,p,p)}static from(n){const s=new c(n.scheme,n.authority,n.path,n.query,n.fragment);return b(s,!0),s}static joinPath(n,...s){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return i.isWindows&&n.scheme==="file"?a=r.file(D.win32.join(u(n,!0),...s)).path:a=D.posix.join(n.path,...s),n.with({path:a})}toString(n=!1){return d(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof r)return n;{const s=new c(n);return s._formatted=n.external,s._fsPath=n._sep===e?n.fsPath:null,s}}else return n}}t.URI=r;const e=i.isWindows?1:void 0;class c extends r{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(n=!1){return n?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=e),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const g={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function E(C,n){let s,a=-1;for(let o=0;o<C.length;o++){const v=C.charCodeAt(o);if(v>=97&&v<=122||v>=65&&v<=90||v>=48&&v<=57||v===45||v===46||v===95||v===126||n&&v===47)a!==-1&&(s+=encodeURIComponent(C.substring(a,o)),a=-1),s!==void 0&&(s+=C.charAt(o));else{s===void 0&&(s=C.substr(0,o));const N=g[v];N!==void 0?(a!==-1&&(s+=encodeURIComponent(C.substring(a,o)),a=-1),s+=N):a===-1&&(a=o)}}return a!==-1&&(s+=encodeURIComponent(C.substring(a))),s!==void 0?s:C}function _(C){let n;for(let s=0;s<C.length;s++){const a=C.charCodeAt(s);a===35||a===63?(n===void 0&&(n=C.substr(0,s)),n+=g[a]):n!==void 0&&(n+=C[s])}return n!==void 0?n:C}function u(C,n){let s;return C.authority&&C.path.length>1&&C.scheme==="file"?s=`//${C.authority}${C.path}`:C.path.charCodeAt(0)===47&&(C.path.charCodeAt(1)>=65&&C.path.charCodeAt(1)<=90||C.path.charCodeAt(1)>=97&&C.path.charCodeAt(1)<=122)&&C.path.charCodeAt(2)===58?n?s=C.path.substr(1):s=C.path[1].toLowerCase()+C.path.substr(2):s=C.path,i.isWindows&&(s=s.replace(/\//g,"\\")),s}t.uriToFsPath=u;function d(C,n){const s=n?_:E;let a="",{scheme:o,authority:v,path:N,query:K,fragment:ne}=C;if(o&&(a+=o,a+=":"),(v||o==="file")&&(a+=A,a+=A),v){let re=v.indexOf("@");if(re!==-1){const we=v.substr(0,re);v=v.substr(re+1),re=we.indexOf(":"),re===-1?a+=s(we,!1):(a+=s(we.substr(0,re),!1),a+=":",a+=s(we.substr(re+1),!1)),a+="@"}v=v.toLowerCase(),re=v.indexOf(":"),re===-1?a+=s(v,!1):(a+=s(v.substr(0,re),!1),a+=v.substr(re))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const re=N.charCodeAt(1);re>=65&&re<=90&&(N=`/${String.fromCharCode(re+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const re=N.charCodeAt(0);re>=65&&re<=90&&(N=`${String.fromCharCode(re+32)}:${N.substr(2)}`)}a+=s(N,!0)}return K&&(a+="?",a+=s(K,!1)),ne&&(a+="#",a+=n?ne:E(ne,!1)),a}function w(C){try{return decodeURIComponent(C)}catch{return C.length>3?C.substr(0,3)+w(C.substr(3)):C}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function L(C){return C.match(S)?C.replace(S,n=>w(n)):C}}),define(me[49],pe([1,0,31,10,16]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function M(h){return JSON.stringify(h,b)}t.stringify=M;function y(h){let p=JSON.parse(h);return p=m(p),p}t.parse=y;function b(h,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,i.regExpFlags)(p)}:p}function m(h,p=0){if(!h||p>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return P.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 14:return new Date(h.source)}if(h instanceof D.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let A=0;A<h.length;++A)h[A]=m(h[A],p+1);else for(const A in h)Object.hasOwnProperty.call(h,A)&&(h[A]=m(h[A],p+1))}return h}t.revive=m}),define(me[35],pe([1,0,5,16]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var P;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(P=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${P.vscodeRemoteResource}`}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}setServerRootPath(m){this._remoteResourcesPath=`${m}/${P.vscodeRemoteResource}`}set(m,h,p){this._hosts[m]=h,this._ports[m]=p}setConnectionToken(m,h){this._connectionTokens[m]=h}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(m){if(this._delegate)return this._delegate(m);const h=m.authority;let p=this._hosts[h];p&&p.indexOf(":")!==-1&&(p=`[${p}]`);const A=this._ports[h],l=this._connectionTokens[h];let r=`path=${encodeURIComponent(m.path)}`;return typeof l=="string"&&(r+=`&${t.connectionTokenQueryName}=${encodeURIComponent(l)}`),i.URI.from({scheme:D.isWeb?this._preferredWebSchema:P.vscodeRemoteResource,authority:`${p}:${A}`,path:this._remoteResourcesPath,query:r})}}t.RemoteAuthorities=new M;class y{asBrowserUri(m,h){const p=this.toUri(m,h);return p.scheme===P.vscodeRemote?t.RemoteAuthorities.rewrite(p):p.scheme===P.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${P.vscodeFileResource}://${y.FALLBACK_AUTHORITY}`)?p.with({scheme:P.vscodeFileResource,authority:p.authority||y.FALLBACK_AUTHORITY,query:null,fragment:null}):p}asFileUri(m,h){const p=this.toUri(m,h);return p.scheme===P.vscodeFileResource?p.with({scheme:P.file,authority:p.authority!==y.FALLBACK_AUTHORITY?p.authority:null,query:null,fragment:null}):p}toUri(m,h){return i.URI.isUri(m)?m:i.URI.parse(h.toUrl(m))}}y.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new y}),define(me[36],pe([1,0,109,35,21,5,10,16]),function(Q,t,D,i,P,M,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function m(r){return(0,b.uriToFsPath)(r,!0)}t.originalFSPath=m;class h{constructor(e){this._ignorePathCasing=e}compare(e,c,g=!1){return e===c?0:(0,y.compare)(this.getComparisonKey(e,g),this.getComparisonKey(c,g))}isEqual(e,c,g=!1){return e===c?!0:!e||!c?!1:this.getComparisonKey(e,g)===this.getComparisonKey(c,g)}getComparisonKey(e,c=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,c,g=!1){if(e.scheme===c.scheme){if(e.scheme===i.Schemas.file)return D.isEqualOrParent(m(e),m(c),this._ignorePathCasing(e))&&e.query===c.query&&(g||e.fragment===c.fragment);if((0,t.isEqualAuthority)(e.authority,c.authority))return D.isEqualOrParent(e.path,c.path,this._ignorePathCasing(e),"/")&&e.query===c.query&&(g||e.fragment===c.fragment)}return!1}joinPath(e,...c){return b.URI.joinPath(e,...c)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return P.posix.basename(e.path)}extname(e){return P.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let c;return e.scheme===i.Schemas.file?c=b.URI.file(P.dirname(m(e))).path:(c=P.posix.dirname(e.path),e.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),c="/")),e.with({path:c})}normalizePath(e){if(!e.path.length)return e;let c;return e.scheme===i.Schemas.file?c=b.URI.file(P.normalize(m(e))).path:c=P.posix.normalize(e.path),e.with({path:c})}relativePath(e,c){if(e.scheme!==c.scheme||!(0,t.isEqualAuthority)(e.authority,c.authority))return;if(e.scheme===i.Schemas.file){const _=P.relative(m(e),m(c));return M.isWindows?D.toSlashes(_):_}let g=e.path||"/";const E=c.path||"/";if(this._ignorePathCasing(e)){let _=0;for(const u=Math.min(g.length,E.length);_<u&&!(g.charCodeAt(_)!==E.charCodeAt(_)&&g.charAt(_).toLowerCase()!==E.charAt(_).toLowerCase());_++);g=E.substr(0,_)+g.substr(_)}return P.posix.relative(g,E)}resolvePath(e,c){if(e.scheme===i.Schemas.file){const g=b.URI.file(P.resolve(m(e),c));return e.with({authority:g.authority,path:g.path})}return c=D.toPosixPath(c),e.with({path:P.posix.resolve(e.path,c)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,c){return e===c||e!==void 0&&c!==void 0&&(0,y.equalsIgnoreCase)(e,c)}hasTrailingPathSeparator(e,c=P.sep){if(e.scheme===i.Schemas.file){const g=m(e);return g.length>D.getRoot(g).length&&g[g.length-1]===c}else{const g=e.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,c=P.sep){return(0,t.hasTrailingPathSeparator)(e,c)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,c=P.sep){let g=!1;if(e.scheme===i.Schemas.file){const E=m(e);g=E!==void 0&&E.length===D.getRoot(E).length&&E[E.length-1]===c}else{c="/";const E=e.path;g=E.length===1&&E.charCodeAt(E.length-1)===47}return!g&&!(0,t.hasTrailingPathSeparator)(e,c)?e.with({path:e.path+"/"}):e}}t.ExtUri=h,t.extUri=new h(()=>!1),t.extUriBiasedIgnorePathCase=new h(r=>r.scheme===i.Schemas.file?!M.isLinux:!0),t.extUriIgnorePathCase=new h(r=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function p(r,e){const c=[];for(let g=0;g<r.length;g++){const E=e(r[g]);r.some((_,u)=>u===g?!1:(0,t.isEqualOrParent)(E,e(_)))||c.push(r[g])}return c}t.distinctParents=p;var A;(function(r){r.META_DATA_LABEL="label",r.META_DATA_DESCRIPTION="description",r.META_DATA_SIZE="size",r.META_DATA_MIME="mime";function e(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(u=>{const[d,w]=u.split(":");d&&w&&g.set(d,w)});const _=c.path.substring(0,c.path.indexOf(";"));return _&&g.set(r.META_DATA_MIME,_),g}r.parseMetaData=e})(A=t.DataUri||(t.DataUri={}));function l(r,e,c){if(e){let g=r.path;return g&&g[0]!==P.posix.sep&&(g=P.posix.sep+g),r.with({scheme:c,authority:e,path:g})}return r.with({scheme:c})}t.toLocalResource=l}),define(me[8],pe([1,0,28,13,3,2,36,5]),function(Q,t,D,i,P,M,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function m(X){return!!X&&typeof X.then=="function"}t.isThenable=m;function h(X){const R=new D.CancellationTokenSource,f=X(R.token),I=new Promise((U,q)=>{const W=R.token.onCancellationRequested(()=>{W.dispose(),R.dispose(),q(new i.CancellationError)});Promise.resolve(f).then(O=>{W.dispose(),R.dispose(),U(O)},O=>{W.dispose(),R.dispose(),q(O)})});return new class{cancel(){R.cancel()}then(U,q){return I.then(U,q)}catch(U){return this.then(void 0,U)}finally(U){return I.finally(U)}}}t.createCancelablePromise=h;function p(X,R,f){return new Promise((I,U)=>{const q=R.onCancellationRequested(()=>{q.dispose(),I(f)});X.then(I,U).finally(()=>q.dispose())})}t.raceCancellation=p;function A(X,R){return new Promise((f,I)=>{const U=R.onCancellationRequested(()=>{U.dispose(),I(new i.CancellationError)});X.then(f,I).finally(()=>U.dispose())})}t.raceCancellationError=A;async function l(X){let R=-1;const f=X.map((U,q)=>U.then(W=>(R=q,W))),I=await Promise.race(f);return X.forEach((U,q)=>{q!==R&&U.cancel()}),I}t.raceCancellablePromises=l;function r(X,R,f){let I;const U=setTimeout(()=>{I?.(void 0),f?.()},R);return Promise.race([X.finally(()=>clearTimeout(U)),new Promise(q=>I=q)])}t.raceTimeout=r;function e(X){return new Promise((R,f)=>{const I=X();m(I)?I.then(R,f):R(I)})}t.asPromise=e;class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(R){if(this.activePromise){if(this.queuedPromiseFactory=R,!this.queuedPromise){const f=()=>{this.queuedPromise=null;const I=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,I};this.queuedPromise=new Promise(I=>{this.activePromise.then(f,f).then(I)})}return new Promise((f,I)=>{this.queuedPromise.then(f,I)})}return this.activePromise=R(),new Promise((f,I)=>{this.activePromise.then(U=>{this.activePromise=null,f(U)},U=>{this.activePromise=null,I(U)})})}}t.Throttler=c;class g{constructor(){this.current=Promise.resolve(null)}queue(R){return this.current=this.current.then(()=>R(),()=>R())}}t.Sequencer=g;class E{constructor(){this.promiseMap=new Map}queue(R,f){const U=(this.promiseMap.get(R)??Promise.resolve()).catch(()=>{}).then(f).finally(()=>{this.promiseMap.get(R)===U&&this.promiseMap.delete(R)});return this.promiseMap.set(R,U),U}}t.SequencerByKey=E;const _=(X,R)=>{let f=!0;const I=setTimeout(()=>{f=!1,R()},X);return{isTriggered:()=>f,dispose:()=>{clearTimeout(I),f=!1}}},u=X=>{let R=!0;return queueMicrotask(()=>{R&&(R=!1,X())}),{isTriggered:()=>R,dispose:()=>{R=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(R){this.defaultDelay=R,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(R,f=this.defaultDelay){this.task=R,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,q)=>{this.doResolve=U,this.doReject=q}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const I=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=f===t.MicrotaskDelay?u(I):_(f,I),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=d;class w{constructor(R){this.delayer=new d(R),this.throttler=new c}trigger(R,f){return this.delayer.trigger(()=>this.throttler.queue(R),f)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=w;class S{constructor(){this._isOpen=!1,this._promise=new Promise((R,f)=>{this._completePromise=R})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=S;class L extends S{constructor(R){super();this._timeout=setTimeout(()=>this.open(),R)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=L;function C(X,R){return R?new Promise((f,I)=>{const U=setTimeout(()=>{q.dispose(),f()},X),q=R.onCancellationRequested(()=>{clearTimeout(U),q.dispose(),I(new i.CancellationError)})}):h(f=>C(X,f))}t.timeout=C;function n(X,R=0){const f=setTimeout(X,R);return(0,M.toDisposable)(()=>clearTimeout(f))}t.disposableTimeout=n;function s(X){const R=[];let f=0;const I=X.length;function U(){return f<I?X[f++]():null}function q(W){W!=null&&R.push(W);const O=U();return O?O.then(q):Promise.resolve(R)}return Promise.resolve(null).then(q)}t.sequence=s;function a(X,R=I=>!!I,f=null){let I=0;const U=X.length,q=()=>{if(I>=U)return Promise.resolve(f);const W=X[I++];return Promise.resolve(W()).then(H=>R(H)?Promise.resolve(H):q())};return q()}t.first=a;function o(X,R=I=>!!I,f=null){if(X.length===0)return Promise.resolve(f);let I=X.length;const U=()=>{I=-1;for(const q of X)q.cancel?.()};return new Promise((q,W)=>{for(const O of X)O.then(H=>{--I>=0&&R(H)?(U(),q(H)):I===0&&q(f)}).catch(H=>{--I>=0&&(U(),W(H))})})}t.firstParallel=o;class v{constructor(R){this._size=0,this.maxDegreeOfParalellism=R,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new P.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(R){return this._size++,new Promise((f,I)=>{this.outstandingPromises.push({factory:R,c:f,e:I}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const R=this.outstandingPromises.shift();this.runningPromises++;const f=R.factory();f.then(R.c,R.e),f.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=v;class N extends v{constructor(){super(1)}}t.Queue=N;class K{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const R=new te;return this.drainers.add(R),R.p}isDrained(){for(const[,R]of this.queues)if(R.size>0)return!1;return!0}queueFor(R,f=y.extUri){const I=f.getComparisonKey(R);let U=this.queues.get(I);return U||(U=new N,P.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(I),this.onDidQueueDrain()}),this.queues.set(I,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const R of this.drainers)R.complete();this.drainers.clear()}dispose(){for(const[,R]of this.queues)R.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=K;class ne{constructor(R,f){this._token=-1,typeof R=="function"&&typeof f=="number"&&this.setIfNotSet(R,f)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(R,f){this.cancel(),this._token=setTimeout(()=>{this._token=-1,R()},f)}setIfNotSet(R,f){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,R()},f))}}t.TimeoutTimer=ne;class re{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(R,f){this.cancel(),this._token=setInterval(()=>{R()},f)}}t.IntervalTimer=re;class we{constructor(R,f){this.timeoutToken=-1,this.runner=R,this.timeout=f,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(R=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,R)}get delay(){return this.timeout}set delay(R){this.timeout=R}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=we;class ae{constructor(R,f){f%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${f}ms is not a multiple of 1000ms.`),this.runner=R,this.timeout=f,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(R=this.timeout){R%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${R}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(R/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ae;class ve extends we{constructor(R,f){super(R,f);this.units=[]}work(R){this.units.push(R),this.isScheduled()||this.schedule()}doRun(){const R=this.units;this.units=[],this.runner?.(R)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=ve;class fe extends M.Disposable{constructor(R,f){super();this.options=R,this.handler=f,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(R){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+R.length>this.options.maxBufferedWork)return!1}else if(this.pending+R.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...R),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new we(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=fe,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=X=>{(0,b.setTimeout0)(()=>{if(R)return;const f=Date.now()+15;X(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,f-Date.now())}}))});let R=!1;return{dispose(){R||(R=!0)}}}:t.runWhenIdle=(X,R)=>{const f=requestIdleCallback(X,typeof R=="number"?{timeout:R}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(f))}}}}();class ge{constructor(R){this._didRun=!1,this._executor=()=>{try{this._value=R()}catch(f){this._error=f}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=ge;async function ye(X,R,f){let I;for(let U=0;U<f;U++)try{return await X()}catch(q){I=q,await C(R)}throw I}t.retry=ye;class ee{hasPending(R){return this._pending?typeof R=="number"?this._pending.taskId===R:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(R,f,I){return this._pending={taskId:R,cancel:()=>I?.(),promise:f},f.then(()=>this.donePending(R),()=>this.donePending(R)),f}donePending(R){this._pending&&R===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const R=this._next;this._next=void 0,R.run().then(R.promiseResolve,R.promiseReject)}}setNext(R){if(this._next)this._next.run=R;else{let f,I;const U=new Promise((q,W)=>{f=q,I=W});this._next={run:R,promise:U,promiseResolve:f,promiseReject:I}}return this._next.promise}}t.TaskSequentializer=ee;class he{constructor(R,f=()=>Date.now()){this.interval=R,this.nowFn=f,this.lastIncrementTime=0,this.value=0}increment(){const R=this.nowFn();return R-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=R,this.value=0),this.value++,this.value}}t.IntervalCounter=he;class te{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((R,f)=>{this.completeCallback=R,this.errorCallback=f})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(R){return new Promise(f=>{this.completeCallback(R),this.resolved=!0,f()})}error(R){return new Promise(f=>{this.errorCallback(R),this.rejected=!0,f()})}cancel(){new Promise(R=>{this.errorCallback(new i.CancellationError),this.rejected=!0,R()})}}t.DeferredPromise=te;var Z;(function(X){async function R(I){let U;const q=await Promise.all(I.map(W=>W.then(O=>O,O=>{U||(U=O)})));if(typeof U!="undefined")throw U;return q}X.settled=R;function f(I){return new Promise(async(U,q)=>{try{await I(U,q)}catch(W){q(W)}})}X.withAsyncBody=f})(Z=t.Promises||(t.Promises={}));var se;(function(X){X[X.Initial=0]="Initial",X[X.DoneOK=1]="DoneOK",X[X.DoneError=2]="DoneError"})(se||(se={}));class ie{constructor(R){this._state=0,this._results=[],this._error=null,this._onStateChanged=new P.Emitter,queueMicrotask(async()=>{const f={emitOne:I=>this.emitOne(I),emitMany:I=>this.emitMany(I),reject:I=>this.reject(I)};try{await Promise.resolve(R(f)),this.resolve()}catch(I){this.reject(I)}finally{f.emitOne=void 0,f.emitMany=void 0,f.reject=void 0}})}static fromArray(R){return new ie(f=>{f.emitMany(R)})}static fromPromise(R){return new ie(async f=>{f.emitMany(await R)})}static fromPromises(R){return new ie(async f=>{await Promise.all(R.map(async I=>f.emitOne(await I)))})}static merge(R){return new ie(async f=>{await Promise.all(R.map(async I=>{for await(const U of I)f.emitOne(U)}))})}[Symbol.asyncIterator](){let R=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(R<this._results.length)return{done:!1,value:this._results[R++]};if(this._state===1)return{done:!0,value:void 0};await P.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(R,f){return new ie(async I=>{for await(const U of R)I.emitOne(f(U))})}map(R){return ie.map(this,R)}static filter(R,f){return new ie(async I=>{for await(const U of R)f(U)&&I.emitOne(U)})}filter(R){return ie.filter(this,R)}static coalesce(R){return ie.filter(R,f=>!!f)}coalesce(){return ie.coalesce(this)}static async toPromise(R){const f=[];for await(const I of R)f.push(I);return f}toPromise(){return ie.toPromise(this)}emitOne(R){this._state===0&&(this._results.push(R),this._onStateChanged.fire())}emitMany(R){this._state===0&&(this._results=this._results.concat(R),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(R){this._state===0&&(this._state=2,this._error=R,this._onStateChanged.fire())}}t.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class T extends ie{constructor(R,f){super(f);this._source=R}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=T;function $(X){const R=new D.CancellationTokenSource,f=X(R.token);return new T(R,async I=>{const U=R.token.onCancellationRequested(()=>{U.dispose(),R.dispose(),I.reject(new i.CancellationError)});try{for await(const q of f){if(R.token.isCancellationRequested)return;I.emitOne(q)}U.dispose(),R.dispose()}catch(q){U.dispose(),R.dispose(),I.reject(q)}})}t.createCancelableAsyncIterable=$}),define(me[4],pe([1,0,15,107,19,20,8,13,3,112,2,35,5,6,16]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.getElementsByTagName=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.StandardWindow=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.createEventEmitter=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function c(Y){for(;Y.firstChild;)Y.firstChild.remove()}t.clearNode=c;function g(Y){return Y?.isConnected??!1}t.isInDOM=g;class E{constructor(G,ue,Ae,Te){this._node=G,this._type=ue,this._handler=Ae,this._options=Te||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function _(Y,G,ue,Ae){return new E(Y,G,ue,Ae)}t.addDisposableListener=_;function u(Y){return function(G){return Y(new M.StandardMouseEvent(G))}}function d(Y){return function(G){return Y(new P.StandardKeyboardEvent(G))}}const w=function(G,ue,Ae,Te){let ze=Ae;return ue==="click"||ue==="mousedown"?ze=u(Ae):(ue==="keydown"||ue==="keypress"||ue==="keyup")&&(ze=d(Ae)),_(G,ue,ze,Te)};t.addStandardDisposableListener=w;const S=function(G,ue,Ae){const Te=u(ue);return C(G,Te,Ae)};t.addStandardDisposableGenericMouseDownListener=S;const L=function(G,ue,Ae){const Te=u(ue);return s(G,Te,Ae)};t.addStandardDisposableGenericMouseUpListener=L;function C(Y,G,ue){return _(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,G,ue)}t.addDisposableGenericMouseDownListener=C;function n(Y,G,ue){return _(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,G,ue)}t.addDisposableGenericMouseMoveListener=n;function s(Y,G,ue){return _(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,G,ue)}t.addDisposableGenericMouseUpListener=s;function a(Y,G,ue){let Ae=null;const Te=Ye=>xe.fire(Ye),ze=()=>{Ae||(Ae=new E(Y,G,Te,ue))},We=()=>{Ae&&(Ae.dispose(),Ae=null)},xe=new m.Emitter({onFirstListenerAdd:ze,onLastListenerRemove:We});return xe}t.createEventEmitter=a;let o=null;function v(Y){if(!o){const G=ue=>setTimeout(()=>ue(new Date().getTime()),0);o=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||G}return o.call(self,Y)}class N{constructor(G,ue=0){this._runner=G,this.priority=ue,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(G){(0,b.onUnexpectedError)(G)}}static sort(G,ue){return ue.priority-G.priority}}(function(){let Y=[],G=null,ue=!1,Ae=!1;const Te=()=>{for(ue=!1,G=Y,Y=[],Ae=!0;G.length>0;)G.sort(N.sort),G.shift().execute();Ae=!1};t.scheduleAtNextAnimationFrame=(ze,We=0)=>{const xe=new N(ze,We);return Y.push(xe),ue||(ue=!0,v(Te)),xe},t.runAtThisOrScheduleAtNextAnimationFrame=(ze,We)=>{if(Ae){const xe=new N(ze,We);return G.push(xe),xe}else return(0,t.scheduleAtNextAnimationFrame)(ze,We)}})();function K(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=K;function ne(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=ne;const re=8,we=function(Y,G){return G};class ae extends p.Disposable{constructor(G,ue,Ae,Te=we,ze=re){super();let We=null,xe=0;const Ye=this._register(new y.TimeoutTimer),ft=()=>{xe=new Date().getTime(),Ae(We),We=null};this._register(_(G,ue,It=>{We=Te(We,It);const gt=new Date().getTime()-xe;gt>=ze?(Ye.cancel(),ft()):Ye.setIfNotSet(ft,ze-gt)}))}}function ve(Y,G,ue,Ae,Te){return new ae(Y,G,ue,Ae,Te)}t.addDisposableThrottledListener=ve;function fe(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=fe;function ge(Y){if(Y!==document.body)return new ee(Y.clientWidth,Y.clientHeight);if(l.isIOS&&window.visualViewport)return new ee(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ee(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ee(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ee(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ge;class ye{static convertToPixels(G,ue){return parseFloat(ue)||0}static getDimension(G,ue,Ae){const Te=fe(G);let ze="0";return Te&&(Te.getPropertyValue?ze=Te.getPropertyValue(ue):ze=Te.getAttribute(Ae)),ye.convertToPixels(G,ze)}static getBorderLeftWidth(G){return ye.getDimension(G,"border-left-width","borderLeftWidth")}static getBorderRightWidth(G){return ye.getDimension(G,"border-right-width","borderRightWidth")}static getBorderTopWidth(G){return ye.getDimension(G,"border-top-width","borderTopWidth")}static getBorderBottomWidth(G){return ye.getDimension(G,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(G){return ye.getDimension(G,"padding-left","paddingLeft")}static getPaddingRight(G){return ye.getDimension(G,"padding-right","paddingRight")}static getPaddingTop(G){return ye.getDimension(G,"padding-top","paddingTop")}static getPaddingBottom(G){return ye.getDimension(G,"padding-bottom","paddingBottom")}static getMarginLeft(G){return ye.getDimension(G,"margin-left","marginLeft")}static getMarginTop(G){return ye.getDimension(G,"margin-top","marginTop")}static getMarginRight(G){return ye.getDimension(G,"margin-right","marginRight")}static getMarginBottom(G){return ye.getDimension(G,"margin-bottom","marginBottom")}}class ee{constructor(G,ue){this.width=G,this.height=ue}with(G=this.width,ue=this.height){return G!==this.width||ue!==this.height?new ee(G,ue):this}static is(G){return typeof G=="object"&&typeof G.height=="number"&&typeof G.width=="number"}static lift(G){return G instanceof ee?G:new ee(G.width,G.height)}static equals(G,ue){return G===ue?!0:!G||!ue?!1:G.width===ue.width&&G.height===ue.height}}t.Dimension=ee,ee.None=new ee(0,0);function he(Y){let G=Y.offsetParent,ue=Y.offsetTop,Ae=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){ue-=Y.scrollTop;const Te=k(Y)?null:fe(Y);Te&&(Ae-=Te.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===G&&(Ae+=ye.getBorderLeftWidth(Y),ue+=ye.getBorderTopWidth(Y),ue+=Y.offsetTop,Ae+=Y.offsetLeft,G=Y.offsetParent)}return{left:Ae,top:ue}}t.getTopLeftOffset=he;function te(Y,G,ue){typeof G=="number"&&(Y.style.width=`${G}px`),typeof ue=="number"&&(Y.style.height=`${ue}px`)}t.size=te;function Z(Y,G,ue,Ae,Te,ze="absolute"){typeof G=="number"&&(Y.style.top=`${G}px`),typeof ue=="number"&&(Y.style.right=`${ue}px`),typeof Ae=="number"&&(Y.style.bottom=`${Ae}px`),typeof Te=="number"&&(Y.style.left=`${Te}px`),Y.style.position=ze}t.position=Z;function se(Y){const G=Y.getBoundingClientRect();return{left:G.left+t.StandardWindow.scrollX,top:G.top+t.StandardWindow.scrollY,width:G.width,height:G.height}}t.getDomNodePagePosition=se;function ie(Y){let G=Y,ue=1;do{const Ae=fe(G).zoom;Ae!=null&&Ae!=="1"&&(ue*=Ae),G=G.parentElement}while(G!==null&&G!==document.documentElement);return ue}t.getDomNodeZoomLevel=ie,t.StandardWindow=new class{get scrollX(){return typeof window.scrollX=="number"?window.scrollX:document.body.scrollLeft+document.documentElement.scrollLeft}get scrollY(){return typeof window.scrollY=="number"?window.scrollY:document.body.scrollTop+document.documentElement.scrollTop}};function T(Y){const G=ye.getMarginLeft(Y)+ye.getMarginRight(Y);return Y.offsetWidth+G}t.getTotalWidth=T;function $(Y){const G=ye.getBorderLeftWidth(Y)+ye.getBorderRightWidth(Y),ue=ye.getPaddingLeft(Y)+ye.getPaddingRight(Y);return Y.offsetWidth-G-ue}t.getContentWidth=$;function X(Y){const G=ye.getMarginLeft(Y)+ye.getMarginRight(Y);return Y.scrollWidth+G}t.getTotalScrollWidth=X;function R(Y){const G=ye.getBorderTopWidth(Y)+ye.getBorderBottomWidth(Y),ue=ye.getPaddingTop(Y)+ye.getPaddingBottom(Y);return Y.offsetHeight-G-ue}t.getContentHeight=R;function f(Y){const G=ye.getMarginTop(Y)+ye.getMarginBottom(Y);return Y.offsetHeight+G}t.getTotalHeight=f;function I(Y,G){if(Y===null)return 0;const ue=he(Y),Ae=he(G);return ue.left-Ae.left}function U(Y,G){const ue=G.map(Te=>Math.max(X(Te),T(Te))+I(Te,Y)||0);return Math.max(...ue)}t.getLargestChildWidth=U;function q(Y,G){for(;Y;){if(Y===G)return!0;Y=Y.parentNode}return!1}t.isAncestor=q;const W="parentFlowToElementId";function O(Y,G){Y.dataset[W]=G.id}t.setParentFlowTo=O;function H(Y){const G=Y.dataset[W];return typeof G=="string"?document.getElementById(G):null}function V(Y,G){let ue=Y;for(;ue;){if(ue===G)return!0;if(ue instanceof HTMLElement){const Ae=H(ue);if(Ae){ue=Ae;continue}}ue=ue.parentNode}return!1}t.isAncestorUsingFlowTo=V;function F(Y,G,ue){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(G))return Y;if(ue){if(typeof ue=="string"){if(Y.classList.contains(ue))return null}else if(Y===ue)return null}Y=Y.parentNode}return null}t.findParentWithClass=F;function z(Y,G,ue){return!!F(Y,G,ue)}t.hasParentWithClass=z;function k(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=k;function B(Y){return!!j(Y)}t.isInShadowDOM=B;function j(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return k(Y)?Y:null}t.getShadowRoot=j;function J(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=J;function ce(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("style");return G.type="text/css",G.media="screen",Y.appendChild(G),G}t.createStyleSheet=ce;function de(Y=document.getElementsByTagName("head")[0]){const G=document.createElement("meta");return Y.appendChild(G),G}t.createMetaElement=de;let Ee=null;function _e(){return Ee||(Ee=ce()),Ee}function ke(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function Ie(Y,G,ue=_e()){!ue||!G||ue.sheet.insertRule(Y+"{"+G+"}",0)}t.createCSSRule=Ie;function De(Y,G=_e()){if(!G)return;const ue=ke(G),Ae=[];for(let Te=0;Te<ue.length;Te++)ue[Te].selectorText.indexOf(Y)!==-1&&Ae.push(Te);for(let Te=Ae.length-1;Te>=0;Te--)G.sheet.deleteRule(Ae[Te])}t.removeCSSRulesContainingSelector=De;function Pe(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Pe,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:D.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:D.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:D.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:function(Y,G){Y.preventDefault?Y.preventDefault():Y.returnValue=!1,G&&(Y.stopPropagation?Y.stopPropagation():Y.cancelBubble=!0)}};function Me(Y){const G=[];for(let ue=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ue++)G[ue]=Y.scrollTop,Y=Y.parentNode;return G}t.saveParentsScrollTop=Me;function Ge(Y,G){for(let ue=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ue++)Y.scrollTop!==G[ue]&&(Y.scrollTop=G[ue]),Y=Y.parentNode}t.restoreParentsScrollTop=Ge;class He extends p.Disposable{constructor(G){super();this._onDidFocus=this._register(new m.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new m.Emitter),this.onDidBlur=this._onDidBlur.event;let ue=He.hasFocusWithin(G),Ae=!1;const Te=()=>{Ae=!1,ue||(ue=!0,this._onDidFocus.fire())},ze=()=>{ue&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,ue=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{He.hasFocusWithin(G)!==ue&&(ue?ze():Te())},this._register(_(G,t.EventType.FOCUS,Te,!0)),this._register(_(G,t.EventType.BLUR,ze,!0)),this._register(_(G,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(_(G,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}static hasFocusWithin(G){const ue=j(G),Ae=ue?ue.activeElement:document.activeElement;return q(Ae,G)}refreshState(){this._refreshStateHandler()}}function Ue(Y){return new He(Y)}t.trackFocus=Ue;function Je(Y,G){return Y.after(G),G}t.after=Je;function je(Y,...G){if(Y.append(...G),G.length===1&&typeof G[0]!="string")return G[0]}t.append=je;function Oe(Y,G){return Y.insertBefore(G,Y.firstChild),G}t.prepend=Oe;function x(Y,...G){Y.innerText="",je(Y,...G)}t.reset=x;const oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var be;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(be=t.Namespace||(t.Namespace={}));function Ce(Y,G,ue,...Ae){const Te=oe.exec(G);if(!Te)throw new Error("Bad use of emmet");ue={...ue||{}};const ze=Te[1]||"div";let We;return Y!==be.HTML?We=document.createElementNS(Y,ze):We=document.createElement(ze),Te[3]&&(We.id=Te[3]),Te[4]&&(We.className=Te[4].replace(/\./g," ").trim()),Object.keys(ue).forEach(xe=>{const Ye=ue[xe];typeof Ye!="undefined"&&(/^on\w+$/.test(xe)?We[xe]=Ye:xe==="selected"?Ye&&We.setAttribute(xe,"true"):We.setAttribute(xe,Ye))}),We.append(...Ae),We}function Fe(Y,G,...ue){return Ce(be.HTML,Y,G,...ue)}t.$=Fe,Fe.SVG=function(Y,G,...ue){return Ce(be.SVG,Y,G,...ue)};function Re(Y,G){const ue=[];return Y.forEach((Ae,Te)=>{Te>0&&(G instanceof Node?ue.push(G.cloneNode()):ue.push(document.createTextNode(G))),ue.push(Ae)}),ue}t.join=Re;function Ve(...Y){for(const G of Y)G.style.display="",G.removeAttribute("aria-hidden")}t.show=Ve;function tt(...Y){for(const G of Y)G.style.display="none",G.setAttribute("aria-hidden","true")}t.hide=tt;function Xe(Y,G){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(G))return Y;Y=Y.parentNode}return null}function qe(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&Xe(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=qe;function Le(Y){return Array.prototype.slice.call(document.getElementsByTagName(Y),0)}t.getElementsByTagName=Le;function le(Y){return G=>{G.preventDefault(),G.stopPropagation(),Y(G)}}t.finalHandler=le;function Se(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=Se;function Ne(Y){const G=window.devicePixelRatio*Y;return Math.max(1,Math.floor(G))/window.devicePixelRatio}t.computeScreenAwareSize=Ne;function $e(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=$e;const Ze=780,Qe=640;function et(Y){const G=Math.floor(window.screenLeft+window.innerWidth/2-Ze/2),ue=Math.floor(window.screenTop+window.innerHeight/2-Qe/2);window.open(Y,"_blank",`width=${Ze},height=${Qe},top=${ue},left=${G}`)}t.windowOpenPopup=et;function st(Y,G=!0){const ue=window.open();return ue?(G&&(ue.opener=null),ue.location.href=Y,!0):!1}t.windowOpenWithSuccess=st;function ht(Y){const G=()=>{Y(),ue=(0,t.scheduleAtNextAnimationFrame)(G)};let ue=(0,t.scheduleAtNextAnimationFrame)(G);return(0,p.toDisposable)(()=>ue.dispose())}t.animate=ht,A.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function Dt(Y){return Y?`url('${A.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=Dt;function Ft(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Ft;function zt(Y,G){let ue;if(e.URI.isUri(Y))ue=Y.toString(!0);else{const Te=new Blob([Y]);ue=URL.createObjectURL(Te),setTimeout(()=>URL.revokeObjectURL(ue))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=G,Ae.href=ue,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.triggerDownload=zt;function hi(){return new Promise(Y=>{const G=document.createElement("input");document.body.appendChild(G),G.type="file",G.multiple=!0,m.Event.once(m.Event.fromDOMEventEmitter(G,"input"))(()=>{Y((0,r.withNullAsUndefined)(G.files))}),G.click(),setTimeout(()=>document.body.removeChild(G))})}t.triggerUpload=hi;var yt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(yt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:yt.BROWSER,guess:!1}:(l.isMacintosh||l.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:yt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function Ut(Y,G=!1){const ue=document.createElement("a");return h.addHook("afterSanitizeAttributes",Ae=>{for(const Te of["href","src"])if(Ae.hasAttribute(Te)){const ze=Ae.getAttribute(Te);if(Te==="href"&&ze.startsWith("#"))continue;if(ue.href=ze,!Y.includes(ue.protocol.replace(/:$/,""))){if(G&&Te==="src"&&ue.href.startsWith("data:"))continue;Ae.removeAttribute(Te)}}}),(0,p.toDisposable)(()=>{h.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Ut;const fi=[A.Schemas.http,A.Schemas.https,A.Schemas.command];function gi(Y,G){const ue={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Ae=Ut(fi);try{const Te=h.sanitize(G,{...ue,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Te}finally{Ae.dispose()}}t.safeInnerHtml=gi;function mi(Y){const G=new Uint16Array(Y.length);for(let Te=0;Te<G.length;Te++)G[Te]=Y.charCodeAt(Te);let ue="";const Ae=new Uint8Array(G.buffer);for(let Te=0;Te<Ae.length;Te++)ue+=String.fromCharCode(Ae[Te]);return ue}function pi(Y){return btoa(mi(Y))}t.multibyteAwareBtoa=pi;class dt extends m.Emitter{constructor(){super();this._subscriptions=new p.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(_(window,"keydown",G=>{if(G.defaultPrevented)return;const ue=new P.StandardKeyboardEvent(G);if(!(ue.keyCode===6&&G.repeat)){if(G.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(G.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(G.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(G.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(ue.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=G,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(_(window,"keyup",G=>{G.defaultPrevented||(!G.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!G.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!G.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!G.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=G.altKey,this._keyStatus.ctrlKey=G.ctrlKey,this._keyStatus.metaKey=G.metaKey,this._keyStatus.shiftKey=G.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=G,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(_(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(_(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(_(document.body,"mousemove",G=>{G.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(_(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.instance||(dt.instance=new dt),dt.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=dt;function bi(Y){const G=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return G?G.pop():void 0}t.getCookieValue=bi;class wi extends p.Disposable{constructor(G,ue){super();this.element=G,this.callbacks=ue,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(_(this.element,t.EventType.DRAG_ENTER,G=>{this.counter++,this.dragStartTime=G.timeStamp,this.callbacks.onDragEnter(G)})),this._register(_(this.element,t.EventType.DRAG_OVER,G=>{G.preventDefault(),this.callbacks.onDragOver?.(G,G.timeStamp-this.dragStartTime)})),this._register(_(this.element,t.EventType.DRAG_LEAVE,G=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(G))})),this._register(_(this.element,t.EventType.DRAG_END,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(G)})),this._register(_(this.element,t.EventType.DROP,G=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(G)}))}}t.DragAndDropObserver=wi;function vi(Y,G){const ue=Y instanceof HTMLElement?Y.getBoundingClientRect():Y,Ae=G.getBoundingClientRect(),Te=Math.max(Ae.top-ue.top,0),ze=Math.max(ue.width-(ue.right-Ae.right),0),We=Math.max(ue.height-(ue.bottom-Ae.bottom),0),xe=Math.max(Ae.left-ue.left,0);return{top:Te,right:ze,bottom:We,left:xe}}t.computeClippingRect=vi;const Di=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(Y,...G){let ue,Ae;Array.isArray(G[0])?(ue={},Ae=G[0]):(ue=G[0]||{},Ae=G[1]);const Te=Di.exec(Y);if(!Te||!Te.groups)throw new Error("Bad use of h");const ze=Te.groups.tag||"div",We=document.createElement(ze);Te.groups.id&&(We.id=Te.groups.id),Te.groups.class&&(We.className=Te.groups.class.replace(/\./g," ").trim());const xe={};if(Te.groups.name&&(xe[Te.groups.name]=We),Ae)for(const Ye of Ae)Ye instanceof HTMLElement?We.appendChild(Ye):typeof Ye=="string"?We.append(Ye):(Object.assign(xe,Ye),We.appendChild(Ye.root));for(const[Ye,ft]of Object.entries(ue))if(Ye==="style")for(const[It,gt]of Object.entries(ft))We.style.setProperty(Vt(It),typeof gt=="number"?gt+"px":""+gt);else Ye==="tabIndex"?We.tabIndex=ft:We.setAttribute(Vt(Ye),ft.toString());return xe.root=We,xe}t.h=yi;function Vt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[50],pe([1,0,4,2,105]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StaticDND=t.DragAndDropData=t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class M extends i.Disposable{constructor(h,p){super();this._register((0,D.addDisposableListener)(h,"dragover",A=>{A.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{p(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(A=>{this._register((0,D.addDisposableListener)(h,A,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=M,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:P.Mimes.text};function y(m,h,p){const A=document.createElement("div");A.className=p,A.textContent=h,m.dataTransfer&&(document.body.appendChild(A),m.dataTransfer.setDragImage(A,-10,-10),setTimeout(()=>document.body.removeChild(A),0))}t.applyDragImage=y;class b{constructor(h){this.data=h}update(){}getData(){return this.data}}t.DragAndDropData=b,t.StaticDND={CurrentDragAndDropData:void 0}}),define(me[51],pe([1,0,4]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(l,r={}){const e=M(r);return e.textContent=l,e}t.renderText=i;function P(l,r={}){const e=M(r);return m(e,h(l,!!r.renderCodeSegments),r.actionHandler,r.renderCodeSegments),e}t.renderFormattedText=P;function M(l){const r=l.inline?"span":"div",e=document.createElement(r);return l.className&&(e.className=l.className),e}t.createElement=M;class y{constructor(r){this.source=r,this.index=0}eos(){return this.index>=this.source.length}next(){const r=this.peek();return this.advance(),r}peek(){return this.source[this.index]}advance(){this.index++}}var b;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(b||(b={}));function m(l,r,e,c){let g;if(r.type===2)g=document.createTextNode(r.content||"");else if(r.type===3)g=document.createElement("b");else if(r.type===4)g=document.createElement("i");else if(r.type===7&&c)g=document.createElement("code");else if(r.type===5&&e){const E=document.createElement("a");e.disposables.add(D.addStandardDisposableListener(E,"click",_=>{e.callback(String(r.index),_)})),g=E}else r.type===8?g=document.createElement("br"):r.type===1&&(g=l);g&&l!==g&&l.appendChild(g),g&&Array.isArray(r.children)&&r.children.forEach(E=>{m(g,E,e,c)})}function h(l,r){const e={type:1,children:[]};let c=0,g=e;const E=[],_=new y(l);for(;!_.eos();){let u=_.next();const d=u==="\\"&&A(_.peek(),r)!==0;if(d&&(u=_.next()),!d&&p(u,r)&&u===_.peek()){_.advance(),g.type===2&&(g=E.pop());const w=A(u,r);if(g.type===w||g.type===5&&w===6)g=E.pop();else{const S={type:w,children:[]};w===5&&(S.index=c,c++),g.children.push(S),E.push(g),g=S}}else if(u===`
`)g.type===2&&(g=E.pop()),g.children.push({type:8});else if(g.type!==2){const w={type:2,content:u};g.children.push(w),E.push(g),g=w}else g.content+=u}return g.type===2&&(g=E.pop()),E.length,e}function p(l,r){return A(l,r)!==0}function A(l,r){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return r?7:0;default:return 0}}}),define(me[52],pe([1,0,4,2]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class P{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(y,b){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const m=this._onStopCallback;this._onStopCallback=null,y&&m&&m(b)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(y,b,m,h,p){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=h,this._onStopCallback=p;let A=y;try{y.setPointerCapture(b),this._hooks.add((0,i.toDisposable)(()=>{y.releasePointerCapture(b)}))}catch{A=window}this._hooks.add(D.addDisposableListener(A,D.EventType.POINTER_MOVE,l=>{if(l.buttons!==m){this.stopMonitoring(!0);return}l.preventDefault(),this._pointerMoveCallback(l)})),this._hooks.add(D.addDisposableListener(A,D.EventType.POINTER_UP,l=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=P});var Ke=this&&this.__decorate||function(Q,t,D,i){var P=arguments.length,M=P<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,D):i,y;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(Q,t,D,i);else for(var b=Q.length-1;b>=0;b--)(y=Q[b])&&(M=(P<3?y(M):P>3?y(t,D,M):y(t,D))||M);return P>3&&M&&Object.defineProperty(t,D,M),M};define(me[22],pe([1,0,4,14,25,2]),function(Q,t,D,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var y;(function(m){m.Tap="-monaco-gesturetap",m.Change="-monaco-gesturechange",m.Start="-monaco-gesturestart",m.End="-monaco-gesturesend",m.Contextmenu="-monaco-gesturecontextmenu"})(y=t.EventType||(t.EventType={}));class b extends M.Disposable{constructor(){super();this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(D.addDisposableListener(document,"touchstart",h=>this.onTouchStart(h),{passive:!1})),this._register(D.addDisposableListener(document,"touchend",h=>this.onTouchEnd(h))),this._register(D.addDisposableListener(document,"touchmove",h=>this.onTouchMove(h),{passive:!1}))}static addTarget(h){return b.isTouchDevice()?(b.INSTANCE||(b.INSTANCE=new b),b.INSTANCE.targets.push(h),{dispose:()=>{b.INSTANCE.targets=b.INSTANCE.targets.filter(p=>p!==h)}}):M.Disposable.None}static ignoreTarget(h){return b.isTouchDevice()?(b.INSTANCE||(b.INSTANCE=new b),b.INSTANCE.ignoreTargets.push(h),{dispose:()=>{b.INSTANCE.ignoreTargets=b.INSTANCE.ignoreTargets.filter(p=>p!==h)}}):M.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(h){const p=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let A=0,l=h.targetTouches.length;A<l;A++){const r=h.targetTouches.item(A);this.activeTouches[r.identifier]={id:r.identifier,initialTarget:r.target,initialTimeStamp:p,initialPageX:r.pageX,initialPageY:r.pageY,rollingTimestamps:[p],rollingPageX:[r.pageX],rollingPageY:[r.pageY]};const e=this.newGestureEvent(y.Start,r.target);e.pageX=r.pageX,e.pageY=r.pageY,this.dispatchEvent(e)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}onTouchEnd(h){const p=Date.now(),A=Object.keys(this.activeTouches).length;for(let l=0,r=h.changedTouches.length;l<r;l++){const e=h.changedTouches.item(l);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const c=this.activeTouches[e.identifier],g=Date.now()-c.initialTimeStamp;if(g<b.HOLD_DELAY&&Math.abs(c.initialPageX-i.tail(c.rollingPageX))<30&&Math.abs(c.initialPageY-i.tail(c.rollingPageY))<30){const E=this.newGestureEvent(y.Tap,c.initialTarget);E.pageX=i.tail(c.rollingPageX),E.pageY=i.tail(c.rollingPageY),this.dispatchEvent(E)}else if(g>=b.HOLD_DELAY&&Math.abs(c.initialPageX-i.tail(c.rollingPageX))<30&&Math.abs(c.initialPageY-i.tail(c.rollingPageY))<30){const E=this.newGestureEvent(y.Contextmenu,c.initialTarget);E.pageX=i.tail(c.rollingPageX),E.pageY=i.tail(c.rollingPageY),this.dispatchEvent(E)}else if(A===1){const E=i.tail(c.rollingPageX),_=i.tail(c.rollingPageY),u=i.tail(c.rollingTimestamps)-c.rollingTimestamps[0],d=E-c.rollingPageX[0],w=_-c.rollingPageY[0],S=this.targets.filter(L=>c.initialTarget instanceof Node&&L.contains(c.initialTarget));this.inertia(S,p,Math.abs(d)/u,d>0?1:-1,E,Math.abs(w)/u,w>0?1:-1,_)}this.dispatchEvent(this.newGestureEvent(y.End,c.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}newGestureEvent(h,p){const A=document.createEvent("CustomEvent");return A.initEvent(h,!1,!0),A.initialTarget=p,A.tapCount=0,A}dispatchEvent(h){if(h.type===y.Tap){const p=new Date().getTime();let A=0;p-this._lastSetTapCountTime>b.CLEAR_TAP_COUNT_TIME?A=1:A=2,this._lastSetTapCountTime=p,h.tapCount=A}else(h.type===y.Change||h.type===y.Contextmenu)&&(this._lastSetTapCountTime=0);for(let p=0;p<this.ignoreTargets.length;p++)if(h.initialTarget instanceof Node&&this.ignoreTargets[p].contains(h.initialTarget))return;this.targets.forEach(p=>{h.initialTarget instanceof Node&&p.contains(h.initialTarget)&&(p.dispatchEvent(h),this.dispatched=!0)})}inertia(h,p,A,l,r,e,c,g){this.handle=D.scheduleAtNextAnimationFrame(()=>{const E=Date.now(),_=E-p;let u=0,d=0,w=!0;A+=b.SCROLL_FRICTION*_,e+=b.SCROLL_FRICTION*_,A>0&&(w=!1,u=l*A*_),e>0&&(w=!1,d=c*e*_);const S=this.newGestureEvent(y.Change);S.translationX=u,S.translationY=d,h.forEach(L=>L.dispatchEvent(S)),w||this.inertia(h,E,A,l,r+u,e,c,g+d)})}onTouchMove(h){const p=Date.now();for(let A=0,l=h.changedTouches.length;A<l;A++){const r=h.changedTouches.item(A);if(!this.activeTouches.hasOwnProperty(String(r.identifier))){console.warn("end of an UNKNOWN touch",r);continue}const e=this.activeTouches[r.identifier],c=this.newGestureEvent(y.Change,e.initialTarget);c.translationX=r.pageX-i.tail(e.rollingPageX),c.translationY=r.pageY-i.tail(e.rollingPageY),c.pageX=r.pageX,c.pageY=r.pageY,this.dispatchEvent(c),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(r.pageX),e.rollingPageY.push(r.pageY),e.rollingTimestamps.push(p)}this.dispatched&&(h.preventDefault(),h.stopPropagation(),this.dispatched=!1)}}b.SCROLL_FRICTION=-.005,b.HOLD_DELAY=700,b.CLEAR_TAP_COUNT_TIME=400,Ke([P.memoize],b,"isTouchDevice",null),t.Gesture=b}),define(me[53],pe([1,0,4,5,82]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const P=2e4;let M,y,b,m,h;function p(e){M=document.createElement("div"),M.className="monaco-aria-container";const c=()=>{const E=document.createElement("div");return E.className="monaco-alert",E.setAttribute("role","alert"),E.setAttribute("aria-atomic","true"),M.appendChild(E),E};y=c(),b=c();const g=()=>{const E=document.createElement("div");return E.className="monaco-status",E.setAttribute("role","complementary"),E.setAttribute("aria-live","polite"),E.setAttribute("aria-atomic","true"),M.appendChild(E),E};m=g(),h=g(),e.appendChild(M)}t.setARIAContainer=p;function A(e){!M||(y.textContent!==e?(D.clearNode(b),r(y,e)):(D.clearNode(y),r(b,e)))}t.alert=A;function l(e){!M||(i.isMacintosh?A(e):m.textContent!==e?(D.clearNode(h),r(m,e)):(D.clearNode(m),r(h,e)))}t.status=l;function r(e,c){D.clearNode(e),c.length>P&&(c=c.substr(0,P)),e.textContent=c,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[113],pe([1,0,4,11]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const P=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function M(b){const m=new Array;let h,p=0,A=0;for(;(h=P.exec(b))!==null;){A=h.index||0,m.push(b.substring(p,A)),p=(h.index||0)+h[0].length;const[,l,r]=h;m.push(l?`$(${r})`:y({id:r}))}return p<b.length&&m.push(b.substring(p)),m}t.renderLabelWithIcons=M;function y(b){const m=D.$("span");return m.classList.add(...i.CSSIcon.asClassNameArray(b)),m}t.renderIcon=y}),define(me[114],pe([1,0,4]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(M){try{M.parentElement?.removeChild(M)}catch{}}class P{constructor(y){this.renderers=y,this.cache=new Map}alloc(y){let b=this.getTemplateCache(y).pop();if(!b){const m=(0,D.$)(".monaco-list-row"),p=this.getRenderer(y).renderTemplate(m);b={domNode:m,templateId:y,templateData:p}}return b}release(y){!y||this.releaseRow(y)}releaseRow(y){const{domNode:b,templateId:m}=y;b&&(b.classList.remove("scrolling"),i(b)),this.getTemplateCache(m).push(y)}getTemplateCache(y){let b=this.cache.get(y);return b||(b=[],this.cache.set(y,b)),b}dispose(){this.cache.forEach((y,b)=>{for(const m of y)this.getRenderer(b).disposeTemplate(m.templateData),m.templateData=null}),this.cache.clear()}getRenderer(y){const b=this.renderers.get(y);if(!b)throw new Error(`No renderer found for ${y}`);return b}}t.RowCache=P}),define(me[115],pe([1,0,8,2]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class P extends i.Disposable{constructor(y,b,m){super();this._visibility=y,this._visibleClassName=b,this._invisibleClassName=m,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new D.TimeoutTimer)}setVisibility(y){this._visibility!==y&&(this._visibility=y,this._updateShouldBeVisible())}setShouldBeVisible(y){this._rawShouldBeVisible=y,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const y=this._applyVisibilitySetting();this._shouldBeVisible!==y&&(this._shouldBeVisible=y,this.ensureVisibility())}setIsNeeded(y){this._isNeeded!==y&&(this._isNeeded=y,this.ensureVisibility())}setDomNode(y){this._domNode=y,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(y){this._revealTimer.cancel(),!!this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(y?" fade":"")))}}t.ScrollbarVisibilityController=P}),define(me[116],pe([1,0,4,22,14,3,2,5]),function(Q,t,D,i,P,M,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class m extends y.Disposable{constructor(p,A,l,r){super();this.selected=0,this.selectBoxOptions=r||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new M.Emitter),this.styles=l,this.registerListeners(),this.setOptions(p,A)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(p=>{this._register(D.addDisposableListener(this.selectElement,p,A=>{this.selectElement.focus()}))}),this._register(D.addStandardDisposableListener(this.selectElement,"click",p=>{D.EventHelper.stop(p,!0)})),this._register(D.addStandardDisposableListener(this.selectElement,"change",p=>{this.selectElement.title=p.target.value,this._onDidSelect.fire({index:p.target.selectedIndex,selected:p.target.value})})),this._register(D.addStandardDisposableListener(this.selectElement,"keydown",p=>{let A=!1;b.isMacintosh?(p.keyCode===18||p.keyCode===16||p.keyCode===10)&&(A=!0):(p.keyCode===18&&p.altKey||p.keyCode===10||p.keyCode===3)&&(A=!0),A&&p.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(p,A){(!this.options||!P.equals(this.options,p))&&(this.options=p,this.selectElement.options.length=0,this.options.forEach((l,r)=>{this.selectElement.add(this.createOption(l.text,r,l.isDisabled))})),A!==void 0&&this.select(A)}select(p){this.options.length===0?this.selected=0:p>=0&&p<this.options.length?this.selected=p:p>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(p){this.selectBoxOptions.ariaLabel=p,this.selectElement.setAttribute("aria-label",p)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(p){this.selectElement.tabIndex=p?0:-1}render(p){p.classList.add("select-container"),p.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(p){this.styles=p,this.applyStyles()}applyStyles(){if(this.selectElement){const p=this.styles.selectBackground?this.styles.selectBackground.toString():"",A=this.styles.selectForeground?this.styles.selectForeground.toString():"",l=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=p,this.selectElement.style.color=A,this.selectElement.style.borderColor=l}}createOption(p,A,l){const r=document.createElement("option");return r.value=p,r.text=p,r.disabled=!!l,r}}t.SelectBoxNative=m}),define(me[54],pe([1,0,23,14,8,111,3,26]),function(Q,t,D,i,P,M,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function m(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.isFilterResult=m;function h(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.getVisibleState=h;function p(l){return typeof l.collapsible=="boolean"}class A{constructor(r,e,c,g={}){this.user=r,this.list=e,this.rootRef=[],this.eventBufferer=new y.EventBufferer,this._onDidChangeCollapseState=new y.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new y.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new y.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new P.Delayer(P.MicrotaskDelay),this.collapseByDefault=typeof g.collapseByDefault=="undefined"?!1:g.collapseByDefault,this.filter=g.filter,this.autoExpandSingleChildren=typeof g.autoExpandSingleChildren=="undefined"?!1:g.autoExpandSingleChildren,this.root={parent:void 0,element:c,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(r,e,c=b.Iterable.empty(),g={}){if(r.length===0)throw new D.TreeError(this.user,"Invalid tree location");g.diffIdentityProvider?this.spliceSmart(g.diffIdentityProvider,r,e,c,g):this.spliceSimple(r,e,c,g)}spliceSmart(r,e,c,g=b.Iterable.empty(),E,_=E.diffDepth??0){const{parentNode:u}=this.getParentNodeWithListIndex(e);if(!u.lastDiffIds)return this.spliceSimple(e,c,g,E);const d=[...g],w=e[e.length-1],S=new M.LcsDiff({getElements:()=>u.lastDiffIds},{getElements:()=>[...u.children.slice(0,w),...d,...u.children.slice(w+c)].map(a=>r.getId(a.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return u.lastDiffIds=void 0,this.spliceSimple(e,c,d,E);const L=e.slice(0,-1),C=(a,o,v)=>{if(_>0)for(let N=0;N<v;N++)a--,o--,this.spliceSmart(r,[...L,a,0],Number.MAX_SAFE_INTEGER,d[o].children,E,_-1)};let n=Math.min(u.children.length,w+c),s=d.length;for(const a of S.changes.sort((o,v)=>v.originalStart-o.originalStart))C(n,s,n-(a.originalStart+a.originalLength)),n=a.originalStart,s=a.modifiedStart-w,this.spliceSimple([...L,n],a.originalLength,b.Iterable.slice(d,s,s+a.modifiedLength),E);C(n,s,n)}spliceSimple(r,e,c=b.Iterable.empty(),{onDidCreateNode:g,onDidDeleteNode:E,diffIdentityProvider:_}){const{parentNode:u,listIndex:d,revealed:w,visible:S}=this.getParentNodeWithListIndex(r),L=[],C=b.Iterable.map(c,ae=>this.createTreeNode(ae,u,u.visible?1:0,w,L,g)),n=r[r.length-1],s=u.children.length>0;let a=0;for(let ae=n;ae>=0&&ae<u.children.length;ae--){const ve=u.children[ae];if(ve.visible){a=ve.visibleChildIndex;break}}const o=[];let v=0,N=0;for(const ae of C)o.push(ae),N+=ae.renderNodeCount,ae.visible&&(ae.visibleChildIndex=a+v++);const K=(0,i.splice)(u.children,n,e,o);_?u.lastDiffIds?(0,i.splice)(u.lastDiffIds,n,e,o.map(ae=>_.getId(ae.element).toString())):u.lastDiffIds=u.children.map(ae=>_.getId(ae.element).toString()):u.lastDiffIds=void 0;let ne=0;for(const ae of K)ae.visible&&ne++;if(ne!==0)for(let ae=n+o.length;ae<u.children.length;ae++){const ve=u.children[ae];ve.visible&&(ve.visibleChildIndex-=ne)}if(u.visibleChildrenCount+=v-ne,w&&S){const ae=K.reduce((ve,fe)=>ve+(fe.visible?fe.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(u,N-ae),this.list.splice(d,ae,L)}if(K.length>0&&E){const ae=ve=>{E(ve),ve.children.forEach(ae)};K.forEach(ae)}this._onDidSplice.fire({insertedNodes:o,deletedNodes:K});const re=u.children.length>0;s!==re&&this.setCollapsible(r.slice(0,-1),re);let we=u;for(;we;){if(we.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}we=we.parent}}rerender(r){if(r.length===0)throw new D.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:c,revealed:g}=this.getTreeNodeWithListIndex(r);e.visible&&g&&this.list.splice(c,1,[e])}updateElementHeight(r,e){if(r.length===0)throw new D.TreeError(this.user,"Invalid tree location");const{listIndex:c}=this.getTreeNodeWithListIndex(r);this.list.updateElementHeight(c,e)}has(r){return this.hasTreeNode(r)}getListIndex(r){const{listIndex:e,visible:c,revealed:g}=this.getTreeNodeWithListIndex(r);return c&&g?e:-1}getListRenderCount(r){return this.getTreeNode(r).renderNodeCount}isCollapsible(r){return this.getTreeNode(r).collapsible}setCollapsible(r,e){const c=this.getTreeNode(r);typeof e=="undefined"&&(e=!c.collapsible);const g={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(r,g))}isCollapsed(r){return this.getTreeNode(r).collapsed}setCollapsed(r,e,c){const g=this.getTreeNode(r);typeof e=="undefined"&&(e=!g.collapsed);const E={collapsed:e,recursive:c||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(r,E))}_setCollapseState(r,e){const{node:c,listIndex:g,revealed:E}=this.getTreeNodeWithListIndex(r),_=this._setListNodeCollapseState(c,g,E,e);if(c!==this.root&&this.autoExpandSingleChildren&&_&&!p(e)&&c.collapsible&&!c.collapsed&&!e.recursive){let u=-1;for(let d=0;d<c.children.length;d++)if(c.children[d].visible)if(u>-1){u=-1;break}else u=d;u>-1&&this._setCollapseState([...r,u],e)}return _}_setListNodeCollapseState(r,e,c,g){const E=this._setNodeCollapseState(r,g,!1);if(!c||!r.visible||!E)return E;const _=r.renderNodeCount,u=this.updateNodeAfterCollapseChange(r),d=_-(e===-1?0:1);return this.list.splice(e+1,d,u.slice(1)),E}_setNodeCollapseState(r,e,c){let g;if(r===this.root?g=!1:(p(e)?(g=r.collapsible!==e.collapsible,r.collapsible=e.collapsible):r.collapsible?(g=r.collapsed!==e.collapsed,r.collapsed=e.collapsed):g=!1,g&&this._onDidChangeCollapseState.fire({node:r,deep:c})),!p(e)&&e.recursive)for(const E of r.children)g=this._setNodeCollapseState(E,e,!0)||g;return g}expandTo(r){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(r);for(;e.parent;)e=e.parent,r=r.slice(0,r.length-1),e.collapsed&&this._setCollapseState(r,{collapsed:!1,recursive:!1})})}refilter(){const r=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,r,e),this.refilterDelayer.cancel()}createTreeNode(r,e,c,g,E,_){const u={parent:e,element:r.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof r.collapsible=="boolean"?r.collapsible:typeof r.collapsed!="undefined",collapsed:typeof r.collapsed=="undefined"?this.collapseByDefault:r.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},d=this._filterNode(u,c);u.visibility=d,g&&E.push(u);const w=r.children||b.Iterable.empty(),S=g&&d!==0&&!u.collapsed,L=b.Iterable.map(w,s=>this.createTreeNode(s,u,d,S,E,_));let C=0,n=1;for(const s of L)u.children.push(s),n+=s.renderNodeCount,s.visible&&(s.visibleChildIndex=C++);return u.collapsible=u.collapsible||u.children.length>0,u.visibleChildrenCount=C,u.visible=d===2?C>0:d===1,u.visible?u.collapsed||(u.renderNodeCount=n):(u.renderNodeCount=0,g&&E.pop()),_?.(u),u}updateNodeAfterCollapseChange(r){const e=r.renderNodeCount,c=[];return this._updateNodeAfterCollapseChange(r,c),this._updateAncestorsRenderNodeCount(r.parent,c.length-e),c}_updateNodeAfterCollapseChange(r,e){if(r.visible===!1)return 0;if(e.push(r),r.renderNodeCount=1,!r.collapsed)for(const c of r.children)r.renderNodeCount+=this._updateNodeAfterCollapseChange(c,e);return this._onDidChangeRenderNodeCount.fire(r),r.renderNodeCount}updateNodeAfterFilterChange(r){const e=r.renderNodeCount,c=[];return this._updateNodeAfterFilterChange(r,r.visible?1:0,c),this._updateAncestorsRenderNodeCount(r.parent,c.length-e),c}_updateNodeAfterFilterChange(r,e,c,g=!0){let E;if(r!==this.root){if(E=this._filterNode(r,e),E===0)return r.visible=!1,r.renderNodeCount=0,!1;g&&c.push(r)}const _=c.length;r.renderNodeCount=r===this.root?0:1;let u=!1;if(!r.collapsed||E!==0){let d=0;for(const w of r.children)u=this._updateNodeAfterFilterChange(w,E,c,g&&!r.collapsed)||u,w.visible&&(w.visibleChildIndex=d++);r.visibleChildrenCount=d}else r.visibleChildrenCount=0;return r!==this.root&&(r.visible=E===2?u:E===1,r.visibility=E),r.visible?r.collapsed||(r.renderNodeCount+=c.length-_):(r.renderNodeCount=0,g&&c.pop()),this._onDidChangeRenderNodeCount.fire(r),r.visible}_updateAncestorsRenderNodeCount(r,e){if(e!==0)for(;r;)r.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(r),r=r.parent}_filterNode(r,e){const c=this.filter?this.filter.filter(r.element,e):1;return typeof c=="boolean"?(r.filterData=void 0,c?1:0):m(c)?(r.filterData=c.data,h(c.visibility)):(r.filterData=void 0,h(c))}hasTreeNode(r,e=this.root){if(!r||r.length===0)return!0;const[c,...g]=r;return c<0||c>e.children.length?!1:this.hasTreeNode(g,e.children[c])}getTreeNode(r,e=this.root){if(!r||r.length===0)return e;const[c,...g]=r;if(c<0||c>e.children.length)throw new D.TreeError(this.user,"Invalid tree location");return this.getTreeNode(g,e.children[c])}getTreeNodeWithListIndex(r){if(r.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:c,revealed:g,visible:E}=this.getParentNodeWithListIndex(r),_=r[r.length-1];if(_<0||_>e.children.length)throw new D.TreeError(this.user,"Invalid tree location");const u=e.children[_];return{node:u,listIndex:c,revealed:g,visible:E&&u.visible}}getParentNodeWithListIndex(r,e=this.root,c=0,g=!0,E=!0){const[_,...u]=r;if(_<0||_>e.children.length)throw new D.TreeError(this.user,"Invalid tree location");for(let d=0;d<_;d++)c+=e.children[d].renderNodeCount;return g=g&&!e.collapsed,E=E&&e.visible,u.length===0?{parentNode:e,listIndex:c,revealed:g,visible:E}:this.getParentNodeWithListIndex(u,e.children[_],c+1,g,E)}getNode(r=[]){return this.getTreeNode(r)}getNodeLocation(r){const e=[];let c=r;for(;c.parent;)e.push(c.parent.children.indexOf(c)),c=c.parent;return e.reverse()}getParentNodeLocation(r){if(r.length!==0)return r.length===1?[]:(0,i.tail2)(r)[0]}getFirstElementChild(r){const e=this.getTreeNode(r);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(r=[]){const e=this.getTreeNode(r);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(r){return r.children.length===0?r.element:this._getLastElementAncestor(r.children[r.children.length-1])}}t.IndexTreeModel=A}),define(me[117],pe([1,0,54,23,26]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class M{constructor(b,m,h={}){this.user=b,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new D.IndexTreeModel(b,m,null,h),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,h.sorter&&(this.sorter={compare(p,A){return h.sorter.compare(p.element,A.element)}}),this.identityProvider=h.identityProvider}get size(){return this.nodes.size}setChildren(b,m=P.Iterable.empty(),h={}){const p=this.getElementLocation(b);this._setChildren(p,this.preserveCollapseState(m),h)}_setChildren(b,m=P.Iterable.empty(),h){const p=new Set,A=new Set,l=e=>{if(e.element===null)return;const c=e;if(p.add(c.element),this.nodes.set(c.element,c),this.identityProvider){const g=this.identityProvider.getId(c.element).toString();A.add(g),this.nodesByIdentity.set(g,c)}h.onDidCreateNode?.(c)},r=e=>{if(e.element===null)return;const c=e;if(p.has(c.element)||this.nodes.delete(c.element),this.identityProvider){const g=this.identityProvider.getId(c.element).toString();A.has(g)||this.nodesByIdentity.delete(g)}h.onDidDeleteNode?.(c)};this.model.splice([...b,0],Number.MAX_VALUE,m,{...h,onDidCreateNode:l,onDidDeleteNode:r})}preserveCollapseState(b=P.Iterable.empty()){return this.sorter&&(b=[...b].sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(b,m=>{let h=this.nodes.get(m.element);if(!h&&this.identityProvider){const l=this.identityProvider.getId(m.element).toString();h=this.nodesByIdentity.get(l)}if(!h)return{...m,children:this.preserveCollapseState(m.children)};const p=typeof m.collapsible=="boolean"?m.collapsible:h.collapsible,A=typeof m.collapsed!="undefined"?m.collapsed:h.collapsed;return{...m,collapsible:p,collapsed:A,children:this.preserveCollapseState(m.children)}})}rerender(b){const m=this.getElementLocation(b);this.model.rerender(m)}updateElementHeight(b,m){const h=this.getElementLocation(b);this.model.updateElementHeight(h,m)}resort(b=null,m=!0){if(!this.sorter)return;const h=this.getElementLocation(b),p=this.model.getNode(h);this._setChildren(h,this.resortChildren(p,m),{})}resortChildren(b,m,h=!0){let p=[...b.children];return(m||h)&&(p=p.sort(this.sorter.compare.bind(this.sorter))),P.Iterable.map(p,A=>({element:A.element,collapsible:A.collapsible,collapsed:A.collapsed,children:this.resortChildren(A,m,!1)}))}getFirstElementChild(b=null){const m=this.getElementLocation(b);return this.model.getFirstElementChild(m)}getLastElementAncestor(b=null){const m=this.getElementLocation(b);return this.model.getLastElementAncestor(m)}has(b){return this.nodes.has(b)}getListIndex(b){const m=this.getElementLocation(b);return this.model.getListIndex(m)}getListRenderCount(b){const m=this.getElementLocation(b);return this.model.getListRenderCount(m)}isCollapsible(b){const m=this.getElementLocation(b);return this.model.isCollapsible(m)}setCollapsible(b,m){const h=this.getElementLocation(b);return this.model.setCollapsible(h,m)}isCollapsed(b){const m=this.getElementLocation(b);return this.model.isCollapsed(m)}setCollapsed(b,m,h){const p=this.getElementLocation(b);return this.model.setCollapsed(p,m,h)}expandTo(b){const m=this.getElementLocation(b);this.model.expandTo(m)}refilter(){this.model.refilter()}getNode(b=null){if(b===null)return this.model.getNode(this.model.rootRef);const m=this.nodes.get(b);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${b}`);return m}getNodeLocation(b){return b.element}getParentNodeLocation(b){if(b===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const m=this.nodes.get(b);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${b}`);const h=this.model.getNodeLocation(m),p=this.model.getParentNodeLocation(h);return this.model.getNode(p).element}getElementLocation(b){if(b===null)return[];const m=this.nodes.get(b);if(!m)throw new i.TreeError(this.user,`Tree element not found: ${b}`);return this.model.getNodeLocation(m)}}t.ObjectTreeModel=M}),define(me[17],pe([1,0,4,19,20,22,2]),function(Q,t,D,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class b extends y.Disposable{onclick(h,p){this._register(D.addDisposableListener(h,D.EventType.CLICK,A=>p(new P.StandardMouseEvent(A))))}onmousedown(h,p){this._register(D.addDisposableListener(h,D.EventType.MOUSE_DOWN,A=>p(new P.StandardMouseEvent(A))))}onmouseover(h,p){this._register(D.addDisposableListener(h,D.EventType.MOUSE_OVER,A=>p(new P.StandardMouseEvent(A))))}onmouseleave(h,p){this._register(D.addDisposableListener(h,D.EventType.MOUSE_LEAVE,A=>p(new P.StandardMouseEvent(A))))}onkeydown(h,p){this._register(D.addDisposableListener(h,D.EventType.KEY_DOWN,A=>p(new i.StandardKeyboardEvent(A))))}onkeyup(h,p){this._register(D.addDisposableListener(h,D.EventType.KEY_UP,A=>p(new i.StandardKeyboardEvent(A))))}oninput(h,p){this._register(D.addDisposableListener(h,D.EventType.INPUT,p))}onblur(h,p){this._register(D.addDisposableListener(h,D.EventType.BLUR,p))}onfocus(h,p){this._register(D.addDisposableListener(h,D.EventType.FOCUS,p))}onchange(h,p){this._register(D.addDisposableListener(h,D.EventType.CHANGE,p))}ignoreGesture(h){M.Gesture.ignoreTarget(h)}}t.Widget=b}),define(me[37],pe([1,0,52,17,8,4]),function(Q,t,D,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class y extends i.Widget{constructor(m){super();this._onActivate=m.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=m.bgWidth+"px",this.bgDomNode.style.height=m.bgHeight+"px",typeof m.top!="undefined"&&(this.bgDomNode.style.top="0px"),typeof m.left!="undefined"&&(this.bgDomNode.style.left="0px"),typeof m.bottom!="undefined"&&(this.bgDomNode.style.bottom="0px"),typeof m.right!="undefined"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=m.className,this.domNode.classList.add(...m.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof m.top!="undefined"&&(this.domNode.style.top=m.top+"px"),typeof m.left!="undefined"&&(this.domNode.style.left=m.left+"px"),typeof m.bottom!="undefined"&&(this.domNode.style.bottom=m.bottom+"px"),typeof m.right!="undefined"&&(this.domNode.style.right=m.right+"px"),this._pointerMoveMonitor=this._register(new D.GlobalPointerMoveMonitor),this._register(M.addStandardDisposableListener(this.bgDomNode,M.EventType.POINTER_DOWN,h=>this._arrowPointerDown(h))),this._register(M.addStandardDisposableListener(this.domNode,M.EventType.POINTER_DOWN,h=>this._arrowPointerDown(h))),this._pointerdownRepeatTimer=this._register(new P.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new P.TimeoutTimer)}_arrowPointerDown(m){if(!m.target||!(m.target instanceof Element))return;const h=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(h,200),this._pointerMoveMonitor.startMonitoring(m.target,m.pointerId,m.buttons,p=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),m.preventDefault()}}t.ScrollbarArrow=y}),define(me[55],pe([1,0,4,40,52,37,115,17,5]),function(Q,t,D,i,P,M,y,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const h=140;class p extends b.Widget{constructor(l){super();this._lazyRender=l.lazyRender,this._host=l.host,this._scrollable=l.scrollable,this._scrollByPage=l.scrollByPage,this._scrollbarState=l.scrollbarState,this._visibilityController=this._register(new y.ScrollbarVisibilityController(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new P.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(D.addDisposableListener(this.domNode.domNode,D.EventType.POINTER_DOWN,r=>this._domNodePointerDown(r)))}_createArrow(l){const r=this._register(new M.ScrollbarArrow(l));this.domNode.domNode.appendChild(r.bgDomNode),this.domNode.domNode.appendChild(r.domNode)}_createSlider(l,r,e,c){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(r),typeof e=="number"&&this.slider.setWidth(e),typeof c=="number"&&this.slider.setHeight(c),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(D.addDisposableListener(this.slider.domNode,D.EventType.POINTER_DOWN,g=>{g.button===0&&(g.preventDefault(),this._sliderPointerDown(g))})),this.onclick(this.slider.domNode,g=>{g.leftButton&&g.stopPropagation()})}_onElementSize(l){return this._scrollbarState.setVisibleSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(l){return this._scrollbarState.setScrollSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(l){return this._scrollbarState.setScrollPosition(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(l){l.target===this.domNode.domNode&&this._onPointerDown(l)}delegatePointerDown(l){const r=this.domNode.domNode.getClientRects()[0].top,e=r+this._scrollbarState.getSliderPosition(),c=r+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),g=this._sliderPointerPosition(l);e<=g&&g<=c?l.button===0&&(l.preventDefault(),this._sliderPointerDown(l)):this._onPointerDown(l)}_onPointerDown(l){let r,e;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")r=l.offsetX,e=l.offsetY;else{const g=D.getDomNodePagePosition(this.domNode.domNode);r=l.pageX-g.left,e=l.pageY-g.top}const c=this._pointerDownRelativePosition(r,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(c):this._scrollbarState.getDesiredScrollPositionFromOffset(c)),l.button===0&&(l.preventDefault(),this._sliderPointerDown(l))}_sliderPointerDown(l){if(!l.target||!(l.target instanceof Element))return;const r=this._sliderPointerPosition(l),e=this._sliderOrthogonalPointerPosition(l),c=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(l.target,l.pointerId,l.buttons,g=>{const E=this._sliderOrthogonalPointerPosition(g),_=Math.abs(E-e);if(m.isWindows&&_>h){this._setDesiredScrollPositionNow(c.getScrollPosition());return}const d=this._sliderPointerPosition(g)-r;this._setDesiredScrollPositionNow(c.getDesiredScrollPositionFromDelta(d))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(l){const r={};this.writeScrollPosition(r,l),this._scrollable.setScrollPositionNow(r)}updateScrollbarSize(l){this._updateScrollbarSize(l),this._scrollbarState.setScrollbarSize(l),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=p}),define(me[118],pe([1,0,20,55,37,41,11]),function(Q,t,D,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class b extends i.AbstractScrollbar{constructor(h,p,A){const l=h.getScrollDimensions(),r=h.getCurrentScrollPosition();super({lazyRender:p.lazyRender,host:A,scrollbarState:new M.ScrollbarState(p.horizontalHasArrows?p.arrowSize:0,p.horizontal===2?0:p.horizontalScrollbarSize,p.vertical===2?0:p.verticalScrollbarSize,l.width,l.scrollWidth,r.scrollLeft),visibility:p.horizontal,extraScrollbarClassName:"horizontal",scrollable:h,scrollByPage:p.scrollByPage});if(p.horizontalHasArrows){const e=(p.arrowSize-P.ARROW_IMG_SIZE)/2,c=(p.horizontalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonLeft,top:c,left:e,bottom:void 0,right:void 0,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new D.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonRight,top:c,left:void 0,bottom:void 0,right:e,bgWidth:p.arrowSize,bgHeight:p.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new D.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((p.horizontalScrollbarSize-p.horizontalSliderSize)/2),0,void 0,p.horizontalSliderSize)}_updateSlider(h,p){this.slider.setWidth(h),this.slider.setLeft(p)}_renderDomNode(h,p){this.domNode.setWidth(h),this.domNode.setHeight(p),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(h){return this._shouldRender=this._onElementScrollSize(h.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(h.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(h.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(h,p){return h}_sliderPointerPosition(h){return h.pageX}_sliderOrthogonalPointerPosition(h){return h.pageY}_updateScrollbarSize(h){this.slider.setHeight(h)}writeScrollPosition(h,p){h.scrollLeft=p}updateOptions(h){this.updateScrollbarSize(h.horizontal===2?0:h.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(h.vertical===2?0:h.verticalScrollbarSize),this._visibilityController.setVisibility(h.horizontal),this._scrollByPage=h.scrollByPage}}t.HorizontalScrollbar=b}),define(me[119],pe([1,0,20,55,37,41,11]),function(Q,t,D,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class b extends i.AbstractScrollbar{constructor(h,p,A){const l=h.getScrollDimensions(),r=h.getCurrentScrollPosition();super({lazyRender:p.lazyRender,host:A,scrollbarState:new M.ScrollbarState(p.verticalHasArrows?p.arrowSize:0,p.vertical===2?0:p.verticalScrollbarSize,0,l.height,l.scrollHeight,r.scrollTop),visibility:p.vertical,extraScrollbarClassName:"vertical",scrollable:h,scrollByPage:p.scrollByPage});if(p.verticalHasArrows){const e=(p.arrowSize-P.ARROW_IMG_SIZE)/2,c=(p.verticalScrollbarSize-P.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonUp,top:e,left:c,bottom:void 0,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this._host.onMouseWheel(new D.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:y.Codicon.scrollbarButtonDown,top:void 0,left:c,bottom:e,right:void 0,bgWidth:p.verticalScrollbarSize,bgHeight:p.arrowSize,onActivate:()=>this._host.onMouseWheel(new D.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((p.verticalScrollbarSize-p.verticalSliderSize)/2),p.verticalSliderSize,void 0)}_updateSlider(h,p){this.slider.setHeight(h),this.slider.setTop(p)}_renderDomNode(h,p){this.domNode.setWidth(p),this.domNode.setHeight(h),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(h){return this._shouldRender=this._onElementScrollSize(h.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(h.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(h.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(h,p){return p}_sliderPointerPosition(h){return h.pageY}_sliderOrthogonalPointerPosition(h){return h.pageX}_updateScrollbarSize(h){this.slider.setWidth(h)}writeScrollPosition(h,p){h.scrollTop=p}updateOptions(h){this.updateScrollbarSize(h.vertical===2?0:h.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(h.vertical),this._scrollByPage=h.scrollByPage}}t.VerticalScrollbar=b}),define(me[56],pe([1,0,15,4,40,20,118,119,17,8,3,2,5,47,89]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,c=50,g=!0;class E{constructor(n,s,a){this.timestamp=n,this.deltaX=s,this.deltaY=a,this.score=0}}class _{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let n=1,s=0,a=1,o=this._rear;do{const v=o===this._front?n:Math.pow(2,-a);if(n-=v,s+=this._memory[o].score*v,o===this._front)break;o=(this._capacity+o-1)%this._capacity,a++}while(!0);return s<=.5}accept(n,s,a){const o=new E(n,s,a);o.score=this._computeScore(o),this._front===-1&&this._rear===-1?(this._memory[0]=o,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=o)}_computeScore(n){if(Math.abs(n.deltaX)>0&&Math.abs(n.deltaY)>0)return 1;let s=.5;const a=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(n.deltaX)||!this._isAlmostInt(n.deltaY))&&(s+=.25),Math.min(Math.max(s,0),1)}_isAlmostInt(n){return Math.abs(Math.round(n)-n)<.01}}t.MouseWheelClassifier=_,_.INSTANCE=new _;class u extends m.Widget{constructor(n,s,a){super();this._onScroll=this._register(new p.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new p.Emitter),this.onWillScroll=this._onWillScroll.event,n.style.overflow="hidden",this._options=L(s),this._scrollable=a,this._register(this._scrollable.onScroll(v=>{this._onWillScroll.fire(v),this._onDidScroll(v),this._onScroll.fire(v)}));const o={onMouseWheel:v=>this._onMouseWheel(v),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new b.VerticalScrollbar(this._scrollable,this._options,o)),this._horizontalScrollbar=this._register(new y.HorizontalScrollbar(this._scrollable,this._options,o)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(n),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,P.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,v=>this._onMouseOver(v)),this.onmouseleave(this._listenOnDomNode,v=>this._onMouseLeave(v)),this._hideTimeout=this._register(new h.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}get options(){return this._options}dispose(){this._mouseWheelToDispose=(0,A.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(n){this._verticalScrollbar.delegatePointerDown(n)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(n){this._scrollable.setScrollDimensions(n,!1)}updateClassName(n){this._options.className=n,l.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(n){typeof n.handleMouseWheel!="undefined"&&(this._options.handleMouseWheel=n.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof n.mouseWheelScrollSensitivity!="undefined"&&(this._options.mouseWheelScrollSensitivity=n.mouseWheelScrollSensitivity),typeof n.fastScrollSensitivity!="undefined"&&(this._options.fastScrollSensitivity=n.fastScrollSensitivity),typeof n.scrollPredominantAxis!="undefined"&&(this._options.scrollPredominantAxis=n.scrollPredominantAxis),typeof n.horizontal!="undefined"&&(this._options.horizontal=n.horizontal),typeof n.vertical!="undefined"&&(this._options.vertical=n.vertical),typeof n.horizontalScrollbarSize!="undefined"&&(this._options.horizontalScrollbarSize=n.horizontalScrollbarSize),typeof n.verticalScrollbarSize!="undefined"&&(this._options.verticalScrollbarSize=n.verticalScrollbarSize),typeof n.scrollByPage!="undefined"&&(this._options.scrollByPage=n.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(n){this._revealOnScroll=n}triggerScrollFromMouseWheelEvent(n){this._onMouseWheel(new M.StandardWheelEvent(n))}_setListeningToMouseWheel(n){if(this._mouseWheelToDispose.length>0!==n&&(this._mouseWheelToDispose=(0,A.dispose)(this._mouseWheelToDispose),n)){const a=o=>{this._onMouseWheel(new M.StandardWheelEvent(o))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,a,{passive:!1}))}}_onMouseWheel(n){const s=_.INSTANCE;if(g){const v=window.devicePixelRatio/(0,D.getZoomFactor)();l.isWindows||l.isLinux?s.accept(Date.now(),n.deltaX/v,n.deltaY/v):s.accept(Date.now(),n.deltaX,n.deltaY)}let a=!1;if(n.deltaY||n.deltaX){let v=n.deltaY*this._options.mouseWheelScrollSensitivity,N=n.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(v)>=Math.abs(N)?N=0:v=0),this._options.flipAxes&&([v,N]=[N,v]);const K=!l.isMacintosh&&n.browserEvent&&n.browserEvent.shiftKey;(this._options.scrollYToX||K)&&!N&&(N=v,v=0),n.browserEvent&&n.browserEvent.altKey&&(N=N*this._options.fastScrollSensitivity,v=v*this._options.fastScrollSensitivity);const ne=this._scrollable.getFutureScrollPosition();let re={};if(v){const we=c*v,ae=ne.scrollTop-(we<0?Math.floor(we):Math.ceil(we));this._verticalScrollbar.writeScrollPosition(re,ae)}if(N){const we=c*N,ae=ne.scrollLeft-(we<0?Math.floor(we):Math.ceil(we));this._horizontalScrollbar.writeScrollPosition(re,ae)}re=this._scrollable.validateScrollPosition(re),(ne.scrollLeft!==re.scrollLeft||ne.scrollTop!==re.scrollTop)&&(g&&this._options.mouseWheelSmoothScroll&&s.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(re):this._scrollable.setScrollPositionNow(re),a=!0)}let o=a;!o&&this._options.alwaysConsumeMouseWheel&&(o=!0),!o&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(o=!0),o&&(n.preventDefault(),n.stopPropagation())}_onDidScroll(n){this._shouldRender=this._horizontalScrollbar.onDidScroll(n)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(n)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const n=this._scrollable.getCurrentScrollPosition(),s=n.scrollTop>0,a=n.scrollLeft>0,o=a?" left":"",v=s?" top":"",N=a||s?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${o}`),this._topShadowDomNode.setClassName(`shadow${v}`),this._topLeftShadowDomNode.setClassName(`shadow${N}${v}${o}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(n){this._mouseIsOver=!1,this._hide()}_onMouseOver(n){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=u;class d extends u{constructor(n,s){s=s||{},s.mouseWheelSmoothScroll=!1;const a=new r.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:o=>i.scheduleAtNextAnimationFrame(o)});super(n,s,a);this._register(a)}setScrollPosition(n){this._scrollable.setScrollPositionNow(n)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=d;class w extends u{constructor(n,s,a){super(n,s,a)}setScrollPosition(n){n.reuseAnimation?this._scrollable.setScrollPositionSmooth(n,n.reuseAnimation):this._scrollable.setScrollPositionNow(n)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=w;class S extends u{constructor(n,s){s=s||{},s.mouseWheelSmoothScroll=!1;const a=new r.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:o=>i.scheduleAtNextAnimationFrame(o)});super(n,s,a);this._register(a),this._element=n,this.onScroll(o=>{o.scrollTopChanged&&(this._element.scrollTop=o.scrollTop),o.scrollLeftChanged&&(this._element.scrollLeft=o.scrollLeft)}),this.scanDomNode()}setScrollPosition(n){this._scrollable.setScrollPositionNow(n)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=S;function L(C){const n={lazyRender:typeof C.lazyRender!="undefined"?C.lazyRender:!1,className:typeof C.className!="undefined"?C.className:"",useShadows:typeof C.useShadows!="undefined"?C.useShadows:!0,handleMouseWheel:typeof C.handleMouseWheel!="undefined"?C.handleMouseWheel:!0,flipAxes:typeof C.flipAxes!="undefined"?C.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof C.consumeMouseWheelIfScrollbarIsNeeded!="undefined"?C.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof C.alwaysConsumeMouseWheel!="undefined"?C.alwaysConsumeMouseWheel:!1,scrollYToX:typeof C.scrollYToX!="undefined"?C.scrollYToX:!1,mouseWheelScrollSensitivity:typeof C.mouseWheelScrollSensitivity!="undefined"?C.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof C.fastScrollSensitivity!="undefined"?C.fastScrollSensitivity:5,scrollPredominantAxis:typeof C.scrollPredominantAxis!="undefined"?C.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof C.mouseWheelSmoothScroll!="undefined"?C.mouseWheelSmoothScroll:!0,arrowSize:typeof C.arrowSize!="undefined"?C.arrowSize:11,listenOnDomNode:typeof C.listenOnDomNode!="undefined"?C.listenOnDomNode:null,horizontal:typeof C.horizontal!="undefined"?C.horizontal:1,horizontalScrollbarSize:typeof C.horizontalScrollbarSize!="undefined"?C.horizontalScrollbarSize:10,horizontalSliderSize:typeof C.horizontalSliderSize!="undefined"?C.horizontalSliderSize:0,horizontalHasArrows:typeof C.horizontalHasArrows!="undefined"?C.horizontalHasArrows:!1,vertical:typeof C.vertical!="undefined"?C.vertical:1,verticalScrollbarSize:typeof C.verticalScrollbarSize!="undefined"?C.verticalScrollbarSize:10,verticalHasArrows:typeof C.verticalHasArrows!="undefined"?C.verticalHasArrows:!1,verticalSliderSize:typeof C.verticalSliderSize!="undefined"?C.verticalSliderSize:0,scrollByPage:typeof C.scrollByPage!="undefined"?C.scrollByPage:!1};return n.horizontalSliderSize=typeof C.horizontalSliderSize!="undefined"?C.horizontalSliderSize:n.horizontalScrollbarSize,n.verticalSliderSize=typeof C.verticalSliderSize!="undefined"?C.verticalSliderSize:n.verticalScrollbarSize,l.isMacintosh&&(n.className+=" mac"),n}}),define(me[57],pe([1,0,15,50,4,18,22,56,14,8,25,3,2,45,47,78,114]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r,e,c,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const E={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(C){return[C]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class _{constructor(n){this.elements=n}get context(){return this._context}set context(n){this._context=n}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=_;class u{constructor(n){this.elements=n}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=u;class d{constructor(){this.types=[],this.files=[]}update(n){if(n.types&&this.types.splice(0,this.types.length,...n.types),n.files){this.files.splice(0,this.files.length);for(let s=0;s<n.files.length;s++){const a=n.files.item(s);a&&(a.size||a.type)&&this.files.push(a)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=d;function w(C,n){return Array.isArray(C)&&Array.isArray(n)?(0,m.equals)(C,n):C===n}class S{constructor(n){n?.getSetSize?this.getSetSize=n.getSetSize.bind(n):this.getSetSize=(s,a,o)=>o,n?.getPosInSet?this.getPosInSet=n.getPosInSet.bind(n):this.getPosInSet=(s,a)=>a+1,n?.getRole?this.getRole=n.getRole.bind(n):this.getRole=s=>"listitem",n?.isChecked?this.isChecked=n.isChecked.bind(n):this.isChecked=s=>{}}}class L{constructor(n,s,a,o=E){if(this.virtualDelegate=s,this.domId=`list_id_${++L.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new h.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=l.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=l.Disposable.None,this.onDragLeaveTimeout=l.Disposable.None,this.disposables=new l.DisposableStore,this._onDidChangeContentHeight=new A.Emitter,this.onDidChangeContentHeight=A.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,o.horizontalScrolling&&o.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new c.RangeMap;for(const N of a)this.renderers.set(N.templateId,N);this.cache=this.disposables.add(new g.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof o.mouseSupport=="boolean"?o.mouseSupport:!0),this._horizontalScrolling=o.horizontalScrolling??E.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof o.additionalScrollHeight=="undefined"?0:o.additionalScrollHeight,this.accessibilityProvider=new S(o.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(o.transformOptimization??E.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(y.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:o.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:N=>(0,P.scheduleAtNextAnimationFrame)(N)}),this.scrollableElement=this.disposables.add(new b.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:o.alwaysConsumeMouseWheel??E.alwaysConsumeMouseWheel,horizontal:1,vertical:o.verticalScrollMode??E.verticalScrollMode,useShadows:o.useShadows??E.useShadows,mouseWheelScrollSensitivity:o.mouseWheelScrollSensitivity,fastScrollSensitivity:o.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),n.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,P.addDisposableListener)(this.rowsContainer,y.EventType.Change,N=>this.onTouchChange(N))),this.disposables.add((0,P.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",N=>N.target.scrollTop=0)),this.disposables.add((0,P.addDisposableListener)(this.domNode,"dragover",N=>this.onDragOver(this.toDragEvent(N)))),this.disposables.add((0,P.addDisposableListener)(this.domNode,"drop",N=>this.onDrop(this.toDragEvent(N)))),this.disposables.add((0,P.addDisposableListener)(this.domNode,"dragleave",N=>this.onDragLeave(this.toDragEvent(N)))),this.disposables.add((0,P.addDisposableListener)(this.domNode,"dragend",N=>this.onDragEnd(N))),this.setRowLineHeight=o.setRowLineHeight??E.setRowLineHeight,this.setRowHeight=o.setRowHeight??E.setRowHeight,this.supportDynamicHeights=o.supportDynamicHeights??E.supportDynamicHeights,this.dnd=o.dnd??E.dnd,this.layout()}get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(n){if(n!==this._horizontalScrolling){if(n&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=n,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const s of this.items)this.measureItemWidth(s);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,P.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}updateOptions(n){n.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=n.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),n.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(n.smoothScrolling?125:0),n.horizontalScrolling!==void 0&&(this.horizontalScrolling=n.horizontalScrolling),n.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:n.mouseWheelScrollSensitivity}),n.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:n.fastScrollSensitivity})}triggerScrollFromMouseWheelEvent(n){this.scrollableElement.triggerScrollFromMouseWheelEvent(n)}updateElementHeight(n,s,a){if(n<0||n>=this.items.length)return;const o=this.items[n].size;if(typeof s=="undefined"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[n].lastDynamicHeightWidth=void 0,s=o+this.probeDynamicHeight(n)}if(o===s)return;const v=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let N=0;n<v.start||a!==null&&a>n&&a<=v.end?N=s-o:N=0,this.rangeMap.splice(n,1,[{size:s}]),this.items[n].size=s,this.render(v,Math.max(0,this.lastRenderTop+N),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(n,s,a=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(n,s,a)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(n,s,a=[]){const o=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),v={start:n,end:n+s},N=r.Range.intersect(o,v),K=new Map;for(let T=N.end-1;T>=N.start;T--){const $=this.items[T];if($.dragStartDisposable.dispose(),$.checkedDisposable.dispose(),$.row){let X=K.get($.templateId);X||(X=[],K.set($.templateId,X));const R=this.renderers.get($.templateId);R&&R.disposeElement&&R.disposeElement($.element,T,$.row.templateData,$.size),X.push($.row)}$.row=null}const ne={start:n+s,end:this.items.length},re=r.Range.intersect(ne,o),we=r.Range.relativeComplement(ne,o),ae=a.map(T=>({id:String(this.itemId++),element:T,templateId:this.virtualDelegate.getTemplateId(T),size:this.virtualDelegate.getHeight(T),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight(T),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:l.Disposable.None,checkedDisposable:l.Disposable.None}));let ve;n===0&&s>=this.items.length?(this.rangeMap=new c.RangeMap,this.rangeMap.splice(0,0,ae),ve=this.items,this.items=ae):(this.rangeMap.splice(n,s,ae),ve=this.items.splice(n,s,...ae));const fe=a.length-s,ge=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ye=(0,c.shift)(re,fe),ee=r.Range.intersect(ge,ye);for(let T=ee.start;T<ee.end;T++)this.updateItemInDOM(this.items[T],T);const he=r.Range.relativeComplement(ye,ge);for(const T of he)for(let $=T.start;$<T.end;$++)this.removeItemFromDOM($);const te=we.map(T=>(0,c.shift)(T,fe)),se=[{start:n,end:n+a.length},...te].map(T=>r.Range.intersect(ge,T)),ie=this.getNextToLastElement(se);for(const T of se)for(let $=T.start;$<T.end;$++){const X=this.items[$],f=K.get(X.templateId)?.pop();this.insertItemInDOM($,ie,f)}for(const T of K.values())for(const $ of T)this.cache.release($);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ve.map(T=>T.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,P.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let n=0;for(const s of this.items)typeof s.width!="undefined"&&(n=Math.max(n,s.width));this.scrollWidth=n,this.scrollableElement.setScrollDimensions({scrollWidth:n===0?0:n+10})}updateWidth(n){if(!this.horizontalScrolling||typeof this.scrollWidth=="undefined")return;const s=this.items[n];this.measureItemWidth(s),typeof s.width!="undefined"&&s.width>this.scrollWidth&&(this.scrollWidth=s.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const n of this.items)n.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const n=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),s=this.rangeMap.positionAt(n.start),a=this.rangeMap.positionAt(n.start+1);return a!==-1&&(a-s)/2+s<this.scrollTop?n.start+1:n.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(n){return this.items[n].element}indexOf(n){return this.items.findIndex(s=>s.element===n)}domElement(n){const s=this.items[n].row;return s&&s.domNode}elementHeight(n){return this.items[n].size}elementTop(n){return this.rangeMap.positionAt(n)}indexAt(n){return this.rangeMap.indexAt(n)}indexAfter(n){return this.rangeMap.indexAfter(n)}layout(n,s){const a={height:typeof n=="number"?n:(0,P.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,a.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(a),typeof s!="undefined"&&(this.renderWidth=s,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof s=="number"?s:(0,P.getContentWidth)(this.domNode)})}render(n,s,a,o,v,N=!1){const K=this.getRenderRange(s,a),ne=r.Range.relativeComplement(K,n),re=r.Range.relativeComplement(n,K),we=this.getNextToLastElement(ne);if(N){const ae=r.Range.intersect(n,K);for(let ve=ae.start;ve<ae.end;ve++)this.updateItemInDOM(this.items[ve],ve)}for(const ae of ne)for(let ve=ae.start;ve<ae.end;ve++)this.insertItemInDOM(ve,we);for(const ae of re)for(let ve=ae.start;ve<ae.end;ve++)this.removeItemFromDOM(ve);o!==void 0&&(this.rowsContainer.style.left=`-${o}px`),this.rowsContainer.style.top=`-${s}px`,this.horizontalScrolling&&v!==void 0&&(this.rowsContainer.style.width=`${Math.max(v,this.renderWidth)}px`),this.lastRenderTop=s,this.lastRenderHeight=a}insertItemInDOM(n,s,a){const o=this.items[n];o.row||(o.row=a??this.cache.alloc(o.templateId));const v=this.accessibilityProvider.getRole(o.element)||"listitem";o.row.domNode.setAttribute("role",v);const N=this.accessibilityProvider.isChecked(o.element);if(typeof N=="boolean")o.row.domNode.setAttribute("aria-checked",String(!!N));else if(N){const re=we=>o.row.domNode.setAttribute("aria-checked",String(!!we));re(N.value),o.checkedDisposable=N.onDidChange(re)}o.row.domNode.parentElement||(s?this.rowsContainer.insertBefore(o.row.domNode,s):this.rowsContainer.appendChild(o.row.domNode)),this.updateItemInDOM(o,n);const K=this.renderers.get(o.templateId);if(!K)throw new Error(`No renderer found for template id ${o.templateId}`);K?.renderElement(o.element,n,o.row.templateData,o.size);const ne=this.dnd.getDragURI(o.element);o.dragStartDisposable.dispose(),o.row.domNode.draggable=!!ne,ne&&(o.dragStartDisposable=(0,P.addDisposableListener)(o.row.domNode,"dragstart",re=>this.onDragStart(o.element,ne,re))),this.horizontalScrolling&&(this.measureItemWidth(o),this.eventuallyUpdateScrollWidth())}measureItemWidth(n){if(!n.row||!n.row.domNode)return;n.row.domNode.style.width=D.isFirefox?"-moz-fit-content":"fit-content",n.width=(0,P.getContentWidth)(n.row.domNode);const s=window.getComputedStyle(n.row.domNode);s.paddingLeft&&(n.width+=parseFloat(s.paddingLeft)),s.paddingRight&&(n.width+=parseFloat(s.paddingRight)),n.row.domNode.style.width=""}updateItemInDOM(n,s){n.row.domNode.style.top=`${this.elementTop(s)}px`,this.setRowHeight&&(n.row.domNode.style.height=`${n.size}px`),this.setRowLineHeight&&(n.row.domNode.style.lineHeight=`${n.size}px`),n.row.domNode.setAttribute("data-index",`${s}`),n.row.domNode.setAttribute("data-last-element",s===this.length-1?"true":"false"),n.row.domNode.setAttribute("data-parity",s%2==0?"even":"odd"),n.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(n.element,s,this.length))),n.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(n.element,s))),n.row.domNode.setAttribute("id",this.getElementDomId(s)),n.row.domNode.classList.toggle("drop-target",n.dropTarget)}removeItemFromDOM(n){const s=this.items[n];if(s.dragStartDisposable.dispose(),s.checkedDisposable.dispose(),s.row){const a=this.renderers.get(s.templateId);a&&a.disposeElement&&a.disposeElement(s.element,n,s.row.templateData,s.size),this.cache.release(s.row),s.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(n,s){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:n,reuseAnimation:s})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(n){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:n})}get scrollTop(){return this.getScrollTop()}set scrollTop(n){this.setScrollTop(n)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"click")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDblClick(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"dblclick")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMiddleClick(){return A.Event.filter(A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"auxclick")).event,n=>this.toMouseEvent(n),this.disposables),n=>n.browserEvent.button===1,this.disposables)}get onMouseUp(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseup")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDown(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousedown")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOver(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseover")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMove(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mousemove")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOut(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"mouseout")).event,n=>this.toMouseEvent(n),this.disposables)}get onContextMenu(){return A.Event.any(A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"contextmenu")).event,n=>this.toMouseEvent(n),this.disposables),A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,y.EventType.Contextmenu)).event,n=>this.toGestureEvent(n),this.disposables))}get onTouchStart(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.domNode,"touchstart")).event,n=>this.toTouchEvent(n),this.disposables)}get onTap(){return A.Event.map(this.disposables.add(new M.DomEmitter(this.rowsContainer,y.EventType.Tap)).event,n=>this.toGestureEvent(n),this.disposables)}toMouseEvent(n){const s=this.getItemIndexFromEventTarget(n.target||null),a=typeof s=="undefined"?void 0:this.items[s],o=a&&a.element;return{browserEvent:n,index:s,element:o}}toTouchEvent(n){const s=this.getItemIndexFromEventTarget(n.target||null),a=typeof s=="undefined"?void 0:this.items[s],o=a&&a.element;return{browserEvent:n,index:s,element:o}}toGestureEvent(n){const s=this.getItemIndexFromEventTarget(n.initialTarget||null),a=typeof s=="undefined"?void 0:this.items[s],o=a&&a.element;return{browserEvent:n,index:s,element:o}}toDragEvent(n){const s=this.getItemIndexFromEventTarget(n.target||null),a=typeof s=="undefined"?void 0:this.items[s],o=a&&a.element;return{browserEvent:n,index:s,element:o}}onScroll(n){try{const s=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(s,n.scrollTop,n.height,n.scrollLeft,n.scrollWidth),this.supportDynamicHeights&&this._rerender(n.scrollTop,n.height,n.inSmoothScrolling)}catch(s){throw console.error("Got bad scroll event:",n),s}}onTouchChange(n){n.preventDefault(),n.stopPropagation(),this.scrollTop-=n.translationY}onDragStart(n,s,a){if(!a.dataTransfer)return;const o=this.dnd.getDragElements(n);if(a.dataTransfer.effectAllowed="copyMove",a.dataTransfer.setData(i.DataTransfers.TEXT,s),a.dataTransfer.setDragImage){let v;this.dnd.getDragLabel&&(v=this.dnd.getDragLabel(o,a)),typeof v=="undefined"&&(v=String(o.length));const N=(0,P.$)(".monaco-drag-image");N.textContent=v,document.body.appendChild(N),a.dataTransfer.setDragImage(N,-10,-10),setTimeout(()=>document.body.removeChild(N),0)}this.currentDragData=new _(o),i.StaticDND.CurrentDragAndDropData=new u(o),this.dnd.onDragStart?.(this.currentDragData,a)}onDragOver(n){if(n.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),i.StaticDND.CurrentDragAndDropData&&i.StaticDND.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(n.browserEvent),!n.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(i.StaticDND.CurrentDragAndDropData)this.currentDragData=i.StaticDND.CurrentDragAndDropData;else{if(!n.browserEvent.dataTransfer.types)return!1;this.currentDragData=new d}const s=this.dnd.onDragOver(this.currentDragData,n.element,n.index,n.browserEvent);if(this.canDrop=typeof s=="boolean"?s:s.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;n.browserEvent.dataTransfer.dropEffect=typeof s!="boolean"&&s.effect===0?"copy":"move";let a;if(typeof s!="boolean"&&s.feedback?a=s.feedback:typeof n.index=="undefined"?a=[-1]:a=[n.index],a=(0,m.distinct)(a).filter(o=>o>=-1&&o<this.length).sort((o,v)=>o-v),a=a[0]===-1?[-1]:a,w(this.currentDragFeedback,a))return!0;if(this.currentDragFeedback=a,this.currentDragFeedbackDisposable.dispose(),a[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const o of a){const v=this.items[o];v.dropTarget=!0,v.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{for(const o of a){const v=this.items[o];v.dropTarget=!1,v.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(n){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,h.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,n.element,n.index,n.browserEvent)}onDrop(n){if(!this.canDrop)return;const s=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,i.StaticDND.CurrentDragAndDropData=void 0,!(!s||!n.browserEvent.dataTransfer)&&(n.browserEvent.preventDefault(),s.update(n.browserEvent.dataTransfer),this.dnd.drop(s,n.element,n.index,n.browserEvent))}onDragEnd(n){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,i.StaticDND.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(n)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=l.Disposable.None}setupDragAndDropScrollTopAnimation(n){if(!this.dragOverAnimationDisposable){const s=(0,P.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,P.animate)(this.animateDragAndDropScrollTop.bind(this,s))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,h.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=n.pageY}animateDragAndDropScrollTop(n){if(this.dragOverMouseY===void 0)return;const s=this.dragOverMouseY-n,a=this.renderHeight-35;s<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(s-35))):s>a&&(this.scrollTop+=Math.min(14,Math.floor(.3*(s-a))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(n){const s=this.scrollableElement.getDomNode();let a=n;for(;a instanceof HTMLElement&&a!==this.rowsContainer&&s.contains(a);){const o=a.getAttribute("data-index");if(o){const v=Number(o);if(!isNaN(v))return v}a=a.parentElement}}getRenderRange(n,s){return{start:this.rangeMap.indexAt(n),end:this.rangeMap.indexAfter(n+s-1)}}_rerender(n,s,a){const o=this.getRenderRange(n,s);let v,N;n===this.elementTop(o.start)?(v=o.start,N=0):o.end-o.start>1&&(v=o.start+1,N=this.elementTop(v)-n);let K=0;for(;;){const ne=this.getRenderRange(n,s);let re=!1;for(let we=ne.start;we<ne.end;we++){const ae=this.probeDynamicHeight(we);ae!==0&&this.rangeMap.splice(we,1,[this.items[we]]),K+=ae,re=re||ae!==0}if(!re){K!==0&&this.eventuallyUpdateScrollDimensions();const we=r.Range.relativeComplement(o,ne);for(const ve of we)for(let fe=ve.start;fe<ve.end;fe++)this.items[fe].row&&this.removeItemFromDOM(fe);const ae=r.Range.relativeComplement(ne,o);for(const ve of ae)for(let fe=ve.start;fe<ve.end;fe++){const ge=fe+1,ye=ge<this.items.length?this.items[ge].row:null,ee=ye?ye.domNode:null;this.insertItemInDOM(fe,ee)}for(let ve=ne.start;ve<ne.end;ve++)this.items[ve].row&&this.updateItemInDOM(this.items[ve],ve);if(typeof v=="number"){const ve=this.scrollable.getFutureScrollPosition().scrollTop-n,fe=this.elementTop(v)-N+ve;this.setScrollTop(fe,a)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(n){const s=this.items[n];if(this.virtualDelegate.getDynamicHeight){const N=this.virtualDelegate.getDynamicHeight(s.element);if(N!==null){const K=s.size;return s.size=N,s.lastDynamicHeightWidth=this.renderWidth,N-K}}if(!s.hasDynamicHeight||s.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(s.element))return 0;const a=s.size;if(!this.setRowHeight&&s.row){const N=s.row.domNode.offsetHeight;return s.size=N,s.lastDynamicHeightWidth=this.renderWidth,N-a}const o=this.cache.alloc(s.templateId);o.domNode.style.height="",this.rowsContainer.appendChild(o.domNode);const v=this.renderers.get(s.templateId);return v&&(v.renderElement(s.element,n,o.templateData,void 0),v.disposeElement?.(s.element,n,o.templateData,void 0)),s.size=o.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight?.(s.element,s.size),s.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(o.domNode),this.cache.release(o),s.size-a}getNextToLastElement(n){const s=n[n.length-1];if(!s)return null;const a=this.items[s.end];return!a||!a.row?null:a.row.domNode}getElementDomId(n){return`${this.domId}_${n}`}dispose(){if(this.items){for(const n of this.items)if(n.row){const s=this.renderers.get(n.row.templateId);s&&(s.disposeElement?.(n.element,-1,n.row.templateData,void 0),s.disposeTemplate(n.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,l.dispose)(this.disposables)}}L.InstanceCount=0,Ke([p.memoize],L.prototype,"onMouseClick",null),Ke([p.memoize],L.prototype,"onMouseDblClick",null),Ke([p.memoize],L.prototype,"onMouseMiddleClick",null),Ke([p.memoize],L.prototype,"onMouseUp",null),Ke([p.memoize],L.prototype,"onMouseDown",null),Ke([p.memoize],L.prototype,"onMouseOver",null),Ke([p.memoize],L.prototype,"onMouseMove",null),Ke([p.memoize],L.prototype,"onMouseOut",null),Ke([p.memoize],L.prototype,"onContextMenu",null),Ke([p.memoize],L.prototype,"onTouchStart",null),Ke([p.memoize],L.prototype,"onTap",null),t.ListView=L}),define(me[58],pe([1,0,4,18,19,22,53,67,14,8,24,25,3,33,2,44,27,5,6,66,57,88]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r,e,c,g,E,_,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class w{constructor(f){this.trait=f,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(f){return f}renderElement(f,I,U){const q=this.renderedElements.findIndex(W=>W.templateData===U);if(q>=0){const W=this.renderedElements[q];this.trait.unrender(U),W.index=I}else{const W={index:I,templateData:U};this.renderedElements.push(W)}this.trait.renderIndex(I,U)}splice(f,I,U){const q=[];for(const W of this.renderedElements)W.index<f?q.push(W):W.index>=f+I&&q.push({index:W.index+U-I,templateData:W.templateData});this.renderedElements=q}renderIndexes(f){for(const{index:I,templateData:U}of this.renderedElements)f.indexOf(I)>-1&&this.trait.renderIndex(I,U)}disposeTemplate(f){const I=this.renderedElements.findIndex(U=>U.templateData===f);I<0||this.renderedElements.splice(I,1)}}class S{constructor(f){this._trait=f,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new l.Emitter,this.onChange=this._onChange.event}get name(){return this._trait}get renderer(){return new w(this)}splice(f,I,U){I=Math.max(0,Math.min(I,this.length-f));const q=U.length-I,W=f+I,O=[...this.sortedIndexes.filter(V=>V<f),...U.map((V,F)=>V?F+f:-1).filter(V=>V!==-1),...this.sortedIndexes.filter(V=>V>=W).map(V=>V+q)],H=this.length+q;if(this.sortedIndexes.length>0&&O.length===0&&H>0){const V=this.sortedIndexes.find(F=>F>=f)??H-1;O.push(Math.min(V,H-1))}this.renderer.splice(f,I,U.length),this._set(O,O),this.length=H}renderIndex(f,I){I.classList.toggle(this._trait,this.contains(f))}unrender(f){f.classList.remove(this._trait)}set(f,I){return this._set(f,[...f].sort(se),I)}_set(f,I,U){const q=this.indexes,W=this.sortedIndexes;this.indexes=f,this.sortedIndexes=I;const O=te(W,f);return this.renderer.renderIndexes(O),this._onChange.fire({indexes:f,browserEvent:U}),q}get(){return this.indexes}contains(f){return(0,m.binarySearch)(this.sortedIndexes,f,se)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ke([A.memoize],S.prototype,"renderer",null);class L extends S{constructor(f){super("selected");this.setAriaSelected=f}renderIndex(f,I){super.renderIndex(f,I),this.setAriaSelected&&(this.contains(f)?I.setAttribute("aria-selected","true"):I.setAttribute("aria-selected","false"))}}class C{constructor(f,I,U){this.trait=f,this.view=I,this.identityProvider=U}splice(f,I,U){if(!this.identityProvider)return this.trait.splice(f,I,U.map(()=>!1));const q=this.trait.get().map(O=>this.identityProvider.getId(this.view.element(O)).toString()),W=U.map(O=>q.indexOf(this.identityProvider.getId(O).toString())>-1);this.trait.splice(f,I,W)}}function n(R){return R.tagName==="INPUT"||R.tagName==="TEXTAREA"}t.isInputElement=n;function s(R){return R.classList.contains("monaco-editor")?!0:R.classList.contains("monaco-list")||!R.parentElement?!1:s(R.parentElement)}t.isMonacoEditor=s;function a(R){return R.tagName==="A"&&R.classList.contains("monaco-button")||R.tagName==="DIV"&&R.classList.contains("monaco-button-dropdown")?!0:R.classList.contains("monaco-list")||!R.parentElement?!1:a(R.parentElement)}t.isButton=a;class o{constructor(f,I,U){this.list=f,this.view=I,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(q=>q.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(q=>q.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(q=>(E.isMacintosh?q.metaKey:q.ctrlKey)&&q.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}get onKeyDown(){return this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(f=>!n(f.target)).map(f=>new P.StandardKeyboardEvent(f)))}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),f.multipleSelectionSupport&&this.onKeyDown.filter(I=>(E.isMacintosh?I.metaKey:I.ctrlKey)&&I.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(f){f.preventDefault(),f.stopPropagation(),this.list.setSelection(this.list.getFocus(),f.browserEvent)}onUpArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusPrevious(1,!1,f.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onDownArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusNext(1,!1,f.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageUpArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusPreviousPage(f.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageDownArrow(f){f.preventDefault(),f.stopPropagation(),this.list.focusNextPage(f.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onCtrlA(f){f.preventDefault(),f.stopPropagation(),this.list.setSelection((0,m.range)(this.list.length),f.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(f){this.list.getSelection().length&&(f.preventDefault(),f.stopPropagation(),this.list.setSelection([],f.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ke([A.memoize],o.prototype,"onKeyDown",null);var v;(function(R){R[R.Automatic=0]="Automatic",R[R.Trigger=1]="Trigger"})(v=t.TypeNavigationMode||(t.TypeNavigationMode={}));var N;(function(R){R[R.Idle=0]="Idle",R[R.Typing=1]="Typing"})(N||(N={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(R){return R.ctrlKey||R.metaKey||R.altKey?!1:R.keyCode>=31&&R.keyCode<=56||R.keyCode>=21&&R.keyCode<=30||R.keyCode>=93&&R.keyCode<=102||R.keyCode>=80&&R.keyCode<=90}};class K{constructor(f,I,U,q,W){this.list=f,this.view=I,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=q,this.delegate=W,this.enabled=!1,this.state=N.Idle,this.mode=v.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(f.options)}updateOptions(f){f.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=f.typeNavigationMode??v.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let f=!1;const I=this.enabledDisposables.add(l.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(W=>!n(W.target)).filter(()=>this.mode===v.Automatic||this.triggered).map(W=>new P.StandardKeyboardEvent(W)).filter(W=>f||this.keyboardNavigationEventFilter(W)).filter(W=>this.delegate.mightProducePrintableCharacter(W)).forEach(i.stopEvent).map(W=>W.browserEvent.key).event,U=l.Event.debounce(I,()=>null,800,void 0,void 0,this.enabledDisposables);l.Event.reduce(l.Event.any(I,U),(W,O)=>O===null?null:(W||"")+O,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),I(()=>f=!0,void 0,this.enabledDisposables),U(()=>f=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const f=this.list.getFocus();if(f.length>0&&f[0]===this.previouslyFocused){const I=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(f[0]));I&&(0,y.alert)(I)}this.previouslyFocused=-1}onInput(f){if(!f){this.state=N.Idle,this.triggered=!1;return}const I=this.list.getFocus(),U=I.length>0?I[0]:0,q=this.state===N.Idle?1:0;this.state=N.Typing;for(let W=0;W<this.list.length;W++){const O=(U+W+q)%this.list.length,H=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(O)),V=H&&H.toString();if(typeof V=="undefined"||(0,r.matchesPrefix)(f,V)){this.previouslyFocused=U,this.list.setFocus([O]),this.list.reveal(O);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class ne{constructor(f,I){this.list=f,this.view=I,this.disposables=new e.DisposableStore,this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(I.domNode,"keydown")).event)).filter(q=>!n(q.target)).map(q=>new P.StandardKeyboardEvent(q)).filter(q=>q.keyCode===2&&!q.ctrlKey&&!q.metaKey&&!q.shiftKey&&!q.altKey).on(this.onTab,this,this.disposables)}onTab(f){if(f.target!==this.view.domNode)return;const I=this.list.getFocus();if(I.length===0)return;const U=this.view.domElement(I[0]);if(!U)return;const q=U.querySelector("[tabIndex]");if(!q||!(q instanceof HTMLElement)||q.tabIndex===-1)return;const W=window.getComputedStyle(q);W.visibility==="hidden"||W.display==="none"||(f.preventDefault(),f.stopPropagation(),q.focus())}dispose(){this.disposables.dispose()}}function re(R){return E.isMacintosh?R.browserEvent.metaKey:R.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=re;function we(R){return R.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=we;function ae(R){return R instanceof MouseEvent&&R.button===2}const ve={isSelectionSingleChangeEvent:re,isSelectionRangeChangeEvent:we};class fe{constructor(f){this.list=f,this.disposables=new e.DisposableStore,this._onPointer=new l.Emitter,this.onPointer=this._onPointer.event,f.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ve),this.mouseSupport=typeof f.options.mouseSupport=="undefined"||!!f.options.mouseSupport,this.mouseSupport&&(f.onMouseDown(this.onMouseDown,this,this.disposables),f.onContextMenu(this.onContextMenu,this,this.disposables),f.onMouseDblClick(this.onDoubleClick,this,this.disposables),f.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(M.Gesture.addTarget(f.getHTMLElement()))),l.Event.any(f.onMouseClick,f.onMouseMiddleClick,f.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(f){f.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,f.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ve))}isSelectionSingleChangeEvent(f){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(f):!1}isSelectionRangeChangeEvent(f){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(f):!1}isSelectionChangeEvent(f){return this.isSelectionSingleChangeEvent(f)||this.isSelectionRangeChangeEvent(f)}onMouseDown(f){s(f.browserEvent.target)||document.activeElement!==f.browserEvent.target&&this.list.domFocus()}onContextMenu(f){if(s(f.browserEvent.target))return;const I=typeof f.index=="undefined"?[]:[f.index];this.list.setFocus(I,f.browserEvent)}onViewPointer(f){if(!this.mouseSupport||n(f.browserEvent.target)||s(f.browserEvent.target))return;const I=f.index;if(typeof I=="undefined"){this.list.setFocus([],f.browserEvent),this.list.setSelection([],f.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(f))return this.changeSelection(f);if(this.isSelectionChangeEvent(f))return this.changeSelection(f);this.list.setFocus([I],f.browserEvent),this.list.setAnchor(I),ae(f.browserEvent)||this.list.setSelection([I],f.browserEvent),this._onPointer.fire(f)}onDoubleClick(f){if(n(f.browserEvent.target)||s(f.browserEvent.target)||this.isSelectionChangeEvent(f))return;const I=this.list.getFocus();this.list.setSelection(I,f.browserEvent)}changeSelection(f){const I=f.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(f)){typeof U=="undefined"&&(U=this.list.getFocus()[0]??I,this.list.setAnchor(U));const q=Math.min(U,I),W=Math.max(U,I),O=(0,m.range)(q,W+1),H=this.list.getSelection(),V=he(te(H,[U]),U);if(V.length===0)return;const F=te(O,Z(H,V));this.list.setSelection(F,f.browserEvent),this.list.setFocus([I],f.browserEvent)}else if(this.isSelectionSingleChangeEvent(f)){const q=this.list.getSelection(),W=q.filter(O=>O!==I);this.list.setFocus([I]),this.list.setAnchor(I),q.length===W.length?this.list.setSelection([...W,I],f.browserEvent):this.list.setSelection(W,f.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=fe;class ge{constructor(f,I){this.styleElement=f,this.selectorSuffix=I}style(f){const I=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];f.listBackground&&(f.listBackground.isOpaque()?U.push(`.monaco-list${I} .monaco-list-rows { background: ${f.listBackground}; }`):E.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),f.listFocusBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.focused { background-color: ${f.listFocusBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.focused:hover { background-color: ${f.listFocusBackground}; }`)),f.listFocusForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.focused { color: ${f.listFocusForeground}; }`),f.listActiveSelectionBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.selected { background-color: ${f.listActiveSelectionBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.selected:hover { background-color: ${f.listActiveSelectionBackground}; }`)),f.listActiveSelectionForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { color: ${f.listActiveSelectionForeground}; }`),f.listActiveSelectionIconForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected .codicon { color: ${f.listActiveSelectionIconForeground}; }`),f.listFocusAndSelectionOutline&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { outline-color: ${f.listFocusAndSelectionOutline} !important; }`),f.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { background-color: ${f.listFocusAndSelectionBackground}; }
			`),f.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { color: ${f.listFocusAndSelectionForeground}; }
			`),f.listInactiveFocusForeground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { color:  ${f.listInactiveFocusForeground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { color:  ${f.listInactiveFocusForeground}; }`)),f.listInactiveSelectionIconForeground&&U.push(`.monaco-list${I} .monaco-list-row.focused .codicon { color:  ${f.listInactiveSelectionIconForeground}; }`),f.listInactiveFocusBackground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { background-color:  ${f.listInactiveFocusBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { background-color:  ${f.listInactiveFocusBackground}; }`)),f.listInactiveSelectionBackground&&(U.push(`.monaco-list${I} .monaco-list-row.selected { background-color:  ${f.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.selected:hover { background-color:  ${f.listInactiveSelectionBackground}; }`)),f.listInactiveSelectionForeground&&U.push(`.monaco-list${I} .monaco-list-row.selected { color: ${f.listInactiveSelectionForeground}; }`),f.listHoverBackground&&U.push(`.monaco-list${I}:not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${f.listHoverBackground}; }`),f.listHoverForeground&&U.push(`.monaco-list${I} .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${f.listHoverForeground}; }`),f.listSelectionOutline&&U.push(`.monaco-list${I} .monaco-list-row.selected { outline: 1px dotted ${f.listSelectionOutline}; outline-offset: -1px; }`),f.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused .monaco-list-row.focused { outline: 1px solid ${f.listFocusOutline}; outline-offset: -1px; }
			`),f.listInactiveFocusOutline&&U.push(`.monaco-list${I} .monaco-list-row.focused { outline: 1px dotted ${f.listInactiveFocusOutline}; outline-offset: -1px; }`),f.listHoverOutline&&U.push(`.monaco-list${I} .monaco-list-row:hover { outline: 1px dashed ${f.listHoverOutline}; outline-offset: -1px; }`),f.listDropBackground&&U.push(`
				.monaco-list${I}.drop-target,
				.monaco-list${I} .monaco-list-rows.drop-target,
				.monaco-list${I} .monaco-list-row.drop-target { background-color: ${f.listDropBackground} !important; color: inherit !important; }
			`),f.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${f.tableColumnsBorder};
			}`),f.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${f.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=ge;const ye={listFocusBackground:p.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:p.Color.fromHex("#0E639C"),listActiveSelectionForeground:p.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:p.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:p.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:p.Color.fromHex("#094771"),listFocusAndSelectionForeground:p.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:p.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:p.Color.fromHex("#FFFFFF"),listHoverBackground:p.Color.fromHex("#2A2D2E"),listDropBackground:p.Color.fromHex("#383B3D"),treeIndentGuidesStroke:p.Color.fromHex("#a9a9a9"),tableColumnsBorder:p.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:p.Color.fromHex("#cccccc").transparent(.04)},ee={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function he(R,f){const I=R.indexOf(f);if(I===-1)return[];const U=[];let q=I-1;for(;q>=0&&R[q]===f-(I-q);)U.push(R[q--]);for(U.reverse(),q=I;q<R.length&&R[q]===f+(q-I);)U.push(R[q++]);return U}function te(R,f){const I=[];let U=0,q=0;for(;U<R.length||q<f.length;)if(U>=R.length)I.push(f[q++]);else if(q>=f.length)I.push(R[U++]);else if(R[U]===f[q]){I.push(R[U]),U++,q++;continue}else R[U]<f[q]?I.push(R[U++]):I.push(f[q++]);return I}function Z(R,f){const I=[];let U=0,q=0;for(;U<R.length||q<f.length;)if(U>=R.length)I.push(f[q++]);else if(q>=f.length)I.push(R[U++]);else if(R[U]===f[q]){U++,q++;continue}else R[U]<f[q]?I.push(R[U++]):q++;return I}const se=(R,f)=>R-f;class ie{constructor(f,I){this._templateId=f,this.renderers=I}get templateId(){return this._templateId}renderTemplate(f){return this.renderers.map(I=>I.renderTemplate(f))}renderElement(f,I,U,q){let W=0;for(const O of this.renderers)O.renderElement(f,I,U[W++],q)}disposeElement(f,I,U,q){let W=0;for(const O of this.renderers)O.disposeElement?.(f,I,U[W],q),W+=1}disposeTemplate(f){let I=0;for(const U of this.renderers)U.disposeTemplate(f[I++])}}class T{constructor(f){this.accessibilityProvider=f,this.templateId="a18n"}renderTemplate(f){return f}renderElement(f,I,U){const q=this.accessibilityProvider.getAriaLabel(f);q?U.setAttribute("aria-label",q):U.removeAttribute("aria-label");const W=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(f);typeof W=="number"?U.setAttribute("aria-level",`${W}`):U.removeAttribute("aria-level")}disposeTemplate(f){}}class ${constructor(f,I){this.list=f,this.dnd=I}getDragElements(f){const I=this.list.getSelectedElements();return I.indexOf(f)>-1?I:[f]}getDragURI(f){return this.dnd.getDragURI(f)}getDragLabel(f,I){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(f,I)}onDragStart(f,I){this.dnd.onDragStart?.(f,I)}onDragOver(f,I,U,q){return this.dnd.onDragOver(f,I,U,q)}onDragLeave(f,I,U,q){this.dnd.onDragLeave?.(f,I,U,q)}onDragEnd(f){this.dnd.onDragEnd?.(f)}drop(f,I,U,q){this.dnd.drop(f,I,U,q)}}class X{constructor(f,I,U,q,W=ee){this.user=f,this._options=W,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new l.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event;const O=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new L(O!=="listbox"),(0,g.mixin)(W,ye,!1);const H=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=W.accessibilityProvider,this.accessibilityProvider&&(H.push(new T(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),q=q.map(F=>new ie(F.templateId,[...H,F]));const V={...W,dnd:W.dnd&&new $(this,W.dnd)};if(this.view=new d.ListView(I,U,q,V),this.view.domNode.setAttribute("role",O),W.styleController)this.styleController=W.styleController(this.view.domId);else{const F=(0,D.createStyleSheet)(this.view.domNode);this.styleController=new ge(F,this.view.domId)}if(this.spliceable=new b.CombinedSpliceable([new C(this.focus,this.view,W.identityProvider),new C(this.selection,this.view,W.identityProvider),new C(this.anchor,this.view,W.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new ne(this,this.view)),(typeof W.keyboardSupport!="boolean"||W.keyboardSupport)&&(this.keyboardController=new o(this,this.view,W),this.disposables.add(this.keyboardController)),W.keyboardNavigationLabelProvider){const F=W.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new K(this,this.view,W.keyboardNavigationLabelProvider,W.keyboardNavigationEventFilter??(()=>!0),F),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(W),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}get onDidChangeFocus(){return l.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),f=>this.toListEvent(f),this.disposables)}get onDidChangeSelection(){return l.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),f=>this.toListEvent(f),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let f=!1;const I=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(W=>new P.StandardKeyboardEvent(W)).filter(W=>f=W.keyCode===58||W.shiftKey&&W.keyCode===68).map(i.stopEvent).filter(()=>!1).event,U=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>f=!1).map(W=>new P.StandardKeyboardEvent(W)).filter(W=>W.keyCode===58||W.shiftKey&&W.keyCode===68).map(i.stopEvent).map(({browserEvent:W})=>{const O=this.getFocus(),H=O.length?O[0]:void 0,V=typeof H!="undefined"?this.view.element(H):void 0,F=typeof H!="undefined"?this.view.domElement(H):this.view.domNode;return{index:H,element:V,anchor:F,browserEvent:W}}).event,q=this.disposables.add(l.Event.chain(this.view.onContextMenu)).filter(W=>!f).map(({element:W,index:O,browserEvent:H})=>({element:W,index:O,anchor:{x:H.pageX+1,y:H.pageY},browserEvent:H})).event;return l.Event.any(I,U,q)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}createMouseController(f){return new fe(this)}updateOptions(f={}){this._options={...this._options,...f},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(f),this.keyboardController?.updateOptions(f),this.view.updateOptions(f)}get options(){return this._options}splice(f,I,U=[]){if(f<0||f>this.view.length)throw new u.ListError(this.user,`Invalid start index: ${f}`);if(I<0)throw new u.ListError(this.user,`Invalid delete count: ${I}`);I===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(f,I,U))}updateWidth(f){this.view.updateWidth(f)}updateElementHeight(f,I){this.view.updateElementHeight(f,I,null)}rerender(){this.view.rerender()}element(f){return this.view.element(f)}indexOf(f){return this.view.indexOf(f)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(f){this.view.setScrollTop(f)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(f){this.view.setScrollLeft(f)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(f){this._ariaLabel=f,this.view.domNode.setAttribute("aria-label",f)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(f,I){this.view.layout(f,I)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(f,I){for(const U of f)if(U<0||U>=this.length)throw new u.ListError(this.user,`Invalid index ${U}`);this.selection.set(f,I)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(f=>this.view.element(f))}setAnchor(f){if(typeof f=="undefined"){this.anchor.set([]);return}if(f<0||f>=this.length)throw new u.ListError(this.user,`Invalid index ${f}`);this.anchor.set([f])}getAnchor(){return(0,m.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const f=this.getAnchor();return typeof f=="undefined"?void 0:this.element(f)}setFocus(f,I){for(const U of f)if(U<0||U>=this.length)throw new u.ListError(this.user,`Invalid index ${U}`);this.focus.set(f,I)}focusNext(f=1,I=!1,U,q){if(this.length===0)return;const W=this.focus.get(),O=this.findNextIndex(W.length>0?W[0]+f:0,I,q);O>-1&&this.setFocus([O],U)}focusPrevious(f=1,I=!1,U,q){if(this.length===0)return;const W=this.focus.get(),O=this.findPreviousIndex(W.length>0?W[0]-f:0,I,q);O>-1&&this.setFocus([O],U)}async focusNextPage(f,I){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const q=this.getFocus()[0];if(q!==U&&(q===void 0||U>q)){const W=this.findPreviousIndex(U,!1,I);W>-1&&q!==W?this.setFocus([W],f):this.setFocus([U],f)}else{const W=this.view.getScrollTop();let O=W+this.view.renderHeight;U>q&&(O-=this.view.elementHeight(U)),this.view.setScrollTop(O),this.view.getScrollTop()!==W&&(this.setFocus([]),await(0,h.timeout)(0),await this.focusNextPage(f,I))}}async focusPreviousPage(f,I){let U;const q=this.view.getScrollTop();q===0?U=this.view.indexAt(q):U=this.view.indexAfter(q-1);const W=this.getFocus()[0];if(W!==U&&(W===void 0||W>=U)){const O=this.findNextIndex(U,!1,I);O>-1&&W!==O?this.setFocus([O],f):this.setFocus([U],f)}else{const O=q;this.view.setScrollTop(q-this.view.renderHeight),this.view.getScrollTop()!==O&&(this.setFocus([]),await(0,h.timeout)(0),await this.focusPreviousPage(f,I))}}focusLast(f,I){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,I);U>-1&&this.setFocus([U],f)}focusFirst(f,I){this.focusNth(0,f,I)}focusNth(f,I,U){if(this.length===0)return;const q=this.findNextIndex(f,!1,U);q>-1&&this.setFocus([q],I)}findNextIndex(f,I=!1,U){for(let q=0;q<this.length;q++){if(f>=this.length&&!I)return-1;if(f=f%this.length,!U||U(this.element(f)))return f;f++}return-1}findPreviousIndex(f,I=!1,U){for(let q=0;q<this.length;q++){if(f<0&&!I)return-1;if(f=(this.length+f%this.length)%this.length,!U||U(this.element(f)))return f;f--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(f=>this.view.element(f))}reveal(f,I){if(f<0||f>=this.length)throw new u.ListError(this.user,`Invalid index ${f}`);const U=this.view.getScrollTop(),q=this.view.elementTop(f),W=this.view.elementHeight(f);if((0,_.isNumber)(I)){const O=W-this.view.renderHeight;this.view.setScrollTop(O*(0,c.clamp)(I,0,1)+q)}else{const O=q+W,H=U+this.view.renderHeight;q<U&&O>=H||(q<U||O>=H&&W>=this.view.renderHeight?this.view.setScrollTop(q):O>=H&&this.view.setScrollTop(O-this.view.renderHeight))}}getRelativeTop(f){if(f<0||f>=this.length)throw new u.ListError(this.user,`Invalid index ${f}`);const I=this.view.getScrollTop(),U=this.view.elementTop(f),q=this.view.elementHeight(f);if(U<I||U+q>I+this.view.renderHeight)return null;const W=q-this.view.renderHeight;return Math.abs((I-U)/W)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(f){return this.view.getElementDomId(f)}style(f){this.styleController.style(f)}toListEvent({indexes:f,browserEvent:I}){return{indexes:f,elements:f.map(U=>this.view.element(U)),browserEvent:I}}_onFocusChange(){const f=this.focus.get();this.view.domNode.classList.toggle("element-focused",f.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const f=this.focus.get();if(f.length>0){let I;this.accessibilityProvider?.getActiveDescendantId&&(I=this.accessibilityProvider.getActiveDescendantId(this.view.element(f[0]))),this.view.domNode.setAttribute("aria-activedescendant",I||this.view.getElementDomId(f[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const f=this.selection.get();this.view.domNode.classList.toggle("selection-none",f.length===0),this.view.domNode.classList.toggle("selection-single",f.length===1),this.view.domNode.classList.toggle("selection-multiple",f.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}Ke([A.memoize],X.prototype,"onDidChangeFocus",null),Ke([A.memoize],X.prototype,"onDidChangeSelection",null),Ke([A.memoize],X.prototype,"onContextMenu",null),Ke([A.memoize],X.prototype,"onKeyDown",null),Ke([A.memoize],X.prototype,"onKeyUp",null),Ke([A.memoize],X.prototype,"onKeyPress",null),Ke([A.memoize],X.prototype,"onDidFocus",null),Ke([A.memoize],X.prototype,"onDidBlur",null),t.List=X}),define(me[59],pe([1,0,13,34,36,10,16]),function(Q,t,D,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var b;(function(g){g[g.Paragraph=0]="Paragraph",g[g.Break=1]="Break"})(b=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class m{constructor(E="",_=!1){if(this.value=E,typeof this.value!="string")throw(0,D.illegalArgument)("value");typeof _=="boolean"?(this.isTrusted=_,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=_.isTrusted??void 0,this.supportThemeIcons=_.supportThemeIcons??!1,this.supportHtml=_.supportHtml??!1)}appendText(E,_=0){return this.value+=l(this.supportThemeIcons?(0,i.escapeIcons)(E):E).replace(/([ \t]+)/g,(u,d)=>"&nbsp;".repeat(d.length)).replace(/\>/gm,"\\>").replace(/\n/g,_===1?`\\
`:`

`),this}appendMarkdown(E){return this.value+=E,this}appendCodeblock(E,_){return this.value+="\n```",this.value+=E,this.value+=`
`,this.value+=_,this.value+="\n```\n",this}appendLink(E,_,u){return this.value+="[",this.value+=this._escape(_,"]"),this.value+="](",this.value+=this._escape(String(E),")"),u&&(this.value+=` "${this._escape(this._escape(u,'"'),")")}"`),this.value+=")",this}_escape(E,_){const u=new RegExp((0,M.escapeRegExpCharacters)(_),"g");return E.replace(u,(d,w)=>E.charAt(w-1)!=="\\"?`\\${d}`:d)}}t.MarkdownString=m;function h(g){return p(g)?!g.value:Array.isArray(g)?g.every(h):!0}t.isEmptyMarkdownString=h;function p(g){return g instanceof m?!0:g&&typeof g=="object"?typeof g.value=="string"&&(typeof g.isTrusted=="boolean"||g.isTrusted===void 0)&&(typeof g.supportThemeIcons=="boolean"||g.supportThemeIcons===void 0):!1}t.isMarkdownString=p;function A(g,E){return g===E?!0:!g||!E?!1:g.value===E.value&&g.isTrusted===E.isTrusted&&g.supportThemeIcons===E.supportThemeIcons&&g.supportHtml===E.supportHtml&&(g.baseUri===E.baseUri||!!g.baseUri&&!!E.baseUri&&(0,P.isEqual)(y.URI.from(g.baseUri),y.URI.from(E.baseUri)))}t.markdownStringEqual=A;function l(g){return g.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=l;function r(g){return g.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=r;function e(g){return g&&g.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function c(g){const E=[],_=g.split("|").map(d=>d.trim());g=_[0];const u=_[1];if(u){const d=/height=(\d+)/.exec(u),w=/width=(\d+)/.exec(u),S=d?d[1]:"",L=w?w[1]:"",C=isFinite(parseInt(L)),n=isFinite(parseInt(S));C&&E.push(`width="${L}"`),n&&E.push(`height="${S}"`)}return{href:g,dimensions:E}}t.parseHrefAndDimensions=c}),define(me[120],pe([1,0,4,112,18,51,20,113,13,3,59,34,71,2,75,49,35,27,36,10,16]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r,e,c,g,E,_,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.renderMarkdown=void 0;function w(a,o={},v={}){const N=new r.DisposableStore;let K=!1;const ne=(0,M.createElement)(o),re=function(he){let te;try{te=(0,c.parse)(decodeURIComponent(he))}catch{}return te?(te=(0,E.cloneAndChange)(te,Z=>{if(a.uris&&a.uris[Z])return d.URI.revive(a.uris[Z])}),encodeURIComponent(JSON.stringify(te))):he},we=function(he,te){const Z=a.uris&&a.uris[he];let se=d.URI.revive(Z);return te?he.startsWith(g.Schemas.data+":")?he:(se||(se=d.URI.parse(he)),g.FileAccess.asBrowserUri(se).toString(!0)):!se||d.URI.parse(he).toString()===se.toString()?he:(se.query&&(se=se.with({query:re(se.query)})),se.toString())},ae=new e.marked.Renderer;ae.image=(he,te,Z)=>{let se=[],ie=[];return he&&({href:he,dimensions:se}=(0,p.parseHrefAndDimensions)(he),ie.push(`src="${(0,p.escapeDoubleQuotes)(he)}"`)),Z&&ie.push(`alt="${(0,p.escapeDoubleQuotes)(Z)}"`),te&&ie.push(`title="${(0,p.escapeDoubleQuotes)(te)}"`),se.length&&(ie=ie.concat(se)),"<img "+ie.join(" ")+">"},ae.link=(he,te,Z)=>typeof he!="string"?"":(he===Z&&(Z=(0,p.removeMarkdownEscapes)(Z)),te=typeof te=="string"?(0,p.escapeDoubleQuotes)((0,p.removeMarkdownEscapes)(te)):"",he=(0,p.removeMarkdownEscapes)(he),he=he.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${he}" title="${te||he}">${Z}</a>`),ae.paragraph=he=>`<p>${he}</p>`;const ve=[];if(o.codeBlockRenderer&&(ae.code=(he,te)=>{const Z=l.defaultGenerator.nextId(),se=o.codeBlockRenderer(te??"",he);return ve.push(se.then(ie=>[Z,ie])),`<div class="code" data-code="${Z}">${(0,u.escape)(he)}</div>`}),o.actionHandler){const he=o.actionHandler.disposables.add(new P.DomEmitter(ne,"click")),te=o.actionHandler.disposables.add(new P.DomEmitter(ne,"auxclick"));o.actionHandler.disposables.add(h.Event.any(he.event,te.event)(Z=>{const se=new y.StandardMouseEvent(Z);if(!se.leftButton&&!se.middleButton)return;let ie=se.target;if(!(ie.tagName!=="A"&&(ie=ie.parentElement,!ie||ie.tagName!=="A")))try{let T=ie.dataset.href;T&&(a.baseUri&&(T=S(d.URI.from(a.baseUri),T)),o.actionHandler.callback(T,se))}catch(T){(0,m.onUnexpectedError)(T)}finally{se.preventDefault()}}))}a.supportHtml||(v.sanitizer=he=>(a.isTrusted?he.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?he:"",v.sanitize=!0,v.silent=!0),v.renderer=ae;let fe=a.value??"";fe.length>1e5&&(fe=`${fe.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(fe=(0,A.markdownEscapeEscapedIcons)(fe));let ge=e.marked.parse(fe,v);a.supportThemeIcons&&(ge=(0,b.renderLabelWithIcons)(ge).map(te=>typeof te=="string"?te:te.outerHTML).join(""));const ee=new DOMParser().parseFromString(L(a,ge),"text/html");if(ee.body.querySelectorAll("img").forEach(he=>{const te=he.getAttribute("src");if(te){let Z=te;try{a.baseUri&&(Z=S(d.URI.from(a.baseUri),Z))}catch{}he.src=we(Z,!0)}}),ee.body.querySelectorAll("a").forEach(he=>{const te=he.getAttribute("href");if(he.setAttribute("href",""),!te||/^data:|javascript:/i.test(te)||/^command:/i.test(te)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(te))he.replaceWith(...he.childNodes);else{let Z=we(te,!1);a.baseUri&&(Z=S(d.URI.from(a.baseUri),te)),he.dataset.href=Z}}),ne.innerHTML=L(a,ee.body.innerHTML),ve.length>0&&Promise.all(ve).then(he=>{if(K)return;const te=new Map(he),Z=ne.querySelectorAll("div[data-code]");for(const se of Z){const ie=te.get(se.dataset.code??"");ie&&D.reset(se,ie)}o.asyncRenderCallback?.()}),o.asyncRenderCallback)for(const he of ne.getElementsByTagName("img")){const te=N.add(D.addDisposableListener(he,"load",()=>{te.dispose(),o.asyncRenderCallback()}))}return{element:ne,dispose:()=>{K=!0,N.dispose()}}}t.renderMarkdown=w;function S(a,o){return/^\w[\w\d+.-]*:/.test(o)?o:a.path.endsWith("/")?(0,_.resolvePath)(a,o).toString():(0,_.resolvePath)((0,_.dirname)(a),o).toString()}function L(a,o){const{config:v,allowedSchemes:N}=C(a);i.addHook("uponSanitizeAttribute",(ne,re)=>{if(re.attrName==="style"||re.attrName==="class"){if(ne.tagName==="SPAN"){if(re.attrName==="style"){re.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(re.attrValue);return}else if(re.attrName==="class"){re.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(re.attrValue);return}}re.keepAttr=!1;return}});const K=D.hookDomPurifyHrefAndSrcSanitizer(N);try{return i.sanitize(o,{...v,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),K.dispose()}}function C(a){const o=[g.Schemas.http,g.Schemas.https,g.Schemas.mailto,g.Schemas.data,g.Schemas.file,g.Schemas.vscodeFileResource,g.Schemas.vscodeRemote,g.Schemas.vscodeRemoteResource];return a.isTrusted&&o.push(g.Schemas.command),{config:{ALLOWED_TAGS:["ul","li","p","b","i","code","blockquote","ol","h1","h2","h3","h4","h5","h6","hr","em","pre","table","thead","tbody","tr","th","td","div","del","a","strong","br","img","span"],ALLOWED_ATTR:["href","data-href","target","title","src","alt","class","style","data-code","width","height","align"],ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:o}}function n(a){return typeof a=="string"?a:s(a)}t.renderStringAsPlaintext=n;function s(a){const o=new e.marked.Renderer;o.code=ne=>ne,o.blockquote=ne=>ne,o.html=ne=>"",o.heading=(ne,re,we)=>ne+`
`,o.hr=()=>"",o.list=(ne,re)=>ne,o.listitem=ne=>ne+`
`,o.paragraph=ne=>ne+`
`,o.table=(ne,re)=>ne+re+`
`,o.tablerow=ne=>ne,o.tablecell=(ne,re)=>ne+" ",o.strong=ne=>ne,o.em=ne=>ne,o.codespan=ne=>ne,o.br=()=>`
`,o.del=ne=>ne,o.image=(ne,re,we)=>"",o.text=ne=>ne,o.link=(ne,re,we)=>we;let v=a.value??"";v.length>1e5&&(v=`${v.substr(0,1e5)}\u2026`);const N=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),K=e.marked.parse(v,{renderer:o}).replace(/&(#\d+|[a-zA-Z]+);/g,ne=>N.get(ne)??ne);return L({isTrusted:!1},K).toString()}t.renderMarkdownAsPlaintext=s}),define(me[121],pe([1,0,4,8,28,59,34,2,6,98]),function(Q,t,D,i,P,M,y,b,m,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function p(r,e){(0,m.isString)(e)?r.title=(0,y.stripIcons)(e):e?.markdownNotSupportedFallback?r.title=e.markdownNotSupportedFallback:r.removeAttribute("title")}t.setupNativeHover=p;class A{constructor(e,c,g){this.hoverDelegate=e,this.target=c,this.fadeInAnimation=g}async update(e,c,g){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let E;if(e===void 0||(0,m.isString)(e)||e instanceof HTMLElement)E=e;else if(!(0,m.isFunction)(e.markdown))E=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,h.localize)(0,null),c),this._cancellationTokenSource=new P.CancellationTokenSource;const _=this._cancellationTokenSource.token;if(E=await e.markdown(_),E===void 0&&(E=e.markdownNotSupportedFallback),this.isDisposed||_.isCancellationRequested)return}this.show(E,c,g)}show(e,c,g){const E=this._hoverWidget;if(this.hasContent(e)){const _={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!E,...g};this._hoverWidget=this.hoverDelegate.showHover(_,c)}E?.dispose()}hasContent(e){return e?(0,M.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function l(r,e,c,g){let E,_;const u=(C,n)=>{C&&(_?.dispose(),_=void 0),n&&(E?.dispose(),E=void 0),r.onDidHideHover?.()},d=(C,n,s)=>new i.TimeoutTimer(async()=>{(!_||_.isDisposed)&&(_=new A(r,s||e,C>0),await _.update(c,n,g))},C),w=()=>{if(E)return;const C=new b.DisposableStore,n=o=>u(!1,o.fromElement===e);C.add(D.addDisposableListener(e,D.EventType.MOUSE_LEAVE,n,!0));const s=()=>u(!0,!0);C.add(D.addDisposableListener(e,D.EventType.MOUSE_DOWN,s,!0));const a={targetElements:[e],dispose:()=>{}};if(r.placement===void 0||r.placement==="mouse"){const o=v=>{a.x=v.x+10,v.target instanceof HTMLElement&&v.target.classList.contains("action-label")&&u(!0,!0)};C.add(D.addDisposableListener(e,D.EventType.MOUSE_MOVE,o,!0))}C.add(d(r.delay,!1,a)),E=C},S=D.addDisposableListener(e,D.EventType.MOUSE_OVER,w,!0);return{show:C=>{u(!1,!0),d(0,C)},hide:()=>{u(!0,!0)},update:async(C,n)=>{c=C,await _?.update(c,void 0,n)},dispose:()=>{S.dispose(),u(!0,!0)}}}t.setupCustomHover=l}),define(me[122],pe([1,0,4,18,19,120,58,14,3,43,2,5,100,91]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const r=D.$,e="selectOption.entry.template";class c{get templateId(){return e}renderTemplate(_){const u=Object.create(null);return u.disposables=[],u.root=_,u.text=D.append(_,r(".option-text")),u.detail=D.append(_,r(".option-detail")),u.decoratorRight=D.append(_,r(".option-decorator-right")),u}renderElement(_,u,d){const w=d,S=_.text,L=_.detail,C=_.decoratorRight,n=_.isDisabled;w.text.textContent=S,w.detail.textContent=L||"",w.decoratorRight.innerText=C||"",n?w.root.classList.add("option-disabled"):w.root.classList.remove("option-disabled")}disposeTemplate(_){_.disposables=(0,p.dispose)(_.disposables)}}class g extends p.Disposable{constructor(_,u,d,w,S){super();this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=S||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=g.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new m.Emitter,this._register(this._onDidSelect),this.styles=w,this.registerListeners(),this.constructSelectDropDown(d),this.selected=u||0,_&&this.setOptions(_,u)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(_){this.contextViewProvider=_,this.selectDropDownContainer=D.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=D.append(this.selectDropDownContainer,r(".select-box-details-pane"));const u=D.append(this.selectDropDownContainer,r(".select-box-dropdown-container-width-control")),d=D.append(u,r(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",D.append(d,this.widthControlElement),this._dropDownPosition=0,this.styleElement=D.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(D.addDisposableListener(this.selectDropDownContainer,D.EventType.DRAG_START,w=>{D.EventHelper.stop(w,!0)}))}registerListeners(){this._register(D.addStandardDisposableListener(this.selectElement,"change",u=>{this.selected=u.target.selectedIndex,this._onDidSelect.fire({index:u.target.selectedIndex,selected:u.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(D.addDisposableListener(this.selectElement,D.EventType.CLICK,u=>{D.EventHelper.stop(u),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(D.addDisposableListener(this.selectElement,D.EventType.MOUSE_DOWN,u=>{D.EventHelper.stop(u)}));let _;this._register(D.addDisposableListener(this.selectElement,"touchstart",u=>{_=this._isVisible})),this._register(D.addDisposableListener(this.selectElement,"touchend",u=>{D.EventHelper.stop(u),_?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(D.addDisposableListener(this.selectElement,D.EventType.KEY_DOWN,u=>{const d=new P.StandardKeyboardEvent(u);let w=!1;A.isMacintosh?(d.keyCode===18||d.keyCode===16||d.keyCode===10||d.keyCode===3)&&(w=!0):(d.keyCode===18&&d.altKey||d.keyCode===16&&d.altKey||d.keyCode===10||d.keyCode===3)&&(w=!0),w&&(this.showSelectDropDown(),D.EventHelper.stop(u,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(_,u){b.equals(this.options,_)||(this.options=_,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((d,w)=>{this.selectElement.add(this.createOption(d.text,w,d.isDisabled)),typeof d.description=="string"&&(this._hasDetails=!0)})),u!==void 0&&(this.select(u),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(_){_>=0&&_<this.options.length?this.selected=_:_>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(_){this.selectBoxOptions.ariaLabel=_,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(_){this.selectElement.tabIndex=_?0:-1}render(_){this.container=_,_.classList.add("select-container"),_.appendChild(this.selectElement),this.applyStyles()}style(_){const u=[];this.styles=_,this.styles.listFocusBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(u.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),u.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&u.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),u.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=u.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const _=this.styles.selectBackground?this.styles.selectBackground.toString():"",u=this.styles.selectForeground?this.styles.selectForeground.toString():"",d=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=_,this.selectElement.style.color=u,this.selectElement.style.borderColor=d}this.selectList&&this.styleList()}styleList(){if(this.selectList){const _=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const u=this.styles.selectListBackground?this.styles.selectListBackground.toString():_;this.selectDropDownListContainer.style.backgroundColor=u,this.selectionDetailsPane.style.backgroundColor=u;const d=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=d,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(_,u,d){const w=document.createElement("option");return w.value=_,w.text=_,w.disabled=!!d,w}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:_=>this.renderSelectDropDown(_,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:_=>this.renderSelectDropDown(_),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(_){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),_&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(_,u){return _.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(u),{dispose:()=>{try{_.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let _=0;return this.options.forEach((u,d)=>{this.updateDetail(d),this.selectionDetailsPane.offsetHeight>_&&(_=this.selectionDetailsPane.offsetHeight)}),_}layoutSelectDropDown(_){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const u=D.getDomNodePagePosition(this.selectElement),d=getComputedStyle(this.selectElement),w=parseFloat(d.getPropertyValue("--dropdown-padding-top"))+parseFloat(d.getPropertyValue("--dropdown-padding-bottom")),S=window.innerHeight-u.top-u.height-(this.selectBoxOptions.minBottomMargin||0),L=u.top-g.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,C=this.selectElement.offsetWidth,n=this.setWidthControlElement(this.widthControlElement),s=Math.max(n,Math.round(C)).toString()+"px";this.selectDropDownContainer.style.width=s,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let a=this.selectList.contentHeight;const o=this._hasDetails?this.measureMaxDetailsHeight():0,v=a+w+o,N=Math.floor((S-w-o)/this.getHeight()),K=Math.floor((L-w-o)/this.getHeight());if(_)return u.top+u.height>window.innerHeight-22||u.top<g.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||N<1&&K<1?!1:(N<g.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&K>N&&this.options.length>N?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(u.top+u.height>window.innerHeight-22||u.top<g.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&N<1||this._dropDownPosition===1&&K<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&N+K<1)return this.hideSelectDropDown(!0),!1;v>S&&(a=N*this.getHeight())}else v>L&&(a=K*this.getHeight());return this.selectList.layout(a),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=a+w+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=a+w+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=s,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(_){let u=0;if(_){let d=0,w=0;this.options.forEach((S,L)=>{const C=S.detail?S.detail.length:0,n=S.decoratorRight?S.decoratorRight.length:0,s=S.text.length+C+n;s>w&&(d=L,w=s)}),_.textContent=this.options[d].text+(this.options[d].decoratorRight?this.options[d].decoratorRight+" ":""),u=D.getTotalWidth(_)}return u}createSelectList(_){if(this.selectList)return;this.selectDropDownListContainer=D.append(_,r(".select-box-dropdown-list-container")),this.listRenderer=new c,this.selectList=new y.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:w=>{let S=w.text;return w.detail&&(S+=`. ${w.detail}`),w.decoratorRight&&(S+=`. ${w.decoratorRight}`),w.description&&(S+=`. ${w.description}`),S},getWidgetAriaLabel:()=>(0,l.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const u=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),d=m.Event.chain(u.event).filter(()=>this.selectList.length>0).map(w=>new P.StandardKeyboardEvent(w));this._register(d.filter(w=>w.keyCode===3).on(w=>this.onEnter(w),this)),this._register(d.filter(w=>w.keyCode===2).on(w=>this.onEnter(w),this)),this._register(d.filter(w=>w.keyCode===9).on(w=>this.onEscape(w),this)),this._register(d.filter(w=>w.keyCode===16).on(w=>this.onUpArrow(w),this)),this._register(d.filter(w=>w.keyCode===18).on(w=>this.onDownArrow(w),this)),this._register(d.filter(w=>w.keyCode===12).on(this.onPageDown,this)),this._register(d.filter(w=>w.keyCode===11).on(this.onPageUp,this)),this._register(d.filter(w=>w.keyCode===14).on(this.onHome,this)),this._register(d.filter(w=>w.keyCode===13).on(this.onEnd,this)),this._register(d.filter(w=>w.keyCode>=21&&w.keyCode<=56||w.keyCode>=80&&w.keyCode<=108).on(this.onCharacter,this)),this._register(D.addDisposableListener(this.selectList.getHTMLElement(),D.EventType.POINTER_UP,w=>this.onPointerUp(w))),this._register(this.selectList.onMouseOver(w=>typeof w.index!="undefined"&&this.selectList.setFocus([w.index]))),this._register(this.selectList.onDidChangeFocus(w=>this.onListFocus(w))),this._register(D.addDisposableListener(this.selectDropDownContainer,D.EventType.FOCUS_OUT,w=>{!this._isVisible||D.isAncestor(w.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(_){if(!this.selectList.length)return;D.EventHelper.stop(_);const u=_.target;if(!u||u.classList.contains("slider"))return;const d=u.closest(".monaco-list-row");if(!d)return;const w=Number(d.getAttribute("data-index")),S=d.classList.contains("option-disabled");w>=0&&w<this.options.length&&!S&&(this.selected=w,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(_,u){const d=S=>{for(let L=0;L<S.childNodes.length;L++){const C=S.childNodes.item(L);(C.tagName&&C.tagName.toLowerCase())==="img"?S.removeChild(C):d(C)}},w=(0,M.renderMarkdown)({value:_},{actionHandler:u});return w.element.classList.add("select-box-description-markdown"),d(w.element),w.element}onListFocus(_){!this._isVisible||!this._hasDetails||this.updateDetail(_.indexes[0])}updateDetail(_){this.selectionDetailsPane.innerText="";const u=this.options[_],d=u?.description??"",w=u?.descriptionIsMarkdown??!1;if(d){if(w){const S=u.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(d,S))}else this.selectionDetailsPane.innerText=d;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(_){D.EventHelper.stop(_),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(_){D.EventHelper.stop(_),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(_){if(this.selected<this.options.length-1){D.EventHelper.stop(_,!0);const u=this.options[this.selected+1].isDisabled;if(u&&this.options.length>this.selected+2)this.selected+=2;else{if(u)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(_){this.selected>0&&(D.EventHelper.stop(_,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(_){D.EventHelper.stop(_),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(_){D.EventHelper.stop(_),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(_){D.EventHelper.stop(_),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(_){D.EventHelper.stop(_),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(_){const u=h.KeyCodeUtils.toString(_.keyCode);let d=-1;for(let w=0;w<this.options.length-1;w++)if(d=(w+this.selected+1)%this.options.length,this.options[d].text.charAt(0).toUpperCase()===u&&!this.options[d].isDisabled){this.select(d),this.selectList.setFocus([d]),this.selectList.reveal(this.selectList.getFocus()[0]),D.EventHelper.stop(_);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=g,g.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,g.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,g.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(me[123],pe([1,0,122,116,17,24,27,5,90]),function(Q,t,D,i,P,M,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:M.Color.fromHex("#3C3C3C"),selectForeground:M.Color.fromHex("#F0F0F0"),selectBorder:M.Color.fromHex("#3C3C3C")};class m extends P.Widget{constructor(p,A,l,r=(0,y.deepClone)(t.defaultStyles),e){super();b.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(p,A,r,e):this.selectBoxDelegate=new D.SelectBoxList(p,A,l,r,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(p,A){this.selectBoxDelegate.setOptions(p,A)}select(p){this.selectBoxDelegate.select(p)}setAriaLabel(p){this.selectBoxDelegate.setAriaLabel(p)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(p){this.selectBoxDelegate.setFocusable(p)}render(p){this.selectBoxDelegate.render(p)}style(p){this.selectBoxDelegate.style(p)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=m}),define(me[60],pe([1,0,15,50,4,22,121,123,32,2,5,6,95,46]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class r extends h.Disposable{constructor(E,_,u={}){super();this.options=u,this._context=E||this,this._action=_,_ instanceof m.Action&&this._register(_.onDidChange(d=>{!this.element||this.handleActionChangeEvent(d)}))}get action(){return this._action}handleActionChangeEvent(E){E.enabled!==void 0&&this.updateEnabled(),E.checked!==void 0&&this.updateChecked(),E.class!==void 0&&this.updateClass(),E.label!==void 0&&(this.updateLabel(),this.updateTooltip()),E.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new m.ActionRunner)),this._actionRunner}set actionRunner(E){this._actionRunner=E}getAction(){return this._action}isEnabled(){return this._action.enabled}setActionContext(E){this._context=E}render(E){const _=this.element=E;this._register(M.Gesture.addTarget(E));const u=this.options&&this.options.draggable;u&&(E.draggable=!0,D.isFirefox&&this._register((0,P.addDisposableListener)(E,P.EventType.DRAG_START,d=>d.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,P.addDisposableListener)(_,M.EventType.Tap,d=>this.onClick(d,!0))),this._register((0,P.addDisposableListener)(_,P.EventType.MOUSE_DOWN,d=>{u||P.EventHelper.stop(d,!0),this._action.enabled&&d.button===0&&_.classList.add("active")})),p.isMacintosh&&this._register((0,P.addDisposableListener)(_,P.EventType.CONTEXT_MENU,d=>{d.button===0&&d.ctrlKey===!0&&this.onClick(d)})),this._register((0,P.addDisposableListener)(_,P.EventType.CLICK,d=>{P.EventHelper.stop(d,!0),this.options&&this.options.isMenu||this.onClick(d)})),this._register((0,P.addDisposableListener)(_,P.EventType.DBLCLICK,d=>{P.EventHelper.stop(d,!0)})),[P.EventType.MOUSE_UP,P.EventType.MOUSE_OUT].forEach(d=>{this._register((0,P.addDisposableListener)(_,d,w=>{P.EventHelper.stop(w),_.classList.remove("active")}))})}onClick(E,_=!1){P.EventHelper.stop(E,!0);const u=A.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?E:{preserveFocus:_}:this._context;this.actionRunner.run(this._action,u)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(E){this.element&&(this.element.tabIndex=E?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.getAction().tooltip}updateTooltip(){if(!this.element)return;const E=this.getTooltip()??"";this.element.setAttribute("aria-label",E),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(E):(this.customHover=(0,y.setupCustomHover)(this.options.hoverDelegate,this.element,E),this._store.add(this.customHover))):this.element.title=E}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=r;class e extends r{constructor(E,_,u={}){super(E,_,u);this.options=u,this.options.icon=u.icon!==void 0?u.icon:!1,this.options.label=u.label!==void 0?u.label:!0,this.cssClass=""}render(E){super.render(E),this.element&&(this.label=(0,P.append)(this.element,(0,P.$)("a.action-label"))),this.label&&(this._action.id===m.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,P.append)(this.element,(0,P.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(E){this.label&&(this.label.tabIndex=E?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.getAction().label)}getTooltip(){let E=null;return this.getAction().tooltip?E=this.getAction().tooltip:!this.options.label&&this.getAction().label&&this.options.icon&&(E=this.getAction().label,this.options.keybinding&&(E=l.localize(0,null,E,this.options.keybinding))),E??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.getAction().class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.getAction().enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateChecked(){this.label&&(this.getAction().checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class c extends r{constructor(E,_,u,d,w,S){super(E,_);this.selectBox=new b.SelectBox(u,d,w,void 0,S),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(E,_){this.selectBox.setOptions(E,_)}select(E){this.selectBox.select(E)}registerListeners(){this._register(this.selectBox.onDidSelect(E=>{this.actionRunner.run(this._action,this.getActionContext(E.selected,E.index))}))}getActionContext(E,_){return E}setFocusable(E){this.selectBox.setFocusable(E)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(E){this.selectBox.render(E)}}t.SelectActionViewItem=c}),define(me[61],pe([1,0,4,19,60,32,3,2,6,46]),function(Q,t,D,i,P,M,y,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var h;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(h=t.ActionsOrientation||(t.ActionsOrientation={}));class p extends b.Disposable{constructor(r,e={}){super();this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new y.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new y.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new y.Emitter),this.onDidRun=this._onDidRun.event,this._onBeforeRun=this._register(new y.Emitter),this.onBeforeRun=this._onBeforeRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new M.ActionRunner,this._register(this._actionRunner)),this._register(this._actionRunner.onDidRun(E=>this._onDidRun.fire(E))),this._register(this._actionRunner.onBeforeRun(E=>this._onBeforeRun.fire(E))),this._actionIds=[],this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let c,g;switch(this._orientation){case 0:c=[15],g=[17];break;case 1:c=[16],g=[18],this.domNode.className+=" vertical";break}this._register(D.addDisposableListener(this.domNode,D.EventType.KEY_DOWN,E=>{const _=new i.StandardKeyboardEvent(E);let u=!0;const d=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;c&&(_.equals(c[0])||_.equals(c[1]))?u=this.focusPrevious():g&&(_.equals(g[0])||_.equals(g[1]))?u=this.focusNext():_.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():_.equals(14)?u=this.focusFirst():_.equals(13)?u=this.focusLast():_.equals(2)&&d instanceof P.BaseActionViewItem&&d.trapsArrowNavigation?u=this.focusNext():this.isTriggerKeyEvent(_)?this._triggerKeys.keyDown?this.doTrigger(_):this.triggerKeyDown=!0:u=!1,u&&(_.preventDefault(),_.stopPropagation())})),this._register(D.addDisposableListener(this.domNode,D.EventType.KEY_UP,E=>{const _=new i.StandardKeyboardEvent(E);this.isTriggerKeyEvent(_)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(_)),_.preventDefault(),_.stopPropagation()):(_.equals(2)||_.equals(1024|2))&&this.updateFocusedItem()})),this.focusTracker=this._register(D.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(D.getActiveElement()===this.domNode||!D.isAncestor(D.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),r.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(r){r?this.actionsList.setAttribute("aria-label",r):this.actionsList.removeAttribute("aria-label")}setFocusable(r){if(this.focusable=r,this.focusable){const e=this.viewItems.find(c=>c instanceof P.BaseActionViewItem&&c.isEnabled());e instanceof P.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof P.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(r){let e=!1;return this._triggerKeys.keys.forEach(c=>{e=e||r.equals(c)}),e}updateFocusedItem(){for(let r=0;r<this.actionsList.children.length;r++){const e=this.actionsList.children[r];if(D.isAncestor(D.getActiveElement(),e)){this.focusedItem=r;break}}}get context(){return this._context}set context(r){this._context=r,this.viewItems.forEach(e=>e.setActionContext(r))}get actionRunner(){return this._actionRunner}set actionRunner(r){r&&(this._actionRunner=r,this.viewItems.forEach(e=>e.actionRunner=r))}getContainer(){return this.domNode}hasAction(r){return this._actionIds.includes(r.id)}getAction(r){return this.viewItems[r].action}push(r,e={}){const c=Array.isArray(r)?r:[r];let g=m.isNumber(e.index)?e.index:null;c.forEach(E=>{const _=document.createElement("li");_.className="action-item",_.setAttribute("role","presentation");let u;this.options.actionViewItemProvider&&(u=this.options.actionViewItemProvider(E)),u||(u=new P.ActionViewItem(this.context,E,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(u,D.addDisposableListener(_,D.EventType.CONTEXT_MENU,d=>{D.EventHelper.stop(d,!0)})),u.actionRunner=this._actionRunner,u.setActionContext(this.context),u.render(_),this.focusable&&u instanceof P.BaseActionViewItem&&this.viewItems.length===0&&u.setFocusable(!0),g===null||g<0||g>=this.actionsList.children.length?(this.actionsList.appendChild(_),this.viewItems.push(u),this._actionIds.push(E.id)):(this.actionsList.insertBefore(_,this.actionsList.children[g]),this.viewItems.splice(g,0,u),this._actionIds.splice(g,0,E.id),g++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(r){if(r>=0&&r<this.actionsList.children.length){const e=this.actionsList.children.item(r);if(e)return e.clientWidth}return 0}getHeight(r){if(r>=0&&r<this.actionsList.children.length){const e=this.actionsList.children.item(r);if(e)return e.clientHeight}return 0}pull(r){r>=0&&r<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[r]),this.viewItemDisposables.get(this.viewItems[r])?.dispose(),this.viewItemDisposables.delete(this.viewItems[r]),(0,b.dispose)(this.viewItems.splice(r,1)),this._actionIds.splice(r,1),this.refreshRole())}clear(){(0,b.dispose)(this.viewItems),this.viewItemDisposables.forEach(r=>r.dispose()),this.viewItemDisposables.clear(),this.viewItems=[],this._actionIds=[],D.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(r){let e=!1,c;if(r===void 0?e=!0:typeof r=="number"?c=r:typeof r=="boolean"&&(e=r),e&&typeof this.focusedItem=="undefined"){const g=this.viewItems.findIndex(E=>E.isEnabled());this.focusedItem=g===-1?void 0:g,this.updateFocus(void 0,void 0,!0)}else c!==void 0&&(this.focusedItem=c),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(r){if(typeof this.focusedItem=="undefined")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let c;do{if(!r&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,c=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===M.Separator.ID));return this.updateFocus(),!0}focusPrevious(r){if(typeof this.focusedItem=="undefined")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let c;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!r&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}c=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!c.isEnabled()||c.action.id===M.Separator.ID));return this.updateFocus(!0),!0}updateFocus(r,e,c=!1){typeof this.focusedItem=="undefined"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const g=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(g){let E=!0;m.isFunction(g.focus)||(E=!1),this.options.focusOnlyEnabledItems&&m.isFunction(g.isEnabled)&&!g.isEnabled()&&(E=!1),g.action.id===M.Separator.ID&&(E=!1),E?(c||this.previouslyFocusedItem!==this.focusedItem)&&(g.focus(r),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(r){if(typeof this.focusedItem=="undefined")return;const e=this.viewItems[this.focusedItem];if(e instanceof P.BaseActionViewItem){const c=e._context===null||e._context===void 0?r:e._context;this.run(e._action,c)}}async run(r,e){await this._actionRunner.run(r,e)}dispose(){(0,b.dispose)(this.viewItems),this.viewItems=[],this._actionIds=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=p;function A(l){if(!l.length)return l;let r=-1;for(let c=0;c<l.length;c++)if(l[c].id!==M.Separator.ID){r=c;break}if(r===-1)return[];l=l.slice(r);for(let c=l.length-1;c>=0&&l[c].id===M.Separator.ID;c--)l.splice(c,1);let e=!1;for(let c=l.length-1;c>=0;c--){const g=l[c].id===M.Separator.ID;g&&!e?l.splice(c,1):g?g&&(e=!1):e=!0}return l}t.prepareActions=A}),define(me[124],pe([1,0,4,18,51,61,53,56,17,24,3,77,27,99,87]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=D.$;var c;(function(u){u[u.INFO=1]="INFO",u[u.WARNING=2]="WARNING",u[u.ERROR=3]="ERROR"})(c=t.MessageType||(t.MessageType={}));const g={inputBackground:h.Color.fromHex("#3C3C3C"),inputForeground:h.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:h.Color.fromHex("#55AAFF"),inputValidationInfoBackground:h.Color.fromHex("#063B49"),inputValidationWarningBorder:h.Color.fromHex("#B89500"),inputValidationWarningBackground:h.Color.fromHex("#352A05"),inputValidationErrorBorder:h.Color.fromHex("#BE1100"),inputValidationErrorBackground:h.Color.fromHex("#5A1D1D")};class E extends m.Widget{constructor(d,w,S){super();this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new p.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=w,this.options=S||Object.create(null),(0,l.mixin)(this.options,g,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=D.append(d,e(".monaco-inputbox.idle"));const L=this.options.flexibleHeight?"textarea":"input",C=D.append(this.element,e(".ibwrapper"));if(this.input=D.append(C,e(L+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=D.append(C,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new b.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),D.append(d,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(a=>this.input.scrollTop=a.scrollTop));const n=this._register(new i.DomEmitter(document,"selectionchange")),s=p.Event.filter(n.event,()=>document.getSelection()?.anchorNode===C);this._register(s(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new M.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(d){this.placeholder=d,this.input.setAttribute("placeholder",d)}setTooltip(d){this.tooltip=d,this.input.title=d}setAriaLabel(d){this.ariaLabel=d,d?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(d){this.input.value!==d&&(this.input.value=d,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:D.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(d=null){this.input.select(),d&&(this.input.setSelectionRange(d.start,d.end),d.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(d){d?this.enable():this.disable()}get width(){return D.getTotalWidth(this.input)}set width(d){if(this.options.flexibleHeight&&this.options.flexibleWidth){let w=0;if(this.mirror){const S=parseFloat(this.mirror.style.paddingLeft||"")||0,L=parseFloat(this.mirror.style.paddingRight||"")||0;w=S+L}this.input.style.width=d-w+"px"}else this.input.style.width=d+"px";this.mirror&&(this.mirror.style.width=d+"px")}set paddingRight(d){this.input.style.width=`calc(100% - ${d}px)`,this.mirror&&(this.mirror.style.paddingRight=d+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const d=this.cachedContentHeight,w=this.cachedHeight,S=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:d,height:w}),this.scrollableElement.setScrollPosition({scrollTop:S})}showMessage(d,w){this.message=d,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(d.type));const S=this.stylesForType(this.message.type);this.element.style.border=S.border?`1px solid ${S.border}`:"",(this.hasFocus()||w)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let d=null;return this.validation&&(d=this.validation(this.value),d?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(d)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),d?.type}stylesForType(d){switch(d){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(d){switch(d){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let d;const w=()=>d.style.width=D.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:L=>{if(!this.message)return null;d=D.append(L,e(".monaco-inputbox-container")),w();const C={inline:!0,className:"monaco-inputbox-message"},n=this.message.formatContent?(0,P.renderFormattedText)(this.message.content,C):(0,P.renderText)(this.message.content,C);n.classList.add(this.classForType(this.message.type));const s=this.stylesForType(this.message.type);return n.style.backgroundColor=s.background?s.background.toString():"",n.style.color=s.foreground?s.foreground.toString():"",n.style.border=s.border?`1px solid ${s.border}`:"",D.append(d,n),null},onHide:()=>{this.state="closed"},layout:w});let S;this.message.type===3?S=r.localize(0,null,this.message.content):this.message.type===2?S=r.localize(1,null,this.message.content):S=r.localize(2,null,this.message.content),y.alert(S),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const d=this.value,S=d.charCodeAt(d.length-1)===10?" ":"";(d+S).replace(/\u000c/g,"")?this.mirror.textContent=d+S:this.mirror.innerText="\xA0",this.layout()}style(d){this.inputBackground=d.inputBackground,this.inputForeground=d.inputForeground,this.inputBorder=d.inputBorder,this.inputValidationInfoBackground=d.inputValidationInfoBackground,this.inputValidationInfoForeground=d.inputValidationInfoForeground,this.inputValidationInfoBorder=d.inputValidationInfoBorder,this.inputValidationWarningBackground=d.inputValidationWarningBackground,this.inputValidationWarningForeground=d.inputValidationWarningForeground,this.inputValidationWarningBorder=d.inputValidationWarningBorder,this.inputValidationErrorBackground=d.inputValidationErrorBackground,this.inputValidationErrorForeground=d.inputValidationErrorForeground,this.inputValidationErrorBorder=d.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const d=this.inputBackground?this.inputBackground.toString():"",w=this.inputForeground?this.inputForeground.toString():"",S=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=d,this.element.style.color=w,this.input.style.backgroundColor="inherit",this.input.style.color=w,this.element.style.borderWidth=S?"1px":"",this.element.style.borderStyle=S?"solid":"",this.element.style.borderColor=S}layout(){if(!this.mirror)return;const d=this.cachedContentHeight;this.cachedContentHeight=D.getTotalHeight(this.mirror),d!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(d){const w=this.inputElement,S=w.selectionStart,L=w.selectionEnd,C=w.value;S!==null&&L!==null&&(this.value=C.substr(0,S)+d+C.substr(L),w.setSelectionRange(S+1,S+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=E;class _ extends E{constructor(d,w,S){const L=r.localize(3,null),C=` or \u21C5 ${L}`,n=` (\u21C5 ${L})`;super(d,w,S);this._onDidFocus=this._register(new p.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new p.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new A.HistoryNavigator(S.history,100);const s=()=>{if(S.showHistoryHint&&S.showHistoryHint()&&!this.placeholder.endsWith(C)&&!this.placeholder.endsWith(n)&&this.history.getHistory().length){const a=this.placeholder.endsWith(")")?C:n,o=this.placeholder+a;S.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=o:this.setPlaceHolder(o)}};this.observer=new MutationObserver((a,o)=>{a.forEach(v=>{v.target.textContent||s()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>s()),this.onblur(this.input,()=>{const a=o=>{if(this.placeholder.endsWith(o)){const v=this.placeholder.slice(0,this.placeholder.length-o.length);return S.showPlaceholderOnFocus?this.placeholder=v:this.setPlaceHolder(v),!0}else return!1};a(n)||a(C)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let d=this.getNextValue();d&&(d=d===this.value?this.getNextValue():d),d&&(this.value=d,y.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let d=this.getPreviousValue();d&&(d=d===this.value?this.getPreviousValue():d),d&&(this.value=d,y.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let d=this.history.current();return d||(d=this.history.last(),this.history.next()),d}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=_}),define(me[62],pe([1,0,60,17,11,24,3,92]),function(Q,t,D,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const b={inputActiveOptionBorder:M.Color.fromHex("#007ACC00"),inputActiveOptionForeground:M.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:M.Color.fromHex("#0E639C50")};class m extends D.BaseActionViewItem{constructor(l,r,e){super(l,r,e);this.toggle=this._register(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(l){this.element=l,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(l){this.toggle.domNode.tabIndex=l?0:-1}}t.ToggleActionViewItem=m;class h extends i.Widget{constructor(l){super();this._onChange=this._register(new y.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...b,...l},this._checked=this._opts.isChecked;const r=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,r.push(...P.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&r.push(...this._opts.actionClassName.split(" ")),this._checked&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...r),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(l){this._checked=l,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(l){this._icon&&this.domNode.classList.remove(...P.CSSIcon.asClassNameArray(this._icon)),this._icon=l,this._icon&&this.domNode.classList.add(...P.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(l){l.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=l.inputActiveOptionBorder),l.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=l.inputActiveOptionForeground),l.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=l.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(l){this.domNode.title=l,this.domNode.setAttribute("aria-label",l)}}t.Toggle=h;class p extends i.Widget{constructor(l,r){super();this.title=l,this.isChecked=r,this.checkbox=new h({title:this.title,isChecked:this.isChecked,icon:P.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(l){this.checkbox.checked=l,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(l){this.styles=l,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=p}),define(me[125],pe([1,0,62,11,97]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const M=P.localize(0,null),y=P.localize(1,null),b=P.localize(2,null);class m extends D.Toggle{constructor(l){super({icon:i.Codicon.caseSensitive,title:M+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.CaseSensitiveToggle=m;class h extends D.Toggle{constructor(l){super({icon:i.Codicon.wholeWord,title:y+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.WholeWordsToggle=h;class p extends D.Toggle{constructor(l){super({icon:i.Codicon.regex,title:b+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.RegexToggle=p}),define(me[126],pe([1,0,4,125,124,17,3,96,86]),function(Q,t,D,i,P,M,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const m=b.localize(0,null);class h extends M.Widget{constructor(A,l,r,e){super();this._showOptionButtons=r,this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalToggles=[],this._onDidOptionChange=this._register(new y.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new y.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new y.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new y.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new y.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new y.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new y.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.contextViewProvider=l,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||m,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const c=e.appendCaseSensitiveLabel||"",g=e.appendWholeWordsLabel||"",E=e.appendRegexLabel||"",_=e.history||[],u=!!e.flexibleHeight,d=!!e.flexibleWidth,w=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new P.HistoryInputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:_,showHistoryHint:e.showHistoryHint,flexibleHeight:u,flexibleWidth:d,flexibleMaxHeight:w})),this.regex=this._register(new i.RegexToggle({appendTitle:E,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(L=>{this._onDidOptionChange.fire(L),!L&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(L=>{this._onRegexKeyDown.fire(L)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:g,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(L=>{this._onDidOptionChange.fire(L),!L&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:c,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(L=>{this._onDidOptionChange.fire(L),!L&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(L=>{this._onCaseSensitiveKeyDown.fire(L)}));const S=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,L=>{if(L.equals(15)||L.equals(17)||L.equals(9)){const C=S.indexOf(document.activeElement);if(C>=0){let n=-1;L.equals(17)?n=(C+1)%S.length:L.equals(15)&&(C===0?n=S.length-1:n=C-1),L.equals(9)?(S[C].blur(),this.inputBox.focus()):n>=0&&S[n].focus(),D.EventHelper.stop(L,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this._showOptionButtons?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this._showOptionButtons||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none");for(const L of e?.additionalToggles??[])this._register(L),this.controls.appendChild(L.domNode),this._register(L.onChange(C=>{this._onDidOptionChange.fire(C),!C&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(L);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this._showOptionButtons?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((L,C)=>L+C.width(),0),this.domNode.appendChild(this.controls),A?.appendChild(this.domNode),this._register(D.addDisposableListener(this.inputBox.inputElement,"compositionstart",L=>{this.imeSessionInProgress=!0})),this._register(D.addDisposableListener(this.inputBox.inputElement,"compositionend",L=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,L=>this._onKeyDown.fire(L)),this.onkeyup(this.inputBox.inputElement,L=>this._onKeyUp.fire(L)),this.oninput(this.inputBox.inputElement,L=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,L=>this._onMouseDown.fire(L))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const A of this.additionalToggles)A.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const A of this.additionalToggles)A.disable()}setFocusInputOnOptionClick(A){this.fixFocusOnOptionClickEnabled=A}setEnabled(A){A?this.enable():this.disable()}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(A){this.inputBox.value!==A&&(this.inputBox.value=A)}onSearchSubmit(){this.inputBox.addToHistory()}style(A){this.inputActiveOptionBorder=A.inputActiveOptionBorder,this.inputActiveOptionForeground=A.inputActiveOptionForeground,this.inputActiveOptionBackground=A.inputActiveOptionBackground,this.inputBackground=A.inputBackground,this.inputForeground=A.inputForeground,this.inputBorder=A.inputBorder,this.inputValidationInfoBackground=A.inputValidationInfoBackground,this.inputValidationInfoForeground=A.inputValidationInfoForeground,this.inputValidationInfoBorder=A.inputValidationInfoBorder,this.inputValidationWarningBackground=A.inputValidationWarningBackground,this.inputValidationWarningForeground=A.inputValidationWarningForeground,this.inputValidationWarningBorder=A.inputValidationWarningBorder,this.inputValidationErrorBackground=A.inputValidationErrorBackground,this.inputValidationErrorForeground=A.inputValidationErrorForeground,this.inputValidationErrorBorder=A.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const A={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(A),this.wholeWords.style(A),this.caseSensitive.style(A);for(const r of this.additionalToggles)r.style(A);const l={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(l)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(A){this.caseSensitive.checked=A}getWholeWords(){return this.wholeWords.checked}setWholeWords(A){this.wholeWords.checked=A}getRegex(){return this.regex.checked}setRegex(A){this.regex.checked=A,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(A){this.inputBox.showMessage(A)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=h,h.OPTION_CHANGE="optionChange"}),define(me[127],pe([1,0,4,18,19,61,126,57,58,62,54,23,32,14,8,11,69,3,33,2,44,6,101,93]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r,e,c,g,E,_,u,d,w,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class L extends b.ElementsDragAndDropData{constructor(T){super(T.elements.map($=>$.element));this.data=T}set context(T){this.data.context=T}get context(){return this.data.context}}function C(ie){return ie instanceof b.ElementsDragAndDropData?new L(ie):ie}class n{constructor(T,$){this.modelProvider=T,this.dnd=$,this.autoExpandDisposable=u.Disposable.None}getDragURI(T){return this.dnd.getDragURI(T.element)}getDragLabel(T,$){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(T.map(X=>X.element),$)}onDragStart(T,$){this.dnd.onDragStart?.(C(T),$)}onDragOver(T,$,X,R,f=!0){const I=this.dnd.onDragOver(C(T),$&&$.element,X,R),U=this.autoExpandNode!==$;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=$),typeof $=="undefined")return I;if(U&&typeof I!="boolean"&&I.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const V=this.modelProvider(),F=V.getNodeLocation($);V.isCollapsed(F)&&V.setCollapsed(F,!1),this.autoExpandNode=void 0},500)),typeof I=="boolean"||!I.accept||typeof I.bubble=="undefined"||I.feedback){if(!f){const V=typeof I=="boolean"?I:I.accept,F=typeof I=="boolean"?void 0:I.effect;return{accept:V,effect:F,feedback:[X]}}return I}if(I.bubble===1){const V=this.modelProvider(),F=V.getNodeLocation($),z=V.getParentNodeLocation(F),k=V.getNode(z),B=z&&V.getListIndex(z);return this.onDragOver(T,k,B,R,!1)}const q=this.modelProvider(),W=q.getNodeLocation($),O=q.getListIndex(W),H=q.getListRenderCount(W);return{...I,feedback:(0,r.range)(O,O+H)}}drop(T,$,X,R){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(C(T),$&&$.element,X,R)}onDragEnd(T){this.dnd.onDragEnd?.(T)}}function s(ie,T){return T&&{...T,identityProvider:T.identityProvider&&{getId($){return T.identityProvider.getId($.element)}},dnd:T.dnd&&new n(ie,T.dnd),multipleSelectionController:T.multipleSelectionController&&{isSelectionSingleChangeEvent($){return T.multipleSelectionController.isSelectionSingleChangeEvent({...$,element:$.element})},isSelectionRangeChangeEvent($){return T.multipleSelectionController.isSelectionRangeChangeEvent({...$,element:$.element})}},accessibilityProvider:T.accessibilityProvider&&{...T.accessibilityProvider,getSetSize($){const X=ie(),R=X.getNodeLocation($),f=X.getParentNodeLocation(R);return X.getNode(f).visibleChildrenCount},getPosInSet($){return $.visibleChildIndex+1},isChecked:T.accessibilityProvider&&T.accessibilityProvider.isChecked?$=>T.accessibilityProvider.isChecked($.element):void 0,getRole:T.accessibilityProvider&&T.accessibilityProvider.getRole?$=>T.accessibilityProvider.getRole($.element):()=>"treeitem",getAriaLabel($){return T.accessibilityProvider.getAriaLabel($.element)},getWidgetAriaLabel(){return T.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:T.accessibilityProvider&&T.accessibilityProvider.getWidgetRole?()=>T.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:T.accessibilityProvider&&T.accessibilityProvider.getAriaLevel?$=>T.accessibilityProvider.getAriaLevel($.element):$=>$.depth,getActiveDescendantId:T.accessibilityProvider.getActiveDescendantId&&($=>T.accessibilityProvider.getActiveDescendantId($.element))},keyboardNavigationLabelProvider:T.keyboardNavigationLabelProvider&&{...T.keyboardNavigationLabelProvider,getKeyboardNavigationLabel($){return T.keyboardNavigationLabelProvider.getKeyboardNavigationLabel($.element)}}}}class a{constructor(T){this.delegate=T}getHeight(T){return this.delegate.getHeight(T.element)}getTemplateId(T){return this.delegate.getTemplateId(T.element)}hasDynamicHeight(T){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(T.element)}setDynamicHeight(T,$){this.delegate.setDynamicHeight?.(T.element,$)}}t.ComposedTreeDelegate=a;class o{constructor(T){if(this.focus=new Set(T.focus),this.selection=new Set(T.selection),T.expanded instanceof Array){this.expanded=Object.create(null);for(const $ of T.expanded)this.expanded[$]=1}else this.expanded=T.expanded;this.expanded=T.expanded,this.scrollTop=T.scrollTop}static lift(T){return T instanceof o?T:new o(T)}static empty(T=0){return new o({focus:[],selection:[],expanded:Object.create(null),scrollTop:T})}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=o;var v;(function(ie){ie.None="none",ie.OnHover="onHover",ie.Always="always"})(v=t.RenderIndentGuides||(t.RenderIndentGuides={}));class N{constructor(T,$=[]){this._elements=$,this.disposables=new u.DisposableStore,this.onDidChange=E.Event.forEach(T,X=>this._elements=X,this.disposables)}get elements(){return this._elements}dispose(){this.disposables.dispose()}}class K{constructor(T,$,X,R,f={}){this.renderer=T,this.modelProvider=$,this.activeNodes=R,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=K.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.renderedIndentGuides=new g.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=u.Disposable.None,this.disposables=new u.DisposableStore,this.templateId=T.templateId,this.updateOptions(f),E.Event.map(X,I=>I.node)(this.onDidChangeNodeTwistieState,this,this.disposables),T.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(T={}){if(typeof T.indent!="undefined"&&(this.indent=(0,d.clamp)(T.indent,0,40)),typeof T.renderIndentGuides!="undefined"){const $=T.renderIndentGuides!==v.None;if($!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=$,this.indentGuidesDisposable.dispose(),$)){const X=new u.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,X),this.indentGuidesDisposable=X,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof T.hideTwistiesOfChildlessElements!="undefined"&&(this.hideTwistiesOfChildlessElements=T.hideTwistiesOfChildlessElements)}renderTemplate(T){const $=(0,D.append)(T,(0,D.$)(".monaco-tl-row")),X=(0,D.append)($,(0,D.$)(".monaco-tl-indent")),R=(0,D.append)($,(0,D.$)(".monaco-tl-twistie")),f=(0,D.append)($,(0,D.$)(".monaco-tl-contents")),I=this.renderer.renderTemplate(f);return{container:T,indent:X,twistie:R,indentGuidesDisposable:u.Disposable.None,templateData:I}}renderElement(T,$,X,R){typeof R=="number"&&(this.renderedNodes.set(T,{templateData:X,height:R}),this.renderedElements.set(T.element,T));const f=K.DefaultIndent+(T.depth-1)*this.indent;X.twistie.style.paddingLeft=`${f}px`,X.indent.style.width=`${f+this.indent-16}px`,this.renderTwistie(T,X),typeof R=="number"&&this.renderIndentGuides(T,X),this.renderer.renderElement(T,$,X.templateData,R)}disposeElement(T,$,X,R){X.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(T,$,X.templateData,R),typeof R=="number"&&(this.renderedNodes.delete(T),this.renderedElements.delete(T.element))}disposeTemplate(T){this.renderer.disposeTemplate(T.templateData)}onDidChangeTwistieState(T){const $=this.renderedElements.get(T);!$||this.onDidChangeNodeTwistieState($)}onDidChangeNodeTwistieState(T){const $=this.renderedNodes.get(T);!$||(this.renderTwistie(T,$.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(T,$.templateData))}renderTwistie(T,$){$.twistie.classList.remove(...c.Codicon.treeItemExpanded.classNamesArray);let X=!1;this.renderer.renderTwistie&&(X=this.renderer.renderTwistie(T.element,$.twistie)),T.collapsible&&(!this.hideTwistiesOfChildlessElements||T.visibleChildrenCount>0)?(X||$.twistie.classList.add(...c.Codicon.treeItemExpanded.classNamesArray),$.twistie.classList.add("collapsible"),$.twistie.classList.toggle("collapsed",T.collapsed)):$.twistie.classList.remove("collapsible","collapsed"),T.collapsible?$.container.setAttribute("aria-expanded",String(!T.collapsed)):$.container.removeAttribute("aria-expanded")}renderIndentGuides(T,$){if((0,D.clearNode)($.indent),$.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const X=new u.DisposableStore,R=this.modelProvider();let f=T;for(;;){const I=R.getNodeLocation(f),U=R.getParentNodeLocation(I);if(!U)break;const q=R.getNode(U),W=(0,D.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(q)&&W.classList.add("active"),$.indent.childElementCount===0?$.indent.appendChild(W):$.indent.insertBefore(W,$.indent.firstElementChild),this.renderedIndentGuides.add(q,W),X.add((0,u.toDisposable)(()=>this.renderedIndentGuides.delete(q,W))),f=q}$.indentGuidesDisposable=X}_onDidChangeActiveNodes(T){if(!this.shouldRenderIndentGuides)return;const $=new Set,X=this.modelProvider();T.forEach(R=>{const f=X.getNodeLocation(R);try{const I=X.getParentNodeLocation(f);R.collapsible&&R.children.length>0&&!R.collapsed?$.add(R):I&&$.add(X.getNode(I))}catch{}}),this.activeIndentNodes.forEach(R=>{$.has(R)||this.renderedIndentGuides.forEach(R,f=>f.classList.remove("active"))}),$.forEach(R=>{this.activeIndentNodes.has(R)||this.renderedIndentGuides.forEach(R,f=>f.classList.add("active"))}),this.activeIndentNodes=$}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,u.dispose)(this.disposables)}}K.DefaultIndent=8;class ne{constructor(T,$,X){this.tree=T,this.keyboardNavigationLabelProvider=$,this._filter=X,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new u.DisposableStore,T.onWillRefilter(this.reset,this,this.disposables)}get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(T){this._pattern=T,this._lowercasePattern=T.toLowerCase()}filter(T,$){let X=1;if(this._filter){const I=this._filter.filter(T,$);if(typeof I=="boolean"?X=I?1:0:(0,p.isFilterResult)(I)?X=(0,p.getVisibleState)(I.visibility):X=I,X===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:_.FuzzyScore.Default,visibility:X};const R=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(T),f=Array.isArray(R)?R:[R];for(const I of f){const U=I&&I.toString();if(typeof U=="undefined")return{data:_.FuzzyScore.Default,visibility:X};const q=(0,_.fuzzyScore)(this._pattern,this._lowercasePattern,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(q)return this._matchCount++,f.length===1?{data:q,visibility:X}:{data:{label:U,score:q},visibility:X}}return this.tree.findMode===we.Filter?2:{data:_.FuzzyScore.Default,visibility:X}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,u.dispose)(this.disposables)}}class re extends h.Toggle{constructor(T){super({icon:c.Codicon.filter,title:(0,S.localize)(0,null),isChecked:T?.isChecked??!1,inputActiveOptionBorder:T?.inputActiveOptionBorder,inputActiveOptionForeground:T?.inputActiveOptionForeground,inputActiveOptionBackground:T?.inputActiveOptionBackground})}}t.ModeToggle=re;var we;(function(ie){ie[ie.Highlight=0]="Highlight",ie[ie.Filter=1]="Filter"})(we=t.TreeFindMode||(t.TreeFindMode={}));class ae extends u.Disposable{constructor(T,$,X,R,f){super();this.tree=$,this.elements=(0,D.h)(".monaco-tree-type-filter",[(0,D.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,D.h)(".monaco-tree-type-filter-input@findInput"),(0,D.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this._onDidDisable=new E.Emitter,this.onDidDisable=this._onDidDisable.event,T.appendChild(this.elements.root),this._register((0,u.toDisposable)(()=>T.removeChild(this.elements.root))),this.modeToggle=this._register(new re({...f,isChecked:R===we.Filter})),this.onDidChangeMode=E.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?we.Filter:we.Highlight,this._store),this.findInput=this._register(new y.FindInput(this.elements.findInput,X,!1,{label:(0,S.localize)(3,null),additionalToggles:[this.modeToggle]})),this.actionbar=this._register(new M.ActionBar(this.elements.actionbar)),this.mode=R;const I=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(E.Event.chain(I.event)).map(H=>new P.StandardKeyboardEvent(H)).event;this._register(U(H=>{switch(H.keyCode){case 18:H.preventDefault(),H.stopPropagation(),this.tree.domFocus();return}}));const q=this._register(new l.Action("close",(0,S.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(q,{icon:!0,label:!1});const W=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(W.event(H=>{const V=new u.DisposableStore,F=V.add(new i.DomEmitter(window,"mousemove")),z=V.add(new i.DomEmitter(window,"mouseup")),k=this.right,B=H.pageX;this.elements.grab.classList.add("grabbing");const j=J=>{const ce=J.pageX-B;this.right=k-ce,this.layout()};V.add(F.event(j)),V.add(z.event(J=>{j(J),this.elements.grab.classList.remove("grabbing"),V.dispose()}))}));const O=this._register(E.Event.chain(this._register(new i.DomEmitter(this.elements.grab,"keydown")).event)).map(H=>new P.StandardKeyboardEvent(H)).event;this._register(O(H=>{let V;H.keyCode===15?V=Number.POSITIVE_INFINITY:H.keyCode===17?V=0:H.keyCode===10&&(V=this.right===0?Number.POSITIVE_INFINITY:0),V!==void 0&&(H.preventDefault(),H.stopPropagation(),this.right=V,this.layout())})),this.onDidChangeValue=this.findInput.onDidChange,this.style(f??{})}set mode(T){this.modeToggle.checked=T===we.Filter,this.findInput.inputBox.setPlaceHolder(T===we.Filter?(0,S.localize)(1,null):(0,S.localize)(2,null))}style(T){this.findInput.style(T),T.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=T.listFilterWidgetBackground.toString()),T.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${T.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(T=this.width){this.width=T,this.right=(0,d.clamp)(this.right,0,Math.max(0,T-212)),this.elements.root.style.right=`${this.right}px`}showMessage(T){this.findInput.showMessage(T)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class ve{constructor(T,$,X,R,f){this.tree=T,this.view=X,this.filter=R,this.contextViewProvider=f,this._pattern="",this.width=0,this._onDidChangeMode=new E.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new E.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new E.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new u.DisposableStore,this.disposables=new u.DisposableStore,this._mode=T.options.defaultFindMode??we.Highlight,$.onDidSplice(this.onDidSpliceModel,this,this.disposables)}get pattern(){return this._pattern}get mode(){return this._mode}set mode(T){T!==this._mode&&(this._mode=T,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(T))}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.mode=this.tree.options.defaultFindMode??we.Highlight,this.widget=new ae(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(T=>this.mode=T,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new u.DisposableStore,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(T){this._pattern=T,this._onDidChangePattern.fire(T),this.filter.pattern=T,this.tree.refilter(),T&&this.tree.focusNext(0,!0,void 0,X=>!_.FuzzyScore.isDefault(X.filterData));const $=this.tree.getFocus();if($.length>0){const X=$[0];this.tree.getRelativeTop(X)===null&&this.tree.reveal(X,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const T=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&T?this.widget?.showMessage({type:2,content:(0,S.localize)(5,null)}):this.widget?.clearMessage()}shouldAllowFocus(T){return!this.widget||!this.pattern||this._mode===we.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!_.FuzzyScore.isDefault(T.filterData)}style(T){this.styles=T,this.widget?.style(T)}layout(T){this.width=T,this.widget?.layout(T)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function fe(ie){let T=A.TreeMouseEventTarget.Unknown;return(0,D.hasParentWithClass)(ie.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?T=A.TreeMouseEventTarget.Twistie:(0,D.hasParentWithClass)(ie.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?T=A.TreeMouseEventTarget.Element:(0,D.hasParentWithClass)(ie.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(T=A.TreeMouseEventTarget.Filter),{browserEvent:ie.browserEvent,element:ie.element?ie.element.element:null,target:T}}function ge(ie){return{element:ie.element?ie.element.element:null,browserEvent:ie.browserEvent,anchor:ie.anchor}}function ye(ie,T){T(ie),ie.children.forEach($=>ye($,T))}class ee{constructor(T,$){this.getFirstViewElementWithTrait=T,this.identityProvider=$,this.nodes=[],this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event}get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}set(T,$){!$?.__forceEvent&&(0,r.equals)(this.nodes,T)||this._set(T,!1,$)}_set(T,$,X){if(this.nodes=[...T],this.elements=void 0,this._nodeSet=void 0,!$){const R=this;this._onDidChange.fire({get elements(){return R.get()},browserEvent:X})}}get(){return this.elements||(this.elements=this.nodes.map(T=>T.element)),[...this.elements]}getNodes(){return this.nodes}has(T){return this.nodeSet.has(T)}onDidModelSplice({insertedNodes:T,deletedNodes:$}){if(!this.identityProvider){const q=this.createNodeSet(),W=O=>q.delete(O);$.forEach(O=>ye(O,W)),this.set([...q.values()]);return}const X=new Set,R=q=>X.add(this.identityProvider.getId(q.element).toString());$.forEach(q=>ye(q,R));const f=new Map,I=q=>f.set(this.identityProvider.getId(q.element).toString(),q);T.forEach(q=>ye(q,I));const U=[];for(const q of this.nodes){const W=this.identityProvider.getId(q.element).toString();if(!X.has(W))U.push(q);else{const H=f.get(W);H&&U.push(H)}}if(this.nodes.length>0&&U.length===0){const q=this.getFirstViewElementWithTrait();q&&U.push(q)}this._set(U,!0)}createNodeSet(){const T=new Set;for(const $ of this.nodes)T.add($);return T}}class he extends m.MouseController{constructor(T,$){super(T);this.tree=$}onViewPointer(T){if((0,m.isButton)(T.browserEvent.target)||(0,m.isInputElement)(T.browserEvent.target)||(0,m.isMonacoEditor)(T.browserEvent.target))return;const $=T.element;if(!$)return super.onViewPointer(T);if(this.isSelectionRangeChangeEvent(T)||this.isSelectionSingleChangeEvent(T))return super.onViewPointer(T);const X=T.browserEvent.target,R=X.classList.contains("monaco-tl-twistie")||X.classList.contains("monaco-icon-label")&&X.classList.contains("folder-icon")&&T.browserEvent.offsetX<16;let f=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?f=this.tree.expandOnlyOnTwistieClick($.element):f=!!this.tree.expandOnlyOnTwistieClick,f&&!R&&T.browserEvent.detail!==2)return super.onViewPointer(T);if(!this.tree.expandOnDoubleClick&&T.browserEvent.detail===2)return super.onViewPointer(T);if($.collapsible){const I=this.tree.model,U=I.getNodeLocation($),q=T.browserEvent.altKey;if(this.tree.setFocus([U]),I.setCollapsed(U,void 0,q),f&&R)return}super.onViewPointer(T)}onDoubleClick(T){T.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(T)}}class te extends m.List{constructor(T,$,X,R,f,I,U,q){super(T,$,X,R,q);this.focusTrait=f,this.selectionTrait=I,this.anchorTrait=U}createMouseController(T){return new he(this,T.tree)}splice(T,$,X=[]){if(super.splice(T,$,X),X.length===0)return;const R=[],f=[];let I;X.forEach((U,q)=>{this.focusTrait.has(U)&&R.push(T+q),this.selectionTrait.has(U)&&f.push(T+q),this.anchorTrait.has(U)&&(I=T+q)}),R.length>0&&super.setFocus((0,r.distinct)([...super.getFocus(),...R])),f.length>0&&super.setSelection((0,r.distinct)([...super.getSelection(),...f])),typeof I=="number"&&super.setAnchor(I)}setFocus(T,$,X=!1){super.setFocus(T,$),X||this.focusTrait.set(T.map(R=>this.element(R)),$)}setSelection(T,$,X=!1){super.setSelection(T,$),X||this.selectionTrait.set(T.map(R=>this.element(R)),$)}setAnchor(T,$=!1){super.setAnchor(T),$||(typeof T=="undefined"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(T)]))}}class Z{constructor(T,$,X,R,f={}){this._user=T,this._options=f,this.eventBufferer=new E.EventBufferer,this.onDidChangeFindOpenState=E.Event.None,this.disposables=new u.DisposableStore,this._onWillRefilter=new E.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new E.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const I=new a(X),U=new E.Relay,q=new E.Relay,W=this.disposables.add(new N(q.event));this.renderers=R.map(V=>new K(V,()=>this.model,U.event,W,f));for(const V of this.renderers)this.disposables.add(V);let O;f.keyboardNavigationLabelProvider&&(O=new ne(this,f.keyboardNavigationLabelProvider,f.filter),f={...f,filter:O},this.disposables.add(O)),this.focus=new ee(()=>this.view.getFocusedElements()[0],f.identityProvider),this.selection=new ee(()=>this.view.getSelectedElements()[0],f.identityProvider),this.anchor=new ee(()=>this.view.getAnchorElement(),f.identityProvider),this.view=new te(T,$,I,this.renderers,this.focus,this.selection,this.anchor,{...s(()=>this.model,f),tree:this}),this.model=this.createModel(T,this.view,f),U.input=this.model.onDidChangeCollapseState;const H=E.Event.forEach(this.model.onDidSplice,V=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(V),this.selection.onDidModelSplice(V)})},this.disposables);if(H(()=>null,null,this.disposables),q.input=E.Event.chain(E.Event.any(H,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const V=new Set;for(const F of this.focus.getNodes())V.add(F);for(const F of this.selection.getNodes())V.add(F);return[...V.values()]}).event,f.keyboardSupport!==!1){const V=E.Event.chain(this.view.onKeyDown).filter(F=>!(0,m.isInputElement)(F.target)).map(F=>new P.StandardKeyboardEvent(F));V.filter(F=>F.keyCode===15).on(this.onLeftArrow,this,this.disposables),V.filter(F=>F.keyCode===17).on(this.onRightArrow,this,this.disposables),V.filter(F=>F.keyCode===10).on(this.onSpace,this,this.disposables)}(f.findWidgetEnabled??!0)&&f.keyboardNavigationLabelProvider&&f.contextViewProvider?(this.findController=new ve(this,this.model,this.view,O,f.contextViewProvider),this.focusNavigationFilter=V=>this.findController.shouldAllowFocus(V),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=E.Event.None,this.styleElement=(0,D.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===v.Always)}get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return E.Event.map(this.view.onMouseClick,fe)}get onMouseDblClick(){return E.Event.filter(E.Event.map(this.view.onMouseDblClick,fe),T=>T.target!==A.TreeMouseEventTarget.Filter)}get onContextMenu(){return E.Event.map(this.view.onContextMenu,ge)}get onTap(){return E.Event.map(this.view.onTap,fe)}get onPointer(){return E.Event.map(this.view.onPointer,fe)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return E.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??we.Highlight}set findMode(T){this.findController&&(this.findController.mode=T)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:E.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick=="undefined"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick=="undefined"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}updateOptions(T={}){this._options={...this._options,...T};for(const $ of this.renderers)$.updateOptions(T);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===v.Always)}get options(){return this._options}updateWidth(T){const $=this.model.getListIndex(T);$!==-1&&this.view.updateWidth($)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(T){this.view.scrollTop=T}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(T){this.view.scrollLeft=T}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const T=this.view.firstVisibleIndex;return T<0||T>=this.view.length?void 0:this.view.element(T).element}get lastVisibleElement(){const T=this.view.lastVisibleIndex;return this.view.element(T).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(T){this.view.ariaLabel=T}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(T,$){this.view.layout(T,$),(0,w.isNumber)($)&&this.findController?.layout($)}style(T){const $=`.${this.view.domId}`,X=[];T.treeIndentGuidesStroke&&(X.push(`.monaco-list${$}:hover .monaco-tl-indent > .indent-guide, .monaco-list${$}.always .monaco-tl-indent > .indent-guide  { border-color: ${T.treeIndentGuidesStroke.transparent(.4)}; }`),X.push(`.monaco-list${$} .monaco-tl-indent > .indent-guide.active { border-color: ${T.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=X.join(`
`),this.findController?.style(T),this.view.style(T)}getParentElement(T){const $=this.model.getParentNodeLocation(T);return this.model.getNode($).element}getFirstElementChild(T){return this.model.getFirstElementChild(T)}getNode(T){return this.model.getNode(T)}collapse(T,$=!1){return this.model.setCollapsed(T,!0,$)}expand(T,$=!1){return this.model.setCollapsed(T,!1,$)}toggleCollapsed(T,$=!1){return this.model.setCollapsed(T,void 0,$)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(T){return this.model.isCollapsible(T)}setCollapsible(T,$){return this.model.setCollapsible(T,$)}isCollapsed(T){return this.model.isCollapsed(T)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(T){if(typeof T=="undefined")return this.view.setAnchor(void 0);const $=this.model.getNode(T);this.anchor.set([$]);const X=this.model.getListIndex(T);X>-1&&this.view.setAnchor(X,!0)}getAnchor(){return(0,r.firstOrDefault)(this.anchor.get(),void 0)}setSelection(T,$){const X=T.map(f=>this.model.getNode(f));this.selection.set(X,$);const R=T.map(f=>this.model.getListIndex(f)).filter(f=>f>-1);this.view.setSelection(R,$,!0)}getSelection(){return this.selection.get()}setFocus(T,$){const X=T.map(f=>this.model.getNode(f));this.focus.set(X,$);const R=T.map(f=>this.model.getListIndex(f)).filter(f=>f>-1);this.view.setFocus(R,$,!0)}focusNext(T=1,$=!1,X,R=this.focusNavigationFilter){this.view.focusNext(T,$,X,R)}focusPrevious(T=1,$=!1,X,R=this.focusNavigationFilter){this.view.focusPrevious(T,$,X,R)}focusNextPage(T,$=this.focusNavigationFilter){return this.view.focusNextPage(T,$)}focusPreviousPage(T,$=this.focusNavigationFilter){return this.view.focusPreviousPage(T,$)}focusLast(T,$=this.focusNavigationFilter){this.view.focusLast(T,$)}focusFirst(T,$=this.focusNavigationFilter){this.view.focusFirst(T,$)}getFocus(){return this.focus.get()}reveal(T,$){this.model.expandTo(T);const X=this.model.getListIndex(T);X!==-1&&this.view.reveal(X,$)}getRelativeTop(T){const $=this.model.getListIndex(T);return $===-1?null:this.view.getRelativeTop($)}getViewState(T=this.options.identityProvider){if(!T)throw new A.TreeError(this._user,"Can't get tree view state without an identity provider");const $=I=>T.getId(I).toString(),X=o.empty(this.scrollTop);for(const I of this.getFocus())X.focus.add($(I));for(const I of this.getSelection())X.selection.add($(I));const R=this.model.getNode(),f=[R];for(;f.length>0;){const I=f.shift();I!==R&&I.collapsible&&(X.expanded[$(I.element)]=I.collapsed?0:1),f.push(...I.children)}return X}onLeftArrow(T){T.preventDefault(),T.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const X=$[0],R=this.model.getNodeLocation(X);if(!this.model.setCollapsed(R,!0)){const I=this.model.getParentNodeLocation(R);if(!I)return;const U=this.model.getListIndex(I);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(T){T.preventDefault(),T.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const X=$[0],R=this.model.getNodeLocation(X);if(!this.model.setCollapsed(R,!1)){if(!X.children.some(q=>q.visible))return;const[I]=this.view.getFocus(),U=I+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(T){T.preventDefault(),T.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const X=$[0],R=this.model.getNodeLocation(X),f=T.browserEvent.altKey;this.model.setCollapsed(R,void 0,f)}navigate(T){return new se(this.view,this.model,T)}dispose(){(0,u.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=Z;class se{constructor(T,$,X){this.view=T,this.model=$,X?this.index=this.model.getListIndex(X):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[128],pe([1,0,127,117,23,26]),function(Q,t,D,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class y extends D.AbstractTree{constructor(m,h,p,A,l,r={}){super(m,h,p,A,r);this.user=m,this.dataSource=l,this.nodesByIdentity=new Map,this.identityProvider=r.identityProvider}getInput(){return this.input}setInput(m,h){if(h&&!this.identityProvider)throw new P.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=m,!m){this.nodesByIdentity.clear(),this.model.setChildren(null,M.Iterable.empty());return}if(!h){this._refresh(m);return}const p=[],A=[],l=e=>{const c=this.identityProvider.getId(e).toString();return!h.expanded[c]},r=e=>{const c=this.identityProvider.getId(e.element).toString();h.focus.has(c)&&p.push(e.element),h.selection.has(c)&&A.push(e.element)};this._refresh(m,l,r),this.setFocus(p),this.setSelection(A),h&&typeof h.scrollTop=="number"&&(this.scrollTop=h.scrollTop)}updateChildren(m=this.input){if(typeof this.input=="undefined")throw new P.TreeError(this.user,"Tree input not set");let h;this.identityProvider&&(h=p=>{const A=this.identityProvider.getId(p).toString(),l=this.nodesByIdentity.get(A);if(!!l)return l.collapsed}),this._refresh(m,h)}resort(m=this.input,h=!0){this.model.resort(m===this.input?null:m,h)}refresh(m){if(m===void 0){this.view.rerender();return}this.model.rerender(m)}_refresh(m,h,p){let A;if(this.identityProvider){const l=new Set,r=p;p=e=>{const c=this.identityProvider.getId(e.element).toString();l.add(c),this.nodesByIdentity.set(c,e),r?.(e)},A=e=>{const c=this.identityProvider.getId(e.element).toString();l.has(c)||this.nodesByIdentity.delete(c)}}this.model.setChildren(m===this.input?null:m,this.iterate(m,h).elements,{onDidCreateNode:p,onDidDeleteNode:A})}iterate(m,h){const p=[...this.dataSource.getChildren(m)];return{elements:M.Iterable.map(p,l=>{const{elements:r,size:e}=this.iterate(l,h),c=this.dataSource.hasChildren?this.dataSource.hasChildren(l):void 0,g=e===0?void 0:h&&h(l);return{element:l,children:r,collapsible:c,collapsed:g}}),size:p.length}}createModel(m,h,p){return new i.ObjectTreeModel(m,h,p)}}t.DataTree=y}),define(me[38],pe([1,0,14,8,31,28,25,13,3,2,49,10,6]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var r;(function(te){te[te.Promise=100]="Promise",te[te.PromiseCancel=101]="PromiseCancel",te[te.EventListen=102]="EventListen",te[te.EventDispose=103]="EventDispose"})(r=t.RequestType||(t.RequestType={}));function e(te){switch(te){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(te){te[te.Initialize=200]="Initialize",te[te.PromiseSuccess=201]="PromiseSuccess",te[te.PromiseError=202]="PromiseError",te[te.PromiseErrorObj=203]="PromiseErrorObj",te[te.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function g(te){switch(te){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var E;(function(te){te[te.Uninitialized=0]="Uninitialized",te[te.Idle=1]="Idle"})(E||(E={}));class _{constructor(Z){this.buffer=Z,this.pos=0}read(Z){const se=this.buffer.slice(this.pos,this.pos+Z);return this.pos+=se.byteLength,se}}class u{constructor(){this.buffers=[]}get buffer(){return P.VSBuffer.concat(this.buffers)}write(Z){this.buffers.push(Z)}}var d;(function(te){te[te.Undefined=0]="Undefined",te[te.String=1]="String",te[te.Buffer=2]="Buffer",te[te.VSBuffer=3]="VSBuffer",te[te.Array=4]="Array",te[te.Object=5]="Object"})(d||(d={}));function w(te){const Z=P.VSBuffer.alloc(4);return Z.writeUInt32BE(te,0),Z}function S(te){return te.read(4).readUInt32BE(0)}function L(te){const Z=P.VSBuffer.alloc(1);return Z.writeUInt8(te,0),Z}const C={Undefined:L(d.Undefined),String:L(d.String),Buffer:L(d.Buffer),VSBuffer:L(d.VSBuffer),Array:L(d.Array),Object:L(d.Object)},n=typeof Buffer!="undefined";function s(te,Z){if(typeof Z=="undefined")te.write(C.Undefined);else if(typeof Z=="string"){const se=P.VSBuffer.fromString(Z);te.write(C.String),te.write(w(se.byteLength)),te.write(se)}else if(n&&Buffer.isBuffer(Z)){const se=P.VSBuffer.wrap(Z);te.write(C.Buffer),te.write(w(se.byteLength)),te.write(se)}else if(Z instanceof P.VSBuffer)te.write(C.VSBuffer),te.write(w(Z.byteLength)),te.write(Z);else if(Array.isArray(Z)){te.write(C.Array),te.write(w(Z.length));for(const se of Z)s(te,se)}else{const se=P.VSBuffer.fromString(JSON.stringify(Z));te.write(C.Object),te.write(w(se.byteLength)),te.write(se)}}function a(te){switch(te.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return te.read(S(te)).toString();case d.Buffer:return te.read(S(te)).buffer;case d.VSBuffer:return te.read(S(te));case d.Array:{const se=S(te),ie=[];for(let T=0;T<se;T++)ie.push(a(te));return ie}case d.Object:return JSON.parse(te.read(S(te)).toString())}}class o{constructor(Z,se,ie=null,T=1e3){this.protocol=Z,this.ctx=se,this.logger=ie,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(Z,se){this.channels.set(Z,se),setTimeout(()=>this.flushPendingRequests(Z),0)}sendResponse(Z){switch(Z.type){case 200:{const se=this.send([Z.type]);this.logger?.logOutgoing(se,0,1,g(Z.type));return}case 201:case 202:case 204:case 203:{const se=this.send([Z.type,Z.id],Z.data);this.logger?.logOutgoing(se,Z.id,1,g(Z.type),Z.data);return}}}send(Z,se=void 0){const ie=new u;return s(ie,Z),s(ie,se),this.sendBuffer(ie.buffer)}sendBuffer(Z){try{return this.protocol.send(Z),Z.byteLength}catch{return 0}}onRawMessage(Z){const se=new _(Z),ie=a(se),T=a(se),$=ie[0];switch($){case 100:return this.logger?.logIncoming(Z.byteLength,ie[1],1,`${e($)}: ${ie[2]}.${ie[3]}`,T),this.onPromise({type:$,id:ie[1],channelName:ie[2],name:ie[3],arg:T});case 102:return this.logger?.logIncoming(Z.byteLength,ie[1],1,`${e($)}: ${ie[2]}.${ie[3]}`,T),this.onEventListen({type:$,id:ie[1],channelName:ie[2],name:ie[3],arg:T});case 101:return this.logger?.logIncoming(Z.byteLength,ie[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:ie[1]});case 103:return this.logger?.logIncoming(Z.byteLength,ie[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:ie[1]})}}onPromise(Z){const se=this.channels.get(Z.channelName);if(!se){this.collectPendingRequest(Z);return}const ie=new M.CancellationTokenSource;let T;try{T=se.call(this.ctx,Z.name,Z.arg,ie.token)}catch(R){T=Promise.reject(R)}const $=Z.id;T.then(R=>{this.sendResponse({id:$,data:R,type:201}),this.activeRequests.delete(Z.id)},R=>{R instanceof Error?this.sendResponse({id:$,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:$,data:R,type:203}),this.activeRequests.delete(Z.id)});const X=(0,h.toDisposable)(()=>ie.cancel());this.activeRequests.set(Z.id,X)}onEventListen(Z){const se=this.channels.get(Z.channelName);if(!se){this.collectPendingRequest(Z);return}const ie=Z.id,$=se.listen(this.ctx,Z.name,Z.arg)(X=>this.sendResponse({id:ie,data:X,type:204}));this.activeRequests.set(Z.id,$)}disposeActiveRequest(Z){const se=this.activeRequests.get(Z.id);se&&(se.dispose(),this.activeRequests.delete(Z.id))}collectPendingRequest(Z){let se=this.pendingRequests.get(Z.channelName);se||(se=[],this.pendingRequests.set(Z.channelName,se));const ie=setTimeout(()=>{console.error(`Unknown channel: ${Z.channelName}`),Z.type===100&&this.sendResponse({id:Z.id,data:{name:"Unknown channel",message:`Channel name '${Z.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);se.push({request:Z,timeoutTimer:ie})}flushPendingRequests(Z){const se=this.pendingRequests.get(Z);if(se){for(const ie of se)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(Z)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=o;var v;(function(te){te[te.LocalSide=0]="LocalSide",te[te.OtherSide=1]="OtherSide"})(v=t.RequestInitiator||(t.RequestInitiator={}));class N{constructor(Z,se=null){this.protocol=Z,this.isDisposed=!1,this.state=E.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new m.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=se}getChannel(Z){const se=this;return{call(ie,T,$){return se.isDisposed?Promise.reject(b.canceled()):se.requestPromise(Z,ie,T,$)},listen(ie,T){return se.isDisposed?m.Event.None:se.requestEvent(Z,ie,T)}}}requestPromise(Z,se,ie,T=M.CancellationToken.None){const $=this.lastRequestId++,R={id:$,type:100,channelName:Z,name:se,arg:ie};if(T.isCancellationRequested)return Promise.reject(b.canceled());let f;return new Promise((U,q)=>{if(T.isCancellationRequested)return q(b.canceled());const W=()=>{const F=z=>{switch(z.type){case 201:this.handlers.delete($),U(z.data);break;case 202:{this.handlers.delete($);const k=new Error(z.data.message);k.stack=z.data.stack,k.name=z.data.name,q(k);break}case 203:this.handlers.delete($),q(z.data);break}};this.handlers.set($,F),this.sendRequest(R)};let O=null;this.state===E.Idle?W():(O=(0,i.createCancelablePromise)(F=>this.whenInitialized()),O.then(()=>{O=null,W()}));const H=()=>{O?(O.cancel(),O=null):this.sendRequest({id:$,type:101}),q(b.canceled())},V=T.onCancellationRequested(H);f=(0,h.combinedDisposable)((0,h.toDisposable)(H),V),this.activeRequests.add(f)}).finally(()=>{this.activeRequests.delete(f)})}requestEvent(Z,se,ie){const T=this.lastRequestId++,X={id:T,type:102,channelName:Z,name:se,arg:ie};let R=null;const f=new m.Emitter({onFirstListenerAdd:()=>{R=(0,i.createCancelablePromise)(U=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(f),this.sendRequest(X)})},onLastListenerRemove:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(f),this.sendRequest({id:T,type:103}))}}),I=U=>f.fire(U.data);return this.handlers.set(T,I),f.event}sendRequest(Z){switch(Z.type){case 100:case 102:{const se=this.send([Z.type,Z.id,Z.channelName,Z.name],Z.arg);this.logger?.logOutgoing(se,Z.id,0,`${e(Z.type)}: ${Z.channelName}.${Z.name}`,Z.arg);return}case 101:case 103:{const se=this.send([Z.type,Z.id]);this.logger?.logOutgoing(se,Z.id,0,e(Z.type));return}}}send(Z,se=void 0){const ie=new u;return s(ie,Z),s(ie,se),this.sendBuffer(ie.buffer)}sendBuffer(Z){try{return this.protocol.send(Z),Z.byteLength}catch{return 0}}onBuffer(Z){const se=new _(Z),ie=a(se),T=a(se),$=ie[0];switch($){case 200:return this.logger?.logIncoming(Z.byteLength,0,0,g($)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(Z.byteLength,ie[1],0,g($),T),this.onResponse({type:ie[0],id:ie[1],data:T})}}onResponse(Z){if(Z.type===200){this.state=E.Idle,this._onDidInitialize.fire();return}this.handlers.get(Z.id)?.(Z)}get onDidInitializePromise(){return m.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===E.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,h.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ke([y.memoize],N.prototype,"onDidInitializePromise",null),t.ChannelClient=N;class K{constructor(Z){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new m.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new m.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,Z(({protocol:se,onDidClientDisconnect:ie})=>{m.Event.once(se.onMessage)($=>{const X=new _($),R=a(X),f=new o(se,R),I=new N(se);this.channels.forEach((q,W)=>f.registerChannel(W,q));const U={channelServer:f,channelClient:I,ctx:R};this._connections.add(U),this._onDidAddConnection.fire(U),ie(()=>{f.dispose(),I.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const Z=[];return this._connections.forEach(se=>Z.push(se)),Z}getChannel(Z,se){const ie=this;return{call(T,$,X){let R;if((0,l.isFunction)(se)){const I=(0,D.getRandomElement)(ie.connections.filter(se));R=I?Promise.resolve(I):m.Event.toPromise(m.Event.filter(ie.onDidAddConnection,se))}else R=se.routeCall(ie,T,$);const f=R.then(I=>I.channelClient.getChannel(Z));return re(f).call(T,$,X)},listen(T,$){if((0,l.isFunction)(se))return ie.getMulticastEvent(Z,se,T,$);const X=se.routeEvent(ie,T,$).then(R=>R.channelClient.getChannel(Z));return re(X).listen(T,$)}}}getMulticastEvent(Z,se,ie,T){const $=this;let X=new h.DisposableStore;const R=new m.Emitter({onFirstListenerAdd:()=>{X=new h.DisposableStore;const f=new m.EventMultiplexer,I=new Map,U=W=>{const H=W.channelClient.getChannel(Z).listen(ie,T),V=f.add(H);I.set(W,V)},q=W=>{const O=I.get(W);!O||(O.dispose(),I.delete(W))};$.connections.filter(se).forEach(U),m.Event.filter($.onDidAddConnection,se)(U,void 0,X),$.onDidRemoveConnection(q,void 0,X),f.event(R.fire,R,X),X.add(f)},onLastListenerRemove:()=>{X.dispose()}});return R.event}registerChannel(Z,se){this.channels.set(Z,se),this._connections.forEach(ie=>{ie.channelServer.registerChannel(Z,se)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=K;class ne{constructor(Z,se,ie=null){const T=new u;s(T,se),Z.send(T.buffer),this.channelClient=new N(Z,ie),this.channelServer=new o(Z,se,ie)}getChannel(Z){return this.channelClient.getChannel(Z)}registerChannel(Z,se){this.channelServer.registerChannel(Z,se)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ne;function re(te){return{call(Z,se,ie){return te.then(T=>T.call(Z,se,ie))},listen(Z,se){const ie=new m.Relay;return te.then(T=>ie.input=T.listen(Z,se)),ie.event}}}t.getDelayedChannel=re;function we(te){let Z=!1;return{call(se,ie,T){return Z?te.call(se,ie,T):(0,i.timeout)(0).then(()=>Z=!0).then(()=>te.call(se,ie,T))},listen(se,ie){if(Z)return te.listen(se,ie);const T=new m.Relay;return(0,i.timeout)(0).then(()=>Z=!0).then(()=>T.input=te.listen(se,ie)),T.event}}}t.getNextTickChannel=we;class ae{constructor(Z){this.fn=Z}routeCall(Z){return this.route(Z)}routeEvent(Z){return this.route(Z)}async route(Z){for(const se of Z.connections)if(await Promise.resolve(this.fn(se.ctx)))return Promise.resolve(se);return await m.Event.toPromise(Z.onDidAddConnection),await this.route(Z)}}t.StaticRouter=ae;var ve;(function(te){function Z($,X){const R=$,f=X&&X.disableMarshalling,I=new Map;for(const U in R)ie(U)&&I.set(U,m.Event.buffer(R[U],!0));return new class{listen(U,q,W){const O=I.get(q);if(O)return O;if(T(q)){const H=R[q];if(typeof H=="function")return H.call(R,W)}throw new Error(`Event not found: ${q}`)}call(U,q,W){const O=R[q];if(typeof O=="function"){if(!f&&Array.isArray(W))for(let H=0;H<W.length;H++)W[H]=(0,p.revive)(W[H]);return O.apply(R,W)}throw new Error(`Method not found: ${q}`)}}}te.fromService=Z;function se($,X){const R=X&&X.disableMarshalling;return new Proxy({},{get(f,I){if(typeof I=="string")return X?.properties?.has(I)?X.properties.get(I):T(I)?function(U){return $.listen(I,U)}:ie(I)?$.listen(I):async function(...U){let q;X&&!(0,l.isUndefinedOrNull)(X.context)?q=[X.context,...U]:q=U;const W=await $.call(I,q);return R?W:(0,p.revive)(W)};throw new Error(`Property not found: ${String(I)}`)}})}te.toService=se;function ie($){return $[0]==="o"&&$[1]==="n"&&A.isUpperAsciiLetter($.charCodeAt(2))}function T($){return/^onDynamic/.test($)&&A.isUpperAsciiLetter($.charCodeAt(9))}})(ve=t.ProxyChannel||(t.ProxyChannel={}));const fe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(te){if(Array.isArray(te))return te;if(te&&typeof te=="object"&&typeof te.toString=="function"){const Z=te.toString();if(Z!=="[object Object]")return Z}return te}function ye(te){return Array.isArray(te)?te.map(ge):ge(te)}function ee(te,Z,se,ie,T,$,X){X=ye(X);const R=fe[T],f=R[ie%R.length];let I=[`%c[${te}]%c[${String(Z).padStart(7," ")}]%c[len: ${String(se).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test($)?(I=I.concat(X),I.push(")")):I.push(X),console.log.apply(console,I)}t.logWithColors=ee;class he{constructor(Z,se){this._outgoingPrefix=Z,this._incomingPrefix=se,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(Z,se,ie,T,$){this._totalOutgoing+=Z,ee(this._outgoingPrefix,this._totalOutgoing,Z,se,ie,T,$)}logIncoming(Z,se,ie,T,$){this._totalIncoming+=Z,ee(this._incomingPrefix,this._totalIncoming,Z,se,ie,T,$)}}t.IPCLogger=he}),define(me[29],pe([1,0,5]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=D.globals.vscode.ipcRenderer,t.ipcMessagePort=D.globals.vscode.ipcMessagePort,t.webFrame=D.globals.vscode.webFrame,t.process=D.globals.vscode.process,t.context=D.globals.vscode.context}),define(me[129],pe([1,0,80,29]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let P=0;function M(b,m,h){const p=[],A=P++,l=`vscode:onContextMenu${A}`,r=(e,c,g)=>{p[c].click?.(g)};i.ipcRenderer.once(l,r),i.ipcRenderer.once(D.CONTEXT_MENU_CLOSE_CHANNEL,(e,c)=>{c===A&&(i.ipcRenderer.removeListener(l,r),h?.())}),i.ipcRenderer.send(D.CONTEXT_MENU_CHANNEL,A,b.map(e=>y(e,p)),l,m)}t.popup=M;function y(b,m){const h={id:m.length,label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:typeof b.enabled=="boolean"?b.enabled:!0,visible:typeof b.visible=="boolean"?b.visible:!0};return m.push(b),Array.isArray(b.submenu)&&(h.submenu=b.submenu.map(p=>y(p,m))),h}}),define(me[130],pe([1,0,31,3,38,81,29]),function(Q,t,D,i,P,M,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class b extends P.IPCClient{constructor(h){const p=b.createProtocol();super(p,h);this.protocol=p}static createProtocol(){const h=i.Event.fromNodeEventEmitter(y.ipcRenderer,"vscode:message",(p,A)=>D.VSBuffer.wrap(A));return y.ipcRenderer.send("vscode:hello"),new M.Protocol(y.ipcRenderer,h)}dispose(){this.protocol.disconnect()}}t.Client=b}),define(me[131],pe([12,9]),function(Q,t){return Q.create("vs/platform/files/common/files",t)}),define(me[132],pe([12,9]),function(Q,t){return Q.create("vs/platform/theme/common/iconRegistry",t)}),define(me[63],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class D{constructor(P,M=[],y=!1){this.ctor=P,this.staticArguments=M,this.supportsDelayedInstantiation=y}}t.SyncDescriptor=D}),define(me[133],pe([1,0,63]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const i=[];function P(y,b,m){b instanceof D.SyncDescriptor||(b=new D.SyncDescriptor(b,[],m)),i.push([y,b])}t.registerSingleton=P;function M(){return i}t.getSingletonServiceDescriptors=M}),define(me[30],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var D;(function(y){y.serviceIds=new Map,y.DI_TARGET="$di$target",y.DI_DEPENDENCIES="$di$dependencies";function b(m){return m[y.DI_DEPENDENCIES]||[]}y.getServiceDependencies=b})(D=t._util||(t._util={})),t.IInstantiationService=P("instantiationService");function i(y,b,m){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:y,index:m}):(b[D.DI_DEPENDENCIES]=[{id:y,index:m}],b[D.DI_TARGET]=b)}function P(y){if(D.serviceIds.has(y))return D.serviceIds.get(y);const b=function(m,h,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(b,m,p)};return b.toString=()=>y,D.serviceIds.set(y,b),b}t.createDecorator=P;function M(y){return y}t.refineServiceDecorator=M}),define(me[134],pe([1,0,30]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,D.createDecorator)(t.ID);function i(M){return!!M.hostName&&!!M.errorMessage}t.isRemoteDiagnosticError=i;class P{async getPerformanceInfo(y,b){return{}}async getSystemInfo(y,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(y,b){return""}async getWorkspaceFileExtensions(y){return{extensions:[]}}async reportWorkspaceStats(y){}}t.NullDiagnosticsService=P}),define(me[135],pe([1,0,48,21,10,6,16,131,30]),function(Q,t,D,i,P,M,y,b,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,m.createDecorator)("fileService");function h(ee){return ee.create===!0}t.isFileOpenForWriteOptions=h;var p;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(p=t.FileType||(t.FileType={}));var A;(function(ee){ee[ee.Readonly=1]="Readonly"})(A=t.FilePermission||(t.FilePermission={}));var l;(function(ee){ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileClone=32768]="FileClone"})(l=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function r(ee){return!!(ee.capabilities&2)}t.hasReadWriteCapability=r;function e(ee){return!!(ee.capabilities&8)}t.hasFileFolderCopyCapability=e;function c(ee){return!!(ee.capabilities&32768)}t.hasFileCloneCapability=c;function g(ee){return!!(ee.capabilities&4)}t.hasOpenReadWriteCloseCapability=g;function E(ee){return!!(ee.capabilities&16)}t.hasFileReadStreamCapability=E;function _(ee){return r(ee)?!!(ee.capabilities&16384):!1}t.hasFileAtomicReadCapability=_;var u;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(u=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class d extends Error{constructor(he,te){super(he);this.code=te}}t.FileSystemProviderError=d;function w(ee,he){const te=new d(ee.toString(),he);return L(te,he),te}t.createFileSystemProviderError=w;function S(ee){return ee||w((0,b.localize)(0,null),u.Unknown)}t.ensureFileSystemProviderError=S;function L(ee,he){return ee.name=he?`${he} (FileSystemError)`:"FileSystemError",ee}t.markAsFileSystemProviderError=L;function C(ee){if(!ee)return u.Unknown;if(ee instanceof d)return ee.code;const he=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!he)return u.Unknown;switch(he[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileExceedsMemoryLimit:return u.FileExceedsMemoryLimit;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}t.toFileSystemProviderErrorCode=C;function n(ee){if(ee instanceof K)return ee.fileOperationResult;switch(C(ee)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 10;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileExceedsMemoryLimit:return 9;case u.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=n;var s;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(s=t.FileOperation||(t.FileOperation={}));class a{constructor(he,te,Z){this.resource=he,this.operation=te,this.target=Z}isOperation(he){return this.operation===he}}t.FileOperationEvent=a;var o;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(o=t.FileChangeType||(t.FileChangeType={}));class v{constructor(he,te){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=he;const Z=new Map;for(const se of he){const ie=Z.get(se.type);switch(ie?ie.push([se.resource,se]):Z.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,ie]of Z)switch(se){case 1:this.added=D.TernarySearchTree.forUris(()=>te),this.added.fill(ie);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>te),this.updated.fill(ie);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>te),this.deleted.fill(ie);break}}contains(he,...te){return this.doContains(he,{includeChildren:!1},...te)}affects(he,...te){return this.doContains(he,{includeChildren:!0},...te)}doContains(he,te,...Z){if(!he)return!1;const se=Z.length>0;return!!((!se||Z.includes(1))&&(this.added?.get(he)||te.includeChildren&&this.added?.findSuperstr(he))||(!se||Z.includes(0))&&(this.updated?.get(he)||te.includeChildren&&this.updated?.findSuperstr(he))||(!se||Z.includes(2))&&(this.deleted?.findSubstr(he)||te.includeChildren&&this.deleted?.findSuperstr(he)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=v;function N(ee,he,te){return!ee||!he||ee===he||he.length>ee.length?!1:(he.charAt(he.length-1)!==i.sep&&(he+=i.sep),te?(0,P.startsWithIgnoreCase)(ee,he):ee.indexOf(he)===0)}t.isParent=N;class K extends Error{constructor(he,te,Z){super(he);this.fileOperationResult=te,this.options=Z}}t.FileOperationError=K;class ne extends K{constructor(he,te,Z){super(he,2,Z);this.stat=te}}t.NotModifiedSinceFileOperationError=ne;var re;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ee[ee.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(re=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var we;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(we=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function ae(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}t.etag=ae;async function ve(ee,he){if(!he.hasProvider(y.URI.from({scheme:ee.scheme})))return new Promise(te=>{const Z=he.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===ee.scheme&&se.added&&(Z.dispose(),te())})})}t.whenProviderRegistered=ve,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class fe{static formatSize(he){return(0,M.isNumber)(he)||(he=0),he<fe.KB?(0,b.localize)(1,null,he.toFixed(0)):he<fe.MB?(0,b.localize)(2,null,(he/fe.KB).toFixed(2)):he<fe.GB?(0,b.localize)(3,null,(he/fe.MB).toFixed(2)):he<fe.TB?(0,b.localize)(4,null,(he/fe.GB).toFixed(2)):(0,b.localize)(5,null,(he/fe.TB).toFixed(2))}}t.ByteSize=fe,fe.KB=1024,fe.MB=fe.KB*fe.KB,fe.GB=fe.MB*fe.KB,fe.TB=fe.GB*fe.KB;var ge;(function(ee){ee[ee.IA32=0]="IA32",ee[ee.OTHER=1]="OTHER"})(ge=t.Arch||(t.Arch={}));function ye(ee){return{maxFileSize:ee===0?300*fe.MB:16*fe.GB,maxHeapSize:ee===0?700*fe.MB:2*700*fe.MB}}t.getPlatformLimits=ye}),define(me[136],pe([1,0,2,130]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class P extends D.Disposable{constructor(y){super();this.mainProcessConnection=this._register(new i.Client(`window:${y}`))}getChannel(y){return this.mainProcessConnection.getChannel(y)}registerChannel(y,b){this.mainProcessConnection.registerChannel(y,b)}}t.ElectronIPCMainProcessService=P});var Tt=this&&this.__param||function(Q,t){return function(D,i){t(D,i,Q)}};define(me[137],pe([1,0,38,63,133,30]),function(Q,t,D,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class y{constructor(r,e,c){const g=c.getChannel(r);return b(e)?new e.channelClientCtor(g):D.ProxyChannel.toService(g,e?.proxyOptions)}}function b(l){return!!l?.channelClientCtor}t.IMainProcessService=(0,M.createDecorator)("mainProcessService");let m=class extends y{constructor(r,e,c){super(r,e,c)}};m=Ke([Tt(2,t.IMainProcessService)],m);function h(l,r,e){(0,P.registerSingleton)(l,new i.SyncDescriptor(m,[r,e],e?.supportsDelayedInstantiation))}t.registerMainProcessRemoteService=h,t.ISharedProcessService=(0,M.createDecorator)("sharedProcessService");let p=class extends y{constructor(r,e,c){super(r,e,c)}};p=Ke([Tt(2,t.ISharedProcessService)],p);function A(l,r,e){(0,P.registerSingleton)(l,new i.SyncDescriptor(p,[r,e],e?.supportsDelayedInstantiation))}t.registerSharedProcessRemoteService=A}),define(me[138],pe([1,0,38,137]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let P=class{constructor(y,b){return this.windowId=y,D.ProxyChannel.toService(b.getChannel("nativeHost"),{context:y,properties:(()=>{const m=new Map;return m.set("windowId",y),m})()})}};P=Ke([Tt(1,i.IMainProcessService)],P),t.NativeHostService=P}),define(me[39],pe([1,0,68,6]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class P{constructor(){this.data=new Map}add(y,b){D.ok(i.isString(y)),D.ok(i.isObject(b)),D.ok(!this.data.has(y),"There is already an extension with this id"),this.data.set(y,b)}knows(y){return this.data.has(y)}as(y){return this.data.get(y)||null}}t.Registry=new P}),define(me[139],pe([1,0,3,39]),function(Q,t,D,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function P(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class M{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,h){this.schemasById[P(m)]=h,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const y=new M;i.Registry.add(t.Extensions.JSONContribution,y)}),define(me[140],pe([1,0]),function(Q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var D;(function(M){M.DARK="dark",M.LIGHT="light",M.HIGH_CONTRAST_DARK="hcDark",M.HIGH_CONTRAST_LIGHT="hcLight"})(D=t.ColorScheme||(t.ColorScheme={}));function i(M){return M===D.HIGH_CONTRAST_DARK||M===D.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function P(M){return M===D.DARK||M===D.HIGH_CONTRAST_DARK}t.isDark=P}),define(me[64],pe([1,0,11,3,2,30,39,140]),function(Q,t,D,i,P,M,y,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,M.createDecorator)("themeService");var m;(function(g){function E(_){return _&&typeof _=="object"&&typeof _.id=="string"}g.isThemeColor=E})(m=t.ThemeColor||(t.ThemeColor={}));function h(g){return{id:g}}t.themeColorFromId=h;var p;(function(g){function E(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color=="undefined"||m.isThemeColor(n.color))}g.isThemeIcon=E;const _=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function u(n){const s=_.exec(n);if(!s)return;const[,a]=s;return{id:a}}g.fromString=u;function d(n){return{id:n}}g.fromId=d;function w(n,s){let a=n.id;const o=a.lastIndexOf("~");return o!==-1&&(a=a.substring(0,o)),s&&(a=`${a}~${s}`),{id:a}}g.modify=w;function S(n){const s=n.id.lastIndexOf("~");if(s!==-1)return n.id.substring(s+1)}g.getModifier=S;function L(n,s){return n.id===s.id&&n.color?.id===s.color?.id}g.isEqual=L;function C(n,s){return{id:n.id,color:s?h(s):void 0}}g.asThemeIcon=C,g.asClassNameArray=D.CSSIcon.asClassNameArray,g.asClassName=D.CSSIcon.asClassName,g.asCSSSelector=D.CSSIcon.asCSSSelector})(p=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=D.Codicon.file,t.FolderThemeIcon=D.Codicon.folder;function A(g){switch(g){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=A,t.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(E){return this.themingParticipants.push(E),this.onThemingParticipantAddedEmitter.fire(E),(0,P.toDisposable)(()=>{const _=this.themingParticipants.indexOf(E);this.themingParticipants.splice(_,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const r=new l;y.Registry.add(t.Extensions.ThemingContribution,r);function e(g){return r.onColorThemeChange(g)}t.registerThemingParticipant=e;class c extends P.Disposable{constructor(E){super();this.themeService=E,this.theme=E.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(_=>this.onThemeChange(_)))}onThemeChange(E){this.theme=E,this.updateStyles()}updateStyles(){}getColor(E,_){let u=this.theme.getColor(E);return u&&_&&(u=_(u,this.theme)),u?u.toString():null}}t.Themable=c}),define(me[141],pe([1,0,8,11,3,6,16,132,139,39,64]),function(Q,t,D,i,P,M,y,b,m,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var A;(function(d){function w(S,L){let C=S.defaults;for(;p.ThemeIcon.isThemeIcon(C);){const n=e.getIcon(C.id);if(!n)return;C=n.defaults}return C}d.getDefinition=w})(A=t.IconContribution||(t.IconContribution={}));var l;(function(d){function w(L){return{weight:L.weight,style:L.style,src:L.src.map(C=>({format:C.format,location:C.location.toString()}))}}d.toJSONObject=w;function S(L){const C=n=>(0,M.isString)(n)?n:void 0;if(L&&Array.isArray(L.src)&&L.src.every(n=>(0,M.isString)(n.format)&&(0,M.isString)(n.location)))return{weight:C(L.weight),style:C(L.style),src:L.src.map(n=>({format:n.format,location:y.URI.parse(n.location)}))}}d.fromJSONObject=S})(l=t.IconFontDefinition||(t.IconFontDefinition={}));class r{constructor(){this._onDidChange=new P.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,b.localize)(0,null)},fontCharacter:{type:"string",description:(0,b.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(w,S,L,C){const n=this.iconsById[w];if(n){if(L&&!n.description){n.description=L,this.iconSchema.properties[w].markdownDescription=`${L} $(${w})`;const o=this.iconReferenceSchema.enum.indexOf(w);o!==-1&&(this.iconReferenceSchema.enumDescriptions[o]=L),this._onDidChange.fire()}return n}const s={id:w,description:L,defaults:S,deprecationMessage:C};this.iconsById[w]=s;const a={$ref:"#/definitions/icons"};return C&&(a.deprecationMessage=C),L&&(a.markdownDescription=`${L}: $(${w})`),this.iconSchema.properties[w]=a,this.iconReferenceSchema.enum.push(w),this.iconReferenceSchema.enumDescriptions.push(L||""),this._onDidChange.fire(),{id:w}}deregisterIcon(w){delete this.iconsById[w],delete this.iconSchema.properties[w];const S=this.iconReferenceSchema.enum.indexOf(w);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(w=>this.iconsById[w])}getIcon(w){return this.iconsById[w]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(w,S){const L=this.iconFontsById[w];return L||(this.iconFontsById[w]=S,this._onDidChange.fire(),S)}deregisterIconFont(w){delete this.iconFontsById[w]}getIconFont(w){return this.iconFontsById[w]}toString(){const w=(n,s)=>n.id.localeCompare(s.id),S=n=>{for(;p.ThemeIcon.isThemeIcon(n.defaults);)n=this.iconsById[n.defaults.id];return`codicon codicon-${n?n.id:""}`},L=[];L.push("| preview     | identifier                        | default codicon ID                | description"),L.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const C=Object.keys(this.iconsById).map(n=>this.iconsById[n]);for(const n of C.filter(s=>!!s.description).sort(w))L.push(`|<i class="${S(n)}"></i>|${n.id}|${p.ThemeIcon.isThemeIcon(n.defaults)?n.defaults.id:n.id}|${n.description||""}|`);L.push("| preview     | identifier                        "),L.push("| ----------- | --------------------------------- |");for(const n of C.filter(s=>!p.ThemeIcon.isThemeIcon(s.defaults)).sort(w))L.push(`|<i class="${S(n)}"></i>|${n.id}|`);return L.join(`
`)}}const e=new r;h.Registry.add(t.Extensions.IconContribution,e);function c(d,w,S,L){return e.registerIcon(d,w,S,L)}t.registerIcon=c;function g(){return e}t.getIconRegistry=g;function E(){for(const d of i.Codicon.getAll())e.registerIcon(d.id,d.definition,d.description)}E(),t.iconsSchemaId="vscode://schemas/icons";const _=h.Registry.as(m.Extensions.JSONContribution);_.registerSchema(t.iconsSchemaId,e.getIconSchema());const u=new D.RunOnceScheduler(()=>_.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{u.isScheduled()||u.schedule()}),t.widgetClose=c("widget-close",i.Codicon.close,(0,b.localize)(2,null)),t.gotoPreviousLocation=c("goto-previous-location",i.Codicon.arrowUp,(0,b.localize)(3,null)),t.gotoNextLocation=c("goto-next-location",i.Codicon.arrowDown,(0,b.localize)(4,null)),t.syncing=p.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=p.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[142],pe([1,0,4,3,141,64]),function(Q,t,D,i,P,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function y(m){const h=new i.Emitter,p=(0,P.getIconRegistry)();return p.onDidChange(()=>h.fire()),m?.onDidProductIconThemeChange(()=>h.fire()),{onDidChange:h.event,getCSS(){const A=m?m.getProductIconTheme():new b,l={},r=c=>{const g=A.getIcon(c);if(!g)return;const E=g.font;return E?(l[E.id]=E.definition,`.codicon-${c.id}:before { content: '${g.fontCharacter}'; font-family: ${(0,D.asCSSPropertyValue)(E.id)}; }`):`.codicon-${c.id}:before { content: '${g.fontCharacter}'; }`},e=[];for(const c of p.getIcons()){const g=r(c);g&&e.push(g)}for(const c in l){const g=l[c],E=g.weight?`font-weight: ${g.weight};`:"",_=g.style?`font-style: ${g.style};`:"",u=g.src.map(d=>`${(0,D.asCSSUrl)(d.location)} format('${d.format}')`).join(", ");e.push(`@font-face { src: ${u}; font-family: ${(0,D.asCSSPropertyValue)(c)};${E}${_} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=y;class b{getIcon(h){const p=(0,P.getIconRegistry)();let A=h.defaults;for(;M.ThemeIcon.isThemeIcon(A);){const l=p.getIcon(A.id);if(!l)return;A=l.defaults}return A}}t.UnthemedProductIconTheme=b}),define(me[143],pe([1,0,5]),function(Q,t,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(p){return!!p.workspaceUri}t.isWorkspaceToOpen=i;function P(p){return!!p.folderUri}t.isFolderToOpen=P;function M(p){return!!p.fileUri}t.isFileToOpen=M;function y(p){const A=b(p),l=p.getValue("window.menuBarVisibility");return l==="default"||A==="native"&&l==="compact"||D.isMacintosh&&D.isNative?"classic":l}t.getMenuBarVisibility=y;function b(p){if(D.isWeb)return"custom";const A=p.getValue("window");if(A){if(D.isMacintosh&&A.nativeTabs===!0||D.isMacintosh&&A.nativeFullScreen===!1)return"native";const e=p.getValue("workbench.colorCustomizations");if(e?.["window.activeBorder"]||e?.["window.inactiveBorder"])return"custom";const c=A.titleBarStyle;if(c==="native"||c==="custom")return c}return D.isLinux?"native":"custom"}t.getTitleBarStyle=b;function m(p,A){return!D.isWindows||D.isWeb||!A.isBuilt||b(p)==="native"?!1:p.getValue("window.experimental.windowControlsOverlay.enabled")}t.useWindowControlsOverlay=m;function h(p=0){return Math.pow(1.2,p)}t.zoomLevelToZoomFactor=h}),define(me[144],pe([1,0,15,29,143]),function(Q,t,D,i,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function M(m){i.webFrame.setZoomLevel(m),(0,D.setZoomFactor)((0,P.zoomLevelToZoomFactor)(m)),(0,D.setZoomLevel)(m,!1)}t.applyZoom=M;function y(){M((0,D.getZoomLevel)()+1)}t.zoomIn=y;function b(){M((0,D.getZoomLevel)()-1)}t.zoomOut=b}),define(me[145],pe([1,0,9,4,128,8,129,29,134,135,136,138,142,144,94,85]),function(Q,t,D,i,P,M,y,b,m,h,p,A,l,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,c=/\s--(inspect|debug)-port=(\d+)/;class g{getHeight(v){return 22}getTemplateId(v){return C(v)?"process":S(v)?"machine":(0,m.isRemoteDiagnosticError)(v)?"error":L(v)?"header":""}}class E{hasChildren(v){return(0,m.isRemoteDiagnosticError)(v)?!1:C(v)?!!v.children?.length:!0}getChildren(v){return C(v)?v.children?v.children:[]:(0,m.isRemoteDiagnosticError)(v)?[]:L(v)?v.processRoots.length>1?v.processRoots:[v.processRoots[0].rootProcess]:S(v)?[v.rootProcess]:[v.processes]}}class _{constructor(){this.templateId="header"}renderTemplate(v){const N=Object.create(null),K=(0,i.append)(v,(0,i.$)(".row"));return N.name=(0,i.append)(K,(0,i.$)(".nameLabel")),N.CPU=(0,i.append)(K,(0,i.$)(".cpu")),N.memory=(0,i.append)(K,(0,i.$)(".memory")),N.PID=(0,i.append)(K,(0,i.$)(".pid")),N}renderElement(v,N,K,ne){K.name.textContent=(0,D.localize)(0,null),K.CPU.textContent=(0,D.localize)(1,null),K.PID.textContent=(0,D.localize)(2,null),K.memory.textContent=(0,D.localize)(3,null)}disposeTemplate(v){}}class u{constructor(){this.templateId="machine"}renderTemplate(v){const N=Object.create(null),K=(0,i.append)(v,(0,i.$)(".row"));return N.name=(0,i.append)(K,(0,i.$)(".nameLabel")),N}renderElement(v,N,K,ne){K.name.textContent=v.element.name}disposeTemplate(v){}}class d{constructor(){this.templateId="error"}renderTemplate(v){const N=Object.create(null),K=(0,i.append)(v,(0,i.$)(".row"));return N.name=(0,i.append)(K,(0,i.$)(".nameLabel")),N}renderElement(v,N,K,ne){K.name.textContent=v.element.errorMessage}disposeTemplate(v){}}class w{constructor(v,N,K){this.platform=v,this.totalMem=N,this.mapPidToWindowTitle=K,this.templateId="process"}renderTemplate(v){const N=Object.create(null),K=(0,i.append)(v,(0,i.$)(".row"));return N.name=(0,i.append)(K,(0,i.$)(".nameLabel")),N.CPU=(0,i.append)(K,(0,i.$)(".cpu")),N.memory=(0,i.append)(K,(0,i.$)(".memory")),N.PID=(0,i.append)(K,(0,i.$)(".pid")),N}renderElement(v,N,K,ne){const{element:re}=v;let we=re.name;we==="window"&&(we=this.mapPidToWindowTitle.get(re.pid)!==void 0?`${we} (${this.mapPidToWindowTitle.get(re.pid)})`:we);const ae=re.pid.toFixed(0);K.name.textContent=we,K.name.title=re.cmd,K.CPU.textContent=re.load.toFixed(0),K.PID.textContent=ae,K.PID.parentElement.id=`pid-${ae}`;const ve=this.platform==="win32"?re.mem:this.totalMem*(re.mem/100);K.memory.textContent=(ve/h.ByteSize.MB).toFixed(0)}disposeTemplate(v){}}function S(o){return!!o.name&&!!o.rootProcess}function L(o){return!!o.processRoots}function C(o){return!!o.pid}class n{constructor(v,N){this.data=N,this.mapPidToWindowTitle=new Map;const K=new p.ElectronIPCMainProcessService(v);this.nativeHostService=new A.NativeHostService(v,K),this.applyStyles(N.styles),this.setEventHandlers(N),b.ipcRenderer.on("vscode:windowsInfoResponse",(ne,re)=>{this.mapPidToWindowTitle=new Map,re.forEach(we=>this.mapPidToWindowTitle.set(we.pid,we.title))}),b.ipcRenderer.on("vscode:listProcessesResponse",async(ne,re)=>{re.forEach((we,ae)=>{C(we.rootProcess)&&(we.rootProcess.name=ae===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?this.tree.setInput({processes:{processRoots:re}}):await this.createProcessTree(re),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),b.ipcRenderer.send("vscode:windowsInfoRequest"),b.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(v){document.onkeydown=N=>{const K=v.platform==="darwin"?N.metaKey:N.ctrlKey;K&&N.keyCode===87&&(N.stopPropagation(),N.preventDefault(),b.ipcRenderer.send("vscode:closeProcessExplorer")),K&&N.keyCode===187&&(0,r.zoomIn)(),K&&N.keyCode===189&&(0,r.zoomOut)()}}async createProcessTree(v){const N=document.getElementById("process-list");if(!N)return;const{totalmem:K}=await this.nativeHostService.getOSStatistics(),ne=[new w(this.data.platform,K,this.mapPidToWindowTitle),new _,new u,new d];this.tree=new P.DataTree("processExplorer",N,new g,ne,new E,{identityProvider:{getId:re=>C(re)?re.pid.toString():(0,m.isRemoteDiagnosticError)(re)?re.hostName:L(re)?"processes":S(re)?re.name:"header"}}),this.tree.setInput({processes:{processRoots:v}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(re=>{C(re.element)&&this.showContextMenu(re.element,!0)})}isDebuggable(v){const N=e.exec(v);return N&&N.length>=2||v.indexOf("node ")>=0||v.indexOf("node.exe")>=0}attachTo(v){const N={type:"node",request:"attach",name:`process ${v.pid}`};let K=e.exec(v.cmd);K&&K.length>=2?(K.length===4&&K[3]&&(N.port=parseInt(K[3])),N.protocol=K[1]==="debug"?"legacy":"inspector"):N.processId=String(v.pid),K=c.exec(v.cmd),K&&K.length===3&&(N.port=parseInt(K[2])),b.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[N]})}applyStyles(v){const N=(0,i.createStyleSheet)(),K=[];v.listFocusBackground&&(K.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${v.listFocusBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${v.listFocusBackground}; }`)),v.listFocusForeground&&K.push(`.monaco-list:focus .monaco-list-row.focused { color: ${v.listFocusForeground}; }`),v.listActiveSelectionBackground&&(K.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${v.listActiveSelectionBackground}; }`),K.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${v.listActiveSelectionBackground}; }`)),v.listActiveSelectionForeground&&K.push(`.monaco-list:focus .monaco-list-row.selected { color: ${v.listActiveSelectionForeground}; }`),v.listHoverBackground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${v.listHoverBackground}; }`),v.listHoverForeground&&K.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${v.listHoverForeground}; }`),v.listFocusOutline&&K.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${v.listFocusOutline}; outline-offset: -1px; }`),v.listHoverOutline&&K.push(`.monaco-list-row:hover { outline: 1px dashed ${v.listHoverOutline}; outline-offset: -1px; }`),N.textContent=K.join(`
`),v.color&&(document.body.style.color=v.color)}showContextMenu(v,N){const K=[],ne=Number(v.pid);N&&(K.push({label:(0,D.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGTERM")}}),K.push({label:(0,D.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGKILL")}}),K.push({type:"separator"})),K.push({label:(0,D.localize)(6,null),click:()=>{const re=this.tree?.getSelection()?.map(ae=>{if(!(!ae||!("pid"in ae)))return ae.pid}).filter(ae=>!!ae);re?.includes(ne)||(re.length=0,re.push(ne));const we=re?.map(ae=>document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(we){const ae=we.map(ve=>ve.innerText).filter(ve=>!!ve);this.nativeHostService.writeClipboardText(ae.join(`
`))}}}),K.push({label:(0,D.localize)(7,null),click:()=>{const re=document.getElementById("process-list");re&&this.nativeHostService.writeClipboardText(re.innerText)}}),v&&N&&this.isDebuggable(v.cmd)&&(K.push({type:"separator"}),K.push({label:(0,D.localize)(8,null),click:()=>{this.attachTo(v)}})),(0,y.popup)(K)}requestProcessList(v){setTimeout(()=>{const N=Date.now(),K=v+N-this.lastRequestTime;this.lastRequestTime=N,K>1e3?(b.ipcRenderer.send("vscode:windowsInfoRequest"),b.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(K)},200)}}function s(){const o=(0,i.createStyleSheet)();o.id="codiconStyles";const v=(0,l.getIconsStyleSheet)(void 0);function N(){o.textContent=v.getCSS()}const K=new M.RunOnceScheduler(N,0);v.onDidChange(()=>K.schedule()),K.schedule()}function a(o){const v=o.data.platform==="win32"?"windows":o.data.platform==="linux"?"linux":"mac";document.body.classList.add(v),s(),(0,r.applyZoom)(o.data.zoomLevel),new n(o.windowId,o.data)}t.startup=a})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/8179d832082f44ee45c4f9e01e229d22c008a2a6/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
